/* This is a version to that of Syngenta, where if GE data available, then 
different from 2010:
1. Hypothesizing Enzyme Limiting or Substrate Limiting -- add this information to reaction-state.
2. Catalytically increased or decreased
3. score: 10 to those agreed
4. Hypothesizing unknown EC. -- make it another fact or not? Should we prefer those known?
	Since you are considering all, it is not a problem for now
*/


:- dynamic reaction_state/2.

:-['topCla'].
%:-['counting.pl'].
%:-['counting_includeLength'].
:-['b_noCycle'].



%set(depthLimit,s(s(s(s(s(s(s(s(0))))))))). %PianoNumDepthLimit):- numMap(6,PianoNumDepthLimit).
%set(depthLimit,s(0)).
%set(depthLimit,s(s(0))).
set(depthLimit,s(s(s(0)))).
%set(depthLimit,s(s(s(s(0))))).
%set(depthLimit,s(s(s(s(s(0)))))).
%set(depthLimit,s(s(s(s(s(s(s(s(s(s(0))))))))))).
set(etoB,yes).








% it is actually minus 2 now
peanoMinus1(s(s(X)),X).

% greater than
peanoGth(X,X).
peanoGth(s(Y),X):-peanoGth(Y,X).


/*********** using other examples ***********/
concentration(DepthLimit,Tr,Tr,VisitedNodes,X,Change,Time):-	
	set(depthLimit,DepthLimit0),
	DepthLimit \== DepthLimit0,
	ex(EI,concentration(X,Change,Time),1),!,
	ex0(EI,concentration(Xname,Change,Time),1).
	%write('***using this example***'), write({EI,Xname,Change}),nl,
	%NewVisitedNodes=[X|VisitedNodes], % since it's the last one, so it doesn't matter in terms of format
	%write('--- one candidate Hypothesis: '),portray_clause(VisitedNodes),pathwayDetails(VisitedNodes).


concentration(DepthLimit,Tr,Tr,VisitedNodes,X,Change,Time):- 
	set(depthLimit,DepthLimit0),
	DepthLimit \== DepthLimit0,
	threeStatesOpposite(Change,Opp1,Opp2),
	(ex(EI,concentration(X,Opp1,Time),1);ex(EI,concentration(X,Opp2,Time),1)),
	%write('!!! this metabolite is measured to be '), ex0(EI,concentration(Xname,ActualChange,Time),1),write({Xname,ActualChange}),nl,
	!,
	fail.


threeStatesOpposite(up,down,no_change).
threeStatesOpposite(down,up,no_change).
threeStatesOpposite(no_change,up,down).





/***************************** Regulation Rules ******************************/
/****************** Direct Effect ******************/

/*---------- Blocked/Slower down ----------*/
concentration(s(DepthLimit),TrSoFar,Tr,VisitedNodes,PID,down,Time):-
	produced_by(PID,ReactionID,'IMPD'),
	catalyzed_by_ECclass(ReactionID,EC_Number),concentration_enzClass(EC_Number,down,Time),
	reaction_state(TrSoFar,Tr,ReactionID,EC_Number,enzymeLimiting,cataDecreased,Time).

concentration(s(CurrentDepth),TrSoFar,Tr,VisitedNodes,SID,up,Time):-				
	set(depthLimit,DepthLimit),peanoMinus1(DepthLimit,DepthLimit1),peanoGth(CurrentDepth,DepthLimit1),%write('succeed'),
	consumed_by(SID,ReactionID,'IMPD'),	
	catalyzed_by_ECclass(ReactionID,EC_Number), concentration_enzClass(EC_Number,down,Time),
	reaction_state(TrSoFar,Tr,ReactionID,EC_Number,enzymeLimiting,cataDecreased,Time).


/*---------- Speeded Up ----------*/
concentration(s(DepthLimit),TrSoFar,Tr,VisitedNodes,PID,up,Time):-
	produced_by(PID,ReactionID,'IMPD'),
	catalyzed_by_ECclass(ReactionID,EC_Number), concentration_enzClass(EC_Number,up,Time),
	reaction_state(TrSoFar,Tr,ReactionID,EC_Number,enzymeLimiting,cataIncreased,Time).

concentration(s(CurrentDepth),TrSoFar,Tr,VisitedNodes,SID,down,Time):-					
	set(depthLimit,DepthLimit),peanoMinus1(DepthLimit,DepthLimit1),peanoGth(CurrentDepth,DepthLimit1),%write('succeed'),
	consumed_by(SID,ReactionID,'IMPD'),	
	catalyzed_by_ECclass(ReactionID,EC_Number), concentration_enzClass(EC_Number,up,Time),
	reaction_state(TrSoFar,Tr,ReactionID,EC_Number,enzymeLimiting,cataIncreased,Time).



/*---------- Catalytically No change ----------*/
concentration(s(DepthLimit),TrSoFar,Tr,VisitedNodes,PID,no_change,Time):-
	produced_by(PID,ReactionID,'IMPD'),
	catalyzed_by_ECclass(ReactionID,EC_Number), concentration_enzClass(EC_Number,noChange,Time),
	reaction_state(TrSoFar,Tr,ReactionID,EC_Number,enzymeLimiting,cataNoChange,Time).

concentration(s(CurrentDepth),TrSoFar,Tr,VisitedNodes,SID,no_change,Time):-	
	set(depthLimit,DepthLimit),peanoMinus1(DepthLimit,DepthLimit1),peanoGth(CurrentDepth,DepthLimit1),%write('succeed'),
	consumed_by(SID,ReactionID,'IMPD'),	
	catalyzed_by_ECclass(ReactionID,EC_Number), concentration_enzClass(EC_Number,noChange,Time),
	%produced_by(SID,ReactionID_Any,'IMPD'), % complement to the next one, just ensure that there is no redundant %% no matter there is sth to produce or 
	reaction_state(TrSoFar,Tr,ReactionID,EC_Number,enzymeLimiting,cataNoChange,Time).


% This rule doesn't largely increased the candidates, because it requites not produced_by any reactions.
concentration(s(CurrentDepth),TrSoFar,Tr,VisitedNodes,SID,no_change,Time):-					
	set(depthLimit,DepthLimit),peanoMinus1(DepthLimit,DepthLimit1),peanoGth(CurrentDepth,DepthLimit1),%write('succeed'),
	consumed_by(SID,ReactionID,'IMPD'),	
	\+produced_by(SID,ReactionID_Any,'IMPD'),
	catalyzed_by_ECclass(ReactionID,EC_Number), concentration_enzClass(EC_Number,down,Time),
	reaction_state(TrSoFar,Tr,ReactionID,EC_Number,enzymeLimiting,cataDecreased,Time).


/*
concentration(s(DepthLimit),TrSoFar,Tr,VisitedNodes,PID,no_change,Time):-
	produced_by(PID,ReactionID,'IMPD'),
	\+consumed_by(PID,ReactionID_Any,'IMPD'),
	catalyzed_by_ECclass(ReactionID,EC_Number),
	reaction_state(TrSoFar,Tr,ReactionID,EC_Number,cataDecreased,Time),writeq(ReactionID),portray_clause(VisitedNodes).
*/



/****************** Indirect Effect (Substrate Limiting) ******************/
/*------------------------- Substrate Up------------------------*/
concentration(s(DepthLimit),TrSoFar,Tr,VisitedNodes,PID,up,Time):-				
	produced_by(PID,ReactionID,'IMPD'),	
	catalyzed_by_ECclass(ReactionID,EC_Number), 
	\+concentration_enzClass(EC_Number,Change,Time),
	reaction_state(TrSoFar,Tr1,ReactionID,EC_Number,substrateLimiting,cataNoChange,Time),
	consumed_by(SID,ReactionID,'IMPD'), \+partMember(SID,VisitedNodes),
	concentration(DepthLimit,Tr1,Tr,[{ReactionID,EC_Number,no_change}-PID|VisitedNodes],SID,up,Time).

concentration(s(DepthLimit),TrSoFar,Tr,VisitedNodes,PID,up,Time):-				
	produced_by(PID,ReactionID,'IMPD'),	
	catalyzed_by_ECclass(ReactionID,EC_Number), 
	\+concentration_enzClass(EC_Number,Change,Time),
	reaction_state(TrSoFar,Tr1,ReactionID,EC_Number,substrateLimiting,cataIncreased,Time),
	consumed_by(SID,ReactionID,'IMPD'),\+partMember(SID,VisitedNodes),
	concentration(DepthLimit,Tr1,Tr,[{ReactionID,EC_Number,cataDecreased}-PID|VisitedNodes],SID,up,Time).

concentration(s(DepthLimit),TrSoFar,Tr,VisitedNodes,PID,no_change,Time):-				
	produced_by(PID,ReactionID,'IMPD'),	
	catalyzed_by_ECclass(ReactionID,EC_Number), 
	\+concentration_enzClass(EC_Number,Change,Time),
	reaction_state(TrSoFar,Tr1,ReactionID,EC_Number,substrateLimiting,cataDecreased,Time),
	consumed_by(SID,ReactionID,'IMPD'),\+partMember(SID,VisitedNodes),
	concentration(DepthLimit,Tr1,Tr,[{ReactionID,EC_Number,cataDecreased}-PID|VisitedNodes],SID,up,Time).

concentration(s(DepthLimit),TrSoFar,Tr,VisitedNodes,PID,up,Time):-				
	produced_by(PID,ReactionID,'IMPD'),	
	catalyzed_by_ECclass(ReactionID,EC_Number),
	\+concentration_enzClass(EC_Number,Change,Time),
	reaction_state(TrSoFar,Tr1,ReactionID,EC_Number,substrateLimiting,cataDecreased,Time),
	consumed_by(SID,ReactionID,'IMPD'),\+partMember(SID,VisitedNodes),
	concentration(DepthLimit,Tr1,Tr,[{ReactionID,EC_Number,cataDecreased}-PID|VisitedNodes],SID,up,Time).





/*------------------------- Substrate Down ------------------------*/
concentration(s(DepthLimit),TrSoFar,Tr,VisitedNodes,PID,down,Time):-				
	produced_by(PID,ReactionID,'IMPD'),	
	catalyzed_by_ECclass(ReactionID,EC_Number), 
	\+concentration_enzClass(EC_Number,Change,Time),
	reaction_state(TrSoFar,Tr1,ReactionID,EC_Number,substrateLimiting,cataNoChange,Time),
	consumed_by(SID,ReactionID,'IMPD'), \+partMember(SID,VisitedNodes),
	concentration(DepthLimit,Tr1,Tr,[{ReactionID,EC_Number,no_change}-PID|VisitedNodes],SID,down,Time).

concentration(s(DepthLimit),TrSoFar,Tr,VisitedNodes,PID,down,Time):-				
	produced_by(PID,ReactionID,'IMPD'),	
	catalyzed_by_ECclass(ReactionID,EC_Number), 
	\+concentration_enzClass(EC_Number,Change,Time),
	reaction_state(TrSoFar,Tr1,ReactionID,EC_Number,substrateLimiting,cataDecreased,Time),
	consumed_by(SID,ReactionID,'IMPD'), \+partMember(SID,VisitedNodes),
	concentration(DepthLimit,Tr1,Tr,[{ReactionID,EC_Number,no_change}-PID|VisitedNodes],SID,down,Time).


concentration(s(DepthLimit),TrSoFar,Tr,VisitedNodes,PID,down,Time):-				
	produced_by(PID,ReactionID,'IMPD'),	
	catalyzed_by_ECclass(ReactionID,EC_Number),
	\+concentration_enzClass(EC_Number,Change,Time),
	reaction_state(TrSoFar,Tr1,ReactionID,EC_Number,substrateLimiting,cataIncreased,Time),
	consumed_by(SID,ReactionID,'IMPD'),\+partMember(SID,VisitedNodes),
	concentration(DepthLimit,Tr1,Tr,[{ReactionID,EC_Number,cataIncreased}-PID|VisitedNodes],SID,down,Time).

concentration(s(DepthLimit),TrSoFar,Tr,VisitedNodes,PID,no_change,Time):-				
	produced_by(PID,ReactionID,'IMPD'),	
	catalyzed_by_ECclass(ReactionID,EC_Number),
	\+concentration_enzClass(EC_Number,Change,Time),
	reaction_state(TrSoFar,Tr1,ReactionID,EC_Number,substrateLimiting,cataIncreased,Time),
	consumed_by(SID,ReactionID,'IMPD'),\+partMember(SID,VisitedNodes),
	concentration(DepthLimit,Tr1,Tr,[{ReactionID,EC_Number,cataIncreased}-PID|VisitedNodes],SID,down,Time).






partMember(M,Record):-
	maplist(wholeRecord_M,Record,Ms),
	member(M,Ms).

wholeRecord_M({ReactionID,EC_Number,Change}-PID,PID).
wholeRecord_M(SID-{ReactionID,EC_Number,Change},SID).






/*************** Abduce reaction_state	****************/
/* Simple version -- no incorporation of integrity constraint
reaction_state(TrSoFar,Tr,EC_Number,State):-
	Tr=[[reaction_state-{EC_Number,State}]|TrSoFar].
*/


% incorporate integrity constraint
% 1. one enzyme not to be hypothesized to several states: (1) the existing B; (2) the same 
% 2. the gene expression data. 

propotional(cataIncreased,up).
propotional(cataDecreased,down).
propotional(cataNoChange,noChange).

% This is not suitable when there are alternative similar rules 


% I don't think I really need Sign to be recorded, but to ensure to be used together with deriving hypotheses


reaction_state(TrSoFar,Tr,ReactionID,EC_Number,LimitingType,State,Time):-
	(appeared(ReactionID,EC_Number,TrSoFar,LimitingType2,State2)-> 
		State2==State, LimitingType2==LimitingType, % write('not contradiction'),nl,	% this will rarely happen -- unless it is going through a cycle, which is not allowed
		Tr=TrSoFar;
		Tr=[[rs-{Sign,ReactionID,EC_Number,LimitingType,State,Time}]|TrSoFar]	% Sign here will be left as a variable
	).


appeared(ReactionID,EC_Number,TrSoFar,LimitingType,State):-	
	% specify ReactionID, without it, it is possible for EC to have different states
	member([rs-{Sign,ReactionID,EC_Number,LimitingType,State,Time}],TrSoFar).
	%write({ReactionID,EC_Number,LimitingType,State,Time}),write(TrSoFar).
	%,nl,write('--Aha, appear before!--').
% appeared(EC_Number,TrSoFar,State):-	% won't happen since no cataDecreased is known, nor added to the background knowledge
%	reaction_state(EC_Number,State,Time).




