/* compare to t_noEC_constrateIncoporate.pl.
The name of simpleRecord refers to the record of visited nodes. 
*/


:- dynamic reaction_state/4, metConcentration/3.

:-['topCla'].
%:-['counting.pl'].
%:-['counting_includeLength'].
:-['b_noCycle'].


%set(depthLimit,s(s(s(s(0))))).
%set(depthLimit,s(s(s(s(s(s(0))))))). peanoMinus1(s(s(s(s(s(s(X)))))),X). %PianoNumDepthLimit):- numMap(6,PianoNumDepthLimit).
%set(depthLimit,s(0)). peanoMinus1(s(X),X).
%set(depthLimit,s(s(0))). peanoMinus1(s(s(X)),X).
set(depthLimit,s(s(s(0)))). peanoMinus1(s(s(s(X))),X).
%set(depthLimit,s(s(s(s(0))))).	peanoMinus1(s(s(s(s(X)))),X).

%set(depthLimit,s(s(s(s(s(s(s(0)))))))). % depth 7
%set(depthLimit,s(s(s(s(s(0)))))).
%set(depthLimit,s(s(s(s(s(s(s(s(s(s(0))))))))))).
set(etoB,yes).




% greater than
peanoGth(X,X).
peanoGth(s(Y),X):-peanoGth(Y,X).


/*********** using other examples ***********/
/*concentration(DepthLimit,Tr,Tr_previous,VisitedNodes,X,Change,Time):-	
	set(depthLimit,DepthLimit0),
	DepthLimit \== DepthLimit0,
	ex(EI,concentration(X,Change,Time),1),!,
	Tr=[[met-{X,Change,Time}]|Tr_previous]. % take out the hypothesis about metConcentration if it exist in the examples
	%write('%***using this example***'), write({EI,X,Change}),nl.
	%NewVisitedNodes=[X|VisitedNodes], % since it's the last one, so it doesn't matter in terms of format
	%write('--- one candidate Hypothesis: '),portray_clause(VisitedNodes),pathwayDetails(VisitedNodes).
*/

concentration(DepthLimit,Tr,Tr,VisitedNodes,X,Change,Time):- 
	set(depthLimit,DepthLimit0),
	DepthLimit \== DepthLimit0,
	threeStatesOpposite(Change,Opp1,Opp2),
	ex(EI,concentration(X,Measured,Time),1),
	(Measured=Opp1;Measured=Opp2),
	%write('!!! this metabolite is measured to be '), write({X,Measured}),nl,
	!,
	fail.


threeStatesOpposite(up,down,no_change).
threeStatesOpposite(down,up,no_change).
threeStatesOpposite(no_change,up,down).





/***************************** Regulation Rules ******************************/
/****************** Direct Effect ******************/

/*---------- Blocked/Slower down ----------*/
concentration(s(DepthLimit),TrSoFar,Tr,VisitedNodes,PID,down,Time):-
	produced_by(PID,ReactionID,'IMPD'),
	\+((consumed_by(SID,ReactionID,'IMPD'),member(SID,VisitedNodes))),
	reaction_state(TrSoFar,Tr,ReactionID,enzymeLimiting,cataDecreased,Time).

concentration(s(CurrentDepth),TrSoFar,Tr,VisitedNodes,SID,up,Time):-				
	set(depthLimit,DepthLimit),peanoMinus1(DepthLimit,DepthLimit1),peanoGth(CurrentDepth,DepthLimit1),%write('succeed'),
	consumed_by(SID,ReactionID,'IMPD'),	
	\+((produced_by(PID,ReactionID,'IMPD'),member(PID,VisitedNodes))),
	reaction_state(TrSoFar,Tr,ReactionID,enzymeLimiting,cataDecreased,Time).


/*---------- Speeded Up ----------*/
concentration(s(DepthLimit),TrSoFar,Tr,VisitedNodes,PID,up,Time):-
	produced_by(PID,ReactionID,'IMPD'),
	\+((consumed_by(SID,ReactionID,'IMPD'),member(SID,VisitedNodes))),
	reaction_state(TrSoFar,Tr,ReactionID,enzymeLimiting,cataIncreased,Time).

concentration(s(CurrentDepth),TrSoFar,Tr,VisitedNodes,SID,down,Time):-					
	set(depthLimit,DepthLimit),peanoMinus1(DepthLimit,DepthLimit1),peanoGth(CurrentDepth,DepthLimit1),%write('succeed'),
	consumed_by(SID,ReactionID,'IMPD'),	
	\+((produced_by(PID,ReactionID,'IMPD'),member(PID,VisitedNodes))),
	reaction_state(TrSoFar,Tr,ReactionID,enzymeLimiting,cataIncreased,Time).



/*---------- Catalytically No change ----------*/
concentration(s(DepthLimit),TrSoFar,Tr,VisitedNodes,PID,no_change,Time):-
	produced_by(PID,ReactionID,'IMPD'),
	reaction_state(TrSoFar,Tr,ReactionID,enzymeLimiting,cataNoChange,Time).

concentration(s(CurrentDepth),TrSoFar,Tr,VisitedNodes,SID,no_change,Time):-	
	set(depthLimit,DepthLimit),peanoMinus1(DepthLimit,DepthLimit1),peanoGth(CurrentDepth,DepthLimit1),%write('succeed'),
	consumed_by(SID,ReactionID,'IMPD'),	
	%produced_by(SID,ReactionID_Any,'IMPD'), % complement to the next one, just ensure that there is no redundant %% no matter there is sth to produce or 
	reaction_state(TrSoFar,Tr,ReactionID,enzymeLimiting,cataNoChange,Time).


% This rule doesn't largely increased the candidates, because it requites not produced_by any reactions.
concentration(s(CurrentDepth),TrSoFar,Tr,VisitedNodes,SID,no_change,Time):-					
	set(depthLimit,DepthLimit),peanoMinus1(DepthLimit,DepthLimit1),peanoGth(CurrentDepth,DepthLimit1),%write('succeed'),
	consumed_by(SID,ReactionID,'IMPD'),	
	\+produced_by(SID,ReactionID_Any,'IMPD'),
	reaction_state(TrSoFar,Tr,ReactionID,enzymeLimiting,cataDecreased,Time). 



% concept_accession('28096: GLT','LycoCyc2.0.1','GLT',false). '28096: GLT'
% concept_accession('28098: GLN','LycoCyc2.0.1','GLN',false). concept_accession('28098: GLN',

/****************** Indirect Effect (Substrate Limiting) ******************/
/*------------------------- Substrate Up------------------------*/
concentration(s(DepthLimit),TrSoFar,Tr,VisitedNodes,PID,up,Time):-				
	produced_by(PID,ReactionID,'IMPD'),
	reaction_state(TrSoFar,Tr1,ReactionID,substrateLimiting,sUp,Time),
	consumed_by(SID,ReactionID,'IMPD'),
	\+ubiqutousCompound(SID),
	\+member(SID,VisitedNodes),
	Tr2=[[met-{SID,up,Time}]|Tr1],
	concentration(DepthLimit,Tr2,Tr,[SID|VisitedNodes],SID,up,Time).


/*------------------------- Substrate Down ------------------------*/
concentration(s(DepthLimit),TrSoFar,Tr,VisitedNodes,PID,down,Time):-				
	produced_by(PID,ReactionID,'IMPD'),
	reaction_state(TrSoFar,Tr1,ReactionID,substrateLimiting,sDown,Time),
	consumed_by(SID,ReactionID,'IMPD'),
	\+ubiqutousCompound(SID),
	\+member(SID,VisitedNodes), 
	Tr2=[[met-{SID,down,Time}]|Tr1],
	concentration(DepthLimit,Tr2,Tr,[SID|VisitedNodes],SID,down,Time).


/*
concentration(s(DepthLimit),TrSoFar,Tr,VisitedNodes,PID,no_change,Time):-				
	produced_by(PID,ReactionID,'IMPD'),
	reaction_state(TrSoFar,Tr1,ReactionID,substrateLimiting,cataDecreased,Time),
	consumed_by(SID,ReactionID,'IMPD'),\+partMember(SID,VisitedNodes),
	concentration(DepthLimit,Tr1,Tr,[{ReactionID,cataDecreased}-PID|VisitedNodes],SID,up,Time).

concentration(s(DepthLimit),TrSoFar,Tr,VisitedNodes,PID,no_change,Time):-				
	produced_by(PID,ReactionID,'IMPD'),	
	reaction_state(TrSoFar,Tr1,ReactionID,substrateLimiting,cataIncreased,Time),
	consumed_by(SID,ReactionID,'IMPD'),\+partMember(SID,VisitedNodes),
	concentration(DepthLimit,Tr1,Tr,[{ReactionID,cataIncreased}-PID|VisitedNodes],SID,down,Time).
*/
% ??? What about substrate no_change?







/*************** Abduce reaction_state	****************/
/* Simple version -- no incorporation of integrity constraint
reaction_state(TrSoFar,Tr,EC_Number,State):-
	Tr=[[reaction_state-{EC_Number,State}]|TrSoFar].
*/


% incorporate integrity constraint
% 1. one enzyme not to be hypothesized to several states: (1) the existing B; (2) the same 
% 2. the gene expression data. 

% This is not suitable when there are alternative similar rules 


% I don't think I really need Sign to be recorded, but to ensure to be used together with deriving hypotheses

reaction_state(TrSoFar,Tr,ReactionID,LimitingType,State,Time):-
	constraintCheck(ReactionID,LimitingType,State,Time),
	noRedundant(ReactionID,TrSoFar),
	Tr=[[rs-{ReactionID,LimitingType,State,Time}]|TrSoFar].


noRedundant(ReactionID,TrSoFar):-
	\+redundantR(ReactionID,TrSoFar).

redundantR(reversed-ReactionID,TrSoFar):-
	!, (member([rs-{reversed-ReactionID,LimitingType,State,Time}],TrSoFar);member([rs-{ReactionID,LimitingType,State,Time}],TrSoFar)).
redundantR(ReactionID,TrSoFar):-
	(member([rs-{reversed-ReactionID,LimitingType,State,Time}],TrSoFar);member([rs-{ReactionID,LimitingType,State,Time}],TrSoFar)).




%constraintCheck(ReactionID,substrateLimiting,HypothesizedState,Time):-!. % always pass the test if they are substractLimiting.
% if enzyme limiting, then always require GE to support. -- Here the assumption is, those without GE are very expensive (in terms of DL), so they won't be selected in the end, so not to generate from the first instance
% if the there is one reaction without EC annotated, while is the shared point of more than one metabolites, then you may miss some good solution. 
constraintCheck(ReactionID,enzymeLimiting,cataNoChange,Time):-!. % hypothesising no change will always pass
constraintCheck(ReactionID,enzymeLimiting,HypothesizedState,Time):- 
	catalyzed_by_ECclass(ReactionID,EC_Number), 
	concentration_e(EC_Number,GEChange,Degree,Time),!,
	proportional(HypothesizedState,GEChange).
%constraintCheck(ReactionID,enzymeLimiting,HypothesizedState,Time). % always passed if no GE annotated
constraintCheck(ReactionID,substrateLimiting,HypothesizedState,Time). 




% compared to b_noCycle0.pl, this one removes those about no_change
% both Substrate and Enzyme Limiting -- no conditions to guide the road
% indirect mapping from reaction to EC via enzymes's ecClass
% terminology -- catINcreased, catDEcreased


% catalyzed_by_ECclass -- move to network/a.pl

queriedE(concentration(MID,Change,Time),concentration(MID,Change,Time,[MID])).

/*
concentration(X,Change,Time,VisitedNodes):-	% using other examples
	%write('try to use old'),
	ex(EI,concentration(X,Change,Time),1),!.
%,write('-=-=-=-=-=-=-=-=-old do exit-----------------'),write('***using this example***'), writeq(EI-X), write(' and '), write(VisitedNodes),nl.
% won't be used in reasoning, but used in T for excluding those useless
*/

concentration(X,Change,Time,VisitedNodes):- 
	length(VisitedNodes,K),K>1,
	threeStatesOpposite(Change,Opp1,Opp2),
	ex(EI,concentration(X,Measured,Time),1),
	(Measured=Opp1;Measured=Opp2),
	%write('!!! this metabolite is measured to be '), write({X,Measured}),nl,
	!,
	fail.




/****************** Direct Effect ******************/
/*---------- Blocked/Slower down ----------*/
% 12,15,18 enzyme inhibited
concentration(PID,down,Time,VisitedNodes):-				%concept_name(P,PID,true),	
	produced_by(PID,ReactionID,'IMPD'),	%reaction(ReactionID,'','LycoCyc','IMPD'),
	\+((consumed_by(SID,ReactionID,'IMPD'),member(SID,VisitedNodes))),
	reaction_state(ReactionID,enzymeLimiting,cataDecreased,Time).
	%enzyme_state(EC_Number,inhibited),portray_clause(VisitedNodes),write({EC_Number,inhibited}).


% enzyme inhibited
concentration(SID,up,Time,VisitedNodes):-				%concept_name(S,SID,true),	
	length(VisitedNodes,K),K<3,
	consumed_by(SID,ReactionID,'IMPD'),	%reaction(ReactionID,'','LycoCyc','IMPD'),
	\+((produced_by(PID,ReactionID,'IMPD'),member(PID,VisitedNodes))),
	reaction_state(ReactionID,enzymeLimiting,cataDecreased,Time).
	%enzyme_state(EC_Number,inhibited),portray_clause(VisitedNodes),write(' weird if long effect'),write({EC_Number,inhibited}).



/*---------- Speeded Up ----------*/
% 10,13,16 enzyme activated
concentration(PID,up,Time,VisitedNodes):-				%concept_name(P,PID,true),	
	produced_by(PID,ReactionID,'IMPD'),	%reaction(ReactionID,'','LycoCyc','IMPD'),
	\+((consumed_by(SID,ReactionID,'IMPD'),member(SID,VisitedNodes))),
	reaction_state(ReactionID,enzymeLimiting,cataIncreased,Time).


% enzyme activated
concentration(SID,down,Time,VisitedNodes):-				%concept_name(S,SID,true),	
	length(VisitedNodes,K),K<3,
	consumed_by(SID,ReactionID,'IMPD'),	%reaction(ReactionID,'','LycoCyc','IMPD'),
	\+((produced_by(PID,ReactionID,'IMPD'),member(PID,VisitedNodes))),
	reaction_state(ReactionID,enzymeLimiting,cataIncreased,Time).


/*---------- No change----------*/
concentration(PID,no_change,Time,VisitedNodes):-				%concept_name(P,PID,true),	
	produced_by(PID,ReactionID,'IMPD'),	%reaction(ReactionID,'','LycoCyc','IMPD'),
	reaction_state(ReactionID,enzymeLimiting,cataNoChange,Time).	


concentration(SID,no_change,Time,VisitedNodes):-				%concept_name(S,SID,true),	
	length(VisitedNodes,K),K<3,
	consumed_by(SID,ReactionID,'IMPD'),	%reaction(ReactionID,'','LycoCyc','IMPD'),
	reaction_state(ReactionID,enzymeLimiting,cataNoChange,Time).

concentration(SID,no_change,Time,VisitedNodes):-				%concept_name(S,SID,true),	
	length(VisitedNodes,K),K<3,
	consumed_by(SID,ReactionID,'IMPD'),	%reaction(ReactionID,'','LycoCyc','IMPD'),
	\+produced_by(SID,ReactionID_Any,'IMPD'),
	reaction_state(ReactionID,enzymeLimiting,cataNoChange,Time).


/****************** Indirect Effect -- Substrate Limiting ******************/

% S up
concentration(PID,up,Time,VisitedNodes):-				%concept_name(P,PID,true),	
	produced_by(PID,ReactionID,'IMPD'),	%reaction(ReactionID,'','LycoCyc','IMPD'),
	reaction_state(ReactionID,substrateLimiting,sUp,Time),
	consumed_by(SID,ReactionID,'IMPD'),
	\+ubiqutousCompound(SID),
	\+member(SID,VisitedNodes),
	concentration(SID,up,Time,[SID|VisitedNodes]).

% S down
concentration(PID,down,Time,VisitedNodes):-				%concept_name(P,PID,true),	
	produced_by(PID,ReactionID,'IMPD'),	%reaction(ReactionID,'','LycoCyc','IMPD'),
	reaction_state(ReactionID,substrateLimiting,sDown,Time), 
	consumed_by(SID,ReactionID,'IMPD'),
	\+ubiqutousCompound(SID),
	\+member(SID,VisitedNodes),
	concentration(SID,down,Time,[SID|VisitedNodes]).





/************ Integrity Constraint **************/
integrityConstraint:-
	reaction_state0(ReactionID,LimitingType1,Change1,Time),reaction_state0(ReactionID,LimitingType2,Change2,Time),
	Change1\==Change2,LimitingType1\==LimitingType2,write('-----------------------reaction_state Integrity Constraint violated'). % this include the case that their limiting types are different.

integrityConstraint:-
	metConcentration(SID,Change1,Time),metConcentration(SID,Change2,Time), 
	Change1\==Change2,write('-----------------------metabolite constraint violated').



reaction_state(ReactionID,LimitingType,Change,Time):-
	reaction_state0(ReactionID,LimitingType0,Change0,Time),!,
	LimitingType==LimitingType0,Change==Change0.  

closedWorldAssumption((reaction_state(RID,substrateLimiting,HypothesizedState,Time):-member(0,[0]))). % this means, if it is not hypothesised. member(0,[0]) is to add another depth



