/*------- Cross Product-------*/
allEs(DepthLimit,EIs,RecordAll):-	
	findall(Tr,
		(
		 oneByone(DepthLimit,EIs,[],Tr),%write('OneTr'),write(Tr),nl,write('PreRemove'),listing,removeRefT(Tr),write('AfterRemove'),listing,
			consistentCheck(Tr,FinalT),
		 nl
		%tInterpreter(Tr,T)
		%,write('*** One theory'),nl,
		%write(Tr),nl,	% track the ID of clauses in B
		%print_list(T),nl,nl
	 
		),
		RecordAll).


oneByone(_,[],Tr,Tr).
oneByone(DepthLimit,[EI|EIs],TrSoFar,Tr):-
	gEx(DepthLimit,EI,OneTr),
	append(OneTr,TrSoFar,NewTrSoFar), 
	%noRedundantAdd(OneTr,TrSoFar,NewTrSoFar), % check integrity constraint; 
	oneByone(DepthLimit,EIs,NewTrSoFar,Tr).


%1. add. Ref is included in Tr
noRedundantAdd([],TrSoFar,TrSoFar).
noRedundantAdd([ClauseIndex|OneTr],TrSoFar,NewTrSoFar):-
	hInterpreter(ClauseIndex,Clause),
	%(partialMem(ClauseIndex,TrSoFar,Sign),!;
	redundantCheck(Clause,Sign)
	,%),
	(Sign==redundant->
		write('Redundant HERE'),%listing,nl,
		UpdatedTrSoFar=TrSoFar;
		length(Clause,K),assertaH(K,Clause,Ref),
		UpdatedTrSoFar=[Ref-ClauseIndex|TrSoFar]
	),
	noRedundantAdd(OneTr,UpdatedTrSoFar,NewTrSoFar).

partialMem(ClauseIndex,[],nonRedundant).
partialMem(ClauseIndex,[Ref-ClauseIndex|TrSoFar],redundant):- !.
partialMem(ClauseIndex,[Ref-ClauseIndex2|TrSoFar],Sign):-
		partialMem(ClauseIndex,TrSoFar,Sign).


