searchFor_finalH(AllCandidates,Threshold,FinalHs):-
	findall(OneFinalH,find_one_finalH(AllCandidates,[],Threshold,[]-0-[],OneFinalH),FinalHs),
	(FinalHs==[] ->
		write('No Hypothesis derived :(');
		write('Derived Hypothesis: '),write(FinalHs)
	).

% OneFinalH = EITIs-Score-ClaID
find_one_finalH([],ToBeAvoided,Threshold,OneFinalH,OneFinalH).
find_one_finalH([EI-TIs|Candidates],ToBeAvoided,Threshold,OneFinalH_sofar,OneFinalH):-
	removeContradicted(EI-TIs,ToBeAvoided,RemainTIs),
	member(TI,RemainTIs),candidateH0(EI,TI,OneExH),
	addOneExH(EI-TI,OneExH,OneFinalH_sofar,NewEITIs-NewScore-NewClaIDs),
	NewScore<Threshold,
	updateAvoided(EI-TI,ToBeAvoided,ToBeAvoided_updated),
	find_one_finalH(Candidates,ToBeAvoided_updated,Threshold,NewEITIs-NewScore-NewClaIDs,OneFinalH).	
	

removeContradicted(EI-TIs,[EI-AvoidingTI|ToBeAvoided],RemainTIs):-
	!,gatherSameEITI(EI,[EI-AvoidingTI|ToBeAvoided],AvoidingTIs),
	ord_subtract(TIs,AvoidingTIs,RemainTIs).
removeContradicted(EI-TIs,ToBeAvoided,TIs).

gatherSameEITI(EI,[],[]).
gatherSameEITI(EI,[EI1-AvoidingTI|ToBeAvoided],[]):- EI1\==EI.
gatherSameEITI(EI,[EI-AvoidingTI|ToBeAvoided],[AvoidingTI|AvoidingTIs]):-
	!,gatherSameEITI(EI,ToBeAvoided,AvoidingTIs).



updateAvoided(EI-TI,ToBeAvoided,ToBeAvoided_updated):-
	contradictHs(EI-TI,NewAvoids),!,
	ord_union(NewAvoids,ToBeAvoided,ToBeAvoided_updated).
updateAvoided(EI-TI,ToBeAvoided,ToBeAvoided).

identify_sharedClaID(EITIs_sofar,[],[]).
identify_sharedClaID(EITIs_sofar,[ClaID|ClaIDs],SharedClaID):-
	sharedHs(ClaID,SharedEITIs),!,
	ord_intersection(SharedEITIs,EITIs_sofar,Intersection),
	(Intersection==[] ->
		SharedClaID=PreSharedClaID;
		SharedClaID=[ClaID|PreSharedClaID]
	),
	identify_sharedClaID(EITIs_sofar,ClaIDs,PreSharedClaID).
identify_sharedClaID(EITIs_sofar,[ClaID|ClaIDs],SharedClaID):-
	identify_sharedClaID(EITIs_sofar,ClaIDs,SharedClaID).


%only need to remove duplicate.-->if no shared,then simply add.
addOneExH(EI-TI,OneExH,EITIs_sofar-Score_sofar-ClaIDs_sofar,EITIs-Score-ClaIDs):-
	identify_sharedClaID(EITIs_sofar,OneExH,Shared_ClaIDs),
	Shared_ClaIDs\==[],!,
	ord_union([EI-TI],EITIs_sofar,EITIs),
	noRedundantAdd(OneExH,Shared_ClaIDs,Score_sofar-ClaIDs_sofar,Score-ClaIDs).

addOneExH(EI-TI,OneExH,EITIs_sofar-Score_sofar-ClaIDs_sofar,EITIs-Score-ClaIDs):-
	ord_union([EI-TI],EITIs_sofar,EITIs),
	hScore(EI-TI,HScore),Score is Score_sofar+HScore,
	append(OneExH,ClaIDs_sofar,ClaIDs).
	
noRedundantAdd([],Shared_ClaIDs,Score-ClaIDs,Score-ClaIDs).
noRedundantAdd([ClaID|OneExH],Shared_ClaIDs,Score_sofar-ClaIDs_sofar,Score-ClaIDs):-
	member(ClaID,Shared_ClaIDs),!,
	noRedundantAdd(OneExH,Shared_ClaIDs,Score_sofar-ClaIDs_sofar,Score-ClaIDs).
noRedundantAdd([ClaID|OneExH],Shared_ClaIDs,Score_sofar-ClaIDs_sofar,Score-ClaIDs):-
	clause_length(ClaID,ClaDL),
	UpdatedScore is Score_sofar+ClaDL,
	noRedundantAdd(OneExH,Shared_ClaIDs,UpdatedScore-[ClaID|ClaIDs_sofar],Score-ClaIDs).
	
