selectSharedClauses(PosEIs,Hypothesis):-
	tell('candidateH2.pl'), %tell('grammar_candidateH.pl'),	
	genAll(PosEIs,AllTs,TotalNum),%genAll_EIsigned(PosEIs,AllTs,TotalNum),
	write('%Total is '), write(TotalNum),nl,
	%print_list(AllTs),nl,
	told,
	consult('candidateH2.pl'),	%consult('grammar_candidateH.pl'),
	
	%tell('tomatoCountedResult.pl'),

	rb_new(Tree0),
	reverse(PosEIs,PosEIsReversedOrder),
	insertTheories(PosEIsReversedOrder,Tree0,Tree), % insertTheories(AllTs,Tree0,Tree) *** be careful about the function you are using
	%scoreAll(AllTs,Tree,ScoredEIsTs).
	rb_visit(Tree,T_EITIs),print_list(T_EITIs),

	sharedClauseAsHypothesis(T_EITIs,Hypothesis).


sharedClauseAsHypothesis([],[]).
sharedClauseAsHypothesis([ClaID-EITIs|Record],H):-
	sharedClauseAsHypothesis(Record,PreH),
	exExtraction(EITIs,EIs),
	length(EIs,EINum),
	(EINum>1 ->
		H=[ClaID|PreH];
		H=PreH
	).
	

sharedClauseAsHypothesis_one(ClaID-EITIs,ClaID):-
      exExtraction(EITIs,EIs),
      length(EIs,EINum),EINum>1,!.




indentifySharedClauses(PosEIs):-
	tell('candidateH.pl'), %tell('grammar_candidateH.pl'),	
	genAll(PosEIs,AllTs,TotalNum),%genAll_EIsigned(PosEIs,AllTs,TotalNum),
	write('%Total is '), write(TotalNum),nl,
	%print_list(AllTs),nl,
	told,
	consult('candidateH.pl'),	%consult('grammar_candidateH.pl'),
	
	%tell('tomatoCountedResult.pl'),

	rb_new(Tree0),
	reverse(PosEIs,PosEIsReversedOrder),
	insertTheories(PosEIsReversedOrder,Tree0,Tree), % insertTheories(AllTs,Tree0,Tree) *** be careful about the function you are using
	%scoreAll(AllTs,Tree,ScoredEIsTs).
	rb_visit(Tree,T_EITIs),%print_list(T_EITIs),
	tell('sharedInfo.pl'),
	maplist(findSharedControlPoint,T_EITIs),
	told, consult('sharedInfo.pl'),
	tell('nonControlSharedInfo.pl'),
	forAll(sharedNonControl0({MID,Change,Time},EITIs),outputNonControlPoint_overlapping({MID,Change,Time},EITIs)),
	told,
	nl.



findSharedControlPoint(ClaID-EITIs):-
      exExtraction(EITIs,EIs),
      length(EIs,EINum),
      (EINum==1 ->
	      Foo=0; % doing nothing
	      outputSharedInfo(ClaID,EITIs)
      ).


outputSharedInfo([rs-{RID,enzymeLimiting,Change,Time}],EITIs):-
      !,	
      RID_Info={RID,Change,Time},
      portray_clause(sharedControlPoint(RID_Info,EITIs)),
      maplist(output_sharedControlPoint_EITI(RID_Info),EITIs).

output_sharedControlPoint_EITI(RID_Info,EI-TI):- portray_clause(sharedControlPoint_EITI(EI,TI,RID_Info)). % RID_Info={RID,Change,Time} % control point means enzymeLimiting


outputSharedInfo([rs-{RID,substrateLimiting,Change,Time}],EITIs):-
      portray_clause(sharedNonControl0({RID,Change,Time},EITIs)). % only whose EI-TI shared the enzymeLimiting
outputSharedInfo([met-{MID,Change,Time}],EITIs):-
      portray_clause(sharedNonControl0({MID,Change,Time},EITIs)).



outputNonControlPoint_overlapping({MID,Change,Time},EITIs):-
      selectShareControlPoint(EITIs,Record),
      (Record==[] ->
	      Foo=0;
	      gatherSameControlPoint(Record,SameControlPointModule),
	      maplist(output_nonControlShared({MID,Change,Time}),SameControlPointModule)
	      %portray_clause(nonControlShared({MID,Change,Time},SameControlPointModule))
      ).


output_nonControlShared({MID,Change,Time},ControlPointInfo-EITIs):-
      exExtraction(EITIs,EIs),
      length(EIs,EINum),
      (EINum==1 ->
	      Foo=0; % doing nothing
	      portray_clause(nonControlShared({MID,Change,Time},EITIs)) %output_nonControlShared_EITI({MID,Change,Time},EITIs)
      ).

      %output(SameControlPointModule), % only want to know whether should be cross product or not, so don't need substrateLimitingID, and  
    % then if non-single EI, then output, 
%sharedNonControl0({reversed-'9872',sDown,'NOR_L'},[91-80,91-153,91-223,91-295,91-366,91-444,91-516,91-588,91-661,91-740,91-812,91-882,91-953,91-1026,91-1097,91-1167,91-1239,91-1310,91-1383,91-1454,91-1526,91-1600,91-1671,91-1747,91-1820,91-1893,91-1964,91-2038,91-2109,91-2185,91-2257,91-2329,91-2401,91-2473,91-2545,91-2615,91-2687,91-2758,91-2910,105-36,105-127]).

selectShareControlPoint([],[]).
selectShareControlPoint([EI-TI|EITIs],[{RID_Info,EI-TI}|Record]):-
      sharedControlPoint_EITI(EI,TI,RID_Info),!,
      selectShareControlPoint(EITIs,Record).
selectShareControlPoint([EI-TI|EITIs],Record):-
      selectShareControlPoint(EITIs,Record).



gatherSameControlPoint([],[]).
gatherSameControlPoint([{RID_Info,EI-TI}|Rest],GroupResult):-
	gatherSameControlPoint(Rest,PreGroupResult),
	(append(Pre,[RID_Info-SameControlPointEITIs|Post],PreGroupResult)->
		 append(Pre,[RID_Info-[EI-TI|SameControlPointEITIs]|Post],GroupResult);
		 GroupResult=[RID_Info-[EI-TI]|PreGroupResult]
	).




% for each module, find their shortest explanation. 
% if there is no shared in terms of substrateLimiting, then simply the shortest set for each EI; 
% while if there is shared -- cross product? -- ONLY shortest+ shared 
% wrap with EI and Description Length



% group based on EI -- within each group


% then do the cross product. -- don't simply decompose all the components
% alternatively, you can identify the smallest set among them, and then the selection start from the one with most smallest. -- update EI, and find the next s

  