:-['catalyzedBy_info.pl'].

concept_name(reversed-RID,reversed-RName,true):-
	concept_name(RID,RName,true).
concept_accession(reversed-RID,_,reversed-RName,true):-
	concept_accession(RID,_,RName,true).

% please replace concept_name0 back
concept_name(RID,RName,false):-
	reaction(RID,_,Path,'KEGGMAP','IMPD'),!,
	concept_name0(RID,RName,false),
	atom_chars(RName,[r,n,o|Rest]).

concept_accession(RID,'KEGG',RName,true):-
	reaction(RID,_,Path,'KEGGMAP','IMPD'),!,
	atom_chars(RID,CharsList),
	append(Pre,[':',' ',r,n,':'|RNameList],CharsList),
	atom_chars(RName,RNameList).
	
concept_accession(MID,'KEGG',MName,true):-
	metabolite(MID,'',PathwayIDs,'KEGGMAP','IMPD'),!,
	atom_chars(MID,CharsList),
	append(Pre,[':',' ',c,p,d,':'|MNameList],CharsList),
	atom_chars(MName,MNameList).


produced_by(PID,RID,'IMPD'):- 
	produces(RID,PID,'IMPD').
produced_by(PID,reversed-RID,'IMPD'):- 
	reaction(RID,'reversible',Path,'KEGGMAP','IMPD'),
	consumed_by0(PID,RID,'IMPD'), \+produces(RID,PID,'IMPD'). 

consumed_by(PID,RID,'IMPD'):- 
	consumed_by0(PID,RID,'IMPD').
consumed_by(PID,reversed-RID,'IMPD'):- 
	reaction(RID,'reversible',Path,'KEGGMAP','IMPD'),
	produces(RID,PID,'IMPD'),\+consumed_by0(PID,RID,'IMPD'). 


pathway('1: rn00010','Glycolysis / Gluconeogenesis','path:rn00010','KEGGMAP','IMPD').
pathway('30134: rno00250','Alanine, aspartate and glutamate metabolism','path:rno00250','KEGGMAP','IMPD').
pathway('31565: rno00400','Phenylalanine, tyrosine and tryptophan biosynthesis','path:rno00400','KEGGMAP','IMPD').
pathway('3838: rn00360','Phenylalanine metabolism','path:rn00360','KEGGMAP','IMPD').
pathway('7659: rn00620','Pyruvate metabolism','path:rn00620','KEGGMAP','IMPD').
pathway('13122: rn00970','Aminoacyl-tRNA biosynthesis','path:rn00970','KEGGMAP','IMPD').
pathway('13613: rn00983','Drug metabolism - other enzymes','path:rn00983','KEGGMAP','IMPD').
pathway('30599: rno00290','Valine, leucine and isoleucine biosynthesis','path:rno00290','KEGGMAP','IMPD').
pathway('35230: rno00970','Aminoacyl-tRNA biosynthesis','path:rno00970','KEGGMAP','IMPD').
pathway('34669: rno00790','Folate biosynthesis','path:rno00790','KEGGMAP','IMPD').
pathway('33083: rno00563','Glycosylphosphatidylinositol(GPI)-anchor biosynthesis','path:rno00563','KEGGMAP','IMPD').
pathway('8294: rn00625','Chloroalkane and chloroalkene degradation','path:rn00625','KEGGMAP','IMPD').
pathway('28191: rno00051','Fructose and mannose metabolism','path:rno00051','KEGGMAP','IMPD').
pathway('514: rn00052','Galactose metabolism','path:rn00052','KEGGMAP','IMPD').
pathway('31047: rno00340','Histidine metabolism','path:rno00340','KEGGMAP','IMPD').
pathway('34653: rno00785','Lipoic acid metabolism','path:rno00785','KEGGMAP','IMPD').
pathway('32030: rno00500','Starch and sucrose metabolism','path:rno00500','KEGGMAP','IMPD').
pathway('9756: rn00730','Thiamine metabolism','path:rn00730','KEGGMAP','IMPD').
pathway('29132: rno00130','Ubiquinone and other terpenoid-quinone biosynthesis','path:rno00130','KEGGMAP','IMPD').
pathway('9276: rn00670','One carbon pool by folate','path:rn00670','KEGGMAP','IMPD').
pathway('4909: rn00430','Taurine and hypotaurine metabolism','path:rn00430','KEGGMAP','IMPD').
pathway('29671: rno00230','Purine metabolism','path:rno00230','KEGGMAP','IMPD').
pathway('6550: rn00550','Peptidoglycan biosynthesis','path:rn00550','KEGGMAP','IMPD').
pathway('8070: rn00624','Polycyclic aromatic hydrocarbon degradation','path:rn00624','KEGGMAP','IMPD').
pathway('13693: rn01040','Biosynthesis of unsaturated fatty acids','path:rn01040','KEGGMAP','IMPD').
pathway('7587: rn00604','Glycosphingolipid biosynthesis - ganglio series','path:rn00604','KEGGMAP','IMPD').
pathway('614: rn00053','Ascorbate and aldarate metabolism','path:rn00053','KEGGMAP','IMPD').
pathway('34623: rno00780','Biotin metabolism','path:rno00780','KEGGMAP','IMPD').
pathway('4959: rn00440','Phosphonate and phosphinate metabolism','path:rn00440','KEGGMAP','IMPD').
pathway('1031: rn00071','Fatty acid metabolism','path:rn00071','KEGGMAP','IMPD').
pathway('30663: rno00300','Lysine biosynthesis','path:rno00300','KEGGMAP','IMPD').
pathway('12565: rn00950','Isoquinoline alkaloid biosynthesis','path:rn00950','KEGGMAP','IMPD').
pathway('97: rn00020','Citrate cycle (TCA cycle)','path:rn00020','KEGGMAP','IMPD').
pathway('32616: rno00524','Butirosin and neomycin biosynthesis','path:rno00524','KEGGMAP','IMPD').
pathway('2768: rn00280','Valine, leucine and isoleucine degradation','path:rn00280','KEGGMAP','IMPD').
pathway('9317: rn00680','Methane metabolism','path:rn00680','KEGGMAP','IMPD').
pathway('4447: rn00380','Tryptophan metabolism','path:rn00380','KEGGMAP','IMPD').
pathway('1536: rn00140','Steroid hormone biosynthesis','path:rn00140','KEGGMAP','IMPD').
pathway('33136: rno00564','Glycerophospholipid metabolism','path:rno00564','KEGGMAP','IMPD').
pathway('3235: rn00330','Arginine and proline metabolism','path:rn00330','KEGGMAP','IMPD').
pathway('34563: rno00770','Pantothenate and CoA biosynthesis','path:rno00770','KEGGMAP','IMPD').
pathway('9815: rn00740','Riboflavin metabolism','path:rn00740','KEGGMAP','IMPD').
pathway('6611: rn00561','Glycerolipid metabolism','path:rn00561','KEGGMAP','IMPD').
pathway('34092: rno00640','Propanoate metabolism','path:rno00640','KEGGMAP','IMPD').
pathway('33605: rno00601','Glycosphingolipid biosynthesis - lacto and neolacto series','path:rno00601','KEGGMAP','IMPD').
pathway('30491: rno00280','Valine, leucine and isoleucine degradation','path:rno00280','KEGGMAP','IMPD').
pathway('2612: rn00270','Cysteine and methionine metabolism','path:rn00270','KEGGMAP','IMPD').
pathway('32173: rno00510','N-Glycan biosynthesis','path:rno00510','KEGGMAP','IMPD').
pathway('1774: rn00230','Purine metabolism','path:rn00230','KEGGMAP','IMPD').
pathway('8385: rn00626','Naphthalene degradation','path:rn00626','KEGGMAP','IMPD').
pathway('35619: rno00983','Drug metabolism - other enzymes','path:rno00983','KEGGMAP','IMPD').
pathway('6448: rn00532','Glycosaminoglycan biosynthesis - chondroitin sulfate','path:rn00532','KEGGMAP','IMPD').
pathway('7545: rn00603','Glycosphingolipid biosynthesis - globo series','path:rn00603','KEGGMAP','IMPD').
pathway('29028: rno00120','Primary bile acid biosynthesis','path:rno00120','KEGGMAP','IMPD').
pathway('35100: rno00910','Nitrogen metabolism','path:rno00910','KEGGMAP','IMPD').
pathway('34791: rno00860','Porphyrin and chlorophyll metabolism','path:rno00860','KEGGMAP','IMPD').
pathway('12769: rn00960','Tropane, piperidine and pyridine alkaloid biosynthesis','path:rn00960','KEGGMAP','IMPD').
pathway('32674: rno00531','Glycosaminoglycan degradation','path:rno00531','KEGGMAP','IMPD').
pathway('31725: rno00430','Taurine and hypotaurine metabolism','path:rno00430','KEGGMAP','IMPD').
pathway('5050: rn00450','Selenocompound metabolism','path:rn00450','KEGGMAP','IMPD').
pathway('27827: rno00010','Glycolysis / Gluconeogenesis','path:rno00010','KEGGMAP','IMPD').
pathway('162: rn00030','Pentose phosphate pathway','path:rn00030','KEGGMAP','IMPD').
pathway('9869: rn00750','Vitamin B6 metabolism','path:rn00750','KEGGMAP','IMPD').
pathway('10366: rn00860','Porphyrin and chlorophyll metabolism','path:rn00860','KEGGMAP','IMPD').
pathway('3188: rn00311','Penicillin and cephalosporin biosynthesis','path:rn00311','KEGGMAP','IMPD').
pathway('8903: rn00640','Propanoate metabolism','path:rn00640','KEGGMAP','IMPD').
pathway('14264: rn01058','Acridone alkaloid biosynthesis','path:rn01058','KEGGMAP','IMPD').
pathway('29971: rno00240','Pyrimidine metabolism','path:rno00240','KEGGMAP','IMPD').
pathway('6112: rn00522','Biosynthesis of 12-, 14- and 16-membered macrolides','path:rn00522','KEGGMAP','IMPD').
pathway('2085: rn00232','Caffeine metabolism','path:rn00232','KEGGMAP','IMPD').
pathway('6975: rn00565','Ether lipid metabolism','path:rn00565','KEGGMAP','IMPD').
pathway('34278: rno00670','One carbon pool by folate','path:rno00670','KEGGMAP','IMPD').
pathway('11781: rn00920','Sulfur metabolism','path:rn00920','KEGGMAP','IMPD').
pathway('11299: rn00906','Carotenoid biosynthesis','path:rn00906','KEGGMAP','IMPD').
pathway('28301: rno00052','Galactose metabolism','path:rno00052','KEGGMAP','IMPD').
pathway('35689: rno01040','Biosynthesis of unsaturated fatty acids','path:rno01040','KEGGMAP','IMPD').
pathway('6500: rn00540','Lipopolysaccharide biosynthesis','path:rn00540','KEGGMAP','IMPD').
pathway('13823: rn01051','Biosynthesis of ansamycins','path:rn01051','KEGGMAP','IMPD').
pathway('10812: rn00902','Monoterpenoid biosynthesis','path:rn00902','KEGGMAP','IMPD').
pathway('2143: rn00240','Pyrimidine metabolism','path:rn00240','KEGGMAP','IMPD').
pathway('34184: rno00650','Butanoate metabolism','path:rno00650','KEGGMAP','IMPD').
pathway('34731: rno00830','Retinol metabolism','path:rno00830','KEGGMAP','IMPD').
pathway('11886: rn00940','Phenylpropanoid biosynthesis','path:rn00940','KEGGMAP','IMPD').
pathway('1177: rn00072','Synthesis and degradation of ketone bodies','path:rn00072','KEGGMAP','IMPD').
pathway('33768: rno00603','Glycosphingolipid biosynthesis - globo series','path:rno00603','KEGGMAP','IMPD').
pathway('10249: rn00791','Atrazine degradation','path:rn00791','KEGGMAP','IMPD').
pathway('28395: rno00053','Ascorbate and aldarate metabolism','path:rno00053','KEGGMAP','IMPD').
pathway('7953: rn00623','Toluene degradation','path:rn00623','KEGGMAP','IMPD').
pathway('32743: rno00532','Glycosaminoglycan biosynthesis - chondroitin sulfate','path:rno00532','KEGGMAP','IMPD').
pathway('31657: rno00410','beta-Alanine metabolism','path:rno00410','KEGGMAP','IMPD').
pathway('5526: rn00510','N-Glycan biosynthesis','path:rn00510','KEGGMAP','IMPD').
pathway('33267: rno00565','Ether lipid metabolism','path:rno00565','KEGGMAP','IMPD').
pathway('1195: rn00100','Steroid biosynthesis','path:rn00100','KEGGMAP','IMPD').
pathway('8838: rn00633','Nitrotoluene degradation','path:rn00633','KEGGMAP','IMPD').
pathway('5104: rn00460','Cyanoamino acid metabolism','path:rn00460','KEGGMAP','IMPD').
pathway('10296: rn00830','Retinol metabolism','path:rn00830','KEGGMAP','IMPD').
pathway('6475: rn00534','Glycosaminoglycan biosynthesis - heparan sulfate','path:rn00534','KEGGMAP','IMPD').
pathway('728: rn00061','Fatty acid biosynthesis','path:rn00061','KEGGMAP','IMPD').
pathway('31129: rno00350','Tyrosine metabolism','path:rno00350','KEGGMAP','IMPD').
pathway('250: rn00040','Pentose and glucuronate interconversions','path:rn00040','KEGGMAP','IMPD').
pathway('3595: rn00350','Tyrosine metabolism','path:rn00350','KEGGMAP','IMPD').
pathway('7032: rn00590','Arachidonic acid metabolism','path:rn00590','KEGGMAP','IMPD').
pathway('13221: rn00980','Metabolism of xenobiotics by cytochrome P450','path:rn00980','KEGGMAP','IMPD').
pathway('9950: rn00760','Nicotinate and nicotinamide metabolism','path:rn00760','KEGGMAP','IMPD').
pathway('35185: rno00920','Sulfur metabolism','path:rno00920','KEGGMAP','IMPD').
pathway('6057: rn00521','Streptomycin biosynthesis','path:rn00521','KEGGMAP','IMPD').
pathway('28906: rno00072','Synthesis and degradation of ketone bodies','path:rno00072','KEGGMAP','IMPD').
pathway('6322: rn00524','Butirosin and neomycin biosynthesis','path:rn00524','KEGGMAP','IMPD').
pathway('30350: rno00270','Cysteine and methionine metabolism','path:rno00270','KEGGMAP','IMPD').
pathway('33877: rno00620','Pyruvate metabolism','path:rno00620','KEGGMAP','IMPD').
pathway('34418: rno00750','Vitamin B6 metabolism','path:rno00750','KEGGMAP','IMPD').
pathway('13370: rn00981','Insect hormone biosynthesis','path:rn00981','KEGGMAP','IMPD').
pathway('28924: rno00100','Steroid biosynthesis','path:rno00100','KEGGMAP','IMPD').
pathway('4627: rn00400','Phenylalanine, tyrosine and tryptophan biosynthesis','path:rn00400','KEGGMAP','IMPD').
pathway('10715: rn00901','Indole alkaloid biosynthesis','path:rn00901','KEGGMAP','IMPD').
pathway('6789: rn00563','Glycosylphosphatidylinositol(GPI)-anchor biosynthesis','path:rn00563','KEGGMAP','IMPD').
pathway('11675: rn00910','Nitrogen metabolism','path:rn00910','KEGGMAP','IMPD').
pathway('2992: rn00300','Lysine biosynthesis','path:rn00300','KEGGMAP','IMPD').
pathway('5235: rn00473','D-Alanine metabolism','path:rn00473','KEGGMAP','IMPD').
pathway('27923: rno00020','Citrate cycle (TCA cycle)','path:rno00020','KEGGMAP','IMPD').
pathway('30830: rno00330','Arginine and proline metabolism','path:rno00330','KEGGMAP','IMPD').
pathway('34369: rno00740','Riboflavin metabolism','path:rno00740','KEGGMAP','IMPD').
pathway('2477: rn00260','Glycine, serine and threonine metabolism','path:rn00260','KEGGMAP','IMPD').
pathway('9044: rn00643','Styrene degradation','path:rn00643','KEGGMAP','IMPD').
pathway('31768: rno00450','Selenocompound metabolism','path:rno00450','KEGGMAP','IMPD').
pathway('32319: rno00512','Mucin type O-Glycan biosynthesis','path:rno00512','KEGGMAP','IMPD').
pathway('6835: rn00564','Glycerophospholipid metabolism','path:rn00564','KEGGMAP','IMPD').
pathway('33310: rno00590','Arachidonic acid metabolism','path:rno00590','KEGGMAP','IMPD').
pathway('32829: rno00534','Glycosaminoglycan biosynthesis - heparan sulfate','path:rno00534','KEGGMAP','IMPD').
pathway('5211: rn00472','D-Arginine and D-ornithine metabolism','path:rn00472','KEGGMAP','IMPD').
pathway('11231: rn00905','Brassinosteroid biosynthesis','path:rn00905','KEGGMAP','IMPD').
pathway('35469: rno00982','Drug metabolism - cytochrome P450','path:rno00982','KEGGMAP','IMPD').
pathway('7369: rn00601','Glycosphingolipid biosynthesis - lacto and neolacto series','path:rn00601','KEGGMAP','IMPD').
pathway('5645: rn00512','Mucin type O-Glycan biosynthesis','path:rn00512','KEGGMAP','IMPD').
pathway('1307: rn00120','Primary bile acid biosynthesis','path:rn00120','KEGGMAP','IMPD').
pathway('10635: rn00900','Terpenoid backbone biosynthesis','path:rn00900','KEGGMAP','IMPD').
pathway('9010: rn00642','Ethylbenzene degradation','path:rn00642','KEGGMAP','IMPD').
pathway('13900: rn01055','Biosynthesis of vancomycin group antibiotics','path:rn01055','KEGGMAP','IMPD').
pathway('29933: rno00232','Caffeine metabolism','path:rno00232','KEGGMAP','IMPD').
pathway('3470: rn00331','Clavulanic acid biosynthesis','path:rn00331','KEGGMAP','IMPD').
pathway('33807: rno00604','Glycosphingolipid biosynthesis - ganglio series','path:rno00604','KEGGMAP','IMPD').
pathway('5178: rn00471','D-Glutamine and D-glutamate metabolism','path:rn00471','KEGGMAP','IMPD').
pathway('6381: rn00531','Glycosaminoglycan degradation','path:rn00531','KEGGMAP','IMPD').
pathway('3071: rn00310','Lysine degradation','path:rn00310','KEGGMAP','IMPD').
pathway('35023: rno00900','Terpenoid backbone biosynthesis','path:rno00900','KEGGMAP','IMPD').
pathway('27988: rno00030','Pentose phosphate pathway','path:rno00030','KEGGMAP','IMPD').
pathway('13427: rn00982','Drug metabolism - cytochrome P450','path:rn00982','KEGGMAP','IMPD').
pathway('30742: rno00310','Lysine degradation','path:rno00310','KEGGMAP','IMPD').
pathway('3491: rn00340','Histidine metabolism','path:rn00340','KEGGMAP','IMPD').
pathway('28488: rno00061','Fatty acid biosynthesis','path:rno00061','KEGGMAP','IMPD').
pathway('8507: rn00627','Aminobenzoate degradation','path:rn00627','KEGGMAP','IMPD').
pathway('10064: rn00770','Pantothenate and CoA biosynthesis','path:rn00770','KEGGMAP','IMPD').
pathway('383: rn00051','Fructose and mannose metabolism','path:rn00051','KEGGMAP','IMPD').
pathway('7868: rn00622','Xylene degradation','path:rn00622','KEGGMAP','IMPD').
pathway('4169: rn00362','Benzoate degradation','path:rn00362','KEGGMAP','IMPD').
pathway('31292: rno00360','Phenylalanine metabolism','path:rno00360','KEGGMAP','IMPD').
pathway('34314: rno00730','Thiamine metabolism','path:rno00730','KEGGMAP','IMPD').
pathway('4720: rn00401','Novobiocin biosynthesis','path:rn00401','KEGGMAP','IMPD').
pathway('31817: rno00460','Cyanoamino acid metabolism','path:rno00460','KEGGMAP','IMPD').
pathway('5693: rn00513','Various types of N-glycan biosynthesis','path:rn00513','KEGGMAP','IMPD').
pathway('3998: rn00361','Chlorocyclohexane and chlorobenzene degradation','path:rn00361','KEGGMAP','IMPD').
pathway('9570: rn00710','Carbon fixation in photosynthetic organisms','path:rn00710','KEGGMAP','IMPD').
pathway('10165: rn00785','Lipoic acid metabolism','path:rn00785','KEGGMAP','IMPD').
pathway('7290: rn00600','Sphingolipid metabolism','path:rn00600','KEGGMAP','IMPD').
pathway('28772: rno00071','Fatty acid metabolism','path:rno00071','KEGGMAP','IMPD').
pathway('9202: rn00660','C5-Branched dibasic acid metabolism','path:rn00660','KEGGMAP','IMPD').
pathway('11521: rn00908','Zeatin biosynthesis','path:rn00908','KEGGMAP','IMPD').
pathway('31929: rno00480','Glutathione metabolism','path:rno00480','KEGGMAP','IMPD').
pathway('32918: rno00561','Glycerolipid metabolism','path:rno00561','KEGGMAP','IMPD').
pathway('2329: rn00250','Alanine, aspartate and glutamate metabolism','path:rn00250','KEGGMAP','IMPD').
pathway('30225: rno00260','Glycine, serine and threonine metabolism','path:rno00260','KEGGMAP','IMPD').
pathway('33469: rno00592','alpha-Linolenic acid metabolism','path:rno00592','KEGGMAP','IMPD').
pathway('2878: rn00281','Geraniol degradation','path:rn00281','KEGGMAP','IMPD').
pathway('31912: rno00472','D-Arginine and D-ornithine metabolism','path:rno00472','KEGGMAP','IMPD').
pathway('5369: rn00500','Starch and sucrose metabolism','path:rn00500','KEGGMAP','IMPD').
pathway('32397: rno00520','Amino sugar and nucleotide sugar metabolism','path:rno00520','KEGGMAP','IMPD').
pathway('10133: rn00780','Biotin metabolism','path:rn00780','KEGGMAP','IMPD').
pathway('9648: rn00720','Carbon fixation pathways in prokaryotes','path:rn00720','KEGGMAP','IMPD').
pathway('8701: rn00630','Glyoxylate and dicarboxylate metabolism','path:rn00630','KEGGMAP','IMPD').
pathway('13985: rn01057','Biosynthesis of type II polyketide products','path:rn01057','KEGGMAP','IMPD').
pathway('35350: rno00980','Metabolism of xenobiotics by cytochrome P450','path:rno00980','KEGGMAP','IMPD').
pathway('28072: rno00040','Pentose and glucuronate interconversions','path:rno00040','KEGGMAP','IMPD').
pathway('6695: rn00562','Inositol phosphate metabolism','path:rn00562','KEGGMAP','IMPD').
pathway('33430: rno00591','Linoleic acid metabolism','path:rno00591','KEGGMAP','IMPD').
pathway('7778: rn00621','Dioxin degradation','path:rn00621','KEGGMAP','IMPD').
pathway('31885: rno00471','D-Glutamine and D-glutamate metabolism','path:rno00471','KEGGMAP','IMPD').
pathway('34478: rno00760','Nicotinate and nicotinamide metabolism','path:rno00760','KEGGMAP','IMPD').
pathway('11043: rn00904','Diterpenoid biosynthesis','path:rn00904','KEGGMAP','IMPD').
pathway('2924: rn00290','Valine, leucine and isoleucine biosynthesis','path:rn00290','KEGGMAP','IMPD').
pathway('7222: rn00592','alpha-Linolenic acid metabolism','path:rn00592','KEGGMAP','IMPD').
pathway('28714: rno00062','Fatty acid elongation in mitochondria','path:rno00062','KEGGMAP','IMPD').
pathway('4321: rn00363','Bisphenol degradation','path:rn00363','KEGGMAP','IMPD').
pathway('6247: rn00523','Polyketide sugar unit biosynthesis','path:rn00523','KEGGMAP','IMPD').
pathway('1412: rn00130','Ubiquinone and other terpenoid-quinone biosynthesis','path:rn00130','KEGGMAP','IMPD').
pathway('4830: rn00410','beta-Alanine metabolism','path:rn00410','KEGGMAP','IMPD').
pathway('11607: rn00909','Sesquiterpenoid biosynthesis','path:rn00909','KEGGMAP','IMPD').
pathway('33534: rno00600','Sphingolipid metabolism','path:rno00600','KEGGMAP','IMPD').
pathway('32993: rno00562','Inositol phosphate metabolism','path:rno00562','KEGGMAP','IMPD').
pathway('5255: rn00480','Glutathione metabolism','path:rn00480','KEGGMAP','IMPD').
pathway('31414: rno00380','Tryptophan metabolism','path:rno00380','KEGGMAP','IMPD').
pathway('5815: rn00520','Amino sugar and nucleotide sugar metabolism','path:rn00520','KEGGMAP','IMPD').
pathway('7177: rn00591','Linoleic acid metabolism','path:rn00591','KEGGMAP','IMPD').
pathway('33976: rno00630','Glyoxylate and dicarboxylate metabolism','path:rno00630','KEGGMAP','IMPD').
pathway('10182: rn00790','Folate biosynthesis','path:rn00790','KEGGMAP','IMPD').
pathway('29239: rno00140','Steroid hormone biosynthesis','path:rno00140','KEGGMAP','IMPD').
pathway('9098: rn00650','Butanoate metabolism','path:rn00650','KEGGMAP','IMPD').
pathway('961: rn00062','Fatty acid elongation in mitochondria','path:rn00062','KEGGMAP','IMPD').
pathway('12983: rn00966','Glucosinolate biosynthesis','path:rn00966','KEGGMAP','IMPD').
pathway('2426: rn00253','Tetracycline biosynthesis','path:rn00253','KEGGMAP','IMPD').
reaction('9: rn:R00755','irreversible','path:rn00010','KEGGMAP','IMPD').
reaction('27: rn:R02738','irreversible','path:rn00010','KEGGMAP','IMPD').
reaction('8829: rn:R00934','irreversible','path:rn00630','KEGGMAP','IMPD').
reaction('8770: rn:R01388','reversible','path:rn00630','KEGGMAP','IMPD').
reaction('39: rn:R00947','irreversible','path:rn00010','KEGGMAP','IMPD').
reaction('40: rn:R00960','irreversible','path:rn00010','KEGGMAP','IMPD').
reaction('8740: rn:R01392','reversible','path:rn00630','KEGGMAP','IMPD').
reaction('8741: rn:R01388','reversible','path:rn00630','KEGGMAP','IMPD').
reaction('8742: rn:R01745 rn:R01747','reversible','path:rn00630','KEGGMAP','IMPD').
reaction('8743: rn:R00013','irreversible','path:rn00630','KEGGMAP','IMPD').
reaction('8739: rn:R01388 rn:R01392','reversible','path:rn00630','KEGGMAP','IMPD').
reaction('8744: rn:R00472','reversible','path:rn00630','KEGGMAP','IMPD').
reaction('4473: rn:R01816','irreversible','path:rn00380','KEGGMAP','IMPD').
reaction('85: rn:R01196','reversible','path:rn00010','KEGGMAP','IMPD').
reaction('84: rn:R01058','irreversible','path:rn00010','KEGGMAP','IMPD').
reaction('86: rn:R07159','irreversible','path:rn00010','KEGGMAP','IMPD').
reaction('4451: rn:R01974','irreversible','path:rn00380','KEGGMAP','IMPD').
reaction('83: rn:R07159','irreversible','path:rn00010','KEGGMAP','IMPD').
reaction('8767: rn:R03140','irreversible','path:rn00630','KEGGMAP','IMPD').
reaction('8710: rn:R00479','irreversible','path:rn00630','KEGGMAP','IMPD').
reaction('8708: rn:R00477','reversible','path:rn00630','KEGGMAP','IMPD').
reaction('8709: rn:R00470','reversible','path:rn00630','KEGGMAP','IMPD').
reaction('8707: rn:R01180','irreversible','path:rn00630','KEGGMAP','IMPD').
reaction('99: rn:R01197','irreversible','path:rn00020','KEGGMAP','IMPD').
reaction('8705: rn:R00474','irreversible','path:rn00630','KEGGMAP','IMPD').
reaction('8733: rn:R03146','irreversible','path:rn00630','KEGGMAP','IMPD').
reaction('8732: rn:R00519','reversible','path:rn00630','KEGGMAP','IMPD').
reaction('8936: rn:R01199','irreversible','path:rn00640','KEGGMAP','IMPD').
reaction('8940: rn:R01608','reversible','path:rn00640','KEGGMAP','IMPD').
reaction('8935: rn:R01199','irreversible','path:rn00640','KEGGMAP','IMPD').
reaction('155: rn:R01196','reversible','path:rn00020','KEGGMAP','IMPD').
reaction('8944: rn:R01611','irreversible','path:rn00640','KEGGMAP','IMPD').
reaction('4516: rn:R04172','irreversible','path:rn00380','KEGGMAP','IMPD').
reaction('8907: rn:R06987','reversible','path:rn00640','KEGGMAP','IMPD').
reaction('169: rn:R01066','reversible','path:rn00030','KEGGMAP','IMPD').
reaction('168: rn:R02749','reversible','path:rn00030','KEGGMAP','IMPD').
reaction('4503: rn:R01974','irreversible','path:rn00380','KEGGMAP','IMPD').
reaction('165: rn:R05605','reversible','path:rn00030','KEGGMAP','IMPD').
reaction('8923: rn:R00920','reversible','path:rn00640','KEGGMAP','IMPD').
reaction('8920: rn:R00928','reversible','path:rn00640','KEGGMAP','IMPD').
reaction('189: rn:R01737','irreversible','path:rn00030','KEGGMAP','IMPD').
reaction('8914: rn:R03381','irreversible','path:rn00640','KEGGMAP','IMPD').
reaction('8915: rn:R02764','irreversible','path:rn00640','KEGGMAP','IMPD').
reaction('13208: rn:R08223','irreversible','path:rn00970','KEGGMAP','IMPD').
reaction('13211: rn:R08219','irreversible','path:rn00970','KEGGMAP','IMPD').
reaction('202: rn:R01522','irreversible','path:rn00030','KEGGMAP','IMPD').
reaction('193: rn:R00305','irreversible','path:rn00030','KEGGMAP','IMPD').
reaction('192: rn:R06620','irreversible','path:rn00030','KEGGMAP','IMPD').
reaction('195: rn:R01520 rn:R01521','reversible','path:rn00030','KEGGMAP','IMPD').
reaction('194: rn:R01522','irreversible','path:rn00030','KEGGMAP','IMPD').
reaction('212: rn:R05605','reversible','path:rn00030','KEGGMAP','IMPD').
reaction('208: rn:R08570','reversible','path:rn00030','KEGGMAP','IMPD').
reaction('210: rn:R08572','irreversible','path:rn00030','KEGGMAP','IMPD').
reaction('13236: rn:R07073','irreversible','path:rn00980','KEGGMAP','IMPD').
reaction('279: rn:R01896','reversible','path:rn00040','KEGGMAP','IMPD').
reaction('283: rn:R01903','reversible','path:rn00040','KEGGMAP','IMPD').
reaction('280: rn:R01432','reversible','path:rn00040','KEGGMAP','IMPD').
reaction('287: rn:R01905','reversible','path:rn00040','KEGGMAP','IMPD').
reaction('9063: rn:R05487','irreversible','path:rn00643','KEGGMAP','IMPD').
reaction('9066: rn:R05450','irreversible','path:rn00643','KEGGMAP','IMPD').
reaction('9048: rn:R02540','irreversible','path:rn00643','KEGGMAP','IMPD').
reaction('12906: rn:R00446','irreversible','path:rn00960','KEGGMAP','IMPD').
reaction('12917: rn:R02317','irreversible','path:rn00960','KEGGMAP','IMPD').
reaction('293: rn:R01481','reversible','path:rn00040','KEGGMAP','IMPD').
reaction('9007: rn:R01438','irreversible','path:rn00640','KEGGMAP','IMPD').
reaction('8965: rn:R00740','reversible','path:rn00640','KEGGMAP','IMPD').
reaction('12849: rn:R00462','reversible','path:rn00960','KEGGMAP','IMPD').
reaction('4266: rn:R00829','irreversible','path:rn00362','KEGGMAP','IMPD').
reaction('9209: rn:R00932','irreversible','path:rn00660','KEGGMAP','IMPD').
reaction('4261: rn:R00829','irreversible','path:rn00362','KEGGMAP','IMPD').
reaction('392: rn:R00877','reversible','path:rn00051','KEGGMAP','IMPD').
reaction('399: rn:R02730','irreversible','path:rn00051','KEGGMAP','IMPD').
reaction('390: rn:R00878','reversible','path:rn00051','KEGGMAP','IMPD').
reaction('425: rn:R02071','reversible','path:rn00051','KEGGMAP','IMPD').
reaction('428: rn:R01059','irreversible','path:rn00051','KEGGMAP','IMPD').
reaction('9123: rn:R00212','irreversible','path:rn00650','KEGGMAP','IMPD').
reaction('9122: rn:R01196','irreversible','path:rn00650','KEGGMAP','IMPD').
reaction('4290: rn:R00750','irreversible','path:rn00362','KEGGMAP','IMPD').
reaction('4310: rn:R00228','reversible','path:rn00362','KEGGMAP','IMPD').
reaction('550: rn:R02411','irreversible','path:rn00052','KEGGMAP','IMPD').
reaction('556: rn:R01192','irreversible','path:rn00052','KEGGMAP','IMPD').
reaction('4867: rn:R01166','irreversible','path:rn00410','KEGGMAP','IMPD').
reaction('4865: rn:R01164','irreversible','path:rn00410','KEGGMAP','IMPD').
reaction('8295: rn:R09158','irreversible','path:rn00625','KEGGMAP','IMPD').
reaction('524: rn:R03635','irreversible','path:rn00052','KEGGMAP','IMPD').
reaction('4926: rn:R05652','reversible','path:rn00430','KEGGMAP','IMPD').
reaction('520: rn:R01069','reversible','path:rn00052','KEGGMAP','IMPD').
reaction('4921: rn:R00230','reversible','path:rn00430','KEGGMAP','IMPD').
reaction('4923: rn:R05651','irreversible','path:rn00430','KEGGMAP','IMPD').
reaction('12614: rn:R02383','irreversible','path:rn00950','KEGGMAP','IMPD').
reaction('528: rn:R02410','irreversible','path:rn00052','KEGGMAP','IMPD').
reaction('4908: rn:R09077','irreversible','path:rn00410','KEGGMAP','IMPD').
reaction('4911: rn:R05320','irreversible','path:rn00430','KEGGMAP','IMPD').
reaction('4907: rn:R09076','irreversible','path:rn00410','KEGGMAP','IMPD').
reaction('4958: rn:R02434','irreversible','path:rn00430','KEGGMAP','IMPD').
reaction('4935: rn:R00901','irreversible','path:rn00430','KEGGMAP','IMPD').
reaction('12580: rn:R04305','irreversible','path:rn00950','KEGGMAP','IMPD').
reaction('4936: rn:R01681','irreversible','path:rn00430','KEGGMAP','IMPD').
reaction('39679: rn:R03657','irreversible','path:rno00290','KEGGMAP','IMPD').
reaction('39678: rn:R01090','reversible','path:rno00290','KEGGMAP','IMPD').
reaction('39677: rn:R02199','irreversible','path:rno00290','KEGGMAP','IMPD').
reaction('39676: rn:R00533','irreversible','path:rno00920','KEGGMAP','IMPD').
reaction('682: rn:R01483','reversible','path:rn00053','KEGGMAP','IMPD').
reaction('653: rn:R03183','reversible','path:rn00053','KEGGMAP','IMPD').
reaction('654: rn:R01481','reversible','path:rn00053','KEGGMAP','IMPD').
reaction('662: rn:R02754','reversible','path:rn00053','KEGGMAP','IMPD').
reaction('657: rn:R03277','reversible','path:rn00053','KEGGMAP','IMPD').
reaction('5072: rn:R07229','irreversible','path:rn00450','KEGGMAP','IMPD').
reaction('12727: rn:R02383','irreversible','path:rn00950','KEGGMAP','IMPD').
reaction('5079: rn:R08223','irreversible','path:rn00450','KEGGMAP','IMPD').
reaction('755: rn:R03370','irreversible','path:rn00061','KEGGMAP','IMPD').
reaction('8337: rn:R06973','irreversible','path:rn00625','KEGGMAP','IMPD').
reaction('12699: rn:R03341','irreversible','path:rn00950','KEGGMAP','IMPD').
reaction('8367: rn:R09151','irreversible','path:rn00625','KEGGMAP','IMPD').
reaction('5097: rn:R04931','irreversible','path:rn00450','KEGGMAP','IMPD').
reaction('5101: rn:R09371','reversible','path:rn00450','KEGGMAP','IMPD').
reaction('8368: rn:R09152','irreversible','path:rn00625','KEGGMAP','IMPD').
reaction('5094: rn:R08219','irreversible','path:rn00450','KEGGMAP','IMPD').
reaction('39814: rn:R00238','reversible','path:rno00900','KEGGMAP','IMPD').
reaction('39815: rn:R00782','reversible','path:rno00270','KEGGMAP','IMPD').
reaction('39812: rn:R02082','irreversible','path:rno00900','KEGGMAP','IMPD').
reaction('39813: rn:R01978','irreversible','path:rno00900','KEGGMAP','IMPD').
reaction('39810: rn:R02408','irreversible','path:rno00270','KEGGMAP','IMPD').
reaction('39811: rn:R00893','irreversible','path:rno00270','KEGGMAP','IMPD').
reaction('39808: rn:R02433','reversible','path:rno00270','KEGGMAP','IMPD').
reaction('39809: rn:R01123','reversible','path:rno00900','KEGGMAP','IMPD').
reaction('39822: rn:R01072','irreversible','path:rno00250','KEGGMAP','IMPD').
reaction('39823: rn:R01514','reversible','path:rno00260','KEGGMAP','IMPD').
reaction('39820: rn:R03104','irreversible','path:rno00270','KEGGMAP','IMPD').
reaction('39821: rn:R03220','irreversible','path:rno00860','KEGGMAP','IMPD').
reaction('39818: rn:R00896','reversible','path:rno00270','KEGGMAP','IMPD').
reaction('39819: rn:R03105','irreversible','path:rno00270','KEGGMAP','IMPD').
reaction('39816: rn:R02245','irreversible','path:rno00900','KEGGMAP','IMPD').
reaction('39817: rn:R02619','irreversible','path:rno00270','KEGGMAP','IMPD').
reaction('39831: rn:R06171','reversible','path:rno00260','KEGGMAP','IMPD').
reaction('4628: rn:R01826','irreversible','path:rn00400','KEGGMAP','IMPD').
reaction('39830: rn:R00565','irreversible','path:rno00260','KEGGMAP','IMPD').
reaction('39829: rn:R01290','irreversible','path:rno00260','KEGGMAP','IMPD').
reaction('39828: rn:R01001','reversible','path:rno00260','KEGGMAP','IMPD').
reaction('39827: rn:R01565','irreversible','path:rno00260','KEGGMAP','IMPD').
reaction('39826: rn:R00589','reversible','path:rno00260','KEGGMAP','IMPD').
reaction('39825: rn:R02565 rn:R02566','irreversible','path:rno00260','KEGGMAP','IMPD').
reaction('39824: rn:R01025','irreversible','path:rno00260','KEGGMAP','IMPD').
reaction('39839: rn:R00371','reversible','path:rno00260','KEGGMAP','IMPD').
reaction('39838: rn:R01465','reversible','path:rno00260','KEGGMAP','IMPD').
reaction('39837: rn:R00366','irreversible','path:rno00260','KEGGMAP','IMPD').
reaction('39836: rn:R01883','irreversible','path:rno00260','KEGGMAP','IMPD').
reaction('39835: rn:R01513','reversible','path:rno00260','KEGGMAP','IMPD').
reaction('39834: rn:R00585','reversible','path:rno00260','KEGGMAP','IMPD').
reaction('39833: rn:R00588','reversible','path:rno00260','KEGGMAP','IMPD').
reaction('39832: rn:R02821','irreversible','path:rno00260','KEGGMAP','IMPD').
reaction('39844: rn:R00582','irreversible','path:rno00260','KEGGMAP','IMPD').
reaction('39845: rn:R00945','reversible','path:rno00260','KEGGMAP','IMPD').
reaction('39846: rn:R00751','reversible','path:rno00260','KEGGMAP','IMPD').
reaction('39847: rn:R04979','irreversible','path:rno00860','KEGGMAP','IMPD').
reaction('39840: rn:R00220','reversible','path:rno00260','KEGGMAP','IMPD').
reaction('39841: rn:R04173','reversible','path:rno00260','KEGGMAP','IMPD').
reaction('39842: rn:R00610','irreversible','path:rno00260','KEGGMAP','IMPD').
reaction('39843: rn:R00611','irreversible','path:rno00260','KEGGMAP','IMPD').
reaction('39852: rn:R02529','irreversible','path:rno00260','KEGGMAP','IMPD').
reaction('39853: rn:R00830','irreversible','path:rno00260','KEGGMAP','IMPD').
reaction('39854: rn:R03425','irreversible','path:rno00260','KEGGMAP','IMPD').
reaction('4653: rn:R01073','reversible','path:rn00400','KEGGMAP','IMPD').
reaction('39855: rn:R00367','reversible','path:rno00260','KEGGMAP','IMPD').
reaction('39848: rn:R03815','irreversible','path:rno00260','KEGGMAP','IMPD').
reaction('39849: rn:R04125','irreversible','path:rno00260','KEGGMAP','IMPD').
reaction('39850: rn:R02389','irreversible','path:rno00860','KEGGMAP','IMPD').
reaction('39851: rn:R02529','irreversible','path:rno00260','KEGGMAP','IMPD').
reaction('39861: rn:R03165','irreversible','path:rno00860','KEGGMAP','IMPD').
reaction('39860: rn:R04972','irreversible','path:rno00860','KEGGMAP','IMPD').
reaction('39863: rn:R03222','irreversible','path:rno00860','KEGGMAP','IMPD').
reaction('39862: rn:R03197','irreversible','path:rno00860','KEGGMAP','IMPD').
reaction('39857: rn:R00830','irreversible','path:rno00860','KEGGMAP','IMPD').
reaction('39856: rn:R05578','irreversible','path:rno00860','KEGGMAP','IMPD').
reaction('39859: rn:R00084','irreversible','path:rno00860','KEGGMAP','IMPD').
reaction('39858: rn:R00036','irreversible','path:rno00860','KEGGMAP','IMPD').
reaction('39869: rn:R08174','irreversible','path:rno01040','KEGGMAP','IMPD').
reaction('39868: rn:R02391 rn:R02393','irreversible','path:rno00860','KEGGMAP','IMPD').
reaction('39871: rn:R08179','irreversible','path:rno01040','KEGGMAP','IMPD').
reaction('39870: rn:R01274','irreversible','path:rno01040','KEGGMAP','IMPD').
reaction('39865: rn:R00078','irreversible','path:rno00860','KEGGMAP','IMPD').
reaction('39864: rn:R00310','irreversible','path:rno00860','KEGGMAP','IMPD').
reaction('39867: rn:R02480','irreversible','path:rno00860','KEGGMAP','IMPD').
reaction('39866: rn:R07411','irreversible','path:rno00860','KEGGMAP','IMPD').
reaction('39874: rn:R08182','irreversible','path:rno01040','KEGGMAP','IMPD').
reaction('39875: rn:R08183','irreversible','path:rno01040','KEGGMAP','IMPD').
reaction('39872: rn:R08180','irreversible','path:rno01040','KEGGMAP','IMPD').
reaction('39873: rn:R08181','irreversible','path:rno01040','KEGGMAP','IMPD').
reaction('39878: rn:R08175','irreversible','path:rno01040','KEGGMAP','IMPD').
reaction('39879: rn:R08178','irreversible','path:rno01040','KEGGMAP','IMPD').
reaction('39876: rn:R08177','irreversible','path:rno01040','KEGGMAP','IMPD').
reaction('39877: rn:R08176','irreversible','path:rno01040','KEGGMAP','IMPD').
reaction('39882: rn:R00256','reversible','path:rno00250','KEGGMAP','IMPD').
reaction('39883: rn:R00253','irreversible','path:rno00250','KEGGMAP','IMPD').
reaction('39880: rn:R00261','irreversible','path:rno00250','KEGGMAP','IMPD').
reaction('39881: rn:R01648','reversible','path:rno00250','KEGGMAP','IMPD').
reaction('39886: rn:R00768','irreversible','path:rno00250','KEGGMAP','IMPD').
reaction('39887: rn:R00707 rn:R00708','reversible','path:rno00250','KEGGMAP','IMPD').
reaction('39884: rn:R00149','irreversible','path:rno00250','KEGGMAP','IMPD').
reaction('39885: rn:R00575','irreversible','path:rno00250','KEGGMAP','IMPD').
reaction('39891: rn:R01954','irreversible','path:rno00250','KEGGMAP','IMPD').
reaction('39890: rn:R00243 rn:R00248','reversible','path:rno00250','KEGGMAP','IMPD').
reaction('39889: rn:R00713','reversible','path:rno00250','KEGGMAP','IMPD').
reaction('39888: rn:R00269','irreversible','path:rno00250','KEGGMAP','IMPD').
reaction('39895: rn:R00369','irreversible','path:rno00250','KEGGMAP','IMPD').
reaction('39894: rn:R01086','irreversible','path:rno00250','KEGGMAP','IMPD').
reaction('39893: rn:R01083','irreversible','path:rno00250','KEGGMAP','IMPD').
reaction('39892: rn:R01135','irreversible','path:rno00250','KEGGMAP','IMPD').
reaction('39899: rn:R00348','irreversible','path:rno00250','KEGGMAP','IMPD').
reaction('39898: rn:R00488','irreversible','path:rno00250','KEGGMAP','IMPD').
reaction('39897: rn:R01397','irreversible','path:rno00250','KEGGMAP','IMPD').
reaction('39896: rn:R00258','reversible','path:rno00250','KEGGMAP','IMPD').
reaction('39903: rn:R00359','irreversible','path:rno00250','KEGGMAP','IMPD').
reaction('39902: rn:R00355','reversible','path:rno00250','KEGGMAP','IMPD').
reaction('39901: rn:R00357','irreversible','path:rno00250','KEGGMAP','IMPD').
reaction('39900: rn:R00578','reversible','path:rno00250','KEGGMAP','IMPD').
reaction('39904: rn:R01878','irreversible','path:rno00240','KEGGMAP','IMPD').
reaction('39905: rn:R00513 rn:R00516 rn:R00517 rn:R00962 rn:R01548 rn:R02091 rn:R02096 rn:R02371 rn:R02372','irreversible','path:rno00240','KEGGMAP','IMPD').
reaction('39906: rn:R00511','irreversible','path:rno00240','KEGGMAP','IMPD').
reaction('39907: rn:R00514','irreversible','path:rno00240','KEGGMAP','IMPD').
reaction('39908: rn:R00512','reversible','path:rno00240','KEGGMAP','IMPD').
reaction('39909: rn:R00569','irreversible','path:rno00240','KEGGMAP','IMPD').
reaction('39910: rn:R00570','reversible','path:rno00240','KEGGMAP','IMPD').
reaction('39911: rn:R00442','reversible','path:rno00240','KEGGMAP','IMPD').
reaction('39912: rn:R00440','reversible','path:rno00240','KEGGMAP','IMPD').
reaction('39913: rn:R02269','reversible','path:rno00240','KEGGMAP','IMPD').
reaction('39914: rn:R00905','irreversible','path:rno00240','KEGGMAP','IMPD').
reaction('39915: rn:R00978','reversible','path:rno00240','KEGGMAP','IMPD').
reaction('39916: rn:R00963','irreversible','path:rno00240','KEGGMAP','IMPD').
reaction('39917: rn:R01876','reversible','path:rno00240','KEGGMAP','IMPD').
reaction('39918: rn:R00964 rn:R00967 rn:R00968 rn:R00970 rn:R01549 rn:R01880 rn:R02097 rn:R02327 rn:R02332','irreversible','path:rno00240','KEGGMAP','IMPD').
reaction('39919: rn:R00966','reversible','path:rno00240','KEGGMAP','IMPD').
reaction('39921: rn:R00155','irreversible','path:rno00240','KEGGMAP','IMPD').
reaction('39920: rn:R00155','irreversible','path:rno00240','KEGGMAP','IMPD').
reaction('39923: rn:R00571 rn:R00573','irreversible','path:rno00240','KEGGMAP','IMPD').
reaction('39922: rn:R00159','irreversible','path:rno00240','KEGGMAP','IMPD').
reaction('39925: rn:R00157','irreversible','path:rno00240','KEGGMAP','IMPD').
reaction('39924: rn:R00158','reversible','path:rno00240','KEGGMAP','IMPD').
reaction('39927: rn:R00443','reversible','path:rno00240','KEGGMAP','IMPD').
reaction('39926: rn:R00156','reversible','path:rno00240','KEGGMAP','IMPD').
reaction('39929: rn:R01870','reversible','path:rno00240','KEGGMAP','IMPD').
reaction('39928: rn:R00438','reversible','path:rno00240','KEGGMAP','IMPD').
reaction('39931: rn:R01397','irreversible','path:rno00240','KEGGMAP','IMPD').
reaction('39930: rn:R01993','reversible','path:rno00240','KEGGMAP','IMPD').
reaction('39933: rn:R08264','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('39932: rn:R08307','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('39935: rn:R08310','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('39934: rn:R08306','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('39695: rn:R03038','irreversible','path:rno00970','KEGGMAP','IMPD').
reaction('39694: rn:R03662','irreversible','path:rno00970','KEGGMAP','IMPD').
reaction('39693: rn:R03659','irreversible','path:rno00970','KEGGMAP','IMPD').
reaction('39692: rn:R03654','irreversible','path:rno00970','KEGGMAP','IMPD').
reaction('39691: rn:R05577','irreversible','path:rno00970','KEGGMAP','IMPD').
reaction('39690: rn:R03652','irreversible','path:rno00970','KEGGMAP','IMPD').
reaction('39689: rn:R03650','irreversible','path:rno00970','KEGGMAP','IMPD').
reaction('39688: rn:R03660','irreversible','path:rno00970','KEGGMAP','IMPD').
reaction('39687: rn:R03646','irreversible','path:rno00970','KEGGMAP','IMPD').
reaction('39686: rn:R03648','irreversible','path:rno00970','KEGGMAP','IMPD').
reaction('39685: rn:R03655','irreversible','path:rno00970','KEGGMAP','IMPD').
reaction('39684: rn:R03656','irreversible','path:rno00970','KEGGMAP','IMPD').
reaction('39683: rn:R02661','irreversible','path:rno00280','KEGGMAP','IMPD').
reaction('39682: rn:R01214','irreversible','path:rno00290','KEGGMAP','IMPD').
reaction('39681: rn:R03665','irreversible','path:rno00290','KEGGMAP','IMPD').
reaction('39680: rn:R00529','irreversible','path:rno00920','KEGGMAP','IMPD').
reaction('39710: rn:R01939','reversible','path:rno00300','KEGGMAP','IMPD').
reaction('39711: rn:R04390','irreversible','path:rno00300','KEGGMAP','IMPD').
reaction('39708: rn:R08224','irreversible','path:rno00970','KEGGMAP','IMPD').
reaction('39709: rn:R08218','irreversible','path:rno00970','KEGGMAP','IMPD').
reaction('39706: rn:R00014','irreversible','path:rno00290','KEGGMAP','IMPD').
reaction('39707: rn:R04863','irreversible','path:rno00300','KEGGMAP','IMPD').
reaction('39704: rn:R03661','irreversible','path:rno00970','KEGGMAP','IMPD').
reaction('39705: rn:R05578','irreversible','path:rno00970','KEGGMAP','IMPD').
reaction('39702: rn:R03940','irreversible','path:rno00970','KEGGMAP','IMPD').
reaction('39703: rn:R02918','irreversible','path:rno00970','KEGGMAP','IMPD').
reaction('39700: rn:R03656','irreversible','path:rno00290','KEGGMAP','IMPD').
reaction('39701: rn:R03664','irreversible','path:rno00970','KEGGMAP','IMPD').
reaction('39698: rn:R03658','irreversible','path:rno00970','KEGGMAP','IMPD').
reaction('39699: rn:R03663','irreversible','path:rno00970','KEGGMAP','IMPD').
reaction('39696: rn:R03665','irreversible','path:rno00970','KEGGMAP','IMPD').
reaction('39697: rn:R03657','irreversible','path:rno00970','KEGGMAP','IMPD').
reaction('39725: rn:R07603','irreversible','path:rno00280','KEGGMAP','IMPD').
reaction('39724: rn:R04095','irreversible','path:rno00280','KEGGMAP','IMPD').
reaction('39727: rn:R04137','reversible','path:rno00280','KEGGMAP','IMPD').
reaction('39726: rn:R04138','irreversible','path:rno00280','KEGGMAP','IMPD').
reaction('39721: rn:R02003','irreversible','path:rno00900','KEGGMAP','IMPD').
reaction('39720: rn:R03245','irreversible','path:rno00900','KEGGMAP','IMPD').
reaction('39723: rn:R05556','irreversible','path:rno00900','KEGGMAP','IMPD').
reaction('39722: rn:R09249','irreversible','path:rno00900','KEGGMAP','IMPD').
reaction('39717: rn:R07618','irreversible','path:rno00280','KEGGMAP','IMPD').
reaction('39716: rn:R07604','irreversible','path:rno00280','KEGGMAP','IMPD').
reaction('39719: rn:R01121','irreversible','path:rno00900','KEGGMAP','IMPD').
reaction('39718: rn:R01658','irreversible','path:rno00900','KEGGMAP','IMPD').
reaction('39713: rn:R00716','reversible','path:rno00300','KEGGMAP','IMPD').
reaction('39712: rn:R03098','irreversible','path:rno00300','KEGGMAP','IMPD').
reaction('39715: rn:R02061','irreversible','path:rno00900','KEGGMAP','IMPD').
reaction('39714: rn:R02869','irreversible','path:rno00270','KEGGMAP','IMPD').
reaction('39740: rn:R00243 rn:R00248','reversible','path:rno00910','KEGGMAP','IMPD').
reaction('39741: rn:R00256','irreversible','path:rno00910','KEGGMAP','IMPD').
reaction('39742: rn:R07600','irreversible','path:rno00280','KEGGMAP','IMPD').
reaction('39743: rn:R07618','irreversible','path:rno00280','KEGGMAP','IMPD').
reaction('39736: rn:R00410','reversible','path:rno00280','KEGGMAP','IMPD').
reaction('39737: rn:R00578','irreversible','path:rno00910','KEGGMAP','IMPD').
reaction('39738: rn:R07602','irreversible','path:rno00280','KEGGMAP','IMPD').
reaction('39739: rn:R07618','irreversible','path:rno00280','KEGGMAP','IMPD').
reaction('39732: rn:R00149','irreversible','path:rno00910','KEGGMAP','IMPD').
reaction('39733: rn:R01360','irreversible','path:rno00280','KEGGMAP','IMPD').
reaction('39734: rn:R02085','reversible','path:rno00280','KEGGMAP','IMPD').
reaction('39735: rn:R01978','irreversible','path:rno00280','KEGGMAP','IMPD').
reaction('39728: rn:R00927','irreversible','path:rno00280','KEGGMAP','IMPD').
reaction('39729: rn:R05066','reversible','path:rno00280','KEGGMAP','IMPD').
reaction('39730: rn:R01214','irreversible','path:rno00280','KEGGMAP','IMPD').
reaction('39731: rn:R00238','reversible','path:rno00280','KEGGMAP','IMPD').
reaction('39755: rn:R04203','reversible','path:rno00280','KEGGMAP','IMPD').
reaction('39754: rn:R03172','irreversible','path:rno00280','KEGGMAP','IMPD').
reaction('39753: rn:R02661','reversible','path:rno00280','KEGGMAP','IMPD').
reaction('39752: rn:R04224','irreversible','path:rno00280','KEGGMAP','IMPD').
reaction('39759: rn:R03871','irreversible','path:rno00280','KEGGMAP','IMPD').
reaction('39758: rn:R05066','reversible','path:rno00280','KEGGMAP','IMPD').
reaction('39757: rn:R05064','irreversible','path:rno00280','KEGGMAP','IMPD').
reaction('39756: rn:R04188','reversible','path:rno00280','KEGGMAP','IMPD').
reaction('39747: rn:R02662','irreversible','path:rno00280','KEGGMAP','IMPD').
reaction('39746: rn:R03172','reversible','path:rno00280','KEGGMAP','IMPD').
reaction('39745: rn:R04095','reversible','path:rno00280','KEGGMAP','IMPD').
reaction('39744: rn:R01168','reversible','path:rno00910','KEGGMAP','IMPD').
reaction('39751: rn:R04203','reversible','path:rno00280','KEGGMAP','IMPD').
reaction('39750: rn:R01090','irreversible','path:rno00280','KEGGMAP','IMPD').
reaction('39749: rn:R04097','irreversible','path:rno00280','KEGGMAP','IMPD').
reaction('39748: rn:R07601','irreversible','path:rno00280','KEGGMAP','IMPD').
reaction('39770: rn:R03174','irreversible','path:rno00280','KEGGMAP','IMPD').
reaction('39771: rn:R00132','reversible','path:rno00910','KEGGMAP','IMPD').
reaction('39768: rn:R04204','irreversible','path:rno00280','KEGGMAP','IMPD').
reaction('39769: rn:R07599','irreversible','path:rno00280','KEGGMAP','IMPD').
reaction('39774: rn:R01001','irreversible','path:rno00910','KEGGMAP','IMPD').
reaction('39775: rn:R01242','irreversible','path:rno00920','KEGGMAP','IMPD').
reaction('39772: rn:R01221','irreversible','path:rno00910','KEGGMAP','IMPD').
reaction('39773: rn:R00253','irreversible','path:rno00910','KEGGMAP','IMPD').
reaction('39762: rn:R03869','irreversible','path:rno00280','KEGGMAP','IMPD').
reaction('39763: rn:R02197','reversible','path:rno00280','KEGGMAP','IMPD').
reaction('39760: rn:R01859','irreversible','path:rno00280','KEGGMAP','IMPD').
reaction('39761: rn:R00935','irreversible','path:rno00280','KEGGMAP','IMPD').
reaction('39766: rn:R00833','irreversible','path:rno00280','KEGGMAP','IMPD').
reaction('39767: rn:R02661','irreversible','path:rno00280','KEGGMAP','IMPD').
reaction('39764: rn:R02199','irreversible','path:rno00280','KEGGMAP','IMPD').
reaction('39765: rn:R02765','irreversible','path:rno00280','KEGGMAP','IMPD').
reaction('39785: rn:R00588','reversible','path:rno00260','KEGGMAP','IMPD').
reaction('39784: rn:R07268','irreversible','path:rno00860','KEGGMAP','IMPD').
reaction('4840: rn:R01608','reversible','path:rn00410','KEGGMAP','IMPD').
reaction('39787: rn:R00372','reversible','path:rno00260','KEGGMAP','IMPD').
reaction('39786: rn:R00891','irreversible','path:rno00260','KEGGMAP','IMPD').
reaction('39789: rn:R07396','irreversible','path:rno00270','KEGGMAP','IMPD').
reaction('39788: rn:R07412','irreversible','path:rno00860','KEGGMAP','IMPD').
reaction('39791: rn:R07363','irreversible','path:rno00270','KEGGMAP','IMPD').
reaction('4845: rn:R01611','reversible','path:rn00410','KEGGMAP','IMPD').
reaction('39790: rn:R07364','irreversible','path:rno00270','KEGGMAP','IMPD').
reaction('39777: rn:R02180','irreversible','path:rno00920','KEGGMAP','IMPD').
reaction('39776: rn:R00509','irreversible','path:rno00920','KEGGMAP','IMPD').
reaction('39779: rn:R02350','irreversible','path:rno00920','KEGGMAP','IMPD').
reaction('39778: rn:R00629','irreversible','path:rno00920','KEGGMAP','IMPD').
reaction('39781: rn:R02661','irreversible','path:rno00280','KEGGMAP','IMPD').
reaction('39780: rn:R03172','irreversible','path:rno00280','KEGGMAP','IMPD').
reaction('39783: rn:R05220','irreversible','path:rno00860','KEGGMAP','IMPD').
reaction('39782: rn:R00508','irreversible','path:rno00920','KEGGMAP','IMPD').
reaction('39800: rn:R03683','irreversible','path:rno00860','KEGGMAP','IMPD').
reaction('39801: rn:R00177','irreversible','path:rno00270','KEGGMAP','IMPD').
reaction('4857: rn:R01914','irreversible','path:rn00410','KEGGMAP','IMPD').
reaction('39802: rn:R02821','irreversible','path:rno00270','KEGGMAP','IMPD').
reaction('39803: rn:R04858','irreversible','path:rno00270','KEGGMAP','IMPD').
reaction('39804: rn:R00192','irreversible','path:rno00270','KEGGMAP','IMPD').
reaction('39805: rn:R00648','irreversible','path:rno00270','KEGGMAP','IMPD').
reaction('39806: rn:R07395','irreversible','path:rno00270','KEGGMAP','IMPD').
reaction('39807: rn:R00590','irreversible','path:rno00270','KEGGMAP','IMPD').
reaction('39792: rn:R07392','irreversible','path:rno00270','KEGGMAP','IMPD').
reaction('39793: rn:R04420','irreversible','path:rno00270','KEGGMAP','IMPD').
reaction('4849: rn:R02473','irreversible','path:rn00410','KEGGMAP','IMPD').
reaction('39794: rn:R01402','irreversible','path:rno00270','KEGGMAP','IMPD').
reaction('39795: rn:R01920','irreversible','path:rno00270','KEGGMAP','IMPD').
reaction('39796: rn:R00178','irreversible','path:rno00270','KEGGMAP','IMPD').
reaction('39797: rn:R01001','reversible','path:rno00270','KEGGMAP','IMPD').
reaction('39798: rn:R00946','irreversible','path:rno00270','KEGGMAP','IMPD').
reaction('39799: rn:R01290','irreversible','path:rno00270','KEGGMAP','IMPD').
reaction('40191: rn:R02893','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40190: rn:R02836 rn:R02834','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40189: rn:R01836','reversible','path:rno00140','KEGGMAP','IMPD').
reaction('40188: rn:R04852','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40187: rn:R02019','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40186: rn:R02107','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40185: rn:R01049','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40184: rn:R01072','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40183: rn:R04144','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40182: rn:R04325','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40181: rn:R04208','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40180: rn:R00507','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40179: rn:R01234','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40178: rn:R00509','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40177: rn:R00529','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40176: rn:R07116','irreversible','path:rno00980','KEGGMAP','IMPD').
reaction('40174: rn:R02720','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40175: rn:R00720','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40172: rn:R02103','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40173: rn:R00426','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40170: rn:R04463','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40171: rn:R01768','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40168: rn:R07070','irreversible','path:rno00980','KEGGMAP','IMPD').
reaction('40169: rn:R00439','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('40166: rn:R07092','irreversible','path:rno00980','KEGGMAP','IMPD').
reaction('40167: rn:R00335','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40164: rn:R07105','irreversible','path:rno00980','KEGGMAP','IMPD').
reaction('40165: rn:R00330','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('40162: rn:R07100','irreversible','path:rno00980','KEGGMAP','IMPD').
reaction('40163: rn:R02090','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('40160: rn:R07106','reversible','path:rno00980','KEGGMAP','IMPD').
reaction('40161: rn:R06601','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40157: rn:R07113','irreversible','path:rno00980','KEGGMAP','IMPD').
reaction('40156: rn:R07112','irreversible','path:rno00980','KEGGMAP','IMPD').
reaction('40159: rn:R07104','irreversible','path:rno00980','KEGGMAP','IMPD').
reaction('40158: rn:R03409','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('40153: rn:R07082','irreversible','path:rno00980','KEGGMAP','IMPD').
reaction('40152: rn:R00376','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('40155: rn:R00441','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('40154: rn:R00434','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('5462: rn:R01557','reversible','path:rn00500','KEGGMAP','IMPD').
reaction('40149: rn:R07083','irreversible','path:rno00980','KEGGMAP','IMPD').
reaction('40148: rn:R01968','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('40151: rn:R07091','irreversible','path:rno00980','KEGGMAP','IMPD').
reaction('40150: rn:R01857','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('40145: rn:R00187','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40144: rn:R03531','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40147: rn:R07084','irreversible','path:rno00980','KEGGMAP','IMPD').
reaction('40146: rn:R02147','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('5455: rn:R00803','reversible','path:rn00500','KEGGMAP','IMPD').
reaction('40140: rn:R00961','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40141: rn:R02557','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('40142: rn:R01547','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('40143: rn:R03530','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('40136: rn:R00430','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('40137: rn:R01858','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('5449: rn:R00306','irreversible','path:rn00500','KEGGMAP','IMPD').
reaction('40138: rn:R01229','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('40139: rn:R04378','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('40132: rn:R07093','irreversible','path:rno00980','KEGGMAP','IMPD').
reaction('9750: rn:R00740','irreversible','path:rn00720','KEGGMAP','IMPD').
reaction('40133: rn:R00184','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('9749: rn:R01196','reversible','path:rn00720','KEGGMAP','IMPD').
reaction('5445: rn:R02886','irreversible','path:rn00500','KEGGMAP','IMPD').
reaction('40134: rn:R01967','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('5444: rn:R00952','reversible','path:rn00500','KEGGMAP','IMPD').
reaction('40135: rn:R00434','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40128: rn:R01855','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40129: rn:R07002','irreversible','path:rno00980','KEGGMAP','IMPD').
reaction('40130: rn:R01054','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40131: rn:R01232','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40123: rn:R00122','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40122: rn:R01135','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40121: rn:R01083','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40120: rn:R00183','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40127: rn:R02805','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40126: rn:R02017','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40125: rn:R01137','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('40124: rn:R00127','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('40115: rn:R02088','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('40114: rn:R02748','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40113: rn:R02297','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('40112: rn:R04560','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('5428: rn:R01555','irreversible','path:rn00500','KEGGMAP','IMPD').
reaction('40119: rn:R00181','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('5429: rn:R02112','irreversible','path:rn00500','KEGGMAP','IMPD').
reaction('40118: rn:R00190','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('40117: rn:R00185','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('40116: rn:R02556','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('40106: rn:R00089','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40107: rn:R00191','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40104: rn:R00435','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('40105: rn:R07087','irreversible','path:rno00980','KEGGMAP','IMPD').
reaction('40110: rn:R04591','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('40111: rn:R04559','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('40108: rn:R00437','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('40109: rn:R04209','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('40098: rn:R07075','irreversible','path:rno00980','KEGGMAP','IMPD').
reaction('40099: rn:R00086','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40096: rn:R02142','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('40097: rn:R00124','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('40102: rn:R00375','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('40103: rn:R07107','irreversible','path:rno00980','KEGGMAP','IMPD').
reaction('40100: rn:R00086','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40101: rn:R07085','irreversible','path:rno00980','KEGGMAP','IMPD').
reaction('40089: rn:R02719','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40088: rn:R02422','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('5400: rn:R00960','irreversible','path:rn00500','KEGGMAP','IMPD').
reaction('40091: rn:R00332','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('40090: rn:R01229','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('40093: rn:R01227','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40092: rn:R07016','irreversible','path:rno00980','KEGGMAP','IMPD').
reaction('40095: rn:R01863','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('40094: rn:R07020','irreversible','path:rno00980','KEGGMAP','IMPD').
reaction('40081: rn:R01134','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('5395: rn:R02889','irreversible','path:rn00500','KEGGMAP','IMPD').
reaction('40080: rn:R00961','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('5392: rn:R00806','irreversible','path:rn00500','KEGGMAP','IMPD').
reaction('40083: rn:R01560','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('5393: rn:R03526','irreversible','path:rn00500','KEGGMAP','IMPD').
reaction('40082: rn:R00719','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('9798: rn:R02134','irreversible','path:rn00730','KEGGMAP','IMPD').
reaction('40085: rn:R02106','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('9799: rn:R02135','irreversible','path:rn00730','KEGGMAP','IMPD').
reaction('40084: rn:R01126','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40087: rn:R01676','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40086: rn:R01969','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('40072: rn:R01132','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('5386: rn:R02886','irreversible','path:rn00500','KEGGMAP','IMPD').
reaction('40073: rn:R00328','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40074: rn:R01769','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40075: rn:R01561','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('40076: rn:R01130','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40077: rn:R00328','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40078: rn:R01230 rn:R01231','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40079: rn:R00722','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('40064: rn:R07981','irreversible','path:rno00232','KEGGMAP','IMPD').
reaction('5378: rn:R03921','reversible','path:rn00500','KEGGMAP','IMPD').
reaction('40065: rn:R08339','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('40066: rn:R07940','irreversible','path:rno00232','KEGGMAP','IMPD').
reaction('40067: rn:R07945','irreversible','path:rno00232','KEGGMAP','IMPD').
reaction('40068: rn:R03697','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('40069: rn:R08261','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('40070: rn:R08262','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('40071: rn:R08281','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('40054: rn:R01127','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('40055: rn:R08341','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('40052: rn:R07027','irreversible','path:rno00980','KEGGMAP','IMPD').
reaction('40053: rn:R07015','irreversible','path:rno00980','KEGGMAP','IMPD').
reaction('40050: rn:R07069','irreversible','path:rno00980','KEGGMAP','IMPD').
reaction('40051: rn:R07094','irreversible','path:rno00980','KEGGMAP','IMPD').
reaction('40048: rn:R00185','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('40049: rn:R08282 rn:R08283','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('40062: rn:R07943','irreversible','path:rno00232','KEGGMAP','IMPD').
reaction('40063: rn:R07978','irreversible','path:rno00232','KEGGMAP','IMPD').
reaction('40060: rn:R08343','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('40061: rn:R07942','irreversible','path:rno00232','KEGGMAP','IMPD').
reaction('40058: rn:R08312','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('40059: rn:R01057','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('40056: rn:R01054','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40057: rn:R06604','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40039: rn:R08267','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('40038: rn:R08275','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('40037: rn:R08276','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('40036: rn:R08275','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('40035: rn:R08275','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('40034: rn:R08280','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('40033: rn:R08285','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('40032: rn:R08272','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('40047: rn:R00200','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('40046: rn:R01138','reversible','path:rno00230','KEGGMAP','IMPD').
reaction('40045: rn:R00086','irreversible','path:rno00230','KEGGMAP','IMPD').
reaction('40044: rn:R08266','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('40043: rn:R08271','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('40042: rn:R08274','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('40041: rn:R08268','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('40040: rn:R08269','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('40020: rn:R02016','irreversible','path:rno00240','KEGGMAP','IMPD').
reaction('40021: rn:R08231','irreversible','path:rno00983','KEGGMAP','IMPD').
reaction('40022: rn:R02024','irreversible','path:rno00240','KEGGMAP','IMPD').
reaction('40023: rn:R08228','irreversible','path:rno00983','KEGGMAP','IMPD').
reaction('40016: rn:R08229','irreversible','path:rno00983','KEGGMAP','IMPD').
reaction('40017: rn:R02016','irreversible','path:rno00240','KEGGMAP','IMPD').
reaction('40018: rn:R08233','irreversible','path:rno00983','KEGGMAP','IMPD').
reaction('40019: rn:R08232','irreversible','path:rno00983','KEGGMAP','IMPD').
reaction('40028: rn:R08293','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('40029: rn:R08293','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('40030: rn:R08294','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('40031: rn:R08270','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('40024: rn:R02016','irreversible','path:rno00240','KEGGMAP','IMPD').
reaction('40025: rn:R08277','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('40026: rn:R08285','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('40027: rn:R08294','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('40005: rn:R00377','reversible','path:rno00240','KEGGMAP','IMPD').
reaction('40004: rn:R08240','irreversible','path:rno00983','KEGGMAP','IMPD').
reaction('40007: rn:R01664','irreversible','path:rno00240','KEGGMAP','IMPD').
reaction('40006: rn:R08259','irreversible','path:rno00983','KEGGMAP','IMPD').
reaction('40001: rn:R02326','reversible','path:rno00240','KEGGMAP','IMPD').
reaction('40000: rn:R08222','irreversible','path:rno00983','KEGGMAP','IMPD').
reaction('9872: rn:R07456','irreversible','path:rn00750','KEGGMAP','IMPD').
reaction('40003: rn:R01665','irreversible','path:rno00240','KEGGMAP','IMPD').
reaction('9873: rn:R07456','irreversible','path:rn00750','KEGGMAP','IMPD').
reaction('40002: rn:R08225','irreversible','path:rno00983','KEGGMAP','IMPD').
reaction('40013: rn:R08227','irreversible','path:rno00983','KEGGMAP','IMPD').
reaction('40012: rn:R01663','irreversible','path:rno00240','KEGGMAP','IMPD').
reaction('40015: rn:R08230','irreversible','path:rno00983','KEGGMAP','IMPD').
reaction('40014: rn:R08226','irreversible','path:rno00983','KEGGMAP','IMPD').
reaction('40009: rn:R01666','irreversible','path:rno00240','KEGGMAP','IMPD').
reaction('40008: rn:R08220','irreversible','path:rno00983','KEGGMAP','IMPD').
reaction('40011: rn:R02100','irreversible','path:rno00240','KEGGMAP','IMPD').
reaction('40010: rn:R08221','irreversible','path:rno00983','KEGGMAP','IMPD').
reaction('39986: rn:R08243','irreversible','path:rno00983','KEGGMAP','IMPD').
reaction('39987: rn:R01567','irreversible','path:rno00240','KEGGMAP','IMPD').
reaction('9955: rn:R01355','irreversible','path:rn00760','KEGGMAP','IMPD').
reaction('39984: rn:R08250','irreversible','path:rno00983','KEGGMAP','IMPD').
reaction('39985: rn:R01569','irreversible','path:rno00240','KEGGMAP','IMPD').
reaction('39990: rn:R02098','reversible','path:rno00240','KEGGMAP','IMPD').
reaction('39991: rn:R02099','irreversible','path:rno00240','KEGGMAP','IMPD').
reaction('39988: rn:R08235','irreversible','path:rno00983','KEGGMAP','IMPD').
reaction('39989: rn:R02331','reversible','path:rno00240','KEGGMAP','IMPD').
reaction('39994: rn:R02484','irreversible','path:rno00240','KEGGMAP','IMPD').
reaction('39995: rn:R08246','irreversible','path:rno00983','KEGGMAP','IMPD').
reaction('39992: rn:R02485','irreversible','path:rno00240','KEGGMAP','IMPD').
reaction('39993: rn:R08239','irreversible','path:rno00983','KEGGMAP','IMPD').
reaction('39998: rn:R08236','irreversible','path:rno00983','KEGGMAP','IMPD').
reaction('39999: rn:R02101','irreversible','path:rno00240','KEGGMAP','IMPD').
reaction('39996: rn:R02484','irreversible','path:rno00240','KEGGMAP','IMPD').
reaction('39997: rn:R02016','irreversible','path:rno00240','KEGGMAP','IMPD').
reaction('39971: rn:R01570','irreversible','path:rno00240','KEGGMAP','IMPD').
reaction('39970: rn:R01415','reversible','path:rno00240','KEGGMAP','IMPD').
reaction('39969: rn:R03055','reversible','path:rno00240','KEGGMAP','IMPD').
reaction('39968: rn:R00662','irreversible','path:rno00240','KEGGMAP','IMPD').
reaction('39975: rn:R00378','reversible','path:rno00240','KEGGMAP','IMPD').
reaction('39974: rn:R08245','irreversible','path:rno00983','KEGGMAP','IMPD').
reaction('39973: rn:R04666','irreversible','path:rno00240','KEGGMAP','IMPD').
reaction('9975: rn:R04292','irreversible','path:rn00760','KEGGMAP','IMPD').
reaction('39972: rn:R01868','reversible','path:rno00240','KEGGMAP','IMPD').
reaction('39979: rn:R02095','irreversible','path:rno00240','KEGGMAP','IMPD').
reaction('39978: rn:R08238','irreversible','path:rno00983','KEGGMAP','IMPD').
reaction('39977: rn:R02093','reversible','path:rno00240','KEGGMAP','IMPD').
reaction('39976: rn:R08244','irreversible','path:rno00983','KEGGMAP','IMPD').
reaction('39983: rn:R02092','irreversible','path:rno00240','KEGGMAP','IMPD').
reaction('39982: rn:R08248','irreversible','path:rno00983','KEGGMAP','IMPD').
reaction('39981: rn:R02094','reversible','path:rno00240','KEGGMAP','IMPD').
reaction('39980: rn:R08237','irreversible','path:rno00983','KEGGMAP','IMPD').
reaction('9923: rn:R01147','reversible','path:rn00750','KEGGMAP','IMPD').
reaction('39952: rn:R08327','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('39953: rn:R08312','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('9921: rn:R01580','reversible','path:rn00750','KEGGMAP','IMPD').
reaction('39954: rn:R08313','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('39955: rn:R07977','irreversible','path:rno00232','KEGGMAP','IMPD').
reaction('39956: rn:R07939','irreversible','path:rno00232','KEGGMAP','IMPD').
reaction('39957: rn:R08318','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('39958: rn:R08313','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('39959: rn:R08285','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('39960: rn:R08263','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('39961: rn:R07979','irreversible','path:rno00232','KEGGMAP','IMPD').
reaction('39962: rn:R08255','irreversible','path:rno00983','KEGGMAP','IMPD').
reaction('39963: rn:R02100','irreversible','path:rno00240','KEGGMAP','IMPD').
reaction('39964: rn:R08260','irreversible','path:rno00983','KEGGMAP','IMPD').
reaction('39965: rn:R00969','irreversible','path:rno00240','KEGGMAP','IMPD').
reaction('39966: rn:R08258','irreversible','path:rno00983','KEGGMAP','IMPD').
reaction('1197: rn:R07496','irreversible','path:rn00100','KEGGMAP','IMPD').
reaction('39967: rn:R00965','irreversible','path:rno00240','KEGGMAP','IMPD').
reaction('39937: rn:R08303','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('39936: rn:R08304','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('39939: rn:R00575','irreversible','path:rno00240','KEGGMAP','IMPD').
reaction('39938: rn:R08303','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('39941: rn:R02018','irreversible','path:rno00240','KEGGMAP','IMPD').
reaction('39940: rn:R08304','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('39943: rn:R08349','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('39942: rn:R08348','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('39945: rn:R08347','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('39944: rn:R08346','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('39947: rn:R08343','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('39946: rn:R08345','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('39949: rn:R08343','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('39948: rn:R08344','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('39951: rn:R08342','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('39950: rn:R08340','irreversible','path:rno00982','KEGGMAP','IMPD').
reaction('40428: rn:R04355','irreversible','path:rno00061','KEGGMAP','IMPD').
reaction('40429: rn:R04739','reversible','path:rno00062','KEGGMAP','IMPD').
reaction('40430: rn:R03858','irreversible','path:rno00062','KEGGMAP','IMPD').
reaction('40431: rn:R03856','irreversible','path:rno00062','KEGGMAP','IMPD').
reaction('40424: rn:R01177','irreversible','path:rno00062','KEGGMAP','IMPD').
reaction('40425: rn:R01274','irreversible','path:rno00062','KEGGMAP','IMPD').
reaction('40426: rn:R04738','reversible','path:rno00062','KEGGMAP','IMPD').
reaction('5224: rn:R00567','reversible','path:rn00472','KEGGMAP','IMPD').
reaction('40427: rn:R01278','irreversible','path:rno00062','KEGGMAP','IMPD').
reaction('40420: rn:R04748','reversible','path:rno00062','KEGGMAP','IMPD').
reaction('5222: rn:R02458','irreversible','path:rn00472','KEGGMAP','IMPD').
reaction('40421: rn:R04748','reversible','path:rno00062','KEGGMAP','IMPD').
reaction('40422: rn:R04749','reversible','path:rno00062','KEGGMAP','IMPD').
reaction('40423: rn:R06985','irreversible','path:rno00062','KEGGMAP','IMPD').
reaction('5219: rn:R00672','reversible','path:rn00472','KEGGMAP','IMPD').
reaction('40416: rn:R04747','irreversible','path:rno00062','KEGGMAP','IMPD').
reaction('5218: rn:R00672','reversible','path:rn00472','KEGGMAP','IMPD').
reaction('40417: rn:R04745','reversible','path:rno00062','KEGGMAP','IMPD').
reaction('5217: rn:R00672','reversible','path:rn00472','KEGGMAP','IMPD').
reaction('40418: rn:R04745','reversible','path:rno00062','KEGGMAP','IMPD').
reaction('40419: rn:R04746','reversible','path:rno00062','KEGGMAP','IMPD').
reaction('40445: rn:R00888','irreversible','path:rno00051','KEGGMAP','IMPD').
reaction('40444: rn:R04744','reversible','path:rno00062','KEGGMAP','IMPD').
reaction('40447: rn:R00885','irreversible','path:rno00051','KEGGMAP','IMPD').
reaction('40446: rn:R05692','irreversible','path:rno00051','KEGGMAP','IMPD').
reaction('40441: rn:R04741','reversible','path:rno00062','KEGGMAP','IMPD').
reaction('1354: rn:R03977','irreversible','path:rn00120','KEGGMAP','IMPD').
reaction('40440: rn:R03776','irreversible','path:rno00062','KEGGMAP','IMPD').
reaction('40443: rn:R04753','irreversible','path:rno00062','KEGGMAP','IMPD').
reaction('40442: rn:R04742','irreversible','path:rno00062','KEGGMAP','IMPD').
reaction('40437: rn:R04743','reversible','path:rno00062','KEGGMAP','IMPD').
reaction('40436: rn:R04740','reversible','path:rno00062','KEGGMAP','IMPD').
reaction('40439: rn:R03778','irreversible','path:rno00062','KEGGMAP','IMPD').
reaction('40438: rn:R04743','reversible','path:rno00062','KEGGMAP','IMPD').
reaction('40433: rn:R04737','reversible','path:rno00062','KEGGMAP','IMPD').
reaction('40432: rn:R04170','reversible','path:rno00062','KEGGMAP','IMPD').
reaction('40435: rn:R03989','irreversible','path:rno00062','KEGGMAP','IMPD').
reaction('40434: rn:R03991','irreversible','path:rno00062','KEGGMAP','IMPD').
reaction('40398: rn:R04751','irreversible','path:rno00071','KEGGMAP','IMPD').
reaction('40399: rn:R01975','reversible','path:rno00071','KEGGMAP','IMPD').
reaction('40396: rn:R01279','irreversible','path:rno00071','KEGGMAP','IMPD').
reaction('40397: rn:R01175','irreversible','path:rno00071','KEGGMAP','IMPD').
reaction('40394: rn:R02487','irreversible','path:rno00071','KEGGMAP','IMPD').
reaction('40395: rn:R00623','reversible','path:rno00071','KEGGMAP','IMPD').
reaction('40392: rn:R03857','irreversible','path:rno00071','KEGGMAP','IMPD').
reaction('40393: rn:R04741','reversible','path:rno00071','KEGGMAP','IMPD').
reaction('40390: rn:R04740','reversible','path:rno00071','KEGGMAP','IMPD').
reaction('5189: rn:R00279','irreversible','path:rn00471','KEGGMAP','IMPD').
reaction('40391: rn:R03858','reversible','path:rno00071','KEGGMAP','IMPD').
reaction('40388: rn:R04739','reversible','path:rno00071','KEGGMAP','IMPD').
reaction('5191: rn:R00260','reversible','path:rn00471','KEGGMAP','IMPD').
reaction('40389: rn:R03990','irreversible','path:rno00071','KEGGMAP','IMPD').
reaction('40386: rn:R04739','reversible','path:rno00071','KEGGMAP','IMPD').
reaction('40387: rn:R00631','irreversible','path:rno00071','KEGGMAP','IMPD').
reaction('40384: rn:R01347 rn:R01348','irreversible','path:rno00071','KEGGMAP','IMPD').
reaction('40385: rn:R03990','irreversible','path:rno00071','KEGGMAP','IMPD').
reaction('40415: rn:R03777','irreversible','path:rno00071','KEGGMAP','IMPD').
reaction('40414: rn:R04746','reversible','path:rno00071','KEGGMAP','IMPD').
reaction('40413: rn:R04745','reversible','path:rno00071','KEGGMAP','IMPD').
reaction('40412: rn:R04747','reversible','path:rno00071','KEGGMAP','IMPD').
reaction('40411: rn:R04751','irreversible','path:rno00071','KEGGMAP','IMPD').
reaction('9993: rn:R01268','irreversible','path:rn00760','KEGGMAP','IMPD').
reaction('40410: rn:R04748','reversible','path:rno00071','KEGGMAP','IMPD').
reaction('5209: rn:R00279','irreversible','path:rn00471','KEGGMAP','IMPD').
reaction('40409: rn:R04751','irreversible','path:rno00071','KEGGMAP','IMPD').
reaction('5210: rn:R00579','reversible','path:rn00471','KEGGMAP','IMPD').
reaction('40408: rn:R04751','irreversible','path:rno00071','KEGGMAP','IMPD').
reaction('40407: rn:R04749','reversible','path:rno00071','KEGGMAP','IMPD').
reaction('40406: rn:R04748','reversible','path:rno00071','KEGGMAP','IMPD').
reaction('40405: rn:R01177','reversible','path:rno00071','KEGGMAP','IMPD').
reaction('9991: rn:R02322','irreversible','path:rn00760','KEGGMAP','IMPD').
reaction('40404: rn:R01177','reversible','path:rno00071','KEGGMAP','IMPD').
reaction('40403: rn:R04756','reversible','path:rno00071','KEGGMAP','IMPD').
reaction('40402: rn:R01175','irreversible','path:rno00071','KEGGMAP','IMPD').
reaction('40401: rn:R03026','reversible','path:rno00071','KEGGMAP','IMPD').
reaction('40400: rn:R01175','irreversible','path:rno00071','KEGGMAP','IMPD').
reaction('40360: rn:R01279','irreversible','path:rno00071','KEGGMAP','IMPD').
reaction('5163: rn:R06614','irreversible','path:rn00460','KEGGMAP','IMPD').
reaction('40361: rn:R01923','reversible','path:rno00071','KEGGMAP','IMPD').
reaction('40362: rn:R01175','irreversible','path:rno00071','KEGGMAP','IMPD').
reaction('40363: rn:R04751','irreversible','path:rno00071','KEGGMAP','IMPD').
reaction('40364: rn:R03777','irreversible','path:rno00071','KEGGMAP','IMPD').
reaction('10110: rn:R02473','irreversible','path:rn00770','KEGGMAP','IMPD').
reaction('40365: rn:R01279','irreversible','path:rno00071','KEGGMAP','IMPD').
reaction('40366: rn:R01280','reversible','path:rno00071','KEGGMAP','IMPD').
reaction('40367: rn:R04737','reversible','path:rno00071','KEGGMAP','IMPD').
reaction('10099: rn:R01623','irreversible','path:rn00770','KEGGMAP','IMPD').
reaction('40352: rn:R01451 rn:R01456','irreversible','path:rno00100','KEGGMAP','IMPD').
reaction('40353: rn:R04804','irreversible','path:rno00100','KEGGMAP','IMPD').
reaction('40354: rn:R01361','reversible','path:rno00072','KEGGMAP','IMPD').
reaction('40355: rn:R00238','reversible','path:rno00072','KEGGMAP','IMPD').
reaction('40356: rn:R00410','reversible','path:rno00072','KEGGMAP','IMPD').
reaction('10102: rn:R02972','irreversible','path:rn00770','KEGGMAP','IMPD').
reaction('40357: rn:R04754','irreversible','path:rno00071','KEGGMAP','IMPD').
reaction('40358: rn:R03857','irreversible','path:rno00071','KEGGMAP','IMPD').
reaction('40359: rn:R03990','irreversible','path:rno00071','KEGGMAP','IMPD').
reaction('40377: rn:R04743','reversible','path:rno00071','KEGGMAP','IMPD').
reaction('40376: rn:R04754','irreversible','path:rno00071','KEGGMAP','IMPD').
reaction('40379: rn:R04754','irreversible','path:rno00071','KEGGMAP','IMPD').
reaction('40378: rn:R04744','reversible','path:rno00071','KEGGMAP','IMPD').
reaction('40381: rn:R04743','reversible','path:rno00071','KEGGMAP','IMPD').
reaction('40380: rn:R03778','reversible','path:rno00071','KEGGMAP','IMPD').
reaction('1292: rn:R03311','irreversible','path:rn00100','KEGGMAP','IMPD').
reaction('40383: rn:R03777','irreversible','path:rno00071','KEGGMAP','IMPD').
reaction('40382: rn:R04745','reversible','path:rno00071','KEGGMAP','IMPD').
reaction('40369: rn:R03991','reversible','path:rno00071','KEGGMAP','IMPD').
reaction('40368: rn:R01279','irreversible','path:rno00071','KEGGMAP','IMPD').
reaction('40371: rn:R04738','reversible','path:rno00071','KEGGMAP','IMPD').
reaction('40370: rn:R04737','reversible','path:rno00071','KEGGMAP','IMPD').
reaction('1286: rn:R03724','irreversible','path:rn00100','KEGGMAP','IMPD').
reaction('40373: rn:R04741','reversible','path:rno00071','KEGGMAP','IMPD').
reaction('40372: rn:R03857','irreversible','path:rno00071','KEGGMAP','IMPD').
reaction('40375: rn:R04742','reversible','path:rno00071','KEGGMAP','IMPD').
reaction('1285: rn:R04667','irreversible','path:rn00100','KEGGMAP','IMPD').
reaction('40374: rn:R04170','reversible','path:rno00071','KEGGMAP','IMPD').
reaction('40330: rn:R03199','irreversible','path:rno00100','KEGGMAP','IMPD').
reaction('40331: rn:R02874','irreversible','path:rno00100','KEGGMAP','IMPD').
reaction('1339: rn:R02797','irreversible','path:rn00120','KEGGMAP','IMPD').
reaction('40328: rn:R07484','irreversible','path:rno00100','KEGGMAP','IMPD').
reaction('1338: rn:R05835','irreversible','path:rn00120','KEGGMAP','IMPD').
reaction('40329: rn:R05639','irreversible','path:rno00100','KEGGMAP','IMPD').
reaction('40334: rn:R07488','irreversible','path:rno00100','KEGGMAP','IMPD').
reaction('40335: rn:R05731','irreversible','path:rno00100','KEGGMAP','IMPD').
reaction('40332: rn:R02872','irreversible','path:rno00100','KEGGMAP','IMPD').
reaction('40333: rn:R00702','irreversible','path:rno00100','KEGGMAP','IMPD').
reaction('40322: rn:R03610','irreversible','path:rno00100','KEGGMAP','IMPD').
reaction('40323: rn:R07509','irreversible','path:rno00100','KEGGMAP','IMPD').
reaction('5120: rn:R00486','irreversible','path:rn00460','KEGGMAP','IMPD').
reaction('40320: rn:R01461','reversible','path:rno00100','KEGGMAP','IMPD').
reaction('40321: rn:R03611','irreversible','path:rno00100','KEGGMAP','IMPD').
reaction('40326: rn:R07494','irreversible','path:rno00100','KEGGMAP','IMPD').
reaction('5125: rn:R01267','irreversible','path:rn00460','KEGGMAP','IMPD').
reaction('40327: rn:R07495','irreversible','path:rno00100','KEGGMAP','IMPD').
reaction('40324: rn:R05640','irreversible','path:rno00100','KEGGMAP','IMPD').
reaction('40325: rn:R03689','reversible','path:rno00100','KEGGMAP','IMPD').
reaction('40347: rn:R07492','irreversible','path:rno00100','KEGGMAP','IMPD').
reaction('40346: rn:R07491','irreversible','path:rno00100','KEGGMAP','IMPD').
reaction('40345: rn:R07493','irreversible','path:rno00100','KEGGMAP','IMPD').
reaction('40344: rn:R05703','reversible','path:rno00100','KEGGMAP','IMPD').
reaction('40351: rn:R07486','irreversible','path:rno00100','KEGGMAP','IMPD').
reaction('40350: rn:R01360','irreversible','path:rno00072','KEGGMAP','IMPD').
reaction('40349: rn:R01978','irreversible','path:rno00072','KEGGMAP','IMPD').
reaction('1327: rn:R03975','irreversible','path:rn00120','KEGGMAP','IMPD').
reaction('40348: rn:R00238','reversible','path:rno00071','KEGGMAP','IMPD').
reaction('40339: rn:R03353','irreversible','path:rno00100','KEGGMAP','IMPD').
reaction('40338: rn:R07487','irreversible','path:rno00100','KEGGMAP','IMPD').
reaction('40337: rn:R07499','reversible','path:rno00100','KEGGMAP','IMPD').
reaction('1315: rn:R04824 rn:R04825','irreversible','path:rn00120','KEGGMAP','IMPD').
reaction('40336: rn:R07483','irreversible','path:rno00100','KEGGMAP','IMPD').
reaction('40343: rn:R07498','reversible','path:rno00100','KEGGMAP','IMPD').
reaction('40342: rn:R01457','reversible','path:rno00100','KEGGMAP','IMPD').
reaction('40341: rn:R07507','reversible','path:rno00100','KEGGMAP','IMPD').
reaction('1319: rn:R04818 rn:R04819','irreversible','path:rn00120','KEGGMAP','IMPD').
reaction('40340: rn:R03310 rn:R07215','irreversible','path:rno00100','KEGGMAP','IMPD').
reaction('40293: rn:R02794','reversible','path:rno00120','KEGGMAP','IMPD').
reaction('5350: rn:R03821','irreversible','path:rn00480','KEGGMAP','IMPD').
reaction('40292: rn:R08745','irreversible','path:rno00120','KEGGMAP','IMPD').
reaction('40295: rn:R01463','irreversible','path:rno00120','KEGGMAP','IMPD').
reaction('40294: rn:R03718','irreversible','path:rno00120','KEGGMAP','IMPD').
reaction('40289: rn:R03720','irreversible','path:rno00120','KEGGMAP','IMPD').
reaction('5346: rn:R08354','irreversible','path:rn00480','KEGGMAP','IMPD').
reaction('40288: rn:R08760','irreversible','path:rno00120','KEGGMAP','IMPD').
reaction('40291: rn:R07208','irreversible','path:rno00120','KEGGMAP','IMPD').
reaction('40290: rn:R04826','irreversible','path:rno00120','KEGGMAP','IMPD').
reaction('40301: rn:R04811','irreversible','path:rno00120','KEGGMAP','IMPD').
reaction('5358: rn:R08358','irreversible','path:rn00480','KEGGMAP','IMPD').
reaction('40300: rn:R03719','irreversible','path:rno00120','KEGGMAP','IMPD').
reaction('5359: rn:R08361','irreversible','path:rn00480','KEGGMAP','IMPD').
reaction('40303: rn:R08505','irreversible','path:rno00120','KEGGMAP','IMPD').
reaction('40302: rn:R08761','irreversible','path:rno00120','KEGGMAP','IMPD').
reaction('40297: rn:R07218','irreversible','path:rno00120','KEGGMAP','IMPD').
reaction('40296: rn:R04813','irreversible','path:rno00120','KEGGMAP','IMPD').
reaction('40299: rn:R08744','irreversible','path:rno00120','KEGGMAP','IMPD').
reaction('40298: rn:R08743','reversible','path:rno00120','KEGGMAP','IMPD').
reaction('40308: rn:R08724','irreversible','path:rno00120','KEGGMAP','IMPD').
reaction('40309: rn:R07372','irreversible','path:rno00120','KEGGMAP','IMPD').
reaction('40310: rn:R07372','irreversible','path:rno00120','KEGGMAP','IMPD').
reaction('40311: rn:R07207','irreversible','path:rno00120','KEGGMAP','IMPD').
reaction('40304: rn:R08759','irreversible','path:rno00120','KEGGMAP','IMPD').
reaction('40305: rn:R04263','irreversible','path:rno00120','KEGGMAP','IMPD').
reaction('40306: rn:R08723','irreversible','path:rno00120','KEGGMAP','IMPD').
reaction('40307: rn:R08728','irreversible','path:rno00120','KEGGMAP','IMPD').
reaction('40316: rn:R08735','irreversible','path:rno00120','KEGGMAP','IMPD').
reaction('40317: rn:R08734','irreversible','path:rno00120','KEGGMAP','IMPD').
reaction('40318: rn:R04807','irreversible','path:rno00120','KEGGMAP','IMPD').
reaction('40319: rn:R01462','irreversible','path:rno00100','KEGGMAP','IMPD').
reaction('40312: rn:R04817','irreversible','path:rno00120','KEGGMAP','IMPD').
reaction('40313: rn:R08725','irreversible','path:rno00120','KEGGMAP','IMPD').
reaction('40314: rn:R08726','irreversible','path:rno00120','KEGGMAP','IMPD').
reaction('40315: rn:R07209','irreversible','path:rno00120','KEGGMAP','IMPD').
reaction('40263: rn:R02499','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40262: rn:R02499','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40261: rn:R04678','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('5318: rn:R08358','irreversible','path:rn00480','KEGGMAP','IMPD').
reaction('40260: rn:R04678','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40259: rn:R03408','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40258: rn:R03404','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40257: rn:R03405','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40256: rn:R03713','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40271: rn:R03848','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40270: rn:R02213','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40269: rn:R02207 rn:R02209','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40268: rn:R03851','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40267: rn:R08958','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40266: rn:R02219','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40265: rn:R02218','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40264: rn:R03849','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('5323: rn:R08361','irreversible','path:rn00480','KEGGMAP','IMPD').
reaction('40278: rn:R08721','irreversible','path:rno00120','KEGGMAP','IMPD').
reaction('40279: rn:R08727','irreversible','path:rno00120','KEGGMAP','IMPD').
reaction('40276: rn:R04812','irreversible','path:rno00120','KEGGMAP','IMPD').
reaction('40277: rn:R04810','irreversible','path:rno00120','KEGGMAP','IMPD').
reaction('40274: rn:R02352 rn:R02353','reversible','path:rno00140','KEGGMAP','IMPD').
reaction('40275: rn:R02521','irreversible','path:rno00130','KEGGMAP','IMPD').
reaction('40272: rn:R04840','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40273: rn:R00734','irreversible','path:rno00130','KEGGMAP','IMPD').
reaction('40286: rn:R04806','irreversible','path:rno00120','KEGGMAP','IMPD').
reaction('40287: rn:R08758','irreversible','path:rno00120','KEGGMAP','IMPD').
reaction('40284: rn:R08733','irreversible','path:rno00120','KEGGMAP','IMPD').
reaction('5343: rn:R08352','irreversible','path:rn00480','KEGGMAP','IMPD').
reaction('40285: rn:R08738','irreversible','path:rno00120','KEGGMAP','IMPD').
reaction('40282: rn:R08740','irreversible','path:rno00120','KEGGMAP','IMPD').
reaction('40283: rn:R04809','irreversible','path:rno00120','KEGGMAP','IMPD').
reaction('40280: rn:R04823','irreversible','path:rno00120','KEGGMAP','IMPD').
reaction('5339: rn:R01917','irreversible','path:rn00480','KEGGMAP','IMPD').
reaction('40281: rn:R08739','irreversible','path:rno00120','KEGGMAP','IMPD').
reaction('5338: rn:R01918','irreversible','path:rn00480','KEGGMAP','IMPD').
reaction('40225: rn:R03325','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40224: rn:R08961','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40227: rn:R04855','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40226: rn:R02723','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40229: rn:R08977','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('5286: rn:R04950','irreversible','path:rn00480','KEGGMAP','IMPD').
reaction('40228: rn:R08941','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40231: rn:R03933','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40230: rn:R04676','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40233: rn:R04854','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40232: rn:R01454','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40235: rn:R03327','reversible','path:rno00140','KEGGMAP','IMPD').
reaction('5288: rn:R01917','irreversible','path:rn00480','KEGGMAP','IMPD').
reaction('40234: rn:R04849','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('5289: rn:R01918','irreversible','path:rn00480','KEGGMAP','IMPD').
reaction('40237: rn:R02216','reversible','path:rno00140','KEGGMAP','IMPD').
reaction('40236: rn:R03327','reversible','path:rno00140','KEGGMAP','IMPD').
reaction('40239: rn:R02840','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40238: rn:R04850','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40240: rn:R02840','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40241: rn:R04849','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40242: rn:R04163','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40243: rn:R04163','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40244: rn:R03784','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40245: rn:R04853','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40246: rn:R02216','reversible','path:rno00140','KEGGMAP','IMPD').
reaction('40247: rn:R08978','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40248: rn:R08942','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40249: rn:R08943','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40250: rn:R04675','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40251: rn:R01837','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40252: rn:R01837','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40253: rn:R03783','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40254: rn:R08949','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40255: rn:R03262','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40195: rn:R08945 rn:R08980','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40194: rn:R03326','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40193: rn:R02841','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40192: rn:R02843','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40199: rn:R04681 rn:R04682','reversible','path:rno00140','KEGGMAP','IMPD').
reaction('40198: rn:R02211','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40197: rn:R02838','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40196: rn:R03329','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40203: rn:R02356','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40202: rn:R02501','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40201: rn:R03089','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40200: rn:R04683','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40207: rn:R04352','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40206: rn:R01834','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40205: rn:R02478','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40204: rn:R01840','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40210: rn:R02725','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40211: rn:R01838','reversible','path:rno00140','KEGGMAP','IMPD').
reaction('40208: rn:R01835','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40209: rn:R04758','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40214: rn:R04764','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40215: rn:R03088 rn:R03090','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40212: rn:R03091','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40213: rn:R04354','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40218: rn:R02354 rn:R02355','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40219: rn:R04762','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40216: rn:R02350','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40217: rn:R02358','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40222: rn:R02498','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40223: rn:R02502','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40220: rn:R04353','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40221: rn:R02497','irreversible','path:rno00140','KEGGMAP','IMPD').
reaction('40665: rn:R01384','irreversible','path:rno00520','KEGGMAP','IMPD').
reaction('40664: rn:R04535','reversible','path:rno00061','KEGGMAP','IMPD').
reaction('40667: rn:R04959','reversible','path:rno00061','KEGGMAP','IMPD').
reaction('40666: rn:R04534','reversible','path:rno00061','KEGGMAP','IMPD').
reaction('40669: rn:R04537','reversible','path:rno00061','KEGGMAP','IMPD').
reaction('40668: rn:R04960','irreversible','path:rno00061','KEGGMAP','IMPD').
reaction('40671: rn:R02251','irreversible','path:rno00561','KEGGMAP','IMPD').
reaction('40670: rn:R02250','irreversible','path:rno00561','KEGGMAP','IMPD').
reaction('40657: rn:R02705','irreversible','path:rno00520','KEGGMAP','IMPD').
reaction('40656: rn:R04435','reversible','path:rno00520','KEGGMAP','IMPD').
reaction('40659: rn:R00286','irreversible','path:rno00520','KEGGMAP','IMPD').
reaction('40658: rn:R04962','reversible','path:rno00061','KEGGMAP','IMPD').
reaction('40661: rn:R00955','reversible','path:rno00520','KEGGMAP','IMPD').
reaction('40660: rn:R00291','reversible','path:rno00520','KEGGMAP','IMPD').
reaction('40663: rn:R02059','irreversible','path:rno00520','KEGGMAP','IMPD').
reaction('9221: rn:R00325','irreversible','path:rn00660','KEGGMAP','IMPD').
reaction('40662: rn:R04963','irreversible','path:rno00061','KEGGMAP','IMPD').
reaction('40648: rn:R04965','reversible','path:rno00061','KEGGMAP','IMPD').
reaction('40649: rn:R00416','irreversible','path:rno00520','KEGGMAP','IMPD').
reaction('40650: rn:R08193','reversible','path:rno00520','KEGGMAP','IMPD').
reaction('40651: rn:R04725','reversible','path:rno00061','KEGGMAP','IMPD').
reaction('40652: rn:R01201','reversible','path:rno00520','KEGGMAP','IMPD').
reaction('40653: rn:R01117','reversible','path:rno00520','KEGGMAP','IMPD').
reaction('40654: rn:R01805','irreversible','path:rno00520','KEGGMAP','IMPD').
reaction('40655: rn:R04964','reversible','path:rno00061','KEGGMAP','IMPD').
reaction('40640: rn:R05914','irreversible','path:rno00512','KEGGMAP','IMPD').
reaction('5955: rn:R02335','irreversible','path:rn00520','KEGGMAP','IMPD').
reaction('40641: rn:R05907','irreversible','path:rno00512','KEGGMAP','IMPD').
reaction('1649: rn:R03403','irreversible','path:rn00140','KEGGMAP','IMPD').
reaction('40642: rn:R05915','irreversible','path:rno00512','KEGGMAP','IMPD').
reaction('40643: rn:R05910','irreversible','path:rno00512','KEGGMAP','IMPD').
reaction('40644: rn:R05907','irreversible','path:rno00512','KEGGMAP','IMPD').
reaction('40645: rn:R05907','irreversible','path:rno00512','KEGGMAP','IMPD').
reaction('1653: rn:R03406 rn:R03407','irreversible','path:rn00140','KEGGMAP','IMPD').
reaction('40646: rn:R05907','irreversible','path:rno00512','KEGGMAP','IMPD').
reaction('40647: rn:R00414','irreversible','path:rno00520','KEGGMAP','IMPD').
reaction('40699: rn:R01350','irreversible','path:rno00561','KEGGMAP','IMPD').
reaction('40698: rn:R01041','reversible','path:rno00561','KEGGMAP','IMPD').
reaction('40697: rn:R01752','reversible','path:rno00561','KEGGMAP','IMPD').
reaction('40696: rn:R00959','reversible','path:rno00520','KEGGMAP','IMPD').
reaction('40703: rn:R01092','reversible','path:rno00520','KEGGMAP','IMPD').
reaction('40702: rn:R04568','reversible','path:rno00061','KEGGMAP','IMPD').
reaction('40701: rn:R01786','reversible','path:rno00520','KEGGMAP','IMPD').
reaction('40700: rn:R04967','reversible','path:rno00061','KEGGMAP','IMPD').
reaction('40691: rn:R01514','reversible','path:rno00561','KEGGMAP','IMPD').
reaction('40690: rn:R04543','reversible','path:rno00061','KEGGMAP','IMPD').
reaction('40689: rn:R02577','irreversible','path:rno00561','KEGGMAP','IMPD').
reaction('40688: rn:R04544','reversible','path:rno00061','KEGGMAP','IMPD').
reaction('40695: rn:R04968','irreversible','path:rno00061','KEGGMAP','IMPD').
reaction('40694: rn:R01036 rn:R01041','reversible','path:rno00561','KEGGMAP','IMPD').
reaction('40693: rn:R01818','reversible','path:rno00520','KEGGMAP','IMPD').
reaction('40692: rn:R01819','reversible','path:rno00520','KEGGMAP','IMPD').
reaction('40682: rn:R01706','irreversible','path:rno00061','KEGGMAP','IMPD').
reaction('40683: rn:R02757','irreversible','path:rno00561','KEGGMAP','IMPD').
reaction('9275: rn:R00934','irreversible','path:rn00660','KEGGMAP','IMPD').
reaction('40680: rn:R00851','irreversible','path:rno00561','KEGGMAP','IMPD').
reaction('40681: rn:R01351','irreversible','path:rno00561','KEGGMAP','IMPD').
reaction('40686: rn:R01804','irreversible','path:rno00520','KEGGMAP','IMPD').
reaction('40687: rn:R04970','reversible','path:rno00061','KEGGMAP','IMPD').
reaction('40684: rn:R01706','irreversible','path:rno00061','KEGGMAP','IMPD').
reaction('40685: rn:R00847','irreversible','path:rno00561','KEGGMAP','IMPD').
reaction('40674: rn:R04952','irreversible','path:rno00061','KEGGMAP','IMPD').
reaction('40675: rn:R02241','irreversible','path:rno00561','KEGGMAP','IMPD').
reaction('40672: rn:R04957','irreversible','path:rno00061','KEGGMAP','IMPD').
reaction('40673: rn:R04536','reversible','path:rno00061','KEGGMAP','IMPD').
reaction('40678: rn:R02239','irreversible','path:rno00561','KEGGMAP','IMPD').
reaction('1620: rn:R03263','irreversible','path:rn00140','KEGGMAP','IMPD').
reaction('40679: rn:R01011','irreversible','path:rno00561','KEGGMAP','IMPD').
reaction('40676: rn:R04957','irreversible','path:rno00061','KEGGMAP','IMPD').
reaction('40677: rn:R02687','irreversible','path:rno00561','KEGGMAP','IMPD').
reaction('40605: rn:R06263','irreversible','path:rno00510','KEGGMAP','IMPD').
reaction('40604: rn:R05981','irreversible','path:rno00510','KEGGMAP','IMPD').
reaction('40607: rn:R02957','reversible','path:rno00053','KEGGMAP','IMPD').
reaction('40606: rn:R06264','irreversible','path:rno00510','KEGGMAP','IMPD').
reaction('40601: rn:R06127','irreversible','path:rno00510','KEGGMAP','IMPD').
reaction('40600: rn:R09035','irreversible','path:rno00564','KEGGMAP','IMPD').
reaction('40603: rn:R06238','irreversible','path:rno00510','KEGGMAP','IMPD').
reaction('40602: rn:R06261','irreversible','path:rno00510','KEGGMAP','IMPD').
reaction('40597: rn:R05931','reversible','path:rno00532','KEGGMAP','IMPD').
reaction('40596: rn:R05929','reversible','path:rno00532','KEGGMAP','IMPD').
reaction('40599: rn:R09036','irreversible','path:rno00564','KEGGMAP','IMPD').
reaction('40598: rn:R05932','reversible','path:rno00532','KEGGMAP','IMPD').
reaction('40593: rn:R09034','irreversible','path:rno00564','KEGGMAP','IMPD').
reaction('40592: rn:R05926','irreversible','path:rno00532','KEGGMAP','IMPD').
reaction('40595: rn:R05928','irreversible','path:rno00532','KEGGMAP','IMPD').
reaction('40594: rn:R05925','irreversible','path:rno00532','KEGGMAP','IMPD').
reaction('40588: rn:R07809','irreversible','path:rno00531','KEGGMAP','IMPD').
reaction('40589: rn:R07808','irreversible','path:rno00531','KEGGMAP','IMPD').
reaction('40590: rn:R05927','irreversible','path:rno00532','KEGGMAP','IMPD').
reaction('40591: rn:R09037','irreversible','path:rno00564','KEGGMAP','IMPD').
reaction('40584: rn:R07812','irreversible','path:rno00531','KEGGMAP','IMPD').
reaction('40585: rn:R07818','irreversible','path:rno00531','KEGGMAP','IMPD').
reaction('40586: rn:R07807','irreversible','path:rno00531','KEGGMAP','IMPD').
reaction('40587: rn:R07806','irreversible','path:rno00531','KEGGMAP','IMPD').
reaction('40580: rn:R03184','irreversible','path:rno00053','KEGGMAP','IMPD').
reaction('40581: rn:R07811','irreversible','path:rno00531','KEGGMAP','IMPD').
reaction('40582: rn:R07816','irreversible','path:rno00531','KEGGMAP','IMPD').
reaction('40583: rn:R07822','irreversible','path:rno00531','KEGGMAP','IMPD').
reaction('40576: rn:R07824','irreversible','path:rno00531','KEGGMAP','IMPD').
reaction('40577: rn:R07823','irreversible','path:rno00531','KEGGMAP','IMPD').
reaction('13665: rn:R08249','irreversible','path:rn00983','KEGGMAP','IMPD').
reaction('40578: rn:R07813','irreversible','path:rno00531','KEGGMAP','IMPD').
reaction('40579: rn:R07814','irreversible','path:rno00531','KEGGMAP','IMPD').
reaction('40639: rn:R05907','irreversible','path:rno00512','KEGGMAP','IMPD').
reaction('40638: rn:R05907','irreversible','path:rno00512','KEGGMAP','IMPD').
reaction('40637: rn:R05907','irreversible','path:rno00512','KEGGMAP','IMPD').
reaction('9327: rn:R01388','irreversible','path:rn00680','KEGGMAP','IMPD').
reaction('40636: rn:R05907','irreversible','path:rno00512','KEGGMAP','IMPD').
reaction('40635: rn:R08159','irreversible','path:rno00061','KEGGMAP','IMPD').
reaction('40634: rn:R08615','irreversible','path:rno00053','KEGGMAP','IMPD').
reaction('40633: rn:R07762','reversible','path:rno00061','KEGGMAP','IMPD').
reaction('9323: rn:R01196','irreversible','path:rn00680','KEGGMAP','IMPD').
reaction('40632: rn:R08163','irreversible','path:rno00061','KEGGMAP','IMPD').
reaction('40631: rn:R02814','irreversible','path:rno00061','KEGGMAP','IMPD').
reaction('40630: rn:R04014','irreversible','path:rno00061','KEGGMAP','IMPD').
reaction('40629: rn:R08159','irreversible','path:rno00061','KEGGMAP','IMPD').
reaction('40628: rn:R04968','irreversible','path:rno00061','KEGGMAP','IMPD').
reaction('40627: rn:R04726','irreversible','path:rno00061','KEGGMAP','IMPD').
reaction('40626: rn:R05915','irreversible','path:rno00512','KEGGMAP','IMPD').
reaction('40625: rn:R04963','irreversible','path:rno00061','KEGGMAP','IMPD').
reaction('40624: rn:R05910','irreversible','path:rno00512','KEGGMAP','IMPD').
reaction('9341: rn:R00519','irreversible','path:rn00680','KEGGMAP','IMPD').
reaction('40622: rn:R05914','irreversible','path:rno00512','KEGGMAP','IMPD').
reaction('9340: rn:R00945','irreversible','path:rn00680','KEGGMAP','IMPD').
reaction('40623: rn:R04960','irreversible','path:rno00061','KEGGMAP','IMPD').
reaction('40620: rn:R05911','irreversible','path:rno00512','KEGGMAP','IMPD').
reaction('40621: rn:R07628','irreversible','path:rno00512','KEGGMAP','IMPD').
reaction('5934: rn:R02738','reversible','path:rn00520','KEGGMAP','IMPD').
reaction('40618: rn:R05909','irreversible','path:rno00512','KEGGMAP','IMPD').
reaction('9336: rn:R08572','irreversible','path:rn00680','KEGGMAP','IMPD').
reaction('40619: rn:R05907','irreversible','path:rno00512','KEGGMAP','IMPD').
reaction('40616: rn:R05936','irreversible','path:rno00534','KEGGMAP','IMPD').
reaction('40617: rn:R05930','irreversible','path:rno00534','KEGGMAP','IMPD').
reaction('40614: rn:R05911','irreversible','path:rno00512','KEGGMAP','IMPD').
reaction('9332: rn:R00134','irreversible','path:rn00680','KEGGMAP','IMPD').
reaction('40615: rn:R07628','irreversible','path:rno00512','KEGGMAP','IMPD').
reaction('40612: rn:R05909','irreversible','path:rno00512','KEGGMAP','IMPD').
reaction('40613: rn:R05907','irreversible','path:rno00512','KEGGMAP','IMPD').
reaction('40610: rn:R00647','irreversible','path:rno00053','KEGGMAP','IMPD').
reaction('1552: rn:R08995','irreversible','path:rn00140','KEGGMAP','IMPD').
reaction('40611: rn:R05983','irreversible','path:rno00510','KEGGMAP','IMPD').
reaction('9331: rn:R00473','irreversible','path:rn00680','KEGGMAP','IMPD').
reaction('40608: rn:R02933','reversible','path:rno00053','KEGGMAP','IMPD').
reaction('40609: rn:R05935','irreversible','path:rno00534','KEGGMAP','IMPD').
reaction('40528: rn:R00291','reversible','path:rno00052','KEGGMAP','IMPD').
reaction('40529: rn:R02240','irreversible','path:rno00564','KEGGMAP','IMPD').
reaction('40530: rn:R00955','reversible','path:rno00052','KEGGMAP','IMPD').
reaction('40531: rn:R01092','irreversible','path:rno00052','KEGGMAP','IMPD').
reaction('40532: rn:R02051','irreversible','path:rno00564','KEGGMAP','IMPD').
reaction('40533: rn:R03236 rn:R03237 rn:R03238 rn:R03239','reversible','path:rno00052','KEGGMAP','IMPD').
reaction('40534: rn:R07814','irreversible','path:rno00531','KEGGMAP','IMPD').
reaction('40535: rn:R02746','irreversible','path:rno00564','KEGGMAP','IMPD').
reaction('40536: rn:R03634','irreversible','path:rno00052','KEGGMAP','IMPD').
reaction('40537: rn:R02056','irreversible','path:rno00564','KEGGMAP','IMPD').
reaction('40538: rn:R05549','irreversible','path:rno00052','KEGGMAP','IMPD').
reaction('40539: rn:R01801','irreversible','path:rno00564','KEGGMAP','IMPD').
reaction('40540: rn:R02030 rn:R07390','irreversible','path:rno00564','KEGGMAP','IMPD').
reaction('40541: rn:R01103','irreversible','path:rno00052','KEGGMAP','IMPD').
reaction('40542: rn:R00801','irreversible','path:rno00052','KEGGMAP','IMPD').
reaction('40543: rn:R01104','reversible','path:rno00052','KEGGMAP','IMPD').
reaction('40513: rn:R01023','irreversible','path:rno00564','KEGGMAP','IMPD').
reaction('40512: rn:R01194','reversible','path:rno00052','KEGGMAP','IMPD').
reaction('40515: rn:R01026','irreversible','path:rno00564','KEGGMAP','IMPD').
reaction('40514: rn:R02926','reversible','path:rno00052','KEGGMAP','IMPD').
reaction('40517: rn:R01021','irreversible','path:rno00564','KEGGMAP','IMPD').
reaction('40516: rn:R01786','reversible','path:rno00052','KEGGMAP','IMPD').
reaction('40519: rn:R01315','irreversible','path:rno00564','KEGGMAP','IMPD').
reaction('40518: rn:R01786','reversible','path:rno00052','KEGGMAP','IMPD').
reaction('40521: rn:R01678','irreversible','path:rno00052','KEGGMAP','IMPD').
reaction('6090: rn:R08639','reversible','path:rn00521','KEGGMAP','IMPD').
reaction('40520: rn:R01678','irreversible','path:rno00052','KEGGMAP','IMPD').
reaction('40523: rn:R01468','irreversible','path:rno00564','KEGGMAP','IMPD').
reaction('40522: rn:R00503','irreversible','path:rno00052','KEGGMAP','IMPD').
reaction('40525: rn:R01310','irreversible','path:rno00564','KEGGMAP','IMPD').
reaction('40524: rn:R00959','reversible','path:rno00052','KEGGMAP','IMPD').
reaction('40527: rn:R02239','irreversible','path:rno00564','KEGGMAP','IMPD').
reaction('40526: rn:R00289','reversible','path:rno00052','KEGGMAP','IMPD').
reaction('40562: rn:R00286','irreversible','path:rno00053','KEGGMAP','IMPD').
reaction('40563: rn:R07824','irreversible','path:rno00531','KEGGMAP','IMPD').
reaction('40560: rn:R01184','irreversible','path:rno00053','KEGGMAP','IMPD').
reaction('40561: rn:R07807','irreversible','path:rno00531','KEGGMAP','IMPD').
reaction('40566: rn:R07822','irreversible','path:rno00531','KEGGMAP','IMPD').
reaction('40567: rn:R07813','irreversible','path:rno00531','KEGGMAP','IMPD').
reaction('40564: rn:R07812','irreversible','path:rno00531','KEGGMAP','IMPD').
reaction('40565: rn:R07806','irreversible','path:rno00531','KEGGMAP','IMPD').
reaction('40570: rn:R07810','irreversible','path:rno00531','KEGGMAP','IMPD').
reaction('9384: rn:R01440','irreversible','path:rn00680','KEGGMAP','IMPD').
reaction('40571: rn:R07825','irreversible','path:rno00531','KEGGMAP','IMPD').
reaction('40568: rn:R07818','irreversible','path:rno00531','KEGGMAP','IMPD').
reaction('40569: rn:R07819','irreversible','path:rno00531','KEGGMAP','IMPD').
reaction('40574: rn:R07824','irreversible','path:rno00531','KEGGMAP','IMPD').
reaction('40575: rn:R07821','irreversible','path:rno00531','KEGGMAP','IMPD').
reaction('40572: rn:R07816','irreversible','path:rno00531','KEGGMAP','IMPD').
reaction('40573: rn:R07809','irreversible','path:rno00531','KEGGMAP','IMPD').
reaction('40547: rn:R02057','irreversible','path:rno00564','KEGGMAP','IMPD').
reaction('40546: rn:R03416','irreversible','path:rno00564','KEGGMAP','IMPD').
reaction('40545: rn:R01093 rn:R01095','reversible','path:rno00052','KEGGMAP','IMPD').
reaction('40544: rn:R01329','reversible','path:rno00052','KEGGMAP','IMPD').
reaction('40551: rn:R01799','irreversible','path:rno00564','KEGGMAP','IMPD').
reaction('40550: rn:R04480','irreversible','path:rno00564','KEGGMAP','IMPD').
reaction('40549: rn:R07811','irreversible','path:rno00531','KEGGMAP','IMPD').
reaction('40548: rn:R03417','irreversible','path:rno00564','KEGGMAP','IMPD').
reaction('40555: rn:R07821','irreversible','path:rno00531','KEGGMAP','IMPD').
reaction('40554: rn:R02055','irreversible','path:rno00564','KEGGMAP','IMPD').
reaction('40553: rn:R07811','irreversible','path:rno00531','KEGGMAP','IMPD').
reaction('40552: rn:R02747','irreversible','path:rno00564','KEGGMAP','IMPD').
reaction('40559: rn:R07823','irreversible','path:rno00531','KEGGMAP','IMPD').
reaction('40558: rn:R07808','irreversible','path:rno00531','KEGGMAP','IMPD').
reaction('40557: rn:R06871','irreversible','path:rno00564','KEGGMAP','IMPD').
reaction('40556: rn:R00855','irreversible','path:rno00564','KEGGMAP','IMPD').
reaction('40468: rn:R05916','irreversible','path:rno00563','KEGGMAP','IMPD').
reaction('40469: rn:R05916','irreversible','path:rno00563','KEGGMAP','IMPD').
reaction('40470: rn:R00264','irreversible','path:rno00040','KEGGMAP','IMPD').
reaction('1700: rn:R01841','irreversible','path:rn00140','KEGGMAP','IMPD').
reaction('40471: rn:R00705','irreversible','path:rno00562','KEGGMAP','IMPD').
reaction('40464: rn:R01430','irreversible','path:rno00040','KEGGMAP','IMPD').
reaction('40465: rn:R05795','irreversible','path:rno00562','KEGGMAP','IMPD').
reaction('40466: rn:R05916','irreversible','path:rno00563','KEGGMAP','IMPD').
reaction('40467: rn:R05916','irreversible','path:rno00563','KEGGMAP','IMPD').
reaction('40476: rn:R05918','irreversible','path:rno00563','KEGGMAP','IMPD').
reaction('1710: rn:R04309 rn:R04310','irreversible','path:rn00140','KEGGMAP','IMPD').
reaction('40477: rn:R08107','irreversible','path:rno00563','KEGGMAP','IMPD').
reaction('40478: rn:R06623','irreversible','path:rno00563','KEGGMAP','IMPD').
reaction('40479: rn:R05916','irreversible','path:rno00563','KEGGMAP','IMPD').
reaction('40472: rn:R01015','irreversible','path:rno00562','KEGGMAP','IMPD').
reaction('40473: rn:R01802','irreversible','path:rno00562','KEGGMAP','IMPD').
reaction('40474: rn:R05802','irreversible','path:rno00562','KEGGMAP','IMPD').
reaction('9416: rn:R00230','irreversible','path:rn00680','KEGGMAP','IMPD').
reaction('40475: rn:R05921','irreversible','path:rno00563','KEGGMAP','IMPD').
reaction('40453: rn:R00872','irreversible','path:rno00051','KEGGMAP','IMPD').
reaction('40452: rn:R01951','reversible','path:rno00051','KEGGMAP','IMPD').
reaction('40455: rn:R00867','irreversible','path:rno00051','KEGGMAP','IMPD').
reaction('40454: rn:R01326','irreversible','path:rno00051','KEGGMAP','IMPD').
reaction('40449: rn:R02731','irreversible','path:rno00051','KEGGMAP','IMPD').
reaction('1715: rn:R02476 rn:R02477','irreversible','path:rn00140','KEGGMAP','IMPD').
reaction('40448: rn:R04779','irreversible','path:rno00051','KEGGMAP','IMPD').
reaction('1712: rn:R04309','irreversible','path:rn00140','KEGGMAP','IMPD').
reaction('40451: rn:R01818','reversible','path:rno00051','KEGGMAP','IMPD').
reaction('40450: rn:R01819','reversible','path:rno00051','KEGGMAP','IMPD').
reaction('40461: rn:R03435','irreversible','path:rno00562','KEGGMAP','IMPD').
reaction('40460: rn:R04545','irreversible','path:rno00562','KEGGMAP','IMPD').
reaction('40463: rn:R07299','irreversible','path:rno00562','KEGGMAP','IMPD').
reaction('40462: rn:R00866','irreversible','path:rno00051','KEGGMAP','IMPD').
reaction('40457: rn:R01787','reversible','path:rno00051','KEGGMAP','IMPD').
reaction('40456: rn:R01185','irreversible','path:rno00562','KEGGMAP','IMPD').
reaction('40459: rn:R00875','reversible','path:rno00051','KEGGMAP','IMPD').
reaction('40458: rn:R05202','irreversible','path:rno00562','KEGGMAP','IMPD').
reaction('40502: rn:R06870','irreversible','path:rno00564','KEGGMAP','IMPD').
reaction('40503: rn:R00299','irreversible','path:rno00524','KEGGMAP','IMPD').
reaction('40500: rn:R02053','irreversible','path:rno00564','KEGGMAP','IMPD').
reaction('40501: rn:R02241','irreversible','path:rno00564','KEGGMAP','IMPD').
reaction('40498: rn:R02568','reversible','path:rno00051','KEGGMAP','IMPD').
reaction('40499: rn:R01802','irreversible','path:rno00564','KEGGMAP','IMPD').
reaction('40496: rn:R01070','reversible','path:rno00051','KEGGMAP','IMPD').
reaction('40497: rn:R01015','reversible','path:rno00051','KEGGMAP','IMPD').
reaction('40510: rn:R01101','irreversible','path:rno00052','KEGGMAP','IMPD').
reaction('40511: rn:R02038','irreversible','path:rno00564','KEGGMAP','IMPD').
reaction('40508: rn:R00842','reversible','path:rno00564','KEGGMAP','IMPD').
reaction('40509: rn:R02114','irreversible','path:rno00564','KEGGMAP','IMPD').
reaction('40506: rn:R00848','reversible','path:rno00564','KEGGMAP','IMPD').
reaction('40507: rn:R00851','irreversible','path:rno00564','KEGGMAP','IMPD').
reaction('40504: rn:R01788','reversible','path:rno00052','KEGGMAP','IMPD').
reaction('40505: rn:R00299','irreversible','path:rno00524','KEGGMAP','IMPD').
reaction('40487: rn:R05916','irreversible','path:rno00563','KEGGMAP','IMPD').
reaction('40486: rn:R05916','irreversible','path:rno00563','KEGGMAP','IMPD').
reaction('40485: rn:R05919','irreversible','path:rno00563','KEGGMAP','IMPD').
reaction('40484: rn:R05919','irreversible','path:rno00563','KEGGMAP','IMPD').
reaction('40483: rn:R08107','irreversible','path:rno00563','KEGGMAP','IMPD').
reaction('1681: rn:R02208','irreversible','path:rn00140','KEGGMAP','IMPD').
reaction('40482: rn:R05917','irreversible','path:rno00563','KEGGMAP','IMPD').
reaction('40481: rn:R05922','irreversible','path:rno00563','KEGGMAP','IMPD').
reaction('40480: rn:R05920','irreversible','path:rno00563','KEGGMAP','IMPD').
reaction('40495: rn:R04780','irreversible','path:rno00051','KEGGMAP','IMPD').
reaction('40494: rn:R07376','irreversible','path:rno00564','KEGGMAP','IMPD').
reaction('40493: rn:R07377','irreversible','path:rno00564','KEGGMAP','IMPD').
reaction('40492: rn:R03161','irreversible','path:rno00051','KEGGMAP','IMPD').
reaction('40491: rn:R01013','irreversible','path:rno00564','KEGGMAP','IMPD').
reaction('40490: rn:R01321','irreversible','path:rno00564','KEGGMAP','IMPD').
reaction('40489: rn:R01890','irreversible','path:rno00564','KEGGMAP','IMPD').
reaction('40488: rn:R01318','irreversible','path:rno00564','KEGGMAP','IMPD').
reaction('40906: rn:R05987','irreversible','path:rno00510','KEGGMAP','IMPD').
reaction('40907: rn:R03321','reversible','path:rno00010','KEGGMAP','IMPD').
reaction('40904: rn:R05982','irreversible','path:rno00510','KEGGMAP','IMPD').
reaction('1914: rn:R01856','irreversible','path:rn00230','KEGGMAP','IMPD').
reaction('40905: rn:R02739','reversible','path:rno00010','KEGGMAP','IMPD').
reaction('40910: rn:R05984','irreversible','path:rno00510','KEGGMAP','IMPD').
reaction('40911: rn:R01786','irreversible','path:rno00010','KEGGMAP','IMPD').
reaction('1919: rn:R00087','irreversible','path:rn00230','KEGGMAP','IMPD').
reaction('40908: rn:R05985','irreversible','path:rno00510','KEGGMAP','IMPD').
reaction('40909: rn:R01600','irreversible','path:rno00010','KEGGMAP','IMPD').
reaction('40898: rn:R05974','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40899: rn:R06190','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40896: rn:R06189','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40897: rn:R06076','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40902: rn:R06221','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40903: rn:R01600','irreversible','path:rno00010','KEGGMAP','IMPD').
reaction('40900: rn:R06038','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40901: rn:R06191','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40923: rn:R01005','irreversible','path:rno00510','KEGGMAP','IMPD').
reaction('40922: rn:R01788','irreversible','path:rno00010','KEGGMAP','IMPD').
reaction('40921: rn:R05970','irreversible','path:rno00510','KEGGMAP','IMPD').
reaction('40920: rn:R05960','reversible','path:rno00603','KEGGMAP','IMPD').
reaction('40927: rn:R05904','reversible','path:rno00603','KEGGMAP','IMPD').
reaction('40926: rn:R01018','irreversible','path:rno00510','KEGGMAP','IMPD').
reaction('40925: rn:R05973','irreversible','path:rno00510','KEGGMAP','IMPD').
reaction('40924: rn:R05963','reversible','path:rno00603','KEGGMAP','IMPD').
reaction('40915: rn:R05964','reversible','path:rno00603','KEGGMAP','IMPD').
reaction('40914: rn:R05976','irreversible','path:rno00510','KEGGMAP','IMPD').
reaction('1890: rn:R00125','irreversible','path:rn00230','KEGGMAP','IMPD').
reaction('40913: rn:R01786','irreversible','path:rno00010','KEGGMAP','IMPD').
reaction('40912: rn:R06128','irreversible','path:rno00510','KEGGMAP','IMPD').
reaction('40919: rn:R05972','irreversible','path:rno00510','KEGGMAP','IMPD').
reaction('40918: rn:R05966','reversible','path:rno00603','KEGGMAP','IMPD').
reaction('40917: rn:R05979','irreversible','path:rno00510','KEGGMAP','IMPD').
reaction('40916: rn:R01602','reversible','path:rno00010','KEGGMAP','IMPD').
reaction('40936: rn:R03270','irreversible','path:rno00010','KEGGMAP','IMPD').
reaction('40937: rn:R01518','reversible','path:rno00010','KEGGMAP','IMPD').
reaction('40938: rn:R00658','reversible','path:rno00010','KEGGMAP','IMPD').
reaction('1880: rn:R02020','irreversible','path:rn00230','KEGGMAP','IMPD').
reaction('40939: rn:R00200','irreversible','path:rno00010','KEGGMAP','IMPD').
reaction('40940: rn:R05967','reversible','path:rno00603','KEGGMAP','IMPD').
reaction('40941: rn:R04779','irreversible','path:rno00010','KEGGMAP','IMPD').
reaction('40942: rn:R01015','reversible','path:rno00010','KEGGMAP','IMPD').
reaction('1884: rn:R00429','irreversible','path:rn00230','KEGGMAP','IMPD').
reaction('40943: rn:R01061','reversible','path:rno00010','KEGGMAP','IMPD').
reaction('40928: rn:R05968','reversible','path:rno00603','KEGGMAP','IMPD').
reaction('40929: rn:R07618','reversible','path:rno00010','KEGGMAP','IMPD').
reaction('40930: rn:R01009','irreversible','path:rno00510','KEGGMAP','IMPD').
reaction('1872: rn:R00336','reversible','path:rn00230','KEGGMAP','IMPD').
reaction('40931: rn:R05961','reversible','path:rno00603','KEGGMAP','IMPD').
reaction('40932: rn:R01512','reversible','path:rno00010','KEGGMAP','IMPD').
reaction('40933: rn:R05969','irreversible','path:rno00510','KEGGMAP','IMPD').
reaction('40934: rn:R00703','reversible','path:rno00010','KEGGMAP','IMPD').
reaction('40935: rn:R02569','reversible','path:rno00010','KEGGMAP','IMPD').
reaction('40953: rn:R05989','irreversible','path:rno00510','KEGGMAP','IMPD').
reaction('1867: rn:R00131','irreversible','path:rn00230','KEGGMAP','IMPD').
reaction('40952: rn:R05988','irreversible','path:rno00510','KEGGMAP','IMPD').
reaction('9512: rn:R09094','irreversible','path:rn00680','KEGGMAP','IMPD').
reaction('1864: rn:R02425','reversible','path:rn00230','KEGGMAP','IMPD').
reaction('40955: rn:R05986','irreversible','path:rno00510','KEGGMAP','IMPD').
reaction('40954: rn:R05992','irreversible','path:rno00510','KEGGMAP','IMPD').
reaction('1870: rn:R00469','reversible','path:rn00230','KEGGMAP','IMPD').
reaction('40957: rn:R00235','irreversible','path:rno00010','KEGGMAP','IMPD').
reaction('40956: rn:R05990','irreversible','path:rno00510','KEGGMAP','IMPD').
reaction('40959: rn:R04770','irreversible','path:rno00450','KEGGMAP','IMPD').
reaction('1869: rn:R01618','irreversible','path:rn00230','KEGGMAP','IMPD').
reaction('40958: rn:R09085','irreversible','path:rno00010','KEGGMAP','IMPD').
reaction('40945: rn:R02740','reversible','path:rno00010','KEGGMAP','IMPD').
reaction('40944: rn:R00959','reversible','path:rno00010','KEGGMAP','IMPD').
reaction('40947: rn:R00431 rn:R00726','irreversible','path:rno00010','KEGGMAP','IMPD').
reaction('40946: rn:R04780','irreversible','path:rno00010','KEGGMAP','IMPD').
reaction('1862: rn:R00776','reversible','path:rn00230','KEGGMAP','IMPD').
reaction('40949: rn:R01004','irreversible','path:rno00510','KEGGMAP','IMPD').
reaction('40948: rn:R05991','irreversible','path:rno00510','KEGGMAP','IMPD').
reaction('40951: rn:R06153','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40950: rn:R06153','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40846: rn:R02108','irreversible','path:rno00500','KEGGMAP','IMPD').
reaction('40847: rn:R06230','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40844: rn:R05196','irreversible','path:rno00500','KEGGMAP','IMPD').
reaction('40845: rn:R05974','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40842: rn:R06222','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40843: rn:R02111','irreversible','path:rno00500','KEGGMAP','IMPD').
reaction('40840: rn:R06221','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40841: rn:R06224','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40838: rn:R01786','reversible','path:rno00500','KEGGMAP','IMPD').
reaction('40839: rn:R06227','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40836: rn:R01786','irreversible','path:rno00500','KEGGMAP','IMPD').
reaction('40837: rn:R05977','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40834: rn:R05975','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40835: rn:R05977','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40832: rn:R06039','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40833: rn:R01788','reversible','path:rno00500','KEGGMAP','IMPD').
reaction('40863: rn:R06024','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40862: rn:R06258','irreversible','path:rno00510','KEGGMAP','IMPD').
reaction('1838: rn:R01244','irreversible','path:rn00230','KEGGMAP','IMPD').
reaction('40861: rn:R06027','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40860: rn:R06167','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40859: rn:R01009','irreversible','path:rno00510','KEGGMAP','IMPD').
reaction('40858: rn:R05970','irreversible','path:rno00510','KEGGMAP','IMPD').
reaction('40857: rn:R06156','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40856: rn:R06006','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('13428: rn:R08317','irreversible','path:rn00982','KEGGMAP','IMPD').
reaction('40855: rn:R06006','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40854: rn:R06006','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40853: rn:R06168','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40852: rn:R06169','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40851: rn:R06170','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40850: rn:R00028','irreversible','path:rno00500','KEGGMAP','IMPD').
reaction('40849: rn:R08969','reversible','path:rno00600','KEGGMAP','IMPD').
reaction('40848: rn:R01790','irreversible','path:rno00500','KEGGMAP','IMPD').
reaction('40876: rn:R06187','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('9598: rn:R00024','irreversible','path:rn00710','KEGGMAP','IMPD').
reaction('40877: rn:R05977','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40878: rn:R06197','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40879: rn:R06193','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40872: rn:R05978','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40873: rn:R01009','irreversible','path:rno00510','KEGGMAP','IMPD').
reaction('40874: rn:R06031','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40875: rn:R06035','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40868: rn:R06262','irreversible','path:rno00510','KEGGMAP','IMPD').
reaction('40869: rn:R06033','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40870: rn:R05975','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40871: rn:R06029','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('1811: rn:R02014','irreversible','path:rn00230','KEGGMAP','IMPD').
reaction('40864: rn:R06259','irreversible','path:rno00510','KEGGMAP','IMPD').
reaction('40865: rn:R06095','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('9585: rn:R01829','irreversible','path:rn00710','KEGGMAP','IMPD').
reaction('40866: rn:R06260','irreversible','path:rno00510','KEGGMAP','IMPD').
reaction('9584: rn:R00214','irreversible','path:rn00710','KEGGMAP','IMPD').
reaction('40867: rn:R05971','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40893: rn:R00754','reversible','path:rno00010','KEGGMAP','IMPD').
reaction('40892: rn:R06025','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40895: rn:R00014','irreversible','path:rno00010','KEGGMAP','IMPD').
reaction('9581: rn:R00341','irreversible','path:rn00710','KEGGMAP','IMPD').
reaction('40894: rn:R06032','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40889: rn:R06039','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40888: rn:R06222','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40891: rn:R00746','reversible','path:rno00010','KEGGMAP','IMPD').
reaction('40890: rn:R06026','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('9574: rn:R00216','irreversible','path:rn00710','KEGGMAP','IMPD').
reaction('40885: rn:R00711','reversible','path:rno00010','KEGGMAP','IMPD').
reaction('40884: rn:R06227','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('9572: rn:R00345','irreversible','path:rn00710','KEGGMAP','IMPD').
reaction('40887: rn:R06037','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('1797: rn:R01053','irreversible','path:rn00230','KEGGMAP','IMPD').
reaction('40886: rn:R06230','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40881: rn:R06041','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40880: rn:R01070','reversible','path:rno00010','KEGGMAP','IMPD').
reaction('40883: rn:R06224','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40882: rn:R00710','reversible','path:rno00010','KEGGMAP','IMPD').
reaction('40771: rn:R03920','reversible','path:rno00500','KEGGMAP','IMPD').
reaction('40770: rn:R03354','irreversible','path:rno00600','KEGGMAP','IMPD').
reaction('40769: rn:R00802','irreversible','path:rno00500','KEGGMAP','IMPD').
reaction('40768: rn:R00802','irreversible','path:rno00500','KEGGMAP','IMPD').
reaction('40775: rn:R01383','irreversible','path:rno00500','KEGGMAP','IMPD').
reaction('40774: rn:R03617','irreversible','path:rno00600','KEGGMAP','IMPD').
reaction('40773: rn:R02887','irreversible','path:rno00500','KEGGMAP','IMPD').
reaction('40772: rn:R00026','irreversible','path:rno00500','KEGGMAP','IMPD').
reaction('40779: rn:R01926','irreversible','path:rno00600','KEGGMAP','IMPD').
reaction('40778: rn:R04856','irreversible','path:rno00600','KEGGMAP','IMPD').
reaction('40777: rn:R00289','irreversible','path:rno00500','KEGGMAP','IMPD').
reaction('40776: rn:R01478','irreversible','path:rno00500','KEGGMAP','IMPD').
reaction('40783: rn:R01660','irreversible','path:rno00500','KEGGMAP','IMPD').
reaction('40782: rn:R06516','irreversible','path:rno00600','KEGGMAP','IMPD').
reaction('40781: rn:R00286','irreversible','path:rno00500','KEGGMAP','IMPD').
reaction('40780: rn:R02976','irreversible','path:rno00600','KEGGMAP','IMPD').
reaction('40786: rn:R01498','irreversible','path:rno00600','KEGGMAP','IMPD').
reaction('40787: rn:R01497','irreversible','path:rno00600','KEGGMAP','IMPD').
reaction('9603: rn:R00345','irreversible','path:rn00710','KEGGMAP','IMPD').
reaction('40784: rn:R02464','irreversible','path:rno00600','KEGGMAP','IMPD').
reaction('40785: rn:R03355','irreversible','path:rno00600','KEGGMAP','IMPD').
reaction('9605: rn:R00216','irreversible','path:rn00710','KEGGMAP','IMPD').
reaction('40790: rn:R04019','irreversible','path:rno00600','KEGGMAP','IMPD').
reaction('40791: rn:R04017','reversible','path:rno00600','KEGGMAP','IMPD').
reaction('40788: rn:R01494','irreversible','path:rno00600','KEGGMAP','IMPD').
reaction('40789: rn:R00287','irreversible','path:rno00500','KEGGMAP','IMPD').
reaction('40794: rn:R05105','irreversible','path:rno00600','KEGGMAP','IMPD').
reaction('5849: rn:R01200','reversible','path:rn00520','KEGGMAP','IMPD').
reaction('40795: rn:R02978','irreversible','path:rno00600','KEGGMAP','IMPD').
reaction('5848: rn:R01204','irreversible','path:rn00520','KEGGMAP','IMPD').
reaction('40792: rn:R04018','irreversible','path:rno00600','KEGGMAP','IMPD').
reaction('40793: rn:R01500','irreversible','path:rno00600','KEGGMAP','IMPD').
reaction('40798: rn:R08359','irreversible','path:rno00480','KEGGMAP','IMPD').
reaction('40799: rn:R02869','irreversible','path:rno00480','KEGGMAP','IMPD').
reaction('40796: rn:R01281','irreversible','path:rno00600','KEGGMAP','IMPD').
reaction('40797: rn:R08363','irreversible','path:rno00480','KEGGMAP','IMPD').
reaction('13442: rn:R08309','reversible','path:rn00982','KEGGMAP','IMPD').
reaction('40801: rn:R06520','irreversible','path:rno00600','KEGGMAP','IMPD').
reaction('40800: rn:R01920','irreversible','path:rno00480','KEGGMAP','IMPD').
reaction('13440: rn:R08305','irreversible','path:rn00982','KEGGMAP','IMPD').
reaction('40803: rn:R01495','irreversible','path:rno00600','KEGGMAP','IMPD').
reaction('40802: rn:R06521','irreversible','path:rno00600','KEGGMAP','IMPD').
reaction('40805: rn:R06522','irreversible','path:rno00600','KEGGMAP','IMPD').
reaction('40804: rn:R04951','irreversible','path:rno00480','KEGGMAP','IMPD').
reaction('13444: rn:R08311','irreversible','path:rn00982','KEGGMAP','IMPD').
reaction('40807: rn:R00899','irreversible','path:rno00480','KEGGMAP','IMPD').
reaction('40806: rn:R02541','irreversible','path:rno00600','KEGGMAP','IMPD').
reaction('40809: rn:R06518','irreversible','path:rno00600','KEGGMAP','IMPD').
reaction('9659: rn:R01196','reversible','path:rn00720','KEGGMAP','IMPD').
reaction('40808: rn:R06519','irreversible','path:rno00600','KEGGMAP','IMPD').
reaction('40811: rn:R06521','irreversible','path:rno00600','KEGGMAP','IMPD').
reaction('40810: rn:R06528','irreversible','path:rno00600','KEGGMAP','IMPD').
reaction('13454: rn:R08278','reversible','path:rn00982','KEGGMAP','IMPD').
reaction('40813: rn:R06520','irreversible','path:rno00600','KEGGMAP','IMPD').
reaction('40812: rn:R08364','irreversible','path:rno00480','KEGGMAP','IMPD').
reaction('40815: rn:R01718','irreversible','path:rno00500','KEGGMAP','IMPD').
reaction('9661: rn:R00345','irreversible','path:rn00720','KEGGMAP','IMPD').
reaction('40814: rn:R06522','irreversible','path:rno00600','KEGGMAP','IMPD').
reaction('5869: rn:R02087','irreversible','path:rn00520','KEGGMAP','IMPD').
reaction('40816: rn:R01791','irreversible','path:rno00500','KEGGMAP','IMPD').
reaction('40817: rn:R01791','irreversible','path:rno00500','KEGGMAP','IMPD').
reaction('40818: rn:R06075','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40819: rn:R02109','reversible','path:rno00500','KEGGMAP','IMPD').
reaction('40820: rn:R06095','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40821: rn:R02740','reversible','path:rno00500','KEGGMAP','IMPD').
reaction('40822: rn:R06076','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40823: rn:R06038','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40824: rn:R02110','irreversible','path:rno00500','KEGGMAP','IMPD').
reaction('40825: rn:R00010','irreversible','path:rno00500','KEGGMAP','IMPD').
reaction('40826: rn:R06025','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40827: rn:R05977','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40828: rn:R00292','irreversible','path:rno00500','KEGGMAP','IMPD').
reaction('40829: rn:R06033','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40830: rn:R06033','irreversible','path:rno00601','KEGGMAP','IMPD').
reaction('40831: rn:R00959','reversible','path:rno00500','KEGGMAP','IMPD').
reaction('40711: rn:R04726','irreversible','path:rno00061','KEGGMAP','IMPD').
reaction('40710: rn:R02058','irreversible','path:rno00520','KEGGMAP','IMPD').
reaction('40709: rn:R03161','reversible','path:rno00520','KEGGMAP','IMPD').
reaction('40708: rn:R04566','reversible','path:rno00061','KEGGMAP','IMPD').
reaction('9680: rn:R09289','irreversible','path:rn00720','KEGGMAP','IMPD').
reaction('40707: rn:R04470','irreversible','path:rno00561','KEGGMAP','IMPD').
reaction('40706: rn:R01951','reversible','path:rno00520','KEGGMAP','IMPD').
reaction('40705: rn:R00885','reversible','path:rno00520','KEGGMAP','IMPD').
reaction('40704: rn:R02240','irreversible','path:rno00561','KEGGMAP','IMPD').
reaction('40719: rn:R01115','reversible','path:rno00520','KEGGMAP','IMPD').
reaction('40718: rn:R00100','irreversible','path:rno00520','KEGGMAP','IMPD').
reaction('40717: rn:R01207','reversible','path:rno00520','KEGGMAP','IMPD').
reaction('40716: rn:R01811','irreversible','path:rno00520','KEGGMAP','IMPD').
reaction('9688: rn:R00473','irreversible','path:rn00720','KEGGMAP','IMPD').
reaction('40715: rn:R00022','irreversible','path:rno00520','KEGGMAP','IMPD').
reaction('40714: rn:R00888','reversible','path:rno00520','KEGGMAP','IMPD').
reaction('40713: rn:R05692','reversible','path:rno00520','KEGGMAP','IMPD').
reaction('40712: rn:R04215','reversible','path:rno00520','KEGGMAP','IMPD').
reaction('40726: rn:R01961','reversible','path:rno00520','KEGGMAP','IMPD').
reaction('40727: rn:R04404','irreversible','path:rno00562','KEGGMAP','IMPD').
reaction('40724: rn:R05800','irreversible','path:rno00562','KEGGMAP','IMPD').
reaction('40725: rn:R04954','reversible','path:rno00061','KEGGMAP','IMPD').
reaction('40722: rn:R01786','reversible','path:rno00520','KEGGMAP','IMPD').
reaction('40723: rn:R05801','irreversible','path:rno00562','KEGGMAP','IMPD').
reaction('40720: rn:R01803','reversible','path:rno00520','KEGGMAP','IMPD').
reaction('9666: rn:R09280','irreversible','path:rn00720','KEGGMAP','IMPD').
reaction('40721: rn:R00959','reversible','path:rno00520','KEGGMAP','IMPD').
reaction('40734: rn:R04430','reversible','path:rno00061','KEGGMAP','IMPD').
reaction('40735: rn:R04428','reversible','path:rno00061','KEGGMAP','IMPD').
reaction('9679: rn:R00740','irreversible','path:rn00720','KEGGMAP','IMPD').
reaction('40732: rn:R04956','reversible','path:rno00061','KEGGMAP','IMPD').
reaction('40733: rn:R03429','irreversible','path:rno00562','KEGGMAP','IMPD').
reaction('9673: rn:R00267','irreversible','path:rn00720','KEGGMAP','IMPD').
reaction('40730: rn:R01786','reversible','path:rno00520','KEGGMAP','IMPD').
reaction('9672: rn:R01197','irreversible','path:rn00720','KEGGMAP','IMPD').
reaction('40731: rn:R05803','irreversible','path:rno00562','KEGGMAP','IMPD').
reaction('40728: rn:R04953','reversible','path:rno00061','KEGGMAP','IMPD').
reaction('40729: rn:R01786','reversible','path:rno00520','KEGGMAP','IMPD').
reaction('40741: rn:R04513','irreversible','path:rno00562','KEGGMAP','IMPD').
reaction('40740: rn:R03434','irreversible','path:rno00562','KEGGMAP','IMPD').
reaction('40743: rn:R03920','reversible','path:rno00520','KEGGMAP','IMPD').
reaction('40742: rn:R04355','irreversible','path:rno00061','KEGGMAP','IMPD').
reaction('40737: rn:R03433','irreversible','path:rno00562','KEGGMAP','IMPD').
reaction('9715: rn:R09317','irreversible','path:rn00720','KEGGMAP','IMPD').
reaction('40736: rn:R03428','irreversible','path:rno00562','KEGGMAP','IMPD').
reaction('40739: rn:R03430','irreversible','path:rno00562','KEGGMAP','IMPD').
reaction('1937: rn:R00126','irreversible','path:rn00230','KEGGMAP','IMPD').
reaction('40738: rn:R04952','irreversible','path:rno00061','KEGGMAP','IMPD').
reaction('40749: rn:R03427','irreversible','path:rno00562','KEGGMAP','IMPD').
reaction('40748: rn:R03394','irreversible','path:rno00562','KEGGMAP','IMPD').
reaction('40751: rn:R02740','reversible','path:rno00520','KEGGMAP','IMPD').
reaction('40750: rn:R04533','reversible','path:rno00061','KEGGMAP','IMPD').
reaction('40745: rn:R03393','irreversible','path:rno00562','KEGGMAP','IMPD').
reaction('1947: rn:R00322','irreversible','path:rn00230','KEGGMAP','IMPD').
reaction('40744: rn:R01626','reversible','path:rno00061','KEGGMAP','IMPD').
reaction('40747: rn:R01626','reversible','path:rno00061','KEGGMAP','IMPD').
reaction('40746: rn:R04372','irreversible','path:rno00562','KEGGMAP','IMPD').
reaction('9703: rn:R00230','irreversible','path:rn00720','KEGGMAP','IMPD').
reaction('40756: rn:R03362','irreversible','path:rno00562','KEGGMAP','IMPD').
reaction('40757: rn:R03361','irreversible','path:rno00562','KEGGMAP','IMPD').
reaction('40758: rn:R01187','irreversible','path:rno00562','KEGGMAP','IMPD').
reaction('40759: rn:R01206','irreversible','path:rno00520','KEGGMAP','IMPD').
reaction('9699: rn:R00943','irreversible','path:rn00720','KEGGMAP','IMPD').
reaction('1923: rn:R01885','irreversible','path:rn00230','KEGGMAP','IMPD').
reaction('40752: rn:R03479','reversible','path:rno00562','KEGGMAP','IMPD').
reaction('9698: rn:R00134','irreversible','path:rn00720','KEGGMAP','IMPD').
reaction('40753: rn:R01326','reversible','path:rno00520','KEGGMAP','IMPD').
reaction('40754: rn:R03469','irreversible','path:rno00562','KEGGMAP','IMPD').
reaction('40755: rn:R04386','reversible','path:rno00061','KEGGMAP','IMPD').
reaction('40764: rn:R01186','irreversible','path:rno00562','KEGGMAP','IMPD').
reaction('40765: rn:R04385','irreversible','path:rno00061','KEGGMAP','IMPD').
reaction('40766: rn:R01384','irreversible','path:rno00500','KEGGMAP','IMPD').
reaction('40767: rn:R03527','irreversible','path:rno00500','KEGGMAP','IMPD').
reaction('40760: rn:R01184','irreversible','path:rno00562','KEGGMAP','IMPD').
reaction('40761: rn:R00289','reversible','path:rno00520','KEGGMAP','IMPD').
reaction('9705: rn:R00237','irreversible','path:rn00720','KEGGMAP','IMPD').
reaction('40762: rn:R07324','irreversible','path:rno00562','KEGGMAP','IMPD').
reaction('40763: rn:R01624','irreversible','path:rno00061','KEGGMAP','IMPD').
reaction('2201: rn:R02022','irreversible','path:rn00240','KEGGMAP','IMPD').
reaction('2205: rn:R02325','irreversible','path:rn00240','KEGGMAP','IMPD').
reaction('6539: rn:R05146','irreversible','path:rn00540','KEGGMAP','IMPD').
reaction('6540: rn:R05075','irreversible','path:rn00540','KEGGMAP','IMPD').
reaction('2209: rn:R01668','irreversible','path:rn00240','KEGGMAP','IMPD').
reaction('6639: rn:R01048','irreversible','path:rn00561','KEGGMAP','IMPD').
reaction('6633: rn:R01034','reversible','path:rn00561','KEGGMAP','IMPD').
reaction('6634: rn:R01039','reversible','path:rn00561','KEGGMAP','IMPD').
reaction('2255: rn:R00515','irreversible','path:rn00240','KEGGMAP','IMPD').
reaction('6651: rn:R04471','irreversible','path:rn00561','KEGGMAP','IMPD').
reaction('2250: rn:R00287','irreversible','path:rn00240','KEGGMAP','IMPD').
reaction('6620: rn:R02691','irreversible','path:rn00561','KEGGMAP','IMPD').
reaction('6442: rn:R07817','irreversible','path:rn00531','KEGGMAP','IMPD').
reaction('2050: rn:R00150','irreversible','path:rn00230','KEGGMAP','IMPD').
reaction('2100: rn:R07969 rn:R07970','irreversible','path:rn00232','KEGGMAP','IMPD').
reaction('2111: rn:R07919','irreversible','path:rn00232','KEGGMAP','IMPD').
reaction('2110: rn:R07955 rn:R07956','irreversible','path:rn00232','KEGGMAP','IMPD').
reaction('2109: rn:R07980','irreversible','path:rn00232','KEGGMAP','IMPD').
reaction('2108: rn:R07961 rn:R07962','irreversible','path:rn00232','KEGGMAP','IMPD').
reaction('6419: rn:R07815','irreversible','path:rn00531','KEGGMAP','IMPD').
reaction('6423: rn:R07817','irreversible','path:rn00531','KEGGMAP','IMPD').
reaction('2142: rn:R07982','irreversible','path:rn00232','KEGGMAP','IMPD').
reaction('2139: rn:R07922','irreversible','path:rn00232','KEGGMAP','IMPD').
reaction('2119: rn:R07965 rn:R07966','irreversible','path:rn00232','KEGGMAP','IMPD').
reaction('2112: rn:R07920','irreversible','path:rn00232','KEGGMAP','IMPD').
reaction('2115: rn:R07919','irreversible','path:rn00232','KEGGMAP','IMPD').
reaction('2120: rn:R07957 rn:R07958','irreversible','path:rn00232','KEGGMAP','IMPD').
reaction('2148: rn:R07307','irreversible','path:rn00240','KEGGMAP','IMPD').
reaction('41568: rn:R01710','reversible','path:rno00750','KEGGMAP','IMPD').
reaction('41569: rn:R00277','irreversible','path:rno00750','KEGGMAP','IMPD').
reaction('41570: rn:R02494','irreversible','path:rno00750','KEGGMAP','IMPD').
reaction('41571: rn:R02493','irreversible','path:rno00750','KEGGMAP','IMPD').
reaction('41546: rn:R00135','irreversible','path:rno00330','KEGGMAP','IMPD').
reaction('41547: rn:R00669','irreversible','path:rno00330','KEGGMAP','IMPD').
reaction('41544: rn:R08408','irreversible','path:rno00760','KEGGMAP','IMPD').
reaction('41545: rn:R04085','irreversible','path:rno00760','KEGGMAP','IMPD').
reaction('41550: rn:R01086','irreversible','path:rno00330','KEGGMAP','IMPD').
reaction('41551: rn:R00278','irreversible','path:rno00750','KEGGMAP','IMPD').
reaction('41548: rn:R01711','reversible','path:rno00750','KEGGMAP','IMPD').
reaction('41549: rn:R00551','irreversible','path:rno00330','KEGGMAP','IMPD').
reaction('41538: rn:R01269','irreversible','path:rno00760','KEGGMAP','IMPD').
reaction('41539: rn:R01253','irreversible','path:rno00330','KEGGMAP','IMPD').
reaction('41536: rn:R00102','irreversible','path:rno00760','KEGGMAP','IMPD').
reaction('41537: rn:R01248 rn:R01251','reversible','path:rno00330','KEGGMAP','IMPD').
reaction('41542: rn:R00112','reversible','path:rno00760','KEGGMAP','IMPD').
reaction('41543: rn:R01252','irreversible','path:rno00330','KEGGMAP','IMPD').
reaction('41540: rn:R00104','irreversible','path:rno00760','KEGGMAP','IMPD').
reaction('41541: rn:R00667','reversible','path:rno00330','KEGGMAP','IMPD').
reaction('41563: rn:R03004','irreversible','path:rno00760','KEGGMAP','IMPD').
reaction('41562: rn:R00253','irreversible','path:rno00330','KEGGMAP','IMPD').
reaction('41561: rn:R01911','irreversible','path:rno00750','KEGGMAP','IMPD').
reaction('41560: rn:R01909','irreversible','path:rno00750','KEGGMAP','IMPD').
reaction('41567: rn:R00119','irreversible','path:rno00760','KEGGMAP','IMPD').
reaction('41566: rn:R03004','irreversible','path:rno00760','KEGGMAP','IMPD').
reaction('41565: rn:R03348','irreversible','path:rno00760','KEGGMAP','IMPD').
reaction('41564: rn:R03346','reversible','path:rno00760','KEGGMAP','IMPD').
reaction('41555: rn:R00149','irreversible','path:rno00330','KEGGMAP','IMPD').
reaction('41554: rn:R05085','reversible','path:rno00750','KEGGMAP','IMPD').
reaction('41553: rn:R01398','irreversible','path:rno00330','KEGGMAP','IMPD').
reaction('41552: rn:R00259','irreversible','path:rno00330','KEGGMAP','IMPD').
reaction('41559: rn:R00173','irreversible','path:rno00750','KEGGMAP','IMPD').
reaction('41558: rn:R00256','irreversible','path:rno00330','KEGGMAP','IMPD').
reaction('41557: rn:R00174','irreversible','path:rno00750','KEGGMAP','IMPD').
reaction('41556: rn:R01954','irreversible','path:rno00330','KEGGMAP','IMPD').
reaction('41516: rn:R00137','reversible','path:rno00760','KEGGMAP','IMPD').
reaction('41517: rn:R00111','irreversible','path:rno00330','KEGGMAP','IMPD').
reaction('41518: rn:R02323','irreversible','path:rno00760','KEGGMAP','IMPD').
reaction('41519: rn:R01271','reversible','path:rno00760','KEGGMAP','IMPD').
reaction('41512: rn:R00103','irreversible','path:rno00760','KEGGMAP','IMPD').
reaction('41513: rn:R01883','irreversible','path:rno00330','KEGGMAP','IMPD').
reaction('41514: rn:R00137','reversible','path:rno00760','KEGGMAP','IMPD').
reaction('41515: rn:R00565','reversible','path:rno00330','KEGGMAP','IMPD').
reaction('41508: rn:R01989','irreversible','path:rno00330','KEGGMAP','IMPD').
reaction('2503: rn:R01388','reversible','path:rn00260','KEGGMAP','IMPD').
reaction('41509: rn:R00566','irreversible','path:rno00330','KEGGMAP','IMPD').
reaction('41510: rn:R01157','irreversible','path:rno00330','KEGGMAP','IMPD').
reaction('41511: rn:R00103','irreversible','path:rno00760','KEGGMAP','IMPD').
reaction('41504: rn:R00239','irreversible','path:rno00330','KEGGMAP','IMPD').
reaction('41505: rn:R00245','reversible','path:rno00330','KEGGMAP','IMPD').
reaction('41506: rn:R03313','irreversible','path:rno00330','KEGGMAP','IMPD').
reaction('41507: rn:R00670','irreversible','path:rno00330','KEGGMAP','IMPD').
reaction('41533: rn:R05051','irreversible','path:rno00330','KEGGMAP','IMPD').
reaction('41532: rn:R05051','irreversible','path:rno00330','KEGGMAP','IMPD').
reaction('41535: rn:R04444 rn:R04445','irreversible','path:rno00330','KEGGMAP','IMPD').
reaction('41534: rn:R03291 rn:R03293','irreversible','path:rno00330','KEGGMAP','IMPD').
reaction('41529: rn:R01724','reversible','path:rno00760','KEGGMAP','IMPD').
reaction('41528: rn:R00257','irreversible','path:rno00760','KEGGMAP','IMPD').
reaction('41531: rn:R02894','irreversible','path:rno00330','KEGGMAP','IMPD').
reaction('41530: rn:R03295','irreversible','path:rno00330','KEGGMAP','IMPD').
reaction('41525: rn:R03005','reversible','path:rno00760','KEGGMAP','IMPD').
reaction('41524: rn:R03005','reversible','path:rno00760','KEGGMAP','IMPD').
reaction('41527: rn:R00558','irreversible','path:rno00330','KEGGMAP','IMPD').
reaction('2516: rn:R00996','irreversible','path:rn00260','KEGGMAP','IMPD').
reaction('41526: rn:R05052','irreversible','path:rno00330','KEGGMAP','IMPD').
reaction('41521: rn:R01881','irreversible','path:rno00330','KEGGMAP','IMPD').
reaction('41520: rn:R02294','reversible','path:rno00760','KEGGMAP','IMPD').
reaction('41523: rn:R03347','irreversible','path:rno00760','KEGGMAP','IMPD').
reaction('41522: rn:R02295','reversible','path:rno00760','KEGGMAP','IMPD').
reaction('41486: rn:R02313','reversible','path:rno00310','KEGGMAP','IMPD').
reaction('41487: rn:R01940','irreversible','path:rno00310','KEGGMAP','IMPD').
reaction('2540: rn:R01388 rn:R01392','reversible','path:rn00260','KEGGMAP','IMPD').
reaction('41484: rn:R03875','irreversible','path:rno00310','KEGGMAP','IMPD').
reaction('41485: rn:R03102 rn:R03103','irreversible','path:rno00310','KEGGMAP','IMPD').
reaction('6366: rn:R08905','irreversible','path:rn00524','KEGGMAP','IMPD').
reaction('41482: rn:R03380','irreversible','path:rno00310','KEGGMAP','IMPD').
reaction('2537: rn:R00221','reversible','path:rn00260','KEGGMAP','IMPD').
reaction('41483: rn:R00619','irreversible','path:rno00730','KEGGMAP','IMPD').
reaction('41480: rn:R04313','irreversible','path:rno00310','KEGGMAP','IMPD').
reaction('41481: rn:R03451','irreversible','path:rno00310','KEGGMAP','IMPD').
reaction('41478: rn:R03026','irreversible','path:rno00310','KEGGMAP','IMPD').
reaction('41479: rn:R04867','irreversible','path:rno00310','KEGGMAP','IMPD').
reaction('41476: rn:R03376','irreversible','path:rno00310','KEGGMAP','IMPD').
reaction('41477: rn:R04866','irreversible','path:rno00310','KEGGMAP','IMPD').
reaction('41474: rn:R00616','irreversible','path:rno00730','KEGGMAP','IMPD').
reaction('41475: rn:R02571','reversible','path:rno00310','KEGGMAP','IMPD').
reaction('41472: rn:R00618','irreversible','path:rno00730','KEGGMAP','IMPD').
reaction('41473: rn:R02204','irreversible','path:rno00310','KEGGMAP','IMPD').
reaction('41503: rn:R01920','irreversible','path:rno00330','KEGGMAP','IMPD').
reaction('41502: rn:R00178','irreversible','path:rno00330','KEGGMAP','IMPD').
reaction('41501: rn:R01986 rn:R02549','irreversible','path:rno00330','KEGGMAP','IMPD').
reaction('41500: rn:R01151','irreversible','path:rno00330','KEGGMAP','IMPD').
reaction('41499: rn:R00716','irreversible','path:rno00310','KEGGMAP','IMPD').
reaction('41498: rn:R00937 rn:R00940','irreversible','path:rno00670','KEGGMAP','IMPD').
reaction('41497: rn:R03283','irreversible','path:rno00310','KEGGMAP','IMPD').
reaction('41496: rn:R02397','irreversible','path:rno00310','KEGGMAP','IMPD').
reaction('41495: rn:R00946','reversible','path:rno00670','KEGGMAP','IMPD').
reaction('41494: rn:R02101','reversible','path:rno00670','KEGGMAP','IMPD').
reaction('41493: rn:R04560','reversible','path:rno00670','KEGGMAP','IMPD').
reaction('41492: rn:R04125','reversible','path:rno00670','KEGGMAP','IMPD').
reaction('41491: rn:R00945','reversible','path:rno00670','KEGGMAP','IMPD').
reaction('41490: rn:R01975','reversible','path:rno00310','KEGGMAP','IMPD').
reaction('41489: rn:R07460','irreversible','path:rno00730','KEGGMAP','IMPD').
reaction('41488: rn:R01939','reversible','path:rno00310','KEGGMAP','IMPD').
reaction('2345: rn:R01346','irreversible','path:rn00250','KEGGMAP','IMPD').
reaction('2346: rn:R00397','irreversible','path:rn00250','KEGGMAP','IMPD').
reaction('2349: rn:R00491','irreversible','path:rn00250','KEGGMAP','IMPD').
reaction('2361: rn:R00490','irreversible','path:rn00250','KEGGMAP','IMPD').
reaction('2388: rn:R00093','irreversible','path:rn00250','KEGGMAP','IMPD').
reaction('2404: rn:R00576','irreversible','path:rn00250','KEGGMAP','IMPD').
reaction('41309: rn:R00238','irreversible','path:rno00620','KEGGMAP','IMPD').
reaction('41308: rn:R00710 rn:R00711','reversible','path:rno00620','KEGGMAP','IMPD').
reaction('41311: rn:R00014','irreversible','path:rno00620','KEGGMAP','IMPD').
reaction('41310: rn:R01795','irreversible','path:rno00360','KEGGMAP','IMPD').
reaction('41305: rn:R02678','irreversible','path:rno00380','KEGGMAP','IMPD').
reaction('41304: rn:R02908','irreversible','path:rno00380','KEGGMAP','IMPD').
reaction('41307: rn:R00316','reversible','path:rno00620','KEGGMAP','IMPD').
reaction('41306: rn:R00742','irreversible','path:rno00620','KEGGMAP','IMPD').
reaction('41301: rn:R02173','irreversible','path:rno00380','KEGGMAP','IMPD').
reaction('41300: rn:R04904','irreversible','path:rno00380','KEGGMAP','IMPD').
reaction('41303: rn:R04903','irreversible','path:rno00380','KEGGMAP','IMPD').
reaction('41302: rn:R04911','irreversible','path:rno00380','KEGGMAP','IMPD').
reaction('41297: rn:R02174','irreversible','path:rno00380','KEGGMAP','IMPD').
reaction('41296: rn:R01514','irreversible','path:rno00630','KEGGMAP','IMPD').
reaction('41299: rn:R02173','irreversible','path:rno00380','KEGGMAP','IMPD').
reaction('41298: rn:R02910','irreversible','path:rno00380','KEGGMAP','IMPD').
reaction('41292: rn:R04905','irreversible','path:rno00380','KEGGMAP','IMPD').
reaction('41293: rn:R03130','irreversible','path:rno00380','KEGGMAP','IMPD').
reaction('41294: rn:R02911','irreversible','path:rno00380','KEGGMAP','IMPD').
reaction('41295: rn:R01334','irreversible','path:rno00630','KEGGMAP','IMPD').
reaction('41288: rn:R02702','irreversible','path:rno00380','KEGGMAP','IMPD').
reaction('41289: rn:R04908','irreversible','path:rno00380','KEGGMAP','IMPD').
reaction('41290: rn:R04909','irreversible','path:rno00380','KEGGMAP','IMPD').
reaction('41291: rn:R02909','irreversible','path:rno00380','KEGGMAP','IMPD').
reaction('41284: rn:R00342','reversible','path:rno00630','KEGGMAP','IMPD').
reaction('41285: rn:R01959','irreversible','path:rno00380','KEGGMAP','IMPD').
reaction('41286: rn:R00238','irreversible','path:rno00380','KEGGMAP','IMPD').
reaction('41287: rn:R02701','irreversible','path:rno00380','KEGGMAP','IMPD').
reaction('41280: rn:R04323','irreversible','path:rno00380','KEGGMAP','IMPD').
reaction('41281: rn:R01933','irreversible','path:rno00380','KEGGMAP','IMPD').
reaction('41282: rn:R03026','irreversible','path:rno00380','KEGGMAP','IMPD').
reaction('41283: rn:R02488','irreversible','path:rno00380','KEGGMAP','IMPD').
reaction('41343: rn:R01167','irreversible','path:rno00340','KEGGMAP','IMPD').
reaction('41342: rn:R02914','irreversible','path:rno00340','KEGGMAP','IMPD').
reaction('41341: rn:R01074','irreversible','path:rno00780','KEGGMAP','IMPD').
reaction('41340: rn:R01168','irreversible','path:rno00340','KEGGMAP','IMPD').
reaction('41339: rn:R02287','reversible','path:rno00340','KEGGMAP','IMPD').
reaction('2712: rn:R00892','reversible','path:rn00270','KEGGMAP','IMPD').
reaction('41338: rn:R07768','irreversible','path:rno00785','KEGGMAP','IMPD').
reaction('2713: rn:R01113','irreversible','path:rn00270','KEGGMAP','IMPD').
reaction('41337: rn:R02288','irreversible','path:rno00340','KEGGMAP','IMPD').
reaction('41336: rn:R07769','irreversible','path:rno00785','KEGGMAP','IMPD').
reaction('41335: rn:R04869','irreversible','path:rno00780','KEGGMAP','IMPD').
reaction('41334: rn:R05145','irreversible','path:rno00780','KEGGMAP','IMPD').
reaction('2709: rn:R07634','irreversible','path:rn00270','KEGGMAP','IMPD').
reaction('41333: rn:R01077','irreversible','path:rno00780','KEGGMAP','IMPD').
reaction('2710: rn:R02409','reversible','path:rn00270','KEGGMAP','IMPD').
reaction('41332: rn:R05145','irreversible','path:rno00780','KEGGMAP','IMPD').
reaction('41331: rn:R05145','irreversible','path:rno00780','KEGGMAP','IMPD').
reaction('41330: rn:R01074','irreversible','path:rno00780','KEGGMAP','IMPD').
reaction('41329: rn:R01074','irreversible','path:rno00780','KEGGMAP','IMPD').
reaction('41328: rn:R07771','irreversible','path:rno00785','KEGGMAP','IMPD').
reaction('41326: rn:R07767','irreversible','path:rno00785','KEGGMAP','IMPD').
reaction('41327: rn:R07766','irreversible','path:rno00785','KEGGMAP','IMPD').
reaction('2700: rn:R07274','irreversible','path:rn00270','KEGGMAP','IMPD').
reaction('41324: rn:R00526','irreversible','path:rno00340','KEGGMAP','IMPD').
reaction('41325: rn:R01166','irreversible','path:rno00340','KEGGMAP','IMPD').
reaction('41322: rn:R01394','irreversible','path:rno00630','KEGGMAP','IMPD').
reaction('2697: rn:R08699','irreversible','path:rn00270','KEGGMAP','IMPD').
reaction('41323: rn:R01159','irreversible','path:rno00340','KEGGMAP','IMPD').
reaction('41320: rn:R02670','irreversible','path:rno00380','KEGGMAP','IMPD').
reaction('41321: rn:R01900','reversible','path:rno00630','KEGGMAP','IMPD').
reaction('41318: rn:R03629','irreversible','path:rno00380','KEGGMAP','IMPD').
reaction('41319: rn:R03628','irreversible','path:rno00380','KEGGMAP','IMPD').
reaction('41316: rn:R01975','irreversible','path:rno00380','KEGGMAP','IMPD').
reaction('41317: rn:R00677','irreversible','path:rno00380','KEGGMAP','IMPD').
reaction('2694: rn:R00901','irreversible','path:rn00270','KEGGMAP','IMPD').
reaction('41314: rn:R00317','irreversible','path:rno00620','KEGGMAP','IMPD').
reaction('2689: rn:R04860','reversible','path:rn00270','KEGGMAP','IMPD').
reaction('41315: rn:R00678','irreversible','path:rno00380','KEGGMAP','IMPD').
reaction('41312: rn:R02569','reversible','path:rno00620','KEGGMAP','IMPD').
reaction('41313: rn:R07618','reversible','path:rno00620','KEGGMAP','IMPD').
reaction('2690: rn:R00900','reversible','path:rn00270','KEGGMAP','IMPD').
reaction('41241: rn:R05947','reversible','path:rno00604','KEGGMAP','IMPD').
reaction('41240: rn:R08965','irreversible','path:rno00350','KEGGMAP','IMPD').
reaction('41243: rn:R05951','reversible','path:rno00604','KEGGMAP','IMPD').
reaction('41242: rn:R05950','reversible','path:rno00604','KEGGMAP','IMPD').
reaction('41245: rn:R05952','reversible','path:rno00604','KEGGMAP','IMPD').
reaction('41244: rn:R05953','reversible','path:rno00604','KEGGMAP','IMPD').
reaction('41247: rn:R05945','reversible','path:rno00604','KEGGMAP','IMPD').
reaction('41246: rn:R05958','reversible','path:rno00604','KEGGMAP','IMPD').
reaction('41233: rn:R05962','reversible','path:rno00603','KEGGMAP','IMPD').
reaction('41232: rn:R05967','reversible','path:rno00603','KEGGMAP','IMPD').
reaction('41235: rn:R06010','reversible','path:rno00604','KEGGMAP','IMPD').
reaction('41234: rn:R05904','reversible','path:rno00603','KEGGMAP','IMPD').
reaction('41237: rn:R05947','reversible','path:rno00604','KEGGMAP','IMPD').
reaction('41236: rn:R05949','reversible','path:rno00604','KEGGMAP','IMPD').
reaction('41239: rn:R02078','irreversible','path:rno00350','KEGGMAP','IMPD').
reaction('41238: rn:R06004','reversible','path:rno00604','KEGGMAP','IMPD').
reaction('41224: rn:R00216','reversible','path:rno00620','KEGGMAP','IMPD').
reaction('41225: rn:R00227','irreversible','path:rno00620','KEGGMAP','IMPD').
reaction('41226: rn:R00236','reversible','path:rno00620','KEGGMAP','IMPD').
reaction('41227: rn:R00703','reversible','path:rno00620','KEGGMAP','IMPD').
reaction('41228: rn:R05962','reversible','path:rno00603','KEGGMAP','IMPD').
reaction('41229: rn:R05968','reversible','path:rno00603','KEGGMAP','IMPD').
reaction('41230: rn:R05964','reversible','path:rno00603','KEGGMAP','IMPD').
reaction('41231: rn:R05960','reversible','path:rno00603','KEGGMAP','IMPD').
reaction('10371: rn:R03684','irreversible','path:rn00860','KEGGMAP','IMPD').
reaction('41216: rn:R02577','irreversible','path:rno00620','KEGGMAP','IMPD').
reaction('41217: rn:R02531','irreversible','path:rno00620','KEGGMAP','IMPD').
reaction('41218: rn:R00200 rn:R02320','irreversible','path:rno00620','KEGGMAP','IMPD').
reaction('41219: rn:R00344','irreversible','path:rno00620','KEGGMAP','IMPD').
reaction('41220: rn:R00214','reversible','path:rno00620','KEGGMAP','IMPD').
reaction('41221: rn:R00197','irreversible','path:rno00620','KEGGMAP','IMPD').
reaction('41222: rn:R01736','irreversible','path:rno00620','KEGGMAP','IMPD').
reaction('41223: rn:R00342','reversible','path:rno00620','KEGGMAP','IMPD').
reaction('41275: rn:R00987','irreversible','path:rno00380','KEGGMAP','IMPD').
reaction('41274: rn:R00475','irreversible','path:rno00630','KEGGMAP','IMPD').
reaction('41273: rn:R00988','irreversible','path:rno00380','KEGGMAP','IMPD').
reaction('41272: rn:R02668','irreversible','path:rno00380','KEGGMAP','IMPD').
reaction('41279: rn:R02665','irreversible','path:rno00380','KEGGMAP','IMPD').
reaction('41278: rn:R01959','irreversible','path:rno00630','KEGGMAP','IMPD').
reaction('41277: rn:R03936','irreversible','path:rno00380','KEGGMAP','IMPD').
reaction('41276: rn:R01960','irreversible','path:rno00380','KEGGMAP','IMPD').
reaction('41267: rn:R04171','irreversible','path:rno00380','KEGGMAP','IMPD').
reaction('41266: rn:R01956','irreversible','path:rno00380','KEGGMAP','IMPD').
reaction('41265: rn:R04907','irreversible','path:rno00380','KEGGMAP','IMPD').
reaction('41264: rn:R00351','reversible','path:rno00630','KEGGMAP','IMPD').
reaction('41271: rn:R01325','reversible','path:rno00630','KEGGMAP','IMPD').
reaction('41270: rn:R00678','irreversible','path:rno00380','KEGGMAP','IMPD').
reaction('41269: rn:R01814','irreversible','path:rno00380','KEGGMAP','IMPD').
reaction('41268: rn:R03664','irreversible','path:rno00380','KEGGMAP','IMPD').
reaction('41258: rn:R05938','reversible','path:rno00604','KEGGMAP','IMPD').
reaction('2761: rn:R04861','irreversible','path:rn00270','KEGGMAP','IMPD').
reaction('41259: rn:R05959','reversible','path:rno00604','KEGGMAP','IMPD').
reaction('41256: rn:R05941','reversible','path:rno00604','KEGGMAP','IMPD').
reaction('41257: rn:R05956','reversible','path:rno00604','KEGGMAP','IMPD').
reaction('41262: rn:R05957','reversible','path:rno00604','KEGGMAP','IMPD').
reaction('41263: rn:R00685','irreversible','path:rno00380','KEGGMAP','IMPD').
reaction('41260: rn:R01364','irreversible','path:rno00350','KEGGMAP','IMPD').
reaction('41261: rn:R05946','reversible','path:rno00604','KEGGMAP','IMPD').
reaction('41250: rn:R05940','reversible','path:rno00604','KEGGMAP','IMPD').
reaction('41251: rn:R05959','reversible','path:rno00604','KEGGMAP','IMPD').
reaction('41248: rn:R05943','reversible','path:rno00604','KEGGMAP','IMPD').
reaction('41249: rn:R05959','reversible','path:rno00604','KEGGMAP','IMPD').
reaction('41254: rn:R05948','reversible','path:rno00604','KEGGMAP','IMPD').
reaction('41255: rn:R05939','reversible','path:rno00604','KEGGMAP','IMPD').
reaction('41252: rn:R05937','reversible','path:rno00604','KEGGMAP','IMPD').
reaction('2759: rn:R00863','irreversible','path:rn00270','KEGGMAP','IMPD').
reaction('41253: rn:R05942','reversible','path:rno00604','KEGGMAP','IMPD').
reaction('41428: rn:R00032','irreversible','path:rno00830','KEGGMAP','IMPD').
reaction('41429: rn:R04893','irreversible','path:rno00350','KEGGMAP','IMPD').
reaction('41430: rn:R02123','irreversible','path:rno00830','KEGGMAP','IMPD').
reaction('2613: rn:R04861','irreversible','path:rn00270','KEGGMAP','IMPD').
reaction('41431: rn:R02519','irreversible','path:rno00350','KEGGMAP','IMPD').
reaction('41424: rn:R02920','irreversible','path:rno00350','KEGGMAP','IMPD').
reaction('41425: rn:R08387','irreversible','path:rno00830','KEGGMAP','IMPD').
reaction('41426: rn:R04891 rn:R04892','irreversible','path:rno00350','KEGGMAP','IMPD').
reaction('41427: rn:R02532','irreversible','path:rno00350','KEGGMAP','IMPD').
reaction('41436: rn:R03973','irreversible','path:rno00350','KEGGMAP','IMPD').
reaction('41437: rn:R09395','irreversible','path:rno00790','KEGGMAP','IMPD').
reaction('41438: rn:R03953','irreversible','path:rno00350','KEGGMAP','IMPD').
reaction('41439: rn:R04620','irreversible','path:rno00790','KEGGMAP','IMPD').
reaction('41432: rn:R03181','irreversible','path:rno00350','KEGGMAP','IMPD').
reaction('41433: rn:R02124','reversible','path:rno00830','KEGGMAP','IMPD').
reaction('2618: rn:R00179','irreversible','path:rn00270','KEGGMAP','IMPD').
reaction('41434: rn:R09394','irreversible','path:rno00790','KEGGMAP','IMPD').
reaction('41435: rn:R03539','irreversible','path:rno00350','KEGGMAP','IMPD').
reaction('41413: rn:R02535','irreversible','path:rno00350','KEGGMAP','IMPD').
reaction('41412: rn:R02919','irreversible','path:rno00350','KEGGMAP','IMPD').
reaction('2599: rn:R01800','irreversible','path:rn00260','KEGGMAP','IMPD').
reaction('41415: rn:R04894','irreversible','path:rno00350','KEGGMAP','IMPD').
reaction('41414: rn:R07163','irreversible','path:rno00830','KEGGMAP','IMPD').
reaction('2597: rn:R01566','irreversible','path:rn00260','KEGGMAP','IMPD').
reaction('41409: rn:R08382 rn:R08383','reversible','path:rno00830','KEGGMAP','IMPD').
reaction('41408: rn:R00736','irreversible','path:rno00350','KEGGMAP','IMPD').
reaction('41411: rn:R08381','irreversible','path:rno00830','KEGGMAP','IMPD').
reaction('41410: rn:R08389','irreversible','path:rno00830','KEGGMAP','IMPD').
reaction('41421: rn:R04887','reversible','path:rno00350','KEGGMAP','IMPD').
reaction('41420: rn:R04881','irreversible','path:rno00350','KEGGMAP','IMPD').
reaction('41423: rn:R02534','irreversible','path:rno00350','KEGGMAP','IMPD').
reaction('10317: rn:R02369','irreversible','path:rn00830','KEGGMAP','IMPD').
reaction('41422: rn:R04882 rn:R04883','reversible','path:rno00350','KEGGMAP','IMPD').
reaction('41417: rn:R02533','irreversible','path:rno00350','KEGGMAP','IMPD').
reaction('2602: rn:R02722','irreversible','path:rn00260','KEGGMAP','IMPD').
reaction('41416: rn:R08388','irreversible','path:rno00830','KEGGMAP','IMPD').
reaction('41419: rn:R03048 rn:R08380','reversible','path:rno00830','KEGGMAP','IMPD').
reaction('41418: rn:R04880','reversible','path:rno00350','KEGGMAP','IMPD').
reaction('10357: rn:R02126','irreversible','path:rn00830','KEGGMAP','IMPD').
reaction('41462: rn:R01709','irreversible','path:rno00750','KEGGMAP','IMPD').
reaction('41463: rn:R00160','irreversible','path:rno00740','KEGGMAP','IMPD').
reaction('41460: rn:R04285','irreversible','path:rno00790','KEGGMAP','IMPD').
reaction('41461: rn:R03673','irreversible','path:rno00350','KEGGMAP','IMPD').
reaction('41458: rn:R02235 rn:R02236','reversible','path:rno00790','KEGGMAP','IMPD').
reaction('41459: rn:R00942','reversible','path:rno00790','KEGGMAP','IMPD').
reaction('41456: rn:R01793 rn:R01794','reversible','path:rno00790','KEGGMAP','IMPD').
reaction('41457: rn:R00936 rn:R00939','reversible','path:rno00790','KEGGMAP','IMPD').
reaction('41470: rn:R00615','irreversible','path:rno00730','KEGGMAP','IMPD').
reaction('41471: rn:R03283','irreversible','path:rno00310','KEGGMAP','IMPD').
reaction('41468: rn:R00238','irreversible','path:rno00310','KEGGMAP','IMPD').
reaction('41469: rn:R02488','irreversible','path:rno00310','KEGGMAP','IMPD').
reaction('41466: rn:R00161','irreversible','path:rno00740','KEGGMAP','IMPD').
reaction('41467: rn:R00549','irreversible','path:rno00740','KEGGMAP','IMPD').
reaction('41464: rn:R02363','irreversible','path:rno00740','KEGGMAP','IMPD').
reaction('41465: rn:R00548','irreversible','path:rno00740','KEGGMAP','IMPD').
reaction('41447: rn:R05046','irreversible','path:rno00790','KEGGMAP','IMPD').
reaction('41446: rn:R04888 rn:R04889','irreversible','path:rno00350','KEGGMAP','IMPD').
reaction('41445: rn:R00428','irreversible','path:rno00790','KEGGMAP','IMPD').
reaction('41444: rn:R04301','irreversible','path:rno00350','KEGGMAP','IMPD').
reaction('41443: rn:R04286','irreversible','path:rno00790','KEGGMAP','IMPD').
reaction('41442: rn:R04890','irreversible','path:rno00350','KEGGMAP','IMPD').
reaction('41441: rn:R04242','irreversible','path:rno00790','KEGGMAP','IMPD').
reaction('41440: rn:R02080','irreversible','path:rno00350','KEGGMAP','IMPD').
reaction('41455: rn:R01813','irreversible','path:rno00790','KEGGMAP','IMPD').
reaction('41454: rn:R05048','irreversible','path:rno00790','KEGGMAP','IMPD').
reaction('41453: rn:R04639','irreversible','path:rno00790','KEGGMAP','IMPD').
reaction('41452: rn:R03300 rn:R03302','reversible','path:rno00350','KEGGMAP','IMPD').
reaction('41451: rn:R00937 rn:R00940','irreversible','path:rno00790','KEGGMAP','IMPD').
reaction('41450: rn:R03304','irreversible','path:rno00350','KEGGMAP','IMPD').
reaction('41449: rn:R02237','irreversible','path:rno00790','KEGGMAP','IMPD').
reaction('41448: rn:R04300','irreversible','path:rno00350','KEGGMAP','IMPD').
reaction('41360: rn:R03269','irreversible','path:rno00770','KEGGMAP','IMPD').
reaction('41361: rn:R00130','irreversible','path:rno00770','KEGGMAP','IMPD').
reaction('41362: rn:R02269','irreversible','path:rno00770','KEGGMAP','IMPD').
reaction('41363: rn:R00978','reversible','path:rno00770','KEGGMAP','IMPD').
reaction('41364: rn:R02869','irreversible','path:rno00330','KEGGMAP','IMPD').
reaction('41365: rn:R04391','irreversible','path:rno00770','KEGGMAP','IMPD').
reaction('41366: rn:R04230 rn:R04231','irreversible','path:rno00770','KEGGMAP','IMPD').
reaction('41367: rn:R03018','irreversible','path:rno00770','KEGGMAP','IMPD').
reaction('41368: rn:R00905','irreversible','path:rno00770','KEGGMAP','IMPD').
reaction('41369: rn:R01154','irreversible','path:rno00330','KEGGMAP','IMPD').
reaction('41370: rn:R02869','irreversible','path:rno00330','KEGGMAP','IMPD').
reaction('41371: rn:R05050','irreversible','path:rno00330','KEGGMAP','IMPD').
reaction('41372: rn:R04025','irreversible','path:rno00330','KEGGMAP','IMPD').
reaction('41373: rn:R00243 rn:R00248','reversible','path:rno00330','KEGGMAP','IMPD').
reaction('41374: rn:R00557','reversible','path:rno00330','KEGGMAP','IMPD').
reaction('41375: rn:R04300','irreversible','path:rno00350','KEGGMAP','IMPD').
reaction('41345: rn:R04065','irreversible','path:rno00340','KEGGMAP','IMPD').
reaction('41344: rn:R01167','irreversible','path:rno00340','KEGGMAP','IMPD').
reaction('41347: rn:R04996','irreversible','path:rno00340','KEGGMAP','IMPD').
reaction('41346: rn:R04674','irreversible','path:rno00340','KEGGMAP','IMPD').
reaction('41349: rn:R02155','irreversible','path:rno00340','KEGGMAP','IMPD').
reaction('41348: rn:R02150','irreversible','path:rno00340','KEGGMAP','IMPD').
reaction('41351: rn:R05145','irreversible','path:rno00780','KEGGMAP','IMPD').
reaction('41350: rn:R01074','irreversible','path:rno00780','KEGGMAP','IMPD').
reaction('41353: rn:R02973','irreversible','path:rno00770','KEGGMAP','IMPD').
reaction('41352: rn:R01214','reversible','path:rno00770','KEGGMAP','IMPD').
reaction('41355: rn:R03035','reversible','path:rno00770','KEGGMAP','IMPD').
reaction('41354: rn:R00707 rn:R00708','irreversible','path:rno00330','KEGGMAP','IMPD').
reaction('41357: rn:R01625','irreversible','path:rno00770','KEGGMAP','IMPD').
reaction('41356: rn:R04221','irreversible','path:rno00330','KEGGMAP','IMPD').
reaction('41359: rn:R02971','irreversible','path:rno00770','KEGGMAP','IMPD').
reaction('41358: rn:R03036','reversible','path:rno00770','KEGGMAP','IMPD').
reaction('41394: rn:R00734','reversible','path:rno00350','KEGGMAP','IMPD').
reaction('41395: rn:R08390','irreversible','path:rno00830','KEGGMAP','IMPD').
reaction('41392: rn:R00729','irreversible','path:rno00350','KEGGMAP','IMPD').
reaction('41393: rn:R08390','irreversible','path:rno00830','KEGGMAP','IMPD').
reaction('41398: rn:R02521','irreversible','path:rno00350','KEGGMAP','IMPD').
reaction('41399: rn:R02124 rn:R08379','reversible','path:rno00830','KEGGMAP','IMPD').
reaction('41396: rn:R00734','reversible','path:rno00350','KEGGMAP','IMPD').
reaction('41397: rn:R03342','reversible','path:rno00350','KEGGMAP','IMPD').
reaction('41402: rn:R02382','irreversible','path:rno00350','KEGGMAP','IMPD').
reaction('41403: rn:R08392','irreversible','path:rno00830','KEGGMAP','IMPD').
reaction('41400: rn:R02695 rn:R02697','reversible','path:rno00350','KEGGMAP','IMPD').
reaction('41401: rn:R02124 rn:R08379','reversible','path:rno00830','KEGGMAP','IMPD').
reaction('41406: rn:R08392','irreversible','path:rno00830','KEGGMAP','IMPD').
reaction('7021: rn:R03415','irreversible','path:rn00565','KEGGMAP','IMPD').
reaction('41407: rn:R08392','irreversible','path:rno00830','KEGGMAP','IMPD').
reaction('7020: rn:R04571','irreversible','path:rn00565','KEGGMAP','IMPD').
reaction('41404: rn:R02382','irreversible','path:rno00350','KEGGMAP','IMPD').
reaction('41405: rn:R02657','irreversible','path:rno00350','KEGGMAP','IMPD').
reaction('41379: rn:R02902','irreversible','path:rno00830','KEGGMAP','IMPD').
reaction('41378: rn:R08383','reversible','path:rno00830','KEGGMAP','IMPD').
reaction('41377: rn:R08392','irreversible','path:rno00830','KEGGMAP','IMPD').
reaction('41376: rn:R03943','irreversible','path:rno00350','KEGGMAP','IMPD').
reaction('41383: rn:R04884','irreversible','path:rno00350','KEGGMAP','IMPD').
reaction('41382: rn:R08391','irreversible','path:rno00830','KEGGMAP','IMPD').
reaction('7029: rn:R07382','irreversible','path:rn00565','KEGGMAP','IMPD').
reaction('41381: rn:R02368','irreversible','path:rno00830','KEGGMAP','IMPD').
reaction('7030: rn:R07383','irreversible','path:rn00565','KEGGMAP','IMPD').
reaction('41380: rn:R08385','irreversible','path:rno00830','KEGGMAP','IMPD').
reaction('41387: rn:R03208','irreversible','path:rno00350','KEGGMAP','IMPD').
reaction('10281: rn:R00131','irreversible','path:rn00791','KEGGMAP','IMPD').
reaction('41386: rn:R08390','irreversible','path:rno00830','KEGGMAP','IMPD').
reaction('41385: rn:R02078','irreversible','path:rno00350','KEGGMAP','IMPD').
reaction('41384: rn:R08390','irreversible','path:rno00830','KEGGMAP','IMPD').
reaction('41391: rn:R00731','irreversible','path:rno00350','KEGGMAP','IMPD').
reaction('41390: rn:R08390','irreversible','path:rno00830','KEGGMAP','IMPD').
reaction('41389: rn:R01815','irreversible','path:rno00350','KEGGMAP','IMPD').
reaction('41388: rn:R08391','irreversible','path:rno00830','KEGGMAP','IMPD').
reaction('41038: rn:R02581','irreversible','path:rno00590','KEGGMAP','IMPD').
reaction('41039: rn:R02266','irreversible','path:rno00590','KEGGMAP','IMPD').
reaction('41036: rn:R00431 rn:R00726','irreversible','path:rno00020','KEGGMAP','IMPD').
reaction('41037: rn:R00945','reversible','path:rno00460','KEGGMAP','IMPD').
reaction('41034: rn:R01641','reversible','path:rno00030','KEGGMAP','IMPD').
reaction('41035: rn:R01051','reversible','path:rno00030','KEGGMAP','IMPD').
reaction('41032: rn:R02750','reversible','path:rno00030','KEGGMAP','IMPD').
reaction('41033: rn:R01049','reversible','path:rno00030','KEGGMAP','IMPD').
reaction('10693: rn:R08375','irreversible','path:rn00900','KEGGMAP','IMPD').
reaction('41030: rn:R00014','irreversible','path:rno00020','KEGGMAP','IMPD').
reaction('41031: rn:R01317','reversible','path:rno00590','KEGGMAP','IMPD').
reaction('41028: rn:R01595','irreversible','path:rno00590','KEGGMAP','IMPD').
reaction('41029: rn:R00073','irreversible','path:rno00590','KEGGMAP','IMPD').
reaction('41026: rn:R07034','irreversible','path:rno00590','KEGGMAP','IMPD').
reaction('41027: rn:R03058','irreversible','path:rno00590','KEGGMAP','IMPD').
reaction('41024: rn:R01596','irreversible','path:rno00590','KEGGMAP','IMPD').
reaction('41025: rn:R01593','irreversible','path:rno00590','KEGGMAP','IMPD').
reaction('41055: rn:R04780','irreversible','path:rno00030','KEGGMAP','IMPD').
reaction('41054: rn:R04779','irreversible','path:rno00030','KEGGMAP','IMPD').
reaction('41053: rn:R03970','irreversible','path:rno00460','KEGGMAP','IMPD').
reaction('41052: rn:R02740','reversible','path:rno00030','KEGGMAP','IMPD').
reaction('41051: rn:R01529','reversible','path:rno00030','KEGGMAP','IMPD').
reaction('41050: rn:R01056','reversible','path:rno00030','KEGGMAP','IMPD').
reaction('41049: rn:R01070','reversible','path:rno00030','KEGGMAP','IMPD').
reaction('41048: rn:R01830','reversible','path:rno00030','KEGGMAP','IMPD').
reaction('41047: rn:R03971','irreversible','path:rno00460','KEGGMAP','IMPD').
reaction('41046: rn:R07050','irreversible','path:rno00590','KEGGMAP','IMPD').
reaction('41045: rn:R07051','irreversible','path:rno00590','KEGGMAP','IMPD').
reaction('41044: rn:R07052','irreversible','path:rno00590','KEGGMAP','IMPD').
reaction('41043: rn:R01528','irreversible','path:rno00030','KEGGMAP','IMPD').
reaction('41042: rn:R02736','irreversible','path:rno00030','KEGGMAP','IMPD').
reaction('41041: rn:R02035','reversible','path:rno00030','KEGGMAP','IMPD').
reaction('41040: rn:R02739','reversible','path:rno00030','KEGGMAP','IMPD').
reaction('41068: rn:R07045','irreversible','path:rno00590','KEGGMAP','IMPD').
reaction('41069: rn:R01519','irreversible','path:rno00030','KEGGMAP','IMPD').
reaction('6846: rn:R05381','irreversible','path:rn00564','KEGGMAP','IMPD').
reaction('41070: rn:R04929','irreversible','path:rno00450','KEGGMAP','IMPD').
reaction('2957: rn:R04673','irreversible','path:rn00290','KEGGMAP','IMPD').
reaction('41071: rn:R07054','irreversible','path:rno00590','KEGGMAP','IMPD').
reaction('41064: rn:R07044','irreversible','path:rno00590','KEGGMAP','IMPD').
reaction('41065: rn:R07048','irreversible','path:rno00590','KEGGMAP','IMPD').
reaction('41066: rn:R07042','irreversible','path:rno00590','KEGGMAP','IMPD').
reaction('41067: rn:R09366','irreversible','path:rno00450','KEGGMAP','IMPD').
reaction('41060: rn:R07046','irreversible','path:rno00590','KEGGMAP','IMPD').
reaction('41061: rn:R07041','irreversible','path:rno00590','KEGGMAP','IMPD').
reaction('41062: rn:R07041','irreversible','path:rno00590','KEGGMAP','IMPD').
reaction('41063: rn:R01057','reversible','path:rno00030','KEGGMAP','IMPD').
reaction('41056: rn:R01827','reversible','path:rno00030','KEGGMAP','IMPD').
reaction('41057: rn:R07041','irreversible','path:rno00590','KEGGMAP','IMPD').
reaction('41058: rn:R07046','irreversible','path:rno00590','KEGGMAP','IMPD').
reaction('41059: rn:R07035','irreversible','path:rno00590','KEGGMAP','IMPD').
reaction('41085: rn:R00256','irreversible','path:rno00471','KEGGMAP','IMPD').
reaction('41084: rn:R01478','irreversible','path:rno00040','KEGGMAP','IMPD').
reaction('41087: rn:R07046','irreversible','path:rno00590','KEGGMAP','IMPD').
reaction('41086: rn:R01579','irreversible','path:rno00471','KEGGMAP','IMPD').
reaction('41081: rn:R02923','irreversible','path:rno00472','KEGGMAP','IMPD').
reaction('41080: rn:R03626','irreversible','path:rno00591','KEGGMAP','IMPD').
reaction('41083: rn:R00243 rn:R00248','reversible','path:rno00471','KEGGMAP','IMPD').
reaction('41082: rn:R02457','irreversible','path:rno00472','KEGGMAP','IMPD').
reaction('41077: rn:R02736 rn:R02035','irreversible','path:rno00030','KEGGMAP','IMPD').
reaction('41076: rn:R07053','irreversible','path:rno00590','KEGGMAP','IMPD').
reaction('41079: rn:R07064','irreversible','path:rno00591','KEGGMAP','IMPD').
reaction('41078: rn:R07056','irreversible','path:rno00591','KEGGMAP','IMPD').
reaction('41073: rn:R07043','irreversible','path:rno00590','KEGGMAP','IMPD').
reaction('41072: rn:R09372','irreversible','path:rno00450','KEGGMAP','IMPD').
reaction('41075: rn:R07038','irreversible','path:rno00590','KEGGMAP','IMPD').
reaction('41074: rn:R09365','irreversible','path:rno00450','KEGGMAP','IMPD').
reaction('40970: rn:R00268','reversible','path:rno00020','KEGGMAP','IMPD').
reaction('40971: rn:R00352','reversible','path:rno00020','KEGGMAP','IMPD').
reaction('40968: rn:R09373','irreversible','path:rno00450','KEGGMAP','IMPD').
reaction('40969: rn:R00709','reversible','path:rno00020','KEGGMAP','IMPD').
reaction('40974: rn:R03316','irreversible','path:rno00020','KEGGMAP','IMPD').
reaction('6877: rn:R02054','irreversible','path:rn00564','KEGGMAP','IMPD').
reaction('40975: rn:R00432 rn:R00727','reversible','path:rno00020','KEGGMAP','IMPD').
reaction('40972: rn:R01899','reversible','path:rno00020','KEGGMAP','IMPD').
reaction('40973: rn:R02570','reversible','path:rno00020','KEGGMAP','IMPD').
reaction('40962: rn:R03599','reversible','path:rno00450','KEGGMAP','IMPD').
reaction('40963: rn:R08224','irreversible','path:rno00450','KEGGMAP','IMPD').
reaction('40960: rn:R01516','reversible','path:rno00010','KEGGMAP','IMPD').
reaction('40961: rn:R01662','reversible','path:rno00010','KEGGMAP','IMPD').
reaction('40966: rn:R07111','irreversible','path:rno00590','KEGGMAP','IMPD').
reaction('6869: rn:R01470','irreversible','path:rn00564','KEGGMAP','IMPD').
reaction('40967: rn:R07110','irreversible','path:rno00590','KEGGMAP','IMPD').
reaction('40964: rn:R07109','irreversible','path:rno00590','KEGGMAP','IMPD').
reaction('40965: rn:R07108','irreversible','path:rno00590','KEGGMAP','IMPD').
reaction('6870: rn:R01800','irreversible','path:rn00564','KEGGMAP','IMPD').
reaction('40987: rn:R00342','reversible','path:rno00020','KEGGMAP','IMPD').
reaction('40986: rn:R00351','reversible','path:rno00020','KEGGMAP','IMPD').
reaction('10650: rn:R05636','irreversible','path:rn00900','KEGGMAP','IMPD').
reaction('40985: rn:R00344','irreversible','path:rno00020','KEGGMAP','IMPD').
reaction('40984: rn:R03595','reversible','path:rno00450','KEGGMAP','IMPD').
reaction('40991: rn:R01082','reversible','path:rno00020','KEGGMAP','IMPD').
reaction('40990: rn:R02164','reversible','path:rno00020','KEGGMAP','IMPD').
reaction('6861: rn:R01316','irreversible','path:rn00564','KEGGMAP','IMPD').
reaction('40989: rn:R01325','reversible','path:rno00020','KEGGMAP','IMPD').
reaction('40988: rn:R01900','reversible','path:rno00020','KEGGMAP','IMPD').
reaction('6863: rn:R02027','irreversible','path:rn00564','KEGGMAP','IMPD').
reaction('40979: rn:R09086','reversible','path:rno00010','KEGGMAP','IMPD').
reaction('40978: rn:R07618','reversible','path:rno00020','KEGGMAP','IMPD').
reaction('6849: rn:R05794','irreversible','path:rn00564','KEGGMAP','IMPD').
reaction('40977: rn:R00621','irreversible','path:rno00020','KEGGMAP','IMPD').
reaction('40976: rn:R00405','reversible','path:rno00020','KEGGMAP','IMPD').
reaction('6851: rn:R01319','irreversible','path:rn00564','KEGGMAP','IMPD').
reaction('40983: rn:R03596','irreversible','path:rno00450','KEGGMAP','IMPD').
reaction('40982: rn:R04162','irreversible','path:rno00565','KEGGMAP','IMPD').
reaction('40981: rn:R04311','irreversible','path:rno00565','KEGGMAP','IMPD').
reaction('40980: rn:R04773','irreversible','path:rno00450','KEGGMAP','IMPD').
reaction('41000: rn:R02466','irreversible','path:rno00430','KEGGMAP','IMPD').
reaction('6907: rn:R01030','irreversible','path:rn00564','KEGGMAP','IMPD').
reaction('41001: rn:R07387','irreversible','path:rno00565','KEGGMAP','IMPD').
reaction('6906: rn:R04864','irreversible','path:rn00564','KEGGMAP','IMPD').
reaction('41002: rn:R02466','irreversible','path:rno00430','KEGGMAP','IMPD').
reaction('6905: rn:R01470','irreversible','path:rn00564','KEGGMAP','IMPD').
reaction('41003: rn:R07379','irreversible','path:rno00565','KEGGMAP','IMPD').
reaction('41004: rn:R02467','irreversible','path:rno00430','KEGGMAP','IMPD').
reaction('41005: rn:R03437','irreversible','path:rno00565','KEGGMAP','IMPD').
reaction('41006: rn:R00893','irreversible','path:rno00430','KEGGMAP','IMPD').
reaction('41007: rn:R06364','irreversible','path:rno00565','KEGGMAP','IMPD').
reaction('40992: rn:R07380','irreversible','path:rno00565','KEGGMAP','IMPD').
reaction('40993: rn:R07388','irreversible','path:rno00565','KEGGMAP','IMPD').
reaction('40994: rn:R07384','reversible','path:rno00565','KEGGMAP','IMPD').
reaction('40995: rn:R04413','irreversible','path:rno00565','KEGGMAP','IMPD').
reaction('6896: rn:R02756','irreversible','path:rn00564','KEGGMAP','IMPD').
reaction('40996: rn:R03720','irreversible','path:rno00430','KEGGMAP','IMPD').
reaction('40997: rn:R07385','irreversible','path:rno00565','KEGGMAP','IMPD').
reaction('40998: rn:R01687','irreversible','path:rno00430','KEGGMAP','IMPD').
reaction('40999: rn:R03438','irreversible','path:rno00565','KEGGMAP','IMPD').
reaction('41017: rn:R07618','reversible','path:rno00020','KEGGMAP','IMPD').
reaction('41016: rn:R03057','irreversible','path:rno00590','KEGGMAP','IMPD').
reaction('3035: rn:R00271','irreversible','path:rn00300','KEGGMAP','IMPD').
reaction('41019: rn:R02265','irreversible','path:rno00590','KEGGMAP','IMPD').
reaction('41018: rn:R03866','irreversible','path:rno00590','KEGGMAP','IMPD').
reaction('41021: rn:R02268','irreversible','path:rno00590','KEGGMAP','IMPD').
reaction('41020: rn:R02569','reversible','path:rno00020','KEGGMAP','IMPD').
reaction('41023: rn:R02267','irreversible','path:rno00590','KEGGMAP','IMPD').
reaction('41022: rn:R01590','irreversible','path:rno00590','KEGGMAP','IMPD').
reaction('41009: rn:R04321','irreversible','path:rno00565','KEGGMAP','IMPD').
reaction('41008: rn:R01682','irreversible','path:rno00430','KEGGMAP','IMPD').
reaction('3027: rn:R00457','reversible','path:rn00300','KEGGMAP','IMPD').
reaction('41011: rn:R04452','irreversible','path:rno00565','KEGGMAP','IMPD').
reaction('41010: rn:R01682','irreversible','path:rno00430','KEGGMAP','IMPD').
reaction('41013: rn:R03059','irreversible','path:rno00590','KEGGMAP','IMPD').
reaction('6886: rn:R02029','irreversible','path:rn00564','KEGGMAP','IMPD').
reaction('41012: rn:R07389','irreversible','path:rno00565','KEGGMAP','IMPD').
reaction('6887: rn:R01030','irreversible','path:rn00564','KEGGMAP','IMPD').
reaction('41015: rn:R03867','irreversible','path:rno00590','KEGGMAP','IMPD').
reaction('41014: rn:R03270','irreversible','path:rno00020','KEGGMAP','IMPD').
reaction('6885: rn:R00749','reversible','path:rn00564','KEGGMAP','IMPD').
reaction('41159: rn:R02301','irreversible','path:rno00670','KEGGMAP','IMPD').
reaction('41158: rn:R00904','irreversible','path:rno00410','KEGGMAP','IMPD').
reaction('41157: rn:R04325','reversible','path:rno00670','KEGGMAP','IMPD').
reaction('41156: rn:R00943','irreversible','path:rno00670','KEGGMAP','IMPD').
reaction('41155: rn:R00941','irreversible','path:rno00670','KEGGMAP','IMPD').
reaction('41154: rn:R00978','reversible','path:rno00410','KEGGMAP','IMPD').
reaction('41153: rn:R02269','reversible','path:rno00410','KEGGMAP','IMPD').
reaction('41152: rn:R00905','reversible','path:rno00410','KEGGMAP','IMPD').
reaction('41167: rn:R03189','irreversible','path:rno00670','KEGGMAP','IMPD').
reaction('41166: rn:R01218','reversible','path:rno00670','KEGGMAP','IMPD').
reaction('41165: rn:R00936 rn:R00939','reversible','path:rno00670','KEGGMAP','IMPD').
reaction('41164: rn:R01220','reversible','path:rno00670','KEGGMAP','IMPD').
reaction('41163: rn:R01655','reversible','path:rno00670','KEGGMAP','IMPD').
reaction('41162: rn:R01224 rn:R07168','irreversible','path:rno00670','KEGGMAP','IMPD').
reaction('41161: rn:R03940','irreversible','path:rno00670','KEGGMAP','IMPD').
reaction('41160: rn:R02300','irreversible','path:rno00670','KEGGMAP','IMPD').
reaction('41174: rn:R01975','reversible','path:rno00650','KEGGMAP','IMPD').
reaction('41175: rn:R00694','reversible','path:rno00400','KEGGMAP','IMPD').
reaction('41172: rn:R01648','reversible','path:rno00650','KEGGMAP','IMPD').
reaction('10582: rn:R03166','irreversible','path:rn00860','KEGGMAP','IMPD').
reaction('41173: rn:R00261','irreversible','path:rno00650','KEGGMAP','IMPD').
reaction('41170: rn:R02302','reversible','path:rno00670','KEGGMAP','IMPD').
reaction('41171: rn:R04326','irreversible','path:rno00670','KEGGMAP','IMPD').
reaction('41168: rn:R02235 rn:R02236','reversible','path:rno00670','KEGGMAP','IMPD').
reaction('41169: rn:R02287','reversible','path:rno00670','KEGGMAP','IMPD').
reaction('41182: rn:R01357','irreversible','path:rno00650','KEGGMAP','IMPD').
reaction('41183: rn:R00410','reversible','path:rno00650','KEGGMAP','IMPD').
reaction('41180: rn:R01978','irreversible','path:rno00650','KEGGMAP','IMPD').
reaction('41181: rn:R01360','irreversible','path:rno00650','KEGGMAP','IMPD').
reaction('41178: rn:R03026','reversible','path:rno00650','KEGGMAP','IMPD').
reaction('41179: rn:R01361','reversible','path:rno00650','KEGGMAP','IMPD').
reaction('41176: rn:R00238','reversible','path:rno00650','KEGGMAP','IMPD').
reaction('41177: rn:R00734','reversible','path:rno00400','KEGGMAP','IMPD').
reaction('41189: rn:R00489','irreversible','path:rno00410','KEGGMAP','IMPD').
reaction('6710: rn:R03478','irreversible','path:rn00562','KEGGMAP','IMPD').
reaction('41188: rn:R02869','irreversible','path:rno00410','KEGGMAP','IMPD').
reaction('41191: rn:R03139','irreversible','path:rno00410','KEGGMAP','IMPD').
reaction('41190: rn:R00904','irreversible','path:rno00410','KEGGMAP','IMPD').
reaction('41185: rn:R00014','irreversible','path:rno00650','KEGGMAP','IMPD').
reaction('41184: rn:R03534','irreversible','path:rno00650','KEGGMAP','IMPD').
reaction('41187: rn:R02869','irreversible','path:rno00410','KEGGMAP','IMPD').
reaction('41186: rn:R00924','reversible','path:rno00410','KEGGMAP','IMPD').
reaction('41197: rn:R00908','reversible','path:rno00410','KEGGMAP','IMPD').
reaction('41196: rn:R00713','irreversible','path:rno00650','KEGGMAP','IMPD').
reaction('41199: rn:R05959','reversible','path:rno00604','KEGGMAP','IMPD').
reaction('41198: rn:R01176','irreversible','path:rno00650','KEGGMAP','IMPD').
reaction('41193: rn:R00233','irreversible','path:rno00410','KEGGMAP','IMPD').
reaction('41192: rn:R01171','reversible','path:rno00650','KEGGMAP','IMPD').
reaction('41195: rn:R03045','reversible','path:rno00410','KEGGMAP','IMPD').
reaction('41194: rn:R03158','reversible','path:rno00410','KEGGMAP','IMPD').
reaction('41204: rn:R00689','irreversible','path:rno00360','KEGGMAP','IMPD').
reaction('2839: rn:R08567','irreversible','path:rn00280','KEGGMAP','IMPD').
reaction('41205: rn:R05937','reversible','path:rno00604','KEGGMAP','IMPD').
reaction('2838: rn:R07160','irreversible','path:rn00280','KEGGMAP','IMPD').
reaction('41206: rn:R03270','irreversible','path:rno00620','KEGGMAP','IMPD').
reaction('2837: rn:R08566','irreversible','path:rn00280','KEGGMAP','IMPD').
reaction('41207: rn:R05947','reversible','path:rno00604','KEGGMAP','IMPD').
reaction('41200: rn:R01378','reversible','path:rno00360','KEGGMAP','IMPD').
reaction('41201: rn:R00694','reversible','path:rno00360','KEGGMAP','IMPD').
reaction('41202: rn:R00694','reversible','path:rno00360','KEGGMAP','IMPD').
reaction('41203: rn:R00698','irreversible','path:rno00360','KEGGMAP','IMPD').
reaction('41212: rn:R02613','reversible','path:rno00360','KEGGMAP','IMPD').
reaction('41213: rn:R02613','reversible','path:rno00360','KEGGMAP','IMPD').
reaction('41214: rn:R00699','irreversible','path:rno00360','KEGGMAP','IMPD').
reaction('41215: rn:R02530','reversible','path:rno00620','KEGGMAP','IMPD').
reaction('41208: rn:R05940','reversible','path:rno00604','KEGGMAP','IMPD').
reaction('41209: rn:R02536 rn:R02537','reversible','path:rno00360','KEGGMAP','IMPD').
reaction('41210: rn:R00431 rn:R00726','reversible','path:rno00620','KEGGMAP','IMPD').
reaction('41211: rn:R01372','irreversible','path:rno00360','KEGGMAP','IMPD').
reaction('41091: rn:R07888','irreversible','path:rno00592','KEGGMAP','IMPD').
reaction('41090: rn:R01529','reversible','path:rno00040','KEGGMAP','IMPD').
reaction('41089: rn:R01639','reversible','path:rno00040','KEGGMAP','IMPD').
reaction('41088: rn:R07055','irreversible','path:rno00591','KEGGMAP','IMPD').
reaction('41095: rn:R07861','irreversible','path:rno00592','KEGGMAP','IMPD').
reaction('41094: rn:R01431','reversible','path:rno00040','KEGGMAP','IMPD').
reaction('41093: rn:R01758 rn:R01759','reversible','path:rno00040','KEGGMAP','IMPD').
reaction('41092: rn:R01904','reversible','path:rno00040','KEGGMAP','IMPD').
reaction('41099: rn:R07859','irreversible','path:rno00592','KEGGMAP','IMPD').
reaction('41098: rn:R01383','reversible','path:rno00040','KEGGMAP','IMPD').
reaction('41097: rn:R02640','reversible','path:rno00040','KEGGMAP','IMPD').
reaction('41096: rn:R00289','irreversible','path:rno00040','KEGGMAP','IMPD').
reaction('41103: rn:R00115','irreversible','path:rno00480','KEGGMAP','IMPD').
reaction('41102: rn:R01528','irreversible','path:rno00480','KEGGMAP','IMPD').
reaction('2925: rn:R07399','irreversible','path:rn00290','KEGGMAP','IMPD').
reaction('41101: rn:R00670','irreversible','path:rno00480','KEGGMAP','IMPD').
reaction('41100: rn:R00286','reversible','path:rno00040','KEGGMAP','IMPD').
reaction('41106: rn:R03522','irreversible','path:rno00480','KEGGMAP','IMPD').
reaction('41107: rn:R07896','irreversible','path:rno00592','KEGGMAP','IMPD').
reaction('2928: rn:R00996','irreversible','path:rn00290','KEGGMAP','IMPD').
reaction('41104: rn:R06518','irreversible','path:rno00600','KEGGMAP','IMPD').
reaction('41105: rn:R07892','irreversible','path:rno00592','KEGGMAP','IMPD').
reaction('41110: rn:R03167','irreversible','path:rno00480','KEGGMAP','IMPD').
reaction('41111: rn:R04951','irreversible','path:rno00480','KEGGMAP','IMPD').
reaction('6724: rn:R03332','irreversible','path:rn00562','KEGGMAP','IMPD').
reaction('41108: rn:R03749','irreversible','path:rno00480','KEGGMAP','IMPD').
reaction('41109: rn:R00274','irreversible','path:rno00480','KEGGMAP','IMPD').
reaction('41114: rn:R03915 rn:R02824','irreversible','path:rno00480','KEGGMAP','IMPD').
reaction('41115: rn:R00894','irreversible','path:rno00480','KEGGMAP','IMPD').
reaction('41112: rn:R03916','irreversible','path:rno00480','KEGGMAP','IMPD').
reaction('41113: rn:R02736','irreversible','path:rno00480','KEGGMAP','IMPD').
reaction('41118: rn:R00497','irreversible','path:rno00480','KEGGMAP','IMPD').
reaction('41119: rn:R02743','irreversible','path:rno00480','KEGGMAP','IMPD').
reaction('6732: rn:R03332','irreversible','path:rn00562','KEGGMAP','IMPD').
reaction('41116: rn:R00494','irreversible','path:rno00480','KEGGMAP','IMPD').
reaction('41117: rn:R00267','irreversible','path:rno00480','KEGGMAP','IMPD').
reaction('41121: rn:R00899','irreversible','path:rno00480','KEGGMAP','IMPD').
reaction('41120: rn:R01262','irreversible','path:rno00480','KEGGMAP','IMPD').
reaction('41123: rn:R01000','irreversible','path:rno00640','KEGGMAP','IMPD').
reaction('41122: rn:R00251','irreversible','path:rno00480','KEGGMAP','IMPD').
reaction('41125: rn:R00742','irreversible','path:rno00640','KEGGMAP','IMPD').
reaction('41124: rn:R00233','irreversible','path:rno00640','KEGGMAP','IMPD').
reaction('41127: rn:R04432','reversible','path:rno00640','KEGGMAP','IMPD').
reaction('41126: rn:R00238','reversible','path:rno00640','KEGGMAP','IMPD').
reaction('41129: rn:R00432','reversible','path:rno00640','KEGGMAP','IMPD').
reaction('6778: rn:R05378','irreversible','path:rn00562','KEGGMAP','IMPD').
reaction('41128: rn:R00405','reversible','path:rno00640','KEGGMAP','IMPD').
reaction('41131: rn:R02940','irreversible','path:rno00640','KEGGMAP','IMPD').
reaction('41130: rn:R00833','reversible','path:rno00640','KEGGMAP','IMPD').
reaction('41133: rn:R03157 rn:R03158','reversible','path:rno00640','KEGGMAP','IMPD').
reaction('41132: rn:R00908','reversible','path:rno00640','KEGGMAP','IMPD').
reaction('41135: rn:R00694','reversible','path:rno00400','KEGGMAP','IMPD').
reaction('41134: rn:R00689','irreversible','path:rno00400','KEGGMAP','IMPD').
reaction('41136: rn:R01795','irreversible','path:rno00400','KEGGMAP','IMPD').
reaction('41137: rn:R00729','irreversible','path:rno00400','KEGGMAP','IMPD').
reaction('41138: rn:R03045','reversible','path:rno00640','KEGGMAP','IMPD').
reaction('41139: rn:R00734','reversible','path:rno00400','KEGGMAP','IMPD').
reaction('41140: rn:R00238','irreversible','path:rno00630','KEGGMAP','IMPD').
reaction('41141: rn:R00935','irreversible','path:rno00640','KEGGMAP','IMPD').
reaction('41142: rn:R01859','irreversible','path:rno00640','KEGGMAP','IMPD').
reaction('41143: rn:R02765','reversible','path:rno00640','KEGGMAP','IMPD').
reaction('41144: rn:R00926','reversible','path:rno00640','KEGGMAP','IMPD').
reaction('41145: rn:R01354','reversible','path:rno00640','KEGGMAP','IMPD').
reaction('41146: rn:R01354','reversible','path:rno00640','KEGGMAP','IMPD').
reaction('41147: rn:R00926','reversible','path:rno00640','KEGGMAP','IMPD').
reaction('41148: rn:R02765','irreversible','path:rno00630','KEGGMAP','IMPD').
reaction('6767: rn:R04504','irreversible','path:rn00562','KEGGMAP','IMPD').
reaction('41149: rn:R01859','irreversible','path:rno00630','KEGGMAP','IMPD').
reaction('41150: rn:R00833','irreversible','path:rno00630','KEGGMAP','IMPD').
reaction('41151: rn:R03288','irreversible','path:rno00410','KEGGMAP','IMPD').
reaction('3286: rn:R04443','reversible','path:rn00330','KEGGMAP','IMPD').
reaction('7673: rn:R00203','irreversible','path:rn00620','KEGGMAP','IMPD').
reaction('7672: rn:R01016','irreversible','path:rn00620','KEGGMAP','IMPD').
reaction('7674: rn:R00203','irreversible','path:rn00620','KEGGMAP','IMPD').
reaction('3228: rn:R04870','irreversible','path:rn00311','KEGGMAP','IMPD').
reaction('3236: rn:R03249','irreversible','path:rn00330','KEGGMAP','IMPD').
reaction('3246: rn:R03314','reversible','path:rn00330','KEGGMAP','IMPD').
reaction('11808: rn:R01930','irreversible','path:rn00920','KEGGMAP','IMPD').
reaction('11809: rn:R00897','irreversible','path:rn00920','KEGGMAP','IMPD').
reaction('3137: rn:R03284','irreversible','path:rn00310','KEGGMAP','IMPD').
reaction('11800: rn:R08553','reversible','path:rn00920','KEGGMAP','IMPD').
reaction('11797: rn:R02021','irreversible','path:rn00920','KEGGMAP','IMPD').
reaction('11784: rn:R00897','irreversible','path:rn00920','KEGGMAP','IMPD').
reaction('11778: rn:R01339','reversible','path:rn00910','KEGGMAP','IMPD').
reaction('11779: rn:R00485','irreversible','path:rn00910','KEGGMAP','IMPD').
reaction('7457: rn:R06198','irreversible','path:rn00601','KEGGMAP','IMPD').
reaction('7456: rn:R06192','irreversible','path:rn00601','KEGGMAP','IMPD').
reaction('7461: rn:R06097','irreversible','path:rn00601','KEGGMAP','IMPD').
reaction('3122: rn:R00462','irreversible','path:rn00310','KEGGMAP','IMPD').
reaction('3532: rn:R03286','irreversible','path:rn00340','KEGGMAP','IMPD').
reaction('3471: rn:R05465','irreversible','path:rn00331','KEGGMAP','IMPD').
reaction('3501: rn:R03288','irreversible','path:rn00340','KEGGMAP','IMPD').
reaction('3502: rn:R02144','irreversible','path:rn00340','KEGGMAP','IMPD').
reaction('7303: rn:R06526','irreversible','path:rn00600','KEGGMAP','IMPD').
reaction('7304: rn:R06525','irreversible','path:rn00600','KEGGMAP','IMPD').
reaction('7309: rn:R02542','irreversible','path:rn00600','KEGGMAP','IMPD').
reaction('3406: rn:R00671','reversible','path:rn00330','KEGGMAP','IMPD').
reaction('3401: rn:R00131','irreversible','path:rn00330','KEGGMAP','IMPD').
reaction('3398: rn:R01987','irreversible','path:rn00330','KEGGMAP','IMPD').
reaction('3423: rn:R01915','irreversible','path:rn00330','KEGGMAP','IMPD').
reaction('3432: rn:R02280','irreversible','path:rn00330','KEGGMAP','IMPD').
reaction('3428: rn:R03296','reversible','path:rn00330','KEGGMAP','IMPD').
reaction('3453: rn:R07245','irreversible','path:rn00330','KEGGMAP','IMPD').
reaction('3343: rn:R00471','irreversible','path:rn00330','KEGGMAP','IMPD').
reaction('3330: rn:R01246 rn:R01249','irreversible','path:rn00330','KEGGMAP','IMPD').
reaction('3329: rn:R01255','irreversible','path:rn00330','KEGGMAP','IMPD').
reaction('3353: rn:R01566','irreversible','path:rn00330','KEGGMAP','IMPD').
reaction('3359: rn:R08197','irreversible','path:rn00330','KEGGMAP','IMPD').
reaction('3345: rn:R00471','irreversible','path:rn00330','KEGGMAP','IMPD').
reaction('3344: rn:R00471','irreversible','path:rn00330','KEGGMAP','IMPD').
reaction('7206: rn:R07063','irreversible','path:rn00591','KEGGMAP','IMPD').
reaction('3379: rn:R07414','irreversible','path:rn00330','KEGGMAP','IMPD').
reaction('7173: rn:R02264','irreversible','path:rn00590','KEGGMAP','IMPD').
reaction('3839: rn:R09090','irreversible','path:rn00360','KEGGMAP','IMPD').
reaction('3785: rn:R03341','irreversible','path:rn00350','KEGGMAP','IMPD').
reaction('3699: rn:R02520','irreversible','path:rn00350','KEGGMAP','IMPD').
reaction('3694: rn:R00042','irreversible','path:rn00350','KEGGMAP','IMPD').
reaction('3652: rn:R02384','irreversible','path:rn00350','KEGGMAP','IMPD').
reaction('7951: rn:R00228','reversible','path:rn00622','KEGGMAP','IMPD').
reaction('3646: rn:R02514 rn:R02516','irreversible','path:rn00350','KEGGMAP','IMPD').
reaction('3642: rn:R02698','irreversible','path:rn00350','KEGGMAP','IMPD').
reaction('3638: rn:R02518','irreversible','path:rn00350','KEGGMAP','IMPD').
reaction('3635: rn:R02489','reversible','path:rn00350','KEGGMAP','IMPD').
reaction('7936: rn:R00750','irreversible','path:rn00622','KEGGMAP','IMPD').
reaction('3596: rn:R03672','irreversible','path:rn00350','KEGGMAP','IMPD').
reaction('3598: rn:R03674','irreversible','path:rn00350','KEGGMAP','IMPD').
reaction('11691: rn:R00490','irreversible','path:rn00910','KEGGMAP','IMPD').
reaction('11694: rn:R00482','irreversible','path:rn00910','KEGGMAP','IMPD').
reaction('11693: rn:R00483','irreversible','path:rn00910','KEGGMAP','IMPD').
reaction('11692: rn:R00490','irreversible','path:rn00910','KEGGMAP','IMPD').
reaction('11734: rn:R00493','reversible','path:rn00910','KEGGMAP','IMPD').
reaction('7859: rn:R00228','irreversible','path:rn00621','KEGGMAP','IMPD').
reaction('11774: rn:R00524','irreversible','path:rn00910','KEGGMAP','IMPD').
reaction('11522: rn:R07260','irreversible','path:rn00908','KEGGMAP','IMPD').
reaction('3943: rn:R06790','irreversible','path:rn00360','KEGGMAP','IMPD').
reaction('3961: rn:R05487','irreversible','path:rn00360','KEGGMAP','IMPD').
reaction('7745: rn:R00230','irreversible','path:rn00620','KEGGMAP','IMPD').
reaction('3953: rn:R01377','irreversible','path:rn00360','KEGGMAP','IMPD').
reaction('7744: rn:R00753','irreversible','path:rn00620','KEGGMAP','IMPD').
reaction('7780: rn:R00750','irreversible','path:rn00621','KEGGMAP','IMPD').
reaction('11596: rn:R08052','irreversible','path:rn00908','KEGGMAP','IMPD').
reaction('11597: rn:R08051','irreversible','path:rn00908','KEGGMAP','IMPD').
reaction('7705: rn:R03145','irreversible','path:rn00620','KEGGMAP','IMPD').
reaction('7706: rn:R00207','irreversible','path:rn00620','KEGGMAP','IMPD').
reaction('11595: rn:R04038','irreversible','path:rn00908','KEGGMAP','IMPD').
reaction('7707: rn:R00230','reversible','path:rn00620','KEGGMAP','IMPD').
reaction('7701: rn:R00472','irreversible','path:rn00620','KEGGMAP','IMPD').
reaction('11591: rn:R08076','irreversible','path:rn00908','KEGGMAP','IMPD').
reaction('3875: rn:R02540','irreversible','path:rn00360','KEGGMAP','IMPD').
reaction('7692: rn:R00212','reversible','path:rn00620','KEGGMAP','IMPD').
reaction('7695: rn:R01196','reversible','path:rn00620','KEGGMAP','IMPD').
reaction('7694: rn:R00211','reversible','path:rn00620','KEGGMAP','IMPD').
reaction('7687: rn:R01450','reversible','path:rn00620','KEGGMAP','IMPD').
reaction('11600: rn:R03726','irreversible','path:rn00908','KEGGMAP','IMPD').
reaction('11603: rn:R02118','irreversible','path:rn00908','KEGGMAP','IMPD').
reaction('11602: rn:R02119','irreversible','path:rn00908','KEGGMAP','IMPD').
reaction('7743: rn:R00319','irreversible','path:rn00620','KEGGMAP','IMPD').
reaction('7737: rn:R00205','irreversible','path:rn00620','KEGGMAP','IMPD').
reaction('3842: rn:R00750','reversible','path:rn00360','KEGGMAP','IMPD').
reaction('3862: rn:R01377','irreversible','path:rn00360','KEGGMAP','IMPD').
reaction('7717: rn:R00228','reversible','path:rn00620','KEGGMAP','IMPD').
metabolite('36906: gl:G00111','','path:rno00604;path:rn00604;path:ec00604','KEGGMAP','IMPD').
metabolite('36905: cpd:C00957','','path:ec00270;path:rn00270;path:rno00270','KEGGMAP','IMPD').
metabolite('36911: gl:G00124','','path:rno00604;path:rn00604;path:ec00604','KEGGMAP','IMPD').
metabolite('36909: cpd:C00458','','path:ec00240;path:rno00240;path:rn00240','KEGGMAP','IMPD').
metabolite('36908: gl:G00112','','path:rno00604;path:rn00604;path:ec00604','KEGGMAP','IMPD').
metabolite('36897: cpd:C00063','','path:ec00240;path:rno00240;path:rn00240','KEGGMAP','IMPD').
metabolite('36896: cpd:C00208','','path:ec00500;path:rn00500;path:rno00500','KEGGMAP','IMPD').
metabolite('36903: cpd:C00295','','path:ec00240;path:rno00240;path:rn00240','KEGGMAP','IMPD').
metabolite('39100: gl:G00027','','path:rno00512;path:ec00512;path:rn00512','KEGGMAP','IMPD').
metabolite('39075: gl:G00010','','path:ec00510;path:rn00510;path:rno00510','KEGGMAP','IMPD').
metabolite('36923: gl:G00109','','path:rno00604;path:rn00604;path:ec00604','KEGGMAP','IMPD').
metabolite('36920: gl:G00108','','path:rno00604;path:rn00604;path:ec00604','KEGGMAP','IMPD').
metabolite('36925: gl:G00110','','path:rno00604;path:rn00604;path:ec00604','KEGGMAP','IMPD').
metabolite('36914: gl:G00123','','path:rno00604;path:rn00604;path:ec00604','KEGGMAP','IMPD').
metabolite('36915: cpd:C00721','','path:ec00500;path:rn00500;path:rno00500','KEGGMAP','IMPD').
metabolite('36913: cpd:C00705','','path:ec00240;path:rno00240;path:rn00240','KEGGMAP','IMPD').
metabolite('36918: cpd:C01083','','path:ec00500;path:rn00500;path:rno00500','KEGGMAP','IMPD').
metabolite('36919: cpd:C05670','','path:ec00460;path:rn00460;path:rno00460','KEGGMAP','IMPD').
metabolite('36916: cpd:C00239','','path:ec00240;path:rno00240;path:rn00240','KEGGMAP','IMPD').
metabolite('36917: gl:G00113','','path:rno00604;path:rn00604;path:ec00604','KEGGMAP','IMPD').
metabolite('36873: cpd:C00664','','path:rno00670;path:ec00670;path:rn00670','KEGGMAP','IMPD').
metabolite('36872: cpd:C16550','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('36875: cpd:C05476','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36874: cpd:C03479','','path:ec00670;path:rno00670;path:rn00670','KEGGMAP','IMPD').
metabolite('36877: cpd:C01780','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36878: cpd:C00632','','path:rn00380;path:ec00627;path:rno00380;path:rn00627;path:ec00380','KEGGMAP','IMPD').
metabolite('36865: cpd:C02538','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36864: cpd:C05488','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36867: cpd:C07643','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('36869: cpd:C11554','','path:ec00562;path:rn00562;path:rno00562','KEGGMAP','IMPD').
metabolite('36868: cpd:C02140','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36871: gl:G12396','','path:ec00563;path:rn00563;path:rno00563','KEGGMAP','IMPD').
metabolite('36870: cpd:C07644','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('36889: gl:G00117','','path:rno00604;path:rn00604;path:ec00604','KEGGMAP','IMPD').
metabolite('36890: cpd:C01231','','path:ec00500;path:rn00500;path:rno00500','KEGGMAP','IMPD').
metabolite('36891: gl:G00116','','path:rno00604;path:rn00604;path:ec00604','KEGGMAP','IMPD').
metabolite('36893: gl:G00114','','path:rno00604;path:rn00604;path:ec00604','KEGGMAP','IMPD').
metabolite('36894: cpd:C05823','','path:ec00270;path:rn00270;path:rno00270','KEGGMAP','IMPD').
metabolite('36880: cpd:C01176','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36881: cpd:C03205','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36883: cpd:C00166','','path:rn00360;path:ec00960;path:ec00400;path:rno00360;path:rno00400;path:rn00400;path:ec00360;path:rn00960','KEGGMAP','IMPD').
metabolite('36884: cpd:C03681','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36886: cpd:C00410','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36975: gl:G00125','','path:rno00604;path:rn00604;path:ec00604','KEGGMAP','IMPD').
metabolite('36974: cpd:C05335','','path:rn00450;path:ec00450;path:rno00450','KEGGMAP','IMPD').
metabolite('36973: cpd:C14874','','path:rno00980;path:ec00980;path:rn00980','KEGGMAP','IMPD').
metabolite('36972: cpd:C05688','','path:rn00450;path:ec00450;path:rno00450','KEGGMAP','IMPD').
metabolite('36970: cpd:C01159','','path:ec00010;path:rno00010;path:rn00010','KEGGMAP','IMPD').
metabolite('36967: cpd:C05689','','path:rn00450;path:ec00450;path:rno00450','KEGGMAP','IMPD').
metabolite('36965: cpd:C05100','','path:ec00240;path:rno00240;path:rn00240','KEGGMAP','IMPD').
metabolite('36964: cpd:C00469','','path:ec00010;path:rno00010;path:rn00010','KEGGMAP','IMPD').
metabolite('36962: cpd:C05145','','path:ec00240;path:rno00240;path:rn00240','KEGGMAP','IMPD').
metabolite('36990: cpd:C00672','','path:ec00240;path:ec00030;path:rno00240;path:rn00240;path:rn00030','KEGGMAP','IMPD').
metabolite('36988: cpd:C06899','','path:rno00980;path:ec00980;path:rn00980','KEGGMAP','IMPD').
metabolite('36989: cpd:C05703','','path:rn00450;path:ec00450;path:rno00450','KEGGMAP','IMPD').
metabolite('36986: cpd:C14869','','path:rno00980;path:ec00980;path:rn00980','KEGGMAP','IMPD').
metabolite('36987: cpd:C00364','','path:ec00240;path:rno00240;path:rn00240','KEGGMAP','IMPD').
metabolite('36984: cpd:C00214','','path:ec00240;path:rno00240;path:rn00240','KEGGMAP','IMPD').
metabolite('36982: cpd:C00459','','path:ec00240;path:rno00240;path:rn00240','KEGGMAP','IMPD').
metabolite('36983: cpd:C11088','','path:rno00980;path:ec00980;path:rn00980','KEGGMAP','IMPD').
metabolite('36980: cpd:C02218','','path:ec00270;path:rn00270;path:rno00270','KEGGMAP','IMPD').
metabolite('36981: cpd:C14870','','path:rno00980;path:ec00980;path:rn00980','KEGGMAP','IMPD').
metabolite('36978: cpd:C05336','','path:rn00450;path:ec00450;path:rno00450','KEGGMAP','IMPD').
metabolite('36979: cpd:C00363','','path:ec00240;path:rno00240;path:rn00240','KEGGMAP','IMPD').
metabolite('36976: cpd:C05698','','path:rn00450;path:ec00450;path:rno00450','KEGGMAP','IMPD').
metabolite('36977: cpd:C14871','','path:rno00980;path:ec00980;path:rn00980','KEGGMAP','IMPD').
metabolite('36941: cpd:C05379','','path:rno00020;path:ec00020;path:rn00020','KEGGMAP','IMPD').
metabolite('36940: cpd:C05527','','path:ec00270;path:rn00270;path:rno00270','KEGGMAP','IMPD').
metabolite('36942: cpd:C00365','','path:ec00240;path:rno00240;path:rn00240','KEGGMAP','IMPD').
metabolite('36936: cpd:C00881','','path:ec00240;path:rno00240;path:rn00240','KEGGMAP','IMPD').
metabolite('39122: gl:G00026','','path:rno00512;path:ec00512;path:rn00512','KEGGMAP','IMPD').
metabolite('36938: cpd:C01346','','path:ec00240;path:rno00240;path:rn00240','KEGGMAP','IMPD').
metabolite('36933: cpd:C00526','','path:ec00240;path:rno00240;path:rn00240','KEGGMAP','IMPD').
metabolite('36932: cpd:C18904','','path:rn00450;path:ec00450;path:rno00450','KEGGMAP','IMPD').
metabolite('39135: gl:G10611','','path:rno00512;path:ec00512;path:rn00512','KEGGMAP','IMPD').
metabolite('36935: cpd:C02763','','path:rn00360;path:rno00360;path:ec00360','KEGGMAP','IMPD').
metabolite('36934: cpd:C14859','','path:rno00980;path:ec00980;path:rn00980','KEGGMAP','IMPD').
metabolite('36929: cpd:C00460','','path:ec00240;path:rno00240;path:rn00240','KEGGMAP','IMPD').
metabolite('39128: gl:G00031','','path:rno00512;path:ec00512;path:rn00512','KEGGMAP','IMPD').
metabolite('39130: gl:G00032','','path:rno00512;path:ec00512;path:rn00512','KEGGMAP','IMPD').
metabolite('36930: cpd:C18902','','path:rn00450;path:ec00450;path:rno00450','KEGGMAP','IMPD').
metabolite('36956: cpd:C05172','','path:rn00450;path:ec00450;path:rno00450','KEGGMAP','IMPD').
metabolite('36958: cpd:C05684','','path:rn00450;path:ec00450;path:rno00450','KEGGMAP','IMPD').
metabolite('36959: cpd:C00906','','path:ec00240;path:rno00240;path:rn00240','KEGGMAP','IMPD').
metabolite('39104: gl:G00028','','path:rno00512;path:ec00512;path:rn00512','KEGGMAP','IMPD').
metabolite('36952: cpd:C00475','','path:ec00240;path:rno00240;path:rn00240','KEGGMAP','IMPD').
metabolite('39106: gl:G00029','','path:rno00512;path:ec00512;path:rn00512','KEGGMAP','IMPD').
metabolite('36954: gl:G00115','','path:rno00604;path:rn00604;path:ec00604','KEGGMAP','IMPD').
metabolite('36955: cpd:C00178','','path:ec00240;path:rno00240;path:rn00240','KEGGMAP','IMPD').
metabolite('36948: cpd:C00055','','path:ec00240;path:rno00240;path:rn00240','KEGGMAP','IMPD').
metabolite('36949: cpd:C00112','','path:ec00240;path:rno00240;path:rn00240','KEGGMAP','IMPD').
metabolite('36950: cpd:C01962','','path:ec00270;path:rn00270;path:rno00270','KEGGMAP','IMPD').
metabolite('39119: gl:G00025','','path:rno00512;path:ec00512;path:rn00512','KEGGMAP','IMPD').
metabolite('36951: cpd:C16254','','path:rno00020;path:ec00020;path:rn00020','KEGGMAP','IMPD').
metabolite('39112: gl:G00035','','path:rno00512;path:ec00512;path:rn00512','KEGGMAP','IMPD').
metabolite('36945: cpd:C00491','','path:ec00270;path:rn00270;path:rno00270','KEGGMAP','IMPD').
metabolite('36946: cpd:C05686','','path:rn00450;path:ec00450;path:rno00450','KEGGMAP','IMPD').
metabolite('39115: gl:G00023','','path:rno00512;path:ec00512;path:rn00512','KEGGMAP','IMPD').
metabolite('37026: cpd:C03406','','path:ec00250;path:rno00330;path:ec00330;path:rno00250;path:rn00330;path:rn00250','KEGGMAP','IMPD').
metabolite('37027: cpd:C05993','','path:rno00620;path:ec00230;path:rn00620;path:rn00230;path:ec00620','KEGGMAP','IMPD').
metabolite('37024: cpd:C14856','','path:rno00980;path:ec00980;path:rn00980','KEGGMAP','IMPD').
metabolite('37025: cpd:C01097','','path:rno00052;path:rn00052;path:ec00052','KEGGMAP','IMPD').
metabolite('37031: cpd:C06205','','path:rno00980;path:ec00980;path:rn00980','KEGGMAP','IMPD').
metabolite('37028: cpd:C03785','','path:rno00052;path:rn00052;path:ec00052','KEGGMAP','IMPD').
metabolite('37029: cpd:C14853','','path:rno00980;path:ec00980;path:rn00980','KEGGMAP','IMPD').
metabolite('37035: cpd:C11821','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37038: cpd:C05402','','path:rno00052;path:rn00052;path:ec00052','KEGGMAP','IMPD').
metabolite('37039: cpd:C14556','','path:rno00980;path:ec00980;path:rn00980','KEGGMAP','IMPD').
metabolite('37037: cpd:C14784','','path:rno00980;path:ec00980;path:rn00980','KEGGMAP','IMPD').
metabolite('37042: cpd:C12248','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37045: cpd:C14850','','path:rno00980;path:ec00980;path:rn00980','KEGGMAP','IMPD').
metabolite('37054: gl:G00126','','path:rno00604;path:rn00604;path:ec00604','KEGGMAP','IMPD').
metabolite('36993: cpd:C01061','','path:ec00643;path:rn00643;path:rno00350;path:ec00350;path:rn00350','KEGGMAP','IMPD').
metabolite('36994: cpd:C01036','','path:ec00643;path:rn00643;path:rno00350;path:ec00350;path:rn00350','KEGGMAP','IMPD').
metabolite('36995: cpd:C00299','','path:ec00240;path:rno00240;path:rn00240','KEGGMAP','IMPD').
metabolite('36997: cpd:C14868','','path:rno00980;path:ec00980;path:rn00980','KEGGMAP','IMPD').
metabolite('36999: cpd:C14863','','path:rno00980;path:ec00980;path:rn00980','KEGGMAP','IMPD').
metabolite('37000: cpd:C00544','','path:ec00643;path:rn00643;path:rn00130;path:rno00350;path:ec00130;path:ec00350;path:rn00350;path:rno00130','KEGGMAP','IMPD').
metabolite('37002: cpd:C14861','','path:rno00980;path:ec00980;path:rn00980','KEGGMAP','IMPD').
metabolite('37004: cpd:C14865','','path:rno00980;path:ec00980;path:rn00980','KEGGMAP','IMPD').
metabolite('37005: cpd:C14864','','path:rno00980;path:ec00980;path:rn00980','KEGGMAP','IMPD').
metabolite('37006: cpd:C00804','','path:ec00640;path:ec00410;path:rn00410;path:rn00640;path:rno00640','KEGGMAP','IMPD').
metabolite('37007: cpd:C14858','','path:rno00980;path:ec00980;path:rn00980','KEGGMAP','IMPD').
metabolite('37009: cpd:C00337','','path:ec00240;path:rno00240;path:rn00240','KEGGMAP','IMPD').
metabolite('37008: cpd:C14857','','path:rno00980;path:ec00980;path:rn00980','KEGGMAP','IMPD').
metabolite('37010: cpd:C01528','','path:rn00450;path:ec00450;path:rno00450','KEGGMAP','IMPD').
metabolite('37013: cpd:C01103','','path:ec00240;path:rno00240;path:rn00240','KEGGMAP','IMPD').
metabolite('37012: cpd:C05697','','path:rn00450;path:ec00450;path:rno00450','KEGGMAP','IMPD').
metabolite('37015: cpd:C14851','','path:rno00980;path:ec00980;path:rn00980','KEGGMAP','IMPD').
metabolite('37017: cpd:C14855','','path:rno00980;path:ec00980;path:rn00980','KEGGMAP','IMPD').
metabolite('37016: cpd:C00243','','path:rno00052;path:rn00052;path:ec00052','KEGGMAP','IMPD').
metabolite('37019: cpd:C14852','','path:rno00980;path:ec00980;path:rn00980','KEGGMAP','IMPD').
metabolite('37023: cpd:C01697','','path:rno00052;path:rn00052;path:ec00052','KEGGMAP','IMPD').
metabolite('37022: cpd:C14854','','path:rno00980;path:ec00980;path:rn00980','KEGGMAP','IMPD').
metabolite('37093: cpd:C05273','','path:ec00071;path:rn00071;path:rn00062;path:rno00062;path:rno00071;path:ec00062','KEGGMAP','IMPD').
metabolite('37090: cpd:C17938','','path:rno00350;path:ec00350;path:rn00350','KEGGMAP','IMPD').
metabolite('37091: gl:G00103','','path:rn00603;path:rno00603;path:ec00603','KEGGMAP','IMPD').
metabolite('37089: cpd:C14847','','path:rno00980;path:ec00980;path:rn00980','KEGGMAP','IMPD').
metabolite('37102: cpd:C15978','','path:rno00280;path:rn00280;path:ec00280','KEGGMAP','IMPD').
metabolite('37100: cpd:C05381','','path:rno00020;path:ec00020;path:rn00020','KEGGMAP','IMPD').
metabolite('37101: gl:G00098','','path:rn00603;path:rno00603;path:ec00603','KEGGMAP','IMPD').
metabolite('37098: cpd:C02593','','path:ec00071;path:rn00071;path:rn00062;path:rno00062;path:rno00071;path:ec00062','KEGGMAP','IMPD').
metabolite('37111: gl:G00099','','path:rn00603;path:rno00603;path:ec00603','KEGGMAP','IMPD').
metabolite('37110: cpd:C14801','','path:rno00980;path:ec00980;path:rn00980','KEGGMAP','IMPD').
metabolite('37109: cpd:C05272','','path:ec00071;path:rn00071;path:rn00062;path:rno00071;path:rno00062;path:ec00062','KEGGMAP','IMPD').
metabolite('37106: gl:G00097','','path:rn00603;path:rno00603;path:ec00603','KEGGMAP','IMPD').
metabolite('37104: gl:G00104','','path:rn00603;path:rno00603;path:ec00603','KEGGMAP','IMPD').
metabolite('37119: cpd:C01042','','path:ec00250;path:rno00250;path:rn00250','KEGGMAP','IMPD').
metabolite('37117: cpd:C05260','','path:ec00071;path:rn00071;path:rn00062;path:rno00062;path:rno00071;path:ec00062','KEGGMAP','IMPD').
metabolite('37115: cpd:C05261','','path:ec00071;path:rn00071;path:rn00062;path:rno00062;path:rno00071;path:ec00062','KEGGMAP','IMPD').
metabolite('37114: cpd:C14848','','path:rno00980;path:ec00980;path:rn00980','KEGGMAP','IMPD').
metabolite('37112: cpd:C00402','','path:ec00250;path:rno00250;path:rn00250','KEGGMAP','IMPD').
metabolite('37063: cpd:C15974','','path:rno00280;path:rn00280;path:ec00280','KEGGMAP','IMPD').
metabolite('37058: gl:G00119','','path:rno00604;path:rn00604;path:ec00604','KEGGMAP','IMPD').
metabolite('37059: gl:G00118','','path:rno00604;path:rn00604;path:ec00604','KEGGMAP','IMPD').
metabolite('37065: gl:G00120','','path:rno00604;path:rn00604;path:ec00604','KEGGMAP','IMPD').
metabolite('38995: cpd:C05443','','path:rn00100;path:rno00100','KEGGMAP','IMPD').
metabolite('37079: cpd:C15976','','path:rno00280;path:rn00280;path:ec00280','KEGGMAP','IMPD').
metabolite('37075: gl:G00127','','path:rno00604;path:rn00604;path:ec00604','KEGGMAP','IMPD').
metabolite('37084: gl:G00128','','path:rno00604;path:rn00604;path:ec00604','KEGGMAP','IMPD').
metabolite('37087: cpd:C14845','','path:rno00980;path:ec00980;path:rn00980','KEGGMAP','IMPD').
metabolite('37081: gl:G00129','','path:rno00604;path:rn00604;path:ec00604','KEGGMAP','IMPD').
metabolite('37177: cpd:C05581','','path:rno00350;path:ec00350;path:rn00350','KEGGMAP','IMPD').
metabolite('37179: cpd:C05966','','path:rno00590;path:rn00590;path:ec00590','KEGGMAP','IMPD').
metabolite('37180: cpd:C00294','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37181: cpd:C04043','','path:rno00350;path:rn00950;path:ec00350;path:rn00350;path:ec00950','KEGGMAP','IMPD').
metabolite('37183: cpd:C00130','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37168: cpd:C05583','','path:rno00350;path:ec00350;path:rn00350','KEGGMAP','IMPD').
metabolite('37169: cpd:C05582','','path:rno00350;path:ec00350;path:rn00350','KEGGMAP','IMPD').
metabolite('37172: cpd:C05956','','path:rno00590;path:rn00590;path:ec00590','KEGGMAP','IMPD').
metabolite('37173: cpd:C01161','','path:rno00350;path:ec00350;path:rn00350','KEGGMAP','IMPD').
metabolite('37175: cpd:C00262','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37160: cpd:C05580','','path:rno00350;path:ec00350;path:rn00350','KEGGMAP','IMPD').
metabolite('37163: cpd:C05584','','path:rno00350;path:ec00350;path:rn00350','KEGGMAP','IMPD').
metabolite('37162: cpd:C00639','','path:rno00590;path:rn00590;path:ec00590','KEGGMAP','IMPD').
metabolite('37165: cpd:C00427','','path:rno00590;path:rn00590;path:ec00590','KEGGMAP','IMPD').
metabolite('37166: cpd:C00212','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37153: cpd:C00206','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37152: cpd:C02166','','path:rno00590;path:rn00590;path:ec00590','KEGGMAP','IMPD').
metabolite('37154: cpd:C00547','','path:rno00350;path:ec00350;path:rn00350','KEGGMAP','IMPD').
metabolite('37156: cpd:C05284','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('37158: cpd:C05577','','path:rno00350;path:ec00350;path:rn00350','KEGGMAP','IMPD').
metabolite('37146: cpd:C00584','','path:rno00590;path:rn00590;path:ec00590','KEGGMAP','IMPD').
metabolite('37147: cpd:C00788','','path:rno00350;path:ec00350;path:rn00350','KEGGMAP','IMPD').
metabolite('37144: cpd:C01312','','path:rno00590;path:rn00590;path:ec00590','KEGGMAP','IMPD').
metabolite('37145: cpd:C05588','','path:rno00350;path:ec00350;path:rn00350','KEGGMAP','IMPD').
metabolite('37150: cpd:C05356','','path:rno00590;path:rn00590;path:ec00590','KEGGMAP','IMPD').
metabolite('37151: cpd:C05589','','path:rno00350;path:ec00350;path:rn00350','KEGGMAP','IMPD').
metabolite('37149: cpd:C00131','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37138: cpd:C00322','','path:rn00380;path:rno00380;path:ec00310;path:rn00310;path:ec00300;path:rno00310;path:rno00300;path:rn00300;path:ec00380','KEGGMAP','IMPD').
metabolite('37136: cpd:C01613','','path:rno00052;path:rn00052;path:ec00052','KEGGMAP','IMPD').
metabolite('37142: cpd:C14791','','path:rno00980;path:ec00980;path:rn00980','KEGGMAP','IMPD').
metabolite('37143: cpd:C06198','','path:ec00240;path:rno00240;path:rn00240','KEGGMAP','IMPD').
metabolite('37130: cpd:C00864','','path:rn00770;path:rn00410;path:ec00410;path:rno00770;path:ec00770','KEGGMAP','IMPD').
metabolite('37128: gl:G00093','','path:rn00603;path:rno00603;path:ec00603','KEGGMAP','IMPD').
metabolite('37134: cpd:C05404','','path:rno00052;path:rn00052;path:ec00052','KEGGMAP','IMPD').
metabolite('37133: gl:G00094','','path:rn00603;path:rno00603;path:ec00603','KEGGMAP','IMPD').
metabolite('37123: cpd:C11713','','path:rno00980;path:ec00980;path:rn00980','KEGGMAP','IMPD').
metabolite('37122: cpd:C02362','','path:ec00250;path:rno00250;path:rn00250','KEGGMAP','IMPD').
metabolite('37121: cpd:C05258','','path:ec00071;path:rn00071;path:rn00062;path:rno00071;path:rno00062;path:ec00062','KEGGMAP','IMPD').
metabolite('37120: cpd:C14453','','path:rno00980;path:ec00980;path:rn00980','KEGGMAP','IMPD').
metabolite('37126: gl:G00095','','path:rn00603;path:rno00603;path:ec00603','KEGGMAP','IMPD').
metabolite('37125: cpd:C01789','','path:rn00100;path:rn00905;path:rno00100;path:ec00100;path:ec00905','KEGGMAP','IMPD').
metabolite('37124: cpd:C05259','','path:ec00071;path:rn00071;path:rn00062;path:rno00062;path:rno00071;path:ec00062','KEGGMAP','IMPD').
metabolite('37244: cpd:C00257','','path:ec00030;path:rno00030;path:rn00030','KEGGMAP','IMPD').
metabolite('37245: cpd:C04805','','path:rno00590;path:rn00590;path:ec00590','KEGGMAP','IMPD').
metabolite('37246: cpd:C00330','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37247: cpd:C00286','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37241: cpd:C00362','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37243: gl:G00037','','path:rn00601;path:ec00601;path:rno00601','KEGGMAP','IMPD').
metabolite('37232: cpd:C02442','','path:rno00350;path:ec00350;path:rn00350','KEGGMAP','IMPD').
metabolite('37235: cpd:C00242','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37229: cpd:C05594','','path:rno00350;path:ec00350;path:rn00350','KEGGMAP','IMPD').
metabolite('37228: gl:G10599','','path:ec00510;path:rn00510;path:rno00510','KEGGMAP','IMPD').
metabolite('37230: gl:G10598','','path:ec00510;path:rn00510;path:rno00510','KEGGMAP','IMPD').
metabolite('37227: cpd:C05576','','path:rno00350;path:ec00350;path:rn00350','KEGGMAP','IMPD').
metabolite('37221: cpd:C06199','','path:rno00350;path:ec00350;path:rn00350','KEGGMAP','IMPD').
metabolite('37220: cpd:C00140','','path:rno00520;path:ec00520;path:rn00520','KEGGMAP','IMPD').
metabolite('37217: cpd:C01040','','path:rn00053;path:ec00053;path:rno00053','KEGGMAP','IMPD').
metabolite('37216: cpd:C00461','','path:rno00520;path:ec00520;path:rn00520','KEGGMAP','IMPD').
metabolite('37219: cpd:C00818','','path:rn00053;path:ec00053;path:rno00053','KEGGMAP','IMPD').
metabolite('37214: cpd:C01260','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37208: cpd:C02350','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37209: cpd:C01674','','path:rno00520;path:ec00520;path:rn00520','KEGGMAP','IMPD').
metabolite('37207: cpd:C00499','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37205: cpd:C02670','','path:rn00053;path:ec00053;path:rno00053','KEGGMAP','IMPD').
metabolite('37202: cpd:C00329','','path:rno00520;path:ec00520;path:rn00520','KEGGMAP','IMPD').
metabolite('37203: cpd:C00366','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37201: cpd:C00696','','path:rno00590;path:rn00590;path:ec00590','KEGGMAP','IMPD').
metabolite('37199: cpd:C02515','','path:rno00350;path:ec00350;path:rn00350','KEGGMAP','IMPD').
metabolite('37198: cpd:C04853','','path:rno00590;path:rn00590;path:ec00590','KEGGMAP','IMPD').
metabolite('37196: cpd:C01060','','path:rno00350;path:ec00350;path:rn00350','KEGGMAP','IMPD').
metabolite('37195: gl:G00157','','path:rno00532;path:ec00532;path:rn00532;path:ec00534;path:rn00534;path:rno00534','KEGGMAP','IMPD').
metabolite('37193: cpd:C02465','','path:rno00350;path:ec00350;path:rn00350','KEGGMAP','IMPD').
metabolite('37191: cpd:C00603','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37190: cpd:C05951','','path:rno00590;path:rn00590;path:ec00590','KEGGMAP','IMPD').
metabolite('37188: cpd:C01829','','path:rno00350;path:ec00350;path:rn00350','KEGGMAP','IMPD').
metabolite('37186: cpd:C00620','','path:ec00230;path:ec00030;path:rn00230;path:rno00030;path:rno00230;path:rn00030','KEGGMAP','IMPD').
metabolite('37185: cpd:C05965','','path:rno00590;path:rn00590;path:ec00590','KEGGMAP','IMPD').
metabolite('37297: cpd:C00673','','path:ec00030;path:rno00030;path:rn00030','KEGGMAP','IMPD').
metabolite('37296: cpd:C04751','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37299: cpd:C05578','','path:rno00350;path:ec00350;path:rn00350','KEGGMAP','IMPD').
metabolite('37300: cpd:C04640','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37303: gl:G00042','','path:rn00601;path:ec00601;path:rno00601','KEGGMAP','IMPD').
metabolite('37302: cpd:C01801','','path:ec00030;path:rno00030;path:rn00030','KEGGMAP','IMPD').
metabolite('37305: cpd:C05579','','path:rno00350;path:ec00350;path:rn00350','KEGGMAP','IMPD').
metabolite('37304: cpd:C16356','','path:rn00232;path:ec00232;path:rno00232','KEGGMAP','IMPD').
metabolite('37307: cpd:C04376','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37308: cpd:C00355','','path:rno00350;path:rn00950;path:ec00350;path:rn00350;path:ec00950','KEGGMAP','IMPD').
metabolite('37310: cpd:C04823','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37281: cpd:C00104','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37282: cpd:C00642','','path:rn00360;path:rno00350;path:ec00350;path:rn00350','KEGGMAP','IMPD').
metabolite('37285: cpd:C00081','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37289: cpd:C01345','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37290: cpd:C16358','','path:rn00232;path:ec00232;path:rno00232','KEGGMAP','IMPD').
metabolite('37294: cpd:C01693','','path:rno00350;path:ec00350;path:rn00350','KEGGMAP','IMPD').
metabolite('37267: cpd:C00144','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37265: cpd:C00999','','path:rno00520;path:ec00520;path:rn00520','KEGGMAP','IMPD').
metabolite('37271: gl:G00039','','path:rn00601;path:ec00601;path:rno00601','KEGGMAP','IMPD').
metabolite('37269: cpd:C01228','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37268: cpd:C03691','','path:rno00520;path:ec00520;path:rn00520','KEGGMAP','IMPD').
metabolite('37275: cpd:C00996','','path:rno00520;path:ec00520;path:rn00520','KEGGMAP','IMPD').
metabolite('37273: gl:G00044','','path:rn00601;path:ec00601;path:rno00601','KEGGMAP','IMPD').
metabolite('37277: cpd:C00387','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37250: gl:G10526','','path:ec00510;path:rn00510;path:rno00510','KEGGMAP','IMPD').
metabolite('37248: cpd:C00198','','path:ec00030;path:rno00030;path:rn00030','KEGGMAP','IMPD').
metabolite('37254: cpd:C00345','','path:ec00030;path:rno00030;path:rn00030','KEGGMAP','IMPD').
metabolite('37252: gl:G10595','','path:ec00510;path:rn00510;path:rno00510','KEGGMAP','IMPD').
metabolite('37253: gl:G00038','','path:rn00601;path:ec00601;path:rno00601','KEGGMAP','IMPD').
metabolite('37258: gl:G10597','','path:ec00510;path:rn00510;path:rno00510','KEGGMAP','IMPD').
metabolite('37256: cpd:C00361','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37257: cpd:C05585','','path:rno00350;path:ec00350;path:rn00350','KEGGMAP','IMPD').
metabolite('37262: cpd:C00035','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37260: cpd:C03410','','path:rno00520;path:ec00520;path:rn00520','KEGGMAP','IMPD').
metabolite('37261: cpd:C04494','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37365: cpd:C16219','','path:rn00061;path:rno00061;path:ec00061','KEGGMAP','IMPD').
metabolite('37367: cpd:C04088','','path:rn00061;path:rno00061;path:ec00061','KEGGMAP','IMPD').
metabolite('37366: gl:G00002','','path:ec00510;path:rn00510;path:rno00510','KEGGMAP','IMPD').
metabolite('37360: cpd:C04742','','path:rno00590;path:rn00590;path:ec00590','KEGGMAP','IMPD').
metabolite('37373: cpd:C05983','','path:ec00640;path:rn00640;path:rno00640','KEGGMAP','IMPD').
metabolite('37369: gl:G00001','','path:ec00510;path:rn00510;path:rno00510','KEGGMAP','IMPD').
metabolite('37368: cpd:C14781','','path:rno00590;path:rn00590;path:ec00590','KEGGMAP','IMPD').
metabolite('37371: cpd:C14813','','path:rno00590;path:rn00590;path:ec00590','KEGGMAP','IMPD').
metabolite('37348: cpd:C00270','','path:rno00520;path:ec00520;path:rn00520','KEGGMAP','IMPD').
metabolite('37350: cpd:C00909','','path:rno00590;path:rn00590;path:ec00590','KEGGMAP','IMPD').
metabolite('37344: cpd:C06241','','path:rno00520;path:ec00520;path:rn00520','KEGGMAP','IMPD').
metabolite('37346: cpd:C02198','','path:rno00590;path:rn00590;path:ec00590','KEGGMAP','IMPD').
metabolite('37347: cpd:C01261','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37358: cpd:C01203','','path:rn00061;path:rno00061;path:ec00061','KEGGMAP','IMPD').
metabolite('37352: cpd:C00822','','path:rno00350;path:ec00350;path:rn00350','KEGGMAP','IMPD').
metabolite('37353: cpd:C00128','','path:rno00520;path:ec00520;path:rn00520','KEGGMAP','IMPD').
metabolite('37354: cpd:C02165','','path:rno00590;path:rn00590;path:ec00590','KEGGMAP','IMPD').
metabolite('37355: cpd:C00121','','path:ec00030;path:rno00030;path:rn00030','KEGGMAP','IMPD').
metabolite('37335: cpd:C16360','','path:rn00232;path:ec00232;path:rno00232','KEGGMAP','IMPD').
metabolite('37334: cpd:C00645','','path:rno00520;path:ec00520;path:rn00520','KEGGMAP','IMPD').
metabolite('37332: cpd:C03021','','path:ec00510;path:rn00510;path:rno00510','KEGGMAP','IMPD').
metabolite('37331: cpd:C00483','','path:rno00350;path:rn00950;path:ec00350;path:rn00350;path:ec00950','KEGGMAP','IMPD').
metabolite('37330: cpd:C04501','','path:rno00520;path:ec00520;path:rn00520','KEGGMAP','IMPD').
metabolite('37329: cpd:C16365','','path:rn00232;path:ec00232;path:rno00232','KEGGMAP','IMPD').
metabolite('37328: gl:G00047','','path:rn00601;path:ec00601;path:rno00601','KEGGMAP','IMPD').
metabolite('37343: cpd:C00381','','path:ec00510;path:rn00510;path:rno00510','KEGGMAP','IMPD').
metabolite('37341: cpd:C00942','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37340: cpd:C04257','','path:rno00520;path:ec00520;path:rn00520','KEGGMAP','IMPD').
metabolite('37339: cpd:C00110','','path:ec00510;path:rn00510;path:rno00510','KEGGMAP','IMPD').
metabolite('37337: cpd:C05350','','path:rno00350;path:ec00350;path:rn00350','KEGGMAP','IMPD').
metabolite('37336: cpd:C03862','','path:ec00510;path:rn00510;path:rno00510','KEGGMAP','IMPD').
metabolite('37318: cpd:C04677','','path:ec00230;path:rn00230;path:rno00230;path:rn00340','KEGGMAP','IMPD').
metabolite('37316: cpd:C03758','','path:rno00350;path:rn00950;path:ec00350;path:rn00350;path:ec00950','KEGGMAP','IMPD').
metabolite('37314: cpd:C01236','','path:ec00030;path:rno00030;path:rn00030','KEGGMAP','IMPD').
metabolite('37312: cpd:C07480','','path:rn00232;path:ec00232;path:rno00232','KEGGMAP','IMPD').
metabolite('37313: cpd:C03838','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37326: cpd:C01246','','path:ec00510;path:rn00510;path:rno00510','KEGGMAP','IMPD').
metabolite('37327: cpd:C01344','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37324: cpd:C16353','','path:rn00232;path:ec00232;path:rno00232','KEGGMAP','IMPD').
metabolite('37325: cpd:C03765','','path:rno00350;path:rn00950;path:ec00350;path:rn00350;path:ec00950','KEGGMAP','IMPD').
metabolite('37322: cpd:C00357','','path:rno00520;path:ec00520;path:rn00520','KEGGMAP','IMPD').
metabolite('37321: cpd:C05587','','path:rno00350;path:ec00350;path:rn00350','KEGGMAP','IMPD').
metabolite('37388: gl:G00017','','path:ec00513;path:ec00510;path:rn00513;path:rn00510;path:rno00510','KEGGMAP','IMPD').
metabolite('37391: gl:G00016','','path:ec00513;path:ec00510;path:rn00513;path:rn00510;path:rno00510','KEGGMAP','IMPD').
metabolite('37390: gl:G00007','','path:ec00510;path:rn00510;path:rno00510','KEGGMAP','IMPD').
metabolite('37385: cpd:C05984','','path:ec00640;path:rn00640;path:rno00640','KEGGMAP','IMPD').
metabolite('37384: cpd:C06049','','path:rn00630;path:rno00630;path:ec00630','KEGGMAP','IMPD').
metabolite('37387: gl:G00008','','path:ec00510;path:rn00510;path:rno00510','KEGGMAP','IMPD').
metabolite('37381: gl:G00006','','path:ec00510;path:rn00510;path:rno00510','KEGGMAP','IMPD').
metabolite('37383: gl:G00005','','path:ec00510;path:rn00510;path:rno00510','KEGGMAP','IMPD').
metabolite('37377: gl:G00003','','path:ec00510;path:rn00510;path:rno00510','KEGGMAP','IMPD').
metabolite('37376: gl:G00004','','path:ec00510;path:rn00510;path:rno00510','KEGGMAP','IMPD').
metabolite('37379: cpd:C05985','','path:ec00640;path:rn00640;path:rno00640','KEGGMAP','IMPD').
metabolite('37404: gl:G00019','','path:ec00510;path:rn00510;path:rno00510','KEGGMAP','IMPD').
metabolite('37407: gl:G00020','','path:ec00510;path:rn00510;path:rno00510','KEGGMAP','IMPD').
metabolite('37402: gl:G00018','','path:ec00510;path:rn00510;path:rno00510','KEGGMAP','IMPD').
metabolite('37403: cpd:C00988','','path:rno00630;path:rn00630;path:ec00630','KEGGMAP','IMPD').
metabolite('37396: cpd:C00886','','path:rno00970;path:rn00970;path:ec00970','KEGGMAP','IMPD').
metabolite('37397: cpd:C01931','','path:rno00970;path:rn00970;path:ec00970','KEGGMAP','IMPD').
metabolite('37392: cpd:C00021','','path:ec00270;path:rn00270;path:rno00270','KEGGMAP','IMPD').
metabolite('37393: gl:G00171','','path:ec00510;path:rn00510;path:rno00510','KEGGMAP','IMPD').
metabolite('37395: gl:G00009','','path:ec00510;path:rn00510;path:rno00510','KEGGMAP','IMPD').
metabolite('37422: cpd:C14812','','path:rno00590;path:rn00590;path:ec00590','KEGGMAP','IMPD').
metabolite('37421: gl:G00072','','path:rn00601;path:ec00601;path:rno00601','KEGGMAP','IMPD').
metabolite('37420: cpd:C02412','','path:rno00970;path:rn00970;path:ec00970','KEGGMAP','IMPD').
metabolite('37419: gl:G00073','','path:rn00601;path:ec00601;path:rno00601','KEGGMAP','IMPD').
metabolite('37417: cpd:C06424','','path:rn00061;path:rno00061;path:ec00061','KEGGMAP','IMPD').
metabolite('37415: cpd:C02679','','path:rn00061;path:rno00061;path:ec00061','KEGGMAP','IMPD').
metabolite('37414: cpd:C02839','','path:rno00970;path:rn00970;path:ec00970','KEGGMAP','IMPD').
metabolite('37412: cpd:C02992','','path:rno00970;path:rn00970;path:ec00970','KEGGMAP','IMPD').
metabolite('37411: gl:G00022','','path:ec00510;path:rn00510;path:rno00510','KEGGMAP','IMPD').
metabolite('37410: cpd:C03512','','path:rn00380;path:rno00380;path:rno00970;path:rn00970;path:ec00380;path:ec00970','KEGGMAP','IMPD').
metabolite('37408: gl:G00021','','path:ec00510;path:rn00510;path:rno00510','KEGGMAP','IMPD').
metabolite('37438: cpd:C02984','','path:rno00970;path:rn00970;path:ec00970','KEGGMAP','IMPD').
metabolite('37439: gl:G00074','','path:rn00601;path:ec00601;path:rno00601','KEGGMAP','IMPD').
metabolite('37436: gl:G00075','','path:rn00601;path:ec00601;path:rno00601','KEGGMAP','IMPD').
metabolite('37434: cpd:C02553','','path:rno00970;path:rn00970;path:ec00970','KEGGMAP','IMPD').
metabolite('37432: cpd:C00760','','path:ec00500;path:rn00500;path:rno00500','KEGGMAP','IMPD').
metabolite('37433: gl:G00083','','path:rn00601;path:ec00601;path:rno00601','KEGGMAP','IMPD').
metabolite('37429: gl:G00082','','path:rn00601;path:ec00601;path:rno00601','KEGGMAP','IMPD').
metabolite('37426: cpd:C02702','','path:rno00970;path:rn00970;path:ec00970','KEGGMAP','IMPD').
metabolite('37427: gl:G10596','','path:ec00510;path:rn00510;path:rno00510','KEGGMAP','IMPD').
metabolite('37424: gl:G00071','','path:rn00601;path:ec00601;path:rno00601','KEGGMAP','IMPD').
metabolite('37448: cpd:C02987','','path:rn00860;path:ec00860;path:rno00860;path:rno00970;path:rn00970;path:ec00970','KEGGMAP','IMPD').
metabolite('37451: gl:G00055','','path:rn00601;path:ec00601;path:rno00601','KEGGMAP','IMPD').
metabolite('37450: gl:G00056','','path:rn00601;path:ec00601;path:rno00601','KEGGMAP','IMPD').
metabolite('37452: cpd:C14748','','path:rno00590;path:rn00590;path:ec00590','KEGGMAP','IMPD').
metabolite('37455: gl:G00081','','path:rn00601;path:ec00601;path:rno00601','KEGGMAP','IMPD').
metabolite('37454: cpd:C03294','','path:rno00970;path:rn00970;path:ec00970','KEGGMAP','IMPD').
metabolite('37440: gl:G00068','','path:rn00601;path:ec00601;path:rno00601','KEGGMAP','IMPD').
metabolite('37443: cpd:C00252','','path:ec00500;path:rn00500;path:rno00500','KEGGMAP','IMPD').
metabolite('37445: gl:G00076','','path:rn00601;path:ec00601;path:rno00601','KEGGMAP','IMPD').
metabolite('37465: gl:G00059','','path:rn00601;path:ec00601;path:rno00601','KEGGMAP','IMPD').
metabolite('37466: cpd:C14773','','path:rno00590;path:rn00590;path:ec00590','KEGGMAP','IMPD').
metabolite('37468: gl:G00054','','path:rn00601;path:ec00601;path:rno00601','KEGGMAP','IMPD').
metabolite('37469: cpd:C14772','','path:rno00590;path:rn00590;path:ec00590','KEGGMAP','IMPD').
metabolite('37458: cpd:C03289','','path:rn00053;path:ec00053;path:rno00053','KEGGMAP','IMPD').
metabolite('37459: cpd:C02430','','path:rno00970;path:rn00970;path:ec00970','KEGGMAP','IMPD').
metabolite('37461: gl:G00077','','path:rn00601;path:ec00601;path:rno00601','KEGGMAP','IMPD').
metabolite('37462: cpd:C14823','','path:rno00590;path:rn00590;path:ec00590','KEGGMAP','IMPD').
metabolite('37463: cpd:C03402','','path:rno00970;path:rn00970;path:ec00970','KEGGMAP','IMPD').
metabolite('37483: cpd:C02988','','path:rno00970;path:rn00970;path:ec00970','KEGGMAP','IMPD').
metabolite('37482: cpd:C14749','','path:rno00590;path:rn00590;path:ec00590','KEGGMAP','IMPD').
metabolite('37481: gl:G00052','','path:rn00601;path:ec00601;path:rno00601','KEGGMAP','IMPD').
metabolite('37480: cpd:C00185','','path:ec00500;path:rn00500;path:rno00500','KEGGMAP','IMPD').
metabolite('37486: gl:G00050','','path:rn00601;path:ec00601;path:rno00601','KEGGMAP','IMPD').
metabolite('37485: gl:G00036','','path:rn00601;path:ec00601;path:rno00601','KEGGMAP','IMPD').
metabolite('37473: cpd:C14775','','path:rno00590;path:rn00590;path:ec00590','KEGGMAP','IMPD').
metabolite('37479: gl:G00051','','path:rn00601;path:ec00601;path:rno00601','KEGGMAP','IMPD').
metabolite('37478: cpd:C03511','','path:rno00970;path:rn00970;path:ec00970','KEGGMAP','IMPD').
metabolite('37477: cpd:C14774','','path:rno00590;path:rn00590;path:ec00590','KEGGMAP','IMPD').
metabolite('37476: gl:G00058','','path:rn00601;path:ec00601;path:rno00601','KEGGMAP','IMPD').
metabolite('37498: cpd:C00559','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37499: cpd:C02163','','path:rno00970;path:rn00970;path:ec00970','KEGGMAP','IMPD').
metabolite('37497: cpd:C14814','','path:rno00590;path:rn00590;path:ec00590','KEGGMAP','IMPD').
metabolite('37503: cpd:C04734','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37500: cpd:C14782','','path:rno00590;path:rn00590;path:ec00590','KEGGMAP','IMPD').
metabolite('37501: cpd:C00360','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37490: cpd:C00369','','path:ec00500;path:rn00500;path:rno00500','KEGGMAP','IMPD').
metabolite('37489: cpd:C02282','','path:rno00970;path:rn00970;path:ec00970','KEGGMAP','IMPD').
metabolite('37494: cpd:C05512','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37495: cpd:C00718','','path:ec00500;path:rn00500;path:rno00500','KEGGMAP','IMPD').
metabolite('37492: cpd:C14778','','path:rno00590;path:rn00590;path:ec00590','KEGGMAP','IMPD').
metabolite('37508: cpd:C14768','','path:rno00590;path:rn00590;path:ec00590','KEGGMAP','IMPD').
metabolite('37511: cpd:C04392','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37504: cpd:C14769','','path:rno00590;path:rn00590;path:ec00590','KEGGMAP','IMPD').
metabolite('37505: cpd:C03125','','path:rno00970;path:rn00970;path:ec00970','KEGGMAP','IMPD').
metabolite('37512: cpd:C14771','','path:rno00590;path:rn00590;path:ec00590','KEGGMAP','IMPD').
metabolite('37514: cpd:C01798','','path:ec00500;path:rn00500;path:rno00500','KEGGMAP','IMPD').
metabolite('37515: cpd:C14770','','path:rno00590;path:rn00590;path:ec00590','KEGGMAP','IMPD').
metabolite('37525: cpd:C00831','','path:rn00770;path:rno00770;path:ec00770','KEGGMAP','IMPD').
metabolite('37524: cpd:C02530','','path:rn00100;path:rno00100;path:ec00100','KEGGMAP','IMPD').
metabolite('37522: cpd:C04079','','path:rn00770;path:rno00770;path:ec00770','KEGGMAP','IMPD').
metabolite('37533: gl:G00162','','path:ec00534;path:rn00534;path:rno00534','KEGGMAP','IMPD').
metabolite('37532: cpd:C01134','','path:rn00770;path:rno00770;path:ec00770','KEGGMAP','IMPD').
metabolite('37534: gl:G00164','','path:ec00534;path:rn00534;path:rno00534','KEGGMAP','IMPD').
metabolite('37531: gl:G00163','','path:ec00534;path:rn00534;path:rno00534','KEGGMAP','IMPD').
metabolite('37530: cpd:C00882','','path:rn00770;path:rno00770;path:ec00770','KEGGMAP','IMPD').
metabolite('37541: cpd:C05437','','path:rn00100;path:rno00100;path:ec00100','KEGGMAP','IMPD').
metabolite('37539: cpd:C04352','','path:rn00770;path:rno00770;path:ec00770','KEGGMAP','IMPD').
metabolite('37550: cpd:C01189','','path:rn00100;path:rno00100;path:ec00100','KEGGMAP','IMPD').
metabolite('37548: cpd:C01164','','path:rn00100;path:rno00100;path:ec00100;path:rn00981','KEGGMAP','IMPD').
metabolite('37544: cpd:C05103','','path:rn00100;path:rno00100;path:ec00100','KEGGMAP','IMPD').
metabolite('37553: cpd:C15816','','path:rn00100;path:rno00100;path:ec00100','KEGGMAP','IMPD').
metabolite('37567: cpd:C05439','','path:rn00100;path:rno00100;path:ec00100','KEGGMAP','IMPD').
metabolite('37575: cpd:C11522','','path:rn00100;path:rno00100;path:ec00100','KEGGMAP','IMPD').
metabolite('37578: cpd:C03845','','path:rn00100;path:rno00100;path:ec00100','KEGGMAP','IMPD').
metabolite('37584: cpd:C03492','','path:rn00770;path:rno00770;path:ec00770','KEGGMAP','IMPD').
metabolite('37590: cpd:C07481','','path:rn00232;path:ec00232;path:rno00232','KEGGMAP','IMPD').
metabolite('37610: cpd:C06213','','path:rn00380;path:rno00380;path:ec00380','KEGGMAP','IMPD').
metabolite('37611: cpd:C16359','','path:rn00232;path:ec00232;path:rno00232','KEGGMAP','IMPD').
metabolite('37608: cpd:C14819','','path:rn00860;path:ec00860;path:rno00860','KEGGMAP','IMPD').
metabolite('37609: cpd:C06212','','path:rn00380;path:rno00380;path:ec00380','KEGGMAP','IMPD').
metabolite('37615: cpd:C16355','','path:rn00232;path:ec00232;path:rno00232','KEGGMAP','IMPD').
metabolite('37613: cpd:C05653','','path:rn00380;path:rno00380;path:ec00380','KEGGMAP','IMPD').
metabolite('37619: cpd:C15519','','path:rn00120;path:rno00120;path:ec00120','KEGGMAP','IMPD').
metabolite('37617: cpd:C15610','','path:rn00120;path:rno00120;path:ec00120','KEGGMAP','IMPD').
metabolite('37623: cpd:C16361','','path:rn00232;path:ec00232;path:rno00232','KEGGMAP','IMPD').
metabolite('37622: cpd:C03594','','path:rn00120;path:rno00120;path:ec00120','KEGGMAP','IMPD').
metabolite('37627: cpd:C13550','','path:rn00120;path:rno00120;path:ec00120','KEGGMAP','IMPD').
metabolite('37626: cpd:C16362','','path:rn00232;path:ec00232;path:rno00232','KEGGMAP','IMPD').
metabolite('37625: cpd:C17333','','path:rn00120;path:rno00120;path:ec00120','KEGGMAP','IMPD').
metabolite('37624: cpd:C17336','','path:rn00120;path:rno00120;path:ec00120','KEGGMAP','IMPD').
metabolite('37629: cpd:C05455','','path:rn00120;path:rno00120;path:ec00120','KEGGMAP','IMPD').
metabolite('37628: cpd:C13747','','path:rn00232;path:ec00232;path:rno00232','KEGGMAP','IMPD').
metabolite('37662: cpd:C05444','','path:rn00120;path:rno00120;path:ec00120','KEGGMAP','IMPD').
metabolite('37663: cpd:C05130','','path:rno00340;path:ec00340;path:rn00340','KEGGMAP','IMPD').
metabolite('37660: cpd:C04895','','path:rno00790;path:ec00790;path:rn00790','KEGGMAP','IMPD').
metabolite('37661: cpd:C04244','','path:rno00790;path:ec00790;path:rn00790','KEGGMAP','IMPD').
metabolite('37658: cpd:C02835','','path:rno00340;path:ec00340;path:rn00340','KEGGMAP','IMPD').
metabolite('37659: cpd:C05452','','path:rn00120;path:rno00120;path:ec00120','KEGGMAP','IMPD').
metabolite('37656: cpd:C05467','','path:rn00120;path:rno00120;path:ec00120','KEGGMAP','IMPD').
metabolite('37657: cpd:C03684','','path:rno00790;path:ec00790;path:rn00790','KEGGMAP','IMPD').
metabolite('37654: cpd:C05460','','path:rn00120;path:rno00120;path:ec00120','KEGGMAP','IMPD').
metabolite('37653: gl:G00154','','path:rno00532;path:ec00532;path:rn00532','KEGGMAP','IMPD').
metabolite('37651: cpd:C17343','','path:rn00120;path:rno00120;path:ec00120','KEGGMAP','IMPD').
metabolite('37648: gl:G13041','','path:rno00531;path:ec00531;path:rn00531','KEGGMAP','IMPD').
metabolite('37647: cpd:C05552','','path:rno00780;path:ec00780;path:rn00780','KEGGMAP','IMPD').
metabolite('37642: cpd:C05921','','path:rno00780;path:ec00780;path:rn00780','KEGGMAP','IMPD').
metabolite('37638: cpd:C00925','','path:rno00531;path:ec00531;path:rn00531','KEGGMAP','IMPD').
metabolite('37636: cpd:C11556','','path:ec00562;path:rn00562;path:rno00562','KEGGMAP','IMPD').
metabolite('37632: cpd:C00120','','path:rno00780;path:ec00780;path:rn00780','KEGGMAP','IMPD').
metabolite('37693: cpd:C17337','','path:rn00120;path:rno00120;path:ec00120','KEGGMAP','IMPD').
metabolite('37694: cpd:C05544','','path:ec00310;path:rn00310;path:rno00310','KEGGMAP','IMPD').
metabolite('37695: cpd:C17335','','path:rn00120;path:rno00120;path:ec00120','KEGGMAP','IMPD').
metabolite('37688: gl:G00156','','path:rno00532;path:ec00532;path:rn00532','KEGGMAP','IMPD').
metabolite('37689: cpd:C01044','','path:rno00340;path:ec00340;path:rn00340','KEGGMAP','IMPD').
metabolite('37690: cpd:C05466','','path:rn00120;path:rno00120;path:ec00120','KEGGMAP','IMPD').
metabolite('37691: gl:G00155','','path:rno00532;path:ec00532;path:rn00532','KEGGMAP','IMPD').
metabolite('37686: cpd:C02528','','path:rn00120;path:rno00120;path:ec00120','KEGGMAP','IMPD').
metabolite('37680: cpd:C05465','','path:rn00120;path:rno00120;path:ec00120','KEGGMAP','IMPD').
metabolite('37681: gl:G00159','','path:rno00532;path:rn00532;path:ec00532','KEGGMAP','IMPD').
metabolite('37683: gl:G00158','','path:rno00532;path:ec00532;path:rn00532','KEGGMAP','IMPD').
metabolite('37676: cpd:C16236','','path:rno00785;path:rn00785;path:ec00785','KEGGMAP','IMPD').
metabolite('37678: gl:G00160','','path:rno00532;path:rn00532;path:ec00532','KEGGMAP','IMPD').
metabolite('37673: cpd:C16237','','path:rno00785;path:rn00785;path:ec00785','KEGGMAP','IMPD').
metabolite('37672: cpd:C17346','','path:rn00120;path:rno00120;path:ec00120','KEGGMAP','IMPD').
metabolite('37674: cpd:C05447','','path:rn00120;path:rno00120;path:ec00120','KEGGMAP','IMPD').
metabolite('37669: cpd:C00272','','path:rno00790;path:ec00790;path:rn00790','KEGGMAP','IMPD').
metabolite('37668: cpd:C04554','','path:rn00120;path:rno00120;path:ec00120','KEGGMAP','IMPD').
metabolite('37671: cpd:C17345','','path:rn00120;path:rno00120;path:ec00120','KEGGMAP','IMPD').
metabolite('37670: cpd:C01152','','path:rno00340;path:ec00340;path:rn00340','KEGGMAP','IMPD').
metabolite('37665: cpd:C00388','','path:rno00340;path:ec00340;path:rn00340','KEGGMAP','IMPD').
metabolite('37664: cpd:C05445','','path:rn00120;path:rno00120;path:ec00120','KEGGMAP','IMPD').
metabolite('37666: cpd:C00268','','path:rno00790;path:ec00790;path:rn00790','KEGGMAP','IMPD').
metabolite('37722: cpd:C06341','','path:rn00120;path:rno00120;path:ec00120','KEGGMAP','IMPD').
metabolite('37723: cpd:C02188','','path:ec00310;path:rn00310;path:rno00310','KEGGMAP','IMPD').
metabolite('37720: cpd:C16239','','path:rno00785;path:rn00785;path:ec00785','KEGGMAP','IMPD').
metabolite('37726: cpd:C00700','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37727: cpd:C01301','','path:rn00120;path:rno00120;path:ec00120','KEGGMAP','IMPD').
metabolite('37724: cpd:C00655','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37725: cpd:C04722','','path:rn00120;path:rno00120;path:ec00120','KEGGMAP','IMPD').
metabolite('37714: cpd:C05337','','path:rn00120;path:rno00120;path:ec00120','KEGGMAP','IMPD').
metabolite('37715: cpd:C05127','','path:rno00340;path:ec00340;path:rn00340','KEGGMAP','IMPD').
metabolite('37712: cpd:C05449','','path:rn00120;path:rno00120;path:ec00120','KEGGMAP','IMPD').
metabolite('37713: cpd:C00575','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37719: cpd:C05446','','path:rn00120;path:rno00120;path:ec00120','KEGGMAP','IMPD').
metabolite('37716: cpd:C01794','','path:rn00120;path:rno00120;path:ec00120','KEGGMAP','IMPD').
metabolite('37717: cpd:C00301','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37707: cpd:C05454','','path:rn00120;path:rno00120;path:ec00120','KEGGMAP','IMPD').
metabolite('37706: cpd:C17339','','path:rn00120;path:rno00120;path:ec00120','KEGGMAP','IMPD').
metabolite('37705: cpd:C04051','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37704: cpd:C04487','','path:ec00310;path:rn00310;path:rno00310','KEGGMAP','IMPD').
metabolite('37711: cpd:C15613','','path:rn00120;path:rno00120;path:ec00120','KEGGMAP','IMPD').
metabolite('37710: cpd:C05453','','path:rn00120;path:rno00120;path:ec00120','KEGGMAP','IMPD').
metabolite('37709: cpd:C16238','','path:rno00785;path:rn00785;path:ec00785','KEGGMAP','IMPD').
metabolite('37708: cpd:C03680','','path:rno00340;path:ec00340;path:rn00340','KEGGMAP','IMPD').
metabolite('37699: cpd:C17331','','path:rn00120;path:rno00120;path:ec00120','KEGGMAP','IMPD').
metabolite('37698: cpd:C05545','','path:ec00310;path:rn00310;path:rno00310','KEGGMAP','IMPD').
metabolite('37697: cpd:C06196','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37696: cpd:C17332','','path:rn00120;path:rno00120;path:ec00120','KEGGMAP','IMPD').
metabolite('37703: cpd:C05451','','path:rn00120;path:rno00120;path:ec00120','KEGGMAP','IMPD').
metabolite('37702: cpd:C06197','','path:ec00230;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('37701: cpd:C01211','','path:ec00310;path:rn00310;path:rno00310','KEGGMAP','IMPD').
metabolite('37700: cpd:C00785','','path:rno00340;path:ec00340;path:rn00340','KEGGMAP','IMPD').
metabolite('37752: cpd:C01204','','path:ec00562;path:rn00562;path:rno00562','KEGGMAP','IMPD').
metabolite('37754: cpd:C05999','','path:ec00561;path:rno00620;path:rn00620;path:rn00561;path:ec00620;path:rno00561','KEGGMAP','IMPD').
metabolite('37757: cpd:C01272','','path:ec00562;path:rn00562;path:rno00562','KEGGMAP','IMPD').
metabolite('37759: cpd:C11555','','path:ec00562;path:rn00562;path:rno00562','KEGGMAP','IMPD').
metabolite('37746: cpd:C00583','','path:ec00561;path:rno00620;path:rn00620;path:rn00561;path:ec00620;path:rno00561','KEGGMAP','IMPD').
metabolite('37747: cpd:C01243','','path:ec00562;path:rn00562;path:rno00562','KEGGMAP','IMPD').
metabolite('37749: cpd:C01245','','path:ec00562;path:rn00562;path:rno00562','KEGGMAP','IMPD').
metabolite('37750: cpd:C04409','','path:rn00380;path:rno00380;path:ec00380','KEGGMAP','IMPD').
metabolite('37737: cpd:C06148','','path:rno00790;path:ec00790;path:rn00790','KEGGMAP','IMPD').
metabolite('37736: cpd:C03692','','path:ec00561;path:rn00561;path:rno00561','KEGGMAP','IMPD').
metabolite('37738: cpd:C05645','','path:rn00380;path:rno00380;path:ec00380','KEGGMAP','IMPD').
metabolite('37740: cpd:C05637','','path:rn00380;path:rno00380;path:ec00380','KEGGMAP','IMPD').
metabolite('37742: cpd:C05922','','path:rno00790;path:ec00790;path:rn00790','KEGGMAP','IMPD').
metabolite('37728: cpd:C00012','','path:rno00330;path:ec00330;path:rn00330','KEGGMAP','IMPD').
metabolite('37731: cpd:C05636','','path:rn00380;path:rno00380;path:ec00380','KEGGMAP','IMPD').
metabolite('37732: cpd:C01885','','path:ec00561;path:rn00561;path:rno00561','KEGGMAP','IMPD').
metabolite('37734: cpd:C03227','','path:rn00380;path:rno00380;path:ec00380','KEGGMAP','IMPD').
metabolite('37782: cpd:C00695','','path:rn00120;path:rno00120;path:ec00120','KEGGMAP','IMPD').
metabolite('37780: cpd:C01252','','path:rn00380;path:rno00380;path:ec00380','KEGGMAP','IMPD').
metabolite('37778: cpd:C00328','','path:rn00380;path:rno00380;path:ec00380','KEGGMAP','IMPD').
metabolite('37776: cpd:C05448','','path:rn00120;path:rno00120;path:ec00120','KEGGMAP','IMPD').
metabolite('37789: gl:G13040','','path:rno00531;path:rn00531;path:ec00531','KEGGMAP','IMPD').
metabolite('37787: cpd:C09332','','path:rno00790;path:ec00790;path:rn00790','KEGGMAP','IMPD').
metabolite('37785: cpd:C01921','','path:rn00120;path:rno00120;path:ec00120','KEGGMAP','IMPD').
metabolite('37784: cpd:C03541','','path:rno00790;path:ec00790;path:rn00790','KEGGMAP','IMPD').
metabolite('37766: cpd:C15520','','path:rn00120;path:rno00120;path:ec00120','KEGGMAP','IMPD').
metabolite('37764: cpd:C00643','','path:rn00380;path:rno00380;path:ec00380','KEGGMAP','IMPD').
metabolite('37765: cpd:C00921','','path:rno00790;path:ec00790;path:rn00790','KEGGMAP','IMPD').
metabolite('37761: cpd:C11557','','path:ec00562;path:rn00562;path:rno00562','KEGGMAP','IMPD').
metabolite('37774: cpd:C05923','','path:rno00790;path:ec00790;path:rn00790','KEGGMAP','IMPD').
metabolite('37773: cpd:C02700','','path:rn00380;path:rno00380;path:ec00380','KEGGMAP','IMPD').
metabolite('37770: cpd:C04874','','path:rno00790;path:ec00790;path:rn00790','KEGGMAP','IMPD').
metabolite('37771: cpd:C15518','','path:rn00120;path:rno00120;path:ec00120','KEGGMAP','IMPD').
metabolite('37769: cpd:C05450','','path:rn00120;path:rno00120;path:ec00120','KEGGMAP','IMPD').
metabolite('37813: gl:G13043','','path:rno00531;path:rn00531;path:ec00531','KEGGMAP','IMPD').
metabolite('37812: gl:G13031','','path:rno00531;path:rn00531;path:ec00531','KEGGMAP','IMPD').
metabolite('37815: gl:G00872','','path:rno00531;path:rn00531;path:ec00531','KEGGMAP','IMPD').
metabolite('37808: gl:G06780','','path:rno00531;path:rn00531;path:ec00531','KEGGMAP','IMPD').
metabolite('37810: gl:G02632','','path:rno00531;path:rn00531;path:ec00531','KEGGMAP','IMPD').
metabolite('37821: gl:G12336','','path:rno00531;path:ec00531;path:rn00531','KEGGMAP','IMPD').
metabolite('37818: gl:G13042','','path:rno00531;path:ec00531;path:rn00531','KEGGMAP','IMPD').
metabolite('37797: gl:G13038','','path:rno00531;path:ec00531;path:rn00531','KEGGMAP','IMPD').
metabolite('37799: gl:G13039','','path:rno00531;path:ec00531;path:rn00531','KEGGMAP','IMPD').
metabolite('37793: gl:G09660','','path:rno00531;path:rn00531;path:ec00531','KEGGMAP','IMPD').
metabolite('37806: cpd:C01277','','path:ec00562;path:rn00562;path:rno00562','KEGGMAP','IMPD').
metabolite('37801: cpd:C05981','','path:ec00562;path:rn00562;path:rno00562','KEGGMAP','IMPD').
metabolite('37803: gl:G13032','','path:rno00531;path:rn00531;path:ec00531','KEGGMAP','IMPD').
metabolite('37843: cpd:C01284','','path:ec00562;path:rn00562;path:rno00562','KEGGMAP','IMPD').
metabolite('37842: cpd:C00637','','path:rn00380;path:rno00380;path:ec00380','KEGGMAP','IMPD').
metabolite('37840: cpd:C04063','','path:ec00562;path:rn00562;path:rno00562','KEGGMAP','IMPD').
metabolite('37847: cpd:C00954','','path:rn00380;path:rno00380;path:ec00380','KEGGMAP','IMPD').
metabolite('37850: cpd:C05643','','path:rn00380;path:rno00380;path:ec00380','KEGGMAP','IMPD').
metabolite('37848: cpd:C01220','','path:ec00562;path:rn00562;path:rno00562','KEGGMAP','IMPD').
metabolite('37853: cpd:C01598','','path:rn00380;path:rno00380;path:ec00380','KEGGMAP','IMPD').
metabolite('37852: cpd:C04520','','path:ec00562;path:rn00562;path:rno00562','KEGGMAP','IMPD').
metabolite('37826: cpd:C00398','','path:rn00380;path:ec00901;path:rno00380;path:rn00901;path:ec00380','KEGGMAP','IMPD').
metabolite('37824: gl:G13036','','path:rno00531;path:ec00531;path:rn00531','KEGGMAP','IMPD').
metabolite('37831: cpd:C05660','','path:rn00380;path:rno00380;path:ec00380','KEGGMAP','IMPD').
metabolite('37828: gl:G13037','','path:rno00531;path:ec00531;path:rn00531','KEGGMAP','IMPD').
metabolite('37834: gl:G13035','','path:rno00531;path:rn00531;path:ec00531','KEGGMAP','IMPD').
metabolite('37832: gl:G13034','','path:rno00531;path:rn00531;path:ec00531','KEGGMAP','IMPD').
metabolite('37873: cpd:C04637','','path:ec00562;path:rn00562;path:rno00562','KEGGMAP','IMPD').
metabolite('37872: cpd:C05647','','path:rn00380;path:rno00380;path:ec00380','KEGGMAP','IMPD').
metabolite('37875: cpd:C05640','','path:rn00380;path:rno00380;path:ec00380','KEGGMAP','IMPD').
metabolite('37877: cpd:C05634','','path:rn00380;path:rno00380;path:ec00380','KEGGMAP','IMPD').
metabolite('37876: cpd:C03546','','path:ec00562;path:rn00562;path:rno00562','KEGGMAP','IMPD').
metabolite('37878: cpd:C00780','','path:rn00380;path:rno00380;path:ec00380','KEGGMAP','IMPD').
metabolite('37856: cpd:C00331','','path:rn00380;path:rno00380;path:ec00380','KEGGMAP','IMPD').
metabolite('37859: cpd:C04477','','path:ec00562;path:rn00562;path:rno00562','KEGGMAP','IMPD').
metabolite('37861: cpd:C05642','','path:rn00380;path:rno00380;path:ec00380','KEGGMAP','IMPD').
metabolite('37864: cpd:C05635','','path:rn00380;path:rno00380;path:ec00380','KEGGMAP','IMPD').
metabolite('37865: cpd:C01177','','path:ec00562;path:rn00562;path:rno00562','KEGGMAP','IMPD').
metabolite('37867: gl:G08421','','path:rno00531;path:ec00531;path:rn00531','KEGGMAP','IMPD').
metabolite('37868: cpd:C00978','','path:rn00380;path:rno00380;path:ec00380','KEGGMAP','IMPD').
metabolite('37869: cpd:C04549','','path:ec00562;path:rn00562;path:rno00562','KEGGMAP','IMPD').
metabolite('37871: gl:G13033','','path:rno00531;path:rn00531;path:ec00531','KEGGMAP','IMPD').
metabolite('36303: cpd:C18125','','path:ec00564;path:rn00564;path:rno00564','KEGGMAP','IMPD').
metabolite('36300: cpd:C01013','','path:ec00640;path:rn00410;path:ec00410;path:ec00720;path:rn00640;path:rno00410;path:rno00640;path:rn00720','KEGGMAP','IMPD').
metabolite('37987: cpd:C16680','','path:ec00830;path:rn00830;path:rno00830','KEGGMAP','IMPD').
metabolite('36299: cpd:C16619','','path:ec00983;path:rno00983;path:rn00983','KEGGMAP','IMPD').
metabolite('36298: cpd:C00020','','path:ec00230;path:rn00230;path:rno00230;path:ec00908;path:rn00908','KEGGMAP','IMPD').
metabolite('36297: cpd:C15606','','path:ec00270;path:rn00270;path:rno00270','KEGGMAP','IMPD').
metabolite('36296: cpd:C00631','','path:rn00680;path:ec00030;path:ec00010;path:rno00010;path:rn00010;path:rn00030;path:ec00680','KEGGMAP','IMPD').
metabolite('37999: cpd:C05946','','path:rno00330;path:ec00330;path:rn00330','KEGGMAP','IMPD').
metabolite('36295: dr:D08603 cpd:C07648','','path:ec00983;path:rno00983;path:rn00983','KEGGMAP','IMPD').
metabolite('36294: cpd:C11131','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36292: cpd:C08276','','path:ec00270;path:rn00270;path:rno00270','KEGGMAP','IMPD').
metabolite('36291: cpd:C02512','','path:ec00460;path:rn00460;path:rno00460','KEGGMAP','IMPD').
metabolite('36290: cpd:C16615','','path:ec00983;path:rno00983;path:rn00983','KEGGMAP','IMPD').
metabolite('37992: cpd:C05774','','path:rn00860;path:ec00860;path:rno00860','KEGGMAP','IMPD').
metabolite('36288: cpd:C16620','','path:ec00983;path:rno00983;path:rn00983','KEGGMAP','IMPD').
metabolite('36318: cpd:C03267','','path:rno00051;path:rn00051;path:ec00051','KEGGMAP','IMPD').
metabolite('36319: cpd:C05301','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36316: cpd:C06250','','path:rno00780;path:rn00061;path:ec00780;path:rno00061;path:rn00780;path:ec00061','KEGGMAP','IMPD').
metabolite('38002: cpd:C01157','','path:rno00330;path:ec00330;path:rn00330','KEGGMAP','IMPD').
metabolite('38003: cpd:C01165','','path:rno00330;path:ec00330;path:rn00330','KEGGMAP','IMPD').
metabolite('36315: cpd:C05302','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('38000: cpd:C05947','','path:rno00330;path:ec00330;path:rn00330','KEGGMAP','IMPD').
metabolite('38001: cpd:C04281','','path:rno00330;path:ec00330;path:rn00330','KEGGMAP','IMPD').
metabolite('36313: cpd:C04419','','path:rn00061;path:rno00061;path:ec00061','KEGGMAP','IMPD').
metabolite('36308: cpd:C07585','','path:ec00983;path:rno00983;path:rn00983','KEGGMAP','IMPD').
metabolite('36307: cpd:C05504','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36305: cpd:C00275','','path:rno00520;path:rno00051;path:rn00051;path:ec00051;path:ec00520;path:rn00520','KEGGMAP','IMPD').
metabolite('37957: cpd:C00899','','path:ec00830;path:rn00830;path:rno00830','KEGGMAP','IMPD').
metabolite('36332: cpd:C16604','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('36335: cpd:C04233','','path:ec00564;path:rn00564;path:rno00564','KEGGMAP','IMPD').
metabolite('36334: cpd:C05535','','path:ec00300;path:rno00300;path:rn00300','KEGGMAP','IMPD').
metabolite('36329: cpd:C01094','','path:rno00051;path:rn00051;path:ec00051','KEGGMAP','IMPD').
metabolite('37952: cpd:C02075 cpd:C02588','','path:ec00830;path:rn00830;path:rno00830','KEGGMAP','IMPD').
metabolite('36328: cpd:C00320','','path:rn00920;path:ec00270;path:rn00270;path:ec00920;path:rno00270','KEGGMAP','IMPD').
metabolite('36331: cpd:C05299','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('37965: cpd:C16682','','path:ec00830;path:rn00830;path:rno00830','KEGGMAP','IMPD').
metabolite('36325: cpd:C16613','','path:ec00983;path:rno00983;path:rn00983','KEGGMAP','IMPD').
metabolite('36324: cpd:C16617','','path:ec00983;path:rno00983;path:rn00983','KEGGMAP','IMPD').
metabolite('36327: cpd:C11132','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36326: cpd:C18126','','path:ec00564;path:rn00564;path:rno00564','KEGGMAP','IMPD').
metabolite('37961: cpd:C02110','','path:ec00830;path:rn00830;path:rno00830','KEGGMAP','IMPD').
metabolite('36320: cpd:C07447','','path:ec00983;path:rno00983;path:rn00983','KEGGMAP','IMPD').
metabolite('36323: cpd:C00094','','path:rn00920;path:ec00270;path:ec00430;path:rn00270;path:ec00920;path:rn00430;path:rno00270;path:rno00920','KEGGMAP','IMPD').
metabolite('37962: cpd:C16681','','path:ec00830;path:rn00830;path:rno00830','KEGGMAP','IMPD').
metabolite('36322: cpd:C05298','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36348: cpd:C00449','','path:ec00310;path:rn00310;path:ec00300;path:rno00310;path:rno00300;path:rn00300','KEGGMAP','IMPD').
metabolite('36349: cpd:C11133','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('37974: cpd:C16679','','path:ec00830;path:rn00830;path:rno00830','KEGGMAP','IMPD').
metabolite('36350: dr:D00358 cpd:C07073','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('36351: cpd:C03819','','path:ec00564;path:rn00564;path:rno00564','KEGGMAP','IMPD').
metabolite('36344: cpd:C01516;dr:D08233 cpd:C01516','','path:ec00982;path:rn00950;path:rno00982;path:ec00950;path:rn00982','KEGGMAP','IMPD').
metabolite('36345: cpd:C00956','','path:rn00311;path:ec00310;path:rn00310;path:ec00300;path:rno00310;path:rno00300;path:ec00311;path:rn00300','KEGGMAP','IMPD').
metabolite('37970: cpd:C15493','','path:ec00830;path:rn00830;path:rno00830','KEGGMAP','IMPD').
metabolite('36346: cpd:C18129','','path:ec00564;path:rn00564;path:rno00564','KEGGMAP','IMPD').
metabolite('36340: cpd:C04076','','path:ec00960;path:ec00310;path:rn00310;path:ec00300;path:rno00310;path:rno00300;path:rn00300;path:rn00960','KEGGMAP','IMPD').
metabolite('36343: cpd:C05141','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36337: cpd:C05300','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36338: cpd:C16560','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('36339: cpd:C00040','','path:ec00561;path:ec00564;path:rn00564;path:rn00561;path:rno00564;path:rno00561','KEGGMAP','IMPD').
metabolite('36235: cpd:C03715','','path:ec00565;path:rn00565;path:rno00565','KEGGMAP','IMPD').
metabolite('36234: cpd:C00800','','path:rno00040;path:rn00053;path:ec00040;path:rn00040;path:ec00053;path:rno00053','KEGGMAP','IMPD').
metabolite('37921: cpd:C15492','','path:ec00830;path:rn00830;path:rno00830','KEGGMAP','IMPD').
metabolite('36233: cpd:C00217','','path:rn00471;path:ec00471;path:ec00750;path:rno00471;path:rn00750','KEGGMAP','IMPD').
metabolite('36232: cpd:C06126','','path:rn00600;path:ec00600;path:rno00600','KEGGMAP','IMPD').
metabolite('36239: cpd:C00181','','path:rno00040;path:ec00040;path:ec00500;path:rn00040;path:rn00500;path:ec00520;path:rn00520','KEGGMAP','IMPD').
metabolite('36238: cpd:C00124','','path:rno00520;path:rno00052;path:rn00052;path:ec00052;path:ec00520;path:rn00520','KEGGMAP','IMPD').
metabolite('37925: cpd:C03455','','path:ec00830;path:rn00830;path:rno00830','KEGGMAP','IMPD').
metabolite('36237: cpd:C06128','','path:rn00600;path:ec00600;path:rno00600','KEGGMAP','IMPD').
metabolite('37930: cpd:C03440','','path:rno00330;path:ec00330;path:rn00330','KEGGMAP','IMPD').
metabolite('37929: cpd:C05639','','path:rn00380;path:rno00380;path:ec00380','KEGGMAP','IMPD').
metabolite('36224: dr:D07704 cpd:C07572','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('37935: cpd:C04282','','path:rno00330;path:ec00330;path:rn00330','KEGGMAP','IMPD').
metabolite('36231: cpd:C05212','','path:ec00565;path:rn00565;path:rno00565','KEGGMAP','IMPD').
metabolite('37934: cpd:C05638','','path:rn00380;path:rno00380;path:ec00380','KEGGMAP','IMPD').
metabolite('36229: cpd:C06127','','path:rn00600;path:ec00600;path:rno00600','KEGGMAP','IMPD').
metabolite('37932: cpd:C11061','','path:ec00830;path:rn00830;path:rno00830','KEGGMAP','IMPD').
metabolite('36228: cpd:C00191','','path:rno00040;path:ec00040;path:rn00562;path:ec00053;path:rn00500;path:ec00520;path:rno00562;path:rn00520;path:ec00562;path:rn00053;path:ec00500;path:rn00040;path:rno00500;path:rno00053','KEGGMAP','IMPD').
metabolite('37938: cpd:C05651','','path:rn00380;path:rno00380;path:ec00380','KEGGMAP','IMPD').
metabolite('36250: cpd:C05859','','path:ec00900;path:rn00900;path:rno00900','KEGGMAP','IMPD').
metabolite('36251: cpd:C15645','','path:ec00565;path:rn00565;path:rno00565','KEGGMAP','IMPD').
metabolite('37936: cpd:C16677','','path:ec00830;path:rn00830;path:rno00830','KEGGMAP','IMPD').
metabolite('36254: cpd:C15646','','path:ec00565;path:rn00565;path:rno00565','KEGGMAP','IMPD').
metabolite('36255: cpd:C02686','','path:rn00600;path:ec00600;path:rno00600','KEGGMAP','IMPD').
metabolite('37941: cpd:C00376','','path:ec00830;path:rn00830;path:rno00830','KEGGMAP','IMPD').
metabolite('36242: cpd:C00199','','path:rno00040;path:ec00040;path:ec00740;path:ec00030;path:rno00030;path:ec00710;path:ec00680;path:rn00680;path:rn00040;path:ec00750;path:rn00740;path:rn00710;path:rn00750;path:rn00030','KEGGMAP','IMPD').
metabolite('36243: cpd:C02934','','path:rn00600;path:ec00600;path:rno00600','KEGGMAP','IMPD').
metabolite('36240: cpd:C06125','','path:rn00600;path:ec00600;path:rno00600','KEGGMAP','IMPD').
metabolite('37950: cpd:C06037','','path:ec00561;path:rn00561;path:rno00561','KEGGMAP','IMPD').
metabolite('36246: cpd:C00231','','path:rno00040;path:rn00680;path:rn00053;path:ec00040;path:ec00030;path:rn00040;path:ec00053;path:ec00710;path:rno00030;path:rn00710;path:rn00030;path:ec00680','KEGGMAP','IMPD').
metabolite('37948: cpd:C00777','','path:ec00830;path:rn00830;path:rno00830','KEGGMAP','IMPD').
metabolite('36244: cpd:C16586','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('36265: cpd:C04756','','path:ec00565;path:rn00565;path:rno00565','KEGGMAP','IMPD').
metabolite('36264: cpd:C04317','','path:ec00565;path:rn00565;path:rno00565','KEGGMAP','IMPD').
metabolite('36267: dr:D04931 cpd:C02380','','path:ec00983;path:rno00983;path:rn00983','KEGGMAP','IMPD').
metabolite('36266: cpd:C00008','','path:rn00680;path:ec00230;path:rn00230;path:rno00230;path:rn00908;path:ec00680','KEGGMAP','IMPD').
metabolite('36269: cpd:C02336','','path:rno00520;path:ec00500;path:rn00500;path:ec00520;path:rno00500;path:rn00520','KEGGMAP','IMPD').
metabolite('36268: cpd:C15650','','path:ec00270;path:rn00270;path:rno00270','KEGGMAP','IMPD').
metabolite('37895: cpd:C00473','','path:ec00830;path:rn00830;path:rno00830','KEGGMAP','IMPD').
metabolite('36270: cpd:C02170','','path:ec00640;path:rno00280;path:ec00240;path:rn00640;path:rn00280;path:rn00240;path:ec00280','KEGGMAP','IMPD').
metabolite('36257: cpd:C00195','','path:rn00600;path:ec00600;path:rno00600','KEGGMAP','IMPD').
metabolite('36258: cpd:C00160','','path:rn00361;path:rn00630;path:rno00630;path:ec00361;path:ec00625;path:rn00625;path:ec00630','KEGGMAP','IMPD').
metabolite('36261: cpd:C00319','','path:rn00600;path:ec00600;path:rno00600','KEGGMAP','IMPD').
metabolite('36260: cpd:C16553','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('36263: cpd:C00310','','path:rno00040;path:ec00040;path:rn00040','KEGGMAP','IMPD').
metabolite('36262: cpd:C01233','','path:ec00564;path:ec00565;path:rn00564;path:rn00565;path:rno00564','KEGGMAP','IMPD').
metabolite('36280: cpd:C04188','','path:ec00270;path:rn00270;path:rno00270','KEGGMAP','IMPD').
metabolite('36282: cpd:C06114','','path:ec00460;path:rn00460;path:rno00460','KEGGMAP','IMPD').
metabolite('36283: cpd:C00346','','path:ec00564;path:rn00564;path:rn00600;path:rno00564;path:ec00600;path:rno00600','KEGGMAP','IMPD').
metabolite('36284: cpd:C01213','','path:ec00640;path:rno00280;path:ec00720;path:rn00640;path:rn00280;path:rno00630;path:rn00630;path:rno00640;path:ec00280;path:rn00720;path:ec00630','KEGGMAP','IMPD').
metabolite('37910: cpd:C00422','','path:ec00561;path:rn00561;path:rno00561','KEGGMAP','IMPD').
metabolite('36286: cpd:C15647','','path:ec00565;path:rn00565;path:rno00565','KEGGMAP','IMPD').
metabolite('36287: cpd:C05503','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36272: cpd:C01190','','path:rn00600;path:ec00600;path:rno00600','KEGGMAP','IMPD').
metabolite('36273: cpd:C16618','','path:ec00983;path:rno00983;path:rn00983','KEGGMAP','IMPD').
metabolite('36274: cpd:C04582','','path:ec00270;path:rn00270;path:rno00270','KEGGMAP','IMPD').
metabolite('36276: cpd:C06002','','path:ec00640;path:rno00280;path:rn00633;path:rn00640;path:rn00280;path:rno00640;path:ec00280;path:ec00633','KEGGMAP','IMPD').
metabolite('36278: cpd:C03090','','path:ec00250;path:ec00230;path:rn00230;path:rno00250;path:rn00250;path:rno00230','KEGGMAP','IMPD').
metabolite('37919: cpd:C05648','','path:rn00380;path:rno00380;path:ec00380','KEGGMAP','IMPD').
metabolite('36279: cpd:C01120','','path:rn00600;path:ec00600;path:rno00600','KEGGMAP','IMPD').
metabolite('38127: cpd:C01079','','path:rn00860;path:ec00860;path:rno00860','KEGGMAP','IMPD').
metabolite('36167: cpd:C00418','','path:ec00900;path:rn00900;path:rno00900','KEGGMAP','IMPD').
metabolite('36164: cpd:C00222','','path:ec00410;path:ec00720;path:rn00562;path:rn00640;path:rno00410;path:rno00640;path:ec00625;path:rno00562;path:ec00640;path:rn00410;path:ec00562;path:rn00625;path:rn00720','KEGGMAP','IMPD').
metabolite('36165: cpd:C01107','','path:ec00900;path:rn00900;path:rno00900','KEGGMAP','IMPD').
metabolite('36162: cpd:C00315','','path:rn00940;path:ec00410;path:rn00410;path:rno00330;path:rno00410;path:ec00480;path:ec00330;path:rno00480;path:rn00330;path:rn00480','KEGGMAP','IMPD').
metabolite('38123: cpd:C02191','','path:rn00860;path:ec00860;path:rno00860','KEGGMAP','IMPD').
metabolite('36163: cpd:C02630','','path:rn00650;path:rno00650;path:ec00650;path:ec00660;path:rn00660','KEGGMAP','IMPD').
metabolite('36161: cpd:C01143','','path:ec00900;path:rn00900;path:rno00900','KEGGMAP','IMPD').
metabolite('36174: cpd:C00103','','path:rno00520;path:rno00052;path:rno00040;path:ec00040;path:ec00010;path:rn00523;path:ec00523;path:ec00052;path:ec00521;path:rn00500;path:ec00520;path:rn00521;path:rn00520;path:rn00052;path:ec00500;path:rno00010;path:rn00040;path:rn00010;path:rno00500','KEGGMAP','IMPD').
metabolite('36175: cpd:C00668','','path:rno00520;path:rno00052;path:ec00030;path:ec00010;path:ec00052;path:rn00500;path:ec00520;path:rno00030;path:rn00520;path:rn00052;path:ec00500;path:rno00010;path:rn00010;path:rno00500;path:rn00030','KEGGMAP','IMPD').
metabolite('38116: cpd:C00486','','path:rn00860;path:ec00860;path:rno00860','KEGGMAP','IMPD').
metabolite('36172: cpd:C00072','','path:rn00053;path:ec00480;path:ec00053;path:rn00480;path:rno00053','KEGGMAP','IMPD').
metabolite('36173: cpd:C00532','','path:rno00040;path:ec00040;path:rn00040','KEGGMAP','IMPD').
metabolite('36170: cpd:C00092','','path:ec00562;path:rn00562;path:ec00500;path:ec00521;path:rn00500;path:rn00524;path:rno00524;path:rn00521;path:rno00562;path:ec00524','KEGGMAP','IMPD').
metabolite('36171: cpd:C03012','','path:rn00624;path:rno00980;path:ec00624;path:ec00626;path:ec00980;path:rn00980;path:rn00626','KEGGMAP','IMPD').
metabolite('38112: cpd:C03287','','path:rno00330;path:ec00330;path:rn00330','KEGGMAP','IMPD').
metabolite('36169: cpd:C00227','','path:ec00720;path:rn00680;path:rno00620;path:rn00620;path:ec00430;path:ec00620;path:rn00430;path:rn00720;path:ec00680','KEGGMAP','IMPD').
metabolite('38143: cpd:C02946','','path:rno00330;path:ec00330;path:rn00330','KEGGMAP','IMPD').
metabolite('36183: cpd:C00267','','path:rno00051;path:rno00520;path:rno00052;path:ec00010;path:ec00052;path:rn00500;path:ec00051;path:ec00520;path:rn00520;path:rn00052;path:rn00051;path:ec00500;path:rno00010;path:rn00010;path:rno00500','KEGGMAP','IMPD').
metabolite('36182: cpd:C05401','','path:ec00561;path:rno00052;path:rn00052;path:ec00052;path:rn00561','KEGGMAP','IMPD').
metabolite('38141: cpd:C05936','','path:rno00330;path:ec00330;path:rn00330','KEGGMAP','IMPD').
metabolite('36181: cpd:C16643','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('36180: cpd:C04006','','path:ec00562;path:rn00562;path:ec00521;path:rn00521;path:rno00562','KEGGMAP','IMPD').
metabolite('36179: cpd:C00129','','path:ec00900;path:rn00900;path:rno00900','KEGGMAP','IMPD').
metabolite('36178: cpd:C05668','','path:ec00640;path:rn00410;path:ec00410;path:ec00720;path:rn00640;path:rno00410;path:rno00640;path:rn00720','KEGGMAP','IMPD').
metabolite('38137: cpd:C00500','','path:rn00860;path:ec00860;path:rno00860','KEGGMAP','IMPD').
metabolite('36177: cpd:C00235','','path:ec00900;path:rn00900;path:ec00908;path:rn00908;path:rno00900','KEGGMAP','IMPD').
metabolite('38136: cpd:C03263','','path:rn00860;path:ec00860;path:rno00860','KEGGMAP','IMPD').
metabolite('36176: cpd:C00618','','path:rno00040;path:rn00053;path:ec00040;path:rn00040;path:ec00053','KEGGMAP','IMPD').
metabolite('38135: cpd:C00179','','path:rno00330;path:ec00330;path:rn00330','KEGGMAP','IMPD').
metabolite('36191: cpd:C03454','','path:ec00565;path:rn00565;path:rno00565','KEGGMAP','IMPD').
metabolite('38134: cpd:C02990','','path:ec00071;path:rn00071;path:rno00071','KEGGMAP','IMPD').
metabolite('36190: cpd:C15973','','path:rno00020;path:rno00280;path:ec00020;path:rno00620;path:rn00620;path:rn00280;path:ec00010;path:rno00010;path:rn00010;path:ec00280;path:rn00020;path:ec00620','KEGGMAP','IMPD').
metabolite('36189: cpd:C00670','','path:ec00564;path:ec00565;path:rn00564;path:rn00565;path:rno00564','KEGGMAP','IMPD').
metabolite('36188: cpd:C00221','','path:ec00030;path:ec00500;path:ec00010;path:rno00010;path:rn00010;path:rn00500;path:rno00500;path:rn00030','KEGGMAP','IMPD').
metabolite('38131: cpd:C05280','','path:ec00071;path:rn00071;path:rno00071','KEGGMAP','IMPD').
metabolite('36187: cpd:C15972','','path:rno00020;path:rno00280;path:ec00020;path:rno00620;path:rn00620;path:rn00280;path:ec00010;path:rno00010;path:rn00010;path:ec00280;path:rn00020;path:ec00620','KEGGMAP','IMPD').
metabolite('38130: cpd:C14818','','path:rn00860;path:ec00860;path:rno00860','KEGGMAP','IMPD').
metabolite('36186: cpd:C00116','','path:rno00052;path:ec00561;path:rn00052;path:rn00561;path:ec00052;path:rno00561','KEGGMAP','IMPD').
metabolite('36185: cpd:C00259','','path:rno00040;path:rn00053;path:ec00040;path:rn00040;path:ec00053;path:ec00520;path:rn00520','KEGGMAP','IMPD').
metabolite('38128: cpd:C01035','','path:rno00330;path:ec00330;path:rn00330','KEGGMAP','IMPD').
metabolite('36184: cpd:C00044','','path:rno00790;path:ec00230;path:ec00740;path:ec00790;path:rn00790;path:rn00230;path:rn00740;path:rno00230','KEGGMAP','IMPD').
metabolite('38092: cpd:C05766','','path:rn00860;path:ec00860;path:rno00860','KEGGMAP','IMPD').
metabolite('36196: cpd:C05977','','path:ec00565;path:rn00565;path:rno00565','KEGGMAP','IMPD').
metabolite('38093: cpd:C00437','','path:rno00330;path:ec00330;path:rn00330','KEGGMAP','IMPD').
metabolite('36197: cpd:C01172','','path:ec00030;path:ec00500;path:ec00010;path:rno00010;path:rn00010;path:rn00500;path:rno00030;path:rn00030','KEGGMAP','IMPD').
metabolite('36198: cpd:C04598','','path:ec00565;path:rn00565;path:rno00565','KEGGMAP','IMPD').
metabolite('36199: cpd:C16255','','path:rno00020;path:ec00020;path:rno00620;path:rn00620;path:ec00010;path:rno00010;path:rn00010;path:rn00020;path:ec00620','KEGGMAP','IMPD').
metabolite('36193: cpd:C00047','','path:ec00780;path:ec00310;path:rn00780;path:rno00310;path:rno00300;path:rn00960;path:rn00970;path:ec00970;path:rno00780;path:ec00960;path:rn00310;path:ec00300;path:rno00970;path:rn00300','KEGGMAP','IMPD').
metabolite('38090: cpd:C01051','','path:rn00860;path:ec00860;path:rno00860','KEGGMAP','IMPD').
metabolite('36194: cpd:C00155','','path:rn00920;path:ec00270;path:rn00270;path:ec00920;path:rno00270','KEGGMAP','IMPD').
metabolite('36195: cpd:C04475','','path:ec00565;path:rn00565;path:rno00565','KEGGMAP','IMPD').
metabolite('38084: cpd:C00624','','path:rno00330;path:ec00330;path:rn00330','KEGGMAP','IMPD').
metabolite('36204: cpd:C03372','','path:ec00564;path:ec00565;path:rn00564;path:rn00565;path:rno00564;path:rno00565','KEGGMAP','IMPD').
metabolite('38085: cpd:C01024','','path:rn00860;path:ec00860;path:rno00860','KEGGMAP','IMPD').
metabolite('36205: cpd:C00472','','path:ec00627;path:ec00740;path:rn00627;path:rn00740;path:rno00740','KEGGMAP','IMPD').
metabolite('36206: cpd:C16607','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('36207: cpd:C03820','','path:ec00565;path:rn00565;path:rno00565','KEGGMAP','IMPD').
metabolite('36200: cpd:C00379','','path:rno00040;path:ec00040;path:rn00040','KEGGMAP','IMPD').
metabolite('36201: cpd:C00530','','path:ec00627;path:ec00740;path:ec00361;path:ec00350;path:rn00350;path:ec00362;path:rno00740;path:ec00363;path:rn00361;path:rn00362;path:rn00363;path:rn00627;path:rn00740','KEGGMAP','IMPD').
metabolite('36203: cpd:C00550','','path:rn00600;path:ec00600;path:rno00600','KEGGMAP','IMPD').
metabolite('36213: cpd:C02266','','path:rno00040;path:ec00040;path:rn00040','KEGGMAP','IMPD').
metabolite('36212: cpd:C00159','','path:rno00520;path:rno00051;path:rno00052;path:rn00052;path:rn00051;path:ec00052;path:ec00520;path:ec00051;path:rn00520','KEGGMAP','IMPD').
metabolite('36215: cpd:C04635','','path:ec00565;path:rn00565;path:rno00565','KEGGMAP','IMPD').
metabolite('36214: cpd:C00091','','path:ec00720;path:ec00020;path:rn00640;path:rn00630;path:rn00280;path:ec00623;path:rno00640;path:ec00626;path:ec00630;path:ec00362;path:ec00640;path:rno00020;path:rn00623;path:rno00280;path:rn00362;path:rno00630;path:ec00280;path:rn00020;path:rn00720;path:rn00626','KEGGMAP','IMPD').
metabolite('36209: cpd:C02960','','path:rn00600;path:ec00600;path:rno00600','KEGGMAP','IMPD').
metabolite('36208: cpd:C00819','','path:ec00471;path:rn00471;path:rno00471','KEGGMAP','IMPD').
metabolite('38100: cpd:C05768','','path:rn00860;path:ec00860;path:rno00860','KEGGMAP','IMPD').
metabolite('36220: cpd:C00312','','path:rno00040;path:ec00040;path:rn00040','KEGGMAP','IMPD').
metabolite('36222: cpd:C03201','','path:ec00565;path:rn00565;path:rno00565','KEGGMAP','IMPD').
metabolite('36216: cpd:C16608','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('36218: cpd:C00143','','path:ec00260;path:rn00680;path:ec00720;path:ec00670;path:rn00260;path:rno00670;path:rn00720;path:rno00260;path:rn00670;path:ec00680','KEGGMAP','IMPD').
metabolite('36099: cpd:C03771','','path:ec00472;path:rn00472;path:ec00330;path:rn00330;path:rno00472','KEGGMAP','IMPD').
metabolite('36096: cpd:C00334','','path:ec00250;path:ec00410;path:rn00410;path:rno00330;path:rn00650;path:ec00330;path:rno00250;path:rn00330;path:rn00250;path:ec00650;path:rno00650','KEGGMAP','IMPD').
metabolite('36097: cpd:C01762','','path:ec00230;path:rn00232;path:rn00230;path:ec00232;path:rno00230','KEGGMAP','IMPD').
metabolite('36103: cpd:C06426','','path:rno01040;path:ec00591;path:rn00591;path:ec01040;path:rn01040','KEGGMAP','IMPD').
metabolite('36100: cpd:C03508','','path:ec00260;path:rn00260;path:rno00260','KEGGMAP','IMPD').
metabolite('38061: cpd:C00763','','path:rno00330;path:ec00330;path:rn00330','KEGGMAP','IMPD').
metabolite('36107: cpd:C16651','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('36105: cpd:C00515','','path:ec00472;path:rn00472;path:rno00472','KEGGMAP','IMPD').
metabolite('36110: cpd:C00792','','path:ec00472;path:rn00472;path:rno00472','KEGGMAP','IMPD').
metabolite('36111: cpd:C00683','','path:ec00640;path:rno00280;path:ec00720;path:rn00640;path:rn00280;path:rno00630;path:rn00630;path:rno00640;path:ec00280;path:ec00630;path:rn00720','KEGGMAP','IMPD').
metabolite('36108: cpd:C03373','','path:ec00230;path:rn00230;path:rno00230;path:rn00730','KEGGMAP','IMPD').
metabolite('36114: cpd:C00164','','path:rn00643;path:rn00650;path:rno00350;path:rn00640;path:rn00280;path:rno00072;path:ec00350;path:rn00350;path:rno00650;path:ec00650;path:ec00072;path:rn00072;path:ec00640;path:ec00643;path:rno00280;path:ec00280','KEGGMAP','IMPD').
metabolite('38072: cpd:C05791','','path:rn00860;path:ec00860;path:rno00860','KEGGMAP','IMPD').
metabolite('36112: gl:G00057','','path:rn00601;path:ec00601;path:rno00601','KEGGMAP','IMPD').
metabolite('36116: cpd:C00062','','path:rn00331;path:rno00330;path:ec00472;path:rn00472;path:rno00970;path:ec00330;path:rn00330;path:ec00331;path:rn00970;path:ec00970','KEGGMAP','IMPD').
metabolite('36123: cpd:C00433','','path:rno00040;path:rn00053;path:ec00040;path:rn00040;path:ec00053;path:ec00330;path:rn00330','KEGGMAP','IMPD').
metabolite('36122: cpd:C00417','','path:rno00020;path:ec00720;path:ec00020;path:rn00630;path:rno00630;path:rn00020;path:rn00660;path:ec00660;path:rn00720;path:ec00630','KEGGMAP','IMPD').
metabolite('38065: cpd:C03564','','path:rno00330;path:ec00330;path:rn00330','KEGGMAP','IMPD').
metabolite('36120: cpd:C00119','','path:ec00240;path:ec00400;path:ec00230;path:rno00240;path:ec00030;path:rn00240;path:ec00340;path:rno00030;path:rn00340;path:rn00230;path:rn00400;path:rno00230;path:rn00030','KEGGMAP','IMPD').
metabolite('38071: cpd:C02305','','path:rno00330;path:ec00330;path:rn00330','KEGGMAP','IMPD').
metabolite('36127: cpd:C00341','','path:rn00130;path:rn00902;path:ec00900;path:rn00900;path:ec00130;path:ec00902;path:rno00900','KEGGMAP','IMPD').
metabolite('38069: cpd:C05933','','path:rno00330;path:ec00330;path:rn00330','KEGGMAP','IMPD').
metabolite('36125: cpd:C03232','','path:ec00260;path:rn00680;path:rn00260;path:rno00260;path:ec00680','KEGGMAP','IMPD').
metabolite('38068: cpd:C06508','','path:rn00860;path:ec00860;path:rno00860','KEGGMAP','IMPD').
metabolite('36128: cpd:C00123','','path:rno00280;path:rn00966;path:rno00290;path:ec00290;path:rn00280;path:rn00290;path:ec00966;path:rno00970;path:ec00280;path:rn00970;path:ec00970','KEGGMAP','IMPD').
metabolite('38025: cpd:C05787','','path:rn00860;path:ec00860;path:rno00860','KEGGMAP','IMPD').
metabolite('36129: cpd:C00074','','path:rn00440;path:ec00400;path:ec00720;path:ec00020;path:ec00010;path:ec00710;path:ec00620;path:ec00680;path:rno00020;path:rn00680;path:rno00620;path:rn00620;path:rn00400;path:rno00010;path:rn00010;path:ec00440;path:rn00020;path:rn00710;path:rn00720','KEGGMAP','IMPD').
metabolite('36132: cpd:C00311','','path:rno00020;path:ec00720;path:ec00020;path:rn00630;path:rno00630;path:rn00020;path:rn00720;path:ec00630','KEGGMAP','IMPD').
metabolite('38030: cpd:C00032','','path:rn00860;path:ec00860;path:rno00860','KEGGMAP','IMPD').
metabolite('36134: cpd:C05167','','path:ec00910;path:rn00910;path:rno00910','KEGGMAP','IMPD').
metabolite('36135: cpd:C00233','','path:rn00966;path:rno00280;path:rno00290;path:ec00290;path:rn00280;path:rn00290;path:ec00966;path:ec00280','KEGGMAP','IMPD').
metabolite('36136: cpd:C16584','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('36137: cpd:C00042','','path:ec00020;path:ec00720;path:rn00650;path:rn00640;path:rn00630;path:ec00623;path:ec00360;path:rno00640;path:rn00250;path:ec00350;path:rno00650;path:rn00350;path:ec00650;path:ec00630;path:rn00623;path:rn00360;path:rno00020;path:ec00640;path:rn00361;path:ec00250;path:rno00250;path:rn00020;path:rn00720','KEGGMAP','IMPD').
metabolite('38018: cpd:C00327','','path:rno00330;path:ec00330;path:rn00330','KEGGMAP','IMPD').
metabolite('36139: cpd:C00137','','path:rno00052;path:rn00052;path:ec00562;path:rn00053;path:rn00562;path:ec00052;path:ec00053;path:ec00521;path:rn00521;path:rno00053;path:rno00562','KEGGMAP','IMPD').
metabolite('36140: cpd:C00163','','path:ec00640;path:ec00642;path:rn00640;path:rn00642;path:ec00760;path:rno00640;path:rn00760','KEGGMAP','IMPD').
metabolite('36141: cpd:C16587','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('38022: cpd:C15672','','path:rn00860;path:ec00860;path:rno00860','KEGGMAP','IMPD').
metabolite('36142: cpd:C00167','','path:rno00520;path:rno00040;path:rn00053;path:ec00040;path:ec00500;path:rn00040;path:ec00053;path:rn00500;path:ec00520;path:rno00500;path:rno00053;path:rn00520','KEGGMAP','IMPD').
metabolite('36145: cpd:C02291','','path:ec00260;path:ec00270;path:rn00270;path:rn00260;path:rno00260;path:rno00270','KEGGMAP','IMPD').
metabolite('36144: cpd:C00100','','path:ec00410;path:ec00720;path:rno00410;path:rn00640;path:rn00630;path:rn00280;path:rno00640;path:ec00522;path:rn00522;path:ec00660;path:ec00630;path:ec00640;path:rn00410;path:rno00280;path:rno00630;path:rn00561;path:ec00280;path:rn00660;path:rn00720','KEGGMAP','IMPD').
metabolite('36147: cpd:C03033','','path:rno00040;path:ec00040;path:ec00500;path:rn00040;path:rn00500;path:rno00500','KEGGMAP','IMPD').
metabolite('36146: cpd:C16582','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('36148: cpd:C17432','','path:ec00900;path:rn00900;path:rno00900','KEGGMAP','IMPD').
metabolite('36151: cpd:C00186','','path:ec00640;path:rn00643;path:ec00643;path:rn00640;path:rno00620;path:rn00620;path:ec00010;path:rno00010;path:rn00010;path:ec00620','KEGGMAP','IMPD').
metabolite('36150: cpd:C00213','','path:ec00260;path:ec00330;path:rn00330;path:rn00260;path:rno00260','KEGGMAP','IMPD').
metabolite('36153: dr:D08195 cpd:C07163','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('38032: cpd:C00931','','path:rn00860;path:ec00860;path:rno00860','KEGGMAP','IMPD').
metabolite('36152: cpd:C00108','','path:rn00621;path:rn00380;path:ec00400;path:ec00627;path:rno00380;path:rn00400;path:ec01058;path:rn00627;path:ec00380;path:rn01058','KEGGMAP','IMPD').
metabolite('36155: cpd:C00894','','path:ec00640;path:rn00410;path:ec00643;path:rn00643;path:ec00410;path:ec00720;path:rn00640;path:rno00410;path:rno00640;path:rn00720','KEGGMAP','IMPD').
metabolite('36154: cpd:C00039','','path:ec00240;path:ec00230;path:rno00240;path:rn00230;path:rn00240;path:rno00230','KEGGMAP','IMPD').
metabolite('36157: cpd:C00188','','path:ec00260;path:rn00860;path:ec00290;path:rn00290;path:rno00970;path:rn00260;path:rno00260;path:rn00970;path:ec00970','KEGGMAP','IMPD').
metabolite('36159: cpd:C02047','','path:ec00290;path:rno00290;path:rn00290;path:rno00970;path:rn00970;path:ec00970','KEGGMAP','IMPD').
metabolite('36158: cpd:C16659','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('36060: cpd:C00448','','path:rn00906;path:rn00100;path:rno00100;path:ec00900;path:rn00900;path:ec00100;path:rn00981;path:ec00909;path:ec00906;path:rno00900;path:rn00909','KEGGMAP','IMPD').
metabolite('38261: cpd:C05109','','path:rn00100;path:rno00100;path:ec00100','KEGGMAP','IMPD').
metabolite('36061: cpd:C16602','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('38262: cpd:C03793','','path:ec00310;path:rn00310;path:rno00310','KEGGMAP','IMPD').
metabolite('36062: cpd:C02972','','path:ec00260;path:rn00260;path:rno00260','KEGGMAP','IMPD').
metabolite('36063: cpd:C00029','','path:rno00520;path:rno00052;path:ec00240;path:rno00040;path:ec00040;path:rn00240;path:ec00052;path:ec00053;path:rn00500;path:ec00520;path:ec00908;path:rn00908;path:rn00520;path:ec00561;path:rn00052;path:rn00053;path:ec00500;path:rn01051;path:rn00040;path:rn00561;path:rno00500;path:rno00053','KEGGMAP','IMPD').
metabolite('38256: cpd:C11455','','path:rn00100;path:rno00100;path:ec00100','KEGGMAP','IMPD').
metabolite('36056: cpd:C00258','','path:rn00630;path:ec00030;path:rn00260;path:rno00561;path:ec00630;path:ec00680;path:ec00260;path:ec00561;path:rn00680;path:rno00630;path:rn00561;path:rno00260;path:rn00030','KEGGMAP','IMPD').
metabolite('36058: gl:G00086','','path:rn00601;path:ec00601;path:rno00601','KEGGMAP','IMPD').
metabolite('38269: cpd:C05108','','path:rn00100;path:rno00100;path:ec00100','KEGGMAP','IMPD').
metabolite('36053: dr:D00252 cpd:C06868','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('38264: cpd:C15808','','path:rn00100;path:rno00100;path:ec00100','KEGGMAP','IMPD').
metabolite('36048: cpd:C00577','','path:rno00051;path:ec00561;path:ec00030;path:rn00051;path:rn00561;path:ec00051;path:rno00561;path:rn00030','KEGGMAP','IMPD').
metabolite('38266: cpd:C05546','','path:ec00310;path:rn00310;path:rno00310','KEGGMAP','IMPD').
metabolite('38245: cpd:C01149','','path:ec00310;path:rn00310;path:rno00310','KEGGMAP','IMPD').
metabolite('36044: cpd:C00407','','path:rn00966;path:rno00280;path:rno00290;path:ec00290;path:rn00280;path:rn00290;path:ec00966;path:rno00970;path:ec00280;path:rn00960;path:rn00970;path:ec00970','KEGGMAP','IMPD').
metabolite('36047: cpd:C00041','','path:rn00450;path:rn00473;path:rn00270;path:rno00450;path:rn00250;path:ec00710;path:rn00970;path:ec00970;path:ec00250;path:ec00473;path:ec00270;path:ec00450;path:ec00430;path:rno00250;path:rno00970;path:rn00710;path:rn00430','KEGGMAP','IMPD').
metabolite('36041: gl:G00088','','path:rn00601;path:ec00601;path:rno00601','KEGGMAP','IMPD').
metabolite('36040: cpd:C00099','','path:ec00640;path:rn00770;path:ec00240;path:rn00410;path:ec00410;path:rn00640;path:rno00410;path:rno00770;path:rno00240;path:ec00770;path:rn00240;path:rno00640','KEGGMAP','IMPD').
metabolite('36043: cpd:C01005','','path:ec00260;path:rn00680;path:ec00270;path:rn00270;path:rn00260;path:rno00260;path:rn00970;path:ec00970;path:ec00680','KEGGMAP','IMPD').
metabolite('36042: cpd:C00353','','path:rn00906;path:rn00904;path:ec00900;path:rn00900;path:ec00904;path:rno00900;path:ec00906','KEGGMAP','IMPD').
metabolite('36037: cpd:C07496','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('36036: cpd:C02642','','path:rn00770;path:rn00410;path:ec00240;path:ec00410;path:rno00410;path:rno00770;path:rno00240;path:ec00770;path:rn00240','KEGGMAP','IMPD').
metabolite('38254: cpd:C15915','','path:rn00100;path:rno00100;path:ec00100','KEGGMAP','IMPD').
metabolite('36038: cpd:C00084','','path:rn00440;path:ec00564;path:rn00564;path:ec00010;path:ec00360;path:ec00625;path:ec00620;path:ec00362;path:ec00621;path:ec00622;path:rn00360;path:rn00621;path:rn00362;path:rn00622;path:rno00620;path:rn00620;path:rno00010;path:rn00010;path:ec00440;path:rn00625','KEGGMAP','IMPD').
metabolite('38249: cpd:C01943','','path:rn00100;path:rno00100;path:ec00100','KEGGMAP','IMPD').
metabolite('36033: cpd:C00671','','path:rno00280;path:rn00966;path:ec00290;path:rno00290;path:rn00280;path:rn00290;path:ec00966;path:ec00280','KEGGMAP','IMPD').
metabolite('36032: cpd:C00051','','path:ec00480;path:ec00270;path:rn00270;path:rno00480;path:rn00480','KEGGMAP','IMPD').
metabolite('36035: cpd:C00533','','path:rno00330;path:ec00910;path:rn00910;path:ec00330;path:rn00330','KEGGMAP','IMPD').
metabolite('38250: cpd:C06157','','path:ec00310;path:rn00310;path:rno00310','KEGGMAP','IMPD').
metabolite('36094: cpd:C00077','','path:rno00330;path:ec00472;path:ec00480;path:rn00472;path:ec00330;path:rno00480;path:rn00330;path:rn00480','KEGGMAP','IMPD').
metabolite('38231: cpd:C11508','','path:rn00100;path:rno00100;path:ec00100','KEGGMAP','IMPD').
metabolite('36095: cpd:C00111','','path:ec00564;path:rn00562;path:rn00564;path:ec00010;path:ec00052;path:ec00051;path:ec00620;path:rn00040;path:rn00710;path:rno00051;path:ec00040;path:rno00564;path:ec00710;path:rno00561;path:ec00680;path:rno00562;path:ec00561;path:rn00680;path:ec00562;path:rn00052;path:rn00051;path:rn00620;path:rno00010;path:rn00561;path:rn00010;path:rn00760','KEGGMAP','IMPD').
metabolite('36092: cpd:C01595','','path:rno00591;path:rno01040;path:ec00591;path:rn00591;path:ec01040;path:rn01040','KEGGMAP','IMPD').
metabolite('36091: cpd:C00086','','path:ec00240;path:ec00791;path:rno00330;path:ec00230;path:rn00791;path:rn00230;path:rn00240;path:ec00330;path:rn00330;path:rno00230','KEGGMAP','IMPD').
metabolite('36088: cpd:C00046','','path:ec00240;path:ec00230;path:rno00240;path:rn00230;path:rn00240;path:rno00230','KEGGMAP','IMPD').
metabolite('36089: cpd:C00059','','path:ec00230;path:rn00230;path:rn00920;path:ec00270;path:rn00270;path:ec00920;path:rno00230;path:rno00920','KEGGMAP','IMPD').
metabolite('36087: cpd:C05345','','path:rno00051;path:rno00520;path:ec00030;path:ec00010;path:rn00500;path:ec00051;path:ec00520;path:rno00030;path:rn00520;path:rn00051;path:ec00500;path:rno00010;path:rn00010;path:rno00500;path:rn00030','KEGGMAP','IMPD').
metabolite('36084: cpd:C00628','','path:rn00362;path:rno00350;path:ec00350;path:ec00626;path:rn00350;path:ec00362;path:rn00626','KEGGMAP','IMPD').
metabolite('36085: cpd:C00122','','path:rn00643;path:rno00330;path:ec00720;path:ec00020;path:rn00650;path:rno00350;path:ec00360;path:ec00623;path:ec00330;path:rn00330;path:rn00250;path:ec00350;path:rn00350;path:ec00650;path:rno00020;path:rn00623;path:rn00360;path:ec00643;path:ec00250;path:ec00760;path:rno00250;path:rn00020;path:rn00760;path:rn00720','KEGGMAP','IMPD').
metabolite('38235: cpd:C01802','','path:rn00100;path:rno00100;path:ec00100','KEGGMAP','IMPD').
metabolite('38233: cpd:C15776','','path:rn00100;path:rno00100;path:ec00100','KEGGMAP','IMPD').
metabolite('38215: cpd:C15781','','path:rn00100;path:rno00100;path:ec00100','KEGGMAP','IMPD').
metabolite('36079: cpd:C00058','','path:ec00720;path:ec00910;path:rn00630;path:rn00910;path:ec00625;path:ec00620;path:ec00630;path:ec00680;path:rn00680;path:rno00630;path:rn00620;path:rn00625;path:rn00720','KEGGMAP','IMPD').
metabolite('38214: cpd:C05107','','path:rn00100;path:rno00100;path:ec00100','KEGGMAP','IMPD').
metabolite('36078: cpd:C01144','','path:ec00071;path:ec00720;path:rn00650;path:ec00627;path:rno00380;path:ec00310;path:rno00071;path:rno00310;path:ec00650;path:rno00650;path:ec00362;path:ec00380;path:rn00380;path:rn00362;path:rn00071;path:rn00310;path:rn00627;path:rn00720','KEGGMAP','IMPD').
metabolite('36077: cpd:C00232','','path:ec00250;path:ec00720;path:rn00650;path:rno00250;path:ec00750;path:rn00250;path:ec00350;path:ec00650;path:rn00350;path:rno00650;path:rn00750;path:rn00720','KEGGMAP','IMPD').
metabolite('38212: cpd:C01561','','path:rn00100;path:rno00100;path:ec00100','KEGGMAP','IMPD').
metabolite('36076: cpd:C00101','','path:ec00720;path:ec00790;path:rn00790;path:ec00670;path:rn00260;path:rno00670;path:rn00970;path:ec00680;path:ec00970;path:ec00260;path:rn00680;path:rno00790;path:rno00970;path:rno00260;path:rn00720;path:rn00670','KEGGMAP','IMPD').
metabolite('36075: cpd:C03127','','path:rno00290;path:ec00290;path:rn00290;path:rno00970;path:rn00970;path:ec00970','KEGGMAP','IMPD').
metabolite('38210: cpd:C01673','','path:rn00100;path:rno00100;path:ec00100','KEGGMAP','IMPD').
metabolite('36074: cpd:C00877','','path:ec00071;path:ec00720;path:rn00650;path:ec00627;path:rn00630;path:rno00380;path:rno00071;path:ec00310;path:rno00310;path:rno00650;path:ec00650;path:ec00362;path:ec00380;path:ec00630;path:rn00380;path:rn00362;path:rn00071;path:rn00310;path:rn00627;path:rn00720','KEGGMAP','IMPD').
metabolite('36073: gl:G00085','','path:rn00601;path:ec00601;path:rno00601','KEGGMAP','IMPD').
metabolite('36072: cpd:C16610','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('38223: cpd:C08821','','path:rn00100;path:rno00100;path:ec00100','KEGGMAP','IMPD').
metabolite('36071: cpd:C15777','','path:rn00100;path:rno00100;path:ec00100','KEGGMAP','IMPD').
metabolite('38222: cpd:C15782','','path:rn00100;path:rno00100;path:ec00100','KEGGMAP','IMPD').
metabolite('36069: cpd:C01110','','path:ec00472;path:rn00472;path:rn00330;path:rno00472','KEGGMAP','IMPD').
metabolite('38220: cpd:C01753','','path:rn00100;path:rno00100;path:ec00100','KEGGMAP','IMPD').
metabolite('36067: cpd:C02051','','path:ec00260;path:rn00260;path:rno00260','KEGGMAP','IMPD').
metabolite('38218: cpd:C15780','','path:rn00100;path:rno00100;path:ec00100','KEGGMAP','IMPD').
metabolite('36066: gl:G00067','','path:rn00601;path:ec00601;path:rno00601','KEGGMAP','IMPD').
metabolite('36065: cpd:C16609','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('38216: cpd:C15783','','path:rn00100;path:rno00100;path:ec00100','KEGGMAP','IMPD').
metabolite('35992: cpd:C00083','','path:ec00410;path:ec00720;path:rn00640;path:rno00410;path:rno00061;path:ec00061;path:rn00253;path:rn00522;path:rno00640;path:ec00620;path:ec00640;path:rn00360;path:rn00410;path:rn01055;path:rn00061;path:rno00620;path:rn00620;path:ec00253;path:rn00720','KEGGMAP','IMPD').
metabolite('35993: gl:G00063','','path:rn00601;path:ec00601;path:rno00601','KEGGMAP','IMPD').
metabolite('35995: cpd:C00002','','path:rn00680;path:ec00230;path:rn00230;path:rno00230;path:rn00908;path:ec00680','KEGGMAP','IMPD').
metabolite('35996: cpd:C03035','','path:rno01040;path:ec01040;path:rn01040','KEGGMAP','IMPD').
metabolite('35997: cpd:C01026','','path:ec00260;path:rn00260;path:rno00260','KEGGMAP','IMPD').
metabolite('35998: cpd:C00048','','path:ec00720;path:ec00230;path:rn00630;path:ec00330;path:rn00260;path:ec00625;path:rn00330;path:ec00660;path:ec00630;path:ec00680;path:ec00260;path:rn00680;path:rn00232;path:rno00630;path:rn00230;path:rn00660;path:rno00260;path:rn00720;path:rn00625','KEGGMAP','IMPD').
metabolite('35984: cpd:C00037','','path:rn00120;path:rn00860;path:ec00860;path:rn00260;path:rno00460;path:ec00120;path:rn00730;path:ec00730;path:ec00910;path:ec00230;path:rn00910;path:rno00860;path:rn00460;path:ec00310;path:rno00480;path:rno00120;path:rn00970;path:ec00680;path:ec00970;path:ec00260;path:ec00460;path:rn00680;path:ec00480;path:rn00230;path:rn00310;path:rno00970;path:rno00910;path:rno00260;path:rn00480','KEGGMAP','IMPD').
metabolite('35985: dr:D04716 cpd:C08012','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('35986: gl:G00062','','path:rn00601;path:ec00601;path:rno00601','KEGGMAP','IMPD').
metabolite('35988: cpd:C00190','','path:rno00520;path:ec00500;path:rn00500;path:ec00520;path:ec00908;path:rno00500;path:rn00908;path:rn00520','KEGGMAP','IMPD').
metabolite('35990: cpd:C00300','','path:ec00260;path:rno00330;path:ec00330;path:rn00330;path:rn00260;path:rno00260','KEGGMAP','IMPD').
metabolite('35991: cpd:C00082','','path:rn00940;path:ec00401;path:rn00966;path:ec00400;path:rno00400;path:ec00360;path:rn00350;path:rno00130;path:rn00401;path:rn01055;path:rn00400;path:ec00130;path:ec00950;path:rn00730;path:rn00130;path:rno00360;path:rno00350;path:rn00950;path:ec00350;path:rn00970;path:ec00970;path:rn00360;path:ec00966;path:rno00970;path:ec00940','KEGGMAP','IMPD').
metabolite('35977: cpd:C00096','','path:rno00051;path:rno00520;path:rn00053;path:rn00051;path:ec00510;path:ec00053;path:ec00520;path:ec00051;path:rn00510;path:rno00510;path:rn00520','KEGGMAP','IMPD').
metabolite('38176: cpd:C03547','','path:ec00071;path:rn00071;path:rno00071','KEGGMAP','IMPD').
metabolite('35976: gl:G00064','','path:rn00601;path:ec00601;path:rno00601','KEGGMAP','IMPD').
metabolite('35979: cpd:C00073','','path:rn00966;path:ec00966;path:ec00270;path:rn00270;path:rno00970;path:rn00970;path:ec00970;path:rno00270','KEGGMAP','IMPD').
metabolite('35981: cpd:C00031','','path:rno00052;path:ec00901;path:ec00030;path:ec00010;path:ec00052;path:ec00521;path:rn00500;path:ec00520;path:rn00524;path:rno00524;path:rn00521;path:ec00524;path:rn00520;path:rn00052;path:ec00500;path:rn00901;path:rn00010;path:rno00500;path:rn00030','KEGGMAP','IMPD').
metabolite('35980: cpd:C00197','','path:rn00630;path:ec00010;path:rn00260;path:ec00710;path:ec00630;path:rno00561;path:ec00680;path:ec00260;path:ec00561;path:rn00680;path:rno00630;path:rno00010;path:rn00561;path:rn00010;path:rn00710;path:rno00260','KEGGMAP','IMPD').
metabolite('35983: cpd:C02249','','path:rno01040;path:ec01040;path:rn01040','KEGGMAP','IMPD').
metabolite('35982: cpd:C00149','','path:ec00020;path:ec00720;path:rn00630;path:ec00710;path:ec00620;path:ec00630;path:ec00680;path:rno00020;path:rn00680;path:rno00620;path:rno00630;path:rn00620;path:rn00020;path:rn00710;path:rn00720','KEGGMAP','IMPD').
metabolite('35969: cpd:C00061','','path:ec00740;path:ec01057;path:rn00524;path:rn00740;path:ec00524;path:rn01057;path:rno00740','KEGGMAP','IMPD').
metabolite('35968: cpd:C02554','','path:ec00290;path:rno00290;path:rn00290;path:rno00970;path:rn00970;path:ec00970','KEGGMAP','IMPD').
metabolite('35971: cpd:C00719','','path:ec00260;path:rn00260;path:rno00260','KEGGMAP','IMPD').
metabolite('35970: cpd:C00169','','path:ec00240;path:rno00330;path:ec00910;path:ec00230;path:rn00910;path:rno00240;path:rn00240;path:ec00330;path:rn00330;path:rn00250;path:ec00250;path:rn00230;path:rno00250;path:rno00910','KEGGMAP','IMPD').
metabolite('35973: cpd:C16660','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('35972: cpd:C03595','','path:rno01040;path:ec01040;path:rn01040','KEGGMAP','IMPD').
metabolite('35975: cpd:C01180','','path:rn00966;path:ec00270;path:ec00966;path:rn00270;path:rno00270','KEGGMAP','IMPD').
metabolite('35974: cpd:C00068','','path:ec00020;path:rn00650;path:ec00730;path:rn00280;path:ec00010;path:rno00730;path:rno00650;path:ec00650;path:ec00620;path:rno00020;path:rno00280;path:rno00620;path:rn00620;path:rno00010;path:rn00010;path:ec00280;path:rn00020;path:rn00730','KEGGMAP','IMPD').
metabolite('36026: cpd:C00429','','path:rn00770;path:rn00410;path:ec00240;path:ec00410;path:rno00410;path:rno00770;path:rno00240;path:ec00770;path:rn00240','KEGGMAP','IMPD').
metabolite('38163: cpd:C00226','','path:ec00071;path:rn00071;path:rno00071','KEGGMAP','IMPD').
metabolite('36024: cpd:C00109','','path:ec00640;path:ec00260;path:rn00640;path:ec00290;path:rn00290;path:ec00270;path:rn00270;path:rno00640;path:rn00260;path:rn00660;path:rno00270','KEGGMAP','IMPD').
metabolite('36025: cpd:C00118','','path:rn00562;path:ec00030;path:ec00900;path:ec00010;path:ec00052;path:ec00051;path:rn00900;path:rn00040;path:ec00750;path:rn00710;path:rn00750;path:rno00051;path:ec00040;path:ec00331;path:rno00030;path:ec00710;path:ec00680;path:rno00562;path:rn00331;path:ec00562;path:rn00680;path:rn00052;path:rn00051;path:rno00010;path:rn00010;path:rn00030','KEGGMAP','IMPD').
metabolite('36030: gl:G00089','','path:rn00601;path:ec00601;path:rno00601','KEGGMAP','IMPD').
metabolite('36031: cpd:C00011','','path:ec00791;path:ec00720;path:ec00910;path:ec00230;path:rn00910;path:rn00630;path:rn00791;path:ec00330;path:rn00330;path:rn00260;path:ec00710;path:ec00630;path:ec00680;path:ec00260;path:rn00361;path:rn00680;path:rn00230;path:rno00910;path:rn00710;path:rno00260;path:rn00625;path:rn00720','KEGGMAP','IMPD').
metabolite('36028: cpd:C00168','','path:ec00260;path:rn00680;path:rno00630;path:rn00630;path:rn00260;path:rno00260;path:ec00630;path:ec00680','KEGGMAP','IMPD').
metabolite('36018: cpd:C16162','','path:rno01040;path:ec01040;path:rn01040','KEGGMAP','IMPD').
metabolite('38168: cpd:C00524','','path:rn00860;path:ec00860;path:rno00860','KEGGMAP','IMPD').
metabolite('36016: cpd:C01179','','path:ec00401;path:ec00400;path:rn00130;path:rno00350;path:rno00400;path:rn00950;path:ec00350;path:rn00350;path:ec00680;path:rno00130;path:rn00401;path:rn00680;path:rn01055;path:rn00400;path:ec00130;path:ec00950','KEGGMAP','IMPD').
metabolite('36017: cpd:C05125','','path:ec00020;path:rn00650;path:rn00290;path:ec00010;path:ec00650;path:rno00650;path:ec00620;path:rno00020;path:rno00290;path:ec00290;path:rno00620;path:rn00620;path:rno00010;path:rn00010;path:rn00020','KEGGMAP','IMPD').
metabolite('36023: cpd:C16601','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('38147: cpd:C02714','','path:rno00330;path:ec00330;path:rn00330','KEGGMAP','IMPD').
metabolite('36010: cpd:C16169','','path:rno01040;path:ec01040;path:rn01040','KEGGMAP','IMPD').
metabolite('38144: cpd:C05279','','path:ec00071;path:rn00071;path:rno00071','KEGGMAP','IMPD').
metabolite('36008: cpd:C00581','','path:ec00260;path:rno00330;path:ec00330;path:rn00260;path:rn00330;path:rno00260','KEGGMAP','IMPD').
metabolite('36015: gl:G00090','','path:rn00601;path:ec00601;path:rno00601','KEGGMAP','IMPD').
metabolite('36014: cpd:C00527','','path:ec00071;path:rn00380;path:rn00362;path:rn00071;path:rno00380;path:rno00071;path:ec00310;path:rn00310;path:rno00310;path:ec00362;path:ec00380','KEGGMAP','IMPD').
metabolite('38149: cpd:C05938','','path:rno00330;path:ec00330;path:rn00330','KEGGMAP','IMPD').
metabolite('36013: gl:G00060','','path:rn00601;path:ec00601;path:rno00601','KEGGMAP','IMPD').
metabolite('36003: cpd:C16165','','path:rno01040;path:ec01040;path:rn01040','KEGGMAP','IMPD').
metabolite('36002: cpd:C05519','','path:ec00260;path:rn00260;path:rno00260','KEGGMAP','IMPD').
metabolite('38153: cpd:C06505','','path:rn00860;path:ec00860;path:rno00860','KEGGMAP','IMPD').
metabolite('36000: gl:G00066','','path:rn00601;path:ec00601;path:rno00601','KEGGMAP','IMPD').
metabolite('38159: cpd:C01708','','path:rn00860;path:ec00860;path:rno00860','KEGGMAP','IMPD').
metabolite('38158: cpd:C06506','','path:rn00860;path:ec00860;path:rno00860','KEGGMAP','IMPD').
metabolite('38157: cpd:C00071','','path:ec00071;path:rn00071;path:rno00071','KEGGMAP','IMPD').
metabolite('36005: cpd:C00078','','path:rn00966;path:ec00400;path:ec00901;path:rno00380;path:rn00260;path:rn00970;path:ec00380;path:ec00970;path:ec00260;path:rn00380;path:rn00400;path:rn00901;path:ec00966;path:rno00970','KEGGMAP','IMPD').
metabolite('38393: cpd:C04185','','path:rno00350;path:ec00350;path:rn00350','KEGGMAP','IMPD').
metabolite('38390: cpd:C18239','','path:rno00790;path:rn00790','KEGGMAP','IMPD').
metabolite('38368: cpd:C05827','','path:rno00340;path:ec00340;path:rn00340','KEGGMAP','IMPD').
metabolite('38370: cpd:C05828','','path:rno00340;path:ec00340;path:rn00340','KEGGMAP','IMPD').
metabolite('35959: cpd:C00049','','path:ec00770;path:rno00340;path:rn00260;path:ec00340;path:rn00330;path:ec00250;path:ec00270;path:rno00250;path:rn00300;path:rn00710;path:rn00770;path:ec00410;path:rno00330;path:ec00910;path:rno00410;path:rn00910;path:rn00460;path:rn00270;path:ec00330;path:rn00250;path:ec00710;path:rn00340;path:rn00970;path:ec00970;path:ec00260;path:rn00410;path:ec00460;path:ec00300;path:rno00970;path:ec00760;path:rn00760','KEGGMAP','IMPD').
metabolite('35958: cpd:C00141','','path:rn00770;path:rn00966;path:rno00280;path:ec00290;path:rno00290;path:rno00770;path:rn00280;path:rn00290;path:ec00770;path:ec00966;path:ec00280','KEGGMAP','IMPD').
metabolite('35957: cpd:C00036','','path:ec00020;path:ec00720;path:rn00630;path:ec00010;path:rn00250;path:ec00710;path:ec00620;path:ec00362;path:ec00630;path:ec00680;path:rno00020;path:ec00250;path:rn00680;path:rn00362;path:rno00620;path:rn00620;path:rno00630;path:rno00010;path:rn00010;path:rno00250;path:rn00020;path:rn00710;path:rn00720','KEGGMAP','IMPD').
metabolite('35956: cpd:C00576','','path:ec00260;path:rn00260;path:rno00260','KEGGMAP','IMPD').
metabolite('35955: cpd:C00026','','path:ec00720;path:rno00040;path:rn00471;path:ec00053;path:rno00650;path:ec00650;path:rno00020;path:ec00250;path:ec00471;path:rn00040;path:rno00250;path:ec00750;path:rn00300;path:rn00020;path:rn00750;path:ec00020;path:rn00650;path:ec00040;path:rn00630;path:rn00250;path:rno00471;path:rn00340;path:ec00630;path:rn00053;path:ec00300;path:rn00660;path:rn00720','KEGGMAP','IMPD').
metabolite('35954: cpd:C00154','','path:ec00071;path:rn00563;path:rno00062;path:rno00071;path:rno01040;path:rno00563;path:ec00062;path:ec00600;path:ec01040;path:rn01040;path:rn00062;path:ec00563;path:rn00071;path:rn00600;path:rno00600','KEGGMAP','IMPD').
metabolite('35953: cpd:C00064','','path:ec00240;path:rno00330;path:rn00471;path:ec00910;path:ec00230;path:rno00240;path:rn00910;path:rn00240;path:ec00330;path:rn00330;path:rn00250;path:rno00471;path:rn00970;path:ec00970;path:ec00250;path:ec00471;path:rn00230;path:rno00970;path:rno00250;path:rno00910;path:rno00230','KEGGMAP','IMPD').
metabolite('35952: cpd:C00022','','path:ec00900;path:ec00010;path:ec00053;path:rn00350;path:rno00650;path:ec00650;path:rno00020;path:ec00250;path:ec00290;path:rn00040;path:rn00900;path:ec00750;path:rn00750;path:rn00710;path:rno00270;path:rn00770;path:ec00020;path:rn00630;path:rn00290;path:ec00330;path:rn00250;path:ec00710;path:ec00660;path:ec00260;path:rn00621;path:rn00680;path:rn00053;path:rn00622;path:rn00620;path:ec00760;path:rn00010;path:rn00430;path:rn00720;path:rn00760;path:rno00260;path:ec00720;path:ec00030;path:rn00473;path:ec00770;path:ec00360;path:rn00260;path:rn00330;path:ec00620;path:ec00362;path:ec00621;path:ec00622;path:ec00473;path:rno00290;path:ec00270;path:ec00430;path:rno00250;path:rn00020;path:rn00650;path:ec00040;path:rn00270;path:ec00350;path:ec00630;path:ec00680;path:rn00360;path:rn00362;path:rno00620;path:rno00010;path:rn00660;path:rn00030','KEGGMAP','IMPD').
metabolite('35967: cpd:C00065','','path:rn00920;path:rn00460;path:rn00270;path:rn00260;path:ec00600;path:rno00460;path:rn00970;path:ec00680;path:ec00970;path:ec00260;path:rn00680;path:ec00460;path:rn00600;path:ec00270;path:rno00970;path:ec00920;path:rno00260;path:rno00600;path:rno00270','KEGGMAP','IMPD').
metabolite('35966: cpd:C00019','','path:rno00330;path:ec00270;path:rn00270;path:ec00330;path:rn00330;path:ec00908;path:rn00908;path:rno00270','KEGGMAP','IMPD').
metabolite('35964: cpd:C00332','','path:ec00071;path:ec00720;path:rn00640;path:ec00900;path:rn00280;path:ec00650;path:rno00650;path:ec00620;path:ec00380;path:ec00072;path:ec00362;path:rno00630;path:rn00900;path:rno00900;path:rn00650;path:rno00380;path:rn00630;path:rno00071;path:ec00310;path:rno00072;path:rno00310;path:rno00640;path:ec00630;path:rn00072;path:ec00640;path:rno00280;path:rn00362;path:rn00380;path:rn00071;path:rno00620;path:rn00620;path:rn00310;path:ec00280;path:rn00720','KEGGMAP','IMPD').
metabolite('35963: cpd:C16662','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('35962: cpd:C00097','','path:rn00920;path:ec00770;path:rno00730;path:rn00260;path:rno00770;path:ec00270;path:ec00430;path:ec00311;path:rno00270;path:rn00730;path:rn00770;path:ec00730;path:rno00430;path:rn00270;path:rno00480;path:rn00970;path:ec00970;path:ec00260;path:ec00480;path:rn00311;path:rno00970;path:ec00920;path:rn00430;path:rno00260;path:rn00480','KEGGMAP','IMPD').
metabolite('38353: cpd:C05924','','path:rno00790;path:rn00790','KEGGMAP','IMPD').
metabolite('35961: gl:G00069','','path:rn00601;path:ec00601;path:rno00601','KEGGMAP','IMPD').
metabolite('35960: cpd:C00025','','path:rn00471;path:rn00860;path:ec00860;path:rno00340;path:rn00330;path:ec00340;path:rn00524;path:rno00650;path:ec00650;path:ec00524;path:ec00250;path:ec00471;path:rno00250;path:rno00330;path:rn00650;path:ec00910;path:rn00910;path:rno00860;path:ec00330;path:rno00480;path:rn00250;path:rno00471;path:rn00340;path:ec00660;path:rn00970;path:ec00970;path:ec00480;path:rno00970;path:rno00910;path:rn00660;path:rn00480','KEGGMAP','IMPD').
metabolite('35942: cpd:C00356','','path:rn00072;path:rno00280;path:rn00650;path:rn00280;path:ec00900;path:rn00900;path:rno00072;path:ec00280;path:rno00650;path:ec00650;path:ec00072;path:rno00900','KEGGMAP','IMPD').
metabolite('35943: cpd:C00079','','path:rn00940;path:rn00966;path:ec00400;path:rno00360;path:rno00400;path:ec00360;path:rn00960;path:rn00970;path:ec00970;path:rn00360;path:ec00960;path:rn00400;path:ec00966;path:rno00970;path:ec00940','KEGGMAP','IMPD').
metabolite('35940: cpd:C00158','','path:rno00020;path:ec00720;path:ec00020;path:rn00630;path:rno00630;path:rn00020;path:ec00630;path:rn00720','KEGGMAP','IMPD').
metabolite('35941: cpd:C00014','','path:rno00330;path:ec00910;path:ec00230;path:rn00910;path:ec00330;path:rn00260;path:rn00330;path:rn00250;path:ec00260;path:ec00250;path:rn00230;path:rno00250;path:rno00910;path:rno00230;path:rno00260','KEGGMAP','IMPD').
metabolite('35950: cpd:C16661','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('35951: cpd:C00136','','path:ec00071;path:rn00062;path:rn00650;path:rn00071;path:rn00630;path:rno00062;path:rno00071;path:ec00062;path:ec00650;path:rno00650;path:ec00630','KEGGMAP','IMPD').
metabolite('35948: gl:G00084','','path:rn00601;path:ec00601;path:rno00601','KEGGMAP','IMPD').
metabolite('35949: cpd:C00033','','path:rn00440;path:ec00720;path:rn00920;path:ec00010;path:ec00620;path:ec00908;path:ec00660;path:rn00908;path:ec00680;path:rn00680;path:rno00620;path:rn00620;path:rno00010;path:ec00430;path:rn00010;path:ec00440;path:ec00920;path:rn00660;path:rn00720;path:rn00430','KEGGMAP','IMPD').
metabolite('35946: cpd:C00152','','path:ec00250;path:ec00460;path:ec00910;path:rn00910;path:rn00460;path:rno00250;path:rno00970;path:rn00250;path:rn00970;path:ec00970','KEGGMAP','IMPD').
metabolite('35947: cpd:C00114','','path:ec00260;path:ec00564;path:rn00564;path:rno00564;path:rn00260;path:rno00260','KEGGMAP','IMPD').
metabolite('35944: cpd:C00024','','path:rn00640;path:rno00061;path:rn00280;path:ec00900;path:rno00062;path:rn00642;path:ec00010;path:rno00650;path:ec00650;path:ec00380;path:rno00020;path:ec00642;path:ec00290;path:ec00253;path:rn00900;path:rn00300;path:ec00410;path:ec00020;path:rn00630;path:rno00071;path:rn00290;path:rno00072;path:ec00061;path:rn00253;path:ec00062;path:rno00640;path:rn00380;path:rn00621;path:rn00680;path:ec00562;path:rn00622;path:rn00620;path:rn00010;path:rn00720;path:rn00430;path:rn00625;path:rn00480;path:ec00071;path:ec00720;path:rn00562;path:ec00625;path:ec00620;path:ec00072;path:ec00362;path:ec00621;path:ec00622;path:rn00061;path:rn00062;path:rno00630;path:ec00430;path:rn00020;path:rno00900;path:rn00650;path:rno00410;path:rno00380;path:ec00310;path:rno00310;path:ec00630;path:rno00562;path:ec00680;path:rn00072;path:ec00640;path:rno00280;path:rn00410;path:rn00362;path:rn00071;path:rno00620;path:ec00480;path:rno00010;path:rn00310;path:ec00300;path:ec00280','KEGGMAP','IMPD').
metabolite('35945: cpd:C00183','','path:rn00770;path:rn00966;path:rn00640;path:rn00280;path:rn00290;path:ec00770;path:rn00970;path:ec00970;path:rno00280;path:ec00290;path:rn00311;path:rno00290;path:rno00770;path:ec00966;path:rno00970;path:ec00280;path:ec00311','KEGGMAP','IMPD').
metabolite('38282: cpd:C01259','','path:ec00310;path:rn00310;path:rno00310','KEGGMAP','IMPD').
metabolite('38283: cpd:C00751','','path:rn00100;path:rno00100;path:ec00100','KEGGMAP','IMPD').
metabolite('38280: cpd:C01054','','path:rn00100;path:rno00100;path:ec00100','KEGGMAP','IMPD').
metabolite('38285: cpd:C03428','','path:rn00100;path:rno00100;path:ec00100','KEGGMAP','IMPD').
metabolite('38279: cpd:C01181','','path:ec00310;path:rn00310;path:rno00310','KEGGMAP','IMPD').
metabolite('38276: cpd:C00487','','path:ec00310;path:rn00310;path:rno00310','KEGGMAP','IMPD').
metabolite('38277: cpd:C01724','','path:rn00100;path:rno00100;path:ec00100','KEGGMAP','IMPD').
metabolite('36843: gl:G00148','','path:ec00563;path:rn00563;path:rno00563','KEGGMAP','IMPD').
metabolite('36844: cpd:C16551','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('36847: cpd:C11583','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('36846: gl:G00149','','path:ec00563;path:rn00563;path:rno00563','KEGGMAP','IMPD').
metabolite('38472: cpd:C15811','','path:ec00730;path:rno00730;path:rn00730','KEGGMAP','IMPD').
metabolite('36832: dr:D07760 cpd:C07888','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('36835: cpd:C16577','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('38474: cpd:C15812','','path:ec00730;path:rno00730;path:rn00730','KEGGMAP','IMPD').
metabolite('36837: cpd:C05332','','path:rn00360;path:rno00360;path:ec00360','KEGGMAP','IMPD').
metabolite('36836: cpd:C00601','','path:rn00360;path:ec00643;path:rn00643;path:rno00360;path:ec00360','KEGGMAP','IMPD').
metabolite('36839: cpd:C02505','','path:rn00360;path:ec00643;path:rn00643;path:rno00360;path:ec00360','KEGGMAP','IMPD').
metabolite('36858: cpd:C05487','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36860: cpd:C05852','','path:rn00360;path:rn00643;path:ec00643;path:rno00360;path:ec00360','KEGGMAP','IMPD').
metabolite('36861: cpd:C00386','','path:ec00410;path:rn00410;path:rno00340;path:ec00340;path:rn00340','KEGGMAP','IMPD').
metabolite('36862: cpd:C00951','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('38488: cpd:C04042','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36848: cpd:C00535','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36849: cpd:C07646','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('36850: cpd:C00555','','path:ec00410;path:rn00410;path:rno00330;path:ec00330;path:rn00330','KEGGMAP','IMPD').
metabolite('36851: cpd:C00280','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36852: cpd:C00415','','path:rno00790;path:ec00790;path:rn00790;path:ec00670;path:rno00670;path:rn00670','KEGGMAP','IMPD').
metabolite('36853: cpd:C00504','','path:rno00790;path:ec00790;path:rn00790;path:rno00670;path:ec00670;path:rn00670','KEGGMAP','IMPD').
metabolite('38494: cpd:C02373','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36855: cpd:C05500','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('38499: cpd:C18044','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36811: cpd:C15980','','path:rno00280;path:rn00280;path:ec00280','KEGGMAP','IMPD').
metabolite('36809: gl:G13044','','path:ec00563;path:rn00563;path:rno00563','KEGGMAP','IMPD').
metabolite('38496: cpd:C18038','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36808: dr:D00399 cpd:C07185','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('38503: cpd:C05502','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36814: gl:G00147','','path:ec00563;path:rn00563;path:rno00563','KEGGMAP','IMPD').
metabolite('38501: cpd:C05501','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36813: cpd:C15979','','path:rno00280;path:rn00280;path:ec00280','KEGGMAP','IMPD').
metabolite('36812: cpd:C04717','','path:rno00591;path:ec00591;path:rn00591','KEGGMAP','IMPD').
metabolite('36803: cpd:C00669','','path:ec00480;path:rno00480;path:rn00480','KEGGMAP','IMPD').
metabolite('38511: cpd:C03772','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36806: gl:G10610','','path:ec00563;path:rn00563;path:rno00563','KEGGMAP','IMPD').
metabolite('36805: cpd:C07645','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('38508: cpd:C00674','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36804: cpd:C01879','','path:ec00480;path:rno00480;path:rn00480','KEGGMAP','IMPD').
metabolite('38515: cpd:C04295','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36827: cpd:C00445','','path:ec00720;path:ec00670;path:rno00670;path:rn00670;path:rn00720','KEGGMAP','IMPD').
metabolite('36824: cpd:C15977','','path:rno00280;path:rn00280;path:ec00280','KEGGMAP','IMPD').
metabolite('38513: cpd:C05285','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('38518: cpd:C05139','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36830: gl:G00145','','path:ec00563;path:rn00563;path:rno00563','KEGGMAP','IMPD').
metabolite('36831: cpd:C07086','','path:rn00360;path:ec00643;path:rn00643;path:rno00360;path:ec00360','KEGGMAP','IMPD').
metabolite('38516: cpd:C05140','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36828: gl:G00143','','path:ec00563;path:rn00563;path:rno00563','KEGGMAP','IMPD').
metabolite('36829: cpd:C16576','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('36818: gl:G00146','','path:ec00563;path:rn00563;path:rno00563','KEGGMAP','IMPD').
metabolite('38521: cpd:C01227','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('38526: cpd:C05490','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36822: gl:G00144','','path:ec00563;path:rn00563;path:rno00563','KEGGMAP','IMPD').
metabolite('36823: cpd:C02189','','path:rno00512;path:rno00532;path:ec00512;path:rn00532;path:ec00532;path:rn00512','KEGGMAP','IMPD').
metabolite('38524: cpd:C05478','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36820: cpd:C16578','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('36780: gl:G10617','','path:ec00563;path:rn00563;path:rno00563','KEGGMAP','IMPD').
metabolite('36783: cpd:C16548','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('36782: cpd:C14825','','path:rno00591;path:ec00591;path:rn00591','KEGGMAP','IMPD').
metabolite('36776: cpd:C00343','','path:ec00240;path:rno00240;path:rn00240','KEGGMAP','IMPD').
metabolite('36779: cpd:C00342','','path:ec00240;path:rno00240;path:rn00240','KEGGMAP','IMPD').
metabolite('36773: cpd:C00075','','path:ec00240;path:rno00240;path:rn00240','KEGGMAP','IMPD').
metabolite('36772: cpd:C00010','','path:rn00770;path:ec00071;path:rn00071;path:rno00770;path:rno00071;path:ec00770','KEGGMAP','IMPD').
metabolite('36775: dr:D08559 cpd:C07108','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('36774: cpd:C02320','','path:ec00480;path:rno00480;path:rn00480','KEGGMAP','IMPD').
metabolite('36771: cpd:C05011','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('36770: cpd:C01322','','path:ec00480;path:rno00480;path:rn00480','KEGGMAP','IMPD').
metabolite('36796: cpd:C03740','','path:ec00480;path:rno00480;path:rn00480','KEGGMAP','IMPD').
metabolite('36798: cpd:C16561','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('36793: cpd:C01419','','path:ec00480;path:rno00480;path:rn00480','KEGGMAP','IMPD').
metabolite('36788: cpd:C16547','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('36789: cpd:C06482','','path:rn00450;path:ec00450;path:rno00450;path:rno00970;path:rn00970;path:ec00970','KEGGMAP','IMPD').
metabolite('36790: cpd:C16545','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('36784: cpd:C01262','','path:rn00410;path:ec00410;path:rno00410;path:ec00340;path:rn00340','KEGGMAP','IMPD').
metabolite('36786: cpd:C00127','','path:ec00480;path:rno00480;path:rn00480','KEGGMAP','IMPD').
metabolite('36787: cpd:C00438','','path:ec00250;path:ec00240;path:rno00240;path:rn00240;path:rno00250;path:rn00250','KEGGMAP','IMPD').
metabolite('36751: cpd:C00621','','path:ec00510;path:rn00900;path:rn00510;path:rno00510','KEGGMAP','IMPD').
metabolite('36749: cpd:C00492','','path:rno00052;path:rn00052;path:ec00052','KEGGMAP','IMPD').
metabolite('36748: cpd:C05499','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('38435: cpd:C00439','','path:rno00340;path:ec00340;path:rn00340','KEGGMAP','IMPD').
metabolite('36747: cpd:C05269','','path:ec00071;path:rn00071;path:rn00062;path:rno00062;path:rno00071;path:ec00062','KEGGMAP','IMPD').
metabolite('36745: cpd:C05270','','path:ec00071;path:rn00071;path:rn00062;path:rno00062;path:rno00071;path:ec00062','KEGGMAP','IMPD').
metabolite('36744: cpd:C01953','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36743: gl:G00015','','path:ec00513;path:ec00510;path:rn00513;path:rn00510;path:rno00510','KEGGMAP','IMPD').
metabolite('36742: cpd:C05665','','path:ec00410;path:rn00410;path:rno00410','KEGGMAP','IMPD').
metabolite('36740: cpd:C00468','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36738: cpd:C05271','','path:ec00071;path:rn00071;path:rn00062;path:rno00062;path:rno00071;path:ec00062','KEGGMAP','IMPD').
metabolite('36737: cpd:C16546','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('36736: cpd:C00236','','path:rno00010;path:ec00010;path:rn00010;path:ec00710;path:rn00710','KEGGMAP','IMPD').
metabolite('36763: cpd:C18045','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('38449: cpd:C01081','','path:ec00730;path:rno00730;path:rn00730','KEGGMAP','IMPD').
metabolite('36759: cpd:C04518','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36756: cpd:C03824','','path:rn00380;path:ec00627;path:rno00380;path:rn00627;path:ec00380','KEGGMAP','IMPD').
metabolite('36754: cpd:C05268','','path:ec00071;path:rn00062;path:rn00071;path:rno00062;path:rno00071;path:ec00062','KEGGMAP','IMPD').
metabolite('36755: cpd:C04555','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36705: cpd:C03221','','path:ec00071;path:rn00062;path:rn00071;path:rno00071;path:rno00062;path:ec00062','KEGGMAP','IMPD').
metabolite('36706: cpd:C05264','','path:ec00071;path:rn00062;path:rn00071;path:rno00062;path:rno00071;path:ec00062','KEGGMAP','IMPD').
metabolite('36708: cpd:C00001','','path:ec00740;path:rn00740;path:ec00710;path:rn00710;path:rno00740','KEGGMAP','IMPD').
metabolite('36709: cpd:C01832','','path:ec00071;path:rn00062;path:rn00071;path:rno00071;path:rno00062;path:ec00062','KEGGMAP','IMPD').
metabolite('36712: cpd:C05528','','path:rn00680;path:ec00270;path:rn00270;path:ec00680;path:rno00270','KEGGMAP','IMPD').
metabolite('36713: cpd:C05265','','path:ec00071;path:rn00062;path:rn00071;path:rno00071;path:rno00062;path:ec00062','KEGGMAP','IMPD').
metabolite('38595: cpd:C05138','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36715: cpd:C05263','','path:ec00071;path:rn00062;path:rn00071;path:rno00071;path:rno00062;path:ec00062','KEGGMAP','IMPD').
metabolite('36716: cpd:C05274','','path:ec00071;path:rn00062;path:rn00071;path:rno00062;path:rno00071;path:ec00062','KEGGMAP','IMPD').
metabolite('36717: cpd:C00151','','path:ec00480;path:rno00480;path:rn00480','KEGGMAP','IMPD').
metabolite('36721: cpd:C05275','','path:ec00071;path:rn00062;path:rn00071;path:rno00062;path:rno00071;path:ec00062','KEGGMAP','IMPD').
metabolite('36720: cpd:C05262','','path:ec00071;path:rn00062;path:rn00071;path:rno00062;path:rno00071;path:ec00062','KEGGMAP','IMPD').
metabolite('36723: cpd:C05399','','path:rno00052;path:rn00052;path:ec00052','KEGGMAP','IMPD').
metabolite('36724: cpd:C05276','','path:ec00071;path:rn00071;path:rn00062;path:rno00071;path:rno00062;path:ec00062','KEGGMAP','IMPD').
metabolite('36727: cpd:C01235','','path:rno00052;path:rn00052;path:ec00052','KEGGMAP','IMPD').
metabolite('36729: cpd:C00279','','path:ec00400;path:ec00030;path:rn00400;path:ec00750;path:ec00710;path:rno00030;path:rn00710;path:rn00750;path:rn00030','KEGGMAP','IMPD').
metabolite('36728: cpd:C01944','','path:ec00071;path:rn00071;path:rn00062;path:rno00071;path:rno00062;path:ec00062','KEGGMAP','IMPD').
metabolite('36730: cpd:C14826','','path:rno00591;path:ec00591;path:rn00591','KEGGMAP','IMPD').
metabolite('36733: cpd:C05266','','path:ec00071;path:rn00071;path:rn00062;path:rno00071;path:rno00062;path:ec00062','KEGGMAP','IMPD').
metabolite('36732: cpd:C05267','','path:ec00071;path:rn00071;path:rn00062;path:rno00071;path:rno00062;path:ec00062','KEGGMAP','IMPD').
metabolite('36734: cpd:C05400','','path:rno00052;path:rn00052;path:ec00052','KEGGMAP','IMPD').
metabolite('36674: cpd:C05751','','path:rn00061;path:rno00061;path:ec00061','KEGGMAP','IMPD').
metabolite('36675: cpd:C03939','','path:rn00061;path:rno00061;path:ec00061','KEGGMAP','IMPD').
metabolite('36672: cpd:C05752','','path:rn00061;path:rno00061;path:rno00785;path:ec00061;path:rn00785;path:ec00785','KEGGMAP','IMPD').
metabolite('36679: cpd:C00106','','path:rn00770;path:rn00410;path:ec00240;path:ec00410;path:rno00410;path:rno00770;path:rno00240;path:ec00770;path:rn00240','KEGGMAP','IMPD').
metabolite('36676: cpd:C16663','','path:ec00480;path:rno00480;path:rn00480','KEGGMAP','IMPD').
metabolite('36677: cpd:C05744','','path:rn00061;path:rno00061;path:ec00061','KEGGMAP','IMPD').
metabolite('36682: cpd:C00162','','path:ec00561;path:ec00071;path:rn00071;path:rno00071;path:rn00561;path:rno00561','KEGGMAP','IMPD').
metabolite('36683: cpd:C00665','','path:rno00051;path:rn00051;path:ec00051','KEGGMAP','IMPD').
metabolite('36680: cpd:C11376','','path:ec00983;path:rno00983;path:rn00983','KEGGMAP','IMPD').
metabolite('36681: cpd:C11173','','path:ec00983;path:rno00983;path:rn00983','KEGGMAP','IMPD').
metabolite('36686: cpd:C00352','','path:rno00520;path:ec00250;path:rno00250;path:rn00250;path:ec00520;path:rn00520','KEGGMAP','IMPD').
metabolite('36687: cpd:C01209','','path:rn00061;path:rno00061;path:ec00061','KEGGMAP','IMPD').
metabolite('36691: cpd:C05745','','path:rn00061;path:rno00061;path:ec00061','KEGGMAP','IMPD').
metabolite('36690: cpd:C16664','','path:ec00480;path:rno00480;path:rn00480','KEGGMAP','IMPD').
metabolite('36688: cpd:C16543','','path:ec00983;path:rno00983;path:rn00983','KEGGMAP','IMPD').
metabolite('36695: cpd:C16336','','path:rno00592;path:rn00592;path:ec00592','KEGGMAP','IMPD').
metabolite('36694: cpd:C06754','','path:ec00982;path:ec00625;path:rn00625;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('36698: cpd:C04618','','path:rn00061;path:rno00061;path:ec00061','KEGGMAP','IMPD').
metabolite('36703: cpd:C00253','','path:rno00760;path:ec00760;path:rn00960;path:rn00760','KEGGMAP','IMPD').
metabolite('36702: cpd:C04246','','path:rn00061;path:rno00061;path:ec00061','KEGGMAP','IMPD').
metabolite('36644: cpd:C07490','','path:rno00980;path:ec00625;path:ec00980;path:rn00980;path:rn00625','KEGGMAP','IMPD').
metabolite('38541: cpd:C01124','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36645: cpd:C05758','','path:rn00061;path:rno00061;path:ec00061','KEGGMAP','IMPD').
metabolite('38543: cpd:C05473','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36647: dr:D00343 cpd:C07047','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('36640: cpd:C05757','','path:rn00061;path:rno00061;path:ec00061','KEGGMAP','IMPD').
metabolite('36643: gl:G00011','','path:ec00513;path:ec00510;path:rn00513;path:rn00510;path:rno00510','KEGGMAP','IMPD').
metabolite('36652: cpd:C16612','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('38533: cpd:C18043','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36654: cpd:C00105','','path:ec00240;path:ec00550;path:rno00240;path:rn00550;path:rn00240','KEGGMAP','IMPD').
metabolite('36648: dr:D01309 cpd:C12739','','path:ec00983;path:rno00983;path:rn00983','KEGGMAP','IMPD').
metabolite('36649: cpd:C05223','','path:rn00061;path:rno00061;path:ec00540;path:ec00061;path:rn00540','KEGGMAP','IMPD').
metabolite('36661: cpd:C16565','','path:ec00480;path:rno00480;path:rn00480','KEGGMAP','IMPD').
metabolite('38556: cpd:C05469','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36660: cpd:C05749','','path:rn00061;path:rno00061;path:ec00061','KEGGMAP','IMPD').
metabolite('38559: cpd:C05471','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36657: cpd:C05748','','path:rn00061;path:rno00061;path:ec00061','KEGGMAP','IMPD').
metabolite('36656: cpd:C00940','','path:ec00250;path:rno00250;path:rn00250','KEGGMAP','IMPD').
metabolite('36669: cpd:C05750','','path:rn00061;path:rno00061;path:ec00061','KEGGMAP','IMPD').
metabolite('38548: cpd:C00762','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36668: cpd:C04620','','path:rn00061;path:rno00061;path:ec00061','KEGGMAP','IMPD').
metabolite('38551: cpd:C00735','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('38550: cpd:C15670','','path:rn00860;path:rno00860','KEGGMAP','IMPD').
metabolite('38544: cpd:C05489','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36664: cpd:C05746','','path:rn00061;path:rno00061;path:ec00061','KEGGMAP','IMPD').
metabolite('36667: cpd:C05747','','path:rn00061;path:rno00061;path:ec00061','KEGGMAP','IMPD').
metabolite('38546: cpd:C05485','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36614: cpd:C05764','','path:rn00061;path:rno00061;path:ec00061','KEGGMAP','IMPD').
metabolite('38572: cpd:C05479','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36612: cpd:C16596','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('36613: cpd:C00006','','path:ec00480;path:rno00760;path:ec00760;path:rno00480;path:rn00760;path:rn00480','KEGGMAP','IMPD').
metabolite('38570: cpd:C18041','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36610: cpd:C05763','','path:rn00061;path:rno00061;path:ec00061','KEGGMAP','IMPD').
metabolite('38568: cpd:C05497','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36608: cpd:C00117','','path:ec00230;path:ec00030;path:rn00230;path:rno00030;path:ec00710;path:rn00710;path:rno00230;path:rn00030','KEGGMAP','IMPD').
metabolite('36609: gl:G00013','','path:ec00513;path:ec00510;path:rn00513;path:rn00510;path:rno00510','KEGGMAP','IMPD').
metabolite('38566: cpd:C05498','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36623: cpd:C11150','','path:rno00980;path:ec00625;path:ec00980;path:rn00980;path:rn00625','KEGGMAP','IMPD').
metabolite('38564: cpd:C18075','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36620: cpd:C16300','','path:rno00592;path:rn00592;path:ec00592','KEGGMAP','IMPD').
metabolite('36621: cpd:C05755','','path:rn00061;path:rno00061;path:ec00061','KEGGMAP','IMPD').
metabolite('36616: cpd:C16591','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('36631: cpd:C05753','','path:rn00061;path:rno00061;path:ec00061','KEGGMAP','IMPD').
metabolite('36630: cpd:C16327','','path:rno00592;path:rn00592;path:ec00592','KEGGMAP','IMPD').
metabolite('36629: cpd:C04619','','path:rn00061;path:rno00061;path:ec00061','KEGGMAP','IMPD').
metabolite('36628: cpd:C16544','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('36627: cpd:C05726','','path:ec00480;path:rno00480;path:rn00480','KEGGMAP','IMPD').
metabolite('36625: cpd:C05754','','path:rn00061;path:rno00061;path:ec00061','KEGGMAP','IMPD').
metabolite('36624: cpd:C16328','','path:rno00592;path:rn00592;path:ec00592','KEGGMAP','IMPD').
metabolite('36638: cpd:C00750','','path:rn00410;path:ec00410;path:rno00330;path:ec00480;path:rno00410;path:ec00330;path:rn00330;path:rno00480;path:rn00480','KEGGMAP','IMPD').
metabolite('36637: cpd:C16635','','path:ec00983;path:rno00983;path:rn00983','KEGGMAP','IMPD').
metabolite('36636: cpd:C05756','','path:rn00061;path:rno00061;path:ec00061','KEGGMAP','IMPD').
metabolite('36632: cpd:C05729','','path:ec00480;path:rno00480;path:rn00480','KEGGMAP','IMPD').
metabolite('36602: gl:G00012','','path:ec00513;path:ec00510;path:rn00513;path:rn00510;path:rno00510','KEGGMAP','IMPD').
metabolite('36603: cpd:C04633','','path:rn00061;path:rno00061;path:ec00061','KEGGMAP','IMPD').
metabolite('36601: dr:D08086 cpd:C16641','','path:ec00983;path:rno00983;path:rn00983','KEGGMAP','IMPD').
metabolite('36606: cpd:C06481','','path:rn00450;path:ec00450;path:rno00970;path:rn00970;path:ec00970','KEGGMAP','IMPD').
metabolite('36594: gl:G00014','','path:ec00513;path:ec00510;path:rn00513;path:rn00510;path:rno00510','KEGGMAP','IMPD').
metabolite('36595: cpd:C05759','','path:rn00061;path:rno00061;path:ec00061','KEGGMAP','IMPD').
metabolite('36596: cpd:C16335','','path:rno00592;path:ec00592;path:rn00592','KEGGMAP','IMPD').
metabolite('36597: cpd:C16549','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('36587: cpd:C05760','','path:rn00061;path:rno00061;path:ec00061','KEGGMAP','IMPD').
metabolite('36586: cpd:C16332','','path:rno00592;path:ec00592;path:rn00592','KEGGMAP','IMPD').
metabolite('36584: cpd:C16595','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('38727: cpd:C00847','','path:ec00750;path:rno00750;path:rn00750','KEGGMAP','IMPD').
metabolite('36590: cpd:C04688','','path:rn00061;path:rno00061;path:ec00061','KEGGMAP','IMPD').
metabolite('36588: cpd:C02090','','path:ec00480;path:rno00480;path:rn00480','KEGGMAP','IMPD').
metabolite('36579: cpd:C00005','','path:ec00480;path:rno00480;path:rn00480','KEGGMAP','IMPD').
metabolite('36578: cpd:C16331','','path:rno00592;path:ec00592;path:rn00592','KEGGMAP','IMPD').
metabolite('36577: cpd:C16638','','path:rn00450;path:ec00450;path:rno00450;path:rno00970;path:rn00970;path:ec00970','KEGGMAP','IMPD').
metabolite('36583: cpd:C03170','','path:ec00480;path:rno00480;path:rn00480','KEGGMAP','IMPD').
metabolite('36582: cpd:C00794','','path:rno00051;path:rno00052;path:rn00052;path:rn00051;path:ec00052;path:ec00051','KEGGMAP','IMPD').
metabolite('36580: cpd:C05761','','path:rn00061;path:rno00061;path:ec00540;path:ec00061;path:rn00540','KEGGMAP','IMPD').
metabolite('36568: cpd:C03460','','path:rno00280;path:rn00280;path:ec00280','KEGGMAP','IMPD').
metabolite('36570: cpd:C06000','','path:rno00280;path:rn00280;path:ec00280','KEGGMAP','IMPD').
metabolite('36572: cpd:C06001','','path:rno00280;path:rn00280;path:ec00280','KEGGMAP','IMPD').
metabolite('36573: cpd:C14840','','path:rno00980;path:ec00980;path:rn00980','KEGGMAP','IMPD').
metabolite('36575: dr:D00536 cpd:C07501','','path:ec00982;path:rno00982;path:rn00982','KEGGMAP','IMPD').
metabolite('36560: cpd:C03345','','path:rno00280;path:rn00280;path:ec00280','KEGGMAP','IMPD').
metabolite('38777: cpd:C00255','','path:ec00740;path:rn00740;path:rno00740','KEGGMAP','IMPD').
metabolite('36562: cpd:C04405','','path:rno00280;path:rn00280;path:ec00280','KEGGMAP','IMPD').
metabolite('38779: cpd:C00007','','path:ec00740;path:rn00740;path:rno00740','KEGGMAP','IMPD').
metabolite('36565: cpd:C00630','','path:rn00360;path:rno00280;path:rn00280;path:ec00280','KEGGMAP','IMPD').
metabolite('36555: cpd:C00134','','path:ec00960;path:rno00330;path:ec00480;path:ec00330;path:rn00330;path:rno00480;path:rn00960;path:rn00480','KEGGMAP','IMPD').
metabolite('36554: cpd:C03344','','path:rno00280;path:rn00280;path:ec00280','KEGGMAP','IMPD').
metabolite('36559: cpd:C05762','','path:rn00061;path:rno00061;path:ec00061','KEGGMAP','IMPD').
metabolite('36558: cpd:C00043','','path:rno00520;path:ec00550;path:ec00540;path:rn00550;path:rn00540;path:rn00524;path:ec00520;path:ec00524;path:rn00520','KEGGMAP','IMPD').
metabolite('36547: cpd:C05378','','path:rno00051;path:ec00030;path:rn00051;path:rno00010;path:ec00010;path:rn00010;path:ec00051;path:rno00030;path:rn00030','KEGGMAP','IMPD').
metabolite('36546: cpd:C00184','','path:ec00561;path:rn00680;path:rn00561;path:rno00561;path:ec00680','KEGGMAP','IMPD').
metabolite('36548: cpd:C14786','','path:rno00980;path:ec00980;path:rn00980','KEGGMAP','IMPD').
metabolite('36550: cpd:C14839','','path:rno00980;path:ec00980;path:rn00980','KEGGMAP','IMPD').
metabolite('36542: cpd:C03284','','path:rno00280;path:rn00280;path:ec00280','KEGGMAP','IMPD').
metabolite('36541: cpd:C14800','','path:rno00980;path:ec00980;path:rn00980','KEGGMAP','IMPD').
metabolite('36538: cpd:C00234','','path:ec00720;path:rno00970;path:ec00670;path:rno00670;path:rn00720;path:rn00670;path:rn00970;path:ec00970','KEGGMAP','IMPD').
metabolite('36536: cpd:C00054','','path:rn00770;path:ec00230;path:rno00770;path:rn00230;path:rn00920;path:ec00770;path:ec00920;path:rno00230;path:rno00920','KEGGMAP','IMPD').
metabolite('38673: cpd:C00534','','path:ec00750;path:rno00750;path:rn00750','KEGGMAP','IMPD').
metabolite('36534: cpd:C00506','','path:rno00430;path:ec00270;path:ec00430;path:rn00270;path:rn00430;path:rno00270','KEGGMAP','IMPD').
metabolite('36532: cpd:C05998','','path:rno00280;path:rn00280;path:ec00280','KEGGMAP','IMPD').
metabolite('36530: cpd:C01678','','path:rno00430;path:ec00430;path:rn00430','KEGGMAP','IMPD').
metabolite('38683: cpd:C00314','','path:ec00750;path:rno00750;path:rn00750','KEGGMAP','IMPD').
metabolite('36531: cpd:C00224','','path:ec00230;path:rn00230;path:rn00920;path:ec00920;path:rno00230;path:rno00920','KEGGMAP','IMPD').
metabolite('36528: cpd:C03231','','path:rno00280;path:rn00280;path:ec00280','KEGGMAP','IMPD').
metabolite('36527: cpd:C00606','','path:rno00430;path:ec00270;path:ec00430;path:rn00270;path:rn00430;path:rno00270','KEGGMAP','IMPD').
metabolite('36526: cpd:C02939','','path:rno00280;path:rn00280;path:ec00280','KEGGMAP','IMPD').
metabolite('36525: cpd:C03912','','path:ec00250;path:rno00330;path:rno00250;path:ec00330;path:rn00330;path:rn00250','KEGGMAP','IMPD').
metabolite('36524: cpd:C00053','','path:ec00230;path:rn00920;path:rn00230;path:ec00920;path:rno00230;path:rno00920','KEGGMAP','IMPD').
metabolite('36523: cpd:C00519','','path:rno00430;path:ec00430;path:rn00430','KEGGMAP','IMPD').
metabolite('36522: cpd:C03069','','path:rno00280;path:rn00280;path:ec00281;path:rn00281;path:ec00280','KEGGMAP','IMPD').
metabolite('38671: cpd:C00250','','path:ec00750;path:rno00750;path:rn00750','KEGGMAP','IMPD').
metabolite('36519: cpd:C00245','','path:rn00120;path:rno00430;path:ec00430;path:rno00120;path:rn00430;path:ec00120','KEGGMAP','IMPD').
metabolite('38669: cpd:C00018','','path:ec00750;path:rno00750;path:rn00750','KEGGMAP','IMPD').
metabolite('36517: cpd:C00095','','path:rno00051;path:rno00052;path:rn00052;path:rn00051;path:ec00500;path:ec00052;path:rn00500;path:ec00051','KEGGMAP','IMPD').
metabolite('36516: cpd:C15975','','path:rno00280;path:rn00280;path:ec00280','KEGGMAP','IMPD').
metabolite('38667: cpd:C00647','','path:ec00750;path:rno00750;path:rn00750','KEGGMAP','IMPD').
metabolite('36512: cpd:C05844','','path:rno00430;path:ec00430;path:rn00430','KEGGMAP','IMPD').
metabolite('36509: cpd:C05122','','path:rn00120;path:rno00430;path:ec00430;path:rno00120;path:rn00430;path:ec00120','KEGGMAP','IMPD').
metabolite('36510: cpd:C00089','','path:rno00052;path:rn00052;path:ec00500;path:ec00052;path:rn00500;path:rno00500','KEGGMAP','IMPD').
metabolite('36511: cpd:C01146','','path:rn00053;path:rn00630;path:rno00630;path:ec00053;path:ec00630','KEGGMAP','IMPD').
metabolite('36505: cpd:C00440','','path:rn00680;path:ec00720;path:rno00670;path:ec00670;path:rn00720;path:rn00670;path:ec00680','KEGGMAP','IMPD').
metabolite('36506: cpd:C06790','','path:rno00980;path:ec00625;path:ec00980;path:rn00980;path:rn00625','KEGGMAP','IMPD').
metabolite('36500: gl:G00092','','path:rn00601;path:rn00603;path:rno00604;path:rn00604;path:ec00601;path:rno00603;path:ec00603;path:rno00601;path:ec00604','KEGGMAP','IMPD').
metabolite('36501: cpd:C16633','','path:ec00983;path:rno00983;path:rn00983','KEGGMAP','IMPD').
metabolite('36503: dr:D04197 cpd:C11736','','path:ec00983;path:rno00983;path:rn00983','KEGGMAP','IMPD').
metabolite('36496: cpd:C02094','','path:rn00906;path:ec00830;path:rn00830;path:rno00830;path:ec00906','KEGGMAP','IMPD').
metabolite('38693: cpd:C06054','','path:ec00750;path:rno00750;path:rn00750','KEGGMAP','IMPD').
metabolite('36492: cpd:C00135','','path:ec00410;path:rn00410;path:rno00340;path:rno00970;path:ec00340;path:rn00340;path:rn00970;path:ec00970','KEGGMAP','IMPD').
metabolite('36495: cpd:C01222','','path:rno00051;path:rno00520;path:rn00051;path:ec00051;path:ec00520;path:rn00520','KEGGMAP','IMPD').
metabolite('36494: cpd:C04242','','path:ec00983;path:rno00983;path:rn00983','KEGGMAP','IMPD').
metabolite('38689: cpd:C06055','','path:ec00750;path:rno00750;path:rn00750','KEGGMAP','IMPD').
metabolite('36489: cpd:C05711','','path:ec00460;path:rn00460;path:rno00460','KEGGMAP','IMPD').
metabolite('36488: cpd:C02041','','path:rno01040;path:ec01040;path:rn01040','KEGGMAP','IMPD').
metabolite('38691: cpd:C03451','','path:rno00620;path:rn00620;path:ec00620','KEGGMAP','IMPD').
metabolite('38690: cpd:C00627','','path:ec00750;path:rno00750;path:rn00750','KEGGMAP','IMPD').
metabolite('36490: cpd:C01996','','path:ec00564;path:rn00564;path:rno00564','KEGGMAP','IMPD').
metabolite('36485: cpd:C00412','','path:rno01040;path:ec01040;path:rn01040','KEGGMAP','IMPD').
metabolite('36484: cpd:C00307','','path:ec00564;path:rn00564;path:rno00564','KEGGMAP','IMPD').
metabolite('36487: cpd:C04230','','path:ec00564;path:rn00564;path:rno00564','KEGGMAP','IMPD').
metabolite('36486: cpd:C00246','','path:rn00650;path:ec00650;path:rno00650','KEGGMAP','IMPD').
metabolite('36481: cpd:C00588','','path:ec00564;path:rn00564;path:rno00564','KEGGMAP','IMPD').
metabolite('38699: cpd:C00256','','path:rno00620;path:rn00620;path:ec00620','KEGGMAP','IMPD').
metabolite('36466: cpd:C16630','','path:ec00983;path:rno00983;path:rn00983','KEGGMAP','IMPD').
metabolite('36465: cpd:C00641','','path:ec00561;path:ec00562;path:ec00564;path:rn00562;path:rn00564;path:rn00561;path:rno00564;path:rno00561;path:rno00562','KEGGMAP','IMPD').
metabolite('38872: cpd:C03150','','path:rno00760;path:ec00760;path:rn00760','KEGGMAP','IMPD').
metabolite('36471: cpd:C00344','','path:ec00564;path:rn00564;path:rno00564','KEGGMAP','IMPD').
metabolite('36470: cpd:C16631','','path:ec00983;path:rno00983;path:rn00983','KEGGMAP','IMPD').
metabolite('36468: cpd:C03892','','path:ec00564;path:rn00564;path:rno00564','KEGGMAP','IMPD').
metabolite('38867: cpd:C00857','','path:rno00760;path:ec00760;path:rn00760','KEGGMAP','IMPD').
metabolite('36475: dr:D01244 cpd:C12673','','path:ec00983;path:rno00983;path:rn00983','KEGGMAP','IMPD').
metabolite('36474: cpd:C01019','','path:rno00520;path:rno00051;path:rn00051;path:ec00051;path:ec00520;path:rn00520','KEGGMAP','IMPD').
metabolite('36473: dr:D00584 cpd:C07649','','path:ec00983;path:rno00983;path:rn00983','KEGGMAP','IMPD').
metabolite('38864: cpd:C00003','','path:rno00760;path:ec00760;path:rn00760','KEGGMAP','IMPD').
metabolite('36472: cpd:C00510','','path:rno01040;path:ec01040;path:rn01040','KEGGMAP','IMPD').
metabolite('36479: cpd:C16622','','path:ec00983;path:rno00983;path:rn00983','KEGGMAP','IMPD').
metabolite('38870: cpd:C02918','','path:rno00760;path:ec00760;path:rn00760','KEGGMAP','IMPD').
metabolite('36478: cpd:C00570','','path:ec00564;path:rn00564;path:rno00564','KEGGMAP','IMPD').
metabolite('36477: cpd:C01353','','path:ec00910;path:rn00910;path:rno00910','KEGGMAP','IMPD').
metabolite('36476: cpd:C03794','','path:ec00250;path:ec00230;path:rn00230;path:rno00250;path:rn00250;path:rno00230','KEGGMAP','IMPD').
metabolite('38858: cpd:C01185','','path:rno00760;path:ec00760;path:rn00760','KEGGMAP','IMPD').
metabolite('36450: cpd:C01089','','path:rn00072;path:rn00650;path:rno00072;path:ec00650;path:rno00650;path:ec00072','KEGGMAP','IMPD').
metabolite('36449: cpd:C06428','','path:rno01040;path:ec01040;path:rn01040','KEGGMAP','IMPD').
metabolite('36454: cpd:C00385','','path:ec00230;path:rn00232;path:ec00232;path:rn00230;path:rno00230','KEGGMAP','IMPD').
metabolite('36455: cpd:C05382','','path:ec00030;path:ec00540;path:rn00540;path:rno00030;path:ec00710;path:rn00710;path:rn00030','KEGGMAP','IMPD').
metabolite('36453: cpd:C00430','','path:ec00260;path:rn00860;path:ec00860;path:rno00860;path:rn00260;path:rno00260','KEGGMAP','IMPD').
metabolite('38848: cpd:C03722','','path:rno00760;path:ec00760;path:rn00760','KEGGMAP','IMPD').
metabolite('36456: cpd:C00157','','path:ec00564;path:rno00591;path:rno00590;path:rn00564;path:rno00564;path:rn00590;path:rno00592;path:ec00592;path:rn00592;path:ec00591;path:rn00591;path:ec00590','KEGGMAP','IMPD').
metabolite('36457: cpd:C00740','','path:ec00260;path:rn00260;path:rno00260','KEGGMAP','IMPD').
metabolite('38855: cpd:C00455','','path:rno00760;path:ec00760;path:rn00760','KEGGMAP','IMPD').
metabolite('36463: cpd:C16634','','path:ec00983;path:rno00983;path:rn00983','KEGGMAP','IMPD').
metabolite('36460: cpd:C16632','','path:ec00983;path:rno00983;path:rn00983','KEGGMAP','IMPD').
metabolite('38904: cpd:C05842','','path:rno00760;path:ec00760;path:rn00760','KEGGMAP','IMPD').
metabolite('38907: cpd:C05843','','path:rno00760;path:ec00760;path:rn00760','KEGGMAP','IMPD').
metabolite('36435: cpd:C00416','','path:ec00561;path:ec00564;path:rn00564;path:rn00561;path:rno00564;path:rno00561','KEGGMAP','IMPD').
metabolite('36434: cpd:C12144','','path:rn00600;path:ec00600;path:rno00600','KEGGMAP','IMPD').
metabolite('36437: cpd:C01888','','path:ec00260;path:rn00260;path:rno00260','KEGGMAP','IMPD').
metabolite('36439: cpd:C00546','','path:ec00260;path:rno00620;path:rn00620;path:rn00260;path:ec00620;path:rno00260','KEGGMAP','IMPD').
metabolite('38910: cpd:C05841','','path:rno00760;path:ec00760;path:rn00760','KEGGMAP','IMPD').
metabolite('36438: cpd:C01194','','path:ec00564;path:ec00562;path:ec00563;path:rn00562;path:rn00563;path:rn00564;path:rno00563;path:rno00564;path:rno00562','KEGGMAP','IMPD').
metabolite('36441: cpd:C00052','','path:rno00520;path:rno00052;path:rn00052;path:ec00052;path:ec00520;path:rn00520','KEGGMAP','IMPD').
metabolite('36440: cpd:C00513','','path:ec00564;path:rn00564;path:rno00564','KEGGMAP','IMPD').
metabolite('36443: cpd:C00269','','path:ec00564;path:rn00564;path:rno00564','KEGGMAP','IMPD').
metabolite('38898: cpd:C00153','','path:rno00760;path:ec00760;path:rn00760','KEGGMAP','IMPD').
metabolite('36445: cpd:C06427','','path:rno01040;path:rno00592;path:rn00592;path:ec00592;path:ec01040;path:rn01040','KEGGMAP','IMPD').
metabolite('36444: cpd:C00446','','path:rno00520;path:rno00052;path:rn00052;path:ec00052;path:ec00520;path:rn00520','KEGGMAP','IMPD').
metabolite('36447: cpd:C00189','','path:rn00440;path:ec00564;path:rn00564;path:rno00564;path:ec00440','KEGGMAP','IMPD').
metabolite('36446: cpd:C02050','','path:rno01040;path:ec01040;path:rn01040','KEGGMAP','IMPD').
metabolite('36417: cpd:C01672','','path:ec00960;path:ec00480;path:ec00310;path:rn00310;path:rno00480;path:rn00960;path:rn00480','KEGGMAP','IMPD').
metabolite('36418: cpd:C00147','','path:ec00230;path:rn00230;path:ec00908;path:rno00230;path:rn00908','KEGGMAP','IMPD').
metabolite('36419: cpd:C00093','','path:ec00561;path:ec00564;path:rn00564;path:rn00561;path:rno00564;path:rno00561','KEGGMAP','IMPD').
metabolite('36420: cpd:C00408','','path:ec00960;path:ec00310;path:rn00310;path:rno00310;path:rn00960','KEGGMAP','IMPD').
metabolite('36421: cpd:C01242','','path:ec00260;path:rn00260;path:rno00260','KEGGMAP','IMPD').
metabolite('38894: cpd:C03688','','path:rn00770;path:rno00770;path:ec00770','KEGGMAP','IMPD').
metabolite('36422: cpd:C12126','','path:rn00600;path:ec00600;path:rno00600','KEGGMAP','IMPD').
metabolite('36424: cpd:C00229','','path:rn00770;path:ec00071;path:rn00061;path:rn00071;path:rno00061;path:rno00770;path:ec00540;path:ec00770;path:ec00061;path:rn00540;path:rn00524;path:ec00524','KEGGMAP','IMPD').
metabolite('36425: cpd:C06425','','path:rno01040;path:ec01040;path:rn01040','KEGGMAP','IMPD').
metabolite('36428: cpd:C00836','','path:rn00600;path:ec00600;path:rno00600','KEGGMAP','IMPD').
metabolite('36429: cpd:C00636','','path:rno00051;path:rno00520;path:rn00051;path:ec00520;path:ec00051;path:rn00520','KEGGMAP','IMPD').
metabolite('36431: cpd:C00681','','path:ec00561;path:ec00564;path:rn00564;path:rn00561;path:rno00564;path:rno00561','KEGGMAP','IMPD').
metabolite('36407: cpd:C00450','','path:ec00960;path:ec00310;path:rn00310;path:rno00310;path:rn00960','KEGGMAP','IMPD').
metabolite('36406: cpd:C02985','','path:rno00051;path:rno00520;path:rn00051;path:ec00051;path:ec00520;path:rn00520','KEGGMAP','IMPD').
metabolite('36405: cpd:C05973','','path:ec00564;path:rn00564;path:rno00564','KEGGMAP','IMPD').
metabolite('38812: cpd:C00378','','path:ec00730;path:rno00730;path:rn00730','KEGGMAP','IMPD').
metabolite('36403: cpd:C04646','','path:ec00983;path:rno00983;path:rn00983','KEGGMAP','IMPD').
metabolite('38810: cpd:C03028','','path:ec00730;path:rno00730;path:rn00730','KEGGMAP','IMPD').
metabolite('36402: cpd:C11135','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36401: cpd:C05980','','path:ec00564;path:rn00564;path:rno00564','KEGGMAP','IMPD').
metabolite('36415: cpd:C00015','','path:ec00240;path:rno00240;path:rn00240;path:ec00908;path:rn00908','KEGGMAP','IMPD').
metabolite('36414: cpd:C12145','','path:rn00600;path:ec00600;path:rno00600','KEGGMAP','IMPD').
metabolite('36413: cpd:C06429','','path:rno01040;path:ec01040;path:rn01040','KEGGMAP','IMPD').
metabolite('36411: cpd:C00325','','path:rno00051;path:rno00520;path:rn00051;path:ec00051;path:ec00520;path:rn00520','KEGGMAP','IMPD').
metabolite('36410: cpd:C04438','','path:ec00564;path:rn00564;path:rno00564','KEGGMAP','IMPD').
metabolite('36408: cpd:C01290','','path:rn00600;path:ec00600;path:rno00600','KEGGMAP','IMPD').
metabolite('36391: cpd:C00170','','path:ec00270;path:rn00270;path:ec00908;path:rn00908;path:rno00270','KEGGMAP','IMPD').
metabolite('36388: cpd:C06174;dr:D00195 cpd:C06174','','path:ec00982;path:rn00950;path:rno00982;path:rn00982;path:ec00950','KEGGMAP','IMPD').
metabolite('36386: cpd:C01137','','path:rno00330;path:ec00270;path:ec00330;path:rn00270;path:rn00330;path:rno00270','KEGGMAP','IMPD').
metabolite('36387: cpd:C04373','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36385: cpd:C00986','','path:ec00260;path:ec00410;path:rn00410;path:rno00410;path:rn00330;path:rn00260','KEGGMAP','IMPD').
metabolite('36398: cpd:C00523','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36399: dr:D00346 cpd:C07054','','path:ec00983;path:rno00983;path:rn00983','KEGGMAP','IMPD').
metabolite('36397: cpd:C03242','','path:rno01040;path:ec01040;path:rn01040','KEGGMAP','IMPD').
metabolite('38787: cpd:C00016','','path:ec00740;path:rn00740;path:rno00740','KEGGMAP','IMPD').
metabolite('36392: cpd:C11136','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36393: cpd:C06124','','path:rn00600;path:ec00600;path:rno00600','KEGGMAP','IMPD').
metabolite('36372: cpd:C02737','','path:ec00260;path:ec00564;path:rn00564;path:rno00564;path:rn00260','KEGGMAP','IMPD').
metabolite('36375: cpd:C00249','','path:ec00071;path:rn00061;path:rn00062;path:rn00071;path:rno00061;path:rno00071;path:rno01040;path:rno00062;path:ec00061;path:ec00062;path:ec01040;path:rn01040','KEGGMAP','IMPD').
metabolite('36368: dr:D01223 cpd:C12650','','path:ec00983;path:rno00983;path:rn00983','KEGGMAP','IMPD').
metabolite('36370: cpd:C00712','','path:rn00061;path:rno00061;path:rno01040;path:ec00061;path:ec01040;path:rn01040','KEGGMAP','IMPD').
metabolite('36380: cpd:C00219','','path:rno00590;path:rno01040;path:rn00590;path:ec01040;path:ec00590;path:rn01040','KEGGMAP','IMPD').
metabolite('36382: cpd:C16614','','path:ec00983;path:rno00983;path:rn00983','KEGGMAP','IMPD').
metabolite('36376: cpd:C01241','','path:ec00564;path:rn00564;path:rno00564','KEGGMAP','IMPD').
metabolite('36379: cpd:C05294','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36359: cpd:C05293','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36352: cpd:C05560','','path:ec00300;path:rno00300;path:rn00300','KEGGMAP','IMPD').
metabolite('36353: cpd:C03917','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36354: cpd:C00148','','path:rn00401;path:rno00330;path:rno00970;path:ec00330;path:rn00330;path:rn00970;path:ec00970','KEGGMAP','IMPD').
metabolite('36364: cpd:C01530','','path:rn00061;path:rno00061;path:rno01040;path:ec00061;path:ec01040;path:rn01040','KEGGMAP','IMPD').
metabolite('36365: cpd:C00350','','path:ec00564;path:ec00563;path:rn00563;path:rn00564;path:rno00563;path:rno00564','KEGGMAP','IMPD').
metabolite('36367: cpd:C05290','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36361: cpd:C11134','','path:rn00140;path:rno00140;path:ec00140','KEGGMAP','IMPD').
metabolite('36362: cpd:C00187','','path:rn00100;path:rn00120;path:rno00100;path:rn00140;path:rno00140;path:ec00100;path:ec00140;path:rno00120;path:rn00981;path:ec00120','KEGGMAP','IMPD').
concept_name0('1: rn00010','path:rn00010',true).
concept_name0('30134: rno00250','path:rno00250',true).
concept_name0('31565: rno00400','path:rno00400',true).
concept_name0('3838: rn00360','path:rn00360',true).
concept_name0('7659: rn00620','path:rn00620',true).
concept_name0('13122: rn00970','path:rn00970',true).
concept_name0('13613: rn00983','path:rn00983',true).
concept_name0('30599: rno00290','path:rno00290',true).
concept_name0('35230: rno00970','path:rno00970',true).
concept_name0('34669: rno00790','path:rno00790',true).
concept_name0('33083: rno00563','path:rno00563',true).
concept_name0('8294: rn00625','path:rn00625',true).
concept_name0('28191: rno00051','path:rno00051',true).
concept_name0('514: rn00052','path:rn00052',true).
concept_name0('31047: rno00340','path:rno00340',true).
concept_name0('34653: rno00785','path:rno00785',true).
concept_name0('32030: rno00500','path:rno00500',true).
concept_name0('9756: rn00730','path:rn00730',true).
concept_name0('29132: rno00130','path:rno00130',true).
concept_name0('9276: rn00670','path:rn00670',true).
concept_name0('4909: rn00430','path:rn00430',true).
concept_name0('29671: rno00230','path:rno00230',true).
concept_name0('6550: rn00550','path:rn00550',true).
concept_name0('8070: rn00624','path:rn00624',true).
concept_name0('13693: rn01040','path:rn01040',true).
concept_name0('7587: rn00604','path:rn00604',true).
concept_name0('614: rn00053','path:rn00053',true).
concept_name0('34623: rno00780','path:rno00780',true).
concept_name0('4959: rn00440','path:rn00440',true).
concept_name0('1031: rn00071','path:rn00071',true).
concept_name0('30663: rno00300','path:rno00300',true).
concept_name0('12565: rn00950','path:rn00950',true).
concept_name0('97: rn00020','path:rn00020',true).
concept_name0('32616: rno00524','path:rno00524',true).
concept_name0('2768: rn00280','path:rn00280',true).
concept_name0('9317: rn00680','path:rn00680',true).
concept_name0('4447: rn00380','path:rn00380',true).
concept_name0('1536: rn00140','path:rn00140',true).
concept_name0('33136: rno00564','path:rno00564',true).
concept_name0('3235: rn00330','path:rn00330',true).
concept_name0('34563: rno00770','path:rno00770',true).
concept_name0('9815: rn00740','path:rn00740',true).
concept_name0('6611: rn00561','path:rn00561',true).
concept_name0('34092: rno00640','path:rno00640',true).
concept_name0('33605: rno00601','path:rno00601',true).
concept_name0('30491: rno00280','path:rno00280',true).
concept_name0('2612: rn00270','path:rn00270',true).
concept_name0('32173: rno00510','path:rno00510',true).
concept_name0('1774: rn00230','path:rn00230',true).
concept_name0('8385: rn00626','path:rn00626',true).
concept_name0('35619: rno00983','path:rno00983',true).
concept_name0('6448: rn00532','path:rn00532',true).
concept_name0('7545: rn00603','path:rn00603',true).
concept_name0('29028: rno00120','path:rno00120',true).
concept_name0('35100: rno00910','path:rno00910',true).
concept_name0('34791: rno00860','path:rno00860',true).
concept_name0('12769: rn00960','path:rn00960',true).
concept_name0('32674: rno00531','path:rno00531',true).
concept_name0('31725: rno00430','path:rno00430',true).
concept_name0('5050: rn00450','path:rn00450',true).
concept_name0('27827: rno00010','path:rno00010',true).
concept_name0('162: rn00030','path:rn00030',true).
concept_name0('9869: rn00750','path:rn00750',true).
concept_name0('10366: rn00860','path:rn00860',true).
concept_name0('3188: rn00311','path:rn00311',true).
concept_name0('8903: rn00640','path:rn00640',true).
concept_name0('14264: rn01058','path:rn01058',true).
concept_name0('29971: rno00240','path:rno00240',true).
concept_name0('6112: rn00522','path:rn00522',true).
concept_name0('2085: rn00232','path:rn00232',true).
concept_name0('6975: rn00565','path:rn00565',true).
concept_name0('34278: rno00670','path:rno00670',true).
concept_name0('11781: rn00920','path:rn00920',true).
concept_name0('11299: rn00906','path:rn00906',true).
concept_name0('28301: rno00052','path:rno00052',true).
concept_name0('35689: rno01040','path:rno01040',true).
concept_name0('6500: rn00540','path:rn00540',true).
concept_name0('13823: rn01051','path:rn01051',true).
concept_name0('10812: rn00902','path:rn00902',true).
concept_name0('2143: rn00240','path:rn00240',true).
concept_name0('34184: rno00650','path:rno00650',true).
concept_name0('34731: rno00830','path:rno00830',true).
concept_name0('11886: rn00940','path:rn00940',true).
concept_name0('1177: rn00072','path:rn00072',true).
concept_name0('33768: rno00603','path:rno00603',true).
concept_name0('10249: rn00791','path:rn00791',true).
concept_name0('28395: rno00053','path:rno00053',true).
concept_name0('7953: rn00623','path:rn00623',true).
concept_name0('32743: rno00532','path:rno00532',true).
concept_name0('31657: rno00410','path:rno00410',true).
concept_name0('5526: rn00510','path:rn00510',true).
concept_name0('33267: rno00565','path:rno00565',true).
concept_name0('1195: rn00100','path:rn00100',true).
concept_name0('8838: rn00633','path:rn00633',true).
concept_name0('5104: rn00460','path:rn00460',true).
concept_name0('10296: rn00830','path:rn00830',true).
concept_name0('6475: rn00534','path:rn00534',true).
concept_name0('728: rn00061','path:rn00061',true).
concept_name0('31129: rno00350','path:rno00350',true).
concept_name0('250: rn00040','path:rn00040',true).
concept_name0('3595: rn00350','path:rn00350',true).
concept_name0('7032: rn00590','path:rn00590',true).
concept_name0('13221: rn00980','path:rn00980',true).
concept_name0('9950: rn00760','path:rn00760',true).
concept_name0('35185: rno00920','path:rno00920',true).
concept_name0('6057: rn00521','path:rn00521',true).
concept_name0('28906: rno00072','path:rno00072',true).
concept_name0('6322: rn00524','path:rn00524',true).
concept_name0('30350: rno00270','path:rno00270',true).
concept_name0('33877: rno00620','path:rno00620',true).
concept_name0('34418: rno00750','path:rno00750',true).
concept_name0('13370: rn00981','path:rn00981',true).
concept_name0('28924: rno00100','path:rno00100',true).
concept_name0('4627: rn00400','path:rn00400',true).
concept_name0('10715: rn00901','path:rn00901',true).
concept_name0('6789: rn00563','path:rn00563',true).
concept_name0('11675: rn00910','path:rn00910',true).
concept_name0('2992: rn00300','path:rn00300',true).
concept_name0('5235: rn00473','path:rn00473',true).
concept_name0('27923: rno00020','path:rno00020',true).
concept_name0('30830: rno00330','path:rno00330',true).
concept_name0('34369: rno00740','path:rno00740',true).
concept_name0('2477: rn00260','path:rn00260',true).
concept_name0('9044: rn00643','path:rn00643',true).
concept_name0('31768: rno00450','path:rno00450',true).
concept_name0('32319: rno00512','path:rno00512',true).
concept_name0('6835: rn00564','path:rn00564',true).
concept_name0('33310: rno00590','path:rno00590',true).
concept_name0('32829: rno00534','path:rno00534',true).
concept_name0('5211: rn00472','path:rn00472',true).
concept_name0('11231: rn00905','path:rn00905',true).
concept_name0('35469: rno00982','path:rno00982',true).
concept_name0('7369: rn00601','path:rn00601',true).
concept_name0('5645: rn00512','path:rn00512',true).
concept_name0('1307: rn00120','path:rn00120',true).
concept_name0('10635: rn00900','path:rn00900',true).
concept_name0('9010: rn00642','path:rn00642',true).
concept_name0('13900: rn01055','path:rn01055',true).
concept_name0('29933: rno00232','path:rno00232',true).
concept_name0('3470: rn00331','path:rn00331',true).
concept_name0('33807: rno00604','path:rno00604',true).
concept_name0('5178: rn00471','path:rn00471',true).
concept_name0('6381: rn00531','path:rn00531',true).
concept_name0('3071: rn00310','path:rn00310',true).
concept_name0('35023: rno00900','path:rno00900',true).
concept_name0('27988: rno00030','path:rno00030',true).
concept_name0('13427: rn00982','path:rn00982',true).
concept_name0('30742: rno00310','path:rno00310',true).
concept_name0('3491: rn00340','path:rn00340',true).
concept_name0('28488: rno00061','path:rno00061',true).
concept_name0('8507: rn00627','path:rn00627',true).
concept_name0('10064: rn00770','path:rn00770',true).
concept_name0('383: rn00051','path:rn00051',true).
concept_name0('7868: rn00622','path:rn00622',true).
concept_name0('4169: rn00362','path:rn00362',true).
concept_name0('31292: rno00360','path:rno00360',true).
concept_name0('34314: rno00730','path:rno00730',true).
concept_name0('4720: rn00401','path:rn00401',true).
concept_name0('31817: rno00460','path:rno00460',true).
concept_name0('5693: rn00513','path:rn00513',true).
concept_name0('3998: rn00361','path:rn00361',true).
concept_name0('9570: rn00710','path:rn00710',true).
concept_name0('10165: rn00785','path:rn00785',true).
concept_name0('7290: rn00600','path:rn00600',true).
concept_name0('28772: rno00071','path:rno00071',true).
concept_name0('9202: rn00660','path:rn00660',true).
concept_name0('11521: rn00908','path:rn00908',true).
concept_name0('31929: rno00480','path:rno00480',true).
concept_name0('32918: rno00561','path:rno00561',true).
concept_name0('2329: rn00250','path:rn00250',true).
concept_name0('30225: rno00260','path:rno00260',true).
concept_name0('33469: rno00592','path:rno00592',true).
concept_name0('2878: rn00281','path:rn00281',true).
concept_name0('31912: rno00472','path:rno00472',true).
concept_name0('5369: rn00500','path:rn00500',true).
concept_name0('32397: rno00520','path:rno00520',true).
concept_name0('10133: rn00780','path:rn00780',true).
concept_name0('9648: rn00720','path:rn00720',true).
concept_name0('8701: rn00630','path:rn00630',true).
concept_name0('13985: rn01057','path:rn01057',true).
concept_name0('35350: rno00980','path:rno00980',true).
concept_name0('28072: rno00040','path:rno00040',true).
concept_name0('6695: rn00562','path:rn00562',true).
concept_name0('33430: rno00591','path:rno00591',true).
concept_name0('7778: rn00621','path:rn00621',true).
concept_name0('31885: rno00471','path:rno00471',true).
concept_name0('34478: rno00760','path:rno00760',true).
concept_name0('11043: rn00904','path:rn00904',true).
concept_name0('2924: rn00290','path:rn00290',true).
concept_name0('7222: rn00592','path:rn00592',true).
concept_name0('28714: rno00062','path:rno00062',true).
concept_name0('4321: rn00363','path:rn00363',true).
concept_name0('6247: rn00523','path:rn00523',true).
concept_name0('1412: rn00130','path:rn00130',true).
concept_name0('4830: rn00410','path:rn00410',true).
concept_name0('11607: rn00909','path:rn00909',true).
concept_name0('33534: rno00600','path:rno00600',true).
concept_name0('32993: rno00562','path:rno00562',true).
concept_name0('5255: rn00480','path:rn00480',true).
concept_name0('31414: rno00380','path:rno00380',true).
concept_name0('5815: rn00520','path:rn00520',true).
concept_name0('7177: rn00591','path:rn00591',true).
concept_name0('33976: rno00630','path:rno00630',true).
concept_name0('10182: rn00790','path:rn00790',true).
concept_name0('29239: rno00140','path:rno00140',true).
concept_name0('9098: rn00650','path:rn00650',true).
concept_name0('961: rn00062','path:rn00062',true).
concept_name0('12983: rn00966','path:rn00966',true).
concept_name0('2426: rn00253','path:rn00253',true).
concept_name0('9: rn:R00755','R00755...',true).
concept_name0('9: rn:R00755','rn:R00755 rp:RP01089 rc:RC00375',false).
concept_name0('27: rn:R02738','R02738...',true).
concept_name0('27: rn:R02738','rn:R02738 rp:RP02452 rc:RC00017',false).
concept_name0('8829: rn:R00934','R00934...',true).
concept_name0('8829: rn:R00934','rn:R00934 rp:RP01183 rp:RP01184 rc:RC00311 rc:RC00407',false).
concept_name0('8770: rn:R01388','R01388...',true).
concept_name0('8770: rn:R01388','rn:R01388 rp:RP00299 rc:RC00031',false).
concept_name0('39: rn:R00947','R00947...',true).
concept_name0('39: rn:R00947','rn:R00947 rp:RP00303 rc:RC00078',false).
concept_name0('40: rn:R00960','R00960...',true).
concept_name0('40: rn:R00960','rn:R00960 rp:RP00303 rc:RC00078',false).
concept_name0('8740: rn:R01392','R01392...',true).
concept_name0('8740: rn:R01392','rn:R01392 rp:RP00299 rc:RC00031',false).
concept_name0('8741: rn:R01388','R01388...',true).
concept_name0('8741: rn:R01388','rn:R01388 rp:RP00299 rc:RC00031',false).
concept_name0('8742: rn:R01745 rn:R01747','R01745...',true).
concept_name0('8742: rn:R01745 rn:R01747','rn:R01745 rn:R01747 rp:RP00349 rp:RP00349 rc:RC00099 rc:RC00099',false).
concept_name0('8743: rn:R00013','rn:R00013 rp:RP02916 rc:RC00899',false).
concept_name0('8743: rn:R00013','R00013...',true).
concept_name0('8739: rn:R01388 rn:R01392','R01388...',true).
concept_name0('8739: rn:R01388 rn:R01392','rn:R01388 rn:R01392 rp:RP00299 rp:RP00299 rc:RC00031 rc:RC00031',false).
concept_name0('8744: rn:R00472','R00472...',true).
concept_name0('8744: rn:R00472','rn:R00472 rp:RP00921 rc:RC00308',false).
concept_name0('4473: rn:R01816','R01816...',true).
concept_name0('4473: rn:R01816','rn:R01816 rp:RP01777 rc:RC00046',false).
concept_name0('85: rn:R01196','rn:R01196',false).
concept_name0('85: rn:R01196','R01196',true).
concept_name0('84: rn:R01058','R01058...',true).
concept_name0('84: rn:R01058','rn:R01058 rp:RP01264 rc:RC00242',false).
concept_name0('86: rn:R07159','R07159...',true).
concept_name0('86: rn:R07159','rn:R07159 rp:RP01264 rc:RC00242',false).
concept_name0('4451: rn:R01974','rn:R01974 rp:RP01885 rc:RC00506',false).
concept_name0('4451: rn:R01974','R01974...',true).
concept_name0('83: rn:R07159','R07159...',true).
concept_name0('83: rn:R07159','rn:R07159 rp:RP01264 rc:RC00242',false).
concept_name0('8767: rn:R03140','R03140...',true).
concept_name0('8767: rn:R03140','rn:R03140 rp:RP00477 rp:RP02791 rc:RC00172 rc:RC00859',false).
concept_name0('8710: rn:R00479','R00479...',true).
concept_name0('8710: rn:R00479','rn:R00479 rp:RP00930 rp:RP00931 rc:RC00313 rc:RC00311',false).
concept_name0('8708: rn:R00477','rn:R00477 rp:RP00926 rp:RP00927 rc:RC00310 rc:RC00311',false).
concept_name0('8708: rn:R00477','R00477...',true).
concept_name0('8709: rn:R00470','rn:R00470 rp:RP00917 rp:RP00918 rc:RC00307 rc:RC00308',false).
concept_name0('8709: rn:R00470','R00470...',true).
concept_name0('8707: rn:R01180','R01180...',true).
concept_name0('8707: rn:R01180','rn:R01180 rp:RP01345 rc:RC00311',false).
concept_name0('99: rn:R01197','rn:R01197',false).
concept_name0('99: rn:R01197','R01197',true).
concept_name0('8705: rn:R00474','R00474...',true).
concept_name0('8705: rn:R00474','rn:R00474 rp:RP00925 rc:RC00309',false).
concept_name0('8733: rn:R03146','R03146',true).
concept_name0('8733: rn:R03146','rn:R03146',false).
concept_name0('8732: rn:R00519','R00519',true).
concept_name0('8732: rn:R00519','rn:R00519',false).
concept_name0('8936: rn:R01199','R01199',true).
concept_name0('8936: rn:R01199','rn:R01199',false).
concept_name0('8940: rn:R01608','R01608...',true).
concept_name0('8940: rn:R01608','rn:R01608 rp:RP01630 rc:RC00087',false).
concept_name0('8935: rn:R01199','R01199',true).
concept_name0('8935: rn:R01199','rn:R01199',false).
concept_name0('155: rn:R01196','rn:R01196',false).
concept_name0('155: rn:R01196','R01196',true).
concept_name0('8944: rn:R01611','R01611...',true).
concept_name0('8944: rn:R01611','rn:R01611 rp:RP01634 rc:RC00565',false).
concept_name0('4516: rn:R04172','R04172...',true).
concept_name0('4516: rn:R04172','rn:R04172 rp:RP03805 rc:RC00299',false).
concept_name0('8907: rn:R06987','R06987',true).
concept_name0('8907: rn:R06987','rn:R06987',false).
concept_name0('169: rn:R01066','rn:R01066 rp:RP01269 rc:RC00437',false).
concept_name0('169: rn:R01066','R01066...',true).
concept_name0('168: rn:R02749','rn:R02749 rp:RP02468 rc:RC00408',false).
concept_name0('168: rn:R02749','R02749...',true).
concept_name0('4503: rn:R01974','rn:R01974 rp:RP01885 rc:RC00506',false).
concept_name0('4503: rn:R01974','R01974...',true).
concept_name0('165: rn:R05605','R05605...',true).
concept_name0('165: rn:R05605','rn:R05605 rp:RP05200 rp:RP05201 rc:RC00307 rc:RC00435',false).
concept_name0('8923: rn:R00920','R00920...',true).
concept_name0('8923: rn:R00920','rn:R00920 rp:RP00117 rc:RC00014',false).
concept_name0('8920: rn:R00928','R00928...',true).
concept_name0('8920: rn:R00928','rn:R00928 rp:RP00117 rc:RC00014',false).
concept_name0('189: rn:R01737','R01737...',true).
concept_name0('189: rn:R01737','rn:R01737 rp:RP01728 rc:RC00017',false).
concept_name0('8914: rn:R03381','R03381...',true).
concept_name0('8914: rn:R03381','rn:R03381 rp:RP03001 rc:RC00846',false).
concept_name0('8915: rn:R02764','rn:R02764 rp:RP02481 rc:RC00137',false).
concept_name0('8915: rn:R02764','R02764...',true).
concept_name0('13208: rn:R08223','R08223...',true).
concept_name0('13208: rn:R08223','rn:R08223 rp:RP13086 rc:RC00017',false).
concept_name0('13211: rn:R08219','R08219...',true).
concept_name0('13211: rn:R08219','rn:R08219 rp:RP13084 rc:RC01246',false).
concept_name0('202: rn:R01522','R01522...',true).
concept_name0('202: rn:R01522','rn:R01522 rp:RP00184 rc:RC00066',false).
concept_name0('193: rn:R00305','rn:R00305 rp:RP00321 rc:RC00066',false).
concept_name0('193: rn:R00305','R00305...',true).
concept_name0('192: rn:R06620','rn:R06620 rp:RP00321 rc:RC00066',false).
concept_name0('192: rn:R06620','R06620...',true).
concept_name0('195: rn:R01520 rn:R01521','rn:R01520 rn:R01521 rp:RP00184 rp:RP00184 rc:RC00066 rc:RC00066',false).
concept_name0('195: rn:R01520 rn:R01521','R01520...',true).
concept_name0('194: rn:R01522','R01522...',true).
concept_name0('194: rn:R01522','rn:R01522 rp:RP00184 rc:RC00066',false).
concept_name0('212: rn:R05605','R05605...',true).
concept_name0('212: rn:R05605','rn:R05605 rp:RP05200 rp:RP05201 rc:RC00307 rc:RC00435',false).
concept_name0('208: rn:R08570','rn:R08570 rp:RP13333 rp:RP13334 rc:RC00307 rc:RC00435',false).
concept_name0('208: rn:R08570','R08570...',true).
concept_name0('210: rn:R08572','R08572...',true).
concept_name0('210: rn:R08572','rn:R08572 rp:RP01729 rc:RC00428',false).
concept_name0('13236: rn:R07073','rn:R07073 rp:RP10227 rc:RC01752',false).
concept_name0('13236: rn:R07073','R07073...',true).
concept_name0('279: rn:R01896','rn:R01896 rp:RP01827 rc:RC00102',false).
concept_name0('279: rn:R01896','R01896...',true).
concept_name0('283: rn:R01903','R01903...',true).
concept_name0('283: rn:R01903','rn:R01903 rp:RP01833 rc:RC00102',false).
concept_name0('280: rn:R01432','rn:R01432 rp:RP01508 rc:RC00516',false).
concept_name0('280: rn:R01432','R01432...',true).
concept_name0('287: rn:R01905','R01905...',true).
concept_name0('287: rn:R01905','rn:R01905 rp:RP01834 rc:RC00619',false).
concept_name0('9063: rn:R05487','R05487...',true).
concept_name0('9063: rn:R05487','rn:R05487 rp:RP05085 rc:RC00046',false).
concept_name0('9066: rn:R05450','R05450...',true).
concept_name0('9066: rn:R05450','rn:R05450 rp:RP05060 rc:RC00490',false).
concept_name0('9048: rn:R02540','rn:R02540 rp:RP02287 rc:RC00010',false).
concept_name0('9048: rn:R02540','R02540...',true).
concept_name0('12906: rn:R00446','R00446...',true).
concept_name0('12906: rn:R00446','rn:R00446 rp:RP00405 rc:RC00062',false).
concept_name0('12917: rn:R02317','R02317...',true).
concept_name0('12917: rn:R02317','rn:R02317 rp:RP02122 rc:RC00694',false).
concept_name0('293: rn:R01481','R01481...',true).
concept_name0('293: rn:R01481','rn:R01481 rp:RP01544 rc:RC00108',false).
concept_name0('9007: rn:R01438','rn:R01438',false).
concept_name0('9007: rn:R01438','R01438',true).
concept_name0('8965: rn:R00740','rn:R00740 rp:RP01076 rc:RC00184',false).
concept_name0('8965: rn:R00740','R00740...',true).
concept_name0('12849: rn:R00462','rn:R00462 rp:RP00913 rc:RC00299',false).
concept_name0('12849: rn:R00462','R00462...',true).
concept_name0('4266: rn:R00829','rn:R00829 rp:RP06330 rc:RC00326',false).
concept_name0('4266: rn:R00829','R00829...',true).
concept_name0('9209: rn:R00932','R00932...',true).
concept_name0('9209: rn:R00932','rn:R00932 rp:RP01182 rc:RC00308',false).
concept_name0('4261: rn:R00829','rn:R00829 rp:RP06330 rc:RC00326',false).
concept_name0('4261: rn:R00829','R00829...',true).
concept_name0('392: rn:R00877','rn:R00877 rp:RP01153 rc:RC00376',false).
concept_name0('392: rn:R00877','R00877...',true).
concept_name0('399: rn:R02730','rn:R02730 rp:RP02444 rc:RC00017',false).
concept_name0('399: rn:R02730','R02730...',true).
concept_name0('390: rn:R00878','rn:R00878 rp:RP01154 rc:RC00376',false).
concept_name0('390: rn:R00878','R00878...',true).
concept_name0('425: rn:R02071','R02071...',true).
concept_name0('425: rn:R02071','rn:R02071 rp:RP01952 rc:RC00017',false).
concept_name0('428: rn:R01059','rn:R01059 rp:RP01265 rc:RC00017',false).
concept_name0('428: rn:R01059','R01059...',true).
concept_name0('9123: rn:R00212','rn:R00212',false).
concept_name0('9123: rn:R00212','R00212',true).
concept_name0('9122: rn:R01196','rn:R01196',false).
concept_name0('9122: rn:R01196','R01196',true).
concept_name0('4290: rn:R00750','R00750...',true).
concept_name0('4290: rn:R00750','rn:R00750 rp:RP01083 rp:RP01084 rc:RC00307 rc:RC00371',false).
concept_name0('4310: rn:R00228','rn:R00228 rp:RP04321 rc:RC01195',false).
concept_name0('4310: rn:R00228','R00228...',true).
concept_name0('550: rn:R02411','rn:R02411 rp:RP00235 rc:RC00059',false).
concept_name0('550: rn:R02411','R02411...',true).
concept_name0('556: rn:R01192','rn:R01192',false).
concept_name0('556: rn:R01192','R01192',true).
concept_name0('4867: rn:R01166','R01166...',true).
concept_name0('4867: rn:R01166','rn:R01166 rp:RP00505 rp:RP00508 rc:RC00090 rc:RC00064',false).
concept_name0('4865: rn:R01164','rn:R01164 rp:RP00505 rc:RC00090',false).
concept_name0('4865: rn:R01164','R01164...',true).
concept_name0('8295: rn:R09158','rn:R09158',false).
concept_name0('8295: rn:R09158','R09158',true).
concept_name0('524: rn:R03635','R03635...',true).
concept_name0('524: rn:R03635','rn:R03635 rp:RP03249 rc:RC00077',false).
concept_name0('4926: rn:R05652','rn:R05652 rp:RP00021 rp:RP00163 rc:RC00008 rc:RC00062',false).
concept_name0('4926: rn:R05652','R05652...',true).
concept_name0('520: rn:R01069','R01069...',true).
concept_name0('520: rn:R01069','rn:R01069 rp:RP01272 rp:RP01273 rc:RC00438 rc:RC00439',false).
concept_name0('4921: rn:R00230','rn:R00230',false).
concept_name0('4921: rn:R00230','R00230',true).
concept_name0('4923: rn:R05651','R05651',true).
concept_name0('4923: rn:R05651','rn:R05651',false).
concept_name0('12614: rn:R02383','rn:R02383 rp:RP02171 rc:RC00046',false).
concept_name0('12614: rn:R02383','R02383...',true).
concept_name0('528: rn:R02410','rn:R02410 rp:RP02188 rc:RC00077',false).
concept_name0('528: rn:R02410','R02410...',true).
concept_name0('4908: rn:R09077','rn:R09077 rp:RP14323 rc:RC00225',false).
concept_name0('4908: rn:R09077','R09077...',true).
concept_name0('4911: rn:R05320','R05320...',true).
concept_name0('4911: rn:R05320','rn:R05320 rp:RP04923 rc:RC01331',false).
concept_name0('4907: rn:R09076','rn:R09076 rp:RP02564 rp:RP14322 rc:RC00053 rc:RC00225',false).
concept_name0('4907: rn:R09076','R09076...',true).
concept_name0('4958: rn:R02434','rn:R02434 rp:RP02211 rc:RC00580',false).
concept_name0('4958: rn:R02434','R02434...',true).
concept_name0('4935: rn:R00901','R00901',true).
concept_name0('4935: rn:R00901','rn:R00901',false).
concept_name0('12580: rn:R04305','rn:R04305 rp:RP03938 rp:RP03939 rc:RC01071 rc:RC01072',false).
concept_name0('12580: rn:R04305','R04305...',true).
concept_name0('4936: rn:R01681','rn:R01681 rp:RP01686 rc:RC00580',false).
concept_name0('4936: rn:R01681','R01681...',true).
concept_name0('39679: rn:R03657','Lars, MGC105585...',true).
concept_name0('39679: rn:R03657','rno:291624 rno:363172',false).
concept_name0('39678: rn:R01090','Bcat1, Bcatc, MGC105472...',true).
concept_name0('39678: rn:R01090','rno:29592 rno:64203',false).
concept_name0('39677: rn:R02199','Bcat1, Bcatc, MGC105472...',true).
concept_name0('39677: rn:R02199','rno:29592 rno:64203',false).
concept_name0('39676: rn:R00533','Suox',true).
concept_name0('39676: rn:R00533','rno:81805',false).
concept_name0('682: rn:R01483','R01483...',true).
concept_name0('682: rn:R01483','rn:R01483 rp:RP01546 rc:RC00531',false).
concept_name0('653: rn:R03183','rn:R03183 rp:RP02822 rc:RC00099',false).
concept_name0('653: rn:R03183','R03183...',true).
concept_name0('654: rn:R01481','R01481...',true).
concept_name0('654: rn:R01481','rn:R01481 rp:RP01544 rc:RC00108',false).
concept_name0('662: rn:R02754','rn:R02754 rp:RP02472 rp:RP02473 rc:RC00307 rc:RC00435',false).
concept_name0('662: rn:R02754','R02754...',true).
concept_name0('657: rn:R03277','R03277...',true).
concept_name0('657: rn:R03277','rn:R03277 rp:RP02906 rp:RP02907 rc:RC00307 rc:RC00435',false).
concept_name0('5072: rn:R07229','rn:R07229 rp:RP11594 rc:RC02420',false).
concept_name0('5072: rn:R07229','R07229...',true).
concept_name0('12727: rn:R02383','rn:R02383 rp:RP02171 rc:RC00046',false).
concept_name0('12727: rn:R02383','R02383...',true).
concept_name0('5079: rn:R08223','R08223...',true).
concept_name0('5079: rn:R08223','rn:R08223 rp:RP13086 rc:RC00017',false).
concept_name0('755: rn:R03370','R03370...',true).
concept_name0('755: rn:R03370','rn:R03370 rp:RP02989 rc:RC00917',false).
concept_name0('8337: rn:R06973','rn:R06973 rp:RP10307 rc:RC01775',false).
concept_name0('8337: rn:R06973','R06973...',true).
concept_name0('12699: rn:R03341','R03341...',true).
concept_name0('12699: rn:R03341','rn:R03341 rp:RP02956 rc:RC00506',false).
concept_name0('8367: rn:R09151','R09151',true).
concept_name0('8367: rn:R09151','rn:R09151',false).
concept_name0('5097: rn:R04931','R04931...',true).
concept_name0('5097: rn:R04931','rn:R04931 rp:RP04537 rc:RC01241',false).
concept_name0('5101: rn:R09371','R09371',true).
concept_name0('5101: rn:R09371','rn:R09371',false).
concept_name0('8368: rn:R09152','R09152',true).
concept_name0('8368: rn:R09152','rn:R09152',false).
concept_name0('5094: rn:R08219','R08219...',true).
concept_name0('5094: rn:R08219','rn:R08219 rp:RP13084 rc:RC01246',false).
concept_name0('39814: rn:R00238','rno:25014 rno:308100',false).
concept_name0('39814: rn:R00238','Acat1, RATACAL...',true).
concept_name0('39815: rn:R00782','rno:24962',false).
concept_name0('39815: rn:R00782','Cth, H',true).
concept_name0('39812: rn:R02082','Hmgcr, 3H3M',true).
concept_name0('39812: rn:R02082','rno:25675',false).
concept_name0('39813: rn:R01978','Hmgcs2, Hmgcs1, Mt3h3mg...',true).
concept_name0('39813: rn:R01978','rno:24450 rno:29637',false).
concept_name0('39810: rn:R02408','rno:24962',false).
concept_name0('39810: rn:R02408','Cth, H',true).
concept_name0('39811: rn:R00893','rno:81718',false).
concept_name0('39811: rn:R00893','Cdo1',true).
concept_name0('39808: rn:R02433','rno:24401 rno:25721',false).
concept_name0('39808: rn:R02433','Got1, Aspat, Gaspat...',true).
concept_name0('39809: rn:R01123','RGD1564999...',true).
concept_name0('39809: rn:R01123','rno:291266 rno:89784',false).
concept_name0('39822: rn:R01072','rno:117544',false).
concept_name0('39822: rn:R01072','Ppat, Atase, MGC93251',true).
concept_name0('39823: rn:R01514','Glyctk',true).
concept_name0('39823: rn:R01514','rno:684314',false).
concept_name0('39820: rn:R03104','rno:24533 rno:24534 rno:29634 rno:369018 rno:500965',false).
concept_name0('39820: rn:R03104','Ldha, Ldh1...',true).
concept_name0('39821: rn:R03220','Cpox, MGC124847',true).
concept_name0('39821: rn:R03220','rno:304024',false).
concept_name0('39818: rn:R00896','rno:24401 rno:25721',false).
concept_name0('39818: rn:R00896','Got1, Aspat, Gaspat...',true).
concept_name0('39819: rn:R03105','Mpst, Mst...',true).
concept_name0('39819: rn:R03105','rno:192172 rno:25274',false).
concept_name0('39816: rn:R02245','Mvk',true).
concept_name0('39816: rn:R02245','rno:81727',false).
concept_name0('39817: rn:R02619','rno:24401 rno:25721',false).
concept_name0('39817: rn:R02619','Got1, Aspat, Gaspat...',true).
concept_name0('39831: rn:R06171','688286',true).
concept_name0('39831: rn:R06171','rno:688286',false).
concept_name0('4628: rn:R01826','rn:R01826 rp:RP01785 rc:RC00435',false).
concept_name0('4628: rn:R01826','R01826...',true).
concept_name0('39830: rn:R00565','Gatm, MGC93388',true).
concept_name0('39830: rn:R00565','rno:81660',false).
concept_name0('39829: rn:R01290','rno:24250',false).
concept_name0('39829: rn:R01290','Cbs',true).
concept_name0('39828: rn:R01001','rno:24962',false).
concept_name0('39828: rn:R01001','Cth, H',true).
concept_name0('39827: rn:R01565','rno:245961',false).
concept_name0('39827: rn:R01565','Dmgdh, Me2GlyDH',true).
concept_name0('39826: rn:R00589','Srr, MGC94291',true).
concept_name0('39826: rn:R00589','rno:303306',false).
concept_name0('39825: rn:R02565 rn:R02566','Aldh7a1, antiquitin',true).
concept_name0('39825: rn:R02565 rn:R02566','rno:291450',false).
concept_name0('39824: rn:R01025','rno:290551',false).
concept_name0('39824: rn:R01025','Chdh, MGC93763',true).
concept_name0('39839: rn:R00371','rno:366959',false).
concept_name0('39839: rn:R00371','Gcat, MGC109060',true).
concept_name0('39838: rn:R01465','rno:290315',false).
concept_name0('39838: rn:R01465','Tdh',true).
concept_name0('39837: rn:R00366','Dao, Dao1',true).
concept_name0('39837: rn:R00366','rno:114027',false).
concept_name0('39836: rn:R01883','rno:25257',false).
concept_name0('39836: rn:R01883','Gamt, GMT',true).
concept_name0('39835: rn:R01513','rno:58835',false).
concept_name0('39835: rn:R01513','Phgdh, MGC105399',true).
concept_name0('39834: rn:R00585','Agxt, Spat',true).
concept_name0('39834: rn:R00585','rno:24792',false).
concept_name0('39833: rn:R00588','Agxt, Spat',true).
concept_name0('39833: rn:R00588','rno:24792',false).
concept_name0('39832: rn:R02821','rno:81508',false).
concept_name0('39832: rn:R02821','Bhmt',true).
concept_name0('39844: rn:R00582','rno:304429',false).
concept_name0('39844: rn:R00582','Psph, MGC109524',true).
concept_name0('39845: rn:R00945','rno:287379 rno:299857',false).
concept_name0('39845: rn:R00945','Shmt1, LRRGT00032, Shmt, mShmt...',true).
concept_name0('39846: rn:R00751','688286',true).
concept_name0('39846: rn:R00751','rno:688286',false).
concept_name0('39847: rn:R04979','Gusb, Ac2-223, Gus-s',true).
concept_name0('39847: rn:R04979','rno:24434',false).
concept_name0('39840: rn:R00220','rno:25044',false).
concept_name0('39840: rn:R00220','Sds, MGC108581, RATSDHE1, SDH2, Sdh, Sdhe1, TDH',true).
concept_name0('39841: rn:R04173','Psat1, Psa1',true).
concept_name0('39841: rn:R04173','rno:293820',false).
concept_name0('39842: rn:R00610','Pipox',true).
concept_name0('39842: rn:R00610','rno:303272',false).
concept_name0('39843: rn:R00611','Sardh',true).
concept_name0('39843: rn:R00611','rno:114123',false).
concept_name0('39852: rn:R02529','rno:25750 rno:29253',false).
concept_name0('39852: rn:R02529','Maob...',true).
concept_name0('39853: rn:R00830','rno:25748 rno:65155',false).
concept_name0('39853: rn:R00830','Alas2...',true).
concept_name0('39854: rn:R03425','Gldc',true).
concept_name0('39854: rn:R03425','rno:309312',false).
concept_name0('4653: rn:R01073','R01073...',true).
concept_name0('4653: rn:R01073','rn:R01073 rp:RP01279 rc:RC00440',false).
concept_name0('39855: rn:R00367','Gnmt',true).
concept_name0('39855: rn:R00367','rno:25134',false).
concept_name0('39848: rn:R03815','rno:298942',false).
concept_name0('39848: rn:R03815','Dld',true).
concept_name0('39849: rn:R04125','Amt',true).
concept_name0('39849: rn:R04125','rno:306586',false).
concept_name0('39850: rn:R02389','rno:113992 rno:154516 rno:24861 rno:24862 rno:266685 rno:286954 rno:289533 rno:29623 rno:301595 rno:305264 rno:396527 rno:396551 rno:396552 rno:574523 rno:63867 rno:83808',false).
concept_name0('39850: rn:R02389','Ugt1a6, MGC124929, UDPGT_1-6, Udpgt, Ugt1, Ugt1a7...',true).
concept_name0('39851: rn:R02529','rno:29473',false).
concept_name0('39851: rn:R02529','Aoc3, SSAO',true).
concept_name0('39861: rn:R03165','rno:309070',false).
concept_name0('39861: rn:R03165','Uros',true).
concept_name0('39860: rn:R04972','rno:29421',false).
concept_name0('39860: rn:R04972','Urod, porphyrinogen_carboxy-lyase',true).
concept_name0('39863: rn:R03222','rno:289219',false).
concept_name0('39863: rn:R03222','Ppox',true).
concept_name0('39862: rn:R03197','rno:29421',false).
concept_name0('39862: rn:R03197','Urod, porphyrinogen_carboxy-lyase',true).
concept_name0('39857: rn:R00830','rno:25748 rno:65155',false).
concept_name0('39857: rn:R00830','Alas2...',true).
concept_name0('39856: rn:R05578','rno:289352 rno:361641',false).
concept_name0('39856: rn:R05578','Eprs...',true).
concept_name0('39859: rn:R00084','rno:25709',false).
concept_name0('39859: rn:R00084','Hmbs, MGC108753, PBG-D, PBGD, URO-S, hemC',true).
concept_name0('39858: rn:R00036','rno:25374',false).
concept_name0('39858: rn:R00036','Alad, ALADR, aminolevulinatedelta-dehydratase',true).
concept_name0('39869: rn:R08174','rno:192272 rno:26759 rno:29725 rno:314304 rno:503049 rno:50559 rno:681337',false).
concept_name0('39869: rn:R08174','Acot2, Mte1...',true).
concept_name0('39868: rn:R02391 rn:R02393','Blvra...',true).
concept_name0('39868: rn:R02391 rn:R02393','rno:116599 rno:292737',false).
concept_name0('39871: rn:R08179','Acot2, Mte1...',true).
concept_name0('39871: rn:R08179','rno:192272 rno:26759 rno:314304 rno:503049 rno:50559 rno:681337',false).
concept_name0('39870: rn:R01274','rno:192272 rno:26759 rno:29725 rno:314304 rno:503049 rno:50559 rno:681337',false).
concept_name0('39870: rn:R01274','Acot2, Mte1...',true).
concept_name0('39865: rn:R00078','100360087...',true).
concept_name0('39865: rn:R00078','rno:100360087 rno:24268 rno:25319 rno:291470 rno:29292',false).
concept_name0('39864: rn:R00310','rno:361338',false).
concept_name0('39864: rn:R00310','Fech',true).
concept_name0('39867: rn:R02480','Hccs, RGD1563855',true).
concept_name0('39867: rn:R02480','rno:317444',false).
concept_name0('39866: rn:R07411','687381',true).
concept_name0('39866: rn:R07411','rno:687381',false).
concept_name0('39874: rn:R08182','Acot2, Mte1...',true).
concept_name0('39874: rn:R08182','rno:192272 rno:26759 rno:314304 rno:503049 rno:50559 rno:681337',false).
concept_name0('39875: rn:R08183','Acot2, Mte1...',true).
concept_name0('39875: rn:R08183','rno:192272 rno:26759 rno:314304 rno:503049 rno:50559 rno:681337',false).
concept_name0('39872: rn:R08180','Acot2, Mte1...',true).
concept_name0('39872: rn:R08180','rno:192272 rno:26759 rno:314304 rno:503049 rno:50559 rno:681337',false).
concept_name0('39873: rn:R08181','Acot2, Mte1...',true).
concept_name0('39873: rn:R08181','rno:192272 rno:26759 rno:314304 rno:503049 rno:50559 rno:681337',false).
concept_name0('39878: rn:R08175','rno:192272 rno:26759 rno:29725 rno:314304 rno:503049 rno:50559 rno:681337',false).
concept_name0('39878: rn:R08175','Acot2, Mte1...',true).
concept_name0('39879: rn:R08178','Acot2, Mte1...',true).
concept_name0('39879: rn:R08178','rno:192272 rno:26759 rno:314304 rno:503049 rno:50559 rno:681337',false).
concept_name0('39876: rn:R08177','Acot2, Mte1...',true).
concept_name0('39876: rn:R08177','rno:192272 rno:26759 rno:314304 rno:503049 rno:50559 rno:681337',false).
concept_name0('39877: rn:R08176','Acot2, Mte1...',true).
concept_name0('39877: rn:R08176','rno:192272 rno:26759 rno:314304 rno:503049 rno:50559 rno:681337',false).
concept_name0('39882: rn:R00256','Gls2, Ga...',true).
concept_name0('39882: rn:R00256','rno:192268 rno:24398',false).
concept_name0('39883: rn:R00253','Glul, Glns',true).
concept_name0('39883: rn:R00253','rno:24957',false).
concept_name0('39880: rn:R00261','rno:24379 rno:24380',false).
concept_name0('39880: rn:R00261','Gad1, Gad67...',true).
concept_name0('39881: rn:R01648','Abat, Gabat, MGC93392, beta-AlaAT',true).
concept_name0('39881: rn:R01648','rno:81632',false).
concept_name0('39886: rn:R00768','rno:297417 rno:360518',false).
concept_name0('39886: rn:R00768','Gfpt1, GFA, GFAT, GFAT1, GFAT1m, Gfpt, MGC95214...',true).
concept_name0('39887: rn:R00707 rn:R00708','Aldh4a1',true).
concept_name0('39887: rn:R00707 rn:R00708','rno:641316',false).
concept_name0('39884: rn:R00149','Cps1',true).
concept_name0('39884: rn:R00149','rno:497840',false).
concept_name0('39885: rn:R00575','Cad',true).
concept_name0('39885: rn:R00575','rno:24240',false).
concept_name0('39891: rn:R01954','Ass1, ASSA, Ass',true).
concept_name0('39891: rn:R01954','rno:25698',false).
concept_name0('39890: rn:R00243 rn:R00248','Glud1, Ac2-281, Glud, MGC93608, MRG-2',true).
concept_name0('39890: rn:R00243 rn:R00248','rno:24399',false).
concept_name0('39889: rn:R00713','rno:291133',false).
concept_name0('39889: rn:R00713','Aldh5a1, Ssadh',true).
concept_name0('39888: rn:R00269','rno:288174',false).
concept_name0('39888: rn:R00269','Nit2, MGC124762, RGD1310494',true).
concept_name0('39895: rn:R00369','Agxt, Spat...',true).
concept_name0('39895: rn:R00369','rno:24792 rno:83784',false).
concept_name0('39894: rn:R01086','rno:59085',false).
concept_name0('39894: rn:R01086','Asl',true).
concept_name0('39893: rn:R01083','Adsl, null',true).
concept_name0('39893: rn:R01083','rno:315150',false).
concept_name0('39892: rn:R01135','rno:289276 rno:684425',false).
concept_name0('39892: rn:R01135','Adss, Adss2...',true).
concept_name0('39899: rn:R00348','rno:288174',false).
concept_name0('39899: rn:R00348','Nit2, MGC124762, RGD1310494',true).
concept_name0('39898: rn:R00488','rno:293653 rno:79251',false).
concept_name0('39898: rn:R00488','Acy3, MGC108859, RGD1305394...',true).
concept_name0('39897: rn:R01397','Cad',true).
concept_name0('39897: rn:R01397','rno:24240',false).
concept_name0('39896: rn:R00258','rno:307759 rno:81670',false).
concept_name0('39896: rn:R00258','Gpt2, ALT2, Cc2-5...',true).
concept_name0('39903: rn:R00359','Ddo',true).
concept_name0('39903: rn:R00359','rno:685325',false).
concept_name0('39902: rn:R00355','rno:24401 rno:25721',false).
concept_name0('39902: rn:R00355','Got1, Aspat, Gaspat...',true).
concept_name0('39901: rn:R00357','100360621...',true).
concept_name0('39901: rn:R00357','rno:100360621 rno:298483',false).
concept_name0('39900: rn:R00578','Asns, MGC93148',true).
concept_name0('39900: rn:R00578','rno:25612',false).
concept_name0('39904: rn:R01878','Cda',true).
concept_name0('39904: rn:R01878','rno:362638',false).
concept_name0('39905: rn:R00513 rn:R00516 rn:R00517 rn:R00962 rn:R01548 rn:R02091 rn:R02096 rn:R02371 rn:R02372','Uck2, Umpk...',true).
concept_name0('39905: rn:R00513 rn:R00516 rn:R00517 rn:R00962 rn:R01548 rn:R02091 rn:R02096 rn:R02371 rn:R02372','rno:304944 rno:311864 rno:499956',false).
concept_name0('39906: rn:R00511','100363253...',true).
concept_name0('39906: rn:R00511','rno:100363253 rno:287368 rno:298881 rno:312373 rno:313574 rno:58813 rno:688261',false).
concept_name0('39907: rn:R00514','Entpd3, NTPDase3...',true).
concept_name0('39907: rn:R00514','rno:316077 rno:613267 rno:64519',false).
concept_name0('39908: rn:R00512','Cmpk1, Cmpk, MGC112719, RGD1310116...',true).
concept_name0('39908: rn:R00512','rno:298410 rno:314004',false).
concept_name0('39909: rn:R00569','Entpd3, NTPDase3...',true).
concept_name0('39909: rn:R00569','rno:316077 rno:613267 rno:64519',false).
concept_name0('39910: rn:R00570','rno:171566 rno:191575 rno:58964 rno:685679 rno:83782 rno:85269',false).
concept_name0('39910: rn:R00570','Nme7, Nm23-r7...',true).
concept_name0('39911: rn:R00442','100363176...',true).
concept_name0('39911: rn:R00442','rno:100363176 rno:117017 rno:288588 rno:289561 rno:291795 rno:292778 rno:300088 rno:301246 rno:306012 rno:310685 rno:311487 rno:313245 rno:361102 rno:361365 rno:361640 rno:361784 rno:362858 rno:363633 rno:364834 rno:366277 rno:498109 rno:502374 rno:681193 rno:685465 rno:690254 rno:690966 rno:83503 rno:83581 rno:83582',false).
concept_name0('39912: rn:R00440','Pnpt1',true).
concept_name0('39912: rn:R00440','rno:360992',false).
concept_name0('39913: rn:R02269','rno:65135',false).
concept_name0('39913: rn:R02269','Dpys',true).
concept_name0('39914: rn:R00905','rno:116593',false).
concept_name0('39914: rn:R00905','Upb1, Bup1',true).
concept_name0('39915: rn:R00978','rno:81656',false).
concept_name0('39915: rn:R00978','Dpyd',true).
concept_name0('39916: rn:R00963','100363253...',true).
concept_name0('39916: rn:R00963','rno:100363253 rno:287368 rno:298881 rno:312373 rno:313574 rno:58813 rno:688261',false).
concept_name0('39917: rn:R01876','Upp1, MGC124655...',true).
concept_name0('39917: rn:R01876','rno:289801 rno:295620',false).
concept_name0('39918: rn:R00964 rn:R00967 rn:R00968 rn:R00970 rn:R01549 rn:R01880 rn:R02097 rn:R02327 rn:R02332','Uck2, Umpk...',true).
concept_name0('39918: rn:R00964 rn:R00967 rn:R00968 rn:R00970 rn:R01549 rn:R01880 rn:R02097 rn:R02327 rn:R02332','rno:304944 rno:311864 rno:499956',false).
concept_name0('39919: rn:R00966','rno:317237',false).
concept_name0('39919: rn:R00966','Uprt, RGD1564806',true).
concept_name0('39921: rn:R00155','rno:246272 rno:314312 rno:361063 rno:85260',false).
concept_name0('39921: rn:R00155','Cant1, srapy...',true).
concept_name0('39920: rn:R00155','Entpd3, NTPDase3...',true).
concept_name0('39920: rn:R00155','rno:316077 rno:613267 rno:64519',false).
concept_name0('39923: rn:R00571 rn:R00573','rno:313560 rno:619580',false).
concept_name0('39923: rn:R00571 rn:R00573','Ctps...',true).
concept_name0('39922: rn:R00159','Entpd3, NTPDase3...',true).
concept_name0('39922: rn:R00159','rno:316077 rno:613267 rno:64519',false).
concept_name0('39925: rn:R00157','rno:26956',false).
concept_name0('39925: rn:R00157','Ak3',true).
concept_name0('39924: rn:R00158','Cmpk1, Cmpk, MGC112719, RGD1310116...',true).
concept_name0('39924: rn:R00158','rno:298410 rno:314004',false).
concept_name0('39927: rn:R00443','100363176...',true).
concept_name0('39927: rn:R00443','rno:100363176 rno:117017 rno:288588 rno:289561 rno:291795 rno:292778 rno:300088 rno:301246 rno:306012 rno:310685 rno:311487 rno:313245 rno:361102 rno:361365 rno:361640 rno:361784 rno:362858 rno:363633 rno:364834 rno:366277 rno:498109 rno:502374 rno:681193 rno:685465 rno:690254 rno:690966 rno:83503 rno:83581 rno:83582',false).
concept_name0('39926: rn:R00156','rno:171566 rno:191575 rno:58964 rno:685679 rno:83782 rno:85269',false).
concept_name0('39926: rn:R00156','Nme7, Nm23-r7...',true).
concept_name0('39929: rn:R01870','rno:288051',false).
concept_name0('39929: rn:R01870','Umps',true).
concept_name0('39928: rn:R00438','Pnpt1',true).
concept_name0('39928: rn:R00438','rno:360992',false).
concept_name0('39931: rn:R01397','Cad',true).
concept_name0('39931: rn:R01397','rno:24240',false).
concept_name0('39930: rn:R01993','Cad',true).
concept_name0('39930: rn:R01993','rno:24240',false).
concept_name0('39933: rn:R08264','Cyp3a9, Cyp3a13, MGC93139, P450olf3...',true).
concept_name0('39933: rn:R08264','rno:171352 rno:252931 rno:25642 rno:266682',false).
concept_name0('39932: rn:R08307','rno:25375 rno:266603 rno:309147',false).
concept_name0('39932: rn:R08307','Aldh3a1, AHDC, Ahd-c, Aldh, Aldh3...',true).
concept_name0('39935: rn:R08310','rno:100145871 rno:171178 rno:24172 rno:29646 rno:310903',false).
concept_name0('39935: rn:R08310','Adh5...',true).
concept_name0('39934: rn:R08306','rno:100145871 rno:171178 rno:24172 rno:29646 rno:310903',false).
concept_name0('39934: rn:R08306','Adh5...',true).
concept_name0('39695: rn:R03038','Aars...',true).
concept_name0('39695: rn:R03038','rno:292023 rno:301254',false).
concept_name0('39694: rn:R03662','rno:266975 rno:292759',false).
concept_name0('39694: rn:R03662','Sars, MGC72629, Sars1...',true).
concept_name0('39693: rn:R03659','rno:299851 rno:316403',false).
concept_name0('39693: rn:R03659','Mars...',true).
concept_name0('39692: rn:R03654','rno:297113',false).
concept_name0('39692: rn:R03654','Gars, GlyRS',true).
concept_name0('39691: rn:R05577','rno:116483 rno:304919',false).
concept_name0('39691: rn:R05577','Dars, DRS1...',true).
concept_name0('39690: rn:R03652','rno:290868',false).
concept_name0('39690: rn:R03652','Qars, MGC94241',true).
concept_name0('39689: rn:R03650','Cars...',true).
concept_name0('39689: rn:R03650','rno:293638 rno:361184',false).
concept_name0('39688: rn:R03660','Farsa, Farsla...',true).
concept_name0('39688: rn:R03660','rno:288917 rno:301544 rno:306879',false).
concept_name0('39687: rn:R03646','rno:287191 rno:297969',false).
concept_name0('39687: rn:R03646','Rars...',true).
concept_name0('39686: rn:R03648','Nars, LRRGT00113, MGC116236...',true).
concept_name0('39686: rn:R03648','rno:291556 rno:293128',false).
concept_name0('39685: rn:R03655','Hars2l, MGC109366, RGD1308426, Zmat2...',true).
concept_name0('39685: rn:R03655','rno:307491 rno:307492',false).
concept_name0('39684: rn:R03656','rno:306804',false).
concept_name0('39684: rn:R03656','Iars, Iarsl',true).
concept_name0('39683: rn:R02661','RGD1564209',true).
concept_name0('39683: rn:R02661','rno:367046',false).
concept_name0('39682: rn:R01214','Bcat1, Bcatc, MGC105472...',true).
concept_name0('39682: rn:R01214','rno:29592 rno:64203',false).
concept_name0('39681: rn:R03665','rno:25009 rno:309596',false).
concept_name0('39681: rn:R03665','Vars, Bat6, G7a, TrsVal, Vars2...',true).
concept_name0('39680: rn:R00529','Papss2, MGC189455...',true).
concept_name0('39680: rn:R00529','rno:294103 rno:295443',false).
concept_name0('39710: rn:R01939','Aadat, Kat2',true).
concept_name0('39710: rn:R01939','rno:29416',false).
concept_name0('39711: rn:R04390','Aldh7a1, antiquitin',true).
concept_name0('39711: rn:R04390','rno:291450',false).
concept_name0('39708: rn:R08224','679383',true).
concept_name0('39708: rn:R08224','rno:679383',false).
concept_name0('39709: rn:R08218','rno:266975 rno:292759',false).
concept_name0('39709: rn:R08218','Sars, MGC72629, Sars1...',true).
concept_name0('39706: rn:R00014','rno:117098 rno:289950 rno:29554',false).
concept_name0('39706: rn:R00014','Pdha2, Pdhal...',true).
concept_name0('39707: rn:R04863','Aldh7a1, antiquitin',true).
concept_name0('39707: rn:R04863','rno:291450',false).
concept_name0('39704: rn:R03661','rno:289352 rno:313429',false).
concept_name0('39704: rn:R03661','Eprs...',true).
concept_name0('39705: rn:R05578','rno:289352 rno:361641',false).
concept_name0('39705: rn:R05578','Eprs...',true).
concept_name0('39702: rn:R03940','Mtfmt, MGC95129, RGD1309462',true).
concept_name0('39702: rn:R03940','rno:315763',false).
concept_name0('39703: rn:R02918','Yars2, CGI-04, RGD1311696...',true).
concept_name0('39703: rn:R02918','rno:287924 rno:313047',false).
concept_name0('39700: rn:R03656','rno:306804',false).
concept_name0('39700: rn:R03656','Iars, Iarsl',true).
concept_name0('39701: rn:R03664','Wars...',true).
concept_name0('39701: rn:R03664','rno:314442 rno:690654',false).
concept_name0('39698: rn:R03658','rno:292028',false).
concept_name0('39698: rn:R03658','Kars, MGC94484',true).
concept_name0('39699: rn:R03663','rno:294810 rno:308701 rno:310672',false).
concept_name0('39699: rn:R03663','Tars, MGC95288...',true).
concept_name0('39696: rn:R03665','rno:25009 rno:309596',false).
concept_name0('39696: rn:R03665','Vars, Bat6, G7a, TrsVal, Vars2...',true).
concept_name0('39697: rn:R03657','Lars, MGC105585...',true).
concept_name0('39697: rn:R03657','rno:291624 rno:363172',false).
concept_name0('39725: rn:R07603','Bckdha, BCKDA, E1a...',true).
concept_name0('39725: rn:R07603','rno:25244 rno:29711',false).
concept_name0('39724: rn:R04095','rno:24513',false).
concept_name0('39724: rn:R04095','Ivd',true).
concept_name0('39727: rn:R04137','Echs1...',true).
concept_name0('39727: rn:R04137','rno:140547 rno:170670 rno:171142',false).
concept_name0('39726: rn:R04138','Mccc1, MGC95141...',true).
concept_name0('39726: rn:R04138','rno:294972 rno:361884',false).
concept_name0('39721: rn:R02003','rno:291211 rno:83791',false).
concept_name0('39721: rn:R02003','Ggps1, Crlf3, rGGPS1a, rGGPS1a1, rGGPS1a2, rGGPS1a3...',true).
concept_name0('39720: rn:R03245','rno:310645',false).
concept_name0('39720: rn:R03245','Pmvk, MGC105660',true).
concept_name0('39723: rn:R05556','rno:298541',false).
concept_name0('39723: rn:R05556','Dhdds',true).
concept_name0('39722: rn:R09249','rno:100364990 rno:365592',false).
concept_name0('39722: rn:R09249','100364990...',true).
concept_name0('39717: rn:R07618','rno:298942',false).
concept_name0('39717: rn:R07618','Dld',true).
concept_name0('39716: rn:R07604','Bckdha, BCKDA, E1a...',true).
concept_name0('39716: rn:R07604','rno:25244 rno:29711',false).
concept_name0('39719: rn:R01121','rno:81726',false).
concept_name0('39719: rn:R01121','Mvd, Mvpd',true).
concept_name0('39718: rn:R01658','rno:291211 rno:83791',false).
concept_name0('39718: rn:R01658','Ggps1, Crlf3, rGGPS1a, rGGPS1a1, rGGPS1a2, rGGPS1a3...',true).
concept_name0('39713: rn:R00716','rno:296925',false).
concept_name0('39713: rn:R00716','Aass',true).
concept_name0('39712: rn:R03098','Aldh7a1, antiquitin',true).
concept_name0('39712: rn:R03098','rno:291450',false).
concept_name0('39715: rn:R02061','rno:291211',false).
concept_name0('39715: rn:R02061','Ggps1, Crlf3, rGGPS1a, rGGPS1a1, rGGPS1a2, rGGPS1a3',true).
concept_name0('39714: rn:R02869','683008',true).
concept_name0('39714: rn:R02869','rno:683008',false).
concept_name0('39740: rn:R00243 rn:R00248','Glud1, Ac2-281, Glud, MGC93608, MRG-2',true).
concept_name0('39740: rn:R00243 rn:R00248','rno:24399',false).
concept_name0('39741: rn:R00256','Gls2, Ga...',true).
concept_name0('39741: rn:R00256','rno:192268 rno:24398',false).
concept_name0('39742: rn:R07600','Bckdha, BCKDA, E1a...',true).
concept_name0('39742: rn:R07600','rno:25244 rno:29711',false).
concept_name0('39743: rn:R07618','rno:298942',false).
concept_name0('39743: rn:R07618','Dld',true).
concept_name0('39736: rn:R00410','100359544...',true).
concept_name0('39736: rn:R00410','rno:100359544 rno:100361036 rno:100365119 rno:366463 rno:690163',false).
concept_name0('39737: rn:R00578','Asns, MGC93148',true).
concept_name0('39737: rn:R00578','rno:25612',false).
concept_name0('39738: rn:R07602','Bckdha, BCKDA, E1a...',true).
concept_name0('39738: rn:R07602','rno:25244 rno:29711',false).
concept_name0('39739: rn:R07618','rno:298942',false).
concept_name0('39739: rn:R07618','Dld',true).
concept_name0('39732: rn:R00149','Cps1',true).
concept_name0('39732: rn:R00149','rno:497840',false).
concept_name0('39733: rn:R01360','rno:79238',false).
concept_name0('39733: rn:R01360','Hmgcl',true).
concept_name0('39734: rn:R02085','Auh',true).
concept_name0('39734: rn:R02085','rno:361215',false).
concept_name0('39735: rn:R01978','Hmgcs2, Hmgcs1, Mt3h3mg...',true).
concept_name0('39735: rn:R01978','rno:24450 rno:29637',false).
concept_name0('39728: rn:R00927','Acaa2...',true).
concept_name0('39728: rn:R00927','rno:170465 rno:171155 rno:24157 rno:501072',false).
concept_name0('39729: rn:R05066','Hadh, Hadhsc...',true).
concept_name0('39729: rn:R05066','rno:113965 rno:171142',false).
concept_name0('39730: rn:R01214','Bcat1, Bcatc, MGC105472...',true).
concept_name0('39730: rn:R01214','rno:29592 rno:64203',false).
concept_name0('39731: rn:R00238','rno:25014 rno:308100',false).
concept_name0('39731: rn:R00238','Acat1, RATACAL...',true).
concept_name0('39755: rn:R04203','Hadh, Hadhsc...',true).
concept_name0('39755: rn:R04203','rno:113965 rno:171142 rno:63864',false).
concept_name0('39754: rn:R03172','Acadsb',true).
concept_name0('39754: rn:R03172','rno:25618',false).
concept_name0('39753: rn:R02661','rno:24158',false).
concept_name0('39753: rn:R02661','Acadm, MCAD',true).
concept_name0('39752: rn:R04224','Echs1...',true).
concept_name0('39752: rn:R04224','rno:140547 rno:170670 rno:171142',false).
concept_name0('39759: rn:R03871','Aox3l1, Aox2...',true).
concept_name0('39759: rn:R03871','rno:316421 rno:54349',false).
concept_name0('39758: rn:R05066','Hibadh',true).
concept_name0('39758: rn:R05066','rno:63938',false).
concept_name0('39757: rn:R05064','Hibch',true).
concept_name0('39757: rn:R05064','rno:301384',false).
concept_name0('39756: rn:R04188','Abat, Gabat, MGC93392, beta-AlaAT',true).
concept_name0('39756: rn:R04188','rno:81632',false).
concept_name0('39747: rn:R02662','rno:29611',false).
concept_name0('39747: rn:R02662','Dbt',true).
concept_name0('39746: rn:R03172','rno:24158',false).
concept_name0('39746: rn:R03172','Acadm, MCAD',true).
concept_name0('39745: rn:R04095','rno:24158',false).
concept_name0('39745: rn:R04095','Acadm, MCAD',true).
concept_name0('39744: rn:R01168','Hal, histidase',true).
concept_name0('39744: rn:R01168','rno:29301',false).
concept_name0('39751: rn:R04203','rno:63864',false).
concept_name0('39751: rn:R04203','Hsd17b10, Hadh2',true).
concept_name0('39750: rn:R01090','Bcat1, Bcatc, MGC105472...',true).
concept_name0('39750: rn:R01090','rno:29592 rno:64203',false).
concept_name0('39749: rn:R04097','rno:29611',false).
concept_name0('39749: rn:R04097','Dbt',true).
concept_name0('39748: rn:R07601','Bckdha, BCKDA, E1a...',true).
concept_name0('39748: rn:R07601','rno:25244 rno:29711',false).
concept_name0('39770: rn:R03174','rno:29611',false).
concept_name0('39770: rn:R03174','Dbt',true).
concept_name0('39771: rn:R00132','rno:288360 rno:291819 rno:29242 rno:297814 rno:298657 rno:302669 rno:310218 rno:313495 rno:363085 rno:499566 rno:54231 rno:54232 rno:54233 rno:791259',false).
concept_name0('39771: rn:R00132','Car15...',true).
concept_name0('39768: rn:R04204','Echs1...',true).
concept_name0('39768: rn:R04204','rno:140547 rno:170670 rno:171142',false).
concept_name0('39769: rn:R07599','Bckdha, BCKDA, E1a...',true).
concept_name0('39769: rn:R07599','rno:25244 rno:29711',false).
concept_name0('39774: rn:R01001','rno:24962',false).
concept_name0('39774: rn:R01001','Cth, H',true).
concept_name0('39775: rn:R01242','rno:83783',false).
concept_name0('39775: rn:R01242','Sult1a1, ASTIV, Mx-ST, PST-1, St1a1, Stm, Stp1, Sult1a3',true).
concept_name0('39772: rn:R01221','Amt',true).
concept_name0('39772: rn:R01221','rno:306586',false).
concept_name0('39773: rn:R00253','Glul, Glns',true).
concept_name0('39773: rn:R00253','rno:24957',false).
concept_name0('39762: rn:R03869','rno:24188 rno:291450 rno:29539 rno:29651 rno:298079 rno:64040 rno:65183',false).
concept_name0('39762: rn:R03869','Aldh1a1, Ahd2, Aldh1, Aldh2...',true).
concept_name0('39763: rn:R02197','100360621...',true).
concept_name0('39763: rn:R02197','rno:100360621 rno:298483',false).
concept_name0('39760: rn:R01859','Pccb, MGC93516...',true).
concept_name0('39760: rn:R01859','rno:24624 rno:687008',false).
concept_name0('39761: rn:R00935','rno:81708',false).
concept_name0('39761: rn:R00935','Aldh6a1, Mmsdh',true).
concept_name0('39766: rn:R00833','rno:100361295 rno:688517',false).
concept_name0('39766: rn:R00833','100361295...',true).
concept_name0('39767: rn:R02661','Acadsb',true).
concept_name0('39767: rn:R02661','rno:25618',false).
concept_name0('39764: rn:R02199','Bcat1, Bcatc, MGC105472...',true).
concept_name0('39764: rn:R02199','rno:29592 rno:64203',false).
concept_name0('39765: rn:R02765','Mcee',true).
concept_name0('39765: rn:R02765','rno:293829',false).
concept_name0('39785: rn:R00588','Agxt, Spat',true).
concept_name0('39785: rn:R00588','rno:24792',false).
concept_name0('39784: rn:R07268','687861',true).
concept_name0('39784: rn:R07268','rno:687861',false).
concept_name0('4840: rn:R01608','R01608...',true).
concept_name0('4840: rn:R01608','rn:R01608 rp:RP01630 rc:RC00087',false).
concept_name0('39787: rn:R00372','Agxt, Spat...',true).
concept_name0('39787: rn:R00372','rno:24792 rno:83784',false).
concept_name0('39786: rn:R00891','rno:24250',false).
concept_name0('39786: rn:R00891','Cbs',true).
concept_name0('39789: rn:R07396','rno:24813',false).
concept_name0('39789: rn:R07396','Tat',true).
concept_name0('39788: rn:R07412','rno:309391',false).
concept_name0('39788: rn:R07412','Cox15, MGC124864',true).
concept_name0('39791: rn:R07363','rno:298934',false).
concept_name0('39791: rn:R07363','Adi1, Alp1, MGC108527',true).
concept_name0('4845: rn:R01611','R01611...',true).
concept_name0('4845: rn:R01611','rn:R01611 rp:RP01634 rc:RC00565',false).
concept_name0('39790: rn:R07364','rno:298934',false).
concept_name0('39790: rn:R07364','Adi1, Alp1, MGC108527',true).
concept_name0('39777: rn:R02180','Chst12, MGC112823...',true).
concept_name0('39777: rn:R02180','rno:304322 rno:314694 rno:500257',false).
concept_name0('39776: rn:R00509','Papss2, MGC189455...',true).
concept_name0('39776: rn:R00509','rno:294103 rno:295443',false).
concept_name0('39779: rn:R02350','rno:25355',false).
concept_name0('39779: rn:R02350','Sult1e1, ESTSUL, ST1E1, Ste',true).
concept_name0('39778: rn:R00629','Sult2b1, ST2B1...',true).
concept_name0('39778: rn:R00629','rno:292915 rno:361510',false).
concept_name0('39781: rn:R02661','rno:64304',false).
concept_name0('39781: rn:R02661','Acads, Scad',true).
concept_name0('39780: rn:R03172','rno:64304',false).
concept_name0('39780: rn:R03172','Acads, Scad',true).
concept_name0('39783: rn:R05220','687861',true).
concept_name0('39783: rn:R05220','rno:687861',false).
concept_name0('39782: rn:R00508','rno:64473',false).
concept_name0('39782: rn:R00508','Bpnt1, MGC93112, Sal3',true).
concept_name0('39800: rn:R03683','rno:24451 rno:79239',false).
concept_name0('39800: rn:R03683','Hmox1, HEOXG, Heox, Hmox, Ho-1, Ho1, hsp32...',true).
concept_name0('39801: rn:R00177','rno:171347 rno:25331 rno:683630',false).
concept_name0('39801: rn:R00177','Mat2a, Sams2...',true).
concept_name0('4857: rn:R01914','rn:R01914 rp:RP00148 rp:RP00643 rc:RC00053 rc:RC00225',false).
concept_name0('4857: rn:R01914','R01914...',true).
concept_name0('39802: rn:R02821','rno:81508',false).
concept_name0('39802: rn:R02821','Bhmt',true).
concept_name0('39803: rn:R04858','Trdmt1, Dnmt2, MGC112666...',true).
concept_name0('39803: rn:R04858','rno:291324 rno:309680 rno:444984 rno:444985 rno:84350',false).
concept_name0('39804: rn:R00192','rno:29443 rno:312192 rno:362013',false).
concept_name0('39804: rn:R00192','Ahcy...',true).
concept_name0('39805: rn:R00648','100360621...',true).
concept_name0('39805: rn:R00648','rno:100360621 rno:298483',false).
concept_name0('39806: rn:R07395','Enoph1, MGC105720, RGD1309016',true).
concept_name0('39806: rn:R07395','rno:305177',false).
concept_name0('39807: rn:R00590','rno:25044',false).
concept_name0('39807: rn:R00590','Sds, MGC108581, RATSDHE1, SDH2, Sdh, Sdhe1, TDH',true).
concept_name0('39792: rn:R07392','Apip, RGD1564562',true).
concept_name0('39792: rn:R07392','rno:295961',false).
concept_name0('39793: rn:R04420','rno:288912',false).
concept_name0('39793: rn:R04420','Mri1, MGC105780, RGD1307789',true).
concept_name0('4849: rn:R02473','rn:R02473 rp:RP00373 rc:RC00096',false).
concept_name0('4849: rn:R02473','R02473...',true).
concept_name0('39794: rn:R01402','Mtap, Cc1-6',true).
concept_name0('39794: rn:R01402','rno:298227',false).
concept_name0('39795: rn:R01920','rno:84596',false).
concept_name0('39795: rn:R01920','Srm',true).
concept_name0('39796: rn:R00178','rno:81640',false).
concept_name0('39796: rn:R00178','Amd1, Amd1a, Amd1b',true).
concept_name0('39797: rn:R01001','rno:24962',false).
concept_name0('39797: rn:R01001','Cth, H',true).
concept_name0('39798: rn:R00946','Mtr, methioninesynthase',true).
concept_name0('39798: rn:R00946','rno:81522',false).
concept_name0('39799: rn:R01290','rno:24250',false).
concept_name0('39799: rn:R01290','Cbs',true).
concept_name0('40191: rn:R02893','rno:192242',false).
concept_name0('40191: rn:R02893','Akr1d1',true).
concept_name0('40190: rn:R02836 rn:R02834','Hsd11b1, LRRGT00065...',true).
concept_name0('40190: rn:R02836 rn:R02834','rno:25116 rno:25117',false).
concept_name0('40189: rn:R01836','rno:286964 rno:361802 rno:79243',false).
concept_name0('40189: rn:R01836','Hsd17b6, Hsd17b9, MGC108559...',true).
concept_name0('40188: rn:R04852','rno:25146',false).
concept_name0('40188: rn:R04852','Cyp17a1, Cyp17',true).
concept_name0('40187: rn:R02019','100359539...',true).
concept_name0('40187: rn:R02019','rno:100359539 rno:299976 rno:362720 rno:685579',false).
concept_name0('40186: rn:R02107','rno:497811',false).
concept_name0('40186: rn:R02107','Xdh, XOR',true).
concept_name0('40185: rn:R01049','Prps2...',true).
concept_name0('40185: rn:R01049','rno:24689 rno:29562 rno:298954 rno:314140',false).
concept_name0('40184: rn:R01072','rno:117544',false).
concept_name0('40184: rn:R01072','Ppat, Atase, MGC93251',true).
concept_name0('40183: rn:R04144','rno:288259',false).
concept_name0('40183: rn:R04144','Gart',true).
concept_name0('40182: rn:R04325','rno:288259',false).
concept_name0('40182: rn:R04325','Gart',true).
concept_name0('40181: rn:R04208','rno:288259',false).
concept_name0('40181: rn:R04208','Gart',true).
concept_name0('40180: rn:R00507','rno:54410 rno:85496',false).
concept_name0('40180: rn:R00507','Enpp3, RB13-6...',true).
concept_name0('40179: rn:R01234','rno:114248 rno:140928 rno:140929 rno:171115 rno:191569 rno:24626 rno:24627 rno:25638 rno:289878 rno:290646 rno:29516 rno:29691 rno:307401 rno:308776 rno:309962 rno:361752 rno:363272 rno:50678 rno:63885 rno:688297 rno:81529 rno:81742 rno:81743 rno:81744',false).
concept_name0('40179: rn:R01234','Pde6h, Pde6g...',true).
concept_name0('40178: rn:R00509','Papss2, MGC189455...',true).
concept_name0('40178: rn:R00509','rno:294103 rno:295443',false).
concept_name0('40177: rn:R00529','Papss2, MGC189455...',true).
concept_name0('40177: rn:R00529','rno:294103 rno:295443',false).
concept_name0('40176: rn:R07116','rno:114846 rno:171341 rno:24421 rno:24422 rno:24423 rno:24424 rno:24426 rno:25260 rno:289197 rno:29487 rno:295037 rno:297029 rno:300850 rno:309465 rno:363205 rno:494499 rno:494500 rno:499688 rno:499689 rno:501110 rno:57298 rno:64352 rno:681913 rno:81869',false).
concept_name0('40176: rn:R07116','Gsto1, MGC94845...',true).
concept_name0('40174: rn:R02720','Itpa',true).
concept_name0('40174: rn:R02720','rno:311422',false).
concept_name0('40175: rn:R00720','Itpa',true).
concept_name0('40175: rn:R00720','rno:311422',false).
concept_name0('40172: rn:R02103','rno:497811',false).
concept_name0('40172: rn:R02103','Xdh, XOR',true).
concept_name0('40173: rn:R00426','Itpa',true).
concept_name0('40173: rn:R00426','rno:311422',false).
concept_name0('40170: rn:R04463','rno:287420',false).
concept_name0('40170: rn:R04463','Pfas',true).
concept_name0('40171: rn:R01768','rno:497811',false).
concept_name0('40171: rn:R01768','Xdh, XOR',true).
concept_name0('40168: rn:R07070','rno:114846 rno:171341 rno:24421 rno:24422 rno:24423 rno:24424 rno:24426 rno:25260 rno:289197 rno:29487 rno:295037 rno:297029 rno:300850 rno:309465 rno:363205 rno:494499 rno:494500 rno:499688 rno:499689 rno:501110 rno:57298 rno:64352 rno:681913 rno:81869',false).
concept_name0('40168: rn:R07070','Gsto1, MGC94845...',true).
concept_name0('40169: rn:R00439','Pnpt1',true).
concept_name0('40169: rn:R00439','rno:360992',false).
concept_name0('40166: rn:R07092','rno:114846 rno:171341 rno:24421 rno:24422 rno:24423 rno:24424 rno:24426 rno:25260 rno:289197 rno:29487 rno:295037 rno:297029 rno:300850 rno:309465 rno:363205 rno:494499 rno:494500 rno:499688 rno:499689 rno:501110 rno:57298 rno:64352 rno:681913 rno:81869',false).
concept_name0('40166: rn:R07092','Gsto1, MGC94845...',true).
concept_name0('40167: rn:R00335','Entpd3, NTPDase3...',true).
concept_name0('40167: rn:R00335','rno:316077 rno:613267 rno:64519',false).
concept_name0('40164: rn:R07105','rno:100145871 rno:171178 rno:24172 rno:29646 rno:310903',false).
concept_name0('40164: rn:R07105','Adh5...',true).
concept_name0('40165: rn:R00330','rno:171566 rno:191575 rno:58964 rno:685679 rno:83782 rno:85269',false).
concept_name0('40165: rn:R00330','Nme7, Nm23-r7...',true).
concept_name0('40162: rn:R07100','rno:114846 rno:171341 rno:24421 rno:24422 rno:24423 rno:24424 rno:24426 rno:25260 rno:289197 rno:29487 rno:295037 rno:297029 rno:300850 rno:309465 rno:363205 rno:494499 rno:494500 rno:499688 rno:499689 rno:501110 rno:57298 rno:64352 rno:681913 rno:81869',false).
concept_name0('40162: rn:R07100','Gsto1, MGC94845...',true).
concept_name0('40163: rn:R02090','rno:303179',false).
concept_name0('40163: rn:R02090','Guk1',true).
concept_name0('40160: rn:R07106','rno:113992 rno:154516 rno:24861 rno:24862 rno:266685 rno:286954 rno:289533 rno:29623 rno:301595 rno:305264 rno:396527 rno:396551 rno:396552 rno:574523 rno:63867 rno:83808',false).
concept_name0('40160: rn:R07106','Ugt1a6, MGC124929, UDPGT_1-6, Udpgt, Ugt1, Ugt1a7...',true).
concept_name0('40161: rn:R06601','rno:293613',false).
concept_name0('40161: rn:R06601','RGD1309350',true).
concept_name0('40157: rn:R07113','rno:114846 rno:171341 rno:24421 rno:24422 rno:24423 rno:24424 rno:24426 rno:25260 rno:289197 rno:29487 rno:295037 rno:297029 rno:300850 rno:309465 rno:363205 rno:494499 rno:494500 rno:499688 rno:499689 rno:501110 rno:57298 rno:64352 rno:681913 rno:81869',false).
concept_name0('40157: rn:R07113','Gsto1, MGC94845...',true).
concept_name0('40156: rn:R07112','rno:25086',false).
concept_name0('40156: rn:R07112','Cyp2e1, Cyp2e',true).
concept_name0('40159: rn:R07104','rno:25375 rno:266603 rno:309147',false).
concept_name0('40159: rn:R07104','Aldh3a1, AHDC, Ahd-c, Aldh, Aldh3...',true).
concept_name0('40158: rn:R03409','Prune, MGC93997',true).
concept_name0('40158: rn:R03409','rno:310664',false).
concept_name0('40153: rn:R07082','rno:25315',false).
concept_name0('40153: rn:R07082','Ephx1, MEH8',true).
concept_name0('40152: rn:R00376','100362333...',true).
concept_name0('40152: rn:R00376','rno:100362333 rno:246327 rno:289758 rno:293144 rno:298098 rno:299112 rno:301323 rno:304573 rno:361698 rno:362385 rno:59294 rno:85241 rno:85242',false).
concept_name0('40155: rn:R00441','100363176...',true).
concept_name0('40155: rn:R00441','rno:100363176 rno:117017 rno:288588 rno:289561 rno:291795 rno:292778 rno:300088 rno:301246 rno:306012 rno:310685 rno:311487 rno:313245 rno:361102 rno:361365 rno:361640 rno:361784 rno:362858 rno:363633 rno:364834 rno:366277 rno:498109 rno:502374 rno:681193 rno:685465 rno:690254 rno:690966 rno:83503 rno:83581 rno:83582',false).
concept_name0('40154: rn:R00434','rno:113911 rno:116556 rno:116564 rno:24603 rno:25202 rno:25206 rno:25711 rno:497757 rno:66012 rno:79222',false).
concept_name0('40154: rn:R00434','Gucy2d...',true).
concept_name0('5462: rn:R01557','rn:R01557 rp:RP11015 rc:RC01816',false).
concept_name0('5462: rn:R01557','R01557...',true).
concept_name0('40149: rn:R07083','rno:114846 rno:171341 rno:24421 rno:24422 rno:24423 rno:24424 rno:24426 rno:25260 rno:289197 rno:29487 rno:295037 rno:297029 rno:300850 rno:309465 rno:363205 rno:494499 rno:494500 rno:499688 rno:499689 rno:501110 rno:57298 rno:64352 rno:681913 rno:81869',false).
concept_name0('40149: rn:R07083','Gsto1, MGC94845...',true).
concept_name0('40148: rn:R01968','100363253...',true).
concept_name0('40148: rn:R01968','rno:100363253 rno:287368 rno:298881 rno:312373 rno:313574 rno:58813 rno:688261',false).
concept_name0('40151: rn:R07091','rno:114846 rno:171341 rno:24421 rno:24422 rno:24423 rno:24424 rno:24426 rno:25260 rno:289197 rno:29487 rno:295037 rno:297029 rno:300850 rno:309465 rno:363205 rno:494499 rno:494500 rno:499688 rno:499689 rno:501110 rno:57298 rno:64352 rno:681913 rno:81869',false).
concept_name0('40151: rn:R07091','Gsto1, MGC94845...',true).
concept_name0('40150: rn:R01857','rno:171566 rno:191575 rno:58964 rno:685679 rno:83782 rno:85269',false).
concept_name0('40150: rn:R01857','Nme7, Nm23-r7...',true).
concept_name0('40145: rn:R00187','rno:60398',false).
concept_name0('40145: rn:R00187','Fhit',true).
concept_name0('40144: rn:R03531','Itpa',true).
concept_name0('40144: rn:R03531','rno:311422',false).
concept_name0('40147: rn:R07084','rno:114846 rno:171341 rno:24421 rno:24422 rno:24423 rno:24424 rno:24426 rno:25260 rno:289197 rno:29487 rno:295037 rno:297029 rno:300850 rno:309465 rno:363205 rno:494499 rno:494500 rno:499688 rno:499689 rno:501110 rno:57298 rno:64352 rno:681913 rno:81869',false).
concept_name0('40147: rn:R07084','Gsto1, MGC94845...',true).
concept_name0('40146: rn:R02147','rno:290029',false).
concept_name0('40146: rn:R02147','Np, Pnp',true).
concept_name0('5455: rn:R00803','rn:R00803 rp:RP00075 rc:RC00028',false).
concept_name0('5455: rn:R00803','R00803...',true).
concept_name0('40140: rn:R00961','rno:246272 rno:314312 rno:361063 rno:85260',false).
concept_name0('40140: rn:R00961','Cant1, srapy...',true).
concept_name0('40141: rn:R02557','rno:290029',false).
concept_name0('40141: rn:R02557','Np, Pnp',true).
concept_name0('40142: rn:R01547','rno:24183 rno:24184 rno:29223 rno:314416 rno:365985',false).
concept_name0('40142: rn:R01547','Ak1, MGC108678...',true).
concept_name0('40143: rn:R03530','rno:171566 rno:191575 rno:58964 rno:685679 rno:83782 rno:85269',false).
concept_name0('40143: rn:R03530','Nme7, Nm23-r7...',true).
concept_name0('40136: rn:R00430','rno:100364062 rno:24651 rno:25630',false).
concept_name0('40136: rn:R00430','100364062...',true).
concept_name0('40137: rn:R01858','rno:100364062 rno:24651 rno:25630',false).
concept_name0('40137: rn:R01858','100364062...',true).
concept_name0('5449: rn:R00306','rn:R00306 rp:RP00324 rp:RP13490 rc:RC00049 rc:RC00049',false).
concept_name0('5449: rn:R00306','R00306...',true).
concept_name0('40138: rn:R01229','rno:292072',false).
concept_name0('40138: rn:R01229','Aprt',true).
concept_name0('40139: rn:R04378','rno:292072',false).
concept_name0('40139: rn:R04378','Aprt',true).
concept_name0('40132: rn:R07093','rno:114846 rno:171341 rno:24421 rno:24422 rno:24423 rno:24424 rno:24426 rno:25260 rno:289197 rno:29487 rno:295037 rno:297029 rno:300850 rno:309465 rno:363205 rno:494499 rno:494500 rno:499688 rno:499689 rno:501110 rno:57298 rno:64352 rno:681913 rno:81869',false).
concept_name0('40132: rn:R07093','Gsto1, MGC94845...',true).
concept_name0('9750: rn:R00740','rn:R00740 rp:RP01076 rc:RC00184',false).
concept_name0('9750: rn:R00740','R00740...',true).
concept_name0('40133: rn:R00184','Nudt2',true).
concept_name0('40133: rn:R00184','rno:297998',false).
concept_name0('9749: rn:R01196','rn:R01196',false).
concept_name0('9749: rn:R01196','R01196',true).
concept_name0('5445: rn:R02886','R02886...',true).
concept_name0('5445: rn:R02886','rn:R02886 rp:RP02572 rc:RC00799',false).
concept_name0('40134: rn:R01967','Dguok, MGC188845',true).
concept_name0('40134: rn:R01967','rno:297389',false).
concept_name0('5444: rn:R00952','R00952...',true).
concept_name0('5444: rn:R00952','rn:R00952 rp:RP00324 rc:RC00049',false).
concept_name0('40135: rn:R00434','rno:100362008 rno:25289 rno:29241 rno:302950 rno:305509 rno:54223 rno:59320 rno:64508 rno:64532 rno:81636 rno:84420',false).
concept_name0('40135: rn:R00434','100362008...',true).
concept_name0('40128: rn:R01855','Itpa',true).
concept_name0('40128: rn:R01855','rno:311422',false).
concept_name0('40129: rn:R07002','rno:114846 rno:171341 rno:24421 rno:24422 rno:24423 rno:24424 rno:24426 rno:25260 rno:289197 rno:29487 rno:295037 rno:297029 rno:300850 rno:309465 rno:363205 rno:494499 rno:494500 rno:499688 rno:499689 rno:501110 rno:57298 rno:64352 rno:681913 rno:81869',false).
concept_name0('40129: rn:R07002','Gsto1, MGC94845...',true).
concept_name0('40130: rn:R01054','rno:287406 rno:305149 rno:361274',false).
concept_name0('40130: rn:R01054','RGD1309906, ADPRibase-Mn, MDS006, MGC108803...',true).
concept_name0('40131: rn:R01232','Nudt2',true).
concept_name0('40131: rn:R01232','rno:297998',false).
concept_name0('40123: rn:R00122','Entpd3, NTPDase3...',true).
concept_name0('40123: rn:R00122','rno:316077 rno:613267 rno:64519',false).
concept_name0('40122: rn:R01135','rno:289276 rno:684425',false).
concept_name0('40122: rn:R01135','Adss, Adss2...',true).
concept_name0('40121: rn:R01083','Adsl, null',true).
concept_name0('40121: rn:R01083','rno:315150',false).
concept_name0('40120: rn:R00183','100363253...',true).
concept_name0('40120: rn:R00183','rno:100363253 rno:287368 rno:298881 rno:312373 rno:313574 rno:58813 rno:688261',false).
concept_name0('40127: rn:R02805','Nudt2',true).
concept_name0('40127: rn:R02805','rno:297998',false).
concept_name0('40126: rn:R02017','100359539...',true).
concept_name0('40126: rn:R02017','rno:100359539 rno:299976 rno:362720 rno:685579',false).
concept_name0('40125: rn:R01137','rno:171566 rno:191575 rno:58964 rno:685679 rno:83782 rno:85269',false).
concept_name0('40125: rn:R01137','Nme7, Nm23-r7...',true).
concept_name0('40124: rn:R00127','rno:24183 rno:24184 rno:29223 rno:314416 rno:365985',false).
concept_name0('40124: rn:R00127','Ak1, MGC108678...',true).
concept_name0('40115: rn:R02088','100363253...',true).
concept_name0('40115: rn:R02088','rno:100363253 rno:287368 rno:298881 rno:312373 rno:313574 rno:58813 rno:688261',false).
concept_name0('40114: rn:R02748','rno:290029',false).
concept_name0('40114: rn:R02748','Np, Pnp',true).
concept_name0('40113: rn:R02297','rno:290029',false).
concept_name0('40113: rn:R02297','Np, Pnp',true).
concept_name0('40112: rn:R04560','rno:81643',false).
concept_name0('40112: rn:R04560','Atic',true).
concept_name0('5428: rn:R01555','rn:R01555 rp:RP01590 rc:RC00049',false).
concept_name0('5428: rn:R01555','R01555...',true).
concept_name0('40119: rn:R00181','Ampd1, Ampd01, RATAMPD01...',true).
concept_name0('40119: rn:R00181','rno:25028 rno:25095 rno:362015',false).
concept_name0('5429: rn:R02112','rn:R02112',false).
concept_name0('5429: rn:R02112','R02112',true).
concept_name0('40118: rn:R00190','rno:292072',false).
concept_name0('40118: rn:R00190','Aprt',true).
concept_name0('40117: rn:R00185','rno:25368',false).
concept_name0('40117: rn:R00185','Adk, AK',true).
concept_name0('40116: rn:R02556','rno:24165',false).
concept_name0('40116: rn:R02556','Ada, MGC108610',true).
concept_name0('40106: rn:R00089','rno:100362008 rno:25289 rno:29241 rno:302950 rno:305509 rno:54223 rno:59320 rno:64508 rno:64532 rno:81636 rno:84420',false).
concept_name0('40106: rn:R00089','100362008...',true).
concept_name0('40107: rn:R00191','rno:140928 rno:140929 rno:24626 rno:24627 rno:25638 rno:290646 rno:29516 rno:29691 rno:308776 rno:309962 rno:50678 rno:63885 rno:81529 rno:81742 rno:81743 rno:81744',false).
concept_name0('40107: rn:R00191','Pde11a...',true).
concept_name0('40104: rn:R00435','100363176...',true).
concept_name0('40104: rn:R00435','rno:100363176 rno:117017 rno:288588 rno:289561 rno:291795 rno:292778 rno:300088 rno:301246 rno:306012 rno:310685 rno:311487 rno:313245 rno:361102 rno:361365 rno:361640 rno:361784 rno:362858 rno:363633 rno:364834 rno:366277 rno:498109 rno:502374 rno:681193 rno:685465 rno:690254 rno:690966 rno:83503 rno:83581 rno:83582',false).
concept_name0('40105: rn:R07087','100364896...',true).
concept_name0('40105: rn:R07087','rno:100364896 rno:171352 rno:171518 rno:171521 rno:24296 rno:246070 rno:25011 rno:252931 rno:25426 rno:25642 rno:266682 rno:29277 rno:29298 rno:293989 rno:687842 rno:83790',false).
concept_name0('40110: rn:R04591','rno:140946',false).
concept_name0('40110: rn:R04591','Paics, Ade2h1, Airc, MGC93240',true).
concept_name0('40111: rn:R04559','Adsl, null',true).
concept_name0('40111: rn:R04559','rno:315150',false).
concept_name0('40108: rn:R00437','Pnpt1',true).
concept_name0('40108: rn:R00437','rno:360992',false).
concept_name0('40109: rn:R04209','rno:140946',false).
concept_name0('40109: rn:R04209','Paics, Ade2h1, Airc, MGC93240',true).
concept_name0('40098: rn:R07075','Cyp2b1, Cyp2b-1, Cypbe, MGC188065...',true).
concept_name0('40098: rn:R07075','rno:24300 rno:25086 rno:286953 rno:292728 rno:29295 rno:361523',false).
concept_name0('40099: rn:R00086','rno:64467',false).
concept_name0('40099: rn:R00086','Entpd2, Cd39l1, NTPDase2',true).
concept_name0('40096: rn:R02142','Hprt1, Hgprtase, Hprt, MGC112554',true).
concept_name0('40096: rn:R02142','rno:24465',false).
concept_name0('40097: rn:R00124','rno:171566 rno:191575 rno:58964 rno:685679 rno:83782 rno:85269',false).
concept_name0('40097: rn:R00124','Nme7, Nm23-r7...',true).
concept_name0('40102: rn:R00375','100362333...',true).
concept_name0('40102: rn:R00375','rno:100362333 rno:246327 rno:289758 rno:293144 rno:298098 rno:299112 rno:301323 rno:304573 rno:361698 rno:362385 rno:59294 rno:85241 rno:85242',false).
concept_name0('40103: rn:R07107','rno:24300 rno:25086 rno:286953 rno:292728 rno:29295 rno:361523 rno:54246',false).
concept_name0('40103: rn:R07107','Cyp2b1, Cyp2b-1, Cypbe, MGC188065...',true).
concept_name0('40100: rn:R00086','Entpd3, NTPDase3...',true).
concept_name0('40100: rn:R00086','rno:316077 rno:613267 rno:64519',false).
concept_name0('40101: rn:R07085','100364896...',true).
concept_name0('40101: rn:R07085','rno:100364896 rno:171352 rno:171518 rno:171521 rno:24296 rno:246070 rno:25011 rno:252931 rno:25426 rno:25642 rno:266682 rno:29277 rno:29298 rno:293989 rno:687842 rno:83790',false).
concept_name0('40089: rn:R02719','100363253...',true).
concept_name0('40089: rn:R02719','rno:100363253 rno:287368 rno:298881 rno:312373 rno:313574 rno:58813 rno:688261',false).
concept_name0('40088: rn:R02422','Allc',true).
concept_name0('40088: rn:R02422','rno:246758',false).
concept_name0('5400: rn:R00960','rn:R00960 rp:RP00303 rp:RP01198 rc:RC00078 rc:RC00017',false).
concept_name0('5400: rn:R00960','R00960...',true).
concept_name0('40091: rn:R00332','rno:303179',false).
concept_name0('40091: rn:R00332','Guk1',true).
concept_name0('40090: rn:R01229','Hprt1, Hgprtase, Hprt, MGC112554',true).
concept_name0('40090: rn:R01229','rno:24465',false).
concept_name0('40093: rn:R01227','100363253...',true).
concept_name0('40093: rn:R01227','rno:100363253 rno:287368 rno:298881 rno:312373 rno:313574 rno:58813 rno:688261',false).
concept_name0('40092: rn:R07016','rno:24296 rno:24297 rno:24300 rno:25086 rno:286953 rno:292728 rno:29295 rno:308445 rno:361523 rno:54246',false).
concept_name0('40092: rn:R07016','Cyp1a1, AHH, AHRR, CP11, CYP1, Cyp45c, Cypc45c, P-450MC, P1-450, P450-C, P450DX...',true).
concept_name0('40095: rn:R01863','rno:290029',false).
concept_name0('40095: rn:R01863','Np, Pnp',true).
concept_name0('40094: rn:R07020','rno:24296 rno:24297 rno:24300 rno:25086 rno:286953 rno:292728 rno:29295 rno:308445 rno:361523 rno:54246',false).
concept_name0('40094: rn:R07020','Cyp1a1, AHH, AHRR, CP11, CYP1, Cyp45c, Cypc45c, P-450MC, P1-450, P450-C, P450DX...',true).
concept_name0('40081: rn:R01134','Gmpr, Gmpr1',true).
concept_name0('40081: rn:R01134','rno:117533',false).
concept_name0('5395: rn:R02889','rn:R02889',false).
concept_name0('5395: rn:R02889','R02889',true).
concept_name0('40080: rn:R00961','Entpd3, NTPDase3...',true).
concept_name0('40080: rn:R00961','rno:316077 rno:613267 rno:64519',false).
concept_name0('5392: rn:R00806','R00806',true).
concept_name0('5392: rn:R00806','rn:R00806',false).
concept_name0('40083: rn:R01560','rno:24165',false).
concept_name0('40083: rn:R01560','Ada, MGC108610',true).
concept_name0('5393: rn:R03526','rn:R03526',false).
concept_name0('5393: rn:R03526','R03526',true).
concept_name0('40082: rn:R00719','Entpd3, NTPDase3...',true).
concept_name0('40082: rn:R00719','rno:316077 rno:613267 rno:64519',false).
concept_name0('9798: rn:R02134','rn:R02134 rp:RP00640 rc:RC00017',false).
concept_name0('9798: rn:R02134','R02134...',true).
concept_name0('40085: rn:R02106','rno:114768',false).
concept_name0('40085: rn:R02106','Uox, UOX-2, Uri, Uri2',true).
concept_name0('9799: rn:R02135','rn:R02135 rp:RP00640 rc:RC00017',false).
concept_name0('9799: rn:R02135','R02135...',true).
concept_name0('40084: rn:R01126','100363253...',true).
concept_name0('40084: rn:R01126','rno:100363253 rno:287368 rno:298881 rno:312373 rno:313574 rno:58813 rno:688261',false).
concept_name0('40087: rn:R01676','rno:83585',false).
concept_name0('40087: rn:R01676','Gda, Cypin',true).
concept_name0('40086: rn:R01969','rno:290029',false).
concept_name0('40086: rn:R01969','Np, Pnp',true).
concept_name0('40072: rn:R01132','Hprt1, Hgprtase, Hprt, MGC112554',true).
concept_name0('40072: rn:R01132','rno:24465',false).
concept_name0('5386: rn:R02886','R02886...',true).
concept_name0('5386: rn:R02886','rn:R02886 rp:RP02572 rc:RC00799',false).
concept_name0('40073: rn:R00328','rno:246272 rno:314312 rno:361063 rno:85260',false).
concept_name0('40073: rn:R00328','Cant1, srapy...',true).
concept_name0('40074: rn:R01769','rno:497811',false).
concept_name0('40074: rn:R01769','Xdh, XOR',true).
concept_name0('40075: rn:R01561','rno:290029',false).
concept_name0('40075: rn:R01561','Np, Pnp',true).
concept_name0('40076: rn:R01130','Impdh2, MGC72938...',true).
concept_name0('40076: rn:R01130','rno:301005 rno:362329',false).
concept_name0('40077: rn:R00328','Entpd3, NTPDase3...',true).
concept_name0('40077: rn:R00328','rno:316077 rno:613267 rno:64519',false).
concept_name0('40078: rn:R01230 rn:R01231','rno:295088',false).
concept_name0('40078: rn:R01230 rn:R01231','Gmps',true).
concept_name0('40079: rn:R00722','rno:171566 rno:191575 rno:58964 rno:685679 rno:83782 rno:85269',false).
concept_name0('40079: rn:R00722','Nme7, Nm23-r7...',true).
concept_name0('40064: rn:R07981','rno:114768',false).
concept_name0('40064: rn:R07981','Uox, UOX-2, Uri, Uri2',true).
concept_name0('5378: rn:R03921','R03921...',true).
concept_name0('5378: rn:R03921','rn:R03921 rp:RP12726 rp:RP12727 rc:RC00077 rc:RC00028',false).
concept_name0('40065: rn:R08339','Cyp3a9, Cyp3a13, MGC93139, P450olf3...',true).
concept_name0('40065: rn:R08339','rno:171352 rno:252931 rno:25642 rno:266682',false).
concept_name0('40066: rn:R07940','rno:116631 rno:116632 rno:290681',false).
concept_name0('40066: rn:R07940','Nat1...',true).
concept_name0('40067: rn:R07945','rno:24297 rno:24299 rno:24894 rno:24895',false).
concept_name0('40067: rn:R07945','Cyp1a2, CYPD45, P-450d, RATCYPD45...',true).
concept_name0('40068: rn:R03697','rno:171522 rno:24303 rno:25053 rno:266684 rno:286963',false).
concept_name0('40068: rn:R03697','Cyp2d4, Cyp2d18, Cyp2d22, Cyp2d4v1, Cyp2d4v2, Cyp2d6...',true).
concept_name0('40069: rn:R08261','rno:113992 rno:154516 rno:24861 rno:24862 rno:266685 rno:286954 rno:289533 rno:29623 rno:301595 rno:305264 rno:396527 rno:396551 rno:396552 rno:574523 rno:63867 rno:83808',false).
concept_name0('40069: rn:R08261','Ugt1a6, MGC124929, UDPGT_1-6, Udpgt, Ugt1, Ugt1a7...',true).
concept_name0('40070: rn:R08262','rno:113992 rno:154516 rno:24861 rno:24862 rno:266685 rno:286954 rno:289533 rno:29623 rno:301595 rno:305264 rno:396527 rno:396551 rno:396552 rno:574523 rno:63867 rno:83808',false).
concept_name0('40070: rn:R08262','Ugt1a6, MGC124929, UDPGT_1-6, Udpgt, Ugt1, Ugt1a7...',true).
concept_name0('40071: rn:R08281','rno:100145871 rno:171178 rno:24172 rno:29646 rno:310903',false).
concept_name0('40071: rn:R08281','Adh5...',true).
concept_name0('40054: rn:R01127','rno:81643',false).
concept_name0('40054: rn:R01127','Atic',true).
concept_name0('40055: rn:R08341','Cyp3a9, Cyp3a13, MGC93139, P450olf3...',true).
concept_name0('40055: rn:R08341','rno:171352 rno:252931 rno:25642 rno:266682',false).
concept_name0('40052: rn:R07027','rno:25315',false).
concept_name0('40052: rn:R07027','Ephx1, MEH8',true).
concept_name0('40053: rn:R07015','rno:691002',false).
concept_name0('40053: rn:R07015','Dhdh',true).
concept_name0('40050: rn:R07069','rno:114846 rno:171341 rno:24421 rno:24422 rno:24423 rno:24424 rno:24426 rno:25260 rno:289197 rno:29487 rno:295037 rno:297029 rno:300850 rno:309465 rno:363205 rno:494499 rno:494500 rno:499688 rno:499689 rno:501110 rno:57298 rno:64352 rno:681913 rno:81869',false).
concept_name0('40050: rn:R07069','Gsto1, MGC94845...',true).
concept_name0('40051: rn:R07094','rno:114846 rno:171341 rno:24421 rno:24422 rno:24423 rno:24424 rno:24426 rno:25260 rno:289197 rno:29487 rno:295037 rno:297029 rno:300850 rno:309465 rno:363205 rno:494499 rno:494500 rno:499688 rno:499689 rno:501110 rno:57298 rno:64352 rno:681913 rno:81869',false).
concept_name0('40051: rn:R07094','Gsto1, MGC94845...',true).
concept_name0('40048: rn:R00185','Dck',true).
concept_name0('40048: rn:R00185','rno:79127',false).
concept_name0('40049: rn:R08282 rn:R08283','rno:25375 rno:266603 rno:309147',false).
concept_name0('40049: rn:R08282 rn:R08283','Aldh3a1, AHDC, Ahd-c, Aldh, Aldh3...',true).
concept_name0('40062: rn:R07943','Cyp1a2, CYPD45, P-450d, RATCYPD45',true).
concept_name0('40062: rn:R07943','rno:24297',false).
concept_name0('40063: rn:R07978','rno:497811',false).
concept_name0('40063: rn:R07978','Xdh, XOR',true).
concept_name0('40060: rn:R08343','Cyp3a9, Cyp3a13, MGC93139, P450olf3...',true).
concept_name0('40060: rn:R08343','rno:171352 rno:252931 rno:25642 rno:266682',false).
concept_name0('40061: rn:R07942','rno:497811',false).
concept_name0('40061: rn:R07942','Xdh, XOR',true).
concept_name0('40058: rn:R08312','Cyp3a9, Cyp3a13, MGC93139, P450olf3...',true).
concept_name0('40058: rn:R08312','rno:171352 rno:252931 rno:25642 rno:266682',false).
concept_name0('40059: rn:R01057','Pgm1',true).
concept_name0('40059: rn:R01057','rno:24645',false).
concept_name0('40056: rn:R01054','rno:361274',false).
concept_name0('40056: rn:R01054','Nudt5, MGC94209',true).
concept_name0('40057: rn:R06604','rno:684055',false).
concept_name0('40057: rn:R06604','684055',true).
concept_name0('40039: rn:R08267','rno:171522 rno:24303 rno:25053 rno:266684 rno:286963',false).
concept_name0('40039: rn:R08267','Cyp2d4, Cyp2d18, Cyp2d22, Cyp2d4v1, Cyp2d4v2, Cyp2d6...',true).
concept_name0('40038: rn:R08275','Cyp3a9, Cyp3a13, MGC93139, P450olf3...',true).
concept_name0('40038: rn:R08275','rno:171352 rno:252931 rno:25642 rno:266682',false).
concept_name0('40037: rn:R08276','Cyp3a9, Cyp3a13, MGC93139, P450olf3...',true).
concept_name0('40037: rn:R08276','rno:171352 rno:252931 rno:25642 rno:266682',false).
concept_name0('40036: rn:R08275','100364896...',true).
concept_name0('40036: rn:R08275','rno:100364896 rno:171518 rno:171521 rno:246070 rno:25011 rno:29277 rno:29298 rno:293989 rno:687842 rno:83790',false).
concept_name0('40035: rn:R08275','rno:24300 rno:286953 rno:292728 rno:29295 rno:361523',false).
concept_name0('40035: rn:R08275','Cyp2b1, Cyp2b-1, Cypbe, MGC188065...',true).
concept_name0('40034: rn:R08280','rno:114846 rno:171341 rno:24421 rno:24422 rno:24423 rno:24424 rno:24426 rno:25260 rno:289197 rno:29487 rno:295037 rno:297029 rno:300850 rno:309465 rno:363205 rno:494499 rno:494500 rno:499688 rno:499689 rno:501110 rno:57298 rno:64352 rno:681913 rno:81869',false).
concept_name0('40034: rn:R08280','Gsto1, MGC94845...',true).
concept_name0('40033: rn:R08285','rno:24300 rno:286953 rno:292728 rno:29295 rno:361523',false).
concept_name0('40033: rn:R08285','Cyp2b1, Cyp2b-1, Cypbe, MGC188065...',true).
concept_name0('40032: rn:R08272','Cyp3a9, Cyp3a13, MGC93139, P450olf3...',true).
concept_name0('40032: rn:R08272','rno:171352 rno:252931 rno:25642 rno:266682',false).
concept_name0('40047: rn:R00200','rno:100364062 rno:24651 rno:25630',false).
concept_name0('40047: rn:R00200','100364062...',true).
concept_name0('40046: rn:R01138','rno:100364062 rno:24651 rno:25630',false).
concept_name0('40046: rn:R01138','100364062...',true).
concept_name0('40045: rn:R00086','rno:361443',false).
concept_name0('40045: rn:R00086','RGD1306192',true).
concept_name0('40044: rn:R08266','rno:246245 rno:246247 rno:246248 rno:25256 rno:84493',false).
concept_name0('40044: rn:R08266','Fmo2...',true).
concept_name0('40043: rn:R08271','Cyp3a9, Cyp3a13, MGC93139, P450olf3...',true).
concept_name0('40043: rn:R08271','rno:171352 rno:252931 rno:25642 rno:266682',false).
concept_name0('40042: rn:R08274','Cyp3a9, Cyp3a13, MGC93139, P450olf3...',true).
concept_name0('40042: rn:R08274','rno:171352 rno:252931 rno:25642 rno:266682',false).
concept_name0('40041: rn:R08268','Cyp3a9, Cyp3a13, MGC93139, P450olf3...',true).
concept_name0('40041: rn:R08268','rno:171352 rno:252931 rno:25642 rno:266682',false).
concept_name0('40040: rn:R08269','Cyp3a9, Cyp3a13, MGC93139, P450olf3...',true).
concept_name0('40040: rn:R08269','rno:171352 rno:252931 rno:25642 rno:266682',false).
concept_name0('40020: rn:R02016','Txnrd3...',true).
concept_name0('40020: rn:R02016','rno:297437 rno:50551 rno:58819',false).
concept_name0('40021: rn:R08231','rno:288051',false).
concept_name0('40021: rn:R08231','Umps',true).
concept_name0('40022: rn:R02024','100359539...',true).
concept_name0('40022: rn:R02024','rno:100359539 rno:299976 rno:362720 rno:685579',false).
concept_name0('40023: rn:R08228','rno:116593',false).
concept_name0('40023: rn:R08228','Upb1, Bup1',true).
concept_name0('40016: rn:R08229','Upp1, MGC124655...',true).
concept_name0('40016: rn:R08229','rno:289801 rno:295620',false).
concept_name0('40017: rn:R02016','Txnrd3...',true).
concept_name0('40017: rn:R02016','rno:297437 rno:50551 rno:58819',false).
concept_name0('40018: rn:R08233','Tk1, Tk...',true).
concept_name0('40018: rn:R08233','rno:24834 rno:291824',false).
concept_name0('40019: rn:R08232','Uck2, Umpk...',true).
concept_name0('40019: rn:R08232','rno:304944 rno:311864 rno:499956',false).
concept_name0('40028: rn:R08293','Cyp1a2, CYPD45, P-450d, RATCYPD45',true).
concept_name0('40028: rn:R08293','rno:24297',false).
concept_name0('40029: rn:R08293','Cyp3a9, Cyp3a13, MGC93139, P450olf3...',true).
concept_name0('40029: rn:R08293','rno:171352 rno:252931 rno:25642 rno:266682',false).
concept_name0('40030: rn:R08294','Cyp3a9, Cyp3a13, MGC93139, P450olf3...',true).
concept_name0('40030: rn:R08294','rno:171352 rno:252931 rno:25642 rno:266682',false).
concept_name0('40031: rn:R08270','rno:171522 rno:24303 rno:25053 rno:266684 rno:286963',false).
concept_name0('40031: rn:R08270','Cyp2d4, Cyp2d18, Cyp2d22, Cyp2d4v1, Cyp2d4v2, Cyp2d6...',true).
concept_name0('40024: rn:R02016','Txnrd3...',true).
concept_name0('40024: rn:R02016','rno:297437 rno:50551 rno:58819',false).
concept_name0('40025: rn:R08277','Cyp3a9, Cyp3a13, MGC93139, P450olf3...',true).
concept_name0('40025: rn:R08277','rno:171352 rno:252931 rno:25642 rno:266682',false).
concept_name0('40026: rn:R08285','Cyp3a9, Cyp3a13, MGC93139, P450olf3...',true).
concept_name0('40026: rn:R08285','rno:171352 rno:252931 rno:25642 rno:266682',false).
concept_name0('40027: rn:R08294','Cyp1a2, CYPD45, P-450d, RATCYPD45',true).
concept_name0('40027: rn:R08294','rno:24297',false).
concept_name0('40005: rn:R00377','100362333...',true).
concept_name0('40005: rn:R00377','rno:100362333 rno:246327 rno:289758 rno:293144 rno:298098 rno:299112 rno:301323 rno:304573 rno:361698 rno:362385 rno:59294 rno:85241 rno:85242',false).
concept_name0('40004: rn:R08240','Impdh2, MGC72938...',true).
concept_name0('40004: rn:R08240','rno:301005 rno:362329',false).
concept_name0('40007: rn:R01664','100363253...',true).
concept_name0('40007: rn:R01664','rno:100363253 rno:287368 rno:298881 rno:312373 rno:313574 rno:58813 rno:688261',false).
concept_name0('40006: rn:R08259','rno:113992 rno:154516 rno:24861 rno:24862 rno:266685 rno:286954 rno:289533 rno:29623 rno:301595 rno:305264 rno:396527 rno:396551 rno:396552 rno:574523 rno:63867 rno:83808',false).
concept_name0('40006: rn:R08259','Ugt1a6, MGC124929, UDPGT_1-6, Udpgt, Ugt1, Ugt1a7...',true).
concept_name0('40001: rn:R02326','rno:171566 rno:191575 rno:58964 rno:685679 rno:83782 rno:85269',false).
concept_name0('40001: rn:R02326','Nme7, Nm23-r7...',true).
concept_name0('40000: rn:R08222','Tymp, Ecgf1, MGC108801, MGC112734',true).
concept_name0('40000: rn:R08222','rno:315219',false).
concept_name0('9872: rn:R07456','rn:R07456 rp:RP10677 rc:RC01783',false).
concept_name0('9872: rn:R07456','R07456...',true).
concept_name0('40003: rn:R01665','Cmpk1, Cmpk, MGC112719, RGD1310116...',true).
concept_name0('40003: rn:R01665','rno:298410 rno:314004',false).
concept_name0('9873: rn:R07456','rn:R07456 rp:RP10677 rc:RC01783',false).
concept_name0('9873: rn:R07456','R07456...',true).
concept_name0('40002: rn:R08225','Cyp2a3, Cyp2a3a, RATCYP2A3A...',true).
concept_name0('40002: rn:R08225','rno:24299 rno:24894 rno:24895',false).
concept_name0('40013: rn:R08227','rno:65135',false).
concept_name0('40013: rn:R08227','Dpys',true).
concept_name0('40012: rn:R01663','rno:290741',false).
concept_name0('40012: rn:R01663','Dctd',true).
concept_name0('40015: rn:R08230','Tymp, Ecgf1, MGC108801, MGC112734',true).
concept_name0('40015: rn:R08230','rno:315219',false).
concept_name0('40014: rn:R08226','rno:81656',false).
concept_name0('40014: rn:R08226','Dpyd',true).
concept_name0('40009: rn:R01666','Dck',true).
concept_name0('40009: rn:R01666','rno:79127',false).
concept_name0('40008: rn:R08220','rno:113902 rno:291863 rno:29225 rno:307660',false).
concept_name0('40008: rn:R08220','Ces3...',true).
concept_name0('40011: rn:R02100','Dut, Dutp, PIP4',true).
concept_name0('40011: rn:R02100','rno:497778',false).
concept_name0('40010: rn:R08221','Cda',true).
concept_name0('40010: rn:R08221','rno:362638',false).
concept_name0('39986: rn:R08243','Itpa',true).
concept_name0('39986: rn:R08243','rno:311422',false).
concept_name0('39987: rn:R01567','Tk1, Tk...',true).
concept_name0('39987: rn:R01567','rno:24834 rno:291824',false).
concept_name0('9955: rn:R01355','R01355...',true).
concept_name0('9955: rn:R01355','rn:R01355 rp:RP10724 rp:RP10986 rc:RC00286 rc:RC01810',false).
concept_name0('39984: rn:R08250','rno:116631 rno:116632 rno:290681',false).
concept_name0('39984: rn:R08250','Nat1...',true).
concept_name0('39985: rn:R01569','100363253...',true).
concept_name0('39985: rn:R01569','rno:100363253 rno:287368 rno:298881 rno:312373 rno:313574 rno:58813 rno:688261',false).
concept_name0('39990: rn:R02098','Dtymk',true).
concept_name0('39990: rn:R02098','rno:301622',false).
concept_name0('39991: rn:R02099','Tk1, Tk...',true).
concept_name0('39991: rn:R02099','rno:24834 rno:291824',false).
concept_name0('39988: rn:R08235','rno:497811',false).
concept_name0('39988: rn:R08235','Xdh, XOR',true).
concept_name0('39989: rn:R02331','rno:171566 rno:191575 rno:58964 rno:685679 rno:83782 rno:85269',false).
concept_name0('39989: rn:R02331','Nme7, Nm23-r7...',true).
concept_name0('39994: rn:R02484','rno:290029',false).
concept_name0('39994: rn:R02484','Np, Pnp',true).
concept_name0('39995: rn:R08246','rno:690050',false).
concept_name0('39995: rn:R08246','Tpmt',true).
concept_name0('39992: rn:R02485','Cda',true).
concept_name0('39992: rn:R02485','rno:362638',false).
concept_name0('39993: rn:R08239','rno:690050',false).
concept_name0('39993: rn:R08239','Tpmt',true).
concept_name0('39998: rn:R08236','rno:690050',false).
concept_name0('39998: rn:R08236','Tpmt',true).
concept_name0('39999: rn:R02101','Tyms, MGC156654',true).
concept_name0('39999: rn:R02101','rno:29261',false).
concept_name0('39996: rn:R02484','Tymp, Ecgf1, MGC108801, MGC112734',true).
concept_name0('39996: rn:R02484','rno:315219',false).
concept_name0('39997: rn:R02016','Txnrd3...',true).
concept_name0('39997: rn:R02016','rno:297437 rno:50551 rno:58819',false).
concept_name0('39971: rn:R01570','Tymp, Ecgf1, MGC108801, MGC112734',true).
concept_name0('39971: rn:R01570','rno:315219',false).
concept_name0('39970: rn:R01415','rno:81656',false).
concept_name0('39970: rn:R01415','Dpyd',true).
concept_name0('39969: rn:R03055','rno:65135',false).
concept_name0('39969: rn:R03055','Dpys',true).
concept_name0('39968: rn:R00662','Itpa',true).
concept_name0('39968: rn:R00662','rno:311422',false).
concept_name0('39975: rn:R00378','100362333...',true).
concept_name0('39975: rn:R00378','rno:100362333 rno:246327 rno:289758 rno:293144 rno:298098 rno:299112 rno:301323 rno:304573 rno:361698 rno:362385 rno:59294 rno:85241 rno:85242',false).
concept_name0('39974: rn:R08245','Hprt1, Hgprtase, Hprt, MGC112554',true).
concept_name0('39974: rn:R08245','rno:24465',false).
concept_name0('39973: rn:R04666','rno:116593',false).
concept_name0('39973: rn:R04666','Upb1, Bup1',true).
concept_name0('9975: rn:R04292','R04292...',true).
concept_name0('9975: rn:R04292','rn:R04292 rp:RP03923 rc:RC01119',false).
concept_name0('39972: rn:R01868','rno:65156',false).
concept_name0('39972: rn:R01868','Dhodh',true).
concept_name0('39979: rn:R02095','Entpd3, NTPDase3...',true).
concept_name0('39979: rn:R02095','rno:316077 rno:613267 rno:64519',false).
concept_name0('39978: rn:R08238','Hprt1, Hgprtase, Hprt, MGC112554',true).
concept_name0('39978: rn:R08238','rno:24465',false).
concept_name0('39977: rn:R02093','rno:171566 rno:191575 rno:58964 rno:685679 rno:83782 rno:85269',false).
concept_name0('39977: rn:R02093','Nme7, Nm23-r7...',true).
concept_name0('39976: rn:R08244','rno:295088',false).
concept_name0('39976: rn:R08244','Gmps',true).
concept_name0('39983: rn:R02092','Entpd3, NTPDase3...',true).
concept_name0('39983: rn:R02092','rno:316077 rno:613267 rno:64519',false).
concept_name0('39982: rn:R08248','rno:116631 rno:116632 rno:290681',false).
concept_name0('39982: rn:R08248','Nat1...',true).
concept_name0('39981: rn:R02094','Dtymk',true).
concept_name0('39981: rn:R02094','rno:301622',false).
concept_name0('39980: rn:R08237','Hprt1, Hgprtase, Hprt, MGC112554',true).
concept_name0('39980: rn:R08237','rno:24465',false).
concept_name0('9923: rn:R01147','rn:R01147 rp:RP00131 rp:RP00171 rc:RC00008 rc:RC00048',false).
concept_name0('9923: rn:R01147','R01147...',true).
concept_name0('39952: rn:R08327','Cyp2a3, Cyp2a3a, RATCYP2A3A...',true).
concept_name0('39952: rn:R08327','rno:24299 rno:24894 rno:24895',false).
concept_name0('39953: rn:R08312','100364896...',true).
concept_name0('39953: rn:R08312','rno:100364896 rno:171518 rno:171521 rno:246070 rno:25011 rno:29277 rno:29298 rno:293989 rno:687842 rno:83790',false).
concept_name0('9921: rn:R01580','rn:R01580 rp:RP00084 rp:RP00171 rc:RC00006 rc:RC00048',false).
concept_name0('9921: rn:R01580','R01580...',true).
concept_name0('39954: rn:R08313','rno:24300 rno:286953 rno:292728 rno:29295 rno:361523',false).
concept_name0('39954: rn:R08313','Cyp2b1, Cyp2b-1, Cypbe, MGC188065...',true).
concept_name0('39955: rn:R07977','rno:497811',false).
concept_name0('39955: rn:R07977','Xdh, XOR',true).
concept_name0('39956: rn:R07939','Cyp1a2, CYPD45, P-450d, RATCYPD45',true).
concept_name0('39956: rn:R07939','rno:24297',false).
concept_name0('39957: rn:R08318','Cyp3a9, Cyp3a13, MGC93139, P450olf3...',true).
concept_name0('39957: rn:R08318','rno:171352 rno:252931 rno:25642 rno:266682',false).
concept_name0('39958: rn:R08313','Cyp3a9, Cyp3a13, MGC93139, P450olf3...',true).
concept_name0('39958: rn:R08313','rno:171352 rno:252931 rno:25642 rno:266682',false).
concept_name0('39959: rn:R08285','100364896...',true).
concept_name0('39959: rn:R08285','rno:100364896 rno:171518 rno:171521 rno:246070 rno:25011 rno:29277 rno:29298 rno:293989 rno:687842 rno:83790',false).
concept_name0('39960: rn:R08263','rno:113992 rno:154516 rno:24861 rno:24862 rno:266685 rno:286954 rno:289533 rno:29623 rno:301595 rno:305264 rno:396527 rno:396551 rno:396552 rno:574523 rno:63867 rno:83808',false).
concept_name0('39960: rn:R08263','Ugt1a6, MGC124929, UDPGT_1-6, Udpgt, Ugt1, Ugt1a7...',true).
concept_name0('39961: rn:R07979','rno:497811',false).
concept_name0('39961: rn:R07979','Xdh, XOR',true).
concept_name0('39962: rn:R08255','Ces3...',true).
concept_name0('39962: rn:R08255','rno:113902 rno:171118 rno:246252 rno:291863 rno:29225 rno:307660 rno:498940',false).
concept_name0('39963: rn:R02100','Itpa',true).
concept_name0('39963: rn:R02100','rno:311422',false).
concept_name0('39964: rn:R08260','Gusb, Ac2-223, Gus-s',true).
concept_name0('39964: rn:R08260','rno:24434',false).
concept_name0('39965: rn:R00969','Nudt2',true).
concept_name0('39965: rn:R00969','rno:297998',false).
concept_name0('39966: rn:R08258','Ces2l, CESRL4, Ces2...',true).
concept_name0('39966: rn:R08258','rno:171118 rno:246252 rno:498940',false).
concept_name0('1197: rn:R07496','rn:R07496 rp:RP11538 rc:RC01867',false).
concept_name0('1197: rn:R07496','R07496...',true).
concept_name0('39967: rn:R00965','rno:288051',false).
concept_name0('39967: rn:R00965','Umps',true).
concept_name0('39937: rn:R08303','rno:25086',false).
concept_name0('39937: rn:R08303','Cyp2e1, Cyp2e',true).
concept_name0('39936: rn:R08304','rno:25086',false).
concept_name0('39936: rn:R08304','Cyp2e1, Cyp2e',true).
concept_name0('39939: rn:R00575','Cad',true).
concept_name0('39939: rn:R00575','rno:24240',false).
concept_name0('39938: rn:R08303','Cyp3a9, Cyp3a13, MGC93139, P450olf3...',true).
concept_name0('39938: rn:R08303','rno:171352 rno:252931 rno:25642 rno:266682',false).
concept_name0('39941: rn:R02018','100359539...',true).
concept_name0('39941: rn:R02018','rno:100359539 rno:299976 rno:362720 rno:685579',false).
concept_name0('39940: rn:R08304','Cyp3a9, Cyp3a13, MGC93139, P450olf3...',true).
concept_name0('39940: rn:R08304','rno:171352 rno:252931 rno:25642 rno:266682',false).
concept_name0('39943: rn:R08349','Aox3l1, Aox2...',true).
concept_name0('39943: rn:R08349','rno:316421 rno:54349',false).
concept_name0('39942: rn:R08348','rno:25750 rno:29253',false).
concept_name0('39942: rn:R08348','Maob...',true).
concept_name0('39945: rn:R08347','rno:25750 rno:29253',false).
concept_name0('39945: rn:R08347','Maob...',true).
concept_name0('39944: rn:R08346','rno:25750 rno:29253',false).
concept_name0('39944: rn:R08346','Maob...',true).
concept_name0('39947: rn:R08343','100364896...',true).
concept_name0('39947: rn:R08343','rno:100364896 rno:171518 rno:171521 rno:246070 rno:25011 rno:29277 rno:29298 rno:293989 rno:687842 rno:83790',false).
concept_name0('39946: rn:R08345','rno:171522 rno:24303 rno:25053 rno:266684 rno:286963',false).
concept_name0('39946: rn:R08345','Cyp2d4, Cyp2d18, Cyp2d22, Cyp2d4v1, Cyp2d4v2, Cyp2d6...',true).
concept_name0('39949: rn:R08343','rno:171522 rno:24303 rno:25053 rno:266684 rno:286963',false).
concept_name0('39949: rn:R08343','Cyp2d4, Cyp2d18, Cyp2d22, Cyp2d4v1, Cyp2d4v2, Cyp2d6...',true).
concept_name0('39948: rn:R08344','rno:171522 rno:24303 rno:25053 rno:266684 rno:286963',false).
concept_name0('39948: rn:R08344','Cyp2d4, Cyp2d18, Cyp2d22, Cyp2d4v1, Cyp2d4v2, Cyp2d6...',true).
concept_name0('39951: rn:R08342','Cyp3a9, Cyp3a13, MGC93139, P450olf3...',true).
concept_name0('39951: rn:R08342','rno:171352 rno:252931 rno:25642 rno:266682',false).
concept_name0('39950: rn:R08340','Cyp3a9, Cyp3a13, MGC93139, P450olf3...',true).
concept_name0('39950: rn:R08340','rno:171352 rno:252931 rno:25642 rno:266682',false).
concept_name0('40428: rn:R04355','rno:289934',false).
concept_name0('40428: rn:R04355','Oxsm, RGD1311092',true).
concept_name0('40429: rn:R04739','Hadha, MGC105338, RGD1560655',true).
concept_name0('40429: rn:R04739','rno:170670',false).
concept_name0('40430: rn:R03858','rno:170465 rno:171155',false).
concept_name0('40430: rn:R03858','Acaa2...',true).
concept_name0('40431: rn:R03856','Mecr, Nrbf1',true).
concept_name0('40431: rn:R03856','rno:29470',false).
concept_name0('40424: rn:R01177','rno:170465 rno:171155',false).
concept_name0('40424: rn:R01177','Acaa2...',true).
concept_name0('40425: rn:R01274','rno:29411 rno:54398',false).
concept_name0('40425: rn:R01274','Ppt1, Ppt...',true).
concept_name0('40426: rn:R04738','Echs1...',true).
concept_name0('40426: rn:R04738','rno:140547 rno:170670',false).
concept_name0('5224: rn:R00567','R00567...',true).
concept_name0('5224: rn:R00567','rn:R00567 rp:RP00988 rc:RC00302',false).
concept_name0('40427: rn:R01278','Mecr, Nrbf1',true).
concept_name0('40427: rn:R01278','rno:29470',false).
concept_name0('40420: rn:R04748','Hadh, Hadhsc',true).
concept_name0('40420: rn:R04748','rno:113965',false).
concept_name0('5222: rn:R02458','R02458...',true).
concept_name0('5222: rn:R02458','rn:R02458 rp:RP02230 rc:RC00024',false).
concept_name0('40421: rn:R04748','Hadha, MGC105338, RGD1560655',true).
concept_name0('40421: rn:R04748','rno:170670',false).
concept_name0('40422: rn:R04749','Echs1...',true).
concept_name0('40422: rn:R04749','rno:140547 rno:170670',false).
concept_name0('40423: rn:R06985','Mecr, Nrbf1',true).
concept_name0('40423: rn:R06985','rno:29470',false).
concept_name0('5219: rn:R00672','R00672...',true).
concept_name0('5219: rn:R00672','rn:R00672 rp:RP01045 rc:RC00302',false).
concept_name0('40416: rn:R04747','rno:170465 rno:171155',false).
concept_name0('40416: rn:R04747','Acaa2...',true).
concept_name0('5218: rn:R00672','R00672...',true).
concept_name0('5218: rn:R00672','rn:R00672 rp:RP01045 rc:RC00302',false).
concept_name0('40417: rn:R04745','Hadh, Hadhsc',true).
concept_name0('40417: rn:R04745','rno:113965',false).
concept_name0('5217: rn:R00672','R00672...',true).
concept_name0('5217: rn:R00672','rn:R00672 rp:RP01045 rc:RC00302',false).
concept_name0('40418: rn:R04745','Hadha, MGC105338, RGD1560655',true).
concept_name0('40418: rn:R04745','rno:170670',false).
concept_name0('40419: rn:R04746','Echs1...',true).
concept_name0('40419: rn:R04746','rno:140547 rno:170670',false).
concept_name0('40445: rn:R00888','Gmds, MGC125154',true).
concept_name0('40445: rn:R00888','rno:291095',false).
concept_name0('40444: rn:R04744','Echs1...',true).
concept_name0('40444: rn:R04744','rno:140547 rno:170670',false).
concept_name0('40447: rn:R00885','Gmppb, RGD1560458...',true).
concept_name0('40447: rn:R00885','rno:363145 rno:501167',false).
concept_name0('40446: rn:R05692','Tsta3',true).
concept_name0('40446: rn:R05692','rno:300036',false).
concept_name0('40441: rn:R04741','Hadha, MGC105338, RGD1560655',true).
concept_name0('40441: rn:R04741','rno:170670',false).
concept_name0('1354: rn:R03977','R03977...',true).
concept_name0('1354: rn:R03977','rn:R03977 rp:RP03597 rp:RP03598 rc:RC00096 rc:RC00090',false).
concept_name0('40440: rn:R03776','Mecr, Nrbf1',true).
concept_name0('40440: rn:R03776','rno:29470',false).
concept_name0('40443: rn:R04753','Mecr, Nrbf1',true).
concept_name0('40443: rn:R04753','rno:29470',false).
concept_name0('40442: rn:R04742','rno:170465 rno:171155',false).
concept_name0('40442: rn:R04742','Acaa2...',true).
concept_name0('40437: rn:R04743','Hadha, MGC105338, RGD1560655',true).
concept_name0('40437: rn:R04743','rno:170670',false).
concept_name0('40436: rn:R04740','Echs1...',true).
concept_name0('40436: rn:R04740','rno:140547 rno:170670',false).
concept_name0('40439: rn:R03778','rno:170465 rno:171155',false).
concept_name0('40439: rn:R03778','Acaa2...',true).
concept_name0('40438: rn:R04743','Hadh, Hadhsc',true).
concept_name0('40438: rn:R04743','rno:113965',false).
concept_name0('40433: rn:R04737','Hadha, MGC105338, RGD1560655',true).
concept_name0('40433: rn:R04737','rno:170670',false).
concept_name0('40432: rn:R04170','Echs1...',true).
concept_name0('40432: rn:R04170','rno:140547 rno:170670',false).
concept_name0('40435: rn:R03989','Mecr, Nrbf1',true).
concept_name0('40435: rn:R03989','rno:29470',false).
concept_name0('40434: rn:R03991','rno:170465 rno:171155',false).
concept_name0('40434: rn:R03991','Acaa2...',true).
concept_name0('40398: rn:R04751','Acadsb',true).
concept_name0('40398: rn:R04751','rno:25618',false).
concept_name0('40399: rn:R01975','Hadh, Hadhsc...',true).
concept_name0('40399: rn:R01975','rno:113965 rno:171142',false).
concept_name0('40396: rn:R01279','rno:25363',false).
concept_name0('40396: rn:R01279','Acadvl, MGC93660, VLCAD',true).
concept_name0('40397: rn:R01175','Acadsb',true).
concept_name0('40397: rn:R01175','rno:25618',false).
concept_name0('40394: rn:R02487','rno:364975',false).
concept_name0('40394: rn:R02487','Gcdh',true).
concept_name0('40395: rn:R00623','rno:100145871 rno:171178 rno:24172 rno:29646 rno:310903',false).
concept_name0('40395: rn:R00623','Adh5...',true).
concept_name0('40392: rn:R03857','rno:25287',false).
concept_name0('40392: rn:R03857','Acadl, ACOADA, LCAD',true).
concept_name0('40393: rn:R04741','Hadha, MGC105338, RGD1560655',true).
concept_name0('40393: rn:R04741','rno:170670',false).
concept_name0('40390: rn:R04740','Echs1...',true).
concept_name0('40390: rn:R04740','rno:140547 rno:170670 rno:171142',false).
concept_name0('5189: rn:R00279','R00279...',true).
concept_name0('5189: rn:R00279','rn:R00279 rp:RP00084 rc:RC00006',false).
concept_name0('40391: rn:R03858','Acaa2...',true).
concept_name0('40391: rn:R03858','rno:170465 rno:171155 rno:24157 rno:501072',false).
concept_name0('40388: rn:R04739','Hadh, Hadhsc...',true).
concept_name0('40388: rn:R04739','rno:113965 rno:171142',false).
concept_name0('5191: rn:R00260','rn:R00260 rp:RP04459 rc:RC00302',false).
concept_name0('5191: rn:R00260','R00260...',true).
concept_name0('40389: rn:R03990','rno:24158',false).
concept_name0('40389: rn:R03990','Acadm, MCAD',true).
concept_name0('40386: rn:R04739','Hadha, MGC105338, RGD1560655',true).
concept_name0('40386: rn:R04739','rno:170670',false).
concept_name0('40387: rn:R00631','rno:24188 rno:291450 rno:29539 rno:29651 rno:298079 rno:64040 rno:65183',false).
concept_name0('40387: rn:R00631','Aldh1a1, Ahd2, Aldh1, Aldh2...',true).
concept_name0('40384: rn:R01347 rn:R01348','Cyp4a1, Cyp4a10, Cyp4a22...',true).
concept_name0('40384: rn:R01347 rn:R01348','rno:170544 rno:24306 rno:266674 rno:298423 rno:50549',false).
concept_name0('40385: rn:R03990','rno:25287',false).
concept_name0('40385: rn:R03990','Acadl, ACOADA, LCAD',true).
concept_name0('40415: rn:R03777','rno:24158',false).
concept_name0('40415: rn:R03777','Acadm, MCAD',true).
concept_name0('40414: rn:R04746','Echs1...',true).
concept_name0('40414: rn:R04746','rno:140547 rno:170670 rno:171142',false).
concept_name0('40413: rn:R04745','Hadh, Hadhsc...',true).
concept_name0('40413: rn:R04745','rno:113965 rno:171142',false).
concept_name0('40412: rn:R04747','Acaa2...',true).
concept_name0('40412: rn:R04747','rno:170465 rno:171155 rno:24157 rno:501072',false).
concept_name0('40411: rn:R04751','rno:25287',false).
concept_name0('40411: rn:R04751','Acadl, ACOADA, LCAD',true).
concept_name0('9993: rn:R01268','rn:R01268 rp:RP01397 rc:RC00100',false).
concept_name0('9993: rn:R01268','R01268...',true).
concept_name0('40410: rn:R04748','Hadha, MGC105338, RGD1560655',true).
concept_name0('40410: rn:R04748','rno:170670',false).
concept_name0('5209: rn:R00279','R00279...',true).
concept_name0('5209: rn:R00279','rn:R00279 rp:RP00084 rc:RC00006',false).
concept_name0('40409: rn:R04751','rno:24158',false).
concept_name0('40409: rn:R04751','Acadm, MCAD',true).
concept_name0('5210: rn:R00579','R00579...',true).
concept_name0('5210: rn:R00579','rn:R00579 rp:RP00992 rc:RC00302',false).
concept_name0('40408: rn:R04751','rno:64304',false).
concept_name0('40408: rn:R04751','Acads, Scad',true).
concept_name0('40407: rn:R04749','Echs1...',true).
concept_name0('40407: rn:R04749','rno:140547 rno:170670 rno:171142',false).
concept_name0('40406: rn:R04748','Hadh, Hadhsc...',true).
concept_name0('40406: rn:R04748','rno:113965 rno:171142',false).
concept_name0('40405: rn:R01177','Acaa2...',true).
concept_name0('40405: rn:R01177','rno:170465 rno:171155 rno:24157 rno:501072',false).
concept_name0('9991: rn:R02322','rn:R02322 rp:RP02124 rc:RC00100',false).
concept_name0('9991: rn:R02322','R02322...',true).
concept_name0('40404: rn:R01177','rno:25014 rno:308100',false).
concept_name0('40404: rn:R01177','Acat1, RATACAL...',true).
concept_name0('40403: rn:R04756','Ehhadh, perMFE-1...',true).
concept_name0('40403: rn:R04756','rno:171142 rno:291075 rno:29740',false).
concept_name0('40402: rn:R01175','rno:24158',false).
concept_name0('40402: rn:R01175','Acadm, MCAD',true).
concept_name0('40401: rn:R03026','Echs1...',true).
concept_name0('40401: rn:R03026','rno:140547 rno:170670 rno:171142',false).
concept_name0('40400: rn:R01175','rno:64304',false).
concept_name0('40400: rn:R01175','Acads, Scad',true).
concept_name0('40360: rn:R01279','rno:50681 rno:83522',false).
concept_name0('40360: rn:R01279','Acox1, RATACOA1...',true).
concept_name0('5163: rn:R06614','rn:R06614 rp:RP09054 rc:RC00299',false).
concept_name0('5163: rn:R06614','R06614...',true).
concept_name0('40361: rn:R01923','rno:25413 rno:25756 rno:25757 rno:308579',false).
concept_name0('40361: rn:R01923','Cpt2, CPTII...',true).
concept_name0('40362: rn:R01175','rno:50681 rno:83522',false).
concept_name0('40362: rn:R01175','Acox1, RATACOA1...',true).
concept_name0('40363: rn:R04751','rno:50681 rno:83522',false).
concept_name0('40363: rn:R04751','Acox1, RATACOA1...',true).
concept_name0('40364: rn:R03777','rno:50681 rno:83522',false).
concept_name0('40364: rn:R03777','Acox1, RATACOA1...',true).
concept_name0('10110: rn:R02473','rn:R02473 rp:RP00373 rp:RP00376 rc:RC00096 rc:RC00141',false).
concept_name0('10110: rn:R02473','R02473...',true).
concept_name0('40365: rn:R01279','rno:24158',false).
concept_name0('40365: rn:R01279','Acadm, MCAD',true).
concept_name0('40366: rn:R01280','Acsl4, Acs4, Facl4...',true).
concept_name0('40366: rn:R01280','rno:113976 rno:114024 rno:117243 rno:171410 rno:25288 rno:301120 rno:94340',false).
concept_name0('40367: rn:R04737','Hadha, MGC105338, RGD1560655',true).
concept_name0('40367: rn:R04737','rno:170670',false).
concept_name0('10099: rn:R01623','R01623',true).
concept_name0('10099: rn:R01623','rn:R01623',false).
concept_name0('40352: rn:R01451 rn:R01456','rno:64191',false).
concept_name0('40352: rn:R01451 rn:R01456','Dhcr7, MGC93039',true).
concept_name0('40353: rn:R04804','rno:117278',false).
concept_name0('40353: rn:R04804','Ebp',true).
concept_name0('40354: rn:R01361','Bdh1, Bdh, MGC94818...',true).
concept_name0('40354: rn:R01361','rno:117099 rno:295458',false).
concept_name0('40355: rn:R00238','rno:25014 rno:308100',false).
concept_name0('40355: rn:R00238','Acat1, RATACAL...',true).
concept_name0('40356: rn:R00410','100359544...',true).
concept_name0('40356: rn:R00410','rno:100359544 rno:100361036 rno:100365119 rno:366463 rno:690163',false).
concept_name0('10102: rn:R02972','rn:R02972 rp:RP02649 rc:RC00822',false).
concept_name0('10102: rn:R02972','R02972...',true).
concept_name0('40357: rn:R04754','rno:50681 rno:83522',false).
concept_name0('40357: rn:R04754','Acox1, RATACOA1...',true).
concept_name0('40358: rn:R03857','rno:50681 rno:83522',false).
concept_name0('40358: rn:R03857','Acox1, RATACOA1...',true).
concept_name0('40359: rn:R03990','rno:50681 rno:83522',false).
concept_name0('40359: rn:R03990','Acox1, RATACOA1...',true).
concept_name0('40377: rn:R04743','Hadha, MGC105338, RGD1560655',true).
concept_name0('40377: rn:R04743','rno:170670',false).
concept_name0('40376: rn:R04754','rno:25287',false).
concept_name0('40376: rn:R04754','Acadl, ACOADA, LCAD',true).
concept_name0('40379: rn:R04754','rno:24158',false).
concept_name0('40379: rn:R04754','Acadm, MCAD',true).
concept_name0('40378: rn:R04744','Echs1...',true).
concept_name0('40378: rn:R04744','rno:140547 rno:170670 rno:171142',false).
concept_name0('40381: rn:R04743','Hadh, Hadhsc...',true).
concept_name0('40381: rn:R04743','rno:113965 rno:171142',false).
concept_name0('40380: rn:R03778','Acaa2...',true).
concept_name0('40380: rn:R03778','rno:170465 rno:171155 rno:24157 rno:501072',false).
concept_name0('1292: rn:R03311','rn:R03311 rp:RP02932 rc:RC00905',false).
concept_name0('1292: rn:R03311','R03311...',true).
concept_name0('40383: rn:R03777','rno:25287',false).
concept_name0('40383: rn:R03777','Acadl, ACOADA, LCAD',true).
concept_name0('40382: rn:R04745','Hadha, MGC105338, RGD1560655',true).
concept_name0('40382: rn:R04745','rno:170670',false).
concept_name0('40369: rn:R03991','Acaa2...',true).
concept_name0('40369: rn:R03991','rno:170465 rno:171155 rno:24157 rno:501072',false).
concept_name0('40368: rn:R01279','rno:25287',false).
concept_name0('40368: rn:R01279','Acadl, ACOADA, LCAD',true).
concept_name0('40371: rn:R04738','Echs1...',true).
concept_name0('40371: rn:R04738','rno:140547 rno:170670 rno:171142',false).
concept_name0('40370: rn:R04737','Hadh, Hadhsc...',true).
concept_name0('40370: rn:R04737','rno:113965 rno:171142',false).
concept_name0('1286: rn:R03724','rn:R03724 rp:RP03349 rc:RC00138',false).
concept_name0('1286: rn:R03724','R03724...',true).
concept_name0('40373: rn:R04741','Hadh, Hadhsc...',true).
concept_name0('40373: rn:R04741','rno:113965 rno:171142',false).
concept_name0('40372: rn:R03857','rno:24158',false).
concept_name0('40372: rn:R03857','Acadm, MCAD',true).
concept_name0('40375: rn:R04742','Acaa2...',true).
concept_name0('40375: rn:R04742','rno:170465 rno:171155 rno:24157 rno:501072',false).
concept_name0('1285: rn:R04667','R04667...',true).
concept_name0('1285: rn:R04667','rn:R04667 rp:RP04309 rc:RC00904',false).
concept_name0('40374: rn:R04170','Echs1...',true).
concept_name0('40374: rn:R04170','rno:140547 rno:170670 rno:171142',false).
concept_name0('40330: rn:R03199','Lss',true).
concept_name0('40330: rn:R03199','rno:81681',false).
concept_name0('40331: rn:R02874','Sqle',true).
concept_name0('40331: rn:R02874','rno:29230',false).
concept_name0('1339: rn:R02797','rn:R02797 rp:RP00523 rp:RP02508 rc:RC00096 rc:RC00090',false).
concept_name0('1339: rn:R02797','R02797...',true).
concept_name0('40328: rn:R07484','rno:117278',false).
concept_name0('40328: rn:R07484','Ebp',true).
concept_name0('1338: rn:R05835','rn:R05835 rp:RP00707 rp:RP05418 rc:RC00096 rc:RC00090',false).
concept_name0('1338: rn:R05835','R05835...',true).
concept_name0('40329: rn:R05639','Tm7sf2, MGC108990',true).
concept_name0('40329: rn:R05639','rno:293688',false).
concept_name0('40334: rn:R07488','Dhcr24',true).
concept_name0('40334: rn:R07488','rno:298298',false).
concept_name0('40335: rn:R05731','rno:25427',false).
concept_name0('40335: rn:R05731','Cyp51, Cyp51a1, MGC93630, RATCP14DM',true).
concept_name0('40332: rn:R02872','Fdft1, MGC93486',true).
concept_name0('40332: rn:R02872','rno:29580',false).
concept_name0('40333: rn:R00702','Fdft1, MGC93486',true).
concept_name0('40333: rn:R00702','rno:29580',false).
concept_name0('40322: rn:R03610','rno:114700',false).
concept_name0('40322: rn:R03610','Cyp27b1, Cyp40',true).
concept_name0('40323: rn:R07509','Sc4mol...',true).
concept_name0('40323: rn:R07509','rno:140910 rno:691221',false).
concept_name0('5120: rn:R00486','R00486...',true).
concept_name0('5120: rn:R00486','rn:R00486 rp:RP00934 rc:RC00315',false).
concept_name0('40320: rn:R01461','Soat2, Acat-2...',true).
concept_name0('40320: rn:R01461','rno:266770 rno:81782',false).
concept_name0('40321: rn:R03611','Cyp2r1',true).
concept_name0('40321: rn:R03611','rno:361631',false).
concept_name0('40326: rn:R07494','rno:309262',false).
concept_name0('40326: rn:R07494','Nsdhl, MGC105618',true).
concept_name0('5125: rn:R01267','R01267...',true).
concept_name0('5125: rn:R01267','rn:R01267 rp:RP01396 rc:RC00483',false).
concept_name0('40327: rn:R07495','rno:29540',false).
concept_name0('40327: rn:R07495','Hsd17b7',true).
concept_name0('40324: rn:R05640','rno:25427',false).
concept_name0('40324: rn:R05640','Cyp51, Cyp51a1, MGC93630, RATCP14DM',true).
concept_name0('40325: rn:R03689','Dhcr24',true).
concept_name0('40325: rn:R03689','rno:298298',false).
concept_name0('40347: rn:R07492','rno:64191',false).
concept_name0('40347: rn:R07492','Dhcr7, MGC93039',true).
concept_name0('40346: rn:R07491','rno:114100',false).
concept_name0('40346: rn:R07491','Sc5dl, MGC93101, Sc5d',true).
concept_name0('40345: rn:R07493','Dhcr24',true).
concept_name0('40345: rn:R07493','rno:298298',false).
concept_name0('40344: rn:R05703','Dhcr24',true).
concept_name0('40344: rn:R05703','rno:298298',false).
concept_name0('40351: rn:R07486','rno:114100',false).
concept_name0('40351: rn:R07486','Sc5dl, MGC93101, Sc5d',true).
concept_name0('40350: rn:R01360','rno:79238',false).
concept_name0('40350: rn:R01360','Hmgcl',true).
concept_name0('40349: rn:R01978','Hmgcs2, Hmgcs1, Mt3h3mg...',true).
concept_name0('40349: rn:R01978','rno:24450 rno:29637',false).
concept_name0('1327: rn:R03975','R03975...',true).
concept_name0('1327: rn:R03975','rn:R03975 rp:RP03593 rp:RP03594 rc:RC00096 rc:RC00090',false).
concept_name0('40348: rn:R00238','rno:25014 rno:308100',false).
concept_name0('40348: rn:R00238','Acat1, RATACAL...',true).
concept_name0('40339: rn:R03353','rno:117278',false).
concept_name0('40339: rn:R03353','Ebp',true).
concept_name0('40338: rn:R07487','rno:64191',false).
concept_name0('40338: rn:R07487','Dhcr7, MGC93039',true).
concept_name0('40337: rn:R07499','Dhcr24',true).
concept_name0('40337: rn:R07499','rno:298298',false).
concept_name0('1315: rn:R04824 rn:R04825','rn:R04824 rn:R04825 rp:RP09136 rp:RP09136 rc:RC00144 rc:RC00144',false).
concept_name0('1315: rn:R04824 rn:R04825','R04824...',true).
concept_name0('40336: rn:R07483','Tm7sf2, MGC108990',true).
concept_name0('40336: rn:R07483','rno:293688',false).
concept_name0('40343: rn:R07498','Dhcr24',true).
concept_name0('40343: rn:R07498','rno:298298',false).
concept_name0('40342: rn:R01457','Dhcr24',true).
concept_name0('40342: rn:R01457','rno:298298',false).
concept_name0('40341: rn:R07507','Dhcr24',true).
concept_name0('40341: rn:R07507','rno:298298',false).
concept_name0('1319: rn:R04818 rn:R04819','R04818...',true).
concept_name0('1319: rn:R04818 rn:R04819','rn:R04818 rn:R04819 rp:RP00786 rp:RP00786 rc:RC00144 rc:RC00144',false).
concept_name0('40340: rn:R03310 rn:R07215','rno:114100',false).
concept_name0('40340: rn:R03310 rn:R07215','Sc5dl, MGC93101, Sc5d',true).
concept_name0('40293: rn:R02794','Slc27a5, BAL, rBAL-1',true).
concept_name0('40293: rn:R02794','rno:79111',false).
concept_name0('5350: rn:R03821','R03821...',true).
concept_name0('5350: rn:R03821','rn:R03821 rp:RP03447 rc:RC01003',false).
concept_name0('40292: rn:R08745','rno:29725',false).
concept_name0('40292: rn:R08745','Baat, MGC108728, kan-1',true).
concept_name0('40295: rn:R01463','rno:25428',false).
concept_name0('40295: rn:R01463','Cyp7a1, CHAP, CYP7, CYP7S1',true).
concept_name0('40294: rn:R03718','rno:29725',false).
concept_name0('40294: rn:R03718','Baat, MGC108728, kan-1',true).
concept_name0('40289: rn:R03720','rno:29725',false).
concept_name0('40289: rn:R03720','Baat, MGC108728, kan-1',true).
concept_name0('5346: rn:R08354','rn:R08354 rp:RP12921 rp:RP13222 rc:RC00090 rc:RC00096',false).
concept_name0('5346: rn:R08354','R08354...',true).
concept_name0('40288: rn:R08760','Cyp27a1, Cyp27, P450C27',true).
concept_name0('40288: rn:R08760','rno:301517',false).
concept_name0('40291: rn:R07208','rno:301264',false).
concept_name0('40291: rn:R07208','Cyp39a1',true).
concept_name0('40290: rn:R04826','rno:81924',false).
concept_name0('40290: rn:R04826','Cyp8b1',true).
concept_name0('40301: rn:R04811','Scp2, NSLIPTR, SCPx',true).
concept_name0('40301: rn:R04811','rno:25541',false).
concept_name0('5358: rn:R08358','R08358...',true).
concept_name0('5358: rn:R08358','rn:R08358 rp:RP00250 rc:RC00092',false).
concept_name0('40300: rn:R03719','Scp2, NSLIPTR, SCPx',true).
concept_name0('40300: rn:R03719','rno:25541',false).
concept_name0('5359: rn:R08361','rn:R08361',false).
concept_name0('5359: rn:R08361','R08361',true).
concept_name0('40303: rn:R08505','Cyp27a1, Cyp27, P450C27',true).
concept_name0('40303: rn:R08505','rno:301517',false).
concept_name0('40302: rn:R08761','Cyp27a1, Cyp27, P450C27',true).
concept_name0('40302: rn:R08761','rno:301517',false).
concept_name0('40297: rn:R07218','Ch25h',true).
concept_name0('40297: rn:R07218','rno:309527',false).
concept_name0('40296: rn:R04813','rno:79244',false).
concept_name0('40296: rn:R04813','Hsd17b4, MPF-2',true).
concept_name0('40299: rn:R08744','rno:29725',false).
concept_name0('40299: rn:R08744','Baat, MGC108728, kan-1',true).
concept_name0('40298: rn:R08743','Slc27a5, BAL, rBAL-1',true).
concept_name0('40298: rn:R08743','rno:79111',false).
concept_name0('40308: rn:R08724','rno:246211',false).
concept_name0('40308: rn:R08724','Hsd3b7, Cca2',true).
concept_name0('40309: rn:R07372','rno:25428',false).
concept_name0('40309: rn:R07372','Cyp7a1, CHAP, CYP7, CYP7S1',true).
concept_name0('40310: rn:R07372','rno:25429',false).
concept_name0('40310: rn:R07372','Cyp7b1',true).
concept_name0('40311: rn:R07207','rno:362782',false).
concept_name0('40311: rn:R07207','Cyp46a1',true).
concept_name0('40304: rn:R08759','Cyp27a1, Cyp27, P450C27',true).
concept_name0('40304: rn:R08759','rno:301517',false).
concept_name0('40305: rn:R04263','rno:246211',false).
concept_name0('40305: rn:R04263','Hsd3b7, Cca2',true).
concept_name0('40306: rn:R08723','rno:246211',false).
concept_name0('40306: rn:R08723','Hsd3b7, Cca2',true).
concept_name0('40307: rn:R08728','rno:246211',false).
concept_name0('40307: rn:R08728','Hsd3b7, Cca2',true).
concept_name0('40316: rn:R08735','rno:252898',false).
concept_name0('40316: rn:R08735','Acox2',true).
concept_name0('40317: rn:R08734','rno:25284',false).
concept_name0('40317: rn:R08734','Amacr, Da1-8, Marc1',true).
concept_name0('40318: rn:R04807','Cyp27a1, Cyp27, P450C27',true).
concept_name0('40318: rn:R04807','rno:301517',false).
concept_name0('40319: rn:R01462','rno:24254 rno:25055',false).
concept_name0('40319: rn:R01462','Cel, Bal, Bssl...',true).
concept_name0('40312: rn:R04817','rno:192242',false).
concept_name0('40312: rn:R04817','Akr1d1',true).
concept_name0('40313: rn:R08725','Cyp27a1, Cyp27, P450C27',true).
concept_name0('40313: rn:R08725','rno:301517',false).
concept_name0('40314: rn:R08726','Cyp27a1, Cyp27, P450C27',true).
concept_name0('40314: rn:R08726','rno:301517',false).
concept_name0('40315: rn:R07209','rno:25429',false).
concept_name0('40315: rn:R07209','Cyp7b1',true).
concept_name0('40263: rn:R02499','rno:24470 rno:29632 rno:360348',false).
concept_name0('40263: rn:R02499','Hsd3b5, Hsd1, Hsd3b, RATHSDI...',true).
concept_name0('40262: rn:R02499','rno:24470 rno:29632 rno:360348',false).
concept_name0('40262: rn:R02499','Hsd3b5, Hsd1, Hsd3b, RATHSDI...',true).
concept_name0('40261: rn:R04678','rno:24470 rno:29632 rno:360348',false).
concept_name0('40261: rn:R04678','Hsd3b5, Hsd1, Hsd3b, RATHSDI...',true).
concept_name0('5318: rn:R08358','R08358...',true).
concept_name0('5318: rn:R08358','rn:R08358 rp:RP00250 rc:RC00092',false).
concept_name0('40260: rn:R04678','rno:24470 rno:29632 rno:360348',false).
concept_name0('40260: rn:R04678','Hsd3b5, Hsd1, Hsd3b, RATHSDI...',true).
concept_name0('40259: rn:R03408','Cyp3a9, Cyp3a13, MGC93139, P450olf3...',true).
concept_name0('40259: rn:R03408','rno:171352 rno:24296 rno:252931 rno:25642 rno:266682',false).
concept_name0('40258: rn:R03404','rno:24800',false).
concept_name0('40258: rn:R03404','Sts',true).
concept_name0('40257: rn:R03405','Sult2b1, ST2B1...',true).
concept_name0('40257: rn:R03405','rno:292915 rno:361510',false).
concept_name0('40256: rn:R03713','rno:192242',false).
concept_name0('40256: rn:R03713','Akr1d1',true).
concept_name0('40271: rn:R03848','Hsd11b1, LRRGT00065...',true).
concept_name0('40271: rn:R03848','rno:25116 rno:25117',false).
concept_name0('40270: rn:R02213','rno:24298',false).
concept_name0('40270: rn:R02213','Cyp21a1, 21-OH, Cyp21',true).
concept_name0('40269: rn:R02207 rn:R02209','rno:171516',false).
concept_name0('40269: rn:R02207 rn:R02209','Akr1c18',true).
concept_name0('40268: rn:R03851','Cyp11b2, Cp45as, Cyp11b3, RNCP45AS...',true).
concept_name0('40268: rn:R03851','rno:24294 rno:353498',false).
concept_name0('40267: rn:R08958','rno:171516',false).
concept_name0('40267: rn:R08958','Akr1c18',true).
concept_name0('40266: rn:R02219','rno:192242',false).
concept_name0('40266: rn:R02219','Akr1d1',true).
concept_name0('40265: rn:R02218','Cyp11b2, Cp45as, Cyp11b3, RNCP45AS...',true).
concept_name0('40265: rn:R02218','rno:24294 rno:353498',false).
concept_name0('40264: rn:R03849','rno:24298',false).
concept_name0('40264: rn:R03849','Cyp21a1, 21-OH, Cyp21',true).
concept_name0('5323: rn:R08361','rn:R08361',false).
concept_name0('5323: rn:R08361','R08361',true).
concept_name0('40278: rn:R08721','rno:246211',false).
concept_name0('40278: rn:R08721','Hsd3b7, Cca2',true).
concept_name0('40279: rn:R08727','rno:25429',false).
concept_name0('40279: rn:R08727','Cyp7b1',true).
concept_name0('40276: rn:R04812','rno:79244',false).
concept_name0('40276: rn:R04812','Hsd17b4, MPF-2',true).
concept_name0('40277: rn:R04810','rno:79244',false).
concept_name0('40277: rn:R04810','Hsd17b4, MPF-2',true).
concept_name0('40274: rn:R02352 rn:R02353','rno:25322 rno:286964 rno:29540 rno:361802 rno:79243 rno:84013',false).
concept_name0('40274: rn:R02352 rn:R02353','Hsd17b1, 17BHD1...',true).
concept_name0('40275: rn:R02521','Hpd',true).
concept_name0('40275: rn:R02521','rno:29531',false).
concept_name0('40272: rn:R04840','Hsd11b1, LRRGT00065...',true).
concept_name0('40272: rn:R04840','rno:25116 rno:25117',false).
concept_name0('40273: rn:R00734','rno:24813',false).
concept_name0('40273: rn:R00734','Tat',true).
concept_name0('40286: rn:R04806','Cyp27a1, Cyp27, P450C27',true).
concept_name0('40286: rn:R04806','rno:301517',false).
concept_name0('40287: rn:R08758','Cyp27a1, Cyp27, P450C27',true).
concept_name0('40287: rn:R08758','rno:301517',false).
concept_name0('40284: rn:R08733','Slc27a5, BAL, rBAL-1',true).
concept_name0('40284: rn:R08733','rno:79111',false).
concept_name0('5343: rn:R08352','rn:R08352 rp:RP12919 rp:RP12994 rc:RC00090 rc:RC00096',false).
concept_name0('5343: rn:R08352','R08352...',true).
concept_name0('40285: rn:R08738','Slc27a5, BAL, rBAL-1',true).
concept_name0('40285: rn:R08738','rno:79111',false).
concept_name0('40282: rn:R08740','rno:252898',false).
concept_name0('40282: rn:R08740','Acox2',true).
concept_name0('40283: rn:R04809','rno:79244',false).
concept_name0('40283: rn:R04809','Hsd17b4, MPF-2',true).
concept_name0('40280: rn:R04823','rno:192242',false).
concept_name0('40280: rn:R04823','Akr1d1',true).
concept_name0('5339: rn:R01917','R01917...',true).
concept_name0('5339: rn:R01917','rn:R01917 rp:RP00445 rp:RP00450 rc:RC00090 rc:RC00096',false).
concept_name0('40281: rn:R08739','rno:25284',false).
concept_name0('40281: rn:R08739','Amacr, Da1-8, Marc1',true).
concept_name0('5338: rn:R01918','R01918...',true).
concept_name0('5338: rn:R01918','rn:R01918 rp:RP00445 rp:RP00450 rc:RC00090 rc:RC00096',false).
concept_name0('40225: rn:R03325','rno:171516',false).
concept_name0('40225: rn:R03325','Akr1c18',true).
concept_name0('40224: rn:R08961','rno:25428',false).
concept_name0('40224: rn:R08961','Cyp7a1, CHAP, CYP7, CYP7S1',true).
concept_name0('40227: rn:R04855','rno:29680',false).
concept_name0('40227: rn:R04855','Cyp11a1, Cyp11a, Cypxia1, P450scc',true).
concept_name0('40226: rn:R02723','rno:29680',false).
concept_name0('40226: rn:R02723','Cyp11a1, Cyp11a, Cypxia1, P450scc',true).
concept_name0('40229: rn:R08977','Sult2b1, ST2B1...',true).
concept_name0('40229: rn:R08977','rno:292915 rno:361510',false).
concept_name0('5286: rn:R04950','rn:R04950 rp:RP04559 rc:RC00064',false).
concept_name0('5286: rn:R04950','R04950...',true).
concept_name0('40228: rn:R08941','rno:24800',false).
concept_name0('40228: rn:R08941','Sts',true).
concept_name0('40231: rn:R03933','rno:29680',false).
concept_name0('40231: rn:R03933','Cyp11a1, Cyp11a, Cypxia1, P450scc',true).
concept_name0('40230: rn:R04676','rno:29680',false).
concept_name0('40230: rn:R04676','Cyp11a1, Cyp11a, Cypxia1, P450scc',true).
concept_name0('40233: rn:R04854','rno:29680',false).
concept_name0('40233: rn:R04854','Cyp11a1, Cyp11a, Cypxia1, P450scc',true).
concept_name0('40232: rn:R01454','rno:29680',false).
concept_name0('40232: rn:R01454','Cyp11a1, Cyp11a, Cypxia1, P450scc',true).
concept_name0('40235: rn:R03327','rno:24470 rno:29632 rno:360348',false).
concept_name0('40235: rn:R03327','Hsd3b5, Hsd1, Hsd3b, RATHSDI...',true).
concept_name0('5288: rn:R01917','R01917...',true).
concept_name0('5288: rn:R01917','rn:R01917 rp:RP00445 rp:RP00450 rc:RC00090 rc:RC00096',false).
concept_name0('40234: rn:R04849','rno:24470 rno:29632 rno:360348',false).
concept_name0('40234: rn:R04849','Hsd3b5, Hsd1, Hsd3b, RATHSDI...',true).
concept_name0('5289: rn:R01918','R01918...',true).
concept_name0('5289: rn:R01918','rn:R01918 rp:RP00445 rp:RP00450 rc:RC00090 rc:RC00096',false).
concept_name0('40237: rn:R02216','rno:24470 rno:29632 rno:360348',false).
concept_name0('40237: rn:R02216','Hsd3b5, Hsd1, Hsd3b, RATHSDI...',true).
concept_name0('40236: rn:R03327','rno:24470 rno:29632 rno:360348',false).
concept_name0('40236: rn:R03327','Hsd3b5, Hsd1, Hsd3b, RATHSDI...',true).
concept_name0('40239: rn:R02840','rno:24470 rno:29632 rno:360348',false).
concept_name0('40239: rn:R02840','Hsd3b5, Hsd1, Hsd3b, RATHSDI...',true).
concept_name0('40238: rn:R04850','Cyp11b2, Cp45as, Cyp11b3, RNCP45AS...',true).
concept_name0('40238: rn:R04850','rno:24294 rno:353498',false).
concept_name0('40240: rn:R02840','rno:24470 rno:29632 rno:360348',false).
concept_name0('40240: rn:R02840','Hsd3b5, Hsd1, Hsd3b, RATHSDI...',true).
concept_name0('40241: rn:R04849','rno:24470 rno:29632 rno:360348',false).
concept_name0('40241: rn:R04849','Hsd3b5, Hsd1, Hsd3b, RATHSDI...',true).
concept_name0('40242: rn:R04163','rno:24470 rno:29632 rno:360348',false).
concept_name0('40242: rn:R04163','Hsd3b5, Hsd1, Hsd3b, RATHSDI...',true).
concept_name0('40243: rn:R04163','rno:24470 rno:29632 rno:360348',false).
concept_name0('40243: rn:R04163','Hsd3b5, Hsd1, Hsd3b, RATHSDI...',true).
concept_name0('40244: rn:R03784','rno:24298',false).
concept_name0('40244: rn:R03784','Cyp21a1, 21-OH, Cyp21',true).
concept_name0('40245: rn:R04853','rno:25146',false).
concept_name0('40245: rn:R04853','Cyp17a1, Cyp17',true).
concept_name0('40246: rn:R02216','rno:24470 rno:29632 rno:360348',false).
concept_name0('40246: rn:R02216','Hsd3b5, Hsd1, Hsd3b, RATHSDI...',true).
concept_name0('40247: rn:R08978','Sult2b1, ST2B1...',true).
concept_name0('40247: rn:R08978','rno:292915 rno:361510',false).
concept_name0('40248: rn:R08942','rno:24800',false).
concept_name0('40248: rn:R08942','Sts',true).
concept_name0('40249: rn:R08943','rno:25429',false).
concept_name0('40249: rn:R08943','Cyp7b1',true).
concept_name0('40250: rn:R04675','rno:24298',false).
concept_name0('40250: rn:R04675','Cyp21a1, 21-OH, Cyp21',true).
concept_name0('40251: rn:R01837','rno:24470 rno:29632 rno:360348',false).
concept_name0('40251: rn:R01837','Hsd3b5, Hsd1, Hsd3b, RATHSDI...',true).
concept_name0('40252: rn:R01837','rno:24470 rno:29632 rno:360348',false).
concept_name0('40252: rn:R01837','Hsd3b5, Hsd1, Hsd3b, RATHSDI...',true).
concept_name0('40253: rn:R03783','rno:25146',false).
concept_name0('40253: rn:R03783','Cyp17a1, Cyp17',true).
concept_name0('40254: rn:R08949','Cyp11b2, Cp45as, Cyp11b3, RNCP45AS...',true).
concept_name0('40254: rn:R08949','rno:24294 rno:353498',false).
concept_name0('40255: rn:R03262','rno:500892',false).
concept_name0('40255: rn:R03262','Cyp11b1, Cp11ba, RATCP11BA',true).
concept_name0('40195: rn:R08945 rn:R08980','rno:25322 rno:286964 rno:29540 rno:361802 rno:79243 rno:84013',false).
concept_name0('40195: rn:R08945 rn:R08980','Hsd17b1, 17BHD1...',true).
concept_name0('40194: rn:R03326','rno:24298',false).
concept_name0('40194: rn:R03326','Cyp21a1, 21-OH, Cyp21',true).
concept_name0('40193: rn:R02841','rno:192242',false).
concept_name0('40193: rn:R02841','Akr1d1',true).
concept_name0('40192: rn:R02843','Cyp11b2, Cp45as, Cyp11b3, RNCP45AS...',true).
concept_name0('40192: rn:R02843','rno:24294 rno:353498',false).
concept_name0('40199: rn:R04681 rn:R04682','rno:25322 rno:286964 rno:29540 rno:361802 rno:79243 rno:84013',false).
concept_name0('40199: rn:R04681 rn:R04682','Hsd17b1, 17BHD1...',true).
concept_name0('40198: rn:R02211','rno:25146',false).
concept_name0('40198: rn:R02211','Cyp17a1, Cyp17',true).
concept_name0('40197: rn:R02838','rno:24298',false).
concept_name0('40197: rn:R02838','Cyp21a1, 21-OH, Cyp21',true).
concept_name0('40196: rn:R03329','Cyp11b2, Cp45as, Cyp11b3, RNCP45AS...',true).
concept_name0('40196: rn:R03329','rno:24294 rno:353498',false).
concept_name0('40203: rn:R02356','Cyp3a9, Cyp3a13, MGC93139, P450olf3...',true).
concept_name0('40203: rn:R02356','rno:171352 rno:24296 rno:252931 rno:25642 rno:266682',false).
concept_name0('40202: rn:R02501','Cyp19a1, Aromatase, Cyp19, Cyp19a, p450arom',true).
concept_name0('40202: rn:R02501','rno:25147',false).
concept_name0('40201: rn:R03089','Cyp1a1, AHH, AHRR, CP11, CYP1, Cyp45c, Cypc45c, P-450MC, P1-450, P450-C, P450DX',true).
concept_name0('40201: rn:R03089','rno:24296',false).
concept_name0('40200: rn:R04683','rno:113992 rno:154516 rno:24861 rno:24862 rno:266685 rno:286954 rno:289533 rno:29623 rno:301595 rno:305264 rno:396527 rno:396551 rno:396552 rno:574523 rno:63867 rno:83808',false).
concept_name0('40200: rn:R04683','Ugt1a6, MGC124929, UDPGT_1-6, Udpgt, Ugt1, Ugt1a7...',true).
concept_name0('40207: rn:R04352','rno:113992 rno:154516 rno:24861 rno:24862 rno:266685 rno:286954 rno:289533 rno:29623 rno:301595 rno:305264 rno:396527 rno:396551 rno:396552 rno:574523 rno:63867 rno:83808',false).
concept_name0('40207: rn:R04352','Ugt1a6, MGC124929, UDPGT_1-6, Udpgt, Ugt1, Ugt1a7...',true).
concept_name0('40206: rn:R01834','rno:24950 rno:305291 rno:64677',false).
concept_name0('40206: rn:R01834','Srd5a1, MGC156498, S5AR_1...',true).
concept_name0('40205: rn:R02478','rno:113992 rno:154516 rno:24861 rno:24862 rno:266685 rno:286954 rno:289533 rno:29623 rno:301595 rno:305264 rno:396527 rno:396551 rno:396552 rno:574523 rno:63867 rno:83808',false).
concept_name0('40205: rn:R02478','Ugt1a6, MGC124929, UDPGT_1-6, Udpgt, Ugt1, Ugt1a7...',true).
concept_name0('40204: rn:R01840','Cyp19a1, Aromatase, Cyp19, Cyp19a, p450arom',true).
concept_name0('40204: rn:R01840','rno:25147',false).
concept_name0('40210: rn:R02725','Cyp11b2, Cp45as, Cyp11b3, RNCP45AS...',true).
concept_name0('40210: rn:R02725','rno:24294 rno:353498',false).
concept_name0('40211: rn:R01838','Hsd17b3',true).
concept_name0('40211: rn:R01838','rno:117182',false).
concept_name0('40208: rn:R01835','rno:192242',false).
concept_name0('40208: rn:R01835','Akr1d1',true).
concept_name0('40209: rn:R04758','Hsd11b1, LRRGT00065...',true).
concept_name0('40209: rn:R04758','rno:25116 rno:25117',false).
concept_name0('40214: rn:R04764','Comt',true).
concept_name0('40214: rn:R04764','rno:24267',false).
concept_name0('40215: rn:R03088 rn:R03090','Cyp1b1',true).
concept_name0('40215: rn:R03088 rn:R03090','rno:25426',false).
concept_name0('40212: rn:R03091','rno:113992 rno:154516 rno:24861 rno:24862 rno:266685 rno:286954 rno:289533 rno:29623 rno:301595 rno:305264 rno:396527 rno:396551 rno:396552 rno:574523 rno:63867 rno:83808',false).
concept_name0('40212: rn:R03091','Ugt1a6, MGC124929, UDPGT_1-6, Udpgt, Ugt1, Ugt1a7...',true).
concept_name0('40213: rn:R04354','rno:113992 rno:154516 rno:24861 rno:24862 rno:266685 rno:286954 rno:289533 rno:29623 rno:301595 rno:305264 rno:396527 rno:396551 rno:396552 rno:574523 rno:63867 rno:83808',false).
concept_name0('40213: rn:R04354','Ugt1a6, MGC124929, UDPGT_1-6, Udpgt, Ugt1, Ugt1a7...',true).
concept_name0('40218: rn:R02354 rn:R02355','Cyp1a1, AHH, AHRR, CP11, CYP1, Cyp45c, Cypc45c, P-450MC, P1-450, P450-C, P450DX',true).
concept_name0('40218: rn:R02354 rn:R02355','rno:24296',false).
concept_name0('40219: rn:R04762','Comt',true).
concept_name0('40219: rn:R04762','rno:24267',false).
concept_name0('40216: rn:R02350','rno:25355',false).
concept_name0('40216: rn:R02350','Sult1e1, ESTSUL, ST1E1, Ste',true).
concept_name0('40217: rn:R02358','rno:113992 rno:154516 rno:24861 rno:24862 rno:266685 rno:286954 rno:289533 rno:29623 rno:301595 rno:305264 rno:396527 rno:396551 rno:396552 rno:574523 rno:63867 rno:83808',false).
concept_name0('40217: rn:R02358','Ugt1a6, MGC124929, UDPGT_1-6, Udpgt, Ugt1, Ugt1a7...',true).
concept_name0('40222: rn:R02498','rno:192242',false).
concept_name0('40222: rn:R02498','Akr1d1',true).
concept_name0('40223: rn:R02502','rno:113992 rno:154516 rno:24861 rno:24862 rno:266685 rno:286954 rno:289533 rno:29623 rno:301595 rno:305264 rno:396527 rno:396551 rno:396552 rno:574523 rno:63867 rno:83808',false).
concept_name0('40223: rn:R02502','Ugt1a6, MGC124929, UDPGT_1-6, Udpgt, Ugt1, Ugt1a7...',true).
concept_name0('40220: rn:R04353','rno:113992 rno:154516 rno:24861 rno:24862 rno:266685 rno:286954 rno:289533 rno:29623 rno:301595 rno:305264 rno:396527 rno:396551 rno:396552 rno:574523 rno:63867 rno:83808',false).
concept_name0('40220: rn:R04353','Ugt1a6, MGC124929, UDPGT_1-6, Udpgt, Ugt1, Ugt1a7...',true).
concept_name0('40221: rn:R02497','rno:24950 rno:305291 rno:64677',false).
concept_name0('40221: rn:R02497','Srd5a1, MGC156498, S5AR_1...',true).
concept_name0('40665: rn:R01384','Uxs1, MGC93157, UGD',true).
concept_name0('40665: rn:R01384','rno:246232',false).
concept_name0('40664: rn:R04535','rno:50671',false).
concept_name0('40664: rn:R04535','Fasn',true).
concept_name0('40667: rn:R04959','rno:50671',false).
concept_name0('40667: rn:R04959','Fasn',true).
concept_name0('40666: rn:R04534','rno:50671',false).
concept_name0('40666: rn:R04534','Fasn',true).
concept_name0('40669: rn:R04537','rno:50671',false).
concept_name0('40669: rn:R04537','Fasn',true).
concept_name0('40668: rn:R04960','rno:50671',false).
concept_name0('40668: rn:R04960','Fasn',true).
concept_name0('40671: rn:R02251','Dgat2, MGC108863...',true).
concept_name0('40671: rn:R02251','rno:252900 rno:84497',false).
concept_name0('40670: rn:R02250','rno:117554 rno:24254 rno:24538 rno:25702 rno:291437 rno:50682 rno:84028',false).
concept_name0('40670: rn:R02250','Pnliprp2...',true).
concept_name0('40657: rn:R02705','rno:114711',false).
concept_name0('40657: rn:R02705','Gne, Uae1',true).
concept_name0('40656: rn:R04435','Nans',true).
concept_name0('40656: rn:R04435','rno:298071',false).
concept_name0('40659: rn:R00286','Ugdh',true).
concept_name0('40659: rn:R00286','rno:83472',false).
concept_name0('40658: rn:R04962','rno:50671',false).
concept_name0('40658: rn:R04962','Fasn',true).
concept_name0('40661: rn:R00955','rno:298003',false).
concept_name0('40661: rn:R00955','Galt, MGC112778',true).
concept_name0('40660: rn:R00291','rno:114860',false).
concept_name0('40660: rn:R00291','Gale',true).
concept_name0('40663: rn:R02059','Amdhd2, MGC109150, RGD1304601',true).
concept_name0('40663: rn:R02059','rno:302972',false).
concept_name0('9221: rn:R00325','rn:R00325 rp:RP04896 rp:RP04947 rc:RC01205 rc:RC01118',false).
concept_name0('9221: rn:R00325','R00325...',true).
concept_name0('40662: rn:R04963','rno:50671',false).
concept_name0('40662: rn:R04963','Fasn',true).
concept_name0('40648: rn:R04965','rno:50671',false).
concept_name0('40648: rn:R04965','Fasn',true).
concept_name0('40649: rn:R00416','Uap1l1...',true).
concept_name0('40649: rn:R00416','rno:296560 rno:498272',false).
concept_name0('40650: rn:R08193','Pgm3',true).
concept_name0('40650: rn:R08193','rno:363109',false).
concept_name0('40651: rn:R04725','rno:50671',false).
concept_name0('40651: rn:R04725','Fasn',true).
concept_name0('40652: rn:R01201','rno:297393',false).
concept_name0('40652: rn:R01201','Nagk, MGC124788',true).
concept_name0('40653: rn:R01117','rno:312826',false).
concept_name0('40653: rn:R01117','Cmas, MGC105806',true).
concept_name0('40654: rn:R01805','rno:311530',false).
concept_name0('40654: rn:R01805','Nanp, Hdhd4, MGC105812, RGD1306009',true).
concept_name0('40655: rn:R04964','rno:50671',false).
concept_name0('40655: rn:R04964','Fasn',true).
concept_name0('40640: rn:R05914','St6galnac1, Siat7A',true).
concept_name0('40640: rn:R05914','rno:287920',false).
concept_name0('5955: rn:R02335','R02335',true).
concept_name0('5955: rn:R02335','rn:R02335',false).
concept_name0('40641: rn:R05907','rno:100361647 rno:100366230 rno:170501 rno:288611 rno:292090 rno:293181 rno:29750 rno:311039 rno:311952 rno:313233 rno:313878 rno:361142 rno:362760 rno:366061 rno:499968 rno:500826 rno:683264 rno:79214 rno:83627',false).
concept_name0('40641: rn:R05907','100361647...',true).
concept_name0('1649: rn:R03403','rn:R03403 rp:RP07501 rc:RC00607',false).
concept_name0('1649: rn:R03403','R03403...',true).
concept_name0('40642: rn:R05915','Gcnt3, beta-16-N-acetylglucosaminyltransferase, dI/C2/C4GnT',true).
concept_name0('40642: rn:R05915','rno:286976',false).
concept_name0('40643: rn:R05910','rno:64043',false).
concept_name0('40643: rn:R05910','Gcnt1, core_2_GlcNAc-T',true).
concept_name0('40644: rn:R05907','rno:100361647 rno:100366230 rno:170501 rno:288611 rno:292090 rno:293181 rno:29750 rno:311039 rno:311952 rno:313233 rno:313878 rno:361142 rno:362760 rno:366061 rno:499968 rno:500826 rno:683264 rno:79214 rno:83627',false).
concept_name0('40644: rn:R05907','100361647...',true).
concept_name0('40645: rn:R05907','rno:100361647 rno:100366230 rno:170501 rno:288611 rno:292090 rno:293181 rno:29750 rno:311039 rno:311952 rno:313233 rno:313878 rno:361142 rno:362760 rno:366061 rno:499968 rno:500826 rno:683264 rno:79214 rno:83627',false).
concept_name0('40645: rn:R05907','100361647...',true).
concept_name0('1653: rn:R03406 rn:R03407','R03406...',true).
concept_name0('1653: rn:R03406 rn:R03407','rn:R03406 rn:R03407 rp:RP00675 rp:RP00675 rc:RC00127 rc:RC00127',false).
concept_name0('40646: rn:R05907','rno:100361647 rno:100366230 rno:170501 rno:288611 rno:292090 rno:293181 rno:29750 rno:311039 rno:311952 rno:313233 rno:313878 rno:361142 rno:362760 rno:366061 rno:499968 rno:500826 rno:683264 rno:79214 rno:83627',false).
concept_name0('40646: rn:R05907','100361647...',true).
concept_name0('40647: rn:R00414','rno:114711',false).
concept_name0('40647: rn:R00414','Gne, Uae1',true).
concept_name0('40699: rn:R01350','Lpl, MGC93586',true).
concept_name0('40699: rn:R01350','rno:24539',false).
concept_name0('40698: rn:R01041','Akr1a1, Akr1a4',true).
concept_name0('40698: rn:R01041','rno:78959',false).
concept_name0('40697: rn:R01752','rno:24188 rno:291450 rno:29539 rno:29651 rno:298079 rno:64040 rno:65183',false).
concept_name0('40697: rn:R01752','Aldh1a1, Ahd2, Aldh1, Aldh2...',true).
concept_name0('40696: rn:R00959','Pgm1',true).
concept_name0('40696: rn:R00959','rno:24645',false).
concept_name0('40703: rn:R01092','Galk1, Galk, Glk, MGC94825...',true).
concept_name0('40703: rn:R01092','rno:287835 rno:296117',false).
concept_name0('40702: rn:R04568','rno:50671',false).
concept_name0('40702: rn:R04568','Fasn',true).
concept_name0('40701: rn:R01786','100364027...',true).
concept_name0('40701: rn:R01786','rno:100364027 rno:25058 rno:25059 rno:25060',false).
concept_name0('40700: rn:R04967','rno:50671',false).
concept_name0('40700: rn:R04967','Fasn',true).
concept_name0('40691: rn:R01514','Glyctk',true).
concept_name0('40691: rn:R01514','rno:684314',false).
concept_name0('40690: rn:R04543','rno:50671',false).
concept_name0('40690: rn:R04543','Fasn',true).
concept_name0('40689: rn:R02577','Akr1b1, ALDRED, ALR-P-I, Akr1b3, Akr1b4, Aldr1, Alr, RATALDRED',true).
concept_name0('40689: rn:R02577','rno:24192',false).
concept_name0('40688: rn:R04544','rno:50671',false).
concept_name0('40688: rn:R04544','Fasn',true).
concept_name0('40695: rn:R04968','rno:50671',false).
concept_name0('40695: rn:R04968','Fasn',true).
concept_name0('40694: rn:R01036 rn:R01041','Akr1b1, ALDRED, ALR-P-I, Akr1b3, Akr1b4, Aldr1, Alr, RATALDRED',true).
concept_name0('40694: rn:R01036 rn:R01041','rno:24192',false).
concept_name0('40693: rn:R01818','Pmm1, MGC105960...',true).
concept_name0('40693: rn:R01818','rno:300089 rno:302915',false).
concept_name0('40692: rn:R01819','Mpi, MGC94106',true).
concept_name0('40692: rn:R01819','rno:300741',false).
concept_name0('40682: rn:R01706','rno:50671',false).
concept_name0('40682: rn:R01706','Fasn',true).
concept_name0('40683: rn:R02757','rno:502749',false).
concept_name0('40683: rn:R02757','Agk, RGD1562046',true).
concept_name0('9275: rn:R00934','R00934...',true).
concept_name0('9275: rn:R00934','rn:R00934 rp:RP01183 rp:RP01184 rc:RC00311 rc:RC00407',false).
concept_name0('40680: rn:R00851','Agpat6, RGD1310520...',true).
concept_name0('40680: rn:R00851','rno:290843 rno:296130 rno:29653 rno:305166',false).
concept_name0('40681: rn:R01351','Mgll, MAGL, MGC124942',true).
concept_name0('40681: rn:R01351','rno:29254',false).
concept_name0('40686: rn:R01804','Nans',true).
concept_name0('40686: rn:R01804','rno:298071',false).
concept_name0('40687: rn:R04970','rno:50671',false).
concept_name0('40687: rn:R04970','Fasn',true).
concept_name0('40684: rn:R01706','Olah, Mch, Thedc1',true).
concept_name0('40684: rn:R01706','rno:64669',false).
concept_name0('40685: rn:R00847','rno:289481 rno:79223',false).
concept_name0('40685: rn:R00847','Gk2, Gk-rs2, MGC94998...',true).
concept_name0('40674: rn:R04952','rno:289934',false).
concept_name0('40674: rn:R04952','Oxsm, RGD1311092',true).
concept_name0('40675: rn:R02241','Agpat4, MGC93227...',true).
concept_name0('40675: rn:R02241','rno:170919 rno:294324 rno:311821 rno:313997 rno:362702 rno:406165 rno:498741',false).
concept_name0('40672: rn:R04957','rno:50671',false).
concept_name0('40672: rn:R04957','Fasn',true).
concept_name0('40673: rn:R04536','rno:50671',false).
concept_name0('40673: rn:R04536','Fasn',true).
concept_name0('40678: rn:R02239','rno:192270 rno:246115 rno:64369',false).
concept_name0('40678: rn:R02239','Ppap2b, Dri42...',true).
concept_name0('1620: rn:R03263','R03263...',true).
concept_name0('1620: rn:R03263','rn:R03263 rp:RP02894 rc:RC00893',false).
concept_name0('40679: rn:R01011','Dak, MGC114371, RGD1311026',true).
concept_name0('40679: rn:R01011','rno:361730',false).
concept_name0('40676: rn:R04957','rno:289934',false).
concept_name0('40676: rn:R04957','Oxsm, RGD1311092',true).
concept_name0('40677: rn:R02687','rno:117554 rno:24254 rno:24538 rno:25702 rno:291437 rno:50682 rno:84028',false).
concept_name0('40677: rn:R02687','Pnliprp2...',true).
concept_name0('40605: rn:R06263','rno:293129',false).
concept_name0('40605: rn:R06263','Alg8, MGC124750',true).
concept_name0('40604: rn:R05981','Ganab, G2an; glucosidase, alpha',true).
concept_name0('40604: rn:R05981','rno:293721',false).
concept_name0('40607: rn:R02957','rno:24188 rno:291450 rno:29539 rno:29651 rno:298079 rno:64040 rno:65183',false).
concept_name0('40607: rn:R02957','Aldh1a1, Ahd2, Aldh1, Aldh2...',true).
concept_name0('40606: rn:R06264','rno:245960',false).
concept_name0('40606: rn:R06264','Alg10, Alg10b, KCR1',true).
concept_name0('40601: rn:R06127','Alg11, RGD1564725',true).
concept_name0('40601: rn:R06127','rno:361174',false).
concept_name0('40600: rn:R09035','Lpcat4, Agpat7, RGD1311177...',true).
concept_name0('40600: rn:R09035','rno:296048 rno:313997 rno:362434 rno:498741',false).
concept_name0('40603: rn:R06238','rno:313231',false).
concept_name0('40603: rn:R06238','Alg2',true).
concept_name0('40602: rn:R06261','Alg9, Dibd1',true).
concept_name0('40602: rn:R06261','rno:367083',false).
concept_name0('40597: rn:R05931','rno:291577 rno:292999 rno:296733 rno:316533',false).
concept_name0('40597: rn:R05931','Chsy3, RGD1560819...',true).
concept_name0('40596: rn:R05929','Csgalnact2, Galnact2, RGD1563660...',true).
concept_name0('40596: rn:R05929','rno:297554 rno:306375',false).
concept_name0('40599: rn:R09036','100359680...',true).
concept_name0('40599: rn:R09036','rno:100359680 rno:296048 rno:307713 rno:361467 rno:362702 rno:679692',false).
concept_name0('40598: rn:R05932','rno:291577 rno:292999 rno:316533',false).
concept_name0('40598: rn:R05932','Chsy3, RGD1560819...',true).
concept_name0('40593: rn:R09034','Agpat4, MGC93227...',true).
concept_name0('40593: rn:R09034','rno:170919 rno:294324 rno:308309 rno:362702',false).
concept_name0('40592: rn:R05926','rno:364675',false).
concept_name0('40592: rn:R05926','B4galt7, MGC116242',true).
concept_name0('40595: rn:R05928','B3gat1, Hnk-1...',true).
concept_name0('40595: rn:R05928','rno:117108 rno:293722 rno:64544',false).
concept_name0('40594: rn:R05925','rno:64133 rno:64134',false).
concept_name0('40594: rn:R05925','Xylt1, XYLT-1, Xt1...',true).
concept_name0('40588: rn:R07809','rno:294673 rno:300757',false).
concept_name0('40588: rn:R07809','Hexb...',true).
concept_name0('40589: rn:R07808','rno:299825',false).
concept_name0('40589: rn:R07808','Gns',true).
concept_name0('40590: rn:R05927','B3galt6',true).
concept_name0('40590: rn:R05927','rno:298690',false).
concept_name0('40591: rn:R09037','rno:362702 rno:363521',false).
concept_name0('40591: rn:R09037','Lclat1, Lycat, RGD1565906...',true).
concept_name0('40584: rn:R07812','rno:363513',false).
concept_name0('40584: rn:R07812','Ids',true).
concept_name0('40585: rn:R07818','Gusb, Ac2-223, Gus-s',true).
concept_name0('40585: rn:R07818','rno:24434',false).
concept_name0('40586: rn:R07807','rno:316033',false).
concept_name0('40586: rn:R07807','Glb1',true).
concept_name0('40587: rn:R07806','rno:292073',false).
concept_name0('40587: rn:R07806','Galns',true).
concept_name0('40580: rn:R03184','rno:60671',false).
concept_name0('40580: rn:R03184','Gulo',true).
concept_name0('40581: rn:R07811','Hpse2...',true).
concept_name0('40581: rn:R07811','rno:368128 rno:64537',false).
concept_name0('40582: rn:R07816','RGD1564228',true).
concept_name0('40582: rn:R07816','rno:360630',false).
concept_name0('40583: rn:R07822','rno:100361089',false).
concept_name0('40583: rn:R07822','100361089',true).
concept_name0('40576: rn:R07824','Spam1, MGC93268, Spam...',true).
concept_name0('40576: rn:R07824','rno:117037 rno:300993 rno:367166 rno:404783 rno:500051 rno:500052 rno:64468',false).
concept_name0('40577: rn:R07823','Arsb',true).
concept_name0('40577: rn:R07823','rno:25227',false).
concept_name0('13665: rn:R08249','rn:R08249 rp:RP13126 rp:RP13128 rc:RC00162 rc:RC00962',false).
concept_name0('13665: rn:R08249','R08249...',true).
concept_name0('40578: rn:R07813','rno:100361089',false).
concept_name0('40578: rn:R07813','100361089',true).
concept_name0('40579: rn:R07814','rno:688293',false).
concept_name0('40579: rn:R07814','688293',true).
concept_name0('40639: rn:R05907','rno:100361647 rno:100366230 rno:170501 rno:288611 rno:292090 rno:293181 rno:29750 rno:311039 rno:311952 rno:313233 rno:313878 rno:361142 rno:362760 rno:366061 rno:499968 rno:500826 rno:683264 rno:79214 rno:83627',false).
concept_name0('40639: rn:R05907','100361647...',true).
concept_name0('40638: rn:R05907','rno:100361647 rno:100366230 rno:170501 rno:288611 rno:292090 rno:293181 rno:29750 rno:311039 rno:311952 rno:313233 rno:313878 rno:361142 rno:362760 rno:366061 rno:499968 rno:500826 rno:683264 rno:79214 rno:83627',false).
concept_name0('40638: rn:R05907','100361647...',true).
concept_name0('40637: rn:R05907','rno:100361647 rno:100366230 rno:170501 rno:288611 rno:292090 rno:293181 rno:29750 rno:311039 rno:311952 rno:313233 rno:313878 rno:361142 rno:362760 rno:366061 rno:499968 rno:500826 rno:683264 rno:79214 rno:83627',false).
concept_name0('40637: rn:R05907','100361647...',true).
concept_name0('9327: rn:R01388','R01388...',true).
concept_name0('9327: rn:R01388','rn:R01388 rp:RP00299 rc:RC00031',false).
concept_name0('40636: rn:R05907','rno:100361647 rno:100366230 rno:170501 rno:288611 rno:292090 rno:293181 rno:29750 rno:311039 rno:311952 rno:313233 rno:313878 rno:361142 rno:362760 rno:366061 rno:499968 rno:500826 rno:683264 rno:79214 rno:83627',false).
concept_name0('40636: rn:R05907','100361647...',true).
concept_name0('40635: rn:R08159','rno:50671',false).
concept_name0('40635: rn:R08159','Fasn',true).
concept_name0('40634: rn:R08615','rno:113992 rno:154516 rno:24861 rno:24862 rno:266685 rno:286954 rno:289533 rno:29623 rno:301595 rno:305264 rno:396527 rno:396551 rno:396552 rno:574523 rno:63867 rno:83808',false).
concept_name0('40634: rn:R08615','Ugt1a6, MGC124929, UDPGT_1-6, Udpgt, Ugt1, Ugt1a7...',true).
concept_name0('40633: rn:R07762','rno:289934',false).
concept_name0('40633: rn:R07762','Oxsm, RGD1311092',true).
concept_name0('9323: rn:R01196','rn:R01196',false).
concept_name0('9323: rn:R01196','R01196',true).
concept_name0('40632: rn:R08163','Olah, Mch, Thedc1',true).
concept_name0('40632: rn:R08163','rno:64669',false).
concept_name0('40631: rn:R02814','Olah, Mch, Thedc1',true).
concept_name0('40631: rn:R02814','rno:64669',false).
concept_name0('40630: rn:R04014','Olah, Mch, Thedc1',true).
concept_name0('40630: rn:R04014','rno:64669',false).
concept_name0('40629: rn:R08159','Olah, Mch, Thedc1',true).
concept_name0('40629: rn:R08159','rno:64669',false).
concept_name0('40628: rn:R04968','rno:289934',false).
concept_name0('40628: rn:R04968','Oxsm, RGD1311092',true).
concept_name0('40627: rn:R04726','rno:289934',false).
concept_name0('40627: rn:R04726','Oxsm, RGD1311092',true).
concept_name0('40626: rn:R05915','Gcnt3, beta-16-N-acetylglucosaminyltransferase, dI/C2/C4GnT',true).
concept_name0('40626: rn:R05915','rno:286976',false).
concept_name0('40625: rn:R04963','rno:289934',false).
concept_name0('40625: rn:R04963','Oxsm, RGD1311092',true).
concept_name0('40624: rn:R05910','rno:64043',false).
concept_name0('40624: rn:R05910','Gcnt1, core_2_GlcNAc-T',true).
concept_name0('9341: rn:R00519','R00519',true).
concept_name0('9341: rn:R00519','rn:R00519',false).
concept_name0('40622: rn:R05914','St6galnac1, Siat7A',true).
concept_name0('40622: rn:R05914','rno:287920',false).
concept_name0('9340: rn:R00945','R00945...',true).
concept_name0('9340: rn:R00945','rn:R00945 rp:RP00061 rc:RC00022',false).
concept_name0('40623: rn:R04960','rno:289934',false).
concept_name0('40623: rn:R04960','Oxsm, RGD1311092',true).
concept_name0('40620: rn:R05911','St6galnac1, Siat7A',true).
concept_name0('40620: rn:R05911','rno:287920',false).
concept_name0('40621: rn:R07628','B4galt5',true).
concept_name0('40621: rn:R07628','rno:362275',false).
concept_name0('5934: rn:R02738','R02738...',true).
concept_name0('5934: rn:R02738','rn:R02738 rp:RP02452 rc:RC00017',false).
concept_name0('40618: rn:R05909','rno:292325',false).
concept_name0('40618: rn:R05909','B3gnt6, RGD1310926',true).
concept_name0('9336: rn:R08572','R08572...',true).
concept_name0('9336: rn:R08572','rn:R08572 rp:RP01729 rc:RC00428',false).
concept_name0('40619: rn:R05907','rno:100361647 rno:100366230 rno:170501 rno:288611 rno:292090 rno:293181 rno:29750 rno:311039 rno:311952 rno:313233 rno:313878 rno:361142 rno:362760 rno:366061 rno:499968 rno:500826 rno:683264 rno:79214 rno:83627',false).
concept_name0('40619: rn:R05907','100361647...',true).
concept_name0('40616: rn:R05936','rno:313610 rno:56819',false).
concept_name0('40616: rn:R05936','Extl1...',true).
concept_name0('40617: rn:R05930','Extl2...',true).
concept_name0('40617: rn:R05930','rno:310803 rno:56819',false).
concept_name0('40614: rn:R05911','St6galnac1, Siat7A',true).
concept_name0('40614: rn:R05911','rno:287920',false).
concept_name0('9332: rn:R00134','rn:R00134',false).
concept_name0('9332: rn:R00134','R00134',true).
concept_name0('40615: rn:R07628','B4galt5',true).
concept_name0('40615: rn:R07628','rno:362275',false).
concept_name0('40612: rn:R05909','rno:292325',false).
concept_name0('40612: rn:R05909','B3gnt6, RGD1310926',true).
concept_name0('40613: rn:R05907','rno:100361647 rno:100366230 rno:170501 rno:288611 rno:292090 rno:293181 rno:29750 rno:311039 rno:311952 rno:313233 rno:313878 rno:361142 rno:362760 rno:366061 rno:499968 rno:500826 rno:683264 rno:79214 rno:83627',false).
concept_name0('40613: rn:R05907','100361647...',true).
concept_name0('40610: rn:R00647','rno:60671',false).
concept_name0('40610: rn:R00647','Gulo',true).
concept_name0('1552: rn:R08995','R08995...',true).
concept_name0('1552: rn:R08995','rn:R08995 rp:RP14203 rc:RC00607',false).
concept_name0('40611: rn:R05983','Mgat1',true).
concept_name0('40611: rn:R05983','rno:81519',false).
concept_name0('9331: rn:R00473','rn:R00473 rp:RP00922 rp:RP00923 rc:RC00307 rc:RC00308',false).
concept_name0('9331: rn:R00473','R00473...',true).
concept_name0('40608: rn:R02933','rno:25106',false).
concept_name0('40608: rn:R02933','Rgn, Rc, Reguc',true).
concept_name0('40609: rn:R05935','rno:299907 rno:311215',false).
concept_name0('40609: rn:R05935','Ext1...',true).
concept_name0('40528: rn:R00291','rno:114860',false).
concept_name0('40528: rn:R00291','Gale',true).
concept_name0('40529: rn:R02240','Dgkq...',true).
concept_name0('40529: rn:R02240','rno:100361138 rno:140866 rno:25666 rno:361076 rno:368088 rno:497978 rno:54248 rno:688705 rno:81821',false).
concept_name0('40530: rn:R00955','rno:298003',false).
concept_name0('40530: rn:R00955','Galt, MGC112778',true).
concept_name0('40531: rn:R01092','Galk1, Galk, Glk, MGC94825...',true).
concept_name0('40531: rn:R01092','rno:287835 rno:296117',false).
concept_name0('40532: rn:R02051','rno:25096 rno:25097',false).
concept_name0('40532: rn:R02051','Pld1, Pld1a, Pld1b, Plda, Pldb...',true).
concept_name0('40533: rn:R03236 rn:R03237 rn:R03238 rn:R03239','rno:25741 rno:60416 rno:65152',false).
concept_name0('40533: rn:R03236 rn:R03237 rn:R03238 rn:R03239','Pfkl...',true).
concept_name0('40534: rn:R07814','rno:688293',false).
concept_name0('40534: rn:R07814','688293',true).
concept_name0('40535: rn:R02746','Plb1, Phlpb...',true).
concept_name0('40535: rn:R02746','rno:192259 rno:246246 rno:25514 rno:360753 rno:361401',false).
concept_name0('40536: rn:R03634','Gla',true).
concept_name0('40536: rn:R03634','rno:363494',false).
concept_name0('40537: rn:R02056','Pemt, PHOMETH, Pempt',true).
concept_name0('40537: rn:R02056','rno:25511',false).
concept_name0('40538: rn:R05549','Gla',true).
concept_name0('40538: rn:R05549','rno:363494',false).
concept_name0('40539: rn:R01801','rno:303698',false).
concept_name0('40539: rn:R01801','Pgs1, RGD1305052',true).
concept_name0('40540: rn:R02030 rn:R07390','Crls1, RGD1311037',true).
concept_name0('40540: rn:R02030 rn:R07390','rno:366196',false).
concept_name0('40541: rn:R01103','Gla',true).
concept_name0('40541: rn:R01103','rno:363494',false).
concept_name0('40542: rn:R00801','rno:24382 rno:312272 rno:367562',false).
concept_name0('40542: rn:R00801','Ganc; glucosidase, alpha...',true).
concept_name0('40543: rn:R01104','Gla',true).
concept_name0('40543: rn:R01104','rno:363494',false).
concept_name0('40513: rn:R01023','Chat',true).
concept_name0('40513: rn:R01023','rno:290567',false).
concept_name0('40512: rn:R01194','Gla',true).
concept_name0('40512: rn:R01194','rno:363494',false).
concept_name0('40515: rn:R01026','Ache',true).
concept_name0('40515: rn:R01026','rno:83817',false).
concept_name0('40514: rn:R02926','Gla',true).
concept_name0('40514: rn:R02926','rno:363494',false).
concept_name0('40517: rn:R01021','rno:29194 rno:29367',false).
concept_name0('40517: rn:R01021','Chka, CK-R, Chk, MGC93538...',true).
concept_name0('40516: rn:R01786','100364027...',true).
concept_name0('40516: rn:R01786','rno:100364027 rno:25058 rno:25059 rno:25060',false).
concept_name0('40519: rn:R01315','rno:192259 rno:24653 rno:289733 rno:29354 rno:29359 rno:29387 rno:29526 rno:296091 rno:29692 rno:298579 rno:311341 rno:360426 rno:362039 rno:367415 rno:690388 rno:691907',false).
concept_name0('40519: rn:R01315','Plb1, Phlpb...',true).
concept_name0('40518: rn:R01786','Gck, GLUKA, RNGK2',true).
concept_name0('40518: rn:R01786','rno:24385',false).
concept_name0('40521: rn:R01678','Lct, Lph',true).
concept_name0('40521: rn:R01678','rno:116569',false).
concept_name0('6090: rn:R08639','R08639...',true).
concept_name0('6090: rn:R08639','rn:R08639 rp:RP10946 rc:RC00408',false).
concept_name0('40520: rn:R01678','rno:316033',false).
concept_name0('40520: rn:R01678','Glb1',true).
concept_name0('40523: rn:R01468','rno:29194 rno:29367 rno:312828 rno:360843',false).
concept_name0('40523: rn:R01468','Chka, CK-R, Chk, MGC93538...',true).
concept_name0('40522: rn:R00503','B4galt1, Ggtb2...',true).
concept_name0('40522: rn:R00503','rno:24390 rno:24528 rno:313536',false).
concept_name0('40525: rn:R01310','rno:25096 rno:25097',false).
concept_name0('40525: rn:R01310','Pld1, Pld1a, Pld1b, Plda, Pldb...',true).
concept_name0('40524: rn:R00959','Pgm1',true).
concept_name0('40524: rn:R00959','rno:24645',false).
concept_name0('40527: rn:R02239','rno:192270 rno:246115 rno:64369',false).
concept_name0('40527: rn:R02239','Ppap2b, Dri42...',true).
concept_name0('40526: rn:R00289','Ugp2',true).
concept_name0('40526: rn:R00289','rno:289827',false).
concept_name0('40562: rn:R00286','Ugdh',true).
concept_name0('40562: rn:R00286','rno:83472',false).
concept_name0('40563: rn:R07824','Spam1, MGC93268, Spam...',true).
concept_name0('40563: rn:R07824','rno:117037 rno:300993 rno:367166 rno:404783 rno:500051 rno:500052 rno:64468',false).
concept_name0('40560: rn:R01184','Miox, Aldrl6, RSOR',true).
concept_name0('40560: rn:R01184','rno:252899',false).
concept_name0('40561: rn:R07807','rno:316033',false).
concept_name0('40561: rn:R07807','Glb1',true).
concept_name0('40566: rn:R07822','rno:100361089',false).
concept_name0('40566: rn:R07822','100361089',true).
concept_name0('40567: rn:R07813','rno:100361089',false).
concept_name0('40567: rn:R07813','100361089',true).
concept_name0('40564: rn:R07812','rno:363513',false).
concept_name0('40564: rn:R07812','Ids',true).
concept_name0('40565: rn:R07806','rno:292073',false).
concept_name0('40565: rn:R07806','Galns',true).
concept_name0('40570: rn:R07810','rno:294673 rno:300757',false).
concept_name0('40570: rn:R07810','Hexb...',true).
concept_name0('9384: rn:R01440','R01440...',true).
concept_name0('9384: rn:R01440','rn:R01440 rp:RP00080 rc:RC00032',false).
concept_name0('40571: rn:R07825','Spam1, MGC93268, Spam...',true).
concept_name0('40571: rn:R07825','rno:117037 rno:300993 rno:367166 rno:404783 rno:500051 rno:500052 rno:64468',false).
concept_name0('40568: rn:R07818','Gusb, Ac2-223, Gus-s',true).
concept_name0('40568: rn:R07818','rno:24434',false).
concept_name0('40569: rn:R07819','rno:299825',false).
concept_name0('40569: rn:R07819','Gns',true).
concept_name0('40574: rn:R07824','Spam1, MGC93268, Spam...',true).
concept_name0('40574: rn:R07824','rno:117037 rno:300993 rno:367166 rno:404783 rno:500051 rno:500052 rno:64468',false).
concept_name0('40575: rn:R07821','rno:363513',false).
concept_name0('40575: rn:R07821','Ids',true).
concept_name0('40572: rn:R07816','RGD1564228',true).
concept_name0('40572: rn:R07816','rno:360630',false).
concept_name0('40573: rn:R07809','rno:294673 rno:300757',false).
concept_name0('40573: rn:R07809','Hexb...',true).
concept_name0('40547: rn:R02057','Cept1, MGC95031...',true).
concept_name0('40547: rn:R02057','rno:310773 rno:362713',false).
concept_name0('40546: rn:R03416','rno:192259 rno:246246 rno:25514 rno:360753',false).
concept_name0('40546: rn:R03416','Plb1, Phlpb...',true).
concept_name0('40545: rn:R01093 rn:R01095','Akr1b1, ALDRED, ALR-P-I, Akr1b3, Akr1b4, Aldr1, Alr, RATALDRED',true).
concept_name0('40545: rn:R01093 rn:R01095','rno:24192',false).
concept_name0('40544: rn:R01329','Gla',true).
concept_name0('40544: rn:R01329','rno:363494',false).
concept_name0('40551: rn:R01799','Cds2...',true).
concept_name0('40551: rn:R01799','rno:114101 rno:81925',false).
concept_name0('40550: rn:R04480','Lpcat4, Agpat7, RGD1311177...',true).
concept_name0('40550: rn:R04480','rno:296048 rno:313997 rno:362434 rno:498741',false).
concept_name0('40549: rn:R07811','rno:368128',false).
concept_name0('40549: rn:R07811','Hpse2',true).
concept_name0('40548: rn:R03417','rno:192259 rno:246246 rno:360753 rno:83510',false).
concept_name0('40548: rn:R03417','Plb1, Phlpb...',true).
concept_name0('40555: rn:R07821','rno:363513',false).
concept_name0('40555: rn:R07821','Ids',true).
concept_name0('40554: rn:R02055','Pisd',true).
concept_name0('40554: rn:R02055','rno:681361',false).
concept_name0('40553: rn:R07811','Hpse, Hep, Hpa',true).
concept_name0('40553: rn:R07811','rno:64537',false).
concept_name0('40552: rn:R02747','rno:192259 rno:246246 rno:360753 rno:83510',false).
concept_name0('40552: rn:R02747','Plb1, Phlpb...',true).
concept_name0('40559: rn:R07823','Arsb',true).
concept_name0('40559: rn:R07823','rno:25227',false).
concept_name0('40558: rn:R07808','rno:299825',false).
concept_name0('40558: rn:R07808','Gns',true).
concept_name0('40557: rn:R06871','rno:287644',false).
concept_name0('40557: rn:R06871','Phospho1',true).
concept_name0('40556: rn:R00855','RGD1309906, ADPRibase-Mn, MDS006, MGC108803',true).
concept_name0('40556: rn:R00855','rno:287406',false).
concept_name0('40468: rn:R05916','rno:288238',false).
concept_name0('40468: rn:R05916','Pigp, Dscr5',true).
concept_name0('40469: rn:R05916','rno:287159',false).
concept_name0('40469: rn:R05916','Pigq, MGC93737',true).
concept_name0('40470: rn:R00264','rno:24188 rno:29539 rno:29651 rno:298079 rno:65183',false).
concept_name0('40470: rn:R00264','Aldh1a1, Ahd2, Aldh1, Aldh2...',true).
concept_name0('1700: rn:R01841','rn:R01841 rp:RP01796 rc:RC00607',false).
concept_name0('1700: rn:R01841','R01841...',true).
concept_name0('40471: rn:R00705','rno:81708',false).
concept_name0('40471: rn:R00705','Aldh6a1, Mmsdh',true).
concept_name0('40464: rn:R01430','rno:691002',false).
concept_name0('40464: rn:R01430','Dhdh',true).
concept_name0('40465: rn:R05795','rno:116720 rno:289021 rno:361632',false).
concept_name0('40465: rn:R05795','Pik3c2g...',true).
concept_name0('40466: rn:R05916','rno:29640',false).
concept_name0('40466: rn:R05916','Dpm2',true).
concept_name0('40467: rn:R05916','100365921',true).
concept_name0('40467: rn:R05916','rno:100365921',false).
concept_name0('40476: rn:R05918','Pigw',true).
concept_name0('40476: rn:R05918','rno:378774',false).
concept_name0('1710: rn:R04309 rn:R04310','rn:R04309 rn:R04310 rp:RP00748 rp:RP00748 rc:RC00144 rc:RC00144',false).
concept_name0('1710: rn:R04309 rn:R04310','R04309...',true).
concept_name0('40477: rn:R08107','Pigo',true).
concept_name0('40477: rn:R08107','rno:313341',false).
concept_name0('40478: rn:R06623','rno:291132',false).
concept_name0('40478: rn:R06623','Gpld1',true).
concept_name0('40479: rn:R05916','rno:363464',false).
concept_name0('40479: rn:R05916','Piga',true).
concept_name0('40472: rn:R01015','rno:246267 rno:24849 rno:498731 rno:500959',false).
concept_name0('40472: rn:R01015','246267...',true).
concept_name0('40473: rn:R01802','Cdipt, Pis, Pis1',true).
concept_name0('40473: rn:R01802','rno:192260',false).
concept_name0('40474: rn:R05802','Pikfyve, Pip5k3',true).
concept_name0('40474: rn:R05802','rno:316457',false).
concept_name0('9416: rn:R00230','rn:R00230',false).
concept_name0('9416: rn:R00230','R00230',true).
concept_name0('40475: rn:R05921','Pigv, RGD1309526',true).
concept_name0('40475: rn:R05921','rno:366478',false).
concept_name0('40453: rn:R00872','Phpt1...',true).
concept_name0('40453: rn:R00872','rno:296571 rno:305935 rno:306490',false).
concept_name0('40452: rn:R01951','rno:310935',false).
concept_name0('40452: rn:R01951','Fpgt',true).
concept_name0('40455: rn:R00867','100364027...',true).
concept_name0('40455: rn:R00867','rno:100364027 rno:25058 rno:25059 rno:25060',false).
concept_name0('40454: rn:R01326','100364027...',true).
concept_name0('40454: rn:R01326','rno:100364027 rno:25058 rno:25059 rno:25060',false).
concept_name0('40449: rn:R02731','Pfkfb3...',true).
concept_name0('40449: rn:R02731','rno:117276 rno:24638 rno:24640 rno:502894 rno:54283',false).
concept_name0('1715: rn:R02476 rn:R02477','R02476...',true).
concept_name0('1715: rn:R02476 rn:R02477','rn:R02476 rn:R02477 rp:RP00381 rp:RP00381 rc:RC00144 rc:RC00144',false).
concept_name0('40448: rn:R04779','rno:25741 rno:60416 rno:65152',false).
concept_name0('40448: rn:R04779','Pfkl...',true).
concept_name0('1712: rn:R04309','rn:R04309 rp:RP00748 rc:RC00144',false).
concept_name0('1712: rn:R04309','R04309...',true).
concept_name0('40451: rn:R01818','Pmm1, MGC105960...',true).
concept_name0('40451: rn:R01818','rno:300089 rno:302915',false).
concept_name0('40450: rn:R01819','Mpi, MGC94106',true).
concept_name0('40450: rn:R01819','rno:300741',false).
concept_name0('40461: rn:R03435','Plce1, Plce...',true).
concept_name0('40461: rn:R03435','rno:114633 rno:140693 rno:24654 rno:24655 rno:25031 rno:25738 rno:287745 rno:29322 rno:29337 rno:497197 rno:85240',false).
concept_name0('40460: rn:R04545','rno:170911 rno:366508 rno:85243',false).
concept_name0('40460: rn:R04545','Pik3ca, MGC116320...',true).
concept_name0('40463: rn:R07299','rno:116699 rno:80849',false).
concept_name0('40463: rn:R07299','Inpp4b...',true).
concept_name0('40462: rn:R00866','rno:25659',false).
concept_name0('40462: rn:R00866','Khk, KETHPRO',true).
concept_name0('40457: rn:R01787','Akr1b1, ALDRED, ALR-P-I, Akr1b3, Akr1b4, Aldr1, Alr, RATALDRED',true).
concept_name0('40457: rn:R01787','rno:24192',false).
concept_name0('40456: rn:R01185','rno:282636 rno:83523',false).
concept_name0('40456: rn:R01185','Impa2, MGC93085...',true).
concept_name0('40459: rn:R00875','Sord',true).
concept_name0('40459: rn:R00875','rno:24788',false).
concept_name0('40458: rn:R05202','Ippk, C9orf12, RGD1311271, rIpk1',true).
concept_name0('40458: rn:R05202','rno:306808',false).
concept_name0('40502: rn:R06870','rno:287644',false).
concept_name0('40502: rn:R06870','Phospho1',true).
concept_name0('40503: rn:R00299','100364027...',true).
concept_name0('40503: rn:R00299','rno:100364027 rno:25058 rno:25059 rno:25060',false).
concept_name0('40500: rn:R02053','rno:192259 rno:24653 rno:289733 rno:29354 rno:29359 rno:29387 rno:29526 rno:296091 rno:29692 rno:298579 rno:311341 rno:360426 rno:362039 rno:367415 rno:690388 rno:691907',false).
concept_name0('40500: rn:R02053','Plb1, Phlpb...',true).
concept_name0('40501: rn:R02241','Agpat4, MGC93227...',true).
concept_name0('40501: rn:R02241','rno:170919 rno:294324 rno:311821 rno:313997 rno:362702 rno:406165 rno:498741',false).
concept_name0('40498: rn:R02568','Aldoa, Aldo1, RNALDOG5...',true).
concept_name0('40498: rn:R02568','rno:24189 rno:24190 rno:24191 rno:299052',false).
concept_name0('40499: rn:R01802','Cdipt, Pis, Pis1',true).
concept_name0('40499: rn:R01802','rno:192260',false).
concept_name0('40496: rn:R01070','Aldoa, Aldo1, RNALDOG5...',true).
concept_name0('40496: rn:R01070','rno:24189 rno:24190 rno:24191 rno:299052',false).
concept_name0('40497: rn:R01015','rno:246267 rno:24849 rno:498731 rno:500959',false).
concept_name0('40497: rn:R01015','246267...',true).
concept_name0('40510: rn:R01101','Gla',true).
concept_name0('40510: rn:R01101','rno:363494',false).
concept_name0('40511: rn:R02038','rno:89841',false).
concept_name0('40511: rn:R02038','Pcyt2, ET, MGC93299',true).
concept_name0('40508: rn:R00842','rno:363159 rno:60666',false).
concept_name0('40508: rn:R00842','Gpd1l, RGD1560123...',true).
concept_name0('40509: rn:R02114','rno:24530',false).
concept_name0('40509: rn:R02114','Lcat, MGC108718',true).
concept_name0('40506: rn:R00848','rno:25062',false).
concept_name0('40506: rn:R00848','Gpd2, mtGPDH',true).
concept_name0('40507: rn:R00851','Agpat6, RGD1310520...',true).
concept_name0('40507: rn:R00851','rno:290843 rno:296130 rno:29653 rno:305166',false).
concept_name0('40504: rn:R01788','rno:25634',false).
concept_name0('40504: rn:R01788','G6pc, G6Pase, MGC93613',true).
concept_name0('40505: rn:R00299','Gck, GLUKA, RNGK2',true).
concept_name0('40505: rn:R00299','rno:24385',false).
concept_name0('40487: rn:R05916','Pigc',true).
concept_name0('40487: rn:R05916','rno:364032',false).
concept_name0('40486: rn:R05916','rno:362756',false).
concept_name0('40486: rn:R05916','Pigh',true).
concept_name0('40485: rn:R05919','rno:288041',false).
concept_name0('40485: rn:R05919','Pigx, FLJ20522, RGD1307289',true).
concept_name0('40484: rn:R05919','Pigm, GPI-MT-I',true).
concept_name0('40484: rn:R05919','rno:79112',false).
concept_name0('40483: rn:R08107','rno:681086',false).
concept_name0('40483: rn:R08107','681086',true).
concept_name0('1681: rn:R02208','R02208...',true).
concept_name0('1681: rn:R02208','rn:R02208 rp:RP02043 rc:RC00145',false).
concept_name0('40482: rn:R05917','Pigl',true).
concept_name0('40482: rn:R05917','rno:192263',false).
concept_name0('40481: rn:R05922','Pigb',true).
concept_name0('40481: rn:R05922','rno:315807',false).
concept_name0('40480: rn:R05920','rno:309051',false).
concept_name0('40480: rn:R05920','Pign',true).
concept_name0('40495: rn:R04780','rno:114508 rno:24362',false).
concept_name0('40495: rn:R04780','Fbp2, FBPase...',true).
concept_name0('40494: rn:R07376','Ptdss2',true).
concept_name0('40494: rn:R07376','rno:293620',false).
concept_name0('40493: rn:R07377','Ptdss1',true).
concept_name0('40493: rn:R07377','rno:314553',false).
concept_name0('40492: rn:R03161','Fuk',true).
concept_name0('40492: rn:R03161','rno:307848',false).
concept_name0('40491: rn:R01013','rno:84470',false).
concept_name0('40491: rn:R01013','Gnpat',true).
concept_name0('40490: rn:R01321','Cept1, MGC95031...',true).
concept_name0('40490: rn:R01321','rno:310773 rno:362866',false).
concept_name0('40489: rn:R01890','rno:140544 rno:286936',false).
concept_name0('40489: rn:R01890','Pcyt1a, CCT-alpha, CTP, MGC93248...',true).
concept_name0('40488: rn:R01318','100359680...',true).
concept_name0('40488: rn:R01318','rno:100359680 rno:296048 rno:307713 rno:361467 rno:362434',false).
concept_name0('40906: rn:R05987','Mgat4b, RGD1562836...',true).
concept_name0('40906: rn:R05987','rno:303100 rno:304646 rno:367252',false).
concept_name0('40907: rn:R03321','rno:292804',false).
concept_name0('40907: rn:R03321','Gpi, Amf, Gpi1',true).
concept_name0('40904: rn:R05982','rno:294410 rno:295319 rno:362625 rno:499751',false).
concept_name0('40904: rn:R05982','Man1a1, Aa2-166, Man1a...',true).
concept_name0('1914: rn:R01856','rn:R01856 rp:RP01802 rc:RC00017',false).
concept_name0('1914: rn:R01856','R01856...',true).
concept_name0('40905: rn:R02739','rno:292804',false).
concept_name0('40905: rn:R02739','Gpi, Amf, Gpi1',true).
concept_name0('40910: rn:R05984','Man2a1, Mana2, Manno...',true).
concept_name0('40910: rn:R05984','rno:25478 rno:308757',false).
concept_name0('40911: rn:R01786','Gck, GLUKA, RNGK2',true).
concept_name0('40911: rn:R01786','rno:24385',false).
concept_name0('1919: rn:R00087','rn:R00087 rp:RP12346 rc:RC00002',false).
concept_name0('1919: rn:R00087','R00087...',true).
concept_name0('40908: rn:R05985','Mgat2, Gnt2, MGC93297',true).
concept_name0('40908: rn:R05985','rno:94273',false).
concept_name0('40909: rn:R01600','100364027...',true).
concept_name0('40909: rn:R01600','rno:100364027 rno:25058 rno:25059 rno:25060',false).
concept_name0('40898: rn:R05974','B3gnt1, B3gnt6...',true).
concept_name0('40898: rn:R05974','rno:293667 rno:305571',false).
concept_name0('40899: rn:R06190','rno:100301568 rno:296504 rno:65270',false).
concept_name0('40899: rn:R06190','Abo2...',true).
concept_name0('40896: rn:R06189','rno:306860',false).
concept_name0('40896: rn:R06189','Gcnt2, Ignt',true).
concept_name0('40897: rn:R06076','rno:84597',false).
concept_name0('40897: rn:R06076','Fut9',true).
concept_name0('40902: rn:R06221','rno:84597',false).
concept_name0('40902: rn:R06221','Fut9',true).
concept_name0('40903: rn:R01600','Gck, GLUKA, RNGK2',true).
concept_name0('40903: rn:R01600','rno:24385',false).
concept_name0('40900: rn:R06038','rno:84597',false).
concept_name0('40900: rn:R06038','Fut9',true).
concept_name0('40901: rn:R06191','rno:100301568 rno:296504 rno:65270',false).
concept_name0('40901: rn:R06191','Abo2...',true).
concept_name0('40923: rn:R01005','rno:295051',false).
concept_name0('40923: rn:R01005','Alg5',true).
concept_name0('40922: rn:R01788','rno:25634',false).
concept_name0('40922: rn:R01788','G6pc, G6Pase, MGC93613',true).
concept_name0('40921: rn:R05970','rno:300284',false).
concept_name0('40921: rn:R05970','Alg13',true).
concept_name0('40920: rn:R05960','A4galt, Gb3',true).
concept_name0('40920: rn:R05960','rno:63888',false).
concept_name0('40927: rn:R05904','rno:84597',false).
concept_name0('40927: rn:R05904','Fut9',true).
concept_name0('40926: rn:R01018','Dolk, Tmem15',true).
concept_name0('40926: rn:R01018','rno:311847',false).
concept_name0('40925: rn:R05973','rno:313231',false).
concept_name0('40925: rn:R05973','Alg2',true).
concept_name0('40924: rn:R05963','rno:294673 rno:300757',false).
concept_name0('40924: rn:R05963','Hexb...',true).
concept_name0('40915: rn:R05964','B3galt5',true).
concept_name0('40915: rn:R05964','rno:288161',false).
concept_name0('40914: rn:R05976','rno:363160 rno:500972',false).
concept_name0('40914: rn:R05976','Stt3b, RGD1311563...',true).
concept_name0('1890: rn:R00125','rn:R00125 rp:RP03640 rc:RC00002',false).
concept_name0('1890: rn:R00125','R00125...',true).
concept_name0('40913: rn:R01786','100364027...',true).
concept_name0('40913: rn:R01786','rno:100364027 rno:25058 rno:25059 rno:25060',false).
concept_name0('40912: rn:R06128','Alg11, RGD1564725',true).
concept_name0('40912: rn:R06128','rno:361174',false).
concept_name0('40919: rn:R05972','rno:360475',false).
concept_name0('40919: rn:R05972','Alg1',true).
concept_name0('40918: rn:R05966','rno:315165',false).
concept_name0('40918: rn:R05966','Naga',true).
concept_name0('40917: rn:R05979','rno:78947',false).
concept_name0('40917: rn:R05979','Gcs1, Mogs',true).
concept_name0('40916: rn:R01602','Galm, MGC93738',true).
concept_name0('40916: rn:R01602','rno:313843',false).
concept_name0('40936: rn:R03270','rno:117098 rno:289950 rno:29554',false).
concept_name0('40936: rn:R03270','Pdha2, Pdhal...',true).
concept_name0('40937: rn:R01518','Pgam1, Pgmut...',true).
concept_name0('40937: rn:R01518','rno:24642 rno:24959 rno:296973',false).
concept_name0('40938: rn:R00658','rno:24333 rno:24334 rno:25438',false).
concept_name0('40938: rn:R00658','Eno1...',true).
concept_name0('1880: rn:R02020','rn:R02020 rp:RP01915 rc:RC00613',false).
concept_name0('1880: rn:R02020','R02020...',true).
concept_name0('40939: rn:R00200','rno:100364062 rno:24651 rno:25630',false).
concept_name0('40939: rn:R00200','100364062...',true).
concept_name0('40940: rn:R05967','rno:362924 rno:64442',false).
concept_name0('40940: rn:R05967','St3gal1, Siat4a...',true).
concept_name0('40941: rn:R04779','rno:25741 rno:60416 rno:65152',false).
concept_name0('40941: rn:R04779','Pfkl...',true).
concept_name0('40942: rn:R01015','rno:246267 rno:24849 rno:498731 rno:500959',false).
concept_name0('40942: rn:R01015','246267...',true).
concept_name0('1884: rn:R00429','rn:R00429 rp:RP00894 rc:RC00078',false).
concept_name0('1884: rn:R00429','R00429...',true).
concept_name0('40943: rn:R01061','rno:24383 rno:290604 rno:293876 rno:295423 rno:303448 rno:306115 rno:498019 rno:498099 rno:498123 rno:498881 rno:500983 rno:66020 rno:685186 rno:688783',false).
concept_name0('40943: rn:R01061','Gapdh, Gapd...',true).
concept_name0('40928: rn:R05968','rno:308586 rno:58924 rno:81919',false).
concept_name0('40928: rn:R05968','Sec1, Ftc, RGD1562499...',true).
concept_name0('40929: rn:R07618','rno:298942',false).
concept_name0('40929: rn:R07618','Dld',true).
concept_name0('40930: rn:R01009','rno:296394',false).
concept_name0('40930: rn:R01009','Dpm1',true).
concept_name0('1872: rn:R00336','R00336...',true).
concept_name0('1872: rn:R00336','rn:R00336 rp:RP05043 rc:RC00078',false).
concept_name0('40931: rn:R05961','Gla',true).
concept_name0('40931: rn:R05961','rno:363494',false).
concept_name0('40932: rn:R01512','Pgk1, MGC105265, Pgk...',true).
concept_name0('40932: rn:R01512','rno:24644 rno:316265 rno:499525',false).
concept_name0('40933: rn:R05969','rno:300668',false).
concept_name0('40933: rn:R05969','Dpagt1, H2afx',true).
concept_name0('40934: rn:R00703','rno:24533 rno:24534 rno:29634 rno:369018 rno:500965',false).
concept_name0('40934: rn:R00703','Ldha, Ldh1...',true).
concept_name0('40935: rn:R02569','rno:81654',false).
concept_name0('40935: rn:R02569','Dlat',true).
concept_name0('40953: rn:R05989','B4galt1, Ggtb2...',true).
concept_name0('40953: rn:R05989','rno:24390 rno:313536 rno:494342',false).
concept_name0('1867: rn:R00131','R00131',true).
concept_name0('1867: rn:R00131','rn:R00131',false).
concept_name0('40952: rn:R05988','Fut8',true).
concept_name0('40952: rn:R05988','rno:432392',false).
concept_name0('9512: rn:R09094','rn:R09094',false).
concept_name0('9512: rn:R09094','R09094',true).
concept_name0('1864: rn:R02425','R02425...',true).
concept_name0('1864: rn:R02425','rn:R02425 rp:RP02201 rc:RC00680',false).
concept_name0('40955: rn:R05986','rno:29582',false).
concept_name0('40955: rn:R05986','Mgat3',true).
concept_name0('40954: rn:R05992','Mgat4c, RGD1307871',true).
concept_name0('40954: rn:R05992','rno:299756',false).
concept_name0('1870: rn:R00469','R00469',true).
concept_name0('1870: rn:R00469','rn:R00469',false).
concept_name0('40957: rn:R00235','Acss1, Acas2l...',true).
concept_name0('40957: rn:R00235','rno:296259 rno:311569',false).
concept_name0('40956: rn:R05990','St6gal1, Siat1...',true).
concept_name0('40956: rn:R05990','rno:25197 rno:301155',false).
concept_name0('40959: rn:R04770','rno:24962',false).
concept_name0('40959: rn:R04770','Cth, H',true).
concept_name0('1869: rn:R01618','R01618',true).
concept_name0('1869: rn:R01618','rn:R01618',false).
concept_name0('40958: rn:R09085','rno:315722',false).
concept_name0('40958: rn:R09085','Adpgk, RGD1306103',true).
concept_name0('40945: rn:R02740','rno:292804',false).
concept_name0('40945: rn:R02740','Gpi, Amf, Gpi1',true).
concept_name0('40944: rn:R00959','Pgm1',true).
concept_name0('40944: rn:R00959','rno:24645',false).
concept_name0('40947: rn:R00431 rn:R00726','rno:361042 rno:362282',false).
concept_name0('40947: rn:R00431 rn:R00726','Pck2...',true).
concept_name0('40946: rn:R04780','rno:114508 rno:24362',false).
concept_name0('40946: rn:R04780','Fbp2, FBPase...',true).
concept_name0('1862: rn:R00776','R00776...',true).
concept_name0('1862: rn:R00776','rn:R00776 rp:RP00410 rp:RP01099 rc:RC00153 rc:RC00379',false).
concept_name0('40949: rn:R01004','rno:296624',false).
concept_name0('40949: rn:R01004','Dolpp1',true).
concept_name0('40948: rn:R05991','Mgat5b...',true).
concept_name0('40948: rn:R05991','rno:303693 rno:65271',false).
concept_name0('40951: rn:R06153','St3gal3, Siat6',true).
concept_name0('40951: rn:R06153','rno:64445',false).
concept_name0('40950: rn:R06153','rno:363040',false).
concept_name0('40950: rn:R06153','St3gal4, siat4c',true).
concept_name0('40846: rn:R02108','rno:24203 rno:497039',false).
concept_name0('40846: rn:R02108','Amy1a, Amy1...',true).
concept_name0('40847: rn:R06230','rno:84597',false).
concept_name0('40847: rn:R06230','Fut9',true).
concept_name0('40844: rn:R05196','Agl',true).
concept_name0('40844: rn:R05196','rno:362029',false).
concept_name0('40845: rn:R05974','B3gnt3',true).
concept_name0('40845: rn:R05974','rno:290638',false).
concept_name0('40842: rn:R06222','rno:84597',false).
concept_name0('40842: rn:R06222','Fut9',true).
concept_name0('40843: rn:R02111','rno:24701 rno:25739 rno:64035',false).
concept_name0('40843: rn:R02111','Pygm, Muscpho...',true).
concept_name0('40840: rn:R06221','rno:60670',false).
concept_name0('40840: rn:R06221','Fut4, Fuct',true).
concept_name0('40841: rn:R06224','rno:84597',false).
concept_name0('40841: rn:R06224','Fut9',true).
concept_name0('40838: rn:R01786','100364027...',true).
concept_name0('40838: rn:R01786','rno:100364027 rno:25058 rno:25059 rno:25060',false).
concept_name0('40839: rn:R06227','rno:84597',false).
concept_name0('40839: rn:R06227','Fut9',true).
concept_name0('40836: rn:R01786','Gck, GLUKA, RNGK2',true).
concept_name0('40836: rn:R01786','rno:24385',false).
concept_name0('40837: rn:R05977','B4galt3, MGC72586',true).
concept_name0('40837: rn:R05977','rno:494342',false).
concept_name0('40834: rn:R05975','rno:288752 rno:290638',false).
concept_name0('40834: rn:R05975','B3gnt4...',true).
concept_name0('40835: rn:R05977','rno:313536',false).
concept_name0('40835: rn:R05977','B4galt2',true).
concept_name0('40832: rn:R06039','rno:60670',false).
concept_name0('40832: rn:R06039','Fut4, Fuct',true).
concept_name0('40833: rn:R01788','rno:25634',false).
concept_name0('40833: rn:R01788','G6pc, G6Pase, MGC93613',true).
concept_name0('40863: rn:R06024','rno:308586 rno:58924 rno:81919',false).
concept_name0('40863: rn:R06024','Sec1, Ftc, RGD1562499...',true).
concept_name0('40862: rn:R06258','rno:287983',false).
concept_name0('40862: rn:R06258','Alg3',true).
concept_name0('1838: rn:R01244','R01244...',true).
concept_name0('1838: rn:R01244','rn:R01244 rp:RP01384 rc:RC00477',false).
concept_name0('40861: rn:R06027','rno:308586 rno:58924 rno:81919',false).
concept_name0('40861: rn:R06027','Sec1, Ftc, RGD1562499...',true).
concept_name0('40860: rn:R06167','rno:100301568 rno:296504 rno:65270',false).
concept_name0('40860: rn:R06167','Abo2...',true).
concept_name0('40859: rn:R01009','Dpm3, RGD1561807',true).
concept_name0('40859: rn:R01009','rno:502017',false).
concept_name0('40858: rn:R05970','rno:362031',false).
concept_name0('40858: rn:R05970','Alg14, RGD1312003',true).
concept_name0('40857: rn:R06156','rno:308586 rno:58924 rno:81919',false).
concept_name0('40857: rn:R06156','Sec1, Ftc, RGD1562499...',true).
concept_name0('40856: rn:R06006','B3galt5',true).
concept_name0('40856: rn:R06006','rno:288161',false).
concept_name0('13428: rn:R08317','R08317...',true).
concept_name0('13428: rn:R08317','rn:R08317 rp:RP13101 rc:RC00490',false).
concept_name0('40855: rn:R06006','rno:686081',false).
concept_name0('40855: rn:R06006','B3galt2',true).
concept_name0('40854: rn:R06006','rno:366064',false).
concept_name0('40854: rn:R06006','B3galt1',true).
concept_name0('40853: rn:R06168','rno:100301568 rno:296504 rno:65270',false).
concept_name0('40853: rn:R06168','Abo2...',true).
concept_name0('40852: rn:R06169','Ggta1',true).
concept_name0('40852: rn:R06169','rno:246766',false).
concept_name0('40851: rn:R06170','rno:308586 rno:58924 rno:81919',false).
concept_name0('40851: rn:R06170','Sec1, Ftc, RGD1562499...',true).
concept_name0('40850: rn:R00028','rno:24382 rno:312272 rno:367562',false).
concept_name0('40850: rn:R00028','Ganc; glucosidase, alpha...',true).
concept_name0('40849: rn:R08969','Sgms2, RGD1305778, spermatin...',true).
concept_name0('40849: rn:R08969','rno:310849 rno:353229',false).
concept_name0('40848: rn:R01790','rno:312272',false).
concept_name0('40848: rn:R01790','Mgam',true).
concept_name0('40876: rn:R06187','rno:100301568 rno:296504 rno:65270',false).
concept_name0('40876: rn:R06187','Abo2...',true).
concept_name0('9598: rn:R00024','rn:R00024 rp:RP00477 rc:RC00172',false).
concept_name0('9598: rn:R00024','R00024...',true).
concept_name0('40877: rn:R05977','B4galt1, Ggtb2',true).
concept_name0('40877: rn:R05977','rno:24390',false).
concept_name0('40878: rn:R06197','rno:100301568 rno:296504 rno:65270',false).
concept_name0('40878: rn:R06197','Abo2...',true).
concept_name0('40879: rn:R06193','rno:100301568 rno:296504 rno:65270',false).
concept_name0('40879: rn:R06193','Abo2...',true).
concept_name0('40872: rn:R05978','Ggta1',true).
concept_name0('40872: rn:R05978','rno:246766',false).
concept_name0('40873: rn:R01009','rno:29640',false).
concept_name0('40873: rn:R01009','Dpm2',true).
concept_name0('40874: rn:R06031','rno:308586 rno:58924 rno:81919',false).
concept_name0('40874: rn:R06031','Sec1, Ftc, RGD1562499...',true).
concept_name0('40875: rn:R06035','rno:308586 rno:58924 rno:81919',false).
concept_name0('40875: rn:R06035','Sec1, Ftc, RGD1562499...',true).
concept_name0('40868: rn:R06262','rno:362547',false).
concept_name0('40868: rn:R06262','Alg6, MGC124652',true).
concept_name0('40869: rn:R06033','B4galt1, Ggtb2',true).
concept_name0('40869: rn:R06033','rno:24390',false).
concept_name0('40870: rn:R05975','B3gnt1, B3gnt6...',true).
concept_name0('40870: rn:R05975','rno:293667 rno:305571',false).
concept_name0('40871: rn:R06029','rno:100301568 rno:296504 rno:65270',false).
concept_name0('40871: rn:R06029','Abo2...',true).
concept_name0('1811: rn:R02014','R02014...',true).
concept_name0('1811: rn:R02014','rn:R02014 rp:RP01910 rc:RC00613',false).
concept_name0('40864: rn:R06259','Alg9, Dibd1',true).
concept_name0('40864: rn:R06259','rno:367083',false).
concept_name0('40865: rn:R06095','rno:84597',false).
concept_name0('40865: rn:R06095','Fut9',true).
concept_name0('9585: rn:R01829','R01829...',true).
concept_name0('9585: rn:R01829','rn:R01829 rp:RP01788 rp:RP01789 rc:RC00603 rc:RC00604',false).
concept_name0('40866: rn:R06260','rno:315212',false).
concept_name0('40866: rn:R06260','Alg12',true).
concept_name0('9584: rn:R00214','rn:R00214 rp:RP00287 rc:RC00105',false).
concept_name0('9584: rn:R00214','R00214...',true).
concept_name0('40867: rn:R05971','B3gnt5...',true).
concept_name0('40867: rn:R05971','rno:116740 rno:311882',false).
concept_name0('40893: rn:R00754','rno:100145871 rno:171178 rno:24172 rno:29646 rno:310903',false).
concept_name0('40893: rn:R00754','Adh5...',true).
concept_name0('40892: rn:R06025','rno:84597',false).
concept_name0('40892: rn:R06025','Fut9',true).
concept_name0('40895: rn:R00014','rno:117098 rno:289950 rno:29554',false).
concept_name0('40895: rn:R00014','Pdha2, Pdhal...',true).
concept_name0('9581: rn:R00341','R00341',true).
concept_name0('9581: rn:R00341','rn:R00341',false).
concept_name0('40894: rn:R06032','St8sia1, Siat8, Siat8a',true).
concept_name0('40894: rn:R06032','rno:25280',false).
concept_name0('40889: rn:R06039','rno:84597',false).
concept_name0('40889: rn:R06039','Fut9',true).
concept_name0('40888: rn:R06222','rno:60670',false).
concept_name0('40888: rn:R06222','Fut4, Fuct',true).
concept_name0('40891: rn:R00746','Akr1a1, Akr1a4',true).
concept_name0('40891: rn:R00746','rno:78959',false).
concept_name0('40890: rn:R06026','St3gal6, Siat10',true).
concept_name0('40890: rn:R06026','rno:304023',false).
concept_name0('9574: rn:R00216','rn:R00216 rp:RP00287 rc:RC00105',false).
concept_name0('9574: rn:R00216','R00216...',true).
concept_name0('40885: rn:R00711','rno:25375 rno:266603 rno:309147',false).
concept_name0('40885: rn:R00711','Aldh3a1, AHDC, Ahd-c, Aldh, Aldh3...',true).
concept_name0('40884: rn:R06227','rno:60670',false).
concept_name0('40884: rn:R06227','Fut4, Fuct',true).
concept_name0('9572: rn:R00345','rn:R00345',false).
concept_name0('9572: rn:R00345','R00345',true).
concept_name0('40887: rn:R06037','St3gal6, Siat10',true).
concept_name0('40887: rn:R06037','rno:304023',false).
concept_name0('1797: rn:R01053','R01053...',true).
concept_name0('1797: rn:R01053','rn:R01053 rp:RP01259 rc:RC00431',false).
concept_name0('40886: rn:R06230','rno:60670',false).
concept_name0('40886: rn:R06230','Fut4, Fuct',true).
concept_name0('40881: rn:R06041','rno:308586 rno:58924 rno:81919',false).
concept_name0('40881: rn:R06041','Sec1, Ftc, RGD1562499...',true).
concept_name0('40880: rn:R01070','Aldoa, Aldo1, RNALDOG5...',true).
concept_name0('40880: rn:R01070','rno:24189 rno:24190 rno:24191 rno:299052',false).
concept_name0('40883: rn:R06224','rno:60670',false).
concept_name0('40883: rn:R06224','Fut4, Fuct',true).
concept_name0('40882: rn:R00710','rno:24188 rno:291450 rno:29539 rno:29651 rno:298079 rno:64040 rno:65183',false).
concept_name0('40882: rn:R00710','Aldh1a1, Ahd2, Aldh1, Aldh2...',true).
concept_name0('40771: rn:R03920','100364027...',true).
concept_name0('40771: rn:R03920','rno:100364027 rno:25058 rno:25059 rno:25060',false).
concept_name0('40770: rn:R03354','B4galt6',true).
concept_name0('40770: rn:R03354','rno:65196',false).
concept_name0('40769: rn:R00802','rno:24382 rno:312272 rno:367562',false).
concept_name0('40769: rn:R00802','Ganc; glucosidase, alpha...',true).
concept_name0('40768: rn:R00802','Si, SUCIMAL',true).
concept_name0('40768: rn:R00802','rno:497756',false).
concept_name0('40775: rn:R01383','rno:113992 rno:154516 rno:24861 rno:24862 rno:266685 rno:286954 rno:289533 rno:29623 rno:301595 rno:305264 rno:396527 rno:396551 rno:396552 rno:574523 rno:63867 rno:83808',false).
concept_name0('40775: rn:R01383','Ugt1a6, MGC124929, UDPGT_1-6, Udpgt, Ugt1, Ugt1a7...',true).
concept_name0('40774: rn:R03617','rno:314360',false).
concept_name0('40774: rn:R03617','Galc',true).
concept_name0('40773: rn:R02887','Gba3',true).
concept_name0('40773: rn:R02887','rno:289687',false).
concept_name0('40772: rn:R00026','Gba3',true).
concept_name0('40772: rn:R00026','rno:289687',false).
concept_name0('40779: rn:R01926','rno:170897 rno:308589',false).
concept_name0('40779: rn:R01926','Sphk1...',true).
concept_name0('40778: rn:R04856','Arsa, MGC125207',true).
concept_name0('40778: rn:R04856','rno:315222',false).
concept_name0('40777: rn:R00289','Ugp2',true).
concept_name0('40777: rn:R00289','rno:289827',false).
concept_name0('40776: rn:R01478','Gusb, Ac2-223, Gus-s...',true).
concept_name0('40776: rn:R01478','rno:24434 rno:83504',false).
concept_name0('40783: rn:R01660','rno:685076',false).
concept_name0('40783: rn:R01660','Pgm2l1',true).
concept_name0('40782: rn:R06516','Sgpl1, Spgl1, spl',true).
concept_name0('40782: rn:R06516','rno:286896',false).
concept_name0('40781: rn:R00286','Ugdh',true).
concept_name0('40781: rn:R00286','rno:83472',false).
concept_name0('40780: rn:R02976','rno:170897 rno:308589',false).
concept_name0('40780: rn:R02976','Sphk1...',true).
concept_name0('40786: rn:R01498','Gba, MGC188451',true).
concept_name0('40786: rn:R01498','rno:684536',false).
concept_name0('40787: rn:R01497','rno:83626',false).
concept_name0('40787: rn:R01497','Ugcg',true).
concept_name0('9603: rn:R00345','rn:R00345',false).
concept_name0('9603: rn:R00345','R00345',true).
concept_name0('40784: rn:R02464','Sgpl1, Spgl1, spl',true).
concept_name0('40784: rn:R02464','rno:286896',false).
concept_name0('40785: rn:R03355','rno:316033',false).
concept_name0('40785: rn:R03355','Glb1',true).
concept_name0('9605: rn:R00216','rn:R00216 rp:RP00287 rc:RC00105',false).
concept_name0('9605: rn:R00216','R00216...',true).
concept_name0('40790: rn:R04019','Gla',true).
concept_name0('40790: rn:R04019','rno:363494',false).
concept_name0('40791: rn:R04017','rno:683713',false).
concept_name0('40791: rn:R04017','683713',true).
concept_name0('40788: rn:R01494','Asah2...',true).
concept_name0('40788: rn:R01494','rno:114104 rno:301118 rno:313339 rno:84431',false).
concept_name0('40789: rn:R00287','rno:54410 rno:85496',false).
concept_name0('40789: rn:R00287','Enpp3, RB13-6...',true).
concept_name0('40794: rn:R05105','rno:683713',false).
concept_name0('40794: rn:R05105','683713',true).
concept_name0('5849: rn:R01200','R01200...',true).
concept_name0('5849: rn:R01200','rn:R01200 rp:RP00546 rc:RC00166',false).
concept_name0('40795: rn:R02978','Kdsr, Fvt1',true).
concept_name0('40795: rn:R02978','rno:360833',false).
concept_name0('5848: rn:R01204','rn:R01204 rp:RP00546 rc:RC00166',false).
concept_name0('5848: rn:R01204','R01204...',true).
concept_name0('40792: rn:R04018','Neu3...',true).
concept_name0('40792: rn:R04018','rno:117185 rno:24591 rno:29204 rno:316642',false).
concept_name0('40793: rn:R01500','Ugt8, Ugt8a',true).
concept_name0('40793: rn:R01500','rno:50555',false).
concept_name0('40798: rn:R08359','rno:84596',false).
concept_name0('40798: rn:R08359','Srm',true).
concept_name0('40799: rn:R02869','683008',true).
concept_name0('40799: rn:R02869','rno:683008',false).
concept_name0('40796: rn:R01281','Sptlc3, RGD1310030...',true).
concept_name0('40796: rn:R01281','rno:296188 rno:361213 rno:366697',false).
concept_name0('40797: rn:R08363','100359539...',true).
concept_name0('40797: rn:R08363','rno:100359539 rno:299976 rno:362720 rno:685579',false).
concept_name0('13442: rn:R08309','R08309...',true).
concept_name0('13442: rn:R08309','rn:R08309 rp:RP13228 rc:RC02271',false).
concept_name0('40801: rn:R06520','rno:192270 rno:246115 rno:64369',false).
concept_name0('40801: rn:R06520','Ppap2b, Dri42...',true).
concept_name0('40800: rn:R01920','rno:84596',false).
concept_name0('40800: rn:R01920','Srm',true).
concept_name0('13440: rn:R08305','R08305...',true).
concept_name0('13440: rn:R08305','rn:R08305 rp:RP13136 rc:RC00041',false).
concept_name0('40803: rn:R01495','rno:300129',false).
concept_name0('40803: rn:R01495','Cerk',true).
concept_name0('40802: rn:R06521','rno:192270 rno:246115 rno:64369',false).
concept_name0('40802: rn:R06521','Ppap2b, Dri42...',true).
concept_name0('40805: rn:R06522','rno:192270 rno:246115 rno:64369',false).
concept_name0('40805: rn:R06522','Ppap2b, Dri42...',true).
concept_name0('40804: rn:R04951','Lap3, LAP-3',true).
concept_name0('40804: rn:R04951','rno:289668',false).
concept_name0('13444: rn:R08311','R08311...',true).
concept_name0('13444: rn:R08311','rn:R08311 rp:RP13233 rc:RC02272',false).
concept_name0('40807: rn:R00899','Lap3, LAP-3',true).
concept_name0('40807: rn:R00899','rno:289668',false).
concept_name0('40806: rn:R02541','rno:303729 rno:303790 rno:308909 rno:315091 rno:83537 rno:94338',false).
concept_name0('40806: rn:R02541','Enpp7, E-NPP_7...',true).
concept_name0('40809: rn:R06518','Asah2...',true).
concept_name0('40809: rn:R06518','rno:114104 rno:84431',false).
concept_name0('9659: rn:R01196','rn:R01196',false).
concept_name0('9659: rn:R01196','R01196',true).
concept_name0('40808: rn:R06519','rno:289322 rno:314438 rno:58970',false).
concept_name0('40808: rn:R06519','RGD1564463...',true).
concept_name0('40811: rn:R06521','rno:81536',false).
concept_name0('40811: rn:R06521','Sgpp1, Spp1',true).
concept_name0('40810: rn:R06528','Asah2...',true).
concept_name0('40810: rn:R06528','rno:114104 rno:84431',false).
concept_name0('13454: rn:R08278','rn:R08278 rp:RP13144 rc:RC02240',false).
concept_name0('13454: rn:R08278','R08278...',true).
concept_name0('40813: rn:R06520','Sgpp2, RGD1565739...',true).
concept_name0('40813: rn:R06520','rno:301543 rno:81536',false).
concept_name0('40812: rn:R08364','100359539...',true).
concept_name0('40812: rn:R08364','rno:100359539 rno:299976 rno:362720 rno:685579',false).
concept_name0('40815: rn:R01718','Si, SUCIMAL',true).
concept_name0('40815: rn:R01718','rno:497756',false).
concept_name0('9661: rn:R00345','rn:R00345',false).
concept_name0('9661: rn:R00345','R00345',true).
concept_name0('40814: rn:R06522','rno:81536',false).
concept_name0('40814: rn:R06522','Sgpp1, Spp1',true).
concept_name0('5869: rn:R02087','rn:R02087 rp:RP01965 rc:RC00290',false).
concept_name0('5869: rn:R02087','R02087...',true).
concept_name0('40816: rn:R01791','rno:312272',false).
concept_name0('40816: rn:R01791','Mgam',true).
concept_name0('40817: rn:R01791','Si, SUCIMAL',true).
concept_name0('40817: rn:R01791','rno:497756',false).
concept_name0('40818: rn:R06075','rno:296564 rno:60670',false).
concept_name0('40818: rn:R06075','Fut7...',true).
concept_name0('40819: rn:R02109','Agl',true).
concept_name0('40819: rn:R02109','rno:362029',false).
concept_name0('40820: rn:R06095','rno:60670',false).
concept_name0('40820: rn:R06095','Fut4, Fuct',true).
concept_name0('40821: rn:R02740','rno:292804',false).
concept_name0('40821: rn:R02740','Gpi, Amf, Gpi1',true).
concept_name0('40822: rn:R06076','rno:60670',false).
concept_name0('40822: rn:R06076','Fut4, Fuct',true).
concept_name0('40823: rn:R06038','rno:60670',false).
concept_name0('40823: rn:R06038','Fut4, Fuct',true).
concept_name0('40824: rn:R02110','Gbe1',true).
concept_name0('40824: rn:R02110','rno:288333',false).
concept_name0('40825: rn:R00010','rno:60576',false).
concept_name0('40825: rn:R00010','Treh',true).
concept_name0('40826: rn:R06025','rno:60670',false).
concept_name0('40826: rn:R06025','Fut4, Fuct',true).
concept_name0('40827: rn:R05977','B4galt4',true).
concept_name0('40827: rn:R05977','rno:303923',false).
concept_name0('40828: rn:R00292','Gys2, GLYSN...',true).
concept_name0('40828: rn:R00292','rno:25623 rno:690987',false).
concept_name0('40829: rn:R06033','B4galt3, MGC72586',true).
concept_name0('40829: rn:R06033','rno:494342',false).
concept_name0('40830: rn:R06033','B4galt4',true).
concept_name0('40830: rn:R06033','rno:303923',false).
concept_name0('40831: rn:R00959','Pgm1',true).
concept_name0('40831: rn:R00959','rno:24645',false).
concept_name0('40711: rn:R04726','rno:50671',false).
concept_name0('40711: rn:R04726','Fasn',true).
concept_name0('40710: rn:R02058','rno:498486',false).
concept_name0('40710: rn:R02058','Gnpnat1, RGD1563144',true).
concept_name0('40709: rn:R03161','Fuk',true).
concept_name0('40709: rn:R03161','rno:307848',false).
concept_name0('40708: rn:R04566','rno:50671',false).
concept_name0('40708: rn:R04566','Fasn',true).
concept_name0('9680: rn:R09289','rn:R09289 rp:RP01630 rc:RC00087',false).
concept_name0('9680: rn:R09289','R09289...',true).
concept_name0('40707: rn:R04470','Gla',true).
concept_name0('40707: rn:R04470','rno:363494',false).
concept_name0('40706: rn:R01951','rno:310935',false).
concept_name0('40706: rn:R01951','Fpgt',true).
concept_name0('40705: rn:R00885','Gmppb, RGD1560458...',true).
concept_name0('40705: rn:R00885','rno:363145 rno:501167',false).
concept_name0('40704: rn:R02240','Dgkq...',true).
concept_name0('40704: rn:R02240','rno:100361138 rno:140866 rno:25666 rno:361076 rno:368088 rno:497978 rno:54248 rno:688705 rno:81821',false).
concept_name0('40719: rn:R01115','Cmah',true).
concept_name0('40719: rn:R01115','rno:361245',false).
concept_name0('40718: rn:R00100','Cyb5r3, Dia1, Nadhcb5, RNNADHCB5...',true).
concept_name0('40718: rn:R00100','rno:25035 rno:304805 rno:365345',false).
concept_name0('40717: rn:R01207','Renbp',true).
concept_name0('40717: rn:R01207','rno:81759',false).
concept_name0('40716: rn:R01811','Npl',true).
concept_name0('40716: rn:R01811','rno:304860',false).
concept_name0('9688: rn:R00473','rn:R00473 rp:RP00922 rp:RP00923 rc:RC00307 rc:RC00308',false).
concept_name0('9688: rn:R00473','R00473...',true).
concept_name0('40715: rn:R00022','rno:294673 rno:300757',false).
concept_name0('40715: rn:R00022','Hexb...',true).
concept_name0('40714: rn:R00888','Gmds, MGC125154',true).
concept_name0('40714: rn:R00888','rno:291095',false).
concept_name0('40713: rn:R05692','Tsta3',true).
concept_name0('40713: rn:R05692','rno:300036',false).
concept_name0('40712: rn:R04215','rno:312826',false).
concept_name0('40712: rn:R04215','Cmas, MGC105806',true).
concept_name0('40726: rn:R01961','100364027...',true).
concept_name0('40726: rn:R01961','rno:100364027 rno:25058 rno:25059 rno:25060',false).
concept_name0('40727: rn:R04404','Sec16a, Inpp5e, Pharbin...',true).
concept_name0('40727: rn:R04404','rno:114089 rno:317576 rno:362590 rno:84018 rno:85238',false).
concept_name0('40724: rn:R05800','rno:171458',false).
concept_name0('40724: rn:R05800','Ipmk, Impk, Ipk2',true).
concept_name0('40725: rn:R04954','rno:50671',false).
concept_name0('40725: rn:R04954','Fasn',true).
concept_name0('40722: rn:R01786','100364027...',true).
concept_name0('40722: rn:R01786','rno:100364027 rno:25058 rno:25059 rno:25060',false).
concept_name0('40723: rn:R05801','rno:171458',false).
concept_name0('40723: rn:R05801','Ipmk, Impk, Ipk2',true).
concept_name0('40720: rn:R01803','Cmah',true).
concept_name0('40720: rn:R01803','rno:361245',false).
concept_name0('9666: rn:R09280','rn:R09280 rp:RP14558 rc:RC00184',false).
concept_name0('9666: rn:R09280','R09280...',true).
concept_name0('40721: rn:R00959','Pgm1',true).
concept_name0('40721: rn:R00959','rno:24645',false).
concept_name0('40734: rn:R04430','rno:50671',false).
concept_name0('40734: rn:R04430','Fasn',true).
concept_name0('40735: rn:R04428','rno:50671',false).
concept_name0('40735: rn:R04428','Fasn',true).
concept_name0('9679: rn:R00740','rn:R00740 rp:RP01076 rc:RC00184',false).
concept_name0('9679: rn:R00740','R00740...',true).
concept_name0('40732: rn:R04956','rno:50671',false).
concept_name0('40732: rn:R04956','Fasn',true).
concept_name0('40733: rn:R03429','Itpk1',true).
concept_name0('40733: rn:R03429','rno:500709',false).
concept_name0('9673: rn:R00267','rn:R00267 rp:RP00305 rc:RC00114',false).
concept_name0('9673: rn:R00267','R00267...',true).
concept_name0('40730: rn:R01786','Gck, GLUKA, RNGK2',true).
concept_name0('40730: rn:R01786','rno:24385',false).
concept_name0('9672: rn:R01197','rn:R01197',false).
concept_name0('9672: rn:R01197','R01197',true).
concept_name0('40731: rn:R05803','Pip4k2a, Pip5k2a...',true).
concept_name0('40731: rn:R05803','rno:116723 rno:140607 rno:89812',false).
concept_name0('40728: rn:R04953','rno:50671',false).
concept_name0('40728: rn:R04953','Fasn',true).
concept_name0('40729: rn:R01786','Gck, GLUKA, RNGK2',true).
concept_name0('40729: rn:R01786','rno:24385',false).
concept_name0('40741: rn:R04513','rno:50557',false).
concept_name0('40741: rn:R04513','Pten, MMAC1, Mmac, TEP1',true).
concept_name0('40740: rn:R03434','rno:29688',false).
concept_name0('40740: rn:R03434','Minpp1',true).
concept_name0('40743: rn:R03920','100364027...',true).
concept_name0('40743: rn:R03920','rno:100364027 rno:25058 rno:25059 rno:25060',false).
concept_name0('40742: rn:R04355','rno:50671',false).
concept_name0('40742: rn:R04355','Fasn',true).
concept_name0('40737: rn:R03433','rno:54260 rno:81677',false).
concept_name0('40737: rn:R03433','Itpkb...',true).
concept_name0('9715: rn:R09317','rn:R09317',false).
concept_name0('9715: rn:R09317','R09317',true).
concept_name0('40736: rn:R03428','Itpk1',true).
concept_name0('40736: rn:R03428','rno:500709',false).
concept_name0('40739: rn:R03430','rno:171088 rno:287533 rno:365382 rno:65038',false).
concept_name0('40739: rn:R03430','Inpp5j, Inpp, Pib5pa, Pipp...',true).
concept_name0('1937: rn:R00126','rn:R00126',false).
concept_name0('1937: rn:R00126','R00126',true).
concept_name0('40738: rn:R04952','rno:50671',false).
concept_name0('40738: rn:R04952','Fasn',true).
concept_name0('40749: rn:R03427','rno:316376',false).
concept_name0('40749: rn:R03427','Inpp1',true).
concept_name0('40748: rn:R03394','rno:171088 rno:287533 rno:365382 rno:65038',false).
concept_name0('40748: rn:R03394','Inpp5j, Inpp, Pib5pa, Pipp...',true).
concept_name0('40751: rn:R02740','rno:292804',false).
concept_name0('40751: rn:R02740','Gpi, Amf, Gpi1',true).
concept_name0('40750: rn:R04533','rno:50671',false).
concept_name0('40750: rn:R04533','Fasn',true).
concept_name0('40745: rn:R03393','rno:316376',false).
concept_name0('40745: rn:R03393','Inpp1',true).
concept_name0('1947: rn:R00322','R00322...',true).
concept_name0('1947: rn:R00322','rn:R00322 rp:RP04359 rc:RC00070',false).
concept_name0('40744: rn:R01626','Mcat, RGD1306698',true).
concept_name0('40744: rn:R01626','rno:315173',false).
concept_name0('40747: rn:R01626','rno:50671',false).
concept_name0('40747: rn:R01626','Fasn',true).
concept_name0('40746: rn:R04372','rno:116699 rno:80849',false).
concept_name0('40746: rn:R04372','Inpp4b...',true).
concept_name0('9703: rn:R00230','rn:R00230',false).
concept_name0('9703: rn:R00230','R00230',true).
concept_name0('40756: rn:R03362','Pik3c3',true).
concept_name0('40756: rn:R03362','rno:65052',false).
concept_name0('40757: rn:R03361','rno:114554 rno:305419 rno:64161 rno:81747',false).
concept_name0('40757: rn:R03361','Pi4k2a, Pi4KII...',true).
concept_name0('40758: rn:R01187','rno:282636 rno:83523',false).
concept_name0('40758: rn:R01187','Impa2, MGC93085...',true).
concept_name0('40759: rn:R01206','rno:113901 rno:289032 rno:89824',false).
concept_name0('40759: rn:R01206','Chia, MGC112572...',true).
concept_name0('9699: rn:R00943','rn:R00943 rp:RP00072 rp:RP00300 rc:RC00026 rc:RC00111',false).
concept_name0('9699: rn:R00943','R00943...',true).
concept_name0('1923: rn:R01885','R01885',true).
concept_name0('1923: rn:R01885','rn:R01885',false).
concept_name0('40752: rn:R03479','Itpk1',true).
concept_name0('40752: rn:R03479','rno:500709',false).
concept_name0('9698: rn:R00134','rn:R00134',false).
concept_name0('9698: rn:R00134','R00134',true).
concept_name0('40753: rn:R01326','100364027...',true).
concept_name0('40753: rn:R01326','rno:100364027 rno:25058 rno:25059 rno:25060',false).
concept_name0('40754: rn:R03469','rno:309419 rno:314641 rno:365865 rno:687758',false).
concept_name0('40754: rn:R03469','Pip5k1b, MGC105713, Pip5k1a...',true).
concept_name0('40755: rn:R04386','Acacb, Acc2...',true).
concept_name0('40755: rn:R04386','rno:116719 rno:60581',false).
concept_name0('40764: rn:R01186','rno:282636 rno:83523',false).
concept_name0('40764: rn:R01186','Impa2, MGC93085...',true).
concept_name0('40765: rn:R04385','Acacb, Acc2...',true).
concept_name0('40765: rn:R04385','rno:116719 rno:60581',false).
concept_name0('40766: rn:R01384','Uxs1, MGC93157, UGD',true).
concept_name0('40766: rn:R01384','rno:246232',false).
concept_name0('40767: rn:R03527','Gba3',true).
concept_name0('40767: rn:R03527','rno:289687',false).
concept_name0('40760: rn:R01184','Miox, Aldrl6, RSOR',true).
concept_name0('40760: rn:R01184','rno:252899',false).
concept_name0('40761: rn:R00289','Ugp2',true).
concept_name0('40761: rn:R00289','rno:289827',false).
concept_name0('9705: rn:R00237','rn:R00237 rp:RP04364 rp:RP04393 rc:RC01205 rc:RC00502',false).
concept_name0('9705: rn:R00237','R00237...',true).
concept_name0('40762: rn:R07324','rno:290651',false).
concept_name0('40762: rn:R07324','Isyna1',true).
concept_name0('40763: rn:R01624','rno:50671',false).
concept_name0('40763: rn:R01624','Fasn',true).
concept_name0('2201: rn:R02022','rn:R02022 rp:RP01916 rc:RC00613',false).
concept_name0('2201: rn:R02022','R02022...',true).
concept_name0('2205: rn:R02325','R02325...',true).
concept_name0('2205: rn:R02325','rn:R02325 rp:RP02125 rc:RC00074',false).
concept_name0('6539: rn:R05146','R05146...',true).
concept_name0('6539: rn:R05146','rn:R05146 rp:RP03636 rp:RP11624 rc:RC00039 rc:RC00037',false).
concept_name0('6540: rn:R05075','R05075...',true).
concept_name0('6540: rn:R05075','rn:R05075 rp:RP04579 rp:RP11625 rc:RC00039 rc:RC00037',false).
concept_name0('2209: rn:R01668','R01668...',true).
concept_name0('2209: rn:R01668','rn:R01668 rp:RP01678 rc:RC00002',false).
concept_name0('6639: rn:R01048','R01048...',true).
concept_name0('6639: rn:R01048','rn:R01048 rp:RP01254 rc:RC00430',false).
concept_name0('6633: rn:R01034','rn:R01034 rp:RP00157 rc:RC00029',false).
concept_name0('6633: rn:R01034','R01034...',true).
concept_name0('6634: rn:R01039','rn:R01039 rp:RP00157 rc:RC00029',false).
concept_name0('6634: rn:R01039','R01039...',true).
concept_name0('2255: rn:R00515','R00515...',true).
concept_name0('2255: rn:R00515','rn:R00515 rp:RP00950 rc:RC00002',false).
concept_name0('6651: rn:R04471','R04471...',true).
concept_name0('6651: rn:R04471','rn:R04471 rp:RP04110 rc:RC00495',false).
concept_name0('2250: rn:R00287','R00287...',true).
concept_name0('2250: rn:R00287','rn:R00287 rp:RP00315 rc:RC00002',false).
concept_name0('6620: rn:R02691','R02691...',true).
concept_name0('6620: rn:R02691','rn:R02691 rp:RP02415 rc:RC00059',false).
concept_name0('6442: rn:R07817','rn:R07817',false).
concept_name0('6442: rn:R07817','R07817',true).
concept_name0('2050: rn:R00150','R00150',true).
concept_name0('2050: rn:R00150','rn:R00150',false).
concept_name0('2100: rn:R07969 rn:R07970','rn:R07969 rn:R07970 rp:RP11122 rp:RP11122 rc:RC00334 rc:RC00334',false).
concept_name0('2100: rn:R07969 rn:R07970','R07969...',true).
concept_name0('2111: rn:R07919','R07919...',true).
concept_name0('2111: rn:R07919','rn:R07919 rp:RP11717 rc:RC00334',false).
concept_name0('2110: rn:R07955 rn:R07956','R07955...',true).
concept_name0('2110: rn:R07955 rn:R07956','rn:R07955 rn:R07956 rp:RP11716 rp:RP11716 rc:RC00334 rc:RC00334',false).
concept_name0('2109: rn:R07980','R07980...',true).
concept_name0('2109: rn:R07980','rn:R07980 rp:RP11721 rc:RC02017',false).
concept_name0('2108: rn:R07961 rn:R07962','R07961...',true).
concept_name0('2108: rn:R07961 rn:R07962','rn:R07961 rn:R07962 rp:RP11717 rp:RP11717 rc:RC00334 rc:RC00334',false).
concept_name0('6419: rn:R07815','rn:R07815',false).
concept_name0('6419: rn:R07815','R07815',true).
concept_name0('6423: rn:R07817','rn:R07817',false).
concept_name0('6423: rn:R07817','R07817',true).
concept_name0('2142: rn:R07982','R07982...',true).
concept_name0('2142: rn:R07982','rn:R07982 rp:RP10831 rp:RP12178 rp:RP12179 rc:RC01791 rc:RC02108 rc:RC02109',false).
concept_name0('2139: rn:R07922','rn:R07922 rp:RP11917 rc:RC00334',false).
concept_name0('2139: rn:R07922','R07922...',true).
concept_name0('2119: rn:R07965 rn:R07966','rn:R07965 rn:R07966 rp:RP11120 rp:RP11120 rc:RC01827 rc:RC01827',false).
concept_name0('2119: rn:R07965 rn:R07966','R07965...',true).
concept_name0('2112: rn:R07920','rn:R07920 rp:RP11716 rc:RC00334',false).
concept_name0('2112: rn:R07920','R07920...',true).
concept_name0('2115: rn:R07919','R07919...',true).
concept_name0('2115: rn:R07919','rn:R07919 rp:RP11717 rc:RC00334',false).
concept_name0('2120: rn:R07957 rn:R07958','rn:R07957 rn:R07958 rp:RP11917 rp:RP11917 rc:RC00334 rc:RC00334',false).
concept_name0('2120: rn:R07957 rn:R07958','R07957...',true).
concept_name0('2148: rn:R07307','rn:R07307 rp:RP11109 rc:RC01825',false).
concept_name0('2148: rn:R07307','R07307...',true).
concept_name0('41568: rn:R01710','rno:64533',false).
concept_name0('41568: rn:R01710','Pnpo, MGC93433',true).
concept_name0('41569: rn:R00277','rno:64533',false).
concept_name0('41569: rn:R00277','Pnpo, MGC93433',true).
concept_name0('41570: rn:R02494','Phospho2, MGC93920...',true).
concept_name0('41570: rn:R02494','rno:295663 rno:727679',false).
concept_name0('41571: rn:R02493','rno:361819 rno:83578',false).
concept_name0('41571: rn:R02493','RGD1566085...',true).
concept_name0('41546: rn:R00135','Lap3, LAP-3',true).
concept_name0('41546: rn:R00135','rno:289668',false).
concept_name0('41547: rn:R00669','Acy1, Acy1a, Acy1b',true).
concept_name0('41547: rn:R00669','rno:300981',false).
concept_name0('41544: rn:R08408','Aox3l1, Aox2...',true).
concept_name0('41544: rn:R08408','rno:316421 rno:54349',false).
concept_name0('41545: rn:R04085','Aox3l1, Aox2...',true).
concept_name0('41545: rn:R04085','rno:316421 rno:54349',false).
concept_name0('41550: rn:R01086','rno:59085',false).
concept_name0('41550: rn:R01086','Asl',true).
concept_name0('41551: rn:R00278','rno:64533',false).
concept_name0('41551: rn:R00278','Pnpo, MGC93433',true).
concept_name0('41548: rn:R01711','rno:64533',false).
concept_name0('41548: rn:R01711','Pnpo, MGC93433',true).
concept_name0('41549: rn:R00551','rno:29215 rno:29221',false).
concept_name0('41549: rn:R00551','Arg2...',true).
concept_name0('41538: rn:R01269','Nnmt',true).
concept_name0('41538: rn:R01269','rno:300691',false).
concept_name0('41539: rn:R01253','rno:680409',false).
concept_name0('41539: rn:R01253','Prodh',true).
concept_name0('41536: rn:R00102','rno:25668 rno:81506',false).
concept_name0('41536: rn:R00102','Cd38...',true).
concept_name0('41537: rn:R01248 rn:R01251','rno:287877 rno:300035 rno:364064',false).
concept_name0('41537: rn:R01248 rn:R01251','Pycr1...',true).
concept_name0('41542: rn:R00112','Nnt, MGC109126',true).
concept_name0('41542: rn:R00112','rno:310378',false).
concept_name0('41543: rn:R01252','P4ha2...',true).
concept_name0('41543: rn:R01252','rno:360526 rno:361612 rno:64475',false).
concept_name0('41540: rn:R00104','rno:100125370',false).
concept_name0('41540: rn:R00104','Nadk, MGC109551',true).
concept_name0('41541: rn:R00667','Oat, rOAT',true).
concept_name0('41541: rn:R00667','rno:64313',false).
concept_name0('41563: rn:R03004','rno:54410 rno:85496',false).
concept_name0('41563: rn:R03004','Enpp3, RB13-6...',true).
concept_name0('41562: rn:R00253','Glul, Glns',true).
concept_name0('41562: rn:R00253','rno:24957',false).
concept_name0('41561: rn:R01911','Phospho2, MGC93920...',true).
concept_name0('41561: rn:R01911','rno:295663 rno:727679',false).
concept_name0('41560: rn:R01909','rno:361819 rno:83578',false).
concept_name0('41560: rn:R01909','RGD1566085...',true).
concept_name0('41567: rn:R00119','rno:25668 rno:81506',false).
concept_name0('41567: rn:R00119','Cd38...',true).
concept_name0('41566: rn:R03004','Nudt12',true).
concept_name0('41566: rn:R03004','rno:367323',false).
concept_name0('41565: rn:R03348','rno:293504',false).
concept_name0('41565: rn:R03348','Qprt, MGC108807',true).
concept_name0('41564: rn:R03346','100363253...',true).
concept_name0('41564: rn:R03346','rno:100363253 rno:287368 rno:298881 rno:312373 rno:313574 rno:58813 rno:688261',false).
concept_name0('41555: rn:R00149','Cps1',true).
concept_name0('41555: rn:R00149','rno:497840',false).
concept_name0('41554: rn:R05085','Psat1, Psa1',true).
concept_name0('41554: rn:R05085','rno:293820',false).
concept_name0('41553: rn:R01398','rno:25611',false).
concept_name0('41553: rn:R01398','Otc, MGC108742',true).
concept_name0('41552: rn:R00259','Nags, RGD1565783',true).
concept_name0('41552: rn:R00259','rno:303563',false).
concept_name0('41559: rn:R00173','Phospho2, MGC93920...',true).
concept_name0('41559: rn:R00173','rno:295663 rno:727679',false).
concept_name0('41558: rn:R00256','Gls2, Ga...',true).
concept_name0('41558: rn:R00256','rno:192268 rno:24398',false).
concept_name0('41557: rn:R00174','rno:361819 rno:83578',false).
concept_name0('41557: rn:R00174','RGD1566085...',true).
concept_name0('41556: rn:R01954','Ass1, ASSA, Ass',true).
concept_name0('41556: rn:R01954','rno:25698',false).
concept_name0('41516: rn:R00137','Nmnat2...',true).
concept_name0('41516: rn:R00137','rno:289095 rno:298653',false).
concept_name0('41517: rn:R00111','Nos1, bNOS...',true).
concept_name0('41517: rn:R00111','rno:24598 rno:24599 rno:24600',false).
concept_name0('41518: rn:R02323','100363253...',true).
concept_name0('41518: rn:R02323','rno:100363253 rno:287368 rno:298881 rno:312373 rno:313574 rno:58813 rno:688261',false).
concept_name0('41519: rn:R01271','rno:297508',false).
concept_name0('41519: rn:R01271','Nampt, Pbef, Pbef1',true).
concept_name0('41512: rn:R00103','Nudt12',true).
concept_name0('41512: rn:R00103','rno:367323',false).
concept_name0('41513: rn:R01883','rno:25257',false).
concept_name0('41513: rn:R01883','Gamt, GMT',true).
concept_name0('41514: rn:R00137','Nmnat2...',true).
concept_name0('41514: rn:R00137','rno:289095 rno:298653',false).
concept_name0('41515: rn:R00565','Gatm, MGC93388',true).
concept_name0('41515: rn:R00565','rno:81660',false).
concept_name0('41508: rn:R01989','Gatm, MGC93388',true).
concept_name0('41508: rn:R01989','rno:81660',false).
concept_name0('2503: rn:R01388','R01388...',true).
concept_name0('2503: rn:R01388','rn:R01388 rp:RP00299 rc:RC00031',false).
concept_name0('41509: rn:R00566','rno:366473',false).
concept_name0('41509: rn:R00566','RGD1564776',true).
concept_name0('41510: rn:R01157','Agmat',true).
concept_name0('41510: rn:R01157','rno:298607',false).
concept_name0('41511: rn:R00103','rno:54410 rno:85496',false).
concept_name0('41511: rn:R00103','Enpp3, RB13-6...',true).
concept_name0('41504: rn:R00239','rno:361755',false).
concept_name0('41504: rn:R00239','Aldh18a1, Pycs',true).
concept_name0('41505: rn:R00245','Aldh4a1',true).
concept_name0('41505: rn:R00245','rno:641316',false).
concept_name0('41506: rn:R03313','rno:361755',false).
concept_name0('41506: rn:R03313','Aldh18a1, Pycs',true).
concept_name0('41507: rn:R00670','Odc1, Odc',true).
concept_name0('41507: rn:R00670','rno:24609',false).
concept_name0('41533: rn:R05051','rno:680409',false).
concept_name0('41533: rn:R05051','Prodh',true).
concept_name0('41532: rn:R05051','Aldh4a1',true).
concept_name0('41532: rn:R05051','rno:641316',false).
concept_name0('41535: rn:R04444 rn:R04445','Aldh4a1',true).
concept_name0('41535: rn:R04444 rn:R04445','rno:641316',false).
concept_name0('41534: rn:R03291 rn:R03293','rno:287877 rno:300035 rno:364064',false).
concept_name0('41534: rn:R03291 rn:R03293','Pycr1...',true).
concept_name0('41529: rn:R01724','Naprt1',true).
concept_name0('41529: rn:R01724','rno:315085',false).
concept_name0('41528: rn:R00257','rno:353255',false).
concept_name0('41528: rn:R00257','Nadsyn1',true).
concept_name0('41531: rn:R02894','Dao, Dao1',true).
concept_name0('41531: rn:R02894','rno:114027',false).
concept_name0('41530: rn:R03295','rno:361538',false).
concept_name0('41530: rn:R03295','Prodh2',true).
concept_name0('41525: rn:R03005','Nmnat2...',true).
concept_name0('41525: rn:R03005','rno:289095 rno:298653',false).
concept_name0('41524: rn:R03005','Nmnat2...',true).
concept_name0('41524: rn:R03005','rno:289095 rno:298653',false).
concept_name0('41527: rn:R00558','Nos1, bNOS...',true).
concept_name0('41527: rn:R00558','rno:24598 rno:24599 rno:24600',false).
concept_name0('2516: rn:R00996','rn:R00996 rp:RP01226 rc:RC00418',false).
concept_name0('2516: rn:R00996','R00996...',true).
concept_name0('41526: rn:R05052','rno:24401 rno:25721',false).
concept_name0('41526: rn:R05052','Got1, Aspat, Gaspat...',true).
concept_name0('41521: rn:R01881','rno:24264 rno:24265 rno:29593 rno:688698',false).
concept_name0('41521: rn:R01881','Ckb, Ckbb, Ckbr, RATCKBR...',true).
concept_name0('41520: rn:R02294','rno:290029',false).
concept_name0('41520: rn:R02294','Np, Pnp',true).
concept_name0('41523: rn:R03347','rno:499330',false).
concept_name0('41523: rn:R03347','Nrk1',true).
concept_name0('41522: rn:R02295','rno:290029',false).
concept_name0('41522: rn:R02295','Np, Pnp',true).
concept_name0('41486: rn:R02313','rno:296925',false).
concept_name0('41486: rn:R02313','Aass',true).
concept_name0('41487: rn:R01940','Ogdhl...',true).
concept_name0('41487: rn:R01940','rno:290566 rno:360975',false).
concept_name0('2540: rn:R01388 rn:R01392','R01388...',true).
concept_name0('2540: rn:R01388 rn:R01392','rn:R01388 rn:R01392 rp:RP00299 rp:RP00299 rc:RC00031 rc:RC00031',false).
concept_name0('41484: rn:R03875','100361710...',true).
concept_name0('41484: rn:R03875','rno:100361710 rno:100362634 rno:100364718 rno:288346 rno:290831 rno:302553 rno:306764 rno:308345 rno:310638 rno:311968 rno:316013 rno:317568 rno:361543 rno:361688 rno:361798 rno:362078 rno:362831 rno:362996 rno:364785 rno:498178 rno:500281 rno:680537 rno:689820 rno:689883 rno:689954',false).
concept_name0('41485: rn:R03102 rn:R03103','Aldh7a1, antiquitin',true).
concept_name0('41485: rn:R03102 rn:R03103','rno:291450',false).
concept_name0('6366: rn:R08905','rn:R08905 rp:RP14243 rp:RP14244 rc:RC00039 rc:RC00014',false).
concept_name0('6366: rn:R08905','R08905...',true).
concept_name0('41482: rn:R03380','rno:288583 rno:289081 rno:290637',false).
concept_name0('41482: rn:R03380','Plod3, MGC93055...',true).
concept_name0('2537: rn:R00221','rn:R00221 rp:RP04299 rc:RC01189',false).
concept_name0('2537: rn:R00221','R00221...',true).
concept_name0('41483: rn:R00619','rno:680668',false).
concept_name0('41483: rn:R00619','Tpk1, MGC188595',true).
concept_name0('41480: rn:R04313','MGC109340, Spcs3',true).
concept_name0('41480: rn:R04313','rno:317409',false).
concept_name0('41481: rn:R03451','rno:170898',false).
concept_name0('41481: rn:R03451','Tmlhe, MGC94841, Tmlh',true).
concept_name0('41478: rn:R03026','Echs1...',true).
concept_name0('41478: rn:R03026','rno:140547 rno:170670 rno:171142',false).
concept_name0('41479: rn:R04867','100361710...',true).
concept_name0('41479: rn:R04867','rno:100361710 rno:100362634 rno:100364718 rno:288346 rno:290831 rno:302553 rno:306764 rno:308345 rno:310638 rno:311968 rno:316013 rno:317568 rno:361543 rno:361688 rno:361798 rno:362078 rno:362831 rno:362996 rno:364785 rno:498178 rno:500281 rno:680537 rno:689820 rno:689883 rno:689954',false).
concept_name0('41476: rn:R03376','rno:116552 rno:288583 rno:300901',false).
concept_name0('41476: rn:R03376','Plod1, Plod...',true).
concept_name0('41477: rn:R04866','100361710...',true).
concept_name0('41477: rn:R04866','rno:100361710 rno:100362634 rno:100364718 rno:288346 rno:290831 rno:302553 rno:306764 rno:308345 rno:310638 rno:311968 rno:316013 rno:317568 rno:361543 rno:361688 rno:361798 rno:362078 rno:362831 rno:362996 rno:364785 rno:498178 rno:500281 rno:680537 rno:689820 rno:689883 rno:689954',false).
concept_name0('41474: rn:R00616','rno:680668',false).
concept_name0('41474: rn:R00616','Tpk1, MGC188595',true).
concept_name0('41475: rn:R02571','rno:299201',false).
concept_name0('41475: rn:R02571','Dlst, MGC95077',true).
concept_name0('41472: rn:R00618','Thtpa, MGC94155',true).
concept_name0('41472: rn:R00618','rno:305889',false).
concept_name0('41473: rn:R02204','Pipox',true).
concept_name0('41473: rn:R02204','rno:303272',false).
concept_name0('41503: rn:R01920','rno:84596',false).
concept_name0('41503: rn:R01920','Srm',true).
concept_name0('41502: rn:R00178','rno:81640',false).
concept_name0('41502: rn:R00178','Amd1, Amd1a, Amd1b',true).
concept_name0('41501: rn:R01986 rn:R02549','rno:24188 rno:291450 rno:29539 rno:29651 rno:298079 rno:64040 rno:65183',false).
concept_name0('41501: rn:R01986 rn:R02549','Aldh1a1, Ahd2, Aldh1, Aldh2...',true).
concept_name0('41500: rn:R01151','rno:65029',false).
concept_name0('41500: rn:R01151','Abp1, Abp',true).
concept_name0('41499: rn:R00716','rno:296925',false).
concept_name0('41499: rn:R00716','Aass',true).
concept_name0('41498: rn:R00937 rn:R00940','rno:24312',false).
concept_name0('41498: rn:R00937 rn:R00940','Dhfr, Dhfr1',true).
concept_name0('41497: rn:R03283','Aldh9a1, Tmaba-dh',true).
concept_name0('41497: rn:R03283','rno:64040',false).
concept_name0('41496: rn:R02397','rno:64564',false).
concept_name0('41496: rn:R02397','Bbox1, Bbh, Bbox',true).
concept_name0('41495: rn:R00946','Mtr, methioninesynthase',true).
concept_name0('41495: rn:R00946','rno:81522',false).
concept_name0('41494: rn:R02101','Tyms, MGC156654',true).
concept_name0('41494: rn:R02101','rno:29261',false).
concept_name0('41493: rn:R04560','rno:81643',false).
concept_name0('41493: rn:R04560','Atic',true).
concept_name0('41492: rn:R04125','Amt',true).
concept_name0('41492: rn:R04125','rno:306586',false).
concept_name0('41491: rn:R00945','rno:287379 rno:299857',false).
concept_name0('41491: rn:R00945','Shmt1, LRRGT00032, Shmt, mShmt...',true).
concept_name0('41490: rn:R01975','Hadh, Hadhsc...',true).
concept_name0('41490: rn:R01975','rno:113965 rno:171142',false).
concept_name0('41489: rn:R07460','Nfs1, MGC124952, Nifs',true).
concept_name0('41489: rn:R07460','rno:84594',false).
concept_name0('41488: rn:R01939','Aadat, Kat2',true).
concept_name0('41488: rn:R01939','rno:29416',false).
concept_name0('2345: rn:R01346','rn:R01346 rp:RP00683 rc:RC00006',false).
concept_name0('2345: rn:R01346','R01346...',true).
concept_name0('2346: rn:R00397','R00397...',true).
concept_name0('2346: rn:R00397','rn:R00397 rp:RP00875 rc:RC00282',false).
concept_name0('2349: rn:R00491','rn:R00491 rp:RP00938 rc:RC00302',false).
concept_name0('2349: rn:R00491','R00491...',true).
concept_name0('2361: rn:R00490','R00490...',true).
concept_name0('2361: rn:R00490','rn:R00490 rp:RP00937 rc:RC00316',false).
concept_name0('2388: rn:R00093','R00093...',true).
concept_name0('2388: rn:R00093','rn:R00093 rp:RP00014 rp:RP00024 rc:RC00006 rc:RC00010',false).
concept_name0('2404: rn:R00576','R00576...',true).
concept_name0('2404: rn:R00576','rn:R00576 rp:RP00133 rc:RC00006',false).
concept_name0('41309: rn:R00238','rno:25014 rno:308100',false).
concept_name0('41309: rn:R00238','Acat1, RATACAL...',true).
concept_name0('41308: rn:R00710 rn:R00711','rno:24188 rno:291450 rno:29539 rno:29651 rno:298079 rno:64040 rno:65183',false).
concept_name0('41308: rn:R00710 rn:R00711','Aldh1a1, Ahd2, Aldh1, Aldh2...',true).
concept_name0('41311: rn:R00014','rno:117098 rno:289950 rno:29554',false).
concept_name0('41311: rn:R00014','Pdha2, Pdhal...',true).
concept_name0('41310: rn:R01795','Pah',true).
concept_name0('41310: rn:R01795','rno:24616',false).
concept_name0('41305: rn:R02678','rno:24188 rno:291450 rno:29539 rno:29651 rno:298079 rno:64040 rno:65183',false).
concept_name0('41305: rn:R02678','Aldh1a1, Ahd2, Aldh1, Aldh2...',true).
concept_name0('41304: rn:R02908','rno:25750 rno:29253',false).
concept_name0('41304: rn:R02908','Maob...',true).
concept_name0('41307: rn:R00316','Acss1, Acas2l...',true).
concept_name0('41307: rn:R00316','rno:296259 rno:311569',false).
concept_name0('41306: rn:R00742','Acacb, Acc2...',true).
concept_name0('41306: rn:R00742','rno:116719 rno:60581',false).
concept_name0('41301: rn:R02173','rno:25750 rno:29253',false).
concept_name0('41301: rn:R02173','Maob...',true).
concept_name0('41300: rn:R04904','Aox3l1, Aox2...',true).
concept_name0('41300: rn:R04904','rno:316421 rno:54349',false).
concept_name0('41303: rn:R04903','rno:24188 rno:291450 rno:29539 rno:29651 rno:298079 rno:64040 rno:65183',false).
concept_name0('41303: rn:R04903','Aldh1a1, Ahd2, Aldh1, Aldh2...',true).
concept_name0('41302: rn:R04911','Afmid',true).
concept_name0('41302: rn:R04911','rno:688283',false).
concept_name0('41297: rn:R02174','rno:368066',false).
concept_name0('41297: rn:R02174','Inmt',true).
concept_name0('41296: rn:R01514','Glyctk',true).
concept_name0('41296: rn:R01514','rno:684314',false).
concept_name0('41299: rn:R02173','rno:65029',false).
concept_name0('41299: rn:R02173','Abp1, Abp',true).
concept_name0('41298: rn:R02910','rno:368066',false).
concept_name0('41298: rn:R02910','Inmt',true).
concept_name0('41292: rn:R04905','Asmt',true).
concept_name0('41292: rn:R04905','rno:246281',false).
concept_name0('41293: rn:R03130','Asmt',true).
concept_name0('41293: rn:R03130','rno:246281',false).
concept_name0('41294: rn:R02911','rno:25120',false).
concept_name0('41294: rn:R02911','Aanat, AA-NAT, Nat4',true).
concept_name0('41295: rn:R01334','rno:287115',false).
concept_name0('41295: rn:R01334','Pgp, RGD1307773',true).
concept_name0('41288: rn:R02702','rno:66029 rno:681319 rno:684861',false).
concept_name0('41288: rn:R02702','Ido1, Ido, Indo...',true).
concept_name0('41289: rn:R04908','rno:25750 rno:29253',false).
concept_name0('41289: rn:R04908','Maob...',true).
concept_name0('41290: rn:R04909','rno:24311',false).
concept_name0('41290: rn:R04909','Ddc, MGC93628',true).
concept_name0('41291: rn:R02909','rno:66029 rno:681319 rno:684861',false).
concept_name0('41291: rn:R02909','Ido1, Ido, Indo...',true).
concept_name0('41284: rn:R00342','Mdh1, MDL1, Mdhl, Mor2...',true).
concept_name0('41284: rn:R00342','rno:24551 rno:81829',false).
concept_name0('41285: rn:R01959','Afmid',true).
concept_name0('41285: rn:R01959','rno:688283',false).
concept_name0('41286: rn:R00238','rno:25014 rno:308100',false).
concept_name0('41286: rn:R00238','Acat1, RATACAL...',true).
concept_name0('41287: rn:R02701','rno:24311',false).
concept_name0('41287: rn:R02701','Ddc, MGC93628',true).
concept_name0('41280: rn:R04323','Acmsd',true).
concept_name0('41280: rn:R04323','rno:171385',false).
concept_name0('41281: rn:R01933','Ogdhl...',true).
concept_name0('41281: rn:R01933','rno:290566 rno:360975',false).
concept_name0('41282: rn:R03026','Echs1...',true).
concept_name0('41282: rn:R03026','rno:140547 rno:170670 rno:171142',false).
concept_name0('41283: rn:R02488','rno:364975',false).
concept_name0('41283: rn:R02488','Gcdh',true).
concept_name0('41343: rn:R01167','rno:24311',false).
concept_name0('41343: rn:R01167','Ddc, MGC93628',true).
concept_name0('41342: rn:R02914','Uroc1',true).
concept_name0('41342: rn:R02914','rno:685999',false).
concept_name0('41341: rn:R01074','rno:288240',false).
concept_name0('41341: rn:R01074','Hlcs, RGD1565360',true).
concept_name0('41340: rn:R01168','Hal, histidase',true).
concept_name0('41340: rn:R01168','rno:29301',false).
concept_name0('41339: rn:R02287','rno:89833',false).
concept_name0('41339: rn:R02287','Ftcd',true).
concept_name0('2712: rn:R00892','rn:R00892 rp:RP00125 rc:RC00011',false).
concept_name0('2712: rn:R00892','R00892...',true).
concept_name0('41338: rn:R07768','Lias',true).
concept_name0('41338: rn:R07768','rno:305348',false).
concept_name0('2713: rn:R01113','rn:R01113 rp:RP00125 rc:RC00011',false).
concept_name0('2713: rn:R01113','R01113...',true).
concept_name0('41337: rn:R02288','rno:299735',false).
concept_name0('41337: rn:R02288','Amdhd1, RGD1308879',true).
concept_name0('41336: rn:R07769','rno:365314',false).
concept_name0('41336: rn:R07769','Lipt2, RGD1305211',true).
concept_name0('41335: rn:R04869','MGC109340, Spcs3',true).
concept_name0('41335: rn:R04869','rno:317409',false).
concept_name0('41334: rn:R05145','rno:288240',false).
concept_name0('41334: rn:R05145','Hlcs, RGD1565360',true).
concept_name0('2709: rn:R07634','rn:R07634 rp:RP10722 rc:RC01784',false).
concept_name0('2709: rn:R07634','R07634...',true).
concept_name0('41333: rn:R01077','Btd, MGC109548',true).
concept_name0('41333: rn:R01077','rno:306262',false).
concept_name0('2710: rn:R02409','rn:R02409',false).
concept_name0('2710: rn:R02409','R02409',true).
concept_name0('41332: rn:R05145','rno:288240',false).
concept_name0('41332: rn:R05145','Hlcs, RGD1565360',true).
concept_name0('41331: rn:R05145','rno:288240',false).
concept_name0('41331: rn:R05145','Hlcs, RGD1565360',true).
concept_name0('41330: rn:R01074','rno:288240',false).
concept_name0('41330: rn:R01074','Hlcs, RGD1565360',true).
concept_name0('41329: rn:R01074','rno:288240',false).
concept_name0('41329: rn:R01074','Hlcs, RGD1565360',true).
concept_name0('41328: rn:R07771','rno:316342',false).
concept_name0('41328: rn:R07771','Lipt1',true).
concept_name0('41326: rn:R07767','Lias',true).
concept_name0('41326: rn:R07767','rno:305348',false).
concept_name0('41327: rn:R07766','rno:365314',false).
concept_name0('41327: rn:R07766','Lipt2, RGD1305211',true).
concept_name0('2700: rn:R07274','rn:R07274',false).
concept_name0('2700: rn:R07274','R07274',true).
concept_name0('41324: rn:R00526','rno:293653 rno:79251',false).
concept_name0('41324: rn:R00526','Acy3, MGC108859, RGD1305394...',true).
concept_name0('41325: rn:R01166','rno:307212',false).
concept_name0('41325: rn:R01166','Cndp1, MGC93742',true).
concept_name0('41322: rn:R01394','rno:500536',false).
concept_name0('41322: rn:R01394','RGD1561416',true).
concept_name0('2697: rn:R08699','rn:R08699 rp:RP13461 rc:RC01020',false).
concept_name0('2697: rn:R08699','R08699...',true).
concept_name0('41323: rn:R01159','rno:290564 rno:300989',false).
concept_name0('41323: rn:R01159','Mettl6, MGC94452...',true).
concept_name0('41320: rn:R02670','Cat, CS1, Cas1, Cs-1, RATCAT01, RATCATL',true).
concept_name0('41320: rn:R02670','rno:24248',false).
concept_name0('41321: rn:R01900','rno:50655 rno:79250',false).
concept_name0('41321: rn:R01900','Aco1, Acon1, Ratireb...',true).
concept_name0('41318: rn:R03629','Cyp1a1, AHH, AHRR, CP11, CYP1, Cyp45c, Cypc45c, P-450MC, P1-450, P450-C, P450DX...',true).
concept_name0('41318: rn:R03629','rno:24296 rno:24297 rno:25426',false).
concept_name0('41319: rn:R03628','rno:66029 rno:681319 rno:684861',false).
concept_name0('41319: rn:R03628','Ido1, Ido, Indo...',true).
concept_name0('41316: rn:R01975','Hadh, Hadhsc...',true).
concept_name0('41316: rn:R01975','rno:113965 rno:171142',false).
concept_name0('41317: rn:R00677','100360621...',true).
concept_name0('41317: rn:R00677','rno:100360621 rno:298483',false).
concept_name0('2694: rn:R00901','R00901',true).
concept_name0('2694: rn:R00901','rn:R00901',false).
concept_name0('41314: rn:R00317','rno:299203 rno:364224',false).
concept_name0('41314: rn:R00317','Acyp1...',true).
concept_name0('2689: rn:R04860','R04860...',true).
concept_name0('2689: rn:R04860','rn:R04860 rp:RP13498 rc:RC00011',false).
concept_name0('41315: rn:R00678','rno:66029 rno:681319 rno:684861',false).
concept_name0('41315: rn:R00678','Ido1, Ido, Indo...',true).
concept_name0('41312: rn:R02569','rno:81654',false).
concept_name0('41312: rn:R02569','Dlat',true).
concept_name0('41313: rn:R07618','rno:298942',false).
concept_name0('41313: rn:R07618','Dld',true).
concept_name0('2690: rn:R00900','R00900...',true).
concept_name0('2690: rn:R00900','rn:R00900 rp:RP13498 rp:RP13499 rc:RC00011 rc:RC00011',false).
concept_name0('41241: rn:R05947','St8sia5, SIAT8E',true).
concept_name0('41241: rn:R05947','rno:364901',false).
concept_name0('41240: rn:R08965','rno:298182',false).
concept_name0('41240: rn:R08965','Tyrp1, B',true).
concept_name0('41243: rn:R05951','Siat7F, MGC109387',true).
concept_name0('41243: rn:R05951','rno:407765',false).
concept_name0('41242: rn:R05950','St8sia5, SIAT8E',true).
concept_name0('41242: rn:R05950','rno:364901',false).
concept_name0('41245: rn:R05952','B4galnt1, GalNAc-T, Galgt1, MGC93424',true).
concept_name0('41245: rn:R05952','rno:64828',false).
concept_name0('41244: rn:R05953','rno:171079',false).
concept_name0('41244: rn:R05953','B3galt4, MGC156596',true).
concept_name0('41247: rn:R05945','Siat7F, MGC109387',true).
concept_name0('41247: rn:R05945','rno:407765',false).
concept_name0('41246: rn:R05958','St8sia5, SIAT8E',true).
concept_name0('41246: rn:R05958','rno:364901',false).
concept_name0('41233: rn:R05962','B3galnt1, B3galt3',true).
concept_name0('41233: rn:R05962','rno:310508',false).
concept_name0('41232: rn:R05967','rno:362924 rno:64442',false).
concept_name0('41232: rn:R05967','St3gal1, Siat4a...',true).
concept_name0('41235: rn:R06010','rno:316033',false).
concept_name0('41235: rn:R06010','Glb1',true).
concept_name0('41234: rn:R05904','rno:84597',false).
concept_name0('41234: rn:R05904','Fut9',true).
concept_name0('41237: rn:R05947','St8sia1, Siat8, Siat8a',true).
concept_name0('41237: rn:R05947','rno:25280',false).
concept_name0('41236: rn:R05949','rno:362924 rno:64442',false).
concept_name0('41236: rn:R05949','St3gal1, Siat4a...',true).
concept_name0('41239: rn:R02078','Tyr, C',true).
concept_name0('41239: rn:R02078','rno:308800',false).
concept_name0('41238: rn:R06004','rno:294673 rno:300757',false).
concept_name0('41238: rn:R06004','Hexb...',true).
concept_name0('41224: rn:R00216','rno:24552 rno:361602',false).
concept_name0('41224: rn:R00216','Me1, MOD1...',true).
concept_name0('41225: rn:R00227','Acot12, Cach, rACH',true).
concept_name0('41225: rn:R00227','rno:170570',false).
concept_name0('41226: rn:R00236','Acss1, Acas2l...',true).
concept_name0('41226: rn:R00236','rno:296259 rno:311569',false).
concept_name0('41227: rn:R00703','rno:24533 rno:24534 rno:29634 rno:369018 rno:500965',false).
concept_name0('41227: rn:R00703','Ldha, Ldh1...',true).
concept_name0('41228: rn:R05962','B3galnt1, B3galt3',true).
concept_name0('41228: rn:R05962','rno:310508',false).
concept_name0('41229: rn:R05968','rno:308586 rno:58924 rno:81919',false).
concept_name0('41229: rn:R05968','Sec1, Ftc, RGD1562499...',true).
concept_name0('41230: rn:R05964','B3galt5',true).
concept_name0('41230: rn:R05964','rno:288161',false).
concept_name0('41231: rn:R05960','A4galt, Gb3',true).
concept_name0('41231: rn:R05960','rno:63888',false).
concept_name0('10371: rn:R03684','R03684',true).
concept_name0('10371: rn:R03684','rn:R03684',false).
concept_name0('41216: rn:R02577','Akr1b1, ALDRED, ALR-P-I, Akr1b3, Akr1b4, Aldr1, Alr, RATALDRED',true).
concept_name0('41216: rn:R02577','rno:24192',false).
concept_name0('41217: rn:R02531','Akr1b1, ALDRED, ALR-P-I, Akr1b3, Akr1b4, Aldr1, Alr, RATALDRED',true).
concept_name0('41217: rn:R02531','rno:24192',false).
concept_name0('41218: rn:R00200 rn:R02320','rno:100364062 rno:24651 rno:25630',false).
concept_name0('41218: rn:R00200 rn:R02320','100364062...',true).
concept_name0('41219: rn:R00344','rno:25104',false).
concept_name0('41219: rn:R00344','Pc, Pcx',true).
concept_name0('41220: rn:R00214','rno:307270',false).
concept_name0('41220: rn:R00214','Me2',true).
concept_name0('41221: rn:R00197','Ldhd, Ac2-202',true).
concept_name0('41221: rn:R00197','rno:307858',false).
concept_name0('41222: rn:R01736','rno:24439',false).
concept_name0('41222: rn:R01736','Hagh, Glo2, RSP29',true).
concept_name0('41223: rn:R00342','Mdh1, MDL1, Mdhl, Mor2...',true).
concept_name0('41223: rn:R00342','rno:24551 rno:81829',false).
concept_name0('41275: rn:R00987','Kynu',true).
concept_name0('41275: rn:R00987','rno:116682',false).
concept_name0('41274: rn:R00475','Hao1, Gox1, XDH1...',true).
concept_name0('41274: rn:R00475','rno:311446 rno:84029',false).
concept_name0('41273: rn:R00988','Afmid',true).
concept_name0('41273: rn:R00988','rno:688283',false).
concept_name0('41272: rn:R02668','Kynu',true).
concept_name0('41272: rn:R02668','rno:116682',false).
concept_name0('41279: rn:R02665','rno:56823',false).
concept_name0('41279: rn:R02665','Haao',true).
concept_name0('41278: rn:R01959','Afmid',true).
concept_name0('41278: rn:R01959','rno:688283',false).
concept_name0('41277: rn:R03936','Kynu',true).
concept_name0('41277: rn:R03936','rno:116682',false).
concept_name0('41276: rn:R01960','rno:59113',false).
concept_name0('41276: rn:R01960','Kmo',true).
concept_name0('41267: rn:R04171','Aadat, Kat2...',true).
concept_name0('41267: rn:R04171','rno:29416 rno:311844 rno:541589',false).
concept_name0('41266: rn:R01956','Aadat, Kat2...',true).
concept_name0('41266: rn:R01956','rno:29416 rno:311844 rno:541589',false).
concept_name0('41265: rn:R04907','rno:25750 rno:29253',false).
concept_name0('41265: rn:R04907','Maob...',true).
concept_name0('41264: rn:R00351','Cs',true).
concept_name0('41264: rn:R00351','rno:170587',false).
concept_name0('41271: rn:R01325','rno:50655 rno:79250',false).
concept_name0('41271: rn:R01325','Aco1, Acon1, Ratireb...',true).
concept_name0('41270: rn:R00678','rno:64206',false).
concept_name0('41270: rn:R00678','Tdo2, TO, Tdo',true).
concept_name0('41269: rn:R01814','Tph1, Tph...',true).
concept_name0('41269: rn:R01814','rno:24848 rno:317675',false).
concept_name0('41268: rn:R03664','Wars...',true).
concept_name0('41268: rn:R03664','rno:314442 rno:690654',false).
concept_name0('41258: rn:R05938','B4galnt1, GalNAc-T, Galgt1, MGC93424',true).
concept_name0('41258: rn:R05938','rno:64828',false).
concept_name0('2761: rn:R04861','rn:R04861 rp:RP04476 rc:RC01225',false).
concept_name0('2761: rn:R04861','R04861...',true).
concept_name0('41259: rn:R05959','Siat7F, MGC109387',true).
concept_name0('41259: rn:R05959','rno:407765',false).
concept_name0('41256: rn:R05941','rno:171079',false).
concept_name0('41256: rn:R05941','B3galt4, MGC156596',true).
concept_name0('41257: rn:R05956','rno:171079',false).
concept_name0('41257: rn:R05956','B3galt4, MGC156596',true).
concept_name0('41262: rn:R05957','rno:362924 rno:64442',false).
concept_name0('41262: rn:R05957','St3gal1, Siat4a...',true).
concept_name0('41263: rn:R00685','rno:24311',false).
concept_name0('41263: rn:R00685','Ddc, MGC93628',true).
concept_name0('41260: rn:R01364','Fah',true).
concept_name0('41260: rn:R01364','rno:29383',false).
concept_name0('41261: rn:R05946','B4galnt1, GalNAc-T, Galgt1, MGC93424',true).
concept_name0('41261: rn:R05946','rno:64828',false).
concept_name0('41250: rn:R05940','St8sia1, Siat8, Siat8a',true).
concept_name0('41250: rn:R05940','rno:25280',false).
concept_name0('41251: rn:R05959','rno:29758',false).
concept_name0('41251: rn:R05959','St6galnac3, Siat7c',true).
concept_name0('41248: rn:R05943','St8sia5, SIAT8E',true).
concept_name0('41248: rn:R05943','rno:364901',false).
concept_name0('41249: rn:R05959','rno:407764',false).
concept_name0('41249: rn:R05959','siat7D',true).
concept_name0('41254: rn:R05948','rno:171079',false).
concept_name0('41254: rn:R05948','B3galt4, MGC156596',true).
concept_name0('41255: rn:R05939','B4galnt1, GalNAc-T, Galgt1, MGC93424',true).
concept_name0('41255: rn:R05939','rno:64828',false).
concept_name0('41252: rn:R05937','St3gal5, Siat9',true).
concept_name0('41252: rn:R05937','rno:83505',false).
concept_name0('2759: rn:R00863','rn:R00863 rp:RP01146 rp:RP01147 rc:RC00399 rc:RC00400',false).
concept_name0('2759: rn:R00863','R00863...',true).
concept_name0('41253: rn:R05942','rno:362924 rno:64442',false).
concept_name0('41253: rn:R05942','St3gal1, Siat4a...',true).
concept_name0('41428: rn:R00032','rno:114106',false).
concept_name0('41428: rn:R00032','Bcmo1, Bcdo',true).
concept_name0('41429: rn:R04893','rno:25750 rno:29253',false).
concept_name0('41429: rn:R04893','Maob...',true).
concept_name0('41430: rn:R02123','rno:116676',false).
concept_name0('41430: rn:R02123','Aldh1a2, MGC114283, Raldh-2',true).
concept_name0('2613: rn:R04861','rn:R04861 rp:RP04476 rc:RC01225',false).
concept_name0('2613: rn:R04861','R04861...',true).
concept_name0('41431: rn:R02519','Hgd',true).
concept_name0('41431: rn:R02519','rno:360719',false).
concept_name0('41424: rn:R02920','Comt',true).
concept_name0('41424: rn:R02920','rno:24267',false).
concept_name0('41425: rn:R08387','Lrat',true).
concept_name0('41425: rn:R08387','rno:64047',false).
concept_name0('41426: rn:R04891 rn:R04892','rno:25375 rno:266603 rno:309147',false).
concept_name0('41426: rn:R04891 rn:R04892','Aldh3a1, AHDC, Ahd-c, Aldh, Aldh3...',true).
concept_name0('41427: rn:R02532','rno:25750 rno:29253',false).
concept_name0('41427: rn:R02532','Maob...',true).
concept_name0('41436: rn:R03973','Tpo',true).
concept_name0('41436: rn:R03973','rno:54314',false).
concept_name0('41437: rn:R09395','Mocs2, MGC94220',true).
concept_name0('41437: rn:R09395','rno:294753',false).
concept_name0('41438: rn:R03953','Tpo',true).
concept_name0('41438: rn:R03953','rno:54314',false).
concept_name0('41439: rn:R04620','rno:100359675 rno:24197 rno:25586 rno:64621',false).
concept_name0('41439: rn:R04620','100359675...',true).
concept_name0('41432: rn:R03181','rno:681913',false).
concept_name0('41432: rn:R03181','Gstz1',true).
concept_name0('41433: rn:R02124','rno:100145871 rno:171178 rno:24172 rno:29646 rno:310903',false).
concept_name0('41433: rn:R02124','Adh5...',true).
concept_name0('2618: rn:R00179','rn:R00179 rp:RP00058 rp:RP03942 rc:RC00021 rc:RC01124',false).
concept_name0('2618: rn:R00179','R00179...',true).
concept_name0('41434: rn:R09394','rno:301221',false).
concept_name0('41434: rn:R09394','Mocs1',true).
concept_name0('41435: rn:R03539','Tpo',true).
concept_name0('41435: rn:R03539','rno:54314',false).
concept_name0('41413: rn:R02535','rno:25699',false).
concept_name0('41413: rn:R02535','Dbh, DOPBHY',true).
concept_name0('41412: rn:R02919','rno:25750 rno:29253',false).
concept_name0('41412: rn:R02919','Maob...',true).
concept_name0('2599: rn:R01800','R01800...',true).
concept_name0('2599: rn:R01800','rn:R01800 rp:RP01763 rc:RC00017',false).
concept_name0('41415: rn:R04894','rno:25750 rno:29253',false).
concept_name0('41415: rn:R04894','Maob...',true).
concept_name0('41414: rn:R07163','Retsat, Rmt7',true).
concept_name0('41414: rn:R07163','rno:246298',false).
concept_name0('2597: rn:R01566','R01566...',true).
concept_name0('2597: rn:R01566','rn:R01566 rp:RP01599 rc:RC00549',false).
concept_name0('41409: rn:R08382 rn:R08383','rno:314264 rno:362757 rno:366791',false).
concept_name0('41409: rn:R08382 rn:R08383','Rdh12...',true).
concept_name0('41408: rn:R00736','rno:24311',false).
concept_name0('41408: rn:R00736','Ddc, MGC93628',true).
concept_name0('41411: rn:R08381','Awat2, Dgat2l4, RGD1565111...',true).
concept_name0('41411: rn:R08381','rno:302425 rno:84497',false).
concept_name0('41410: rn:R08389','Lrat',true).
concept_name0('41410: rn:R08389','rno:64047',false).
concept_name0('41421: rn:R04887','Comt',true).
concept_name0('41421: rn:R04887','rno:24267',false).
concept_name0('41420: rn:R04881','Comt',true).
concept_name0('41420: rn:R04881','rno:24267',false).
concept_name0('41423: rn:R02534','Comt',true).
concept_name0('41423: rn:R02534','rno:24267',false).
concept_name0('10317: rn:R02369','rn:R02369 rp:RP02159 rc:RC00650',false).
concept_name0('10317: rn:R02369','R02369...',true).
concept_name0('41422: rn:R04882 rn:R04883','rno:25375 rno:266603 rno:309147',false).
concept_name0('41422: rn:R04882 rn:R04883','Aldh3a1, AHDC, Ahd-c, Aldh, Aldh3...',true).
concept_name0('41417: rn:R02533','Pnmt',true).
concept_name0('41417: rn:R02533','rno:24661',false).
concept_name0('2602: rn:R02722','rn:R02722 rp:RP00587 rc:RC00210',false).
concept_name0('2602: rn:R02722','R02722...',true).
concept_name0('41416: rn:R08388','rno:89826',false).
concept_name0('41416: rn:R08388','Rpe65',true).
concept_name0('41419: rn:R03048 rn:R08380','rno:362757 rno:366791',false).
concept_name0('41419: rn:R03048 rn:R08380','Rdh11...',true).
concept_name0('41418: rn:R04880','rno:100145871 rno:171178 rno:24172 rno:29646 rno:310903',false).
concept_name0('41418: rn:R04880','Adh5...',true).
concept_name0('10357: rn:R02126','rn:R02126 rp:RP01984 rc:RC00650',false).
concept_name0('10357: rn:R02126','R02126...',true).
concept_name0('41462: rn:R01709','Aox3l1, Aox2...',true).
concept_name0('41462: rn:R01709','rno:316421 rno:54349',false).
concept_name0('41463: rn:R00160','rno:54410 rno:85496',false).
concept_name0('41463: rn:R00160','Enpp3, RB13-6...',true).
concept_name0('41460: rn:R04285','Spr',true).
concept_name0('41460: rn:R04285','rno:29270',false).
concept_name0('41461: rn:R03673','Dct, RGD1564975',true).
concept_name0('41461: rn:R03673','rno:290484',false).
concept_name0('41458: rn:R02235 rn:R02236','rno:24312',false).
concept_name0('41458: rn:R02235 rn:R02236','Dhfr, Dhfr1',true).
concept_name0('41459: rn:R00942','rno:687266',false).
concept_name0('41459: rn:R00942','Fpgs',true).
concept_name0('41456: rn:R01793 rn:R01794','rno:64192',false).
concept_name0('41456: rn:R01793 rn:R01794','Qdpr',true).
concept_name0('41457: rn:R00936 rn:R00939','rno:24312',false).
concept_name0('41457: rn:R00936 rn:R00939','Dhfr, Dhfr1',true).
concept_name0('41470: rn:R00615','rno:361443',false).
concept_name0('41470: rn:R00615','RGD1306192',true).
concept_name0('41471: rn:R03283','rno:24188 rno:291450 rno:29539 rno:29651 rno:298079 rno:64040 rno:65183',false).
concept_name0('41471: rn:R03283','Aldh1a1, Ahd2, Aldh1, Aldh2...',true).
concept_name0('41468: rn:R00238','rno:25014 rno:308100',false).
concept_name0('41468: rn:R00238','Acat1, RATACAL...',true).
concept_name0('41469: rn:R02488','rno:364975',false).
concept_name0('41469: rn:R02488','Gcdh',true).
concept_name0('41466: rn:R00161','Flad1, MGC187714',true).
concept_name0('41466: rn:R00161','rno:751787',false).
concept_name0('41467: rn:R00549','Rfk',true).
concept_name0('41467: rn:R00549','rno:499328',false).
concept_name0('41464: rn:R02363','Tyr, C',true).
concept_name0('41464: rn:R02363','rno:308800',false).
concept_name0('41465: rn:R00548','100361084...',true).
concept_name0('41465: rn:R00548','rno:100361084 rno:100365942 rno:24161 rno:24162 rno:25732 rno:295305 rno:308569 rno:56780',false).
concept_name0('41447: rn:R05046','Gch1, Gch',true).
concept_name0('41447: rn:R05046','rno:29244',false).
concept_name0('41446: rn:R04888 rn:R04889','rno:25375 rno:266603 rno:309147',false).
concept_name0('41446: rn:R04888 rn:R04889','Aldh3a1, AHDC, Ahd-c, Aldh, Aldh3...',true).
concept_name0('41445: rn:R00428','Gch1, Gch',true).
concept_name0('41445: rn:R00428','rno:29244',false).
concept_name0('41444: rn:R04301','Comt',true).
concept_name0('41444: rn:R04301','rno:24267',false).
concept_name0('41443: rn:R04286','Pts',true).
concept_name0('41443: rn:R04286','rno:29498',false).
concept_name0('41442: rn:R04890','rno:25750 rno:29253',false).
concept_name0('41442: rn:R04890','Maob...',true).
concept_name0('41441: rn:R04242','rno:25455',false).
concept_name0('41441: rn:R04242','Ggh, MGC105496',true).
concept_name0('41440: rn:R02080','rno:24311',false).
concept_name0('41440: rn:R02080','Ddc, MGC93628',true).
concept_name0('41455: rn:R01813','Spr',true).
concept_name0('41455: rn:R01813','rno:29270',false).
concept_name0('41454: rn:R05048','Gch1, Gch',true).
concept_name0('41454: rn:R05048','rno:29244',false).
concept_name0('41453: rn:R04639','Gch1, Gch',true).
concept_name0('41453: rn:R04639','rno:29244',false).
concept_name0('41452: rn:R03300 rn:R03302','rno:25375 rno:266603 rno:309147',false).
concept_name0('41452: rn:R03300 rn:R03302','Aldh3a1, AHDC, Ahd-c, Aldh, Aldh3...',true).
concept_name0('41451: rn:R00937 rn:R00940','rno:24312',false).
concept_name0('41451: rn:R00937 rn:R00940','Dhfr, Dhfr1',true).
concept_name0('41450: rn:R03304','Comt',true).
concept_name0('41450: rn:R03304','rno:24267',false).
concept_name0('41449: rn:R02237','rno:687266',false).
concept_name0('41449: rn:R02237','Fpgs',true).
concept_name0('41448: rn:R04300','rno:25750 rno:29253',false).
concept_name0('41448: rn:R04300','Maob...',true).
concept_name0('41360: rn:R03269','rno:363069',false).
concept_name0('41360: rn:R03269','Ppcdc, RGD1306267',true).
concept_name0('41361: rn:R00130','Coasy, MGC94749, Naglu',true).
concept_name0('41361: rn:R00130','rno:287711',false).
concept_name0('41362: rn:R02269','rno:65135',false).
concept_name0('41362: rn:R02269','Dpys',true).
concept_name0('41363: rn:R00978','rno:81656',false).
concept_name0('41363: rn:R00978','Dpyd',true).
concept_name0('41364: rn:R02869','rno:84596',false).
concept_name0('41364: rn:R02869','Srm',true).
concept_name0('41365: rn:R04391','rno:171053 rno:294088 rno:296167 rno:360511',false).
concept_name0('41365: rn:R04391','Pank4, Fang1...',true).
concept_name0('41366: rn:R04230 rn:R04231','rno:298490',false).
concept_name0('41366: rn:R04230 rn:R04231','Ppcs, MGC116383, RGD1311399',true).
concept_name0('41367: rn:R03018','rno:171053 rno:294088 rno:296167 rno:360511',false).
concept_name0('41367: rn:R03018','Pank4, Fang1...',true).
concept_name0('41368: rn:R00905','rno:116593',false).
concept_name0('41368: rn:R00905','Upb1, Bup1',true).
concept_name0('41369: rn:R01154','rno:302642 rno:360547',false).
concept_name0('41369: rn:R01154','Sat1, Ab2-402, MGC72945, SSAT, Sat...',true).
concept_name0('41370: rn:R02869','683008',true).
concept_name0('41370: rn:R02869','rno:683008',false).
concept_name0('41371: rn:R05050','rno:24188 rno:291450 rno:29539 rno:29651 rno:298079 rno:64040 rno:65183',false).
concept_name0('41371: rn:R05050','Aldh1a1, Ahd2, Aldh1, Aldh2...',true).
concept_name0('41372: rn:R04025','rno:25750 rno:29253',false).
concept_name0('41372: rn:R04025','Maob...',true).
concept_name0('41373: rn:R00243 rn:R00248','Glud1, Ac2-281, Glud, MGC93608, MRG-2',true).
concept_name0('41373: rn:R00243 rn:R00248','rno:24399',false).
concept_name0('41374: rn:R00557','Nos1, bNOS...',true).
concept_name0('41374: rn:R00557','rno:24598 rno:24599 rno:24600',false).
concept_name0('41375: rn:R04300','rno:29473',false).
concept_name0('41375: rn:R04300','Aoc3, SSAO',true).
concept_name0('41345: rn:R04065','rno:24188 rno:291450 rno:29539 rno:29651 rno:298079 rno:64040 rno:65183',false).
concept_name0('41345: rn:R04065','Aldh1a1, Ahd2, Aldh1, Aldh2...',true).
concept_name0('41344: rn:R01167','Hdc, MGC156577',true).
concept_name0('41344: rn:R01167','rno:24443',false).
concept_name0('41347: rn:R04996','rno:25375 rno:266603 rno:309147',false).
concept_name0('41347: rn:R04996','Aldh3a1, AHDC, Ahd-c, Aldh, Aldh3...',true).
concept_name0('41346: rn:R04674','rno:25750 rno:29253',false).
concept_name0('41346: rn:R04674','Maob...',true).
concept_name0('41349: rn:R02155','rno:81676',false).
concept_name0('41349: rn:R02155','Hnmt, MGC105411',true).
concept_name0('41348: rn:R02150','rno:65029',false).
concept_name0('41348: rn:R02150','Abp1, Abp',true).
concept_name0('41351: rn:R05145','rno:288240',false).
concept_name0('41351: rn:R05145','Hlcs, RGD1565360',true).
concept_name0('41350: rn:R01074','rno:288240',false).
concept_name0('41350: rn:R01074','Hlcs, RGD1565360',true).
concept_name0('41353: rn:R02973','rno:29142',false).
concept_name0('41353: rn:R02973','Vnn1, MGC114385, Tiff66',true).
concept_name0('41352: rn:R01214','Bcat1, Bcatc, MGC105472...',true).
concept_name0('41352: rn:R01214','rno:29592 rno:64203',false).
concept_name0('41355: rn:R03035','Coasy, MGC94749, Naglu',true).
concept_name0('41355: rn:R03035','rno:287711',false).
concept_name0('41354: rn:R00707 rn:R00708','Aldh4a1',true).
concept_name0('41354: rn:R00707 rn:R00708','rno:641316',false).
concept_name0('41357: rn:R01625','Aasdhppt',true).
concept_name0('41357: rn:R01625','rno:300328',false).
concept_name0('41356: rn:R04221','Dao, Dao1',true).
concept_name0('41356: rn:R04221','rno:114027',false).
concept_name0('41359: rn:R02971','rno:171053 rno:294088 rno:296167 rno:360511',false).
concept_name0('41359: rn:R02971','Pank4, Fang1...',true).
concept_name0('41358: rn:R03036','rno:54410 rno:85496',false).
concept_name0('41358: rn:R03036','Enpp3, RB13-6...',true).
concept_name0('41394: rn:R00734','rno:24813',false).
concept_name0('41394: rn:R00734','Tat',true).
concept_name0('41395: rn:R08390','Cyp4a1, Cyp4a10, Cyp4a22...',true).
concept_name0('41395: rn:R08390','rno:170544 rno:24306 rno:266674 rno:298423 rno:50549',false).
concept_name0('41392: rn:R00729','100360621...',true).
concept_name0('41392: rn:R00729','rno:100360621 rno:298483',false).
concept_name0('41393: rn:R08390','Cyp1a1, AHH, AHRR, CP11, CYP1, Cyp45c, Cypc45c, P-450MC, P1-450, P450-C, P450DX',true).
concept_name0('41393: rn:R08390','rno:24296',false).
concept_name0('41398: rn:R02521','Hpd',true).
concept_name0('41398: rn:R02521','rno:29531',false).
concept_name0('41399: rn:R02124 rn:R08379','Rdh12...',true).
concept_name0('41399: rn:R02124 rn:R08379','rno:314264 rno:353252 rno:360420 rno:362757 rno:690953',false).
concept_name0('41396: rn:R00734','rno:24401 rno:25721',false).
concept_name0('41396: rn:R00734','Got1, Aspat, Gaspat...',true).
concept_name0('41397: rn:R03342','Mif, MGC72801',true).
concept_name0('41397: rn:R03342','rno:81683',false).
concept_name0('41402: rn:R02382','rno:25750 rno:29253',false).
concept_name0('41402: rn:R02382','Maob...',true).
concept_name0('41403: rn:R08392','Cyp26a1, Cyp26...',true).
concept_name0('41403: rn:R08392','rno:154985 rno:308190 rno:312495',false).
concept_name0('41400: rn:R02695 rn:R02697','rno:25375 rno:266603 rno:309147',false).
concept_name0('41400: rn:R02695 rn:R02697','Aldh3a1, AHDC, Ahd-c, Aldh, Aldh3...',true).
concept_name0('41401: rn:R02124 rn:R08379','Dhrs9, Rdhl...',true).
concept_name0('41401: rn:R02124 rn:R08379','rno:170635 rno:266686 rno:313689',false).
concept_name0('41406: rn:R08392','Cyp1a1, AHH, AHRR, CP11, CYP1, Cyp45c, Cypc45c, P-450MC, P1-450, P450-C, P450DX...',true).
concept_name0('41406: rn:R08392','rno:24296 rno:24297',false).
concept_name0('7021: rn:R03415','R03415...',true).
concept_name0('7021: rn:R03415','rn:R03415 rp:RP03027 rc:RC00199',false).
concept_name0('41407: rn:R08392','Cyp3a9, Cyp3a13, MGC93139, P450olf3...',true).
concept_name0('41407: rn:R08392','rno:171352 rno:252931 rno:25642 rno:266682',false).
concept_name0('7020: rn:R04571','rn:R04571',false).
concept_name0('7020: rn:R04571','R04571',true).
concept_name0('41404: rn:R02382','rno:29473',false).
concept_name0('41404: rn:R02382','Aoc3, SSAO',true).
concept_name0('41405: rn:R02657','Aox3l1, Aox2...',true).
concept_name0('41405: rn:R02657','rno:316421 rno:54349',false).
concept_name0('41379: rn:R02902','rno:113992 rno:154516 rno:24861 rno:24862 rno:266685 rno:286954 rno:289533 rno:29623 rno:301595 rno:305264 rno:396527 rno:396551 rno:396552 rno:574523 rno:63867 rno:83808',false).
concept_name0('41379: rn:R02902','Ugt1a6, MGC124929, UDPGT_1-6, Udpgt, Ugt1, Ugt1a7...',true).
concept_name0('41378: rn:R08383','rno:266686',false).
concept_name0('41378: rn:R08383','Dhrs4, PSCD',true).
concept_name0('41377: rn:R08392','rno:100364896 rno:171518 rno:171521 rno:24299 rno:24300 rno:246070 rno:24894 rno:24895 rno:25011 rno:286953 rno:292728 rno:29277 rno:29295 rno:29298 rno:293989 rno:361523 rno:687842 rno:83790',false).
concept_name0('41377: rn:R08392','100364896...',true).
concept_name0('41376: rn:R03943','rno:290564 rno:300989',false).
concept_name0('41376: rn:R03943','Mettl6, MGC94452...',true).
concept_name0('41383: rn:R04884','Tyr, C',true).
concept_name0('41383: rn:R04884','rno:308800',false).
concept_name0('41382: rn:R08391','Cyp3a9, Cyp3a13, MGC93139, P450olf3...',true).
concept_name0('41382: rn:R08391','rno:171352 rno:252931 rno:25642 rno:266682',false).
concept_name0('7029: rn:R07382','R07382...',true).
concept_name0('7029: rn:R07382','rn:R07382 rp:RP11971 rc:RC00037',false).
concept_name0('41381: rn:R02368','RGD1562200',true).
concept_name0('41381: rn:R02368','rno:363471',false).
concept_name0('7030: rn:R07383','R07383...',true).
concept_name0('7030: rn:R07383','rn:R07383 rp:RP11455 rc:RC00017',false).
concept_name0('41380: rn:R08385','rno:116676',false).
concept_name0('41380: rn:R08385','Aldh1a2, MGC114283, Raldh-2',true).
concept_name0('41387: rn:R03208','Tpo',true).
concept_name0('41387: rn:R03208','rno:54314',false).
concept_name0('10281: rn:R00131','R00131',true).
concept_name0('10281: rn:R00131','rn:R00131',false).
concept_name0('41386: rn:R08390','Cyp26a1, Cyp26...',true).
concept_name0('41386: rn:R08390','rno:154985 rno:308190 rno:312495',false).
concept_name0('41385: rn:R02078','Tyr, C',true).
concept_name0('41385: rn:R02078','rno:308800',false).
concept_name0('41384: rn:R08390','Cyp3a9, Cyp3a13, MGC93139, P450olf3...',true).
concept_name0('41384: rn:R08390','rno:171352 rno:252931 rno:25642 rno:266682',false).
concept_name0('41391: rn:R00731','Tyr, C',true).
concept_name0('41391: rn:R00731','rno:308800',false).
concept_name0('41390: rn:R08390','rno:100364896 rno:171518 rno:171521 rno:24299 rno:24300 rno:246070 rno:24894 rno:24895 rno:25011 rno:286953 rno:292728 rno:29277 rno:29295 rno:29298 rno:293989 rno:361523 rno:687842 rno:83790',false).
concept_name0('41390: rn:R08390','100364896...',true).
concept_name0('41389: rn:R01815','Th, The',true).
concept_name0('41389: rn:R01815','rno:25085',false).
concept_name0('41388: rn:R08391','Cyp2a3, Cyp2a3a, RATCYP2A3A...',true).
concept_name0('41388: rn:R08391','rno:24299 rno:24300 rno:24894 rno:24895 rno:286953 rno:292728 rno:29295 rno:361523',false).
concept_name0('41038: rn:R02581','rno:29224 rno:304078',false).
concept_name0('41038: rn:R02581','Cbr1, Cbr, MGC124927...',true).
concept_name0('41039: rn:R02266','rno:25526 rno:58962',false).
concept_name0('41039: rn:R02266','Ptgds, PH2DISO...',true).
concept_name0('41036: rn:R00431 rn:R00726','rno:361042 rno:362282',false).
concept_name0('41036: rn:R00431 rn:R00726','Pck2...',true).
concept_name0('41037: rn:R00945','rno:287379 rno:299857',false).
concept_name0('41037: rn:R00945','Shmt1, LRRGT00032, Shmt, mShmt...',true).
concept_name0('41034: rn:R01641','rno:290685 rno:64524 rno:689374',false).
concept_name0('41034: rn:R01641','Tktl2, RGD1304767...',true).
concept_name0('41035: rn:R01051','rno:362706',false).
concept_name0('41035: rn:R01051','Rbks',true).
concept_name0('41032: rn:R02750','rno:362706',false).
concept_name0('41032: rn:R02750','Rbks',true).
concept_name0('41033: rn:R01049','Prps2...',true).
concept_name0('41033: rn:R01049','rno:24689 rno:29562 rno:298954 rno:314140',false).
concept_name0('10693: rn:R08375','rn:R08375 rp:RP12991 rc:RC00212',false).
concept_name0('10693: rn:R08375','R08375...',true).
concept_name0('41030: rn:R00014','rno:117098 rno:289950 rno:29554',false).
concept_name0('41030: rn:R00014','Pdha2, Pdhal...',true).
concept_name0('41031: rn:R01317','rno:192259 rno:24653 rno:289733 rno:29354 rno:29359 rno:29387 rno:29526 rno:296091 rno:29692 rno:298579 rno:311341 rno:360426 rno:362039 rno:367415 rno:690388 rno:691907',false).
concept_name0('41031: rn:R01317','Plb1, Phlpb...',true).
concept_name0('41028: rn:R01595','rno:25290',false).
concept_name0('41028: rn:R01595','Alox5, LOX5A',true).
concept_name0('41029: rn:R00073','rno:24693 rno:29527',false).
concept_name0('41029: rn:R00073','Ptgs1, Cox-3, Cox1, Cox3...',true).
concept_name0('41026: rn:R07034','Gpx5...',true).
concept_name0('41026: rn:R07034','rno:113919 rno:24404 rno:259233 rno:29326 rno:294744 rno:298376 rno:64317',false).
concept_name0('41027: rn:R03058','rno:25290',false).
concept_name0('41027: rn:R03058','Alox5, LOX5A',true).
concept_name0('41024: rn:R01596','rno:287454',false).
concept_name0('41024: rn:R01596','Alox12, MGC187960',true).
concept_name0('41025: rn:R01593','Alox15b...',true).
concept_name0('41025: rn:R01593','rno:266604 rno:303252 rno:81639',false).
concept_name0('41055: rn:R04780','rno:114508 rno:24362',false).
concept_name0('41055: rn:R04780','Fbp2, FBPase...',true).
concept_name0('41054: rn:R04779','rno:25741 rno:60416 rno:65152',false).
concept_name0('41054: rn:R04779','Pfkl...',true).
concept_name0('41053: rn:R03970','Ggt1, GGLUT, Ggt, Ggtp, RATGGLUT...',true).
concept_name0('41053: rn:R03970','rno:116568 rno:156275 rno:29566 rno:408206',false).
concept_name0('41052: rn:R02740','rno:292804',false).
concept_name0('41052: rn:R02740','Gpi, Amf, Gpi1',true).
concept_name0('41051: rn:R01529','rno:501157',false).
concept_name0('41051: rn:R01529','Rpe, MGC124653',true).
concept_name0('41050: rn:R01056','Rpia',true).
concept_name0('41050: rn:R01056','rno:362383',false).
concept_name0('41049: rn:R01070','Aldoa, Aldo1, RNALDOG5...',true).
concept_name0('41049: rn:R01070','rno:24189 rno:24190 rno:24191 rno:299052',false).
concept_name0('41048: rn:R01830','rno:290685 rno:64524 rno:689374',false).
concept_name0('41048: rn:R01830','Tktl2, RGD1304767...',true).
concept_name0('41047: rn:R03971','Ggt1, GGLUT, Ggt, Ggtp, RATGGLUT...',true).
concept_name0('41047: rn:R03971','rno:116568 rno:156275 rno:29566 rno:408206',false).
concept_name0('41046: rn:R07050','100364896...',true).
concept_name0('41046: rn:R07050','rno:100364896 rno:170544 rno:171518 rno:171521 rno:24300 rno:24306 rno:246070 rno:25011 rno:266674 rno:286953 rno:292728 rno:29277 rno:29295 rno:29298 rno:293989 rno:298423 rno:313375 rno:361523 rno:502969 rno:50549 rno:65210 rno:687842 rno:83790',false).
concept_name0('41045: rn:R07051','100364896...',true).
concept_name0('41045: rn:R07051','rno:100364896 rno:171518 rno:171521 rno:24300 rno:246070 rno:25011 rno:286953 rno:292728 rno:29277 rno:29295 rno:29298 rno:293989 rno:313375 rno:361523 rno:502969 rno:65210 rno:687842 rno:83790',false).
concept_name0('41044: rn:R07052','100364896...',true).
concept_name0('41044: rn:R07052','rno:100364896 rno:171518 rno:171521 rno:24300 rno:246070 rno:25011 rno:286953 rno:292728 rno:29277 rno:29295 rno:29298 rno:293989 rno:313375 rno:361523 rno:502969 rno:65210 rno:687842 rno:83790',false).
concept_name0('41043: rn:R01528','rno:100360180',false).
concept_name0('41043: rn:R01528','100360180',true).
concept_name0('41042: rn:R02736','rno:24377',false).
concept_name0('41042: rn:R02736','G6pd, G6pdx',true).
concept_name0('41041: rn:R02035','Pgls',true).
concept_name0('41041: rn:R02035','rno:290636',false).
concept_name0('41040: rn:R02739','rno:292804',false).
concept_name0('41040: rn:R02739','Gpi, Amf, Gpi1',true).
concept_name0('41068: rn:R07045','Cyp2j3, Cyp2j9...',true).
concept_name0('41068: rn:R07045','rno:313375 rno:502969 rno:65210',false).
concept_name0('41069: rn:R01519','rno:25106',false).
concept_name0('41069: rn:R01519','Rgn, Rc, Reguc',true).
concept_name0('6846: rn:R05381','rn:R05381 rp:RP04988 rp:RP04989 rc:RC01347 rc:RC00053',false).
concept_name0('6846: rn:R05381','R05381...',true).
concept_name0('41070: rn:R04929','Papss2, MGC189455...',true).
concept_name0('41070: rn:R04929','rno:294103 rno:295443',false).
concept_name0('2957: rn:R04673','rn:R04673 rp:RP04312 rc:RC01192',false).
concept_name0('2957: rn:R04673','R04673...',true).
concept_name0('41071: rn:R07054','100364896...',true).
concept_name0('41071: rn:R07054','rno:100364896 rno:171518 rno:171521 rno:246070 rno:25011 rno:29277 rno:29298 rno:293989 rno:687842 rno:83790',false).
concept_name0('41064: rn:R07044','Cyp2j3, Cyp2j9...',true).
concept_name0('41064: rn:R07044','rno:313375 rno:502969 rno:65210',false).
concept_name0('41065: rn:R07048','100364896...',true).
concept_name0('41065: rn:R07048','rno:100364896 rno:171518 rno:171521 rno:24300 rno:246070 rno:25011 rno:286953 rno:292728 rno:29277 rno:29295 rno:29298 rno:293989 rno:313375 rno:361523 rno:502969 rno:65210 rno:687842 rno:83790',false).
concept_name0('41066: rn:R07042','100364896...',true).
concept_name0('41066: rn:R07042','rno:100364896 rno:171518 rno:171521 rno:246070 rno:25011 rno:29277 rno:29298 rno:293989 rno:313375 rno:502969 rno:65210 rno:687842 rno:83790',false).
concept_name0('41067: rn:R09366','Scly, MGC94824',true).
concept_name0('41067: rn:R09366','rno:363285',false).
concept_name0('41060: rn:R07046','rno:25086',false).
concept_name0('41060: rn:R07046','Cyp2e1, Cyp2e',true).
concept_name0('41061: rn:R07041','rno:266689 rno:286904 rno:286905 rno:290623 rno:500801 rno:503122 rno:56266',false).
concept_name0('41061: rn:R07041','Cyp4f6, MGC93133...',true).
concept_name0('41062: rn:R07041','Cyp4a1, Cyp4a10, Cyp4a22...',true).
concept_name0('41062: rn:R07041','rno:170544 rno:24306 rno:266674 rno:298423 rno:50549',false).
concept_name0('41063: rn:R01057','Pgm1',true).
concept_name0('41063: rn:R01057','rno:24645',false).
concept_name0('41056: rn:R01827','rno:83688',false).
concept_name0('41056: rn:R01827','Taldo1',true).
concept_name0('41057: rn:R07041','rno:310848',false).
concept_name0('41057: rn:R07041','Cyp2u1',true).
concept_name0('41058: rn:R07046','rno:310848',false).
concept_name0('41058: rn:R07046','Cyp2u1',true).
concept_name0('41059: rn:R07035','Gpx5...',true).
concept_name0('41059: rn:R07035','rno:113919 rno:24404 rno:259233 rno:29326 rno:294744 rno:298376 rno:64317',false).
concept_name0('41085: rn:R00256','Gls2, Ga...',true).
concept_name0('41085: rn:R00256','rno:192268 rno:24398',false).
concept_name0('41084: rn:R01478','Gusb, Ac2-223, Gus-s...',true).
concept_name0('41084: rn:R01478','rno:24434 rno:83504',false).
concept_name0('41087: rn:R07046','Cyp2j3, Cyp2j9...',true).
concept_name0('41087: rn:R07046','rno:313375 rno:502969 rno:65210',false).
concept_name0('41086: rn:R01579','Gls2, Ga...',true).
concept_name0('41086: rn:R01579','rno:192268 rno:24398',false).
concept_name0('41081: rn:R02923','Dao, Dao1',true).
concept_name0('41081: rn:R02923','rno:114027',false).
concept_name0('41080: rn:R03626','rno:303252 rno:81639',false).
concept_name0('41080: rn:R03626','Alox12e...',true).
concept_name0('41083: rn:R00243 rn:R00248','Glud1, Ac2-281, Glud, MGC93608, MRG-2',true).
concept_name0('41083: rn:R00243 rn:R00248','rno:24399',false).
concept_name0('41082: rn:R02457','Dao, Dao1',true).
concept_name0('41082: rn:R02457','rno:114027',false).
concept_name0('41077: rn:R02736 rn:R02035','rno:298655',false).
concept_name0('41077: rn:R02736 rn:R02035','H6pd',true).
concept_name0('41076: rn:R07053','rno:266604',false).
concept_name0('41076: rn:R07053','Alox15b',true).
concept_name0('41079: rn:R07064','rno:192259 rno:24653 rno:289733 rno:29354 rno:29359 rno:29387 rno:29526 rno:296091 rno:29692 rno:298579 rno:311341 rno:360426 rno:362039 rno:367415 rno:690388 rno:691907',false).
concept_name0('41079: rn:R07064','Plb1, Phlpb...',true).
concept_name0('41078: rn:R07056','100364896...',true).
concept_name0('41078: rn:R07056','rno:100364896 rno:171352 rno:171518 rno:171521 rno:24297 rno:246070 rno:25011 rno:25086 rno:252931 rno:25642 rno:266682 rno:29277 rno:29298 rno:293989 rno:313375 rno:502969 rno:65210 rno:687842 rno:83790',false).
concept_name0('41073: rn:R07043','100364896...',true).
concept_name0('41073: rn:R07043','rno:100364896 rno:171518 rno:171521 rno:246070 rno:25011 rno:29277 rno:29298 rno:293989 rno:313375 rno:502969 rno:65210 rno:687842 rno:83790',false).
concept_name0('41072: rn:R09372','Txnrd3...',true).
concept_name0('41072: rn:R09372','rno:297437 rno:50551 rno:58819',false).
concept_name0('41075: rn:R07038','rno:287425',false).
concept_name0('41075: rn:R07038','Alox12b',true).
concept_name0('41074: rn:R09365','Mtr, methioninesynthase',true).
concept_name0('41074: rn:R09365','rno:81522',false).
concept_name0('40970: rn:R00268','Idh1...',true).
concept_name0('40970: rn:R00268','rno:24479 rno:361596',false).
concept_name0('40971: rn:R00352','Acly, ACL, Clatp, MGC124629',true).
concept_name0('40971: rn:R00352','rno:24159',false).
concept_name0('40968: rn:R09373','Ccbl1, Gtk, KatI...',true).
concept_name0('40968: rn:R09373','rno:311844 rno:541589',false).
concept_name0('40969: rn:R00709','rno:114096 rno:25179 rno:94173',false).
concept_name0('40969: rn:R00709','Idh3a...',true).
concept_name0('40974: rn:R03316','Ogdhl...',true).
concept_name0('40974: rn:R03316','rno:290566 rno:360975',false).
concept_name0('6877: rn:R02054','rn:R02054 rp:RP00455 rc:RC00041',false).
concept_name0('6877: rn:R02054','R02054...',true).
concept_name0('40975: rn:R00432 rn:R00727','rno:114597 rno:361071 rno:362404',false).
concept_name0('40975: rn:R00432 rn:R00727','Suclg1...',true).
concept_name0('40972: rn:R01899','Idh1...',true).
concept_name0('40972: rn:R01899','rno:24479 rno:361596',false).
concept_name0('40973: rn:R02570','rno:299201',false).
concept_name0('40973: rn:R02570','Dlst, MGC95077',true).
concept_name0('40962: rn:R03599','Scly, MGC94824',true).
concept_name0('40962: rn:R03599','rno:363285',false).
concept_name0('40963: rn:R08224','679383',true).
concept_name0('40963: rn:R08224','rno:679383',false).
concept_name0('40960: rn:R01516','rno:296973',false).
concept_name0('40960: rn:R01516','Bpgm, Ab2-098',true).
concept_name0('40961: rn:R01662','rno:296973',false).
concept_name0('40961: rn:R01662','Bpgm, Ab2-098',true).
concept_name0('40966: rn:R07111','Ephx2',true).
concept_name0('40966: rn:R07111','rno:65030',false).
concept_name0('6869: rn:R01470','rn:R01470 rp:RP01533 rp:RP01534 rc:RC00425 rc:RC00017',false).
concept_name0('6869: rn:R01470','R01470...',true).
concept_name0('40967: rn:R07110','Ephx2',true).
concept_name0('40967: rn:R07110','rno:65030',false).
concept_name0('40964: rn:R07109','Ephx2',true).
concept_name0('40964: rn:R07109','rno:65030',false).
concept_name0('40965: rn:R07108','Ephx2',true).
concept_name0('40965: rn:R07108','rno:65030',false).
concept_name0('6870: rn:R01800','R01800',true).
concept_name0('6870: rn:R01800','rn:R01800',false).
concept_name0('40987: rn:R00342','Mdh1, MDL1, Mdhl, Mor2...',true).
concept_name0('40987: rn:R00342','rno:24551 rno:81829',false).
concept_name0('40986: rn:R00351','Cs',true).
concept_name0('40986: rn:R00351','rno:170587',false).
concept_name0('10650: rn:R05636','R05636...',true).
concept_name0('10650: rn:R05636','rn:R05636 rp:RP05243 rc:RC00032',false).
concept_name0('40985: rn:R00344','rno:25104',false).
concept_name0('40985: rn:R00344','Pc, Pcx',true).
concept_name0('40984: rn:R03595','rno:291314 rno:308993',false).
concept_name0('40984: rn:R03595','Sephs1...',true).
concept_name0('40991: rn:R01082','Fh1, Fh, MGC105468',true).
concept_name0('40991: rn:R01082','rno:24368',false).
concept_name0('40990: rn:R02164','Sdha...',true).
concept_name0('40990: rn:R02164','rno:157074 rno:289217 rno:298596 rno:363061',false).
concept_name0('6861: rn:R01316','R01316...',true).
concept_name0('6861: rn:R01316','rn:R01316 rp:RP00541 rc:RC00041',false).
concept_name0('40989: rn:R01325','rno:50655 rno:79250',false).
concept_name0('40989: rn:R01325','Aco1, Acon1, Ratireb...',true).
concept_name0('40988: rn:R01900','rno:50655 rno:79250',false).
concept_name0('40988: rn:R01900','Aco1, Acon1, Ratireb...',true).
concept_name0('6863: rn:R02027','R02027...',true).
concept_name0('6863: rn:R02027','rn:R02027 rp:RP00393 rc:RC00017',false).
concept_name0('40979: rn:R09086','rno:315722',false).
concept_name0('40979: rn:R09086','Adpgk, RGD1306103',true).
concept_name0('40978: rn:R07618','rno:298942',false).
concept_name0('40978: rn:R07618','Dld',true).
concept_name0('6849: rn:R05794','rn:R05794',false).
concept_name0('6849: rn:R05794','R05794',true).
concept_name0('40977: rn:R00621','Ogdhl...',true).
concept_name0('40977: rn:R00621','rno:290566 rno:360975',false).
concept_name0('40976: rn:R00405','rno:114597 rno:361071 rno:362404',false).
concept_name0('40976: rn:R00405','Suclg1...',true).
concept_name0('6851: rn:R01319','R01319...',true).
concept_name0('6851: rn:R01319','rn:R01319 rp:RP00541 rc:RC00041',false).
concept_name0('40983: rn:R03596','Txnrd3...',true).
concept_name0('40983: rn:R03596','rno:297437 rno:50551 rno:58819',false).
concept_name0('40982: rn:R04162','rno:192270 rno:246115 rno:64369',false).
concept_name0('40982: rn:R04162','Ppap2b, Dri42...',true).
concept_name0('40981: rn:R04311','rno:84114',false).
concept_name0('40981: rn:R04311','Agps, Adap-s, Adps, Ads',true).
concept_name0('40980: rn:R04773','rno:299851 rno:316403',false).
concept_name0('40980: rn:R04773','Mars...',true).
concept_name0('41000: rn:R02466','rno:24379 rno:24380',false).
concept_name0('41000: rn:R02466','Gad1, Gad67...',true).
concept_name0('6907: rn:R01030','R01030...',true).
concept_name0('6907: rn:R01030','rn:R01030 rp:RP01244 rp:RP01245 rc:RC00425 rc:RC00017',false).
concept_name0('41001: rn:R07387','rno:192259 rno:24653 rno:289733 rno:29354 rno:29359 rno:29387 rno:29526 rno:296091 rno:29692 rno:298579 rno:311341 rno:360426 rno:362039 rno:367415 rno:690388 rno:691907',false).
concept_name0('41001: rn:R07387','Plb1, Phlpb...',true).
concept_name0('6906: rn:R04864','R04864...',true).
concept_name0('6906: rn:R04864','rn:R04864 rp:RP00455 rc:RC00041',false).
concept_name0('41002: rn:R02466','Csad',true).
concept_name0('41002: rn:R02466','rno:60356',false).
concept_name0('6905: rn:R01470','rn:R01470 rp:RP01533 rp:RP01534 rc:RC00425 rc:RC00017',false).
concept_name0('6905: rn:R01470','R01470...',true).
concept_name0('41003: rn:R07379','rno:192259 rno:24653 rno:289733 rno:29354 rno:29359 rno:29387 rno:29526 rno:296091 rno:29692 rno:298579 rno:311341 rno:360426 rno:362039 rno:367415 rno:690388 rno:691907',false).
concept_name0('41003: rn:R07379','Plb1, Phlpb...',true).
concept_name0('41004: rn:R02467','rno:309732',false).
concept_name0('41004: rn:R02467','Ado, RGD1308233',true).
concept_name0('41005: rn:R03437','100359680...',true).
concept_name0('41005: rn:R03437','rno:100359680 rno:296048 rno:307713 rno:361467',false).
concept_name0('41006: rn:R00893','rno:81718',false).
concept_name0('41006: rn:R00893','Cdo1',true).
concept_name0('41007: rn:R06364','Cept1, MGC95031...',true).
concept_name0('41007: rn:R06364','rno:310773 rno:362713',false).
concept_name0('40992: rn:R07380','rno:306460',false).
concept_name0('40992: rn:R07380','Enpp6, E-NPP_6',true).
concept_name0('40993: rn:R07388','rno:84050',false).
concept_name0('40993: rn:R07388','Enpp2, MGC93258',true).
concept_name0('40994: rn:R07384','Cept1, MGC95031...',true).
concept_name0('40994: rn:R07384','rno:310773 rno:362713',false).
concept_name0('40995: rn:R04413','rno:296048',false).
concept_name0('40995: rn:R04413','Lpcat4, Agpat7, RGD1311177',true).
concept_name0('6896: rn:R02756','rn:R02756 rp:RP02475 rc:RC00029',false).
concept_name0('6896: rn:R02756','R02756...',true).
concept_name0('40996: rn:R03720','rno:29725',false).
concept_name0('40996: rn:R03720','Baat, MGC108728, kan-1',true).
concept_name0('40997: rn:R07385','rno:25096 rno:25097',false).
concept_name0('40997: rn:R07385','Pld1, Pld1a, Pld1b, Plda, Pldb...',true).
concept_name0('40998: rn:R01687','Ggt1, GGLUT, Ggt, Ggtp, RATGGLUT...',true).
concept_name0('40998: rn:R01687','rno:116568 rno:156275 rno:29566 rno:408206',false).
concept_name0('40999: rn:R03438','100359680...',true).
concept_name0('40999: rn:R03438','rno:100359680 rno:307713 rno:361467',false).
concept_name0('41017: rn:R07618','rno:298942',false).
concept_name0('41017: rn:R07618','Dld',true).
concept_name0('41016: rn:R03057','rno:299732',false).
concept_name0('41016: rn:R03057','Lta4h',true).
concept_name0('3035: rn:R00271','R00271...',true).
concept_name0('3035: rn:R00271','rn:R00271 rp:RP04508 rc:RC00067',false).
concept_name0('41019: rn:R02265','rno:311865 rno:59103',false).
concept_name0('41019: rn:R02265','Ptges2...',true).
concept_name0('41018: rn:R03866','rno:266689 rno:286904 rno:286905 rno:290623 rno:500801 rno:503122 rno:56266',false).
concept_name0('41018: rn:R03866','Cyp4f6, MGC93133...',true).
concept_name0('41021: rn:R02268','Tbxas1',true).
concept_name0('41021: rn:R02268','rno:24886',false).
concept_name0('41020: rn:R02569','rno:81654',false).
concept_name0('41020: rn:R02569','Dlat',true).
concept_name0('41023: rn:R02267','Ptgis, PGIS',true).
concept_name0('41023: rn:R02267','rno:25527',false).
concept_name0('41022: rn:R01590','rno:24693 rno:29527',false).
concept_name0('41022: rn:R01590','Ptgs1, Cox-3, Cox1, Cox3...',true).
concept_name0('41009: rn:R04321','Cept1, MGC95031...',true).
concept_name0('41009: rn:R04321','rno:310773 rno:362866',false).
concept_name0('41008: rn:R01682','rno:24379 rno:24380',false).
concept_name0('41008: rn:R01682','Gad1, Gad67...',true).
concept_name0('3027: rn:R00457','rn:R00457 rp:RP00405 rc:RC00062',false).
concept_name0('3027: rn:R00457','R00457...',true).
concept_name0('41011: rn:R04452','rno:114113 rno:301265 rno:313611 rno:64189 rno:83572',false).
concept_name0('41011: rn:R04452','Pafah1b3, MGC156583...',true).
concept_name0('41010: rn:R01682','Csad',true).
concept_name0('41010: rn:R01682','rno:60356',false).
concept_name0('41013: rn:R03059','Ltc4s',true).
concept_name0('41013: rn:R03059','rno:114097',false).
concept_name0('6886: rn:R02029','R02029...',true).
concept_name0('6886: rn:R02029','rn:R02029 rp:RP01923 rc:RC00017',false).
concept_name0('41012: rn:R07389','Cept1, MGC95031...',true).
concept_name0('41012: rn:R07389','rno:310773 rno:362866',false).
concept_name0('6887: rn:R01030','R01030...',true).
concept_name0('6887: rn:R01030','rn:R01030 rp:RP01244 rp:RP01245 rc:RC00425 rc:RC00017',false).
concept_name0('41015: rn:R03867','Ggt1, GGLUT, Ggt, Ggtp, RATGGLUT...',true).
concept_name0('41015: rn:R03867','rno:116568 rno:156275 rno:29566 rno:408206',false).
concept_name0('41014: rn:R03270','rno:117098 rno:289950 rno:29554',false).
concept_name0('41014: rn:R03270','Pdha2, Pdhal...',true).
concept_name0('6885: rn:R00749','rn:R00749 rp:RP01082 rc:RC00370',false).
concept_name0('6885: rn:R00749','R00749...',true).
concept_name0('41159: rn:R02301','Mthfs, MGC95139',true).
concept_name0('41159: rn:R02301','rno:300886',false).
concept_name0('41158: rn:R00904','rno:25375 rno:266603 rno:309147',false).
concept_name0('41158: rn:R00904','Aldh3a1, AHDC, Ahd-c, Aldh, Aldh3...',true).
concept_name0('41157: rn:R04325','rno:288259',false).
concept_name0('41157: rn:R04325','Gart',true).
concept_name0('41156: rn:R00943','rno:361472 rno:64300',false).
concept_name0('41156: rn:R00943','Mthfd1l, Fthfsdc1...',true).
concept_name0('41155: rn:R00941','rno:299699 rno:64392',false).
concept_name0('41155: rn:R00941','Aldh1l2, RGD1309458...',true).
concept_name0('41154: rn:R00978','rno:81656',false).
concept_name0('41154: rn:R00978','Dpyd',true).
concept_name0('41153: rn:R02269','rno:65135',false).
concept_name0('41153: rn:R02269','Dpys',true).
concept_name0('41152: rn:R00905','rno:116593',false).
concept_name0('41152: rn:R00905','Upb1, Bup1',true).
concept_name0('41167: rn:R03189','rno:89833',false).
concept_name0('41167: rn:R03189','Ftcd',true).
concept_name0('41166: rn:R01218','rno:305248 rno:313410 rno:680308',false).
concept_name0('41166: rn:R01218','Mthfd2l, RGD1310879...',true).
concept_name0('41165: rn:R00936 rn:R00939','rno:24312',false).
concept_name0('41165: rn:R00936 rn:R00939','Dhfr, Dhfr1',true).
concept_name0('41164: rn:R01220','Mthfd1',true).
concept_name0('41164: rn:R01220','rno:64300',false).
concept_name0('41163: rn:R01655','rno:305248 rno:313410 rno:64300 rno:680308',false).
concept_name0('41163: rn:R01655','Mthfd2l, RGD1310879...',true).
concept_name0('41162: rn:R01224 rn:R07168','Mthfr',true).
concept_name0('41162: rn:R01224 rn:R07168','rno:362657',false).
concept_name0('41161: rn:R03940','Mtfmt, MGC95129, RGD1309462',true).
concept_name0('41161: rn:R03940','rno:315763',false).
concept_name0('41160: rn:R02300','Amt',true).
concept_name0('41160: rn:R02300','rno:306586',false).
concept_name0('41174: rn:R01975','Hadh, Hadhsc...',true).
concept_name0('41174: rn:R01975','rno:113965 rno:171142',false).
concept_name0('41175: rn:R00694','rno:24401 rno:25721',false).
concept_name0('41175: rn:R00694','Got1, Aspat, Gaspat...',true).
concept_name0('41172: rn:R01648','Abat, Gabat, MGC93392, beta-AlaAT',true).
concept_name0('41172: rn:R01648','rno:81632',false).
concept_name0('10582: rn:R03166','R03166...',true).
concept_name0('10582: rn:R03166','rn:R03166 rp:RP02809 rc:RC00864',false).
concept_name0('41173: rn:R00261','rno:24379 rno:24380',false).
concept_name0('41173: rn:R00261','Gad1, Gad67...',true).
concept_name0('41170: rn:R02302','rno:89833',false).
concept_name0('41170: rn:R02302','Ftcd',true).
concept_name0('41171: rn:R04326','rno:288259',false).
concept_name0('41171: rn:R04326','Gart',true).
concept_name0('41168: rn:R02235 rn:R02236','rno:24312',false).
concept_name0('41168: rn:R02235 rn:R02236','Dhfr, Dhfr1',true).
concept_name0('41169: rn:R02287','rno:89833',false).
concept_name0('41169: rn:R02287','Ftcd',true).
concept_name0('41182: rn:R01357','rno:65984',false).
concept_name0('41182: rn:R01357','Aacs',true).
concept_name0('41183: rn:R00410','100359544...',true).
concept_name0('41183: rn:R00410','rno:100359544 rno:100361036 rno:100365119 rno:366463 rno:690163',false).
concept_name0('41180: rn:R01978','Hmgcs2, Hmgcs1, Mt3h3mg...',true).
concept_name0('41180: rn:R01978','rno:24450 rno:29637',false).
concept_name0('41181: rn:R01360','rno:79238',false).
concept_name0('41181: rn:R01360','Hmgcl',true).
concept_name0('41178: rn:R03026','Echs1...',true).
concept_name0('41178: rn:R03026','rno:140547 rno:170670 rno:171142',false).
concept_name0('41179: rn:R01361','Bdh1, Bdh, MGC94818...',true).
concept_name0('41179: rn:R01361','rno:117099 rno:295458',false).
concept_name0('41176: rn:R00238','rno:25014 rno:308100',false).
concept_name0('41176: rn:R00238','Acat1, RATACAL...',true).
concept_name0('41177: rn:R00734','rno:24401 rno:25721',false).
concept_name0('41177: rn:R00734','Got1, Aspat, Gaspat...',true).
concept_name0('41189: rn:R00489','rno:24379 rno:24380',false).
concept_name0('41189: rn:R00489','Gad1, Gad67...',true).
concept_name0('6710: rn:R03478','rn:R03478 rp:RP03092 rc:RC00078',false).
concept_name0('6710: rn:R03478','R03478...',true).
concept_name0('41188: rn:R02869','683008',true).
concept_name0('41188: rn:R02869','rno:683008',false).
concept_name0('41191: rn:R03139','rno:29473',false).
concept_name0('41191: rn:R03139','Aoc3, SSAO',true).
concept_name0('41190: rn:R00904','rno:24188 rno:291450 rno:29539 rno:29651 rno:298079 rno:64040 rno:65183',false).
concept_name0('41190: rn:R00904','Aldh1a1, Ahd2, Aldh1, Aldh2...',true).
concept_name0('41185: rn:R00014','rno:117098 rno:289950 rno:29554',false).
concept_name0('41185: rn:R00014','Pdha2, Pdhal...',true).
concept_name0('41184: rn:R03534','L2hgdh, RGD1306250',true).
concept_name0('41184: rn:R03534','rno:314196',false).
concept_name0('41187: rn:R02869','rno:84596',false).
concept_name0('41187: rn:R02869','Srm',true).
concept_name0('41186: rn:R00924','rno:24158',false).
concept_name0('41186: rn:R00924','Acadm, MCAD',true).
concept_name0('41197: rn:R00908','Abat, Gabat, MGC93392, beta-AlaAT',true).
concept_name0('41197: rn:R00908','rno:81632',false).
concept_name0('41196: rn:R00713','rno:291133',false).
concept_name0('41196: rn:R00713','Aldh5a1, Ssadh',true).
concept_name0('41199: rn:R05959','rno:365984',false).
concept_name0('41199: rn:R05959','Siat7E, ST6GalNAcV',true).
concept_name0('41198: rn:R01176','rno:246263 rno:24763 rno:353317 rno:361637',false).
concept_name0('41198: rn:R01176','Acsm2, Acsm2a, KS...',true).
concept_name0('41193: rn:R00233','rno:85239',false).
concept_name0('41193: rn:R00233','Mlycd, Mcd',true).
concept_name0('41192: rn:R01171','rno:64304',false).
concept_name0('41192: rn:R01171','Acads, Scad',true).
concept_name0('41195: rn:R03045','Echs1...',true).
concept_name0('41195: rn:R03045','rno:140547 rno:170670 rno:171142',false).
concept_name0('41194: rn:R03158','Hibch',true).
concept_name0('41194: rn:R03158','rno:301384',false).
concept_name0('41204: rn:R00689','100360621...',true).
concept_name0('41204: rn:R00689','rno:100360621 rno:298483',false).
concept_name0('2839: rn:R08567','rn:R08567',false).
concept_name0('2839: rn:R08567','R08567',true).
concept_name0('41205: rn:R05937','St3gal5, Siat9',true).
concept_name0('41205: rn:R05937','rno:83505',false).
concept_name0('2838: rn:R07160','R07160',true).
concept_name0('2838: rn:R07160','rn:R07160',false).
concept_name0('41206: rn:R03270','rno:117098 rno:289950 rno:29554',false).
concept_name0('41206: rn:R03270','Pdha2, Pdhal...',true).
concept_name0('2837: rn:R08566','rn:R08566',false).
concept_name0('2837: rn:R08566','R08566',true).
concept_name0('41207: rn:R05947','rno:25280 rno:364901',false).
concept_name0('41207: rn:R05947','St8sia1, Siat8, Siat8a...',true).
concept_name0('41200: rn:R01378','Mif, MGC72801',true).
concept_name0('41200: rn:R01378','rno:81683',false).
concept_name0('41201: rn:R00694','rno:24813',false).
concept_name0('41201: rn:R00694','Tat',true).
concept_name0('41202: rn:R00694','rno:24401 rno:25721',false).
concept_name0('41202: rn:R00694','Got1, Aspat, Gaspat...',true).
concept_name0('41203: rn:R00698','Prdx6',true).
concept_name0('41203: rn:R00698','rno:94167',false).
concept_name0('41212: rn:R02613','rno:25750 rno:29253',false).
concept_name0('41212: rn:R02613','Maob...',true).
concept_name0('41213: rn:R02613','rno:29473',false).
concept_name0('41213: rn:R02613','Aoc3, SSAO',true).
concept_name0('41214: rn:R00699','rno:24311',false).
concept_name0('41214: rn:R00699','Ddc, MGC93628',true).
concept_name0('41215: rn:R02530','rno:294320',false).
concept_name0('41215: rn:R02530','Glo1',true).
concept_name0('41208: rn:R05940','St8sia1, Siat8, Siat8a',true).
concept_name0('41208: rn:R05940','rno:25280',false).
concept_name0('41209: rn:R02536 rn:R02537','rno:25375 rno:266603 rno:309147',false).
concept_name0('41209: rn:R02536 rn:R02537','Aldh3a1, AHDC, Ahd-c, Aldh, Aldh3...',true).
concept_name0('41210: rn:R00431 rn:R00726','rno:361042 rno:362282',false).
concept_name0('41210: rn:R00431 rn:R00726','Pck2...',true).
concept_name0('41211: rn:R01372','Hpd',true).
concept_name0('41211: rn:R01372','rno:29531',false).
concept_name0('41091: rn:R07888','rno:50681 rno:83522',false).
concept_name0('41091: rn:R07888','Acox1, RATACOA1...',true).
concept_name0('41090: rn:R01529','rno:501157',false).
concept_name0('41090: rn:R01529','Rpe, MGC124653',true).
concept_name0('41089: rn:R01639','rno:316067',false).
concept_name0('41089: rn:R01639','Xylb, MGC124790',true).
concept_name0('41088: rn:R07055','100364896...',true).
concept_name0('41088: rn:R07055','rno:100364896 rno:171352 rno:171518 rno:171521 rno:24297 rno:246070 rno:25011 rno:25086 rno:252931 rno:25642 rno:266682 rno:29277 rno:29298 rno:293989 rno:313375 rno:502969 rno:65210 rno:687842 rno:83790',false).
concept_name0('41095: rn:R07861','rno:83512',false).
concept_name0('41095: rn:R07861','Fads2, Fadsd6, MGC93365',true).
concept_name0('41094: rn:R01431','Akr1b1, ALDRED, ALR-P-I, Akr1b3, Akr1b4, Aldr1, Alr, RATALDRED',true).
concept_name0('41094: rn:R01431','rno:24192',false).
concept_name0('41093: rn:R01758 rn:R01759','Akr1b1, ALDRED, ALR-P-I, Akr1b3, Akr1b4, Aldr1, Alr, RATALDRED',true).
concept_name0('41093: rn:R01758 rn:R01759','rno:24192',false).
concept_name0('41092: rn:R01904','rno:171408',false).
concept_name0('41092: rn:R01904','Dcxr, glb',true).
concept_name0('41099: rn:R07859','rno:192259 rno:24653 rno:289733 rno:29354 rno:29359 rno:29387 rno:29526 rno:296091 rno:29692 rno:298579 rno:311341 rno:360426 rno:362039 rno:367415 rno:690388 rno:691907',false).
concept_name0('41099: rn:R07859','Plb1, Phlpb...',true).
concept_name0('41098: rn:R01383','rno:113992 rno:154516 rno:24861 rno:24862 rno:266685 rno:286954 rno:289533 rno:29623 rno:301595 rno:305264 rno:396527 rno:396551 rno:396552 rno:574523 rno:63867 rno:83808',false).
concept_name0('41098: rn:R01383','Ugt1a6, MGC124929, UDPGT_1-6, Udpgt, Ugt1, Ugt1a7...',true).
concept_name0('41097: rn:R02640','rno:290277',false).
concept_name0('41097: rn:R02640','Cryl1',true).
concept_name0('41096: rn:R00289','Ugp2',true).
concept_name0('41096: rn:R00289','rno:289827',false).
concept_name0('41103: rn:R00115','rno:116686',false).
concept_name0('41103: rn:R00115','Gsr',true).
concept_name0('41102: rn:R01528','rno:100360180',false).
concept_name0('41102: rn:R01528','100360180',true).
concept_name0('2925: rn:R07399','R07399...',true).
concept_name0('2925: rn:R07399','rn:R07399 rp:RP10723 rc:RC01205',false).
concept_name0('41101: rn:R00670','Odc1, Odc',true).
concept_name0('41101: rn:R00670','rno:24609',false).
concept_name0('41100: rn:R00286','Ugdh',true).
concept_name0('41100: rn:R00286','rno:83472',false).
concept_name0('41106: rn:R03522','rno:114846 rno:171341 rno:24421 rno:24422 rno:24423 rno:24424 rno:24426 rno:25260 rno:289197 rno:29487 rno:295037 rno:297029 rno:300850 rno:309465 rno:363205 rno:494499 rno:494500 rno:499688 rno:499689 rno:501110 rno:57298 rno:64352 rno:681913 rno:81869',false).
concept_name0('41106: rn:R03522','Gsto1, MGC94845...',true).
concept_name0('41107: rn:R07896','rno:50681 rno:83522',false).
concept_name0('41107: rn:R07896','Acox1, RATACOA1...',true).
concept_name0('2928: rn:R00996','rn:R00996 rp:RP01226 rc:RC00418',false).
concept_name0('2928: rn:R00996','R00996...',true).
concept_name0('41104: rn:R06518','Acer3, Phca, RGD1561254',true).
concept_name0('41104: rn:R06518','rno:499210',false).
concept_name0('41105: rn:R07892','rno:50681 rno:83522',false).
concept_name0('41105: rn:R07892','Acox1, RATACOA1...',true).
concept_name0('41110: rn:R03167','Gpx4, Phgpx, gpx-4, snGpx',true).
concept_name0('41110: rn:R03167','rno:29328',false).
concept_name0('41111: rn:R04951','rno:81641',false).
concept_name0('41111: rn:R04951','Anpep, AP-M, AP-N, Apm, Apn, KZP, Lap1, rAPN',true).
concept_name0('6724: rn:R03332','rn:R03332 rp:RP02951 rc:RC00425',false).
concept_name0('6724: rn:R03332','R03332...',true).
concept_name0('41108: rn:R03749','Ggct, RGD1304876, RGD1562590',true).
concept_name0('41108: rn:R03749','rno:362368',false).
concept_name0('41109: rn:R00274','Gpx5...',true).
concept_name0('41109: rn:R00274','rno:113919 rno:24404 rno:259233 rno:29326 rno:294744 rno:298376 rno:64317',false).
concept_name0('41114: rn:R03915 rn:R02824','rno:298370',false).
concept_name0('41114: rn:R03915 rn:R02824','Txndc12, RGD1305960',true).
concept_name0('41115: rn:R00894','rno:25283 rno:29739',false).
concept_name0('41115: rn:R00894','Gclc, Glclc, MGC93096...',true).
concept_name0('41112: rn:R03916','Ggt1, GGLUT, Ggt, Ggtp, RATGGLUT...',true).
concept_name0('41112: rn:R03916','rno:116568 rno:156275 rno:29566 rno:408206',false).
concept_name0('41113: rn:R02736','rno:24377',false).
concept_name0('41113: rn:R02736','G6pd, G6pdx',true).
concept_name0('41118: rn:R00497','Gss',true).
concept_name0('41118: rn:R00497','rno:25458',false).
concept_name0('41119: rn:R02743','Ggct, RGD1304876, RGD1562590',true).
concept_name0('41119: rn:R02743','rno:362368',false).
concept_name0('6732: rn:R03332','rn:R03332 rp:RP02951 rc:RC00425',false).
concept_name0('6732: rn:R03332','R03332...',true).
concept_name0('41116: rn:R00494','Ggt1, GGLUT, Ggt, Ggtp, RATGGLUT...',true).
concept_name0('41116: rn:R00494','rno:116568 rno:156275 rno:29566 rno:408206',false).
concept_name0('41117: rn:R00267','Idh1...',true).
concept_name0('41117: rn:R00267','rno:24479 rno:361596',false).
concept_name0('41121: rn:R00899','rno:81641',false).
concept_name0('41121: rn:R00899','Anpep, AP-M, AP-N, Apm, Apn, KZP, Lap1, rAPN',true).
concept_name0('41120: rn:R01262','Ggt1, GGLUT, Ggt, Ggtp, RATGGLUT...',true).
concept_name0('41120: rn:R01262','rno:116568 rno:156275 rno:29566 rno:408206',false).
concept_name0('41123: rn:R01000','rno:24533 rno:24534 rno:29634 rno:369018 rno:500965',false).
concept_name0('41123: rn:R01000','Ldha, Ldh1...',true).
concept_name0('41122: rn:R00251','Oplah, MGC105359',true).
concept_name0('41122: rn:R00251','rno:116684',false).
concept_name0('41125: rn:R00742','Acacb, Acc2...',true).
concept_name0('41125: rn:R00742','rno:116719 rno:60581',false).
concept_name0('41124: rn:R00233','rno:85239',false).
concept_name0('41124: rn:R00233','Mlycd, Mcd',true).
concept_name0('41127: rn:R04432','rno:24158',false).
concept_name0('41127: rn:R04432','Acadm, MCAD',true).
concept_name0('41126: rn:R00238','rno:25014 rno:308100',false).
concept_name0('41126: rn:R00238','Acat1, RATACAL...',true).
concept_name0('41129: rn:R00432','rno:114597 rno:361071 rno:362404',false).
concept_name0('41129: rn:R00432','Suclg1...',true).
concept_name0('6778: rn:R05378','R05378...',true).
concept_name0('6778: rn:R05378','rn:R05378 rp:RP04984 rp:RP04985 rc:RC00603 rc:RC00721',false).
concept_name0('41128: rn:R00405','rno:114597 rno:361071 rno:362404',false).
concept_name0('41128: rn:R00405','Suclg1...',true).
concept_name0('41131: rn:R02940','rno:24188 rno:291450 rno:29539 rno:29651 rno:298079 rno:64040 rno:65183',false).
concept_name0('41131: rn:R02940','Aldh1a1, Ahd2, Aldh1, Aldh2...',true).
concept_name0('41130: rn:R00833','rno:100361295 rno:688517',false).
concept_name0('41130: rn:R00833','100361295...',true).
concept_name0('41133: rn:R03157 rn:R03158','Hibch',true).
concept_name0('41133: rn:R03157 rn:R03158','rno:301384',false).
concept_name0('41132: rn:R00908','Abat, Gabat, MGC93392, beta-AlaAT',true).
concept_name0('41132: rn:R00908','rno:81632',false).
concept_name0('41135: rn:R00694','rno:24813',false).
concept_name0('41135: rn:R00694','Tat',true).
concept_name0('41134: rn:R00689','100360621...',true).
concept_name0('41134: rn:R00689','rno:100360621 rno:298483',false).
concept_name0('41136: rn:R01795','Pah',true).
concept_name0('41136: rn:R01795','rno:24616',false).
concept_name0('41137: rn:R00729','100360621...',true).
concept_name0('41137: rn:R00729','rno:100360621 rno:298483',false).
concept_name0('41138: rn:R03045','Echs1...',true).
concept_name0('41138: rn:R03045','rno:140547 rno:170670 rno:171142',false).
concept_name0('41139: rn:R00734','rno:24813',false).
concept_name0('41139: rn:R00734','Tat',true).
concept_name0('41140: rn:R00238','rno:25014 rno:308100',false).
concept_name0('41140: rn:R00238','Acat1, RATACAL...',true).
concept_name0('41141: rn:R00935','rno:81708',false).
concept_name0('41141: rn:R00935','Aldh6a1, Mmsdh',true).
concept_name0('41142: rn:R01859','Pccb, MGC93516...',true).
concept_name0('41142: rn:R01859','rno:24624 rno:687008',false).
concept_name0('41143: rn:R02765','Mcee',true).
concept_name0('41143: rn:R02765','rno:293829',false).
concept_name0('41144: rn:R00926','RGD1307051',true).
concept_name0('41144: rn:R00926','rno:314800',false).
concept_name0('41145: rn:R01354','RGD1307051',true).
concept_name0('41145: rn:R01354','rno:314800',false).
concept_name0('41146: rn:R01354','Acss1, Acas2l...',true).
concept_name0('41146: rn:R01354','rno:296259 rno:311569',false).
concept_name0('41147: rn:R00926','Acss1, Acas2l...',true).
concept_name0('41147: rn:R00926','rno:296259 rno:311569',false).
concept_name0('41148: rn:R02765','Mcee',true).
concept_name0('41148: rn:R02765','rno:293829',false).
concept_name0('6767: rn:R04504','R04504...',true).
concept_name0('6767: rn:R04504','rn:R04504 rp:RP11500 rc:RC01938',false).
concept_name0('41149: rn:R01859','Pccb, MGC93516...',true).
concept_name0('41149: rn:R01859','rno:24624 rno:687008',false).
concept_name0('41150: rn:R00833','rno:100361295 rno:688517',false).
concept_name0('41150: rn:R00833','100361295...',true).
concept_name0('41151: rn:R03288','rno:307212',false).
concept_name0('41151: rn:R03288','Cndp1, MGC93742',true).
concept_name0('3286: rn:R04443','rn:R04443 rp:RP04081 rc:RC01156',false).
concept_name0('3286: rn:R04443','R04443...',true).
concept_name0('7673: rn:R00203','R00203...',true).
concept_name0('7673: rn:R00203','rn:R00203 rp:RP00283 rc:RC00104',false).
concept_name0('7672: rn:R01016','R01016...',true).
concept_name0('7672: rn:R01016','rn:R01016 rp:RP01239 rc:RC00424',false).
concept_name0('7674: rn:R00203','R00203...',true).
concept_name0('7674: rn:R00203','rn:R00203 rp:RP00283 rc:RC00104',false).
concept_name0('3228: rn:R04870','R04870...',true).
concept_name0('3228: rn:R04870','rn:R04870 rp:RP04484 rp:RP04485 rp:RP04486 rc:RC01227 rc:RC01228 rc:RC00090',false).
concept_name0('3236: rn:R03249','R03249...',true).
concept_name0('3236: rn:R03249','rn:R03249 rp:RP02877 rc:RC00890',false).
concept_name0('3246: rn:R03314','R03314...',true).
concept_name0('3246: rn:R03314','rn:R03314 rp:RP02935 rc:RC00694',false).
concept_name0('11808: rn:R01930','R01930...',true).
concept_name0('11808: rn:R01930','rn:R01930 rp:RP01853 rc:RC00625',false).
concept_name0('11809: rn:R00897','R00897...',true).
concept_name0('11809: rn:R00897','rn:R00897 rp:RP00050 rc:RC00020',false).
concept_name0('3137: rn:R03284','rn:R03284 rp:RP02913 rp:RP02914 rc:RC00312 rc:RC00721',false).
concept_name0('3137: rn:R03284','R03284...',true).
concept_name0('11800: rn:R08553','rn:R08553',false).
concept_name0('11800: rn:R08553','R08553',true).
concept_name0('11797: rn:R02021','rn:R02021',false).
concept_name0('11797: rn:R02021','R02021',true).
concept_name0('11784: rn:R00897','R00897...',true).
concept_name0('11784: rn:R00897','rn:R00897 rp:RP00050 rc:RC00020',false).
concept_name0('11778: rn:R01339','rn:R01339',false).
concept_name0('11778: rn:R01339','R01339',true).
concept_name0('11779: rn:R00485','R00485...',true).
concept_name0('11779: rn:R00485','rn:R00485 rp:RP00116 rc:RC00010',false).
concept_name0('7457: rn:R06198','rn:R06198',false).
concept_name0('7457: rn:R06198','R06198',true).
concept_name0('7456: rn:R06192','R06192',true).
concept_name0('7456: rn:R06192','rn:R06192',false).
concept_name0('7461: rn:R06097','rn:R06097',false).
concept_name0('7461: rn:R06097','R06097',true).
concept_name0('3122: rn:R00462','rn:R00462 rp:RP00913 rc:RC00299',false).
concept_name0('3122: rn:R00462','R00462...',true).
concept_name0('3532: rn:R03286','rn:R03286 rp:RP00245 rc:RC00064',false).
concept_name0('3532: rn:R03286','R03286...',true).
concept_name0('3471: rn:R05465','rn:R05465 rp:RP10848 rc:RC00215',false).
concept_name0('3471: rn:R05465','R05465...',true).
concept_name0('3501: rn:R03288','R03288...',true).
concept_name0('3501: rn:R03288','rn:R03288 rp:RP00245 rc:RC00064',false).
concept_name0('3502: rn:R02144','rn:R02144 rp:RP01997 rc:RC00333',false).
concept_name0('3502: rn:R02144','R02144...',true).
concept_name0('7303: rn:R06526','rn:R06526 rp:RP05669 rc:RC00773',false).
concept_name0('7303: rn:R06526','R06526...',true).
concept_name0('7304: rn:R06525','rn:R06525 rp:RP05668 rc:RC00773',false).
concept_name0('7304: rn:R06525','R06525...',true).
concept_name0('7309: rn:R02542','R02542...',true).
concept_name0('7309: rn:R02542','rn:R02542 rp:RP02290 rc:RC00425',false).
concept_name0('3406: rn:R00671','R00671...',true).
concept_name0('3406: rn:R00671','rn:R00671 rp:RP01044 rc:RC00354',false).
concept_name0('3401: rn:R00131','R00131',true).
concept_name0('3401: rn:R00131','rn:R00131',false).
concept_name0('3398: rn:R01987','rn:R01987 rp:RP01893 rc:RC00096',false).
concept_name0('3398: rn:R01987','R01987...',true).
concept_name0('3423: rn:R01915','R01915...',true).
concept_name0('3423: rn:R01915','rn:R01915 rp:RP00643 rc:RC00225',false).
concept_name0('3432: rn:R02280','R02280...',true).
concept_name0('3432: rn:R02280','rn:R02280 rp:RP02098 rc:RC00679',false).
concept_name0('3428: rn:R03296','rn:R03296 rp:RP02920 rc:RC00479',false).
concept_name0('3428: rn:R03296','R03296...',true).
concept_name0('3453: rn:R07245','rn:R07245 rp:RP11135 rc:RC00096',false).
concept_name0('3453: rn:R07245','R07245...',true).
concept_name0('3343: rn:R00471','rn:R00471 rp:RP00919 rp:RP00920 rc:RC00307 rc:RC00308',false).
concept_name0('3343: rn:R00471','R00471...',true).
concept_name0('3330: rn:R01246 rn:R01249','rn:R01246 rn:R01249 rp:RP00597 rp:RP00597 rc:RC00135 rc:RC00135',false).
concept_name0('3330: rn:R01246 rn:R01249','R01246...',true).
concept_name0('3329: rn:R01255','rn:R01255 rp:RP01387 rc:RC00479',false).
concept_name0('3329: rn:R01255','R01255...',true).
concept_name0('3353: rn:R01566','rn:R01566 rp:RP01598 rp:RP01599 rc:RC00548 rc:RC00549',false).
concept_name0('3353: rn:R01566','R01566...',true).
concept_name0('3359: rn:R08197','R08197...',true).
concept_name0('3359: rn:R08197','rn:R08197 rp:RP12924 rc:RC00006',false).
concept_name0('3345: rn:R00471','rn:R00471 rp:RP00919 rp:RP00920 rc:RC00307 rc:RC00308',false).
concept_name0('3345: rn:R00471','R00471...',true).
concept_name0('3344: rn:R00471','rn:R00471 rp:RP00919 rp:RP00920 rc:RC00307 rc:RC00308',false).
concept_name0('3344: rn:R00471','R00471...',true).
concept_name0('7206: rn:R07063','R07063...',true).
concept_name0('7206: rn:R07063','rn:R07063 rp:RP10140 rc:RC00917',false).
concept_name0('3379: rn:R07414','R07414...',true).
concept_name0('3379: rn:R07414','rn:R07414 rp:RP10760 rp:RP10975 rc:RC00090 rc:RC00096',false).
concept_name0('7173: rn:R02264','R02264...',true).
concept_name0('7173: rn:R02264','rn:R02264 rp:RP02083 rc:RC00671',false).
concept_name0('3839: rn:R09090','R09090',true).
concept_name0('3839: rn:R09090','rn:R09090',false).
concept_name0('3785: rn:R03341','R03341...',true).
concept_name0('3785: rn:R03341','rn:R03341 rp:RP02956 rc:RC00506',false).
concept_name0('3699: rn:R02520','R02520...',true).
concept_name0('3699: rn:R02520','rn:R02520 rp:RP00564 rc:RC00198',false).
concept_name0('3694: rn:R00042','R00042...',true).
concept_name0('3694: rn:R00042','rn:R00042 rp:RP03014 rc:RC00866',false).
concept_name0('3652: rn:R02384','R02384...',true).
concept_name0('3652: rn:R02384','rn:R02384 rp:RP02172 rc:RC00060',false).
concept_name0('7951: rn:R00228','rn:R00228 rp:RP04321 rc:RC01195',false).
concept_name0('7951: rn:R00228','R00228...',true).
concept_name0('3646: rn:R02514 rn:R02516','rn:R02514 rn:R02516 rp:RP00544 rp:RP00544 rc:RC00193 rc:RC00193',false).
concept_name0('3646: rn:R02514 rn:R02516','R02514...',true).
concept_name0('3642: rn:R02698','R02698...',true).
concept_name0('3642: rn:R02698','rn:R02698 rp:RP02416 rc:RC00046',false).
concept_name0('3638: rn:R02518','rn:R02518',false).
concept_name0('3638: rn:R02518','R02518',true).
concept_name0('3635: rn:R02489','rn:R02489 rp:RP02253 rc:RC00390',false).
concept_name0('3635: rn:R02489','R02489...',true).
concept_name0('7936: rn:R00750','R00750...',true).
concept_name0('7936: rn:R00750','rn:R00750 rp:RP01083 rp:RP01084 rc:RC00307 rc:RC00371',false).
concept_name0('3596: rn:R03672','rn:R03672 rp:RP03299 rc:RC00180',false).
concept_name0('3596: rn:R03672','R03672...',true).
concept_name0('3598: rn:R03674','rn:R03674 rp:RP03301 rc:RC00972',false).
concept_name0('3598: rn:R03674','R03674...',true).
concept_name0('11691: rn:R00490','rn:R00490',false).
concept_name0('11691: rn:R00490','R00490',true).
concept_name0('11694: rn:R00482','rn:R00482 rp:RP00116 rc:RC00010',false).
concept_name0('11694: rn:R00482','R00482...',true).
concept_name0('11693: rn:R00483','R00483...',true).
concept_name0('11693: rn:R00483','rn:R00483 rp:RP00116 rc:RC00010',false).
concept_name0('11692: rn:R00490','rn:R00490',false).
concept_name0('11692: rn:R00490','R00490',true).
concept_name0('11734: rn:R00493','rn:R00493',false).
concept_name0('11734: rn:R00493','R00493',true).
concept_name0('7859: rn:R00228','rn:R00228 rp:RP04321 rc:RC01195',false).
concept_name0('7859: rn:R00228','R00228...',true).
concept_name0('11774: rn:R00524','R00524...',true).
concept_name0('11774: rn:R00524','rn:R00524 rp:RP00955 rc:RC02432',false).
concept_name0('11522: rn:R07260','rn:R07260 rp:RP00012 rp:RP11953 rc:RC00005 rc:RC00059',false).
concept_name0('11522: rn:R07260','R07260...',true).
concept_name0('3943: rn:R06790','R06790...',true).
concept_name0('3943: rn:R06790','rn:R06790 rp:RP09197 rc:RC00490',false).
concept_name0('3961: rn:R05487','R05487...',true).
concept_name0('3961: rn:R05487','rn:R05487 rp:RP05085 rc:RC00046',false).
concept_name0('7745: rn:R00230','rn:R00230',false).
concept_name0('7745: rn:R00230','R00230',true).
concept_name0('3953: rn:R01377','R01377...',true).
concept_name0('3953: rn:R01377','rn:R01377 rp:RP01466 rc:RC00506',false).
concept_name0('7744: rn:R00753','rn:R00753 rp:RP01088 rc:RC00374',false).
concept_name0('7744: rn:R00753','R00753...',true).
concept_name0('7780: rn:R00750','R00750...',true).
concept_name0('7780: rn:R00750','rn:R00750 rp:RP01083 rp:RP01084 rc:RC00307 rc:RC00371',false).
concept_name0('11596: rn:R08052','R08052...',true).
concept_name0('11596: rn:R08052','rn:R08052 rp:RP10594 rc:RC00121',false).
concept_name0('11597: rn:R08051','rn:R08051 rp:RP10497 rc:RC00121',false).
concept_name0('11597: rn:R08051','R08051...',true).
concept_name0('7705: rn:R03145','R03145...',true).
concept_name0('7705: rn:R03145','rn:R03145 rp:RP02797 rc:RC00860',false).
concept_name0('7706: rn:R00207','rn:R00207',false).
concept_name0('7706: rn:R00207','R00207',true).
concept_name0('11595: rn:R04038','rn:R04038 rp:RP03664 rc:RC00121',false).
concept_name0('11595: rn:R04038','R04038...',true).
concept_name0('7707: rn:R00230','rn:R00230',false).
concept_name0('7707: rn:R00230','R00230',true).
concept_name0('7701: rn:R00472','rn:R00472',false).
concept_name0('7701: rn:R00472','R00472',true).
concept_name0('11591: rn:R08076','R08076...',true).
concept_name0('11591: rn:R08076','rn:R08076 rp:RP00012 rp:RP11359 rc:RC00005 rc:RC00059',false).
concept_name0('3875: rn:R02540','rn:R02540 rp:RP02287 rc:RC00010',false).
concept_name0('3875: rn:R02540','R02540...',true).
concept_name0('7692: rn:R00212','rn:R00212 rp:RP04232 rc:RC01181',false).
concept_name0('7692: rn:R00212','R00212...',true).
concept_name0('7695: rn:R01196','rn:R01196',false).
concept_name0('7695: rn:R01196','R01196',true).
concept_name0('7694: rn:R00211','rn:R00211',false).
concept_name0('7694: rn:R00211','R00211',true).
concept_name0('7687: rn:R01450','rn:R01450 rp:RP01518 rc:RC00519',false).
concept_name0('7687: rn:R01450','R01450...',true).
concept_name0('11600: rn:R03726','rn:R03726 rp:RP00058 rp:RP03351 rc:RC00021 rc:RC00986',false).
concept_name0('11600: rn:R03726','R03726...',true).
concept_name0('11603: rn:R02118','R02118...',true).
concept_name0('11603: rn:R02118','rn:R02118 rp:RP00012 rp:RP01980 rc:RC00005 rc:RC00059',false).
concept_name0('11602: rn:R02119','R02119...',true).
concept_name0('11602: rn:R02119','rn:R02119 rp:RP00087 rp:RP01981 rc:RC00005 rc:RC00059',false).
concept_name0('7743: rn:R00319','R00319...',true).
concept_name0('7743: rn:R00319','rn:R00319 rp:RP04861 rc:RC01312',false).
concept_name0('7737: rn:R00205','rn:R00205 rp:RP00283 rc:RC00104',false).
concept_name0('7737: rn:R00205','R00205...',true).
concept_name0('3842: rn:R00750','R00750...',true).
concept_name0('3842: rn:R00750','rn:R00750 rp:RP01083 rp:RP01084 rc:RC00307 rc:RC00371',false).
concept_name0('3862: rn:R01377','R01377...',true).
concept_name0('3862: rn:R01377','rn:R01377 rp:RP01466 rc:RC00506',false).
concept_name0('7717: rn:R00228','rn:R00228 rp:RP04321 rc:RC01195',false).
concept_name0('7717: rn:R00228','R00228...',true).
concept_name0('36906: gl:G00111','G00111',true).
concept_name0('36906: gl:G00111','gl:G00111',false).
concept_name0('36905: cpd:C00957','C00957',true).
concept_name0('36905: cpd:C00957','cpd:C00957',false).
concept_name0('36911: gl:G00124','G00124',true).
concept_name0('36911: gl:G00124','gl:G00124',false).
concept_name0('36909: cpd:C00458','C00458',true).
concept_name0('36909: cpd:C00458','cpd:C00458',false).
concept_name0('36908: gl:G00112','G00112',true).
concept_name0('36908: gl:G00112','gl:G00112',false).
concept_name0('36897: cpd:C00063','C00063',true).
concept_name0('36897: cpd:C00063','cpd:C00063',false).
concept_name0('36896: cpd:C00208','cpd:C00208',false).
concept_name0('36896: cpd:C00208','C00208',true).
concept_name0('36903: cpd:C00295','cpd:C00295',false).
concept_name0('36903: cpd:C00295','C00295',true).
concept_name0('39100: gl:G00027','G00027',true).
concept_name0('39100: gl:G00027','gl:G00027',false).
concept_name0('39075: gl:G00010','G00010',true).
concept_name0('39075: gl:G00010','gl:G00010',false).
concept_name0('36923: gl:G00109','gl:G00109',false).
concept_name0('36923: gl:G00109','G00109',true).
concept_name0('36920: gl:G00108','gl:G00108',false).
concept_name0('36920: gl:G00108','G00108',true).
concept_name0('36925: gl:G00110','G00110',true).
concept_name0('36925: gl:G00110','gl:G00110',false).
concept_name0('36914: gl:G00123','G00123',true).
concept_name0('36914: gl:G00123','gl:G00123',false).
concept_name0('36915: cpd:C00721','cpd:C00721',false).
concept_name0('36915: cpd:C00721','C00721',true).
concept_name0('36913: cpd:C00705','C00705',true).
concept_name0('36913: cpd:C00705','cpd:C00705',false).
concept_name0('36918: cpd:C01083','C01083',true).
concept_name0('36918: cpd:C01083','cpd:C01083',false).
concept_name0('36919: cpd:C05670','cpd:C05670',false).
concept_name0('36919: cpd:C05670','C05670',true).
concept_name0('36916: cpd:C00239','cpd:C00239',false).
concept_name0('36916: cpd:C00239','C00239',true).
concept_name0('36917: gl:G00113','G00113',true).
concept_name0('36917: gl:G00113','gl:G00113',false).
concept_name0('36873: cpd:C00664','C00664',true).
concept_name0('36873: cpd:C00664','cpd:C00664',false).
concept_name0('36872: cpd:C16550','cpd:C16550',false).
concept_name0('36872: cpd:C16550','C16550',true).
concept_name0('36875: cpd:C05476','C05476',true).
concept_name0('36875: cpd:C05476','cpd:C05476',false).
concept_name0('36874: cpd:C03479','C03479',true).
concept_name0('36874: cpd:C03479','cpd:C03479',false).
concept_name0('36877: cpd:C01780','C01780',true).
concept_name0('36877: cpd:C01780','cpd:C01780',false).
concept_name0('36878: cpd:C00632','cpd:C00632',false).
concept_name0('36878: cpd:C00632','C00632',true).
concept_name0('36865: cpd:C02538','cpd:C02538',false).
concept_name0('36865: cpd:C02538','C02538',true).
concept_name0('36864: cpd:C05488','C05488',true).
concept_name0('36864: cpd:C05488','cpd:C05488',false).
concept_name0('36867: cpd:C07643','cpd:C07643',false).
concept_name0('36867: cpd:C07643','C07643',true).
concept_name0('36869: cpd:C11554','cpd:C11554',false).
concept_name0('36869: cpd:C11554','C11554',true).
concept_name0('36868: cpd:C02140','C02140',true).
concept_name0('36868: cpd:C02140','cpd:C02140',false).
concept_name0('36871: gl:G12396','G12396',true).
concept_name0('36871: gl:G12396','gl:G12396',false).
concept_name0('36870: cpd:C07644','C07644',true).
concept_name0('36870: cpd:C07644','cpd:C07644',false).
concept_name0('36889: gl:G00117','gl:G00117',false).
concept_name0('36889: gl:G00117','G00117',true).
concept_name0('36890: cpd:C01231','C01231',true).
concept_name0('36890: cpd:C01231','cpd:C01231',false).
concept_name0('36891: gl:G00116','G00116',true).
concept_name0('36891: gl:G00116','gl:G00116',false).
concept_name0('36893: gl:G00114','G00114',true).
concept_name0('36893: gl:G00114','gl:G00114',false).
concept_name0('36894: cpd:C05823','C05823',true).
concept_name0('36894: cpd:C05823','cpd:C05823',false).
concept_name0('36880: cpd:C01176','cpd:C01176',false).
concept_name0('36880: cpd:C01176','C01176',true).
concept_name0('36881: cpd:C03205','C03205',true).
concept_name0('36881: cpd:C03205','cpd:C03205',false).
concept_name0('36883: cpd:C00166','cpd:C00166',false).
concept_name0('36883: cpd:C00166','C00166',true).
concept_name0('36884: cpd:C03681','C03681',true).
concept_name0('36884: cpd:C03681','cpd:C03681',false).
concept_name0('36886: cpd:C00410','cpd:C00410',false).
concept_name0('36886: cpd:C00410','C00410',true).
concept_name0('36975: gl:G00125','G00125',true).
concept_name0('36975: gl:G00125','gl:G00125',false).
concept_name0('36974: cpd:C05335','C05335',true).
concept_name0('36974: cpd:C05335','cpd:C05335',false).
concept_name0('36973: cpd:C14874','C14874',true).
concept_name0('36973: cpd:C14874','cpd:C14874',false).
concept_name0('36972: cpd:C05688','C05688',true).
concept_name0('36972: cpd:C05688','cpd:C05688',false).
concept_name0('36970: cpd:C01159','cpd:C01159',false).
concept_name0('36970: cpd:C01159','C01159',true).
concept_name0('36967: cpd:C05689','C05689',true).
concept_name0('36967: cpd:C05689','cpd:C05689',false).
concept_name0('36965: cpd:C05100','cpd:C05100',false).
concept_name0('36965: cpd:C05100','C05100',true).
concept_name0('36964: cpd:C00469','C00469',true).
concept_name0('36964: cpd:C00469','cpd:C00469',false).
concept_name0('36962: cpd:C05145','cpd:C05145',false).
concept_name0('36962: cpd:C05145','C05145',true).
concept_name0('36990: cpd:C00672','C00672',true).
concept_name0('36990: cpd:C00672','cpd:C00672',false).
concept_name0('36988: cpd:C06899','cpd:C06899',false).
concept_name0('36988: cpd:C06899','C06899',true).
concept_name0('36989: cpd:C05703','cpd:C05703',false).
concept_name0('36989: cpd:C05703','C05703',true).
concept_name0('36986: cpd:C14869','cpd:C14869',false).
concept_name0('36986: cpd:C14869','C14869',true).
concept_name0('36987: cpd:C00364','cpd:C00364',false).
concept_name0('36987: cpd:C00364','C00364',true).
concept_name0('36984: cpd:C00214','C00214',true).
concept_name0('36984: cpd:C00214','cpd:C00214',false).
concept_name0('36982: cpd:C00459','cpd:C00459',false).
concept_name0('36982: cpd:C00459','C00459',true).
concept_name0('36983: cpd:C11088','C11088',true).
concept_name0('36983: cpd:C11088','cpd:C11088',false).
concept_name0('36980: cpd:C02218','cpd:C02218',false).
concept_name0('36980: cpd:C02218','C02218',true).
concept_name0('36981: cpd:C14870','cpd:C14870',false).
concept_name0('36981: cpd:C14870','C14870',true).
concept_name0('36978: cpd:C05336','C05336',true).
concept_name0('36978: cpd:C05336','cpd:C05336',false).
concept_name0('36979: cpd:C00363','cpd:C00363',false).
concept_name0('36979: cpd:C00363','C00363',true).
concept_name0('36976: cpd:C05698','cpd:C05698',false).
concept_name0('36976: cpd:C05698','C05698',true).
concept_name0('36977: cpd:C14871','C14871',true).
concept_name0('36977: cpd:C14871','cpd:C14871',false).
concept_name0('36941: cpd:C05379','cpd:C05379',false).
concept_name0('36941: cpd:C05379','C05379',true).
concept_name0('36940: cpd:C05527','C05527',true).
concept_name0('36940: cpd:C05527','cpd:C05527',false).
concept_name0('36942: cpd:C00365','cpd:C00365',false).
concept_name0('36942: cpd:C00365','C00365',true).
concept_name0('36936: cpd:C00881','C00881',true).
concept_name0('36936: cpd:C00881','cpd:C00881',false).
concept_name0('39122: gl:G00026','G00026',true).
concept_name0('39122: gl:G00026','gl:G00026',false).
concept_name0('36938: cpd:C01346','cpd:C01346',false).
concept_name0('36938: cpd:C01346','C01346',true).
concept_name0('36933: cpd:C00526','cpd:C00526',false).
concept_name0('36933: cpd:C00526','C00526',true).
concept_name0('36932: cpd:C18904','C18904',true).
concept_name0('36932: cpd:C18904','cpd:C18904',false).
concept_name0('39135: gl:G10611','gl:G10611',false).
concept_name0('39135: gl:G10611','G10611',true).
concept_name0('36935: cpd:C02763','C02763',true).
concept_name0('36935: cpd:C02763','cpd:C02763',false).
concept_name0('36934: cpd:C14859','cpd:C14859',false).
concept_name0('36934: cpd:C14859','C14859',true).
concept_name0('36929: cpd:C00460','cpd:C00460',false).
concept_name0('36929: cpd:C00460','C00460',true).
concept_name0('39128: gl:G00031','G00031',true).
concept_name0('39128: gl:G00031','gl:G00031',false).
concept_name0('39130: gl:G00032','G00032',true).
concept_name0('39130: gl:G00032','gl:G00032',false).
concept_name0('36930: cpd:C18902','C18902',true).
concept_name0('36930: cpd:C18902','cpd:C18902',false).
concept_name0('36956: cpd:C05172','C05172',true).
concept_name0('36956: cpd:C05172','cpd:C05172',false).
concept_name0('36958: cpd:C05684','cpd:C05684',false).
concept_name0('36958: cpd:C05684','C05684',true).
concept_name0('36959: cpd:C00906','C00906',true).
concept_name0('36959: cpd:C00906','cpd:C00906',false).
concept_name0('39104: gl:G00028','gl:G00028',false).
concept_name0('39104: gl:G00028','G00028',true).
concept_name0('36952: cpd:C00475','C00475',true).
concept_name0('36952: cpd:C00475','cpd:C00475',false).
concept_name0('39106: gl:G00029','gl:G00029',false).
concept_name0('39106: gl:G00029','G00029',true).
concept_name0('36954: gl:G00115','G00115',true).
concept_name0('36954: gl:G00115','gl:G00115',false).
concept_name0('36955: cpd:C00178','cpd:C00178',false).
concept_name0('36955: cpd:C00178','C00178',true).
concept_name0('36948: cpd:C00055','C00055',true).
concept_name0('36948: cpd:C00055','cpd:C00055',false).
concept_name0('36949: cpd:C00112','cpd:C00112',false).
concept_name0('36949: cpd:C00112','C00112',true).
concept_name0('36950: cpd:C01962','C01962',true).
concept_name0('36950: cpd:C01962','cpd:C01962',false).
concept_name0('39119: gl:G00025','G00025',true).
concept_name0('39119: gl:G00025','gl:G00025',false).
concept_name0('36951: cpd:C16254','C16254',true).
concept_name0('36951: cpd:C16254','cpd:C16254',false).
concept_name0('39112: gl:G00035','gl:G00035',false).
concept_name0('39112: gl:G00035','G00035',true).
concept_name0('36945: cpd:C00491','C00491',true).
concept_name0('36945: cpd:C00491','cpd:C00491',false).
concept_name0('36946: cpd:C05686','cpd:C05686',false).
concept_name0('36946: cpd:C05686','C05686',true).
concept_name0('39115: gl:G00023','G00023',true).
concept_name0('39115: gl:G00023','gl:G00023',false).
concept_name0('37026: cpd:C03406','C03406',true).
concept_name0('37026: cpd:C03406','cpd:C03406',false).
concept_name0('37027: cpd:C05993','C05993',true).
concept_name0('37027: cpd:C05993','cpd:C05993',false).
concept_name0('37024: cpd:C14856','C14856',true).
concept_name0('37024: cpd:C14856','cpd:C14856',false).
concept_name0('37025: cpd:C01097','C01097',true).
concept_name0('37025: cpd:C01097','cpd:C01097',false).
concept_name0('37031: cpd:C06205','cpd:C06205',false).
concept_name0('37031: cpd:C06205','C06205',true).
concept_name0('37028: cpd:C03785','C03785',true).
concept_name0('37028: cpd:C03785','cpd:C03785',false).
concept_name0('37029: cpd:C14853','C14853',true).
concept_name0('37029: cpd:C14853','cpd:C14853',false).
concept_name0('37035: cpd:C11821','cpd:C11821',false).
concept_name0('37035: cpd:C11821','C11821',true).
concept_name0('37038: cpd:C05402','C05402',true).
concept_name0('37038: cpd:C05402','cpd:C05402',false).
concept_name0('37039: cpd:C14556','C14556',true).
concept_name0('37039: cpd:C14556','cpd:C14556',false).
concept_name0('37037: cpd:C14784','C14784',true).
concept_name0('37037: cpd:C14784','cpd:C14784',false).
concept_name0('37042: cpd:C12248','C12248',true).
concept_name0('37042: cpd:C12248','cpd:C12248',false).
concept_name0('37045: cpd:C14850','cpd:C14850',false).
concept_name0('37045: cpd:C14850','C14850',true).
concept_name0('37054: gl:G00126','G00126',true).
concept_name0('37054: gl:G00126','gl:G00126',false).
concept_name0('36993: cpd:C01061','C01061',true).
concept_name0('36993: cpd:C01061','cpd:C01061',false).
concept_name0('36994: cpd:C01036','C01036',true).
concept_name0('36994: cpd:C01036','cpd:C01036',false).
concept_name0('36995: cpd:C00299','cpd:C00299',false).
concept_name0('36995: cpd:C00299','C00299',true).
concept_name0('36997: cpd:C14868','C14868',true).
concept_name0('36997: cpd:C14868','cpd:C14868',false).
concept_name0('36999: cpd:C14863','C14863',true).
concept_name0('36999: cpd:C14863','cpd:C14863',false).
concept_name0('37000: cpd:C00544','cpd:C00544',false).
concept_name0('37000: cpd:C00544','C00544',true).
concept_name0('37002: cpd:C14861','C14861',true).
concept_name0('37002: cpd:C14861','cpd:C14861',false).
concept_name0('37004: cpd:C14865','cpd:C14865',false).
concept_name0('37004: cpd:C14865','C14865',true).
concept_name0('37005: cpd:C14864','C14864',true).
concept_name0('37005: cpd:C14864','cpd:C14864',false).
concept_name0('37006: cpd:C00804','C00804',true).
concept_name0('37006: cpd:C00804','cpd:C00804',false).
concept_name0('37007: cpd:C14858','cpd:C14858',false).
concept_name0('37007: cpd:C14858','C14858',true).
concept_name0('37009: cpd:C00337','cpd:C00337',false).
concept_name0('37009: cpd:C00337','C00337',true).
concept_name0('37008: cpd:C14857','C14857',true).
concept_name0('37008: cpd:C14857','cpd:C14857',false).
concept_name0('37010: cpd:C01528','C01528',true).
concept_name0('37010: cpd:C01528','cpd:C01528',false).
concept_name0('37013: cpd:C01103','cpd:C01103',false).
concept_name0('37013: cpd:C01103','C01103',true).
concept_name0('37012: cpd:C05697','C05697',true).
concept_name0('37012: cpd:C05697','cpd:C05697',false).
concept_name0('37015: cpd:C14851','cpd:C14851',false).
concept_name0('37015: cpd:C14851','C14851',true).
concept_name0('37017: cpd:C14855','C14855',true).
concept_name0('37017: cpd:C14855','cpd:C14855',false).
concept_name0('37016: cpd:C00243','cpd:C00243',false).
concept_name0('37016: cpd:C00243','C00243',true).
concept_name0('37019: cpd:C14852','cpd:C14852',false).
concept_name0('37019: cpd:C14852','C14852',true).
concept_name0('37023: cpd:C01697','cpd:C01697',false).
concept_name0('37023: cpd:C01697','C01697',true).
concept_name0('37022: cpd:C14854','C14854',true).
concept_name0('37022: cpd:C14854','cpd:C14854',false).
concept_name0('37093: cpd:C05273','cpd:C05273',false).
concept_name0('37093: cpd:C05273','C05273',true).
concept_name0('37090: cpd:C17938','C17938',true).
concept_name0('37090: cpd:C17938','cpd:C17938',false).
concept_name0('37091: gl:G00103','G00103',true).
concept_name0('37091: gl:G00103','gl:G00103',false).
concept_name0('37089: cpd:C14847','cpd:C14847',false).
concept_name0('37089: cpd:C14847','C14847',true).
concept_name0('37102: cpd:C15978','C15978',true).
concept_name0('37102: cpd:C15978','cpd:C15978',false).
concept_name0('37100: cpd:C05381','cpd:C05381',false).
concept_name0('37100: cpd:C05381','C05381',true).
concept_name0('37101: gl:G00098','G00098',true).
concept_name0('37101: gl:G00098','gl:G00098',false).
concept_name0('37098: cpd:C02593','C02593',true).
concept_name0('37098: cpd:C02593','cpd:C02593',false).
concept_name0('37111: gl:G00099','G00099',true).
concept_name0('37111: gl:G00099','gl:G00099',false).
concept_name0('37110: cpd:C14801','cpd:C14801',false).
concept_name0('37110: cpd:C14801','C14801',true).
concept_name0('37109: cpd:C05272','cpd:C05272',false).
concept_name0('37109: cpd:C05272','C05272',true).
concept_name0('37106: gl:G00097','G00097',true).
concept_name0('37106: gl:G00097','gl:G00097',false).
concept_name0('37104: gl:G00104','G00104',true).
concept_name0('37104: gl:G00104','gl:G00104',false).
concept_name0('37119: cpd:C01042','cpd:C01042',false).
concept_name0('37119: cpd:C01042','C01042',true).
concept_name0('37117: cpd:C05260','cpd:C05260',false).
concept_name0('37117: cpd:C05260','C05260',true).
concept_name0('37115: cpd:C05261','cpd:C05261',false).
concept_name0('37115: cpd:C05261','C05261',true).
concept_name0('37114: cpd:C14848','cpd:C14848',false).
concept_name0('37114: cpd:C14848','C14848',true).
concept_name0('37112: cpd:C00402','cpd:C00402',false).
concept_name0('37112: cpd:C00402','C00402',true).
concept_name0('37063: cpd:C15974','C15974',true).
concept_name0('37063: cpd:C15974','cpd:C15974',false).
concept_name0('37058: gl:G00119','gl:G00119',false).
concept_name0('37058: gl:G00119','G00119',true).
concept_name0('37059: gl:G00118','gl:G00118',false).
concept_name0('37059: gl:G00118','G00118',true).
concept_name0('37065: gl:G00120','G00120',true).
concept_name0('37065: gl:G00120','gl:G00120',false).
concept_name0('38995: cpd:C05443','cpd:C05443',false).
concept_name0('38995: cpd:C05443','C05443',true).
concept_name0('37079: cpd:C15976','C15976',true).
concept_name0('37079: cpd:C15976','cpd:C15976',false).
concept_name0('37075: gl:G00127','G00127',true).
concept_name0('37075: gl:G00127','gl:G00127',false).
concept_name0('37084: gl:G00128','G00128',true).
concept_name0('37084: gl:G00128','gl:G00128',false).
concept_name0('37087: cpd:C14845','C14845',true).
concept_name0('37087: cpd:C14845','cpd:C14845',false).
concept_name0('37081: gl:G00129','G00129',true).
concept_name0('37081: gl:G00129','gl:G00129',false).
concept_name0('37177: cpd:C05581','cpd:C05581',false).
concept_name0('37177: cpd:C05581','C05581',true).
concept_name0('37179: cpd:C05966','C05966',true).
concept_name0('37179: cpd:C05966','cpd:C05966',false).
concept_name0('37180: cpd:C00294','cpd:C00294',false).
concept_name0('37180: cpd:C00294','C00294',true).
concept_name0('37181: cpd:C04043','C04043',true).
concept_name0('37181: cpd:C04043','cpd:C04043',false).
concept_name0('37183: cpd:C00130','cpd:C00130',false).
concept_name0('37183: cpd:C00130','C00130',true).
concept_name0('37168: cpd:C05583','cpd:C05583',false).
concept_name0('37168: cpd:C05583','C05583',true).
concept_name0('37169: cpd:C05582','cpd:C05582',false).
concept_name0('37169: cpd:C05582','C05582',true).
concept_name0('37172: cpd:C05956','C05956',true).
concept_name0('37172: cpd:C05956','cpd:C05956',false).
concept_name0('37173: cpd:C01161','C01161',true).
concept_name0('37173: cpd:C01161','cpd:C01161',false).
concept_name0('37175: cpd:C00262','C00262',true).
concept_name0('37175: cpd:C00262','cpd:C00262',false).
concept_name0('37160: cpd:C05580','cpd:C05580',false).
concept_name0('37160: cpd:C05580','C05580',true).
concept_name0('37163: cpd:C05584','cpd:C05584',false).
concept_name0('37163: cpd:C05584','C05584',true).
concept_name0('37162: cpd:C00639','C00639',true).
concept_name0('37162: cpd:C00639','cpd:C00639',false).
concept_name0('37165: cpd:C00427','C00427',true).
concept_name0('37165: cpd:C00427','cpd:C00427',false).
concept_name0('37166: cpd:C00212','C00212',true).
concept_name0('37166: cpd:C00212','cpd:C00212',false).
concept_name0('37153: cpd:C00206','cpd:C00206',false).
concept_name0('37153: cpd:C00206','C00206',true).
concept_name0('37152: cpd:C02166','cpd:C02166',false).
concept_name0('37152: cpd:C02166','C02166',true).
concept_name0('37154: cpd:C00547','cpd:C00547',false).
concept_name0('37154: cpd:C00547','C00547',true).
concept_name0('37156: cpd:C05284','cpd:C05284',false).
concept_name0('37156: cpd:C05284','C05284',true).
concept_name0('37158: cpd:C05577','C05577',true).
concept_name0('37158: cpd:C05577','cpd:C05577',false).
concept_name0('37146: cpd:C00584','cpd:C00584',false).
concept_name0('37146: cpd:C00584','C00584',true).
concept_name0('37147: cpd:C00788','cpd:C00788',false).
concept_name0('37147: cpd:C00788','C00788',true).
concept_name0('37144: cpd:C01312','cpd:C01312',false).
concept_name0('37144: cpd:C01312','C01312',true).
concept_name0('37145: cpd:C05588','C05588',true).
concept_name0('37145: cpd:C05588','cpd:C05588',false).
concept_name0('37150: cpd:C05356','cpd:C05356',false).
concept_name0('37150: cpd:C05356','C05356',true).
concept_name0('37151: cpd:C05589','C05589',true).
concept_name0('37151: cpd:C05589','cpd:C05589',false).
concept_name0('37149: cpd:C00131','cpd:C00131',false).
concept_name0('37149: cpd:C00131','C00131',true).
concept_name0('37138: cpd:C00322','cpd:C00322',false).
concept_name0('37138: cpd:C00322','C00322',true).
concept_name0('37136: cpd:C01613','C01613',true).
concept_name0('37136: cpd:C01613','cpd:C01613',false).
concept_name0('37142: cpd:C14791','cpd:C14791',false).
concept_name0('37142: cpd:C14791','C14791',true).
concept_name0('37143: cpd:C06198','cpd:C06198',false).
concept_name0('37143: cpd:C06198','C06198',true).
concept_name0('37130: cpd:C00864','C00864',true).
concept_name0('37130: cpd:C00864','cpd:C00864',false).
concept_name0('37128: gl:G00093','G00093',true).
concept_name0('37128: gl:G00093','gl:G00093',false).
concept_name0('37134: cpd:C05404','cpd:C05404',false).
concept_name0('37134: cpd:C05404','C05404',true).
concept_name0('37133: gl:G00094','G00094',true).
concept_name0('37133: gl:G00094','gl:G00094',false).
concept_name0('37123: cpd:C11713','cpd:C11713',false).
concept_name0('37123: cpd:C11713','C11713',true).
concept_name0('37122: cpd:C02362','C02362',true).
concept_name0('37122: cpd:C02362','cpd:C02362',false).
concept_name0('37121: cpd:C05258','C05258',true).
concept_name0('37121: cpd:C05258','cpd:C05258',false).
concept_name0('37120: cpd:C14453','cpd:C14453',false).
concept_name0('37120: cpd:C14453','C14453',true).
concept_name0('37126: gl:G00095','G00095',true).
concept_name0('37126: gl:G00095','gl:G00095',false).
concept_name0('37125: cpd:C01789','C01789',true).
concept_name0('37125: cpd:C01789','cpd:C01789',false).
concept_name0('37124: cpd:C05259','C05259',true).
concept_name0('37124: cpd:C05259','cpd:C05259',false).
concept_name0('37244: cpd:C00257','cpd:C00257',false).
concept_name0('37244: cpd:C00257','C00257',true).
concept_name0('37245: cpd:C04805','cpd:C04805',false).
concept_name0('37245: cpd:C04805','C04805',true).
concept_name0('37246: cpd:C00330','cpd:C00330',false).
concept_name0('37246: cpd:C00330','C00330',true).
concept_name0('37247: cpd:C00286','cpd:C00286',false).
concept_name0('37247: cpd:C00286','C00286',true).
concept_name0('37241: cpd:C00362','cpd:C00362',false).
concept_name0('37241: cpd:C00362','C00362',true).
concept_name0('37243: gl:G00037','G00037',true).
concept_name0('37243: gl:G00037','gl:G00037',false).
concept_name0('37232: cpd:C02442','C02442',true).
concept_name0('37232: cpd:C02442','cpd:C02442',false).
concept_name0('37235: cpd:C00242','cpd:C00242',false).
concept_name0('37235: cpd:C00242','C00242',true).
concept_name0('37229: cpd:C05594','cpd:C05594',false).
concept_name0('37229: cpd:C05594','C05594',true).
concept_name0('37228: gl:G10599','G10599',true).
concept_name0('37228: gl:G10599','gl:G10599',false).
concept_name0('37230: gl:G10598','gl:G10598',false).
concept_name0('37230: gl:G10598','G10598',true).
concept_name0('37227: cpd:C05576','C05576',true).
concept_name0('37227: cpd:C05576','cpd:C05576',false).
concept_name0('37221: cpd:C06199','cpd:C06199',false).
concept_name0('37221: cpd:C06199','C06199',true).
concept_name0('37220: cpd:C00140','cpd:C00140',false).
concept_name0('37220: cpd:C00140','C00140',true).
concept_name0('37217: cpd:C01040','cpd:C01040',false).
concept_name0('37217: cpd:C01040','C01040',true).
concept_name0('37216: cpd:C00461','cpd:C00461',false).
concept_name0('37216: cpd:C00461','C00461',true).
concept_name0('37219: cpd:C00818','cpd:C00818',false).
concept_name0('37219: cpd:C00818','C00818',true).
concept_name0('37214: cpd:C01260','C01260',true).
concept_name0('37214: cpd:C01260','cpd:C01260',false).
concept_name0('37208: cpd:C02350','C02350',true).
concept_name0('37208: cpd:C02350','cpd:C02350',false).
concept_name0('37209: cpd:C01674','C01674',true).
concept_name0('37209: cpd:C01674','cpd:C01674',false).
concept_name0('37207: cpd:C00499','cpd:C00499',false).
concept_name0('37207: cpd:C00499','C00499',true).
concept_name0('37205: cpd:C02670','C02670',true).
concept_name0('37205: cpd:C02670','cpd:C02670',false).
concept_name0('37202: cpd:C00329','cpd:C00329',false).
concept_name0('37202: cpd:C00329','C00329',true).
concept_name0('37203: cpd:C00366','C00366',true).
concept_name0('37203: cpd:C00366','cpd:C00366',false).
concept_name0('37201: cpd:C00696','C00696',true).
concept_name0('37201: cpd:C00696','cpd:C00696',false).
concept_name0('37199: cpd:C02515','C02515',true).
concept_name0('37199: cpd:C02515','cpd:C02515',false).
concept_name0('37198: cpd:C04853','cpd:C04853',false).
concept_name0('37198: cpd:C04853','C04853',true).
concept_name0('37196: cpd:C01060','C01060',true).
concept_name0('37196: cpd:C01060','cpd:C01060',false).
concept_name0('37195: gl:G00157','G00157',true).
concept_name0('37195: gl:G00157','gl:G00157',false).
concept_name0('37193: cpd:C02465','C02465',true).
concept_name0('37193: cpd:C02465','cpd:C02465',false).
concept_name0('37191: cpd:C00603','C00603',true).
concept_name0('37191: cpd:C00603','cpd:C00603',false).
concept_name0('37190: cpd:C05951','cpd:C05951',false).
concept_name0('37190: cpd:C05951','C05951',true).
concept_name0('37188: cpd:C01829','C01829',true).
concept_name0('37188: cpd:C01829','cpd:C01829',false).
concept_name0('37186: cpd:C00620','cpd:C00620',false).
concept_name0('37186: cpd:C00620','C00620',true).
concept_name0('37185: cpd:C05965','cpd:C05965',false).
concept_name0('37185: cpd:C05965','C05965',true).
concept_name0('37297: cpd:C00673','C00673',true).
concept_name0('37297: cpd:C00673','cpd:C00673',false).
concept_name0('37296: cpd:C04751','cpd:C04751',false).
concept_name0('37296: cpd:C04751','C04751',true).
concept_name0('37299: cpd:C05578','C05578',true).
concept_name0('37299: cpd:C05578','cpd:C05578',false).
concept_name0('37300: cpd:C04640','C04640',true).
concept_name0('37300: cpd:C04640','cpd:C04640',false).
concept_name0('37303: gl:G00042','gl:G00042',false).
concept_name0('37303: gl:G00042','G00042',true).
concept_name0('37302: cpd:C01801','cpd:C01801',false).
concept_name0('37302: cpd:C01801','C01801',true).
concept_name0('37305: cpd:C05579','C05579',true).
concept_name0('37305: cpd:C05579','cpd:C05579',false).
concept_name0('37304: cpd:C16356','C16356',true).
concept_name0('37304: cpd:C16356','cpd:C16356',false).
concept_name0('37307: cpd:C04376','C04376',true).
concept_name0('37307: cpd:C04376','cpd:C04376',false).
concept_name0('37308: cpd:C00355','C00355',true).
concept_name0('37308: cpd:C00355','cpd:C00355',false).
concept_name0('37310: cpd:C04823','C04823',true).
concept_name0('37310: cpd:C04823','cpd:C04823',false).
concept_name0('37281: cpd:C00104','cpd:C00104',false).
concept_name0('37281: cpd:C00104','C00104',true).
concept_name0('37282: cpd:C00642','C00642',true).
concept_name0('37282: cpd:C00642','cpd:C00642',false).
concept_name0('37285: cpd:C00081','C00081',true).
concept_name0('37285: cpd:C00081','cpd:C00081',false).
concept_name0('37289: cpd:C01345','cpd:C01345',false).
concept_name0('37289: cpd:C01345','C01345',true).
concept_name0('37290: cpd:C16358','cpd:C16358',false).
concept_name0('37290: cpd:C16358','C16358',true).
concept_name0('37294: cpd:C01693','C01693',true).
concept_name0('37294: cpd:C01693','cpd:C01693',false).
concept_name0('37267: cpd:C00144','C00144',true).
concept_name0('37267: cpd:C00144','cpd:C00144',false).
concept_name0('37265: cpd:C00999','C00999',true).
concept_name0('37265: cpd:C00999','cpd:C00999',false).
concept_name0('37271: gl:G00039','gl:G00039',false).
concept_name0('37271: gl:G00039','G00039',true).
concept_name0('37269: cpd:C01228','C01228',true).
concept_name0('37269: cpd:C01228','cpd:C01228',false).
concept_name0('37268: cpd:C03691','cpd:C03691',false).
concept_name0('37268: cpd:C03691','C03691',true).
concept_name0('37275: cpd:C00996','C00996',true).
concept_name0('37275: cpd:C00996','cpd:C00996',false).
concept_name0('37273: gl:G00044','G00044',true).
concept_name0('37273: gl:G00044','gl:G00044',false).
concept_name0('37277: cpd:C00387','C00387',true).
concept_name0('37277: cpd:C00387','cpd:C00387',false).
concept_name0('37250: gl:G10526','gl:G10526',false).
concept_name0('37250: gl:G10526','G10526',true).
concept_name0('37248: cpd:C00198','cpd:C00198',false).
concept_name0('37248: cpd:C00198','C00198',true).
concept_name0('37254: cpd:C00345','cpd:C00345',false).
concept_name0('37254: cpd:C00345','C00345',true).
concept_name0('37252: gl:G10595','G10595',true).
concept_name0('37252: gl:G10595','gl:G10595',false).
concept_name0('37253: gl:G00038','G00038',true).
concept_name0('37253: gl:G00038','gl:G00038',false).
concept_name0('37258: gl:G10597','gl:G10597',false).
concept_name0('37258: gl:G10597','G10597',true).
concept_name0('37256: cpd:C00361','cpd:C00361',false).
concept_name0('37256: cpd:C00361','C00361',true).
concept_name0('37257: cpd:C05585','C05585',true).
concept_name0('37257: cpd:C05585','cpd:C05585',false).
concept_name0('37262: cpd:C00035','cpd:C00035',false).
concept_name0('37262: cpd:C00035','C00035',true).
concept_name0('37260: cpd:C03410','C03410',true).
concept_name0('37260: cpd:C03410','cpd:C03410',false).
concept_name0('37261: cpd:C04494','C04494',true).
concept_name0('37261: cpd:C04494','cpd:C04494',false).
concept_name0('37365: cpd:C16219','C16219',true).
concept_name0('37365: cpd:C16219','cpd:C16219',false).
concept_name0('37367: cpd:C04088','C04088',true).
concept_name0('37367: cpd:C04088','cpd:C04088',false).
concept_name0('37366: gl:G00002','gl:G00002',false).
concept_name0('37366: gl:G00002','G00002',true).
concept_name0('37360: cpd:C04742','C04742',true).
concept_name0('37360: cpd:C04742','cpd:C04742',false).
concept_name0('37373: cpd:C05983','cpd:C05983',false).
concept_name0('37373: cpd:C05983','C05983',true).
concept_name0('37369: gl:G00001','gl:G00001',false).
concept_name0('37369: gl:G00001','G00001',true).
concept_name0('37368: cpd:C14781','C14781',true).
concept_name0('37368: cpd:C14781','cpd:C14781',false).
concept_name0('37371: cpd:C14813','cpd:C14813',false).
concept_name0('37371: cpd:C14813','C14813',true).
concept_name0('37348: cpd:C00270','C00270',true).
concept_name0('37348: cpd:C00270','cpd:C00270',false).
concept_name0('37350: cpd:C00909','C00909',true).
concept_name0('37350: cpd:C00909','cpd:C00909',false).
concept_name0('37344: cpd:C06241','cpd:C06241',false).
concept_name0('37344: cpd:C06241','C06241',true).
concept_name0('37346: cpd:C02198','C02198',true).
concept_name0('37346: cpd:C02198','cpd:C02198',false).
concept_name0('37347: cpd:C01261','C01261',true).
concept_name0('37347: cpd:C01261','cpd:C01261',false).
concept_name0('37358: cpd:C01203','C01203',true).
concept_name0('37358: cpd:C01203','cpd:C01203',false).
concept_name0('37352: cpd:C00822','C00822',true).
concept_name0('37352: cpd:C00822','cpd:C00822',false).
concept_name0('37353: cpd:C00128','C00128',true).
concept_name0('37353: cpd:C00128','cpd:C00128',false).
concept_name0('37354: cpd:C02165','cpd:C02165',false).
concept_name0('37354: cpd:C02165','C02165',true).
concept_name0('37355: cpd:C00121','cpd:C00121',false).
concept_name0('37355: cpd:C00121','C00121',true).
concept_name0('37335: cpd:C16360','cpd:C16360',false).
concept_name0('37335: cpd:C16360','C16360',true).
concept_name0('37334: cpd:C00645','cpd:C00645',false).
concept_name0('37334: cpd:C00645','C00645',true).
concept_name0('37332: cpd:C03021','C03021',true).
concept_name0('37332: cpd:C03021','cpd:C03021',false).
concept_name0('37331: cpd:C00483','C00483',true).
concept_name0('37331: cpd:C00483','cpd:C00483',false).
concept_name0('37330: cpd:C04501','C04501',true).
concept_name0('37330: cpd:C04501','cpd:C04501',false).
concept_name0('37329: cpd:C16365','C16365',true).
concept_name0('37329: cpd:C16365','cpd:C16365',false).
concept_name0('37328: gl:G00047','G00047',true).
concept_name0('37328: gl:G00047','gl:G00047',false).
concept_name0('37343: cpd:C00381','cpd:C00381',false).
concept_name0('37343: cpd:C00381','C00381',true).
concept_name0('37341: cpd:C00942','cpd:C00942',false).
concept_name0('37341: cpd:C00942','C00942',true).
concept_name0('37340: cpd:C04257','C04257',true).
concept_name0('37340: cpd:C04257','cpd:C04257',false).
concept_name0('37339: cpd:C00110','cpd:C00110',false).
concept_name0('37339: cpd:C00110','C00110',true).
concept_name0('37337: cpd:C05350','cpd:C05350',false).
concept_name0('37337: cpd:C05350','C05350',true).
concept_name0('37336: cpd:C03862','C03862',true).
concept_name0('37336: cpd:C03862','cpd:C03862',false).
concept_name0('37318: cpd:C04677','C04677',true).
concept_name0('37318: cpd:C04677','cpd:C04677',false).
concept_name0('37316: cpd:C03758','C03758',true).
concept_name0('37316: cpd:C03758','cpd:C03758',false).
concept_name0('37314: cpd:C01236','cpd:C01236',false).
concept_name0('37314: cpd:C01236','C01236',true).
concept_name0('37312: cpd:C07480','cpd:C07480',false).
concept_name0('37312: cpd:C07480','C07480',true).
concept_name0('37313: cpd:C03838','cpd:C03838',false).
concept_name0('37313: cpd:C03838','C03838',true).
concept_name0('37326: cpd:C01246','cpd:C01246',false).
concept_name0('37326: cpd:C01246','C01246',true).
concept_name0('37327: cpd:C01344','C01344',true).
concept_name0('37327: cpd:C01344','cpd:C01344',false).
concept_name0('37324: cpd:C16353','cpd:C16353',false).
concept_name0('37324: cpd:C16353','C16353',true).
concept_name0('37325: cpd:C03765','cpd:C03765',false).
concept_name0('37325: cpd:C03765','C03765',true).
concept_name0('37322: cpd:C00357','cpd:C00357',false).
concept_name0('37322: cpd:C00357','C00357',true).
concept_name0('37321: cpd:C05587','C05587',true).
concept_name0('37321: cpd:C05587','cpd:C05587',false).
concept_name0('37388: gl:G00017','gl:G00017',false).
concept_name0('37388: gl:G00017','G00017',true).
concept_name0('37391: gl:G00016','gl:G00016',false).
concept_name0('37391: gl:G00016','G00016',true).
concept_name0('37390: gl:G00007','G00007',true).
concept_name0('37390: gl:G00007','gl:G00007',false).
concept_name0('37385: cpd:C05984','cpd:C05984',false).
concept_name0('37385: cpd:C05984','C05984',true).
concept_name0('37384: cpd:C06049','C06049',true).
concept_name0('37384: cpd:C06049','cpd:C06049',false).
concept_name0('37387: gl:G00008','G00008',true).
concept_name0('37387: gl:G00008','gl:G00008',false).
concept_name0('37381: gl:G00006','gl:G00006',false).
concept_name0('37381: gl:G00006','G00006',true).
concept_name0('37383: gl:G00005','gl:G00005',false).
concept_name0('37383: gl:G00005','G00005',true).
concept_name0('37377: gl:G00003','gl:G00003',false).
concept_name0('37377: gl:G00003','G00003',true).
concept_name0('37376: gl:G00004','gl:G00004',false).
concept_name0('37376: gl:G00004','G00004',true).
concept_name0('37379: cpd:C05985','cpd:C05985',false).
concept_name0('37379: cpd:C05985','C05985',true).
concept_name0('37404: gl:G00019','G00019',true).
concept_name0('37404: gl:G00019','gl:G00019',false).
concept_name0('37407: gl:G00020','G00020',true).
concept_name0('37407: gl:G00020','gl:G00020',false).
concept_name0('37402: gl:G00018','G00018',true).
concept_name0('37402: gl:G00018','gl:G00018',false).
concept_name0('37403: cpd:C00988','C00988',true).
concept_name0('37403: cpd:C00988','cpd:C00988',false).
concept_name0('37396: cpd:C00886','cpd:C00886',false).
concept_name0('37396: cpd:C00886','C00886',true).
concept_name0('37397: cpd:C01931','C01931',true).
concept_name0('37397: cpd:C01931','cpd:C01931',false).
concept_name0('37392: cpd:C00021','cpd:C00021',false).
concept_name0('37392: cpd:C00021','C00021',true).
concept_name0('37393: gl:G00171','G00171',true).
concept_name0('37393: gl:G00171','gl:G00171',false).
concept_name0('37395: gl:G00009','G00009',true).
concept_name0('37395: gl:G00009','gl:G00009',false).
concept_name0('37422: cpd:C14812','cpd:C14812',false).
concept_name0('37422: cpd:C14812','C14812',true).
concept_name0('37421: gl:G00072','G00072',true).
concept_name0('37421: gl:G00072','gl:G00072',false).
concept_name0('37420: cpd:C02412','C02412',true).
concept_name0('37420: cpd:C02412','cpd:C02412',false).
concept_name0('37419: gl:G00073','G00073',true).
concept_name0('37419: gl:G00073','gl:G00073',false).
concept_name0('37417: cpd:C06424','cpd:C06424',false).
concept_name0('37417: cpd:C06424','C06424',true).
concept_name0('37415: cpd:C02679','C02679',true).
concept_name0('37415: cpd:C02679','cpd:C02679',false).
concept_name0('37414: cpd:C02839','C02839',true).
concept_name0('37414: cpd:C02839','cpd:C02839',false).
concept_name0('37412: cpd:C02992','cpd:C02992',false).
concept_name0('37412: cpd:C02992','C02992',true).
concept_name0('37411: gl:G00022','G00022',true).
concept_name0('37411: gl:G00022','gl:G00022',false).
concept_name0('37410: cpd:C03512','cpd:C03512',false).
concept_name0('37410: cpd:C03512','C03512',true).
concept_name0('37408: gl:G00021','G00021',true).
concept_name0('37408: gl:G00021','gl:G00021',false).
concept_name0('37438: cpd:C02984','cpd:C02984',false).
concept_name0('37438: cpd:C02984','C02984',true).
concept_name0('37439: gl:G00074','G00074',true).
concept_name0('37439: gl:G00074','gl:G00074',false).
concept_name0('37436: gl:G00075','gl:G00075',false).
concept_name0('37436: gl:G00075','G00075',true).
concept_name0('37434: cpd:C02553','C02553',true).
concept_name0('37434: cpd:C02553','cpd:C02553',false).
concept_name0('37432: cpd:C00760','cpd:C00760',false).
concept_name0('37432: cpd:C00760','C00760',true).
concept_name0('37433: gl:G00083','G00083',true).
concept_name0('37433: gl:G00083','gl:G00083',false).
concept_name0('37429: gl:G00082','G00082',true).
concept_name0('37429: gl:G00082','gl:G00082',false).
concept_name0('37426: cpd:C02702','C02702',true).
concept_name0('37426: cpd:C02702','cpd:C02702',false).
concept_name0('37427: gl:G10596','gl:G10596',false).
concept_name0('37427: gl:G10596','G10596',true).
concept_name0('37424: gl:G00071','gl:G00071',false).
concept_name0('37424: gl:G00071','G00071',true).
concept_name0('37448: cpd:C02987','C02987',true).
concept_name0('37448: cpd:C02987','cpd:C02987',false).
concept_name0('37451: gl:G00055','G00055',true).
concept_name0('37451: gl:G00055','gl:G00055',false).
concept_name0('37450: gl:G00056','G00056',true).
concept_name0('37450: gl:G00056','gl:G00056',false).
concept_name0('37452: cpd:C14748','C14748',true).
concept_name0('37452: cpd:C14748','cpd:C14748',false).
concept_name0('37455: gl:G00081','G00081',true).
concept_name0('37455: gl:G00081','gl:G00081',false).
concept_name0('37454: cpd:C03294','cpd:C03294',false).
concept_name0('37454: cpd:C03294','C03294',true).
concept_name0('37440: gl:G00068','G00068',true).
concept_name0('37440: gl:G00068','gl:G00068',false).
concept_name0('37443: cpd:C00252','C00252',true).
concept_name0('37443: cpd:C00252','cpd:C00252',false).
concept_name0('37445: gl:G00076','gl:G00076',false).
concept_name0('37445: gl:G00076','G00076',true).
concept_name0('37465: gl:G00059','G00059',true).
concept_name0('37465: gl:G00059','gl:G00059',false).
concept_name0('37466: cpd:C14773','cpd:C14773',false).
concept_name0('37466: cpd:C14773','C14773',true).
concept_name0('37468: gl:G00054','G00054',true).
concept_name0('37468: gl:G00054','gl:G00054',false).
concept_name0('37469: cpd:C14772','cpd:C14772',false).
concept_name0('37469: cpd:C14772','C14772',true).
concept_name0('37458: cpd:C03289','C03289',true).
concept_name0('37458: cpd:C03289','cpd:C03289',false).
concept_name0('37459: cpd:C02430','C02430',true).
concept_name0('37459: cpd:C02430','cpd:C02430',false).
concept_name0('37461: gl:G00077','gl:G00077',false).
concept_name0('37461: gl:G00077','G00077',true).
concept_name0('37462: cpd:C14823','cpd:C14823',false).
concept_name0('37462: cpd:C14823','C14823',true).
concept_name0('37463: cpd:C03402','cpd:C03402',false).
concept_name0('37463: cpd:C03402','C03402',true).
concept_name0('37483: cpd:C02988','C02988',true).
concept_name0('37483: cpd:C02988','cpd:C02988',false).
concept_name0('37482: cpd:C14749','C14749',true).
concept_name0('37482: cpd:C14749','cpd:C14749',false).
concept_name0('37481: gl:G00052','gl:G00052',false).
concept_name0('37481: gl:G00052','G00052',true).
concept_name0('37480: cpd:C00185','C00185',true).
concept_name0('37480: cpd:C00185','cpd:C00185',false).
concept_name0('37486: gl:G00050','gl:G00050',false).
concept_name0('37486: gl:G00050','G00050',true).
concept_name0('37485: gl:G00036','G00036',true).
concept_name0('37485: gl:G00036','gl:G00036',false).
concept_name0('37473: cpd:C14775','cpd:C14775',false).
concept_name0('37473: cpd:C14775','C14775',true).
concept_name0('37479: gl:G00051','gl:G00051',false).
concept_name0('37479: gl:G00051','G00051',true).
concept_name0('37478: cpd:C03511','C03511',true).
concept_name0('37478: cpd:C03511','cpd:C03511',false).
concept_name0('37477: cpd:C14774','cpd:C14774',false).
concept_name0('37477: cpd:C14774','C14774',true).
concept_name0('37476: gl:G00058','G00058',true).
concept_name0('37476: gl:G00058','gl:G00058',false).
concept_name0('37498: cpd:C00559','cpd:C00559',false).
concept_name0('37498: cpd:C00559','C00559',true).
concept_name0('37499: cpd:C02163','cpd:C02163',false).
concept_name0('37499: cpd:C02163','C02163',true).
concept_name0('37497: cpd:C14814','cpd:C14814',false).
concept_name0('37497: cpd:C14814','C14814',true).
concept_name0('37503: cpd:C04734','C04734',true).
concept_name0('37503: cpd:C04734','cpd:C04734',false).
concept_name0('37500: cpd:C14782','cpd:C14782',false).
concept_name0('37500: cpd:C14782','C14782',true).
concept_name0('37501: cpd:C00360','cpd:C00360',false).
concept_name0('37501: cpd:C00360','C00360',true).
concept_name0('37490: cpd:C00369','C00369',true).
concept_name0('37490: cpd:C00369','cpd:C00369',false).
concept_name0('37489: cpd:C02282','C02282',true).
concept_name0('37489: cpd:C02282','cpd:C02282',false).
concept_name0('37494: cpd:C05512','cpd:C05512',false).
concept_name0('37494: cpd:C05512','C05512',true).
concept_name0('37495: cpd:C00718','C00718',true).
concept_name0('37495: cpd:C00718','cpd:C00718',false).
concept_name0('37492: cpd:C14778','C14778',true).
concept_name0('37492: cpd:C14778','cpd:C14778',false).
concept_name0('37508: cpd:C14768','C14768',true).
concept_name0('37508: cpd:C14768','cpd:C14768',false).
concept_name0('37511: cpd:C04392','cpd:C04392',false).
concept_name0('37511: cpd:C04392','C04392',true).
concept_name0('37504: cpd:C14769','C14769',true).
concept_name0('37504: cpd:C14769','cpd:C14769',false).
concept_name0('37505: cpd:C03125','C03125',true).
concept_name0('37505: cpd:C03125','cpd:C03125',false).
concept_name0('37512: cpd:C14771','cpd:C14771',false).
concept_name0('37512: cpd:C14771','C14771',true).
concept_name0('37514: cpd:C01798','cpd:C01798',false).
concept_name0('37514: cpd:C01798','C01798',true).
concept_name0('37515: cpd:C14770','cpd:C14770',false).
concept_name0('37515: cpd:C14770','C14770',true).
concept_name0('37525: cpd:C00831','C00831',true).
concept_name0('37525: cpd:C00831','cpd:C00831',false).
concept_name0('37524: cpd:C02530','C02530',true).
concept_name0('37524: cpd:C02530','cpd:C02530',false).
concept_name0('37522: cpd:C04079','C04079',true).
concept_name0('37522: cpd:C04079','cpd:C04079',false).
concept_name0('37533: gl:G00162','G00162',true).
concept_name0('37533: gl:G00162','gl:G00162',false).
concept_name0('37532: cpd:C01134','cpd:C01134',false).
concept_name0('37532: cpd:C01134','C01134',true).
concept_name0('37534: gl:G00164','gl:G00164',false).
concept_name0('37534: gl:G00164','G00164',true).
concept_name0('37531: gl:G00163','gl:G00163',false).
concept_name0('37531: gl:G00163','G00163',true).
concept_name0('37530: cpd:C00882','C00882',true).
concept_name0('37530: cpd:C00882','cpd:C00882',false).
concept_name0('37541: cpd:C05437','C05437',true).
concept_name0('37541: cpd:C05437','cpd:C05437',false).
concept_name0('37539: cpd:C04352','cpd:C04352',false).
concept_name0('37539: cpd:C04352','C04352',true).
concept_name0('37550: cpd:C01189','C01189',true).
concept_name0('37550: cpd:C01189','cpd:C01189',false).
concept_name0('37548: cpd:C01164','C01164',true).
concept_name0('37548: cpd:C01164','cpd:C01164',false).
concept_name0('37544: cpd:C05103','cpd:C05103',false).
concept_name0('37544: cpd:C05103','C05103',true).
concept_name0('37553: cpd:C15816','cpd:C15816',false).
concept_name0('37553: cpd:C15816','C15816',true).
concept_name0('37567: cpd:C05439','C05439',true).
concept_name0('37567: cpd:C05439','cpd:C05439',false).
concept_name0('37575: cpd:C11522','cpd:C11522',false).
concept_name0('37575: cpd:C11522','C11522',true).
concept_name0('37578: cpd:C03845','C03845',true).
concept_name0('37578: cpd:C03845','cpd:C03845',false).
concept_name0('37584: cpd:C03492','cpd:C03492',false).
concept_name0('37584: cpd:C03492','C03492',true).
concept_name0('37590: cpd:C07481','cpd:C07481',false).
concept_name0('37590: cpd:C07481','C07481',true).
concept_name0('37610: cpd:C06213','C06213',true).
concept_name0('37610: cpd:C06213','cpd:C06213',false).
concept_name0('37611: cpd:C16359','cpd:C16359',false).
concept_name0('37611: cpd:C16359','C16359',true).
concept_name0('37608: cpd:C14819','C14819',true).
concept_name0('37608: cpd:C14819','cpd:C14819',false).
concept_name0('37609: cpd:C06212','C06212',true).
concept_name0('37609: cpd:C06212','cpd:C06212',false).
concept_name0('37615: cpd:C16355','cpd:C16355',false).
concept_name0('37615: cpd:C16355','C16355',true).
concept_name0('37613: cpd:C05653','cpd:C05653',false).
concept_name0('37613: cpd:C05653','C05653',true).
concept_name0('37619: cpd:C15519','cpd:C15519',false).
concept_name0('37619: cpd:C15519','C15519',true).
concept_name0('37617: cpd:C15610','cpd:C15610',false).
concept_name0('37617: cpd:C15610','C15610',true).
concept_name0('37623: cpd:C16361','cpd:C16361',false).
concept_name0('37623: cpd:C16361','C16361',true).
concept_name0('37622: cpd:C03594','C03594',true).
concept_name0('37622: cpd:C03594','cpd:C03594',false).
concept_name0('37627: cpd:C13550','cpd:C13550',false).
concept_name0('37627: cpd:C13550','C13550',true).
concept_name0('37626: cpd:C16362','cpd:C16362',false).
concept_name0('37626: cpd:C16362','C16362',true).
concept_name0('37625: cpd:C17333','cpd:C17333',false).
concept_name0('37625: cpd:C17333','C17333',true).
concept_name0('37624: cpd:C17336','cpd:C17336',false).
concept_name0('37624: cpd:C17336','C17336',true).
concept_name0('37629: cpd:C05455','C05455',true).
concept_name0('37629: cpd:C05455','cpd:C05455',false).
concept_name0('37628: cpd:C13747','cpd:C13747',false).
concept_name0('37628: cpd:C13747','C13747',true).
concept_name0('37662: cpd:C05444','cpd:C05444',false).
concept_name0('37662: cpd:C05444','C05444',true).
concept_name0('37663: cpd:C05130','C05130',true).
concept_name0('37663: cpd:C05130','cpd:C05130',false).
concept_name0('37660: cpd:C04895','C04895',true).
concept_name0('37660: cpd:C04895','cpd:C04895',false).
concept_name0('37661: cpd:C04244','cpd:C04244',false).
concept_name0('37661: cpd:C04244','C04244',true).
concept_name0('37658: cpd:C02835','C02835',true).
concept_name0('37658: cpd:C02835','cpd:C02835',false).
concept_name0('37659: cpd:C05452','cpd:C05452',false).
concept_name0('37659: cpd:C05452','C05452',true).
concept_name0('37656: cpd:C05467','cpd:C05467',false).
concept_name0('37656: cpd:C05467','C05467',true).
concept_name0('37657: cpd:C03684','cpd:C03684',false).
concept_name0('37657: cpd:C03684','C03684',true).
concept_name0('37654: cpd:C05460','C05460',true).
concept_name0('37654: cpd:C05460','cpd:C05460',false).
concept_name0('37653: gl:G00154','gl:G00154',false).
concept_name0('37653: gl:G00154','G00154',true).
concept_name0('37651: cpd:C17343','cpd:C17343',false).
concept_name0('37651: cpd:C17343','C17343',true).
concept_name0('37648: gl:G13041','G13041',true).
concept_name0('37648: gl:G13041','gl:G13041',false).
concept_name0('37647: cpd:C05552','C05552',true).
concept_name0('37647: cpd:C05552','cpd:C05552',false).
concept_name0('37642: cpd:C05921','cpd:C05921',false).
concept_name0('37642: cpd:C05921','C05921',true).
concept_name0('37638: cpd:C00925','C00925',true).
concept_name0('37638: cpd:C00925','cpd:C00925',false).
concept_name0('37636: cpd:C11556','cpd:C11556',false).
concept_name0('37636: cpd:C11556','C11556',true).
concept_name0('37632: cpd:C00120','cpd:C00120',false).
concept_name0('37632: cpd:C00120','C00120',true).
concept_name0('37693: cpd:C17337','cpd:C17337',false).
concept_name0('37693: cpd:C17337','C17337',true).
concept_name0('37694: cpd:C05544','cpd:C05544',false).
concept_name0('37694: cpd:C05544','C05544',true).
concept_name0('37695: cpd:C17335','C17335',true).
concept_name0('37695: cpd:C17335','cpd:C17335',false).
concept_name0('37688: gl:G00156','G00156',true).
concept_name0('37688: gl:G00156','gl:G00156',false).
concept_name0('37689: cpd:C01044','cpd:C01044',false).
concept_name0('37689: cpd:C01044','C01044',true).
concept_name0('37690: cpd:C05466','C05466',true).
concept_name0('37690: cpd:C05466','cpd:C05466',false).
concept_name0('37691: gl:G00155','gl:G00155',false).
concept_name0('37691: gl:G00155','G00155',true).
concept_name0('37686: cpd:C02528','cpd:C02528',false).
concept_name0('37686: cpd:C02528','C02528',true).
concept_name0('37680: cpd:C05465','cpd:C05465',false).
concept_name0('37680: cpd:C05465','C05465',true).
concept_name0('37681: gl:G00159','G00159',true).
concept_name0('37681: gl:G00159','gl:G00159',false).
concept_name0('37683: gl:G00158','G00158',true).
concept_name0('37683: gl:G00158','gl:G00158',false).
concept_name0('37676: cpd:C16236','C16236',true).
concept_name0('37676: cpd:C16236','cpd:C16236',false).
concept_name0('37678: gl:G00160','G00160',true).
concept_name0('37678: gl:G00160','gl:G00160',false).
concept_name0('37673: cpd:C16237','C16237',true).
concept_name0('37673: cpd:C16237','cpd:C16237',false).
concept_name0('37672: cpd:C17346','C17346',true).
concept_name0('37672: cpd:C17346','cpd:C17346',false).
concept_name0('37674: cpd:C05447','cpd:C05447',false).
concept_name0('37674: cpd:C05447','C05447',true).
concept_name0('37669: cpd:C00272','C00272',true).
concept_name0('37669: cpd:C00272','cpd:C00272',false).
concept_name0('37668: cpd:C04554','C04554',true).
concept_name0('37668: cpd:C04554','cpd:C04554',false).
concept_name0('37671: cpd:C17345','cpd:C17345',false).
concept_name0('37671: cpd:C17345','C17345',true).
concept_name0('37670: cpd:C01152','C01152',true).
concept_name0('37670: cpd:C01152','cpd:C01152',false).
concept_name0('37665: cpd:C00388','C00388',true).
concept_name0('37665: cpd:C00388','cpd:C00388',false).
concept_name0('37664: cpd:C05445','cpd:C05445',false).
concept_name0('37664: cpd:C05445','C05445',true).
concept_name0('37666: cpd:C00268','cpd:C00268',false).
concept_name0('37666: cpd:C00268','C00268',true).
concept_name0('37722: cpd:C06341','C06341',true).
concept_name0('37722: cpd:C06341','cpd:C06341',false).
concept_name0('37723: cpd:C02188','cpd:C02188',false).
concept_name0('37723: cpd:C02188','C02188',true).
concept_name0('37720: cpd:C16239','C16239',true).
concept_name0('37720: cpd:C16239','cpd:C16239',false).
concept_name0('37726: cpd:C00700','cpd:C00700',false).
concept_name0('37726: cpd:C00700','C00700',true).
concept_name0('37727: cpd:C01301','cpd:C01301',false).
concept_name0('37727: cpd:C01301','C01301',true).
concept_name0('37724: cpd:C00655','C00655',true).
concept_name0('37724: cpd:C00655','cpd:C00655',false).
concept_name0('37725: cpd:C04722','cpd:C04722',false).
concept_name0('37725: cpd:C04722','C04722',true).
concept_name0('37714: cpd:C05337','C05337',true).
concept_name0('37714: cpd:C05337','cpd:C05337',false).
concept_name0('37715: cpd:C05127','cpd:C05127',false).
concept_name0('37715: cpd:C05127','C05127',true).
concept_name0('37712: cpd:C05449','C05449',true).
concept_name0('37712: cpd:C05449','cpd:C05449',false).
concept_name0('37713: cpd:C00575','cpd:C00575',false).
concept_name0('37713: cpd:C00575','C00575',true).
concept_name0('37719: cpd:C05446','cpd:C05446',false).
concept_name0('37719: cpd:C05446','C05446',true).
concept_name0('37716: cpd:C01794','cpd:C01794',false).
concept_name0('37716: cpd:C01794','C01794',true).
concept_name0('37717: cpd:C00301','cpd:C00301',false).
concept_name0('37717: cpd:C00301','C00301',true).
concept_name0('37707: cpd:C05454','cpd:C05454',false).
concept_name0('37707: cpd:C05454','C05454',true).
concept_name0('37706: cpd:C17339','C17339',true).
concept_name0('37706: cpd:C17339','cpd:C17339',false).
concept_name0('37705: cpd:C04051','cpd:C04051',false).
concept_name0('37705: cpd:C04051','C04051',true).
concept_name0('37704: cpd:C04487','cpd:C04487',false).
concept_name0('37704: cpd:C04487','C04487',true).
concept_name0('37711: cpd:C15613','C15613',true).
concept_name0('37711: cpd:C15613','cpd:C15613',false).
concept_name0('37710: cpd:C05453','cpd:C05453',false).
concept_name0('37710: cpd:C05453','C05453',true).
concept_name0('37709: cpd:C16238','C16238',true).
concept_name0('37709: cpd:C16238','cpd:C16238',false).
concept_name0('37708: cpd:C03680','cpd:C03680',false).
concept_name0('37708: cpd:C03680','C03680',true).
concept_name0('37699: cpd:C17331','C17331',true).
concept_name0('37699: cpd:C17331','cpd:C17331',false).
concept_name0('37698: cpd:C05545','cpd:C05545',false).
concept_name0('37698: cpd:C05545','C05545',true).
concept_name0('37697: cpd:C06196','cpd:C06196',false).
concept_name0('37697: cpd:C06196','C06196',true).
concept_name0('37696: cpd:C17332','cpd:C17332',false).
concept_name0('37696: cpd:C17332','C17332',true).
concept_name0('37703: cpd:C05451','C05451',true).
concept_name0('37703: cpd:C05451','cpd:C05451',false).
concept_name0('37702: cpd:C06197','cpd:C06197',false).
concept_name0('37702: cpd:C06197','C06197',true).
concept_name0('37701: cpd:C01211','cpd:C01211',false).
concept_name0('37701: cpd:C01211','C01211',true).
concept_name0('37700: cpd:C00785','cpd:C00785',false).
concept_name0('37700: cpd:C00785','C00785',true).
concept_name0('37752: cpd:C01204','C01204',true).
concept_name0('37752: cpd:C01204','cpd:C01204',false).
concept_name0('37754: cpd:C05999','cpd:C05999',false).
concept_name0('37754: cpd:C05999','C05999',true).
concept_name0('37757: cpd:C01272','cpd:C01272',false).
concept_name0('37757: cpd:C01272','C01272',true).
concept_name0('37759: cpd:C11555','cpd:C11555',false).
concept_name0('37759: cpd:C11555','C11555',true).
concept_name0('37746: cpd:C00583','cpd:C00583',false).
concept_name0('37746: cpd:C00583','C00583',true).
concept_name0('37747: cpd:C01243','C01243',true).
concept_name0('37747: cpd:C01243','cpd:C01243',false).
concept_name0('37749: cpd:C01245','C01245',true).
concept_name0('37749: cpd:C01245','cpd:C01245',false).
concept_name0('37750: cpd:C04409','cpd:C04409',false).
concept_name0('37750: cpd:C04409','C04409',true).
concept_name0('37737: cpd:C06148','cpd:C06148',false).
concept_name0('37737: cpd:C06148','C06148',true).
concept_name0('37736: cpd:C03692','cpd:C03692',false).
concept_name0('37736: cpd:C03692','C03692',true).
concept_name0('37738: cpd:C05645','cpd:C05645',false).
concept_name0('37738: cpd:C05645','C05645',true).
concept_name0('37740: cpd:C05637','C05637',true).
concept_name0('37740: cpd:C05637','cpd:C05637',false).
concept_name0('37742: cpd:C05922','C05922',true).
concept_name0('37742: cpd:C05922','cpd:C05922',false).
concept_name0('37728: cpd:C00012','cpd:C00012',false).
concept_name0('37728: cpd:C00012','C00012',true).
concept_name0('37731: cpd:C05636','C05636',true).
concept_name0('37731: cpd:C05636','cpd:C05636',false).
concept_name0('37732: cpd:C01885','cpd:C01885',false).
concept_name0('37732: cpd:C01885','C01885',true).
concept_name0('37734: cpd:C03227','C03227',true).
concept_name0('37734: cpd:C03227','cpd:C03227',false).
concept_name0('37782: cpd:C00695','cpd:C00695',false).
concept_name0('37782: cpd:C00695','C00695',true).
concept_name0('37780: cpd:C01252','C01252',true).
concept_name0('37780: cpd:C01252','cpd:C01252',false).
concept_name0('37778: cpd:C00328','cpd:C00328',false).
concept_name0('37778: cpd:C00328','C00328',true).
concept_name0('37776: cpd:C05448','C05448',true).
concept_name0('37776: cpd:C05448','cpd:C05448',false).
concept_name0('37789: gl:G13040','gl:G13040',false).
concept_name0('37789: gl:G13040','G13040',true).
concept_name0('37787: cpd:C09332','cpd:C09332',false).
concept_name0('37787: cpd:C09332','C09332',true).
concept_name0('37785: cpd:C01921','C01921',true).
concept_name0('37785: cpd:C01921','cpd:C01921',false).
concept_name0('37784: cpd:C03541','cpd:C03541',false).
concept_name0('37784: cpd:C03541','C03541',true).
concept_name0('37766: cpd:C15520','cpd:C15520',false).
concept_name0('37766: cpd:C15520','C15520',true).
concept_name0('37764: cpd:C00643','C00643',true).
concept_name0('37764: cpd:C00643','cpd:C00643',false).
concept_name0('37765: cpd:C00921','cpd:C00921',false).
concept_name0('37765: cpd:C00921','C00921',true).
concept_name0('37761: cpd:C11557','cpd:C11557',false).
concept_name0('37761: cpd:C11557','C11557',true).
concept_name0('37774: cpd:C05923','C05923',true).
concept_name0('37774: cpd:C05923','cpd:C05923',false).
concept_name0('37773: cpd:C02700','C02700',true).
concept_name0('37773: cpd:C02700','cpd:C02700',false).
concept_name0('37770: cpd:C04874','C04874',true).
concept_name0('37770: cpd:C04874','cpd:C04874',false).
concept_name0('37771: cpd:C15518','C15518',true).
concept_name0('37771: cpd:C15518','cpd:C15518',false).
concept_name0('37769: cpd:C05450','C05450',true).
concept_name0('37769: cpd:C05450','cpd:C05450',false).
concept_name0('37813: gl:G13043','gl:G13043',false).
concept_name0('37813: gl:G13043','G13043',true).
concept_name0('37812: gl:G13031','gl:G13031',false).
concept_name0('37812: gl:G13031','G13031',true).
concept_name0('37815: gl:G00872','gl:G00872',false).
concept_name0('37815: gl:G00872','G00872',true).
concept_name0('37808: gl:G06780','gl:G06780',false).
concept_name0('37808: gl:G06780','G06780',true).
concept_name0('37810: gl:G02632','gl:G02632',false).
concept_name0('37810: gl:G02632','G02632',true).
concept_name0('37821: gl:G12336','G12336',true).
concept_name0('37821: gl:G12336','gl:G12336',false).
concept_name0('37818: gl:G13042','G13042',true).
concept_name0('37818: gl:G13042','gl:G13042',false).
concept_name0('37797: gl:G13038','G13038',true).
concept_name0('37797: gl:G13038','gl:G13038',false).
concept_name0('37799: gl:G13039','gl:G13039',false).
concept_name0('37799: gl:G13039','G13039',true).
concept_name0('37793: gl:G09660','G09660',true).
concept_name0('37793: gl:G09660','gl:G09660',false).
concept_name0('37806: cpd:C01277','C01277',true).
concept_name0('37806: cpd:C01277','cpd:C01277',false).
concept_name0('37801: cpd:C05981','cpd:C05981',false).
concept_name0('37801: cpd:C05981','C05981',true).
concept_name0('37803: gl:G13032','gl:G13032',false).
concept_name0('37803: gl:G13032','G13032',true).
concept_name0('37843: cpd:C01284','cpd:C01284',false).
concept_name0('37843: cpd:C01284','C01284',true).
concept_name0('37842: cpd:C00637','cpd:C00637',false).
concept_name0('37842: cpd:C00637','C00637',true).
concept_name0('37840: cpd:C04063','C04063',true).
concept_name0('37840: cpd:C04063','cpd:C04063',false).
concept_name0('37847: cpd:C00954','cpd:C00954',false).
concept_name0('37847: cpd:C00954','C00954',true).
concept_name0('37850: cpd:C05643','cpd:C05643',false).
concept_name0('37850: cpd:C05643','C05643',true).
concept_name0('37848: cpd:C01220','C01220',true).
concept_name0('37848: cpd:C01220','cpd:C01220',false).
concept_name0('37853: cpd:C01598','C01598',true).
concept_name0('37853: cpd:C01598','cpd:C01598',false).
concept_name0('37852: cpd:C04520','C04520',true).
concept_name0('37852: cpd:C04520','cpd:C04520',false).
concept_name0('37826: cpd:C00398','C00398',true).
concept_name0('37826: cpd:C00398','cpd:C00398',false).
concept_name0('37824: gl:G13036','gl:G13036',false).
concept_name0('37824: gl:G13036','G13036',true).
concept_name0('37831: cpd:C05660','cpd:C05660',false).
concept_name0('37831: cpd:C05660','C05660',true).
concept_name0('37828: gl:G13037','gl:G13037',false).
concept_name0('37828: gl:G13037','G13037',true).
concept_name0('37834: gl:G13035','gl:G13035',false).
concept_name0('37834: gl:G13035','G13035',true).
concept_name0('37832: gl:G13034','gl:G13034',false).
concept_name0('37832: gl:G13034','G13034',true).
concept_name0('37873: cpd:C04637','cpd:C04637',false).
concept_name0('37873: cpd:C04637','C04637',true).
concept_name0('37872: cpd:C05647','C05647',true).
concept_name0('37872: cpd:C05647','cpd:C05647',false).
concept_name0('37875: cpd:C05640','cpd:C05640',false).
concept_name0('37875: cpd:C05640','C05640',true).
concept_name0('37877: cpd:C05634','cpd:C05634',false).
concept_name0('37877: cpd:C05634','C05634',true).
concept_name0('37876: cpd:C03546','C03546',true).
concept_name0('37876: cpd:C03546','cpd:C03546',false).
concept_name0('37878: cpd:C00780','C00780',true).
concept_name0('37878: cpd:C00780','cpd:C00780',false).
concept_name0('37856: cpd:C00331','cpd:C00331',false).
concept_name0('37856: cpd:C00331','C00331',true).
concept_name0('37859: cpd:C04477','C04477',true).
concept_name0('37859: cpd:C04477','cpd:C04477',false).
concept_name0('37861: cpd:C05642','C05642',true).
concept_name0('37861: cpd:C05642','cpd:C05642',false).
concept_name0('37864: cpd:C05635','cpd:C05635',false).
concept_name0('37864: cpd:C05635','C05635',true).
concept_name0('37865: cpd:C01177','C01177',true).
concept_name0('37865: cpd:C01177','cpd:C01177',false).
concept_name0('37867: gl:G08421','G08421',true).
concept_name0('37867: gl:G08421','gl:G08421',false).
concept_name0('37868: cpd:C00978','cpd:C00978',false).
concept_name0('37868: cpd:C00978','C00978',true).
concept_name0('37869: cpd:C04549','cpd:C04549',false).
concept_name0('37869: cpd:C04549','C04549',true).
concept_name0('37871: gl:G13033','gl:G13033',false).
concept_name0('37871: gl:G13033','G13033',true).
concept_name0('36303: cpd:C18125','C18125',true).
concept_name0('36303: cpd:C18125','cpd:C18125',false).
concept_name0('36300: cpd:C01013','C01013',true).
concept_name0('36300: cpd:C01013','cpd:C01013',false).
concept_name0('37987: cpd:C16680','cpd:C16680',false).
concept_name0('37987: cpd:C16680','C16680',true).
concept_name0('36299: cpd:C16619','C16619',true).
concept_name0('36299: cpd:C16619','cpd:C16619',false).
concept_name0('36298: cpd:C00020','C00020',true).
concept_name0('36298: cpd:C00020','cpd:C00020',false).
concept_name0('36297: cpd:C15606','C15606',true).
concept_name0('36297: cpd:C15606','cpd:C15606',false).
concept_name0('36296: cpd:C00631','cpd:C00631',false).
concept_name0('36296: cpd:C00631','C00631',true).
concept_name0('37999: cpd:C05946','cpd:C05946',false).
concept_name0('37999: cpd:C05946','C05946',true).
concept_name0('36295: dr:D08603 cpd:C07648','D08603...',true).
concept_name0('36295: dr:D08603 cpd:C07648','dr:D08603 cpd:C07648',false).
concept_name0('36294: cpd:C11131','cpd:C11131',false).
concept_name0('36294: cpd:C11131','C11131',true).
concept_name0('36292: cpd:C08276','C08276',true).
concept_name0('36292: cpd:C08276','cpd:C08276',false).
concept_name0('36291: cpd:C02512','C02512',true).
concept_name0('36291: cpd:C02512','cpd:C02512',false).
concept_name0('36290: cpd:C16615','cpd:C16615',false).
concept_name0('36290: cpd:C16615','C16615',true).
concept_name0('37992: cpd:C05774','C05774',true).
concept_name0('37992: cpd:C05774','cpd:C05774',false).
concept_name0('36288: cpd:C16620','C16620',true).
concept_name0('36288: cpd:C16620','cpd:C16620',false).
concept_name0('36318: cpd:C03267','C03267',true).
concept_name0('36318: cpd:C03267','cpd:C03267',false).
concept_name0('36319: cpd:C05301','C05301',true).
concept_name0('36319: cpd:C05301','cpd:C05301',false).
concept_name0('36316: cpd:C06250','C06250',true).
concept_name0('36316: cpd:C06250','cpd:C06250',false).
concept_name0('38002: cpd:C01157','C01157',true).
concept_name0('38002: cpd:C01157','cpd:C01157',false).
concept_name0('38003: cpd:C01165','C01165',true).
concept_name0('38003: cpd:C01165','cpd:C01165',false).
concept_name0('36315: cpd:C05302','cpd:C05302',false).
concept_name0('36315: cpd:C05302','C05302',true).
concept_name0('38000: cpd:C05947','cpd:C05947',false).
concept_name0('38000: cpd:C05947','C05947',true).
concept_name0('38001: cpd:C04281','cpd:C04281',false).
concept_name0('38001: cpd:C04281','C04281',true).
concept_name0('36313: cpd:C04419','cpd:C04419',false).
concept_name0('36313: cpd:C04419','C04419',true).
concept_name0('36308: cpd:C07585','cpd:C07585',false).
concept_name0('36308: cpd:C07585','C07585',true).
concept_name0('36307: cpd:C05504','cpd:C05504',false).
concept_name0('36307: cpd:C05504','C05504',true).
concept_name0('36305: cpd:C00275','cpd:C00275',false).
concept_name0('36305: cpd:C00275','C00275',true).
concept_name0('37957: cpd:C00899','cpd:C00899',false).
concept_name0('37957: cpd:C00899','C00899',true).
concept_name0('36332: cpd:C16604','cpd:C16604',false).
concept_name0('36332: cpd:C16604','C16604',true).
concept_name0('36335: cpd:C04233','C04233',true).
concept_name0('36335: cpd:C04233','cpd:C04233',false).
concept_name0('36334: cpd:C05535','cpd:C05535',false).
concept_name0('36334: cpd:C05535','C05535',true).
concept_name0('36329: cpd:C01094','cpd:C01094',false).
concept_name0('36329: cpd:C01094','C01094',true).
concept_name0('37952: cpd:C02075 cpd:C02588','C02075...',true).
concept_name0('37952: cpd:C02075 cpd:C02588','cpd:C02075 cpd:C02588',false).
concept_name0('36328: cpd:C00320','cpd:C00320',false).
concept_name0('36328: cpd:C00320','C00320',true).
concept_name0('36331: cpd:C05299','C05299',true).
concept_name0('36331: cpd:C05299','cpd:C05299',false).
concept_name0('37965: cpd:C16682','C16682',true).
concept_name0('37965: cpd:C16682','cpd:C16682',false).
concept_name0('36325: cpd:C16613','cpd:C16613',false).
concept_name0('36325: cpd:C16613','C16613',true).
concept_name0('36324: cpd:C16617','cpd:C16617',false).
concept_name0('36324: cpd:C16617','C16617',true).
concept_name0('36327: cpd:C11132','cpd:C11132',false).
concept_name0('36327: cpd:C11132','C11132',true).
concept_name0('36326: cpd:C18126','C18126',true).
concept_name0('36326: cpd:C18126','cpd:C18126',false).
concept_name0('37961: cpd:C02110','C02110',true).
concept_name0('37961: cpd:C02110','cpd:C02110',false).
concept_name0('36320: cpd:C07447','C07447',true).
concept_name0('36320: cpd:C07447','cpd:C07447',false).
concept_name0('36323: cpd:C00094','C00094',true).
concept_name0('36323: cpd:C00094','cpd:C00094',false).
concept_name0('37962: cpd:C16681','cpd:C16681',false).
concept_name0('37962: cpd:C16681','C16681',true).
concept_name0('36322: cpd:C05298','C05298',true).
concept_name0('36322: cpd:C05298','cpd:C05298',false).
concept_name0('36348: cpd:C00449','cpd:C00449',false).
concept_name0('36348: cpd:C00449','C00449',true).
concept_name0('36349: cpd:C11133','cpd:C11133',false).
concept_name0('36349: cpd:C11133','C11133',true).
concept_name0('37974: cpd:C16679','cpd:C16679',false).
concept_name0('37974: cpd:C16679','C16679',true).
concept_name0('36350: dr:D00358 cpd:C07073','dr:D00358 cpd:C07073',false).
concept_name0('36350: dr:D00358 cpd:C07073','D00358...',true).
concept_name0('36351: cpd:C03819','C03819',true).
concept_name0('36351: cpd:C03819','cpd:C03819',false).
concept_name0('36344: cpd:C01516;dr:D08233 cpd:C01516','dr:D08233 cpd:C01516',false).
concept_name0('36344: cpd:C01516;dr:D08233 cpd:C01516','cpd:C01516',false).
concept_name0('36344: cpd:C01516;dr:D08233 cpd:C01516','D08233...',true).
concept_name0('36344: cpd:C01516;dr:D08233 cpd:C01516','C01516',true).
concept_name0('36345: cpd:C00956','cpd:C00956',false).
concept_name0('36345: cpd:C00956','C00956',true).
concept_name0('37970: cpd:C15493','cpd:C15493',false).
concept_name0('37970: cpd:C15493','C15493',true).
concept_name0('36346: cpd:C18129','cpd:C18129',false).
concept_name0('36346: cpd:C18129','C18129',true).
concept_name0('36340: cpd:C04076','C04076',true).
concept_name0('36340: cpd:C04076','cpd:C04076',false).
concept_name0('36343: cpd:C05141','C05141',true).
concept_name0('36343: cpd:C05141','cpd:C05141',false).
concept_name0('36337: cpd:C05300','cpd:C05300',false).
concept_name0('36337: cpd:C05300','C05300',true).
concept_name0('36338: cpd:C16560','cpd:C16560',false).
concept_name0('36338: cpd:C16560','C16560',true).
concept_name0('36339: cpd:C00040','cpd:C00040',false).
concept_name0('36339: cpd:C00040','C00040',true).
concept_name0('36235: cpd:C03715','C03715',true).
concept_name0('36235: cpd:C03715','cpd:C03715',false).
concept_name0('36234: cpd:C00800','C00800',true).
concept_name0('36234: cpd:C00800','cpd:C00800',false).
concept_name0('37921: cpd:C15492','cpd:C15492',false).
concept_name0('37921: cpd:C15492','C15492',true).
concept_name0('36233: cpd:C00217','cpd:C00217',false).
concept_name0('36233: cpd:C00217','C00217',true).
concept_name0('36232: cpd:C06126','C06126',true).
concept_name0('36232: cpd:C06126','cpd:C06126',false).
concept_name0('36239: cpd:C00181','C00181',true).
concept_name0('36239: cpd:C00181','cpd:C00181',false).
concept_name0('36238: cpd:C00124','C00124',true).
concept_name0('36238: cpd:C00124','cpd:C00124',false).
concept_name0('37925: cpd:C03455','C03455',true).
concept_name0('37925: cpd:C03455','cpd:C03455',false).
concept_name0('36237: cpd:C06128','cpd:C06128',false).
concept_name0('36237: cpd:C06128','C06128',true).
concept_name0('37930: cpd:C03440','C03440',true).
concept_name0('37930: cpd:C03440','cpd:C03440',false).
concept_name0('37929: cpd:C05639','C05639',true).
concept_name0('37929: cpd:C05639','cpd:C05639',false).
concept_name0('36224: dr:D07704 cpd:C07572','D07704...',true).
concept_name0('36224: dr:D07704 cpd:C07572','dr:D07704 cpd:C07572',false).
concept_name0('37935: cpd:C04282','C04282',true).
concept_name0('37935: cpd:C04282','cpd:C04282',false).
concept_name0('36231: cpd:C05212','cpd:C05212',false).
concept_name0('36231: cpd:C05212','C05212',true).
concept_name0('37934: cpd:C05638','C05638',true).
concept_name0('37934: cpd:C05638','cpd:C05638',false).
concept_name0('36229: cpd:C06127','cpd:C06127',false).
concept_name0('36229: cpd:C06127','C06127',true).
concept_name0('37932: cpd:C11061','cpd:C11061',false).
concept_name0('37932: cpd:C11061','C11061',true).
concept_name0('36228: cpd:C00191','C00191',true).
concept_name0('36228: cpd:C00191','cpd:C00191',false).
concept_name0('37938: cpd:C05651','cpd:C05651',false).
concept_name0('37938: cpd:C05651','C05651',true).
concept_name0('36250: cpd:C05859','cpd:C05859',false).
concept_name0('36250: cpd:C05859','C05859',true).
concept_name0('36251: cpd:C15645','cpd:C15645',false).
concept_name0('36251: cpd:C15645','C15645',true).
concept_name0('37936: cpd:C16677','cpd:C16677',false).
concept_name0('37936: cpd:C16677','C16677',true).
concept_name0('36254: cpd:C15646','cpd:C15646',false).
concept_name0('36254: cpd:C15646','C15646',true).
concept_name0('36255: cpd:C02686','C02686',true).
concept_name0('36255: cpd:C02686','cpd:C02686',false).
concept_name0('37941: cpd:C00376','cpd:C00376',false).
concept_name0('37941: cpd:C00376','C00376',true).
concept_name0('36242: cpd:C00199','cpd:C00199',false).
concept_name0('36242: cpd:C00199','C00199',true).
concept_name0('36243: cpd:C02934','cpd:C02934',false).
concept_name0('36243: cpd:C02934','C02934',true).
concept_name0('36240: cpd:C06125','C06125',true).
concept_name0('36240: cpd:C06125','cpd:C06125',false).
concept_name0('37950: cpd:C06037','C06037',true).
concept_name0('37950: cpd:C06037','cpd:C06037',false).
concept_name0('36246: cpd:C00231','C00231',true).
concept_name0('36246: cpd:C00231','cpd:C00231',false).
concept_name0('37948: cpd:C00777','cpd:C00777',false).
concept_name0('37948: cpd:C00777','C00777',true).
concept_name0('36244: cpd:C16586','cpd:C16586',false).
concept_name0('36244: cpd:C16586','C16586',true).
concept_name0('36265: cpd:C04756','C04756',true).
concept_name0('36265: cpd:C04756','cpd:C04756',false).
concept_name0('36264: cpd:C04317','cpd:C04317',false).
concept_name0('36264: cpd:C04317','C04317',true).
concept_name0('36267: dr:D04931 cpd:C02380','D04931...',true).
concept_name0('36267: dr:D04931 cpd:C02380','dr:D04931 cpd:C02380',false).
concept_name0('36266: cpd:C00008','cpd:C00008',false).
concept_name0('36266: cpd:C00008','C00008',true).
concept_name0('36269: cpd:C02336','C02336',true).
concept_name0('36269: cpd:C02336','cpd:C02336',false).
concept_name0('36268: cpd:C15650','C15650',true).
concept_name0('36268: cpd:C15650','cpd:C15650',false).
concept_name0('37895: cpd:C00473','C00473',true).
concept_name0('37895: cpd:C00473','cpd:C00473',false).
concept_name0('36270: cpd:C02170','C02170',true).
concept_name0('36270: cpd:C02170','cpd:C02170',false).
concept_name0('36257: cpd:C00195','C00195',true).
concept_name0('36257: cpd:C00195','cpd:C00195',false).
concept_name0('36258: cpd:C00160','C00160',true).
concept_name0('36258: cpd:C00160','cpd:C00160',false).
concept_name0('36261: cpd:C00319','cpd:C00319',false).
concept_name0('36261: cpd:C00319','C00319',true).
concept_name0('36260: cpd:C16553','cpd:C16553',false).
concept_name0('36260: cpd:C16553','C16553',true).
concept_name0('36263: cpd:C00310','C00310',true).
concept_name0('36263: cpd:C00310','cpd:C00310',false).
concept_name0('36262: cpd:C01233','C01233',true).
concept_name0('36262: cpd:C01233','cpd:C01233',false).
concept_name0('36280: cpd:C04188','cpd:C04188',false).
concept_name0('36280: cpd:C04188','C04188',true).
concept_name0('36282: cpd:C06114','cpd:C06114',false).
concept_name0('36282: cpd:C06114','C06114',true).
concept_name0('36283: cpd:C00346','cpd:C00346',false).
concept_name0('36283: cpd:C00346','C00346',true).
concept_name0('36284: cpd:C01213','cpd:C01213',false).
concept_name0('36284: cpd:C01213','C01213',true).
concept_name0('37910: cpd:C00422','cpd:C00422',false).
concept_name0('37910: cpd:C00422','C00422',true).
concept_name0('36286: cpd:C15647','cpd:C15647',false).
concept_name0('36286: cpd:C15647','C15647',true).
concept_name0('36287: cpd:C05503','C05503',true).
concept_name0('36287: cpd:C05503','cpd:C05503',false).
concept_name0('36272: cpd:C01190','C01190',true).
concept_name0('36272: cpd:C01190','cpd:C01190',false).
concept_name0('36273: cpd:C16618','cpd:C16618',false).
concept_name0('36273: cpd:C16618','C16618',true).
concept_name0('36274: cpd:C04582','cpd:C04582',false).
concept_name0('36274: cpd:C04582','C04582',true).
concept_name0('36276: cpd:C06002','C06002',true).
concept_name0('36276: cpd:C06002','cpd:C06002',false).
concept_name0('36278: cpd:C03090','C03090',true).
concept_name0('36278: cpd:C03090','cpd:C03090',false).
concept_name0('37919: cpd:C05648','cpd:C05648',false).
concept_name0('37919: cpd:C05648','C05648',true).
concept_name0('36279: cpd:C01120','cpd:C01120',false).
concept_name0('36279: cpd:C01120','C01120',true).
concept_name0('38127: cpd:C01079','C01079',true).
concept_name0('38127: cpd:C01079','cpd:C01079',false).
concept_name0('36167: cpd:C00418','C00418',true).
concept_name0('36167: cpd:C00418','cpd:C00418',false).
concept_name0('36164: cpd:C00222','C00222',true).
concept_name0('36164: cpd:C00222','cpd:C00222',false).
concept_name0('36165: cpd:C01107','C01107',true).
concept_name0('36165: cpd:C01107','cpd:C01107',false).
concept_name0('36162: cpd:C00315','cpd:C00315',false).
concept_name0('36162: cpd:C00315','C00315',true).
concept_name0('38123: cpd:C02191','cpd:C02191',false).
concept_name0('38123: cpd:C02191','C02191',true).
concept_name0('36163: cpd:C02630','C02630',true).
concept_name0('36163: cpd:C02630','cpd:C02630',false).
concept_name0('36161: cpd:C01143','cpd:C01143',false).
concept_name0('36161: cpd:C01143','C01143',true).
concept_name0('36174: cpd:C00103','cpd:C00103',false).
concept_name0('36174: cpd:C00103','C00103',true).
concept_name0('36175: cpd:C00668','C00668',true).
concept_name0('36175: cpd:C00668','cpd:C00668',false).
concept_name0('38116: cpd:C00486','cpd:C00486',false).
concept_name0('38116: cpd:C00486','C00486',true).
concept_name0('36172: cpd:C00072','C00072',true).
concept_name0('36172: cpd:C00072','cpd:C00072',false).
concept_name0('36173: cpd:C00532','C00532',true).
concept_name0('36173: cpd:C00532','cpd:C00532',false).
concept_name0('36170: cpd:C00092','C00092',true).
concept_name0('36170: cpd:C00092','cpd:C00092',false).
concept_name0('36171: cpd:C03012','C03012',true).
concept_name0('36171: cpd:C03012','cpd:C03012',false).
concept_name0('38112: cpd:C03287','C03287',true).
concept_name0('38112: cpd:C03287','cpd:C03287',false).
concept_name0('36169: cpd:C00227','C00227',true).
concept_name0('36169: cpd:C00227','cpd:C00227',false).
concept_name0('38143: cpd:C02946','cpd:C02946',false).
concept_name0('38143: cpd:C02946','C02946',true).
concept_name0('36183: cpd:C00267','C00267',true).
concept_name0('36183: cpd:C00267','cpd:C00267',false).
concept_name0('36182: cpd:C05401','C05401',true).
concept_name0('36182: cpd:C05401','cpd:C05401',false).
concept_name0('38141: cpd:C05936','cpd:C05936',false).
concept_name0('38141: cpd:C05936','C05936',true).
concept_name0('36181: cpd:C16643','C16643',true).
concept_name0('36181: cpd:C16643','cpd:C16643',false).
concept_name0('36180: cpd:C04006','cpd:C04006',false).
concept_name0('36180: cpd:C04006','C04006',true).
concept_name0('36179: cpd:C00129','cpd:C00129',false).
concept_name0('36179: cpd:C00129','C00129',true).
concept_name0('36178: cpd:C05668','C05668',true).
concept_name0('36178: cpd:C05668','cpd:C05668',false).
concept_name0('38137: cpd:C00500','C00500',true).
concept_name0('38137: cpd:C00500','cpd:C00500',false).
concept_name0('36177: cpd:C00235','cpd:C00235',false).
concept_name0('36177: cpd:C00235','C00235',true).
concept_name0('38136: cpd:C03263','C03263',true).
concept_name0('38136: cpd:C03263','cpd:C03263',false).
concept_name0('36176: cpd:C00618','C00618',true).
concept_name0('36176: cpd:C00618','cpd:C00618',false).
concept_name0('38135: cpd:C00179','cpd:C00179',false).
concept_name0('38135: cpd:C00179','C00179',true).
concept_name0('36191: cpd:C03454','C03454',true).
concept_name0('36191: cpd:C03454','cpd:C03454',false).
concept_name0('38134: cpd:C02990','C02990',true).
concept_name0('38134: cpd:C02990','cpd:C02990',false).
concept_name0('36190: cpd:C15973','C15973',true).
concept_name0('36190: cpd:C15973','cpd:C15973',false).
concept_name0('36189: cpd:C00670','cpd:C00670',false).
concept_name0('36189: cpd:C00670','C00670',true).
concept_name0('36188: cpd:C00221','C00221',true).
concept_name0('36188: cpd:C00221','cpd:C00221',false).
concept_name0('38131: cpd:C05280','C05280',true).
concept_name0('38131: cpd:C05280','cpd:C05280',false).
concept_name0('36187: cpd:C15972','C15972',true).
concept_name0('36187: cpd:C15972','cpd:C15972',false).
concept_name0('38130: cpd:C14818','C14818',true).
concept_name0('38130: cpd:C14818','cpd:C14818',false).
concept_name0('36186: cpd:C00116','cpd:C00116',false).
concept_name0('36186: cpd:C00116','C00116',true).
concept_name0('36185: cpd:C00259','cpd:C00259',false).
concept_name0('36185: cpd:C00259','C00259',true).
concept_name0('38128: cpd:C01035','C01035',true).
concept_name0('38128: cpd:C01035','cpd:C01035',false).
concept_name0('36184: cpd:C00044','cpd:C00044',false).
concept_name0('36184: cpd:C00044','C00044',true).
concept_name0('38092: cpd:C05766','C05766',true).
concept_name0('38092: cpd:C05766','cpd:C05766',false).
concept_name0('36196: cpd:C05977','C05977',true).
concept_name0('36196: cpd:C05977','cpd:C05977',false).
concept_name0('38093: cpd:C00437','C00437',true).
concept_name0('38093: cpd:C00437','cpd:C00437',false).
concept_name0('36197: cpd:C01172','C01172',true).
concept_name0('36197: cpd:C01172','cpd:C01172',false).
concept_name0('36198: cpd:C04598','C04598',true).
concept_name0('36198: cpd:C04598','cpd:C04598',false).
concept_name0('36199: cpd:C16255','C16255',true).
concept_name0('36199: cpd:C16255','cpd:C16255',false).
concept_name0('36193: cpd:C00047','C00047',true).
concept_name0('36193: cpd:C00047','cpd:C00047',false).
concept_name0('38090: cpd:C01051','C01051',true).
concept_name0('38090: cpd:C01051','cpd:C01051',false).
concept_name0('36194: cpd:C00155','C00155',true).
concept_name0('36194: cpd:C00155','cpd:C00155',false).
concept_name0('36195: cpd:C04475','C04475',true).
concept_name0('36195: cpd:C04475','cpd:C04475',false).
concept_name0('38084: cpd:C00624','cpd:C00624',false).
concept_name0('38084: cpd:C00624','C00624',true).
concept_name0('36204: cpd:C03372','cpd:C03372',false).
concept_name0('36204: cpd:C03372','C03372',true).
concept_name0('38085: cpd:C01024','C01024',true).
concept_name0('38085: cpd:C01024','cpd:C01024',false).
concept_name0('36205: cpd:C00472','cpd:C00472',false).
concept_name0('36205: cpd:C00472','C00472',true).
concept_name0('36206: cpd:C16607','C16607',true).
concept_name0('36206: cpd:C16607','cpd:C16607',false).
concept_name0('36207: cpd:C03820','cpd:C03820',false).
concept_name0('36207: cpd:C03820','C03820',true).
concept_name0('36200: cpd:C00379','C00379',true).
concept_name0('36200: cpd:C00379','cpd:C00379',false).
concept_name0('36201: cpd:C00530','cpd:C00530',false).
concept_name0('36201: cpd:C00530','C00530',true).
concept_name0('36203: cpd:C00550','C00550',true).
concept_name0('36203: cpd:C00550','cpd:C00550',false).
concept_name0('36213: cpd:C02266','cpd:C02266',false).
concept_name0('36213: cpd:C02266','C02266',true).
concept_name0('36212: cpd:C00159','C00159',true).
concept_name0('36212: cpd:C00159','cpd:C00159',false).
concept_name0('36215: cpd:C04635','cpd:C04635',false).
concept_name0('36215: cpd:C04635','C04635',true).
concept_name0('36214: cpd:C00091','C00091',true).
concept_name0('36214: cpd:C00091','cpd:C00091',false).
concept_name0('36209: cpd:C02960','cpd:C02960',false).
concept_name0('36209: cpd:C02960','C02960',true).
concept_name0('36208: cpd:C00819','cpd:C00819',false).
concept_name0('36208: cpd:C00819','C00819',true).
concept_name0('38100: cpd:C05768','C05768',true).
concept_name0('38100: cpd:C05768','cpd:C05768',false).
concept_name0('36220: cpd:C00312','cpd:C00312',false).
concept_name0('36220: cpd:C00312','C00312',true).
concept_name0('36222: cpd:C03201','C03201',true).
concept_name0('36222: cpd:C03201','cpd:C03201',false).
concept_name0('36216: cpd:C16608','C16608',true).
concept_name0('36216: cpd:C16608','cpd:C16608',false).
concept_name0('36218: cpd:C00143','C00143',true).
concept_name0('36218: cpd:C00143','cpd:C00143',false).
concept_name0('36099: cpd:C03771','cpd:C03771',false).
concept_name0('36099: cpd:C03771','C03771',true).
concept_name0('36096: cpd:C00334','cpd:C00334',false).
concept_name0('36096: cpd:C00334','C00334',true).
concept_name0('36097: cpd:C01762','C01762',true).
concept_name0('36097: cpd:C01762','cpd:C01762',false).
concept_name0('36103: cpd:C06426','cpd:C06426',false).
concept_name0('36103: cpd:C06426','C06426',true).
concept_name0('36100: cpd:C03508','cpd:C03508',false).
concept_name0('36100: cpd:C03508','C03508',true).
concept_name0('38061: cpd:C00763','cpd:C00763',false).
concept_name0('38061: cpd:C00763','C00763',true).
concept_name0('36107: cpd:C16651','cpd:C16651',false).
concept_name0('36107: cpd:C16651','C16651',true).
concept_name0('36105: cpd:C00515','C00515',true).
concept_name0('36105: cpd:C00515','cpd:C00515',false).
concept_name0('36110: cpd:C00792','cpd:C00792',false).
concept_name0('36110: cpd:C00792','C00792',true).
concept_name0('36111: cpd:C00683','cpd:C00683',false).
concept_name0('36111: cpd:C00683','C00683',true).
concept_name0('36108: cpd:C03373','cpd:C03373',false).
concept_name0('36108: cpd:C03373','C03373',true).
concept_name0('36114: cpd:C00164','C00164',true).
concept_name0('36114: cpd:C00164','cpd:C00164',false).
concept_name0('38072: cpd:C05791','C05791',true).
concept_name0('38072: cpd:C05791','cpd:C05791',false).
concept_name0('36112: gl:G00057','G00057',true).
concept_name0('36112: gl:G00057','gl:G00057',false).
concept_name0('36116: cpd:C00062','cpd:C00062',false).
concept_name0('36116: cpd:C00062','C00062',true).
concept_name0('36123: cpd:C00433','cpd:C00433',false).
concept_name0('36123: cpd:C00433','C00433',true).
concept_name0('36122: cpd:C00417','cpd:C00417',false).
concept_name0('36122: cpd:C00417','C00417',true).
concept_name0('38065: cpd:C03564','cpd:C03564',false).
concept_name0('38065: cpd:C03564','C03564',true).
concept_name0('36120: cpd:C00119','C00119',true).
concept_name0('36120: cpd:C00119','cpd:C00119',false).
concept_name0('38071: cpd:C02305','C02305',true).
concept_name0('38071: cpd:C02305','cpd:C02305',false).
concept_name0('36127: cpd:C00341','cpd:C00341',false).
concept_name0('36127: cpd:C00341','C00341',true).
concept_name0('38069: cpd:C05933','cpd:C05933',false).
concept_name0('38069: cpd:C05933','C05933',true).
concept_name0('36125: cpd:C03232','cpd:C03232',false).
concept_name0('36125: cpd:C03232','C03232',true).
concept_name0('38068: cpd:C06508','cpd:C06508',false).
concept_name0('38068: cpd:C06508','C06508',true).
concept_name0('36128: cpd:C00123','cpd:C00123',false).
concept_name0('36128: cpd:C00123','C00123',true).
concept_name0('38025: cpd:C05787','cpd:C05787',false).
concept_name0('38025: cpd:C05787','C05787',true).
concept_name0('36129: cpd:C00074','C00074',true).
concept_name0('36129: cpd:C00074','cpd:C00074',false).
concept_name0('36132: cpd:C00311','cpd:C00311',false).
concept_name0('36132: cpd:C00311','C00311',true).
concept_name0('38030: cpd:C00032','cpd:C00032',false).
concept_name0('38030: cpd:C00032','C00032',true).
concept_name0('36134: cpd:C05167','C05167',true).
concept_name0('36134: cpd:C05167','cpd:C05167',false).
concept_name0('36135: cpd:C00233','C00233',true).
concept_name0('36135: cpd:C00233','cpd:C00233',false).
concept_name0('36136: cpd:C16584','cpd:C16584',false).
concept_name0('36136: cpd:C16584','C16584',true).
concept_name0('36137: cpd:C00042','cpd:C00042',false).
concept_name0('36137: cpd:C00042','C00042',true).
concept_name0('38018: cpd:C00327','cpd:C00327',false).
concept_name0('38018: cpd:C00327','C00327',true).
concept_name0('36139: cpd:C00137','C00137',true).
concept_name0('36139: cpd:C00137','cpd:C00137',false).
concept_name0('36140: cpd:C00163','C00163',true).
concept_name0('36140: cpd:C00163','cpd:C00163',false).
concept_name0('36141: cpd:C16587','C16587',true).
concept_name0('36141: cpd:C16587','cpd:C16587',false).
concept_name0('38022: cpd:C15672','cpd:C15672',false).
concept_name0('38022: cpd:C15672','C15672',true).
concept_name0('36142: cpd:C00167','C00167',true).
concept_name0('36142: cpd:C00167','cpd:C00167',false).
concept_name0('36145: cpd:C02291','C02291',true).
concept_name0('36145: cpd:C02291','cpd:C02291',false).
concept_name0('36144: cpd:C00100','cpd:C00100',false).
concept_name0('36144: cpd:C00100','C00100',true).
concept_name0('36147: cpd:C03033','C03033',true).
concept_name0('36147: cpd:C03033','cpd:C03033',false).
concept_name0('36146: cpd:C16582','C16582',true).
concept_name0('36146: cpd:C16582','cpd:C16582',false).
concept_name0('36148: cpd:C17432','cpd:C17432',false).
concept_name0('36148: cpd:C17432','C17432',true).
concept_name0('36151: cpd:C00186','cpd:C00186',false).
concept_name0('36151: cpd:C00186','C00186',true).
concept_name0('36150: cpd:C00213','C00213',true).
concept_name0('36150: cpd:C00213','cpd:C00213',false).
concept_name0('36153: dr:D08195 cpd:C07163','dr:D08195 cpd:C07163',false).
concept_name0('36153: dr:D08195 cpd:C07163','D08195...',true).
concept_name0('38032: cpd:C00931','cpd:C00931',false).
concept_name0('38032: cpd:C00931','C00931',true).
concept_name0('36152: cpd:C00108','C00108',true).
concept_name0('36152: cpd:C00108','cpd:C00108',false).
concept_name0('36155: cpd:C00894','cpd:C00894',false).
concept_name0('36155: cpd:C00894','C00894',true).
concept_name0('36154: cpd:C00039','cpd:C00039',false).
concept_name0('36154: cpd:C00039','C00039',true).
concept_name0('36157: cpd:C00188','cpd:C00188',false).
concept_name0('36157: cpd:C00188','C00188',true).
concept_name0('36159: cpd:C02047','C02047',true).
concept_name0('36159: cpd:C02047','cpd:C02047',false).
concept_name0('36158: cpd:C16659','C16659',true).
concept_name0('36158: cpd:C16659','cpd:C16659',false).
concept_name0('36060: cpd:C00448','cpd:C00448',false).
concept_name0('36060: cpd:C00448','C00448',true).
concept_name0('38261: cpd:C05109','cpd:C05109',false).
concept_name0('38261: cpd:C05109','C05109',true).
concept_name0('36061: cpd:C16602','cpd:C16602',false).
concept_name0('36061: cpd:C16602','C16602',true).
concept_name0('38262: cpd:C03793','C03793',true).
concept_name0('38262: cpd:C03793','cpd:C03793',false).
concept_name0('36062: cpd:C02972','C02972',true).
concept_name0('36062: cpd:C02972','cpd:C02972',false).
concept_name0('36063: cpd:C00029','cpd:C00029',false).
concept_name0('36063: cpd:C00029','C00029',true).
concept_name0('38256: cpd:C11455','cpd:C11455',false).
concept_name0('38256: cpd:C11455','C11455',true).
concept_name0('36056: cpd:C00258','cpd:C00258',false).
concept_name0('36056: cpd:C00258','C00258',true).
concept_name0('36058: gl:G00086','gl:G00086',false).
concept_name0('36058: gl:G00086','G00086',true).
concept_name0('38269: cpd:C05108','cpd:C05108',false).
concept_name0('38269: cpd:C05108','C05108',true).
concept_name0('36053: dr:D00252 cpd:C06868','D00252...',true).
concept_name0('36053: dr:D00252 cpd:C06868','dr:D00252 cpd:C06868',false).
concept_name0('38264: cpd:C15808','C15808',true).
concept_name0('38264: cpd:C15808','cpd:C15808',false).
concept_name0('36048: cpd:C00577','cpd:C00577',false).
concept_name0('36048: cpd:C00577','C00577',true).
concept_name0('38266: cpd:C05546','cpd:C05546',false).
concept_name0('38266: cpd:C05546','C05546',true).
concept_name0('38245: cpd:C01149','C01149',true).
concept_name0('38245: cpd:C01149','cpd:C01149',false).
concept_name0('36044: cpd:C00407','C00407',true).
concept_name0('36044: cpd:C00407','cpd:C00407',false).
concept_name0('36047: cpd:C00041','cpd:C00041',false).
concept_name0('36047: cpd:C00041','C00041',true).
concept_name0('36041: gl:G00088','gl:G00088',false).
concept_name0('36041: gl:G00088','G00088',true).
concept_name0('36040: cpd:C00099','C00099',true).
concept_name0('36040: cpd:C00099','cpd:C00099',false).
concept_name0('36043: cpd:C01005','cpd:C01005',false).
concept_name0('36043: cpd:C01005','C01005',true).
concept_name0('36042: cpd:C00353','cpd:C00353',false).
concept_name0('36042: cpd:C00353','C00353',true).
concept_name0('36037: cpd:C07496','C07496',true).
concept_name0('36037: cpd:C07496','cpd:C07496',false).
concept_name0('36036: cpd:C02642','C02642',true).
concept_name0('36036: cpd:C02642','cpd:C02642',false).
concept_name0('38254: cpd:C15915','C15915',true).
concept_name0('38254: cpd:C15915','cpd:C15915',false).
concept_name0('36038: cpd:C00084','C00084',true).
concept_name0('36038: cpd:C00084','cpd:C00084',false).
concept_name0('38249: cpd:C01943','C01943',true).
concept_name0('38249: cpd:C01943','cpd:C01943',false).
concept_name0('36033: cpd:C00671','cpd:C00671',false).
concept_name0('36033: cpd:C00671','C00671',true).
concept_name0('36032: cpd:C00051','cpd:C00051',false).
concept_name0('36032: cpd:C00051','C00051',true).
concept_name0('36035: cpd:C00533','C00533',true).
concept_name0('36035: cpd:C00533','cpd:C00533',false).
concept_name0('38250: cpd:C06157','cpd:C06157',false).
concept_name0('38250: cpd:C06157','C06157',true).
concept_name0('36094: cpd:C00077','C00077',true).
concept_name0('36094: cpd:C00077','cpd:C00077',false).
concept_name0('38231: cpd:C11508','C11508',true).
concept_name0('38231: cpd:C11508','cpd:C11508',false).
concept_name0('36095: cpd:C00111','cpd:C00111',false).
concept_name0('36095: cpd:C00111','C00111',true).
concept_name0('36092: cpd:C01595','C01595',true).
concept_name0('36092: cpd:C01595','cpd:C01595',false).
concept_name0('36091: cpd:C00086','C00086',true).
concept_name0('36091: cpd:C00086','cpd:C00086',false).
concept_name0('36088: cpd:C00046','C00046',true).
concept_name0('36088: cpd:C00046','cpd:C00046',false).
concept_name0('36089: cpd:C00059','C00059',true).
concept_name0('36089: cpd:C00059','cpd:C00059',false).
concept_name0('36087: cpd:C05345','C05345',true).
concept_name0('36087: cpd:C05345','cpd:C05345',false).
concept_name0('36084: cpd:C00628','C00628',true).
concept_name0('36084: cpd:C00628','cpd:C00628',false).
concept_name0('36085: cpd:C00122','cpd:C00122',false).
concept_name0('36085: cpd:C00122','C00122',true).
concept_name0('38235: cpd:C01802','cpd:C01802',false).
concept_name0('38235: cpd:C01802','C01802',true).
concept_name0('38233: cpd:C15776','cpd:C15776',false).
concept_name0('38233: cpd:C15776','C15776',true).
concept_name0('38215: cpd:C15781','cpd:C15781',false).
concept_name0('38215: cpd:C15781','C15781',true).
concept_name0('36079: cpd:C00058','C00058',true).
concept_name0('36079: cpd:C00058','cpd:C00058',false).
concept_name0('38214: cpd:C05107','C05107',true).
concept_name0('38214: cpd:C05107','cpd:C05107',false).
concept_name0('36078: cpd:C01144','cpd:C01144',false).
concept_name0('36078: cpd:C01144','C01144',true).
concept_name0('36077: cpd:C00232','C00232',true).
concept_name0('36077: cpd:C00232','cpd:C00232',false).
concept_name0('38212: cpd:C01561','C01561',true).
concept_name0('38212: cpd:C01561','cpd:C01561',false).
concept_name0('36076: cpd:C00101','cpd:C00101',false).
concept_name0('36076: cpd:C00101','C00101',true).
concept_name0('36075: cpd:C03127','C03127',true).
concept_name0('36075: cpd:C03127','cpd:C03127',false).
concept_name0('38210: cpd:C01673','cpd:C01673',false).
concept_name0('38210: cpd:C01673','C01673',true).
concept_name0('36074: cpd:C00877','cpd:C00877',false).
concept_name0('36074: cpd:C00877','C00877',true).
concept_name0('36073: gl:G00085','G00085',true).
concept_name0('36073: gl:G00085','gl:G00085',false).
concept_name0('36072: cpd:C16610','cpd:C16610',false).
concept_name0('36072: cpd:C16610','C16610',true).
concept_name0('38223: cpd:C08821','cpd:C08821',false).
concept_name0('38223: cpd:C08821','C08821',true).
concept_name0('36071: cpd:C15777','cpd:C15777',false).
concept_name0('36071: cpd:C15777','C15777',true).
concept_name0('38222: cpd:C15782','C15782',true).
concept_name0('38222: cpd:C15782','cpd:C15782',false).
concept_name0('36069: cpd:C01110','cpd:C01110',false).
concept_name0('36069: cpd:C01110','C01110',true).
concept_name0('38220: cpd:C01753','C01753',true).
concept_name0('38220: cpd:C01753','cpd:C01753',false).
concept_name0('36067: cpd:C02051','C02051',true).
concept_name0('36067: cpd:C02051','cpd:C02051',false).
concept_name0('38218: cpd:C15780','cpd:C15780',false).
concept_name0('38218: cpd:C15780','C15780',true).
concept_name0('36066: gl:G00067','gl:G00067',false).
concept_name0('36066: gl:G00067','G00067',true).
concept_name0('36065: cpd:C16609','cpd:C16609',false).
concept_name0('36065: cpd:C16609','C16609',true).
concept_name0('38216: cpd:C15783','cpd:C15783',false).
concept_name0('38216: cpd:C15783','C15783',true).
concept_name0('35992: cpd:C00083','C00083',true).
concept_name0('35992: cpd:C00083','cpd:C00083',false).
concept_name0('35993: gl:G00063','G00063',true).
concept_name0('35993: gl:G00063','gl:G00063',false).
concept_name0('35995: cpd:C00002','cpd:C00002',false).
concept_name0('35995: cpd:C00002','C00002',true).
concept_name0('35996: cpd:C03035','cpd:C03035',false).
concept_name0('35996: cpd:C03035','C03035',true).
concept_name0('35997: cpd:C01026','cpd:C01026',false).
concept_name0('35997: cpd:C01026','C01026',true).
concept_name0('35998: cpd:C00048','C00048',true).
concept_name0('35998: cpd:C00048','cpd:C00048',false).
concept_name0('35984: cpd:C00037','C00037',true).
concept_name0('35984: cpd:C00037','cpd:C00037',false).
concept_name0('35985: dr:D04716 cpd:C08012','D04716...',true).
concept_name0('35985: dr:D04716 cpd:C08012','dr:D04716 cpd:C08012',false).
concept_name0('35986: gl:G00062','gl:G00062',false).
concept_name0('35986: gl:G00062','G00062',true).
concept_name0('35988: cpd:C00190','C00190',true).
concept_name0('35988: cpd:C00190','cpd:C00190',false).
concept_name0('35990: cpd:C00300','cpd:C00300',false).
concept_name0('35990: cpd:C00300','C00300',true).
concept_name0('35991: cpd:C00082','C00082',true).
concept_name0('35991: cpd:C00082','cpd:C00082',false).
concept_name0('35977: cpd:C00096','C00096',true).
concept_name0('35977: cpd:C00096','cpd:C00096',false).
concept_name0('38176: cpd:C03547','C03547',true).
concept_name0('38176: cpd:C03547','cpd:C03547',false).
concept_name0('35976: gl:G00064','G00064',true).
concept_name0('35976: gl:G00064','gl:G00064',false).
concept_name0('35979: cpd:C00073','C00073',true).
concept_name0('35979: cpd:C00073','cpd:C00073',false).
concept_name0('35981: cpd:C00031','cpd:C00031',false).
concept_name0('35981: cpd:C00031','C00031',true).
concept_name0('35980: cpd:C00197','cpd:C00197',false).
concept_name0('35980: cpd:C00197','C00197',true).
concept_name0('35983: cpd:C02249','C02249',true).
concept_name0('35983: cpd:C02249','cpd:C02249',false).
concept_name0('35982: cpd:C00149','C00149',true).
concept_name0('35982: cpd:C00149','cpd:C00149',false).
concept_name0('35969: cpd:C00061','C00061',true).
concept_name0('35969: cpd:C00061','cpd:C00061',false).
concept_name0('35968: cpd:C02554','C02554',true).
concept_name0('35968: cpd:C02554','cpd:C02554',false).
concept_name0('35971: cpd:C00719','cpd:C00719',false).
concept_name0('35971: cpd:C00719','C00719',true).
concept_name0('35970: cpd:C00169','cpd:C00169',false).
concept_name0('35970: cpd:C00169','C00169',true).
concept_name0('35973: cpd:C16660','C16660',true).
concept_name0('35973: cpd:C16660','cpd:C16660',false).
concept_name0('35972: cpd:C03595','cpd:C03595',false).
concept_name0('35972: cpd:C03595','C03595',true).
concept_name0('35975: cpd:C01180','cpd:C01180',false).
concept_name0('35975: cpd:C01180','C01180',true).
concept_name0('35974: cpd:C00068','C00068',true).
concept_name0('35974: cpd:C00068','cpd:C00068',false).
concept_name0('36026: cpd:C00429','cpd:C00429',false).
concept_name0('36026: cpd:C00429','C00429',true).
concept_name0('38163: cpd:C00226','cpd:C00226',false).
concept_name0('38163: cpd:C00226','C00226',true).
concept_name0('36024: cpd:C00109','C00109',true).
concept_name0('36024: cpd:C00109','cpd:C00109',false).
concept_name0('36025: cpd:C00118','C00118',true).
concept_name0('36025: cpd:C00118','cpd:C00118',false).
concept_name0('36030: gl:G00089','gl:G00089',false).
concept_name0('36030: gl:G00089','G00089',true).
concept_name0('36031: cpd:C00011','cpd:C00011',false).
concept_name0('36031: cpd:C00011','C00011',true).
concept_name0('36028: cpd:C00168','cpd:C00168',false).
concept_name0('36028: cpd:C00168','C00168',true).
concept_name0('36018: cpd:C16162','cpd:C16162',false).
concept_name0('36018: cpd:C16162','C16162',true).
concept_name0('38168: cpd:C00524','C00524',true).
concept_name0('38168: cpd:C00524','cpd:C00524',false).
concept_name0('36016: cpd:C01179','C01179',true).
concept_name0('36016: cpd:C01179','cpd:C01179',false).
concept_name0('36017: cpd:C05125','cpd:C05125',false).
concept_name0('36017: cpd:C05125','C05125',true).
concept_name0('36023: cpd:C16601','cpd:C16601',false).
concept_name0('36023: cpd:C16601','C16601',true).
concept_name0('38147: cpd:C02714','cpd:C02714',false).
concept_name0('38147: cpd:C02714','C02714',true).
concept_name0('36010: cpd:C16169','cpd:C16169',false).
concept_name0('36010: cpd:C16169','C16169',true).
concept_name0('38144: cpd:C05279','C05279',true).
concept_name0('38144: cpd:C05279','cpd:C05279',false).
concept_name0('36008: cpd:C00581','cpd:C00581',false).
concept_name0('36008: cpd:C00581','C00581',true).
concept_name0('36015: gl:G00090','G00090',true).
concept_name0('36015: gl:G00090','gl:G00090',false).
concept_name0('36014: cpd:C00527','cpd:C00527',false).
concept_name0('36014: cpd:C00527','C00527',true).
concept_name0('38149: cpd:C05938','C05938',true).
concept_name0('38149: cpd:C05938','cpd:C05938',false).
concept_name0('36013: gl:G00060','gl:G00060',false).
concept_name0('36013: gl:G00060','G00060',true).
concept_name0('36003: cpd:C16165','cpd:C16165',false).
concept_name0('36003: cpd:C16165','C16165',true).
concept_name0('36002: cpd:C05519','cpd:C05519',false).
concept_name0('36002: cpd:C05519','C05519',true).
concept_name0('38153: cpd:C06505','cpd:C06505',false).
concept_name0('38153: cpd:C06505','C06505',true).
concept_name0('36000: gl:G00066','gl:G00066',false).
concept_name0('36000: gl:G00066','G00066',true).
concept_name0('38159: cpd:C01708','cpd:C01708',false).
concept_name0('38159: cpd:C01708','C01708',true).
concept_name0('38158: cpd:C06506','cpd:C06506',false).
concept_name0('38158: cpd:C06506','C06506',true).
concept_name0('38157: cpd:C00071','cpd:C00071',false).
concept_name0('38157: cpd:C00071','C00071',true).
concept_name0('36005: cpd:C00078','C00078',true).
concept_name0('36005: cpd:C00078','cpd:C00078',false).
concept_name0('38393: cpd:C04185','C04185',true).
concept_name0('38393: cpd:C04185','cpd:C04185',false).
concept_name0('38390: cpd:C18239','C18239',true).
concept_name0('38390: cpd:C18239','cpd:C18239',false).
concept_name0('38368: cpd:C05827','C05827',true).
concept_name0('38368: cpd:C05827','cpd:C05827',false).
concept_name0('38370: cpd:C05828','C05828',true).
concept_name0('38370: cpd:C05828','cpd:C05828',false).
concept_name0('35959: cpd:C00049','C00049',true).
concept_name0('35959: cpd:C00049','cpd:C00049',false).
concept_name0('35958: cpd:C00141','C00141',true).
concept_name0('35958: cpd:C00141','cpd:C00141',false).
concept_name0('35957: cpd:C00036','C00036',true).
concept_name0('35957: cpd:C00036','cpd:C00036',false).
concept_name0('35956: cpd:C00576','cpd:C00576',false).
concept_name0('35956: cpd:C00576','C00576',true).
concept_name0('35955: cpd:C00026','cpd:C00026',false).
concept_name0('35955: cpd:C00026','C00026',true).
concept_name0('35954: cpd:C00154','C00154',true).
concept_name0('35954: cpd:C00154','cpd:C00154',false).
concept_name0('35953: cpd:C00064','C00064',true).
concept_name0('35953: cpd:C00064','cpd:C00064',false).
concept_name0('35952: cpd:C00022','cpd:C00022',false).
concept_name0('35952: cpd:C00022','C00022',true).
concept_name0('35967: cpd:C00065','cpd:C00065',false).
concept_name0('35967: cpd:C00065','C00065',true).
concept_name0('35966: cpd:C00019','cpd:C00019',false).
concept_name0('35966: cpd:C00019','C00019',true).
concept_name0('35964: cpd:C00332','cpd:C00332',false).
concept_name0('35964: cpd:C00332','C00332',true).
concept_name0('35963: cpd:C16662','cpd:C16662',false).
concept_name0('35963: cpd:C16662','C16662',true).
concept_name0('35962: cpd:C00097','C00097',true).
concept_name0('35962: cpd:C00097','cpd:C00097',false).
concept_name0('38353: cpd:C05924','C05924',true).
concept_name0('38353: cpd:C05924','cpd:C05924',false).
concept_name0('35961: gl:G00069','G00069',true).
concept_name0('35961: gl:G00069','gl:G00069',false).
concept_name0('35960: cpd:C00025','C00025',true).
concept_name0('35960: cpd:C00025','cpd:C00025',false).
concept_name0('35942: cpd:C00356','cpd:C00356',false).
concept_name0('35942: cpd:C00356','C00356',true).
concept_name0('35943: cpd:C00079','C00079',true).
concept_name0('35943: cpd:C00079','cpd:C00079',false).
concept_name0('35940: cpd:C00158','C00158',true).
concept_name0('35940: cpd:C00158','cpd:C00158',false).
concept_name0('35941: cpd:C00014','cpd:C00014',false).
concept_name0('35941: cpd:C00014','C00014',true).
concept_name0('35950: cpd:C16661','cpd:C16661',false).
concept_name0('35950: cpd:C16661','C16661',true).
concept_name0('35951: cpd:C00136','C00136',true).
concept_name0('35951: cpd:C00136','cpd:C00136',false).
concept_name0('35948: gl:G00084','gl:G00084',false).
concept_name0('35948: gl:G00084','G00084',true).
concept_name0('35949: cpd:C00033','cpd:C00033',false).
concept_name0('35949: cpd:C00033','C00033',true).
concept_name0('35946: cpd:C00152','cpd:C00152',false).
concept_name0('35946: cpd:C00152','C00152',true).
concept_name0('35947: cpd:C00114','cpd:C00114',false).
concept_name0('35947: cpd:C00114','C00114',true).
concept_name0('35944: cpd:C00024','cpd:C00024',false).
concept_name0('35944: cpd:C00024','C00024',true).
concept_name0('35945: cpd:C00183','cpd:C00183',false).
concept_name0('35945: cpd:C00183','C00183',true).
concept_name0('38282: cpd:C01259','C01259',true).
concept_name0('38282: cpd:C01259','cpd:C01259',false).
concept_name0('38283: cpd:C00751','C00751',true).
concept_name0('38283: cpd:C00751','cpd:C00751',false).
concept_name0('38280: cpd:C01054','cpd:C01054',false).
concept_name0('38280: cpd:C01054','C01054',true).
concept_name0('38285: cpd:C03428','cpd:C03428',false).
concept_name0('38285: cpd:C03428','C03428',true).
concept_name0('38279: cpd:C01181','cpd:C01181',false).
concept_name0('38279: cpd:C01181','C01181',true).
concept_name0('38276: cpd:C00487','cpd:C00487',false).
concept_name0('38276: cpd:C00487','C00487',true).
concept_name0('38277: cpd:C01724','cpd:C01724',false).
concept_name0('38277: cpd:C01724','C01724',true).
concept_name0('36843: gl:G00148','G00148',true).
concept_name0('36843: gl:G00148','gl:G00148',false).
concept_name0('36844: cpd:C16551','cpd:C16551',false).
concept_name0('36844: cpd:C16551','C16551',true).
concept_name0('36847: cpd:C11583','C11583',true).
concept_name0('36847: cpd:C11583','cpd:C11583',false).
concept_name0('36846: gl:G00149','G00149',true).
concept_name0('36846: gl:G00149','gl:G00149',false).
concept_name0('38472: cpd:C15811','C15811',true).
concept_name0('38472: cpd:C15811','cpd:C15811',false).
concept_name0('36832: dr:D07760 cpd:C07888','D07760...',true).
concept_name0('36832: dr:D07760 cpd:C07888','dr:D07760 cpd:C07888',false).
concept_name0('36835: cpd:C16577','cpd:C16577',false).
concept_name0('36835: cpd:C16577','C16577',true).
concept_name0('38474: cpd:C15812','C15812',true).
concept_name0('38474: cpd:C15812','cpd:C15812',false).
concept_name0('36837: cpd:C05332','cpd:C05332',false).
concept_name0('36837: cpd:C05332','C05332',true).
concept_name0('36836: cpd:C00601','cpd:C00601',false).
concept_name0('36836: cpd:C00601','C00601',true).
concept_name0('36839: cpd:C02505','C02505',true).
concept_name0('36839: cpd:C02505','cpd:C02505',false).
concept_name0('36858: cpd:C05487','C05487',true).
concept_name0('36858: cpd:C05487','cpd:C05487',false).
concept_name0('36860: cpd:C05852','C05852',true).
concept_name0('36860: cpd:C05852','cpd:C05852',false).
concept_name0('36861: cpd:C00386','C00386',true).
concept_name0('36861: cpd:C00386','cpd:C00386',false).
concept_name0('36862: cpd:C00951','C00951',true).
concept_name0('36862: cpd:C00951','cpd:C00951',false).
concept_name0('38488: cpd:C04042','cpd:C04042',false).
concept_name0('38488: cpd:C04042','C04042',true).
concept_name0('36848: cpd:C00535','C00535',true).
concept_name0('36848: cpd:C00535','cpd:C00535',false).
concept_name0('36849: cpd:C07646','cpd:C07646',false).
concept_name0('36849: cpd:C07646','C07646',true).
concept_name0('36850: cpd:C00555','cpd:C00555',false).
concept_name0('36850: cpd:C00555','C00555',true).
concept_name0('36851: cpd:C00280','C00280',true).
concept_name0('36851: cpd:C00280','cpd:C00280',false).
concept_name0('36852: cpd:C00415','cpd:C00415',false).
concept_name0('36852: cpd:C00415','C00415',true).
concept_name0('36853: cpd:C00504','C00504',true).
concept_name0('36853: cpd:C00504','cpd:C00504',false).
concept_name0('38494: cpd:C02373','C02373',true).
concept_name0('38494: cpd:C02373','cpd:C02373',false).
concept_name0('36855: cpd:C05500','C05500',true).
concept_name0('36855: cpd:C05500','cpd:C05500',false).
concept_name0('38499: cpd:C18044','C18044',true).
concept_name0('38499: cpd:C18044','cpd:C18044',false).
concept_name0('36811: cpd:C15980','C15980',true).
concept_name0('36811: cpd:C15980','cpd:C15980',false).
concept_name0('36809: gl:G13044','G13044',true).
concept_name0('36809: gl:G13044','gl:G13044',false).
concept_name0('38496: cpd:C18038','cpd:C18038',false).
concept_name0('38496: cpd:C18038','C18038',true).
concept_name0('36808: dr:D00399 cpd:C07185','dr:D00399 cpd:C07185',false).
concept_name0('36808: dr:D00399 cpd:C07185','D00399...',true).
concept_name0('38503: cpd:C05502','C05502',true).
concept_name0('38503: cpd:C05502','cpd:C05502',false).
concept_name0('36814: gl:G00147','G00147',true).
concept_name0('36814: gl:G00147','gl:G00147',false).
concept_name0('38501: cpd:C05501','C05501',true).
concept_name0('38501: cpd:C05501','cpd:C05501',false).
concept_name0('36813: cpd:C15979','C15979',true).
concept_name0('36813: cpd:C15979','cpd:C15979',false).
concept_name0('36812: cpd:C04717','cpd:C04717',false).
concept_name0('36812: cpd:C04717','C04717',true).
concept_name0('36803: cpd:C00669','cpd:C00669',false).
concept_name0('36803: cpd:C00669','C00669',true).
concept_name0('38511: cpd:C03772','cpd:C03772',false).
concept_name0('38511: cpd:C03772','C03772',true).
concept_name0('36806: gl:G10610','G10610',true).
concept_name0('36806: gl:G10610','gl:G10610',false).
concept_name0('36805: cpd:C07645','cpd:C07645',false).
concept_name0('36805: cpd:C07645','C07645',true).
concept_name0('38508: cpd:C00674','C00674',true).
concept_name0('38508: cpd:C00674','cpd:C00674',false).
concept_name0('36804: cpd:C01879','cpd:C01879',false).
concept_name0('36804: cpd:C01879','C01879',true).
concept_name0('38515: cpd:C04295','C04295',true).
concept_name0('38515: cpd:C04295','cpd:C04295',false).
concept_name0('36827: cpd:C00445','C00445',true).
concept_name0('36827: cpd:C00445','cpd:C00445',false).
concept_name0('36824: cpd:C15977','C15977',true).
concept_name0('36824: cpd:C15977','cpd:C15977',false).
concept_name0('38513: cpd:C05285','cpd:C05285',false).
concept_name0('38513: cpd:C05285','C05285',true).
concept_name0('38518: cpd:C05139','cpd:C05139',false).
concept_name0('38518: cpd:C05139','C05139',true).
concept_name0('36830: gl:G00145','G00145',true).
concept_name0('36830: gl:G00145','gl:G00145',false).
concept_name0('36831: cpd:C07086','cpd:C07086',false).
concept_name0('36831: cpd:C07086','C07086',true).
concept_name0('38516: cpd:C05140','C05140',true).
concept_name0('38516: cpd:C05140','cpd:C05140',false).
concept_name0('36828: gl:G00143','gl:G00143',false).
concept_name0('36828: gl:G00143','G00143',true).
concept_name0('36829: cpd:C16576','cpd:C16576',false).
concept_name0('36829: cpd:C16576','C16576',true).
concept_name0('36818: gl:G00146','G00146',true).
concept_name0('36818: gl:G00146','gl:G00146',false).
concept_name0('38521: cpd:C01227','C01227',true).
concept_name0('38521: cpd:C01227','cpd:C01227',false).
concept_name0('38526: cpd:C05490','cpd:C05490',false).
concept_name0('38526: cpd:C05490','C05490',true).
concept_name0('36822: gl:G00144','gl:G00144',false).
concept_name0('36822: gl:G00144','G00144',true).
concept_name0('36823: cpd:C02189','cpd:C02189',false).
concept_name0('36823: cpd:C02189','C02189',true).
concept_name0('38524: cpd:C05478','cpd:C05478',false).
concept_name0('38524: cpd:C05478','C05478',true).
concept_name0('36820: cpd:C16578','cpd:C16578',false).
concept_name0('36820: cpd:C16578','C16578',true).
concept_name0('36780: gl:G10617','gl:G10617',false).
concept_name0('36780: gl:G10617','G10617',true).
concept_name0('36783: cpd:C16548','cpd:C16548',false).
concept_name0('36783: cpd:C16548','C16548',true).
concept_name0('36782: cpd:C14825','C14825',true).
concept_name0('36782: cpd:C14825','cpd:C14825',false).
concept_name0('36776: cpd:C00343','cpd:C00343',false).
concept_name0('36776: cpd:C00343','C00343',true).
concept_name0('36779: cpd:C00342','cpd:C00342',false).
concept_name0('36779: cpd:C00342','C00342',true).
concept_name0('36773: cpd:C00075','cpd:C00075',false).
concept_name0('36773: cpd:C00075','C00075',true).
concept_name0('36772: cpd:C00010','C00010',true).
concept_name0('36772: cpd:C00010','cpd:C00010',false).
concept_name0('36775: dr:D08559 cpd:C07108','D08559...',true).
concept_name0('36775: dr:D08559 cpd:C07108','dr:D08559 cpd:C07108',false).
concept_name0('36774: cpd:C02320','cpd:C02320',false).
concept_name0('36774: cpd:C02320','C02320',true).
concept_name0('36771: cpd:C05011','C05011',true).
concept_name0('36771: cpd:C05011','cpd:C05011',false).
concept_name0('36770: cpd:C01322','C01322',true).
concept_name0('36770: cpd:C01322','cpd:C01322',false).
concept_name0('36796: cpd:C03740','C03740',true).
concept_name0('36796: cpd:C03740','cpd:C03740',false).
concept_name0('36798: cpd:C16561','cpd:C16561',false).
concept_name0('36798: cpd:C16561','C16561',true).
concept_name0('36793: cpd:C01419','cpd:C01419',false).
concept_name0('36793: cpd:C01419','C01419',true).
concept_name0('36788: cpd:C16547','C16547',true).
concept_name0('36788: cpd:C16547','cpd:C16547',false).
concept_name0('36789: cpd:C06482','cpd:C06482',false).
concept_name0('36789: cpd:C06482','C06482',true).
concept_name0('36790: cpd:C16545','C16545',true).
concept_name0('36790: cpd:C16545','cpd:C16545',false).
concept_name0('36784: cpd:C01262','C01262',true).
concept_name0('36784: cpd:C01262','cpd:C01262',false).
concept_name0('36786: cpd:C00127','C00127',true).
concept_name0('36786: cpd:C00127','cpd:C00127',false).
concept_name0('36787: cpd:C00438','C00438',true).
concept_name0('36787: cpd:C00438','cpd:C00438',false).
concept_name0('36751: cpd:C00621','cpd:C00621',false).
concept_name0('36751: cpd:C00621','C00621',true).
concept_name0('36749: cpd:C00492','C00492',true).
concept_name0('36749: cpd:C00492','cpd:C00492',false).
concept_name0('36748: cpd:C05499','C05499',true).
concept_name0('36748: cpd:C05499','cpd:C05499',false).
concept_name0('38435: cpd:C00439','C00439',true).
concept_name0('38435: cpd:C00439','cpd:C00439',false).
concept_name0('36747: cpd:C05269','C05269',true).
concept_name0('36747: cpd:C05269','cpd:C05269',false).
concept_name0('36745: cpd:C05270','C05270',true).
concept_name0('36745: cpd:C05270','cpd:C05270',false).
concept_name0('36744: cpd:C01953','C01953',true).
concept_name0('36744: cpd:C01953','cpd:C01953',false).
concept_name0('36743: gl:G00015','gl:G00015',false).
concept_name0('36743: gl:G00015','G00015',true).
concept_name0('36742: cpd:C05665','cpd:C05665',false).
concept_name0('36742: cpd:C05665','C05665',true).
concept_name0('36740: cpd:C00468','cpd:C00468',false).
concept_name0('36740: cpd:C00468','C00468',true).
concept_name0('36738: cpd:C05271','C05271',true).
concept_name0('36738: cpd:C05271','cpd:C05271',false).
concept_name0('36737: cpd:C16546','C16546',true).
concept_name0('36737: cpd:C16546','cpd:C16546',false).
concept_name0('36736: cpd:C00236','cpd:C00236',false).
concept_name0('36736: cpd:C00236','C00236',true).
concept_name0('36763: cpd:C18045','C18045',true).
concept_name0('36763: cpd:C18045','cpd:C18045',false).
concept_name0('38449: cpd:C01081','C01081',true).
concept_name0('38449: cpd:C01081','cpd:C01081',false).
concept_name0('36759: cpd:C04518','C04518',true).
concept_name0('36759: cpd:C04518','cpd:C04518',false).
concept_name0('36756: cpd:C03824','cpd:C03824',false).
concept_name0('36756: cpd:C03824','C03824',true).
concept_name0('36754: cpd:C05268','cpd:C05268',false).
concept_name0('36754: cpd:C05268','C05268',true).
concept_name0('36755: cpd:C04555','C04555',true).
concept_name0('36755: cpd:C04555','cpd:C04555',false).
concept_name0('36705: cpd:C03221','cpd:C03221',false).
concept_name0('36705: cpd:C03221','C03221',true).
concept_name0('36706: cpd:C05264','cpd:C05264',false).
concept_name0('36706: cpd:C05264','C05264',true).
concept_name0('36708: cpd:C00001','cpd:C00001',false).
concept_name0('36708: cpd:C00001','C00001',true).
concept_name0('36709: cpd:C01832','C01832',true).
concept_name0('36709: cpd:C01832','cpd:C01832',false).
concept_name0('36712: cpd:C05528','C05528',true).
concept_name0('36712: cpd:C05528','cpd:C05528',false).
concept_name0('36713: cpd:C05265','cpd:C05265',false).
concept_name0('36713: cpd:C05265','C05265',true).
concept_name0('38595: cpd:C05138','cpd:C05138',false).
concept_name0('38595: cpd:C05138','C05138',true).
concept_name0('36715: cpd:C05263','cpd:C05263',false).
concept_name0('36715: cpd:C05263','C05263',true).
concept_name0('36716: cpd:C05274','cpd:C05274',false).
concept_name0('36716: cpd:C05274','C05274',true).
concept_name0('36717: cpd:C00151','cpd:C00151',false).
concept_name0('36717: cpd:C00151','C00151',true).
concept_name0('36721: cpd:C05275','cpd:C05275',false).
concept_name0('36721: cpd:C05275','C05275',true).
concept_name0('36720: cpd:C05262','cpd:C05262',false).
concept_name0('36720: cpd:C05262','C05262',true).
concept_name0('36723: cpd:C05399','C05399',true).
concept_name0('36723: cpd:C05399','cpd:C05399',false).
concept_name0('36724: cpd:C05276','cpd:C05276',false).
concept_name0('36724: cpd:C05276','C05276',true).
concept_name0('36727: cpd:C01235','cpd:C01235',false).
concept_name0('36727: cpd:C01235','C01235',true).
concept_name0('36729: cpd:C00279','C00279',true).
concept_name0('36729: cpd:C00279','cpd:C00279',false).
concept_name0('36728: cpd:C01944','C01944',true).
concept_name0('36728: cpd:C01944','cpd:C01944',false).
concept_name0('36730: cpd:C14826','C14826',true).
concept_name0('36730: cpd:C14826','cpd:C14826',false).
concept_name0('36733: cpd:C05266','cpd:C05266',false).
concept_name0('36733: cpd:C05266','C05266',true).
concept_name0('36732: cpd:C05267','cpd:C05267',false).
concept_name0('36732: cpd:C05267','C05267',true).
concept_name0('36734: cpd:C05400','C05400',true).
concept_name0('36734: cpd:C05400','cpd:C05400',false).
concept_name0('36674: cpd:C05751','C05751',true).
concept_name0('36674: cpd:C05751','cpd:C05751',false).
concept_name0('36675: cpd:C03939','cpd:C03939',false).
concept_name0('36675: cpd:C03939','C03939',true).
concept_name0('36672: cpd:C05752','C05752',true).
concept_name0('36672: cpd:C05752','cpd:C05752',false).
concept_name0('36679: cpd:C00106','cpd:C00106',false).
concept_name0('36679: cpd:C00106','C00106',true).
concept_name0('36676: cpd:C16663','cpd:C16663',false).
concept_name0('36676: cpd:C16663','C16663',true).
concept_name0('36677: cpd:C05744','C05744',true).
concept_name0('36677: cpd:C05744','cpd:C05744',false).
concept_name0('36682: cpd:C00162','C00162',true).
concept_name0('36682: cpd:C00162','cpd:C00162',false).
concept_name0('36683: cpd:C00665','C00665',true).
concept_name0('36683: cpd:C00665','cpd:C00665',false).
concept_name0('36680: cpd:C11376','cpd:C11376',false).
concept_name0('36680: cpd:C11376','C11376',true).
concept_name0('36681: cpd:C11173','C11173',true).
concept_name0('36681: cpd:C11173','cpd:C11173',false).
concept_name0('36686: cpd:C00352','cpd:C00352',false).
concept_name0('36686: cpd:C00352','C00352',true).
concept_name0('36687: cpd:C01209','cpd:C01209',false).
concept_name0('36687: cpd:C01209','C01209',true).
concept_name0('36691: cpd:C05745','C05745',true).
concept_name0('36691: cpd:C05745','cpd:C05745',false).
concept_name0('36690: cpd:C16664','C16664',true).
concept_name0('36690: cpd:C16664','cpd:C16664',false).
concept_name0('36688: cpd:C16543','C16543',true).
concept_name0('36688: cpd:C16543','cpd:C16543',false).
concept_name0('36695: cpd:C16336','cpd:C16336',false).
concept_name0('36695: cpd:C16336','C16336',true).
concept_name0('36694: cpd:C06754','cpd:C06754',false).
concept_name0('36694: cpd:C06754','C06754',true).
concept_name0('36698: cpd:C04618','C04618',true).
concept_name0('36698: cpd:C04618','cpd:C04618',false).
concept_name0('36703: cpd:C00253','cpd:C00253',false).
concept_name0('36703: cpd:C00253','C00253',true).
concept_name0('36702: cpd:C04246','C04246',true).
concept_name0('36702: cpd:C04246','cpd:C04246',false).
concept_name0('36644: cpd:C07490','C07490',true).
concept_name0('36644: cpd:C07490','cpd:C07490',false).
concept_name0('38541: cpd:C01124','C01124',true).
concept_name0('38541: cpd:C01124','cpd:C01124',false).
concept_name0('36645: cpd:C05758','C05758',true).
concept_name0('36645: cpd:C05758','cpd:C05758',false).
concept_name0('38543: cpd:C05473','C05473',true).
concept_name0('38543: cpd:C05473','cpd:C05473',false).
concept_name0('36647: dr:D00343 cpd:C07047','D00343...',true).
concept_name0('36647: dr:D00343 cpd:C07047','dr:D00343 cpd:C07047',false).
concept_name0('36640: cpd:C05757','C05757',true).
concept_name0('36640: cpd:C05757','cpd:C05757',false).
concept_name0('36643: gl:G00011','G00011',true).
concept_name0('36643: gl:G00011','gl:G00011',false).
concept_name0('36652: cpd:C16612','C16612',true).
concept_name0('36652: cpd:C16612','cpd:C16612',false).
concept_name0('38533: cpd:C18043','C18043',true).
concept_name0('38533: cpd:C18043','cpd:C18043',false).
concept_name0('36654: cpd:C00105','cpd:C00105',false).
concept_name0('36654: cpd:C00105','C00105',true).
concept_name0('36648: dr:D01309 cpd:C12739','dr:D01309 cpd:C12739',false).
concept_name0('36648: dr:D01309 cpd:C12739','D01309...',true).
concept_name0('36649: cpd:C05223','cpd:C05223',false).
concept_name0('36649: cpd:C05223','C05223',true).
concept_name0('36661: cpd:C16565','cpd:C16565',false).
concept_name0('36661: cpd:C16565','C16565',true).
concept_name0('38556: cpd:C05469','cpd:C05469',false).
concept_name0('38556: cpd:C05469','C05469',true).
concept_name0('36660: cpd:C05749','C05749',true).
concept_name0('36660: cpd:C05749','cpd:C05749',false).
concept_name0('38559: cpd:C05471','cpd:C05471',false).
concept_name0('38559: cpd:C05471','C05471',true).
concept_name0('36657: cpd:C05748','C05748',true).
concept_name0('36657: cpd:C05748','cpd:C05748',false).
concept_name0('36656: cpd:C00940','cpd:C00940',false).
concept_name0('36656: cpd:C00940','C00940',true).
concept_name0('36669: cpd:C05750','C05750',true).
concept_name0('36669: cpd:C05750','cpd:C05750',false).
concept_name0('38548: cpd:C00762','cpd:C00762',false).
concept_name0('38548: cpd:C00762','C00762',true).
concept_name0('36668: cpd:C04620','C04620',true).
concept_name0('36668: cpd:C04620','cpd:C04620',false).
concept_name0('38551: cpd:C00735','C00735',true).
concept_name0('38551: cpd:C00735','cpd:C00735',false).
concept_name0('38550: cpd:C15670','cpd:C15670',false).
concept_name0('38550: cpd:C15670','C15670',true).
concept_name0('38544: cpd:C05489','cpd:C05489',false).
concept_name0('38544: cpd:C05489','C05489',true).
concept_name0('36664: cpd:C05746','C05746',true).
concept_name0('36664: cpd:C05746','cpd:C05746',false).
concept_name0('36667: cpd:C05747','C05747',true).
concept_name0('36667: cpd:C05747','cpd:C05747',false).
concept_name0('38546: cpd:C05485','C05485',true).
concept_name0('38546: cpd:C05485','cpd:C05485',false).
concept_name0('36614: cpd:C05764','C05764',true).
concept_name0('36614: cpd:C05764','cpd:C05764',false).
concept_name0('38572: cpd:C05479','cpd:C05479',false).
concept_name0('38572: cpd:C05479','C05479',true).
concept_name0('36612: cpd:C16596','cpd:C16596',false).
concept_name0('36612: cpd:C16596','C16596',true).
concept_name0('36613: cpd:C00006','cpd:C00006',false).
concept_name0('36613: cpd:C00006','C00006',true).
concept_name0('38570: cpd:C18041','C18041',true).
concept_name0('38570: cpd:C18041','cpd:C18041',false).
concept_name0('36610: cpd:C05763','C05763',true).
concept_name0('36610: cpd:C05763','cpd:C05763',false).
concept_name0('38568: cpd:C05497','cpd:C05497',false).
concept_name0('38568: cpd:C05497','C05497',true).
concept_name0('36608: cpd:C00117','cpd:C00117',false).
concept_name0('36608: cpd:C00117','C00117',true).
concept_name0('36609: gl:G00013','gl:G00013',false).
concept_name0('36609: gl:G00013','G00013',true).
concept_name0('38566: cpd:C05498','cpd:C05498',false).
concept_name0('38566: cpd:C05498','C05498',true).
concept_name0('36623: cpd:C11150','C11150',true).
concept_name0('36623: cpd:C11150','cpd:C11150',false).
concept_name0('38564: cpd:C18075','C18075',true).
concept_name0('38564: cpd:C18075','cpd:C18075',false).
concept_name0('36620: cpd:C16300','cpd:C16300',false).
concept_name0('36620: cpd:C16300','C16300',true).
concept_name0('36621: cpd:C05755','C05755',true).
concept_name0('36621: cpd:C05755','cpd:C05755',false).
concept_name0('36616: cpd:C16591','C16591',true).
concept_name0('36616: cpd:C16591','cpd:C16591',false).
concept_name0('36631: cpd:C05753','C05753',true).
concept_name0('36631: cpd:C05753','cpd:C05753',false).
concept_name0('36630: cpd:C16327','C16327',true).
concept_name0('36630: cpd:C16327','cpd:C16327',false).
concept_name0('36629: cpd:C04619','C04619',true).
concept_name0('36629: cpd:C04619','cpd:C04619',false).
concept_name0('36628: cpd:C16544','C16544',true).
concept_name0('36628: cpd:C16544','cpd:C16544',false).
concept_name0('36627: cpd:C05726','C05726',true).
concept_name0('36627: cpd:C05726','cpd:C05726',false).
concept_name0('36625: cpd:C05754','C05754',true).
concept_name0('36625: cpd:C05754','cpd:C05754',false).
concept_name0('36624: cpd:C16328','C16328',true).
concept_name0('36624: cpd:C16328','cpd:C16328',false).
concept_name0('36638: cpd:C00750','cpd:C00750',false).
concept_name0('36638: cpd:C00750','C00750',true).
concept_name0('36637: cpd:C16635','cpd:C16635',false).
concept_name0('36637: cpd:C16635','C16635',true).
concept_name0('36636: cpd:C05756','cpd:C05756',false).
concept_name0('36636: cpd:C05756','C05756',true).
concept_name0('36632: cpd:C05729','C05729',true).
concept_name0('36632: cpd:C05729','cpd:C05729',false).
concept_name0('36602: gl:G00012','G00012',true).
concept_name0('36602: gl:G00012','gl:G00012',false).
concept_name0('36603: cpd:C04633','C04633',true).
concept_name0('36603: cpd:C04633','cpd:C04633',false).
concept_name0('36601: dr:D08086 cpd:C16641','D08086...',true).
concept_name0('36601: dr:D08086 cpd:C16641','dr:D08086 cpd:C16641',false).
concept_name0('36606: cpd:C06481','C06481',true).
concept_name0('36606: cpd:C06481','cpd:C06481',false).
concept_name0('36594: gl:G00014','gl:G00014',false).
concept_name0('36594: gl:G00014','G00014',true).
concept_name0('36595: cpd:C05759','C05759',true).
concept_name0('36595: cpd:C05759','cpd:C05759',false).
concept_name0('36596: cpd:C16335','cpd:C16335',false).
concept_name0('36596: cpd:C16335','C16335',true).
concept_name0('36597: cpd:C16549','cpd:C16549',false).
concept_name0('36597: cpd:C16549','C16549',true).
concept_name0('36587: cpd:C05760','C05760',true).
concept_name0('36587: cpd:C05760','cpd:C05760',false).
concept_name0('36586: cpd:C16332','cpd:C16332',false).
concept_name0('36586: cpd:C16332','C16332',true).
concept_name0('36584: cpd:C16595','cpd:C16595',false).
concept_name0('36584: cpd:C16595','C16595',true).
concept_name0('38727: cpd:C00847','cpd:C00847',false).
concept_name0('38727: cpd:C00847','C00847',true).
concept_name0('36590: cpd:C04688','cpd:C04688',false).
concept_name0('36590: cpd:C04688','C04688',true).
concept_name0('36588: cpd:C02090','C02090',true).
concept_name0('36588: cpd:C02090','cpd:C02090',false).
concept_name0('36579: cpd:C00005','cpd:C00005',false).
concept_name0('36579: cpd:C00005','C00005',true).
concept_name0('36578: cpd:C16331','cpd:C16331',false).
concept_name0('36578: cpd:C16331','C16331',true).
concept_name0('36577: cpd:C16638','C16638',true).
concept_name0('36577: cpd:C16638','cpd:C16638',false).
concept_name0('36583: cpd:C03170','cpd:C03170',false).
concept_name0('36583: cpd:C03170','C03170',true).
concept_name0('36582: cpd:C00794','cpd:C00794',false).
concept_name0('36582: cpd:C00794','C00794',true).
concept_name0('36580: cpd:C05761','cpd:C05761',false).
concept_name0('36580: cpd:C05761','C05761',true).
concept_name0('36568: cpd:C03460','cpd:C03460',false).
concept_name0('36568: cpd:C03460','C03460',true).
concept_name0('36570: cpd:C06000','cpd:C06000',false).
concept_name0('36570: cpd:C06000','C06000',true).
concept_name0('36572: cpd:C06001','cpd:C06001',false).
concept_name0('36572: cpd:C06001','C06001',true).
concept_name0('36573: cpd:C14840','cpd:C14840',false).
concept_name0('36573: cpd:C14840','C14840',true).
concept_name0('36575: dr:D00536 cpd:C07501','dr:D00536 cpd:C07501',false).
concept_name0('36575: dr:D00536 cpd:C07501','D00536...',true).
concept_name0('36560: cpd:C03345','C03345',true).
concept_name0('36560: cpd:C03345','cpd:C03345',false).
concept_name0('38777: cpd:C00255','cpd:C00255',false).
concept_name0('38777: cpd:C00255','C00255',true).
concept_name0('36562: cpd:C04405','C04405',true).
concept_name0('36562: cpd:C04405','cpd:C04405',false).
concept_name0('38779: cpd:C00007','cpd:C00007',false).
concept_name0('38779: cpd:C00007','C00007',true).
concept_name0('36565: cpd:C00630','cpd:C00630',false).
concept_name0('36565: cpd:C00630','C00630',true).
concept_name0('36555: cpd:C00134','cpd:C00134',false).
concept_name0('36555: cpd:C00134','C00134',true).
concept_name0('36554: cpd:C03344','C03344',true).
concept_name0('36554: cpd:C03344','cpd:C03344',false).
concept_name0('36559: cpd:C05762','C05762',true).
concept_name0('36559: cpd:C05762','cpd:C05762',false).
concept_name0('36558: cpd:C00043','cpd:C00043',false).
concept_name0('36558: cpd:C00043','C00043',true).
concept_name0('36547: cpd:C05378','C05378',true).
concept_name0('36547: cpd:C05378','cpd:C05378',false).
concept_name0('36546: cpd:C00184','C00184',true).
concept_name0('36546: cpd:C00184','cpd:C00184',false).
concept_name0('36548: cpd:C14786','C14786',true).
concept_name0('36548: cpd:C14786','cpd:C14786',false).
concept_name0('36550: cpd:C14839','C14839',true).
concept_name0('36550: cpd:C14839','cpd:C14839',false).
concept_name0('36542: cpd:C03284','C03284',true).
concept_name0('36542: cpd:C03284','cpd:C03284',false).
concept_name0('36541: cpd:C14800','cpd:C14800',false).
concept_name0('36541: cpd:C14800','C14800',true).
concept_name0('36538: cpd:C00234','C00234',true).
concept_name0('36538: cpd:C00234','cpd:C00234',false).
concept_name0('36536: cpd:C00054','cpd:C00054',false).
concept_name0('36536: cpd:C00054','C00054',true).
concept_name0('38673: cpd:C00534','C00534',true).
concept_name0('38673: cpd:C00534','cpd:C00534',false).
concept_name0('36534: cpd:C00506','cpd:C00506',false).
concept_name0('36534: cpd:C00506','C00506',true).
concept_name0('36532: cpd:C05998','cpd:C05998',false).
concept_name0('36532: cpd:C05998','C05998',true).
concept_name0('36530: cpd:C01678','C01678',true).
concept_name0('36530: cpd:C01678','cpd:C01678',false).
concept_name0('38683: cpd:C00314','cpd:C00314',false).
concept_name0('38683: cpd:C00314','C00314',true).
concept_name0('36531: cpd:C00224','cpd:C00224',false).
concept_name0('36531: cpd:C00224','C00224',true).
concept_name0('36528: cpd:C03231','C03231',true).
concept_name0('36528: cpd:C03231','cpd:C03231',false).
concept_name0('36527: cpd:C00606','cpd:C00606',false).
concept_name0('36527: cpd:C00606','C00606',true).
concept_name0('36526: cpd:C02939','C02939',true).
concept_name0('36526: cpd:C02939','cpd:C02939',false).
concept_name0('36525: cpd:C03912','C03912',true).
concept_name0('36525: cpd:C03912','cpd:C03912',false).
concept_name0('36524: cpd:C00053','cpd:C00053',false).
concept_name0('36524: cpd:C00053','C00053',true).
concept_name0('36523: cpd:C00519','cpd:C00519',false).
concept_name0('36523: cpd:C00519','C00519',true).
concept_name0('36522: cpd:C03069','C03069',true).
concept_name0('36522: cpd:C03069','cpd:C03069',false).
concept_name0('38671: cpd:C00250','C00250',true).
concept_name0('38671: cpd:C00250','cpd:C00250',false).
concept_name0('36519: cpd:C00245','cpd:C00245',false).
concept_name0('36519: cpd:C00245','C00245',true).
concept_name0('38669: cpd:C00018','cpd:C00018',false).
concept_name0('38669: cpd:C00018','C00018',true).
concept_name0('36517: cpd:C00095','C00095',true).
concept_name0('36517: cpd:C00095','cpd:C00095',false).
concept_name0('36516: cpd:C15975','C15975',true).
concept_name0('36516: cpd:C15975','cpd:C15975',false).
concept_name0('38667: cpd:C00647','cpd:C00647',false).
concept_name0('38667: cpd:C00647','C00647',true).
concept_name0('36512: cpd:C05844','cpd:C05844',false).
concept_name0('36512: cpd:C05844','C05844',true).
concept_name0('36509: cpd:C05122','cpd:C05122',false).
concept_name0('36509: cpd:C05122','C05122',true).
concept_name0('36510: cpd:C00089','C00089',true).
concept_name0('36510: cpd:C00089','cpd:C00089',false).
concept_name0('36511: cpd:C01146','cpd:C01146',false).
concept_name0('36511: cpd:C01146','C01146',true).
concept_name0('36505: cpd:C00440','cpd:C00440',false).
concept_name0('36505: cpd:C00440','C00440',true).
concept_name0('36506: cpd:C06790','cpd:C06790',false).
concept_name0('36506: cpd:C06790','C06790',true).
concept_name0('36500: gl:G00092','G00092',true).
concept_name0('36500: gl:G00092','gl:G00092',false).
concept_name0('36501: cpd:C16633','C16633',true).
concept_name0('36501: cpd:C16633','cpd:C16633',false).
concept_name0('36503: dr:D04197 cpd:C11736','dr:D04197 cpd:C11736',false).
concept_name0('36503: dr:D04197 cpd:C11736','D04197...',true).
concept_name0('36496: cpd:C02094','cpd:C02094',false).
concept_name0('36496: cpd:C02094','C02094',true).
concept_name0('38693: cpd:C06054','C06054',true).
concept_name0('38693: cpd:C06054','cpd:C06054',false).
concept_name0('36492: cpd:C00135','C00135',true).
concept_name0('36492: cpd:C00135','cpd:C00135',false).
concept_name0('36495: cpd:C01222','cpd:C01222',false).
concept_name0('36495: cpd:C01222','C01222',true).
concept_name0('36494: cpd:C04242','cpd:C04242',false).
concept_name0('36494: cpd:C04242','C04242',true).
concept_name0('38689: cpd:C06055','C06055',true).
concept_name0('38689: cpd:C06055','cpd:C06055',false).
concept_name0('36489: cpd:C05711','cpd:C05711',false).
concept_name0('36489: cpd:C05711','C05711',true).
concept_name0('36488: cpd:C02041','C02041',true).
concept_name0('36488: cpd:C02041','cpd:C02041',false).
concept_name0('38691: cpd:C03451','cpd:C03451',false).
concept_name0('38691: cpd:C03451','C03451',true).
concept_name0('38690: cpd:C00627','C00627',true).
concept_name0('38690: cpd:C00627','cpd:C00627',false).
concept_name0('36490: cpd:C01996','C01996',true).
concept_name0('36490: cpd:C01996','cpd:C01996',false).
concept_name0('36485: cpd:C00412','cpd:C00412',false).
concept_name0('36485: cpd:C00412','C00412',true).
concept_name0('36484: cpd:C00307','cpd:C00307',false).
concept_name0('36484: cpd:C00307','C00307',true).
concept_name0('36487: cpd:C04230','C04230',true).
concept_name0('36487: cpd:C04230','cpd:C04230',false).
concept_name0('36486: cpd:C00246','cpd:C00246',false).
concept_name0('36486: cpd:C00246','C00246',true).
concept_name0('36481: cpd:C00588','cpd:C00588',false).
concept_name0('36481: cpd:C00588','C00588',true).
concept_name0('38699: cpd:C00256','cpd:C00256',false).
concept_name0('38699: cpd:C00256','C00256',true).
concept_name0('36466: cpd:C16630','C16630',true).
concept_name0('36466: cpd:C16630','cpd:C16630',false).
concept_name0('36465: cpd:C00641','C00641',true).
concept_name0('36465: cpd:C00641','cpd:C00641',false).
concept_name0('38872: cpd:C03150','C03150',true).
concept_name0('38872: cpd:C03150','cpd:C03150',false).
concept_name0('36471: cpd:C00344','C00344',true).
concept_name0('36471: cpd:C00344','cpd:C00344',false).
concept_name0('36470: cpd:C16631','C16631',true).
concept_name0('36470: cpd:C16631','cpd:C16631',false).
concept_name0('36468: cpd:C03892','C03892',true).
concept_name0('36468: cpd:C03892','cpd:C03892',false).
concept_name0('38867: cpd:C00857','cpd:C00857',false).
concept_name0('38867: cpd:C00857','C00857',true).
concept_name0('36475: dr:D01244 cpd:C12673','dr:D01244 cpd:C12673',false).
concept_name0('36475: dr:D01244 cpd:C12673','D01244...',true).
concept_name0('36474: cpd:C01019','C01019',true).
concept_name0('36474: cpd:C01019','cpd:C01019',false).
concept_name0('36473: dr:D00584 cpd:C07649','D00584...',true).
concept_name0('36473: dr:D00584 cpd:C07649','dr:D00584 cpd:C07649',false).
concept_name0('38864: cpd:C00003','cpd:C00003',false).
concept_name0('38864: cpd:C00003','C00003',true).
concept_name0('36472: cpd:C00510','C00510',true).
concept_name0('36472: cpd:C00510','cpd:C00510',false).
concept_name0('36479: cpd:C16622','C16622',true).
concept_name0('36479: cpd:C16622','cpd:C16622',false).
concept_name0('38870: cpd:C02918','cpd:C02918',false).
concept_name0('38870: cpd:C02918','C02918',true).
concept_name0('36478: cpd:C00570','C00570',true).
concept_name0('36478: cpd:C00570','cpd:C00570',false).
concept_name0('36477: cpd:C01353','C01353',true).
concept_name0('36477: cpd:C01353','cpd:C01353',false).
concept_name0('36476: cpd:C03794','C03794',true).
concept_name0('36476: cpd:C03794','cpd:C03794',false).
concept_name0('38858: cpd:C01185','C01185',true).
concept_name0('38858: cpd:C01185','cpd:C01185',false).
concept_name0('36450: cpd:C01089','C01089',true).
concept_name0('36450: cpd:C01089','cpd:C01089',false).
concept_name0('36449: cpd:C06428','cpd:C06428',false).
concept_name0('36449: cpd:C06428','C06428',true).
concept_name0('36454: cpd:C00385','C00385',true).
concept_name0('36454: cpd:C00385','cpd:C00385',false).
concept_name0('36455: cpd:C05382','C05382',true).
concept_name0('36455: cpd:C05382','cpd:C05382',false).
concept_name0('36453: cpd:C00430','cpd:C00430',false).
concept_name0('36453: cpd:C00430','C00430',true).
concept_name0('38848: cpd:C03722','C03722',true).
concept_name0('38848: cpd:C03722','cpd:C03722',false).
concept_name0('36456: cpd:C00157','C00157',true).
concept_name0('36456: cpd:C00157','cpd:C00157',false).
concept_name0('36457: cpd:C00740','C00740',true).
concept_name0('36457: cpd:C00740','cpd:C00740',false).
concept_name0('38855: cpd:C00455','C00455',true).
concept_name0('38855: cpd:C00455','cpd:C00455',false).
concept_name0('36463: cpd:C16634','C16634',true).
concept_name0('36463: cpd:C16634','cpd:C16634',false).
concept_name0('36460: cpd:C16632','C16632',true).
concept_name0('36460: cpd:C16632','cpd:C16632',false).
concept_name0('38904: cpd:C05842','C05842',true).
concept_name0('38904: cpd:C05842','cpd:C05842',false).
concept_name0('38907: cpd:C05843','C05843',true).
concept_name0('38907: cpd:C05843','cpd:C05843',false).
concept_name0('36435: cpd:C00416','cpd:C00416',false).
concept_name0('36435: cpd:C00416','C00416',true).
concept_name0('36434: cpd:C12144','C12144',true).
concept_name0('36434: cpd:C12144','cpd:C12144',false).
concept_name0('36437: cpd:C01888','cpd:C01888',false).
concept_name0('36437: cpd:C01888','C01888',true).
concept_name0('36439: cpd:C00546','cpd:C00546',false).
concept_name0('36439: cpd:C00546','C00546',true).
concept_name0('38910: cpd:C05841','C05841',true).
concept_name0('38910: cpd:C05841','cpd:C05841',false).
concept_name0('36438: cpd:C01194','cpd:C01194',false).
concept_name0('36438: cpd:C01194','C01194',true).
concept_name0('36441: cpd:C00052','cpd:C00052',false).
concept_name0('36441: cpd:C00052','C00052',true).
concept_name0('36440: cpd:C00513','C00513',true).
concept_name0('36440: cpd:C00513','cpd:C00513',false).
concept_name0('36443: cpd:C00269','C00269',true).
concept_name0('36443: cpd:C00269','cpd:C00269',false).
concept_name0('38898: cpd:C00153','cpd:C00153',false).
concept_name0('38898: cpd:C00153','C00153',true).
concept_name0('36445: cpd:C06427','cpd:C06427',false).
concept_name0('36445: cpd:C06427','C06427',true).
concept_name0('36444: cpd:C00446','C00446',true).
concept_name0('36444: cpd:C00446','cpd:C00446',false).
concept_name0('36447: cpd:C00189','cpd:C00189',false).
concept_name0('36447: cpd:C00189','C00189',true).
concept_name0('36446: cpd:C02050','cpd:C02050',false).
concept_name0('36446: cpd:C02050','C02050',true).
concept_name0('36417: cpd:C01672','C01672',true).
concept_name0('36417: cpd:C01672','cpd:C01672',false).
concept_name0('36418: cpd:C00147','cpd:C00147',false).
concept_name0('36418: cpd:C00147','C00147',true).
concept_name0('36419: cpd:C00093','C00093',true).
concept_name0('36419: cpd:C00093','cpd:C00093',false).
concept_name0('36420: cpd:C00408','C00408',true).
concept_name0('36420: cpd:C00408','cpd:C00408',false).
concept_name0('36421: cpd:C01242','C01242',true).
concept_name0('36421: cpd:C01242','cpd:C01242',false).
concept_name0('38894: cpd:C03688','cpd:C03688',false).
concept_name0('38894: cpd:C03688','C03688',true).
concept_name0('36422: cpd:C12126','C12126',true).
concept_name0('36422: cpd:C12126','cpd:C12126',false).
concept_name0('36424: cpd:C00229','cpd:C00229',false).
concept_name0('36424: cpd:C00229','C00229',true).
concept_name0('36425: cpd:C06425','cpd:C06425',false).
concept_name0('36425: cpd:C06425','C06425',true).
concept_name0('36428: cpd:C00836','C00836',true).
concept_name0('36428: cpd:C00836','cpd:C00836',false).
concept_name0('36429: cpd:C00636','C00636',true).
concept_name0('36429: cpd:C00636','cpd:C00636',false).
concept_name0('36431: cpd:C00681','cpd:C00681',false).
concept_name0('36431: cpd:C00681','C00681',true).
concept_name0('36407: cpd:C00450','cpd:C00450',false).
concept_name0('36407: cpd:C00450','C00450',true).
concept_name0('36406: cpd:C02985','C02985',true).
concept_name0('36406: cpd:C02985','cpd:C02985',false).
concept_name0('36405: cpd:C05973','cpd:C05973',false).
concept_name0('36405: cpd:C05973','C05973',true).
concept_name0('38812: cpd:C00378','C00378',true).
concept_name0('38812: cpd:C00378','cpd:C00378',false).
concept_name0('36403: cpd:C04646','C04646',true).
concept_name0('36403: cpd:C04646','cpd:C04646',false).
concept_name0('38810: cpd:C03028','cpd:C03028',false).
concept_name0('38810: cpd:C03028','C03028',true).
concept_name0('36402: cpd:C11135','C11135',true).
concept_name0('36402: cpd:C11135','cpd:C11135',false).
concept_name0('36401: cpd:C05980','cpd:C05980',false).
concept_name0('36401: cpd:C05980','C05980',true).
concept_name0('36415: cpd:C00015','cpd:C00015',false).
concept_name0('36415: cpd:C00015','C00015',true).
concept_name0('36414: cpd:C12145','cpd:C12145',false).
concept_name0('36414: cpd:C12145','C12145',true).
concept_name0('36413: cpd:C06429','cpd:C06429',false).
concept_name0('36413: cpd:C06429','C06429',true).
concept_name0('36411: cpd:C00325','cpd:C00325',false).
concept_name0('36411: cpd:C00325','C00325',true).
concept_name0('36410: cpd:C04438','C04438',true).
concept_name0('36410: cpd:C04438','cpd:C04438',false).
concept_name0('36408: cpd:C01290','C01290',true).
concept_name0('36408: cpd:C01290','cpd:C01290',false).
concept_name0('36391: cpd:C00170','cpd:C00170',false).
concept_name0('36391: cpd:C00170','C00170',true).
concept_name0('36388: cpd:C06174;dr:D00195 cpd:C06174','cpd:C06174',false).
concept_name0('36388: cpd:C06174;dr:D00195 cpd:C06174','dr:D00195 cpd:C06174',false).
concept_name0('36388: cpd:C06174;dr:D00195 cpd:C06174','C06174',true).
concept_name0('36388: cpd:C06174;dr:D00195 cpd:C06174','D00195...',true).
concept_name0('36386: cpd:C01137','C01137',true).
concept_name0('36386: cpd:C01137','cpd:C01137',false).
concept_name0('36387: cpd:C04373','C04373',true).
concept_name0('36387: cpd:C04373','cpd:C04373',false).
concept_name0('36385: cpd:C00986','cpd:C00986',false).
concept_name0('36385: cpd:C00986','C00986',true).
concept_name0('36398: cpd:C00523','C00523',true).
concept_name0('36398: cpd:C00523','cpd:C00523',false).
concept_name0('36399: dr:D00346 cpd:C07054','dr:D00346 cpd:C07054',false).
concept_name0('36399: dr:D00346 cpd:C07054','D00346...',true).
concept_name0('36397: cpd:C03242','C03242',true).
concept_name0('36397: cpd:C03242','cpd:C03242',false).
concept_name0('38787: cpd:C00016','cpd:C00016',false).
concept_name0('38787: cpd:C00016','C00016',true).
concept_name0('36392: cpd:C11136','C11136',true).
concept_name0('36392: cpd:C11136','cpd:C11136',false).
concept_name0('36393: cpd:C06124','cpd:C06124',false).
concept_name0('36393: cpd:C06124','C06124',true).
concept_name0('36372: cpd:C02737','C02737',true).
concept_name0('36372: cpd:C02737','cpd:C02737',false).
concept_name0('36375: cpd:C00249','cpd:C00249',false).
concept_name0('36375: cpd:C00249','C00249',true).
concept_name0('36368: dr:D01223 cpd:C12650','D01223...',true).
concept_name0('36368: dr:D01223 cpd:C12650','dr:D01223 cpd:C12650',false).
concept_name0('36370: cpd:C00712','cpd:C00712',false).
concept_name0('36370: cpd:C00712','C00712',true).
concept_name0('36380: cpd:C00219','cpd:C00219',false).
concept_name0('36380: cpd:C00219','C00219',true).
concept_name0('36382: cpd:C16614','cpd:C16614',false).
concept_name0('36382: cpd:C16614','C16614',true).
concept_name0('36376: cpd:C01241','C01241',true).
concept_name0('36376: cpd:C01241','cpd:C01241',false).
concept_name0('36379: cpd:C05294','cpd:C05294',false).
concept_name0('36379: cpd:C05294','C05294',true).
concept_name0('36359: cpd:C05293','cpd:C05293',false).
concept_name0('36359: cpd:C05293','C05293',true).
concept_name0('36352: cpd:C05560','C05560',true).
concept_name0('36352: cpd:C05560','cpd:C05560',false).
concept_name0('36353: cpd:C03917','cpd:C03917',false).
concept_name0('36353: cpd:C03917','C03917',true).
concept_name0('36354: cpd:C00148','C00148',true).
concept_name0('36354: cpd:C00148','cpd:C00148',false).
concept_name0('36364: cpd:C01530','cpd:C01530',false).
concept_name0('36364: cpd:C01530','C01530',true).
concept_name0('36365: cpd:C00350','cpd:C00350',false).
concept_name0('36365: cpd:C00350','C00350',true).
concept_name0('36367: cpd:C05290','cpd:C05290',false).
concept_name0('36367: cpd:C05290','C05290',true).
concept_name0('36361: cpd:C11134','cpd:C11134',false).
concept_name0('36361: cpd:C11134','C11134',true).
concept_name0('36362: cpd:C00187','cpd:C00187',false).
concept_name0('36362: cpd:C00187','C00187',true).
concept_accession('1: rn00010','KEGG','PATH:RN00010',true).
concept_accession('30134: rno00250','KEGG','PATH:RNO00250',true).
concept_accession('31565: rno00400','KEGG','PATH:RNO00400',true).
concept_accession('3838: rn00360','KEGG','PATH:RN00360',true).
concept_accession('7659: rn00620','KEGG','PATH:RN00620',true).
concept_accession('13122: rn00970','KEGG','PATH:RN00970',true).
concept_accession('13613: rn00983','KEGG','PATH:RN00983',true).
concept_accession('30599: rno00290','KEGG','PATH:RNO00290',true).
concept_accession('35230: rno00970','KEGG','PATH:RNO00970',true).
concept_accession('34669: rno00790','KEGG','PATH:RNO00790',true).
concept_accession('33083: rno00563','KEGG','PATH:RNO00563',true).
concept_accession('8294: rn00625','KEGG','PATH:RN00625',true).
concept_accession('28191: rno00051','KEGG','PATH:RNO00051',true).
concept_accession('514: rn00052','KEGG','PATH:RN00052',true).
concept_accession('31047: rno00340','KEGG','PATH:RNO00340',true).
concept_accession('34653: rno00785','KEGG','PATH:RNO00785',true).
concept_accession('32030: rno00500','KEGG','PATH:RNO00500',true).
concept_accession('9756: rn00730','KEGG','PATH:RN00730',true).
concept_accession('29132: rno00130','KEGG','PATH:RNO00130',true).
concept_accession('9276: rn00670','KEGG','PATH:RN00670',true).
concept_accession('4909: rn00430','KEGG','PATH:RN00430',true).
concept_accession('29671: rno00230','KEGG','PATH:RNO00230',true).
concept_accession('6550: rn00550','KEGG','PATH:RN00550',true).
concept_accession('8070: rn00624','KEGG','PATH:RN00624',true).
concept_accession('13693: rn01040','KEGG','PATH:RN01040',true).
concept_accession('7587: rn00604','KEGG','PATH:RN00604',true).
concept_accession('614: rn00053','KEGG','PATH:RN00053',true).
concept_accession('34623: rno00780','KEGG','PATH:RNO00780',true).
concept_accession('4959: rn00440','KEGG','PATH:RN00440',true).
concept_accession('1031: rn00071','KEGG','PATH:RN00071',true).
concept_accession('30663: rno00300','KEGG','PATH:RNO00300',true).
concept_accession('12565: rn00950','KEGG','PATH:RN00950',true).
concept_accession('97: rn00020','KEGG','PATH:RN00020',true).
concept_accession('32616: rno00524','KEGG','PATH:RNO00524',true).
concept_accession('2768: rn00280','KEGG','PATH:RN00280',true).
concept_accession('9317: rn00680','KEGG','PATH:RN00680',true).
concept_accession('4447: rn00380','KEGG','PATH:RN00380',true).
concept_accession('1536: rn00140','KEGG','PATH:RN00140',true).
concept_accession('33136: rno00564','KEGG','PATH:RNO00564',true).
concept_accession('3235: rn00330','KEGG','PATH:RN00330',true).
concept_accession('34563: rno00770','KEGG','PATH:RNO00770',true).
concept_accession('9815: rn00740','KEGG','PATH:RN00740',true).
concept_accession('6611: rn00561','KEGG','PATH:RN00561',true).
concept_accession('34092: rno00640','KEGG','PATH:RNO00640',true).
concept_accession('33605: rno00601','KEGG','PATH:RNO00601',true).
concept_accession('30491: rno00280','KEGG','PATH:RNO00280',true).
concept_accession('2612: rn00270','KEGG','PATH:RN00270',true).
concept_accession('32173: rno00510','KEGG','PATH:RNO00510',true).
concept_accession('1774: rn00230','KEGG','PATH:RN00230',true).
concept_accession('8385: rn00626','KEGG','PATH:RN00626',true).
concept_accession('35619: rno00983','KEGG','PATH:RNO00983',true).
concept_accession('6448: rn00532','KEGG','PATH:RN00532',true).
concept_accession('7545: rn00603','KEGG','PATH:RN00603',true).
concept_accession('29028: rno00120','KEGG','PATH:RNO00120',true).
concept_accession('35100: rno00910','KEGG','PATH:RNO00910',true).
concept_accession('34791: rno00860','KEGG','PATH:RNO00860',true).
concept_accession('12769: rn00960','KEGG','PATH:RN00960',true).
concept_accession('32674: rno00531','KEGG','PATH:RNO00531',true).
concept_accession('31725: rno00430','KEGG','PATH:RNO00430',true).
concept_accession('5050: rn00450','KEGG','PATH:RN00450',true).
concept_accession('27827: rno00010','KEGG','PATH:RNO00010',true).
concept_accession('162: rn00030','KEGG','PATH:RN00030',true).
concept_accession('9869: rn00750','KEGG','PATH:RN00750',true).
concept_accession('10366: rn00860','KEGG','PATH:RN00860',true).
concept_accession('3188: rn00311','KEGG','PATH:RN00311',true).
concept_accession('8903: rn00640','KEGG','PATH:RN00640',true).
concept_accession('14264: rn01058','KEGG','PATH:RN01058',true).
concept_accession('29971: rno00240','KEGG','PATH:RNO00240',true).
concept_accession('6112: rn00522','KEGG','PATH:RN00522',true).
concept_accession('2085: rn00232','KEGG','PATH:RN00232',true).
concept_accession('6975: rn00565','KEGG','PATH:RN00565',true).
concept_accession('34278: rno00670','KEGG','PATH:RNO00670',true).
concept_accession('11781: rn00920','KEGG','PATH:RN00920',true).
concept_accession('11299: rn00906','KEGG','PATH:RN00906',true).
concept_accession('28301: rno00052','KEGG','PATH:RNO00052',true).
concept_accession('35689: rno01040','KEGG','PATH:RNO01040',true).
concept_accession('6500: rn00540','KEGG','PATH:RN00540',true).
concept_accession('13823: rn01051','KEGG','PATH:RN01051',true).
concept_accession('10812: rn00902','KEGG','PATH:RN00902',true).
concept_accession('2143: rn00240','KEGG','PATH:RN00240',true).
concept_accession('34184: rno00650','KEGG','PATH:RNO00650',true).
concept_accession('34731: rno00830','KEGG','PATH:RNO00830',true).
concept_accession('11886: rn00940','KEGG','PATH:RN00940',true).
concept_accession('1177: rn00072','KEGG','PATH:RN00072',true).
concept_accession('33768: rno00603','KEGG','PATH:RNO00603',true).
concept_accession('10249: rn00791','KEGG','PATH:RN00791',true).
concept_accession('28395: rno00053','KEGG','PATH:RNO00053',true).
concept_accession('7953: rn00623','KEGG','PATH:RN00623',true).
concept_accession('32743: rno00532','KEGG','PATH:RNO00532',true).
concept_accession('31657: rno00410','KEGG','PATH:RNO00410',true).
concept_accession('5526: rn00510','KEGG','PATH:RN00510',true).
concept_accession('33267: rno00565','KEGG','PATH:RNO00565',true).
concept_accession('1195: rn00100','KEGG','PATH:RN00100',true).
concept_accession('8838: rn00633','KEGG','PATH:RN00633',true).
concept_accession('5104: rn00460','KEGG','PATH:RN00460',true).
concept_accession('10296: rn00830','KEGG','PATH:RN00830',true).
concept_accession('6475: rn00534','KEGG','PATH:RN00534',true).
concept_accession('728: rn00061','KEGG','PATH:RN00061',true).
concept_accession('31129: rno00350','KEGG','PATH:RNO00350',true).
concept_accession('250: rn00040','KEGG','PATH:RN00040',true).
concept_accession('3595: rn00350','KEGG','PATH:RN00350',true).
concept_accession('7032: rn00590','KEGG','PATH:RN00590',true).
concept_accession('13221: rn00980','KEGG','PATH:RN00980',true).
concept_accession('9950: rn00760','KEGG','PATH:RN00760',true).
concept_accession('35185: rno00920','KEGG','PATH:RNO00920',true).
concept_accession('6057: rn00521','KEGG','PATH:RN00521',true).
concept_accession('28906: rno00072','KEGG','PATH:RNO00072',true).
concept_accession('6322: rn00524','KEGG','PATH:RN00524',true).
concept_accession('30350: rno00270','KEGG','PATH:RNO00270',true).
concept_accession('33877: rno00620','KEGG','PATH:RNO00620',true).
concept_accession('34418: rno00750','KEGG','PATH:RNO00750',true).
concept_accession('13370: rn00981','KEGG','PATH:RN00981',true).
concept_accession('28924: rno00100','KEGG','PATH:RNO00100',true).
concept_accession('4627: rn00400','KEGG','PATH:RN00400',true).
concept_accession('10715: rn00901','KEGG','PATH:RN00901',true).
concept_accession('6789: rn00563','KEGG','PATH:RN00563',true).
concept_accession('11675: rn00910','KEGG','PATH:RN00910',true).
concept_accession('2992: rn00300','KEGG','PATH:RN00300',true).
concept_accession('5235: rn00473','KEGG','PATH:RN00473',true).
concept_accession('27923: rno00020','KEGG','PATH:RNO00020',true).
concept_accession('30830: rno00330','KEGG','PATH:RNO00330',true).
concept_accession('34369: rno00740','KEGG','PATH:RNO00740',true).
concept_accession('2477: rn00260','KEGG','PATH:RN00260',true).
concept_accession('9044: rn00643','KEGG','PATH:RN00643',true).
concept_accession('31768: rno00450','KEGG','PATH:RNO00450',true).
concept_accession('32319: rno00512','KEGG','PATH:RNO00512',true).
concept_accession('6835: rn00564','KEGG','PATH:RN00564',true).
concept_accession('33310: rno00590','KEGG','PATH:RNO00590',true).
concept_accession('32829: rno00534','KEGG','PATH:RNO00534',true).
concept_accession('5211: rn00472','KEGG','PATH:RN00472',true).
concept_accession('11231: rn00905','KEGG','PATH:RN00905',true).
concept_accession('35469: rno00982','KEGG','PATH:RNO00982',true).
concept_accession('7369: rn00601','KEGG','PATH:RN00601',true).
concept_accession('5645: rn00512','KEGG','PATH:RN00512',true).
concept_accession('1307: rn00120','KEGG','PATH:RN00120',true).
concept_accession('10635: rn00900','KEGG','PATH:RN00900',true).
concept_accession('9010: rn00642','KEGG','PATH:RN00642',true).
concept_accession('13900: rn01055','KEGG','PATH:RN01055',true).
concept_accession('29933: rno00232','KEGG','PATH:RNO00232',true).
concept_accession('3470: rn00331','KEGG','PATH:RN00331',true).
concept_accession('33807: rno00604','KEGG','PATH:RNO00604',true).
concept_accession('5178: rn00471','KEGG','PATH:RN00471',true).
concept_accession('6381: rn00531','KEGG','PATH:RN00531',true).
concept_accession('3071: rn00310','KEGG','PATH:RN00310',true).
concept_accession('35023: rno00900','KEGG','PATH:RNO00900',true).
concept_accession('27988: rno00030','KEGG','PATH:RNO00030',true).
concept_accession('13427: rn00982','KEGG','PATH:RN00982',true).
concept_accession('30742: rno00310','KEGG','PATH:RNO00310',true).
concept_accession('3491: rn00340','KEGG','PATH:RN00340',true).
concept_accession('28488: rno00061','KEGG','PATH:RNO00061',true).
concept_accession('8507: rn00627','KEGG','PATH:RN00627',true).
concept_accession('10064: rn00770','KEGG','PATH:RN00770',true).
concept_accession('383: rn00051','KEGG','PATH:RN00051',true).
concept_accession('7868: rn00622','KEGG','PATH:RN00622',true).
concept_accession('4169: rn00362','KEGG','PATH:RN00362',true).
concept_accession('31292: rno00360','KEGG','PATH:RNO00360',true).
concept_accession('34314: rno00730','KEGG','PATH:RNO00730',true).
concept_accession('4720: rn00401','KEGG','PATH:RN00401',true).
concept_accession('31817: rno00460','KEGG','PATH:RNO00460',true).
concept_accession('5693: rn00513','KEGG','PATH:RN00513',true).
concept_accession('3998: rn00361','KEGG','PATH:RN00361',true).
concept_accession('9570: rn00710','KEGG','PATH:RN00710',true).
concept_accession('10165: rn00785','KEGG','PATH:RN00785',true).
concept_accession('7290: rn00600','KEGG','PATH:RN00600',true).
concept_accession('28772: rno00071','KEGG','PATH:RNO00071',true).
concept_accession('9202: rn00660','KEGG','PATH:RN00660',true).
concept_accession('11521: rn00908','KEGG','PATH:RN00908',true).
concept_accession('31929: rno00480','KEGG','PATH:RNO00480',true).
concept_accession('32918: rno00561','KEGG','PATH:RNO00561',true).
concept_accession('2329: rn00250','KEGG','PATH:RN00250',true).
concept_accession('30225: rno00260','KEGG','PATH:RNO00260',true).
concept_accession('33469: rno00592','KEGG','PATH:RNO00592',true).
concept_accession('2878: rn00281','KEGG','PATH:RN00281',true).
concept_accession('31912: rno00472','KEGG','PATH:RNO00472',true).
concept_accession('5369: rn00500','KEGG','PATH:RN00500',true).
concept_accession('32397: rno00520','KEGG','PATH:RNO00520',true).
concept_accession('10133: rn00780','KEGG','PATH:RN00780',true).
concept_accession('9648: rn00720','KEGG','PATH:RN00720',true).
concept_accession('8701: rn00630','KEGG','PATH:RN00630',true).
concept_accession('13985: rn01057','KEGG','PATH:RN01057',true).
concept_accession('35350: rno00980','KEGG','PATH:RNO00980',true).
concept_accession('28072: rno00040','KEGG','PATH:RNO00040',true).
concept_accession('6695: rn00562','KEGG','PATH:RN00562',true).
concept_accession('33430: rno00591','KEGG','PATH:RNO00591',true).
concept_accession('7778: rn00621','KEGG','PATH:RN00621',true).
concept_accession('31885: rno00471','KEGG','PATH:RNO00471',true).
concept_accession('34478: rno00760','KEGG','PATH:RNO00760',true).
concept_accession('11043: rn00904','KEGG','PATH:RN00904',true).
concept_accession('2924: rn00290','KEGG','PATH:RN00290',true).
concept_accession('7222: rn00592','KEGG','PATH:RN00592',true).
concept_accession('28714: rno00062','KEGG','PATH:RNO00062',true).
concept_accession('4321: rn00363','KEGG','PATH:RN00363',true).
concept_accession('6247: rn00523','KEGG','PATH:RN00523',true).
concept_accession('1412: rn00130','KEGG','PATH:RN00130',true).
concept_accession('4830: rn00410','KEGG','PATH:RN00410',true).
concept_accession('11607: rn00909','KEGG','PATH:RN00909',true).
concept_accession('33534: rno00600','KEGG','PATH:RNO00600',true).
concept_accession('32993: rno00562','KEGG','PATH:RNO00562',true).
concept_accession('5255: rn00480','KEGG','PATH:RN00480',true).
concept_accession('31414: rno00380','KEGG','PATH:RNO00380',true).
concept_accession('5815: rn00520','KEGG','PATH:RN00520',true).
concept_accession('7177: rn00591','KEGG','PATH:RN00591',true).
concept_accession('33976: rno00630','KEGG','PATH:RNO00630',true).
concept_accession('10182: rn00790','KEGG','PATH:RN00790',true).
concept_accession('29239: rno00140','KEGG','PATH:RNO00140',true).
concept_accession('9098: rn00650','KEGG','PATH:RN00650',true).
concept_accession('961: rn00062','KEGG','PATH:RN00062',true).
concept_accession('12983: rn00966','KEGG','PATH:RN00966',true).
concept_accession('2426: rn00253','KEGG','PATH:RN00253',true).
concept_accession('9: rn:R00755','KEGG','EC:4.1.1.1',true).
concept_accession('9: rn:R00755','KEGG','RN:R00755',true).
concept_accession('9: rn:R00755','KEGG','RC:RC00375',true).
concept_accession('9: rn:R00755','EC','4.1.1.1',false).
concept_accession('9: rn:R00755','KEGG','RP01089',true).
concept_accession('9: rn:R00755','KEGG','R00755',true).
concept_accession('9: rn:R00755','KEGG','RC00375',true).
concept_accession('9: rn:R00755','KEGG','RP:RP01089',true).
concept_accession('9: rn:R00755','KEGG','4.1.1.1',true).
concept_accession('27: rn:R02738','KEGG','RP02452',true).
concept_accession('27: rn:R02738','KEGG','RN:R02738',true).
concept_accession('27: rn:R02738','KEGG','RC00017',true).
concept_accession('27: rn:R02738','EC','2.7.1.69',false).
concept_accession('27: rn:R02738','KEGG','EC:2.7.1.69',true).
concept_accession('27: rn:R02738','KEGG','RP:RP02452',true).
concept_accession('27: rn:R02738','KEGG','RC:RC00017',true).
concept_accession('27: rn:R02738','KEGG','R02738',true).
concept_accession('27: rn:R02738','KEGG','2.7.1.69',true).
concept_accession('8829: rn:R00934','KEGG','RC00407',true).
concept_accession('8829: rn:R00934','EC','4.1.3.24',false).
concept_accession('8829: rn:R00934','KEGG','RC:RC00311',true).
concept_accession('8829: rn:R00934','KEGG','RC:RC00407',true).
concept_accession('8829: rn:R00934','KEGG','EC:4.1.3.24',true).
concept_accession('8829: rn:R00934','KEGG','RC00311',true).
concept_accession('8829: rn:R00934','KEGG','R00934',true).
concept_accession('8829: rn:R00934','KEGG','4.1.3.24',true).
concept_accession('8829: rn:R00934','KEGG','RN:R00934',true).
concept_accession('8829: rn:R00934','KEGG','RP01183',true).
concept_accession('8829: rn:R00934','KEGG','RP:RP01184',true).
concept_accession('8829: rn:R00934','KEGG','RP:RP01183',true).
concept_accession('8829: rn:R00934','KEGG','RP01184',true).
concept_accession('8770: rn:R01388','KEGG','RP:RP00299',true).
concept_accession('8770: rn:R01388','KEGG','RC00031',true).
concept_accession('8770: rn:R01388','KEGG','1.1.1.29',true).
concept_accession('8770: rn:R01388','EC','1.1.1.29',false).
concept_accession('8770: rn:R01388','KEGG','R01388',true).
concept_accession('8770: rn:R01388','KEGG','EC:1.1.1.29',true).
concept_accession('8770: rn:R01388','KEGG','RC:RC00031',true).
concept_accession('8770: rn:R01388','KEGG','RP00299',true).
concept_accession('8770: rn:R01388','KEGG','RN:R01388',true).
concept_accession('39: rn:R00947','KEGG','RC:RC00078',true).
concept_accession('39: rn:R00947','KEGG','RN:R00947',true).
concept_accession('39: rn:R00947','KEGG','R00947',true).
concept_accession('39: rn:R00947','KEGG','3.1.3.10',true).
concept_accession('39: rn:R00947','KEGG','RC00078',true).
concept_accession('39: rn:R00947','KEGG','RP:RP00303',true).
concept_accession('39: rn:R00947','KEGG','EC:3.1.3.10',true).
concept_accession('39: rn:R00947','EC','3.1.3.10',false).
concept_accession('39: rn:R00947','KEGG','RP00303',true).
concept_accession('40: rn:R00960','KEGG','RC:RC00078',true).
concept_accession('40: rn:R00960','KEGG','2.7.1.41',true).
concept_accession('40: rn:R00960','KEGG','RC00078',true).
concept_accession('40: rn:R00960','EC','2.7.1.41',false).
concept_accession('40: rn:R00960','KEGG','EC:2.7.1.41',true).
concept_accession('40: rn:R00960','KEGG','RP:RP00303',true).
concept_accession('40: rn:R00960','KEGG','R00960',true).
concept_accession('40: rn:R00960','KEGG','RP00303',true).
concept_accession('40: rn:R00960','KEGG','RN:R00960',true).
concept_accession('8740: rn:R01392','KEGG','RP:RP00299',true).
concept_accession('8740: rn:R01392','KEGG','EC:1.1.1.79',true).
concept_accession('8740: rn:R01392','KEGG','RC00031',true).
concept_accession('8740: rn:R01392','KEGG','R01392',true).
concept_accession('8740: rn:R01392','KEGG','1.1.1.79',true).
concept_accession('8740: rn:R01392','KEGG','RC:RC00031',true).
concept_accession('8740: rn:R01392','EC','1.1.1.79',false).
concept_accession('8740: rn:R01392','KEGG','RN:R01392',true).
concept_accession('8740: rn:R01392','KEGG','RP00299',true).
concept_accession('8741: rn:R01388','KEGG','RP:RP00299',true).
concept_accession('8741: rn:R01388','KEGG','RC00031',true).
concept_accession('8741: rn:R01388','KEGG','1.1.1.29',true).
concept_accession('8741: rn:R01388','EC','1.1.1.29',false).
concept_accession('8741: rn:R01388','KEGG','R01388',true).
concept_accession('8741: rn:R01388','KEGG','EC:1.1.1.29',true).
concept_accession('8741: rn:R01388','KEGG','RC:RC00031',true).
concept_accession('8741: rn:R01388','KEGG','RP00299',true).
concept_accession('8741: rn:R01388','KEGG','RN:R01388',true).
concept_accession('8742: rn:R01745 rn:R01747','KEGG','RP:RP00349',true).
concept_accession('8742: rn:R01745 rn:R01747','KEGG','RC00099',true).
concept_accession('8742: rn:R01745 rn:R01747','KEGG','R01747',true).
concept_accession('8742: rn:R01745 rn:R01747','KEGG','RN:R01747',true).
concept_accession('8742: rn:R01745 rn:R01747','KEGG','R01745',true).
concept_accession('8742: rn:R01745 rn:R01747','KEGG','RN:R01745',true).
concept_accession('8742: rn:R01745 rn:R01747','EC','1.1.1.60',false).
concept_accession('8742: rn:R01745 rn:R01747','KEGG','EC:1.1.1.60',true).
concept_accession('8742: rn:R01745 rn:R01747','KEGG','1.1.1.60',true).
concept_accession('8742: rn:R01745 rn:R01747','KEGG','RP00349',true).
concept_accession('8742: rn:R01745 rn:R01747','KEGG','RC:RC00099',true).
concept_accession('8743: rn:R00013','KEGG','EC:4.1.1.47',true).
concept_accession('8743: rn:R00013','KEGG','4.1.1.47',true).
concept_accession('8743: rn:R00013','KEGG','RP:RP02916',true).
concept_accession('8743: rn:R00013','KEGG','R00013',true).
concept_accession('8743: rn:R00013','KEGG','RN:R00013',true).
concept_accession('8743: rn:R00013','KEGG','RC00899',true).
concept_accession('8743: rn:R00013','EC','4.1.1.47',false).
concept_accession('8743: rn:R00013','KEGG','RC:RC00899',true).
concept_accession('8743: rn:R00013','KEGG','RP02916',true).
concept_accession('8739: rn:R01388 rn:R01392','KEGG','1.1.1.81',true).
concept_accession('8739: rn:R01388 rn:R01392','KEGG','RP:RP00299',true).
concept_accession('8739: rn:R01388 rn:R01392','KEGG','RC00031',true).
concept_accession('8739: rn:R01388 rn:R01392','KEGG','R01392',true).
concept_accession('8739: rn:R01388 rn:R01392','KEGG','R01388',true).
concept_accession('8739: rn:R01388 rn:R01392','KEGG','RC:RC00031',true).
concept_accession('8739: rn:R01388 rn:R01392','KEGG','EC:1.1.1.81',true).
concept_accession('8739: rn:R01388 rn:R01392','KEGG','RN:R01392',true).
concept_accession('8739: rn:R01388 rn:R01392','KEGG','RP00299',true).
concept_accession('8739: rn:R01388 rn:R01392','EC','1.1.1.81',false).
concept_accession('8739: rn:R01388 rn:R01392','KEGG','RN:R01388',true).
concept_accession('8744: rn:R00472','KEGG','R00472',true).
concept_accession('8744: rn:R00472','KEGG','RN:R00472',true).
concept_accession('8744: rn:R00472','KEGG','RC:RC00308',true).
concept_accession('8744: rn:R00472','KEGG','2.3.3.9',true).
concept_accession('8744: rn:R00472','KEGG','RP00921',true).
concept_accession('8744: rn:R00472','KEGG','RC00308',true).
concept_accession('8744: rn:R00472','EC','2.3.3.9',false).
concept_accession('8744: rn:R00472','KEGG','EC:2.3.3.9',true).
concept_accession('8744: rn:R00472','KEGG','RP:RP00921',true).
concept_accession('4473: rn:R01816','KEGG','EC:1.14.16.3',true).
concept_accession('4473: rn:R01816','KEGG','RC:RC00046',true).
concept_accession('4473: rn:R01816','KEGG','1.14.16.3',true).
concept_accession('4473: rn:R01816','KEGG','RC00046',true).
concept_accession('4473: rn:R01816','KEGG','RP:RP01777',true).
concept_accession('4473: rn:R01816','KEGG','RN:R01816',true).
concept_accession('4473: rn:R01816','KEGG','RP01777',true).
concept_accession('4473: rn:R01816','EC','1.14.16.3',false).
concept_accession('4473: rn:R01816','KEGG','R01816',true).
concept_accession('85: rn:R01196','KEGG','R01196',true).
concept_accession('85: rn:R01196','KEGG','RN:R01196',true).
concept_accession('85: rn:R01196','KEGG','1.2.7.1',true).
concept_accession('85: rn:R01196','EC','1.2.7.1',false).
concept_accession('85: rn:R01196','KEGG','EC:1.2.7.1',true).
concept_accession('84: rn:R01058','KEGG','RC00242',true).
concept_accession('84: rn:R01058','EC','1.2.1.9',false).
concept_accession('84: rn:R01058','KEGG','EC:1.2.1.9',true).
concept_accession('84: rn:R01058','KEGG','R01058',true).
concept_accession('84: rn:R01058','KEGG','1.2.1.9',true).
concept_accession('84: rn:R01058','KEGG','RC:RC00242',true).
concept_accession('84: rn:R01058','KEGG','RP01264',true).
concept_accession('84: rn:R01058','KEGG','RP:RP01264',true).
concept_accession('84: rn:R01058','KEGG','RN:R01058',true).
concept_accession('86: rn:R07159','KEGG','1.2.7.5',true).
concept_accession('86: rn:R07159','KEGG','RC00242',true).
concept_accession('86: rn:R07159','KEGG','RC:RC00242',true).
concept_accession('86: rn:R07159','KEGG','RP01264',true).
concept_accession('86: rn:R07159','KEGG','RN:R07159',true).
concept_accession('86: rn:R07159','EC','1.2.7.5',false).
concept_accession('86: rn:R07159','KEGG','EC:1.2.7.5',true).
concept_accession('86: rn:R07159','KEGG','RP:RP01264',true).
concept_accession('86: rn:R07159','KEGG','R07159',true).
concept_accession('4451: rn:R01974','KEGG','RP:RP01885',true).
concept_accession('4451: rn:R01974','KEGG','RP01885',true).
concept_accession('4451: rn:R01974','KEGG','RN:R01974',true).
concept_accession('4451: rn:R01974','KEGG','R01974',true).
concept_accession('4451: rn:R01974','KEGG','EC:4.1.1.43',true).
concept_accession('4451: rn:R01974','KEGG','RC:RC00506',true).
concept_accession('4451: rn:R01974','KEGG','4.1.1.43',true).
concept_accession('4451: rn:R01974','EC','4.1.1.43',false).
concept_accession('4451: rn:R01974','KEGG','RC00506',true).
concept_accession('83: rn:R07159','KEGG','1.2.7.5',true).
concept_accession('83: rn:R07159','KEGG','RC00242',true).
concept_accession('83: rn:R07159','KEGG','RC:RC00242',true).
concept_accession('83: rn:R07159','KEGG','RP01264',true).
concept_accession('83: rn:R07159','KEGG','RN:R07159',true).
concept_accession('83: rn:R07159','EC','1.2.7.5',false).
concept_accession('83: rn:R07159','KEGG','EC:1.2.7.5',true).
concept_accession('83: rn:R07159','KEGG','RP:RP01264',true).
concept_accession('83: rn:R07159','KEGG','R07159',true).
concept_accession('8767: rn:R03140','KEGG','EC:4.1.1.39',true).
concept_accession('8767: rn:R03140','KEGG','RN:R03140',true).
concept_accession('8767: rn:R03140','KEGG','R03140',true).
concept_accession('8767: rn:R03140','KEGG','4.1.1.39',true).
concept_accession('8767: rn:R03140','KEGG','RC00859',true).
concept_accession('8767: rn:R03140','KEGG','RP02791',true).
concept_accession('8767: rn:R03140','KEGG','RC:RC00172',true).
concept_accession('8767: rn:R03140','KEGG','RC:RC00859',true).
concept_accession('8767: rn:R03140','KEGG','RP00477',true).
concept_accession('8767: rn:R03140','KEGG','RP:RP00477',true).
concept_accession('8767: rn:R03140','EC','4.1.1.39',false).
concept_accession('8767: rn:R03140','KEGG','RP:RP02791',true).
concept_accession('8767: rn:R03140','KEGG','RC00172',true).
concept_accession('8710: rn:R00479','EC','4.1.3.1',false).
concept_accession('8710: rn:R00479','KEGG','RC:RC00311',true).
concept_accession('8710: rn:R00479','KEGG','RC00313',true).
concept_accession('8710: rn:R00479','KEGG','RC:RC00313',true).
concept_accession('8710: rn:R00479','KEGG','RC00311',true).
concept_accession('8710: rn:R00479','KEGG','EC:4.1.3.1',true).
concept_accession('8710: rn:R00479','KEGG','RP:RP00930',true).
concept_accession('8710: rn:R00479','KEGG','RP:RP00931',true).
concept_accession('8710: rn:R00479','KEGG','RN:R00479',true).
concept_accession('8710: rn:R00479','KEGG','R00479',true).
concept_accession('8710: rn:R00479','KEGG','RP00930',true).
concept_accession('8710: rn:R00479','KEGG','RP00931',true).
concept_accession('8710: rn:R00479','KEGG','4.1.3.1',true).
concept_accession('8708: rn:R00477','KEGG','EC:4.1.3.13',true).
concept_accession('8708: rn:R00477','KEGG','RC00310',true).
concept_accession('8708: rn:R00477','KEGG','RC:RC00310',true).
concept_accession('8708: rn:R00477','KEGG','RC:RC00311',true).
concept_accession('8708: rn:R00477','KEGG','RC00311',true).
concept_accession('8708: rn:R00477','KEGG','4.1.3.13',true).
concept_accession('8708: rn:R00477','KEGG','RP00926',true).
concept_accession('8708: rn:R00477','EC','4.1.3.13',false).
concept_accession('8708: rn:R00477','KEGG','R00477',true).
concept_accession('8708: rn:R00477','KEGG','RP00927',true).
concept_accession('8708: rn:R00477','KEGG','RP:RP00927',true).
concept_accession('8708: rn:R00477','KEGG','RN:R00477',true).
concept_accession('8708: rn:R00477','KEGG','RP:RP00926',true).
concept_accession('8709: rn:R00470','KEGG','RC:RC00307',true).
concept_accession('8709: rn:R00470','KEGG','RC:RC00308',true).
concept_accession('8709: rn:R00470','KEGG','RP:RP00918',true).
concept_accession('8709: rn:R00470','KEGG','EC:4.1.3.16',true).
concept_accession('8709: rn:R00470','KEGG','4.1.3.16',true).
concept_accession('8709: rn:R00470','KEGG','RC00307',true).
concept_accession('8709: rn:R00470','KEGG','R00470',true).
concept_accession('8709: rn:R00470','KEGG','RN:R00470',true).
concept_accession('8709: rn:R00470','KEGG','RC00308',true).
concept_accession('8709: rn:R00470','KEGG','RP00917',true).
concept_accession('8709: rn:R00470','EC','4.1.3.16',false).
concept_accession('8709: rn:R00470','KEGG','RP:RP00917',true).
concept_accession('8709: rn:R00470','KEGG','RP00918',true).
concept_accession('8707: rn:R01180','KEGG','RP:RP01345',true).
concept_accession('8707: rn:R01180','KEGG','RN:R01180',true).
concept_accession('8707: rn:R01180','KEGG','R01180',true).
concept_accession('8707: rn:R01180','KEGG','2.3.3.7',true).
concept_accession('8707: rn:R01180','KEGG','RC:RC00311',true).
concept_accession('8707: rn:R01180','EC','2.3.3.7',false).
concept_accession('8707: rn:R01180','KEGG','EC:2.3.3.7',true).
concept_accession('8707: rn:R01180','KEGG','RC00311',true).
concept_accession('8707: rn:R01180','KEGG','RP01345',true).
concept_accession('99: rn:R01197','KEGG','R01197',true).
concept_accession('99: rn:R01197','KEGG','1.2.7.3',true).
concept_accession('99: rn:R01197','KEGG','RN:R01197',true).
concept_accession('99: rn:R01197','EC','1.2.7.3',false).
concept_accession('99: rn:R01197','KEGG','EC:1.2.7.3',true).
concept_accession('8705: rn:R00474','KEGG','RN:R00474',true).
concept_accession('8705: rn:R00474','KEGG','RC00309',true).
concept_accession('8705: rn:R00474','KEGG','RC:RC00309',true).
concept_accession('8705: rn:R00474','EC','2.2.1.5',false).
concept_accession('8705: rn:R00474','KEGG','RP00925',true).
concept_accession('8705: rn:R00474','KEGG','EC:2.2.1.5',true).
concept_accession('8705: rn:R00474','KEGG','2.2.1.5',true).
concept_accession('8705: rn:R00474','KEGG','RP:RP00925',true).
concept_accession('8705: rn:R00474','KEGG','R00474',true).
concept_accession('8733: rn:R03146','KEGG','EC:1.2.2.1',true).
concept_accession('8733: rn:R03146','KEGG','RN:R03146',true).
concept_accession('8733: rn:R03146','KEGG','1.2.2.1',true).
concept_accession('8733: rn:R03146','EC','1.2.2.1',false).
concept_accession('8733: rn:R03146','KEGG','R03146',true).
concept_accession('8732: rn:R00519','KEGG','1.2.1.2',true).
concept_accession('8732: rn:R00519','KEGG','R00519',true).
concept_accession('8732: rn:R00519','KEGG','RN:R00519',true).
concept_accession('8732: rn:R00519','EC','1.2.1.2',false).
concept_accession('8732: rn:R00519','KEGG','EC:1.2.1.2',true).
concept_accession('8936: rn:R01199','KEGG','1.2.7.1',true).
concept_accession('8936: rn:R01199','EC','1.2.7.1',false).
concept_accession('8936: rn:R01199','KEGG','EC:1.2.7.1',true).
concept_accession('8936: rn:R01199','KEGG','RN:R01199',true).
concept_accession('8936: rn:R01199','KEGG','R01199',true).
concept_accession('8940: rn:R01608','KEGG','RC00087',true).
concept_accession('8940: rn:R01608','KEGG','RN:R01608',true).
concept_accession('8940: rn:R01608','KEGG','RC:RC00087',true).
concept_accession('8940: rn:R01608','KEGG','1.1.1.59',true).
concept_accession('8940: rn:R01608','KEGG','R01608',true).
concept_accession('8940: rn:R01608','KEGG','EC:1.1.1.59',true).
concept_accession('8940: rn:R01608','KEGG','RP:RP01630',true).
concept_accession('8940: rn:R01608','KEGG','RP01630',true).
concept_accession('8940: rn:R01608','EC','1.1.1.59',false).
concept_accession('8935: rn:R01199','KEGG','1.2.7.1',true).
concept_accession('8935: rn:R01199','EC','1.2.7.1',false).
concept_accession('8935: rn:R01199','KEGG','EC:1.2.7.1',true).
concept_accession('8935: rn:R01199','KEGG','RN:R01199',true).
concept_accession('8935: rn:R01199','KEGG','R01199',true).
concept_accession('155: rn:R01196','KEGG','R01196',true).
concept_accession('155: rn:R01196','KEGG','RN:R01196',true).
concept_accession('155: rn:R01196','KEGG','1.2.7.1',true).
concept_accession('155: rn:R01196','EC','1.2.7.1',false).
concept_accession('155: rn:R01196','KEGG','EC:1.2.7.1',true).
concept_accession('8944: rn:R01611','KEGG','RC:RC00565',true).
concept_accession('8944: rn:R01611','EC','4.2.1.27',false).
concept_accession('8944: rn:R01611','KEGG','RP01634',true).
concept_accession('8944: rn:R01611','KEGG','RC00565',true).
concept_accession('8944: rn:R01611','KEGG','RN:R01611',true).
concept_accession('8944: rn:R01611','KEGG','EC:4.2.1.27',true).
concept_accession('8944: rn:R01611','KEGG','RP:RP01634',true).
concept_accession('8944: rn:R01611','KEGG','4.2.1.27',true).
concept_accession('8944: rn:R01611','KEGG','R01611',true).
concept_accession('4516: rn:R04172','KEGG','RP:RP03805',true).
concept_accession('4516: rn:R04172','KEGG','RC:RC00299',true).
concept_accession('4516: rn:R04172','KEGG','RP03805',true).
concept_accession('4516: rn:R04172','EC','4.1.1.-',false).
concept_accession('4516: rn:R04172','KEGG','4.1.1.-',true).
concept_accession('4516: rn:R04172','KEGG','RC00299',true).
concept_accession('4516: rn:R04172','KEGG','R04172',true).
concept_accession('4516: rn:R04172','KEGG','EC:4.1.1.-',true).
concept_accession('4516: rn:R04172','KEGG','RN:R04172',true).
concept_accession('8907: rn:R06987','EC','2.3.1.54',false).
concept_accession('8907: rn:R06987','KEGG','R06987',true).
concept_accession('8907: rn:R06987','KEGG','RN:R06987',true).
concept_accession('8907: rn:R06987','KEGG','2.3.1.54',true).
concept_accession('8907: rn:R06987','KEGG','EC:2.3.1.54',true).
concept_accession('169: rn:R01066','KEGG','RN:R01066',true).
concept_accession('169: rn:R01066','KEGG','EC:4.1.2.4',true).
concept_accession('169: rn:R01066','KEGG','RP01269',true).
concept_accession('169: rn:R01066','KEGG','RP:RP01269',true).
concept_accession('169: rn:R01066','KEGG','4.1.2.4',true).
concept_accession('169: rn:R01066','KEGG','RC:RC00437',true).
concept_accession('169: rn:R01066','KEGG','R01066',true).
concept_accession('169: rn:R01066','EC','4.1.2.4',false).
concept_accession('169: rn:R01066','KEGG','RC00437',true).
concept_accession('168: rn:R02749','KEGG','RN:R02749',true).
concept_accession('168: rn:R02749','KEGG','RC00408',true).
concept_accession('168: rn:R02749','KEGG','RP:RP02468',true).
concept_accession('168: rn:R02749','KEGG','EC:5.4.2.7',true).
concept_accession('168: rn:R02749','KEGG','RP02468',true).
concept_accession('168: rn:R02749','KEGG','R02749',true).
concept_accession('168: rn:R02749','EC','5.4.2.7',false).
concept_accession('168: rn:R02749','KEGG','5.4.2.7',true).
concept_accession('168: rn:R02749','KEGG','RC:RC00408',true).
concept_accession('4503: rn:R01974','KEGG','RP:RP01885',true).
concept_accession('4503: rn:R01974','KEGG','RP01885',true).
concept_accession('4503: rn:R01974','KEGG','RN:R01974',true).
concept_accession('4503: rn:R01974','KEGG','R01974',true).
concept_accession('4503: rn:R01974','KEGG','EC:4.1.1.43',true).
concept_accession('4503: rn:R01974','KEGG','RC:RC00506',true).
concept_accession('4503: rn:R01974','KEGG','4.1.1.43',true).
concept_accession('4503: rn:R01974','EC','4.1.1.43',false).
concept_accession('4503: rn:R01974','KEGG','RC00506',true).
concept_accession('165: rn:R05605','KEGG','RP05200',true).
concept_accession('165: rn:R05605','KEGG','RC:RC00307',true).
concept_accession('165: rn:R05605','KEGG','RP05201',true).
concept_accession('165: rn:R05605','KEGG','RC:RC00435',true).
concept_accession('165: rn:R05605','KEGG','4.1.2.14',true).
concept_accession('165: rn:R05605','EC','4.1.2.14',false).
concept_accession('165: rn:R05605','KEGG','RC00307',true).
concept_accession('165: rn:R05605','KEGG','EC:4.1.2.14',true).
concept_accession('165: rn:R05605','KEGG','RC00435',true).
concept_accession('165: rn:R05605','KEGG','RN:R05605',true).
concept_accession('165: rn:R05605','KEGG','R05605',true).
concept_accession('165: rn:R05605','KEGG','RP:RP05200',true).
concept_accession('165: rn:R05605','KEGG','RP:RP05201',true).
concept_accession('8923: rn:R00920','KEGG','6.2.1.13',true).
concept_accession('8923: rn:R00920','KEGG','RP:RP00117',true).
concept_accession('8923: rn:R00920','KEGG','R00920',true).
concept_accession('8923: rn:R00920','KEGG','RC00014',true).
concept_accession('8923: rn:R00920','KEGG','EC:6.2.1.13',true).
concept_accession('8923: rn:R00920','KEGG','RN:R00920',true).
concept_accession('8923: rn:R00920','KEGG','RC:RC00014',true).
concept_accession('8923: rn:R00920','KEGG','RP00117',true).
concept_accession('8923: rn:R00920','EC','6.2.1.13',false).
concept_accession('8920: rn:R00928','KEGG','RP:RP00117',true).
concept_accession('8920: rn:R00928','KEGG','EC:2.8.3.1',true).
concept_accession('8920: rn:R00928','KEGG','RC00014',true).
concept_accession('8920: rn:R00928','KEGG','2.8.3.1',true).
concept_accession('8920: rn:R00928','KEGG','RN:R00928',true).
concept_accession('8920: rn:R00928','EC','2.8.3.1',false).
concept_accession('8920: rn:R00928','KEGG','R00928',true).
concept_accession('8920: rn:R00928','KEGG','RC:RC00014',true).
concept_accession('8920: rn:R00928','KEGG','RP00117',true).
concept_accession('189: rn:R01737','KEGG','2.7.1.12',true).
concept_accession('189: rn:R01737','KEGG','RC00017',true).
concept_accession('189: rn:R01737','KEGG','RP:RP01728',true).
concept_accession('189: rn:R01737','EC','2.7.1.12',false).
concept_accession('189: rn:R01737','KEGG','R01737',true).
concept_accession('189: rn:R01737','KEGG','EC:2.7.1.12',true).
concept_accession('189: rn:R01737','KEGG','RN:R01737',true).
concept_accession('189: rn:R01737','KEGG','RC:RC00017',true).
concept_accession('189: rn:R01737','KEGG','RP01728',true).
concept_accession('8914: rn:R03381','KEGG','EC:1.2.1.18',true).
concept_accession('8914: rn:R03381','KEGG','R03381',true).
concept_accession('8914: rn:R03381','KEGG','RP03001',true).
concept_accession('8914: rn:R03381','EC','1.2.1.18',false).
concept_accession('8914: rn:R03381','KEGG','RC:RC00846',true).
concept_accession('8914: rn:R03381','KEGG','1.2.1.18',true).
concept_accession('8914: rn:R03381','KEGG','RC00846',true).
concept_accession('8914: rn:R03381','KEGG','RN:R03381',true).
concept_accession('8914: rn:R03381','KEGG','RP:RP03001',true).
concept_accession('8915: rn:R02764','KEGG','RC:RC00137',true).
concept_accession('8915: rn:R02764','KEGG','3.1.2.17',true).
concept_accession('8915: rn:R02764','KEGG','RP02481',true).
concept_accession('8915: rn:R02764','KEGG','RN:R02764',true).
concept_accession('8915: rn:R02764','KEGG','RP:RP02481',true).
concept_accession('8915: rn:R02764','EC','3.1.2.17',false).
concept_accession('8915: rn:R02764','KEGG','EC:3.1.2.17',true).
concept_accession('8915: rn:R02764','KEGG','R02764',true).
concept_accession('8915: rn:R02764','KEGG','RC00137',true).
concept_accession('13208: rn:R08223','KEGG','RN:R08223',true).
concept_accession('13208: rn:R08223','KEGG','2.7.1.164',true).
concept_accession('13208: rn:R08223','KEGG','RP:RP13086',true).
concept_accession('13208: rn:R08223','KEGG','RC00017',true).
concept_accession('13208: rn:R08223','KEGG','R08223',true).
concept_accession('13208: rn:R08223','KEGG','RP13086',true).
concept_accession('13208: rn:R08223','KEGG','RC:RC00017',true).
concept_accession('13208: rn:R08223','EC','2.7.1.164',false).
concept_accession('13208: rn:R08223','KEGG','EC:2.7.1.164',true).
concept_accession('13211: rn:R08219','KEGG','EC:2.9.1.1',true).
concept_accession('13211: rn:R08219','KEGG','R08219',true).
concept_accession('13211: rn:R08219','KEGG','RP:RP13084',true).
concept_accession('13211: rn:R08219','KEGG','RP13084',true).
concept_accession('13211: rn:R08219','KEGG','RN:R08219',true).
concept_accession('13211: rn:R08219','EC','2.9.1.1',false).
concept_accession('13211: rn:R08219','KEGG','RC:RC01246',true).
concept_accession('13211: rn:R08219','KEGG','RC01246',true).
concept_accession('13211: rn:R08219','KEGG','2.9.1.1',true).
concept_accession('202: rn:R01522','KEGG','RP00184',true).
concept_accession('202: rn:R01522','KEGG','RC:RC00066',true).
concept_accession('202: rn:R01522','KEGG','EC:1.1.3.4',true).
concept_accession('202: rn:R01522','KEGG','RC00066',true).
concept_accession('202: rn:R01522','KEGG','RP:RP00184',true).
concept_accession('202: rn:R01522','KEGG','1.1.3.4',true).
concept_accession('202: rn:R01522','KEGG','R01522',true).
concept_accession('202: rn:R01522','EC','1.1.3.4',false).
concept_accession('202: rn:R01522','KEGG','RN:R01522',true).
concept_accession('193: rn:R00305','KEGG','RC:RC00066',true).
concept_accession('193: rn:R00305','KEGG','RC00066',true).
concept_accession('193: rn:R00305','KEGG','RP00321',true).
concept_accession('193: rn:R00305','KEGG','R00305',true).
concept_accession('193: rn:R00305','KEGG','1.1.99.10',true).
concept_accession('193: rn:R00305','EC','1.1.99.10',false).
concept_accession('193: rn:R00305','KEGG','RN:R00305',true).
concept_accession('193: rn:R00305','KEGG','RP:RP00321',true).
concept_accession('193: rn:R00305','KEGG','EC:1.1.99.10',true).
concept_accession('192: rn:R06620','KEGG','RC:RC00066',true).
concept_accession('192: rn:R06620','KEGG','RC00066',true).
concept_accession('192: rn:R06620','KEGG','1.1.5.2',true).
concept_accession('192: rn:R06620','KEGG','RP00321',true).
concept_accession('192: rn:R06620','EC','1.1.5.2',false).
concept_accession('192: rn:R06620','KEGG','EC:1.1.5.2',true).
concept_accession('192: rn:R06620','KEGG','R06620',true).
concept_accession('192: rn:R06620','KEGG','RP:RP00321',true).
concept_accession('192: rn:R06620','KEGG','RN:R06620',true).
concept_accession('195: rn:R01520 rn:R01521','KEGG','RP00184',true).
concept_accession('195: rn:R01520 rn:R01521','KEGG','RC:RC00066',true).
concept_accession('195: rn:R01520 rn:R01521','KEGG','RC00066',true).
concept_accession('195: rn:R01520 rn:R01521','EC','1.1.1.47',false).
concept_accession('195: rn:R01520 rn:R01521','KEGG','RP:RP00184',true).
concept_accession('195: rn:R01520 rn:R01521','KEGG','EC:1.1.1.47',true).
concept_accession('195: rn:R01520 rn:R01521','KEGG','1.1.1.47',true).
concept_accession('195: rn:R01520 rn:R01521','KEGG','R01521',true).
concept_accession('195: rn:R01520 rn:R01521','KEGG','R01520',true).
concept_accession('195: rn:R01520 rn:R01521','KEGG','RN:R01521',true).
concept_accession('195: rn:R01520 rn:R01521','KEGG','RN:R01520',true).
concept_accession('194: rn:R01522','KEGG','RP00184',true).
concept_accession('194: rn:R01522','KEGG','RC:RC00066',true).
concept_accession('194: rn:R01522','KEGG','EC:1.1.3.4',true).
concept_accession('194: rn:R01522','KEGG','RC00066',true).
concept_accession('194: rn:R01522','KEGG','RP:RP00184',true).
concept_accession('194: rn:R01522','KEGG','1.1.3.4',true).
concept_accession('194: rn:R01522','KEGG','R01522',true).
concept_accession('194: rn:R01522','EC','1.1.3.4',false).
concept_accession('194: rn:R01522','KEGG','RN:R01522',true).
concept_accession('212: rn:R05605','KEGG','RP05200',true).
concept_accession('212: rn:R05605','KEGG','RC:RC00307',true).
concept_accession('212: rn:R05605','KEGG','RP05201',true).
concept_accession('212: rn:R05605','KEGG','RC:RC00435',true).
concept_accession('212: rn:R05605','KEGG','4.1.2.14',true).
concept_accession('212: rn:R05605','EC','4.1.2.14',false).
concept_accession('212: rn:R05605','KEGG','RC00307',true).
concept_accession('212: rn:R05605','KEGG','EC:4.1.2.14',true).
concept_accession('212: rn:R05605','KEGG','RC00435',true).
concept_accession('212: rn:R05605','KEGG','RN:R05605',true).
concept_accession('212: rn:R05605','KEGG','R05605',true).
concept_accession('212: rn:R05605','KEGG','RP:RP05200',true).
concept_accession('212: rn:R05605','KEGG','RP:RP05201',true).
concept_accession('208: rn:R08570','KEGG','RC:RC00307',true).
concept_accession('208: rn:R08570','KEGG','RP:RP13334',true).
concept_accession('208: rn:R08570','KEGG','RP:RP13333',true).
concept_accession('208: rn:R08570','KEGG','RC:RC00435',true).
concept_accession('208: rn:R08570','KEGG','EC:4.1.2.-',true).
concept_accession('208: rn:R08570','EC','4.1.2.-',false).
concept_accession('208: rn:R08570','KEGG','R08570',true).
concept_accession('208: rn:R08570','KEGG','RC00307',true).
concept_accession('208: rn:R08570','KEGG','RC00435',true).
concept_accession('208: rn:R08570','KEGG','4.1.2.-',true).
concept_accession('208: rn:R08570','KEGG','RN:R08570',true).
concept_accession('208: rn:R08570','KEGG','RP13333',true).
concept_accession('208: rn:R08570','KEGG','RP13334',true).
concept_accession('210: rn:R08572','KEGG','2.7.1.-',true).
concept_accession('210: rn:R08572','EC','2.7.1.-',false).
concept_accession('210: rn:R08572','KEGG','R08572',true).
concept_accession('210: rn:R08572','KEGG','RC:RC00428',true).
concept_accession('210: rn:R08572','KEGG','RN:R08572',true).
concept_accession('210: rn:R08572','KEGG','RC00428',true).
concept_accession('210: rn:R08572','KEGG','RP:RP01729',true).
concept_accession('210: rn:R08572','KEGG','RP01729',true).
concept_accession('210: rn:R08572','KEGG','EC:2.7.1.-',true).
concept_accession('13236: rn:R07073','KEGG','R07073',true).
concept_accession('13236: rn:R07073','KEGG','RP:RP10227',true).
concept_accession('13236: rn:R07073','KEGG','RN:R07073',true).
concept_accession('13236: rn:R07073','KEGG','RC:RC01752',true).
concept_accession('13236: rn:R07073','KEGG','RP10227',true).
concept_accession('13236: rn:R07073','KEGG','RC01752',true).
concept_accession('279: rn:R01896','KEGG','RN:R01896',true).
concept_accession('279: rn:R01896','KEGG','EC:1.1.1.9',true).
concept_accession('279: rn:R01896','KEGG','R01896',true).
concept_accession('279: rn:R01896','KEGG','1.1.1.9',true).
concept_accession('279: rn:R01896','KEGG','RC:RC00102',true).
concept_accession('279: rn:R01896','KEGG','RP01827',true).
concept_accession('279: rn:R01896','EC','1.1.1.9',false).
concept_accession('279: rn:R01896','KEGG','RC00102',true).
concept_accession('279: rn:R01896','KEGG','RP:RP01827',true).
concept_accession('283: rn:R01903','KEGG','RP:RP01833',true).
concept_accession('283: rn:R01903','KEGG','RN:R01903',true).
concept_accession('283: rn:R01903','KEGG','R01903',true).
concept_accession('283: rn:R01903','KEGG','RC:RC00102',true).
concept_accession('283: rn:R01903','KEGG','1.1.1.12',true).
concept_accession('283: rn:R01903','KEGG','RC00102',true).
concept_accession('283: rn:R01903','EC','1.1.1.12',false).
concept_accession('283: rn:R01903','KEGG','RP01833',true).
concept_accession('283: rn:R01903','KEGG','EC:1.1.1.12',true).
concept_accession('280: rn:R01432','KEGG','R01432',true).
concept_accession('280: rn:R01432','EC','5.3.1.5',false).
concept_accession('280: rn:R01432','KEGG','RP01508',true).
concept_accession('280: rn:R01432','KEGG','EC:5.3.1.5',true).
concept_accession('280: rn:R01432','KEGG','RC:RC00516',true).
concept_accession('280: rn:R01432','KEGG','5.3.1.5',true).
concept_accession('280: rn:R01432','KEGG','RP:RP01508',true).
concept_accession('280: rn:R01432','KEGG','RC00516',true).
concept_accession('280: rn:R01432','KEGG','RN:R01432',true).
concept_accession('287: rn:R01905','KEGG','R01905',true).
concept_accession('287: rn:R01905','KEGG','RC:RC00619',true).
concept_accession('287: rn:R01905','EC','4.1.1.34',false).
concept_accession('287: rn:R01905','KEGG','RC00619',true).
concept_accession('287: rn:R01905','KEGG','RN:R01905',true).
concept_accession('287: rn:R01905','KEGG','RP01834',true).
concept_accession('287: rn:R01905','KEGG','EC:4.1.1.34',true).
concept_accession('287: rn:R01905','KEGG','4.1.1.34',true).
concept_accession('287: rn:R01905','KEGG','RP:RP01834',true).
concept_accession('9063: rn:R05487','KEGG','RP05085',true).
concept_accession('9063: rn:R05487','KEGG','RC:RC00046',true).
concept_accession('9063: rn:R05487','EC','1.14.13.-',false).
concept_accession('9063: rn:R05487','KEGG','RP:RP05085',true).
concept_accession('9063: rn:R05487','KEGG','R05487',true).
concept_accession('9063: rn:R05487','KEGG','1.14.13.-',true).
concept_accession('9063: rn:R05487','KEGG','RC00046',true).
concept_accession('9063: rn:R05487','KEGG','RN:R05487',true).
concept_accession('9063: rn:R05487','KEGG','EC:1.14.13.-',true).
concept_accession('9066: rn:R05450','KEGG','RC:RC00490',true).
concept_accession('9066: rn:R05450','KEGG','RP05060',true).
concept_accession('9066: rn:R05450','KEGG','RN:R05450',true).
concept_accession('9066: rn:R05450','KEGG','RP:RP05060',true).
concept_accession('9066: rn:R05450','EC','1.14.13.-',false).
concept_accession('9066: rn:R05450','KEGG','1.14.13.-',true).
concept_accession('9066: rn:R05450','KEGG','RC00490',true).
concept_accession('9066: rn:R05450','KEGG','EC:1.14.13.-',true).
concept_accession('9066: rn:R05450','KEGG','R05450',true).
concept_accession('9048: rn:R02540','KEGG','RC00010',true).
concept_accession('9048: rn:R02540','EC','3.5.1.4',false).
concept_accession('9048: rn:R02540','KEGG','RC:RC00010',true).
concept_accession('9048: rn:R02540','KEGG','RP02287',true).
concept_accession('9048: rn:R02540','KEGG','R02540',true).
concept_accession('9048: rn:R02540','KEGG','EC:3.5.1.4',true).
concept_accession('9048: rn:R02540','KEGG','RP:RP02287',true).
concept_accession('9048: rn:R02540','KEGG','3.5.1.4',true).
concept_accession('9048: rn:R02540','KEGG','RN:R02540',true).
concept_accession('12906: rn:R00446','KEGG','RP:RP00405',true).
concept_accession('12906: rn:R00446','KEGG','EC:1.4.1.18',true).
concept_accession('12906: rn:R00446','KEGG','R00446',true).
concept_accession('12906: rn:R00446','KEGG','RN:R00446',true).
concept_accession('12906: rn:R00446','KEGG','RC00062',true).
concept_accession('12906: rn:R00446','EC','1.4.1.18',false).
concept_accession('12906: rn:R00446','KEGG','RP00405',true).
concept_accession('12906: rn:R00446','KEGG','1.4.1.18',true).
concept_accession('12906: rn:R00446','KEGG','RC:RC00062',true).
concept_accession('12917: rn:R02317','KEGG','EC:1.4.1.18',true).
concept_accession('12917: rn:R02317','KEGG','RC00694',true).
concept_accession('12917: rn:R02317','KEGG','RP02122',true).
concept_accession('12917: rn:R02317','KEGG','RP:RP02122',true).
concept_accession('12917: rn:R02317','KEGG','RN:R02317',true).
concept_accession('12917: rn:R02317','EC','1.4.1.18',false).
concept_accession('12917: rn:R02317','KEGG','RC:RC00694',true).
concept_accession('12917: rn:R02317','KEGG','R02317',true).
concept_accession('12917: rn:R02317','KEGG','1.4.1.18',true).
concept_accession('293: rn:R01481','KEGG','1.1.1.19',true).
concept_accession('293: rn:R01481','KEGG','EC:1.1.1.19',true).
concept_accession('293: rn:R01481','EC','1.1.1.19',false).
concept_accession('293: rn:R01481','KEGG','RC00108',true).
concept_accession('293: rn:R01481','KEGG','R01481',true).
concept_accession('293: rn:R01481','KEGG','RP01544',true).
concept_accession('293: rn:R01481','KEGG','RN:R01481',true).
concept_accession('293: rn:R01481','KEGG','RC:RC00108',true).
concept_accession('293: rn:R01481','KEGG','RP:RP01544',true).
concept_accession('9007: rn:R01438','KEGG','RN:R01438',true).
concept_accession('9007: rn:R01438','KEGG','R01438',true).
concept_accession('8965: rn:R00740','KEGG','R00740',true).
concept_accession('8965: rn:R00740','KEGG','EC:1.2.1.18',true).
concept_accession('8965: rn:R00740','KEGG','RC00184',true).
concept_accession('8965: rn:R00740','KEGG','RN:R00740',true).
concept_accession('8965: rn:R00740','KEGG','RP01076',true).
concept_accession('8965: rn:R00740','EC','1.2.1.18',false).
concept_accession('8965: rn:R00740','KEGG','RC:RC00184',true).
concept_accession('8965: rn:R00740','KEGG','1.2.1.18',true).
concept_accession('8965: rn:R00740','KEGG','RP:RP01076',true).
concept_accession('12849: rn:R00462','KEGG','RC:RC00299',true).
concept_accession('12849: rn:R00462','KEGG','RN:R00462',true).
concept_accession('12849: rn:R00462','KEGG','RP00913',true).
concept_accession('12849: rn:R00462','KEGG','EC:4.1.1.18',true).
concept_accession('12849: rn:R00462','KEGG','4.1.1.18',true).
concept_accession('12849: rn:R00462','KEGG','RC00299',true).
concept_accession('12849: rn:R00462','KEGG','RP:RP00913',true).
concept_accession('12849: rn:R00462','EC','4.1.1.18',false).
concept_accession('12849: rn:R00462','KEGG','R00462',true).
concept_accession('4266: rn:R00829','KEGG','EC:2.3.1.16',true).
concept_accession('4266: rn:R00829','KEGG','RC:RC00326',true).
concept_accession('4266: rn:R00829','KEGG','RC00326',true).
concept_accession('4266: rn:R00829','EC','2.3.1.16',false).
concept_accession('4266: rn:R00829','KEGG','2.3.1.16',true).
concept_accession('4266: rn:R00829','KEGG','RP06330',true).
concept_accession('4266: rn:R00829','KEGG','RP:RP06330',true).
concept_accession('4266: rn:R00829','KEGG','RN:R00829',true).
concept_accession('4266: rn:R00829','KEGG','R00829',true).
concept_accession('9209: rn:R00932','KEGG','RC:RC00308',true).
concept_accession('9209: rn:R00932','KEGG','R00932',true).
concept_accession('9209: rn:R00932','KEGG','2.3.3.11',true).
concept_accession('9209: rn:R00932','KEGG','RP01182',true).
concept_accession('9209: rn:R00932','KEGG','RP:RP01182',true).
concept_accession('9209: rn:R00932','EC','2.3.3.11',false).
concept_accession('9209: rn:R00932','KEGG','RC00308',true).
concept_accession('9209: rn:R00932','KEGG','RN:R00932',true).
concept_accession('9209: rn:R00932','KEGG','EC:2.3.3.11',true).
concept_accession('4261: rn:R00829','KEGG','EC:2.3.1.16',true).
concept_accession('4261: rn:R00829','KEGG','RC:RC00326',true).
concept_accession('4261: rn:R00829','KEGG','RC00326',true).
concept_accession('4261: rn:R00829','EC','2.3.1.16',false).
concept_accession('4261: rn:R00829','KEGG','2.3.1.16',true).
concept_accession('4261: rn:R00829','KEGG','RP06330',true).
concept_accession('4261: rn:R00829','KEGG','RP:RP06330',true).
concept_accession('4261: rn:R00829','KEGG','RN:R00829',true).
concept_accession('4261: rn:R00829','KEGG','R00829',true).
concept_accession('392: rn:R00877','KEGG','RC:RC00376',true).
concept_accession('392: rn:R00877','EC','5.3.1.7',false).
concept_accession('392: rn:R00877','KEGG','5.3.1.7',true).
concept_accession('392: rn:R00877','KEGG','RP01153',true).
concept_accession('392: rn:R00877','KEGG','RP:RP01153',true).
concept_accession('392: rn:R00877','KEGG','R00877',true).
concept_accession('392: rn:R00877','KEGG','RC00376',true).
concept_accession('392: rn:R00877','KEGG','EC:5.3.1.7',true).
concept_accession('392: rn:R00877','KEGG','RN:R00877',true).
concept_accession('399: rn:R02730','EC','3.1.3.54',false).
concept_accession('399: rn:R02730','KEGG','EC:3.1.3.54',true).
concept_accession('399: rn:R02730','KEGG','RP02444',true).
concept_accession('399: rn:R02730','KEGG','R02730',true).
concept_accession('399: rn:R02730','KEGG','RC00017',true).
concept_accession('399: rn:R02730','KEGG','RP:RP02444',true).
concept_accession('399: rn:R02730','KEGG','RC:RC00017',true).
concept_accession('399: rn:R02730','KEGG','3.1.3.54',true).
concept_accession('399: rn:R02730','KEGG','RN:R02730',true).
concept_accession('390: rn:R00878','KEGG','RC:RC00376',true).
concept_accession('390: rn:R00878','KEGG','RP:RP01154',true).
concept_accession('390: rn:R00878','KEGG','RP01154',true).
concept_accession('390: rn:R00878','KEGG','R00878',true).
concept_accession('390: rn:R00878','EC','5.3.1.5',false).
concept_accession('390: rn:R00878','KEGG','EC:5.3.1.5',true).
concept_accession('390: rn:R00878','KEGG','5.3.1.5',true).
concept_accession('390: rn:R00878','KEGG','RC00376',true).
concept_accession('390: rn:R00878','KEGG','RN:R00878',true).
concept_accession('425: rn:R02071','EC','2.7.1.56',false).
concept_accession('425: rn:R02071','KEGG','EC:2.7.1.56',true).
concept_accession('425: rn:R02071','KEGG','RN:R02071',true).
concept_accession('425: rn:R02071','KEGG','RP01952',true).
concept_accession('425: rn:R02071','KEGG','RC00017',true).
concept_accession('425: rn:R02071','KEGG','2.7.1.56',true).
concept_accession('425: rn:R02071','KEGG','RP:RP01952',true).
concept_accession('425: rn:R02071','KEGG','RC:RC00017',true).
concept_accession('425: rn:R02071','KEGG','R02071',true).
concept_accession('428: rn:R01059','KEGG','RP:RP01265',true).
concept_accession('428: rn:R01059','EC','2.7.1.28',false).
concept_accession('428: rn:R01059','KEGG','RC00017',true).
concept_accession('428: rn:R01059','KEGG','R01059',true).
concept_accession('428: rn:R01059','KEGG','EC:2.7.1.28',true).
concept_accession('428: rn:R01059','KEGG','2.7.1.28',true).
concept_accession('428: rn:R01059','KEGG','RC:RC00017',true).
concept_accession('428: rn:R01059','KEGG','RN:R01059',true).
concept_accession('428: rn:R01059','KEGG','RP01265',true).
concept_accession('9123: rn:R00212','KEGG','RN:R00212',true).
concept_accession('9123: rn:R00212','KEGG','R00212',true).
concept_accession('9123: rn:R00212','EC','2.3.1.54',false).
concept_accession('9123: rn:R00212','KEGG','2.3.1.54',true).
concept_accession('9123: rn:R00212','KEGG','EC:2.3.1.54',true).
concept_accession('9122: rn:R01196','KEGG','R01196',true).
concept_accession('9122: rn:R01196','KEGG','RN:R01196',true).
concept_accession('9122: rn:R01196','KEGG','1.2.7.1',true).
concept_accession('9122: rn:R01196','EC','1.2.7.1',false).
concept_accession('9122: rn:R01196','KEGG','EC:1.2.7.1',true).
concept_accession('4290: rn:R00750','KEGG','RC:RC00307',true).
concept_accession('4290: rn:R00750','EC','4.1.3.39',false).
concept_accession('4290: rn:R00750','KEGG','RC00371',true).
concept_accession('4290: rn:R00750','KEGG','4.1.3.39',true).
concept_accession('4290: rn:R00750','KEGG','EC:4.1.3.39',true).
concept_accession('4290: rn:R00750','KEGG','RC:RC00371',true).
concept_accession('4290: rn:R00750','KEGG','RP:RP01084',true).
concept_accession('4290: rn:R00750','KEGG','RC00307',true).
concept_accession('4290: rn:R00750','KEGG','RP:RP01083',true).
concept_accession('4290: rn:R00750','KEGG','R00750',true).
concept_accession('4290: rn:R00750','KEGG','RN:R00750',true).
concept_accession('4290: rn:R00750','KEGG','RP01084',true).
concept_accession('4290: rn:R00750','KEGG','RP01083',true).
concept_accession('4310: rn:R00228','KEGG','RP:RP04321',true).
concept_accession('4310: rn:R00228','KEGG','RP04321',true).
concept_accession('4310: rn:R00228','KEGG','R00228',true).
concept_accession('4310: rn:R00228','KEGG','RN:R00228',true).
concept_accession('4310: rn:R00228','KEGG','EC:1.2.1.10',true).
concept_accession('4310: rn:R00228','KEGG','RC:RC01195',true).
concept_accession('4310: rn:R00228','KEGG','RC01195',true).
concept_accession('4310: rn:R00228','EC','1.2.1.10',false).
concept_accession('4310: rn:R00228','KEGG','1.2.1.10',true).
concept_accession('550: rn:R02411','KEGG','RC:RC00059',true).
concept_accession('550: rn:R02411','EC','2.4.1.82',false).
concept_accession('550: rn:R02411','KEGG','RP00235',true).
concept_accession('550: rn:R02411','KEGG','R02411',true).
concept_accession('550: rn:R02411','KEGG','RP:RP00235',true).
concept_accession('550: rn:R02411','KEGG','EC:2.4.1.82',true).
concept_accession('550: rn:R02411','KEGG','2.4.1.82',true).
concept_accession('550: rn:R02411','KEGG','RC00059',true).
concept_accession('550: rn:R02411','KEGG','RN:R02411',true).
concept_accession('556: rn:R01192','KEGG','EC:2.4.1.123',true).
concept_accession('556: rn:R01192','KEGG','R01192',true).
concept_accession('556: rn:R01192','KEGG','2.4.1.123',true).
concept_accession('556: rn:R01192','KEGG','RN:R01192',true).
concept_accession('556: rn:R01192','EC','2.4.1.123',false).
concept_accession('4867: rn:R01166','KEGG','RP00505',true).
concept_accession('4867: rn:R01166','KEGG','RC:RC00090',true).
concept_accession('4867: rn:R01166','EC','3.4.13.3',false).
concept_accession('4867: rn:R01166','KEGG','RP00508',true).
concept_accession('4867: rn:R01166','KEGG','RP:RP00508',true).
concept_accession('4867: rn:R01166','KEGG','RP:RP00505',true).
concept_accession('4867: rn:R01166','KEGG','3.4.13.3',true).
concept_accession('4867: rn:R01166','KEGG','EC:3.4.13.3',true).
concept_accession('4867: rn:R01166','KEGG','R01166',true).
concept_accession('4867: rn:R01166','KEGG','RC00064',true).
concept_accession('4867: rn:R01166','KEGG','RC00090',true).
concept_accession('4867: rn:R01166','KEGG','RC:RC00064',true).
concept_accession('4867: rn:R01166','KEGG','RN:R01166',true).
concept_accession('4865: rn:R01164','KEGG','RP00505',true).
concept_accession('4865: rn:R01164','KEGG','EC:6.3.2.11',true).
concept_accession('4865: rn:R01164','KEGG','RP:RP00505',true).
concept_accession('4865: rn:R01164','KEGG','R01164',true).
concept_accession('4865: rn:R01164','KEGG','6.3.2.11',true).
concept_accession('4865: rn:R01164','KEGG','RC:RC00090',true).
concept_accession('4865: rn:R01164','KEGG','RC00090',true).
concept_accession('4865: rn:R01164','EC','6.3.2.11',false).
concept_accession('4865: rn:R01164','KEGG','RN:R01164',true).
concept_accession('8295: rn:R09158','KEGG','RN:R09158',true).
concept_accession('8295: rn:R09158','KEGG','R09158',true).
concept_accession('524: rn:R03635','KEGG','RC:RC00077',true).
concept_accession('524: rn:R03635','KEGG','RP:RP03249',true).
concept_accession('524: rn:R03635','EC','3.2.1.26',false).
concept_accession('524: rn:R03635','KEGG','R03635',true).
concept_accession('524: rn:R03635','KEGG','EC:3.2.1.26',true).
concept_accession('524: rn:R03635','KEGG','RC00077',true).
concept_accession('524: rn:R03635','KEGG','RN:R03635',true).
concept_accession('524: rn:R03635','KEGG','3.2.1.26',true).
concept_accession('524: rn:R03635','KEGG','RP03249',true).
concept_accession('4926: rn:R05652','KEGG','RP00021',true).
concept_accession('4926: rn:R05652','KEGG','RP:RP00163',true).
concept_accession('4926: rn:R05652','KEGG','RP:RP00021',true).
concept_accession('4926: rn:R05652','KEGG','RC:RC00008',true).
concept_accession('4926: rn:R05652','KEGG','2.6.1.77',true).
concept_accession('4926: rn:R05652','KEGG','EC:2.6.1.77',true).
concept_accession('4926: rn:R05652','EC','2.6.1.77',false).
concept_accession('4926: rn:R05652','KEGG','RC00062',true).
concept_accession('4926: rn:R05652','KEGG','RC00008',true).
concept_accession('4926: rn:R05652','KEGG','RP00163',true).
concept_accession('4926: rn:R05652','KEGG','R05652',true).
concept_accession('4926: rn:R05652','KEGG','RN:R05652',true).
concept_accession('4926: rn:R05652','KEGG','RC:RC00062',true).
concept_accession('520: rn:R01069','KEGG','R01069',true).
concept_accession('520: rn:R01069','KEGG','RP01273',true).
concept_accession('520: rn:R01069','KEGG','RP01272',true).
concept_accession('520: rn:R01069','KEGG','RC:RC00438',true).
concept_accession('520: rn:R01069','KEGG','RC:RC00439',true).
concept_accession('520: rn:R01069','KEGG','4.1.2.40',true).
concept_accession('520: rn:R01069','KEGG','RN:R01069',true).
concept_accession('520: rn:R01069','KEGG','RP:RP01273',true).
concept_accession('520: rn:R01069','KEGG','RC00438',true).
concept_accession('520: rn:R01069','KEGG','RP:RP01272',true).
concept_accession('520: rn:R01069','KEGG','RC00439',true).
concept_accession('520: rn:R01069','EC','4.1.2.40',false).
concept_accession('520: rn:R01069','KEGG','EC:4.1.2.40',true).
concept_accession('4921: rn:R00230','KEGG','R00230',true).
concept_accession('4921: rn:R00230','KEGG','2.3.1.8',true).
concept_accession('4921: rn:R00230','KEGG','RN:R00230',true).
concept_accession('4921: rn:R00230','EC','2.3.1.8',false).
concept_accession('4921: rn:R00230','KEGG','EC:2.3.1.8',true).
concept_accession('4923: rn:R05651','EC','2.3.3.15',false).
concept_accession('4923: rn:R05651','KEGG','RN:R05651',true).
concept_accession('4923: rn:R05651','KEGG','EC:2.3.3.15',true).
concept_accession('4923: rn:R05651','KEGG','R05651',true).
concept_accession('4923: rn:R05651','KEGG','2.3.3.15',true).
concept_accession('12614: rn:R02383','KEGG','RC:RC00046',true).
concept_accession('12614: rn:R02383','KEGG','RP02171',true).
concept_accession('12614: rn:R02383','KEGG','R02383',true).
concept_accession('12614: rn:R02383','KEGG','EC:1.14.18.1',true).
concept_accession('12614: rn:R02383','KEGG','RC00046',true).
concept_accession('12614: rn:R02383','KEGG','RP:RP02171',true).
concept_accession('12614: rn:R02383','KEGG','RN:R02383',true).
concept_accession('12614: rn:R02383','EC','1.14.18.1',false).
concept_accession('12614: rn:R02383','KEGG','1.14.18.1',true).
concept_accession('528: rn:R02410','KEGG','RC:RC00077',true).
concept_accession('528: rn:R02410','KEGG','RN:R02410',true).
concept_accession('528: rn:R02410','EC','3.2.1.26',false).
concept_accession('528: rn:R02410','KEGG','EC:3.2.1.26',true).
concept_accession('528: rn:R02410','KEGG','RC00077',true).
concept_accession('528: rn:R02410','KEGG','R02410',true).
concept_accession('528: rn:R02410','KEGG','RP02188',true).
concept_accession('528: rn:R02410','KEGG','3.2.1.26',true).
concept_accession('528: rn:R02410','KEGG','RP:RP02188',true).
concept_accession('4908: rn:R09077','KEGG','RC00225',true).
concept_accession('4908: rn:R09077','EC','1.5.3.17',false).
concept_accession('4908: rn:R09077','KEGG','EC:1.5.3.17',true).
concept_accession('4908: rn:R09077','KEGG','R09077',true).
concept_accession('4908: rn:R09077','KEGG','1.5.3.17',true).
concept_accession('4908: rn:R09077','KEGG','RN:R09077',true).
concept_accession('4908: rn:R09077','KEGG','RC:RC00225',true).
concept_accession('4908: rn:R09077','KEGG','RP14323',true).
concept_accession('4908: rn:R09077','KEGG','RP:RP14323',true).
concept_accession('4911: rn:R05320','KEGG','R05320',true).
concept_accession('4911: rn:R05320','EC','1.14.11.17',false).
concept_accession('4911: rn:R05320','KEGG','1.14.11.17',true).
concept_accession('4911: rn:R05320','KEGG','RC:RC01331',true).
concept_accession('4911: rn:R05320','KEGG','RC01331',true).
concept_accession('4911: rn:R05320','KEGG','RP:RP04923',true).
concept_accession('4911: rn:R05320','KEGG','EC:1.14.11.17',true).
concept_accession('4911: rn:R05320','KEGG','RN:R05320',true).
concept_accession('4911: rn:R05320','KEGG','RP04923',true).
concept_accession('4907: rn:R09076','KEGG','R09076',true).
concept_accession('4907: rn:R09076','KEGG','EC:1.5.3.17',true).
concept_accession('4907: rn:R09076','KEGG','RC00053',true).
concept_accession('4907: rn:R09076','KEGG','1.5.3.17',true).
concept_accession('4907: rn:R09076','KEGG','RN:R09076',true).
concept_accession('4907: rn:R09076','KEGG','RP:RP14322',true).
concept_accession('4907: rn:R09076','KEGG','RP14322',true).
concept_accession('4907: rn:R09076','KEGG','RC00225',true).
concept_accession('4907: rn:R09076','KEGG','RP:RP02564',true).
concept_accession('4907: rn:R09076','EC','1.5.3.17',false).
concept_accession('4907: rn:R09076','KEGG','RC:RC00225',true).
concept_accession('4907: rn:R09076','KEGG','RC:RC00053',true).
concept_accession('4907: rn:R09076','KEGG','RP02564',true).
concept_accession('4958: rn:R02434','KEGG','RC00580',true).
concept_accession('4958: rn:R02434','KEGG','R02434',true).
concept_accession('4958: rn:R02434','KEGG','RP:RP02211',true).
concept_accession('4958: rn:R02434','KEGG','RP02211',true).
concept_accession('4958: rn:R02434','KEGG','RN:R02434',true).
concept_accession('4958: rn:R02434','KEGG','RC:RC00580',true).
concept_accession('4935: rn:R00901','KEGG','4.4.1.10',true).
concept_accession('4935: rn:R00901','KEGG','RN:R00901',true).
concept_accession('4935: rn:R00901','KEGG','R00901',true).
concept_accession('4935: rn:R00901','EC','4.4.1.10',false).
concept_accession('4935: rn:R00901','KEGG','EC:4.4.1.10',true).
concept_accession('12580: rn:R04305','KEGG','RC:RC01071',true).
concept_accession('12580: rn:R04305','KEGG','RC:RC01072',true).
concept_accession('12580: rn:R04305','KEGG','RP03939',true).
concept_accession('12580: rn:R04305','KEGG','RP03938',true).
concept_accession('12580: rn:R04305','KEGG','RP:RP03938',true).
concept_accession('12580: rn:R04305','KEGG','RP:RP03939',true).
concept_accession('12580: rn:R04305','KEGG','RN:R04305',true).
concept_accession('12580: rn:R04305','KEGG','EC:4.2.1.78',true).
concept_accession('12580: rn:R04305','KEGG','RC01071',true).
concept_accession('12580: rn:R04305','KEGG','RC01072',true).
concept_accession('12580: rn:R04305','EC','4.2.1.78',false).
concept_accession('12580: rn:R04305','KEGG','R04305',true).
concept_accession('12580: rn:R04305','KEGG','4.2.1.78',true).
concept_accession('4936: rn:R01681','KEGG','RC00580',true).
concept_accession('4936: rn:R01681','KEGG','RN:R01681',true).
concept_accession('4936: rn:R01681','KEGG','R01681',true).
concept_accession('4936: rn:R01681','KEGG','EC:1.8.1.3',true).
concept_accession('4936: rn:R01681','KEGG','1.8.1.3',true).
concept_accession('4936: rn:R01681','KEGG','RP01686',true).
concept_accession('4936: rn:R01681','EC','1.8.1.3',false).
concept_accession('4936: rn:R01681','KEGG','RP:RP01686',true).
concept_accession('4936: rn:R01681','KEGG','RC:RC00580',true).
concept_accession('39679: rn:R03657','KEGG','6.1.1.4',true).
concept_accession('39679: rn:R03657','KEGG','363172',true).
concept_accession('39679: rn:R03657','KEGG','291624',true).
concept_accession('39679: rn:R03657','KEGG','RNO:363172',true).
concept_accession('39679: rn:R03657','KEGG','RNO:291624',true).
concept_accession('39679: rn:R03657','KEGG','EC:6.1.1.4',true).
concept_accession('39679: rn:R03657','EC','6.1.1.4',true).
concept_accession('39678: rn:R01090','KEGG','64203',true).
concept_accession('39678: rn:R01090','KEGG','RNO:64203',true).
concept_accession('39678: rn:R01090','KEGG','EC:2.6.1.42',true).
concept_accession('39678: rn:R01090','KEGG','RNO:29592',true).
concept_accession('39678: rn:R01090','KEGG','29592',true).
concept_accession('39678: rn:R01090','KEGG','2.6.1.42',true).
concept_accession('39678: rn:R01090','EC','2.6.1.42',true).
concept_accession('39677: rn:R02199','KEGG','64203',true).
concept_accession('39677: rn:R02199','KEGG','RNO:64203',true).
concept_accession('39677: rn:R02199','KEGG','EC:2.6.1.42',true).
concept_accession('39677: rn:R02199','KEGG','RNO:29592',true).
concept_accession('39677: rn:R02199','KEGG','29592',true).
concept_accession('39677: rn:R02199','KEGG','2.6.1.42',true).
concept_accession('39677: rn:R02199','EC','2.6.1.42',true).
concept_accession('39676: rn:R00533','KEGG','81805',true).
concept_accession('39676: rn:R00533','KEGG','RNO:81805',true).
concept_accession('39676: rn:R00533','EC','1.8.3.1',true).
concept_accession('39676: rn:R00533','KEGG','1.8.3.1',true).
concept_accession('39676: rn:R00533','KEGG','EC:1.8.3.1',true).
concept_accession('682: rn:R01483','EC','3.1.1.19',false).
concept_accession('682: rn:R01483','KEGG','RC00531',true).
concept_accession('682: rn:R01483','KEGG','R01483',true).
concept_accession('682: rn:R01483','KEGG','EC:3.1.1.19',true).
concept_accession('682: rn:R01483','KEGG','3.1.1.19',true).
concept_accession('682: rn:R01483','KEGG','RP01546',true).
concept_accession('682: rn:R01483','KEGG','RC:RC00531',true).
concept_accession('682: rn:R01483','KEGG','RP:RP01546',true).
concept_accession('682: rn:R01483','KEGG','RN:R01483',true).
concept_accession('653: rn:R03183','KEGG','1.1.1.20',true).
concept_accession('653: rn:R03183','KEGG','RC00099',true).
concept_accession('653: rn:R03183','KEGG','RN:R03183',true).
concept_accession('653: rn:R03183','KEGG','EC:1.1.1.20',true).
concept_accession('653: rn:R03183','KEGG','RP:RP02822',true).
concept_accession('653: rn:R03183','KEGG','R03183',true).
concept_accession('653: rn:R03183','EC','1.1.1.20',false).
concept_accession('653: rn:R03183','KEGG','RP02822',true).
concept_accession('653: rn:R03183','KEGG','RC:RC00099',true).
concept_accession('654: rn:R01481','KEGG','1.1.1.19',true).
concept_accession('654: rn:R01481','KEGG','EC:1.1.1.19',true).
concept_accession('654: rn:R01481','EC','1.1.1.19',false).
concept_accession('654: rn:R01481','KEGG','RC00108',true).
concept_accession('654: rn:R01481','KEGG','R01481',true).
concept_accession('654: rn:R01481','KEGG','RP01544',true).
concept_accession('654: rn:R01481','KEGG','RN:R01481',true).
concept_accession('654: rn:R01481','KEGG','RC:RC00108',true).
concept_accession('654: rn:R01481','KEGG','RP:RP01544',true).
concept_accession('662: rn:R02754','KEGG','RC:RC00307',true).
concept_accession('662: rn:R02754','KEGG','R02754',true).
concept_accession('662: rn:R02754','KEGG','RC:RC00435',true).
concept_accession('662: rn:R02754','KEGG','RN:R02754',true).
concept_accession('662: rn:R02754','KEGG','RP:RP02472',true).
concept_accession('662: rn:R02754','KEGG','RP:RP02473',true).
concept_accession('662: rn:R02754','KEGG','RC00307',true).
concept_accession('662: rn:R02754','EC','4.1.2.20',false).
concept_accession('662: rn:R02754','KEGG','RC00435',true).
concept_accession('662: rn:R02754','KEGG','EC:4.1.2.20',true).
concept_accession('662: rn:R02754','KEGG','4.1.2.20',true).
concept_accession('662: rn:R02754','KEGG','RP02472',true).
concept_accession('662: rn:R02754','KEGG','RP02473',true).
concept_accession('657: rn:R03277','KEGG','RC:RC00307',true).
concept_accession('657: rn:R03277','KEGG','RC:RC00435',true).
concept_accession('657: rn:R03277','KEGG','RN:R03277',true).
concept_accession('657: rn:R03277','KEGG','RC00307',true).
concept_accession('657: rn:R03277','KEGG','RP02907',true).
concept_accession('657: rn:R03277','KEGG','RP02906',true).
concept_accession('657: rn:R03277','EC','4.1.2.20',false).
concept_accession('657: rn:R03277','KEGG','RP:RP02906',true).
concept_accession('657: rn:R03277','KEGG','RC00435',true).
concept_accession('657: rn:R03277','KEGG','RP:RP02907',true).
concept_accession('657: rn:R03277','KEGG','EC:4.1.2.20',true).
concept_accession('657: rn:R03277','KEGG','R03277',true).
concept_accession('657: rn:R03277','KEGG','4.1.2.20',true).
concept_accession('5072: rn:R07229','KEGG','RN:R07229',true).
concept_accession('5072: rn:R07229','KEGG','R07229',true).
concept_accession('5072: rn:R07229','KEGG','RC02420',true).
concept_accession('5072: rn:R07229','KEGG','1.97.1.9',true).
concept_accession('5072: rn:R07229','KEGG','RP11594',true).
concept_accession('5072: rn:R07229','KEGG','RP:RP11594',true).
concept_accession('5072: rn:R07229','KEGG','RC:RC02420',true).
concept_accession('5072: rn:R07229','EC','1.97.1.9',false).
concept_accession('5072: rn:R07229','KEGG','EC:1.97.1.9',true).
concept_accession('12727: rn:R02383','KEGG','RC:RC00046',true).
concept_accession('12727: rn:R02383','KEGG','RP02171',true).
concept_accession('12727: rn:R02383','KEGG','R02383',true).
concept_accession('12727: rn:R02383','KEGG','EC:1.14.18.1',true).
concept_accession('12727: rn:R02383','KEGG','RC00046',true).
concept_accession('12727: rn:R02383','KEGG','RP:RP02171',true).
concept_accession('12727: rn:R02383','KEGG','RN:R02383',true).
concept_accession('12727: rn:R02383','EC','1.14.18.1',false).
concept_accession('12727: rn:R02383','KEGG','1.14.18.1',true).
concept_accession('5079: rn:R08223','KEGG','RN:R08223',true).
concept_accession('5079: rn:R08223','KEGG','2.7.1.164',true).
concept_accession('5079: rn:R08223','KEGG','RP:RP13086',true).
concept_accession('5079: rn:R08223','KEGG','RC00017',true).
concept_accession('5079: rn:R08223','KEGG','R08223',true).
concept_accession('5079: rn:R08223','KEGG','RP13086',true).
concept_accession('5079: rn:R08223','KEGG','RC:RC00017',true).
concept_accession('5079: rn:R08223','EC','2.7.1.164',false).
concept_accession('5079: rn:R08223','KEGG','EC:2.7.1.164',true).
concept_accession('755: rn:R03370','KEGG','R03370',true).
concept_accession('755: rn:R03370','KEGG','RC00917',true).
concept_accession('755: rn:R03370','KEGG','EC:1.14.19.2',true).
concept_accession('755: rn:R03370','KEGG','RP:RP02989',true).
concept_accession('755: rn:R03370','KEGG','1.14.19.2',true).
concept_accession('755: rn:R03370','KEGG','RC:RC00917',true).
concept_accession('755: rn:R03370','EC','1.14.19.2',false).
concept_accession('755: rn:R03370','KEGG','RP02989',true).
concept_accession('755: rn:R03370','KEGG','RN:R03370',true).
concept_accession('8337: rn:R06973','KEGG','RN:R06973',true).
concept_accession('8337: rn:R06973','KEGG','RP:RP10307',true).
concept_accession('8337: rn:R06973','KEGG','R06973',true).
concept_accession('8337: rn:R06973','KEGG','RC:RC01775',true).
concept_accession('8337: rn:R06973','EC','4.1.1.-',false).
concept_accession('8337: rn:R06973','KEGG','4.1.1.-',true).
concept_accession('8337: rn:R06973','KEGG','RC01775',true).
concept_accession('8337: rn:R06973','KEGG','EC:4.1.1.-',true).
concept_accession('8337: rn:R06973','KEGG','RP10307',true).
concept_accession('12699: rn:R03341','KEGG','4.1.1.80',true).
concept_accession('12699: rn:R03341','KEGG','R03341',true).
concept_accession('12699: rn:R03341','KEGG','EC:4.1.1.80',true).
concept_accession('12699: rn:R03341','KEGG','RP:RP02956',true).
concept_accession('12699: rn:R03341','KEGG','RC:RC00506',true).
concept_accession('12699: rn:R03341','KEGG','RN:R03341',true).
concept_accession('12699: rn:R03341','KEGG','RP02956',true).
concept_accession('12699: rn:R03341','EC','4.1.1.80',false).
concept_accession('12699: rn:R03341','KEGG','RC00506',true).
concept_accession('8367: rn:R09151','EC','1.14.12.11',false).
concept_accession('8367: rn:R09151','KEGG','R09151',true).
concept_accession('8367: rn:R09151','KEGG','RN:R09151',true).
concept_accession('8367: rn:R09151','KEGG','EC:1.14.12.11',true).
concept_accession('8367: rn:R09151','KEGG','1.14.12.11',true).
concept_accession('5097: rn:R04931','KEGG','RC01241',true).
concept_accession('5097: rn:R04931','KEGG','EC:2.1.1.-',true).
concept_accession('5097: rn:R04931','KEGG','2.1.1.-',true).
concept_accession('5097: rn:R04931','KEGG','R04931',true).
concept_accession('5097: rn:R04931','KEGG','RC:RC01241',true).
concept_accession('5097: rn:R04931','KEGG','RN:R04931',true).
concept_accession('5097: rn:R04931','KEGG','RP:RP04537',true).
concept_accession('5097: rn:R04931','EC','2.1.1.-',false).
concept_accession('5097: rn:R04931','KEGG','RP04537',true).
concept_accession('5101: rn:R09371','KEGG','EC:2.1.1.-',true).
concept_accession('5101: rn:R09371','KEGG','2.1.1.-',true).
concept_accession('5101: rn:R09371','KEGG','RN:R09371',true).
concept_accession('5101: rn:R09371','KEGG','R09371',true).
concept_accession('5101: rn:R09371','EC','2.1.1.-',false).
concept_accession('8368: rn:R09152','EC','1.14.12.11',false).
concept_accession('8368: rn:R09152','KEGG','R09152',true).
concept_accession('8368: rn:R09152','KEGG','RN:R09152',true).
concept_accession('8368: rn:R09152','KEGG','EC:1.14.12.11',true).
concept_accession('8368: rn:R09152','KEGG','1.14.12.11',true).
concept_accession('5094: rn:R08219','KEGG','EC:2.9.1.1',true).
concept_accession('5094: rn:R08219','KEGG','R08219',true).
concept_accession('5094: rn:R08219','KEGG','RP:RP13084',true).
concept_accession('5094: rn:R08219','KEGG','RP13084',true).
concept_accession('5094: rn:R08219','KEGG','RN:R08219',true).
concept_accession('5094: rn:R08219','EC','2.9.1.1',false).
concept_accession('5094: rn:R08219','KEGG','RC:RC01246',true).
concept_accession('5094: rn:R08219','KEGG','RC01246',true).
concept_accession('5094: rn:R08219','KEGG','2.9.1.1',true).
concept_accession('39814: rn:R00238','KEGG','2.3.1.9',true).
concept_accession('39814: rn:R00238','KEGG','EC:2.3.1.9',true).
concept_accession('39814: rn:R00238','EC','2.3.1.9',true).
concept_accession('39814: rn:R00238','KEGG','RNO:308100',true).
concept_accession('39814: rn:R00238','KEGG','RNO:25014',true).
concept_accession('39814: rn:R00238','KEGG','25014',true).
concept_accession('39814: rn:R00238','KEGG','308100',true).
concept_accession('39815: rn:R00782','KEGG','EC:4.4.1.1',true).
concept_accession('39815: rn:R00782','EC','4.4.1.1',true).
concept_accession('39815: rn:R00782','KEGG','24962',true).
concept_accession('39815: rn:R00782','KEGG','RNO:24962',true).
concept_accession('39815: rn:R00782','KEGG','4.4.1.1',true).
concept_accession('39812: rn:R02082','KEGG','25675',true).
concept_accession('39812: rn:R02082','EC','1.1.1.34',true).
concept_accession('39812: rn:R02082','KEGG','EC:1.1.1.34',true).
concept_accession('39812: rn:R02082','KEGG','1.1.1.34',true).
concept_accession('39812: rn:R02082','KEGG','RNO:25675',true).
concept_accession('39813: rn:R01978','KEGG','EC:2.3.3.10',true).
concept_accession('39813: rn:R01978','KEGG','RNO:29637',true).
concept_accession('39813: rn:R01978','KEGG','RNO:24450',true).
concept_accession('39813: rn:R01978','KEGG','2.3.3.10',true).
concept_accession('39813: rn:R01978','KEGG','24450',true).
concept_accession('39813: rn:R01978','EC','2.3.3.10',true).
concept_accession('39813: rn:R01978','KEGG','29637',true).
concept_accession('39810: rn:R02408','KEGG','EC:4.4.1.8',true).
concept_accession('39810: rn:R02408','EC','4.4.1.8',true).
concept_accession('39810: rn:R02408','KEGG','4.4.1.8',true).
concept_accession('39810: rn:R02408','KEGG','24962',true).
concept_accession('39810: rn:R02408','KEGG','RNO:24962',true).
concept_accession('39811: rn:R00893','KEGG','EC:1.13.11.20',true).
concept_accession('39811: rn:R00893','KEGG','81718',true).
concept_accession('39811: rn:R00893','EC','1.13.11.20',true).
concept_accession('39811: rn:R00893','KEGG','RNO:81718',true).
concept_accession('39811: rn:R00893','KEGG','1.13.11.20',true).
concept_accession('39808: rn:R02433','KEGG','25721',true).
concept_accession('39808: rn:R02433','KEGG','RNO:25721',true).
concept_accession('39808: rn:R02433','KEGG','24401',true).
concept_accession('39808: rn:R02433','EC','2.6.1.1',true).
concept_accession('39808: rn:R02433','KEGG','RNO:24401',true).
concept_accession('39808: rn:R02433','KEGG','EC:2.6.1.1',true).
concept_accession('39808: rn:R02433','KEGG','2.6.1.1',true).
concept_accession('39809: rn:R01123','KEGG','EC:5.3.3.2',true).
concept_accession('39809: rn:R01123','KEGG','291266',true).
concept_accession('39809: rn:R01123','KEGG','RNO:89784',true).
concept_accession('39809: rn:R01123','KEGG','89784',true).
concept_accession('39809: rn:R01123','KEGG','5.3.3.2',true).
concept_accession('39809: rn:R01123','EC','5.3.3.2',true).
concept_accession('39809: rn:R01123','KEGG','RNO:291266',true).
concept_accession('39822: rn:R01072','KEGG','RNO:117544',true).
concept_accession('39822: rn:R01072','EC','2.4.2.14',true).
concept_accession('39822: rn:R01072','KEGG','EC:2.4.2.14',true).
concept_accession('39822: rn:R01072','KEGG','117544',true).
concept_accession('39822: rn:R01072','KEGG','2.4.2.14',true).
concept_accession('39823: rn:R01514','KEGG','684314',true).
concept_accession('39823: rn:R01514','KEGG','RNO:684314',true).
concept_accession('39823: rn:R01514','KEGG','EC:2.7.1.31',true).
concept_accession('39823: rn:R01514','KEGG','2.7.1.31',true).
concept_accession('39823: rn:R01514','EC','2.7.1.31',true).
concept_accession('39820: rn:R03104','KEGG','EC:1.1.1.27',true).
concept_accession('39820: rn:R03104','KEGG','RNO:369018',true).
concept_accession('39820: rn:R03104','EC','1.1.1.27',true).
concept_accession('39820: rn:R03104','KEGG','369018',true).
concept_accession('39820: rn:R03104','KEGG','RNO:24533',true).
concept_accession('39820: rn:R03104','KEGG','RNO:29634',true).
concept_accession('39820: rn:R03104','KEGG','RNO:24534',true).
concept_accession('39820: rn:R03104','KEGG','24534',true).
concept_accession('39820: rn:R03104','KEGG','24533',true).
concept_accession('39820: rn:R03104','KEGG','29634',true).
concept_accession('39820: rn:R03104','KEGG','RNO:500965',true).
concept_accession('39820: rn:R03104','KEGG','1.1.1.27',true).
concept_accession('39820: rn:R03104','KEGG','500965',true).
concept_accession('39821: rn:R03220','KEGG','304024',true).
concept_accession('39821: rn:R03220','KEGG','RNO:304024',true).
concept_accession('39821: rn:R03220','KEGG','1.3.3.3',true).
concept_accession('39821: rn:R03220','KEGG','EC:1.3.3.3',true).
concept_accession('39821: rn:R03220','EC','1.3.3.3',true).
concept_accession('39818: rn:R00896','KEGG','25721',true).
concept_accession('39818: rn:R00896','KEGG','RNO:25721',true).
concept_accession('39818: rn:R00896','KEGG','24401',true).
concept_accession('39818: rn:R00896','EC','2.6.1.1',true).
concept_accession('39818: rn:R00896','KEGG','RNO:24401',true).
concept_accession('39818: rn:R00896','KEGG','EC:2.6.1.1',true).
concept_accession('39818: rn:R00896','KEGG','2.6.1.1',true).
concept_accession('39819: rn:R03105','KEGG','192172',true).
concept_accession('39819: rn:R03105','EC','2.8.1.2',true).
concept_accession('39819: rn:R03105','KEGG','RNO:25274',true).
concept_accession('39819: rn:R03105','KEGG','RNO:192172',true).
concept_accession('39819: rn:R03105','KEGG','25274',true).
concept_accession('39819: rn:R03105','KEGG','2.8.1.2',true).
concept_accession('39819: rn:R03105','KEGG','EC:2.8.1.2',true).
concept_accession('39816: rn:R02245','KEGG','EC:2.7.1.36',true).
concept_accession('39816: rn:R02245','KEGG','81727',true).
concept_accession('39816: rn:R02245','EC','2.7.1.36',true).
concept_accession('39816: rn:R02245','KEGG','RNO:81727',true).
concept_accession('39816: rn:R02245','KEGG','2.7.1.36',true).
concept_accession('39817: rn:R02619','KEGG','25721',true).
concept_accession('39817: rn:R02619','KEGG','RNO:25721',true).
concept_accession('39817: rn:R02619','KEGG','24401',true).
concept_accession('39817: rn:R02619','EC','2.6.1.1',true).
concept_accession('39817: rn:R02619','KEGG','RNO:24401',true).
concept_accession('39817: rn:R02619','KEGG','EC:2.6.1.1',true).
concept_accession('39817: rn:R02619','KEGG','2.6.1.1',true).
concept_accession('39831: rn:R06171','EC','4.1.2.5',true).
concept_accession('39831: rn:R06171','KEGG','RNO:688286',true).
concept_accession('39831: rn:R06171','KEGG','688286',true).
concept_accession('39831: rn:R06171','KEGG','EC:4.1.2.5',true).
concept_accession('39831: rn:R06171','KEGG','4.1.2.5',true).
concept_accession('4628: rn:R01826','KEGG','2.5.1.54',true).
concept_accession('4628: rn:R01826','KEGG','RC00435',true).
concept_accession('4628: rn:R01826','KEGG','RN:R01826',true).
concept_accession('4628: rn:R01826','KEGG','RC:RC00435',true).
concept_accession('4628: rn:R01826','KEGG','R01826',true).
concept_accession('4628: rn:R01826','KEGG','RP01785',true).
concept_accession('4628: rn:R01826','KEGG','RP:RP01785',true).
concept_accession('4628: rn:R01826','EC','2.5.1.54',false).
concept_accession('4628: rn:R01826','KEGG','EC:2.5.1.54',true).
concept_accession('39830: rn:R00565','KEGG','81660',true).
concept_accession('39830: rn:R00565','EC','2.1.4.1',true).
concept_accession('39830: rn:R00565','KEGG','RNO:81660',true).
concept_accession('39830: rn:R00565','KEGG','EC:2.1.4.1',true).
concept_accession('39830: rn:R00565','KEGG','2.1.4.1',true).
concept_accession('39829: rn:R01290','KEGG','RNO:24250',true).
concept_accession('39829: rn:R01290','KEGG','24250',true).
concept_accession('39829: rn:R01290','EC','4.2.1.22',true).
concept_accession('39829: rn:R01290','KEGG','4.2.1.22',true).
concept_accession('39829: rn:R01290','KEGG','EC:4.2.1.22',true).
concept_accession('39828: rn:R01001','KEGG','EC:4.4.1.1',true).
concept_accession('39828: rn:R01001','EC','4.4.1.1',true).
concept_accession('39828: rn:R01001','KEGG','24962',true).
concept_accession('39828: rn:R01001','KEGG','RNO:24962',true).
concept_accession('39828: rn:R01001','KEGG','4.4.1.1',true).
concept_accession('39827: rn:R01565','KEGG','1.5.99.2',true).
concept_accession('39827: rn:R01565','KEGG','EC:1.5.99.2',true).
concept_accession('39827: rn:R01565','KEGG','RNO:245961',true).
concept_accession('39827: rn:R01565','KEGG','245961',true).
concept_accession('39827: rn:R01565','EC','1.5.99.2',true).
concept_accession('39826: rn:R00589','KEGG','303306',true).
concept_accession('39826: rn:R00589','KEGG','RNO:303306',true).
concept_accession('39826: rn:R00589','EC','5.1.1.10',true).
concept_accession('39826: rn:R00589','KEGG','EC:5.1.1.10',true).
concept_accession('39826: rn:R00589','KEGG','5.1.1.10',true).
concept_accession('39825: rn:R02565 rn:R02566','KEGG','EC:1.2.1.8',true).
concept_accession('39825: rn:R02565 rn:R02566','EC','1.2.1.8',true).
concept_accession('39825: rn:R02565 rn:R02566','KEGG','1.2.1.8',true).
concept_accession('39825: rn:R02565 rn:R02566','KEGG','RNO:291450',true).
concept_accession('39825: rn:R02565 rn:R02566','KEGG','291450',true).
concept_accession('39824: rn:R01025','KEGG','290551',true).
concept_accession('39824: rn:R01025','KEGG','RNO:290551',true).
concept_accession('39824: rn:R01025','KEGG','EC:1.1.99.1',true).
concept_accession('39824: rn:R01025','KEGG','1.1.99.1',true).
concept_accession('39824: rn:R01025','EC','1.1.99.1',true).
concept_accession('39839: rn:R00371','EC','2.3.1.29',true).
concept_accession('39839: rn:R00371','KEGG','366959',true).
concept_accession('39839: rn:R00371','KEGG','EC:2.3.1.29',true).
concept_accession('39839: rn:R00371','KEGG','RNO:366959',true).
concept_accession('39839: rn:R00371','KEGG','2.3.1.29',true).
concept_accession('39838: rn:R01465','KEGG','RNO:290315',true).
concept_accession('39838: rn:R01465','KEGG','1.1.1.103',true).
concept_accession('39838: rn:R01465','KEGG','EC:1.1.1.103',true).
concept_accession('39838: rn:R01465','KEGG','290315',true).
concept_accession('39838: rn:R01465','EC','1.1.1.103',true).
concept_accession('39837: rn:R00366','KEGG','RNO:114027',true).
concept_accession('39837: rn:R00366','KEGG','114027',true).
concept_accession('39837: rn:R00366','KEGG','EC:1.4.3.3',true).
concept_accession('39837: rn:R00366','EC','1.4.3.3',true).
concept_accession('39837: rn:R00366','KEGG','1.4.3.3',true).
concept_accession('39836: rn:R01883','EC','2.1.1.2',true).
concept_accession('39836: rn:R01883','KEGG','2.1.1.2',true).
concept_accession('39836: rn:R01883','KEGG','25257',true).
concept_accession('39836: rn:R01883','KEGG','RNO:25257',true).
concept_accession('39836: rn:R01883','KEGG','EC:2.1.1.2',true).
concept_accession('39835: rn:R01513','KEGG','1.1.1.95',true).
concept_accession('39835: rn:R01513','KEGG','RNO:58835',true).
concept_accession('39835: rn:R01513','KEGG','58835',true).
concept_accession('39835: rn:R01513','KEGG','EC:1.1.1.95',true).
concept_accession('39835: rn:R01513','EC','1.1.1.95',true).
concept_accession('39834: rn:R00585','KEGG','EC:2.6.1.51',true).
concept_accession('39834: rn:R00585','EC','2.6.1.51',true).
concept_accession('39834: rn:R00585','KEGG','2.6.1.51',true).
concept_accession('39834: rn:R00585','KEGG','RNO:24792',true).
concept_accession('39834: rn:R00585','KEGG','24792',true).
concept_accession('39833: rn:R00588','EC','2.6.1.45',true).
concept_accession('39833: rn:R00588','KEGG','EC:2.6.1.45',true).
concept_accession('39833: rn:R00588','KEGG','2.6.1.45',true).
concept_accession('39833: rn:R00588','KEGG','RNO:24792',true).
concept_accession('39833: rn:R00588','KEGG','24792',true).
concept_accession('39832: rn:R02821','KEGG','RNO:81508',true).
concept_accession('39832: rn:R02821','EC','2.1.1.5',true).
concept_accession('39832: rn:R02821','KEGG','2.1.1.5',true).
concept_accession('39832: rn:R02821','KEGG','EC:2.1.1.5',true).
concept_accession('39832: rn:R02821','KEGG','81508',true).
concept_accession('39844: rn:R00582','EC','3.1.3.3',true).
concept_accession('39844: rn:R00582','KEGG','3.1.3.3',true).
concept_accession('39844: rn:R00582','KEGG','RNO:304429',true).
concept_accession('39844: rn:R00582','KEGG','304429',true).
concept_accession('39844: rn:R00582','KEGG','EC:3.1.3.3',true).
concept_accession('39845: rn:R00945','KEGG','299857',true).
concept_accession('39845: rn:R00945','KEGG','287379',true).
concept_accession('39845: rn:R00945','KEGG','EC:2.1.2.1',true).
concept_accession('39845: rn:R00945','KEGG','RNO:287379',true).
concept_accession('39845: rn:R00945','KEGG','RNO:299857',true).
concept_accession('39845: rn:R00945','KEGG','2.1.2.1',true).
concept_accession('39845: rn:R00945','EC','2.1.2.1',true).
concept_accession('39846: rn:R00751','EC','4.1.2.5',true).
concept_accession('39846: rn:R00751','KEGG','RNO:688286',true).
concept_accession('39846: rn:R00751','KEGG','688286',true).
concept_accession('39846: rn:R00751','KEGG','EC:4.1.2.5',true).
concept_accession('39846: rn:R00751','KEGG','4.1.2.5',true).
concept_accession('39847: rn:R04979','EC','3.2.1.31',true).
concept_accession('39847: rn:R04979','KEGG','24434',true).
concept_accession('39847: rn:R04979','KEGG','EC:3.2.1.31',true).
concept_accession('39847: rn:R04979','KEGG','3.2.1.31',true).
concept_accession('39847: rn:R04979','KEGG','RNO:24434',true).
concept_accession('39840: rn:R00220','KEGG','EC:4.3.1.19',true).
concept_accession('39840: rn:R00220','KEGG','4.3.1.19',true).
concept_accession('39840: rn:R00220','KEGG','RNO:25044',true).
concept_accession('39840: rn:R00220','EC','4.3.1.19',true).
concept_accession('39840: rn:R00220','KEGG','25044',true).
concept_accession('39841: rn:R04173','KEGG','293820',true).
concept_accession('39841: rn:R04173','KEGG','EC:2.6.1.52',true).
concept_accession('39841: rn:R04173','EC','2.6.1.52',true).
concept_accession('39841: rn:R04173','KEGG','2.6.1.52',true).
concept_accession('39841: rn:R04173','KEGG','RNO:293820',true).
concept_accession('39842: rn:R00610','KEGG','303272',true).
concept_accession('39842: rn:R00610','KEGG','1.5.3.1',true).
concept_accession('39842: rn:R00610','KEGG','EC:1.5.3.1',true).
concept_accession('39842: rn:R00610','KEGG','RNO:303272',true).
concept_accession('39842: rn:R00610','EC','1.5.3.1',true).
concept_accession('39843: rn:R00611','KEGG','RNO:114123',true).
concept_accession('39843: rn:R00611','KEGG','114123',true).
concept_accession('39843: rn:R00611','EC','1.5.99.1',true).
concept_accession('39843: rn:R00611','KEGG','1.5.99.1',true).
concept_accession('39843: rn:R00611','KEGG','EC:1.5.99.1',true).
concept_accession('39852: rn:R02529','KEGG','29253',true).
concept_accession('39852: rn:R02529','KEGG','RNO:29253',true).
concept_accession('39852: rn:R02529','KEGG','25750',true).
concept_accession('39852: rn:R02529','KEGG','RNO:25750',true).
concept_accession('39852: rn:R02529','KEGG','EC:1.4.3.4',true).
concept_accession('39852: rn:R02529','EC','1.4.3.4',true).
concept_accession('39852: rn:R02529','KEGG','1.4.3.4',true).
concept_accession('39853: rn:R00830','KEGG','25748',true).
concept_accession('39853: rn:R00830','KEGG','EC:2.3.1.37',true).
concept_accession('39853: rn:R00830','KEGG','2.3.1.37',true).
concept_accession('39853: rn:R00830','KEGG','RNO:65155',true).
concept_accession('39853: rn:R00830','KEGG','65155',true).
concept_accession('39853: rn:R00830','KEGG','RNO:25748',true).
concept_accession('39853: rn:R00830','EC','2.3.1.37',true).
concept_accession('39854: rn:R03425','KEGG','1.4.4.2',true).
concept_accession('39854: rn:R03425','EC','1.4.4.2',true).
concept_accession('39854: rn:R03425','KEGG','RNO:309312',true).
concept_accession('39854: rn:R03425','KEGG','EC:1.4.4.2',true).
concept_accession('39854: rn:R03425','KEGG','309312',true).
concept_accession('4653: rn:R01073','KEGG','RP:RP01279',true).
concept_accession('4653: rn:R01073','KEGG','RC00440',true).
concept_accession('4653: rn:R01073','EC','2.4.2.18',false).
concept_accession('4653: rn:R01073','KEGG','2.4.2.18',true).
concept_accession('4653: rn:R01073','KEGG','RN:R01073',true).
concept_accession('4653: rn:R01073','KEGG','EC:2.4.2.18',true).
concept_accession('4653: rn:R01073','KEGG','R01073',true).
concept_accession('4653: rn:R01073','KEGG','RP01279',true).
concept_accession('4653: rn:R01073','KEGG','RC:RC00440',true).
concept_accession('39855: rn:R00367','KEGG','25134',true).
concept_accession('39855: rn:R00367','KEGG','RNO:25134',true).
concept_accession('39855: rn:R00367','KEGG','EC:2.1.1.20',true).
concept_accession('39855: rn:R00367','EC','2.1.1.20',true).
concept_accession('39855: rn:R00367','KEGG','2.1.1.20',true).
concept_accession('39848: rn:R03815','KEGG','298942',true).
concept_accession('39848: rn:R03815','KEGG','1.8.1.4',true).
concept_accession('39848: rn:R03815','KEGG','EC:1.8.1.4',true).
concept_accession('39848: rn:R03815','KEGG','RNO:298942',true).
concept_accession('39848: rn:R03815','EC','1.8.1.4',true).
concept_accession('39849: rn:R04125','KEGG','EC:2.1.2.10',true).
concept_accession('39849: rn:R04125','EC','2.1.2.10',true).
concept_accession('39849: rn:R04125','KEGG','2.1.2.10',true).
concept_accession('39849: rn:R04125','KEGG','RNO:306586',true).
concept_accession('39849: rn:R04125','KEGG','306586',true).
concept_accession('39850: rn:R02389','KEGG','396551',true).
concept_accession('39850: rn:R02389','KEGG','2.4.1.17',true).
concept_accession('39850: rn:R02389','KEGG','154516',true).
concept_accession('39850: rn:R02389','KEGG','396552',true).
concept_accession('39850: rn:R02389','KEGG','RNO:305264',true).
concept_accession('39850: rn:R02389','KEGG','289533',true).
concept_accession('39850: rn:R02389','KEGG','RNO:396527',true).
concept_accession('39850: rn:R02389','KEGG','574523',true).
concept_accession('39850: rn:R02389','KEGG','396527',true).
concept_accession('39850: rn:R02389','KEGG','EC:2.4.1.17',true).
concept_accession('39850: rn:R02389','KEGG','113992',true).
concept_accession('39850: rn:R02389','KEGG','RNO:574523',true).
concept_accession('39850: rn:R02389','KEGG','RNO:266685',true).
concept_accession('39850: rn:R02389','KEGG','RNO:24861',true).
concept_accession('39850: rn:R02389','KEGG','266685',true).
concept_accession('39850: rn:R02389','KEGG','RNO:24862',true).
concept_accession('39850: rn:R02389','KEGG','29623',true).
concept_accession('39850: rn:R02389','KEGG','RNO:289533',true).
concept_accession('39850: rn:R02389','KEGG','305264',true).
concept_accession('39850: rn:R02389','KEGG','RNO:83808',true).
concept_accession('39850: rn:R02389','KEGG','RNO:301595',true).
concept_accession('39850: rn:R02389','KEGG','RNO:29623',true).
concept_accession('39850: rn:R02389','KEGG','RNO:154516',true).
concept_accession('39850: rn:R02389','KEGG','301595',true).
concept_accession('39850: rn:R02389','KEGG','RNO:396552',true).
concept_accession('39850: rn:R02389','KEGG','RNO:396551',true).
concept_accession('39850: rn:R02389','KEGG','RNO:286954',true).
concept_accession('39850: rn:R02389','KEGG','RNO:113992',true).
concept_accession('39850: rn:R02389','KEGG','RNO:63867',true).
concept_accession('39850: rn:R02389','KEGG','286954',true).
concept_accession('39850: rn:R02389','KEGG','83808',true).
concept_accession('39850: rn:R02389','KEGG','24861',true).
concept_accession('39850: rn:R02389','KEGG','63867',true).
concept_accession('39850: rn:R02389','EC','2.4.1.17',true).
concept_accession('39850: rn:R02389','KEGG','24862',true).
concept_accession('39851: rn:R02529','KEGG','RNO:29473',true).
concept_accession('39851: rn:R02529','KEGG','29473',true).
concept_accession('39851: rn:R02529','KEGG','EC:1.4.3.4',true).
concept_accession('39851: rn:R02529','EC','1.4.3.4',true).
concept_accession('39851: rn:R02529','KEGG','1.4.3.4',true).
concept_accession('39861: rn:R03165','KEGG','309070',true).
concept_accession('39861: rn:R03165','EC','4.2.1.75',true).
concept_accession('39861: rn:R03165','KEGG','RNO:309070',true).
concept_accession('39861: rn:R03165','KEGG','EC:4.2.1.75',true).
concept_accession('39861: rn:R03165','KEGG','4.2.1.75',true).
concept_accession('39860: rn:R04972','KEGG','4.1.1.37',true).
concept_accession('39860: rn:R04972','EC','4.1.1.37',true).
concept_accession('39860: rn:R04972','KEGG','RNO:29421',true).
concept_accession('39860: rn:R04972','KEGG','29421',true).
concept_accession('39860: rn:R04972','KEGG','EC:4.1.1.37',true).
concept_accession('39863: rn:R03222','KEGG','RNO:289219',true).
concept_accession('39863: rn:R03222','KEGG','1.3.3.4',true).
concept_accession('39863: rn:R03222','KEGG','289219',true).
concept_accession('39863: rn:R03222','KEGG','EC:1.3.3.4',true).
concept_accession('39863: rn:R03222','EC','1.3.3.4',true).
concept_accession('39862: rn:R03197','KEGG','4.1.1.37',true).
concept_accession('39862: rn:R03197','EC','4.1.1.37',true).
concept_accession('39862: rn:R03197','KEGG','RNO:29421',true).
concept_accession('39862: rn:R03197','KEGG','29421',true).
concept_accession('39862: rn:R03197','KEGG','EC:4.1.1.37',true).
concept_accession('39857: rn:R00830','KEGG','25748',true).
concept_accession('39857: rn:R00830','KEGG','EC:2.3.1.37',true).
concept_accession('39857: rn:R00830','KEGG','2.3.1.37',true).
concept_accession('39857: rn:R00830','KEGG','RNO:65155',true).
concept_accession('39857: rn:R00830','KEGG','65155',true).
concept_accession('39857: rn:R00830','KEGG','RNO:25748',true).
concept_accession('39857: rn:R00830','EC','2.3.1.37',true).
concept_accession('39856: rn:R05578','KEGG','RNO:361641',true).
concept_accession('39856: rn:R05578','KEGG','6.1.1.24',true).
concept_accession('39856: rn:R05578','EC','6.1.1.24',true).
concept_accession('39856: rn:R05578','KEGG','289352',true).
concept_accession('39856: rn:R05578','KEGG','361641',true).
concept_accession('39856: rn:R05578','KEGG','RNO:289352',true).
concept_accession('39856: rn:R05578','KEGG','EC:6.1.1.24',true).
concept_accession('39859: rn:R00084','EC','2.5.1.61',true).
concept_accession('39859: rn:R00084','KEGG','EC:2.5.1.61',true).
concept_accession('39859: rn:R00084','KEGG','25709',true).
concept_accession('39859: rn:R00084','KEGG','2.5.1.61',true).
concept_accession('39859: rn:R00084','KEGG','RNO:25709',true).
concept_accession('39858: rn:R00036','EC','4.2.1.24',true).
concept_accession('39858: rn:R00036','KEGG','RNO:25374',true).
concept_accession('39858: rn:R00036','KEGG','4.2.1.24',true).
concept_accession('39858: rn:R00036','KEGG','EC:4.2.1.24',true).
concept_accession('39858: rn:R00036','KEGG','25374',true).
concept_accession('39869: rn:R08174','EC','3.1.2.-',true).
concept_accession('39869: rn:R08174','KEGG','RNO:503049',true).
concept_accession('39869: rn:R08174','KEGG','RNO:681337',true).
concept_accession('39869: rn:R08174','KEGG','RNO:26759',true).
concept_accession('39869: rn:R08174','KEGG','RNO:192272',true).
concept_accession('39869: rn:R08174','KEGG','RNO:50559',true).
concept_accession('39869: rn:R08174','KEGG','RNO:314304',true).
concept_accession('39869: rn:R08174','KEGG','50559',true).
concept_accession('39869: rn:R08174','KEGG','3.1.2.-',true).
concept_accession('39869: rn:R08174','KEGG','RNO:29725',true).
concept_accession('39869: rn:R08174','KEGG','503049',true).
concept_accession('39869: rn:R08174','KEGG','314304',true).
concept_accession('39869: rn:R08174','KEGG','192272',true).
concept_accession('39869: rn:R08174','KEGG','EC:3.1.2.-',true).
concept_accession('39869: rn:R08174','KEGG','26759',true).
concept_accession('39869: rn:R08174','KEGG','681337',true).
concept_accession('39869: rn:R08174','KEGG','29725',true).
concept_accession('39868: rn:R02391 rn:R02393','KEGG','RNO:116599',true).
concept_accession('39868: rn:R02391 rn:R02393','KEGG','292737',true).
concept_accession('39868: rn:R02391 rn:R02393','KEGG','1.3.1.24',true).
concept_accession('39868: rn:R02391 rn:R02393','EC','1.3.1.24',true).
concept_accession('39868: rn:R02391 rn:R02393','KEGG','RNO:292737',true).
concept_accession('39868: rn:R02391 rn:R02393','KEGG','116599',true).
concept_accession('39868: rn:R02391 rn:R02393','KEGG','EC:1.3.1.24',true).
concept_accession('39871: rn:R08179','KEGG','RNO:503049',true).
concept_accession('39871: rn:R08179','KEGG','RNO:681337',true).
concept_accession('39871: rn:R08179','KEGG','RNO:26759',true).
concept_accession('39871: rn:R08179','KEGG','RNO:192272',true).
concept_accession('39871: rn:R08179','KEGG','RNO:50559',true).
concept_accession('39871: rn:R08179','KEGG','RNO:314304',true).
concept_accession('39871: rn:R08179','EC','3.1.2.2',true).
concept_accession('39871: rn:R08179','KEGG','50559',true).
concept_accession('39871: rn:R08179','KEGG','503049',true).
concept_accession('39871: rn:R08179','KEGG','314304',true).
concept_accession('39871: rn:R08179','KEGG','192272',true).
concept_accession('39871: rn:R08179','KEGG','26759',true).
concept_accession('39871: rn:R08179','KEGG','681337',true).
concept_accession('39871: rn:R08179','KEGG','3.1.2.2',true).
concept_accession('39871: rn:R08179','KEGG','EC:3.1.2.2',true).
concept_accession('39870: rn:R01274','KEGG','EC:3.1.2.22',true).
concept_accession('39870: rn:R01274','KEGG','RNO:503049',true).
concept_accession('39870: rn:R01274','KEGG','RNO:681337',true).
concept_accession('39870: rn:R01274','KEGG','RNO:26759',true).
concept_accession('39870: rn:R01274','KEGG','3.1.2.22',true).
concept_accession('39870: rn:R01274','KEGG','RNO:192272',true).
concept_accession('39870: rn:R01274','KEGG','RNO:50559',true).
concept_accession('39870: rn:R01274','KEGG','RNO:314304',true).
concept_accession('39870: rn:R01274','KEGG','50559',true).
concept_accession('39870: rn:R01274','KEGG','RNO:29725',true).
concept_accession('39870: rn:R01274','KEGG','503049',true).
concept_accession('39870: rn:R01274','KEGG','314304',true).
concept_accession('39870: rn:R01274','KEGG','192272',true).
concept_accession('39870: rn:R01274','EC','3.1.2.22',true).
concept_accession('39870: rn:R01274','KEGG','26759',true).
concept_accession('39870: rn:R01274','KEGG','681337',true).
concept_accession('39870: rn:R01274','KEGG','29725',true).
concept_accession('39865: rn:R00078','KEGG','RNO:100360087',true).
concept_accession('39865: rn:R00078','KEGG','1.16.3.1',true).
concept_accession('39865: rn:R00078','KEGG','100360087',true).
concept_accession('39865: rn:R00078','KEGG','RNO:29292',true).
concept_accession('39865: rn:R00078','KEGG','RNO:291470',true).
concept_accession('39865: rn:R00078','KEGG','25319',true).
concept_accession('39865: rn:R00078','KEGG','EC:1.16.3.1',true).
concept_accession('39865: rn:R00078','KEGG','24268',true).
concept_accession('39865: rn:R00078','EC','1.16.3.1',true).
concept_accession('39865: rn:R00078','KEGG','291470',true).
concept_accession('39865: rn:R00078','KEGG','29292',true).
concept_accession('39865: rn:R00078','KEGG','RNO:25319',true).
concept_accession('39865: rn:R00078','KEGG','RNO:24268',true).
concept_accession('39864: rn:R00310','KEGG','RNO:361338',true).
concept_accession('39864: rn:R00310','KEGG','EC:4.99.1.1',true).
concept_accession('39864: rn:R00310','EC','4.99.1.1',true).
concept_accession('39864: rn:R00310','KEGG','4.99.1.1',true).
concept_accession('39864: rn:R00310','KEGG','361338',true).
concept_accession('39867: rn:R02480','KEGG','317444',true).
concept_accession('39867: rn:R02480','EC','4.4.1.17',true).
concept_accession('39867: rn:R02480','KEGG','EC:4.4.1.17',true).
concept_accession('39867: rn:R02480','KEGG','4.4.1.17',true).
concept_accession('39867: rn:R02480','KEGG','RNO:317444',true).
concept_accession('39866: rn:R07411','KEGG','687381',true).
concept_accession('39866: rn:R07411','KEGG','EC:2.5.1.-',true).
concept_accession('39866: rn:R07411','EC','2.5.1.-',true).
concept_accession('39866: rn:R07411','KEGG','RNO:687381',true).
concept_accession('39866: rn:R07411','KEGG','2.5.1.-',true).
concept_accession('39874: rn:R08182','KEGG','RNO:503049',true).
concept_accession('39874: rn:R08182','KEGG','RNO:681337',true).
concept_accession('39874: rn:R08182','KEGG','RNO:26759',true).
concept_accession('39874: rn:R08182','KEGG','RNO:192272',true).
concept_accession('39874: rn:R08182','KEGG','RNO:50559',true).
concept_accession('39874: rn:R08182','KEGG','RNO:314304',true).
concept_accession('39874: rn:R08182','EC','3.1.2.2',true).
concept_accession('39874: rn:R08182','KEGG','50559',true).
concept_accession('39874: rn:R08182','KEGG','503049',true).
concept_accession('39874: rn:R08182','KEGG','314304',true).
concept_accession('39874: rn:R08182','KEGG','192272',true).
concept_accession('39874: rn:R08182','KEGG','26759',true).
concept_accession('39874: rn:R08182','KEGG','681337',true).
concept_accession('39874: rn:R08182','KEGG','3.1.2.2',true).
concept_accession('39874: rn:R08182','KEGG','EC:3.1.2.2',true).
concept_accession('39875: rn:R08183','KEGG','RNO:503049',true).
concept_accession('39875: rn:R08183','KEGG','RNO:681337',true).
concept_accession('39875: rn:R08183','KEGG','RNO:26759',true).
concept_accession('39875: rn:R08183','KEGG','RNO:192272',true).
concept_accession('39875: rn:R08183','KEGG','RNO:50559',true).
concept_accession('39875: rn:R08183','KEGG','RNO:314304',true).
concept_accession('39875: rn:R08183','EC','3.1.2.2',true).
concept_accession('39875: rn:R08183','KEGG','50559',true).
concept_accession('39875: rn:R08183','KEGG','503049',true).
concept_accession('39875: rn:R08183','KEGG','314304',true).
concept_accession('39875: rn:R08183','KEGG','192272',true).
concept_accession('39875: rn:R08183','KEGG','26759',true).
concept_accession('39875: rn:R08183','KEGG','681337',true).
concept_accession('39875: rn:R08183','KEGG','3.1.2.2',true).
concept_accession('39875: rn:R08183','KEGG','EC:3.1.2.2',true).
concept_accession('39872: rn:R08180','KEGG','RNO:503049',true).
concept_accession('39872: rn:R08180','KEGG','RNO:681337',true).
concept_accession('39872: rn:R08180','KEGG','RNO:26759',true).
concept_accession('39872: rn:R08180','KEGG','RNO:192272',true).
concept_accession('39872: rn:R08180','KEGG','RNO:50559',true).
concept_accession('39872: rn:R08180','KEGG','RNO:314304',true).
concept_accession('39872: rn:R08180','EC','3.1.2.2',true).
concept_accession('39872: rn:R08180','KEGG','50559',true).
concept_accession('39872: rn:R08180','KEGG','503049',true).
concept_accession('39872: rn:R08180','KEGG','314304',true).
concept_accession('39872: rn:R08180','KEGG','192272',true).
concept_accession('39872: rn:R08180','KEGG','26759',true).
concept_accession('39872: rn:R08180','KEGG','681337',true).
concept_accession('39872: rn:R08180','KEGG','3.1.2.2',true).
concept_accession('39872: rn:R08180','KEGG','EC:3.1.2.2',true).
concept_accession('39873: rn:R08181','KEGG','RNO:503049',true).
concept_accession('39873: rn:R08181','KEGG','RNO:681337',true).
concept_accession('39873: rn:R08181','KEGG','RNO:26759',true).
concept_accession('39873: rn:R08181','KEGG','RNO:192272',true).
concept_accession('39873: rn:R08181','KEGG','RNO:50559',true).
concept_accession('39873: rn:R08181','KEGG','RNO:314304',true).
concept_accession('39873: rn:R08181','EC','3.1.2.2',true).
concept_accession('39873: rn:R08181','KEGG','50559',true).
concept_accession('39873: rn:R08181','KEGG','503049',true).
concept_accession('39873: rn:R08181','KEGG','314304',true).
concept_accession('39873: rn:R08181','KEGG','192272',true).
concept_accession('39873: rn:R08181','KEGG','26759',true).
concept_accession('39873: rn:R08181','KEGG','681337',true).
concept_accession('39873: rn:R08181','KEGG','3.1.2.2',true).
concept_accession('39873: rn:R08181','KEGG','EC:3.1.2.2',true).
concept_accession('39878: rn:R08175','KEGG','RNO:503049',true).
concept_accession('39878: rn:R08175','KEGG','RNO:681337',true).
concept_accession('39878: rn:R08175','KEGG','RNO:26759',true).
concept_accession('39878: rn:R08175','KEGG','RNO:192272',true).
concept_accession('39878: rn:R08175','KEGG','RNO:50559',true).
concept_accession('39878: rn:R08175','KEGG','RNO:314304',true).
concept_accession('39878: rn:R08175','EC','3.1.2.2',true).
concept_accession('39878: rn:R08175','KEGG','50559',true).
concept_accession('39878: rn:R08175','KEGG','RNO:29725',true).
concept_accession('39878: rn:R08175','KEGG','503049',true).
concept_accession('39878: rn:R08175','KEGG','314304',true).
concept_accession('39878: rn:R08175','KEGG','192272',true).
concept_accession('39878: rn:R08175','KEGG','26759',true).
concept_accession('39878: rn:R08175','KEGG','681337',true).
concept_accession('39878: rn:R08175','KEGG','3.1.2.2',true).
concept_accession('39878: rn:R08175','KEGG','29725',true).
concept_accession('39878: rn:R08175','KEGG','EC:3.1.2.2',true).
concept_accession('39879: rn:R08178','KEGG','RNO:503049',true).
concept_accession('39879: rn:R08178','KEGG','RNO:681337',true).
concept_accession('39879: rn:R08178','KEGG','RNO:26759',true).
concept_accession('39879: rn:R08178','KEGG','RNO:192272',true).
concept_accession('39879: rn:R08178','KEGG','RNO:50559',true).
concept_accession('39879: rn:R08178','KEGG','RNO:314304',true).
concept_accession('39879: rn:R08178','EC','3.1.2.2',true).
concept_accession('39879: rn:R08178','KEGG','50559',true).
concept_accession('39879: rn:R08178','KEGG','503049',true).
concept_accession('39879: rn:R08178','KEGG','314304',true).
concept_accession('39879: rn:R08178','KEGG','192272',true).
concept_accession('39879: rn:R08178','KEGG','26759',true).
concept_accession('39879: rn:R08178','KEGG','681337',true).
concept_accession('39879: rn:R08178','KEGG','3.1.2.2',true).
concept_accession('39879: rn:R08178','KEGG','EC:3.1.2.2',true).
concept_accession('39876: rn:R08177','KEGG','RNO:503049',true).
concept_accession('39876: rn:R08177','KEGG','RNO:681337',true).
concept_accession('39876: rn:R08177','KEGG','RNO:26759',true).
concept_accession('39876: rn:R08177','KEGG','RNO:192272',true).
concept_accession('39876: rn:R08177','KEGG','RNO:50559',true).
concept_accession('39876: rn:R08177','KEGG','RNO:314304',true).
concept_accession('39876: rn:R08177','EC','3.1.2.2',true).
concept_accession('39876: rn:R08177','KEGG','50559',true).
concept_accession('39876: rn:R08177','KEGG','503049',true).
concept_accession('39876: rn:R08177','KEGG','314304',true).
concept_accession('39876: rn:R08177','KEGG','192272',true).
concept_accession('39876: rn:R08177','KEGG','26759',true).
concept_accession('39876: rn:R08177','KEGG','681337',true).
concept_accession('39876: rn:R08177','KEGG','3.1.2.2',true).
concept_accession('39876: rn:R08177','KEGG','EC:3.1.2.2',true).
concept_accession('39877: rn:R08176','EC','3.1.2.-',true).
concept_accession('39877: rn:R08176','KEGG','RNO:503049',true).
concept_accession('39877: rn:R08176','KEGG','RNO:681337',true).
concept_accession('39877: rn:R08176','KEGG','RNO:26759',true).
concept_accession('39877: rn:R08176','KEGG','RNO:192272',true).
concept_accession('39877: rn:R08176','KEGG','RNO:50559',true).
concept_accession('39877: rn:R08176','KEGG','RNO:314304',true).
concept_accession('39877: rn:R08176','KEGG','50559',true).
concept_accession('39877: rn:R08176','KEGG','503049',true).
concept_accession('39877: rn:R08176','KEGG','3.1.2.-',true).
concept_accession('39877: rn:R08176','KEGG','314304',true).
concept_accession('39877: rn:R08176','KEGG','EC:3.1.2.-',true).
concept_accession('39877: rn:R08176','KEGG','192272',true).
concept_accession('39877: rn:R08176','KEGG','26759',true).
concept_accession('39877: rn:R08176','KEGG','681337',true).
concept_accession('39882: rn:R00256','KEGG','RNO:192268',true).
concept_accession('39882: rn:R00256','KEGG','24398',true).
concept_accession('39882: rn:R00256','KEGG','RNO:24398',true).
concept_accession('39882: rn:R00256','KEGG','EC:3.5.1.2',true).
concept_accession('39882: rn:R00256','KEGG','3.5.1.2',true).
concept_accession('39882: rn:R00256','KEGG','192268',true).
concept_accession('39882: rn:R00256','EC','3.5.1.2',true).
concept_accession('39883: rn:R00253','KEGG','RNO:24957',true).
concept_accession('39883: rn:R00253','KEGG','EC:6.3.1.2',true).
concept_accession('39883: rn:R00253','KEGG','24957',true).
concept_accession('39883: rn:R00253','EC','6.3.1.2',true).
concept_accession('39883: rn:R00253','KEGG','6.3.1.2',true).
concept_accession('39880: rn:R00261','KEGG','24379',true).
concept_accession('39880: rn:R00261','KEGG','RNO:24379',true).
concept_accession('39880: rn:R00261','EC','4.1.1.15',true).
concept_accession('39880: rn:R00261','KEGG','RNO:24380',true).
concept_accession('39880: rn:R00261','KEGG','EC:4.1.1.15',true).
concept_accession('39880: rn:R00261','KEGG','24380',true).
concept_accession('39880: rn:R00261','KEGG','4.1.1.15',true).
concept_accession('39881: rn:R01648','EC','2.6.1.19',true).
concept_accession('39881: rn:R01648','KEGG','EC:2.6.1.19',true).
concept_accession('39881: rn:R01648','KEGG','2.6.1.19',true).
concept_accession('39881: rn:R01648','KEGG','RNO:81632',true).
concept_accession('39881: rn:R01648','KEGG','81632',true).
concept_accession('39886: rn:R00768','EC','2.6.1.16',true).
concept_accession('39886: rn:R00768','KEGG','RNO:360518',true).
concept_accession('39886: rn:R00768','KEGG','EC:2.6.1.16',true).
concept_accession('39886: rn:R00768','KEGG','297417',true).
concept_accession('39886: rn:R00768','KEGG','RNO:297417',true).
concept_accession('39886: rn:R00768','KEGG','360518',true).
concept_accession('39886: rn:R00768','KEGG','2.6.1.16',true).
concept_accession('39887: rn:R00707 rn:R00708','KEGG','1.5.1.12',true).
concept_accession('39887: rn:R00707 rn:R00708','KEGG','641316',true).
concept_accession('39887: rn:R00707 rn:R00708','KEGG','RNO:641316',true).
concept_accession('39887: rn:R00707 rn:R00708','KEGG','EC:1.5.1.12',true).
concept_accession('39887: rn:R00707 rn:R00708','EC','1.5.1.12',true).
concept_accession('39884: rn:R00149','KEGG','6.3.4.16',true).
concept_accession('39884: rn:R00149','KEGG','EC:6.3.4.16',true).
concept_accession('39884: rn:R00149','EC','6.3.4.16',true).
concept_accession('39884: rn:R00149','KEGG','RNO:497840',true).
concept_accession('39884: rn:R00149','KEGG','497840',true).
concept_accession('39885: rn:R00575','KEGG','EC:6.3.5.5',true).
concept_accession('39885: rn:R00575','KEGG','RNO:24240',true).
concept_accession('39885: rn:R00575','EC','6.3.5.5',true).
concept_accession('39885: rn:R00575','KEGG','24240',true).
concept_accession('39885: rn:R00575','KEGG','6.3.5.5',true).
concept_accession('39891: rn:R01954','KEGG','6.3.4.5',true).
concept_accession('39891: rn:R01954','KEGG','25698',true).
concept_accession('39891: rn:R01954','KEGG','RNO:25698',true).
concept_accession('39891: rn:R01954','KEGG','EC:6.3.4.5',true).
concept_accession('39891: rn:R01954','EC','6.3.4.5',true).
concept_accession('39890: rn:R00243 rn:R00248','KEGG','RNO:24399',true).
concept_accession('39890: rn:R00243 rn:R00248','KEGG','24399',true).
concept_accession('39890: rn:R00243 rn:R00248','KEGG','1.4.1.3',true).
concept_accession('39890: rn:R00243 rn:R00248','EC','1.4.1.3',true).
concept_accession('39890: rn:R00243 rn:R00248','KEGG','EC:1.4.1.3',true).
concept_accession('39889: rn:R00713','KEGG','1.2.1.24',true).
concept_accession('39889: rn:R00713','KEGG','RNO:291133',true).
concept_accession('39889: rn:R00713','KEGG','EC:1.2.1.24',true).
concept_accession('39889: rn:R00713','EC','1.2.1.24',true).
concept_accession('39889: rn:R00713','KEGG','291133',true).
concept_accession('39888: rn:R00269','EC','3.5.1.3',true).
concept_accession('39888: rn:R00269','KEGG','EC:3.5.1.3',true).
concept_accession('39888: rn:R00269','KEGG','RNO:288174',true).
concept_accession('39888: rn:R00269','KEGG','3.5.1.3',true).
concept_accession('39888: rn:R00269','KEGG','288174',true).
concept_accession('39895: rn:R00369','KEGG','RNO:83784',true).
concept_accession('39895: rn:R00369','KEGG','83784',true).
concept_accession('39895: rn:R00369','KEGG','EC:2.6.1.44',true).
concept_accession('39895: rn:R00369','KEGG','2.6.1.44',true).
concept_accession('39895: rn:R00369','EC','2.6.1.44',true).
concept_accession('39895: rn:R00369','KEGG','RNO:24792',true).
concept_accession('39895: rn:R00369','KEGG','24792',true).
concept_accession('39894: rn:R01086','KEGG','59085',true).
concept_accession('39894: rn:R01086','KEGG','EC:4.3.2.1',true).
concept_accession('39894: rn:R01086','KEGG','4.3.2.1',true).
concept_accession('39894: rn:R01086','KEGG','RNO:59085',true).
concept_accession('39894: rn:R01086','EC','4.3.2.1',true).
concept_accession('39893: rn:R01083','KEGG','RNO:315150',true).
concept_accession('39893: rn:R01083','KEGG','EC:4.3.2.2',true).
concept_accession('39893: rn:R01083','KEGG','315150',true).
concept_accession('39893: rn:R01083','KEGG','4.3.2.2',true).
concept_accession('39893: rn:R01083','EC','4.3.2.2',true).
concept_accession('39892: rn:R01135','KEGG','RNO:684425',true).
concept_accession('39892: rn:R01135','KEGG','6.3.4.4',true).
concept_accession('39892: rn:R01135','KEGG','289276',true).
concept_accession('39892: rn:R01135','KEGG','684425',true).
concept_accession('39892: rn:R01135','KEGG','EC:6.3.4.4',true).
concept_accession('39892: rn:R01135','EC','6.3.4.4',true).
concept_accession('39892: rn:R01135','KEGG','RNO:289276',true).
concept_accession('39899: rn:R00348','EC','3.5.1.3',true).
concept_accession('39899: rn:R00348','KEGG','EC:3.5.1.3',true).
concept_accession('39899: rn:R00348','KEGG','RNO:288174',true).
concept_accession('39899: rn:R00348','KEGG','3.5.1.3',true).
concept_accession('39899: rn:R00348','KEGG','288174',true).
concept_accession('39898: rn:R00488','KEGG','3.5.1.15',true).
concept_accession('39898: rn:R00488','EC','3.5.1.15',true).
concept_accession('39898: rn:R00488','KEGG','293653',true).
concept_accession('39898: rn:R00488','KEGG','RNO:293653',true).
concept_accession('39898: rn:R00488','KEGG','79251',true).
concept_accession('39898: rn:R00488','KEGG','RNO:79251',true).
concept_accession('39898: rn:R00488','KEGG','EC:3.5.1.15',true).
concept_accession('39897: rn:R01397','KEGG','2.1.3.2',true).
concept_accession('39897: rn:R01397','KEGG','RNO:24240',true).
concept_accession('39897: rn:R01397','EC','2.1.3.2',true).
concept_accession('39897: rn:R01397','KEGG','24240',true).
concept_accession('39897: rn:R01397','KEGG','EC:2.1.3.2',true).
concept_accession('39896: rn:R00258','KEGG','81670',true).
concept_accession('39896: rn:R00258','KEGG','RNO:81670',true).
concept_accession('39896: rn:R00258','EC','2.6.1.2',true).
concept_accession('39896: rn:R00258','KEGG','307759',true).
concept_accession('39896: rn:R00258','KEGG','EC:2.6.1.2',true).
concept_accession('39896: rn:R00258','KEGG','RNO:307759',true).
concept_accession('39896: rn:R00258','KEGG','2.6.1.2',true).
concept_accession('39903: rn:R00359','KEGG','RNO:685325',true).
concept_accession('39903: rn:R00359','KEGG','EC:1.4.3.1',true).
concept_accession('39903: rn:R00359','EC','1.4.3.1',true).
concept_accession('39903: rn:R00359','KEGG','685325',true).
concept_accession('39903: rn:R00359','KEGG','1.4.3.1',true).
concept_accession('39902: rn:R00355','KEGG','25721',true).
concept_accession('39902: rn:R00355','KEGG','RNO:25721',true).
concept_accession('39902: rn:R00355','KEGG','24401',true).
concept_accession('39902: rn:R00355','EC','2.6.1.1',true).
concept_accession('39902: rn:R00355','KEGG','RNO:24401',true).
concept_accession('39902: rn:R00355','KEGG','EC:2.6.1.1',true).
concept_accession('39902: rn:R00355','KEGG','2.6.1.1',true).
concept_accession('39901: rn:R00357','KEGG','EC:1.4.3.16',true).
concept_accession('39901: rn:R00357','KEGG','298483',true).
concept_accession('39901: rn:R00357','KEGG','RNO:100360621',true).
concept_accession('39901: rn:R00357','KEGG','RNO:298483',true).
concept_accession('39901: rn:R00357','KEGG','1.4.3.16',true).
concept_accession('39901: rn:R00357','EC','1.4.3.16',true).
concept_accession('39901: rn:R00357','KEGG','100360621',true).
concept_accession('39900: rn:R00578','KEGG','EC:6.3.5.4',true).
concept_accession('39900: rn:R00578','KEGG','25612',true).
concept_accession('39900: rn:R00578','KEGG','RNO:25612',true).
concept_accession('39900: rn:R00578','EC','6.3.5.4',true).
concept_accession('39900: rn:R00578','KEGG','6.3.5.4',true).
concept_accession('39904: rn:R01878','KEGG','3.5.4.5',true).
concept_accession('39904: rn:R01878','KEGG','EC:3.5.4.5',true).
concept_accession('39904: rn:R01878','EC','3.5.4.5',true).
concept_accession('39904: rn:R01878','KEGG','RNO:362638',true).
concept_accession('39904: rn:R01878','KEGG','362638',true).
concept_accession('39905: rn:R00513 rn:R00516 rn:R00517 rn:R00962 rn:R01548 rn:R02091 rn:R02096 rn:R02371 rn:R02372','KEGG','RNO:304944',true).
concept_accession('39905: rn:R00513 rn:R00516 rn:R00517 rn:R00962 rn:R01548 rn:R02091 rn:R02096 rn:R02371 rn:R02372','KEGG','311864',true).
concept_accession('39905: rn:R00513 rn:R00516 rn:R00517 rn:R00962 rn:R01548 rn:R02091 rn:R02096 rn:R02371 rn:R02372','KEGG','499956',true).
concept_accession('39905: rn:R00513 rn:R00516 rn:R00517 rn:R00962 rn:R01548 rn:R02091 rn:R02096 rn:R02371 rn:R02372','KEGG','RNO:499956',true).
concept_accession('39905: rn:R00513 rn:R00516 rn:R00517 rn:R00962 rn:R01548 rn:R02091 rn:R02096 rn:R02371 rn:R02372','KEGG','2.7.1.48',true).
concept_accession('39905: rn:R00513 rn:R00516 rn:R00517 rn:R00962 rn:R01548 rn:R02091 rn:R02096 rn:R02371 rn:R02372','KEGG','304944',true).
concept_accession('39905: rn:R00513 rn:R00516 rn:R00517 rn:R00962 rn:R01548 rn:R02091 rn:R02096 rn:R02371 rn:R02372','KEGG','RNO:311864',true).
concept_accession('39905: rn:R00513 rn:R00516 rn:R00517 rn:R00962 rn:R01548 rn:R02091 rn:R02096 rn:R02371 rn:R02372','KEGG','EC:2.7.1.48',true).
concept_accession('39905: rn:R00513 rn:R00516 rn:R00517 rn:R00962 rn:R01548 rn:R02091 rn:R02096 rn:R02371 rn:R02372','EC','2.7.1.48',true).
concept_accession('39906: rn:R00511','KEGG','RNO:313574',true).
concept_accession('39906: rn:R00511','KEGG','100363253',true).
concept_accession('39906: rn:R00511','KEGG','RNO:688261',true).
concept_accession('39906: rn:R00511','KEGG','RNO:287368',true).
concept_accession('39906: rn:R00511','KEGG','688261',true).
concept_accession('39906: rn:R00511','EC','3.1.3.5',true).
concept_accession('39906: rn:R00511','KEGG','313574',true).
concept_accession('39906: rn:R00511','KEGG','RNO:58813',true).
concept_accession('39906: rn:R00511','KEGG','287368',true).
concept_accession('39906: rn:R00511','KEGG','RNO:312373',true).
concept_accession('39906: rn:R00511','KEGG','3.1.3.5',true).
concept_accession('39906: rn:R00511','KEGG','RNO:100363253',true).
concept_accession('39906: rn:R00511','KEGG','RNO:298881',true).
concept_accession('39906: rn:R00511','KEGG','EC:3.1.3.5',true).
concept_accession('39906: rn:R00511','KEGG','298881',true).
concept_accession('39906: rn:R00511','KEGG','58813',true).
concept_accession('39906: rn:R00511','KEGG','312373',true).
concept_accession('39907: rn:R00514','KEGG','316077',true).
concept_accession('39907: rn:R00514','KEGG','64519',true).
concept_accession('39907: rn:R00514','KEGG','RNO:613267',true).
concept_accession('39907: rn:R00514','KEGG','3.6.1.5',true).
concept_accession('39907: rn:R00514','KEGG','RNO:64519',true).
concept_accession('39907: rn:R00514','KEGG','EC:3.6.1.5',true).
concept_accession('39907: rn:R00514','EC','3.6.1.5',true).
concept_accession('39907: rn:R00514','KEGG','613267',true).
concept_accession('39907: rn:R00514','KEGG','RNO:316077',true).
concept_accession('39908: rn:R00512','KEGG','RNO:298410',true).
concept_accession('39908: rn:R00512','KEGG','2.7.4.14',true).
concept_accession('39908: rn:R00512','KEGG','RNO:314004',true).
concept_accession('39908: rn:R00512','KEGG','314004',true).
concept_accession('39908: rn:R00512','EC','2.7.4.14',true).
concept_accession('39908: rn:R00512','KEGG','EC:2.7.4.14',true).
concept_accession('39908: rn:R00512','KEGG','298410',true).
concept_accession('39909: rn:R00569','KEGG','316077',true).
concept_accession('39909: rn:R00569','KEGG','64519',true).
concept_accession('39909: rn:R00569','KEGG','RNO:613267',true).
concept_accession('39909: rn:R00569','KEGG','3.6.1.5',true).
concept_accession('39909: rn:R00569','KEGG','RNO:64519',true).
concept_accession('39909: rn:R00569','KEGG','EC:3.6.1.5',true).
concept_accession('39909: rn:R00569','EC','3.6.1.5',true).
concept_accession('39909: rn:R00569','KEGG','613267',true).
concept_accession('39909: rn:R00569','KEGG','RNO:316077',true).
concept_accession('39910: rn:R00570','KEGG','171566',true).
concept_accession('39910: rn:R00570','KEGG','2.7.4.6',true).
concept_accession('39910: rn:R00570','KEGG','685679',true).
concept_accession('39910: rn:R00570','KEGG','83782',true).
concept_accession('39910: rn:R00570','KEGG','RNO:58964',true).
concept_accession('39910: rn:R00570','KEGG','RNO:83782',true).
concept_accession('39910: rn:R00570','KEGG','85269',true).
concept_accession('39910: rn:R00570','KEGG','RNO:685679',true).
concept_accession('39910: rn:R00570','KEGG','RNO:85269',true).
concept_accession('39910: rn:R00570','EC','2.7.4.6',true).
concept_accession('39910: rn:R00570','KEGG','EC:2.7.4.6',true).
concept_accession('39910: rn:R00570','KEGG','RNO:191575',true).
concept_accession('39910: rn:R00570','KEGG','191575',true).
concept_accession('39910: rn:R00570','KEGG','58964',true).
concept_accession('39910: rn:R00570','KEGG','RNO:171566',true).
concept_accession('39911: rn:R00442','KEGG','83581',true).
concept_accession('39911: rn:R00442','KEGG','292778',true).
concept_accession('39911: rn:R00442','KEGG','RNO:361102',true).
concept_accession('39911: rn:R00442','KEGG','83582',true).
concept_accession('39911: rn:R00442','KEGG','361365',true).
concept_accession('39911: rn:R00442','KEGG','RNO:83503',true).
concept_accession('39911: rn:R00442','KEGG','361640',true).
concept_accession('39911: rn:R00442','KEGG','364834',true).
concept_accession('39911: rn:R00442','KEGG','RNO:289561',true).
concept_accession('39911: rn:R00442','KEGG','RNO:313245',true).
concept_accession('39911: rn:R00442','KEGG','363633',true).
concept_accession('39911: rn:R00442','KEGG','RNO:361640',true).
concept_accession('39911: rn:R00442','KEGG','366277',true).
concept_accession('39911: rn:R00442','KEGG','RNO:685465',true).
concept_accession('39911: rn:R00442','KEGG','310685',true).
concept_accession('39911: rn:R00442','KEGG','100363176',true).
concept_accession('39911: rn:R00442','KEGG','RNO:363633',true).
concept_accession('39911: rn:R00442','KEGG','RNO:117017',true).
concept_accession('39911: rn:R00442','KEGG','RNO:306012',true).
concept_accession('39911: rn:R00442','KEGG','RNO:502374',true).
concept_accession('39911: rn:R00442','KEGG','RNO:292778',true).
concept_accession('39911: rn:R00442','KEGG','289561',true).
concept_accession('39911: rn:R00442','KEGG','288588',true).
concept_accession('39911: rn:R00442','KEGG','RNO:690966',true).
concept_accession('39911: rn:R00442','KEGG','RNO:361365',true).
concept_accession('39911: rn:R00442','KEGG','RNO:300088',true).
concept_accession('39911: rn:R00442','KEGG','502374',true).
concept_accession('39911: rn:R00442','KEGG','311487',true).
concept_accession('39911: rn:R00442','KEGG','RNO:288588',true).
concept_accession('39911: rn:R00442','KEGG','685465',true).
concept_accession('39911: rn:R00442','KEGG','362858',true).
concept_accession('39911: rn:R00442','KEGG','498109',true).
concept_accession('39911: rn:R00442','KEGG','313245',true).
concept_accession('39911: rn:R00442','KEGG','2.7.7.6',true).
concept_accession('39911: rn:R00442','KEGG','RNO:681193',true).
concept_accession('39911: rn:R00442','KEGG','RNO:100363176',true).
concept_accession('39911: rn:R00442','KEGG','361102',true).
concept_accession('39911: rn:R00442','KEGG','681193',true).
concept_accession('39911: rn:R00442','KEGG','RNO:301246',true).
concept_accession('39911: rn:R00442','KEGG','RNO:291795',true).
concept_accession('39911: rn:R00442','KEGG','RNO:361784',true).
concept_accession('39911: rn:R00442','KEGG','RNO:362858',true).
concept_accession('39911: rn:R00442','KEGG','117017',true).
concept_accession('39911: rn:R00442','KEGG','300088',true).
concept_accession('39911: rn:R00442','KEGG','EC:2.7.7.6',true).
concept_accession('39911: rn:R00442','KEGG','83503',true).
concept_accession('39911: rn:R00442','KEGG','RNO:690254',true).
concept_accession('39911: rn:R00442','KEGG','RNO:311487',true).
concept_accession('39911: rn:R00442','KEGG','291795',true).
concept_accession('39911: rn:R00442','KEGG','RNO:83582',true).
concept_accession('39911: rn:R00442','KEGG','RNO:366277',true).
concept_accession('39911: rn:R00442','KEGG','RNO:83581',true).
concept_accession('39911: rn:R00442','KEGG','361784',true).
concept_accession('39911: rn:R00442','KEGG','690254',true).
concept_accession('39911: rn:R00442','KEGG','RNO:498109',true).
concept_accession('39911: rn:R00442','KEGG','690966',true).
concept_accession('39911: rn:R00442','KEGG','306012',true).
concept_accession('39911: rn:R00442','EC','2.7.7.6',true).
concept_accession('39911: rn:R00442','KEGG','RNO:364834',true).
concept_accession('39911: rn:R00442','KEGG','301246',true).
concept_accession('39911: rn:R00442','KEGG','RNO:310685',true).
concept_accession('39912: rn:R00440','KEGG','EC:2.7.7.8',true).
concept_accession('39912: rn:R00440','KEGG','360992',true).
concept_accession('39912: rn:R00440','KEGG','RNO:360992',true).
concept_accession('39912: rn:R00440','KEGG','2.7.7.8',true).
concept_accession('39912: rn:R00440','EC','2.7.7.8',true).
concept_accession('39913: rn:R02269','KEGG','65135',true).
concept_accession('39913: rn:R02269','KEGG','RNO:65135',true).
concept_accession('39913: rn:R02269','EC','3.5.2.2',true).
concept_accession('39913: rn:R02269','KEGG','3.5.2.2',true).
concept_accession('39913: rn:R02269','KEGG','EC:3.5.2.2',true).
concept_accession('39914: rn:R00905','EC','3.5.1.6',true).
concept_accession('39914: rn:R00905','KEGG','116593',true).
concept_accession('39914: rn:R00905','KEGG','EC:3.5.1.6',true).
concept_accession('39914: rn:R00905','KEGG','RNO:116593',true).
concept_accession('39914: rn:R00905','KEGG','3.5.1.6',true).
concept_accession('39915: rn:R00978','KEGG','RNO:81656',true).
concept_accession('39915: rn:R00978','KEGG','81656',true).
concept_accession('39915: rn:R00978','KEGG','1.3.1.2',true).
concept_accession('39915: rn:R00978','KEGG','EC:1.3.1.2',true).
concept_accession('39915: rn:R00978','EC','1.3.1.2',true).
concept_accession('39916: rn:R00963','KEGG','RNO:313574',true).
concept_accession('39916: rn:R00963','KEGG','100363253',true).
concept_accession('39916: rn:R00963','KEGG','RNO:688261',true).
concept_accession('39916: rn:R00963','KEGG','RNO:287368',true).
concept_accession('39916: rn:R00963','KEGG','688261',true).
concept_accession('39916: rn:R00963','EC','3.1.3.5',true).
concept_accession('39916: rn:R00963','KEGG','313574',true).
concept_accession('39916: rn:R00963','KEGG','RNO:58813',true).
concept_accession('39916: rn:R00963','KEGG','287368',true).
concept_accession('39916: rn:R00963','KEGG','RNO:312373',true).
concept_accession('39916: rn:R00963','KEGG','3.1.3.5',true).
concept_accession('39916: rn:R00963','KEGG','RNO:100363253',true).
concept_accession('39916: rn:R00963','KEGG','RNO:298881',true).
concept_accession('39916: rn:R00963','KEGG','EC:3.1.3.5',true).
concept_accession('39916: rn:R00963','KEGG','298881',true).
concept_accession('39916: rn:R00963','KEGG','58813',true).
concept_accession('39916: rn:R00963','KEGG','312373',true).
concept_accession('39917: rn:R01876','KEGG','2.4.2.3',true).
concept_accession('39917: rn:R01876','KEGG','RNO:289801',true).
concept_accession('39917: rn:R01876','KEGG','EC:2.4.2.3',true).
concept_accession('39917: rn:R01876','EC','2.4.2.3',true).
concept_accession('39917: rn:R01876','KEGG','295620',true).
concept_accession('39917: rn:R01876','KEGG','289801',true).
concept_accession('39917: rn:R01876','KEGG','RNO:295620',true).
concept_accession('39918: rn:R00964 rn:R00967 rn:R00968 rn:R00970 rn:R01549 rn:R01880 rn:R02097 rn:R02327 rn:R02332','KEGG','RNO:304944',true).
concept_accession('39918: rn:R00964 rn:R00967 rn:R00968 rn:R00970 rn:R01549 rn:R01880 rn:R02097 rn:R02327 rn:R02332','KEGG','311864',true).
concept_accession('39918: rn:R00964 rn:R00967 rn:R00968 rn:R00970 rn:R01549 rn:R01880 rn:R02097 rn:R02327 rn:R02332','KEGG','499956',true).
concept_accession('39918: rn:R00964 rn:R00967 rn:R00968 rn:R00970 rn:R01549 rn:R01880 rn:R02097 rn:R02327 rn:R02332','KEGG','RNO:499956',true).
concept_accession('39918: rn:R00964 rn:R00967 rn:R00968 rn:R00970 rn:R01549 rn:R01880 rn:R02097 rn:R02327 rn:R02332','KEGG','2.7.1.48',true).
concept_accession('39918: rn:R00964 rn:R00967 rn:R00968 rn:R00970 rn:R01549 rn:R01880 rn:R02097 rn:R02327 rn:R02332','KEGG','304944',true).
concept_accession('39918: rn:R00964 rn:R00967 rn:R00968 rn:R00970 rn:R01549 rn:R01880 rn:R02097 rn:R02327 rn:R02332','KEGG','RNO:311864',true).
concept_accession('39918: rn:R00964 rn:R00967 rn:R00968 rn:R00970 rn:R01549 rn:R01880 rn:R02097 rn:R02327 rn:R02332','KEGG','EC:2.7.1.48',true).
concept_accession('39918: rn:R00964 rn:R00967 rn:R00968 rn:R00970 rn:R01549 rn:R01880 rn:R02097 rn:R02327 rn:R02332','EC','2.7.1.48',true).
concept_accession('39919: rn:R00966','EC','2.4.2.9',true).
concept_accession('39919: rn:R00966','KEGG','RNO:317237',true).
concept_accession('39919: rn:R00966','KEGG','EC:2.4.2.9',true).
concept_accession('39919: rn:R00966','KEGG','317237',true).
concept_accession('39919: rn:R00966','KEGG','2.4.2.9',true).
concept_accession('39921: rn:R00155','KEGG','RNO:85260',true).
concept_accession('39921: rn:R00155','KEGG','RNO:314312',true).
concept_accession('39921: rn:R00155','KEGG','85260',true).
concept_accession('39921: rn:R00155','KEGG','314312',true).
concept_accession('39921: rn:R00155','KEGG','3.6.1.5',true).
concept_accession('39921: rn:R00155','KEGG','EC:3.6.1.5',true).
concept_accession('39921: rn:R00155','KEGG','RNO:246272',true).
concept_accession('39921: rn:R00155','KEGG','361063',true).
concept_accession('39921: rn:R00155','EC','3.6.1.5',true).
concept_accession('39921: rn:R00155','KEGG','RNO:361063',true).
concept_accession('39921: rn:R00155','KEGG','246272',true).
concept_accession('39920: rn:R00155','KEGG','316077',true).
concept_accession('39920: rn:R00155','KEGG','64519',true).
concept_accession('39920: rn:R00155','KEGG','RNO:613267',true).
concept_accession('39920: rn:R00155','KEGG','3.6.1.5',true).
concept_accession('39920: rn:R00155','KEGG','RNO:64519',true).
concept_accession('39920: rn:R00155','KEGG','EC:3.6.1.5',true).
concept_accession('39920: rn:R00155','EC','3.6.1.5',true).
concept_accession('39920: rn:R00155','KEGG','613267',true).
concept_accession('39920: rn:R00155','KEGG','RNO:316077',true).
concept_accession('39923: rn:R00571 rn:R00573','KEGG','619580',true).
concept_accession('39923: rn:R00571 rn:R00573','KEGG','RNO:619580',true).
concept_accession('39923: rn:R00571 rn:R00573','KEGG','RNO:313560',true).
concept_accession('39923: rn:R00571 rn:R00573','KEGG','6.3.4.2',true).
concept_accession('39923: rn:R00571 rn:R00573','KEGG','313560',true).
concept_accession('39923: rn:R00571 rn:R00573','KEGG','EC:6.3.4.2',true).
concept_accession('39923: rn:R00571 rn:R00573','EC','6.3.4.2',true).
concept_accession('39922: rn:R00159','KEGG','316077',true).
concept_accession('39922: rn:R00159','KEGG','64519',true).
concept_accession('39922: rn:R00159','KEGG','RNO:613267',true).
concept_accession('39922: rn:R00159','KEGG','3.6.1.5',true).
concept_accession('39922: rn:R00159','KEGG','RNO:64519',true).
concept_accession('39922: rn:R00159','KEGG','EC:3.6.1.5',true).
concept_accession('39922: rn:R00159','EC','3.6.1.5',true).
concept_accession('39922: rn:R00159','KEGG','613267',true).
concept_accession('39922: rn:R00159','KEGG','RNO:316077',true).
concept_accession('39925: rn:R00157','KEGG','26956',true).
concept_accession('39925: rn:R00157','KEGG','EC:2.7.4.10',true).
concept_accession('39925: rn:R00157','EC','2.7.4.10',true).
concept_accession('39925: rn:R00157','KEGG','2.7.4.10',true).
concept_accession('39925: rn:R00157','KEGG','RNO:26956',true).
concept_accession('39924: rn:R00158','KEGG','2.7.4.22',true).
concept_accession('39924: rn:R00158','KEGG','RNO:298410',true).
concept_accession('39924: rn:R00158','KEGG','RNO:314004',true).
concept_accession('39924: rn:R00158','KEGG','314004',true).
concept_accession('39924: rn:R00158','KEGG','EC:2.7.4.22',true).
concept_accession('39924: rn:R00158','KEGG','298410',true).
concept_accession('39924: rn:R00158','EC','2.7.4.22',true).
concept_accession('39927: rn:R00443','KEGG','83581',true).
concept_accession('39927: rn:R00443','KEGG','292778',true).
concept_accession('39927: rn:R00443','KEGG','RNO:361102',true).
concept_accession('39927: rn:R00443','KEGG','83582',true).
concept_accession('39927: rn:R00443','KEGG','361365',true).
concept_accession('39927: rn:R00443','KEGG','RNO:83503',true).
concept_accession('39927: rn:R00443','KEGG','361640',true).
concept_accession('39927: rn:R00443','KEGG','364834',true).
concept_accession('39927: rn:R00443','KEGG','RNO:289561',true).
concept_accession('39927: rn:R00443','KEGG','RNO:313245',true).
concept_accession('39927: rn:R00443','KEGG','363633',true).
concept_accession('39927: rn:R00443','KEGG','RNO:361640',true).
concept_accession('39927: rn:R00443','KEGG','366277',true).
concept_accession('39927: rn:R00443','KEGG','RNO:685465',true).
concept_accession('39927: rn:R00443','KEGG','310685',true).
concept_accession('39927: rn:R00443','KEGG','100363176',true).
concept_accession('39927: rn:R00443','KEGG','RNO:363633',true).
concept_accession('39927: rn:R00443','KEGG','RNO:117017',true).
concept_accession('39927: rn:R00443','KEGG','RNO:306012',true).
concept_accession('39927: rn:R00443','KEGG','RNO:502374',true).
concept_accession('39927: rn:R00443','KEGG','RNO:292778',true).
concept_accession('39927: rn:R00443','KEGG','289561',true).
concept_accession('39927: rn:R00443','KEGG','288588',true).
concept_accession('39927: rn:R00443','KEGG','RNO:690966',true).
concept_accession('39927: rn:R00443','KEGG','RNO:361365',true).
concept_accession('39927: rn:R00443','KEGG','RNO:300088',true).
concept_accession('39927: rn:R00443','KEGG','502374',true).
concept_accession('39927: rn:R00443','KEGG','311487',true).
concept_accession('39927: rn:R00443','KEGG','RNO:288588',true).
concept_accession('39927: rn:R00443','KEGG','685465',true).
concept_accession('39927: rn:R00443','KEGG','362858',true).
concept_accession('39927: rn:R00443','KEGG','498109',true).
concept_accession('39927: rn:R00443','KEGG','313245',true).
concept_accession('39927: rn:R00443','KEGG','2.7.7.6',true).
concept_accession('39927: rn:R00443','KEGG','RNO:681193',true).
concept_accession('39927: rn:R00443','KEGG','RNO:100363176',true).
concept_accession('39927: rn:R00443','KEGG','361102',true).
concept_accession('39927: rn:R00443','KEGG','681193',true).
concept_accession('39927: rn:R00443','KEGG','RNO:301246',true).
concept_accession('39927: rn:R00443','KEGG','RNO:291795',true).
concept_accession('39927: rn:R00443','KEGG','RNO:361784',true).
concept_accession('39927: rn:R00443','KEGG','RNO:362858',true).
concept_accession('39927: rn:R00443','KEGG','117017',true).
concept_accession('39927: rn:R00443','KEGG','300088',true).
concept_accession('39927: rn:R00443','KEGG','EC:2.7.7.6',true).
concept_accession('39927: rn:R00443','KEGG','83503',true).
concept_accession('39927: rn:R00443','KEGG','RNO:690254',true).
concept_accession('39927: rn:R00443','KEGG','RNO:311487',true).
concept_accession('39927: rn:R00443','KEGG','291795',true).
concept_accession('39927: rn:R00443','KEGG','RNO:83582',true).
concept_accession('39927: rn:R00443','KEGG','RNO:366277',true).
concept_accession('39927: rn:R00443','KEGG','RNO:83581',true).
concept_accession('39927: rn:R00443','KEGG','361784',true).
concept_accession('39927: rn:R00443','KEGG','690254',true).
concept_accession('39927: rn:R00443','KEGG','RNO:498109',true).
concept_accession('39927: rn:R00443','KEGG','690966',true).
concept_accession('39927: rn:R00443','KEGG','306012',true).
concept_accession('39927: rn:R00443','EC','2.7.7.6',true).
concept_accession('39927: rn:R00443','KEGG','RNO:364834',true).
concept_accession('39927: rn:R00443','KEGG','301246',true).
concept_accession('39927: rn:R00443','KEGG','RNO:310685',true).
concept_accession('39926: rn:R00156','KEGG','171566',true).
concept_accession('39926: rn:R00156','KEGG','2.7.4.6',true).
concept_accession('39926: rn:R00156','KEGG','685679',true).
concept_accession('39926: rn:R00156','KEGG','83782',true).
concept_accession('39926: rn:R00156','KEGG','RNO:58964',true).
concept_accession('39926: rn:R00156','KEGG','RNO:83782',true).
concept_accession('39926: rn:R00156','KEGG','85269',true).
concept_accession('39926: rn:R00156','KEGG','RNO:685679',true).
concept_accession('39926: rn:R00156','KEGG','RNO:85269',true).
concept_accession('39926: rn:R00156','EC','2.7.4.6',true).
concept_accession('39926: rn:R00156','KEGG','EC:2.7.4.6',true).
concept_accession('39926: rn:R00156','KEGG','RNO:191575',true).
concept_accession('39926: rn:R00156','KEGG','191575',true).
concept_accession('39926: rn:R00156','KEGG','58964',true).
concept_accession('39926: rn:R00156','KEGG','RNO:171566',true).
concept_accession('39929: rn:R01870','KEGG','EC:2.4.2.10',true).
concept_accession('39929: rn:R01870','KEGG','288051',true).
concept_accession('39929: rn:R01870','KEGG','RNO:288051',true).
concept_accession('39929: rn:R01870','KEGG','2.4.2.10',true).
concept_accession('39929: rn:R01870','EC','2.4.2.10',true).
concept_accession('39928: rn:R00438','KEGG','EC:2.7.7.8',true).
concept_accession('39928: rn:R00438','KEGG','360992',true).
concept_accession('39928: rn:R00438','KEGG','RNO:360992',true).
concept_accession('39928: rn:R00438','KEGG','2.7.7.8',true).
concept_accession('39928: rn:R00438','EC','2.7.7.8',true).
concept_accession('39931: rn:R01397','KEGG','2.1.3.2',true).
concept_accession('39931: rn:R01397','KEGG','RNO:24240',true).
concept_accession('39931: rn:R01397','EC','2.1.3.2',true).
concept_accession('39931: rn:R01397','KEGG','24240',true).
concept_accession('39931: rn:R01397','KEGG','EC:2.1.3.2',true).
concept_accession('39930: rn:R01993','EC','3.5.2.3',true).
concept_accession('39930: rn:R01993','KEGG','RNO:24240',true).
concept_accession('39930: rn:R01993','KEGG','3.5.2.3',true).
concept_accession('39930: rn:R01993','KEGG','EC:3.5.2.3',true).
concept_accession('39930: rn:R01993','KEGG','24240',true).
concept_accession('39933: rn:R08264','EC','1.14.14.1',true).
concept_accession('39933: rn:R08264','KEGG','1.14.14.1',true).
concept_accession('39933: rn:R08264','KEGG','25642',true).
concept_accession('39933: rn:R08264','KEGG','RNO:25642',true).
concept_accession('39933: rn:R08264','KEGG','RNO:171352',true).
concept_accession('39933: rn:R08264','KEGG','171352',true).
concept_accession('39933: rn:R08264','KEGG','266682',true).
concept_accession('39933: rn:R08264','KEGG','252931',true).
concept_accession('39933: rn:R08264','KEGG','RNO:266682',true).
concept_accession('39933: rn:R08264','KEGG','RNO:252931',true).
concept_accession('39933: rn:R08264','KEGG','EC:1.14.14.1',true).
concept_accession('39932: rn:R08307','KEGG','RNO:25375',true).
concept_accession('39932: rn:R08307','KEGG','25375',true).
concept_accession('39932: rn:R08307','KEGG','RNO:266603',true).
concept_accession('39932: rn:R08307','KEGG','266603',true).
concept_accession('39932: rn:R08307','KEGG','RNO:309147',true).
concept_accession('39932: rn:R08307','KEGG','309147',true).
concept_accession('39932: rn:R08307','KEGG','EC:1.2.1.5',true).
concept_accession('39932: rn:R08307','EC','1.2.1.5',true).
concept_accession('39932: rn:R08307','KEGG','1.2.1.5',true).
concept_accession('39935: rn:R08310','KEGG','24172',true).
concept_accession('39935: rn:R08310','KEGG','RNO:29646',true).
concept_accession('39935: rn:R08310','KEGG','RNO:310903',true).
concept_accession('39935: rn:R08310','KEGG','100145871',true).
concept_accession('39935: rn:R08310','KEGG','EC:1.1.1.1',true).
concept_accession('39935: rn:R08310','KEGG','310903',true).
concept_accession('39935: rn:R08310','KEGG','1.1.1.1',true).
concept_accession('39935: rn:R08310','KEGG','RNO:171178',true).
concept_accession('39935: rn:R08310','EC','1.1.1.1',true).
concept_accession('39935: rn:R08310','KEGG','171178',true).
concept_accession('39935: rn:R08310','KEGG','RNO:100145871',true).
concept_accession('39935: rn:R08310','KEGG','RNO:24172',true).
concept_accession('39935: rn:R08310','KEGG','29646',true).
concept_accession('39934: rn:R08306','KEGG','24172',true).
concept_accession('39934: rn:R08306','KEGG','RNO:29646',true).
concept_accession('39934: rn:R08306','KEGG','RNO:310903',true).
concept_accession('39934: rn:R08306','KEGG','100145871',true).
concept_accession('39934: rn:R08306','KEGG','EC:1.1.1.1',true).
concept_accession('39934: rn:R08306','KEGG','310903',true).
concept_accession('39934: rn:R08306','KEGG','1.1.1.1',true).
concept_accession('39934: rn:R08306','KEGG','RNO:171178',true).
concept_accession('39934: rn:R08306','EC','1.1.1.1',true).
concept_accession('39934: rn:R08306','KEGG','171178',true).
concept_accession('39934: rn:R08306','KEGG','RNO:100145871',true).
concept_accession('39934: rn:R08306','KEGG','RNO:24172',true).
concept_accession('39934: rn:R08306','KEGG','29646',true).
concept_accession('39695: rn:R03038','KEGG','301254',true).
concept_accession('39695: rn:R03038','KEGG','292023',true).
concept_accession('39695: rn:R03038','KEGG','6.1.1.7',true).
concept_accession('39695: rn:R03038','KEGG','RNO:292023',true).
concept_accession('39695: rn:R03038','KEGG','RNO:301254',true).
concept_accession('39695: rn:R03038','KEGG','EC:6.1.1.7',true).
concept_accession('39695: rn:R03038','EC','6.1.1.7',true).
concept_accession('39694: rn:R03662','KEGG','6.1.1.11',true).
concept_accession('39694: rn:R03662','KEGG','266975',true).
concept_accession('39694: rn:R03662','KEGG','RNO:266975',true).
concept_accession('39694: rn:R03662','KEGG','EC:6.1.1.11',true).
concept_accession('39694: rn:R03662','KEGG','RNO:292759',true).
concept_accession('39694: rn:R03662','KEGG','292759',true).
concept_accession('39694: rn:R03662','EC','6.1.1.11',true).
concept_accession('39693: rn:R03659','KEGG','RNO:299851',true).
concept_accession('39693: rn:R03659','KEGG','299851',true).
concept_accession('39693: rn:R03659','KEGG','6.1.1.10',true).
concept_accession('39693: rn:R03659','EC','6.1.1.10',true).
concept_accession('39693: rn:R03659','KEGG','EC:6.1.1.10',true).
concept_accession('39693: rn:R03659','KEGG','RNO:316403',true).
concept_accession('39693: rn:R03659','KEGG','316403',true).
concept_accession('39692: rn:R03654','KEGG','297113',true).
concept_accession('39692: rn:R03654','KEGG','6.1.1.14',true).
concept_accession('39692: rn:R03654','KEGG','EC:6.1.1.14',true).
concept_accession('39692: rn:R03654','KEGG','RNO:297113',true).
concept_accession('39692: rn:R03654','EC','6.1.1.14',true).
concept_accession('39691: rn:R05577','KEGG','RNO:116483',true).
concept_accession('39691: rn:R05577','EC','6.1.1.23',true).
concept_accession('39691: rn:R05577','KEGG','6.1.1.23',true).
concept_accession('39691: rn:R05577','KEGG','RNO:304919',true).
concept_accession('39691: rn:R05577','KEGG','304919',true).
concept_accession('39691: rn:R05577','KEGG','EC:6.1.1.23',true).
concept_accession('39691: rn:R05577','KEGG','116483',true).
concept_accession('39690: rn:R03652','KEGG','EC:6.1.1.18',true).
concept_accession('39690: rn:R03652','KEGG','290868',true).
concept_accession('39690: rn:R03652','KEGG','RNO:290868',true).
concept_accession('39690: rn:R03652','KEGG','6.1.1.18',true).
concept_accession('39690: rn:R03652','EC','6.1.1.18',true).
concept_accession('39689: rn:R03650','KEGG','361184',true).
concept_accession('39689: rn:R03650','KEGG','EC:6.1.1.16',true).
concept_accession('39689: rn:R03650','KEGG','RNO:361184',true).
concept_accession('39689: rn:R03650','KEGG','293638',true).
concept_accession('39689: rn:R03650','KEGG','6.1.1.16',true).
concept_accession('39689: rn:R03650','EC','6.1.1.16',true).
concept_accession('39689: rn:R03650','KEGG','RNO:293638',true).
concept_accession('39688: rn:R03660','KEGG','RNO:301544',true).
concept_accession('39688: rn:R03660','KEGG','288917',true).
concept_accession('39688: rn:R03660','KEGG','RNO:288917',true).
concept_accession('39688: rn:R03660','KEGG','RNO:306879',true).
concept_accession('39688: rn:R03660','KEGG','6.1.1.20',true).
concept_accession('39688: rn:R03660','KEGG','EC:6.1.1.20',true).
concept_accession('39688: rn:R03660','KEGG','306879',true).
concept_accession('39688: rn:R03660','KEGG','301544',true).
concept_accession('39688: rn:R03660','EC','6.1.1.20',true).
concept_accession('39687: rn:R03646','EC','6.1.1.19',true).
concept_accession('39687: rn:R03646','KEGG','287191',true).
concept_accession('39687: rn:R03646','KEGG','RNO:287191',true).
concept_accession('39687: rn:R03646','KEGG','6.1.1.19',true).
concept_accession('39687: rn:R03646','KEGG','RNO:297969',true).
concept_accession('39687: rn:R03646','KEGG','297969',true).
concept_accession('39687: rn:R03646','KEGG','EC:6.1.1.19',true).
concept_accession('39686: rn:R03648','EC','6.1.1.22',true).
concept_accession('39686: rn:R03648','KEGG','6.1.1.22',true).
concept_accession('39686: rn:R03648','KEGG','RNO:293128',true).
concept_accession('39686: rn:R03648','KEGG','291556',true).
concept_accession('39686: rn:R03648','KEGG','EC:6.1.1.22',true).
concept_accession('39686: rn:R03648','KEGG','RNO:291556',true).
concept_accession('39686: rn:R03648','KEGG','293128',true).
concept_accession('39685: rn:R03655','KEGG','6.1.1.21',true).
concept_accession('39685: rn:R03655','KEGG','EC:6.1.1.21',true).
concept_accession('39685: rn:R03655','KEGG','307491',true).
concept_accession('39685: rn:R03655','KEGG','RNO:307492',true).
concept_accession('39685: rn:R03655','KEGG','307492',true).
concept_accession('39685: rn:R03655','KEGG','RNO:307491',true).
concept_accession('39685: rn:R03655','EC','6.1.1.21',true).
concept_accession('39684: rn:R03656','KEGG','6.1.1.5',true).
concept_accession('39684: rn:R03656','KEGG','306804',true).
concept_accession('39684: rn:R03656','KEGG','RNO:306804',true).
concept_accession('39684: rn:R03656','KEGG','EC:6.1.1.5',true).
concept_accession('39684: rn:R03656','EC','6.1.1.5',true).
concept_accession('39683: rn:R02661','KEGG','367046',true).
concept_accession('39683: rn:R02661','EC','1.3.99.-',true).
concept_accession('39683: rn:R02661','KEGG','RNO:367046',true).
concept_accession('39683: rn:R02661','KEGG','EC:1.3.99.-',true).
concept_accession('39683: rn:R02661','KEGG','1.3.99.-',true).
concept_accession('39682: rn:R01214','KEGG','64203',true).
concept_accession('39682: rn:R01214','KEGG','RNO:64203',true).
concept_accession('39682: rn:R01214','KEGG','EC:2.6.1.42',true).
concept_accession('39682: rn:R01214','KEGG','RNO:29592',true).
concept_accession('39682: rn:R01214','KEGG','29592',true).
concept_accession('39682: rn:R01214','KEGG','2.6.1.42',true).
concept_accession('39682: rn:R01214','EC','2.6.1.42',true).
concept_accession('39681: rn:R03665','KEGG','25009',true).
concept_accession('39681: rn:R03665','KEGG','6.1.1.9',true).
concept_accession('39681: rn:R03665','KEGG','309596',true).
concept_accession('39681: rn:R03665','KEGG','RNO:25009',true).
concept_accession('39681: rn:R03665','EC','6.1.1.9',true).
concept_accession('39681: rn:R03665','KEGG','EC:6.1.1.9',true).
concept_accession('39681: rn:R03665','KEGG','RNO:309596',true).
concept_accession('39680: rn:R00529','KEGG','2.7.7.4',true).
concept_accession('39680: rn:R00529','KEGG','EC:2.7.7.4',true).
concept_accession('39680: rn:R00529','KEGG','RNO:295443',true).
concept_accession('39680: rn:R00529','KEGG','295443',true).
concept_accession('39680: rn:R00529','EC','2.7.7.4',true).
concept_accession('39680: rn:R00529','KEGG','RNO:294103',true).
concept_accession('39680: rn:R00529','KEGG','294103',true).
concept_accession('39710: rn:R01939','KEGG','EC:2.6.1.39',true).
concept_accession('39710: rn:R01939','KEGG','RNO:29416',true).
concept_accession('39710: rn:R01939','EC','2.6.1.39',true).
concept_accession('39710: rn:R01939','KEGG','29416',true).
concept_accession('39710: rn:R01939','KEGG','2.6.1.39',true).
concept_accession('39711: rn:R04390','KEGG','1.2.1.31',true).
concept_accession('39711: rn:R04390','KEGG','RNO:291450',true).
concept_accession('39711: rn:R04390','EC','1.2.1.31',true).
concept_accession('39711: rn:R04390','KEGG','291450',true).
concept_accession('39711: rn:R04390','KEGG','EC:1.2.1.31',true).
concept_accession('39708: rn:R08224','KEGG','RNO:679383',true).
concept_accession('39708: rn:R08224','KEGG','EC:2.9.1.2',true).
concept_accession('39708: rn:R08224','EC','2.9.1.2',true).
concept_accession('39708: rn:R08224','KEGG','679383',true).
concept_accession('39708: rn:R08224','KEGG','2.9.1.2',true).
concept_accession('39709: rn:R08218','KEGG','6.1.1.11',true).
concept_accession('39709: rn:R08218','KEGG','266975',true).
concept_accession('39709: rn:R08218','KEGG','RNO:266975',true).
concept_accession('39709: rn:R08218','KEGG','EC:6.1.1.11',true).
concept_accession('39709: rn:R08218','KEGG','RNO:292759',true).
concept_accession('39709: rn:R08218','KEGG','292759',true).
concept_accession('39709: rn:R08218','EC','6.1.1.11',true).
concept_accession('39706: rn:R00014','KEGG','RNO:117098',true).
concept_accession('39706: rn:R00014','EC','1.2.4.1',true).
concept_accession('39706: rn:R00014','KEGG','RNO:289950',true).
concept_accession('39706: rn:R00014','KEGG','1.2.4.1',true).
concept_accession('39706: rn:R00014','KEGG','117098',true).
concept_accession('39706: rn:R00014','KEGG','289950',true).
concept_accession('39706: rn:R00014','KEGG','29554',true).
concept_accession('39706: rn:R00014','KEGG','RNO:29554',true).
concept_accession('39706: rn:R00014','KEGG','EC:1.2.4.1',true).
concept_accession('39707: rn:R04863','KEGG','1.2.1.31',true).
concept_accession('39707: rn:R04863','KEGG','RNO:291450',true).
concept_accession('39707: rn:R04863','EC','1.2.1.31',true).
concept_accession('39707: rn:R04863','KEGG','291450',true).
concept_accession('39707: rn:R04863','KEGG','EC:1.2.1.31',true).
concept_accession('39704: rn:R03661','KEGG','EC:6.1.1.15',true).
concept_accession('39704: rn:R03661','KEGG','289352',true).
concept_accession('39704: rn:R03661','KEGG','313429',true).
concept_accession('39704: rn:R03661','KEGG','RNO:289352',true).
concept_accession('39704: rn:R03661','KEGG','RNO:313429',true).
concept_accession('39704: rn:R03661','KEGG','6.1.1.15',true).
concept_accession('39704: rn:R03661','EC','6.1.1.15',true).
concept_accession('39705: rn:R05578','KEGG','RNO:361641',true).
concept_accession('39705: rn:R05578','KEGG','6.1.1.24',true).
concept_accession('39705: rn:R05578','EC','6.1.1.24',true).
concept_accession('39705: rn:R05578','KEGG','289352',true).
concept_accession('39705: rn:R05578','KEGG','361641',true).
concept_accession('39705: rn:R05578','KEGG','RNO:289352',true).
concept_accession('39705: rn:R05578','KEGG','EC:6.1.1.24',true).
concept_accession('39702: rn:R03940','KEGG','2.1.2.9',true).
concept_accession('39702: rn:R03940','KEGG','RNO:315763',true).
concept_accession('39702: rn:R03940','EC','2.1.2.9',true).
concept_accession('39702: rn:R03940','KEGG','315763',true).
concept_accession('39702: rn:R03940','KEGG','EC:2.1.2.9',true).
concept_accession('39703: rn:R02918','EC','6.1.1.1',true).
concept_accession('39703: rn:R02918','KEGG','6.1.1.1',true).
concept_accession('39703: rn:R02918','KEGG','313047',true).
concept_accession('39703: rn:R02918','KEGG','EC:6.1.1.1',true).
concept_accession('39703: rn:R02918','KEGG','287924',true).
concept_accession('39703: rn:R02918','KEGG','RNO:313047',true).
concept_accession('39703: rn:R02918','KEGG','RNO:287924',true).
concept_accession('39700: rn:R03656','KEGG','6.1.1.5',true).
concept_accession('39700: rn:R03656','KEGG','306804',true).
concept_accession('39700: rn:R03656','KEGG','RNO:306804',true).
concept_accession('39700: rn:R03656','KEGG','EC:6.1.1.5',true).
concept_accession('39700: rn:R03656','EC','6.1.1.5',true).
concept_accession('39701: rn:R03664','KEGG','314442',true).
concept_accession('39701: rn:R03664','EC','6.1.1.2',true).
concept_accession('39701: rn:R03664','KEGG','RNO:690654',true).
concept_accession('39701: rn:R03664','KEGG','EC:6.1.1.2',true).
concept_accession('39701: rn:R03664','KEGG','6.1.1.2',true).
concept_accession('39701: rn:R03664','KEGG','690654',true).
concept_accession('39701: rn:R03664','KEGG','RNO:314442',true).
concept_accession('39698: rn:R03658','KEGG','6.1.1.6',true).
concept_accession('39698: rn:R03658','KEGG','292028',true).
concept_accession('39698: rn:R03658','KEGG','EC:6.1.1.6',true).
concept_accession('39698: rn:R03658','KEGG','RNO:292028',true).
concept_accession('39698: rn:R03658','EC','6.1.1.6',true).
concept_accession('39699: rn:R03663','EC','6.1.1.3',true).
concept_accession('39699: rn:R03663','KEGG','310672',true).
concept_accession('39699: rn:R03663','KEGG','EC:6.1.1.3',true).
concept_accession('39699: rn:R03663','KEGG','RNO:294810',true).
concept_accession('39699: rn:R03663','KEGG','RNO:308701',true).
concept_accession('39699: rn:R03663','KEGG','308701',true).
concept_accession('39699: rn:R03663','KEGG','6.1.1.3',true).
concept_accession('39699: rn:R03663','KEGG','294810',true).
concept_accession('39699: rn:R03663','KEGG','RNO:310672',true).
concept_accession('39696: rn:R03665','KEGG','25009',true).
concept_accession('39696: rn:R03665','KEGG','6.1.1.9',true).
concept_accession('39696: rn:R03665','KEGG','309596',true).
concept_accession('39696: rn:R03665','KEGG','RNO:25009',true).
concept_accession('39696: rn:R03665','EC','6.1.1.9',true).
concept_accession('39696: rn:R03665','KEGG','EC:6.1.1.9',true).
concept_accession('39696: rn:R03665','KEGG','RNO:309596',true).
concept_accession('39697: rn:R03657','KEGG','6.1.1.4',true).
concept_accession('39697: rn:R03657','KEGG','363172',true).
concept_accession('39697: rn:R03657','KEGG','291624',true).
concept_accession('39697: rn:R03657','KEGG','RNO:363172',true).
concept_accession('39697: rn:R03657','KEGG','RNO:291624',true).
concept_accession('39697: rn:R03657','KEGG','EC:6.1.1.4',true).
concept_accession('39697: rn:R03657','EC','6.1.1.4',true).
concept_accession('39725: rn:R07603','KEGG','1.2.4.4',true).
concept_accession('39725: rn:R07603','EC','1.2.4.4',true).
concept_accession('39725: rn:R07603','KEGG','RNO:29711',true).
concept_accession('39725: rn:R07603','KEGG','29711',true).
concept_accession('39725: rn:R07603','KEGG','25244',true).
concept_accession('39725: rn:R07603','KEGG','RNO:25244',true).
concept_accession('39725: rn:R07603','KEGG','EC:1.2.4.4',true).
concept_accession('39724: rn:R04095','KEGG','24513',true).
concept_accession('39724: rn:R04095','KEGG','EC:1.3.99.3',true).
concept_accession('39724: rn:R04095','KEGG','1.3.99.3',true).
concept_accession('39724: rn:R04095','KEGG','RNO:24513',true).
concept_accession('39724: rn:R04095','EC','1.3.99.3',true).
concept_accession('39727: rn:R04137','KEGG','RNO:170670',true).
concept_accession('39727: rn:R04137','KEGG','171142',true).
concept_accession('39727: rn:R04137','KEGG','RNO:171142',true).
concept_accession('39727: rn:R04137','EC','4.2.1.17',true).
concept_accession('39727: rn:R04137','KEGG','170670',true).
concept_accession('39727: rn:R04137','KEGG','RNO:140547',true).
concept_accession('39727: rn:R04137','KEGG','140547',true).
concept_accession('39727: rn:R04137','KEGG','4.2.1.17',true).
concept_accession('39727: rn:R04137','KEGG','EC:4.2.1.17',true).
concept_accession('39726: rn:R04138','KEGG','RNO:361884',true).
concept_accession('39726: rn:R04138','KEGG','6.4.1.4',true).
concept_accession('39726: rn:R04138','EC','6.4.1.4',true).
concept_accession('39726: rn:R04138','KEGG','EC:6.4.1.4',true).
concept_accession('39726: rn:R04138','KEGG','361884',true).
concept_accession('39726: rn:R04138','KEGG','294972',true).
concept_accession('39726: rn:R04138','KEGG','RNO:294972',true).
concept_accession('39721: rn:R02003','EC','2.5.1.10',true).
concept_accession('39721: rn:R02003','KEGG','RNO:291211',true).
concept_accession('39721: rn:R02003','KEGG','EC:2.5.1.10',true).
concept_accession('39721: rn:R02003','KEGG','83791',true).
concept_accession('39721: rn:R02003','KEGG','2.5.1.10',true).
concept_accession('39721: rn:R02003','KEGG','RNO:83791',true).
concept_accession('39721: rn:R02003','KEGG','291211',true).
concept_accession('39720: rn:R03245','KEGG','RNO:310645',true).
concept_accession('39720: rn:R03245','KEGG','310645',true).
concept_accession('39720: rn:R03245','KEGG','2.7.4.2',true).
concept_accession('39720: rn:R03245','KEGG','EC:2.7.4.2',true).
concept_accession('39720: rn:R03245','EC','2.7.4.2',true).
concept_accession('39723: rn:R05556','EC','2.5.1.87',true).
concept_accession('39723: rn:R05556','KEGG','298541',true).
concept_accession('39723: rn:R05556','KEGG','RNO:298541',true).
concept_accession('39723: rn:R05556','KEGG','2.5.1.87',true).
concept_accession('39723: rn:R05556','KEGG','EC:2.5.1.87',true).
concept_accession('39722: rn:R09249','KEGG','365592',true).
concept_accession('39722: rn:R09249','KEGG','RNO:100364990',true).
concept_accession('39722: rn:R09249','EC','2.5.1.91',true).
concept_accession('39722: rn:R09249','KEGG','2.5.1.91',true).
concept_accession('39722: rn:R09249','KEGG','RNO:365592',true).
concept_accession('39722: rn:R09249','KEGG','100364990',true).
concept_accession('39722: rn:R09249','KEGG','EC:2.5.1.91',true).
concept_accession('39717: rn:R07618','KEGG','298942',true).
concept_accession('39717: rn:R07618','KEGG','1.8.1.4',true).
concept_accession('39717: rn:R07618','KEGG','EC:1.8.1.4',true).
concept_accession('39717: rn:R07618','KEGG','RNO:298942',true).
concept_accession('39717: rn:R07618','EC','1.8.1.4',true).
concept_accession('39716: rn:R07604','KEGG','1.2.4.4',true).
concept_accession('39716: rn:R07604','EC','1.2.4.4',true).
concept_accession('39716: rn:R07604','KEGG','RNO:29711',true).
concept_accession('39716: rn:R07604','KEGG','29711',true).
concept_accession('39716: rn:R07604','KEGG','25244',true).
concept_accession('39716: rn:R07604','KEGG','RNO:25244',true).
concept_accession('39716: rn:R07604','KEGG','EC:1.2.4.4',true).
concept_accession('39719: rn:R01121','KEGG','81726',true).
concept_accession('39719: rn:R01121','EC','4.1.1.33',true).
concept_accession('39719: rn:R01121','KEGG','RNO:81726',true).
concept_accession('39719: rn:R01121','KEGG','EC:4.1.1.33',true).
concept_accession('39719: rn:R01121','KEGG','4.1.1.33',true).
concept_accession('39718: rn:R01658','KEGG','2.5.1.1',true).
concept_accession('39718: rn:R01658','KEGG','EC:2.5.1.1',true).
concept_accession('39718: rn:R01658','KEGG','RNO:291211',true).
concept_accession('39718: rn:R01658','KEGG','83791',true).
concept_accession('39718: rn:R01658','EC','2.5.1.1',true).
concept_accession('39718: rn:R01658','KEGG','RNO:83791',true).
concept_accession('39718: rn:R01658','KEGG','291211',true).
concept_accession('39713: rn:R00716','KEGG','RNO:296925',true).
concept_accession('39713: rn:R00716','EC','1.5.1.8',true).
concept_accession('39713: rn:R00716','KEGG','296925',true).
concept_accession('39713: rn:R00716','KEGG','1.5.1.8',true).
concept_accession('39713: rn:R00716','KEGG','EC:1.5.1.8',true).
concept_accession('39712: rn:R03098','KEGG','1.2.1.31',true).
concept_accession('39712: rn:R03098','KEGG','RNO:291450',true).
concept_accession('39712: rn:R03098','EC','1.2.1.31',true).
concept_accession('39712: rn:R03098','KEGG','291450',true).
concept_accession('39712: rn:R03098','KEGG','EC:1.2.1.31',true).
concept_accession('39715: rn:R02061','KEGG','2.5.1.29',true).
concept_accession('39715: rn:R02061','KEGG','EC:2.5.1.29',true).
concept_accession('39715: rn:R02061','KEGG','RNO:291211',true).
concept_accession('39715: rn:R02061','EC','2.5.1.29',true).
concept_accession('39715: rn:R02061','KEGG','291211',true).
concept_accession('39714: rn:R02869','EC','2.5.1.22',true).
concept_accession('39714: rn:R02869','KEGG','EC:2.5.1.22',true).
concept_accession('39714: rn:R02869','KEGG','683008',true).
concept_accession('39714: rn:R02869','KEGG','RNO:683008',true).
concept_accession('39714: rn:R02869','KEGG','2.5.1.22',true).
concept_accession('39740: rn:R00243 rn:R00248','KEGG','RNO:24399',true).
concept_accession('39740: rn:R00243 rn:R00248','KEGG','24399',true).
concept_accession('39740: rn:R00243 rn:R00248','KEGG','1.4.1.3',true).
concept_accession('39740: rn:R00243 rn:R00248','EC','1.4.1.3',true).
concept_accession('39740: rn:R00243 rn:R00248','KEGG','EC:1.4.1.3',true).
concept_accession('39741: rn:R00256','KEGG','RNO:192268',true).
concept_accession('39741: rn:R00256','KEGG','24398',true).
concept_accession('39741: rn:R00256','KEGG','RNO:24398',true).
concept_accession('39741: rn:R00256','KEGG','EC:3.5.1.2',true).
concept_accession('39741: rn:R00256','KEGG','3.5.1.2',true).
concept_accession('39741: rn:R00256','KEGG','192268',true).
concept_accession('39741: rn:R00256','EC','3.5.1.2',true).
concept_accession('39742: rn:R07600','KEGG','1.2.4.4',true).
concept_accession('39742: rn:R07600','EC','1.2.4.4',true).
concept_accession('39742: rn:R07600','KEGG','RNO:29711',true).
concept_accession('39742: rn:R07600','KEGG','29711',true).
concept_accession('39742: rn:R07600','KEGG','25244',true).
concept_accession('39742: rn:R07600','KEGG','RNO:25244',true).
concept_accession('39742: rn:R07600','KEGG','EC:1.2.4.4',true).
concept_accession('39743: rn:R07618','KEGG','298942',true).
concept_accession('39743: rn:R07618','KEGG','1.8.1.4',true).
concept_accession('39743: rn:R07618','KEGG','EC:1.8.1.4',true).
concept_accession('39743: rn:R07618','KEGG','RNO:298942',true).
concept_accession('39743: rn:R07618','EC','1.8.1.4',true).
concept_accession('39736: rn:R00410','KEGG','RNO:100361036',true).
concept_accession('39736: rn:R00410','KEGG','EC:2.8.3.5',true).
concept_accession('39736: rn:R00410','KEGG','100361036',true).
concept_accession('39736: rn:R00410','EC','2.8.3.5',true).
concept_accession('39736: rn:R00410','KEGG','RNO:690163',true).
concept_accession('39736: rn:R00410','KEGG','100365119',true).
concept_accession('39736: rn:R00410','KEGG','100359544',true).
concept_accession('39736: rn:R00410','KEGG','2.8.3.5',true).
concept_accession('39736: rn:R00410','KEGG','RNO:366463',true).
concept_accession('39736: rn:R00410','KEGG','RNO:100365119',true).
concept_accession('39736: rn:R00410','KEGG','RNO:100359544',true).
concept_accession('39736: rn:R00410','KEGG','690163',true).
concept_accession('39736: rn:R00410','KEGG','366463',true).
concept_accession('39737: rn:R00578','KEGG','EC:6.3.5.4',true).
concept_accession('39737: rn:R00578','KEGG','25612',true).
concept_accession('39737: rn:R00578','KEGG','RNO:25612',true).
concept_accession('39737: rn:R00578','EC','6.3.5.4',true).
concept_accession('39737: rn:R00578','KEGG','6.3.5.4',true).
concept_accession('39738: rn:R07602','KEGG','1.2.4.4',true).
concept_accession('39738: rn:R07602','EC','1.2.4.4',true).
concept_accession('39738: rn:R07602','KEGG','RNO:29711',true).
concept_accession('39738: rn:R07602','KEGG','29711',true).
concept_accession('39738: rn:R07602','KEGG','25244',true).
concept_accession('39738: rn:R07602','KEGG','RNO:25244',true).
concept_accession('39738: rn:R07602','KEGG','EC:1.2.4.4',true).
concept_accession('39739: rn:R07618','KEGG','298942',true).
concept_accession('39739: rn:R07618','KEGG','1.8.1.4',true).
concept_accession('39739: rn:R07618','KEGG','EC:1.8.1.4',true).
concept_accession('39739: rn:R07618','KEGG','RNO:298942',true).
concept_accession('39739: rn:R07618','EC','1.8.1.4',true).
concept_accession('39732: rn:R00149','KEGG','6.3.4.16',true).
concept_accession('39732: rn:R00149','KEGG','EC:6.3.4.16',true).
concept_accession('39732: rn:R00149','EC','6.3.4.16',true).
concept_accession('39732: rn:R00149','KEGG','RNO:497840',true).
concept_accession('39732: rn:R00149','KEGG','497840',true).
concept_accession('39733: rn:R01360','KEGG','EC:4.1.3.4',true).
concept_accession('39733: rn:R01360','KEGG','79238',true).
concept_accession('39733: rn:R01360','EC','4.1.3.4',true).
concept_accession('39733: rn:R01360','KEGG','RNO:79238',true).
concept_accession('39733: rn:R01360','KEGG','4.1.3.4',true).
concept_accession('39734: rn:R02085','KEGG','EC:4.2.1.18',true).
concept_accession('39734: rn:R02085','KEGG','361215',true).
concept_accession('39734: rn:R02085','KEGG','RNO:361215',true).
concept_accession('39734: rn:R02085','EC','4.2.1.18',true).
concept_accession('39734: rn:R02085','KEGG','4.2.1.18',true).
concept_accession('39735: rn:R01978','KEGG','EC:2.3.3.10',true).
concept_accession('39735: rn:R01978','KEGG','RNO:29637',true).
concept_accession('39735: rn:R01978','KEGG','RNO:24450',true).
concept_accession('39735: rn:R01978','KEGG','2.3.3.10',true).
concept_accession('39735: rn:R01978','KEGG','24450',true).
concept_accession('39735: rn:R01978','EC','2.3.3.10',true).
concept_accession('39735: rn:R01978','KEGG','29637',true).
concept_accession('39728: rn:R00927','KEGG','EC:2.3.1.16',true).
concept_accession('39728: rn:R00927','KEGG','24157',true).
concept_accession('39728: rn:R00927','KEGG','501072',true).
concept_accession('39728: rn:R00927','KEGG','RNO:171155',true).
concept_accession('39728: rn:R00927','KEGG','RNO:24157',true).
concept_accession('39728: rn:R00927','KEGG','171155',true).
concept_accession('39728: rn:R00927','KEGG','RNO:501072',true).
concept_accession('39728: rn:R00927','KEGG','2.3.1.16',true).
concept_accession('39728: rn:R00927','EC','2.3.1.16',true).
concept_accession('39728: rn:R00927','KEGG','RNO:170465',true).
concept_accession('39728: rn:R00927','KEGG','170465',true).
concept_accession('39729: rn:R05066','KEGG','1.1.1.31',true).
concept_accession('39729: rn:R05066','KEGG','171142',true).
concept_accession('39729: rn:R05066','KEGG','RNO:171142',true).
concept_accession('39729: rn:R05066','KEGG','RNO:113965',true).
concept_accession('39729: rn:R05066','EC','1.1.1.31',true).
concept_accession('39729: rn:R05066','KEGG','113965',true).
concept_accession('39729: rn:R05066','KEGG','EC:1.1.1.31',true).
concept_accession('39730: rn:R01214','KEGG','64203',true).
concept_accession('39730: rn:R01214','KEGG','RNO:64203',true).
concept_accession('39730: rn:R01214','KEGG','EC:2.6.1.42',true).
concept_accession('39730: rn:R01214','KEGG','RNO:29592',true).
concept_accession('39730: rn:R01214','KEGG','29592',true).
concept_accession('39730: rn:R01214','KEGG','2.6.1.42',true).
concept_accession('39730: rn:R01214','EC','2.6.1.42',true).
concept_accession('39731: rn:R00238','KEGG','2.3.1.9',true).
concept_accession('39731: rn:R00238','KEGG','EC:2.3.1.9',true).
concept_accession('39731: rn:R00238','EC','2.3.1.9',true).
concept_accession('39731: rn:R00238','KEGG','RNO:308100',true).
concept_accession('39731: rn:R00238','KEGG','RNO:25014',true).
concept_accession('39731: rn:R00238','KEGG','25014',true).
concept_accession('39731: rn:R00238','KEGG','308100',true).
concept_accession('39755: rn:R04203','KEGG','171142',true).
concept_accession('39755: rn:R04203','KEGG','RNO:171142',true).
concept_accession('39755: rn:R04203','KEGG','RNO:63864',true).
concept_accession('39755: rn:R04203','EC','1.1.1.35',true).
concept_accession('39755: rn:R04203','KEGG','RNO:113965',true).
concept_accession('39755: rn:R04203','KEGG','EC:1.1.1.35',true).
concept_accession('39755: rn:R04203','KEGG','1.1.1.35',true).
concept_accession('39755: rn:R04203','KEGG','113965',true).
concept_accession('39755: rn:R04203','KEGG','63864',true).
concept_accession('39754: rn:R03172','KEGG','RNO:25618',true).
concept_accession('39754: rn:R03172','KEGG','25618',true).
concept_accession('39754: rn:R03172','KEGG','EC:1.3.99.3',true).
concept_accession('39754: rn:R03172','KEGG','1.3.99.3',true).
concept_accession('39754: rn:R03172','EC','1.3.99.3',true).
concept_accession('39753: rn:R02661','KEGG','RNO:24158',true).
concept_accession('39753: rn:R02661','EC','1.3.99.-',true).
concept_accession('39753: rn:R02661','KEGG','24158',true).
concept_accession('39753: rn:R02661','KEGG','EC:1.3.99.-',true).
concept_accession('39753: rn:R02661','KEGG','1.3.99.-',true).
concept_accession('39752: rn:R04224','KEGG','RNO:170670',true).
concept_accession('39752: rn:R04224','KEGG','171142',true).
concept_accession('39752: rn:R04224','KEGG','RNO:171142',true).
concept_accession('39752: rn:R04224','EC','4.2.1.17',true).
concept_accession('39752: rn:R04224','KEGG','170670',true).
concept_accession('39752: rn:R04224','KEGG','RNO:140547',true).
concept_accession('39752: rn:R04224','KEGG','140547',true).
concept_accession('39752: rn:R04224','KEGG','4.2.1.17',true).
concept_accession('39752: rn:R04224','KEGG','EC:4.2.1.17',true).
concept_accession('39759: rn:R03871','KEGG','RNO:316421',true).
concept_accession('39759: rn:R03871','KEGG','RNO:54349',true).
concept_accession('39759: rn:R03871','EC','1.2.3.1',true).
concept_accession('39759: rn:R03871','KEGG','EC:1.2.3.1',true).
concept_accession('39759: rn:R03871','KEGG','54349',true).
concept_accession('39759: rn:R03871','KEGG','316421',true).
concept_accession('39759: rn:R03871','KEGG','1.2.3.1',true).
concept_accession('39758: rn:R05066','KEGG','63938',true).
concept_accession('39758: rn:R05066','KEGG','1.1.1.31',true).
concept_accession('39758: rn:R05066','KEGG','RNO:63938',true).
concept_accession('39758: rn:R05066','EC','1.1.1.31',true).
concept_accession('39758: rn:R05066','KEGG','EC:1.1.1.31',true).
concept_accession('39757: rn:R05064','KEGG','RNO:301384',true).
concept_accession('39757: rn:R05064','KEGG','3.1.2.4',true).
concept_accession('39757: rn:R05064','KEGG','EC:3.1.2.4',true).
concept_accession('39757: rn:R05064','EC','3.1.2.4',true).
concept_accession('39757: rn:R05064','KEGG','301384',true).
concept_accession('39756: rn:R04188','KEGG','2.6.1.22',true).
concept_accession('39756: rn:R04188','EC','2.6.1.22',true).
concept_accession('39756: rn:R04188','KEGG','RNO:81632',true).
concept_accession('39756: rn:R04188','KEGG','EC:2.6.1.22',true).
concept_accession('39756: rn:R04188','KEGG','81632',true).
concept_accession('39747: rn:R02662','KEGG','2.3.1.168',true).
concept_accession('39747: rn:R02662','KEGG','29611',true).
concept_accession('39747: rn:R02662','KEGG','EC:2.3.1.168',true).
concept_accession('39747: rn:R02662','EC','2.3.1.168',true).
concept_accession('39747: rn:R02662','KEGG','RNO:29611',true).
concept_accession('39746: rn:R03172','KEGG','RNO:24158',true).
concept_accession('39746: rn:R03172','KEGG','24158',true).
concept_accession('39746: rn:R03172','KEGG','EC:1.3.99.3',true).
concept_accession('39746: rn:R03172','KEGG','1.3.99.3',true).
concept_accession('39746: rn:R03172','EC','1.3.99.3',true).
concept_accession('39745: rn:R04095','KEGG','RNO:24158',true).
concept_accession('39745: rn:R04095','KEGG','24158',true).
concept_accession('39745: rn:R04095','KEGG','EC:1.3.99.3',true).
concept_accession('39745: rn:R04095','KEGG','1.3.99.3',true).
concept_accession('39745: rn:R04095','EC','1.3.99.3',true).
concept_accession('39744: rn:R01168','EC','4.3.1.3',true).
concept_accession('39744: rn:R01168','KEGG','29301',true).
concept_accession('39744: rn:R01168','KEGG','4.3.1.3',true).
concept_accession('39744: rn:R01168','KEGG','RNO:29301',true).
concept_accession('39744: rn:R01168','KEGG','EC:4.3.1.3',true).
concept_accession('39751: rn:R04203','KEGG','RNO:63864',true).
concept_accession('39751: rn:R04203','EC','1.1.1.35',true).
concept_accession('39751: rn:R04203','KEGG','EC:1.1.1.35',true).
concept_accession('39751: rn:R04203','KEGG','1.1.1.35',true).
concept_accession('39751: rn:R04203','KEGG','63864',true).
concept_accession('39750: rn:R01090','KEGG','64203',true).
concept_accession('39750: rn:R01090','KEGG','RNO:64203',true).
concept_accession('39750: rn:R01090','KEGG','EC:2.6.1.42',true).
concept_accession('39750: rn:R01090','KEGG','RNO:29592',true).
concept_accession('39750: rn:R01090','KEGG','29592',true).
concept_accession('39750: rn:R01090','KEGG','2.6.1.42',true).
concept_accession('39750: rn:R01090','EC','2.6.1.42',true).
concept_accession('39749: rn:R04097','KEGG','2.3.1.168',true).
concept_accession('39749: rn:R04097','KEGG','29611',true).
concept_accession('39749: rn:R04097','KEGG','EC:2.3.1.168',true).
concept_accession('39749: rn:R04097','EC','2.3.1.168',true).
concept_accession('39749: rn:R04097','KEGG','RNO:29611',true).
concept_accession('39748: rn:R07601','KEGG','1.2.4.4',true).
concept_accession('39748: rn:R07601','EC','1.2.4.4',true).
concept_accession('39748: rn:R07601','KEGG','RNO:29711',true).
concept_accession('39748: rn:R07601','KEGG','29711',true).
concept_accession('39748: rn:R07601','KEGG','25244',true).
concept_accession('39748: rn:R07601','KEGG','RNO:25244',true).
concept_accession('39748: rn:R07601','KEGG','EC:1.2.4.4',true).
concept_accession('39770: rn:R03174','KEGG','2.3.1.168',true).
concept_accession('39770: rn:R03174','KEGG','29611',true).
concept_accession('39770: rn:R03174','KEGG','EC:2.3.1.168',true).
concept_accession('39770: rn:R03174','EC','2.3.1.168',true).
concept_accession('39770: rn:R03174','KEGG','RNO:29611',true).
concept_accession('39771: rn:R00132','KEGG','29242',true).
concept_accession('39771: rn:R00132','KEGG','RNO:363085',true).
concept_accession('39771: rn:R00132','KEGG','291819',true).
concept_accession('39771: rn:R00132','KEGG','499566',true).
concept_accession('39771: rn:R00132','KEGG','RNO:298657',true).
concept_accession('39771: rn:R00132','KEGG','RNO:302669',true).
concept_accession('39771: rn:R00132','KEGG','RNO:54231',true).
concept_accession('39771: rn:R00132','KEGG','RNO:54232',true).
concept_accession('39771: rn:R00132','KEGG','RNO:54233',true).
concept_accession('39771: rn:R00132','KEGG','4.2.1.1',true).
concept_accession('39771: rn:R00132','KEGG','298657',true).
concept_accession('39771: rn:R00132','KEGG','313495',true).
concept_accession('39771: rn:R00132','KEGG','RNO:291819',true).
concept_accession('39771: rn:R00132','KEGG','RNO:499566',true).
concept_accession('39771: rn:R00132','KEGG','RNO:791259',true).
concept_accession('39771: rn:R00132','KEGG','EC:4.2.1.1',true).
concept_accession('39771: rn:R00132','KEGG','RNO:297814',true).
concept_accession('39771: rn:R00132','KEGG','310218',true).
concept_accession('39771: rn:R00132','KEGG','297814',true).
concept_accession('39771: rn:R00132','KEGG','RNO:288360',true).
concept_accession('39771: rn:R00132','KEGG','302669',true).
concept_accession('39771: rn:R00132','KEGG','288360',true).
concept_accession('39771: rn:R00132','KEGG','RNO:29242',true).
concept_accession('39771: rn:R00132','KEGG','363085',true).
concept_accession('39771: rn:R00132','KEGG','791259',true).
concept_accession('39771: rn:R00132','KEGG','54232',true).
concept_accession('39771: rn:R00132','KEGG','54233',true).
concept_accession('39771: rn:R00132','EC','4.2.1.1',true).
concept_accession('39771: rn:R00132','KEGG','RNO:313495',true).
concept_accession('39771: rn:R00132','KEGG','RNO:310218',true).
concept_accession('39771: rn:R00132','KEGG','54231',true).
concept_accession('39768: rn:R04204','KEGG','RNO:170670',true).
concept_accession('39768: rn:R04204','KEGG','171142',true).
concept_accession('39768: rn:R04204','KEGG','RNO:171142',true).
concept_accession('39768: rn:R04204','EC','4.2.1.17',true).
concept_accession('39768: rn:R04204','KEGG','170670',true).
concept_accession('39768: rn:R04204','KEGG','RNO:140547',true).
concept_accession('39768: rn:R04204','KEGG','140547',true).
concept_accession('39768: rn:R04204','KEGG','4.2.1.17',true).
concept_accession('39768: rn:R04204','KEGG','EC:4.2.1.17',true).
concept_accession('39769: rn:R07599','KEGG','1.2.4.4',true).
concept_accession('39769: rn:R07599','EC','1.2.4.4',true).
concept_accession('39769: rn:R07599','KEGG','RNO:29711',true).
concept_accession('39769: rn:R07599','KEGG','29711',true).
concept_accession('39769: rn:R07599','KEGG','25244',true).
concept_accession('39769: rn:R07599','KEGG','RNO:25244',true).
concept_accession('39769: rn:R07599','KEGG','EC:1.2.4.4',true).
concept_accession('39774: rn:R01001','KEGG','EC:4.4.1.1',true).
concept_accession('39774: rn:R01001','EC','4.4.1.1',true).
concept_accession('39774: rn:R01001','KEGG','24962',true).
concept_accession('39774: rn:R01001','KEGG','RNO:24962',true).
concept_accession('39774: rn:R01001','KEGG','4.4.1.1',true).
concept_accession('39775: rn:R01242','KEGG','2.8.2.1',true).
concept_accession('39775: rn:R01242','KEGG','83783',true).
concept_accession('39775: rn:R01242','KEGG','RNO:83783',true).
concept_accession('39775: rn:R01242','KEGG','EC:2.8.2.1',true).
concept_accession('39775: rn:R01242','EC','2.8.2.1',true).
concept_accession('39772: rn:R01221','KEGG','EC:2.1.2.10',true).
concept_accession('39772: rn:R01221','EC','2.1.2.10',true).
concept_accession('39772: rn:R01221','KEGG','2.1.2.10',true).
concept_accession('39772: rn:R01221','KEGG','RNO:306586',true).
concept_accession('39772: rn:R01221','KEGG','306586',true).
concept_accession('39773: rn:R00253','KEGG','RNO:24957',true).
concept_accession('39773: rn:R00253','KEGG','EC:6.3.1.2',true).
concept_accession('39773: rn:R00253','KEGG','24957',true).
concept_accession('39773: rn:R00253','EC','6.3.1.2',true).
concept_accession('39773: rn:R00253','KEGG','6.3.1.2',true).
concept_accession('39762: rn:R03869','KEGG','1.2.1.3',true).
concept_accession('39762: rn:R03869','KEGG','RNO:291450',true).
concept_accession('39762: rn:R03869','KEGG','RNO:64040',true).
concept_accession('39762: rn:R03869','EC','1.2.1.3',true).
concept_accession('39762: rn:R03869','KEGG','65183',true).
concept_accession('39762: rn:R03869','KEGG','24188',true).
concept_accession('39762: rn:R03869','KEGG','RNO:29539',true).
concept_accession('39762: rn:R03869','KEGG','64040',true).
concept_accession('39762: rn:R03869','KEGG','RNO:24188',true).
concept_accession('39762: rn:R03869','KEGG','29539',true).
concept_accession('39762: rn:R03869','KEGG','29651',true).
concept_accession('39762: rn:R03869','KEGG','298079',true).
concept_accession('39762: rn:R03869','KEGG','RNO:298079',true).
concept_accession('39762: rn:R03869','KEGG','RNO:65183',true).
concept_accession('39762: rn:R03869','KEGG','RNO:29651',true).
concept_accession('39762: rn:R03869','KEGG','291450',true).
concept_accession('39762: rn:R03869','KEGG','EC:1.2.1.3',true).
concept_accession('39763: rn:R02197','KEGG','EC:1.4.3.2',true).
concept_accession('39763: rn:R02197','EC','1.4.3.2',true).
concept_accession('39763: rn:R02197','KEGG','298483',true).
concept_accession('39763: rn:R02197','KEGG','RNO:100360621',true).
concept_accession('39763: rn:R02197','KEGG','1.4.3.2',true).
concept_accession('39763: rn:R02197','KEGG','RNO:298483',true).
concept_accession('39763: rn:R02197','KEGG','100360621',true).
concept_accession('39760: rn:R01859','KEGG','6.4.1.3',true).
concept_accession('39760: rn:R01859','KEGG','24624',true).
concept_accession('39760: rn:R01859','KEGG','687008',true).
concept_accession('39760: rn:R01859','EC','6.4.1.3',true).
concept_accession('39760: rn:R01859','KEGG','RNO:24624',true).
concept_accession('39760: rn:R01859','KEGG','EC:6.4.1.3',true).
concept_accession('39760: rn:R01859','KEGG','RNO:687008',true).
concept_accession('39761: rn:R00935','KEGG','RNO:81708',true).
concept_accession('39761: rn:R00935','EC','1.2.1.27',true).
concept_accession('39761: rn:R00935','KEGG','EC:1.2.1.27',true).
concept_accession('39761: rn:R00935','KEGG','1.2.1.27',true).
concept_accession('39761: rn:R00935','KEGG','81708',true).
concept_accession('39766: rn:R00833','KEGG','RNO:100361295',true).
concept_accession('39766: rn:R00833','KEGG','100361295',true).
concept_accession('39766: rn:R00833','KEGG','EC:5.4.99.2',true).
concept_accession('39766: rn:R00833','KEGG','RNO:688517',true).
concept_accession('39766: rn:R00833','EC','5.4.99.2',true).
concept_accession('39766: rn:R00833','KEGG','688517',true).
concept_accession('39766: rn:R00833','KEGG','5.4.99.2',true).
concept_accession('39767: rn:R02661','KEGG','RNO:25618',true).
concept_accession('39767: rn:R02661','KEGG','25618',true).
concept_accession('39767: rn:R02661','EC','1.3.99.-',true).
concept_accession('39767: rn:R02661','KEGG','EC:1.3.99.-',true).
concept_accession('39767: rn:R02661','KEGG','1.3.99.-',true).
concept_accession('39764: rn:R02199','KEGG','64203',true).
concept_accession('39764: rn:R02199','KEGG','RNO:64203',true).
concept_accession('39764: rn:R02199','KEGG','EC:2.6.1.42',true).
concept_accession('39764: rn:R02199','KEGG','RNO:29592',true).
concept_accession('39764: rn:R02199','KEGG','29592',true).
concept_accession('39764: rn:R02199','KEGG','2.6.1.42',true).
concept_accession('39764: rn:R02199','EC','2.6.1.42',true).
concept_accession('39765: rn:R02765','KEGG','RNO:293829',true).
concept_accession('39765: rn:R02765','KEGG','5.1.99.1',true).
concept_accession('39765: rn:R02765','KEGG','EC:5.1.99.1',true).
concept_accession('39765: rn:R02765','EC','5.1.99.1',true).
concept_accession('39765: rn:R02765','KEGG','293829',true).
concept_accession('39785: rn:R00588','EC','2.6.1.45',true).
concept_accession('39785: rn:R00588','KEGG','EC:2.6.1.45',true).
concept_accession('39785: rn:R00588','KEGG','2.6.1.45',true).
concept_accession('39785: rn:R00588','KEGG','RNO:24792',true).
concept_accession('39785: rn:R00588','KEGG','24792',true).
concept_accession('39784: rn:R07268','KEGG','2.5.1.17',true).
concept_accession('39784: rn:R07268','KEGG','RNO:687861',true).
concept_accession('39784: rn:R07268','KEGG','687861',true).
concept_accession('39784: rn:R07268','EC','2.5.1.17',true).
concept_accession('39784: rn:R07268','KEGG','EC:2.5.1.17',true).
concept_accession('4840: rn:R01608','KEGG','RC00087',true).
concept_accession('4840: rn:R01608','KEGG','RN:R01608',true).
concept_accession('4840: rn:R01608','KEGG','RC:RC00087',true).
concept_accession('4840: rn:R01608','KEGG','1.1.1.59',true).
concept_accession('4840: rn:R01608','KEGG','R01608',true).
concept_accession('4840: rn:R01608','KEGG','EC:1.1.1.59',true).
concept_accession('4840: rn:R01608','KEGG','RP:RP01630',true).
concept_accession('4840: rn:R01608','KEGG','RP01630',true).
concept_accession('4840: rn:R01608','EC','1.1.1.59',false).
concept_accession('39787: rn:R00372','KEGG','RNO:83784',true).
concept_accession('39787: rn:R00372','KEGG','83784',true).
concept_accession('39787: rn:R00372','KEGG','EC:2.6.1.44',true).
concept_accession('39787: rn:R00372','KEGG','2.6.1.44',true).
concept_accession('39787: rn:R00372','EC','2.6.1.44',true).
concept_accession('39787: rn:R00372','KEGG','RNO:24792',true).
concept_accession('39787: rn:R00372','KEGG','24792',true).
concept_accession('39786: rn:R00891','KEGG','RNO:24250',true).
concept_accession('39786: rn:R00891','KEGG','24250',true).
concept_accession('39786: rn:R00891','EC','4.2.1.22',true).
concept_accession('39786: rn:R00891','KEGG','4.2.1.22',true).
concept_accession('39786: rn:R00891','KEGG','EC:4.2.1.22',true).
concept_accession('39789: rn:R07396','KEGG','EC:2.6.1.5',true).
concept_accession('39789: rn:R07396','KEGG','RNO:24813',true).
concept_accession('39789: rn:R07396','EC','2.6.1.5',true).
concept_accession('39789: rn:R07396','KEGG','2.6.1.5',true).
concept_accession('39789: rn:R07396','KEGG','24813',true).
concept_accession('39788: rn:R07412','KEGG','RNO:309391',true).
concept_accession('39788: rn:R07412','KEGG','309391',true).
concept_accession('39791: rn:R07363','EC','1.13.11.53',true).
concept_accession('39791: rn:R07363','KEGG','1.13.11.53',true).
concept_accession('39791: rn:R07363','KEGG','298934',true).
concept_accession('39791: rn:R07363','KEGG','RNO:298934',true).
concept_accession('39791: rn:R07363','KEGG','EC:1.13.11.53',true).
concept_accession('4845: rn:R01611','KEGG','RC:RC00565',true).
concept_accession('4845: rn:R01611','EC','4.2.1.27',false).
concept_accession('4845: rn:R01611','KEGG','RP01634',true).
concept_accession('4845: rn:R01611','KEGG','RC00565',true).
concept_accession('4845: rn:R01611','KEGG','RN:R01611',true).
concept_accession('4845: rn:R01611','KEGG','EC:4.2.1.27',true).
concept_accession('4845: rn:R01611','KEGG','RP:RP01634',true).
concept_accession('4845: rn:R01611','KEGG','4.2.1.27',true).
concept_accession('4845: rn:R01611','KEGG','R01611',true).
concept_accession('39790: rn:R07364','EC','1.13.11.54',true).
concept_accession('39790: rn:R07364','KEGG','298934',true).
concept_accession('39790: rn:R07364','KEGG','EC:1.13.11.54',true).
concept_accession('39790: rn:R07364','KEGG','1.13.11.54',true).
concept_accession('39790: rn:R07364','KEGG','RNO:298934',true).
concept_accession('39777: rn:R02180','KEGG','304322',true).
concept_accession('39777: rn:R02180','KEGG','314694',true).
concept_accession('39777: rn:R02180','KEGG','RNO:500257',true).
concept_accession('39777: rn:R02180','EC','2.8.2.5',true).
concept_accession('39777: rn:R02180','KEGG','RNO:304322',true).
concept_accession('39777: rn:R02180','KEGG','2.8.2.5',true).
concept_accession('39777: rn:R02180','KEGG','RNO:314694',true).
concept_accession('39777: rn:R02180','KEGG','500257',true).
concept_accession('39777: rn:R02180','KEGG','EC:2.8.2.5',true).
concept_accession('39776: rn:R00509','EC','2.7.1.25',true).
concept_accession('39776: rn:R00509','KEGG','EC:2.7.1.25',true).
concept_accession('39776: rn:R00509','KEGG','2.7.1.25',true).
concept_accession('39776: rn:R00509','KEGG','RNO:295443',true).
concept_accession('39776: rn:R00509','KEGG','295443',true).
concept_accession('39776: rn:R00509','KEGG','RNO:294103',true).
concept_accession('39776: rn:R00509','KEGG','294103',true).
concept_accession('39779: rn:R02350','KEGG','2.8.2.15',true).
concept_accession('39779: rn:R02350','KEGG','EC:2.8.2.15',true).
concept_accession('39779: rn:R02350','KEGG','RNO:25355',true).
concept_accession('39779: rn:R02350','KEGG','25355',true).
concept_accession('39779: rn:R02350','EC','2.8.2.15',true).
concept_accession('39778: rn:R00629','KEGG','361510',true).
concept_accession('39778: rn:R00629','KEGG','2.8.2.2',true).
concept_accession('39778: rn:R00629','KEGG','RNO:292915',true).
concept_accession('39778: rn:R00629','KEGG','EC:2.8.2.2',true).
concept_accession('39778: rn:R00629','EC','2.8.2.2',true).
concept_accession('39778: rn:R00629','KEGG','292915',true).
concept_accession('39778: rn:R00629','KEGG','RNO:361510',true).
concept_accession('39781: rn:R02661','KEGG','64304',true).
concept_accession('39781: rn:R02661','EC','1.3.99.-',true).
concept_accession('39781: rn:R02661','KEGG','EC:1.3.99.-',true).
concept_accession('39781: rn:R02661','KEGG','RNO:64304',true).
concept_accession('39781: rn:R02661','KEGG','1.3.99.-',true).
concept_accession('39780: rn:R03172','KEGG','64304',true).
concept_accession('39780: rn:R03172','KEGG','EC:1.3.99.3',true).
concept_accession('39780: rn:R03172','KEGG','1.3.99.3',true).
concept_accession('39780: rn:R03172','KEGG','RNO:64304',true).
concept_accession('39780: rn:R03172','EC','1.3.99.3',true).
concept_accession('39783: rn:R05220','KEGG','2.5.1.17',true).
concept_accession('39783: rn:R05220','KEGG','RNO:687861',true).
concept_accession('39783: rn:R05220','KEGG','687861',true).
concept_accession('39783: rn:R05220','EC','2.5.1.17',true).
concept_accession('39783: rn:R05220','KEGG','EC:2.5.1.17',true).
concept_accession('39782: rn:R00508','KEGG','3.1.3.7',true).
concept_accession('39782: rn:R00508','KEGG','EC:3.1.3.7',true).
concept_accession('39782: rn:R00508','KEGG','RNO:64473',true).
concept_accession('39782: rn:R00508','KEGG','64473',true).
concept_accession('39782: rn:R00508','EC','3.1.3.7',true).
concept_accession('39800: rn:R03683','EC','1.14.99.3',true).
concept_accession('39800: rn:R03683','KEGG','24451',true).
concept_accession('39800: rn:R03683','KEGG','RNO:24451',true).
concept_accession('39800: rn:R03683','KEGG','EC:1.14.99.3',true).
concept_accession('39800: rn:R03683','KEGG','RNO:79239',true).
concept_accession('39800: rn:R03683','KEGG','79239',true).
concept_accession('39800: rn:R03683','KEGG','1.14.99.3',true).
concept_accession('39801: rn:R00177','EC','2.5.1.6',true).
concept_accession('39801: rn:R00177','KEGG','RNO:683630',true).
concept_accession('39801: rn:R00177','KEGG','RNO:25331',true).
concept_accession('39801: rn:R00177','KEGG','2.5.1.6',true).
concept_accession('39801: rn:R00177','KEGG','25331',true).
concept_accession('39801: rn:R00177','KEGG','171347',true).
concept_accession('39801: rn:R00177','KEGG','RNO:171347',true).
concept_accession('39801: rn:R00177','KEGG','683630',true).
concept_accession('39801: rn:R00177','KEGG','EC:2.5.1.6',true).
concept_accession('4857: rn:R01914','KEGG','RP00148',true).
concept_accession('4857: rn:R01914','KEGG','RN:R01914',true).
concept_accession('4857: rn:R01914','KEGG','RC00053',true).
concept_accession('4857: rn:R01914','KEGG','RC00225',true).
concept_accession('4857: rn:R01914','KEGG','R01914',true).
concept_accession('4857: rn:R01914','KEGG','RP:RP00148',true).
concept_accession('4857: rn:R01914','KEGG','EC:1.5.99.6',true).
concept_accession('4857: rn:R01914','EC','1.5.99.6',false).
concept_accession('4857: rn:R01914','KEGG','RP:RP00643',true).
concept_accession('4857: rn:R01914','KEGG','RP00643',true).
concept_accession('4857: rn:R01914','KEGG','RC:RC00225',true).
concept_accession('4857: rn:R01914','KEGG','RC:RC00053',true).
concept_accession('4857: rn:R01914','KEGG','1.5.99.6',true).
concept_accession('39802: rn:R02821','KEGG','RNO:81508',true).
concept_accession('39802: rn:R02821','EC','2.1.1.5',true).
concept_accession('39802: rn:R02821','KEGG','2.1.1.5',true).
concept_accession('39802: rn:R02821','KEGG','EC:2.1.1.5',true).
concept_accession('39802: rn:R02821','KEGG','81508',true).
concept_accession('39803: rn:R04858','KEGG','2.1.1.37',true).
concept_accession('39803: rn:R04858','KEGG','444985',true).
concept_accession('39803: rn:R04858','KEGG','444984',true).
concept_accession('39803: rn:R04858','KEGG','291324',true).
concept_accession('39803: rn:R04858','KEGG','RNO:444985',true).
concept_accession('39803: rn:R04858','KEGG','RNO:444984',true).
concept_accession('39803: rn:R04858','KEGG','RNO:84350',true).
concept_accession('39803: rn:R04858','KEGG','309680',true).
concept_accession('39803: rn:R04858','KEGG','EC:2.1.1.37',true).
concept_accession('39803: rn:R04858','KEGG','84350',true).
concept_accession('39803: rn:R04858','KEGG','RNO:309680',true).
concept_accession('39803: rn:R04858','KEGG','RNO:291324',true).
concept_accession('39803: rn:R04858','EC','2.1.1.37',true).
concept_accession('39804: rn:R00192','KEGG','RNO:29443',true).
concept_accession('39804: rn:R00192','KEGG','312192',true).
concept_accession('39804: rn:R00192','KEGG','RNO:362013',true).
concept_accession('39804: rn:R00192','KEGG','362013',true).
concept_accession('39804: rn:R00192','EC','3.3.1.1',true).
concept_accession('39804: rn:R00192','KEGG','RNO:312192',true).
concept_accession('39804: rn:R00192','KEGG','3.3.1.1',true).
concept_accession('39804: rn:R00192','KEGG','29443',true).
concept_accession('39804: rn:R00192','KEGG','EC:3.3.1.1',true).
concept_accession('39805: rn:R00648','KEGG','EC:1.4.3.2',true).
concept_accession('39805: rn:R00648','EC','1.4.3.2',true).
concept_accession('39805: rn:R00648','KEGG','298483',true).
concept_accession('39805: rn:R00648','KEGG','RNO:100360621',true).
concept_accession('39805: rn:R00648','KEGG','1.4.3.2',true).
concept_accession('39805: rn:R00648','KEGG','RNO:298483',true).
concept_accession('39805: rn:R00648','KEGG','100360621',true).
concept_accession('39806: rn:R07395','KEGG','RNO:305177',true).
concept_accession('39806: rn:R07395','KEGG','EC:3.1.3.77',true).
concept_accession('39806: rn:R07395','EC','3.1.3.77',true).
concept_accession('39806: rn:R07395','KEGG','305177',true).
concept_accession('39806: rn:R07395','KEGG','3.1.3.77',true).
concept_accession('39807: rn:R00590','KEGG','4.3.1.17',true).
concept_accession('39807: rn:R00590','EC','4.3.1.17',true).
concept_accession('39807: rn:R00590','KEGG','RNO:25044',true).
concept_accession('39807: rn:R00590','KEGG','EC:4.3.1.17',true).
concept_accession('39807: rn:R00590','KEGG','25044',true).
concept_accession('39792: rn:R07392','KEGG','EC:4.2.1.109',true).
concept_accession('39792: rn:R07392','KEGG','RNO:295961',true).
concept_accession('39792: rn:R07392','EC','4.2.1.109',true).
concept_accession('39792: rn:R07392','KEGG','4.2.1.109',true).
concept_accession('39792: rn:R07392','KEGG','295961',true).
concept_accession('39793: rn:R04420','KEGG','288912',true).
concept_accession('39793: rn:R04420','KEGG','RNO:288912',true).
concept_accession('39793: rn:R04420','KEGG','5.3.1.23',true).
concept_accession('39793: rn:R04420','EC','5.3.1.23',true).
concept_accession('39793: rn:R04420','KEGG','EC:5.3.1.23',true).
concept_accession('4849: rn:R02473','KEGG','6.3.2.1',true).
concept_accession('4849: rn:R02473','KEGG','RC:RC00096',true).
concept_accession('4849: rn:R02473','KEGG','EC:6.3.2.1',true).
concept_accession('4849: rn:R02473','EC','6.3.2.1',false).
concept_accession('4849: rn:R02473','KEGG','R02473',true).
concept_accession('4849: rn:R02473','KEGG','RN:R02473',true).
concept_accession('4849: rn:R02473','KEGG','RP00373',true).
concept_accession('4849: rn:R02473','KEGG','RC00096',true).
concept_accession('4849: rn:R02473','KEGG','RP:RP00373',true).
concept_accession('39794: rn:R01402','EC','2.4.2.28',true).
concept_accession('39794: rn:R01402','KEGG','RNO:298227',true).
concept_accession('39794: rn:R01402','KEGG','2.4.2.28',true).
concept_accession('39794: rn:R01402','KEGG','EC:2.4.2.28',true).
concept_accession('39794: rn:R01402','KEGG','298227',true).
concept_accession('39795: rn:R01920','KEGG','84596',true).
concept_accession('39795: rn:R01920','KEGG','2.5.1.16',true).
concept_accession('39795: rn:R01920','KEGG','RNO:84596',true).
concept_accession('39795: rn:R01920','EC','2.5.1.16',true).
concept_accession('39795: rn:R01920','KEGG','EC:2.5.1.16',true).
concept_accession('39796: rn:R00178','EC','4.1.1.50',true).
concept_accession('39796: rn:R00178','KEGG','EC:4.1.1.50',true).
concept_accession('39796: rn:R00178','KEGG','81640',true).
concept_accession('39796: rn:R00178','KEGG','4.1.1.50',true).
concept_accession('39796: rn:R00178','KEGG','RNO:81640',true).
concept_accession('39797: rn:R01001','KEGG','EC:4.4.1.1',true).
concept_accession('39797: rn:R01001','EC','4.4.1.1',true).
concept_accession('39797: rn:R01001','KEGG','24962',true).
concept_accession('39797: rn:R01001','KEGG','RNO:24962',true).
concept_accession('39797: rn:R01001','KEGG','4.4.1.1',true).
concept_accession('39798: rn:R00946','KEGG','81522',true).
concept_accession('39798: rn:R00946','KEGG','2.1.1.13',true).
concept_accession('39798: rn:R00946','KEGG','RNO:81522',true).
concept_accession('39798: rn:R00946','KEGG','EC:2.1.1.13',true).
concept_accession('39798: rn:R00946','EC','2.1.1.13',true).
concept_accession('39799: rn:R01290','KEGG','RNO:24250',true).
concept_accession('39799: rn:R01290','KEGG','24250',true).
concept_accession('39799: rn:R01290','EC','4.2.1.22',true).
concept_accession('39799: rn:R01290','KEGG','4.2.1.22',true).
concept_accession('39799: rn:R01290','KEGG','EC:4.2.1.22',true).
concept_accession('40191: rn:R02893','KEGG','RNO:192242',true).
concept_accession('40191: rn:R02893','KEGG','EC:1.3.1.3',true).
concept_accession('40191: rn:R02893','EC','1.3.1.3',true).
concept_accession('40191: rn:R02893','KEGG','1.3.1.3',true).
concept_accession('40191: rn:R02893','KEGG','192242',true).
concept_accession('40190: rn:R02836 rn:R02834','KEGG','25116',true).
concept_accession('40190: rn:R02836 rn:R02834','KEGG','RNO:25116',true).
concept_accession('40190: rn:R02836 rn:R02834','KEGG','25117',true).
concept_accession('40190: rn:R02836 rn:R02834','KEGG','RNO:25117',true).
concept_accession('40190: rn:R02836 rn:R02834','EC','1.1.1.146',true).
concept_accession('40190: rn:R02836 rn:R02834','KEGG','EC:1.1.1.146',true).
concept_accession('40190: rn:R02836 rn:R02834','KEGG','1.1.1.146',true).
concept_accession('40189: rn:R01836','KEGG','EC:1.1.1.63',true).
concept_accession('40189: rn:R01836','KEGG','RNO:286964',true).
concept_accession('40189: rn:R01836','KEGG','RNO:79243',true).
concept_accession('40189: rn:R01836','KEGG','361802',true).
concept_accession('40189: rn:R01836','KEGG','286964',true).
concept_accession('40189: rn:R01836','KEGG','79243',true).
concept_accession('40189: rn:R01836','EC','1.1.1.63',true).
concept_accession('40189: rn:R01836','KEGG','RNO:361802',true).
concept_accession('40189: rn:R01836','KEGG','1.1.1.63',true).
concept_accession('40188: rn:R04852','KEGG','1.14.99.9',true).
concept_accession('40188: rn:R04852','KEGG','EC:1.14.99.9',true).
concept_accession('40188: rn:R04852','KEGG','RNO:25146',true).
concept_accession('40188: rn:R04852','EC','1.14.99.9',true).
concept_accession('40188: rn:R04852','KEGG','25146',true).
concept_accession('40187: rn:R02019','EC','1.17.4.1',true).
concept_accession('40187: rn:R02019','KEGG','362720',true).
concept_accession('40187: rn:R02019','KEGG','RNO:100359539',true).
concept_accession('40187: rn:R02019','KEGG','RNO:685579',true).
concept_accession('40187: rn:R02019','KEGG','1.17.4.1',true).
concept_accession('40187: rn:R02019','KEGG','100359539',true).
concept_accession('40187: rn:R02019','KEGG','EC:1.17.4.1',true).
concept_accession('40187: rn:R02019','KEGG','685579',true).
concept_accession('40187: rn:R02019','KEGG','299976',true).
concept_accession('40187: rn:R02019','KEGG','RNO:299976',true).
concept_accession('40187: rn:R02019','KEGG','RNO:362720',true).
concept_accession('40186: rn:R02107','KEGG','497811',true).
concept_accession('40186: rn:R02107','KEGG','1.17.3.2',true).
concept_accession('40186: rn:R02107','KEGG','EC:1.17.3.2',true).
concept_accession('40186: rn:R02107','EC','1.17.3.2',true).
concept_accession('40186: rn:R02107','KEGG','RNO:497811',true).
concept_accession('40185: rn:R01049','KEGG','29562',true).
concept_accession('40185: rn:R01049','KEGG','314140',true).
concept_accession('40185: rn:R01049','KEGG','24689',true).
concept_accession('40185: rn:R01049','KEGG','RNO:298954',true).
concept_accession('40185: rn:R01049','KEGG','298954',true).
concept_accession('40185: rn:R01049','KEGG','EC:2.7.6.1',true).
concept_accession('40185: rn:R01049','EC','2.7.6.1',true).
concept_accession('40185: rn:R01049','KEGG','RNO:24689',true).
concept_accession('40185: rn:R01049','KEGG','RNO:314140',true).
concept_accession('40185: rn:R01049','KEGG','2.7.6.1',true).
concept_accession('40185: rn:R01049','KEGG','RNO:29562',true).
concept_accession('40184: rn:R01072','KEGG','RNO:117544',true).
concept_accession('40184: rn:R01072','EC','2.4.2.14',true).
concept_accession('40184: rn:R01072','KEGG','EC:2.4.2.14',true).
concept_accession('40184: rn:R01072','KEGG','117544',true).
concept_accession('40184: rn:R01072','KEGG','2.4.2.14',true).
concept_accession('40183: rn:R04144','KEGG','6.3.4.13',true).
concept_accession('40183: rn:R04144','KEGG','288259',true).
concept_accession('40183: rn:R04144','KEGG','RNO:288259',true).
concept_accession('40183: rn:R04144','KEGG','EC:6.3.4.13',true).
concept_accession('40183: rn:R04144','EC','6.3.4.13',true).
concept_accession('40182: rn:R04325','KEGG','EC:2.1.2.2',true).
concept_accession('40182: rn:R04325','KEGG','288259',true).
concept_accession('40182: rn:R04325','KEGG','RNO:288259',true).
concept_accession('40182: rn:R04325','KEGG','2.1.2.2',true).
concept_accession('40182: rn:R04325','EC','2.1.2.2',true).
concept_accession('40181: rn:R04208','KEGG','6.3.3.1',true).
concept_accession('40181: rn:R04208','EC','6.3.3.1',true).
concept_accession('40181: rn:R04208','KEGG','288259',true).
concept_accession('40181: rn:R04208','KEGG','RNO:288259',true).
concept_accession('40181: rn:R04208','KEGG','EC:6.3.3.1',true).
concept_accession('40180: rn:R00507','KEGG','RNO:85496',true).
concept_accession('40180: rn:R00507','KEGG','RNO:54410',true).
concept_accession('40180: rn:R00507','KEGG','3.6.1.9',true).
concept_accession('40180: rn:R00507','KEGG','54410',true).
concept_accession('40180: rn:R00507','KEGG','85496',true).
concept_accession('40180: rn:R00507','KEGG','EC:3.6.1.9',true).
concept_accession('40180: rn:R00507','EC','3.6.1.9',true).
concept_accession('40179: rn:R01234','KEGG','140929',true).
concept_accession('40179: rn:R01234','KEGG','307401',true).
concept_accession('40179: rn:R01234','KEGG','140928',true).
concept_accession('40179: rn:R01234','KEGG','308776',true).
concept_accession('40179: rn:R01234','KEGG','RNO:114248',true).
concept_accession('40179: rn:R01234','KEGG','3.1.4.17',true).
concept_accession('40179: rn:R01234','KEGG','81742',true).
concept_accession('40179: rn:R01234','KEGG','81743',true).
concept_accession('40179: rn:R01234','KEGG','RNO:307401',true).
concept_accession('40179: rn:R01234','KEGG','81744',true).
concept_accession('40179: rn:R01234','KEGG','25638',true).
concept_accession('40179: rn:R01234','KEGG','RNO:308776',true).
concept_accession('40179: rn:R01234','KEGG','RNO:29516',true).
concept_accession('40179: rn:R01234','KEGG','114248',true).
concept_accession('40179: rn:R01234','KEGG','309962',true).
concept_accession('40179: rn:R01234','KEGG','RNO:50678',true).
concept_accession('40179: rn:R01234','KEGG','171115',true).
concept_accession('40179: rn:R01234','KEGG','290646',true).
concept_accession('40179: rn:R01234','KEGG','RNO:363272',true).
concept_accession('40179: rn:R01234','KEGG','EC:3.1.4.17',true).
concept_accession('40179: rn:R01234','EC','3.1.4.17',true).
concept_accession('40179: rn:R01234','KEGG','29516',true).
concept_accession('40179: rn:R01234','KEGG','RNO:309962',true).
concept_accession('40179: rn:R01234','KEGG','81529',true).
concept_accession('40179: rn:R01234','KEGG','RNO:81529',true).
concept_accession('40179: rn:R01234','KEGG','191569',true).
concept_accession('40179: rn:R01234','KEGG','29691',true).
concept_accession('40179: rn:R01234','KEGG','RNO:361752',true).
concept_accession('40179: rn:R01234','KEGG','RNO:24627',true).
concept_accession('40179: rn:R01234','KEGG','361752',true).
concept_accession('40179: rn:R01234','KEGG','RNO:289878',true).
concept_accession('40179: rn:R01234','KEGG','RNO:24626',true).
concept_accession('40179: rn:R01234','KEGG','688297',true).
concept_accession('40179: rn:R01234','KEGG','24627',true).
concept_accession('40179: rn:R01234','KEGG','24626',true).
concept_accession('40179: rn:R01234','KEGG','RNO:191569',true).
concept_accession('40179: rn:R01234','KEGG','289878',true).
concept_accession('40179: rn:R01234','KEGG','3.1.4.35',true).
concept_accession('40179: rn:R01234','KEGG','63885',true).
concept_accession('40179: rn:R01234','EC','3.1.4.35',true).
concept_accession('40179: rn:R01234','KEGG','RNO:171115',true).
concept_accession('40179: rn:R01234','KEGG','RNO:81744',true).
concept_accession('40179: rn:R01234','KEGG','RNO:29691',true).
concept_accession('40179: rn:R01234','KEGG','RNO:81743',true).
concept_accession('40179: rn:R01234','KEGG','50678',true).
concept_accession('40179: rn:R01234','KEGG','RNO:688297',true).
concept_accession('40179: rn:R01234','KEGG','363272',true).
concept_accession('40179: rn:R01234','KEGG','RNO:140928',true).
concept_accession('40179: rn:R01234','KEGG','EC:3.1.4.35',true).
concept_accession('40179: rn:R01234','KEGG','RNO:63885',true).
concept_accession('40179: rn:R01234','KEGG','RNO:140929',true).
concept_accession('40179: rn:R01234','KEGG','RNO:25638',true).
concept_accession('40179: rn:R01234','KEGG','RNO:81742',true).
concept_accession('40179: rn:R01234','KEGG','RNO:290646',true).
concept_accession('40178: rn:R00509','EC','2.7.1.25',true).
concept_accession('40178: rn:R00509','KEGG','EC:2.7.1.25',true).
concept_accession('40178: rn:R00509','KEGG','2.7.1.25',true).
concept_accession('40178: rn:R00509','KEGG','RNO:295443',true).
concept_accession('40178: rn:R00509','KEGG','295443',true).
concept_accession('40178: rn:R00509','KEGG','RNO:294103',true).
concept_accession('40178: rn:R00509','KEGG','294103',true).
concept_accession('40177: rn:R00529','KEGG','2.7.7.4',true).
concept_accession('40177: rn:R00529','KEGG','EC:2.7.7.4',true).
concept_accession('40177: rn:R00529','KEGG','RNO:295443',true).
concept_accession('40177: rn:R00529','KEGG','295443',true).
concept_accession('40177: rn:R00529','EC','2.7.7.4',true).
concept_accession('40177: rn:R00529','KEGG','RNO:294103',true).
concept_accession('40177: rn:R00529','KEGG','294103',true).
concept_accession('40176: rn:R07116','KEGG','289197',true).
concept_accession('40176: rn:R07116','KEGG','494500',true).
concept_accession('40176: rn:R07116','KEGG','RNO:681913',true).
concept_accession('40176: rn:R07116','KEGG','363205',true).
concept_accession('40176: rn:R07116','KEGG','EC:2.5.1.18',true).
concept_accession('40176: rn:R07116','KEGG','RNO:494500',true).
concept_accession('40176: rn:R07116','KEGG','29487',true).
concept_accession('40176: rn:R07116','EC','2.5.1.18',true).
concept_accession('40176: rn:R07116','KEGG','309465',true).
concept_accession('40176: rn:R07116','KEGG','RNO:57298',true).
concept_accession('40176: rn:R07116','KEGG','RNO:171341',true).
concept_accession('40176: rn:R07116','KEGG','RNO:24423',true).
concept_accession('40176: rn:R07116','KEGG','681913',true).
concept_accession('40176: rn:R07116','KEGG','300850',true).
concept_accession('40176: rn:R07116','KEGG','RNO:24424',true).
concept_accession('40176: rn:R07116','KEGG','RNO:24421',true).
concept_accession('40176: rn:R07116','KEGG','RNO:24422',true).
concept_accession('40176: rn:R07116','KEGG','RNO:81869',true).
concept_accession('40176: rn:R07116','KEGG','295037',true).
concept_accession('40176: rn:R07116','KEGG','RNO:24426',true).
concept_accession('40176: rn:R07116','KEGG','494499',true).
concept_accession('40176: rn:R07116','KEGG','RNO:289197',true).
concept_accession('40176: rn:R07116','KEGG','25260',true).
concept_accession('40176: rn:R07116','KEGG','114846',true).
concept_accession('40176: rn:R07116','KEGG','81869',true).
concept_accession('40176: rn:R07116','KEGG','501110',true).
concept_accession('40176: rn:R07116','KEGG','64352',true).
concept_accession('40176: rn:R07116','KEGG','24426',true).
concept_accession('40176: rn:R07116','KEGG','RNO:300850',true).
concept_accession('40176: rn:R07116','KEGG','24421',true).
concept_accession('40176: rn:R07116','KEGG','RNO:499688',true).
concept_accession('40176: rn:R07116','KEGG','2.5.1.18',true).
concept_accession('40176: rn:R07116','KEGG','24423',true).
concept_accession('40176: rn:R07116','KEGG','RNO:499689',true).
concept_accession('40176: rn:R07116','KEGG','24422',true).
concept_accession('40176: rn:R07116','KEGG','24424',true).
concept_accession('40176: rn:R07116','KEGG','499689',true).
concept_accession('40176: rn:R07116','KEGG','RNO:29487',true).
concept_accession('40176: rn:R07116','KEGG','499688',true).
concept_accession('40176: rn:R07116','KEGG','RNO:494499',true).
concept_accession('40176: rn:R07116','KEGG','RNO:114846',true).
concept_accession('40176: rn:R07116','KEGG','RNO:501110',true).
concept_accession('40176: rn:R07116','KEGG','57298',true).
concept_accession('40176: rn:R07116','KEGG','RNO:309465',true).
concept_accession('40176: rn:R07116','KEGG','RNO:297029',true).
concept_accession('40176: rn:R07116','KEGG','171341',true).
concept_accession('40176: rn:R07116','KEGG','RNO:25260',true).
concept_accession('40176: rn:R07116','KEGG','RNO:295037',true).
concept_accession('40176: rn:R07116','KEGG','RNO:363205',true).
concept_accession('40176: rn:R07116','KEGG','RNO:64352',true).
concept_accession('40176: rn:R07116','KEGG','297029',true).
concept_accession('40174: rn:R02720','EC','3.6.1.19',true).
concept_accession('40174: rn:R02720','KEGG','EC:3.6.1.19',true).
concept_accession('40174: rn:R02720','KEGG','RNO:311422',true).
concept_accession('40174: rn:R02720','KEGG','311422',true).
concept_accession('40174: rn:R02720','KEGG','3.6.1.19',true).
concept_accession('40175: rn:R00720','EC','3.6.1.19',true).
concept_accession('40175: rn:R00720','KEGG','EC:3.6.1.19',true).
concept_accession('40175: rn:R00720','KEGG','RNO:311422',true).
concept_accession('40175: rn:R00720','KEGG','311422',true).
concept_accession('40175: rn:R00720','KEGG','3.6.1.19',true).
concept_accession('40172: rn:R02103','KEGG','EC:1.17.1.4',true).
concept_accession('40172: rn:R02103','KEGG','497811',true).
concept_accession('40172: rn:R02103','EC','1.17.1.4',true).
concept_accession('40172: rn:R02103','KEGG','1.17.1.4',true).
concept_accession('40172: rn:R02103','KEGG','RNO:497811',true).
concept_accession('40173: rn:R00426','EC','3.6.1.19',true).
concept_accession('40173: rn:R00426','KEGG','EC:3.6.1.19',true).
concept_accession('40173: rn:R00426','KEGG','RNO:311422',true).
concept_accession('40173: rn:R00426','KEGG','311422',true).
concept_accession('40173: rn:R00426','KEGG','3.6.1.19',true).
concept_accession('40170: rn:R04463','KEGG','EC:6.3.5.3',true).
concept_accession('40170: rn:R04463','KEGG','287420',true).
concept_accession('40170: rn:R04463','EC','6.3.5.3',true).
concept_accession('40170: rn:R04463','KEGG','RNO:287420',true).
concept_accession('40170: rn:R04463','KEGG','6.3.5.3',true).
concept_accession('40171: rn:R01768','KEGG','EC:1.17.1.4',true).
concept_accession('40171: rn:R01768','KEGG','497811',true).
concept_accession('40171: rn:R01768','EC','1.17.1.4',true).
concept_accession('40171: rn:R01768','KEGG','1.17.1.4',true).
concept_accession('40171: rn:R01768','KEGG','RNO:497811',true).
concept_accession('40168: rn:R07070','KEGG','289197',true).
concept_accession('40168: rn:R07070','KEGG','494500',true).
concept_accession('40168: rn:R07070','KEGG','RNO:681913',true).
concept_accession('40168: rn:R07070','KEGG','363205',true).
concept_accession('40168: rn:R07070','KEGG','EC:2.5.1.18',true).
concept_accession('40168: rn:R07070','KEGG','RNO:494500',true).
concept_accession('40168: rn:R07070','KEGG','29487',true).
concept_accession('40168: rn:R07070','EC','2.5.1.18',true).
concept_accession('40168: rn:R07070','KEGG','309465',true).
concept_accession('40168: rn:R07070','KEGG','RNO:57298',true).
concept_accession('40168: rn:R07070','KEGG','RNO:171341',true).
concept_accession('40168: rn:R07070','KEGG','RNO:24423',true).
concept_accession('40168: rn:R07070','KEGG','681913',true).
concept_accession('40168: rn:R07070','KEGG','300850',true).
concept_accession('40168: rn:R07070','KEGG','RNO:24424',true).
concept_accession('40168: rn:R07070','KEGG','RNO:24421',true).
concept_accession('40168: rn:R07070','KEGG','RNO:24422',true).
concept_accession('40168: rn:R07070','KEGG','RNO:81869',true).
concept_accession('40168: rn:R07070','KEGG','295037',true).
concept_accession('40168: rn:R07070','KEGG','RNO:24426',true).
concept_accession('40168: rn:R07070','KEGG','494499',true).
concept_accession('40168: rn:R07070','KEGG','RNO:289197',true).
concept_accession('40168: rn:R07070','KEGG','25260',true).
concept_accession('40168: rn:R07070','KEGG','114846',true).
concept_accession('40168: rn:R07070','KEGG','81869',true).
concept_accession('40168: rn:R07070','KEGG','501110',true).
concept_accession('40168: rn:R07070','KEGG','64352',true).
concept_accession('40168: rn:R07070','KEGG','24426',true).
concept_accession('40168: rn:R07070','KEGG','RNO:300850',true).
concept_accession('40168: rn:R07070','KEGG','24421',true).
concept_accession('40168: rn:R07070','KEGG','RNO:499688',true).
concept_accession('40168: rn:R07070','KEGG','2.5.1.18',true).
concept_accession('40168: rn:R07070','KEGG','24423',true).
concept_accession('40168: rn:R07070','KEGG','RNO:499689',true).
concept_accession('40168: rn:R07070','KEGG','24422',true).
concept_accession('40168: rn:R07070','KEGG','24424',true).
concept_accession('40168: rn:R07070','KEGG','499689',true).
concept_accession('40168: rn:R07070','KEGG','RNO:29487',true).
concept_accession('40168: rn:R07070','KEGG','499688',true).
concept_accession('40168: rn:R07070','KEGG','RNO:494499',true).
concept_accession('40168: rn:R07070','KEGG','RNO:114846',true).
concept_accession('40168: rn:R07070','KEGG','RNO:501110',true).
concept_accession('40168: rn:R07070','KEGG','57298',true).
concept_accession('40168: rn:R07070','KEGG','RNO:309465',true).
concept_accession('40168: rn:R07070','KEGG','RNO:297029',true).
concept_accession('40168: rn:R07070','KEGG','171341',true).
concept_accession('40168: rn:R07070','KEGG','RNO:25260',true).
concept_accession('40168: rn:R07070','KEGG','RNO:295037',true).
concept_accession('40168: rn:R07070','KEGG','RNO:363205',true).
concept_accession('40168: rn:R07070','KEGG','RNO:64352',true).
concept_accession('40168: rn:R07070','KEGG','297029',true).
concept_accession('40169: rn:R00439','KEGG','EC:2.7.7.8',true).
concept_accession('40169: rn:R00439','KEGG','360992',true).
concept_accession('40169: rn:R00439','KEGG','RNO:360992',true).
concept_accession('40169: rn:R00439','KEGG','2.7.7.8',true).
concept_accession('40169: rn:R00439','EC','2.7.7.8',true).
concept_accession('40166: rn:R07092','KEGG','289197',true).
concept_accession('40166: rn:R07092','KEGG','494500',true).
concept_accession('40166: rn:R07092','KEGG','RNO:681913',true).
concept_accession('40166: rn:R07092','KEGG','363205',true).
concept_accession('40166: rn:R07092','KEGG','EC:2.5.1.18',true).
concept_accession('40166: rn:R07092','KEGG','RNO:494500',true).
concept_accession('40166: rn:R07092','KEGG','29487',true).
concept_accession('40166: rn:R07092','EC','2.5.1.18',true).
concept_accession('40166: rn:R07092','KEGG','309465',true).
concept_accession('40166: rn:R07092','KEGG','RNO:57298',true).
concept_accession('40166: rn:R07092','KEGG','RNO:171341',true).
concept_accession('40166: rn:R07092','KEGG','RNO:24423',true).
concept_accession('40166: rn:R07092','KEGG','681913',true).
concept_accession('40166: rn:R07092','KEGG','300850',true).
concept_accession('40166: rn:R07092','KEGG','RNO:24424',true).
concept_accession('40166: rn:R07092','KEGG','RNO:24421',true).
concept_accession('40166: rn:R07092','KEGG','RNO:24422',true).
concept_accession('40166: rn:R07092','KEGG','RNO:81869',true).
concept_accession('40166: rn:R07092','KEGG','295037',true).
concept_accession('40166: rn:R07092','KEGG','RNO:24426',true).
concept_accession('40166: rn:R07092','KEGG','494499',true).
concept_accession('40166: rn:R07092','KEGG','RNO:289197',true).
concept_accession('40166: rn:R07092','KEGG','25260',true).
concept_accession('40166: rn:R07092','KEGG','114846',true).
concept_accession('40166: rn:R07092','KEGG','81869',true).
concept_accession('40166: rn:R07092','KEGG','501110',true).
concept_accession('40166: rn:R07092','KEGG','64352',true).
concept_accession('40166: rn:R07092','KEGG','24426',true).
concept_accession('40166: rn:R07092','KEGG','RNO:300850',true).
concept_accession('40166: rn:R07092','KEGG','24421',true).
concept_accession('40166: rn:R07092','KEGG','RNO:499688',true).
concept_accession('40166: rn:R07092','KEGG','2.5.1.18',true).
concept_accession('40166: rn:R07092','KEGG','24423',true).
concept_accession('40166: rn:R07092','KEGG','RNO:499689',true).
concept_accession('40166: rn:R07092','KEGG','24422',true).
concept_accession('40166: rn:R07092','KEGG','24424',true).
concept_accession('40166: rn:R07092','KEGG','499689',true).
concept_accession('40166: rn:R07092','KEGG','RNO:29487',true).
concept_accession('40166: rn:R07092','KEGG','499688',true).
concept_accession('40166: rn:R07092','KEGG','RNO:494499',true).
concept_accession('40166: rn:R07092','KEGG','RNO:114846',true).
concept_accession('40166: rn:R07092','KEGG','RNO:501110',true).
concept_accession('40166: rn:R07092','KEGG','57298',true).
concept_accession('40166: rn:R07092','KEGG','RNO:309465',true).
concept_accession('40166: rn:R07092','KEGG','RNO:297029',true).
concept_accession('40166: rn:R07092','KEGG','171341',true).
concept_accession('40166: rn:R07092','KEGG','RNO:25260',true).
concept_accession('40166: rn:R07092','KEGG','RNO:295037',true).
concept_accession('40166: rn:R07092','KEGG','RNO:363205',true).
concept_accession('40166: rn:R07092','KEGG','RNO:64352',true).
concept_accession('40166: rn:R07092','KEGG','297029',true).
concept_accession('40167: rn:R00335','KEGG','316077',true).
concept_accession('40167: rn:R00335','KEGG','64519',true).
concept_accession('40167: rn:R00335','KEGG','RNO:613267',true).
concept_accession('40167: rn:R00335','KEGG','3.6.1.5',true).
concept_accession('40167: rn:R00335','KEGG','RNO:64519',true).
concept_accession('40167: rn:R00335','KEGG','EC:3.6.1.5',true).
concept_accession('40167: rn:R00335','EC','3.6.1.5',true).
concept_accession('40167: rn:R00335','KEGG','613267',true).
concept_accession('40167: rn:R00335','KEGG','RNO:316077',true).
concept_accession('40164: rn:R07105','KEGG','24172',true).
concept_accession('40164: rn:R07105','KEGG','RNO:29646',true).
concept_accession('40164: rn:R07105','KEGG','RNO:310903',true).
concept_accession('40164: rn:R07105','KEGG','100145871',true).
concept_accession('40164: rn:R07105','KEGG','EC:1.1.1.1',true).
concept_accession('40164: rn:R07105','KEGG','310903',true).
concept_accession('40164: rn:R07105','KEGG','1.1.1.1',true).
concept_accession('40164: rn:R07105','KEGG','RNO:171178',true).
concept_accession('40164: rn:R07105','EC','1.1.1.1',true).
concept_accession('40164: rn:R07105','KEGG','171178',true).
concept_accession('40164: rn:R07105','KEGG','RNO:100145871',true).
concept_accession('40164: rn:R07105','KEGG','RNO:24172',true).
concept_accession('40164: rn:R07105','KEGG','29646',true).
concept_accession('40165: rn:R00330','KEGG','171566',true).
concept_accession('40165: rn:R00330','KEGG','2.7.4.6',true).
concept_accession('40165: rn:R00330','KEGG','685679',true).
concept_accession('40165: rn:R00330','KEGG','83782',true).
concept_accession('40165: rn:R00330','KEGG','RNO:58964',true).
concept_accession('40165: rn:R00330','KEGG','RNO:83782',true).
concept_accession('40165: rn:R00330','KEGG','85269',true).
concept_accession('40165: rn:R00330','KEGG','RNO:685679',true).
concept_accession('40165: rn:R00330','KEGG','RNO:85269',true).
concept_accession('40165: rn:R00330','EC','2.7.4.6',true).
concept_accession('40165: rn:R00330','KEGG','EC:2.7.4.6',true).
concept_accession('40165: rn:R00330','KEGG','RNO:191575',true).
concept_accession('40165: rn:R00330','KEGG','191575',true).
concept_accession('40165: rn:R00330','KEGG','58964',true).
concept_accession('40165: rn:R00330','KEGG','RNO:171566',true).
concept_accession('40162: rn:R07100','KEGG','289197',true).
concept_accession('40162: rn:R07100','KEGG','494500',true).
concept_accession('40162: rn:R07100','KEGG','RNO:681913',true).
concept_accession('40162: rn:R07100','KEGG','363205',true).
concept_accession('40162: rn:R07100','KEGG','EC:2.5.1.18',true).
concept_accession('40162: rn:R07100','KEGG','RNO:494500',true).
concept_accession('40162: rn:R07100','KEGG','29487',true).
concept_accession('40162: rn:R07100','EC','2.5.1.18',true).
concept_accession('40162: rn:R07100','KEGG','309465',true).
concept_accession('40162: rn:R07100','KEGG','RNO:57298',true).
concept_accession('40162: rn:R07100','KEGG','RNO:171341',true).
concept_accession('40162: rn:R07100','KEGG','RNO:24423',true).
concept_accession('40162: rn:R07100','KEGG','681913',true).
concept_accession('40162: rn:R07100','KEGG','300850',true).
concept_accession('40162: rn:R07100','KEGG','RNO:24424',true).
concept_accession('40162: rn:R07100','KEGG','RNO:24421',true).
concept_accession('40162: rn:R07100','KEGG','RNO:24422',true).
concept_accession('40162: rn:R07100','KEGG','RNO:81869',true).
concept_accession('40162: rn:R07100','KEGG','295037',true).
concept_accession('40162: rn:R07100','KEGG','RNO:24426',true).
concept_accession('40162: rn:R07100','KEGG','494499',true).
concept_accession('40162: rn:R07100','KEGG','RNO:289197',true).
concept_accession('40162: rn:R07100','KEGG','25260',true).
concept_accession('40162: rn:R07100','KEGG','114846',true).
concept_accession('40162: rn:R07100','KEGG','81869',true).
concept_accession('40162: rn:R07100','KEGG','501110',true).
concept_accession('40162: rn:R07100','KEGG','64352',true).
concept_accession('40162: rn:R07100','KEGG','24426',true).
concept_accession('40162: rn:R07100','KEGG','RNO:300850',true).
concept_accession('40162: rn:R07100','KEGG','24421',true).
concept_accession('40162: rn:R07100','KEGG','RNO:499688',true).
concept_accession('40162: rn:R07100','KEGG','2.5.1.18',true).
concept_accession('40162: rn:R07100','KEGG','24423',true).
concept_accession('40162: rn:R07100','KEGG','RNO:499689',true).
concept_accession('40162: rn:R07100','KEGG','24422',true).
concept_accession('40162: rn:R07100','KEGG','24424',true).
concept_accession('40162: rn:R07100','KEGG','499689',true).
concept_accession('40162: rn:R07100','KEGG','RNO:29487',true).
concept_accession('40162: rn:R07100','KEGG','499688',true).
concept_accession('40162: rn:R07100','KEGG','RNO:494499',true).
concept_accession('40162: rn:R07100','KEGG','RNO:114846',true).
concept_accession('40162: rn:R07100','KEGG','RNO:501110',true).
concept_accession('40162: rn:R07100','KEGG','57298',true).
concept_accession('40162: rn:R07100','KEGG','RNO:309465',true).
concept_accession('40162: rn:R07100','KEGG','RNO:297029',true).
concept_accession('40162: rn:R07100','KEGG','171341',true).
concept_accession('40162: rn:R07100','KEGG','RNO:25260',true).
concept_accession('40162: rn:R07100','KEGG','RNO:295037',true).
concept_accession('40162: rn:R07100','KEGG','RNO:363205',true).
concept_accession('40162: rn:R07100','KEGG','RNO:64352',true).
concept_accession('40162: rn:R07100','KEGG','297029',true).
concept_accession('40163: rn:R02090','KEGG','EC:2.7.4.8',true).
concept_accession('40163: rn:R02090','EC','2.7.4.8',true).
concept_accession('40163: rn:R02090','KEGG','2.7.4.8',true).
concept_accession('40163: rn:R02090','KEGG','303179',true).
concept_accession('40163: rn:R02090','KEGG','RNO:303179',true).
concept_accession('40160: rn:R07106','KEGG','396551',true).
concept_accession('40160: rn:R07106','KEGG','2.4.1.17',true).
concept_accession('40160: rn:R07106','KEGG','154516',true).
concept_accession('40160: rn:R07106','KEGG','396552',true).
concept_accession('40160: rn:R07106','KEGG','RNO:305264',true).
concept_accession('40160: rn:R07106','KEGG','289533',true).
concept_accession('40160: rn:R07106','KEGG','RNO:396527',true).
concept_accession('40160: rn:R07106','KEGG','574523',true).
concept_accession('40160: rn:R07106','KEGG','396527',true).
concept_accession('40160: rn:R07106','KEGG','EC:2.4.1.17',true).
concept_accession('40160: rn:R07106','KEGG','113992',true).
concept_accession('40160: rn:R07106','KEGG','RNO:574523',true).
concept_accession('40160: rn:R07106','KEGG','RNO:266685',true).
concept_accession('40160: rn:R07106','KEGG','RNO:24861',true).
concept_accession('40160: rn:R07106','KEGG','266685',true).
concept_accession('40160: rn:R07106','KEGG','RNO:24862',true).
concept_accession('40160: rn:R07106','KEGG','29623',true).
concept_accession('40160: rn:R07106','KEGG','RNO:289533',true).
concept_accession('40160: rn:R07106','KEGG','305264',true).
concept_accession('40160: rn:R07106','KEGG','RNO:83808',true).
concept_accession('40160: rn:R07106','KEGG','RNO:301595',true).
concept_accession('40160: rn:R07106','KEGG','RNO:29623',true).
concept_accession('40160: rn:R07106','KEGG','RNO:154516',true).
concept_accession('40160: rn:R07106','KEGG','301595',true).
concept_accession('40160: rn:R07106','KEGG','RNO:396552',true).
concept_accession('40160: rn:R07106','KEGG','RNO:396551',true).
concept_accession('40160: rn:R07106','KEGG','RNO:286954',true).
concept_accession('40160: rn:R07106','KEGG','RNO:113992',true).
concept_accession('40160: rn:R07106','KEGG','RNO:63867',true).
concept_accession('40160: rn:R07106','KEGG','286954',true).
concept_accession('40160: rn:R07106','KEGG','83808',true).
concept_accession('40160: rn:R07106','KEGG','24861',true).
concept_accession('40160: rn:R07106','KEGG','63867',true).
concept_accession('40160: rn:R07106','EC','2.4.1.17',true).
concept_accession('40160: rn:R07106','KEGG','24862',true).
concept_accession('40161: rn:R06601','KEGG','3.5.2.17',true).
concept_accession('40161: rn:R06601','KEGG','EC:3.5.2.17',true).
concept_accession('40161: rn:R06601','KEGG','RNO:293613',true).
concept_accession('40161: rn:R06601','KEGG','293613',true).
concept_accession('40161: rn:R06601','EC','3.5.2.17',true).
concept_accession('40157: rn:R07113','KEGG','289197',true).
concept_accession('40157: rn:R07113','KEGG','494500',true).
concept_accession('40157: rn:R07113','KEGG','RNO:681913',true).
concept_accession('40157: rn:R07113','KEGG','363205',true).
concept_accession('40157: rn:R07113','KEGG','EC:2.5.1.18',true).
concept_accession('40157: rn:R07113','KEGG','RNO:494500',true).
concept_accession('40157: rn:R07113','KEGG','29487',true).
concept_accession('40157: rn:R07113','EC','2.5.1.18',true).
concept_accession('40157: rn:R07113','KEGG','309465',true).
concept_accession('40157: rn:R07113','KEGG','RNO:57298',true).
concept_accession('40157: rn:R07113','KEGG','RNO:171341',true).
concept_accession('40157: rn:R07113','KEGG','RNO:24423',true).
concept_accession('40157: rn:R07113','KEGG','681913',true).
concept_accession('40157: rn:R07113','KEGG','300850',true).
concept_accession('40157: rn:R07113','KEGG','RNO:24424',true).
concept_accession('40157: rn:R07113','KEGG','RNO:24421',true).
concept_accession('40157: rn:R07113','KEGG','RNO:24422',true).
concept_accession('40157: rn:R07113','KEGG','RNO:81869',true).
concept_accession('40157: rn:R07113','KEGG','295037',true).
concept_accession('40157: rn:R07113','KEGG','RNO:24426',true).
concept_accession('40157: rn:R07113','KEGG','494499',true).
concept_accession('40157: rn:R07113','KEGG','RNO:289197',true).
concept_accession('40157: rn:R07113','KEGG','25260',true).
concept_accession('40157: rn:R07113','KEGG','114846',true).
concept_accession('40157: rn:R07113','KEGG','81869',true).
concept_accession('40157: rn:R07113','KEGG','501110',true).
concept_accession('40157: rn:R07113','KEGG','64352',true).
concept_accession('40157: rn:R07113','KEGG','24426',true).
concept_accession('40157: rn:R07113','KEGG','RNO:300850',true).
concept_accession('40157: rn:R07113','KEGG','24421',true).
concept_accession('40157: rn:R07113','KEGG','RNO:499688',true).
concept_accession('40157: rn:R07113','KEGG','2.5.1.18',true).
concept_accession('40157: rn:R07113','KEGG','24423',true).
concept_accession('40157: rn:R07113','KEGG','RNO:499689',true).
concept_accession('40157: rn:R07113','KEGG','24422',true).
concept_accession('40157: rn:R07113','KEGG','24424',true).
concept_accession('40157: rn:R07113','KEGG','499689',true).
concept_accession('40157: rn:R07113','KEGG','RNO:29487',true).
concept_accession('40157: rn:R07113','KEGG','499688',true).
concept_accession('40157: rn:R07113','KEGG','RNO:494499',true).
concept_accession('40157: rn:R07113','KEGG','RNO:114846',true).
concept_accession('40157: rn:R07113','KEGG','RNO:501110',true).
concept_accession('40157: rn:R07113','KEGG','57298',true).
concept_accession('40157: rn:R07113','KEGG','RNO:309465',true).
concept_accession('40157: rn:R07113','KEGG','RNO:297029',true).
concept_accession('40157: rn:R07113','KEGG','171341',true).
concept_accession('40157: rn:R07113','KEGG','RNO:25260',true).
concept_accession('40157: rn:R07113','KEGG','RNO:295037',true).
concept_accession('40157: rn:R07113','KEGG','RNO:363205',true).
concept_accession('40157: rn:R07113','KEGG','RNO:64352',true).
concept_accession('40157: rn:R07113','KEGG','297029',true).
concept_accession('40156: rn:R07112','EC','1.14.14.1',true).
concept_accession('40156: rn:R07112','KEGG','RNO:25086',true).
concept_accession('40156: rn:R07112','KEGG','1.14.14.1',true).
concept_accession('40156: rn:R07112','KEGG','25086',true).
concept_accession('40156: rn:R07112','KEGG','EC:1.14.14.1',true).
concept_accession('40159: rn:R07104','KEGG','RNO:25375',true).
concept_accession('40159: rn:R07104','KEGG','25375',true).
concept_accession('40159: rn:R07104','KEGG','RNO:266603',true).
concept_accession('40159: rn:R07104','KEGG','266603',true).
concept_accession('40159: rn:R07104','KEGG','RNO:309147',true).
concept_accession('40159: rn:R07104','KEGG','309147',true).
concept_accession('40159: rn:R07104','KEGG','EC:1.2.1.5',true).
concept_accession('40159: rn:R07104','EC','1.2.1.5',true).
concept_accession('40159: rn:R07104','KEGG','1.2.1.5',true).
concept_accession('40158: rn:R03409','KEGG','EC:3.6.1.40',true).
concept_accession('40158: rn:R03409','KEGG','310664',true).
concept_accession('40158: rn:R03409','EC','3.6.1.40',true).
concept_accession('40158: rn:R03409','KEGG','RNO:310664',true).
concept_accession('40158: rn:R03409','KEGG','3.6.1.40',true).
concept_accession('40153: rn:R07082','KEGG','RNO:25315',true).
concept_accession('40153: rn:R07082','EC','3.3.2.9',true).
concept_accession('40153: rn:R07082','KEGG','25315',true).
concept_accession('40153: rn:R07082','KEGG','3.3.2.9',true).
concept_accession('40153: rn:R07082','KEGG','EC:3.3.2.9',true).
concept_accession('40152: rn:R00376','KEGG','RNO:293144',true).
concept_accession('40152: rn:R00376','KEGG','RNO:289758',true).
concept_accession('40152: rn:R00376','KEGG','289758',true).
concept_accession('40152: rn:R00376','KEGG','299112',true).
concept_accession('40152: rn:R00376','KEGG','RNO:361698',true).
concept_accession('40152: rn:R00376','KEGG','246327',true).
concept_accession('40152: rn:R00376','KEGG','85241',true).
concept_accession('40152: rn:R00376','KEGG','85242',true).
concept_accession('40152: rn:R00376','KEGG','2.7.7.7',true).
concept_accession('40152: rn:R00376','KEGG','304573',true).
concept_accession('40152: rn:R00376','KEGG','59294',true).
concept_accession('40152: rn:R00376','KEGG','298098',true).
concept_accession('40152: rn:R00376','KEGG','RNO:85242',true).
concept_accession('40152: rn:R00376','KEGG','293144',true).
concept_accession('40152: rn:R00376','KEGG','362385',true).
concept_accession('40152: rn:R00376','KEGG','RNO:85241',true).
concept_accession('40152: rn:R00376','KEGG','EC:2.7.7.7',true).
concept_accession('40152: rn:R00376','KEGG','RNO:301323',true).
concept_accession('40152: rn:R00376','KEGG','RNO:298098',true).
concept_accession('40152: rn:R00376','KEGG','RNO:100362333',true).
concept_accession('40152: rn:R00376','KEGG','RNO:304573',true).
concept_accession('40152: rn:R00376','KEGG','361698',true).
concept_accession('40152: rn:R00376','KEGG','RNO:299112',true).
concept_accession('40152: rn:R00376','KEGG','RNO:246327',true).
concept_accession('40152: rn:R00376','KEGG','RNO:59294',true).
concept_accession('40152: rn:R00376','KEGG','100362333',true).
concept_accession('40152: rn:R00376','KEGG','RNO:362385',true).
concept_accession('40152: rn:R00376','EC','2.7.7.7',true).
concept_accession('40152: rn:R00376','KEGG','301323',true).
concept_accession('40155: rn:R00441','KEGG','83581',true).
concept_accession('40155: rn:R00441','KEGG','292778',true).
concept_accession('40155: rn:R00441','KEGG','RNO:361102',true).
concept_accession('40155: rn:R00441','KEGG','83582',true).
concept_accession('40155: rn:R00441','KEGG','361365',true).
concept_accession('40155: rn:R00441','KEGG','RNO:83503',true).
concept_accession('40155: rn:R00441','KEGG','361640',true).
concept_accession('40155: rn:R00441','KEGG','364834',true).
concept_accession('40155: rn:R00441','KEGG','RNO:289561',true).
concept_accession('40155: rn:R00441','KEGG','RNO:313245',true).
concept_accession('40155: rn:R00441','KEGG','363633',true).
concept_accession('40155: rn:R00441','KEGG','RNO:361640',true).
concept_accession('40155: rn:R00441','KEGG','366277',true).
concept_accession('40155: rn:R00441','KEGG','RNO:685465',true).
concept_accession('40155: rn:R00441','KEGG','310685',true).
concept_accession('40155: rn:R00441','KEGG','100363176',true).
concept_accession('40155: rn:R00441','KEGG','RNO:363633',true).
concept_accession('40155: rn:R00441','KEGG','RNO:117017',true).
concept_accession('40155: rn:R00441','KEGG','RNO:306012',true).
concept_accession('40155: rn:R00441','KEGG','RNO:502374',true).
concept_accession('40155: rn:R00441','KEGG','RNO:292778',true).
concept_accession('40155: rn:R00441','KEGG','289561',true).
concept_accession('40155: rn:R00441','KEGG','288588',true).
concept_accession('40155: rn:R00441','KEGG','RNO:690966',true).
concept_accession('40155: rn:R00441','KEGG','RNO:361365',true).
concept_accession('40155: rn:R00441','KEGG','RNO:300088',true).
concept_accession('40155: rn:R00441','KEGG','502374',true).
concept_accession('40155: rn:R00441','KEGG','311487',true).
concept_accession('40155: rn:R00441','KEGG','RNO:288588',true).
concept_accession('40155: rn:R00441','KEGG','685465',true).
concept_accession('40155: rn:R00441','KEGG','362858',true).
concept_accession('40155: rn:R00441','KEGG','498109',true).
concept_accession('40155: rn:R00441','KEGG','313245',true).
concept_accession('40155: rn:R00441','KEGG','2.7.7.6',true).
concept_accession('40155: rn:R00441','KEGG','RNO:681193',true).
concept_accession('40155: rn:R00441','KEGG','RNO:100363176',true).
concept_accession('40155: rn:R00441','KEGG','361102',true).
concept_accession('40155: rn:R00441','KEGG','681193',true).
concept_accession('40155: rn:R00441','KEGG','RNO:301246',true).
concept_accession('40155: rn:R00441','KEGG','RNO:291795',true).
concept_accession('40155: rn:R00441','KEGG','RNO:361784',true).
concept_accession('40155: rn:R00441','KEGG','RNO:362858',true).
concept_accession('40155: rn:R00441','KEGG','117017',true).
concept_accession('40155: rn:R00441','KEGG','300088',true).
concept_accession('40155: rn:R00441','KEGG','EC:2.7.7.6',true).
concept_accession('40155: rn:R00441','KEGG','83503',true).
concept_accession('40155: rn:R00441','KEGG','RNO:690254',true).
concept_accession('40155: rn:R00441','KEGG','RNO:311487',true).
concept_accession('40155: rn:R00441','KEGG','291795',true).
concept_accession('40155: rn:R00441','KEGG','RNO:83582',true).
concept_accession('40155: rn:R00441','KEGG','RNO:366277',true).
concept_accession('40155: rn:R00441','KEGG','RNO:83581',true).
concept_accession('40155: rn:R00441','KEGG','361784',true).
concept_accession('40155: rn:R00441','KEGG','690254',true).
concept_accession('40155: rn:R00441','KEGG','RNO:498109',true).
concept_accession('40155: rn:R00441','KEGG','690966',true).
concept_accession('40155: rn:R00441','KEGG','306012',true).
concept_accession('40155: rn:R00441','EC','2.7.7.6',true).
concept_accession('40155: rn:R00441','KEGG','RNO:364834',true).
concept_accession('40155: rn:R00441','KEGG','301246',true).
concept_accession('40155: rn:R00441','KEGG','RNO:310685',true).
concept_accession('40154: rn:R00434','KEGG','25202',true).
concept_accession('40154: rn:R00434','KEGG','4.6.1.2',true).
concept_accession('40154: rn:R00434','KEGG','RNO:116564',true).
concept_accession('40154: rn:R00434','KEGG','25206',true).
concept_accession('40154: rn:R00434','KEGG','RNO:113911',true).
concept_accession('40154: rn:R00434','KEGG','116556',true).
concept_accession('40154: rn:R00434','EC','4.6.1.2',true).
concept_accession('40154: rn:R00434','KEGG','116564',true).
concept_accession('40154: rn:R00434','KEGG','RNO:25711',true).
concept_accession('40154: rn:R00434','KEGG','RNO:24603',true).
concept_accession('40154: rn:R00434','KEGG','EC:4.6.1.2',true).
concept_accession('40154: rn:R00434','KEGG','RNO:79222',true).
concept_accession('40154: rn:R00434','KEGG','24603',true).
concept_accession('40154: rn:R00434','KEGG','RNO:25206',true).
concept_accession('40154: rn:R00434','KEGG','79222',true).
concept_accession('40154: rn:R00434','KEGG','497757',true).
concept_accession('40154: rn:R00434','KEGG','25711',true).
concept_accession('40154: rn:R00434','KEGG','66012',true).
concept_accession('40154: rn:R00434','KEGG','RNO:116556',true).
concept_accession('40154: rn:R00434','KEGG','113911',true).
concept_accession('40154: rn:R00434','KEGG','RNO:25202',true).
concept_accession('40154: rn:R00434','KEGG','RNO:497757',true).
concept_accession('40154: rn:R00434','KEGG','RNO:66012',true).
concept_accession('5462: rn:R01557','EC','5.4.99.16',false).
concept_accession('5462: rn:R01557','KEGG','RC:RC01816',true).
concept_accession('5462: rn:R01557','KEGG','5.4.99.16',true).
concept_accession('5462: rn:R01557','KEGG','RN:R01557',true).
concept_accession('5462: rn:R01557','KEGG','R01557',true).
concept_accession('5462: rn:R01557','KEGG','RP11015',true).
concept_accession('5462: rn:R01557','KEGG','EC:5.4.99.16',true).
concept_accession('5462: rn:R01557','KEGG','RP:RP11015',true).
concept_accession('5462: rn:R01557','KEGG','RC01816',true).
concept_accession('40149: rn:R07083','KEGG','289197',true).
concept_accession('40149: rn:R07083','KEGG','494500',true).
concept_accession('40149: rn:R07083','KEGG','RNO:681913',true).
concept_accession('40149: rn:R07083','KEGG','363205',true).
concept_accession('40149: rn:R07083','KEGG','EC:2.5.1.18',true).
concept_accession('40149: rn:R07083','KEGG','RNO:494500',true).
concept_accession('40149: rn:R07083','KEGG','29487',true).
concept_accession('40149: rn:R07083','EC','2.5.1.18',true).
concept_accession('40149: rn:R07083','KEGG','309465',true).
concept_accession('40149: rn:R07083','KEGG','RNO:57298',true).
concept_accession('40149: rn:R07083','KEGG','RNO:171341',true).
concept_accession('40149: rn:R07083','KEGG','RNO:24423',true).
concept_accession('40149: rn:R07083','KEGG','681913',true).
concept_accession('40149: rn:R07083','KEGG','300850',true).
concept_accession('40149: rn:R07083','KEGG','RNO:24424',true).
concept_accession('40149: rn:R07083','KEGG','RNO:24421',true).
concept_accession('40149: rn:R07083','KEGG','RNO:24422',true).
concept_accession('40149: rn:R07083','KEGG','RNO:81869',true).
concept_accession('40149: rn:R07083','KEGG','295037',true).
concept_accession('40149: rn:R07083','KEGG','RNO:24426',true).
concept_accession('40149: rn:R07083','KEGG','494499',true).
concept_accession('40149: rn:R07083','KEGG','RNO:289197',true).
concept_accession('40149: rn:R07083','KEGG','25260',true).
concept_accession('40149: rn:R07083','KEGG','114846',true).
concept_accession('40149: rn:R07083','KEGG','81869',true).
concept_accession('40149: rn:R07083','KEGG','501110',true).
concept_accession('40149: rn:R07083','KEGG','64352',true).
concept_accession('40149: rn:R07083','KEGG','24426',true).
concept_accession('40149: rn:R07083','KEGG','RNO:300850',true).
concept_accession('40149: rn:R07083','KEGG','24421',true).
concept_accession('40149: rn:R07083','KEGG','RNO:499688',true).
concept_accession('40149: rn:R07083','KEGG','2.5.1.18',true).
concept_accession('40149: rn:R07083','KEGG','24423',true).
concept_accession('40149: rn:R07083','KEGG','RNO:499689',true).
concept_accession('40149: rn:R07083','KEGG','24422',true).
concept_accession('40149: rn:R07083','KEGG','24424',true).
concept_accession('40149: rn:R07083','KEGG','499689',true).
concept_accession('40149: rn:R07083','KEGG','RNO:29487',true).
concept_accession('40149: rn:R07083','KEGG','499688',true).
concept_accession('40149: rn:R07083','KEGG','RNO:494499',true).
concept_accession('40149: rn:R07083','KEGG','RNO:114846',true).
concept_accession('40149: rn:R07083','KEGG','RNO:501110',true).
concept_accession('40149: rn:R07083','KEGG','57298',true).
concept_accession('40149: rn:R07083','KEGG','RNO:309465',true).
concept_accession('40149: rn:R07083','KEGG','RNO:297029',true).
concept_accession('40149: rn:R07083','KEGG','171341',true).
concept_accession('40149: rn:R07083','KEGG','RNO:25260',true).
concept_accession('40149: rn:R07083','KEGG','RNO:295037',true).
concept_accession('40149: rn:R07083','KEGG','RNO:363205',true).
concept_accession('40149: rn:R07083','KEGG','RNO:64352',true).
concept_accession('40149: rn:R07083','KEGG','297029',true).
concept_accession('40148: rn:R01968','KEGG','RNO:313574',true).
concept_accession('40148: rn:R01968','KEGG','100363253',true).
concept_accession('40148: rn:R01968','KEGG','RNO:688261',true).
concept_accession('40148: rn:R01968','KEGG','RNO:287368',true).
concept_accession('40148: rn:R01968','KEGG','688261',true).
concept_accession('40148: rn:R01968','EC','3.1.3.5',true).
concept_accession('40148: rn:R01968','KEGG','313574',true).
concept_accession('40148: rn:R01968','KEGG','RNO:58813',true).
concept_accession('40148: rn:R01968','KEGG','287368',true).
concept_accession('40148: rn:R01968','KEGG','RNO:312373',true).
concept_accession('40148: rn:R01968','KEGG','3.1.3.5',true).
concept_accession('40148: rn:R01968','KEGG','RNO:100363253',true).
concept_accession('40148: rn:R01968','KEGG','RNO:298881',true).
concept_accession('40148: rn:R01968','KEGG','EC:3.1.3.5',true).
concept_accession('40148: rn:R01968','KEGG','298881',true).
concept_accession('40148: rn:R01968','KEGG','58813',true).
concept_accession('40148: rn:R01968','KEGG','312373',true).
concept_accession('40151: rn:R07091','KEGG','289197',true).
concept_accession('40151: rn:R07091','KEGG','494500',true).
concept_accession('40151: rn:R07091','KEGG','RNO:681913',true).
concept_accession('40151: rn:R07091','KEGG','363205',true).
concept_accession('40151: rn:R07091','KEGG','EC:2.5.1.18',true).
concept_accession('40151: rn:R07091','KEGG','RNO:494500',true).
concept_accession('40151: rn:R07091','KEGG','29487',true).
concept_accession('40151: rn:R07091','EC','2.5.1.18',true).
concept_accession('40151: rn:R07091','KEGG','309465',true).
concept_accession('40151: rn:R07091','KEGG','RNO:57298',true).
concept_accession('40151: rn:R07091','KEGG','RNO:171341',true).
concept_accession('40151: rn:R07091','KEGG','RNO:24423',true).
concept_accession('40151: rn:R07091','KEGG','681913',true).
concept_accession('40151: rn:R07091','KEGG','300850',true).
concept_accession('40151: rn:R07091','KEGG','RNO:24424',true).
concept_accession('40151: rn:R07091','KEGG','RNO:24421',true).
concept_accession('40151: rn:R07091','KEGG','RNO:24422',true).
concept_accession('40151: rn:R07091','KEGG','RNO:81869',true).
concept_accession('40151: rn:R07091','KEGG','295037',true).
concept_accession('40151: rn:R07091','KEGG','RNO:24426',true).
concept_accession('40151: rn:R07091','KEGG','494499',true).
concept_accession('40151: rn:R07091','KEGG','RNO:289197',true).
concept_accession('40151: rn:R07091','KEGG','25260',true).
concept_accession('40151: rn:R07091','KEGG','114846',true).
concept_accession('40151: rn:R07091','KEGG','81869',true).
concept_accession('40151: rn:R07091','KEGG','501110',true).
concept_accession('40151: rn:R07091','KEGG','64352',true).
concept_accession('40151: rn:R07091','KEGG','24426',true).
concept_accession('40151: rn:R07091','KEGG','RNO:300850',true).
concept_accession('40151: rn:R07091','KEGG','24421',true).
concept_accession('40151: rn:R07091','KEGG','RNO:499688',true).
concept_accession('40151: rn:R07091','KEGG','2.5.1.18',true).
concept_accession('40151: rn:R07091','KEGG','24423',true).
concept_accession('40151: rn:R07091','KEGG','RNO:499689',true).
concept_accession('40151: rn:R07091','KEGG','24422',true).
concept_accession('40151: rn:R07091','KEGG','24424',true).
concept_accession('40151: rn:R07091','KEGG','499689',true).
concept_accession('40151: rn:R07091','KEGG','RNO:29487',true).
concept_accession('40151: rn:R07091','KEGG','499688',true).
concept_accession('40151: rn:R07091','KEGG','RNO:494499',true).
concept_accession('40151: rn:R07091','KEGG','RNO:114846',true).
concept_accession('40151: rn:R07091','KEGG','RNO:501110',true).
concept_accession('40151: rn:R07091','KEGG','57298',true).
concept_accession('40151: rn:R07091','KEGG','RNO:309465',true).
concept_accession('40151: rn:R07091','KEGG','RNO:297029',true).
concept_accession('40151: rn:R07091','KEGG','171341',true).
concept_accession('40151: rn:R07091','KEGG','RNO:25260',true).
concept_accession('40151: rn:R07091','KEGG','RNO:295037',true).
concept_accession('40151: rn:R07091','KEGG','RNO:363205',true).
concept_accession('40151: rn:R07091','KEGG','RNO:64352',true).
concept_accession('40151: rn:R07091','KEGG','297029',true).
concept_accession('40150: rn:R01857','KEGG','171566',true).
concept_accession('40150: rn:R01857','KEGG','2.7.4.6',true).
concept_accession('40150: rn:R01857','KEGG','685679',true).
concept_accession('40150: rn:R01857','KEGG','83782',true).
concept_accession('40150: rn:R01857','KEGG','RNO:58964',true).
concept_accession('40150: rn:R01857','KEGG','RNO:83782',true).
concept_accession('40150: rn:R01857','KEGG','85269',true).
concept_accession('40150: rn:R01857','KEGG','RNO:685679',true).
concept_accession('40150: rn:R01857','KEGG','RNO:85269',true).
concept_accession('40150: rn:R01857','EC','2.7.4.6',true).
concept_accession('40150: rn:R01857','KEGG','EC:2.7.4.6',true).
concept_accession('40150: rn:R01857','KEGG','RNO:191575',true).
concept_accession('40150: rn:R01857','KEGG','191575',true).
concept_accession('40150: rn:R01857','KEGG','58964',true).
concept_accession('40150: rn:R01857','KEGG','RNO:171566',true).
concept_accession('40145: rn:R00187','KEGG','RNO:60398',true).
concept_accession('40145: rn:R00187','KEGG','60398',true).
concept_accession('40145: rn:R00187','KEGG','EC:3.6.1.29',true).
concept_accession('40145: rn:R00187','KEGG','3.6.1.29',true).
concept_accession('40145: rn:R00187','EC','3.6.1.29',true).
concept_accession('40144: rn:R03531','EC','3.6.1.19',true).
concept_accession('40144: rn:R03531','KEGG','EC:3.6.1.19',true).
concept_accession('40144: rn:R03531','KEGG','RNO:311422',true).
concept_accession('40144: rn:R03531','KEGG','311422',true).
concept_accession('40144: rn:R03531','KEGG','3.6.1.19',true).
concept_accession('40147: rn:R07084','KEGG','289197',true).
concept_accession('40147: rn:R07084','KEGG','494500',true).
concept_accession('40147: rn:R07084','KEGG','RNO:681913',true).
concept_accession('40147: rn:R07084','KEGG','363205',true).
concept_accession('40147: rn:R07084','KEGG','EC:2.5.1.18',true).
concept_accession('40147: rn:R07084','KEGG','RNO:494500',true).
concept_accession('40147: rn:R07084','KEGG','29487',true).
concept_accession('40147: rn:R07084','EC','2.5.1.18',true).
concept_accession('40147: rn:R07084','KEGG','309465',true).
concept_accession('40147: rn:R07084','KEGG','RNO:57298',true).
concept_accession('40147: rn:R07084','KEGG','RNO:171341',true).
concept_accession('40147: rn:R07084','KEGG','RNO:24423',true).
concept_accession('40147: rn:R07084','KEGG','681913',true).
concept_accession('40147: rn:R07084','KEGG','300850',true).
concept_accession('40147: rn:R07084','KEGG','RNO:24424',true).
concept_accession('40147: rn:R07084','KEGG','RNO:24421',true).
concept_accession('40147: rn:R07084','KEGG','RNO:24422',true).
concept_accession('40147: rn:R07084','KEGG','RNO:81869',true).
concept_accession('40147: rn:R07084','KEGG','295037',true).
concept_accession('40147: rn:R07084','KEGG','RNO:24426',true).
concept_accession('40147: rn:R07084','KEGG','494499',true).
concept_accession('40147: rn:R07084','KEGG','RNO:289197',true).
concept_accession('40147: rn:R07084','KEGG','25260',true).
concept_accession('40147: rn:R07084','KEGG','114846',true).
concept_accession('40147: rn:R07084','KEGG','81869',true).
concept_accession('40147: rn:R07084','KEGG','501110',true).
concept_accession('40147: rn:R07084','KEGG','64352',true).
concept_accession('40147: rn:R07084','KEGG','24426',true).
concept_accession('40147: rn:R07084','KEGG','RNO:300850',true).
concept_accession('40147: rn:R07084','KEGG','24421',true).
concept_accession('40147: rn:R07084','KEGG','RNO:499688',true).
concept_accession('40147: rn:R07084','KEGG','2.5.1.18',true).
concept_accession('40147: rn:R07084','KEGG','24423',true).
concept_accession('40147: rn:R07084','KEGG','RNO:499689',true).
concept_accession('40147: rn:R07084','KEGG','24422',true).
concept_accession('40147: rn:R07084','KEGG','24424',true).
concept_accession('40147: rn:R07084','KEGG','499689',true).
concept_accession('40147: rn:R07084','KEGG','RNO:29487',true).
concept_accession('40147: rn:R07084','KEGG','499688',true).
concept_accession('40147: rn:R07084','KEGG','RNO:494499',true).
concept_accession('40147: rn:R07084','KEGG','RNO:114846',true).
concept_accession('40147: rn:R07084','KEGG','RNO:501110',true).
concept_accession('40147: rn:R07084','KEGG','57298',true).
concept_accession('40147: rn:R07084','KEGG','RNO:309465',true).
concept_accession('40147: rn:R07084','KEGG','RNO:297029',true).
concept_accession('40147: rn:R07084','KEGG','171341',true).
concept_accession('40147: rn:R07084','KEGG','RNO:25260',true).
concept_accession('40147: rn:R07084','KEGG','RNO:295037',true).
concept_accession('40147: rn:R07084','KEGG','RNO:363205',true).
concept_accession('40147: rn:R07084','KEGG','RNO:64352',true).
concept_accession('40147: rn:R07084','KEGG','297029',true).
concept_accession('40146: rn:R02147','KEGG','290029',true).
concept_accession('40146: rn:R02147','KEGG','2.4.2.1',true).
concept_accession('40146: rn:R02147','KEGG','EC:2.4.2.1',true).
concept_accession('40146: rn:R02147','EC','2.4.2.1',true).
concept_accession('40146: rn:R02147','KEGG','RNO:290029',true).
concept_accession('5455: rn:R00803','KEGG','EC:2.4.1.7',true).
concept_accession('5455: rn:R00803','KEGG','R00803',true).
concept_accession('5455: rn:R00803','KEGG','2.4.1.7',true).
concept_accession('5455: rn:R00803','KEGG','RC00028',true).
concept_accession('5455: rn:R00803','EC','2.4.1.7',false).
concept_accession('5455: rn:R00803','KEGG','RP00075',true).
concept_accession('5455: rn:R00803','KEGG','RC:RC00028',true).
concept_accession('5455: rn:R00803','KEGG','RN:R00803',true).
concept_accession('5455: rn:R00803','KEGG','RP:RP00075',true).
concept_accession('40140: rn:R00961','KEGG','RNO:85260',true).
concept_accession('40140: rn:R00961','KEGG','RNO:314312',true).
concept_accession('40140: rn:R00961','KEGG','85260',true).
concept_accession('40140: rn:R00961','KEGG','314312',true).
concept_accession('40140: rn:R00961','KEGG','3.6.1.5',true).
concept_accession('40140: rn:R00961','KEGG','EC:3.6.1.5',true).
concept_accession('40140: rn:R00961','KEGG','RNO:246272',true).
concept_accession('40140: rn:R00961','KEGG','361063',true).
concept_accession('40140: rn:R00961','EC','3.6.1.5',true).
concept_accession('40140: rn:R00961','KEGG','RNO:361063',true).
concept_accession('40140: rn:R00961','KEGG','246272',true).
concept_accession('40141: rn:R02557','KEGG','290029',true).
concept_accession('40141: rn:R02557','KEGG','2.4.2.1',true).
concept_accession('40141: rn:R02557','KEGG','EC:2.4.2.1',true).
concept_accession('40141: rn:R02557','EC','2.4.2.1',true).
concept_accession('40141: rn:R02557','KEGG','RNO:290029',true).
concept_accession('40142: rn:R01547','KEGG','29223',true).
concept_accession('40142: rn:R01547','KEGG','24184',true).
concept_accession('40142: rn:R01547','KEGG','24183',true).
concept_accession('40142: rn:R01547','KEGG','365985',true).
concept_accession('40142: rn:R01547','KEGG','2.7.4.11',true).
concept_accession('40142: rn:R01547','KEGG','RNO:314416',true).
concept_accession('40142: rn:R01547','KEGG','EC:2.7.4.11',true).
concept_accession('40142: rn:R01547','KEGG','RNO:29223',true).
concept_accession('40142: rn:R01547','KEGG','RNO:365985',true).
concept_accession('40142: rn:R01547','KEGG','314416',true).
concept_accession('40142: rn:R01547','EC','2.7.4.11',true).
concept_accession('40142: rn:R01547','KEGG','RNO:24184',true).
concept_accession('40142: rn:R01547','KEGG','RNO:24183',true).
concept_accession('40143: rn:R03530','KEGG','171566',true).
concept_accession('40143: rn:R03530','KEGG','2.7.4.6',true).
concept_accession('40143: rn:R03530','KEGG','685679',true).
concept_accession('40143: rn:R03530','KEGG','83782',true).
concept_accession('40143: rn:R03530','KEGG','RNO:58964',true).
concept_accession('40143: rn:R03530','KEGG','RNO:83782',true).
concept_accession('40143: rn:R03530','KEGG','85269',true).
concept_accession('40143: rn:R03530','KEGG','RNO:685679',true).
concept_accession('40143: rn:R03530','KEGG','RNO:85269',true).
concept_accession('40143: rn:R03530','EC','2.7.4.6',true).
concept_accession('40143: rn:R03530','KEGG','EC:2.7.4.6',true).
concept_accession('40143: rn:R03530','KEGG','RNO:191575',true).
concept_accession('40143: rn:R03530','KEGG','191575',true).
concept_accession('40143: rn:R03530','KEGG','58964',true).
concept_accession('40143: rn:R03530','KEGG','RNO:171566',true).
concept_accession('40136: rn:R00430','KEGG','RNO:25630',true).
concept_accession('40136: rn:R00430','KEGG','24651',true).
concept_accession('40136: rn:R00430','KEGG','2.7.1.40',true).
concept_accession('40136: rn:R00430','KEGG','25630',true).
concept_accession('40136: rn:R00430','KEGG','EC:2.7.1.40',true).
concept_accession('40136: rn:R00430','EC','2.7.1.40',true).
concept_accession('40136: rn:R00430','KEGG','100364062',true).
concept_accession('40136: rn:R00430','KEGG','RNO:24651',true).
concept_accession('40136: rn:R00430','KEGG','RNO:100364062',true).
concept_accession('40137: rn:R01858','KEGG','RNO:25630',true).
concept_accession('40137: rn:R01858','KEGG','24651',true).
concept_accession('40137: rn:R01858','KEGG','2.7.1.40',true).
concept_accession('40137: rn:R01858','KEGG','25630',true).
concept_accession('40137: rn:R01858','KEGG','EC:2.7.1.40',true).
concept_accession('40137: rn:R01858','EC','2.7.1.40',true).
concept_accession('40137: rn:R01858','KEGG','100364062',true).
concept_accession('40137: rn:R01858','KEGG','RNO:24651',true).
concept_accession('40137: rn:R01858','KEGG','RNO:100364062',true).
concept_accession('5449: rn:R00306','KEGG','RC:RC00049',true).
concept_accession('5449: rn:R00306','KEGG','EC:3.2.1.74',true).
concept_accession('5449: rn:R00306','KEGG','RP13490',true).
concept_accession('5449: rn:R00306','KEGG','R00306',true).
concept_accession('5449: rn:R00306','EC','3.2.1.74',false).
concept_accession('5449: rn:R00306','KEGG','RN:R00306',true).
concept_accession('5449: rn:R00306','KEGG','RP00324',true).
concept_accession('5449: rn:R00306','KEGG','RP:RP00324',true).
concept_accession('5449: rn:R00306','KEGG','RP:RP13490',true).
concept_accession('5449: rn:R00306','KEGG','3.2.1.74',true).
concept_accession('5449: rn:R00306','KEGG','RC00049',true).
concept_accession('40138: rn:R01229','KEGG','EC:2.4.2.8',true).
concept_accession('40138: rn:R01229','EC','2.4.2.8',true).
concept_accession('40138: rn:R01229','KEGG','RNO:292072',true).
concept_accession('40138: rn:R01229','KEGG','2.4.2.8',true).
concept_accession('40138: rn:R01229','KEGG','292072',true).
concept_accession('40139: rn:R04378','KEGG','2.4.2.7',true).
concept_accession('40139: rn:R04378','EC','2.4.2.7',true).
concept_accession('40139: rn:R04378','KEGG','EC:2.4.2.7',true).
concept_accession('40139: rn:R04378','KEGG','RNO:292072',true).
concept_accession('40139: rn:R04378','KEGG','292072',true).
concept_accession('40132: rn:R07093','KEGG','289197',true).
concept_accession('40132: rn:R07093','KEGG','494500',true).
concept_accession('40132: rn:R07093','KEGG','RNO:681913',true).
concept_accession('40132: rn:R07093','KEGG','363205',true).
concept_accession('40132: rn:R07093','KEGG','EC:2.5.1.18',true).
concept_accession('40132: rn:R07093','KEGG','RNO:494500',true).
concept_accession('40132: rn:R07093','KEGG','29487',true).
concept_accession('40132: rn:R07093','EC','2.5.1.18',true).
concept_accession('40132: rn:R07093','KEGG','309465',true).
concept_accession('40132: rn:R07093','KEGG','RNO:57298',true).
concept_accession('40132: rn:R07093','KEGG','RNO:171341',true).
concept_accession('40132: rn:R07093','KEGG','RNO:24423',true).
concept_accession('40132: rn:R07093','KEGG','681913',true).
concept_accession('40132: rn:R07093','KEGG','300850',true).
concept_accession('40132: rn:R07093','KEGG','RNO:24424',true).
concept_accession('40132: rn:R07093','KEGG','RNO:24421',true).
concept_accession('40132: rn:R07093','KEGG','RNO:24422',true).
concept_accession('40132: rn:R07093','KEGG','RNO:81869',true).
concept_accession('40132: rn:R07093','KEGG','295037',true).
concept_accession('40132: rn:R07093','KEGG','RNO:24426',true).
concept_accession('40132: rn:R07093','KEGG','494499',true).
concept_accession('40132: rn:R07093','KEGG','RNO:289197',true).
concept_accession('40132: rn:R07093','KEGG','25260',true).
concept_accession('40132: rn:R07093','KEGG','114846',true).
concept_accession('40132: rn:R07093','KEGG','81869',true).
concept_accession('40132: rn:R07093','KEGG','501110',true).
concept_accession('40132: rn:R07093','KEGG','64352',true).
concept_accession('40132: rn:R07093','KEGG','24426',true).
concept_accession('40132: rn:R07093','KEGG','RNO:300850',true).
concept_accession('40132: rn:R07093','KEGG','24421',true).
concept_accession('40132: rn:R07093','KEGG','RNO:499688',true).
concept_accession('40132: rn:R07093','KEGG','2.5.1.18',true).
concept_accession('40132: rn:R07093','KEGG','24423',true).
concept_accession('40132: rn:R07093','KEGG','RNO:499689',true).
concept_accession('40132: rn:R07093','KEGG','24422',true).
concept_accession('40132: rn:R07093','KEGG','24424',true).
concept_accession('40132: rn:R07093','KEGG','499689',true).
concept_accession('40132: rn:R07093','KEGG','RNO:29487',true).
concept_accession('40132: rn:R07093','KEGG','499688',true).
concept_accession('40132: rn:R07093','KEGG','RNO:494499',true).
concept_accession('40132: rn:R07093','KEGG','RNO:114846',true).
concept_accession('40132: rn:R07093','KEGG','RNO:501110',true).
concept_accession('40132: rn:R07093','KEGG','57298',true).
concept_accession('40132: rn:R07093','KEGG','RNO:309465',true).
concept_accession('40132: rn:R07093','KEGG','RNO:297029',true).
concept_accession('40132: rn:R07093','KEGG','171341',true).
concept_accession('40132: rn:R07093','KEGG','RNO:25260',true).
concept_accession('40132: rn:R07093','KEGG','RNO:295037',true).
concept_accession('40132: rn:R07093','KEGG','RNO:363205',true).
concept_accession('40132: rn:R07093','KEGG','RNO:64352',true).
concept_accession('40132: rn:R07093','KEGG','297029',true).
concept_accession('9750: rn:R00740','KEGG','R00740',true).
concept_accession('9750: rn:R00740','KEGG','EC:1.2.1.18',true).
concept_accession('9750: rn:R00740','KEGG','RC00184',true).
concept_accession('9750: rn:R00740','KEGG','RN:R00740',true).
concept_accession('9750: rn:R00740','KEGG','RP01076',true).
concept_accession('9750: rn:R00740','EC','1.2.1.18',false).
concept_accession('9750: rn:R00740','KEGG','RC:RC00184',true).
concept_accession('9750: rn:R00740','KEGG','1.2.1.18',true).
concept_accession('9750: rn:R00740','KEGG','RP:RP01076',true).
concept_accession('40133: rn:R00184','EC','3.6.1.17',true).
concept_accession('40133: rn:R00184','KEGG','RNO:297998',true).
concept_accession('40133: rn:R00184','KEGG','EC:3.6.1.17',true).
concept_accession('40133: rn:R00184','KEGG','297998',true).
concept_accession('40133: rn:R00184','KEGG','3.6.1.17',true).
concept_accession('9749: rn:R01196','KEGG','R01196',true).
concept_accession('9749: rn:R01196','KEGG','RN:R01196',true).
concept_accession('9749: rn:R01196','KEGG','1.2.7.1',true).
concept_accession('9749: rn:R01196','EC','1.2.7.1',false).
concept_accession('9749: rn:R01196','KEGG','EC:1.2.7.1',true).
concept_accession('5445: rn:R02886','KEGG','RP:RP02572',true).
concept_accession('5445: rn:R02886','KEGG','RC00799',true).
concept_accession('5445: rn:R02886','KEGG','3.2.1.91',true).
concept_accession('5445: rn:R02886','EC','3.2.1.91',false).
concept_accession('5445: rn:R02886','KEGG','EC:3.2.1.91',true).
concept_accession('5445: rn:R02886','KEGG','RN:R02886',true).
concept_accession('5445: rn:R02886','KEGG','RC:RC00799',true).
concept_accession('5445: rn:R02886','KEGG','RP02572',true).
concept_accession('5445: rn:R02886','KEGG','R02886',true).
concept_accession('40134: rn:R01967','KEGG','EC:2.7.1.113',true).
concept_accession('40134: rn:R01967','KEGG','297389',true).
concept_accession('40134: rn:R01967','KEGG','RNO:297389',true).
concept_accession('40134: rn:R01967','EC','2.7.1.113',true).
concept_accession('40134: rn:R01967','KEGG','2.7.1.113',true).
concept_accession('5444: rn:R00952','EC','2.4.1.20',false).
concept_accession('5444: rn:R00952','KEGG','RC:RC00049',true).
concept_accession('5444: rn:R00952','KEGG','2.4.1.20',true).
concept_accession('5444: rn:R00952','KEGG','EC:2.4.1.20',true).
concept_accession('5444: rn:R00952','KEGG','RP00324',true).
concept_accession('5444: rn:R00952','KEGG','RP:RP00324',true).
concept_accession('5444: rn:R00952','KEGG','RC00049',true).
concept_accession('5444: rn:R00952','KEGG','RN:R00952',true).
concept_accession('5444: rn:R00952','KEGG','R00952',true).
concept_accession('40135: rn:R00434','KEGG','29241',true).
concept_accession('40135: rn:R00434','KEGG','RNO:25289',true).
concept_accession('40135: rn:R00434','KEGG','EC:4.6.1.2',true).
concept_accession('40135: rn:R00434','KEGG','64508',true).
concept_accession('40135: rn:R00434','KEGG','81636',true).
concept_accession('40135: rn:R00434','KEGG','RNO:81636',true).
concept_accession('40135: rn:R00434','KEGG','59320',true).
concept_accession('40135: rn:R00434','KEGG','84420',true).
concept_accession('40135: rn:R00434','KEGG','RNO:64532',true).
concept_accession('40135: rn:R00434','KEGG','305509',true).
concept_accession('40135: rn:R00434','KEGG','54223',true).
concept_accession('40135: rn:R00434','KEGG','RNO:59320',true).
concept_accession('40135: rn:R00434','KEGG','RNO:100362008',true).
concept_accession('40135: rn:R00434','KEGG','4.6.1.2',true).
concept_accession('40135: rn:R00434','EC','4.6.1.2',true).
concept_accession('40135: rn:R00434','KEGG','RNO:302950',true).
concept_accession('40135: rn:R00434','KEGG','RNO:64508',true).
concept_accession('40135: rn:R00434','KEGG','RNO:54223',true).
concept_accession('40135: rn:R00434','KEGG','64532',true).
concept_accession('40135: rn:R00434','KEGG','100362008',true).
concept_accession('40135: rn:R00434','KEGG','RNO:29241',true).
concept_accession('40135: rn:R00434','KEGG','25289',true).
concept_accession('40135: rn:R00434','KEGG','RNO:305509',true).
concept_accession('40135: rn:R00434','KEGG','302950',true).
concept_accession('40135: rn:R00434','KEGG','RNO:84420',true).
concept_accession('40128: rn:R01855','EC','3.6.1.19',true).
concept_accession('40128: rn:R01855','KEGG','EC:3.6.1.19',true).
concept_accession('40128: rn:R01855','KEGG','RNO:311422',true).
concept_accession('40128: rn:R01855','KEGG','311422',true).
concept_accession('40128: rn:R01855','KEGG','3.6.1.19',true).
concept_accession('40129: rn:R07002','KEGG','289197',true).
concept_accession('40129: rn:R07002','KEGG','494500',true).
concept_accession('40129: rn:R07002','KEGG','RNO:681913',true).
concept_accession('40129: rn:R07002','KEGG','363205',true).
concept_accession('40129: rn:R07002','KEGG','EC:2.5.1.18',true).
concept_accession('40129: rn:R07002','KEGG','RNO:494500',true).
concept_accession('40129: rn:R07002','KEGG','29487',true).
concept_accession('40129: rn:R07002','EC','2.5.1.18',true).
concept_accession('40129: rn:R07002','KEGG','309465',true).
concept_accession('40129: rn:R07002','KEGG','RNO:57298',true).
concept_accession('40129: rn:R07002','KEGG','RNO:171341',true).
concept_accession('40129: rn:R07002','KEGG','RNO:24423',true).
concept_accession('40129: rn:R07002','KEGG','681913',true).
concept_accession('40129: rn:R07002','KEGG','300850',true).
concept_accession('40129: rn:R07002','KEGG','RNO:24424',true).
concept_accession('40129: rn:R07002','KEGG','RNO:24421',true).
concept_accession('40129: rn:R07002','KEGG','RNO:24422',true).
concept_accession('40129: rn:R07002','KEGG','RNO:81869',true).
concept_accession('40129: rn:R07002','KEGG','295037',true).
concept_accession('40129: rn:R07002','KEGG','RNO:24426',true).
concept_accession('40129: rn:R07002','KEGG','494499',true).
concept_accession('40129: rn:R07002','KEGG','RNO:289197',true).
concept_accession('40129: rn:R07002','KEGG','25260',true).
concept_accession('40129: rn:R07002','KEGG','114846',true).
concept_accession('40129: rn:R07002','KEGG','81869',true).
concept_accession('40129: rn:R07002','KEGG','501110',true).
concept_accession('40129: rn:R07002','KEGG','64352',true).
concept_accession('40129: rn:R07002','KEGG','24426',true).
concept_accession('40129: rn:R07002','KEGG','RNO:300850',true).
concept_accession('40129: rn:R07002','KEGG','24421',true).
concept_accession('40129: rn:R07002','KEGG','RNO:499688',true).
concept_accession('40129: rn:R07002','KEGG','2.5.1.18',true).
concept_accession('40129: rn:R07002','KEGG','24423',true).
concept_accession('40129: rn:R07002','KEGG','RNO:499689',true).
concept_accession('40129: rn:R07002','KEGG','24422',true).
concept_accession('40129: rn:R07002','KEGG','24424',true).
concept_accession('40129: rn:R07002','KEGG','499689',true).
concept_accession('40129: rn:R07002','KEGG','RNO:29487',true).
concept_accession('40129: rn:R07002','KEGG','499688',true).
concept_accession('40129: rn:R07002','KEGG','RNO:494499',true).
concept_accession('40129: rn:R07002','KEGG','RNO:114846',true).
concept_accession('40129: rn:R07002','KEGG','RNO:501110',true).
concept_accession('40129: rn:R07002','KEGG','57298',true).
concept_accession('40129: rn:R07002','KEGG','RNO:309465',true).
concept_accession('40129: rn:R07002','KEGG','RNO:297029',true).
concept_accession('40129: rn:R07002','KEGG','171341',true).
concept_accession('40129: rn:R07002','KEGG','RNO:25260',true).
concept_accession('40129: rn:R07002','KEGG','RNO:295037',true).
concept_accession('40129: rn:R07002','KEGG','RNO:363205',true).
concept_accession('40129: rn:R07002','KEGG','RNO:64352',true).
concept_accession('40129: rn:R07002','KEGG','297029',true).
concept_accession('40130: rn:R01054','KEGG','3.6.1.13',true).
concept_accession('40130: rn:R01054','KEGG','EC:3.6.1.13',true).
concept_accession('40130: rn:R01054','KEGG','RNO:361274',true).
concept_accession('40130: rn:R01054','KEGG','287406',true).
concept_accession('40130: rn:R01054','KEGG','361274',true).
concept_accession('40130: rn:R01054','EC','3.6.1.13',true).
concept_accession('40130: rn:R01054','KEGG','RNO:305149',true).
concept_accession('40130: rn:R01054','KEGG','RNO:287406',true).
concept_accession('40130: rn:R01054','KEGG','305149',true).
concept_accession('40131: rn:R01232','EC','3.6.1.17',true).
concept_accession('40131: rn:R01232','KEGG','RNO:297998',true).
concept_accession('40131: rn:R01232','KEGG','EC:3.6.1.17',true).
concept_accession('40131: rn:R01232','KEGG','297998',true).
concept_accession('40131: rn:R01232','KEGG','3.6.1.17',true).
concept_accession('40123: rn:R00122','KEGG','316077',true).
concept_accession('40123: rn:R00122','KEGG','64519',true).
concept_accession('40123: rn:R00122','KEGG','RNO:613267',true).
concept_accession('40123: rn:R00122','KEGG','3.6.1.5',true).
concept_accession('40123: rn:R00122','KEGG','RNO:64519',true).
concept_accession('40123: rn:R00122','KEGG','EC:3.6.1.5',true).
concept_accession('40123: rn:R00122','EC','3.6.1.5',true).
concept_accession('40123: rn:R00122','KEGG','613267',true).
concept_accession('40123: rn:R00122','KEGG','RNO:316077',true).
concept_accession('40122: rn:R01135','KEGG','RNO:684425',true).
concept_accession('40122: rn:R01135','KEGG','6.3.4.4',true).
concept_accession('40122: rn:R01135','KEGG','289276',true).
concept_accession('40122: rn:R01135','KEGG','684425',true).
concept_accession('40122: rn:R01135','KEGG','EC:6.3.4.4',true).
concept_accession('40122: rn:R01135','EC','6.3.4.4',true).
concept_accession('40122: rn:R01135','KEGG','RNO:289276',true).
concept_accession('40121: rn:R01083','KEGG','RNO:315150',true).
concept_accession('40121: rn:R01083','KEGG','EC:4.3.2.2',true).
concept_accession('40121: rn:R01083','KEGG','315150',true).
concept_accession('40121: rn:R01083','KEGG','4.3.2.2',true).
concept_accession('40121: rn:R01083','EC','4.3.2.2',true).
concept_accession('40120: rn:R00183','KEGG','RNO:313574',true).
concept_accession('40120: rn:R00183','KEGG','100363253',true).
concept_accession('40120: rn:R00183','KEGG','RNO:688261',true).
concept_accession('40120: rn:R00183','KEGG','RNO:287368',true).
concept_accession('40120: rn:R00183','KEGG','688261',true).
concept_accession('40120: rn:R00183','EC','3.1.3.5',true).
concept_accession('40120: rn:R00183','KEGG','313574',true).
concept_accession('40120: rn:R00183','KEGG','RNO:58813',true).
concept_accession('40120: rn:R00183','KEGG','287368',true).
concept_accession('40120: rn:R00183','KEGG','RNO:312373',true).
concept_accession('40120: rn:R00183','KEGG','3.1.3.5',true).
concept_accession('40120: rn:R00183','KEGG','RNO:100363253',true).
concept_accession('40120: rn:R00183','KEGG','RNO:298881',true).
concept_accession('40120: rn:R00183','KEGG','EC:3.1.3.5',true).
concept_accession('40120: rn:R00183','KEGG','298881',true).
concept_accession('40120: rn:R00183','KEGG','58813',true).
concept_accession('40120: rn:R00183','KEGG','312373',true).
concept_accession('40127: rn:R02805','EC','3.6.1.17',true).
concept_accession('40127: rn:R02805','KEGG','RNO:297998',true).
concept_accession('40127: rn:R02805','KEGG','EC:3.6.1.17',true).
concept_accession('40127: rn:R02805','KEGG','297998',true).
concept_accession('40127: rn:R02805','KEGG','3.6.1.17',true).
concept_accession('40126: rn:R02017','EC','1.17.4.1',true).
concept_accession('40126: rn:R02017','KEGG','362720',true).
concept_accession('40126: rn:R02017','KEGG','RNO:100359539',true).
concept_accession('40126: rn:R02017','KEGG','RNO:685579',true).
concept_accession('40126: rn:R02017','KEGG','1.17.4.1',true).
concept_accession('40126: rn:R02017','KEGG','100359539',true).
concept_accession('40126: rn:R02017','KEGG','EC:1.17.4.1',true).
concept_accession('40126: rn:R02017','KEGG','685579',true).
concept_accession('40126: rn:R02017','KEGG','299976',true).
concept_accession('40126: rn:R02017','KEGG','RNO:299976',true).
concept_accession('40126: rn:R02017','KEGG','RNO:362720',true).
concept_accession('40125: rn:R01137','KEGG','171566',true).
concept_accession('40125: rn:R01137','KEGG','2.7.4.6',true).
concept_accession('40125: rn:R01137','KEGG','685679',true).
concept_accession('40125: rn:R01137','KEGG','83782',true).
concept_accession('40125: rn:R01137','KEGG','RNO:58964',true).
concept_accession('40125: rn:R01137','KEGG','RNO:83782',true).
concept_accession('40125: rn:R01137','KEGG','85269',true).
concept_accession('40125: rn:R01137','KEGG','RNO:685679',true).
concept_accession('40125: rn:R01137','KEGG','RNO:85269',true).
concept_accession('40125: rn:R01137','EC','2.7.4.6',true).
concept_accession('40125: rn:R01137','KEGG','EC:2.7.4.6',true).
concept_accession('40125: rn:R01137','KEGG','RNO:191575',true).
concept_accession('40125: rn:R01137','KEGG','191575',true).
concept_accession('40125: rn:R01137','KEGG','58964',true).
concept_accession('40125: rn:R01137','KEGG','RNO:171566',true).
concept_accession('40124: rn:R00127','KEGG','29223',true).
concept_accession('40124: rn:R00127','KEGG','2.7.4.3',true).
concept_accession('40124: rn:R00127','KEGG','24184',true).
concept_accession('40124: rn:R00127','KEGG','24183',true).
concept_accession('40124: rn:R00127','KEGG','365985',true).
concept_accession('40124: rn:R00127','KEGG','EC:2.7.4.3',true).
concept_accession('40124: rn:R00127','EC','2.7.4.3',true).
concept_accession('40124: rn:R00127','KEGG','RNO:314416',true).
concept_accession('40124: rn:R00127','KEGG','RNO:29223',true).
concept_accession('40124: rn:R00127','KEGG','RNO:365985',true).
concept_accession('40124: rn:R00127','KEGG','314416',true).
concept_accession('40124: rn:R00127','KEGG','RNO:24184',true).
concept_accession('40124: rn:R00127','KEGG','RNO:24183',true).
concept_accession('40115: rn:R02088','KEGG','RNO:313574',true).
concept_accession('40115: rn:R02088','KEGG','100363253',true).
concept_accession('40115: rn:R02088','KEGG','RNO:688261',true).
concept_accession('40115: rn:R02088','KEGG','RNO:287368',true).
concept_accession('40115: rn:R02088','KEGG','688261',true).
concept_accession('40115: rn:R02088','EC','3.1.3.5',true).
concept_accession('40115: rn:R02088','KEGG','313574',true).
concept_accession('40115: rn:R02088','KEGG','RNO:58813',true).
concept_accession('40115: rn:R02088','KEGG','287368',true).
concept_accession('40115: rn:R02088','KEGG','RNO:312373',true).
concept_accession('40115: rn:R02088','KEGG','3.1.3.5',true).
concept_accession('40115: rn:R02088','KEGG','RNO:100363253',true).
concept_accession('40115: rn:R02088','KEGG','RNO:298881',true).
concept_accession('40115: rn:R02088','KEGG','EC:3.1.3.5',true).
concept_accession('40115: rn:R02088','KEGG','298881',true).
concept_accession('40115: rn:R02088','KEGG','58813',true).
concept_accession('40115: rn:R02088','KEGG','312373',true).
concept_accession('40114: rn:R02748','KEGG','290029',true).
concept_accession('40114: rn:R02748','KEGG','2.4.2.1',true).
concept_accession('40114: rn:R02748','KEGG','EC:2.4.2.1',true).
concept_accession('40114: rn:R02748','EC','2.4.2.1',true).
concept_accession('40114: rn:R02748','KEGG','RNO:290029',true).
concept_accession('40113: rn:R02297','KEGG','290029',true).
concept_accession('40113: rn:R02297','KEGG','2.4.2.1',true).
concept_accession('40113: rn:R02297','KEGG','EC:2.4.2.1',true).
concept_accession('40113: rn:R02297','EC','2.4.2.1',true).
concept_accession('40113: rn:R02297','KEGG','RNO:290029',true).
concept_accession('40112: rn:R04560','KEGG','EC:2.1.2.3',true).
concept_accession('40112: rn:R04560','KEGG','2.1.2.3',true).
concept_accession('40112: rn:R04560','KEGG','81643',true).
concept_accession('40112: rn:R04560','EC','2.1.2.3',true).
concept_accession('40112: rn:R04560','KEGG','RNO:81643',true).
concept_accession('5428: rn:R01555','KEGG','EC:2.4.1.8',true).
concept_accession('5428: rn:R01555','KEGG','RC:RC00049',true).
concept_accession('5428: rn:R01555','KEGG','RN:R01555',true).
concept_accession('5428: rn:R01555','KEGG','RP01590',true).
concept_accession('5428: rn:R01555','KEGG','R01555',true).
concept_accession('5428: rn:R01555','KEGG','2.4.1.8',true).
concept_accession('5428: rn:R01555','EC','2.4.1.8',false).
concept_accession('5428: rn:R01555','KEGG','RP:RP01590',true).
concept_accession('5428: rn:R01555','KEGG','RC00049',true).
concept_accession('40119: rn:R00181','KEGG','25095',true).
concept_accession('40119: rn:R00181','KEGG','3.5.4.6',true).
concept_accession('40119: rn:R00181','KEGG','25028',true).
concept_accession('40119: rn:R00181','KEGG','RNO:25095',true).
concept_accession('40119: rn:R00181','KEGG','RNO:362015',true).
concept_accession('40119: rn:R00181','KEGG','362015',true).
concept_accession('40119: rn:R00181','KEGG','EC:3.5.4.6',true).
concept_accession('40119: rn:R00181','EC','3.5.4.6',true).
concept_accession('40119: rn:R00181','KEGG','RNO:25028',true).
concept_accession('5429: rn:R02112','KEGG','R02112',true).
concept_accession('5429: rn:R02112','KEGG','EC:3.2.1.2',true).
concept_accession('5429: rn:R02112','KEGG','RN:R02112',true).
concept_accession('5429: rn:R02112','EC','3.2.1.2',false).
concept_accession('5429: rn:R02112','KEGG','3.2.1.2',true).
concept_accession('40118: rn:R00190','KEGG','2.4.2.7',true).
concept_accession('40118: rn:R00190','EC','2.4.2.7',true).
concept_accession('40118: rn:R00190','KEGG','EC:2.4.2.7',true).
concept_accession('40118: rn:R00190','KEGG','RNO:292072',true).
concept_accession('40118: rn:R00190','KEGG','292072',true).
concept_accession('40117: rn:R00185','KEGG','2.7.1.20',true).
concept_accession('40117: rn:R00185','KEGG','RNO:25368',true).
concept_accession('40117: rn:R00185','KEGG','25368',true).
concept_accession('40117: rn:R00185','EC','2.7.1.20',true).
concept_accession('40117: rn:R00185','KEGG','EC:2.7.1.20',true).
concept_accession('40116: rn:R02556','KEGG','24165',true).
concept_accession('40116: rn:R02556','KEGG','RNO:24165',true).
concept_accession('40116: rn:R02556','KEGG','3.5.4.4',true).
concept_accession('40116: rn:R02556','KEGG','EC:3.5.4.4',true).
concept_accession('40116: rn:R02556','EC','3.5.4.4',true).
concept_accession('40106: rn:R00089','KEGG','29241',true).
concept_accession('40106: rn:R00089','KEGG','RNO:25289',true).
concept_accession('40106: rn:R00089','KEGG','EC:4.6.1.1',true).
concept_accession('40106: rn:R00089','KEGG','64508',true).
concept_accession('40106: rn:R00089','KEGG','81636',true).
concept_accession('40106: rn:R00089','KEGG','RNO:81636',true).
concept_accession('40106: rn:R00089','KEGG','59320',true).
concept_accession('40106: rn:R00089','KEGG','84420',true).
concept_accession('40106: rn:R00089','KEGG','RNO:64532',true).
concept_accession('40106: rn:R00089','KEGG','305509',true).
concept_accession('40106: rn:R00089','KEGG','54223',true).
concept_accession('40106: rn:R00089','KEGG','RNO:59320',true).
concept_accession('40106: rn:R00089','KEGG','RNO:100362008',true).
concept_accession('40106: rn:R00089','KEGG','4.6.1.1',true).
concept_accession('40106: rn:R00089','EC','4.6.1.1',true).
concept_accession('40106: rn:R00089','KEGG','RNO:302950',true).
concept_accession('40106: rn:R00089','KEGG','RNO:64508',true).
concept_accession('40106: rn:R00089','KEGG','RNO:54223',true).
concept_accession('40106: rn:R00089','KEGG','64532',true).
concept_accession('40106: rn:R00089','KEGG','100362008',true).
concept_accession('40106: rn:R00089','KEGG','RNO:29241',true).
concept_accession('40106: rn:R00089','KEGG','25289',true).
concept_accession('40106: rn:R00089','KEGG','RNO:305509',true).
concept_accession('40106: rn:R00089','KEGG','302950',true).
concept_accession('40106: rn:R00089','KEGG','RNO:84420',true).
concept_accession('40107: rn:R00191','KEGG','140929',true).
concept_accession('40107: rn:R00191','KEGG','RNO:24627',true).
concept_accession('40107: rn:R00191','KEGG','308776',true).
concept_accession('40107: rn:R00191','KEGG','140928',true).
concept_accession('40107: rn:R00191','KEGG','RNO:24626',true).
concept_accession('40107: rn:R00191','KEGG','81742',true).
concept_accession('40107: rn:R00191','KEGG','3.1.4.17',true).
concept_accession('40107: rn:R00191','KEGG','81743',true).
concept_accession('40107: rn:R00191','KEGG','81744',true).
concept_accession('40107: rn:R00191','KEGG','RNO:308776',true).
concept_accession('40107: rn:R00191','KEGG','25638',true).
concept_accession('40107: rn:R00191','KEGG','RNO:29516',true).
concept_accession('40107: rn:R00191','KEGG','24627',true).
concept_accession('40107: rn:R00191','KEGG','24626',true).
concept_accession('40107: rn:R00191','KEGG','309962',true).
concept_accession('40107: rn:R00191','KEGG','RNO:50678',true).
concept_accession('40107: rn:R00191','KEGG','63885',true).
concept_accession('40107: rn:R00191','KEGG','290646',true).
concept_accession('40107: rn:R00191','KEGG','RNO:81744',true).
concept_accession('40107: rn:R00191','KEGG','RNO:81743',true).
concept_accession('40107: rn:R00191','KEGG','RNO:29691',true).
concept_accession('40107: rn:R00191','KEGG','EC:3.1.4.17',true).
concept_accession('40107: rn:R00191','KEGG','50678',true).
concept_accession('40107: rn:R00191','EC','3.1.4.17',true).
concept_accession('40107: rn:R00191','KEGG','RNO:140928',true).
concept_accession('40107: rn:R00191','KEGG','RNO:63885',true).
concept_accession('40107: rn:R00191','KEGG','29516',true).
concept_accession('40107: rn:R00191','KEGG','RNO:140929',true).
concept_accession('40107: rn:R00191','KEGG','RNO:25638',true).
concept_accession('40107: rn:R00191','KEGG','RNO:309962',true).
concept_accession('40107: rn:R00191','KEGG','RNO:81742',true).
concept_accession('40107: rn:R00191','KEGG','81529',true).
concept_accession('40107: rn:R00191','KEGG','RNO:290646',true).
concept_accession('40107: rn:R00191','KEGG','RNO:81529',true).
concept_accession('40107: rn:R00191','KEGG','29691',true).
concept_accession('40104: rn:R00435','KEGG','83581',true).
concept_accession('40104: rn:R00435','KEGG','292778',true).
concept_accession('40104: rn:R00435','KEGG','RNO:361102',true).
concept_accession('40104: rn:R00435','KEGG','83582',true).
concept_accession('40104: rn:R00435','KEGG','361365',true).
concept_accession('40104: rn:R00435','KEGG','RNO:83503',true).
concept_accession('40104: rn:R00435','KEGG','361640',true).
concept_accession('40104: rn:R00435','KEGG','364834',true).
concept_accession('40104: rn:R00435','KEGG','RNO:289561',true).
concept_accession('40104: rn:R00435','KEGG','RNO:313245',true).
concept_accession('40104: rn:R00435','KEGG','363633',true).
concept_accession('40104: rn:R00435','KEGG','RNO:361640',true).
concept_accession('40104: rn:R00435','KEGG','366277',true).
concept_accession('40104: rn:R00435','KEGG','RNO:685465',true).
concept_accession('40104: rn:R00435','KEGG','310685',true).
concept_accession('40104: rn:R00435','KEGG','100363176',true).
concept_accession('40104: rn:R00435','KEGG','RNO:363633',true).
concept_accession('40104: rn:R00435','KEGG','RNO:117017',true).
concept_accession('40104: rn:R00435','KEGG','RNO:306012',true).
concept_accession('40104: rn:R00435','KEGG','RNO:502374',true).
concept_accession('40104: rn:R00435','KEGG','RNO:292778',true).
concept_accession('40104: rn:R00435','KEGG','289561',true).
concept_accession('40104: rn:R00435','KEGG','EC:2.7.7.48',true).
concept_accession('40104: rn:R00435','KEGG','288588',true).
concept_accession('40104: rn:R00435','KEGG','RNO:690966',true).
concept_accession('40104: rn:R00435','KEGG','RNO:361365',true).
concept_accession('40104: rn:R00435','KEGG','RNO:300088',true).
concept_accession('40104: rn:R00435','KEGG','502374',true).
concept_accession('40104: rn:R00435','KEGG','311487',true).
concept_accession('40104: rn:R00435','KEGG','RNO:288588',true).
concept_accession('40104: rn:R00435','KEGG','685465',true).
concept_accession('40104: rn:R00435','KEGG','362858',true).
concept_accession('40104: rn:R00435','KEGG','498109',true).
concept_accession('40104: rn:R00435','KEGG','313245',true).
concept_accession('40104: rn:R00435','KEGG','RNO:681193',true).
concept_accession('40104: rn:R00435','KEGG','RNO:100363176',true).
concept_accession('40104: rn:R00435','KEGG','2.7.7.48',true).
concept_accession('40104: rn:R00435','KEGG','361102',true).
concept_accession('40104: rn:R00435','KEGG','681193',true).
concept_accession('40104: rn:R00435','KEGG','RNO:301246',true).
concept_accession('40104: rn:R00435','KEGG','RNO:291795',true).
concept_accession('40104: rn:R00435','KEGG','RNO:361784',true).
concept_accession('40104: rn:R00435','KEGG','RNO:362858',true).
concept_accession('40104: rn:R00435','KEGG','117017',true).
concept_accession('40104: rn:R00435','KEGG','300088',true).
concept_accession('40104: rn:R00435','KEGG','83503',true).
concept_accession('40104: rn:R00435','KEGG','RNO:690254',true).
concept_accession('40104: rn:R00435','KEGG','RNO:311487',true).
concept_accession('40104: rn:R00435','KEGG','291795',true).
concept_accession('40104: rn:R00435','KEGG','RNO:83582',true).
concept_accession('40104: rn:R00435','KEGG','RNO:366277',true).
concept_accession('40104: rn:R00435','KEGG','RNO:83581',true).
concept_accession('40104: rn:R00435','KEGG','361784',true).
concept_accession('40104: rn:R00435','KEGG','690254',true).
concept_accession('40104: rn:R00435','KEGG','RNO:498109',true).
concept_accession('40104: rn:R00435','EC','2.7.7.48',true).
concept_accession('40104: rn:R00435','KEGG','690966',true).
concept_accession('40104: rn:R00435','KEGG','306012',true).
concept_accession('40104: rn:R00435','KEGG','RNO:364834',true).
concept_accession('40104: rn:R00435','KEGG','301246',true).
concept_accession('40104: rn:R00435','KEGG','RNO:310685',true).
concept_accession('40105: rn:R07087','EC','1.14.14.1',true).
concept_accession('40105: rn:R07087','KEGG','246070',true).
concept_accession('40105: rn:R07087','KEGG','100364896',true).
concept_accession('40105: rn:R07087','KEGG','RNO:171352',true).
concept_accession('40105: rn:R07087','KEGG','252931',true).
concept_accession('40105: rn:R07087','KEGG','171521',true).
concept_accession('40105: rn:R07087','KEGG','RNO:25426',true).
concept_accession('40105: rn:R07087','KEGG','RNO:293989',true).
concept_accession('40105: rn:R07087','KEGG','293989',true).
concept_accession('40105: rn:R07087','KEGG','RNO:83790',true).
concept_accession('40105: rn:R07087','KEGG','EC:1.14.14.1',true).
concept_accession('40105: rn:R07087','KEGG','RNO:29277',true).
concept_accession('40105: rn:R07087','KEGG','687842',true).
concept_accession('40105: rn:R07087','KEGG','RNO:25642',true).
concept_accession('40105: rn:R07087','KEGG','171352',true).
concept_accession('40105: rn:R07087','KEGG','266682',true).
concept_accession('40105: rn:R07087','KEGG','24296',true).
concept_accession('40105: rn:R07087','KEGG','171518',true).
concept_accession('40105: rn:R07087','KEGG','RNO:100364896',true).
concept_accession('40105: rn:R07087','KEGG','29277',true).
concept_accession('40105: rn:R07087','KEGG','RNO:29298',true).
concept_accession('40105: rn:R07087','KEGG','RNO:266682',true).
concept_accession('40105: rn:R07087','KEGG','29298',true).
concept_accession('40105: rn:R07087','KEGG','RNO:246070',true).
concept_accession('40105: rn:R07087','KEGG','25426',true).
concept_accession('40105: rn:R07087','KEGG','RNO:687842',true).
concept_accession('40105: rn:R07087','KEGG','1.14.14.1',true).
concept_accession('40105: rn:R07087','KEGG','25642',true).
concept_accession('40105: rn:R07087','KEGG','RNO:171518',true).
concept_accession('40105: rn:R07087','KEGG','RNO:171521',true).
concept_accession('40105: rn:R07087','KEGG','25011',true).
concept_accession('40105: rn:R07087','KEGG','RNO:25011',true).
concept_accession('40105: rn:R07087','KEGG','RNO:24296',true).
concept_accession('40105: rn:R07087','KEGG','83790',true).
concept_accession('40105: rn:R07087','KEGG','RNO:252931',true).
concept_accession('40110: rn:R04591','KEGG','EC:6.3.2.6',true).
concept_accession('40110: rn:R04591','EC','6.3.2.6',true).
concept_accession('40110: rn:R04591','KEGG','RNO:140946',true).
concept_accession('40110: rn:R04591','KEGG','6.3.2.6',true).
concept_accession('40110: rn:R04591','KEGG','140946',true).
concept_accession('40111: rn:R04559','KEGG','RNO:315150',true).
concept_accession('40111: rn:R04559','KEGG','EC:4.3.2.2',true).
concept_accession('40111: rn:R04559','KEGG','315150',true).
concept_accession('40111: rn:R04559','KEGG','4.3.2.2',true).
concept_accession('40111: rn:R04559','EC','4.3.2.2',true).
concept_accession('40108: rn:R00437','KEGG','EC:2.7.7.8',true).
concept_accession('40108: rn:R00437','KEGG','360992',true).
concept_accession('40108: rn:R00437','KEGG','RNO:360992',true).
concept_accession('40108: rn:R00437','KEGG','2.7.7.8',true).
concept_accession('40108: rn:R00437','EC','2.7.7.8',true).
concept_accession('40109: rn:R04209','KEGG','4.1.1.21',true).
concept_accession('40109: rn:R04209','EC','4.1.1.21',true).
concept_accession('40109: rn:R04209','KEGG','RNO:140946',true).
concept_accession('40109: rn:R04209','KEGG','140946',true).
concept_accession('40109: rn:R04209','KEGG','EC:4.1.1.21',true).
concept_accession('40098: rn:R07075','KEGG','361523',true).
concept_accession('40098: rn:R07075','EC','1.14.14.1',true).
concept_accession('40098: rn:R07075','KEGG','25086',true).
concept_accession('40098: rn:R07075','KEGG','RNO:361523',true).
concept_accession('40098: rn:R07075','KEGG','29295',true).
concept_accession('40098: rn:R07075','KEGG','RNO:292728',true).
concept_accession('40098: rn:R07075','KEGG','RNO:24300',true).
concept_accession('40098: rn:R07075','KEGG','RNO:286953',true).
concept_accession('40098: rn:R07075','KEGG','EC:1.14.14.1',true).
concept_accession('40098: rn:R07075','KEGG','RNO:29295',true).
concept_accession('40098: rn:R07075','KEGG','RNO:25086',true).
concept_accession('40098: rn:R07075','KEGG','1.14.14.1',true).
concept_accession('40098: rn:R07075','KEGG','286953',true).
concept_accession('40098: rn:R07075','KEGG','292728',true).
concept_accession('40098: rn:R07075','KEGG','24300',true).
concept_accession('40099: rn:R00086','KEGG','64467',true).
concept_accession('40099: rn:R00086','KEGG','3.6.1.5',true).
concept_accession('40099: rn:R00086','KEGG','EC:3.6.1.5',true).
concept_accession('40099: rn:R00086','EC','3.6.1.5',true).
concept_accession('40099: rn:R00086','KEGG','RNO:64467',true).
concept_accession('40096: rn:R02142','KEGG','EC:2.4.2.8',true).
concept_accession('40096: rn:R02142','EC','2.4.2.8',true).
concept_accession('40096: rn:R02142','KEGG','24465',true).
concept_accession('40096: rn:R02142','KEGG','2.4.2.8',true).
concept_accession('40096: rn:R02142','KEGG','RNO:24465',true).
concept_accession('40097: rn:R00124','KEGG','171566',true).
concept_accession('40097: rn:R00124','KEGG','2.7.4.6',true).
concept_accession('40097: rn:R00124','KEGG','685679',true).
concept_accession('40097: rn:R00124','KEGG','83782',true).
concept_accession('40097: rn:R00124','KEGG','RNO:58964',true).
concept_accession('40097: rn:R00124','KEGG','RNO:83782',true).
concept_accession('40097: rn:R00124','KEGG','85269',true).
concept_accession('40097: rn:R00124','KEGG','RNO:685679',true).
concept_accession('40097: rn:R00124','KEGG','RNO:85269',true).
concept_accession('40097: rn:R00124','EC','2.7.4.6',true).
concept_accession('40097: rn:R00124','KEGG','EC:2.7.4.6',true).
concept_accession('40097: rn:R00124','KEGG','RNO:191575',true).
concept_accession('40097: rn:R00124','KEGG','191575',true).
concept_accession('40097: rn:R00124','KEGG','58964',true).
concept_accession('40097: rn:R00124','KEGG','RNO:171566',true).
concept_accession('40102: rn:R00375','KEGG','RNO:293144',true).
concept_accession('40102: rn:R00375','KEGG','RNO:289758',true).
concept_accession('40102: rn:R00375','KEGG','289758',true).
concept_accession('40102: rn:R00375','KEGG','299112',true).
concept_accession('40102: rn:R00375','KEGG','RNO:361698',true).
concept_accession('40102: rn:R00375','KEGG','246327',true).
concept_accession('40102: rn:R00375','KEGG','85241',true).
concept_accession('40102: rn:R00375','KEGG','85242',true).
concept_accession('40102: rn:R00375','KEGG','2.7.7.7',true).
concept_accession('40102: rn:R00375','KEGG','304573',true).
concept_accession('40102: rn:R00375','KEGG','59294',true).
concept_accession('40102: rn:R00375','KEGG','298098',true).
concept_accession('40102: rn:R00375','KEGG','RNO:85242',true).
concept_accession('40102: rn:R00375','KEGG','293144',true).
concept_accession('40102: rn:R00375','KEGG','362385',true).
concept_accession('40102: rn:R00375','KEGG','RNO:85241',true).
concept_accession('40102: rn:R00375','KEGG','EC:2.7.7.7',true).
concept_accession('40102: rn:R00375','KEGG','RNO:301323',true).
concept_accession('40102: rn:R00375','KEGG','RNO:298098',true).
concept_accession('40102: rn:R00375','KEGG','RNO:100362333',true).
concept_accession('40102: rn:R00375','KEGG','RNO:304573',true).
concept_accession('40102: rn:R00375','KEGG','361698',true).
concept_accession('40102: rn:R00375','KEGG','RNO:299112',true).
concept_accession('40102: rn:R00375','KEGG','RNO:246327',true).
concept_accession('40102: rn:R00375','KEGG','RNO:59294',true).
concept_accession('40102: rn:R00375','KEGG','100362333',true).
concept_accession('40102: rn:R00375','KEGG','RNO:362385',true).
concept_accession('40102: rn:R00375','EC','2.7.7.7',true).
concept_accession('40102: rn:R00375','KEGG','301323',true).
concept_accession('40103: rn:R07107','EC','1.14.14.1',true).
concept_accession('40103: rn:R07107','KEGG','361523',true).
concept_accession('40103: rn:R07107','KEGG','25086',true).
concept_accession('40103: rn:R07107','KEGG','RNO:54246',true).
concept_accession('40103: rn:R07107','KEGG','RNO:361523',true).
concept_accession('40103: rn:R07107','KEGG','29295',true).
concept_accession('40103: rn:R07107','KEGG','RNO:292728',true).
concept_accession('40103: rn:R07107','KEGG','RNO:24300',true).
concept_accession('40103: rn:R07107','KEGG','RNO:286953',true).
concept_accession('40103: rn:R07107','KEGG','EC:1.14.14.1',true).
concept_accession('40103: rn:R07107','KEGG','RNO:29295',true).
concept_accession('40103: rn:R07107','KEGG','RNO:25086',true).
concept_accession('40103: rn:R07107','KEGG','1.14.14.1',true).
concept_accession('40103: rn:R07107','KEGG','286953',true).
concept_accession('40103: rn:R07107','KEGG','292728',true).
concept_accession('40103: rn:R07107','KEGG','54246',true).
concept_accession('40103: rn:R07107','KEGG','24300',true).
concept_accession('40100: rn:R00086','KEGG','316077',true).
concept_accession('40100: rn:R00086','KEGG','64519',true).
concept_accession('40100: rn:R00086','KEGG','RNO:613267',true).
concept_accession('40100: rn:R00086','KEGG','3.6.1.5',true).
concept_accession('40100: rn:R00086','KEGG','RNO:64519',true).
concept_accession('40100: rn:R00086','KEGG','EC:3.6.1.5',true).
concept_accession('40100: rn:R00086','EC','3.6.1.5',true).
concept_accession('40100: rn:R00086','KEGG','613267',true).
concept_accession('40100: rn:R00086','KEGG','RNO:316077',true).
concept_accession('40101: rn:R07085','EC','1.14.14.1',true).
concept_accession('40101: rn:R07085','KEGG','246070',true).
concept_accession('40101: rn:R07085','KEGG','100364896',true).
concept_accession('40101: rn:R07085','KEGG','RNO:171352',true).
concept_accession('40101: rn:R07085','KEGG','252931',true).
concept_accession('40101: rn:R07085','KEGG','171521',true).
concept_accession('40101: rn:R07085','KEGG','RNO:25426',true).
concept_accession('40101: rn:R07085','KEGG','RNO:293989',true).
concept_accession('40101: rn:R07085','KEGG','293989',true).
concept_accession('40101: rn:R07085','KEGG','RNO:83790',true).
concept_accession('40101: rn:R07085','KEGG','EC:1.14.14.1',true).
concept_accession('40101: rn:R07085','KEGG','RNO:29277',true).
concept_accession('40101: rn:R07085','KEGG','687842',true).
concept_accession('40101: rn:R07085','KEGG','RNO:25642',true).
concept_accession('40101: rn:R07085','KEGG','171352',true).
concept_accession('40101: rn:R07085','KEGG','266682',true).
concept_accession('40101: rn:R07085','KEGG','24296',true).
concept_accession('40101: rn:R07085','KEGG','171518',true).
concept_accession('40101: rn:R07085','KEGG','RNO:100364896',true).
concept_accession('40101: rn:R07085','KEGG','29277',true).
concept_accession('40101: rn:R07085','KEGG','RNO:29298',true).
concept_accession('40101: rn:R07085','KEGG','RNO:266682',true).
concept_accession('40101: rn:R07085','KEGG','29298',true).
concept_accession('40101: rn:R07085','KEGG','RNO:246070',true).
concept_accession('40101: rn:R07085','KEGG','25426',true).
concept_accession('40101: rn:R07085','KEGG','RNO:687842',true).
concept_accession('40101: rn:R07085','KEGG','1.14.14.1',true).
concept_accession('40101: rn:R07085','KEGG','25642',true).
concept_accession('40101: rn:R07085','KEGG','RNO:171518',true).
concept_accession('40101: rn:R07085','KEGG','RNO:171521',true).
concept_accession('40101: rn:R07085','KEGG','25011',true).
concept_accession('40101: rn:R07085','KEGG','RNO:25011',true).
concept_accession('40101: rn:R07085','KEGG','RNO:24296',true).
concept_accession('40101: rn:R07085','KEGG','83790',true).
concept_accession('40101: rn:R07085','KEGG','RNO:252931',true).
concept_accession('40089: rn:R02719','KEGG','RNO:313574',true).
concept_accession('40089: rn:R02719','KEGG','100363253',true).
concept_accession('40089: rn:R02719','KEGG','RNO:688261',true).
concept_accession('40089: rn:R02719','KEGG','RNO:287368',true).
concept_accession('40089: rn:R02719','KEGG','688261',true).
concept_accession('40089: rn:R02719','EC','3.1.3.5',true).
concept_accession('40089: rn:R02719','KEGG','313574',true).
concept_accession('40089: rn:R02719','KEGG','RNO:58813',true).
concept_accession('40089: rn:R02719','KEGG','287368',true).
concept_accession('40089: rn:R02719','KEGG','RNO:312373',true).
concept_accession('40089: rn:R02719','KEGG','3.1.3.5',true).
concept_accession('40089: rn:R02719','KEGG','RNO:100363253',true).
concept_accession('40089: rn:R02719','KEGG','RNO:298881',true).
concept_accession('40089: rn:R02719','KEGG','EC:3.1.3.5',true).
concept_accession('40089: rn:R02719','KEGG','298881',true).
concept_accession('40089: rn:R02719','KEGG','58813',true).
concept_accession('40089: rn:R02719','KEGG','312373',true).
concept_accession('40088: rn:R02422','KEGG','RNO:246758',true).
concept_accession('40088: rn:R02422','KEGG','3.5.3.4',true).
concept_accession('40088: rn:R02422','EC','3.5.3.4',true).
concept_accession('40088: rn:R02422','KEGG','246758',true).
concept_accession('40088: rn:R02422','KEGG','EC:3.5.3.4',true).
concept_accession('5400: rn:R00960','KEGG','RC:RC00078',true).
concept_accession('5400: rn:R00960','KEGG','RC00017',true).
concept_accession('5400: rn:R00960','KEGG','RC:RC00017',true).
concept_accession('5400: rn:R00960','KEGG','R00960',true).
concept_accession('5400: rn:R00960','KEGG','RN:R00960',true).
concept_accession('5400: rn:R00960','KEGG','RP:RP01198',true).
concept_accession('5400: rn:R00960','KEGG','2.7.1.41',true).
concept_accession('5400: rn:R00960','KEGG','RC00078',true).
concept_accession('5400: rn:R00960','EC','2.7.1.41',false).
concept_accession('5400: rn:R00960','KEGG','RP:RP00303',true).
concept_accession('5400: rn:R00960','KEGG','EC:2.7.1.41',true).
concept_accession('5400: rn:R00960','KEGG','RP01198',true).
concept_accession('5400: rn:R00960','KEGG','RP00303',true).
concept_accession('40091: rn:R00332','KEGG','EC:2.7.4.8',true).
concept_accession('40091: rn:R00332','EC','2.7.4.8',true).
concept_accession('40091: rn:R00332','KEGG','2.7.4.8',true).
concept_accession('40091: rn:R00332','KEGG','303179',true).
concept_accession('40091: rn:R00332','KEGG','RNO:303179',true).
concept_accession('40090: rn:R01229','KEGG','EC:2.4.2.8',true).
concept_accession('40090: rn:R01229','EC','2.4.2.8',true).
concept_accession('40090: rn:R01229','KEGG','24465',true).
concept_accession('40090: rn:R01229','KEGG','2.4.2.8',true).
concept_accession('40090: rn:R01229','KEGG','RNO:24465',true).
concept_accession('40093: rn:R01227','KEGG','RNO:313574',true).
concept_accession('40093: rn:R01227','KEGG','100363253',true).
concept_accession('40093: rn:R01227','KEGG','RNO:688261',true).
concept_accession('40093: rn:R01227','KEGG','RNO:287368',true).
concept_accession('40093: rn:R01227','KEGG','688261',true).
concept_accession('40093: rn:R01227','EC','3.1.3.5',true).
concept_accession('40093: rn:R01227','KEGG','313574',true).
concept_accession('40093: rn:R01227','KEGG','RNO:58813',true).
concept_accession('40093: rn:R01227','KEGG','287368',true).
concept_accession('40093: rn:R01227','KEGG','RNO:312373',true).
concept_accession('40093: rn:R01227','KEGG','3.1.3.5',true).
concept_accession('40093: rn:R01227','KEGG','RNO:100363253',true).
concept_accession('40093: rn:R01227','KEGG','RNO:298881',true).
concept_accession('40093: rn:R01227','KEGG','EC:3.1.3.5',true).
concept_accession('40093: rn:R01227','KEGG','298881',true).
concept_accession('40093: rn:R01227','KEGG','58813',true).
concept_accession('40093: rn:R01227','KEGG','312373',true).
concept_accession('40092: rn:R07016','EC','1.14.14.1',true).
concept_accession('40092: rn:R07016','KEGG','361523',true).
concept_accession('40092: rn:R07016','KEGG','25086',true).
concept_accession('40092: rn:R07016','KEGG','RNO:54246',true).
concept_accession('40092: rn:R07016','KEGG','RNO:361523',true).
concept_accession('40092: rn:R07016','KEGG','308445',true).
concept_accession('40092: rn:R07016','KEGG','29295',true).
concept_accession('40092: rn:R07016','KEGG','RNO:292728',true).
concept_accession('40092: rn:R07016','KEGG','RNO:24300',true).
concept_accession('40092: rn:R07016','KEGG','RNO:286953',true).
concept_accession('40092: rn:R07016','KEGG','EC:1.14.14.1',true).
concept_accession('40092: rn:R07016','KEGG','RNO:308445',true).
concept_accession('40092: rn:R07016','KEGG','RNO:29295',true).
concept_accession('40092: rn:R07016','KEGG','RNO:25086',true).
concept_accession('40092: rn:R07016','KEGG','1.14.14.1',true).
concept_accession('40092: rn:R07016','KEGG','286953',true).
concept_accession('40092: rn:R07016','KEGG','292728',true).
concept_accession('40092: rn:R07016','KEGG','24297',true).
concept_accession('40092: rn:R07016','KEGG','24296',true).
concept_accession('40092: rn:R07016','KEGG','54246',true).
concept_accession('40092: rn:R07016','KEGG','24300',true).
concept_accession('40092: rn:R07016','KEGG','RNO:24296',true).
concept_accession('40092: rn:R07016','KEGG','RNO:24297',true).
concept_accession('40095: rn:R01863','KEGG','290029',true).
concept_accession('40095: rn:R01863','KEGG','2.4.2.1',true).
concept_accession('40095: rn:R01863','KEGG','EC:2.4.2.1',true).
concept_accession('40095: rn:R01863','EC','2.4.2.1',true).
concept_accession('40095: rn:R01863','KEGG','RNO:290029',true).
concept_accession('40094: rn:R07020','EC','1.14.14.1',true).
concept_accession('40094: rn:R07020','KEGG','361523',true).
concept_accession('40094: rn:R07020','KEGG','25086',true).
concept_accession('40094: rn:R07020','KEGG','RNO:54246',true).
concept_accession('40094: rn:R07020','KEGG','RNO:361523',true).
concept_accession('40094: rn:R07020','KEGG','308445',true).
concept_accession('40094: rn:R07020','KEGG','29295',true).
concept_accession('40094: rn:R07020','KEGG','RNO:292728',true).
concept_accession('40094: rn:R07020','KEGG','RNO:24300',true).
concept_accession('40094: rn:R07020','KEGG','RNO:286953',true).
concept_accession('40094: rn:R07020','KEGG','EC:1.14.14.1',true).
concept_accession('40094: rn:R07020','KEGG','RNO:308445',true).
concept_accession('40094: rn:R07020','KEGG','RNO:29295',true).
concept_accession('40094: rn:R07020','KEGG','RNO:25086',true).
concept_accession('40094: rn:R07020','KEGG','1.14.14.1',true).
concept_accession('40094: rn:R07020','KEGG','286953',true).
concept_accession('40094: rn:R07020','KEGG','292728',true).
concept_accession('40094: rn:R07020','KEGG','24297',true).
concept_accession('40094: rn:R07020','KEGG','24296',true).
concept_accession('40094: rn:R07020','KEGG','54246',true).
concept_accession('40094: rn:R07020','KEGG','24300',true).
concept_accession('40094: rn:R07020','KEGG','RNO:24296',true).
concept_accession('40094: rn:R07020','KEGG','RNO:24297',true).
concept_accession('40081: rn:R01134','KEGG','RNO:117533',true).
concept_accession('40081: rn:R01134','KEGG','117533',true).
concept_accession('40081: rn:R01134','KEGG','EC:1.7.1.7',true).
concept_accession('40081: rn:R01134','KEGG','1.7.1.7',true).
concept_accession('40081: rn:R01134','EC','1.7.1.7',true).
concept_accession('5395: rn:R02889','KEGG','EC:2.4.1.12',true).
concept_accession('5395: rn:R02889','KEGG','RN:R02889',true).
concept_accession('5395: rn:R02889','KEGG','R02889',true).
concept_accession('5395: rn:R02889','EC','2.4.1.12',false).
concept_accession('5395: rn:R02889','KEGG','2.4.1.12',true).
concept_accession('40080: rn:R00961','KEGG','316077',true).
concept_accession('40080: rn:R00961','KEGG','64519',true).
concept_accession('40080: rn:R00961','KEGG','RNO:613267',true).
concept_accession('40080: rn:R00961','KEGG','3.6.1.5',true).
concept_accession('40080: rn:R00961','KEGG','RNO:64519',true).
concept_accession('40080: rn:R00961','KEGG','EC:3.6.1.5',true).
concept_accession('40080: rn:R00961','EC','3.6.1.5',true).
concept_accession('40080: rn:R00961','KEGG','613267',true).
concept_accession('40080: rn:R00961','KEGG','RNO:316077',true).
concept_accession('5392: rn:R00806','KEGG','R00806',true).
concept_accession('5392: rn:R00806','KEGG','EC:2.4.1.13',true).
concept_accession('5392: rn:R00806','KEGG','RN:R00806',true).
concept_accession('5392: rn:R00806','KEGG','2.4.1.13',true).
concept_accession('5392: rn:R00806','EC','2.4.1.13',false).
concept_accession('40083: rn:R01560','KEGG','24165',true).
concept_accession('40083: rn:R01560','KEGG','RNO:24165',true).
concept_accession('40083: rn:R01560','KEGG','3.5.4.4',true).
concept_accession('40083: rn:R01560','KEGG','EC:3.5.4.4',true).
concept_accession('40083: rn:R01560','EC','3.5.4.4',true).
concept_accession('5393: rn:R03526','EC','2.4.1.35',false).
concept_accession('5393: rn:R03526','KEGG','2.4.1.35',true).
concept_accession('5393: rn:R03526','KEGG','RN:R03526',true).
concept_accession('5393: rn:R03526','KEGG','EC:2.4.1.35',true).
concept_accession('5393: rn:R03526','KEGG','R03526',true).
concept_accession('40082: rn:R00719','KEGG','316077',true).
concept_accession('40082: rn:R00719','KEGG','64519',true).
concept_accession('40082: rn:R00719','KEGG','RNO:613267',true).
concept_accession('40082: rn:R00719','KEGG','3.6.1.5',true).
concept_accession('40082: rn:R00719','KEGG','RNO:64519',true).
concept_accession('40082: rn:R00719','KEGG','EC:3.6.1.5',true).
concept_accession('40082: rn:R00719','EC','3.6.1.5',true).
concept_accession('40082: rn:R00719','KEGG','613267',true).
concept_accession('40082: rn:R00719','KEGG','RNO:316077',true).
concept_accession('9798: rn:R02134','KEGG','2.7.1.89',true).
concept_accession('9798: rn:R02134','KEGG','RC00017',true).
concept_accession('9798: rn:R02134','KEGG','RP00640',true).
concept_accession('9798: rn:R02134','EC','2.7.1.89',false).
concept_accession('9798: rn:R02134','KEGG','EC:2.7.1.89',true).
concept_accession('9798: rn:R02134','KEGG','RC:RC00017',true).
concept_accession('9798: rn:R02134','KEGG','R02134',true).
concept_accession('9798: rn:R02134','KEGG','RP:RP00640',true).
concept_accession('9798: rn:R02134','KEGG','RN:R02134',true).
concept_accession('40085: rn:R02106','KEGG','RNO:114768',true).
concept_accession('40085: rn:R02106','KEGG','114768',true).
concept_accession('40085: rn:R02106','KEGG','1.7.3.3',true).
concept_accession('40085: rn:R02106','EC','1.7.3.3',true).
concept_accession('40085: rn:R02106','KEGG','EC:1.7.3.3',true).
concept_accession('9799: rn:R02135','EC','3.1.3.-',false).
concept_accession('9799: rn:R02135','KEGG','RC00017',true).
concept_accession('9799: rn:R02135','KEGG','RP00640',true).
concept_accession('9799: rn:R02135','KEGG','EC:3.1.3.-',true).
concept_accession('9799: rn:R02135','KEGG','3.1.3.-',true).
concept_accession('9799: rn:R02135','KEGG','RC:RC00017',true).
concept_accession('9799: rn:R02135','KEGG','R02135',true).
concept_accession('9799: rn:R02135','KEGG','RP:RP00640',true).
concept_accession('9799: rn:R02135','KEGG','RN:R02135',true).
concept_accession('40084: rn:R01126','KEGG','RNO:313574',true).
concept_accession('40084: rn:R01126','KEGG','100363253',true).
concept_accession('40084: rn:R01126','KEGG','RNO:688261',true).
concept_accession('40084: rn:R01126','KEGG','RNO:287368',true).
concept_accession('40084: rn:R01126','KEGG','688261',true).
concept_accession('40084: rn:R01126','EC','3.1.3.5',true).
concept_accession('40084: rn:R01126','KEGG','313574',true).
concept_accession('40084: rn:R01126','KEGG','RNO:58813',true).
concept_accession('40084: rn:R01126','KEGG','287368',true).
concept_accession('40084: rn:R01126','KEGG','RNO:312373',true).
concept_accession('40084: rn:R01126','KEGG','3.1.3.5',true).
concept_accession('40084: rn:R01126','KEGG','RNO:100363253',true).
concept_accession('40084: rn:R01126','KEGG','RNO:298881',true).
concept_accession('40084: rn:R01126','KEGG','EC:3.1.3.5',true).
concept_accession('40084: rn:R01126','KEGG','298881',true).
concept_accession('40084: rn:R01126','KEGG','58813',true).
concept_accession('40084: rn:R01126','KEGG','312373',true).
concept_accession('40087: rn:R01676','KEGG','RNO:83585',true).
concept_accession('40087: rn:R01676','KEGG','EC:3.5.4.3',true).
concept_accession('40087: rn:R01676','KEGG','3.5.4.3',true).
concept_accession('40087: rn:R01676','KEGG','83585',true).
concept_accession('40087: rn:R01676','EC','3.5.4.3',true).
concept_accession('40086: rn:R01969','KEGG','290029',true).
concept_accession('40086: rn:R01969','KEGG','2.4.2.1',true).
concept_accession('40086: rn:R01969','KEGG','EC:2.4.2.1',true).
concept_accession('40086: rn:R01969','EC','2.4.2.1',true).
concept_accession('40086: rn:R01969','KEGG','RNO:290029',true).
concept_accession('40072: rn:R01132','KEGG','EC:2.4.2.8',true).
concept_accession('40072: rn:R01132','EC','2.4.2.8',true).
concept_accession('40072: rn:R01132','KEGG','24465',true).
concept_accession('40072: rn:R01132','KEGG','2.4.2.8',true).
concept_accession('40072: rn:R01132','KEGG','RNO:24465',true).
concept_accession('5386: rn:R02886','KEGG','RP:RP02572',true).
concept_accession('5386: rn:R02886','KEGG','RC00799',true).
concept_accession('5386: rn:R02886','KEGG','3.2.1.91',true).
concept_accession('5386: rn:R02886','EC','3.2.1.91',false).
concept_accession('5386: rn:R02886','KEGG','EC:3.2.1.91',true).
concept_accession('5386: rn:R02886','KEGG','RN:R02886',true).
concept_accession('5386: rn:R02886','KEGG','RC:RC00799',true).
concept_accession('5386: rn:R02886','KEGG','RP02572',true).
concept_accession('5386: rn:R02886','KEGG','R02886',true).
concept_accession('40073: rn:R00328','KEGG','RNO:85260',true).
concept_accession('40073: rn:R00328','KEGG','3.6.1.6',true).
concept_accession('40073: rn:R00328','KEGG','RNO:314312',true).
concept_accession('40073: rn:R00328','KEGG','85260',true).
concept_accession('40073: rn:R00328','KEGG','314312',true).
concept_accession('40073: rn:R00328','KEGG','RNO:246272',true).
concept_accession('40073: rn:R00328','KEGG','361063',true).
concept_accession('40073: rn:R00328','KEGG','RNO:361063',true).
concept_accession('40073: rn:R00328','EC','3.6.1.6',true).
concept_accession('40073: rn:R00328','KEGG','246272',true).
concept_accession('40073: rn:R00328','KEGG','EC:3.6.1.6',true).
concept_accession('40074: rn:R01769','KEGG','497811',true).
concept_accession('40074: rn:R01769','KEGG','1.17.3.2',true).
concept_accession('40074: rn:R01769','KEGG','EC:1.17.3.2',true).
concept_accession('40074: rn:R01769','EC','1.17.3.2',true).
concept_accession('40074: rn:R01769','KEGG','RNO:497811',true).
concept_accession('40075: rn:R01561','KEGG','290029',true).
concept_accession('40075: rn:R01561','KEGG','2.4.2.1',true).
concept_accession('40075: rn:R01561','KEGG','EC:2.4.2.1',true).
concept_accession('40075: rn:R01561','EC','2.4.2.1',true).
concept_accession('40075: rn:R01561','KEGG','RNO:290029',true).
concept_accession('40076: rn:R01130','KEGG','RNO:301005',true).
concept_accession('40076: rn:R01130','KEGG','RNO:362329',true).
concept_accession('40076: rn:R01130','KEGG','1.1.1.205',true).
concept_accession('40076: rn:R01130','KEGG','362329',true).
concept_accession('40076: rn:R01130','KEGG','EC:1.1.1.205',true).
concept_accession('40076: rn:R01130','KEGG','301005',true).
concept_accession('40076: rn:R01130','EC','1.1.1.205',true).
concept_accession('40077: rn:R00328','KEGG','3.6.1.6',true).
concept_accession('40077: rn:R00328','KEGG','316077',true).
concept_accession('40077: rn:R00328','KEGG','64519',true).
concept_accession('40077: rn:R00328','KEGG','RNO:613267',true).
concept_accession('40077: rn:R00328','KEGG','RNO:64519',true).
concept_accession('40077: rn:R00328','KEGG','613267',true).
concept_accession('40077: rn:R00328','KEGG','RNO:316077',true).
concept_accession('40077: rn:R00328','EC','3.6.1.6',true).
concept_accession('40077: rn:R00328','KEGG','EC:3.6.1.6',true).
concept_accession('40078: rn:R01230 rn:R01231','KEGG','EC:6.3.5.2',true).
concept_accession('40078: rn:R01230 rn:R01231','EC','6.3.5.2',true).
concept_accession('40078: rn:R01230 rn:R01231','KEGG','RNO:295088',true).
concept_accession('40078: rn:R01230 rn:R01231','KEGG','295088',true).
concept_accession('40078: rn:R01230 rn:R01231','KEGG','6.3.5.2',true).
concept_accession('40079: rn:R00722','KEGG','171566',true).
concept_accession('40079: rn:R00722','KEGG','2.7.4.6',true).
concept_accession('40079: rn:R00722','KEGG','685679',true).
concept_accession('40079: rn:R00722','KEGG','83782',true).
concept_accession('40079: rn:R00722','KEGG','RNO:58964',true).
concept_accession('40079: rn:R00722','KEGG','RNO:83782',true).
concept_accession('40079: rn:R00722','KEGG','85269',true).
concept_accession('40079: rn:R00722','KEGG','RNO:685679',true).
concept_accession('40079: rn:R00722','KEGG','RNO:85269',true).
concept_accession('40079: rn:R00722','EC','2.7.4.6',true).
concept_accession('40079: rn:R00722','KEGG','EC:2.7.4.6',true).
concept_accession('40079: rn:R00722','KEGG','RNO:191575',true).
concept_accession('40079: rn:R00722','KEGG','191575',true).
concept_accession('40079: rn:R00722','KEGG','58964',true).
concept_accession('40079: rn:R00722','KEGG','RNO:171566',true).
concept_accession('40064: rn:R07981','KEGG','RNO:114768',true).
concept_accession('40064: rn:R07981','KEGG','114768',true).
concept_accession('40064: rn:R07981','KEGG','1.7.3.3',true).
concept_accession('40064: rn:R07981','EC','1.7.3.3',true).
concept_accession('40064: rn:R07981','KEGG','EC:1.7.3.3',true).
concept_accession('5378: rn:R03921','KEGG','RC:RC00077',true).
concept_accession('5378: rn:R03921','KEGG','RP:RP12727',true).
concept_accession('5378: rn:R03921','KEGG','RP:RP12726',true).
concept_accession('5378: rn:R03921','KEGG','RC00028',true).
concept_accession('5378: rn:R03921','KEGG','RP12726',true).
concept_accession('5378: rn:R03921','KEGG','3.2.1.26',true).
concept_accession('5378: rn:R03921','KEGG','RP12727',true).
concept_accession('5378: rn:R03921','KEGG','RC:RC00028',true).
concept_accession('5378: rn:R03921','KEGG','RN:R03921',true).
concept_accession('5378: rn:R03921','EC','3.2.1.26',false).
concept_accession('5378: rn:R03921','KEGG','RC00077',true).
concept_accession('5378: rn:R03921','KEGG','EC:3.2.1.26',true).
concept_accession('5378: rn:R03921','KEGG','R03921',true).
concept_accession('40065: rn:R08339','EC','1.14.14.1',true).
concept_accession('40065: rn:R08339','KEGG','1.14.14.1',true).
concept_accession('40065: rn:R08339','KEGG','25642',true).
concept_accession('40065: rn:R08339','KEGG','RNO:25642',true).
concept_accession('40065: rn:R08339','KEGG','RNO:171352',true).
concept_accession('40065: rn:R08339','KEGG','171352',true).
concept_accession('40065: rn:R08339','KEGG','266682',true).
concept_accession('40065: rn:R08339','KEGG','252931',true).
concept_accession('40065: rn:R08339','KEGG','RNO:266682',true).
concept_accession('40065: rn:R08339','KEGG','RNO:252931',true).
concept_accession('40065: rn:R08339','KEGG','EC:1.14.14.1',true).
concept_accession('40066: rn:R07940','KEGG','RNO:116631',true).
concept_accession('40066: rn:R07940','KEGG','290681',true).
concept_accession('40066: rn:R07940','KEGG','116631',true).
concept_accession('40066: rn:R07940','KEGG','RNO:290681',true).
concept_accession('40066: rn:R07940','KEGG','2.3.1.5',true).
concept_accession('40066: rn:R07940','KEGG','116632',true).
concept_accession('40066: rn:R07940','KEGG','RNO:116632',true).
concept_accession('40066: rn:R07940','KEGG','EC:2.3.1.5',true).
concept_accession('40066: rn:R07940','EC','2.3.1.5',true).
concept_accession('40067: rn:R07945','EC','1.14.14.1',true).
concept_accession('40067: rn:R07945','KEGG','24894',true).
concept_accession('40067: rn:R07945','KEGG','1.14.14.1',true).
concept_accession('40067: rn:R07945','KEGG','24299',true).
concept_accession('40067: rn:R07945','KEGG','24297',true).
concept_accession('40067: rn:R07945','KEGG','24895',true).
concept_accession('40067: rn:R07945','KEGG','RNO:24299',true).
concept_accession('40067: rn:R07945','KEGG','RNO:24297',true).
concept_accession('40067: rn:R07945','KEGG','RNO:24894',true).
concept_accession('40067: rn:R07945','KEGG','RNO:24895',true).
concept_accession('40067: rn:R07945','KEGG','EC:1.14.14.1',true).
concept_accession('40068: rn:R03697','EC','1.14.14.1',true).
concept_accession('40068: rn:R03697','KEGG','RNO:25053',true).
concept_accession('40068: rn:R03697','KEGG','171522',true).
concept_accession('40068: rn:R03697','KEGG','RNO:24303',true).
concept_accession('40068: rn:R03697','KEGG','RNO:286963',true).
concept_accession('40068: rn:R03697','KEGG','25053',true).
concept_accession('40068: rn:R03697','KEGG','EC:1.14.14.1',true).
concept_accession('40068: rn:R03697','KEGG','286963',true).
concept_accession('40068: rn:R03697','KEGG','1.14.14.1',true).
concept_accession('40068: rn:R03697','KEGG','RNO:171522',true).
concept_accession('40068: rn:R03697','KEGG','RNO:266684',true).
concept_accession('40068: rn:R03697','KEGG','266684',true).
concept_accession('40068: rn:R03697','KEGG','24303',true).
concept_accession('40069: rn:R08261','KEGG','396551',true).
concept_accession('40069: rn:R08261','KEGG','2.4.1.17',true).
concept_accession('40069: rn:R08261','KEGG','154516',true).
concept_accession('40069: rn:R08261','KEGG','396552',true).
concept_accession('40069: rn:R08261','KEGG','RNO:305264',true).
concept_accession('40069: rn:R08261','KEGG','289533',true).
concept_accession('40069: rn:R08261','KEGG','RNO:396527',true).
concept_accession('40069: rn:R08261','KEGG','574523',true).
concept_accession('40069: rn:R08261','KEGG','396527',true).
concept_accession('40069: rn:R08261','KEGG','EC:2.4.1.17',true).
concept_accession('40069: rn:R08261','KEGG','113992',true).
concept_accession('40069: rn:R08261','KEGG','RNO:574523',true).
concept_accession('40069: rn:R08261','KEGG','RNO:266685',true).
concept_accession('40069: rn:R08261','KEGG','RNO:24861',true).
concept_accession('40069: rn:R08261','KEGG','266685',true).
concept_accession('40069: rn:R08261','KEGG','RNO:24862',true).
concept_accession('40069: rn:R08261','KEGG','29623',true).
concept_accession('40069: rn:R08261','KEGG','RNO:289533',true).
concept_accession('40069: rn:R08261','KEGG','305264',true).
concept_accession('40069: rn:R08261','KEGG','RNO:83808',true).
concept_accession('40069: rn:R08261','KEGG','RNO:301595',true).
concept_accession('40069: rn:R08261','KEGG','RNO:29623',true).
concept_accession('40069: rn:R08261','KEGG','RNO:154516',true).
concept_accession('40069: rn:R08261','KEGG','301595',true).
concept_accession('40069: rn:R08261','KEGG','RNO:396552',true).
concept_accession('40069: rn:R08261','KEGG','RNO:396551',true).
concept_accession('40069: rn:R08261','KEGG','RNO:286954',true).
concept_accession('40069: rn:R08261','KEGG','RNO:113992',true).
concept_accession('40069: rn:R08261','KEGG','RNO:63867',true).
concept_accession('40069: rn:R08261','KEGG','286954',true).
concept_accession('40069: rn:R08261','KEGG','83808',true).
concept_accession('40069: rn:R08261','KEGG','24861',true).
concept_accession('40069: rn:R08261','KEGG','63867',true).
concept_accession('40069: rn:R08261','EC','2.4.1.17',true).
concept_accession('40069: rn:R08261','KEGG','24862',true).
concept_accession('40070: rn:R08262','KEGG','396551',true).
concept_accession('40070: rn:R08262','KEGG','2.4.1.17',true).
concept_accession('40070: rn:R08262','KEGG','154516',true).
concept_accession('40070: rn:R08262','KEGG','396552',true).
concept_accession('40070: rn:R08262','KEGG','RNO:305264',true).
concept_accession('40070: rn:R08262','KEGG','289533',true).
concept_accession('40070: rn:R08262','KEGG','RNO:396527',true).
concept_accession('40070: rn:R08262','KEGG','574523',true).
concept_accession('40070: rn:R08262','KEGG','396527',true).
concept_accession('40070: rn:R08262','KEGG','EC:2.4.1.17',true).
concept_accession('40070: rn:R08262','KEGG','113992',true).
concept_accession('40070: rn:R08262','KEGG','RNO:574523',true).
concept_accession('40070: rn:R08262','KEGG','RNO:266685',true).
concept_accession('40070: rn:R08262','KEGG','RNO:24861',true).
concept_accession('40070: rn:R08262','KEGG','266685',true).
concept_accession('40070: rn:R08262','KEGG','RNO:24862',true).
concept_accession('40070: rn:R08262','KEGG','29623',true).
concept_accession('40070: rn:R08262','KEGG','RNO:289533',true).
concept_accession('40070: rn:R08262','KEGG','305264',true).
concept_accession('40070: rn:R08262','KEGG','RNO:83808',true).
concept_accession('40070: rn:R08262','KEGG','RNO:301595',true).
concept_accession('40070: rn:R08262','KEGG','RNO:29623',true).
concept_accession('40070: rn:R08262','KEGG','RNO:154516',true).
concept_accession('40070: rn:R08262','KEGG','301595',true).
concept_accession('40070: rn:R08262','KEGG','RNO:396552',true).
concept_accession('40070: rn:R08262','KEGG','RNO:396551',true).
concept_accession('40070: rn:R08262','KEGG','RNO:286954',true).
concept_accession('40070: rn:R08262','KEGG','RNO:113992',true).
concept_accession('40070: rn:R08262','KEGG','RNO:63867',true).
concept_accession('40070: rn:R08262','KEGG','286954',true).
concept_accession('40070: rn:R08262','KEGG','83808',true).
concept_accession('40070: rn:R08262','KEGG','24861',true).
concept_accession('40070: rn:R08262','KEGG','63867',true).
concept_accession('40070: rn:R08262','EC','2.4.1.17',true).
concept_accession('40070: rn:R08262','KEGG','24862',true).
concept_accession('40071: rn:R08281','KEGG','24172',true).
concept_accession('40071: rn:R08281','KEGG','RNO:29646',true).
concept_accession('40071: rn:R08281','KEGG','RNO:310903',true).
concept_accession('40071: rn:R08281','KEGG','100145871',true).
concept_accession('40071: rn:R08281','KEGG','EC:1.1.1.1',true).
concept_accession('40071: rn:R08281','KEGG','310903',true).
concept_accession('40071: rn:R08281','KEGG','1.1.1.1',true).
concept_accession('40071: rn:R08281','KEGG','RNO:171178',true).
concept_accession('40071: rn:R08281','EC','1.1.1.1',true).
concept_accession('40071: rn:R08281','KEGG','171178',true).
concept_accession('40071: rn:R08281','KEGG','RNO:100145871',true).
concept_accession('40071: rn:R08281','KEGG','RNO:24172',true).
concept_accession('40071: rn:R08281','KEGG','29646',true).
concept_accession('40054: rn:R01127','KEGG','EC:3.5.4.10',true).
concept_accession('40054: rn:R01127','KEGG','3.5.4.10',true).
concept_accession('40054: rn:R01127','KEGG','81643',true).
concept_accession('40054: rn:R01127','EC','3.5.4.10',true).
concept_accession('40054: rn:R01127','KEGG','RNO:81643',true).
concept_accession('40055: rn:R08341','EC','1.14.14.1',true).
concept_accession('40055: rn:R08341','KEGG','1.14.14.1',true).
concept_accession('40055: rn:R08341','KEGG','25642',true).
concept_accession('40055: rn:R08341','KEGG','RNO:25642',true).
concept_accession('40055: rn:R08341','KEGG','RNO:171352',true).
concept_accession('40055: rn:R08341','KEGG','171352',true).
concept_accession('40055: rn:R08341','KEGG','266682',true).
concept_accession('40055: rn:R08341','KEGG','252931',true).
concept_accession('40055: rn:R08341','KEGG','RNO:266682',true).
concept_accession('40055: rn:R08341','KEGG','RNO:252931',true).
concept_accession('40055: rn:R08341','KEGG','EC:1.14.14.1',true).
concept_accession('40052: rn:R07027','KEGG','RNO:25315',true).
concept_accession('40052: rn:R07027','EC','3.3.2.9',true).
concept_accession('40052: rn:R07027','KEGG','25315',true).
concept_accession('40052: rn:R07027','KEGG','3.3.2.9',true).
concept_accession('40052: rn:R07027','KEGG','EC:3.3.2.9',true).
concept_accession('40053: rn:R07015','KEGG','1.3.1.20',true).
concept_accession('40053: rn:R07015','KEGG','RNO:691002',true).
concept_accession('40053: rn:R07015','KEGG','691002',true).
concept_accession('40053: rn:R07015','KEGG','EC:1.3.1.20',true).
concept_accession('40053: rn:R07015','EC','1.3.1.20',true).
concept_accession('40050: rn:R07069','KEGG','289197',true).
concept_accession('40050: rn:R07069','KEGG','494500',true).
concept_accession('40050: rn:R07069','KEGG','RNO:681913',true).
concept_accession('40050: rn:R07069','KEGG','363205',true).
concept_accession('40050: rn:R07069','KEGG','EC:2.5.1.18',true).
concept_accession('40050: rn:R07069','KEGG','RNO:494500',true).
concept_accession('40050: rn:R07069','KEGG','29487',true).
concept_accession('40050: rn:R07069','EC','2.5.1.18',true).
concept_accession('40050: rn:R07069','KEGG','309465',true).
concept_accession('40050: rn:R07069','KEGG','RNO:57298',true).
concept_accession('40050: rn:R07069','KEGG','RNO:171341',true).
concept_accession('40050: rn:R07069','KEGG','RNO:24423',true).
concept_accession('40050: rn:R07069','KEGG','681913',true).
concept_accession('40050: rn:R07069','KEGG','300850',true).
concept_accession('40050: rn:R07069','KEGG','RNO:24424',true).
concept_accession('40050: rn:R07069','KEGG','RNO:24421',true).
concept_accession('40050: rn:R07069','KEGG','RNO:24422',true).
concept_accession('40050: rn:R07069','KEGG','RNO:81869',true).
concept_accession('40050: rn:R07069','KEGG','295037',true).
concept_accession('40050: rn:R07069','KEGG','RNO:24426',true).
concept_accession('40050: rn:R07069','KEGG','494499',true).
concept_accession('40050: rn:R07069','KEGG','RNO:289197',true).
concept_accession('40050: rn:R07069','KEGG','25260',true).
concept_accession('40050: rn:R07069','KEGG','114846',true).
concept_accession('40050: rn:R07069','KEGG','81869',true).
concept_accession('40050: rn:R07069','KEGG','501110',true).
concept_accession('40050: rn:R07069','KEGG','64352',true).
concept_accession('40050: rn:R07069','KEGG','24426',true).
concept_accession('40050: rn:R07069','KEGG','RNO:300850',true).
concept_accession('40050: rn:R07069','KEGG','24421',true).
concept_accession('40050: rn:R07069','KEGG','RNO:499688',true).
concept_accession('40050: rn:R07069','KEGG','2.5.1.18',true).
concept_accession('40050: rn:R07069','KEGG','24423',true).
concept_accession('40050: rn:R07069','KEGG','RNO:499689',true).
concept_accession('40050: rn:R07069','KEGG','24422',true).
concept_accession('40050: rn:R07069','KEGG','24424',true).
concept_accession('40050: rn:R07069','KEGG','499689',true).
concept_accession('40050: rn:R07069','KEGG','RNO:29487',true).
concept_accession('40050: rn:R07069','KEGG','499688',true).
concept_accession('40050: rn:R07069','KEGG','RNO:494499',true).
concept_accession('40050: rn:R07069','KEGG','RNO:114846',true).
concept_accession('40050: rn:R07069','KEGG','RNO:501110',true).
concept_accession('40050: rn:R07069','KEGG','57298',true).
concept_accession('40050: rn:R07069','KEGG','RNO:309465',true).
concept_accession('40050: rn:R07069','KEGG','RNO:297029',true).
concept_accession('40050: rn:R07069','KEGG','171341',true).
concept_accession('40050: rn:R07069','KEGG','RNO:25260',true).
concept_accession('40050: rn:R07069','KEGG','RNO:295037',true).
concept_accession('40050: rn:R07069','KEGG','RNO:363205',true).
concept_accession('40050: rn:R07069','KEGG','RNO:64352',true).
concept_accession('40050: rn:R07069','KEGG','297029',true).
concept_accession('40051: rn:R07094','KEGG','289197',true).
concept_accession('40051: rn:R07094','KEGG','494500',true).
concept_accession('40051: rn:R07094','KEGG','RNO:681913',true).
concept_accession('40051: rn:R07094','KEGG','363205',true).
concept_accession('40051: rn:R07094','KEGG','EC:2.5.1.18',true).
concept_accession('40051: rn:R07094','KEGG','RNO:494500',true).
concept_accession('40051: rn:R07094','KEGG','29487',true).
concept_accession('40051: rn:R07094','EC','2.5.1.18',true).
concept_accession('40051: rn:R07094','KEGG','309465',true).
concept_accession('40051: rn:R07094','KEGG','RNO:57298',true).
concept_accession('40051: rn:R07094','KEGG','RNO:171341',true).
concept_accession('40051: rn:R07094','KEGG','RNO:24423',true).
concept_accession('40051: rn:R07094','KEGG','681913',true).
concept_accession('40051: rn:R07094','KEGG','300850',true).
concept_accession('40051: rn:R07094','KEGG','RNO:24424',true).
concept_accession('40051: rn:R07094','KEGG','RNO:24421',true).
concept_accession('40051: rn:R07094','KEGG','RNO:24422',true).
concept_accession('40051: rn:R07094','KEGG','RNO:81869',true).
concept_accession('40051: rn:R07094','KEGG','295037',true).
concept_accession('40051: rn:R07094','KEGG','RNO:24426',true).
concept_accession('40051: rn:R07094','KEGG','494499',true).
concept_accession('40051: rn:R07094','KEGG','RNO:289197',true).
concept_accession('40051: rn:R07094','KEGG','25260',true).
concept_accession('40051: rn:R07094','KEGG','114846',true).
concept_accession('40051: rn:R07094','KEGG','81869',true).
concept_accession('40051: rn:R07094','KEGG','501110',true).
concept_accession('40051: rn:R07094','KEGG','64352',true).
concept_accession('40051: rn:R07094','KEGG','24426',true).
concept_accession('40051: rn:R07094','KEGG','RNO:300850',true).
concept_accession('40051: rn:R07094','KEGG','24421',true).
concept_accession('40051: rn:R07094','KEGG','RNO:499688',true).
concept_accession('40051: rn:R07094','KEGG','2.5.1.18',true).
concept_accession('40051: rn:R07094','KEGG','24423',true).
concept_accession('40051: rn:R07094','KEGG','RNO:499689',true).
concept_accession('40051: rn:R07094','KEGG','24422',true).
concept_accession('40051: rn:R07094','KEGG','24424',true).
concept_accession('40051: rn:R07094','KEGG','499689',true).
concept_accession('40051: rn:R07094','KEGG','RNO:29487',true).
concept_accession('40051: rn:R07094','KEGG','499688',true).
concept_accession('40051: rn:R07094','KEGG','RNO:494499',true).
concept_accession('40051: rn:R07094','KEGG','RNO:114846',true).
concept_accession('40051: rn:R07094','KEGG','RNO:501110',true).
concept_accession('40051: rn:R07094','KEGG','57298',true).
concept_accession('40051: rn:R07094','KEGG','RNO:309465',true).
concept_accession('40051: rn:R07094','KEGG','RNO:297029',true).
concept_accession('40051: rn:R07094','KEGG','171341',true).
concept_accession('40051: rn:R07094','KEGG','RNO:25260',true).
concept_accession('40051: rn:R07094','KEGG','RNO:295037',true).
concept_accession('40051: rn:R07094','KEGG','RNO:363205',true).
concept_accession('40051: rn:R07094','KEGG','RNO:64352',true).
concept_accession('40051: rn:R07094','KEGG','297029',true).
concept_accession('40048: rn:R00185','KEGG','2.7.1.20',true).
concept_accession('40048: rn:R00185','KEGG','79127',true).
concept_accession('40048: rn:R00185','EC','2.7.1.20',true).
concept_accession('40048: rn:R00185','KEGG','RNO:79127',true).
concept_accession('40048: rn:R00185','KEGG','EC:2.7.1.20',true).
concept_accession('40049: rn:R08282 rn:R08283','KEGG','RNO:25375',true).
concept_accession('40049: rn:R08282 rn:R08283','KEGG','25375',true).
concept_accession('40049: rn:R08282 rn:R08283','KEGG','RNO:266603',true).
concept_accession('40049: rn:R08282 rn:R08283','KEGG','266603',true).
concept_accession('40049: rn:R08282 rn:R08283','KEGG','RNO:309147',true).
concept_accession('40049: rn:R08282 rn:R08283','KEGG','309147',true).
concept_accession('40049: rn:R08282 rn:R08283','KEGG','EC:1.2.1.5',true).
concept_accession('40049: rn:R08282 rn:R08283','EC','1.2.1.5',true).
concept_accession('40049: rn:R08282 rn:R08283','KEGG','1.2.1.5',true).
concept_accession('40062: rn:R07943','EC','1.14.14.1',true).
concept_accession('40062: rn:R07943','KEGG','1.14.14.1',true).
concept_accession('40062: rn:R07943','KEGG','24297',true).
concept_accession('40062: rn:R07943','KEGG','RNO:24297',true).
concept_accession('40062: rn:R07943','KEGG','EC:1.14.14.1',true).
concept_accession('40063: rn:R07978','KEGG','497811',true).
concept_accession('40063: rn:R07978','KEGG','1.17.3.2',true).
concept_accession('40063: rn:R07978','KEGG','EC:1.17.3.2',true).
concept_accession('40063: rn:R07978','EC','1.17.3.2',true).
concept_accession('40063: rn:R07978','KEGG','RNO:497811',true).
concept_accession('40060: rn:R08343','EC','1.14.14.1',true).
concept_accession('40060: rn:R08343','KEGG','1.14.14.1',true).
concept_accession('40060: rn:R08343','KEGG','25642',true).
concept_accession('40060: rn:R08343','KEGG','RNO:25642',true).
concept_accession('40060: rn:R08343','KEGG','RNO:171352',true).
concept_accession('40060: rn:R08343','KEGG','171352',true).
concept_accession('40060: rn:R08343','KEGG','266682',true).
concept_accession('40060: rn:R08343','KEGG','252931',true).
concept_accession('40060: rn:R08343','KEGG','RNO:266682',true).
concept_accession('40060: rn:R08343','KEGG','RNO:252931',true).
concept_accession('40060: rn:R08343','KEGG','EC:1.14.14.1',true).
concept_accession('40061: rn:R07942','KEGG','497811',true).
concept_accession('40061: rn:R07942','KEGG','1.17.3.2',true).
concept_accession('40061: rn:R07942','KEGG','EC:1.17.3.2',true).
concept_accession('40061: rn:R07942','EC','1.17.3.2',true).
concept_accession('40061: rn:R07942','KEGG','RNO:497811',true).
concept_accession('40058: rn:R08312','EC','1.14.14.1',true).
concept_accession('40058: rn:R08312','KEGG','1.14.14.1',true).
concept_accession('40058: rn:R08312','KEGG','25642',true).
concept_accession('40058: rn:R08312','KEGG','RNO:25642',true).
concept_accession('40058: rn:R08312','KEGG','RNO:171352',true).
concept_accession('40058: rn:R08312','KEGG','171352',true).
concept_accession('40058: rn:R08312','KEGG','266682',true).
concept_accession('40058: rn:R08312','KEGG','252931',true).
concept_accession('40058: rn:R08312','KEGG','RNO:266682',true).
concept_accession('40058: rn:R08312','KEGG','RNO:252931',true).
concept_accession('40058: rn:R08312','KEGG','EC:1.14.14.1',true).
concept_accession('40059: rn:R01057','KEGG','RNO:24645',true).
concept_accession('40059: rn:R01057','KEGG','EC:5.4.2.7',true).
concept_accession('40059: rn:R01057','KEGG','5.4.2.7',true).
concept_accession('40059: rn:R01057','EC','5.4.2.7',true).
concept_accession('40059: rn:R01057','KEGG','24645',true).
concept_accession('40056: rn:R01054','KEGG','3.6.1.13',true).
concept_accession('40056: rn:R01054','KEGG','EC:3.6.1.13',true).
concept_accession('40056: rn:R01054','KEGG','RNO:361274',true).
concept_accession('40056: rn:R01054','KEGG','361274',true).
concept_accession('40056: rn:R01054','EC','3.6.1.13',true).
concept_accession('40057: rn:R06604','KEGG','684055',true).
concept_accession('40057: rn:R06604','EC','4.1.1.-',true).
concept_accession('40057: rn:R06604','KEGG','4.1.1.-',true).
concept_accession('40057: rn:R06604','KEGG','RNO:684055',true).
concept_accession('40057: rn:R06604','KEGG','EC:4.1.1.-',true).
concept_accession('40039: rn:R08267','EC','1.14.14.1',true).
concept_accession('40039: rn:R08267','KEGG','RNO:25053',true).
concept_accession('40039: rn:R08267','KEGG','171522',true).
concept_accession('40039: rn:R08267','KEGG','RNO:24303',true).
concept_accession('40039: rn:R08267','KEGG','RNO:286963',true).
concept_accession('40039: rn:R08267','KEGG','25053',true).
concept_accession('40039: rn:R08267','KEGG','EC:1.14.14.1',true).
concept_accession('40039: rn:R08267','KEGG','286963',true).
concept_accession('40039: rn:R08267','KEGG','1.14.14.1',true).
concept_accession('40039: rn:R08267','KEGG','RNO:171522',true).
concept_accession('40039: rn:R08267','KEGG','RNO:266684',true).
concept_accession('40039: rn:R08267','KEGG','266684',true).
concept_accession('40039: rn:R08267','KEGG','24303',true).
concept_accession('40038: rn:R08275','EC','1.14.14.1',true).
concept_accession('40038: rn:R08275','KEGG','1.14.14.1',true).
concept_accession('40038: rn:R08275','KEGG','25642',true).
concept_accession('40038: rn:R08275','KEGG','RNO:25642',true).
concept_accession('40038: rn:R08275','KEGG','RNO:171352',true).
concept_accession('40038: rn:R08275','KEGG','171352',true).
concept_accession('40038: rn:R08275','KEGG','266682',true).
concept_accession('40038: rn:R08275','KEGG','252931',true).
concept_accession('40038: rn:R08275','KEGG','RNO:266682',true).
concept_accession('40038: rn:R08275','KEGG','RNO:252931',true).
concept_accession('40038: rn:R08275','KEGG','EC:1.14.14.1',true).
concept_accession('40037: rn:R08276','EC','1.14.14.1',true).
concept_accession('40037: rn:R08276','KEGG','1.14.14.1',true).
concept_accession('40037: rn:R08276','KEGG','25642',true).
concept_accession('40037: rn:R08276','KEGG','RNO:25642',true).
concept_accession('40037: rn:R08276','KEGG','RNO:171352',true).
concept_accession('40037: rn:R08276','KEGG','171352',true).
concept_accession('40037: rn:R08276','KEGG','266682',true).
concept_accession('40037: rn:R08276','KEGG','252931',true).
concept_accession('40037: rn:R08276','KEGG','RNO:266682',true).
concept_accession('40037: rn:R08276','KEGG','RNO:252931',true).
concept_accession('40037: rn:R08276','KEGG','EC:1.14.14.1',true).
concept_accession('40036: rn:R08275','EC','1.14.14.1',true).
concept_accession('40036: rn:R08275','KEGG','RNO:100364896',true).
concept_accession('40036: rn:R08275','KEGG','171518',true).
concept_accession('40036: rn:R08275','KEGG','246070',true).
concept_accession('40036: rn:R08275','KEGG','100364896',true).
concept_accession('40036: rn:R08275','KEGG','29277',true).
concept_accession('40036: rn:R08275','KEGG','RNO:29298',true).
concept_accession('40036: rn:R08275','KEGG','171521',true).
concept_accession('40036: rn:R08275','KEGG','RNO:293989',true).
concept_accession('40036: rn:R08275','KEGG','29298',true).
concept_accession('40036: rn:R08275','KEGG','RNO:246070',true).
concept_accession('40036: rn:R08275','KEGG','EC:1.14.14.1',true).
concept_accession('40036: rn:R08275','KEGG','RNO:83790',true).
concept_accession('40036: rn:R08275','KEGG','293989',true).
concept_accession('40036: rn:R08275','KEGG','RNO:29277',true).
concept_accession('40036: rn:R08275','KEGG','RNO:687842',true).
concept_accession('40036: rn:R08275','KEGG','687842',true).
concept_accession('40036: rn:R08275','KEGG','1.14.14.1',true).
concept_accession('40036: rn:R08275','KEGG','RNO:171521',true).
concept_accession('40036: rn:R08275','KEGG','RNO:171518',true).
concept_accession('40036: rn:R08275','KEGG','25011',true).
concept_accession('40036: rn:R08275','KEGG','RNO:25011',true).
concept_accession('40036: rn:R08275','KEGG','83790',true).
concept_accession('40035: rn:R08275','KEGG','361523',true).
concept_accession('40035: rn:R08275','EC','1.14.14.1',true).
concept_accession('40035: rn:R08275','KEGG','RNO:361523',true).
concept_accession('40035: rn:R08275','KEGG','29295',true).
concept_accession('40035: rn:R08275','KEGG','RNO:292728',true).
concept_accession('40035: rn:R08275','KEGG','RNO:24300',true).
concept_accession('40035: rn:R08275','KEGG','RNO:286953',true).
concept_accession('40035: rn:R08275','KEGG','RNO:29295',true).
concept_accession('40035: rn:R08275','KEGG','EC:1.14.14.1',true).
concept_accession('40035: rn:R08275','KEGG','1.14.14.1',true).
concept_accession('40035: rn:R08275','KEGG','286953',true).
concept_accession('40035: rn:R08275','KEGG','292728',true).
concept_accession('40035: rn:R08275','KEGG','24300',true).
concept_accession('40034: rn:R08280','KEGG','289197',true).
concept_accession('40034: rn:R08280','KEGG','494500',true).
concept_accession('40034: rn:R08280','KEGG','RNO:681913',true).
concept_accession('40034: rn:R08280','KEGG','363205',true).
concept_accession('40034: rn:R08280','KEGG','EC:2.5.1.18',true).
concept_accession('40034: rn:R08280','KEGG','RNO:494500',true).
concept_accession('40034: rn:R08280','KEGG','29487',true).
concept_accession('40034: rn:R08280','EC','2.5.1.18',true).
concept_accession('40034: rn:R08280','KEGG','309465',true).
concept_accession('40034: rn:R08280','KEGG','RNO:57298',true).
concept_accession('40034: rn:R08280','KEGG','RNO:171341',true).
concept_accession('40034: rn:R08280','KEGG','RNO:24423',true).
concept_accession('40034: rn:R08280','KEGG','681913',true).
concept_accession('40034: rn:R08280','KEGG','300850',true).
concept_accession('40034: rn:R08280','KEGG','RNO:24424',true).
concept_accession('40034: rn:R08280','KEGG','RNO:24421',true).
concept_accession('40034: rn:R08280','KEGG','RNO:24422',true).
concept_accession('40034: rn:R08280','KEGG','RNO:81869',true).
concept_accession('40034: rn:R08280','KEGG','295037',true).
concept_accession('40034: rn:R08280','KEGG','RNO:24426',true).
concept_accession('40034: rn:R08280','KEGG','494499',true).
concept_accession('40034: rn:R08280','KEGG','RNO:289197',true).
concept_accession('40034: rn:R08280','KEGG','25260',true).
concept_accession('40034: rn:R08280','KEGG','114846',true).
concept_accession('40034: rn:R08280','KEGG','81869',true).
concept_accession('40034: rn:R08280','KEGG','501110',true).
concept_accession('40034: rn:R08280','KEGG','64352',true).
concept_accession('40034: rn:R08280','KEGG','24426',true).
concept_accession('40034: rn:R08280','KEGG','RNO:300850',true).
concept_accession('40034: rn:R08280','KEGG','24421',true).
concept_accession('40034: rn:R08280','KEGG','RNO:499688',true).
concept_accession('40034: rn:R08280','KEGG','2.5.1.18',true).
concept_accession('40034: rn:R08280','KEGG','24423',true).
concept_accession('40034: rn:R08280','KEGG','RNO:499689',true).
concept_accession('40034: rn:R08280','KEGG','24422',true).
concept_accession('40034: rn:R08280','KEGG','24424',true).
concept_accession('40034: rn:R08280','KEGG','499689',true).
concept_accession('40034: rn:R08280','KEGG','RNO:29487',true).
concept_accession('40034: rn:R08280','KEGG','499688',true).
concept_accession('40034: rn:R08280','KEGG','RNO:494499',true).
concept_accession('40034: rn:R08280','KEGG','RNO:114846',true).
concept_accession('40034: rn:R08280','KEGG','RNO:501110',true).
concept_accession('40034: rn:R08280','KEGG','57298',true).
concept_accession('40034: rn:R08280','KEGG','RNO:309465',true).
concept_accession('40034: rn:R08280','KEGG','RNO:297029',true).
concept_accession('40034: rn:R08280','KEGG','171341',true).
concept_accession('40034: rn:R08280','KEGG','RNO:25260',true).
concept_accession('40034: rn:R08280','KEGG','RNO:295037',true).
concept_accession('40034: rn:R08280','KEGG','RNO:363205',true).
concept_accession('40034: rn:R08280','KEGG','RNO:64352',true).
concept_accession('40034: rn:R08280','KEGG','297029',true).
concept_accession('40033: rn:R08285','KEGG','361523',true).
concept_accession('40033: rn:R08285','EC','1.14.14.1',true).
concept_accession('40033: rn:R08285','KEGG','RNO:361523',true).
concept_accession('40033: rn:R08285','KEGG','29295',true).
concept_accession('40033: rn:R08285','KEGG','RNO:292728',true).
concept_accession('40033: rn:R08285','KEGG','RNO:24300',true).
concept_accession('40033: rn:R08285','KEGG','RNO:286953',true).
concept_accession('40033: rn:R08285','KEGG','RNO:29295',true).
concept_accession('40033: rn:R08285','KEGG','EC:1.14.14.1',true).
concept_accession('40033: rn:R08285','KEGG','1.14.14.1',true).
concept_accession('40033: rn:R08285','KEGG','286953',true).
concept_accession('40033: rn:R08285','KEGG','292728',true).
concept_accession('40033: rn:R08285','KEGG','24300',true).
concept_accession('40032: rn:R08272','EC','1.14.14.1',true).
concept_accession('40032: rn:R08272','KEGG','1.14.14.1',true).
concept_accession('40032: rn:R08272','KEGG','25642',true).
concept_accession('40032: rn:R08272','KEGG','RNO:25642',true).
concept_accession('40032: rn:R08272','KEGG','RNO:171352',true).
concept_accession('40032: rn:R08272','KEGG','171352',true).
concept_accession('40032: rn:R08272','KEGG','266682',true).
concept_accession('40032: rn:R08272','KEGG','252931',true).
concept_accession('40032: rn:R08272','KEGG','RNO:266682',true).
concept_accession('40032: rn:R08272','KEGG','RNO:252931',true).
concept_accession('40032: rn:R08272','KEGG','EC:1.14.14.1',true).
concept_accession('40047: rn:R00200','KEGG','RNO:25630',true).
concept_accession('40047: rn:R00200','KEGG','24651',true).
concept_accession('40047: rn:R00200','KEGG','2.7.1.40',true).
concept_accession('40047: rn:R00200','KEGG','25630',true).
concept_accession('40047: rn:R00200','KEGG','EC:2.7.1.40',true).
concept_accession('40047: rn:R00200','EC','2.7.1.40',true).
concept_accession('40047: rn:R00200','KEGG','100364062',true).
concept_accession('40047: rn:R00200','KEGG','RNO:24651',true).
concept_accession('40047: rn:R00200','KEGG','RNO:100364062',true).
concept_accession('40046: rn:R01138','KEGG','RNO:25630',true).
concept_accession('40046: rn:R01138','KEGG','24651',true).
concept_accession('40046: rn:R01138','KEGG','2.7.1.40',true).
concept_accession('40046: rn:R01138','KEGG','25630',true).
concept_accession('40046: rn:R01138','KEGG','EC:2.7.1.40',true).
concept_accession('40046: rn:R01138','EC','2.7.1.40',true).
concept_accession('40046: rn:R01138','KEGG','100364062',true).
concept_accession('40046: rn:R01138','KEGG','RNO:24651',true).
concept_accession('40046: rn:R01138','KEGG','RNO:100364062',true).
concept_accession('40045: rn:R00086','KEGG','361443',true).
concept_accession('40045: rn:R00086','KEGG','RNO:361443',true).
concept_accession('40045: rn:R00086','KEGG','3.6.1.5',true).
concept_accession('40045: rn:R00086','KEGG','EC:3.6.1.5',true).
concept_accession('40045: rn:R00086','EC','3.6.1.5',true).
concept_accession('40044: rn:R08266','KEGG','RNO:246245',true).
concept_accession('40044: rn:R08266','KEGG','RNO:246248',true).
concept_accession('40044: rn:R08266','KEGG','RNO:246247',true).
concept_accession('40044: rn:R08266','KEGG','EC:1.14.13.8',true).
concept_accession('40044: rn:R08266','KEGG','246248',true).
concept_accession('40044: rn:R08266','KEGG','25256',true).
concept_accession('40044: rn:R08266','KEGG','RNO:25256',true).
concept_accession('40044: rn:R08266','KEGG','246247',true).
concept_accession('40044: rn:R08266','KEGG','246245',true).
concept_accession('40044: rn:R08266','EC','1.14.13.8',true).
concept_accession('40044: rn:R08266','KEGG','1.14.13.8',true).
concept_accession('40044: rn:R08266','KEGG','84493',true).
concept_accession('40044: rn:R08266','KEGG','RNO:84493',true).
concept_accession('40043: rn:R08271','EC','1.14.14.1',true).
concept_accession('40043: rn:R08271','KEGG','1.14.14.1',true).
concept_accession('40043: rn:R08271','KEGG','25642',true).
concept_accession('40043: rn:R08271','KEGG','RNO:25642',true).
concept_accession('40043: rn:R08271','KEGG','RNO:171352',true).
concept_accession('40043: rn:R08271','KEGG','171352',true).
concept_accession('40043: rn:R08271','KEGG','266682',true).
concept_accession('40043: rn:R08271','KEGG','252931',true).
concept_accession('40043: rn:R08271','KEGG','RNO:266682',true).
concept_accession('40043: rn:R08271','KEGG','RNO:252931',true).
concept_accession('40043: rn:R08271','KEGG','EC:1.14.14.1',true).
concept_accession('40042: rn:R08274','EC','1.14.14.1',true).
concept_accession('40042: rn:R08274','KEGG','1.14.14.1',true).
concept_accession('40042: rn:R08274','KEGG','25642',true).
concept_accession('40042: rn:R08274','KEGG','RNO:25642',true).
concept_accession('40042: rn:R08274','KEGG','RNO:171352',true).
concept_accession('40042: rn:R08274','KEGG','171352',true).
concept_accession('40042: rn:R08274','KEGG','266682',true).
concept_accession('40042: rn:R08274','KEGG','252931',true).
concept_accession('40042: rn:R08274','KEGG','RNO:266682',true).
concept_accession('40042: rn:R08274','KEGG','RNO:252931',true).
concept_accession('40042: rn:R08274','KEGG','EC:1.14.14.1',true).
concept_accession('40041: rn:R08268','EC','1.14.14.1',true).
concept_accession('40041: rn:R08268','KEGG','1.14.14.1',true).
concept_accession('40041: rn:R08268','KEGG','25642',true).
concept_accession('40041: rn:R08268','KEGG','RNO:25642',true).
concept_accession('40041: rn:R08268','KEGG','RNO:171352',true).
concept_accession('40041: rn:R08268','KEGG','171352',true).
concept_accession('40041: rn:R08268','KEGG','266682',true).
concept_accession('40041: rn:R08268','KEGG','252931',true).
concept_accession('40041: rn:R08268','KEGG','RNO:266682',true).
concept_accession('40041: rn:R08268','KEGG','RNO:252931',true).
concept_accession('40041: rn:R08268','KEGG','EC:1.14.14.1',true).
concept_accession('40040: rn:R08269','EC','1.14.14.1',true).
concept_accession('40040: rn:R08269','KEGG','1.14.14.1',true).
concept_accession('40040: rn:R08269','KEGG','25642',true).
concept_accession('40040: rn:R08269','KEGG','RNO:25642',true).
concept_accession('40040: rn:R08269','KEGG','RNO:171352',true).
concept_accession('40040: rn:R08269','KEGG','171352',true).
concept_accession('40040: rn:R08269','KEGG','266682',true).
concept_accession('40040: rn:R08269','KEGG','252931',true).
concept_accession('40040: rn:R08269','KEGG','RNO:266682',true).
concept_accession('40040: rn:R08269','KEGG','RNO:252931',true).
concept_accession('40040: rn:R08269','KEGG','EC:1.14.14.1',true).
concept_accession('40020: rn:R02016','KEGG','297437',true).
concept_accession('40020: rn:R02016','KEGG','EC:1.8.1.9',true).
concept_accession('40020: rn:R02016','KEGG','RNO:50551',true).
concept_accession('40020: rn:R02016','KEGG','RNO:58819',true).
concept_accession('40020: rn:R02016','KEGG','50551',true).
concept_accession('40020: rn:R02016','KEGG','RNO:297437',true).
concept_accession('40020: rn:R02016','KEGG','58819',true).
concept_accession('40020: rn:R02016','EC','1.8.1.9',true).
concept_accession('40020: rn:R02016','KEGG','1.8.1.9',true).
concept_accession('40021: rn:R08231','KEGG','EC:2.4.2.10',true).
concept_accession('40021: rn:R08231','KEGG','288051',true).
concept_accession('40021: rn:R08231','KEGG','RNO:288051',true).
concept_accession('40021: rn:R08231','KEGG','2.4.2.10',true).
concept_accession('40021: rn:R08231','EC','2.4.2.10',true).
concept_accession('40022: rn:R02024','EC','1.17.4.1',true).
concept_accession('40022: rn:R02024','KEGG','362720',true).
concept_accession('40022: rn:R02024','KEGG','RNO:100359539',true).
concept_accession('40022: rn:R02024','KEGG','RNO:685579',true).
concept_accession('40022: rn:R02024','KEGG','1.17.4.1',true).
concept_accession('40022: rn:R02024','KEGG','100359539',true).
concept_accession('40022: rn:R02024','KEGG','EC:1.17.4.1',true).
concept_accession('40022: rn:R02024','KEGG','685579',true).
concept_accession('40022: rn:R02024','KEGG','299976',true).
concept_accession('40022: rn:R02024','KEGG','RNO:299976',true).
concept_accession('40022: rn:R02024','KEGG','RNO:362720',true).
concept_accession('40023: rn:R08228','EC','3.5.1.6',true).
concept_accession('40023: rn:R08228','KEGG','116593',true).
concept_accession('40023: rn:R08228','KEGG','EC:3.5.1.6',true).
concept_accession('40023: rn:R08228','KEGG','RNO:116593',true).
concept_accession('40023: rn:R08228','KEGG','3.5.1.6',true).
concept_accession('40016: rn:R08229','KEGG','2.4.2.3',true).
concept_accession('40016: rn:R08229','KEGG','RNO:289801',true).
concept_accession('40016: rn:R08229','KEGG','EC:2.4.2.3',true).
concept_accession('40016: rn:R08229','EC','2.4.2.3',true).
concept_accession('40016: rn:R08229','KEGG','295620',true).
concept_accession('40016: rn:R08229','KEGG','289801',true).
concept_accession('40016: rn:R08229','KEGG','RNO:295620',true).
concept_accession('40017: rn:R02016','KEGG','297437',true).
concept_accession('40017: rn:R02016','KEGG','EC:1.8.1.9',true).
concept_accession('40017: rn:R02016','KEGG','RNO:50551',true).
concept_accession('40017: rn:R02016','KEGG','RNO:58819',true).
concept_accession('40017: rn:R02016','KEGG','50551',true).
concept_accession('40017: rn:R02016','KEGG','RNO:297437',true).
concept_accession('40017: rn:R02016','KEGG','58819',true).
concept_accession('40017: rn:R02016','EC','1.8.1.9',true).
concept_accession('40017: rn:R02016','KEGG','1.8.1.9',true).
concept_accession('40018: rn:R08233','KEGG','RNO:291824',true).
concept_accession('40018: rn:R08233','KEGG','2.7.1.21',true).
concept_accession('40018: rn:R08233','KEGG','24834',true).
concept_accession('40018: rn:R08233','KEGG','291824',true).
concept_accession('40018: rn:R08233','EC','2.7.1.21',true).
concept_accession('40018: rn:R08233','KEGG','EC:2.7.1.21',true).
concept_accession('40018: rn:R08233','KEGG','RNO:24834',true).
concept_accession('40019: rn:R08232','KEGG','RNO:304944',true).
concept_accession('40019: rn:R08232','KEGG','311864',true).
concept_accession('40019: rn:R08232','KEGG','499956',true).
concept_accession('40019: rn:R08232','KEGG','RNO:499956',true).
concept_accession('40019: rn:R08232','KEGG','2.7.1.48',true).
concept_accession('40019: rn:R08232','KEGG','304944',true).
concept_accession('40019: rn:R08232','KEGG','RNO:311864',true).
concept_accession('40019: rn:R08232','KEGG','EC:2.7.1.48',true).
concept_accession('40019: rn:R08232','EC','2.7.1.48',true).
concept_accession('40028: rn:R08293','EC','1.14.14.1',true).
concept_accession('40028: rn:R08293','KEGG','1.14.14.1',true).
concept_accession('40028: rn:R08293','KEGG','24297',true).
concept_accession('40028: rn:R08293','KEGG','RNO:24297',true).
concept_accession('40028: rn:R08293','KEGG','EC:1.14.14.1',true).
concept_accession('40029: rn:R08293','EC','1.14.14.1',true).
concept_accession('40029: rn:R08293','KEGG','1.14.14.1',true).
concept_accession('40029: rn:R08293','KEGG','25642',true).
concept_accession('40029: rn:R08293','KEGG','RNO:25642',true).
concept_accession('40029: rn:R08293','KEGG','RNO:171352',true).
concept_accession('40029: rn:R08293','KEGG','171352',true).
concept_accession('40029: rn:R08293','KEGG','266682',true).
concept_accession('40029: rn:R08293','KEGG','252931',true).
concept_accession('40029: rn:R08293','KEGG','RNO:266682',true).
concept_accession('40029: rn:R08293','KEGG','RNO:252931',true).
concept_accession('40029: rn:R08293','KEGG','EC:1.14.14.1',true).
concept_accession('40030: rn:R08294','EC','1.14.14.1',true).
concept_accession('40030: rn:R08294','KEGG','1.14.14.1',true).
concept_accession('40030: rn:R08294','KEGG','25642',true).
concept_accession('40030: rn:R08294','KEGG','RNO:25642',true).
concept_accession('40030: rn:R08294','KEGG','RNO:171352',true).
concept_accession('40030: rn:R08294','KEGG','171352',true).
concept_accession('40030: rn:R08294','KEGG','266682',true).
concept_accession('40030: rn:R08294','KEGG','252931',true).
concept_accession('40030: rn:R08294','KEGG','RNO:266682',true).
concept_accession('40030: rn:R08294','KEGG','RNO:252931',true).
concept_accession('40030: rn:R08294','KEGG','EC:1.14.14.1',true).
concept_accession('40031: rn:R08270','EC','1.14.14.1',true).
concept_accession('40031: rn:R08270','KEGG','RNO:25053',true).
concept_accession('40031: rn:R08270','KEGG','171522',true).
concept_accession('40031: rn:R08270','KEGG','RNO:24303',true).
concept_accession('40031: rn:R08270','KEGG','RNO:286963',true).
concept_accession('40031: rn:R08270','KEGG','25053',true).
concept_accession('40031: rn:R08270','KEGG','EC:1.14.14.1',true).
concept_accession('40031: rn:R08270','KEGG','286963',true).
concept_accession('40031: rn:R08270','KEGG','1.14.14.1',true).
concept_accession('40031: rn:R08270','KEGG','RNO:171522',true).
concept_accession('40031: rn:R08270','KEGG','RNO:266684',true).
concept_accession('40031: rn:R08270','KEGG','266684',true).
concept_accession('40031: rn:R08270','KEGG','24303',true).
concept_accession('40024: rn:R02016','KEGG','297437',true).
concept_accession('40024: rn:R02016','KEGG','EC:1.8.1.9',true).
concept_accession('40024: rn:R02016','KEGG','RNO:50551',true).
concept_accession('40024: rn:R02016','KEGG','RNO:58819',true).
concept_accession('40024: rn:R02016','KEGG','50551',true).
concept_accession('40024: rn:R02016','KEGG','RNO:297437',true).
concept_accession('40024: rn:R02016','KEGG','58819',true).
concept_accession('40024: rn:R02016','EC','1.8.1.9',true).
concept_accession('40024: rn:R02016','KEGG','1.8.1.9',true).
concept_accession('40025: rn:R08277','EC','1.14.14.1',true).
concept_accession('40025: rn:R08277','KEGG','1.14.14.1',true).
concept_accession('40025: rn:R08277','KEGG','25642',true).
concept_accession('40025: rn:R08277','KEGG','RNO:25642',true).
concept_accession('40025: rn:R08277','KEGG','RNO:171352',true).
concept_accession('40025: rn:R08277','KEGG','171352',true).
concept_accession('40025: rn:R08277','KEGG','266682',true).
concept_accession('40025: rn:R08277','KEGG','252931',true).
concept_accession('40025: rn:R08277','KEGG','RNO:266682',true).
concept_accession('40025: rn:R08277','KEGG','RNO:252931',true).
concept_accession('40025: rn:R08277','KEGG','EC:1.14.14.1',true).
concept_accession('40026: rn:R08285','EC','1.14.14.1',true).
concept_accession('40026: rn:R08285','KEGG','1.14.14.1',true).
concept_accession('40026: rn:R08285','KEGG','25642',true).
concept_accession('40026: rn:R08285','KEGG','RNO:25642',true).
concept_accession('40026: rn:R08285','KEGG','RNO:171352',true).
concept_accession('40026: rn:R08285','KEGG','171352',true).
concept_accession('40026: rn:R08285','KEGG','266682',true).
concept_accession('40026: rn:R08285','KEGG','252931',true).
concept_accession('40026: rn:R08285','KEGG','RNO:266682',true).
concept_accession('40026: rn:R08285','KEGG','RNO:252931',true).
concept_accession('40026: rn:R08285','KEGG','EC:1.14.14.1',true).
concept_accession('40027: rn:R08294','EC','1.14.14.1',true).
concept_accession('40027: rn:R08294','KEGG','1.14.14.1',true).
concept_accession('40027: rn:R08294','KEGG','24297',true).
concept_accession('40027: rn:R08294','KEGG','RNO:24297',true).
concept_accession('40027: rn:R08294','KEGG','EC:1.14.14.1',true).
concept_accession('40005: rn:R00377','KEGG','RNO:293144',true).
concept_accession('40005: rn:R00377','KEGG','RNO:289758',true).
concept_accession('40005: rn:R00377','KEGG','289758',true).
concept_accession('40005: rn:R00377','KEGG','299112',true).
concept_accession('40005: rn:R00377','KEGG','RNO:361698',true).
concept_accession('40005: rn:R00377','KEGG','246327',true).
concept_accession('40005: rn:R00377','KEGG','85241',true).
concept_accession('40005: rn:R00377','KEGG','85242',true).
concept_accession('40005: rn:R00377','KEGG','2.7.7.7',true).
concept_accession('40005: rn:R00377','KEGG','304573',true).
concept_accession('40005: rn:R00377','KEGG','59294',true).
concept_accession('40005: rn:R00377','KEGG','298098',true).
concept_accession('40005: rn:R00377','KEGG','RNO:85242',true).
concept_accession('40005: rn:R00377','KEGG','293144',true).
concept_accession('40005: rn:R00377','KEGG','362385',true).
concept_accession('40005: rn:R00377','KEGG','RNO:85241',true).
concept_accession('40005: rn:R00377','KEGG','EC:2.7.7.7',true).
concept_accession('40005: rn:R00377','KEGG','RNO:301323',true).
concept_accession('40005: rn:R00377','KEGG','RNO:298098',true).
concept_accession('40005: rn:R00377','KEGG','RNO:100362333',true).
concept_accession('40005: rn:R00377','KEGG','RNO:304573',true).
concept_accession('40005: rn:R00377','KEGG','361698',true).
concept_accession('40005: rn:R00377','KEGG','RNO:299112',true).
concept_accession('40005: rn:R00377','KEGG','RNO:246327',true).
concept_accession('40005: rn:R00377','KEGG','RNO:59294',true).
concept_accession('40005: rn:R00377','KEGG','100362333',true).
concept_accession('40005: rn:R00377','KEGG','RNO:362385',true).
concept_accession('40005: rn:R00377','EC','2.7.7.7',true).
concept_accession('40005: rn:R00377','KEGG','301323',true).
concept_accession('40004: rn:R08240','KEGG','RNO:301005',true).
concept_accession('40004: rn:R08240','KEGG','RNO:362329',true).
concept_accession('40004: rn:R08240','KEGG','1.1.1.205',true).
concept_accession('40004: rn:R08240','KEGG','362329',true).
concept_accession('40004: rn:R08240','KEGG','EC:1.1.1.205',true).
concept_accession('40004: rn:R08240','KEGG','301005',true).
concept_accession('40004: rn:R08240','EC','1.1.1.205',true).
concept_accession('40007: rn:R01664','KEGG','RNO:313574',true).
concept_accession('40007: rn:R01664','KEGG','100363253',true).
concept_accession('40007: rn:R01664','KEGG','RNO:688261',true).
concept_accession('40007: rn:R01664','KEGG','RNO:287368',true).
concept_accession('40007: rn:R01664','KEGG','688261',true).
concept_accession('40007: rn:R01664','EC','3.1.3.5',true).
concept_accession('40007: rn:R01664','KEGG','313574',true).
concept_accession('40007: rn:R01664','KEGG','RNO:58813',true).
concept_accession('40007: rn:R01664','KEGG','287368',true).
concept_accession('40007: rn:R01664','KEGG','RNO:312373',true).
concept_accession('40007: rn:R01664','KEGG','3.1.3.5',true).
concept_accession('40007: rn:R01664','KEGG','RNO:100363253',true).
concept_accession('40007: rn:R01664','KEGG','RNO:298881',true).
concept_accession('40007: rn:R01664','KEGG','EC:3.1.3.5',true).
concept_accession('40007: rn:R01664','KEGG','298881',true).
concept_accession('40007: rn:R01664','KEGG','58813',true).
concept_accession('40007: rn:R01664','KEGG','312373',true).
concept_accession('40006: rn:R08259','KEGG','396551',true).
concept_accession('40006: rn:R08259','KEGG','2.4.1.17',true).
concept_accession('40006: rn:R08259','KEGG','154516',true).
concept_accession('40006: rn:R08259','KEGG','396552',true).
concept_accession('40006: rn:R08259','KEGG','RNO:305264',true).
concept_accession('40006: rn:R08259','KEGG','289533',true).
concept_accession('40006: rn:R08259','KEGG','RNO:396527',true).
concept_accession('40006: rn:R08259','KEGG','574523',true).
concept_accession('40006: rn:R08259','KEGG','396527',true).
concept_accession('40006: rn:R08259','KEGG','EC:2.4.1.17',true).
concept_accession('40006: rn:R08259','KEGG','113992',true).
concept_accession('40006: rn:R08259','KEGG','RNO:574523',true).
concept_accession('40006: rn:R08259','KEGG','RNO:266685',true).
concept_accession('40006: rn:R08259','KEGG','RNO:24861',true).
concept_accession('40006: rn:R08259','KEGG','266685',true).
concept_accession('40006: rn:R08259','KEGG','RNO:24862',true).
concept_accession('40006: rn:R08259','KEGG','29623',true).
concept_accession('40006: rn:R08259','KEGG','RNO:289533',true).
concept_accession('40006: rn:R08259','KEGG','305264',true).
concept_accession('40006: rn:R08259','KEGG','RNO:83808',true).
concept_accession('40006: rn:R08259','KEGG','RNO:301595',true).
concept_accession('40006: rn:R08259','KEGG','RNO:29623',true).
concept_accession('40006: rn:R08259','KEGG','RNO:154516',true).
concept_accession('40006: rn:R08259','KEGG','301595',true).
concept_accession('40006: rn:R08259','KEGG','RNO:396552',true).
concept_accession('40006: rn:R08259','KEGG','RNO:396551',true).
concept_accession('40006: rn:R08259','KEGG','RNO:286954',true).
concept_accession('40006: rn:R08259','KEGG','RNO:113992',true).
concept_accession('40006: rn:R08259','KEGG','RNO:63867',true).
concept_accession('40006: rn:R08259','KEGG','286954',true).
concept_accession('40006: rn:R08259','KEGG','83808',true).
concept_accession('40006: rn:R08259','KEGG','24861',true).
concept_accession('40006: rn:R08259','KEGG','63867',true).
concept_accession('40006: rn:R08259','EC','2.4.1.17',true).
concept_accession('40006: rn:R08259','KEGG','24862',true).
concept_accession('40001: rn:R02326','KEGG','171566',true).
concept_accession('40001: rn:R02326','KEGG','2.7.4.6',true).
concept_accession('40001: rn:R02326','KEGG','685679',true).
concept_accession('40001: rn:R02326','KEGG','83782',true).
concept_accession('40001: rn:R02326','KEGG','RNO:58964',true).
concept_accession('40001: rn:R02326','KEGG','RNO:83782',true).
concept_accession('40001: rn:R02326','KEGG','85269',true).
concept_accession('40001: rn:R02326','KEGG','RNO:685679',true).
concept_accession('40001: rn:R02326','KEGG','RNO:85269',true).
concept_accession('40001: rn:R02326','EC','2.7.4.6',true).
concept_accession('40001: rn:R02326','KEGG','EC:2.7.4.6',true).
concept_accession('40001: rn:R02326','KEGG','RNO:191575',true).
concept_accession('40001: rn:R02326','KEGG','191575',true).
concept_accession('40001: rn:R02326','KEGG','58964',true).
concept_accession('40001: rn:R02326','KEGG','RNO:171566',true).
concept_accession('40000: rn:R08222','KEGG','315219',true).
concept_accession('40000: rn:R08222','KEGG','EC:2.4.2.4',true).
concept_accession('40000: rn:R08222','EC','2.4.2.4',true).
concept_accession('40000: rn:R08222','KEGG','2.4.2.4',true).
concept_accession('40000: rn:R08222','KEGG','RNO:315219',true).
concept_accession('9872: rn:R07456','KEGG','RC:RC01783',true).
concept_accession('9872: rn:R07456','KEGG','RP10677',true).
concept_accession('9872: rn:R07456','KEGG','RP:RP10677',true).
concept_accession('9872: rn:R07456','KEGG','2.6.-.-',true).
concept_accession('9872: rn:R07456','KEGG','EC:2.6.-.-',true).
concept_accession('9872: rn:R07456','KEGG','R07456',true).
concept_accession('9872: rn:R07456','EC','2.6.-.-',false).
concept_accession('9872: rn:R07456','KEGG','RC01783',true).
concept_accession('9872: rn:R07456','KEGG','RN:R07456',true).
concept_accession('40003: rn:R01665','KEGG','RNO:298410',true).
concept_accession('40003: rn:R01665','KEGG','2.7.4.14',true).
concept_accession('40003: rn:R01665','KEGG','RNO:314004',true).
concept_accession('40003: rn:R01665','KEGG','314004',true).
concept_accession('40003: rn:R01665','EC','2.7.4.14',true).
concept_accession('40003: rn:R01665','KEGG','EC:2.7.4.14',true).
concept_accession('40003: rn:R01665','KEGG','298410',true).
concept_accession('9873: rn:R07456','KEGG','RC:RC01783',true).
concept_accession('9873: rn:R07456','KEGG','RP10677',true).
concept_accession('9873: rn:R07456','KEGG','RP:RP10677',true).
concept_accession('9873: rn:R07456','KEGG','2.6.-.-',true).
concept_accession('9873: rn:R07456','KEGG','EC:2.6.-.-',true).
concept_accession('9873: rn:R07456','KEGG','R07456',true).
concept_accession('9873: rn:R07456','EC','2.6.-.-',false).
concept_accession('9873: rn:R07456','KEGG','RC01783',true).
concept_accession('9873: rn:R07456','KEGG','RN:R07456',true).
concept_accession('40002: rn:R08225','EC','1.14.14.1',true).
concept_accession('40002: rn:R08225','KEGG','24894',true).
concept_accession('40002: rn:R08225','KEGG','1.14.14.1',true).
concept_accession('40002: rn:R08225','KEGG','24299',true).
concept_accession('40002: rn:R08225','KEGG','24895',true).
concept_accession('40002: rn:R08225','KEGG','RNO:24299',true).
concept_accession('40002: rn:R08225','KEGG','RNO:24894',true).
concept_accession('40002: rn:R08225','KEGG','RNO:24895',true).
concept_accession('40002: rn:R08225','KEGG','EC:1.14.14.1',true).
concept_accession('40013: rn:R08227','KEGG','65135',true).
concept_accession('40013: rn:R08227','KEGG','RNO:65135',true).
concept_accession('40013: rn:R08227','EC','3.5.2.2',true).
concept_accession('40013: rn:R08227','KEGG','3.5.2.2',true).
concept_accession('40013: rn:R08227','KEGG','EC:3.5.2.2',true).
concept_accession('40012: rn:R01663','KEGG','EC:3.5.4.12',true).
concept_accession('40012: rn:R01663','KEGG','3.5.4.12',true).
concept_accession('40012: rn:R01663','KEGG','RNO:290741',true).
concept_accession('40012: rn:R01663','KEGG','290741',true).
concept_accession('40012: rn:R01663','EC','3.5.4.12',true).
concept_accession('40015: rn:R08230','KEGG','315219',true).
concept_accession('40015: rn:R08230','KEGG','EC:2.4.2.4',true).
concept_accession('40015: rn:R08230','EC','2.4.2.4',true).
concept_accession('40015: rn:R08230','KEGG','2.4.2.4',true).
concept_accession('40015: rn:R08230','KEGG','RNO:315219',true).
concept_accession('40014: rn:R08226','KEGG','RNO:81656',true).
concept_accession('40014: rn:R08226','KEGG','81656',true).
concept_accession('40014: rn:R08226','KEGG','1.3.1.2',true).
concept_accession('40014: rn:R08226','KEGG','EC:1.3.1.2',true).
concept_accession('40014: rn:R08226','EC','1.3.1.2',true).
concept_accession('40009: rn:R01666','EC','2.7.1.74',true).
concept_accession('40009: rn:R01666','KEGG','EC:2.7.1.74',true).
concept_accession('40009: rn:R01666','KEGG','79127',true).
concept_accession('40009: rn:R01666','KEGG','RNO:79127',true).
concept_accession('40009: rn:R01666','KEGG','2.7.1.74',true).
concept_accession('40008: rn:R08220','KEGG','3.1.1.1',true).
concept_accession('40008: rn:R08220','KEGG','EC:3.1.1.1',true).
concept_accession('40008: rn:R08220','KEGG','RNO:291863',true).
concept_accession('40008: rn:R08220','KEGG','RNO:29225',true).
concept_accession('40008: rn:R08220','KEGG','RNO:113902',true).
concept_accession('40008: rn:R08220','KEGG','113902',true).
concept_accession('40008: rn:R08220','KEGG','291863',true).
concept_accession('40008: rn:R08220','KEGG','RNO:307660',true).
concept_accession('40008: rn:R08220','KEGG','307660',true).
concept_accession('40008: rn:R08220','EC','3.1.1.1',true).
concept_accession('40008: rn:R08220','KEGG','29225',true).
concept_accession('40011: rn:R02100','EC','3.6.1.19',true).
concept_accession('40011: rn:R02100','KEGG','RNO:497778',true).
concept_accession('40011: rn:R02100','KEGG','EC:3.6.1.19',true).
concept_accession('40011: rn:R02100','KEGG','497778',true).
concept_accession('40011: rn:R02100','KEGG','3.6.1.19',true).
concept_accession('40010: rn:R08221','KEGG','3.5.4.5',true).
concept_accession('40010: rn:R08221','KEGG','EC:3.5.4.5',true).
concept_accession('40010: rn:R08221','EC','3.5.4.5',true).
concept_accession('40010: rn:R08221','KEGG','RNO:362638',true).
concept_accession('40010: rn:R08221','KEGG','362638',true).
concept_accession('39986: rn:R08243','EC','3.6.1.19',true).
concept_accession('39986: rn:R08243','KEGG','EC:3.6.1.19',true).
concept_accession('39986: rn:R08243','KEGG','RNO:311422',true).
concept_accession('39986: rn:R08243','KEGG','311422',true).
concept_accession('39986: rn:R08243','KEGG','3.6.1.19',true).
concept_accession('39987: rn:R01567','KEGG','RNO:291824',true).
concept_accession('39987: rn:R01567','KEGG','2.7.1.21',true).
concept_accession('39987: rn:R01567','KEGG','24834',true).
concept_accession('39987: rn:R01567','KEGG','291824',true).
concept_accession('39987: rn:R01567','EC','2.7.1.21',true).
concept_accession('39987: rn:R01567','KEGG','EC:2.7.1.21',true).
concept_accession('39987: rn:R01567','KEGG','RNO:24834',true).
concept_accession('9955: rn:R01355','KEGG','RP:RP10986',true).
concept_accession('9955: rn:R01355','KEGG','EC:4.1.3.32',true).
concept_accession('9955: rn:R01355','KEGG','R01355',true).
concept_accession('9955: rn:R01355','KEGG','RP10986',true).
concept_accession('9955: rn:R01355','KEGG','RN:R01355',true).
concept_accession('9955: rn:R01355','KEGG','RC:RC01810',true).
concept_accession('9955: rn:R01355','KEGG','RC:RC00286',true).
concept_accession('9955: rn:R01355','KEGG','RC01810',true).
concept_accession('9955: rn:R01355','KEGG','4.1.3.32',true).
concept_accession('9955: rn:R01355','KEGG','RP:RP10724',true).
concept_accession('9955: rn:R01355','KEGG','RP10724',true).
concept_accession('9955: rn:R01355','EC','4.1.3.32',false).
concept_accession('9955: rn:R01355','KEGG','RC00286',true).
concept_accession('39984: rn:R08250','KEGG','RNO:116631',true).
concept_accession('39984: rn:R08250','KEGG','290681',true).
concept_accession('39984: rn:R08250','KEGG','116631',true).
concept_accession('39984: rn:R08250','KEGG','RNO:290681',true).
concept_accession('39984: rn:R08250','KEGG','2.3.1.5',true).
concept_accession('39984: rn:R08250','KEGG','116632',true).
concept_accession('39984: rn:R08250','KEGG','RNO:116632',true).
concept_accession('39984: rn:R08250','KEGG','EC:2.3.1.5',true).
concept_accession('39984: rn:R08250','EC','2.3.1.5',true).
concept_accession('39985: rn:R01569','KEGG','RNO:313574',true).
concept_accession('39985: rn:R01569','KEGG','100363253',true).
concept_accession('39985: rn:R01569','KEGG','RNO:688261',true).
concept_accession('39985: rn:R01569','KEGG','RNO:287368',true).
concept_accession('39985: rn:R01569','KEGG','688261',true).
concept_accession('39985: rn:R01569','EC','3.1.3.5',true).
concept_accession('39985: rn:R01569','KEGG','313574',true).
concept_accession('39985: rn:R01569','KEGG','RNO:58813',true).
concept_accession('39985: rn:R01569','KEGG','287368',true).
concept_accession('39985: rn:R01569','KEGG','RNO:312373',true).
concept_accession('39985: rn:R01569','KEGG','3.1.3.5',true).
concept_accession('39985: rn:R01569','KEGG','RNO:100363253',true).
concept_accession('39985: rn:R01569','KEGG','RNO:298881',true).
concept_accession('39985: rn:R01569','KEGG','EC:3.1.3.5',true).
concept_accession('39985: rn:R01569','KEGG','298881',true).
concept_accession('39985: rn:R01569','KEGG','58813',true).
concept_accession('39985: rn:R01569','KEGG','312373',true).
concept_accession('39990: rn:R02098','KEGG','2.7.4.4',true).
concept_accession('39990: rn:R02098','KEGG','RNO:301622',true).
concept_accession('39990: rn:R02098','KEGG','301622',true).
concept_accession('39990: rn:R02098','KEGG','EC:2.7.4.4',true).
concept_accession('39990: rn:R02098','EC','2.7.4.4',true).
concept_accession('39991: rn:R02099','KEGG','RNO:291824',true).
concept_accession('39991: rn:R02099','KEGG','2.7.1.21',true).
concept_accession('39991: rn:R02099','KEGG','24834',true).
concept_accession('39991: rn:R02099','KEGG','291824',true).
concept_accession('39991: rn:R02099','EC','2.7.1.21',true).
concept_accession('39991: rn:R02099','KEGG','EC:2.7.1.21',true).
concept_accession('39991: rn:R02099','KEGG','RNO:24834',true).
concept_accession('39988: rn:R08235','KEGG','497811',true).
concept_accession('39988: rn:R08235','KEGG','1.17.3.2',true).
concept_accession('39988: rn:R08235','KEGG','EC:1.17.3.2',true).
concept_accession('39988: rn:R08235','EC','1.17.3.2',true).
concept_accession('39988: rn:R08235','KEGG','RNO:497811',true).
concept_accession('39989: rn:R02331','KEGG','171566',true).
concept_accession('39989: rn:R02331','KEGG','2.7.4.6',true).
concept_accession('39989: rn:R02331','KEGG','685679',true).
concept_accession('39989: rn:R02331','KEGG','83782',true).
concept_accession('39989: rn:R02331','KEGG','RNO:58964',true).
concept_accession('39989: rn:R02331','KEGG','RNO:83782',true).
concept_accession('39989: rn:R02331','KEGG','85269',true).
concept_accession('39989: rn:R02331','KEGG','RNO:685679',true).
concept_accession('39989: rn:R02331','KEGG','RNO:85269',true).
concept_accession('39989: rn:R02331','EC','2.7.4.6',true).
concept_accession('39989: rn:R02331','KEGG','EC:2.7.4.6',true).
concept_accession('39989: rn:R02331','KEGG','RNO:191575',true).
concept_accession('39989: rn:R02331','KEGG','191575',true).
concept_accession('39989: rn:R02331','KEGG','58964',true).
concept_accession('39989: rn:R02331','KEGG','RNO:171566',true).
concept_accession('39994: rn:R02484','KEGG','290029',true).
concept_accession('39994: rn:R02484','KEGG','EC:2.4.2.4',true).
concept_accession('39994: rn:R02484','EC','2.4.2.4',true).
concept_accession('39994: rn:R02484','KEGG','2.4.2.4',true).
concept_accession('39994: rn:R02484','KEGG','RNO:290029',true).
concept_accession('39995: rn:R08246','KEGG','RNO:690050',true).
concept_accession('39995: rn:R08246','KEGG','EC:2.1.1.67',true).
concept_accession('39995: rn:R08246','EC','2.1.1.67',true).
concept_accession('39995: rn:R08246','KEGG','690050',true).
concept_accession('39995: rn:R08246','KEGG','2.1.1.67',true).
concept_accession('39992: rn:R02485','KEGG','EC:3.5.4.14',true).
concept_accession('39992: rn:R02485','KEGG','RNO:362638',true).
concept_accession('39992: rn:R02485','KEGG','362638',true).
concept_accession('39992: rn:R02485','KEGG','3.5.4.14',true).
concept_accession('39992: rn:R02485','EC','3.5.4.14',true).
concept_accession('39993: rn:R08239','KEGG','RNO:690050',true).
concept_accession('39993: rn:R08239','KEGG','EC:2.1.1.67',true).
concept_accession('39993: rn:R08239','EC','2.1.1.67',true).
concept_accession('39993: rn:R08239','KEGG','690050',true).
concept_accession('39993: rn:R08239','KEGG','2.1.1.67',true).
concept_accession('39998: rn:R08236','KEGG','RNO:690050',true).
concept_accession('39998: rn:R08236','KEGG','EC:2.1.1.67',true).
concept_accession('39998: rn:R08236','EC','2.1.1.67',true).
concept_accession('39998: rn:R08236','KEGG','690050',true).
concept_accession('39998: rn:R08236','KEGG','2.1.1.67',true).
concept_accession('39999: rn:R02101','EC','2.1.1.45',true).
concept_accession('39999: rn:R02101','KEGG','RNO:29261',true).
concept_accession('39999: rn:R02101','KEGG','2.1.1.45',true).
concept_accession('39999: rn:R02101','KEGG','EC:2.1.1.45',true).
concept_accession('39999: rn:R02101','KEGG','29261',true).
concept_accession('39996: rn:R02484','KEGG','315219',true).
concept_accession('39996: rn:R02484','KEGG','EC:2.4.2.4',true).
concept_accession('39996: rn:R02484','EC','2.4.2.4',true).
concept_accession('39996: rn:R02484','KEGG','2.4.2.4',true).
concept_accession('39996: rn:R02484','KEGG','RNO:315219',true).
concept_accession('39997: rn:R02016','KEGG','297437',true).
concept_accession('39997: rn:R02016','KEGG','EC:1.8.1.9',true).
concept_accession('39997: rn:R02016','KEGG','RNO:50551',true).
concept_accession('39997: rn:R02016','KEGG','RNO:58819',true).
concept_accession('39997: rn:R02016','KEGG','50551',true).
concept_accession('39997: rn:R02016','KEGG','RNO:297437',true).
concept_accession('39997: rn:R02016','KEGG','58819',true).
concept_accession('39997: rn:R02016','EC','1.8.1.9',true).
concept_accession('39997: rn:R02016','KEGG','1.8.1.9',true).
concept_accession('39971: rn:R01570','KEGG','315219',true).
concept_accession('39971: rn:R01570','KEGG','EC:2.4.2.4',true).
concept_accession('39971: rn:R01570','EC','2.4.2.4',true).
concept_accession('39971: rn:R01570','KEGG','2.4.2.4',true).
concept_accession('39971: rn:R01570','KEGG','RNO:315219',true).
concept_accession('39970: rn:R01415','KEGG','RNO:81656',true).
concept_accession('39970: rn:R01415','KEGG','81656',true).
concept_accession('39970: rn:R01415','KEGG','1.3.1.2',true).
concept_accession('39970: rn:R01415','KEGG','EC:1.3.1.2',true).
concept_accession('39970: rn:R01415','EC','1.3.1.2',true).
concept_accession('39969: rn:R03055','KEGG','65135',true).
concept_accession('39969: rn:R03055','KEGG','RNO:65135',true).
concept_accession('39969: rn:R03055','EC','3.5.2.2',true).
concept_accession('39969: rn:R03055','KEGG','3.5.2.2',true).
concept_accession('39969: rn:R03055','KEGG','EC:3.5.2.2',true).
concept_accession('39968: rn:R00662','KEGG','3.6.1.8',true).
concept_accession('39968: rn:R00662','KEGG','RNO:311422',true).
concept_accession('39968: rn:R00662','KEGG','311422',true).
concept_accession('39968: rn:R00662','KEGG','EC:3.6.1.8',true).
concept_accession('39968: rn:R00662','EC','3.6.1.8',true).
concept_accession('39975: rn:R00378','KEGG','RNO:293144',true).
concept_accession('39975: rn:R00378','KEGG','RNO:289758',true).
concept_accession('39975: rn:R00378','KEGG','289758',true).
concept_accession('39975: rn:R00378','KEGG','299112',true).
concept_accession('39975: rn:R00378','KEGG','RNO:361698',true).
concept_accession('39975: rn:R00378','KEGG','246327',true).
concept_accession('39975: rn:R00378','KEGG','85241',true).
concept_accession('39975: rn:R00378','KEGG','85242',true).
concept_accession('39975: rn:R00378','KEGG','2.7.7.7',true).
concept_accession('39975: rn:R00378','KEGG','304573',true).
concept_accession('39975: rn:R00378','KEGG','59294',true).
concept_accession('39975: rn:R00378','KEGG','298098',true).
concept_accession('39975: rn:R00378','KEGG','RNO:85242',true).
concept_accession('39975: rn:R00378','KEGG','293144',true).
concept_accession('39975: rn:R00378','KEGG','362385',true).
concept_accession('39975: rn:R00378','KEGG','RNO:85241',true).
concept_accession('39975: rn:R00378','KEGG','EC:2.7.7.7',true).
concept_accession('39975: rn:R00378','KEGG','RNO:301323',true).
concept_accession('39975: rn:R00378','KEGG','RNO:298098',true).
concept_accession('39975: rn:R00378','KEGG','RNO:100362333',true).
concept_accession('39975: rn:R00378','KEGG','RNO:304573',true).
concept_accession('39975: rn:R00378','KEGG','361698',true).
concept_accession('39975: rn:R00378','KEGG','RNO:299112',true).
concept_accession('39975: rn:R00378','KEGG','RNO:246327',true).
concept_accession('39975: rn:R00378','KEGG','RNO:59294',true).
concept_accession('39975: rn:R00378','KEGG','100362333',true).
concept_accession('39975: rn:R00378','KEGG','RNO:362385',true).
concept_accession('39975: rn:R00378','EC','2.7.7.7',true).
concept_accession('39975: rn:R00378','KEGG','301323',true).
concept_accession('39974: rn:R08245','KEGG','EC:2.4.2.8',true).
concept_accession('39974: rn:R08245','EC','2.4.2.8',true).
concept_accession('39974: rn:R08245','KEGG','24465',true).
concept_accession('39974: rn:R08245','KEGG','2.4.2.8',true).
concept_accession('39974: rn:R08245','KEGG','RNO:24465',true).
concept_accession('39973: rn:R04666','EC','3.5.1.6',true).
concept_accession('39973: rn:R04666','KEGG','116593',true).
concept_accession('39973: rn:R04666','KEGG','EC:3.5.1.6',true).
concept_accession('39973: rn:R04666','KEGG','RNO:116593',true).
concept_accession('39973: rn:R04666','KEGG','3.5.1.6',true).
concept_accession('9975: rn:R04292','KEGG','RN:R04292',true).
concept_accession('9975: rn:R04292','KEGG','RP:RP03923',true).
concept_accession('9975: rn:R04292','KEGG','RC01119',true).
concept_accession('9975: rn:R04292','KEGG','R04292',true).
concept_accession('9975: rn:R04292','KEGG','RC:RC01119',true).
concept_accession('9975: rn:R04292','KEGG','RP03923',true).
concept_accession('39972: rn:R01868','EC','1.3.5.2',true).
concept_accession('39972: rn:R01868','KEGG','RNO:65156',true).
concept_accession('39972: rn:R01868','KEGG','EC:1.3.5.2',true).
concept_accession('39972: rn:R01868','KEGG','65156',true).
concept_accession('39972: rn:R01868','KEGG','1.3.5.2',true).
concept_accession('39979: rn:R02095','KEGG','316077',true).
concept_accession('39979: rn:R02095','KEGG','64519',true).
concept_accession('39979: rn:R02095','KEGG','RNO:613267',true).
concept_accession('39979: rn:R02095','KEGG','RNO:64519',true).
concept_accession('39979: rn:R02095','KEGG','EC:3.6.1.39',true).
concept_accession('39979: rn:R02095','KEGG','3.6.1.39',true).
concept_accession('39979: rn:R02095','KEGG','613267',true).
concept_accession('39979: rn:R02095','KEGG','RNO:316077',true).
concept_accession('39979: rn:R02095','EC','3.6.1.39',true).
concept_accession('39978: rn:R08238','KEGG','EC:2.4.2.8',true).
concept_accession('39978: rn:R08238','EC','2.4.2.8',true).
concept_accession('39978: rn:R08238','KEGG','24465',true).
concept_accession('39978: rn:R08238','KEGG','2.4.2.8',true).
concept_accession('39978: rn:R08238','KEGG','RNO:24465',true).
concept_accession('39977: rn:R02093','KEGG','171566',true).
concept_accession('39977: rn:R02093','KEGG','2.7.4.6',true).
concept_accession('39977: rn:R02093','KEGG','685679',true).
concept_accession('39977: rn:R02093','KEGG','83782',true).
concept_accession('39977: rn:R02093','KEGG','RNO:58964',true).
concept_accession('39977: rn:R02093','KEGG','RNO:83782',true).
concept_accession('39977: rn:R02093','KEGG','85269',true).
concept_accession('39977: rn:R02093','KEGG','RNO:685679',true).
concept_accession('39977: rn:R02093','KEGG','RNO:85269',true).
concept_accession('39977: rn:R02093','EC','2.7.4.6',true).
concept_accession('39977: rn:R02093','KEGG','EC:2.7.4.6',true).
concept_accession('39977: rn:R02093','KEGG','RNO:191575',true).
concept_accession('39977: rn:R02093','KEGG','191575',true).
concept_accession('39977: rn:R02093','KEGG','58964',true).
concept_accession('39977: rn:R02093','KEGG','RNO:171566',true).
concept_accession('39976: rn:R08244','KEGG','EC:6.3.5.2',true).
concept_accession('39976: rn:R08244','EC','6.3.5.2',true).
concept_accession('39976: rn:R08244','KEGG','RNO:295088',true).
concept_accession('39976: rn:R08244','KEGG','295088',true).
concept_accession('39976: rn:R08244','KEGG','6.3.5.2',true).
concept_accession('39983: rn:R02092','KEGG','316077',true).
concept_accession('39983: rn:R02092','KEGG','64519',true).
concept_accession('39983: rn:R02092','KEGG','RNO:613267',true).
concept_accession('39983: rn:R02092','KEGG','3.6.1.5',true).
concept_accession('39983: rn:R02092','KEGG','RNO:64519',true).
concept_accession('39983: rn:R02092','KEGG','EC:3.6.1.5',true).
concept_accession('39983: rn:R02092','EC','3.6.1.5',true).
concept_accession('39983: rn:R02092','KEGG','613267',true).
concept_accession('39983: rn:R02092','KEGG','RNO:316077',true).
concept_accession('39982: rn:R08248','KEGG','RNO:116631',true).
concept_accession('39982: rn:R08248','KEGG','290681',true).
concept_accession('39982: rn:R08248','KEGG','116631',true).
concept_accession('39982: rn:R08248','KEGG','RNO:290681',true).
concept_accession('39982: rn:R08248','KEGG','2.3.1.5',true).
concept_accession('39982: rn:R08248','KEGG','116632',true).
concept_accession('39982: rn:R08248','KEGG','RNO:116632',true).
concept_accession('39982: rn:R08248','KEGG','EC:2.3.1.5',true).
concept_accession('39982: rn:R08248','EC','2.3.1.5',true).
concept_accession('39981: rn:R02094','KEGG','RNO:301622',true).
concept_accession('39981: rn:R02094','KEGG','EC:2.7.4.9',true).
concept_accession('39981: rn:R02094','EC','2.7.4.9',true).
concept_accession('39981: rn:R02094','KEGG','2.7.4.9',true).
concept_accession('39981: rn:R02094','KEGG','301622',true).
concept_accession('39980: rn:R08237','KEGG','EC:2.4.2.8',true).
concept_accession('39980: rn:R08237','EC','2.4.2.8',true).
concept_accession('39980: rn:R08237','KEGG','24465',true).
concept_accession('39980: rn:R08237','KEGG','2.4.2.8',true).
concept_accession('39980: rn:R08237','KEGG','RNO:24465',true).
concept_accession('9923: rn:R01147','KEGG','RP:RP00171',true).
concept_accession('9923: rn:R01147','KEGG','RC:RC00048',true).
concept_accession('9923: rn:R01147','KEGG','RC:RC00008',true).
concept_accession('9923: rn:R01147','KEGG','RP:RP00131',true).
concept_accession('9923: rn:R01147','KEGG','RP00171',true).
concept_accession('9923: rn:R01147','KEGG','RC00048',true).
concept_accession('9923: rn:R01147','KEGG','2.6.1.54',true).
concept_accession('9923: rn:R01147','KEGG','R01147',true).
concept_accession('9923: rn:R01147','KEGG','EC:2.6.1.54',true).
concept_accession('9923: rn:R01147','EC','2.6.1.54',false).
concept_accession('9923: rn:R01147','KEGG','RC00008',true).
concept_accession('9923: rn:R01147','KEGG','RP00131',true).
concept_accession('9923: rn:R01147','KEGG','RN:R01147',true).
concept_accession('39952: rn:R08327','EC','1.14.14.1',true).
concept_accession('39952: rn:R08327','KEGG','24894',true).
concept_accession('39952: rn:R08327','KEGG','1.14.14.1',true).
concept_accession('39952: rn:R08327','KEGG','24299',true).
concept_accession('39952: rn:R08327','KEGG','24895',true).
concept_accession('39952: rn:R08327','KEGG','RNO:24299',true).
concept_accession('39952: rn:R08327','KEGG','RNO:24894',true).
concept_accession('39952: rn:R08327','KEGG','RNO:24895',true).
concept_accession('39952: rn:R08327','KEGG','EC:1.14.14.1',true).
concept_accession('39953: rn:R08312','EC','1.14.14.1',true).
concept_accession('39953: rn:R08312','KEGG','RNO:100364896',true).
concept_accession('39953: rn:R08312','KEGG','171518',true).
concept_accession('39953: rn:R08312','KEGG','246070',true).
concept_accession('39953: rn:R08312','KEGG','100364896',true).
concept_accession('39953: rn:R08312','KEGG','29277',true).
concept_accession('39953: rn:R08312','KEGG','RNO:29298',true).
concept_accession('39953: rn:R08312','KEGG','171521',true).
concept_accession('39953: rn:R08312','KEGG','RNO:293989',true).
concept_accession('39953: rn:R08312','KEGG','29298',true).
concept_accession('39953: rn:R08312','KEGG','RNO:246070',true).
concept_accession('39953: rn:R08312','KEGG','EC:1.14.14.1',true).
concept_accession('39953: rn:R08312','KEGG','RNO:83790',true).
concept_accession('39953: rn:R08312','KEGG','293989',true).
concept_accession('39953: rn:R08312','KEGG','RNO:29277',true).
concept_accession('39953: rn:R08312','KEGG','RNO:687842',true).
concept_accession('39953: rn:R08312','KEGG','687842',true).
concept_accession('39953: rn:R08312','KEGG','1.14.14.1',true).
concept_accession('39953: rn:R08312','KEGG','RNO:171521',true).
concept_accession('39953: rn:R08312','KEGG','RNO:171518',true).
concept_accession('39953: rn:R08312','KEGG','25011',true).
concept_accession('39953: rn:R08312','KEGG','RNO:25011',true).
concept_accession('39953: rn:R08312','KEGG','83790',true).
concept_accession('9921: rn:R01580','KEGG','RP:RP00171',true).
concept_accession('9921: rn:R01580','KEGG','RC:RC00048',true).
concept_accession('9921: rn:R01580','KEGG','RC00006',true).
concept_accession('9921: rn:R01580','KEGG','RC:RC00006',true).
concept_accession('9921: rn:R01580','KEGG','RN:R01580',true).
concept_accession('9921: rn:R01580','KEGG','RP00171',true).
concept_accession('9921: rn:R01580','KEGG','RC00048',true).
concept_accession('9921: rn:R01580','KEGG','2.6.1.54',true).
concept_accession('9921: rn:R01580','KEGG','EC:2.6.1.54',true).
concept_accession('9921: rn:R01580','EC','2.6.1.54',false).
concept_accession('9921: rn:R01580','KEGG','R01580',true).
concept_accession('9921: rn:R01580','KEGG','RP00084',true).
concept_accession('9921: rn:R01580','KEGG','RP:RP00084',true).
concept_accession('39954: rn:R08313','KEGG','361523',true).
concept_accession('39954: rn:R08313','EC','1.14.14.1',true).
concept_accession('39954: rn:R08313','KEGG','RNO:361523',true).
concept_accession('39954: rn:R08313','KEGG','29295',true).
concept_accession('39954: rn:R08313','KEGG','RNO:292728',true).
concept_accession('39954: rn:R08313','KEGG','RNO:24300',true).
concept_accession('39954: rn:R08313','KEGG','RNO:286953',true).
concept_accession('39954: rn:R08313','KEGG','RNO:29295',true).
concept_accession('39954: rn:R08313','KEGG','EC:1.14.14.1',true).
concept_accession('39954: rn:R08313','KEGG','1.14.14.1',true).
concept_accession('39954: rn:R08313','KEGG','286953',true).
concept_accession('39954: rn:R08313','KEGG','292728',true).
concept_accession('39954: rn:R08313','KEGG','24300',true).
concept_accession('39955: rn:R07977','KEGG','497811',true).
concept_accession('39955: rn:R07977','KEGG','1.17.3.2',true).
concept_accession('39955: rn:R07977','KEGG','EC:1.17.3.2',true).
concept_accession('39955: rn:R07977','EC','1.17.3.2',true).
concept_accession('39955: rn:R07977','KEGG','RNO:497811',true).
concept_accession('39956: rn:R07939','EC','1.14.14.1',true).
concept_accession('39956: rn:R07939','KEGG','1.14.14.1',true).
concept_accession('39956: rn:R07939','KEGG','24297',true).
concept_accession('39956: rn:R07939','KEGG','RNO:24297',true).
concept_accession('39956: rn:R07939','KEGG','EC:1.14.14.1',true).
concept_accession('39957: rn:R08318','EC','1.14.14.1',true).
concept_accession('39957: rn:R08318','KEGG','1.14.14.1',true).
concept_accession('39957: rn:R08318','KEGG','25642',true).
concept_accession('39957: rn:R08318','KEGG','RNO:25642',true).
concept_accession('39957: rn:R08318','KEGG','RNO:171352',true).
concept_accession('39957: rn:R08318','KEGG','171352',true).
concept_accession('39957: rn:R08318','KEGG','266682',true).
concept_accession('39957: rn:R08318','KEGG','252931',true).
concept_accession('39957: rn:R08318','KEGG','RNO:266682',true).
concept_accession('39957: rn:R08318','KEGG','RNO:252931',true).
concept_accession('39957: rn:R08318','KEGG','EC:1.14.14.1',true).
concept_accession('39958: rn:R08313','EC','1.14.14.1',true).
concept_accession('39958: rn:R08313','KEGG','1.14.14.1',true).
concept_accession('39958: rn:R08313','KEGG','25642',true).
concept_accession('39958: rn:R08313','KEGG','RNO:25642',true).
concept_accession('39958: rn:R08313','KEGG','RNO:171352',true).
concept_accession('39958: rn:R08313','KEGG','171352',true).
concept_accession('39958: rn:R08313','KEGG','266682',true).
concept_accession('39958: rn:R08313','KEGG','252931',true).
concept_accession('39958: rn:R08313','KEGG','RNO:266682',true).
concept_accession('39958: rn:R08313','KEGG','RNO:252931',true).
concept_accession('39958: rn:R08313','KEGG','EC:1.14.14.1',true).
concept_accession('39959: rn:R08285','EC','1.14.14.1',true).
concept_accession('39959: rn:R08285','KEGG','RNO:100364896',true).
concept_accession('39959: rn:R08285','KEGG','171518',true).
concept_accession('39959: rn:R08285','KEGG','246070',true).
concept_accession('39959: rn:R08285','KEGG','100364896',true).
concept_accession('39959: rn:R08285','KEGG','29277',true).
concept_accession('39959: rn:R08285','KEGG','RNO:29298',true).
concept_accession('39959: rn:R08285','KEGG','171521',true).
concept_accession('39959: rn:R08285','KEGG','RNO:293989',true).
concept_accession('39959: rn:R08285','KEGG','29298',true).
concept_accession('39959: rn:R08285','KEGG','RNO:246070',true).
concept_accession('39959: rn:R08285','KEGG','EC:1.14.14.1',true).
concept_accession('39959: rn:R08285','KEGG','RNO:83790',true).
concept_accession('39959: rn:R08285','KEGG','293989',true).
concept_accession('39959: rn:R08285','KEGG','RNO:29277',true).
concept_accession('39959: rn:R08285','KEGG','RNO:687842',true).
concept_accession('39959: rn:R08285','KEGG','687842',true).
concept_accession('39959: rn:R08285','KEGG','1.14.14.1',true).
concept_accession('39959: rn:R08285','KEGG','RNO:171521',true).
concept_accession('39959: rn:R08285','KEGG','RNO:171518',true).
concept_accession('39959: rn:R08285','KEGG','25011',true).
concept_accession('39959: rn:R08285','KEGG','RNO:25011',true).
concept_accession('39959: rn:R08285','KEGG','83790',true).
concept_accession('39960: rn:R08263','KEGG','396551',true).
concept_accession('39960: rn:R08263','KEGG','2.4.1.17',true).
concept_accession('39960: rn:R08263','KEGG','154516',true).
concept_accession('39960: rn:R08263','KEGG','396552',true).
concept_accession('39960: rn:R08263','KEGG','RNO:305264',true).
concept_accession('39960: rn:R08263','KEGG','289533',true).
concept_accession('39960: rn:R08263','KEGG','RNO:396527',true).
concept_accession('39960: rn:R08263','KEGG','574523',true).
concept_accession('39960: rn:R08263','KEGG','396527',true).
concept_accession('39960: rn:R08263','KEGG','EC:2.4.1.17',true).
concept_accession('39960: rn:R08263','KEGG','113992',true).
concept_accession('39960: rn:R08263','KEGG','RNO:574523',true).
concept_accession('39960: rn:R08263','KEGG','RNO:266685',true).
concept_accession('39960: rn:R08263','KEGG','RNO:24861',true).
concept_accession('39960: rn:R08263','KEGG','266685',true).
concept_accession('39960: rn:R08263','KEGG','RNO:24862',true).
concept_accession('39960: rn:R08263','KEGG','29623',true).
concept_accession('39960: rn:R08263','KEGG','RNO:289533',true).
concept_accession('39960: rn:R08263','KEGG','305264',true).
concept_accession('39960: rn:R08263','KEGG','RNO:83808',true).
concept_accession('39960: rn:R08263','KEGG','RNO:301595',true).
concept_accession('39960: rn:R08263','KEGG','RNO:29623',true).
concept_accession('39960: rn:R08263','KEGG','RNO:154516',true).
concept_accession('39960: rn:R08263','KEGG','301595',true).
concept_accession('39960: rn:R08263','KEGG','RNO:396552',true).
concept_accession('39960: rn:R08263','KEGG','RNO:396551',true).
concept_accession('39960: rn:R08263','KEGG','RNO:286954',true).
concept_accession('39960: rn:R08263','KEGG','RNO:113992',true).
concept_accession('39960: rn:R08263','KEGG','RNO:63867',true).
concept_accession('39960: rn:R08263','KEGG','286954',true).
concept_accession('39960: rn:R08263','KEGG','83808',true).
concept_accession('39960: rn:R08263','KEGG','24861',true).
concept_accession('39960: rn:R08263','KEGG','63867',true).
concept_accession('39960: rn:R08263','EC','2.4.1.17',true).
concept_accession('39960: rn:R08263','KEGG','24862',true).
concept_accession('39961: rn:R07979','KEGG','497811',true).
concept_accession('39961: rn:R07979','KEGG','1.17.3.2',true).
concept_accession('39961: rn:R07979','KEGG','EC:1.17.3.2',true).
concept_accession('39961: rn:R07979','EC','1.17.3.2',true).
concept_accession('39961: rn:R07979','KEGG','RNO:497811',true).
concept_accession('39962: rn:R08255','KEGG','RNO:171118',true).
concept_accession('39962: rn:R08255','KEGG','3.1.1.1',true).
concept_accession('39962: rn:R08255','KEGG','246252',true).
concept_accession('39962: rn:R08255','KEGG','RNO:29225',true).
concept_accession('39962: rn:R08255','KEGG','RNO:113902',true).
concept_accession('39962: rn:R08255','KEGG','RNO:498940',true).
concept_accession('39962: rn:R08255','EC','3.1.1.1',true).
concept_accession('39962: rn:R08255','KEGG','RNO:307660',true).
concept_accession('39962: rn:R08255','KEGG','29225',true).
concept_accession('39962: rn:R08255','KEGG','498940',true).
concept_accession('39962: rn:R08255','KEGG','EC:3.1.1.1',true).
concept_accession('39962: rn:R08255','KEGG','RNO:291863',true).
concept_accession('39962: rn:R08255','KEGG','RNO:246252',true).
concept_accession('39962: rn:R08255','KEGG','291863',true).
concept_accession('39962: rn:R08255','KEGG','113902',true).
concept_accession('39962: rn:R08255','KEGG','307660',true).
concept_accession('39962: rn:R08255','KEGG','171118',true).
concept_accession('39963: rn:R02100','EC','3.6.1.19',true).
concept_accession('39963: rn:R02100','KEGG','EC:3.6.1.19',true).
concept_accession('39963: rn:R02100','KEGG','RNO:311422',true).
concept_accession('39963: rn:R02100','KEGG','311422',true).
concept_accession('39963: rn:R02100','KEGG','3.6.1.19',true).
concept_accession('39964: rn:R08260','EC','3.2.1.31',true).
concept_accession('39964: rn:R08260','KEGG','24434',true).
concept_accession('39964: rn:R08260','KEGG','EC:3.2.1.31',true).
concept_accession('39964: rn:R08260','KEGG','3.2.1.31',true).
concept_accession('39964: rn:R08260','KEGG','RNO:24434',true).
concept_accession('39965: rn:R00969','EC','3.6.1.17',true).
concept_accession('39965: rn:R00969','KEGG','RNO:297998',true).
concept_accession('39965: rn:R00969','KEGG','EC:3.6.1.17',true).
concept_accession('39965: rn:R00969','KEGG','297998',true).
concept_accession('39965: rn:R00969','KEGG','3.6.1.17',true).
concept_accession('39966: rn:R08258','KEGG','RNO:171118',true).
concept_accession('39966: rn:R08258','KEGG','498940',true).
concept_accession('39966: rn:R08258','KEGG','3.1.1.1',true).
concept_accession('39966: rn:R08258','KEGG','EC:3.1.1.1',true).
concept_accession('39966: rn:R08258','KEGG','246252',true).
concept_accession('39966: rn:R08258','KEGG','RNO:246252',true).
concept_accession('39966: rn:R08258','KEGG','RNO:498940',true).
concept_accession('39966: rn:R08258','EC','3.1.1.1',true).
concept_accession('39966: rn:R08258','KEGG','171118',true).
concept_accession('1197: rn:R07496','KEGG','RN:R07496',true).
concept_accession('1197: rn:R07496','KEGG','R07496',true).
concept_accession('1197: rn:R07496','KEGG','RC01867',true).
concept_accession('1197: rn:R07496','KEGG','RP11538',true).
concept_accession('1197: rn:R07496','KEGG','RC:RC01867',true).
concept_accession('1197: rn:R07496','KEGG','RP:RP11538',true).
concept_accession('39967: rn:R00965','EC','4.1.1.23',true).
concept_accession('39967: rn:R00965','KEGG','4.1.1.23',true).
concept_accession('39967: rn:R00965','KEGG','288051',true).
concept_accession('39967: rn:R00965','KEGG','EC:4.1.1.23',true).
concept_accession('39967: rn:R00965','KEGG','RNO:288051',true).
concept_accession('39937: rn:R08303','EC','1.14.14.1',true).
concept_accession('39937: rn:R08303','KEGG','RNO:25086',true).
concept_accession('39937: rn:R08303','KEGG','1.14.14.1',true).
concept_accession('39937: rn:R08303','KEGG','25086',true).
concept_accession('39937: rn:R08303','KEGG','EC:1.14.14.1',true).
concept_accession('39936: rn:R08304','EC','1.14.14.1',true).
concept_accession('39936: rn:R08304','KEGG','RNO:25086',true).
concept_accession('39936: rn:R08304','KEGG','1.14.14.1',true).
concept_accession('39936: rn:R08304','KEGG','25086',true).
concept_accession('39936: rn:R08304','KEGG','EC:1.14.14.1',true).
concept_accession('39939: rn:R00575','KEGG','EC:6.3.5.5',true).
concept_accession('39939: rn:R00575','KEGG','RNO:24240',true).
concept_accession('39939: rn:R00575','EC','6.3.5.5',true).
concept_accession('39939: rn:R00575','KEGG','24240',true).
concept_accession('39939: rn:R00575','KEGG','6.3.5.5',true).
concept_accession('39938: rn:R08303','EC','1.14.14.1',true).
concept_accession('39938: rn:R08303','KEGG','1.14.14.1',true).
concept_accession('39938: rn:R08303','KEGG','25642',true).
concept_accession('39938: rn:R08303','KEGG','RNO:25642',true).
concept_accession('39938: rn:R08303','KEGG','RNO:171352',true).
concept_accession('39938: rn:R08303','KEGG','171352',true).
concept_accession('39938: rn:R08303','KEGG','266682',true).
concept_accession('39938: rn:R08303','KEGG','252931',true).
concept_accession('39938: rn:R08303','KEGG','RNO:266682',true).
concept_accession('39938: rn:R08303','KEGG','RNO:252931',true).
concept_accession('39938: rn:R08303','KEGG','EC:1.14.14.1',true).
concept_accession('39941: rn:R02018','EC','1.17.4.1',true).
concept_accession('39941: rn:R02018','KEGG','362720',true).
concept_accession('39941: rn:R02018','KEGG','RNO:100359539',true).
concept_accession('39941: rn:R02018','KEGG','RNO:685579',true).
concept_accession('39941: rn:R02018','KEGG','1.17.4.1',true).
concept_accession('39941: rn:R02018','KEGG','100359539',true).
concept_accession('39941: rn:R02018','KEGG','EC:1.17.4.1',true).
concept_accession('39941: rn:R02018','KEGG','685579',true).
concept_accession('39941: rn:R02018','KEGG','299976',true).
concept_accession('39941: rn:R02018','KEGG','RNO:299976',true).
concept_accession('39941: rn:R02018','KEGG','RNO:362720',true).
concept_accession('39940: rn:R08304','EC','1.14.14.1',true).
concept_accession('39940: rn:R08304','KEGG','1.14.14.1',true).
concept_accession('39940: rn:R08304','KEGG','25642',true).
concept_accession('39940: rn:R08304','KEGG','RNO:25642',true).
concept_accession('39940: rn:R08304','KEGG','RNO:171352',true).
concept_accession('39940: rn:R08304','KEGG','171352',true).
concept_accession('39940: rn:R08304','KEGG','266682',true).
concept_accession('39940: rn:R08304','KEGG','252931',true).
concept_accession('39940: rn:R08304','KEGG','RNO:266682',true).
concept_accession('39940: rn:R08304','KEGG','RNO:252931',true).
concept_accession('39940: rn:R08304','KEGG','EC:1.14.14.1',true).
concept_accession('39943: rn:R08349','KEGG','RNO:316421',true).
concept_accession('39943: rn:R08349','KEGG','RNO:54349',true).
concept_accession('39943: rn:R08349','EC','1.2.3.1',true).
concept_accession('39943: rn:R08349','KEGG','EC:1.2.3.1',true).
concept_accession('39943: rn:R08349','KEGG','54349',true).
concept_accession('39943: rn:R08349','KEGG','316421',true).
concept_accession('39943: rn:R08349','KEGG','1.2.3.1',true).
concept_accession('39942: rn:R08348','KEGG','29253',true).
concept_accession('39942: rn:R08348','KEGG','RNO:29253',true).
concept_accession('39942: rn:R08348','KEGG','25750',true).
concept_accession('39942: rn:R08348','KEGG','RNO:25750',true).
concept_accession('39942: rn:R08348','KEGG','EC:1.4.3.4',true).
concept_accession('39942: rn:R08348','EC','1.4.3.4',true).
concept_accession('39942: rn:R08348','KEGG','1.4.3.4',true).
concept_accession('39945: rn:R08347','KEGG','29253',true).
concept_accession('39945: rn:R08347','KEGG','RNO:29253',true).
concept_accession('39945: rn:R08347','KEGG','25750',true).
concept_accession('39945: rn:R08347','KEGG','RNO:25750',true).
concept_accession('39945: rn:R08347','KEGG','EC:1.4.3.4',true).
concept_accession('39945: rn:R08347','EC','1.4.3.4',true).
concept_accession('39945: rn:R08347','KEGG','1.4.3.4',true).
concept_accession('39944: rn:R08346','KEGG','29253',true).
concept_accession('39944: rn:R08346','KEGG','RNO:29253',true).
concept_accession('39944: rn:R08346','KEGG','25750',true).
concept_accession('39944: rn:R08346','KEGG','RNO:25750',true).
concept_accession('39944: rn:R08346','KEGG','EC:1.4.3.4',true).
concept_accession('39944: rn:R08346','EC','1.4.3.4',true).
concept_accession('39944: rn:R08346','KEGG','1.4.3.4',true).
concept_accession('39947: rn:R08343','EC','1.14.14.1',true).
concept_accession('39947: rn:R08343','KEGG','RNO:100364896',true).
concept_accession('39947: rn:R08343','KEGG','171518',true).
concept_accession('39947: rn:R08343','KEGG','246070',true).
concept_accession('39947: rn:R08343','KEGG','100364896',true).
concept_accession('39947: rn:R08343','KEGG','29277',true).
concept_accession('39947: rn:R08343','KEGG','RNO:29298',true).
concept_accession('39947: rn:R08343','KEGG','171521',true).
concept_accession('39947: rn:R08343','KEGG','RNO:293989',true).
concept_accession('39947: rn:R08343','KEGG','29298',true).
concept_accession('39947: rn:R08343','KEGG','RNO:246070',true).
concept_accession('39947: rn:R08343','KEGG','EC:1.14.14.1',true).
concept_accession('39947: rn:R08343','KEGG','RNO:83790',true).
concept_accession('39947: rn:R08343','KEGG','293989',true).
concept_accession('39947: rn:R08343','KEGG','RNO:29277',true).
concept_accession('39947: rn:R08343','KEGG','RNO:687842',true).
concept_accession('39947: rn:R08343','KEGG','687842',true).
concept_accession('39947: rn:R08343','KEGG','1.14.14.1',true).
concept_accession('39947: rn:R08343','KEGG','RNO:171521',true).
concept_accession('39947: rn:R08343','KEGG','RNO:171518',true).
concept_accession('39947: rn:R08343','KEGG','25011',true).
concept_accession('39947: rn:R08343','KEGG','RNO:25011',true).
concept_accession('39947: rn:R08343','KEGG','83790',true).
concept_accession('39946: rn:R08345','EC','1.14.14.1',true).
concept_accession('39946: rn:R08345','KEGG','RNO:25053',true).
concept_accession('39946: rn:R08345','KEGG','171522',true).
concept_accession('39946: rn:R08345','KEGG','RNO:24303',true).
concept_accession('39946: rn:R08345','KEGG','RNO:286963',true).
concept_accession('39946: rn:R08345','KEGG','25053',true).
concept_accession('39946: rn:R08345','KEGG','EC:1.14.14.1',true).
concept_accession('39946: rn:R08345','KEGG','286963',true).
concept_accession('39946: rn:R08345','KEGG','1.14.14.1',true).
concept_accession('39946: rn:R08345','KEGG','RNO:171522',true).
concept_accession('39946: rn:R08345','KEGG','RNO:266684',true).
concept_accession('39946: rn:R08345','KEGG','266684',true).
concept_accession('39946: rn:R08345','KEGG','24303',true).
concept_accession('39949: rn:R08343','EC','1.14.14.1',true).
concept_accession('39949: rn:R08343','KEGG','RNO:25053',true).
concept_accession('39949: rn:R08343','KEGG','171522',true).
concept_accession('39949: rn:R08343','KEGG','RNO:24303',true).
concept_accession('39949: rn:R08343','KEGG','RNO:286963',true).
concept_accession('39949: rn:R08343','KEGG','25053',true).
concept_accession('39949: rn:R08343','KEGG','EC:1.14.14.1',true).
concept_accession('39949: rn:R08343','KEGG','286963',true).
concept_accession('39949: rn:R08343','KEGG','1.14.14.1',true).
concept_accession('39949: rn:R08343','KEGG','RNO:171522',true).
concept_accession('39949: rn:R08343','KEGG','RNO:266684',true).
concept_accession('39949: rn:R08343','KEGG','266684',true).
concept_accession('39949: rn:R08343','KEGG','24303',true).
concept_accession('39948: rn:R08344','EC','1.14.14.1',true).
concept_accession('39948: rn:R08344','KEGG','RNO:25053',true).
concept_accession('39948: rn:R08344','KEGG','171522',true).
concept_accession('39948: rn:R08344','KEGG','RNO:24303',true).
concept_accession('39948: rn:R08344','KEGG','RNO:286963',true).
concept_accession('39948: rn:R08344','KEGG','25053',true).
concept_accession('39948: rn:R08344','KEGG','EC:1.14.14.1',true).
concept_accession('39948: rn:R08344','KEGG','286963',true).
concept_accession('39948: rn:R08344','KEGG','1.14.14.1',true).
concept_accession('39948: rn:R08344','KEGG','RNO:171522',true).
concept_accession('39948: rn:R08344','KEGG','RNO:266684',true).
concept_accession('39948: rn:R08344','KEGG','266684',true).
concept_accession('39948: rn:R08344','KEGG','24303',true).
concept_accession('39951: rn:R08342','EC','1.14.14.1',true).
concept_accession('39951: rn:R08342','KEGG','1.14.14.1',true).
concept_accession('39951: rn:R08342','KEGG','25642',true).
concept_accession('39951: rn:R08342','KEGG','RNO:25642',true).
concept_accession('39951: rn:R08342','KEGG','RNO:171352',true).
concept_accession('39951: rn:R08342','KEGG','171352',true).
concept_accession('39951: rn:R08342','KEGG','266682',true).
concept_accession('39951: rn:R08342','KEGG','252931',true).
concept_accession('39951: rn:R08342','KEGG','RNO:266682',true).
concept_accession('39951: rn:R08342','KEGG','RNO:252931',true).
concept_accession('39951: rn:R08342','KEGG','EC:1.14.14.1',true).
concept_accession('39950: rn:R08340','EC','1.14.14.1',true).
concept_accession('39950: rn:R08340','KEGG','1.14.14.1',true).
concept_accession('39950: rn:R08340','KEGG','25642',true).
concept_accession('39950: rn:R08340','KEGG','RNO:25642',true).
concept_accession('39950: rn:R08340','KEGG','RNO:171352',true).
concept_accession('39950: rn:R08340','KEGG','171352',true).
concept_accession('39950: rn:R08340','KEGG','266682',true).
concept_accession('39950: rn:R08340','KEGG','252931',true).
concept_accession('39950: rn:R08340','KEGG','RNO:266682',true).
concept_accession('39950: rn:R08340','KEGG','RNO:252931',true).
concept_accession('39950: rn:R08340','KEGG','EC:1.14.14.1',true).
concept_accession('40428: rn:R04355','KEGG','2.3.1.180',true).
concept_accession('40428: rn:R04355','KEGG','RNO:289934',true).
concept_accession('40428: rn:R04355','EC','2.3.1.180',true).
concept_accession('40428: rn:R04355','KEGG','EC:2.3.1.180',true).
concept_accession('40428: rn:R04355','KEGG','289934',true).
concept_accession('40429: rn:R04739','KEGG','RNO:170670',true).
concept_accession('40429: rn:R04739','KEGG','170670',true).
concept_accession('40429: rn:R04739','KEGG','1.1.1.211',true).
concept_accession('40429: rn:R04739','EC','1.1.1.211',true).
concept_accession('40429: rn:R04739','KEGG','EC:1.1.1.211',true).
concept_accession('40430: rn:R03858','KEGG','EC:2.3.1.16',true).
concept_accession('40430: rn:R03858','KEGG','RNO:171155',true).
concept_accession('40430: rn:R03858','KEGG','171155',true).
concept_accession('40430: rn:R03858','KEGG','2.3.1.16',true).
concept_accession('40430: rn:R03858','EC','2.3.1.16',true).
concept_accession('40430: rn:R03858','KEGG','RNO:170465',true).
concept_accession('40430: rn:R03858','KEGG','170465',true).
concept_accession('40431: rn:R03856','KEGG','RNO:29470',true).
concept_accession('40431: rn:R03856','KEGG','29470',true).
concept_accession('40431: rn:R03856','KEGG','1.3.1.8',true).
concept_accession('40431: rn:R03856','KEGG','EC:1.3.1.8',true).
concept_accession('40431: rn:R03856','EC','1.3.1.8',true).
concept_accession('40424: rn:R01177','KEGG','EC:2.3.1.16',true).
concept_accession('40424: rn:R01177','KEGG','RNO:171155',true).
concept_accession('40424: rn:R01177','KEGG','171155',true).
concept_accession('40424: rn:R01177','KEGG','2.3.1.16',true).
concept_accession('40424: rn:R01177','EC','2.3.1.16',true).
concept_accession('40424: rn:R01177','KEGG','RNO:170465',true).
concept_accession('40424: rn:R01177','KEGG','170465',true).
concept_accession('40425: rn:R01274','KEGG','RNO:29411',true).
concept_accession('40425: rn:R01274','KEGG','29411',true).
concept_accession('40425: rn:R01274','KEGG','RNO:54398',true).
concept_accession('40425: rn:R01274','KEGG','EC:3.1.2.22',true).
concept_accession('40425: rn:R01274','EC','3.1.2.22',true).
concept_accession('40425: rn:R01274','KEGG','3.1.2.22',true).
concept_accession('40425: rn:R01274','KEGG','54398',true).
concept_accession('40426: rn:R04738','KEGG','RNO:170670',true).
concept_accession('40426: rn:R04738','KEGG','170670',true).
concept_accession('40426: rn:R04738','EC','4.2.1.74',true).
concept_accession('40426: rn:R04738','KEGG','RNO:140547',true).
concept_accession('40426: rn:R04738','KEGG','EC:4.2.1.74',true).
concept_accession('40426: rn:R04738','KEGG','140547',true).
concept_accession('40426: rn:R04738','KEGG','4.2.1.74',true).
concept_accession('5224: rn:R00567','KEGG','RP00988',true).
concept_accession('5224: rn:R00567','KEGG','EC:5.1.1.9',true).
concept_accession('5224: rn:R00567','KEGG','RP:RP00988',true).
concept_accession('5224: rn:R00567','EC','5.1.1.9',false).
concept_accession('5224: rn:R00567','KEGG','RC00302',true).
concept_accession('5224: rn:R00567','KEGG','R00567',true).
concept_accession('5224: rn:R00567','KEGG','RN:R00567',true).
concept_accession('5224: rn:R00567','KEGG','5.1.1.9',true).
concept_accession('5224: rn:R00567','KEGG','RC:RC00302',true).
concept_accession('40427: rn:R01278','KEGG','RNO:29470',true).
concept_accession('40427: rn:R01278','KEGG','29470',true).
concept_accession('40427: rn:R01278','KEGG','1.3.1.8',true).
concept_accession('40427: rn:R01278','KEGG','EC:1.3.1.8',true).
concept_accession('40427: rn:R01278','EC','1.3.1.8',true).
concept_accession('40420: rn:R04748','KEGG','1.1.1.211',true).
concept_accession('40420: rn:R04748','EC','1.1.1.211',true).
concept_accession('40420: rn:R04748','KEGG','RNO:113965',true).
concept_accession('40420: rn:R04748','KEGG','EC:1.1.1.211',true).
concept_accession('40420: rn:R04748','KEGG','113965',true).
concept_accession('5222: rn:R02458','KEGG','EC:3.5.3.10',true).
concept_accession('5222: rn:R02458','KEGG','RN:R02458',true).
concept_accession('5222: rn:R02458','KEGG','3.5.3.10',true).
concept_accession('5222: rn:R02458','KEGG','RC:RC00024',true).
concept_accession('5222: rn:R02458','KEGG','R02458',true).
concept_accession('5222: rn:R02458','EC','3.5.3.10',false).
concept_accession('5222: rn:R02458','KEGG','RC00024',true).
concept_accession('5222: rn:R02458','KEGG','RP02230',true).
concept_accession('5222: rn:R02458','KEGG','RP:RP02230',true).
concept_accession('40421: rn:R04748','KEGG','RNO:170670',true).
concept_accession('40421: rn:R04748','KEGG','170670',true).
concept_accession('40421: rn:R04748','KEGG','1.1.1.211',true).
concept_accession('40421: rn:R04748','EC','1.1.1.211',true).
concept_accession('40421: rn:R04748','KEGG','EC:1.1.1.211',true).
concept_accession('40422: rn:R04749','KEGG','RNO:170670',true).
concept_accession('40422: rn:R04749','KEGG','170670',true).
concept_accession('40422: rn:R04749','EC','4.2.1.74',true).
concept_accession('40422: rn:R04749','KEGG','RNO:140547',true).
concept_accession('40422: rn:R04749','KEGG','EC:4.2.1.74',true).
concept_accession('40422: rn:R04749','KEGG','140547',true).
concept_accession('40422: rn:R04749','KEGG','4.2.1.74',true).
concept_accession('40423: rn:R06985','KEGG','RNO:29470',true).
concept_accession('40423: rn:R06985','KEGG','29470',true).
concept_accession('40423: rn:R06985','EC','1.3.1.38',true).
concept_accession('40423: rn:R06985','KEGG','EC:1.3.1.38',true).
concept_accession('40423: rn:R06985','KEGG','1.3.1.38',true).
concept_accession('5219: rn:R00672','KEGG','RP:RP01045',true).
concept_accession('5219: rn:R00672','EC','5.1.1.12',false).
concept_accession('5219: rn:R00672','KEGG','R00672',true).
concept_accession('5219: rn:R00672','KEGG','EC:5.1.1.12',true).
concept_accession('5219: rn:R00672','KEGG','RN:R00672',true).
concept_accession('5219: rn:R00672','KEGG','RP01045',true).
concept_accession('5219: rn:R00672','KEGG','RC00302',true).
concept_accession('5219: rn:R00672','KEGG','5.1.1.12',true).
concept_accession('5219: rn:R00672','KEGG','RC:RC00302',true).
concept_accession('40416: rn:R04747','KEGG','EC:2.3.1.16',true).
concept_accession('40416: rn:R04747','KEGG','RNO:171155',true).
concept_accession('40416: rn:R04747','KEGG','171155',true).
concept_accession('40416: rn:R04747','KEGG','2.3.1.16',true).
concept_accession('40416: rn:R04747','EC','2.3.1.16',true).
concept_accession('40416: rn:R04747','KEGG','RNO:170465',true).
concept_accession('40416: rn:R04747','KEGG','170465',true).
concept_accession('5218: rn:R00672','KEGG','RP:RP01045',true).
concept_accession('5218: rn:R00672','EC','5.1.1.12',false).
concept_accession('5218: rn:R00672','KEGG','R00672',true).
concept_accession('5218: rn:R00672','KEGG','EC:5.1.1.12',true).
concept_accession('5218: rn:R00672','KEGG','RN:R00672',true).
concept_accession('5218: rn:R00672','KEGG','RP01045',true).
concept_accession('5218: rn:R00672','KEGG','RC00302',true).
concept_accession('5218: rn:R00672','KEGG','5.1.1.12',true).
concept_accession('5218: rn:R00672','KEGG','RC:RC00302',true).
concept_accession('40417: rn:R04745','EC','1.1.1.35',true).
concept_accession('40417: rn:R04745','KEGG','RNO:113965',true).
concept_accession('40417: rn:R04745','KEGG','EC:1.1.1.35',true).
concept_accession('40417: rn:R04745','KEGG','1.1.1.35',true).
concept_accession('40417: rn:R04745','KEGG','113965',true).
concept_accession('5217: rn:R00672','KEGG','RP:RP01045',true).
concept_accession('5217: rn:R00672','EC','5.1.1.12',false).
concept_accession('5217: rn:R00672','KEGG','R00672',true).
concept_accession('5217: rn:R00672','KEGG','EC:5.1.1.12',true).
concept_accession('5217: rn:R00672','KEGG','RN:R00672',true).
concept_accession('5217: rn:R00672','KEGG','RP01045',true).
concept_accession('5217: rn:R00672','KEGG','RC00302',true).
concept_accession('5217: rn:R00672','KEGG','5.1.1.12',true).
concept_accession('5217: rn:R00672','KEGG','RC:RC00302',true).
concept_accession('40418: rn:R04745','KEGG','RNO:170670',true).
concept_accession('40418: rn:R04745','KEGG','170670',true).
concept_accession('40418: rn:R04745','EC','1.1.1.35',true).
concept_accession('40418: rn:R04745','KEGG','EC:1.1.1.35',true).
concept_accession('40418: rn:R04745','KEGG','1.1.1.35',true).
concept_accession('40419: rn:R04746','KEGG','RNO:170670',true).
concept_accession('40419: rn:R04746','KEGG','170670',true).
concept_accession('40419: rn:R04746','EC','4.2.1.74',true).
concept_accession('40419: rn:R04746','KEGG','RNO:140547',true).
concept_accession('40419: rn:R04746','KEGG','EC:4.2.1.74',true).
concept_accession('40419: rn:R04746','KEGG','140547',true).
concept_accession('40419: rn:R04746','KEGG','4.2.1.74',true).
concept_accession('40445: rn:R00888','KEGG','EC:4.2.1.47',true).
concept_accession('40445: rn:R00888','KEGG','RNO:291095',true).
concept_accession('40445: rn:R00888','KEGG','291095',true).
concept_accession('40445: rn:R00888','EC','4.2.1.47',true).
concept_accession('40445: rn:R00888','KEGG','4.2.1.47',true).
concept_accession('40444: rn:R04744','KEGG','RNO:170670',true).
concept_accession('40444: rn:R04744','KEGG','170670',true).
concept_accession('40444: rn:R04744','EC','4.2.1.74',true).
concept_accession('40444: rn:R04744','KEGG','RNO:140547',true).
concept_accession('40444: rn:R04744','KEGG','EC:4.2.1.74',true).
concept_accession('40444: rn:R04744','KEGG','140547',true).
concept_accession('40444: rn:R04744','KEGG','4.2.1.74',true).
concept_accession('40447: rn:R00885','KEGG','EC:2.7.7.13',true).
concept_accession('40447: rn:R00885','KEGG','RNO:363145',true).
concept_accession('40447: rn:R00885','KEGG','363145',true).
concept_accession('40447: rn:R00885','KEGG','501167',true).
concept_accession('40447: rn:R00885','KEGG','2.7.7.13',true).
concept_accession('40447: rn:R00885','EC','2.7.7.13',true).
concept_accession('40447: rn:R00885','KEGG','RNO:501167',true).
concept_accession('40446: rn:R05692','KEGG','RNO:300036',true).
concept_accession('40446: rn:R05692','EC','1.1.1.271',true).
concept_accession('40446: rn:R05692','KEGG','1.1.1.271',true).
concept_accession('40446: rn:R05692','KEGG','EC:1.1.1.271',true).
concept_accession('40446: rn:R05692','KEGG','300036',true).
concept_accession('40441: rn:R04741','KEGG','RNO:170670',true).
concept_accession('40441: rn:R04741','KEGG','170670',true).
concept_accession('40441: rn:R04741','KEGG','1.1.1.211',true).
concept_accession('40441: rn:R04741','EC','1.1.1.211',true).
concept_accession('40441: rn:R04741','KEGG','EC:1.1.1.211',true).
concept_accession('1354: rn:R03977','KEGG','RN:R03977',true).
concept_accession('1354: rn:R03977','KEGG','RC:RC00096',true).
concept_accession('1354: rn:R03977','KEGG','RP:RP03598',true).
concept_accession('1354: rn:R03977','KEGG','RP:RP03597',true).
concept_accession('1354: rn:R03977','KEGG','RC:RC00090',true).
concept_accession('1354: rn:R03977','KEGG','R03977',true).
concept_accession('1354: rn:R03977','KEGG','3.5.1.24',true).
concept_accession('1354: rn:R03977','EC','3.5.1.24',false).
concept_accession('1354: rn:R03977','KEGG','RP03598',true).
concept_accession('1354: rn:R03977','KEGG','RP03597',true).
concept_accession('1354: rn:R03977','KEGG','RC00090',true).
concept_accession('1354: rn:R03977','KEGG','RC00096',true).
concept_accession('1354: rn:R03977','KEGG','EC:3.5.1.24',true).
concept_accession('40440: rn:R03776','KEGG','RNO:29470',true).
concept_accession('40440: rn:R03776','KEGG','29470',true).
concept_accession('40440: rn:R03776','EC','1.3.1.38',true).
concept_accession('40440: rn:R03776','KEGG','EC:1.3.1.38',true).
concept_accession('40440: rn:R03776','KEGG','1.3.1.38',true).
concept_accession('40443: rn:R04753','KEGG','RNO:29470',true).
concept_accession('40443: rn:R04753','KEGG','29470',true).
concept_accession('40443: rn:R04753','KEGG','1.3.1.8',true).
concept_accession('40443: rn:R04753','KEGG','EC:1.3.1.8',true).
concept_accession('40443: rn:R04753','EC','1.3.1.8',true).
concept_accession('40442: rn:R04742','KEGG','EC:2.3.1.16',true).
concept_accession('40442: rn:R04742','KEGG','RNO:171155',true).
concept_accession('40442: rn:R04742','KEGG','171155',true).
concept_accession('40442: rn:R04742','KEGG','2.3.1.16',true).
concept_accession('40442: rn:R04742','EC','2.3.1.16',true).
concept_accession('40442: rn:R04742','KEGG','RNO:170465',true).
concept_accession('40442: rn:R04742','KEGG','170465',true).
concept_accession('40437: rn:R04743','KEGG','RNO:170670',true).
concept_accession('40437: rn:R04743','KEGG','170670',true).
concept_accession('40437: rn:R04743','KEGG','1.1.1.211',true).
concept_accession('40437: rn:R04743','EC','1.1.1.211',true).
concept_accession('40437: rn:R04743','KEGG','EC:1.1.1.211',true).
concept_accession('40436: rn:R04740','KEGG','RNO:170670',true).
concept_accession('40436: rn:R04740','KEGG','170670',true).
concept_accession('40436: rn:R04740','EC','4.2.1.74',true).
concept_accession('40436: rn:R04740','KEGG','RNO:140547',true).
concept_accession('40436: rn:R04740','KEGG','EC:4.2.1.74',true).
concept_accession('40436: rn:R04740','KEGG','140547',true).
concept_accession('40436: rn:R04740','KEGG','4.2.1.74',true).
concept_accession('40439: rn:R03778','KEGG','EC:2.3.1.16',true).
concept_accession('40439: rn:R03778','KEGG','RNO:171155',true).
concept_accession('40439: rn:R03778','KEGG','171155',true).
concept_accession('40439: rn:R03778','KEGG','2.3.1.16',true).
concept_accession('40439: rn:R03778','EC','2.3.1.16',true).
concept_accession('40439: rn:R03778','KEGG','RNO:170465',true).
concept_accession('40439: rn:R03778','KEGG','170465',true).
concept_accession('40438: rn:R04743','KEGG','1.1.1.211',true).
concept_accession('40438: rn:R04743','EC','1.1.1.211',true).
concept_accession('40438: rn:R04743','KEGG','RNO:113965',true).
concept_accession('40438: rn:R04743','KEGG','EC:1.1.1.211',true).
concept_accession('40438: rn:R04743','KEGG','113965',true).
concept_accession('40433: rn:R04737','KEGG','RNO:170670',true).
concept_accession('40433: rn:R04737','KEGG','170670',true).
concept_accession('40433: rn:R04737','KEGG','1.1.1.211',true).
concept_accession('40433: rn:R04737','EC','1.1.1.211',true).
concept_accession('40433: rn:R04737','KEGG','EC:1.1.1.211',true).
concept_accession('40432: rn:R04170','KEGG','RNO:170670',true).
concept_accession('40432: rn:R04170','KEGG','170670',true).
concept_accession('40432: rn:R04170','EC','4.2.1.74',true).
concept_accession('40432: rn:R04170','KEGG','RNO:140547',true).
concept_accession('40432: rn:R04170','KEGG','EC:4.2.1.74',true).
concept_accession('40432: rn:R04170','KEGG','140547',true).
concept_accession('40432: rn:R04170','KEGG','4.2.1.74',true).
concept_accession('40435: rn:R03989','KEGG','RNO:29470',true).
concept_accession('40435: rn:R03989','KEGG','29470',true).
concept_accession('40435: rn:R03989','KEGG','1.3.1.8',true).
concept_accession('40435: rn:R03989','KEGG','EC:1.3.1.8',true).
concept_accession('40435: rn:R03989','EC','1.3.1.8',true).
concept_accession('40434: rn:R03991','KEGG','EC:2.3.1.16',true).
concept_accession('40434: rn:R03991','KEGG','RNO:171155',true).
concept_accession('40434: rn:R03991','KEGG','171155',true).
concept_accession('40434: rn:R03991','KEGG','2.3.1.16',true).
concept_accession('40434: rn:R03991','EC','2.3.1.16',true).
concept_accession('40434: rn:R03991','KEGG','RNO:170465',true).
concept_accession('40434: rn:R03991','KEGG','170465',true).
concept_accession('40398: rn:R04751','KEGG','1.3.3.6',true).
concept_accession('40398: rn:R04751','KEGG','EC:1.3.3.6',true).
concept_accession('40398: rn:R04751','EC','1.3.3.6',true).
concept_accession('40398: rn:R04751','KEGG','RNO:25618',true).
concept_accession('40398: rn:R04751','KEGG','25618',true).
concept_accession('40399: rn:R01975','KEGG','171142',true).
concept_accession('40399: rn:R01975','KEGG','RNO:171142',true).
concept_accession('40399: rn:R01975','EC','1.1.1.35',true).
concept_accession('40399: rn:R01975','KEGG','RNO:113965',true).
concept_accession('40399: rn:R01975','KEGG','EC:1.1.1.35',true).
concept_accession('40399: rn:R01975','KEGG','1.1.1.35',true).
concept_accession('40399: rn:R01975','KEGG','113965',true).
concept_accession('40396: rn:R01279','KEGG','1.3.99.13',true).
concept_accession('40396: rn:R01279','KEGG','EC:1.3.99.13',true).
concept_accession('40396: rn:R01279','KEGG','RNO:25363',true).
concept_accession('40396: rn:R01279','EC','1.3.99.13',true).
concept_accession('40396: rn:R01279','KEGG','25363',true).
concept_accession('40397: rn:R01175','KEGG','1.3.3.6',true).
concept_accession('40397: rn:R01175','KEGG','EC:1.3.3.6',true).
concept_accession('40397: rn:R01175','EC','1.3.3.6',true).
concept_accession('40397: rn:R01175','KEGG','RNO:25618',true).
concept_accession('40397: rn:R01175','KEGG','25618',true).
concept_accession('40394: rn:R02487','KEGG','RNO:364975',true).
concept_accession('40394: rn:R02487','KEGG','1.3.99.7',true).
concept_accession('40394: rn:R02487','EC','1.3.99.7',true).
concept_accession('40394: rn:R02487','KEGG','EC:1.3.99.7',true).
concept_accession('40394: rn:R02487','KEGG','364975',true).
concept_accession('40395: rn:R00623','KEGG','24172',true).
concept_accession('40395: rn:R00623','KEGG','RNO:29646',true).
concept_accession('40395: rn:R00623','KEGG','RNO:310903',true).
concept_accession('40395: rn:R00623','KEGG','100145871',true).
concept_accession('40395: rn:R00623','KEGG','EC:1.1.1.1',true).
concept_accession('40395: rn:R00623','KEGG','310903',true).
concept_accession('40395: rn:R00623','KEGG','1.1.1.1',true).
concept_accession('40395: rn:R00623','KEGG','RNO:171178',true).
concept_accession('40395: rn:R00623','EC','1.1.1.1',true).
concept_accession('40395: rn:R00623','KEGG','171178',true).
concept_accession('40395: rn:R00623','KEGG','RNO:100145871',true).
concept_accession('40395: rn:R00623','KEGG','RNO:24172',true).
concept_accession('40395: rn:R00623','KEGG','29646',true).
concept_accession('40392: rn:R03857','KEGG','1.3.3.6',true).
concept_accession('40392: rn:R03857','KEGG','EC:1.3.3.6',true).
concept_accession('40392: rn:R03857','EC','1.3.3.6',true).
concept_accession('40392: rn:R03857','KEGG','25287',true).
concept_accession('40392: rn:R03857','KEGG','RNO:25287',true).
concept_accession('40393: rn:R04741','KEGG','RNO:170670',true).
concept_accession('40393: rn:R04741','KEGG','170670',true).
concept_accession('40393: rn:R04741','KEGG','1.1.1.211',true).
concept_accession('40393: rn:R04741','EC','1.1.1.211',true).
concept_accession('40393: rn:R04741','KEGG','EC:1.1.1.211',true).
concept_accession('40390: rn:R04740','KEGG','RNO:170670',true).
concept_accession('40390: rn:R04740','KEGG','171142',true).
concept_accession('40390: rn:R04740','KEGG','RNO:171142',true).
concept_accession('40390: rn:R04740','KEGG','170670',true).
concept_accession('40390: rn:R04740','EC','4.2.1.74',true).
concept_accession('40390: rn:R04740','KEGG','RNO:140547',true).
concept_accession('40390: rn:R04740','KEGG','EC:4.2.1.74',true).
concept_accession('40390: rn:R04740','KEGG','140547',true).
concept_accession('40390: rn:R04740','KEGG','4.2.1.74',true).
concept_accession('5189: rn:R00279','KEGG','R00279',true).
concept_accession('5189: rn:R00279','KEGG','RN:R00279',true).
concept_accession('5189: rn:R00279','KEGG','RC00006',true).
concept_accession('5189: rn:R00279','KEGG','RC:RC00006',true).
concept_accession('5189: rn:R00279','EC','1.4.3.7',false).
concept_accession('5189: rn:R00279','KEGG','EC:1.4.3.7',true).
concept_accession('5189: rn:R00279','KEGG','RP00084',true).
concept_accession('5189: rn:R00279','KEGG','1.4.3.7',true).
concept_accession('5189: rn:R00279','KEGG','RP:RP00084',true).
concept_accession('40391: rn:R03858','KEGG','EC:2.3.1.16',true).
concept_accession('40391: rn:R03858','KEGG','24157',true).
concept_accession('40391: rn:R03858','KEGG','501072',true).
concept_accession('40391: rn:R03858','KEGG','RNO:171155',true).
concept_accession('40391: rn:R03858','KEGG','RNO:24157',true).
concept_accession('40391: rn:R03858','KEGG','171155',true).
concept_accession('40391: rn:R03858','KEGG','RNO:501072',true).
concept_accession('40391: rn:R03858','KEGG','2.3.1.16',true).
concept_accession('40391: rn:R03858','EC','2.3.1.16',true).
concept_accession('40391: rn:R03858','KEGG','RNO:170465',true).
concept_accession('40391: rn:R03858','KEGG','170465',true).
concept_accession('40388: rn:R04739','KEGG','171142',true).
concept_accession('40388: rn:R04739','KEGG','RNO:171142',true).
concept_accession('40388: rn:R04739','KEGG','1.1.1.211',true).
concept_accession('40388: rn:R04739','EC','1.1.1.211',true).
concept_accession('40388: rn:R04739','KEGG','RNO:113965',true).
concept_accession('40388: rn:R04739','KEGG','EC:1.1.1.211',true).
concept_accession('40388: rn:R04739','KEGG','113965',true).
concept_accession('5191: rn:R00260','KEGG','5.1.1.3',true).
concept_accession('5191: rn:R00260','KEGG','RP:RP04459',true).
concept_accession('5191: rn:R00260','EC','5.1.1.3',false).
concept_accession('5191: rn:R00260','KEGG','R00260',true).
concept_accession('5191: rn:R00260','KEGG','RN:R00260',true).
concept_accession('5191: rn:R00260','KEGG','EC:5.1.1.3',true).
concept_accession('5191: rn:R00260','KEGG','RC00302',true).
concept_accession('5191: rn:R00260','KEGG','RP04459',true).
concept_accession('5191: rn:R00260','KEGG','RC:RC00302',true).
concept_accession('40389: rn:R03990','KEGG','1.3.99.13',true).
concept_accession('40389: rn:R03990','KEGG','EC:1.3.99.13',true).
concept_accession('40389: rn:R03990','KEGG','RNO:24158',true).
concept_accession('40389: rn:R03990','KEGG','24158',true).
concept_accession('40389: rn:R03990','EC','1.3.99.13',true).
concept_accession('40386: rn:R04739','KEGG','RNO:170670',true).
concept_accession('40386: rn:R04739','KEGG','170670',true).
concept_accession('40386: rn:R04739','KEGG','1.1.1.211',true).
concept_accession('40386: rn:R04739','EC','1.1.1.211',true).
concept_accession('40386: rn:R04739','KEGG','EC:1.1.1.211',true).
concept_accession('40387: rn:R00631','KEGG','1.2.1.3',true).
concept_accession('40387: rn:R00631','KEGG','RNO:291450',true).
concept_accession('40387: rn:R00631','KEGG','RNO:64040',true).
concept_accession('40387: rn:R00631','EC','1.2.1.3',true).
concept_accession('40387: rn:R00631','KEGG','65183',true).
concept_accession('40387: rn:R00631','KEGG','24188',true).
concept_accession('40387: rn:R00631','KEGG','RNO:29539',true).
concept_accession('40387: rn:R00631','KEGG','64040',true).
concept_accession('40387: rn:R00631','KEGG','RNO:24188',true).
concept_accession('40387: rn:R00631','KEGG','29539',true).
concept_accession('40387: rn:R00631','KEGG','29651',true).
concept_accession('40387: rn:R00631','KEGG','298079',true).
concept_accession('40387: rn:R00631','KEGG','RNO:298079',true).
concept_accession('40387: rn:R00631','KEGG','RNO:65183',true).
concept_accession('40387: rn:R00631','KEGG','RNO:29651',true).
concept_accession('40387: rn:R00631','KEGG','291450',true).
concept_accession('40387: rn:R00631','KEGG','EC:1.2.1.3',true).
concept_accession('40384: rn:R01347 rn:R01348','KEGG','RNO:24306',true).
concept_accession('40384: rn:R01347 rn:R01348','KEGG','24306',true).
concept_accession('40384: rn:R01347 rn:R01348','KEGG','50549',true).
concept_accession('40384: rn:R01347 rn:R01348','KEGG','RNO:50549',true).
concept_accession('40384: rn:R01347 rn:R01348','KEGG','EC:1.14.15.3',true).
concept_accession('40384: rn:R01347 rn:R01348','KEGG','RNO:266674',true).
concept_accession('40384: rn:R01347 rn:R01348','KEGG','266674',true).
concept_accession('40384: rn:R01347 rn:R01348','KEGG','RNO:170544',true).
concept_accession('40384: rn:R01347 rn:R01348','KEGG','1.14.15.3',true).
concept_accession('40384: rn:R01347 rn:R01348','KEGG','170544',true).
concept_accession('40384: rn:R01347 rn:R01348','KEGG','RNO:298423',true).
concept_accession('40384: rn:R01347 rn:R01348','EC','1.14.15.3',true).
concept_accession('40384: rn:R01347 rn:R01348','KEGG','298423',true).
concept_accession('40385: rn:R03990','KEGG','1.3.99.13',true).
concept_accession('40385: rn:R03990','KEGG','EC:1.3.99.13',true).
concept_accession('40385: rn:R03990','KEGG','25287',true).
concept_accession('40385: rn:R03990','KEGG','RNO:25287',true).
concept_accession('40385: rn:R03990','EC','1.3.99.13',true).
concept_accession('40415: rn:R03777','KEGG','1.3.3.6',true).
concept_accession('40415: rn:R03777','KEGG','EC:1.3.3.6',true).
concept_accession('40415: rn:R03777','EC','1.3.3.6',true).
concept_accession('40415: rn:R03777','KEGG','RNO:24158',true).
concept_accession('40415: rn:R03777','KEGG','24158',true).
concept_accession('40414: rn:R04746','KEGG','RNO:170670',true).
concept_accession('40414: rn:R04746','KEGG','171142',true).
concept_accession('40414: rn:R04746','KEGG','RNO:171142',true).
concept_accession('40414: rn:R04746','KEGG','170670',true).
concept_accession('40414: rn:R04746','EC','4.2.1.74',true).
concept_accession('40414: rn:R04746','KEGG','RNO:140547',true).
concept_accession('40414: rn:R04746','KEGG','EC:4.2.1.74',true).
concept_accession('40414: rn:R04746','KEGG','140547',true).
concept_accession('40414: rn:R04746','KEGG','4.2.1.74',true).
concept_accession('40413: rn:R04745','KEGG','171142',true).
concept_accession('40413: rn:R04745','KEGG','RNO:171142',true).
concept_accession('40413: rn:R04745','EC','1.1.1.35',true).
concept_accession('40413: rn:R04745','KEGG','RNO:113965',true).
concept_accession('40413: rn:R04745','KEGG','EC:1.1.1.35',true).
concept_accession('40413: rn:R04745','KEGG','1.1.1.35',true).
concept_accession('40413: rn:R04745','KEGG','113965',true).
concept_accession('40412: rn:R04747','KEGG','EC:2.3.1.16',true).
concept_accession('40412: rn:R04747','KEGG','24157',true).
concept_accession('40412: rn:R04747','KEGG','501072',true).
concept_accession('40412: rn:R04747','KEGG','RNO:171155',true).
concept_accession('40412: rn:R04747','KEGG','RNO:24157',true).
concept_accession('40412: rn:R04747','KEGG','171155',true).
concept_accession('40412: rn:R04747','KEGG','RNO:501072',true).
concept_accession('40412: rn:R04747','KEGG','2.3.1.16',true).
concept_accession('40412: rn:R04747','EC','2.3.1.16',true).
concept_accession('40412: rn:R04747','KEGG','RNO:170465',true).
concept_accession('40412: rn:R04747','KEGG','170465',true).
concept_accession('40411: rn:R04751','KEGG','1.3.3.6',true).
concept_accession('40411: rn:R04751','KEGG','EC:1.3.3.6',true).
concept_accession('40411: rn:R04751','EC','1.3.3.6',true).
concept_accession('40411: rn:R04751','KEGG','25287',true).
concept_accession('40411: rn:R04751','KEGG','RNO:25287',true).
concept_accession('9993: rn:R01268','KEGG','RC:RC00100',true).
concept_accession('9993: rn:R01268','KEGG','RP01397',true).
concept_accession('9993: rn:R01268','KEGG','RN:R01268',true).
concept_accession('9993: rn:R01268','EC','3.5.1.19',false).
concept_accession('9993: rn:R01268','KEGG','EC:3.5.1.19',true).
concept_accession('9993: rn:R01268','KEGG','RP:RP01397',true).
concept_accession('9993: rn:R01268','KEGG','R01268',true).
concept_accession('9993: rn:R01268','KEGG','3.5.1.19',true).
concept_accession('9993: rn:R01268','KEGG','RC00100',true).
concept_accession('40410: rn:R04748','KEGG','RNO:170670',true).
concept_accession('40410: rn:R04748','KEGG','170670',true).
concept_accession('40410: rn:R04748','KEGG','1.1.1.211',true).
concept_accession('40410: rn:R04748','EC','1.1.1.211',true).
concept_accession('40410: rn:R04748','KEGG','EC:1.1.1.211',true).
concept_accession('5209: rn:R00279','KEGG','R00279',true).
concept_accession('5209: rn:R00279','KEGG','RN:R00279',true).
concept_accession('5209: rn:R00279','KEGG','RC00006',true).
concept_accession('5209: rn:R00279','KEGG','RC:RC00006',true).
concept_accession('5209: rn:R00279','EC','1.4.3.7',false).
concept_accession('5209: rn:R00279','KEGG','EC:1.4.3.7',true).
concept_accession('5209: rn:R00279','KEGG','RP00084',true).
concept_accession('5209: rn:R00279','KEGG','1.4.3.7',true).
concept_accession('5209: rn:R00279','KEGG','RP:RP00084',true).
concept_accession('40409: rn:R04751','KEGG','1.3.3.6',true).
concept_accession('40409: rn:R04751','KEGG','EC:1.3.3.6',true).
concept_accession('40409: rn:R04751','EC','1.3.3.6',true).
concept_accession('40409: rn:R04751','KEGG','RNO:24158',true).
concept_accession('40409: rn:R04751','KEGG','24158',true).
concept_accession('5210: rn:R00579','KEGG','RP:RP00992',true).
concept_accession('5210: rn:R00579','EC','5.1.1.10',false).
concept_accession('5210: rn:R00579','KEGG','EC:5.1.1.10',true).
concept_accession('5210: rn:R00579','KEGG','5.1.1.10',true).
concept_accession('5210: rn:R00579','KEGG','R00579',true).
concept_accession('5210: rn:R00579','KEGG','RN:R00579',true).
concept_accession('5210: rn:R00579','KEGG','RC00302',true).
concept_accession('5210: rn:R00579','KEGG','RP00992',true).
concept_accession('5210: rn:R00579','KEGG','RC:RC00302',true).
concept_accession('40408: rn:R04751','KEGG','1.3.3.6',true).
concept_accession('40408: rn:R04751','KEGG','EC:1.3.3.6',true).
concept_accession('40408: rn:R04751','EC','1.3.3.6',true).
concept_accession('40408: rn:R04751','KEGG','64304',true).
concept_accession('40408: rn:R04751','KEGG','RNO:64304',true).
concept_accession('40407: rn:R04749','KEGG','RNO:170670',true).
concept_accession('40407: rn:R04749','KEGG','171142',true).
concept_accession('40407: rn:R04749','KEGG','RNO:171142',true).
concept_accession('40407: rn:R04749','KEGG','170670',true).
concept_accession('40407: rn:R04749','EC','4.2.1.74',true).
concept_accession('40407: rn:R04749','KEGG','RNO:140547',true).
concept_accession('40407: rn:R04749','KEGG','EC:4.2.1.74',true).
concept_accession('40407: rn:R04749','KEGG','140547',true).
concept_accession('40407: rn:R04749','KEGG','4.2.1.74',true).
concept_accession('40406: rn:R04748','KEGG','171142',true).
concept_accession('40406: rn:R04748','KEGG','RNO:171142',true).
concept_accession('40406: rn:R04748','KEGG','1.1.1.211',true).
concept_accession('40406: rn:R04748','EC','1.1.1.211',true).
concept_accession('40406: rn:R04748','KEGG','RNO:113965',true).
concept_accession('40406: rn:R04748','KEGG','EC:1.1.1.211',true).
concept_accession('40406: rn:R04748','KEGG','113965',true).
concept_accession('40405: rn:R01177','KEGG','EC:2.3.1.16',true).
concept_accession('40405: rn:R01177','KEGG','24157',true).
concept_accession('40405: rn:R01177','KEGG','501072',true).
concept_accession('40405: rn:R01177','KEGG','RNO:171155',true).
concept_accession('40405: rn:R01177','KEGG','RNO:24157',true).
concept_accession('40405: rn:R01177','KEGG','171155',true).
concept_accession('40405: rn:R01177','KEGG','RNO:501072',true).
concept_accession('40405: rn:R01177','KEGG','2.3.1.16',true).
concept_accession('40405: rn:R01177','EC','2.3.1.16',true).
concept_accession('40405: rn:R01177','KEGG','RNO:170465',true).
concept_accession('40405: rn:R01177','KEGG','170465',true).
concept_accession('9991: rn:R02322','KEGG','RP02124',true).
concept_accession('9991: rn:R02322','EC','3.5.1.42',false).
concept_accession('9991: rn:R02322','KEGG','RN:R02322',true).
concept_accession('9991: rn:R02322','KEGG','RC:RC00100',true).
concept_accession('9991: rn:R02322','KEGG','R02322',true).
concept_accession('9991: rn:R02322','KEGG','RP:RP02124',true).
concept_accession('9991: rn:R02322','KEGG','EC:3.5.1.42',true).
concept_accession('9991: rn:R02322','KEGG','RC00100',true).
concept_accession('9991: rn:R02322','KEGG','3.5.1.42',true).
concept_accession('40404: rn:R01177','KEGG','EC:2.3.1.16',true).
concept_accession('40404: rn:R01177','KEGG','RNO:308100',true).
concept_accession('40404: rn:R01177','KEGG','2.3.1.16',true).
concept_accession('40404: rn:R01177','EC','2.3.1.16',true).
concept_accession('40404: rn:R01177','KEGG','RNO:25014',true).
concept_accession('40404: rn:R01177','KEGG','25014',true).
concept_accession('40404: rn:R01177','KEGG','308100',true).
concept_accession('40403: rn:R04756','KEGG','171142',true).
concept_accession('40403: rn:R04756','KEGG','RNO:171142',true).
concept_accession('40403: rn:R04756','KEGG','291075',true).
concept_accession('40403: rn:R04756','KEGG','EC:5.3.3.8',true).
concept_accession('40403: rn:R04756','KEGG','RNO:291075',true).
concept_accession('40403: rn:R04756','EC','5.3.3.8',true).
concept_accession('40403: rn:R04756','KEGG','RNO:29740',true).
concept_accession('40403: rn:R04756','KEGG','29740',true).
concept_accession('40403: rn:R04756','KEGG','5.3.3.8',true).
concept_accession('40402: rn:R01175','KEGG','1.3.3.6',true).
concept_accession('40402: rn:R01175','KEGG','EC:1.3.3.6',true).
concept_accession('40402: rn:R01175','EC','1.3.3.6',true).
concept_accession('40402: rn:R01175','KEGG','RNO:24158',true).
concept_accession('40402: rn:R01175','KEGG','24158',true).
concept_accession('40401: rn:R03026','KEGG','RNO:170670',true).
concept_accession('40401: rn:R03026','KEGG','171142',true).
concept_accession('40401: rn:R03026','KEGG','RNO:171142',true).
concept_accession('40401: rn:R03026','EC','4.2.1.17',true).
concept_accession('40401: rn:R03026','KEGG','170670',true).
concept_accession('40401: rn:R03026','KEGG','RNO:140547',true).
concept_accession('40401: rn:R03026','KEGG','140547',true).
concept_accession('40401: rn:R03026','KEGG','4.2.1.17',true).
concept_accession('40401: rn:R03026','KEGG','EC:4.2.1.17',true).
concept_accession('40400: rn:R01175','KEGG','1.3.3.6',true).
concept_accession('40400: rn:R01175','KEGG','EC:1.3.3.6',true).
concept_accession('40400: rn:R01175','EC','1.3.3.6',true).
concept_accession('40400: rn:R01175','KEGG','64304',true).
concept_accession('40400: rn:R01175','KEGG','RNO:64304',true).
concept_accession('40360: rn:R01279','KEGG','1.3.99.13',true).
concept_accession('40360: rn:R01279','KEGG','EC:1.3.99.13',true).
concept_accession('40360: rn:R01279','KEGG','RNO:50681',true).
concept_accession('40360: rn:R01279','KEGG','50681',true).
concept_accession('40360: rn:R01279','KEGG','83522',true).
concept_accession('40360: rn:R01279','EC','1.3.99.13',true).
concept_accession('40360: rn:R01279','KEGG','RNO:83522',true).
concept_accession('5163: rn:R06614','KEGG','RC:RC00299',true).
concept_accession('5163: rn:R06614','KEGG','RP09054',true).
concept_accession('5163: rn:R06614','KEGG','RN:R06614',true).
concept_accession('5163: rn:R06614','KEGG','RP:RP09054',true).
concept_accession('5163: rn:R06614','KEGG','R06614',true).
concept_accession('5163: rn:R06614','KEGG','RC00299',true).
concept_accession('40361: rn:R01923','KEGG','25757',true).
concept_accession('40361: rn:R01923','KEGG','EC:2.3.1.21',true).
concept_accession('40361: rn:R01923','KEGG','RNO:25413',true).
concept_accession('40361: rn:R01923','KEGG','RNO:25757',true).
concept_accession('40361: rn:R01923','KEGG','25413',true).
concept_accession('40361: rn:R01923','KEGG','RNO:25756',true).
concept_accession('40361: rn:R01923','KEGG','RNO:308579',true).
concept_accession('40361: rn:R01923','KEGG','2.3.1.21',true).
concept_accession('40361: rn:R01923','EC','2.3.1.21',true).
concept_accession('40361: rn:R01923','KEGG','25756',true).
concept_accession('40361: rn:R01923','KEGG','308579',true).
concept_accession('40362: rn:R01175','KEGG','1.3.3.6',true).
concept_accession('40362: rn:R01175','KEGG','EC:1.3.3.6',true).
concept_accession('40362: rn:R01175','EC','1.3.3.6',true).
concept_accession('40362: rn:R01175','KEGG','RNO:50681',true).
concept_accession('40362: rn:R01175','KEGG','50681',true).
concept_accession('40362: rn:R01175','KEGG','83522',true).
concept_accession('40362: rn:R01175','KEGG','RNO:83522',true).
concept_accession('40363: rn:R04751','KEGG','1.3.3.6',true).
concept_accession('40363: rn:R04751','KEGG','EC:1.3.3.6',true).
concept_accession('40363: rn:R04751','EC','1.3.3.6',true).
concept_accession('40363: rn:R04751','KEGG','RNO:50681',true).
concept_accession('40363: rn:R04751','KEGG','50681',true).
concept_accession('40363: rn:R04751','KEGG','83522',true).
concept_accession('40363: rn:R04751','KEGG','RNO:83522',true).
concept_accession('40364: rn:R03777','KEGG','1.3.3.6',true).
concept_accession('40364: rn:R03777','KEGG','EC:1.3.3.6',true).
concept_accession('40364: rn:R03777','EC','1.3.3.6',true).
concept_accession('40364: rn:R03777','KEGG','RNO:50681',true).
concept_accession('40364: rn:R03777','KEGG','50681',true).
concept_accession('40364: rn:R03777','KEGG','83522',true).
concept_accession('40364: rn:R03777','KEGG','RNO:83522',true).
concept_accession('10110: rn:R02473','KEGG','RP:RP00376',true).
concept_accession('10110: rn:R02473','KEGG','RC:RC00096',true).
concept_accession('10110: rn:R02473','KEGG','EC:6.3.2.1',true).
concept_accession('10110: rn:R02473','KEGG','R02473',true).
concept_accession('10110: rn:R02473','EC','6.3.2.1',false).
concept_accession('10110: rn:R02473','KEGG','RN:R02473',true).
concept_accession('10110: rn:R02473','KEGG','RP00373',true).
concept_accession('10110: rn:R02473','KEGG','RP00376',true).
concept_accession('10110: rn:R02473','KEGG','6.3.2.1',true).
concept_accession('10110: rn:R02473','KEGG','RC00141',true).
concept_accession('10110: rn:R02473','KEGG','RC:RC00141',true).
concept_accession('10110: rn:R02473','KEGG','RC00096',true).
concept_accession('10110: rn:R02473','KEGG','RP:RP00373',true).
concept_accession('40365: rn:R01279','KEGG','1.3.99.13',true).
concept_accession('40365: rn:R01279','KEGG','EC:1.3.99.13',true).
concept_accession('40365: rn:R01279','KEGG','RNO:24158',true).
concept_accession('40365: rn:R01279','KEGG','24158',true).
concept_accession('40365: rn:R01279','EC','1.3.99.13',true).
concept_accession('40366: rn:R01280','EC','6.2.1.3',true).
concept_accession('40366: rn:R01280','KEGG','EC:6.2.1.3',true).
concept_accession('40366: rn:R01280','KEGG','RNO:25288',true).
concept_accession('40366: rn:R01280','KEGG','RNO:301120',true).
concept_accession('40366: rn:R01280','KEGG','RNO:117243',true).
concept_accession('40366: rn:R01280','KEGG','6.2.1.3',true).
concept_accession('40366: rn:R01280','KEGG','301120',true).
concept_accession('40366: rn:R01280','KEGG','RNO:114024',true).
concept_accession('40366: rn:R01280','KEGG','117243',true).
concept_accession('40366: rn:R01280','KEGG','25288',true).
concept_accession('40366: rn:R01280','KEGG','113976',true).
concept_accession('40366: rn:R01280','KEGG','114024',true).
concept_accession('40366: rn:R01280','KEGG','171410',true).
concept_accession('40366: rn:R01280','KEGG','94340',true).
concept_accession('40366: rn:R01280','KEGG','RNO:113976',true).
concept_accession('40366: rn:R01280','KEGG','RNO:171410',true).
concept_accession('40366: rn:R01280','KEGG','RNO:94340',true).
concept_accession('40367: rn:R04737','KEGG','RNO:170670',true).
concept_accession('40367: rn:R04737','KEGG','170670',true).
concept_accession('40367: rn:R04737','KEGG','1.1.1.211',true).
concept_accession('40367: rn:R04737','EC','1.1.1.211',true).
concept_accession('40367: rn:R04737','KEGG','EC:1.1.1.211',true).
concept_accession('10099: rn:R01623','KEGG','3.1.4.14',true).
concept_accession('10099: rn:R01623','KEGG','EC:3.1.4.14',true).
concept_accession('10099: rn:R01623','KEGG','R01623',true).
concept_accession('10099: rn:R01623','EC','3.1.4.14',false).
concept_accession('10099: rn:R01623','KEGG','RN:R01623',true).
concept_accession('40352: rn:R01451 rn:R01456','KEGG','RNO:64191',true).
concept_accession('40352: rn:R01451 rn:R01456','KEGG','64191',true).
concept_accession('40352: rn:R01451 rn:R01456','KEGG','1.3.1.21',true).
concept_accession('40352: rn:R01451 rn:R01456','KEGG','EC:1.3.1.21',true).
concept_accession('40352: rn:R01451 rn:R01456','EC','1.3.1.21',true).
concept_accession('40353: rn:R04804','KEGG','117278',true).
concept_accession('40353: rn:R04804','KEGG','EC:5.3.3.5',true).
concept_accession('40353: rn:R04804','KEGG','RNO:117278',true).
concept_accession('40353: rn:R04804','EC','5.3.3.5',true).
concept_accession('40353: rn:R04804','KEGG','5.3.3.5',true).
concept_accession('40354: rn:R01361','KEGG','1.1.1.30',true).
concept_accession('40354: rn:R01361','KEGG','RNO:117099',true).
concept_accession('40354: rn:R01361','KEGG','RNO:295458',true).
concept_accession('40354: rn:R01361','KEGG','117099',true).
concept_accession('40354: rn:R01361','KEGG','295458',true).
concept_accession('40354: rn:R01361','EC','1.1.1.30',true).
concept_accession('40354: rn:R01361','KEGG','EC:1.1.1.30',true).
concept_accession('40355: rn:R00238','KEGG','2.3.1.9',true).
concept_accession('40355: rn:R00238','KEGG','EC:2.3.1.9',true).
concept_accession('40355: rn:R00238','EC','2.3.1.9',true).
concept_accession('40355: rn:R00238','KEGG','RNO:308100',true).
concept_accession('40355: rn:R00238','KEGG','RNO:25014',true).
concept_accession('40355: rn:R00238','KEGG','25014',true).
concept_accession('40355: rn:R00238','KEGG','308100',true).
concept_accession('40356: rn:R00410','KEGG','RNO:100361036',true).
concept_accession('40356: rn:R00410','KEGG','EC:2.8.3.5',true).
concept_accession('40356: rn:R00410','KEGG','100361036',true).
concept_accession('40356: rn:R00410','EC','2.8.3.5',true).
concept_accession('40356: rn:R00410','KEGG','RNO:690163',true).
concept_accession('40356: rn:R00410','KEGG','100365119',true).
concept_accession('40356: rn:R00410','KEGG','100359544',true).
concept_accession('40356: rn:R00410','KEGG','2.8.3.5',true).
concept_accession('40356: rn:R00410','KEGG','RNO:366463',true).
concept_accession('40356: rn:R00410','KEGG','RNO:100365119',true).
concept_accession('40356: rn:R00410','KEGG','RNO:100359544',true).
concept_accession('40356: rn:R00410','KEGG','690163',true).
concept_accession('40356: rn:R00410','KEGG','366463',true).
concept_accession('10102: rn:R02972','KEGG','EC:4.1.1.30',true).
concept_accession('10102: rn:R02972','KEGG','RP02649',true).
concept_accession('10102: rn:R02972','KEGG','4.1.1.30',true).
concept_accession('10102: rn:R02972','KEGG','RC:RC00822',true).
concept_accession('10102: rn:R02972','KEGG','RP:RP02649',true).
concept_accession('10102: rn:R02972','KEGG','RC00822',true).
concept_accession('10102: rn:R02972','KEGG','R02972',true).
concept_accession('10102: rn:R02972','KEGG','RN:R02972',true).
concept_accession('10102: rn:R02972','EC','4.1.1.30',false).
concept_accession('40357: rn:R04754','KEGG','1.3.3.6',true).
concept_accession('40357: rn:R04754','KEGG','EC:1.3.3.6',true).
concept_accession('40357: rn:R04754','EC','1.3.3.6',true).
concept_accession('40357: rn:R04754','KEGG','RNO:50681',true).
concept_accession('40357: rn:R04754','KEGG','50681',true).
concept_accession('40357: rn:R04754','KEGG','83522',true).
concept_accession('40357: rn:R04754','KEGG','RNO:83522',true).
concept_accession('40358: rn:R03857','KEGG','1.3.3.6',true).
concept_accession('40358: rn:R03857','KEGG','EC:1.3.3.6',true).
concept_accession('40358: rn:R03857','EC','1.3.3.6',true).
concept_accession('40358: rn:R03857','KEGG','RNO:50681',true).
concept_accession('40358: rn:R03857','KEGG','50681',true).
concept_accession('40358: rn:R03857','KEGG','83522',true).
concept_accession('40358: rn:R03857','KEGG','RNO:83522',true).
concept_accession('40359: rn:R03990','KEGG','1.3.99.13',true).
concept_accession('40359: rn:R03990','KEGG','EC:1.3.99.13',true).
concept_accession('40359: rn:R03990','KEGG','RNO:50681',true).
concept_accession('40359: rn:R03990','KEGG','50681',true).
concept_accession('40359: rn:R03990','KEGG','83522',true).
concept_accession('40359: rn:R03990','EC','1.3.99.13',true).
concept_accession('40359: rn:R03990','KEGG','RNO:83522',true).
concept_accession('40377: rn:R04743','KEGG','RNO:170670',true).
concept_accession('40377: rn:R04743','KEGG','170670',true).
concept_accession('40377: rn:R04743','KEGG','1.1.1.211',true).
concept_accession('40377: rn:R04743','EC','1.1.1.211',true).
concept_accession('40377: rn:R04743','KEGG','EC:1.1.1.211',true).
concept_accession('40376: rn:R04754','KEGG','1.3.3.6',true).
concept_accession('40376: rn:R04754','KEGG','EC:1.3.3.6',true).
concept_accession('40376: rn:R04754','EC','1.3.3.6',true).
concept_accession('40376: rn:R04754','KEGG','25287',true).
concept_accession('40376: rn:R04754','KEGG','RNO:25287',true).
concept_accession('40379: rn:R04754','KEGG','1.3.3.6',true).
concept_accession('40379: rn:R04754','KEGG','EC:1.3.3.6',true).
concept_accession('40379: rn:R04754','EC','1.3.3.6',true).
concept_accession('40379: rn:R04754','KEGG','RNO:24158',true).
concept_accession('40379: rn:R04754','KEGG','24158',true).
concept_accession('40378: rn:R04744','KEGG','RNO:170670',true).
concept_accession('40378: rn:R04744','KEGG','171142',true).
concept_accession('40378: rn:R04744','KEGG','RNO:171142',true).
concept_accession('40378: rn:R04744','KEGG','170670',true).
concept_accession('40378: rn:R04744','EC','4.2.1.74',true).
concept_accession('40378: rn:R04744','KEGG','RNO:140547',true).
concept_accession('40378: rn:R04744','KEGG','EC:4.2.1.74',true).
concept_accession('40378: rn:R04744','KEGG','140547',true).
concept_accession('40378: rn:R04744','KEGG','4.2.1.74',true).
concept_accession('40381: rn:R04743','KEGG','171142',true).
concept_accession('40381: rn:R04743','KEGG','RNO:171142',true).
concept_accession('40381: rn:R04743','KEGG','1.1.1.211',true).
concept_accession('40381: rn:R04743','EC','1.1.1.211',true).
concept_accession('40381: rn:R04743','KEGG','RNO:113965',true).
concept_accession('40381: rn:R04743','KEGG','EC:1.1.1.211',true).
concept_accession('40381: rn:R04743','KEGG','113965',true).
concept_accession('40380: rn:R03778','KEGG','EC:2.3.1.16',true).
concept_accession('40380: rn:R03778','KEGG','24157',true).
concept_accession('40380: rn:R03778','KEGG','501072',true).
concept_accession('40380: rn:R03778','KEGG','RNO:171155',true).
concept_accession('40380: rn:R03778','KEGG','RNO:24157',true).
concept_accession('40380: rn:R03778','KEGG','171155',true).
concept_accession('40380: rn:R03778','KEGG','RNO:501072',true).
concept_accession('40380: rn:R03778','KEGG','2.3.1.16',true).
concept_accession('40380: rn:R03778','EC','2.3.1.16',true).
concept_accession('40380: rn:R03778','KEGG','RNO:170465',true).
concept_accession('40380: rn:R03778','KEGG','170465',true).
concept_accession('1292: rn:R03311','KEGG','RP02932',true).
concept_accession('1292: rn:R03311','KEGG','RN:R03311',true).
concept_accession('1292: rn:R03311','KEGG','RP:RP02932',true).
concept_accession('1292: rn:R03311','KEGG','R03311',true).
concept_accession('1292: rn:R03311','KEGG','RC:RC00905',true).
concept_accession('1292: rn:R03311','KEGG','RC00905',true).
concept_accession('40383: rn:R03777','KEGG','1.3.3.6',true).
concept_accession('40383: rn:R03777','KEGG','EC:1.3.3.6',true).
concept_accession('40383: rn:R03777','EC','1.3.3.6',true).
concept_accession('40383: rn:R03777','KEGG','25287',true).
concept_accession('40383: rn:R03777','KEGG','RNO:25287',true).
concept_accession('40382: rn:R04745','KEGG','RNO:170670',true).
concept_accession('40382: rn:R04745','KEGG','170670',true).
concept_accession('40382: rn:R04745','EC','1.1.1.35',true).
concept_accession('40382: rn:R04745','KEGG','EC:1.1.1.35',true).
concept_accession('40382: rn:R04745','KEGG','1.1.1.35',true).
concept_accession('40369: rn:R03991','KEGG','EC:2.3.1.16',true).
concept_accession('40369: rn:R03991','KEGG','24157',true).
concept_accession('40369: rn:R03991','KEGG','501072',true).
concept_accession('40369: rn:R03991','KEGG','RNO:171155',true).
concept_accession('40369: rn:R03991','KEGG','RNO:24157',true).
concept_accession('40369: rn:R03991','KEGG','171155',true).
concept_accession('40369: rn:R03991','KEGG','RNO:501072',true).
concept_accession('40369: rn:R03991','KEGG','2.3.1.16',true).
concept_accession('40369: rn:R03991','EC','2.3.1.16',true).
concept_accession('40369: rn:R03991','KEGG','RNO:170465',true).
concept_accession('40369: rn:R03991','KEGG','170465',true).
concept_accession('40368: rn:R01279','KEGG','1.3.99.13',true).
concept_accession('40368: rn:R01279','KEGG','EC:1.3.99.13',true).
concept_accession('40368: rn:R01279','KEGG','25287',true).
concept_accession('40368: rn:R01279','KEGG','RNO:25287',true).
concept_accession('40368: rn:R01279','EC','1.3.99.13',true).
concept_accession('40371: rn:R04738','KEGG','RNO:170670',true).
concept_accession('40371: rn:R04738','KEGG','171142',true).
concept_accession('40371: rn:R04738','KEGG','RNO:171142',true).
concept_accession('40371: rn:R04738','KEGG','170670',true).
concept_accession('40371: rn:R04738','EC','4.2.1.74',true).
concept_accession('40371: rn:R04738','KEGG','RNO:140547',true).
concept_accession('40371: rn:R04738','KEGG','EC:4.2.1.74',true).
concept_accession('40371: rn:R04738','KEGG','140547',true).
concept_accession('40371: rn:R04738','KEGG','4.2.1.74',true).
concept_accession('40370: rn:R04737','KEGG','171142',true).
concept_accession('40370: rn:R04737','KEGG','RNO:171142',true).
concept_accession('40370: rn:R04737','KEGG','1.1.1.211',true).
concept_accession('40370: rn:R04737','EC','1.1.1.211',true).
concept_accession('40370: rn:R04737','KEGG','RNO:113965',true).
concept_accession('40370: rn:R04737','KEGG','EC:1.1.1.211',true).
concept_accession('40370: rn:R04737','KEGG','113965',true).
concept_accession('1286: rn:R03724','KEGG','RC:RC00138',true).
concept_accession('1286: rn:R03724','KEGG','R03724',true).
concept_accession('1286: rn:R03724','KEGG','RP03349',true).
concept_accession('1286: rn:R03724','KEGG','RC00138',true).
concept_accession('1286: rn:R03724','KEGG','RP:RP03349',true).
concept_accession('1286: rn:R03724','KEGG','RN:R03724',true).
concept_accession('40373: rn:R04741','KEGG','171142',true).
concept_accession('40373: rn:R04741','KEGG','RNO:171142',true).
concept_accession('40373: rn:R04741','KEGG','1.1.1.211',true).
concept_accession('40373: rn:R04741','EC','1.1.1.211',true).
concept_accession('40373: rn:R04741','KEGG','RNO:113965',true).
concept_accession('40373: rn:R04741','KEGG','EC:1.1.1.211',true).
concept_accession('40373: rn:R04741','KEGG','113965',true).
concept_accession('40372: rn:R03857','KEGG','1.3.3.6',true).
concept_accession('40372: rn:R03857','KEGG','EC:1.3.3.6',true).
concept_accession('40372: rn:R03857','EC','1.3.3.6',true).
concept_accession('40372: rn:R03857','KEGG','RNO:24158',true).
concept_accession('40372: rn:R03857','KEGG','24158',true).
concept_accession('40375: rn:R04742','KEGG','EC:2.3.1.16',true).
concept_accession('40375: rn:R04742','KEGG','24157',true).
concept_accession('40375: rn:R04742','KEGG','501072',true).
concept_accession('40375: rn:R04742','KEGG','RNO:171155',true).
concept_accession('40375: rn:R04742','KEGG','RNO:24157',true).
concept_accession('40375: rn:R04742','KEGG','171155',true).
concept_accession('40375: rn:R04742','KEGG','RNO:501072',true).
concept_accession('40375: rn:R04742','KEGG','2.3.1.16',true).
concept_accession('40375: rn:R04742','EC','2.3.1.16',true).
concept_accession('40375: rn:R04742','KEGG','RNO:170465',true).
concept_accession('40375: rn:R04742','KEGG','170465',true).
concept_accession('1285: rn:R04667','KEGG','R04667',true).
concept_accession('1285: rn:R04667','KEGG','RP:RP04309',true).
concept_accession('1285: rn:R04667','KEGG','RP04309',true).
concept_accession('1285: rn:R04667','KEGG','RN:R04667',true).
concept_accession('1285: rn:R04667','KEGG','RC:RC00904',true).
concept_accession('1285: rn:R04667','KEGG','RC00904',true).
concept_accession('40374: rn:R04170','KEGG','RNO:170670',true).
concept_accession('40374: rn:R04170','KEGG','171142',true).
concept_accession('40374: rn:R04170','KEGG','RNO:171142',true).
concept_accession('40374: rn:R04170','KEGG','170670',true).
concept_accession('40374: rn:R04170','EC','4.2.1.74',true).
concept_accession('40374: rn:R04170','KEGG','RNO:140547',true).
concept_accession('40374: rn:R04170','KEGG','EC:4.2.1.74',true).
concept_accession('40374: rn:R04170','KEGG','140547',true).
concept_accession('40374: rn:R04170','KEGG','4.2.1.74',true).
concept_accession('40330: rn:R03199','KEGG','RNO:81681',true).
concept_accession('40330: rn:R03199','EC','5.4.99.7',true).
concept_accession('40330: rn:R03199','KEGG','81681',true).
concept_accession('40330: rn:R03199','KEGG','EC:5.4.99.7',true).
concept_accession('40330: rn:R03199','KEGG','5.4.99.7',true).
concept_accession('40331: rn:R02874','KEGG','1.14.99.7',true).
concept_accession('40331: rn:R02874','KEGG','EC:1.14.99.7',true).
concept_accession('40331: rn:R02874','KEGG','29230',true).
concept_accession('40331: rn:R02874','EC','1.14.99.7',true).
concept_accession('40331: rn:R02874','KEGG','RNO:29230',true).
concept_accession('1339: rn:R02797','KEGG','RN:R02797',true).
concept_accession('1339: rn:R02797','KEGG','RP00523',true).
concept_accession('1339: rn:R02797','KEGG','RP:RP00523',true).
concept_accession('1339: rn:R02797','KEGG','RC:RC00096',true).
concept_accession('1339: rn:R02797','KEGG','RP:RP02508',true).
concept_accession('1339: rn:R02797','KEGG','R02797',true).
concept_accession('1339: rn:R02797','KEGG','RP02508',true).
concept_accession('1339: rn:R02797','KEGG','RC:RC00090',true).
concept_accession('1339: rn:R02797','KEGG','3.5.1.24',true).
concept_accession('1339: rn:R02797','EC','3.5.1.24',false).
concept_accession('1339: rn:R02797','KEGG','RC00090',true).
concept_accession('1339: rn:R02797','KEGG','RC00096',true).
concept_accession('1339: rn:R02797','KEGG','EC:3.5.1.24',true).
concept_accession('40328: rn:R07484','KEGG','117278',true).
concept_accession('40328: rn:R07484','KEGG','EC:5.3.3.5',true).
concept_accession('40328: rn:R07484','KEGG','RNO:117278',true).
concept_accession('40328: rn:R07484','EC','5.3.3.5',true).
concept_accession('40328: rn:R07484','KEGG','5.3.3.5',true).
concept_accession('1338: rn:R05835','KEGG','RP05418',true).
concept_accession('1338: rn:R05835','KEGG','RN:R05835',true).
concept_accession('1338: rn:R05835','KEGG','RC:RC00096',true).
concept_accession('1338: rn:R05835','KEGG','RP00707',true).
concept_accession('1338: rn:R05835','KEGG','R05835',true).
concept_accession('1338: rn:R05835','KEGG','RP:RP00707',true).
concept_accession('1338: rn:R05835','KEGG','RC:RC00090',true).
concept_accession('1338: rn:R05835','KEGG','3.5.1.24',true).
concept_accession('1338: rn:R05835','EC','3.5.1.24',false).
concept_accession('1338: rn:R05835','KEGG','RC00090',true).
concept_accession('1338: rn:R05835','KEGG','RP:RP05418',true).
concept_accession('1338: rn:R05835','KEGG','RC00096',true).
concept_accession('1338: rn:R05835','KEGG','EC:3.5.1.24',true).
concept_accession('40329: rn:R05639','EC','1.3.1.70',true).
concept_accession('40329: rn:R05639','KEGG','EC:1.3.1.70',true).
concept_accession('40329: rn:R05639','KEGG','1.3.1.70',true).
concept_accession('40329: rn:R05639','KEGG','RNO:293688',true).
concept_accession('40329: rn:R05639','KEGG','293688',true).
concept_accession('40334: rn:R07488','KEGG','EC:1.3.1.72',true).
concept_accession('40334: rn:R07488','KEGG','298298',true).
concept_accession('40334: rn:R07488','EC','1.3.1.72',true).
concept_accession('40334: rn:R07488','KEGG','1.3.1.72',true).
concept_accession('40334: rn:R07488','KEGG','RNO:298298',true).
concept_accession('40335: rn:R05731','KEGG','EC:1.14.13.70',true).
concept_accession('40335: rn:R05731','KEGG','1.14.13.70',true).
concept_accession('40335: rn:R05731','EC','1.14.13.70',true).
concept_accession('40335: rn:R05731','KEGG','RNO:25427',true).
concept_accession('40335: rn:R05731','KEGG','25427',true).
concept_accession('40332: rn:R02872','KEGG','2.5.1.21',true).
concept_accession('40332: rn:R02872','KEGG','RNO:29580',true).
concept_accession('40332: rn:R02872','KEGG','EC:2.5.1.21',true).
concept_accession('40332: rn:R02872','EC','2.5.1.21',true).
concept_accession('40332: rn:R02872','KEGG','29580',true).
concept_accession('40333: rn:R00702','KEGG','2.5.1.21',true).
concept_accession('40333: rn:R00702','KEGG','RNO:29580',true).
concept_accession('40333: rn:R00702','KEGG','EC:2.5.1.21',true).
concept_accession('40333: rn:R00702','EC','2.5.1.21',true).
concept_accession('40333: rn:R00702','KEGG','29580',true).
concept_accession('40322: rn:R03610','KEGG','114700',true).
concept_accession('40322: rn:R03610','KEGG','1.14.13.13',true).
concept_accession('40322: rn:R03610','KEGG','EC:1.14.13.13',true).
concept_accession('40322: rn:R03610','KEGG','RNO:114700',true).
concept_accession('40322: rn:R03610','EC','1.14.13.13',true).
concept_accession('40323: rn:R07509','KEGG','691221',true).
concept_accession('40323: rn:R07509','KEGG','1.14.13.72',true).
concept_accession('40323: rn:R07509','EC','1.14.13.72',true).
concept_accession('40323: rn:R07509','KEGG','EC:1.14.13.72',true).
concept_accession('40323: rn:R07509','KEGG','140910',true).
concept_accession('40323: rn:R07509','KEGG','RNO:691221',true).
concept_accession('40323: rn:R07509','KEGG','RNO:140910',true).
concept_accession('5120: rn:R00486','KEGG','3.5.5.4',true).
concept_accession('5120: rn:R00486','KEGG','EC:3.5.5.4',true).
concept_accession('5120: rn:R00486','EC','3.5.5.4',false).
concept_accession('5120: rn:R00486','KEGG','RC00315',true).
concept_accession('5120: rn:R00486','KEGG','RP00934',true).
concept_accession('5120: rn:R00486','KEGG','R00486',true).
concept_accession('5120: rn:R00486','KEGG','RN:R00486',true).
concept_accession('5120: rn:R00486','KEGG','RP:RP00934',true).
concept_accession('5120: rn:R00486','KEGG','RC:RC00315',true).
concept_accession('40320: rn:R01461','KEGG','RNO:266770',true).
concept_accession('40320: rn:R01461','KEGG','RNO:81782',true).
concept_accession('40320: rn:R01461','KEGG','EC:2.3.1.26',true).
concept_accession('40320: rn:R01461','KEGG','81782',true).
concept_accession('40320: rn:R01461','KEGG','2.3.1.26',true).
concept_accession('40320: rn:R01461','KEGG','266770',true).
concept_accession('40320: rn:R01461','EC','2.3.1.26',true).
concept_accession('40321: rn:R03611','KEGG','RNO:361631',true).
concept_accession('40321: rn:R03611','KEGG','361631',true).
concept_accession('40326: rn:R07494','KEGG','RNO:309262',true).
concept_accession('40326: rn:R07494','EC','1.1.1.170',true).
concept_accession('40326: rn:R07494','KEGG','1.1.1.170',true).
concept_accession('40326: rn:R07494','KEGG','309262',true).
concept_accession('40326: rn:R07494','KEGG','EC:1.1.1.170',true).
concept_accession('5125: rn:R01267','KEGG','RC00483',true).
concept_accession('5125: rn:R01267','KEGG','RP01396',true).
concept_accession('5125: rn:R01267','KEGG','EC:4.2.1.65',true).
concept_accession('5125: rn:R01267','KEGG','RP:RP01396',true).
concept_accession('5125: rn:R01267','KEGG','RN:R01267',true).
concept_accession('5125: rn:R01267','KEGG','RC:RC00483',true).
concept_accession('5125: rn:R01267','EC','4.2.1.65',false).
concept_accession('5125: rn:R01267','KEGG','4.2.1.65',true).
concept_accession('5125: rn:R01267','KEGG','R01267',true).
concept_accession('40327: rn:R07495','KEGG','29540',true).
concept_accession('40327: rn:R07495','KEGG','RNO:29540',true).
concept_accession('40327: rn:R07495','EC','1.1.1.270',true).
concept_accession('40327: rn:R07495','KEGG','1.1.1.270',true).
concept_accession('40327: rn:R07495','KEGG','EC:1.1.1.270',true).
concept_accession('40324: rn:R05640','KEGG','EC:1.14.13.70',true).
concept_accession('40324: rn:R05640','KEGG','1.14.13.70',true).
concept_accession('40324: rn:R05640','EC','1.14.13.70',true).
concept_accession('40324: rn:R05640','KEGG','RNO:25427',true).
concept_accession('40324: rn:R05640','KEGG','25427',true).
concept_accession('40325: rn:R03689','KEGG','EC:1.3.1.72',true).
concept_accession('40325: rn:R03689','KEGG','298298',true).
concept_accession('40325: rn:R03689','EC','1.3.1.72',true).
concept_accession('40325: rn:R03689','KEGG','1.3.1.72',true).
concept_accession('40325: rn:R03689','KEGG','RNO:298298',true).
concept_accession('40347: rn:R07492','KEGG','RNO:64191',true).
concept_accession('40347: rn:R07492','KEGG','64191',true).
concept_accession('40347: rn:R07492','KEGG','1.3.1.21',true).
concept_accession('40347: rn:R07492','KEGG','EC:1.3.1.21',true).
concept_accession('40347: rn:R07492','EC','1.3.1.21',true).
concept_accession('40346: rn:R07491','KEGG','EC:1.14.21.6',true).
concept_accession('40346: rn:R07491','KEGG','1.14.21.6',true).
concept_accession('40346: rn:R07491','KEGG','114100',true).
concept_accession('40346: rn:R07491','KEGG','RNO:114100',true).
concept_accession('40346: rn:R07491','EC','1.14.21.6',true).
concept_accession('40345: rn:R07493','KEGG','EC:1.3.1.72',true).
concept_accession('40345: rn:R07493','KEGG','298298',true).
concept_accession('40345: rn:R07493','EC','1.3.1.72',true).
concept_accession('40345: rn:R07493','KEGG','1.3.1.72',true).
concept_accession('40345: rn:R07493','KEGG','RNO:298298',true).
concept_accession('40344: rn:R05703','KEGG','EC:1.3.1.72',true).
concept_accession('40344: rn:R05703','KEGG','298298',true).
concept_accession('40344: rn:R05703','EC','1.3.1.72',true).
concept_accession('40344: rn:R05703','KEGG','1.3.1.72',true).
concept_accession('40344: rn:R05703','KEGG','RNO:298298',true).
concept_accession('40351: rn:R07486','KEGG','EC:1.14.21.6',true).
concept_accession('40351: rn:R07486','KEGG','1.14.21.6',true).
concept_accession('40351: rn:R07486','KEGG','114100',true).
concept_accession('40351: rn:R07486','KEGG','RNO:114100',true).
concept_accession('40351: rn:R07486','EC','1.14.21.6',true).
concept_accession('40350: rn:R01360','KEGG','EC:4.1.3.4',true).
concept_accession('40350: rn:R01360','KEGG','79238',true).
concept_accession('40350: rn:R01360','EC','4.1.3.4',true).
concept_accession('40350: rn:R01360','KEGG','RNO:79238',true).
concept_accession('40350: rn:R01360','KEGG','4.1.3.4',true).
concept_accession('40349: rn:R01978','KEGG','EC:2.3.3.10',true).
concept_accession('40349: rn:R01978','KEGG','RNO:29637',true).
concept_accession('40349: rn:R01978','KEGG','RNO:24450',true).
concept_accession('40349: rn:R01978','KEGG','2.3.3.10',true).
concept_accession('40349: rn:R01978','KEGG','24450',true).
concept_accession('40349: rn:R01978','EC','2.3.3.10',true).
concept_accession('40349: rn:R01978','KEGG','29637',true).
concept_accession('1327: rn:R03975','KEGG','RC:RC00096',true).
concept_accession('1327: rn:R03975','KEGG','RN:R03975',true).
concept_accession('1327: rn:R03975','KEGG','R03975',true).
concept_accession('1327: rn:R03975','KEGG','RC:RC00090',true).
concept_accession('1327: rn:R03975','KEGG','3.5.1.24',true).
concept_accession('1327: rn:R03975','KEGG','RP03594',true).
concept_accession('1327: rn:R03975','KEGG','RP03593',true).
concept_accession('1327: rn:R03975','EC','3.5.1.24',false).
concept_accession('1327: rn:R03975','KEGG','RP:RP03593',true).
concept_accession('1327: rn:R03975','KEGG','RP:RP03594',true).
concept_accession('1327: rn:R03975','KEGG','RC00090',true).
concept_accession('1327: rn:R03975','KEGG','RC00096',true).
concept_accession('1327: rn:R03975','KEGG','EC:3.5.1.24',true).
concept_accession('40348: rn:R00238','KEGG','2.3.1.9',true).
concept_accession('40348: rn:R00238','KEGG','EC:2.3.1.9',true).
concept_accession('40348: rn:R00238','EC','2.3.1.9',true).
concept_accession('40348: rn:R00238','KEGG','RNO:308100',true).
concept_accession('40348: rn:R00238','KEGG','RNO:25014',true).
concept_accession('40348: rn:R00238','KEGG','25014',true).
concept_accession('40348: rn:R00238','KEGG','308100',true).
concept_accession('40339: rn:R03353','KEGG','117278',true).
concept_accession('40339: rn:R03353','KEGG','EC:5.3.3.5',true).
concept_accession('40339: rn:R03353','KEGG','RNO:117278',true).
concept_accession('40339: rn:R03353','EC','5.3.3.5',true).
concept_accession('40339: rn:R03353','KEGG','5.3.3.5',true).
concept_accession('40338: rn:R07487','KEGG','RNO:64191',true).
concept_accession('40338: rn:R07487','KEGG','64191',true).
concept_accession('40338: rn:R07487','KEGG','1.3.1.21',true).
concept_accession('40338: rn:R07487','KEGG','EC:1.3.1.21',true).
concept_accession('40338: rn:R07487','EC','1.3.1.21',true).
concept_accession('40337: rn:R07499','KEGG','EC:1.3.1.72',true).
concept_accession('40337: rn:R07499','KEGG','298298',true).
concept_accession('40337: rn:R07499','EC','1.3.1.72',true).
concept_accession('40337: rn:R07499','KEGG','1.3.1.72',true).
concept_accession('40337: rn:R07499','KEGG','RNO:298298',true).
concept_accession('1315: rn:R04824 rn:R04825','KEGG','EC:1.1.1.50',true).
concept_accession('1315: rn:R04824 rn:R04825','KEGG','RC:RC00144',true).
concept_accession('1315: rn:R04824 rn:R04825','KEGG','R04825',true).
concept_accession('1315: rn:R04824 rn:R04825','KEGG','R04824',true).
concept_accession('1315: rn:R04824 rn:R04825','EC','1.1.1.50',false).
concept_accession('1315: rn:R04824 rn:R04825','KEGG','RC00144',true).
concept_accession('1315: rn:R04824 rn:R04825','KEGG','RP:RP09136',true).
concept_accession('1315: rn:R04824 rn:R04825','KEGG','RN:R04825',true).
concept_accession('1315: rn:R04824 rn:R04825','KEGG','RP09136',true).
concept_accession('1315: rn:R04824 rn:R04825','KEGG','RN:R04824',true).
concept_accession('1315: rn:R04824 rn:R04825','KEGG','1.1.1.50',true).
concept_accession('40336: rn:R07483','EC','1.3.1.70',true).
concept_accession('40336: rn:R07483','KEGG','EC:1.3.1.70',true).
concept_accession('40336: rn:R07483','KEGG','1.3.1.70',true).
concept_accession('40336: rn:R07483','KEGG','RNO:293688',true).
concept_accession('40336: rn:R07483','KEGG','293688',true).
concept_accession('40343: rn:R07498','KEGG','EC:1.3.1.72',true).
concept_accession('40343: rn:R07498','KEGG','298298',true).
concept_accession('40343: rn:R07498','EC','1.3.1.72',true).
concept_accession('40343: rn:R07498','KEGG','1.3.1.72',true).
concept_accession('40343: rn:R07498','KEGG','RNO:298298',true).
concept_accession('40342: rn:R01457','KEGG','EC:1.3.1.72',true).
concept_accession('40342: rn:R01457','KEGG','298298',true).
concept_accession('40342: rn:R01457','EC','1.3.1.72',true).
concept_accession('40342: rn:R01457','KEGG','1.3.1.72',true).
concept_accession('40342: rn:R01457','KEGG','RNO:298298',true).
concept_accession('40341: rn:R07507','KEGG','EC:1.3.1.72',true).
concept_accession('40341: rn:R07507','KEGG','298298',true).
concept_accession('40341: rn:R07507','EC','1.3.1.72',true).
concept_accession('40341: rn:R07507','KEGG','1.3.1.72',true).
concept_accession('40341: rn:R07507','KEGG','RNO:298298',true).
concept_accession('1319: rn:R04818 rn:R04819','KEGG','EC:1.1.1.50',true).
concept_accession('1319: rn:R04818 rn:R04819','KEGG','RC:RC00144',true).
concept_accession('1319: rn:R04818 rn:R04819','EC','1.1.1.50',false).
concept_accession('1319: rn:R04818 rn:R04819','KEGG','RC00144',true).
concept_accession('1319: rn:R04818 rn:R04819','KEGG','RN:R04819',true).
concept_accession('1319: rn:R04818 rn:R04819','KEGG','RP:RP00786',true).
concept_accession('1319: rn:R04818 rn:R04819','KEGG','RN:R04818',true).
concept_accession('1319: rn:R04818 rn:R04819','KEGG','R04819',true).
concept_accession('1319: rn:R04818 rn:R04819','KEGG','1.1.1.50',true).
concept_accession('1319: rn:R04818 rn:R04819','KEGG','RP00786',true).
concept_accession('1319: rn:R04818 rn:R04819','KEGG','R04818',true).
concept_accession('40340: rn:R03310 rn:R07215','KEGG','EC:1.14.21.6',true).
concept_accession('40340: rn:R03310 rn:R07215','KEGG','1.14.21.6',true).
concept_accession('40340: rn:R03310 rn:R07215','KEGG','114100',true).
concept_accession('40340: rn:R03310 rn:R07215','KEGG','RNO:114100',true).
concept_accession('40340: rn:R03310 rn:R07215','EC','1.14.21.6',true).
concept_accession('40293: rn:R02794','KEGG','EC:6.2.1.7',true).
concept_accession('40293: rn:R02794','EC','6.2.1.7',true).
concept_accession('40293: rn:R02794','KEGG','RNO:79111',true).
concept_accession('40293: rn:R02794','KEGG','79111',true).
concept_accession('40293: rn:R02794','KEGG','6.2.1.7',true).
concept_accession('5350: rn:R03821','KEGG','RP:RP03447',true).
concept_accession('5350: rn:R03821','KEGG','EC:1.8.1.12',true).
concept_accession('5350: rn:R03821','KEGG','RN:R03821',true).
concept_accession('5350: rn:R03821','KEGG','RP03447',true).
concept_accession('5350: rn:R03821','EC','1.8.1.12',false).
concept_accession('5350: rn:R03821','KEGG','RC:RC01003',true).
concept_accession('5350: rn:R03821','KEGG','R03821',true).
concept_accession('5350: rn:R03821','KEGG','RC01003',true).
concept_accession('5350: rn:R03821','KEGG','1.8.1.12',true).
concept_accession('40292: rn:R08745','KEGG','RNO:29725',true).
concept_accession('40292: rn:R08745','KEGG','EC:2.3.1.65',true).
concept_accession('40292: rn:R08745','KEGG','29725',true).
concept_accession('40292: rn:R08745','KEGG','2.3.1.65',true).
concept_accession('40292: rn:R08745','EC','2.3.1.65',true).
concept_accession('40295: rn:R01463','KEGG','1.14.13.17',true).
concept_accession('40295: rn:R01463','EC','1.14.13.17',true).
concept_accession('40295: rn:R01463','KEGG','EC:1.14.13.17',true).
concept_accession('40295: rn:R01463','KEGG','RNO:25428',true).
concept_accession('40295: rn:R01463','KEGG','25428',true).
concept_accession('40294: rn:R03718','KEGG','RNO:29725',true).
concept_accession('40294: rn:R03718','KEGG','EC:2.3.1.65',true).
concept_accession('40294: rn:R03718','KEGG','29725',true).
concept_accession('40294: rn:R03718','KEGG','2.3.1.65',true).
concept_accession('40294: rn:R03718','EC','2.3.1.65',true).
concept_accession('40289: rn:R03720','KEGG','RNO:29725',true).
concept_accession('40289: rn:R03720','KEGG','EC:2.3.1.65',true).
concept_accession('40289: rn:R03720','KEGG','29725',true).
concept_accession('40289: rn:R03720','KEGG','2.3.1.65',true).
concept_accession('40289: rn:R03720','EC','2.3.1.65',true).
concept_accession('5346: rn:R08354','KEGG','RP12921',true).
concept_accession('5346: rn:R08354','KEGG','RC:RC00096',true).
concept_accession('5346: rn:R08354','KEGG','EC:6.3.1.9',true).
concept_accession('5346: rn:R08354','KEGG','RC:RC00090',true).
concept_accession('5346: rn:R08354','KEGG','R08354',true).
concept_accession('5346: rn:R08354','EC','6.3.1.9',false).
concept_accession('5346: rn:R08354','KEGG','RP13222',true).
concept_accession('5346: rn:R08354','KEGG','RP:RP12921',true).
concept_accession('5346: rn:R08354','KEGG','RP:RP13222',true).
concept_accession('5346: rn:R08354','KEGG','RN:R08354',true).
concept_accession('5346: rn:R08354','KEGG','RC00090',true).
concept_accession('5346: rn:R08354','KEGG','RC00096',true).
concept_accession('5346: rn:R08354','KEGG','6.3.1.9',true).
concept_accession('40288: rn:R08760','KEGG','1.14.13.15',true).
concept_accession('40288: rn:R08760','KEGG','RNO:301517',true).
concept_accession('40288: rn:R08760','EC','1.14.13.15',true).
concept_accession('40288: rn:R08760','KEGG','EC:1.14.13.15',true).
concept_accession('40288: rn:R08760','KEGG','301517',true).
concept_accession('40291: rn:R07208','KEGG','301264',true).
concept_accession('40291: rn:R07208','KEGG','1.14.13.99',true).
concept_accession('40291: rn:R07208','EC','1.14.13.99',true).
concept_accession('40291: rn:R07208','KEGG','RNO:301264',true).
concept_accession('40291: rn:R07208','KEGG','EC:1.14.13.99',true).
concept_accession('40290: rn:R04826','KEGG','RNO:81924',true).
concept_accession('40290: rn:R04826','EC','1.14.13.96',true).
concept_accession('40290: rn:R04826','KEGG','81924',true).
concept_accession('40290: rn:R04826','KEGG','1.14.13.96',true).
concept_accession('40290: rn:R04826','KEGG','EC:1.14.13.96',true).
concept_accession('40301: rn:R04811','KEGG','EC:2.3.1.176',true).
concept_accession('40301: rn:R04811','EC','2.3.1.176',true).
concept_accession('40301: rn:R04811','KEGG','25541',true).
concept_accession('40301: rn:R04811','KEGG','2.3.1.176',true).
concept_accession('40301: rn:R04811','KEGG','RNO:25541',true).
concept_accession('5358: rn:R08358','KEGG','RP00250',true).
concept_accession('5358: rn:R08358','KEGG','RP:RP00250',true).
concept_accession('5358: rn:R08358','KEGG','RC:RC00092',true).
concept_accession('5358: rn:R08358','KEGG','RC00092',true).
concept_accession('5358: rn:R08358','KEGG','R08358',true).
concept_accession('5358: rn:R08358','KEGG','RN:R08358',true).
concept_accession('40300: rn:R03719','KEGG','EC:2.3.1.176',true).
concept_accession('40300: rn:R03719','EC','2.3.1.176',true).
concept_accession('40300: rn:R03719','KEGG','25541',true).
concept_accession('40300: rn:R03719','KEGG','2.3.1.176',true).
concept_accession('40300: rn:R03719','KEGG','RNO:25541',true).
concept_accession('5359: rn:R08361','KEGG','RN:R08361',true).
concept_accession('5359: rn:R08361','KEGG','R08361',true).
concept_accession('40303: rn:R08505','KEGG','1.14.13.15',true).
concept_accession('40303: rn:R08505','KEGG','RNO:301517',true).
concept_accession('40303: rn:R08505','EC','1.14.13.15',true).
concept_accession('40303: rn:R08505','KEGG','EC:1.14.13.15',true).
concept_accession('40303: rn:R08505','KEGG','301517',true).
concept_accession('40302: rn:R08761','KEGG','1.14.13.15',true).
concept_accession('40302: rn:R08761','KEGG','RNO:301517',true).
concept_accession('40302: rn:R08761','EC','1.14.13.15',true).
concept_accession('40302: rn:R08761','KEGG','EC:1.14.13.15',true).
concept_accession('40302: rn:R08761','KEGG','301517',true).
concept_accession('40297: rn:R07218','KEGG','RNO:309527',true).
concept_accession('40297: rn:R07218','KEGG','1.14.99.38',true).
concept_accession('40297: rn:R07218','KEGG','309527',true).
concept_accession('40297: rn:R07218','EC','1.14.99.38',true).
concept_accession('40297: rn:R07218','KEGG','EC:1.14.99.38',true).
concept_accession('40296: rn:R04813','KEGG','RNO:79244',true).
concept_accession('40296: rn:R04813','KEGG','79244',true).
concept_accession('40296: rn:R04813','KEGG','EC:4.2.1.107',true).
concept_accession('40296: rn:R04813','KEGG','4.2.1.107',true).
concept_accession('40296: rn:R04813','EC','4.2.1.107',true).
concept_accession('40299: rn:R08744','KEGG','RNO:29725',true).
concept_accession('40299: rn:R08744','KEGG','EC:2.3.1.65',true).
concept_accession('40299: rn:R08744','KEGG','29725',true).
concept_accession('40299: rn:R08744','KEGG','2.3.1.65',true).
concept_accession('40299: rn:R08744','EC','2.3.1.65',true).
concept_accession('40298: rn:R08743','KEGG','EC:6.2.1.7',true).
concept_accession('40298: rn:R08743','EC','6.2.1.7',true).
concept_accession('40298: rn:R08743','KEGG','RNO:79111',true).
concept_accession('40298: rn:R08743','KEGG','79111',true).
concept_accession('40298: rn:R08743','KEGG','6.2.1.7',true).
concept_accession('40308: rn:R08724','KEGG','RNO:246211',true).
concept_accession('40308: rn:R08724','KEGG','246211',true).
concept_accession('40308: rn:R08724','EC','1.1.1.181',true).
concept_accession('40308: rn:R08724','KEGG','EC:1.1.1.181',true).
concept_accession('40308: rn:R08724','KEGG','1.1.1.181',true).
concept_accession('40309: rn:R07372','EC','1.14.13.100',true).
concept_accession('40309: rn:R07372','KEGG','EC:1.14.13.100',true).
concept_accession('40309: rn:R07372','KEGG','RNO:25428',true).
concept_accession('40309: rn:R07372','KEGG','25428',true).
concept_accession('40309: rn:R07372','KEGG','1.14.13.100',true).
concept_accession('40310: rn:R07372','EC','1.14.13.100',true).
concept_accession('40310: rn:R07372','KEGG','EC:1.14.13.100',true).
concept_accession('40310: rn:R07372','KEGG','25429',true).
concept_accession('40310: rn:R07372','KEGG','RNO:25429',true).
concept_accession('40310: rn:R07372','KEGG','1.14.13.100',true).
concept_accession('40311: rn:R07207','EC','1.14.13.98',true).
concept_accession('40311: rn:R07207','KEGG','362782',true).
concept_accession('40311: rn:R07207','KEGG','1.14.13.98',true).
concept_accession('40311: rn:R07207','KEGG','RNO:362782',true).
concept_accession('40311: rn:R07207','KEGG','EC:1.14.13.98',true).
concept_accession('40304: rn:R08759','KEGG','1.14.13.15',true).
concept_accession('40304: rn:R08759','KEGG','RNO:301517',true).
concept_accession('40304: rn:R08759','EC','1.14.13.15',true).
concept_accession('40304: rn:R08759','KEGG','EC:1.14.13.15',true).
concept_accession('40304: rn:R08759','KEGG','301517',true).
concept_accession('40305: rn:R04263','KEGG','RNO:246211',true).
concept_accession('40305: rn:R04263','KEGG','246211',true).
concept_accession('40305: rn:R04263','EC','1.1.1.181',true).
concept_accession('40305: rn:R04263','KEGG','EC:1.1.1.181',true).
concept_accession('40305: rn:R04263','KEGG','1.1.1.181',true).
concept_accession('40306: rn:R08723','KEGG','RNO:246211',true).
concept_accession('40306: rn:R08723','KEGG','246211',true).
concept_accession('40306: rn:R08723','EC','1.1.1.181',true).
concept_accession('40306: rn:R08723','KEGG','EC:1.1.1.181',true).
concept_accession('40306: rn:R08723','KEGG','1.1.1.181',true).
concept_accession('40307: rn:R08728','KEGG','RNO:246211',true).
concept_accession('40307: rn:R08728','KEGG','246211',true).
concept_accession('40307: rn:R08728','EC','1.1.1.181',true).
concept_accession('40307: rn:R08728','KEGG','EC:1.1.1.181',true).
concept_accession('40307: rn:R08728','KEGG','1.1.1.181',true).
concept_accession('40316: rn:R08735','KEGG','1.17.99.3',true).
concept_accession('40316: rn:R08735','KEGG','EC:1.17.99.3',true).
concept_accession('40316: rn:R08735','KEGG','RNO:252898',true).
concept_accession('40316: rn:R08735','EC','1.17.99.3',true).
concept_accession('40316: rn:R08735','KEGG','252898',true).
concept_accession('40317: rn:R08734','EC','5.1.99.4',true).
concept_accession('40317: rn:R08734','KEGG','5.1.99.4',true).
concept_accession('40317: rn:R08734','KEGG','RNO:25284',true).
concept_accession('40317: rn:R08734','KEGG','25284',true).
concept_accession('40317: rn:R08734','KEGG','EC:5.1.99.4',true).
concept_accession('40318: rn:R04807','KEGG','1.14.13.15',true).
concept_accession('40318: rn:R04807','KEGG','RNO:301517',true).
concept_accession('40318: rn:R04807','EC','1.14.13.15',true).
concept_accession('40318: rn:R04807','KEGG','EC:1.14.13.15',true).
concept_accession('40318: rn:R04807','KEGG','301517',true).
concept_accession('40319: rn:R01462','KEGG','RNO:25055',true).
concept_accession('40319: rn:R01462','KEGG','EC:3.1.1.13',true).
concept_accession('40319: rn:R01462','KEGG','24254',true).
concept_accession('40319: rn:R01462','KEGG','3.1.1.13',true).
concept_accession('40319: rn:R01462','EC','3.1.1.13',true).
concept_accession('40319: rn:R01462','KEGG','25055',true).
concept_accession('40319: rn:R01462','KEGG','RNO:24254',true).
concept_accession('40312: rn:R04817','KEGG','RNO:192242',true).
concept_accession('40312: rn:R04817','KEGG','EC:1.3.1.3',true).
concept_accession('40312: rn:R04817','EC','1.3.1.3',true).
concept_accession('40312: rn:R04817','KEGG','1.3.1.3',true).
concept_accession('40312: rn:R04817','KEGG','192242',true).
concept_accession('40313: rn:R08725','KEGG','1.14.13.15',true).
concept_accession('40313: rn:R08725','KEGG','RNO:301517',true).
concept_accession('40313: rn:R08725','EC','1.14.13.15',true).
concept_accession('40313: rn:R08725','KEGG','EC:1.14.13.15',true).
concept_accession('40313: rn:R08725','KEGG','301517',true).
concept_accession('40314: rn:R08726','KEGG','1.14.13.15',true).
concept_accession('40314: rn:R08726','KEGG','RNO:301517',true).
concept_accession('40314: rn:R08726','EC','1.14.13.15',true).
concept_accession('40314: rn:R08726','KEGG','EC:1.14.13.15',true).
concept_accession('40314: rn:R08726','KEGG','301517',true).
concept_accession('40315: rn:R07209','EC','1.14.13.100',true).
concept_accession('40315: rn:R07209','KEGG','EC:1.14.13.100',true).
concept_accession('40315: rn:R07209','KEGG','25429',true).
concept_accession('40315: rn:R07209','KEGG','RNO:25429',true).
concept_accession('40315: rn:R07209','KEGG','1.14.13.100',true).
concept_accession('40263: rn:R02499','KEGG','EC:5.3.3.1',true).
concept_accession('40263: rn:R02499','KEGG','360348',true).
concept_accession('40263: rn:R02499','KEGG','RNO:24470',true).
concept_accession('40263: rn:R02499','KEGG','RNO:29632',true).
concept_accession('40263: rn:R02499','KEGG','RNO:360348',true).
concept_accession('40263: rn:R02499','KEGG','5.3.3.1',true).
concept_accession('40263: rn:R02499','KEGG','29632',true).
concept_accession('40263: rn:R02499','KEGG','24470',true).
concept_accession('40263: rn:R02499','EC','5.3.3.1',true).
concept_accession('40262: rn:R02499','KEGG','EC:5.3.3.1',true).
concept_accession('40262: rn:R02499','KEGG','360348',true).
concept_accession('40262: rn:R02499','KEGG','RNO:24470',true).
concept_accession('40262: rn:R02499','KEGG','RNO:29632',true).
concept_accession('40262: rn:R02499','KEGG','RNO:360348',true).
concept_accession('40262: rn:R02499','KEGG','5.3.3.1',true).
concept_accession('40262: rn:R02499','KEGG','29632',true).
concept_accession('40262: rn:R02499','KEGG','24470',true).
concept_accession('40262: rn:R02499','EC','5.3.3.1',true).
concept_accession('40261: rn:R04678','KEGG','EC:5.3.3.1',true).
concept_accession('40261: rn:R04678','KEGG','360348',true).
concept_accession('40261: rn:R04678','KEGG','RNO:24470',true).
concept_accession('40261: rn:R04678','KEGG','RNO:29632',true).
concept_accession('40261: rn:R04678','KEGG','RNO:360348',true).
concept_accession('40261: rn:R04678','KEGG','5.3.3.1',true).
concept_accession('40261: rn:R04678','KEGG','29632',true).
concept_accession('40261: rn:R04678','KEGG','24470',true).
concept_accession('40261: rn:R04678','EC','5.3.3.1',true).
concept_accession('5318: rn:R08358','KEGG','RP00250',true).
concept_accession('5318: rn:R08358','KEGG','RP:RP00250',true).
concept_accession('5318: rn:R08358','KEGG','RC:RC00092',true).
concept_accession('5318: rn:R08358','KEGG','RC00092',true).
concept_accession('5318: rn:R08358','KEGG','R08358',true).
concept_accession('5318: rn:R08358','KEGG','RN:R08358',true).
concept_accession('40260: rn:R04678','KEGG','EC:5.3.3.1',true).
concept_accession('40260: rn:R04678','KEGG','360348',true).
concept_accession('40260: rn:R04678','KEGG','RNO:24470',true).
concept_accession('40260: rn:R04678','KEGG','RNO:29632',true).
concept_accession('40260: rn:R04678','KEGG','RNO:360348',true).
concept_accession('40260: rn:R04678','KEGG','5.3.3.1',true).
concept_accession('40260: rn:R04678','KEGG','29632',true).
concept_accession('40260: rn:R04678','KEGG','24470',true).
concept_accession('40260: rn:R04678','EC','5.3.3.1',true).
concept_accession('40259: rn:R03408','EC','1.14.14.1',true).
concept_accession('40259: rn:R03408','KEGG','RNO:171352',true).
concept_accession('40259: rn:R03408','KEGG','252931',true).
concept_accession('40259: rn:R03408','KEGG','RNO:266682',true).
concept_accession('40259: rn:R03408','KEGG','EC:1.14.14.1',true).
concept_accession('40259: rn:R03408','KEGG','1.14.14.1',true).
concept_accession('40259: rn:R03408','KEGG','25642',true).
concept_accession('40259: rn:R03408','KEGG','RNO:25642',true).
concept_accession('40259: rn:R03408','KEGG','171352',true).
concept_accession('40259: rn:R03408','KEGG','266682',true).
concept_accession('40259: rn:R03408','KEGG','24296',true).
concept_accession('40259: rn:R03408','KEGG','RNO:24296',true).
concept_accession('40259: rn:R03408','KEGG','RNO:252931',true).
concept_accession('40258: rn:R03404','KEGG','3.1.6.2',true).
concept_accession('40258: rn:R03404','EC','3.1.6.2',true).
concept_accession('40258: rn:R03404','KEGG','EC:3.1.6.2',true).
concept_accession('40258: rn:R03404','KEGG','RNO:24800',true).
concept_accession('40258: rn:R03404','KEGG','24800',true).
concept_accession('40257: rn:R03405','KEGG','361510',true).
concept_accession('40257: rn:R03405','KEGG','2.8.2.2',true).
concept_accession('40257: rn:R03405','KEGG','RNO:292915',true).
concept_accession('40257: rn:R03405','KEGG','EC:2.8.2.2',true).
concept_accession('40257: rn:R03405','EC','2.8.2.2',true).
concept_accession('40257: rn:R03405','KEGG','292915',true).
concept_accession('40257: rn:R03405','KEGG','RNO:361510',true).
concept_accession('40256: rn:R03713','KEGG','RNO:192242',true).
concept_accession('40256: rn:R03713','KEGG','EC:1.3.1.3',true).
concept_accession('40256: rn:R03713','EC','1.3.1.3',true).
concept_accession('40256: rn:R03713','KEGG','1.3.1.3',true).
concept_accession('40256: rn:R03713','KEGG','192242',true).
concept_accession('40271: rn:R03848','KEGG','25116',true).
concept_accession('40271: rn:R03848','KEGG','RNO:25116',true).
concept_accession('40271: rn:R03848','KEGG','25117',true).
concept_accession('40271: rn:R03848','KEGG','RNO:25117',true).
concept_accession('40271: rn:R03848','KEGG','EC:1.1.1.-',true).
concept_accession('40271: rn:R03848','KEGG','1.1.1.-',true).
concept_accession('40271: rn:R03848','EC','1.1.1.-',true).
concept_accession('40270: rn:R02213','KEGG','24298',true).
concept_accession('40270: rn:R02213','KEGG','RNO:24298',true).
concept_accession('40270: rn:R02213','EC','1.14.99.10',true).
concept_accession('40270: rn:R02213','KEGG','1.14.99.10',true).
concept_accession('40270: rn:R02213','KEGG','EC:1.14.99.10',true).
concept_accession('40269: rn:R02207 rn:R02209','KEGG','171516',true).
concept_accession('40269: rn:R02207 rn:R02209','EC','1.1.1.149',true).
concept_accession('40269: rn:R02207 rn:R02209','KEGG','1.1.1.149',true).
concept_accession('40269: rn:R02207 rn:R02209','KEGG','RNO:171516',true).
concept_accession('40269: rn:R02207 rn:R02209','KEGG','EC:1.1.1.149',true).
concept_accession('40268: rn:R03851','KEGG','353498',true).
concept_accession('40268: rn:R03851','KEGG','RNO:24294',true).
concept_accession('40268: rn:R03851','KEGG','RNO:353498',true).
concept_accession('40268: rn:R03851','EC','1.14.15.4',true).
concept_accession('40268: rn:R03851','KEGG','1.14.15.4',true).
concept_accession('40268: rn:R03851','KEGG','24294',true).
concept_accession('40268: rn:R03851','KEGG','EC:1.14.15.4',true).
concept_accession('40267: rn:R08958','KEGG','171516',true).
concept_accession('40267: rn:R08958','EC','1.1.1.149',true).
concept_accession('40267: rn:R08958','KEGG','1.1.1.149',true).
concept_accession('40267: rn:R08958','KEGG','RNO:171516',true).
concept_accession('40267: rn:R08958','KEGG','EC:1.1.1.149',true).
concept_accession('40266: rn:R02219','KEGG','RNO:192242',true).
concept_accession('40266: rn:R02219','KEGG','EC:1.3.1.3',true).
concept_accession('40266: rn:R02219','EC','1.3.1.3',true).
concept_accession('40266: rn:R02219','KEGG','1.3.1.3',true).
concept_accession('40266: rn:R02219','KEGG','192242',true).
concept_accession('40265: rn:R02218','KEGG','353498',true).
concept_accession('40265: rn:R02218','KEGG','RNO:24294',true).
concept_accession('40265: rn:R02218','KEGG','RNO:353498',true).
concept_accession('40265: rn:R02218','EC','1.14.15.4',true).
concept_accession('40265: rn:R02218','KEGG','1.14.15.4',true).
concept_accession('40265: rn:R02218','KEGG','24294',true).
concept_accession('40265: rn:R02218','KEGG','EC:1.14.15.4',true).
concept_accession('40264: rn:R03849','KEGG','24298',true).
concept_accession('40264: rn:R03849','KEGG','RNO:24298',true).
concept_accession('40264: rn:R03849','EC','1.14.99.10',true).
concept_accession('40264: rn:R03849','KEGG','1.14.99.10',true).
concept_accession('40264: rn:R03849','KEGG','EC:1.14.99.10',true).
concept_accession('5323: rn:R08361','KEGG','RN:R08361',true).
concept_accession('5323: rn:R08361','KEGG','R08361',true).
concept_accession('40278: rn:R08721','KEGG','RNO:246211',true).
concept_accession('40278: rn:R08721','KEGG','246211',true).
concept_accession('40278: rn:R08721','EC','1.1.1.181',true).
concept_accession('40278: rn:R08721','KEGG','EC:1.1.1.181',true).
concept_accession('40278: rn:R08721','KEGG','1.1.1.181',true).
concept_accession('40279: rn:R08727','EC','1.14.13.100',true).
concept_accession('40279: rn:R08727','KEGG','EC:1.14.13.100',true).
concept_accession('40279: rn:R08727','KEGG','25429',true).
concept_accession('40279: rn:R08727','KEGG','RNO:25429',true).
concept_accession('40279: rn:R08727','KEGG','1.14.13.100',true).
concept_accession('40276: rn:R04812','KEGG','RNO:79244',true).
concept_accession('40276: rn:R04812','KEGG','79244',true).
concept_accession('40276: rn:R04812','EC','1.1.1.35',true).
concept_accession('40276: rn:R04812','KEGG','EC:1.1.1.35',true).
concept_accession('40276: rn:R04812','KEGG','1.1.1.35',true).
concept_accession('40277: rn:R04810','KEGG','RNO:79244',true).
concept_accession('40277: rn:R04810','KEGG','79244',true).
concept_accession('40277: rn:R04810','EC','1.1.1.35',true).
concept_accession('40277: rn:R04810','KEGG','EC:1.1.1.35',true).
concept_accession('40277: rn:R04810','KEGG','1.1.1.35',true).
concept_accession('40274: rn:R02352 rn:R02353','KEGG','RNO:286964',true).
concept_accession('40274: rn:R02352 rn:R02353','KEGG','361802',true).
concept_accession('40274: rn:R02352 rn:R02353','KEGG','84013',true).
concept_accession('40274: rn:R02352 rn:R02353','KEGG','RNO:84013',true).
concept_accession('40274: rn:R02352 rn:R02353','KEGG','RNO:79243',true).
concept_accession('40274: rn:R02352 rn:R02353','KEGG','RNO:25322',true).
concept_accession('40274: rn:R02352 rn:R02353','KEGG','286964',true).
concept_accession('40274: rn:R02352 rn:R02353','KEGG','EC:1.1.1.62',true).
concept_accession('40274: rn:R02352 rn:R02353','KEGG','29540',true).
concept_accession('40274: rn:R02352 rn:R02353','KEGG','79243',true).
concept_accession('40274: rn:R02352 rn:R02353','KEGG','RNO:29540',true).
concept_accession('40274: rn:R02352 rn:R02353','EC','1.1.1.62',true).
concept_accession('40274: rn:R02352 rn:R02353','KEGG','RNO:361802',true).
concept_accession('40274: rn:R02352 rn:R02353','KEGG','25322',true).
concept_accession('40274: rn:R02352 rn:R02353','KEGG','1.1.1.62',true).
concept_accession('40275: rn:R02521','KEGG','1.13.11.27',true).
concept_accession('40275: rn:R02521','KEGG','RNO:29531',true).
concept_accession('40275: rn:R02521','EC','1.13.11.27',true).
concept_accession('40275: rn:R02521','KEGG','29531',true).
concept_accession('40275: rn:R02521','KEGG','EC:1.13.11.27',true).
concept_accession('40272: rn:R04840','KEGG','25116',true).
concept_accession('40272: rn:R04840','KEGG','RNO:25116',true).
concept_accession('40272: rn:R04840','KEGG','25117',true).
concept_accession('40272: rn:R04840','KEGG','RNO:25117',true).
concept_accession('40272: rn:R04840','EC','1.1.1.146',true).
concept_accession('40272: rn:R04840','KEGG','EC:1.1.1.146',true).
concept_accession('40272: rn:R04840','KEGG','1.1.1.146',true).
concept_accession('40273: rn:R00734','KEGG','EC:2.6.1.5',true).
concept_accession('40273: rn:R00734','KEGG','RNO:24813',true).
concept_accession('40273: rn:R00734','EC','2.6.1.5',true).
concept_accession('40273: rn:R00734','KEGG','2.6.1.5',true).
concept_accession('40273: rn:R00734','KEGG','24813',true).
concept_accession('40286: rn:R04806','KEGG','1.14.13.15',true).
concept_accession('40286: rn:R04806','KEGG','RNO:301517',true).
concept_accession('40286: rn:R04806','EC','1.14.13.15',true).
concept_accession('40286: rn:R04806','KEGG','EC:1.14.13.15',true).
concept_accession('40286: rn:R04806','KEGG','301517',true).
concept_accession('40287: rn:R08758','KEGG','1.14.13.15',true).
concept_accession('40287: rn:R08758','KEGG','RNO:301517',true).
concept_accession('40287: rn:R08758','EC','1.14.13.15',true).
concept_accession('40287: rn:R08758','KEGG','EC:1.14.13.15',true).
concept_accession('40287: rn:R08758','KEGG','301517',true).
concept_accession('40284: rn:R08733','KEGG','EC:6.2.1.7',true).
concept_accession('40284: rn:R08733','EC','6.2.1.7',true).
concept_accession('40284: rn:R08733','KEGG','RNO:79111',true).
concept_accession('40284: rn:R08733','KEGG','79111',true).
concept_accession('40284: rn:R08733','KEGG','6.2.1.7',true).
concept_accession('5343: rn:R08352','KEGG','RP:RP12994',true).
concept_accession('5343: rn:R08352','KEGG','RC:RC00096',true).
concept_accession('5343: rn:R08352','KEGG','RN:R08352',true).
concept_accession('5343: rn:R08352','KEGG','RP:RP12919',true).
concept_accession('5343: rn:R08352','KEGG','EC:6.3.1.9',true).
concept_accession('5343: rn:R08352','KEGG','RC:RC00090',true).
concept_accession('5343: rn:R08352','KEGG','RP12919',true).
concept_accession('5343: rn:R08352','KEGG','RP12994',true).
concept_accession('5343: rn:R08352','EC','6.3.1.9',false).
concept_accession('5343: rn:R08352','KEGG','R08352',true).
concept_accession('5343: rn:R08352','KEGG','RC00090',true).
concept_accession('5343: rn:R08352','KEGG','RC00096',true).
concept_accession('5343: rn:R08352','KEGG','6.3.1.9',true).
concept_accession('40285: rn:R08738','KEGG','EC:6.2.1.7',true).
concept_accession('40285: rn:R08738','EC','6.2.1.7',true).
concept_accession('40285: rn:R08738','KEGG','RNO:79111',true).
concept_accession('40285: rn:R08738','KEGG','79111',true).
concept_accession('40285: rn:R08738','KEGG','6.2.1.7',true).
concept_accession('40282: rn:R08740','KEGG','1.17.99.3',true).
concept_accession('40282: rn:R08740','KEGG','EC:1.17.99.3',true).
concept_accession('40282: rn:R08740','KEGG','RNO:252898',true).
concept_accession('40282: rn:R08740','EC','1.17.99.3',true).
concept_accession('40282: rn:R08740','KEGG','252898',true).
concept_accession('40283: rn:R04809','KEGG','RNO:79244',true).
concept_accession('40283: rn:R04809','KEGG','79244',true).
concept_accession('40283: rn:R04809','KEGG','EC:4.2.1.107',true).
concept_accession('40283: rn:R04809','KEGG','4.2.1.107',true).
concept_accession('40283: rn:R04809','EC','4.2.1.107',true).
concept_accession('40280: rn:R04823','KEGG','RNO:192242',true).
concept_accession('40280: rn:R04823','KEGG','EC:1.3.1.3',true).
concept_accession('40280: rn:R04823','EC','1.3.1.3',true).
concept_accession('40280: rn:R04823','KEGG','1.3.1.3',true).
concept_accession('40280: rn:R04823','KEGG','192242',true).
concept_accession('5339: rn:R01917','KEGG','RP00445',true).
concept_accession('5339: rn:R01917','KEGG','RP:RP00445',true).
concept_accession('5339: rn:R01917','KEGG','RN:R01917',true).
concept_accession('5339: rn:R01917','KEGG','RC:RC00096',true).
concept_accession('5339: rn:R01917','KEGG','EC:6.3.1.9',true).
concept_accession('5339: rn:R01917','KEGG','RC:RC00090',true).
concept_accession('5339: rn:R01917','KEGG','RP00450',true).
concept_accession('5339: rn:R01917','EC','6.3.1.9',false).
concept_accession('5339: rn:R01917','KEGG','R01917',true).
concept_accession('5339: rn:R01917','KEGG','RC00090',true).
concept_accession('5339: rn:R01917','KEGG','RP:RP00450',true).
concept_accession('5339: rn:R01917','KEGG','RC00096',true).
concept_accession('5339: rn:R01917','KEGG','6.3.1.9',true).
concept_accession('40281: rn:R08739','EC','5.1.99.4',true).
concept_accession('40281: rn:R08739','KEGG','5.1.99.4',true).
concept_accession('40281: rn:R08739','KEGG','RNO:25284',true).
concept_accession('40281: rn:R08739','KEGG','25284',true).
concept_accession('40281: rn:R08739','KEGG','EC:5.1.99.4',true).
concept_accession('5338: rn:R01918','KEGG','RP00445',true).
concept_accession('5338: rn:R01918','KEGG','RP:RP00445',true).
concept_accession('5338: rn:R01918','KEGG','RN:R01918',true).
concept_accession('5338: rn:R01918','KEGG','RC:RC00096',true).
concept_accession('5338: rn:R01918','KEGG','RC:RC00090',true).
concept_accession('5338: rn:R01918','KEGG','RP00450',true).
concept_accession('5338: rn:R01918','KEGG','EC:3.5.1.-',true).
concept_accession('5338: rn:R01918','KEGG','R01918',true).
concept_accession('5338: rn:R01918','KEGG','3.5.1.-',true).
concept_accession('5338: rn:R01918','KEGG','RC00090',true).
concept_accession('5338: rn:R01918','EC','3.5.1.-',false).
concept_accession('5338: rn:R01918','KEGG','RP:RP00450',true).
concept_accession('5338: rn:R01918','KEGG','RC00096',true).
concept_accession('40225: rn:R03325','KEGG','171516',true).
concept_accession('40225: rn:R03325','EC','1.1.1.149',true).
concept_accession('40225: rn:R03325','KEGG','1.1.1.149',true).
concept_accession('40225: rn:R03325','KEGG','RNO:171516',true).
concept_accession('40225: rn:R03325','KEGG','EC:1.1.1.149',true).
concept_accession('40224: rn:R08961','KEGG','1.14.13.17',true).
concept_accession('40224: rn:R08961','EC','1.14.13.17',true).
concept_accession('40224: rn:R08961','KEGG','EC:1.14.13.17',true).
concept_accession('40224: rn:R08961','KEGG','RNO:25428',true).
concept_accession('40224: rn:R08961','KEGG','25428',true).
concept_accession('40227: rn:R04855','KEGG','EC:1.14.15.6',true).
concept_accession('40227: rn:R04855','KEGG','RNO:29680',true).
concept_accession('40227: rn:R04855','EC','1.14.15.6',true).
concept_accession('40227: rn:R04855','KEGG','29680',true).
concept_accession('40227: rn:R04855','KEGG','1.14.15.6',true).
concept_accession('40226: rn:R02723','KEGG','EC:1.14.15.6',true).
concept_accession('40226: rn:R02723','KEGG','RNO:29680',true).
concept_accession('40226: rn:R02723','EC','1.14.15.6',true).
concept_accession('40226: rn:R02723','KEGG','29680',true).
concept_accession('40226: rn:R02723','KEGG','1.14.15.6',true).
concept_accession('40229: rn:R08977','KEGG','361510',true).
concept_accession('40229: rn:R08977','KEGG','2.8.2.2',true).
concept_accession('40229: rn:R08977','KEGG','RNO:292915',true).
concept_accession('40229: rn:R08977','KEGG','EC:2.8.2.2',true).
concept_accession('40229: rn:R08977','EC','2.8.2.2',true).
concept_accession('40229: rn:R08977','KEGG','292915',true).
concept_accession('40229: rn:R08977','KEGG','RNO:361510',true).
concept_accession('5286: rn:R04950','EC','2.3.1.80',false).
concept_accession('5286: rn:R04950','KEGG','2.3.1.80',true).
concept_accession('5286: rn:R04950','KEGG','RC00064',true).
concept_accession('5286: rn:R04950','KEGG','RP04559',true).
concept_accession('5286: rn:R04950','KEGG','RN:R04950',true).
concept_accession('5286: rn:R04950','KEGG','EC:2.3.1.80',true).
concept_accession('5286: rn:R04950','KEGG','RC:RC00064',true).
concept_accession('5286: rn:R04950','KEGG','RP:RP04559',true).
concept_accession('5286: rn:R04950','KEGG','R04950',true).
concept_accession('40228: rn:R08941','KEGG','3.1.6.2',true).
concept_accession('40228: rn:R08941','EC','3.1.6.2',true).
concept_accession('40228: rn:R08941','KEGG','EC:3.1.6.2',true).
concept_accession('40228: rn:R08941','KEGG','RNO:24800',true).
concept_accession('40228: rn:R08941','KEGG','24800',true).
concept_accession('40231: rn:R03933','KEGG','EC:1.14.15.6',true).
concept_accession('40231: rn:R03933','KEGG','RNO:29680',true).
concept_accession('40231: rn:R03933','EC','1.14.15.6',true).
concept_accession('40231: rn:R03933','KEGG','29680',true).
concept_accession('40231: rn:R03933','KEGG','1.14.15.6',true).
concept_accession('40230: rn:R04676','KEGG','EC:1.14.15.6',true).
concept_accession('40230: rn:R04676','KEGG','RNO:29680',true).
concept_accession('40230: rn:R04676','EC','1.14.15.6',true).
concept_accession('40230: rn:R04676','KEGG','29680',true).
concept_accession('40230: rn:R04676','KEGG','1.14.15.6',true).
concept_accession('40233: rn:R04854','KEGG','EC:1.14.15.6',true).
concept_accession('40233: rn:R04854','KEGG','RNO:29680',true).
concept_accession('40233: rn:R04854','EC','1.14.15.6',true).
concept_accession('40233: rn:R04854','KEGG','29680',true).
concept_accession('40233: rn:R04854','KEGG','1.14.15.6',true).
concept_accession('40232: rn:R01454','KEGG','EC:1.14.15.6',true).
concept_accession('40232: rn:R01454','KEGG','RNO:29680',true).
concept_accession('40232: rn:R01454','EC','1.14.15.6',true).
concept_accession('40232: rn:R01454','KEGG','29680',true).
concept_accession('40232: rn:R01454','KEGG','1.14.15.6',true).
concept_accession('40235: rn:R03327','KEGG','EC:5.3.3.1',true).
concept_accession('40235: rn:R03327','KEGG','360348',true).
concept_accession('40235: rn:R03327','KEGG','RNO:24470',true).
concept_accession('40235: rn:R03327','KEGG','RNO:29632',true).
concept_accession('40235: rn:R03327','KEGG','RNO:360348',true).
concept_accession('40235: rn:R03327','KEGG','5.3.3.1',true).
concept_accession('40235: rn:R03327','KEGG','29632',true).
concept_accession('40235: rn:R03327','KEGG','24470',true).
concept_accession('40235: rn:R03327','EC','5.3.3.1',true).
concept_accession('5288: rn:R01917','KEGG','RP00445',true).
concept_accession('5288: rn:R01917','KEGG','RP:RP00445',true).
concept_accession('5288: rn:R01917','KEGG','RN:R01917',true).
concept_accession('5288: rn:R01917','KEGG','RC:RC00096',true).
concept_accession('5288: rn:R01917','KEGG','EC:6.3.1.9',true).
concept_accession('5288: rn:R01917','KEGG','RC:RC00090',true).
concept_accession('5288: rn:R01917','KEGG','RP00450',true).
concept_accession('5288: rn:R01917','EC','6.3.1.9',false).
concept_accession('5288: rn:R01917','KEGG','R01917',true).
concept_accession('5288: rn:R01917','KEGG','RC00090',true).
concept_accession('5288: rn:R01917','KEGG','RP:RP00450',true).
concept_accession('5288: rn:R01917','KEGG','RC00096',true).
concept_accession('5288: rn:R01917','KEGG','6.3.1.9',true).
concept_accession('40234: rn:R04849','KEGG','360348',true).
concept_accession('40234: rn:R04849','KEGG','RNO:24470',true).
concept_accession('40234: rn:R04849','KEGG','RNO:29632',true).
concept_accession('40234: rn:R04849','KEGG','RNO:360348',true).
concept_accession('40234: rn:R04849','EC','1.1.1.145',true).
concept_accession('40234: rn:R04849','KEGG','EC:1.1.1.145',true).
concept_accession('40234: rn:R04849','KEGG','29632',true).
concept_accession('40234: rn:R04849','KEGG','24470',true).
concept_accession('40234: rn:R04849','KEGG','1.1.1.145',true).
concept_accession('5289: rn:R01918','KEGG','RP00445',true).
concept_accession('5289: rn:R01918','KEGG','RP:RP00445',true).
concept_accession('5289: rn:R01918','KEGG','RN:R01918',true).
concept_accession('5289: rn:R01918','KEGG','RC:RC00096',true).
concept_accession('5289: rn:R01918','KEGG','RC:RC00090',true).
concept_accession('5289: rn:R01918','KEGG','RP00450',true).
concept_accession('5289: rn:R01918','KEGG','EC:3.5.1.-',true).
concept_accession('5289: rn:R01918','KEGG','R01918',true).
concept_accession('5289: rn:R01918','KEGG','3.5.1.-',true).
concept_accession('5289: rn:R01918','KEGG','RC00090',true).
concept_accession('5289: rn:R01918','EC','3.5.1.-',false).
concept_accession('5289: rn:R01918','KEGG','RP:RP00450',true).
concept_accession('5289: rn:R01918','KEGG','RC00096',true).
concept_accession('40237: rn:R02216','KEGG','360348',true).
concept_accession('40237: rn:R02216','KEGG','RNO:24470',true).
concept_accession('40237: rn:R02216','KEGG','RNO:29632',true).
concept_accession('40237: rn:R02216','KEGG','RNO:360348',true).
concept_accession('40237: rn:R02216','EC','1.1.1.145',true).
concept_accession('40237: rn:R02216','KEGG','EC:1.1.1.145',true).
concept_accession('40237: rn:R02216','KEGG','29632',true).
concept_accession('40237: rn:R02216','KEGG','24470',true).
concept_accession('40237: rn:R02216','KEGG','1.1.1.145',true).
concept_accession('40236: rn:R03327','KEGG','EC:5.3.3.1',true).
concept_accession('40236: rn:R03327','KEGG','360348',true).
concept_accession('40236: rn:R03327','KEGG','RNO:24470',true).
concept_accession('40236: rn:R03327','KEGG','RNO:29632',true).
concept_accession('40236: rn:R03327','KEGG','RNO:360348',true).
concept_accession('40236: rn:R03327','KEGG','5.3.3.1',true).
concept_accession('40236: rn:R03327','KEGG','29632',true).
concept_accession('40236: rn:R03327','KEGG','24470',true).
concept_accession('40236: rn:R03327','EC','5.3.3.1',true).
concept_accession('40239: rn:R02840','KEGG','EC:5.3.3.1',true).
concept_accession('40239: rn:R02840','KEGG','360348',true).
concept_accession('40239: rn:R02840','KEGG','RNO:24470',true).
concept_accession('40239: rn:R02840','KEGG','RNO:29632',true).
concept_accession('40239: rn:R02840','KEGG','RNO:360348',true).
concept_accession('40239: rn:R02840','KEGG','5.3.3.1',true).
concept_accession('40239: rn:R02840','KEGG','29632',true).
concept_accession('40239: rn:R02840','KEGG','24470',true).
concept_accession('40239: rn:R02840','EC','5.3.3.1',true).
concept_accession('40238: rn:R04850','KEGG','353498',true).
concept_accession('40238: rn:R04850','KEGG','RNO:24294',true).
concept_accession('40238: rn:R04850','KEGG','RNO:353498',true).
concept_accession('40238: rn:R04850','EC','1.14.15.4',true).
concept_accession('40238: rn:R04850','KEGG','1.14.15.4',true).
concept_accession('40238: rn:R04850','KEGG','24294',true).
concept_accession('40238: rn:R04850','KEGG','EC:1.14.15.4',true).
concept_accession('40240: rn:R02840','KEGG','EC:5.3.3.1',true).
concept_accession('40240: rn:R02840','KEGG','360348',true).
concept_accession('40240: rn:R02840','KEGG','RNO:24470',true).
concept_accession('40240: rn:R02840','KEGG','RNO:29632',true).
concept_accession('40240: rn:R02840','KEGG','RNO:360348',true).
concept_accession('40240: rn:R02840','KEGG','5.3.3.1',true).
concept_accession('40240: rn:R02840','KEGG','29632',true).
concept_accession('40240: rn:R02840','KEGG','24470',true).
concept_accession('40240: rn:R02840','EC','5.3.3.1',true).
concept_accession('40241: rn:R04849','KEGG','360348',true).
concept_accession('40241: rn:R04849','KEGG','RNO:24470',true).
concept_accession('40241: rn:R04849','KEGG','RNO:29632',true).
concept_accession('40241: rn:R04849','KEGG','RNO:360348',true).
concept_accession('40241: rn:R04849','EC','1.1.1.145',true).
concept_accession('40241: rn:R04849','KEGG','EC:1.1.1.145',true).
concept_accession('40241: rn:R04849','KEGG','29632',true).
concept_accession('40241: rn:R04849','KEGG','24470',true).
concept_accession('40241: rn:R04849','KEGG','1.1.1.145',true).
concept_accession('40242: rn:R04163','KEGG','360348',true).
concept_accession('40242: rn:R04163','KEGG','RNO:24470',true).
concept_accession('40242: rn:R04163','KEGG','RNO:29632',true).
concept_accession('40242: rn:R04163','KEGG','RNO:360348',true).
concept_accession('40242: rn:R04163','EC','1.1.1.145',true).
concept_accession('40242: rn:R04163','KEGG','EC:1.1.1.145',true).
concept_accession('40242: rn:R04163','KEGG','29632',true).
concept_accession('40242: rn:R04163','KEGG','24470',true).
concept_accession('40242: rn:R04163','KEGG','1.1.1.145',true).
concept_accession('40243: rn:R04163','KEGG','360348',true).
concept_accession('40243: rn:R04163','KEGG','RNO:24470',true).
concept_accession('40243: rn:R04163','KEGG','RNO:29632',true).
concept_accession('40243: rn:R04163','KEGG','RNO:360348',true).
concept_accession('40243: rn:R04163','EC','1.1.1.145',true).
concept_accession('40243: rn:R04163','KEGG','EC:1.1.1.145',true).
concept_accession('40243: rn:R04163','KEGG','29632',true).
concept_accession('40243: rn:R04163','KEGG','24470',true).
concept_accession('40243: rn:R04163','KEGG','1.1.1.145',true).
concept_accession('40244: rn:R03784','KEGG','24298',true).
concept_accession('40244: rn:R03784','KEGG','RNO:24298',true).
concept_accession('40244: rn:R03784','EC','1.14.99.10',true).
concept_accession('40244: rn:R03784','KEGG','1.14.99.10',true).
concept_accession('40244: rn:R03784','KEGG','EC:1.14.99.10',true).
concept_accession('40245: rn:R04853','KEGG','1.14.99.9',true).
concept_accession('40245: rn:R04853','KEGG','EC:1.14.99.9',true).
concept_accession('40245: rn:R04853','KEGG','RNO:25146',true).
concept_accession('40245: rn:R04853','EC','1.14.99.9',true).
concept_accession('40245: rn:R04853','KEGG','25146',true).
concept_accession('40246: rn:R02216','KEGG','360348',true).
concept_accession('40246: rn:R02216','KEGG','RNO:24470',true).
concept_accession('40246: rn:R02216','KEGG','RNO:29632',true).
concept_accession('40246: rn:R02216','KEGG','RNO:360348',true).
concept_accession('40246: rn:R02216','EC','1.1.1.145',true).
concept_accession('40246: rn:R02216','KEGG','EC:1.1.1.145',true).
concept_accession('40246: rn:R02216','KEGG','29632',true).
concept_accession('40246: rn:R02216','KEGG','24470',true).
concept_accession('40246: rn:R02216','KEGG','1.1.1.145',true).
concept_accession('40247: rn:R08978','KEGG','361510',true).
concept_accession('40247: rn:R08978','KEGG','2.8.2.2',true).
concept_accession('40247: rn:R08978','KEGG','RNO:292915',true).
concept_accession('40247: rn:R08978','KEGG','EC:2.8.2.2',true).
concept_accession('40247: rn:R08978','EC','2.8.2.2',true).
concept_accession('40247: rn:R08978','KEGG','292915',true).
concept_accession('40247: rn:R08978','KEGG','RNO:361510',true).
concept_accession('40248: rn:R08942','KEGG','3.1.6.2',true).
concept_accession('40248: rn:R08942','EC','3.1.6.2',true).
concept_accession('40248: rn:R08942','KEGG','EC:3.1.6.2',true).
concept_accession('40248: rn:R08942','KEGG','RNO:24800',true).
concept_accession('40248: rn:R08942','KEGG','24800',true).
concept_accession('40249: rn:R08943','EC','1.14.13.100',true).
concept_accession('40249: rn:R08943','KEGG','EC:1.14.13.100',true).
concept_accession('40249: rn:R08943','KEGG','25429',true).
concept_accession('40249: rn:R08943','KEGG','RNO:25429',true).
concept_accession('40249: rn:R08943','KEGG','1.14.13.100',true).
concept_accession('40250: rn:R04675','KEGG','24298',true).
concept_accession('40250: rn:R04675','KEGG','RNO:24298',true).
concept_accession('40250: rn:R04675','EC','1.14.99.10',true).
concept_accession('40250: rn:R04675','KEGG','1.14.99.10',true).
concept_accession('40250: rn:R04675','KEGG','EC:1.14.99.10',true).
concept_accession('40251: rn:R01837','KEGG','360348',true).
concept_accession('40251: rn:R01837','KEGG','RNO:24470',true).
concept_accession('40251: rn:R01837','KEGG','RNO:29632',true).
concept_accession('40251: rn:R01837','KEGG','RNO:360348',true).
concept_accession('40251: rn:R01837','EC','1.1.1.145',true).
concept_accession('40251: rn:R01837','KEGG','EC:1.1.1.145',true).
concept_accession('40251: rn:R01837','KEGG','29632',true).
concept_accession('40251: rn:R01837','KEGG','24470',true).
concept_accession('40251: rn:R01837','KEGG','1.1.1.145',true).
concept_accession('40252: rn:R01837','KEGG','360348',true).
concept_accession('40252: rn:R01837','KEGG','RNO:24470',true).
concept_accession('40252: rn:R01837','KEGG','RNO:29632',true).
concept_accession('40252: rn:R01837','KEGG','RNO:360348',true).
concept_accession('40252: rn:R01837','EC','1.1.1.145',true).
concept_accession('40252: rn:R01837','KEGG','EC:1.1.1.145',true).
concept_accession('40252: rn:R01837','KEGG','29632',true).
concept_accession('40252: rn:R01837','KEGG','24470',true).
concept_accession('40252: rn:R01837','KEGG','1.1.1.145',true).
concept_accession('40253: rn:R03783','KEGG','1.14.99.9',true).
concept_accession('40253: rn:R03783','KEGG','EC:1.14.99.9',true).
concept_accession('40253: rn:R03783','KEGG','RNO:25146',true).
concept_accession('40253: rn:R03783','EC','1.14.99.9',true).
concept_accession('40253: rn:R03783','KEGG','25146',true).
concept_accession('40254: rn:R08949','KEGG','353498',true).
concept_accession('40254: rn:R08949','KEGG','RNO:24294',true).
concept_accession('40254: rn:R08949','KEGG','RNO:353498',true).
concept_accession('40254: rn:R08949','EC','1.14.15.4',true).
concept_accession('40254: rn:R08949','KEGG','1.14.15.4',true).
concept_accession('40254: rn:R08949','KEGG','24294',true).
concept_accession('40254: rn:R08949','KEGG','EC:1.14.15.4',true).
concept_accession('40255: rn:R03262','KEGG','500892',true).
concept_accession('40255: rn:R03262','KEGG','RNO:500892',true).
concept_accession('40255: rn:R03262','KEGG','1.14.15.5',true).
concept_accession('40255: rn:R03262','EC','1.14.15.5',true).
concept_accession('40255: rn:R03262','KEGG','EC:1.14.15.5',true).
concept_accession('40195: rn:R08945 rn:R08980','KEGG','RNO:286964',true).
concept_accession('40195: rn:R08945 rn:R08980','KEGG','361802',true).
concept_accession('40195: rn:R08945 rn:R08980','KEGG','84013',true).
concept_accession('40195: rn:R08945 rn:R08980','KEGG','RNO:84013',true).
concept_accession('40195: rn:R08945 rn:R08980','KEGG','RNO:79243',true).
concept_accession('40195: rn:R08945 rn:R08980','KEGG','RNO:25322',true).
concept_accession('40195: rn:R08945 rn:R08980','KEGG','286964',true).
concept_accession('40195: rn:R08945 rn:R08980','KEGG','EC:1.1.1.62',true).
concept_accession('40195: rn:R08945 rn:R08980','KEGG','29540',true).
concept_accession('40195: rn:R08945 rn:R08980','KEGG','79243',true).
concept_accession('40195: rn:R08945 rn:R08980','KEGG','RNO:29540',true).
concept_accession('40195: rn:R08945 rn:R08980','EC','1.1.1.62',true).
concept_accession('40195: rn:R08945 rn:R08980','KEGG','RNO:361802',true).
concept_accession('40195: rn:R08945 rn:R08980','KEGG','25322',true).
concept_accession('40195: rn:R08945 rn:R08980','KEGG','1.1.1.62',true).
concept_accession('40194: rn:R03326','KEGG','24298',true).
concept_accession('40194: rn:R03326','KEGG','RNO:24298',true).
concept_accession('40194: rn:R03326','EC','1.14.99.10',true).
concept_accession('40194: rn:R03326','KEGG','1.14.99.10',true).
concept_accession('40194: rn:R03326','KEGG','EC:1.14.99.10',true).
concept_accession('40193: rn:R02841','KEGG','RNO:192242',true).
concept_accession('40193: rn:R02841','KEGG','EC:1.3.1.3',true).
concept_accession('40193: rn:R02841','EC','1.3.1.3',true).
concept_accession('40193: rn:R02841','KEGG','1.3.1.3',true).
concept_accession('40193: rn:R02841','KEGG','192242',true).
concept_accession('40192: rn:R02843','KEGG','353498',true).
concept_accession('40192: rn:R02843','KEGG','RNO:24294',true).
concept_accession('40192: rn:R02843','KEGG','RNO:353498',true).
concept_accession('40192: rn:R02843','EC','1.14.15.4',true).
concept_accession('40192: rn:R02843','KEGG','1.14.15.4',true).
concept_accession('40192: rn:R02843','KEGG','24294',true).
concept_accession('40192: rn:R02843','KEGG','EC:1.14.15.4',true).
concept_accession('40199: rn:R04681 rn:R04682','KEGG','RNO:286964',true).
concept_accession('40199: rn:R04681 rn:R04682','KEGG','361802',true).
concept_accession('40199: rn:R04681 rn:R04682','KEGG','84013',true).
concept_accession('40199: rn:R04681 rn:R04682','KEGG','RNO:84013',true).
concept_accession('40199: rn:R04681 rn:R04682','KEGG','RNO:79243',true).
concept_accession('40199: rn:R04681 rn:R04682','KEGG','RNO:25322',true).
concept_accession('40199: rn:R04681 rn:R04682','KEGG','286964',true).
concept_accession('40199: rn:R04681 rn:R04682','KEGG','EC:1.1.1.62',true).
concept_accession('40199: rn:R04681 rn:R04682','KEGG','29540',true).
concept_accession('40199: rn:R04681 rn:R04682','KEGG','79243',true).
concept_accession('40199: rn:R04681 rn:R04682','KEGG','RNO:29540',true).
concept_accession('40199: rn:R04681 rn:R04682','EC','1.1.1.62',true).
concept_accession('40199: rn:R04681 rn:R04682','KEGG','RNO:361802',true).
concept_accession('40199: rn:R04681 rn:R04682','KEGG','25322',true).
concept_accession('40199: rn:R04681 rn:R04682','KEGG','1.1.1.62',true).
concept_accession('40198: rn:R02211','KEGG','1.14.99.9',true).
concept_accession('40198: rn:R02211','KEGG','EC:1.14.99.9',true).
concept_accession('40198: rn:R02211','KEGG','RNO:25146',true).
concept_accession('40198: rn:R02211','EC','1.14.99.9',true).
concept_accession('40198: rn:R02211','KEGG','25146',true).
concept_accession('40197: rn:R02838','KEGG','24298',true).
concept_accession('40197: rn:R02838','KEGG','RNO:24298',true).
concept_accession('40197: rn:R02838','EC','1.14.99.10',true).
concept_accession('40197: rn:R02838','KEGG','1.14.99.10',true).
concept_accession('40197: rn:R02838','KEGG','EC:1.14.99.10',true).
concept_accession('40196: rn:R03329','KEGG','353498',true).
concept_accession('40196: rn:R03329','KEGG','RNO:24294',true).
concept_accession('40196: rn:R03329','KEGG','RNO:353498',true).
concept_accession('40196: rn:R03329','EC','1.14.15.4',true).
concept_accession('40196: rn:R03329','KEGG','1.14.15.4',true).
concept_accession('40196: rn:R03329','KEGG','24294',true).
concept_accession('40196: rn:R03329','KEGG','EC:1.14.15.4',true).
concept_accession('40203: rn:R02356','EC','1.14.14.1',true).
concept_accession('40203: rn:R02356','KEGG','RNO:171352',true).
concept_accession('40203: rn:R02356','KEGG','252931',true).
concept_accession('40203: rn:R02356','KEGG','RNO:266682',true).
concept_accession('40203: rn:R02356','KEGG','EC:1.14.14.1',true).
concept_accession('40203: rn:R02356','KEGG','1.14.14.1',true).
concept_accession('40203: rn:R02356','KEGG','25642',true).
concept_accession('40203: rn:R02356','KEGG','RNO:25642',true).
concept_accession('40203: rn:R02356','KEGG','171352',true).
concept_accession('40203: rn:R02356','KEGG','266682',true).
concept_accession('40203: rn:R02356','KEGG','24296',true).
concept_accession('40203: rn:R02356','KEGG','RNO:24296',true).
concept_accession('40203: rn:R02356','KEGG','RNO:252931',true).
concept_accession('40202: rn:R02501','EC','1.14.14.1',true).
concept_accession('40202: rn:R02501','KEGG','1.14.14.1',true).
concept_accession('40202: rn:R02501','KEGG','RNO:25147',true).
concept_accession('40202: rn:R02501','KEGG','25147',true).
concept_accession('40202: rn:R02501','KEGG','EC:1.14.14.1',true).
concept_accession('40201: rn:R03089','EC','1.14.14.1',true).
concept_accession('40201: rn:R03089','KEGG','1.14.14.1',true).
concept_accession('40201: rn:R03089','KEGG','24296',true).
concept_accession('40201: rn:R03089','KEGG','RNO:24296',true).
concept_accession('40201: rn:R03089','KEGG','EC:1.14.14.1',true).
concept_accession('40200: rn:R04683','KEGG','396551',true).
concept_accession('40200: rn:R04683','KEGG','2.4.1.17',true).
concept_accession('40200: rn:R04683','KEGG','154516',true).
concept_accession('40200: rn:R04683','KEGG','396552',true).
concept_accession('40200: rn:R04683','KEGG','RNO:305264',true).
concept_accession('40200: rn:R04683','KEGG','289533',true).
concept_accession('40200: rn:R04683','KEGG','RNO:396527',true).
concept_accession('40200: rn:R04683','KEGG','574523',true).
concept_accession('40200: rn:R04683','KEGG','396527',true).
concept_accession('40200: rn:R04683','KEGG','EC:2.4.1.17',true).
concept_accession('40200: rn:R04683','KEGG','113992',true).
concept_accession('40200: rn:R04683','KEGG','RNO:574523',true).
concept_accession('40200: rn:R04683','KEGG','RNO:266685',true).
concept_accession('40200: rn:R04683','KEGG','RNO:24861',true).
concept_accession('40200: rn:R04683','KEGG','266685',true).
concept_accession('40200: rn:R04683','KEGG','RNO:24862',true).
concept_accession('40200: rn:R04683','KEGG','29623',true).
concept_accession('40200: rn:R04683','KEGG','RNO:289533',true).
concept_accession('40200: rn:R04683','KEGG','305264',true).
concept_accession('40200: rn:R04683','KEGG','RNO:83808',true).
concept_accession('40200: rn:R04683','KEGG','RNO:301595',true).
concept_accession('40200: rn:R04683','KEGG','RNO:29623',true).
concept_accession('40200: rn:R04683','KEGG','RNO:154516',true).
concept_accession('40200: rn:R04683','KEGG','301595',true).
concept_accession('40200: rn:R04683','KEGG','RNO:396552',true).
concept_accession('40200: rn:R04683','KEGG','RNO:396551',true).
concept_accession('40200: rn:R04683','KEGG','RNO:286954',true).
concept_accession('40200: rn:R04683','KEGG','RNO:113992',true).
concept_accession('40200: rn:R04683','KEGG','RNO:63867',true).
concept_accession('40200: rn:R04683','KEGG','286954',true).
concept_accession('40200: rn:R04683','KEGG','83808',true).
concept_accession('40200: rn:R04683','KEGG','24861',true).
concept_accession('40200: rn:R04683','KEGG','63867',true).
concept_accession('40200: rn:R04683','EC','2.4.1.17',true).
concept_accession('40200: rn:R04683','KEGG','24862',true).
concept_accession('40207: rn:R04352','KEGG','396551',true).
concept_accession('40207: rn:R04352','KEGG','2.4.1.17',true).
concept_accession('40207: rn:R04352','KEGG','154516',true).
concept_accession('40207: rn:R04352','KEGG','396552',true).
concept_accession('40207: rn:R04352','KEGG','RNO:305264',true).
concept_accession('40207: rn:R04352','KEGG','289533',true).
concept_accession('40207: rn:R04352','KEGG','RNO:396527',true).
concept_accession('40207: rn:R04352','KEGG','574523',true).
concept_accession('40207: rn:R04352','KEGG','396527',true).
concept_accession('40207: rn:R04352','KEGG','EC:2.4.1.17',true).
concept_accession('40207: rn:R04352','KEGG','113992',true).
concept_accession('40207: rn:R04352','KEGG','RNO:574523',true).
concept_accession('40207: rn:R04352','KEGG','RNO:266685',true).
concept_accession('40207: rn:R04352','KEGG','RNO:24861',true).
concept_accession('40207: rn:R04352','KEGG','266685',true).
concept_accession('40207: rn:R04352','KEGG','RNO:24862',true).
concept_accession('40207: rn:R04352','KEGG','29623',true).
concept_accession('40207: rn:R04352','KEGG','RNO:289533',true).
concept_accession('40207: rn:R04352','KEGG','305264',true).
concept_accession('40207: rn:R04352','KEGG','RNO:83808',true).
concept_accession('40207: rn:R04352','KEGG','RNO:301595',true).
concept_accession('40207: rn:R04352','KEGG','RNO:29623',true).
concept_accession('40207: rn:R04352','KEGG','RNO:154516',true).
concept_accession('40207: rn:R04352','KEGG','301595',true).
concept_accession('40207: rn:R04352','KEGG','RNO:396552',true).
concept_accession('40207: rn:R04352','KEGG','RNO:396551',true).
concept_accession('40207: rn:R04352','KEGG','RNO:286954',true).
concept_accession('40207: rn:R04352','KEGG','RNO:113992',true).
concept_accession('40207: rn:R04352','KEGG','RNO:63867',true).
concept_accession('40207: rn:R04352','KEGG','286954',true).
concept_accession('40207: rn:R04352','KEGG','83808',true).
concept_accession('40207: rn:R04352','KEGG','24861',true).
concept_accession('40207: rn:R04352','KEGG','63867',true).
concept_accession('40207: rn:R04352','EC','2.4.1.17',true).
concept_accession('40207: rn:R04352','KEGG','24862',true).
concept_accession('40206: rn:R01834','KEGG','RNO:64677',true).
concept_accession('40206: rn:R01834','KEGG','1.3.99.5',true).
concept_accession('40206: rn:R01834','KEGG','RNO:305291',true).
concept_accession('40206: rn:R01834','KEGG','24950',true).
concept_accession('40206: rn:R01834','KEGG','RNO:24950',true).
concept_accession('40206: rn:R01834','EC','1.3.99.5',true).
concept_accession('40206: rn:R01834','KEGG','64677',true).
concept_accession('40206: rn:R01834','KEGG','305291',true).
concept_accession('40206: rn:R01834','KEGG','EC:1.3.99.5',true).
concept_accession('40205: rn:R02478','KEGG','396551',true).
concept_accession('40205: rn:R02478','KEGG','2.4.1.17',true).
concept_accession('40205: rn:R02478','KEGG','154516',true).
concept_accession('40205: rn:R02478','KEGG','396552',true).
concept_accession('40205: rn:R02478','KEGG','RNO:305264',true).
concept_accession('40205: rn:R02478','KEGG','289533',true).
concept_accession('40205: rn:R02478','KEGG','RNO:396527',true).
concept_accession('40205: rn:R02478','KEGG','574523',true).
concept_accession('40205: rn:R02478','KEGG','396527',true).
concept_accession('40205: rn:R02478','KEGG','EC:2.4.1.17',true).
concept_accession('40205: rn:R02478','KEGG','113992',true).
concept_accession('40205: rn:R02478','KEGG','RNO:574523',true).
concept_accession('40205: rn:R02478','KEGG','RNO:266685',true).
concept_accession('40205: rn:R02478','KEGG','RNO:24861',true).
concept_accession('40205: rn:R02478','KEGG','266685',true).
concept_accession('40205: rn:R02478','KEGG','RNO:24862',true).
concept_accession('40205: rn:R02478','KEGG','29623',true).
concept_accession('40205: rn:R02478','KEGG','RNO:289533',true).
concept_accession('40205: rn:R02478','KEGG','305264',true).
concept_accession('40205: rn:R02478','KEGG','RNO:83808',true).
concept_accession('40205: rn:R02478','KEGG','RNO:301595',true).
concept_accession('40205: rn:R02478','KEGG','RNO:29623',true).
concept_accession('40205: rn:R02478','KEGG','RNO:154516',true).
concept_accession('40205: rn:R02478','KEGG','301595',true).
concept_accession('40205: rn:R02478','KEGG','RNO:396552',true).
concept_accession('40205: rn:R02478','KEGG','RNO:396551',true).
concept_accession('40205: rn:R02478','KEGG','RNO:286954',true).
concept_accession('40205: rn:R02478','KEGG','RNO:113992',true).
concept_accession('40205: rn:R02478','KEGG','RNO:63867',true).
concept_accession('40205: rn:R02478','KEGG','286954',true).
concept_accession('40205: rn:R02478','KEGG','83808',true).
concept_accession('40205: rn:R02478','KEGG','24861',true).
concept_accession('40205: rn:R02478','KEGG','63867',true).
concept_accession('40205: rn:R02478','EC','2.4.1.17',true).
concept_accession('40205: rn:R02478','KEGG','24862',true).
concept_accession('40204: rn:R01840','EC','1.14.14.1',true).
concept_accession('40204: rn:R01840','KEGG','1.14.14.1',true).
concept_accession('40204: rn:R01840','KEGG','RNO:25147',true).
concept_accession('40204: rn:R01840','KEGG','25147',true).
concept_accession('40204: rn:R01840','KEGG','EC:1.14.14.1',true).
concept_accession('40210: rn:R02725','KEGG','353498',true).
concept_accession('40210: rn:R02725','KEGG','RNO:24294',true).
concept_accession('40210: rn:R02725','KEGG','RNO:353498',true).
concept_accession('40210: rn:R02725','EC','1.14.15.4',true).
concept_accession('40210: rn:R02725','KEGG','1.14.15.4',true).
concept_accession('40210: rn:R02725','KEGG','24294',true).
concept_accession('40210: rn:R02725','KEGG','EC:1.14.15.4',true).
concept_accession('40211: rn:R01838','KEGG','EC:1.1.1.64',true).
concept_accession('40211: rn:R01838','EC','1.1.1.64',true).
concept_accession('40211: rn:R01838','KEGG','1.1.1.64',true).
concept_accession('40211: rn:R01838','KEGG','117182',true).
concept_accession('40211: rn:R01838','KEGG','RNO:117182',true).
concept_accession('40208: rn:R01835','KEGG','RNO:192242',true).
concept_accession('40208: rn:R01835','KEGG','EC:1.3.1.3',true).
concept_accession('40208: rn:R01835','EC','1.3.1.3',true).
concept_accession('40208: rn:R01835','KEGG','1.3.1.3',true).
concept_accession('40208: rn:R01835','KEGG','192242',true).
concept_accession('40209: rn:R04758','KEGG','25116',true).
concept_accession('40209: rn:R04758','KEGG','RNO:25116',true).
concept_accession('40209: rn:R04758','KEGG','25117',true).
concept_accession('40209: rn:R04758','KEGG','RNO:25117',true).
concept_accession('40209: rn:R04758','EC','1.1.1.146',true).
concept_accession('40209: rn:R04758','KEGG','EC:1.1.1.146',true).
concept_accession('40209: rn:R04758','KEGG','1.1.1.146',true).
concept_accession('40214: rn:R04764','EC','2.1.1.6',true).
concept_accession('40214: rn:R04764','KEGG','RNO:24267',true).
concept_accession('40214: rn:R04764','KEGG','2.1.1.6',true).
concept_accession('40214: rn:R04764','KEGG','EC:2.1.1.6',true).
concept_accession('40214: rn:R04764','KEGG','24267',true).
concept_accession('40215: rn:R03088 rn:R03090','KEGG','25426',true).
concept_accession('40215: rn:R03088 rn:R03090','EC','1.14.14.1',true).
concept_accession('40215: rn:R03088 rn:R03090','KEGG','1.14.14.1',true).
concept_accession('40215: rn:R03088 rn:R03090','KEGG','RNO:25426',true).
concept_accession('40215: rn:R03088 rn:R03090','KEGG','EC:1.14.14.1',true).
concept_accession('40212: rn:R03091','KEGG','396551',true).
concept_accession('40212: rn:R03091','KEGG','2.4.1.17',true).
concept_accession('40212: rn:R03091','KEGG','154516',true).
concept_accession('40212: rn:R03091','KEGG','396552',true).
concept_accession('40212: rn:R03091','KEGG','RNO:305264',true).
concept_accession('40212: rn:R03091','KEGG','289533',true).
concept_accession('40212: rn:R03091','KEGG','RNO:396527',true).
concept_accession('40212: rn:R03091','KEGG','574523',true).
concept_accession('40212: rn:R03091','KEGG','396527',true).
concept_accession('40212: rn:R03091','KEGG','EC:2.4.1.17',true).
concept_accession('40212: rn:R03091','KEGG','113992',true).
concept_accession('40212: rn:R03091','KEGG','RNO:574523',true).
concept_accession('40212: rn:R03091','KEGG','RNO:266685',true).
concept_accession('40212: rn:R03091','KEGG','RNO:24861',true).
concept_accession('40212: rn:R03091','KEGG','266685',true).
concept_accession('40212: rn:R03091','KEGG','RNO:24862',true).
concept_accession('40212: rn:R03091','KEGG','29623',true).
concept_accession('40212: rn:R03091','KEGG','RNO:289533',true).
concept_accession('40212: rn:R03091','KEGG','305264',true).
concept_accession('40212: rn:R03091','KEGG','RNO:83808',true).
concept_accession('40212: rn:R03091','KEGG','RNO:301595',true).
concept_accession('40212: rn:R03091','KEGG','RNO:29623',true).
concept_accession('40212: rn:R03091','KEGG','RNO:154516',true).
concept_accession('40212: rn:R03091','KEGG','301595',true).
concept_accession('40212: rn:R03091','KEGG','RNO:396552',true).
concept_accession('40212: rn:R03091','KEGG','RNO:396551',true).
concept_accession('40212: rn:R03091','KEGG','RNO:286954',true).
concept_accession('40212: rn:R03091','KEGG','RNO:113992',true).
concept_accession('40212: rn:R03091','KEGG','RNO:63867',true).
concept_accession('40212: rn:R03091','KEGG','286954',true).
concept_accession('40212: rn:R03091','KEGG','83808',true).
concept_accession('40212: rn:R03091','KEGG','24861',true).
concept_accession('40212: rn:R03091','KEGG','63867',true).
concept_accession('40212: rn:R03091','EC','2.4.1.17',true).
concept_accession('40212: rn:R03091','KEGG','24862',true).
concept_accession('40213: rn:R04354','KEGG','396551',true).
concept_accession('40213: rn:R04354','KEGG','2.4.1.17',true).
concept_accession('40213: rn:R04354','KEGG','154516',true).
concept_accession('40213: rn:R04354','KEGG','396552',true).
concept_accession('40213: rn:R04354','KEGG','RNO:305264',true).
concept_accession('40213: rn:R04354','KEGG','289533',true).
concept_accession('40213: rn:R04354','KEGG','RNO:396527',true).
concept_accession('40213: rn:R04354','KEGG','574523',true).
concept_accession('40213: rn:R04354','KEGG','396527',true).
concept_accession('40213: rn:R04354','KEGG','EC:2.4.1.17',true).
concept_accession('40213: rn:R04354','KEGG','113992',true).
concept_accession('40213: rn:R04354','KEGG','RNO:574523',true).
concept_accession('40213: rn:R04354','KEGG','RNO:266685',true).
concept_accession('40213: rn:R04354','KEGG','RNO:24861',true).
concept_accession('40213: rn:R04354','KEGG','266685',true).
concept_accession('40213: rn:R04354','KEGG','RNO:24862',true).
concept_accession('40213: rn:R04354','KEGG','29623',true).
concept_accession('40213: rn:R04354','KEGG','RNO:289533',true).
concept_accession('40213: rn:R04354','KEGG','305264',true).
concept_accession('40213: rn:R04354','KEGG','RNO:83808',true).
concept_accession('40213: rn:R04354','KEGG','RNO:301595',true).
concept_accession('40213: rn:R04354','KEGG','RNO:29623',true).
concept_accession('40213: rn:R04354','KEGG','RNO:154516',true).
concept_accession('40213: rn:R04354','KEGG','301595',true).
concept_accession('40213: rn:R04354','KEGG','RNO:396552',true).
concept_accession('40213: rn:R04354','KEGG','RNO:396551',true).
concept_accession('40213: rn:R04354','KEGG','RNO:286954',true).
concept_accession('40213: rn:R04354','KEGG','RNO:113992',true).
concept_accession('40213: rn:R04354','KEGG','RNO:63867',true).
concept_accession('40213: rn:R04354','KEGG','286954',true).
concept_accession('40213: rn:R04354','KEGG','83808',true).
concept_accession('40213: rn:R04354','KEGG','24861',true).
concept_accession('40213: rn:R04354','KEGG','63867',true).
concept_accession('40213: rn:R04354','EC','2.4.1.17',true).
concept_accession('40213: rn:R04354','KEGG','24862',true).
concept_accession('40218: rn:R02354 rn:R02355','EC','1.14.14.1',true).
concept_accession('40218: rn:R02354 rn:R02355','KEGG','1.14.14.1',true).
concept_accession('40218: rn:R02354 rn:R02355','KEGG','24296',true).
concept_accession('40218: rn:R02354 rn:R02355','KEGG','RNO:24296',true).
concept_accession('40218: rn:R02354 rn:R02355','KEGG','EC:1.14.14.1',true).
concept_accession('40219: rn:R04762','EC','2.1.1.6',true).
concept_accession('40219: rn:R04762','KEGG','RNO:24267',true).
concept_accession('40219: rn:R04762','KEGG','2.1.1.6',true).
concept_accession('40219: rn:R04762','KEGG','EC:2.1.1.6',true).
concept_accession('40219: rn:R04762','KEGG','24267',true).
concept_accession('40216: rn:R02350','KEGG','2.8.2.15',true).
concept_accession('40216: rn:R02350','KEGG','EC:2.8.2.15',true).
concept_accession('40216: rn:R02350','KEGG','RNO:25355',true).
concept_accession('40216: rn:R02350','KEGG','25355',true).
concept_accession('40216: rn:R02350','EC','2.8.2.15',true).
concept_accession('40217: rn:R02358','KEGG','396551',true).
concept_accession('40217: rn:R02358','KEGG','2.4.1.17',true).
concept_accession('40217: rn:R02358','KEGG','154516',true).
concept_accession('40217: rn:R02358','KEGG','396552',true).
concept_accession('40217: rn:R02358','KEGG','RNO:305264',true).
concept_accession('40217: rn:R02358','KEGG','289533',true).
concept_accession('40217: rn:R02358','KEGG','RNO:396527',true).
concept_accession('40217: rn:R02358','KEGG','574523',true).
concept_accession('40217: rn:R02358','KEGG','396527',true).
concept_accession('40217: rn:R02358','KEGG','EC:2.4.1.17',true).
concept_accession('40217: rn:R02358','KEGG','113992',true).
concept_accession('40217: rn:R02358','KEGG','RNO:574523',true).
concept_accession('40217: rn:R02358','KEGG','RNO:266685',true).
concept_accession('40217: rn:R02358','KEGG','RNO:24861',true).
concept_accession('40217: rn:R02358','KEGG','266685',true).
concept_accession('40217: rn:R02358','KEGG','RNO:24862',true).
concept_accession('40217: rn:R02358','KEGG','29623',true).
concept_accession('40217: rn:R02358','KEGG','RNO:289533',true).
concept_accession('40217: rn:R02358','KEGG','305264',true).
concept_accession('40217: rn:R02358','KEGG','RNO:83808',true).
concept_accession('40217: rn:R02358','KEGG','RNO:301595',true).
concept_accession('40217: rn:R02358','KEGG','RNO:29623',true).
concept_accession('40217: rn:R02358','KEGG','RNO:154516',true).
concept_accession('40217: rn:R02358','KEGG','301595',true).
concept_accession('40217: rn:R02358','KEGG','RNO:396552',true).
concept_accession('40217: rn:R02358','KEGG','RNO:396551',true).
concept_accession('40217: rn:R02358','KEGG','RNO:286954',true).
concept_accession('40217: rn:R02358','KEGG','RNO:113992',true).
concept_accession('40217: rn:R02358','KEGG','RNO:63867',true).
concept_accession('40217: rn:R02358','KEGG','286954',true).
concept_accession('40217: rn:R02358','KEGG','83808',true).
concept_accession('40217: rn:R02358','KEGG','24861',true).
concept_accession('40217: rn:R02358','KEGG','63867',true).
concept_accession('40217: rn:R02358','EC','2.4.1.17',true).
concept_accession('40217: rn:R02358','KEGG','24862',true).
concept_accession('40222: rn:R02498','KEGG','RNO:192242',true).
concept_accession('40222: rn:R02498','KEGG','EC:1.3.1.3',true).
concept_accession('40222: rn:R02498','EC','1.3.1.3',true).
concept_accession('40222: rn:R02498','KEGG','1.3.1.3',true).
concept_accession('40222: rn:R02498','KEGG','192242',true).
concept_accession('40223: rn:R02502','KEGG','396551',true).
concept_accession('40223: rn:R02502','KEGG','2.4.1.17',true).
concept_accession('40223: rn:R02502','KEGG','154516',true).
concept_accession('40223: rn:R02502','KEGG','396552',true).
concept_accession('40223: rn:R02502','KEGG','RNO:305264',true).
concept_accession('40223: rn:R02502','KEGG','289533',true).
concept_accession('40223: rn:R02502','KEGG','RNO:396527',true).
concept_accession('40223: rn:R02502','KEGG','574523',true).
concept_accession('40223: rn:R02502','KEGG','396527',true).
concept_accession('40223: rn:R02502','KEGG','EC:2.4.1.17',true).
concept_accession('40223: rn:R02502','KEGG','113992',true).
concept_accession('40223: rn:R02502','KEGG','RNO:574523',true).
concept_accession('40223: rn:R02502','KEGG','RNO:266685',true).
concept_accession('40223: rn:R02502','KEGG','RNO:24861',true).
concept_accession('40223: rn:R02502','KEGG','266685',true).
concept_accession('40223: rn:R02502','KEGG','RNO:24862',true).
concept_accession('40223: rn:R02502','KEGG','29623',true).
concept_accession('40223: rn:R02502','KEGG','RNO:289533',true).
concept_accession('40223: rn:R02502','KEGG','305264',true).
concept_accession('40223: rn:R02502','KEGG','RNO:83808',true).
concept_accession('40223: rn:R02502','KEGG','RNO:301595',true).
concept_accession('40223: rn:R02502','KEGG','RNO:29623',true).
concept_accession('40223: rn:R02502','KEGG','RNO:154516',true).
concept_accession('40223: rn:R02502','KEGG','301595',true).
concept_accession('40223: rn:R02502','KEGG','RNO:396552',true).
concept_accession('40223: rn:R02502','KEGG','RNO:396551',true).
concept_accession('40223: rn:R02502','KEGG','RNO:286954',true).
concept_accession('40223: rn:R02502','KEGG','RNO:113992',true).
concept_accession('40223: rn:R02502','KEGG','RNO:63867',true).
concept_accession('40223: rn:R02502','KEGG','286954',true).
concept_accession('40223: rn:R02502','KEGG','83808',true).
concept_accession('40223: rn:R02502','KEGG','24861',true).
concept_accession('40223: rn:R02502','KEGG','63867',true).
concept_accession('40223: rn:R02502','EC','2.4.1.17',true).
concept_accession('40223: rn:R02502','KEGG','24862',true).
concept_accession('40220: rn:R04353','KEGG','396551',true).
concept_accession('40220: rn:R04353','KEGG','2.4.1.17',true).
concept_accession('40220: rn:R04353','KEGG','154516',true).
concept_accession('40220: rn:R04353','KEGG','396552',true).
concept_accession('40220: rn:R04353','KEGG','RNO:305264',true).
concept_accession('40220: rn:R04353','KEGG','289533',true).
concept_accession('40220: rn:R04353','KEGG','RNO:396527',true).
concept_accession('40220: rn:R04353','KEGG','574523',true).
concept_accession('40220: rn:R04353','KEGG','396527',true).
concept_accession('40220: rn:R04353','KEGG','EC:2.4.1.17',true).
concept_accession('40220: rn:R04353','KEGG','113992',true).
concept_accession('40220: rn:R04353','KEGG','RNO:574523',true).
concept_accession('40220: rn:R04353','KEGG','RNO:266685',true).
concept_accession('40220: rn:R04353','KEGG','RNO:24861',true).
concept_accession('40220: rn:R04353','KEGG','266685',true).
concept_accession('40220: rn:R04353','KEGG','RNO:24862',true).
concept_accession('40220: rn:R04353','KEGG','29623',true).
concept_accession('40220: rn:R04353','KEGG','RNO:289533',true).
concept_accession('40220: rn:R04353','KEGG','305264',true).
concept_accession('40220: rn:R04353','KEGG','RNO:83808',true).
concept_accession('40220: rn:R04353','KEGG','RNO:301595',true).
concept_accession('40220: rn:R04353','KEGG','RNO:29623',true).
concept_accession('40220: rn:R04353','KEGG','RNO:154516',true).
concept_accession('40220: rn:R04353','KEGG','301595',true).
concept_accession('40220: rn:R04353','KEGG','RNO:396552',true).
concept_accession('40220: rn:R04353','KEGG','RNO:396551',true).
concept_accession('40220: rn:R04353','KEGG','RNO:286954',true).
concept_accession('40220: rn:R04353','KEGG','RNO:113992',true).
concept_accession('40220: rn:R04353','KEGG','RNO:63867',true).
concept_accession('40220: rn:R04353','KEGG','286954',true).
concept_accession('40220: rn:R04353','KEGG','83808',true).
concept_accession('40220: rn:R04353','KEGG','24861',true).
concept_accession('40220: rn:R04353','KEGG','63867',true).
concept_accession('40220: rn:R04353','EC','2.4.1.17',true).
concept_accession('40220: rn:R04353','KEGG','24862',true).
concept_accession('40221: rn:R02497','KEGG','RNO:64677',true).
concept_accession('40221: rn:R02497','KEGG','1.3.99.5',true).
concept_accession('40221: rn:R02497','KEGG','RNO:305291',true).
concept_accession('40221: rn:R02497','KEGG','24950',true).
concept_accession('40221: rn:R02497','KEGG','RNO:24950',true).
concept_accession('40221: rn:R02497','EC','1.3.99.5',true).
concept_accession('40221: rn:R02497','KEGG','64677',true).
concept_accession('40221: rn:R02497','KEGG','305291',true).
concept_accession('40221: rn:R02497','KEGG','EC:1.3.99.5',true).
concept_accession('40665: rn:R01384','KEGG','4.1.1.35',true).
concept_accession('40665: rn:R01384','KEGG','246232',true).
concept_accession('40665: rn:R01384','KEGG','RNO:246232',true).
concept_accession('40665: rn:R01384','EC','4.1.1.35',true).
concept_accession('40665: rn:R01384','KEGG','EC:4.1.1.35',true).
concept_accession('40664: rn:R04535','KEGG','50671',true).
concept_accession('40664: rn:R04535','KEGG','4.2.1.-',true).
concept_accession('40664: rn:R04535','KEGG','EC:4.2.1.-',true).
concept_accession('40664: rn:R04535','KEGG','RNO:50671',true).
concept_accession('40664: rn:R04535','EC','4.2.1.-',true).
concept_accession('40667: rn:R04959','KEGG','50671',true).
concept_accession('40667: rn:R04959','KEGG','1.3.1.-',true).
concept_accession('40667: rn:R04959','KEGG','RNO:50671',true).
concept_accession('40667: rn:R04959','KEGG','EC:1.3.1.-',true).
concept_accession('40667: rn:R04959','EC','1.3.1.-',true).
concept_accession('40666: rn:R04534','KEGG','1.1.1.100',true).
concept_accession('40666: rn:R04534','KEGG','50671',true).
concept_accession('40666: rn:R04534','KEGG','EC:1.1.1.100',true).
concept_accession('40666: rn:R04534','KEGG','RNO:50671',true).
concept_accession('40666: rn:R04534','EC','1.1.1.100',true).
concept_accession('40669: rn:R04537','KEGG','50671',true).
concept_accession('40669: rn:R04537','KEGG','4.2.1.-',true).
concept_accession('40669: rn:R04537','KEGG','EC:4.2.1.-',true).
concept_accession('40669: rn:R04537','KEGG','RNO:50671',true).
concept_accession('40669: rn:R04537','EC','4.2.1.-',true).
concept_accession('40668: rn:R04960','KEGG','50671',true).
concept_accession('40668: rn:R04960','KEGG','2.3.1.179',true).
concept_accession('40668: rn:R04960','KEGG','EC:2.3.1.179',true).
concept_accession('40668: rn:R04960','EC','2.3.1.179',true).
concept_accession('40668: rn:R04960','KEGG','RNO:50671',true).
concept_accession('40671: rn:R02251','KEGG','RNO:252900',true).
concept_accession('40671: rn:R02251','KEGG','EC:2.3.1.20',true).
concept_accession('40671: rn:R02251','KEGG','2.3.1.20',true).
concept_accession('40671: rn:R02251','KEGG','84497',true).
concept_accession('40671: rn:R02251','KEGG','RNO:84497',true).
concept_accession('40671: rn:R02251','KEGG','252900',true).
concept_accession('40671: rn:R02251','EC','2.3.1.20',true).
concept_accession('40670: rn:R02250','KEGG','84028',true).
concept_accession('40670: rn:R02250','KEGG','117554',true).
concept_accession('40670: rn:R02250','KEGG','RNO:25702',true).
concept_accession('40670: rn:R02250','KEGG','RNO:291437',true).
concept_accession('40670: rn:R02250','KEGG','291437',true).
concept_accession('40670: rn:R02250','KEGG','RNO:84028',true).
concept_accession('40670: rn:R02250','EC','3.1.1.3',true).
concept_accession('40670: rn:R02250','KEGG','RNO:24538',true).
concept_accession('40670: rn:R02250','KEGG','25702',true).
concept_accession('40670: rn:R02250','KEGG','24254',true).
concept_accession('40670: rn:R02250','KEGG','3.1.1.3',true).
concept_accession('40670: rn:R02250','KEGG','RNO:117554',true).
concept_accession('40670: rn:R02250','KEGG','24538',true).
concept_accession('40670: rn:R02250','KEGG','EC:3.1.1.3',true).
concept_accession('40670: rn:R02250','KEGG','50682',true).
concept_accession('40670: rn:R02250','KEGG','RNO:50682',true).
concept_accession('40670: rn:R02250','KEGG','RNO:24254',true).
concept_accession('40657: rn:R02705','KEGG','EC:2.7.1.60',true).
concept_accession('40657: rn:R02705','EC','2.7.1.60',true).
concept_accession('40657: rn:R02705','KEGG','114711',true).
concept_accession('40657: rn:R02705','KEGG','2.7.1.60',true).
concept_accession('40657: rn:R02705','KEGG','RNO:114711',true).
concept_accession('40656: rn:R04435','KEGG','EC:2.5.1.57',true).
concept_accession('40656: rn:R04435','KEGG','2.5.1.57',true).
concept_accession('40656: rn:R04435','EC','2.5.1.57',true).
concept_accession('40656: rn:R04435','KEGG','298071',true).
concept_accession('40656: rn:R04435','KEGG','RNO:298071',true).
concept_accession('40659: rn:R00286','KEGG','RNO:83472',true).
concept_accession('40659: rn:R00286','KEGG','83472',true).
concept_accession('40659: rn:R00286','EC','1.1.1.22',true).
concept_accession('40659: rn:R00286','KEGG','1.1.1.22',true).
concept_accession('40659: rn:R00286','KEGG','EC:1.1.1.22',true).
concept_accession('40658: rn:R04962','KEGG','50671',true).
concept_accession('40658: rn:R04962','KEGG','1.3.1.-',true).
concept_accession('40658: rn:R04962','KEGG','RNO:50671',true).
concept_accession('40658: rn:R04962','KEGG','EC:1.3.1.-',true).
concept_accession('40658: rn:R04962','EC','1.3.1.-',true).
concept_accession('40661: rn:R00955','KEGG','298003',true).
concept_accession('40661: rn:R00955','KEGG','EC:2.7.7.12',true).
concept_accession('40661: rn:R00955','KEGG','RNO:298003',true).
concept_accession('40661: rn:R00955','KEGG','2.7.7.12',true).
concept_accession('40661: rn:R00955','EC','2.7.7.12',true).
concept_accession('40660: rn:R00291','KEGG','RNO:114860',true).
concept_accession('40660: rn:R00291','KEGG','114860',true).
concept_accession('40660: rn:R00291','EC','5.1.3.2',true).
concept_accession('40660: rn:R00291','KEGG','5.1.3.2',true).
concept_accession('40660: rn:R00291','KEGG','EC:5.1.3.2',true).
concept_accession('40663: rn:R02059','KEGG','302972',true).
concept_accession('40663: rn:R02059','EC','3.5.1.25',true).
concept_accession('40663: rn:R02059','KEGG','3.5.1.25',true).
concept_accession('40663: rn:R02059','KEGG','RNO:302972',true).
concept_accession('40663: rn:R02059','KEGG','EC:3.5.1.25',true).
concept_accession('9221: rn:R00325','KEGG','RP:RP04947',true).
concept_accession('9221: rn:R00325','EC','4.1.3.22',false).
concept_accession('9221: rn:R00325','KEGG','RC:RC01205',true).
concept_accession('9221: rn:R00325','KEGG','RP04947',true).
concept_accession('9221: rn:R00325','KEGG','R00325',true).
concept_accession('9221: rn:R00325','KEGG','RN:R00325',true).
concept_accession('9221: rn:R00325','KEGG','EC:4.1.3.22',true).
concept_accession('9221: rn:R00325','KEGG','RP:RP04896',true).
concept_accession('9221: rn:R00325','KEGG','RC01205',true).
concept_accession('9221: rn:R00325','KEGG','4.1.3.22',true).
concept_accession('9221: rn:R00325','KEGG','RC:RC01118',true).
concept_accession('9221: rn:R00325','KEGG','RC01118',true).
concept_accession('9221: rn:R00325','KEGG','RP04896',true).
concept_accession('40662: rn:R04963','KEGG','50671',true).
concept_accession('40662: rn:R04963','KEGG','2.3.1.86',true).
concept_accession('40662: rn:R04963','EC','2.3.1.86',true).
concept_accession('40662: rn:R04963','KEGG','EC:2.3.1.86',true).
concept_accession('40662: rn:R04963','KEGG','RNO:50671',true).
concept_accession('40648: rn:R04965','KEGG','50671',true).
concept_accession('40648: rn:R04965','KEGG','4.2.1.-',true).
concept_accession('40648: rn:R04965','KEGG','EC:4.2.1.-',true).
concept_accession('40648: rn:R04965','KEGG','RNO:50671',true).
concept_accession('40648: rn:R04965','EC','4.2.1.-',true).
concept_accession('40649: rn:R00416','KEGG','RNO:498272',true).
concept_accession('40649: rn:R00416','EC','2.7.7.23',true).
concept_accession('40649: rn:R00416','KEGG','296560',true).
concept_accession('40649: rn:R00416','KEGG','498272',true).
concept_accession('40649: rn:R00416','KEGG','RNO:296560',true).
concept_accession('40649: rn:R00416','KEGG','2.7.7.23',true).
concept_accession('40649: rn:R00416','KEGG','EC:2.7.7.23',true).
concept_accession('40650: rn:R08193','KEGG','EC:5.4.2.3',true).
concept_accession('40650: rn:R08193','KEGG','RNO:363109',true).
concept_accession('40650: rn:R08193','KEGG','5.4.2.3',true).
concept_accession('40650: rn:R08193','KEGG','363109',true).
concept_accession('40650: rn:R08193','EC','5.4.2.3',true).
concept_accession('40651: rn:R04725','KEGG','50671',true).
concept_accession('40651: rn:R04725','KEGG','1.3.1.-',true).
concept_accession('40651: rn:R04725','KEGG','RNO:50671',true).
concept_accession('40651: rn:R04725','KEGG','EC:1.3.1.-',true).
concept_accession('40651: rn:R04725','EC','1.3.1.-',true).
concept_accession('40652: rn:R01201','KEGG','RNO:297393',true).
concept_accession('40652: rn:R01201','KEGG','297393',true).
concept_accession('40652: rn:R01201','KEGG','2.7.1.59',true).
concept_accession('40652: rn:R01201','KEGG','EC:2.7.1.59',true).
concept_accession('40652: rn:R01201','EC','2.7.1.59',true).
concept_accession('40653: rn:R01117','KEGG','EC:2.7.7.43',true).
concept_accession('40653: rn:R01117','EC','2.7.7.43',true).
concept_accession('40653: rn:R01117','KEGG','2.7.7.43',true).
concept_accession('40653: rn:R01117','KEGG','312826',true).
concept_accession('40653: rn:R01117','KEGG','RNO:312826',true).
concept_accession('40654: rn:R01805','KEGG','311530',true).
concept_accession('40654: rn:R01805','EC','3.1.3.29',true).
concept_accession('40654: rn:R01805','KEGG','RNO:311530',true).
concept_accession('40654: rn:R01805','KEGG','EC:3.1.3.29',true).
concept_accession('40654: rn:R01805','KEGG','3.1.3.29',true).
concept_accession('40655: rn:R04964','KEGG','50671',true).
concept_accession('40655: rn:R04964','KEGG','2.3.1.85',true).
concept_accession('40655: rn:R04964','KEGG','EC:2.3.1.85',true).
concept_accession('40655: rn:R04964','KEGG','RNO:50671',true).
concept_accession('40655: rn:R04964','EC','2.3.1.85',true).
concept_accession('40640: rn:R05914','KEGG','RNO:287920',true).
concept_accession('40640: rn:R05914','KEGG','2.4.99.3',true).
concept_accession('40640: rn:R05914','KEGG','287920',true).
concept_accession('40640: rn:R05914','KEGG','EC:2.4.99.3',true).
concept_accession('40640: rn:R05914','EC','2.4.99.3',true).
concept_accession('5955: rn:R02335','KEGG','2.4.1.16',true).
concept_accession('5955: rn:R02335','KEGG','EC:2.4.1.16',true).
concept_accession('5955: rn:R02335','KEGG','R02335',true).
concept_accession('5955: rn:R02335','KEGG','RN:R02335',true).
concept_accession('5955: rn:R02335','EC','2.4.1.16',false).
concept_accession('40641: rn:R05907','KEGG','RNO:500826',true).
concept_accession('40641: rn:R05907','KEGG','RNO:288611',true).
concept_accession('40641: rn:R05907','KEGG','RNO:366061',true).
concept_accession('40641: rn:R05907','KEGG','313878',true).
concept_accession('40641: rn:R05907','KEGG','RNO:499968',true).
concept_accession('40641: rn:R05907','KEGG','683264',true).
concept_accession('40641: rn:R05907','KEGG','361142',true).
concept_accession('40641: rn:R05907','KEGG','288611',true).
concept_accession('40641: rn:R05907','KEGG','311039',true).
concept_accession('40641: rn:R05907','KEGG','RNO:29750',true).
concept_accession('40641: rn:R05907','EC','2.4.1.41',true).
concept_accession('40641: rn:R05907','KEGG','RNO:362760',true).
concept_accession('40641: rn:R05907','KEGG','RNO:100366230',true).
concept_accession('40641: rn:R05907','KEGG','RNO:83627',true).
concept_accession('40641: rn:R05907','KEGG','293181',true).
concept_accession('40641: rn:R05907','KEGG','RNO:170501',true).
concept_accession('40641: rn:R05907','KEGG','RNO:313878',true).
concept_accession('40641: rn:R05907','KEGG','500826',true).
concept_accession('40641: rn:R05907','KEGG','362760',true).
concept_accession('40641: rn:R05907','KEGG','RNO:361142',true).
concept_accession('40641: rn:R05907','KEGG','83627',true).
concept_accession('40641: rn:R05907','KEGG','100361647',true).
concept_accession('40641: rn:R05907','KEGG','RNO:100361647',true).
concept_accession('40641: rn:R05907','KEGG','RNO:311039',true).
concept_accession('40641: rn:R05907','KEGG','313233',true).
concept_accession('40641: rn:R05907','KEGG','311952',true).
concept_accession('40641: rn:R05907','KEGG','366061',true).
concept_accession('40641: rn:R05907','KEGG','RNO:292090',true).
concept_accession('40641: rn:R05907','KEGG','EC:2.4.1.41',true).
concept_accession('40641: rn:R05907','KEGG','170501',true).
concept_accession('40641: rn:R05907','KEGG','292090',true).
concept_accession('40641: rn:R05907','KEGG','RNO:79214',true).
concept_accession('40641: rn:R05907','KEGG','100366230',true).
concept_accession('40641: rn:R05907','KEGG','499968',true).
concept_accession('40641: rn:R05907','KEGG','RNO:683264',true).
concept_accession('40641: rn:R05907','KEGG','RNO:313233',true).
concept_accession('40641: rn:R05907','KEGG','29750',true).
concept_accession('40641: rn:R05907','KEGG','2.4.1.41',true).
concept_accession('40641: rn:R05907','KEGG','RNO:311952',true).
concept_accession('40641: rn:R05907','KEGG','79214',true).
concept_accession('40641: rn:R05907','KEGG','RNO:293181',true).
concept_accession('1649: rn:R03403','KEGG','RC:RC00607',true).
concept_accession('1649: rn:R03403','EC','4.1.2.30',false).
concept_accession('1649: rn:R03403','KEGG','RP:RP07501',true).
concept_accession('1649: rn:R03403','KEGG','R03403',true).
concept_accession('1649: rn:R03403','KEGG','4.1.2.30',true).
concept_accession('1649: rn:R03403','KEGG','RN:R03403',true).
concept_accession('1649: rn:R03403','KEGG','RC00607',true).
concept_accession('1649: rn:R03403','KEGG','RP07501',true).
concept_accession('1649: rn:R03403','KEGG','EC:4.1.2.30',true).
concept_accession('40642: rn:R05915','KEGG','EC:2.4.1.148',true).
concept_accession('40642: rn:R05915','KEGG','RNO:286976',true).
concept_accession('40642: rn:R05915','KEGG','286976',true).
concept_accession('40642: rn:R05915','EC','2.4.1.148',true).
concept_accession('40642: rn:R05915','KEGG','2.4.1.148',true).
concept_accession('40643: rn:R05910','EC','2.4.1.102',true).
concept_accession('40643: rn:R05910','KEGG','EC:2.4.1.102',true).
concept_accession('40643: rn:R05910','KEGG','2.4.1.102',true).
concept_accession('40643: rn:R05910','KEGG','64043',true).
concept_accession('40643: rn:R05910','KEGG','RNO:64043',true).
concept_accession('40644: rn:R05907','KEGG','RNO:500826',true).
concept_accession('40644: rn:R05907','KEGG','RNO:288611',true).
concept_accession('40644: rn:R05907','KEGG','RNO:366061',true).
concept_accession('40644: rn:R05907','KEGG','313878',true).
concept_accession('40644: rn:R05907','KEGG','RNO:499968',true).
concept_accession('40644: rn:R05907','KEGG','683264',true).
concept_accession('40644: rn:R05907','KEGG','361142',true).
concept_accession('40644: rn:R05907','KEGG','288611',true).
concept_accession('40644: rn:R05907','KEGG','311039',true).
concept_accession('40644: rn:R05907','KEGG','RNO:29750',true).
concept_accession('40644: rn:R05907','EC','2.4.1.41',true).
concept_accession('40644: rn:R05907','KEGG','RNO:362760',true).
concept_accession('40644: rn:R05907','KEGG','RNO:100366230',true).
concept_accession('40644: rn:R05907','KEGG','RNO:83627',true).
concept_accession('40644: rn:R05907','KEGG','293181',true).
concept_accession('40644: rn:R05907','KEGG','RNO:170501',true).
concept_accession('40644: rn:R05907','KEGG','RNO:313878',true).
concept_accession('40644: rn:R05907','KEGG','500826',true).
concept_accession('40644: rn:R05907','KEGG','362760',true).
concept_accession('40644: rn:R05907','KEGG','RNO:361142',true).
concept_accession('40644: rn:R05907','KEGG','83627',true).
concept_accession('40644: rn:R05907','KEGG','100361647',true).
concept_accession('40644: rn:R05907','KEGG','RNO:100361647',true).
concept_accession('40644: rn:R05907','KEGG','RNO:311039',true).
concept_accession('40644: rn:R05907','KEGG','313233',true).
concept_accession('40644: rn:R05907','KEGG','311952',true).
concept_accession('40644: rn:R05907','KEGG','366061',true).
concept_accession('40644: rn:R05907','KEGG','RNO:292090',true).
concept_accession('40644: rn:R05907','KEGG','EC:2.4.1.41',true).
concept_accession('40644: rn:R05907','KEGG','170501',true).
concept_accession('40644: rn:R05907','KEGG','292090',true).
concept_accession('40644: rn:R05907','KEGG','RNO:79214',true).
concept_accession('40644: rn:R05907','KEGG','100366230',true).
concept_accession('40644: rn:R05907','KEGG','499968',true).
concept_accession('40644: rn:R05907','KEGG','RNO:683264',true).
concept_accession('40644: rn:R05907','KEGG','RNO:313233',true).
concept_accession('40644: rn:R05907','KEGG','29750',true).
concept_accession('40644: rn:R05907','KEGG','2.4.1.41',true).
concept_accession('40644: rn:R05907','KEGG','RNO:311952',true).
concept_accession('40644: rn:R05907','KEGG','79214',true).
concept_accession('40644: rn:R05907','KEGG','RNO:293181',true).
concept_accession('40645: rn:R05907','KEGG','RNO:500826',true).
concept_accession('40645: rn:R05907','KEGG','RNO:288611',true).
concept_accession('40645: rn:R05907','KEGG','RNO:366061',true).
concept_accession('40645: rn:R05907','KEGG','313878',true).
concept_accession('40645: rn:R05907','KEGG','RNO:499968',true).
concept_accession('40645: rn:R05907','KEGG','683264',true).
concept_accession('40645: rn:R05907','KEGG','361142',true).
concept_accession('40645: rn:R05907','KEGG','288611',true).
concept_accession('40645: rn:R05907','KEGG','311039',true).
concept_accession('40645: rn:R05907','KEGG','RNO:29750',true).
concept_accession('40645: rn:R05907','EC','2.4.1.41',true).
concept_accession('40645: rn:R05907','KEGG','RNO:362760',true).
concept_accession('40645: rn:R05907','KEGG','RNO:100366230',true).
concept_accession('40645: rn:R05907','KEGG','RNO:83627',true).
concept_accession('40645: rn:R05907','KEGG','293181',true).
concept_accession('40645: rn:R05907','KEGG','RNO:170501',true).
concept_accession('40645: rn:R05907','KEGG','RNO:313878',true).
concept_accession('40645: rn:R05907','KEGG','500826',true).
concept_accession('40645: rn:R05907','KEGG','362760',true).
concept_accession('40645: rn:R05907','KEGG','RNO:361142',true).
concept_accession('40645: rn:R05907','KEGG','83627',true).
concept_accession('40645: rn:R05907','KEGG','100361647',true).
concept_accession('40645: rn:R05907','KEGG','RNO:100361647',true).
concept_accession('40645: rn:R05907','KEGG','RNO:311039',true).
concept_accession('40645: rn:R05907','KEGG','313233',true).
concept_accession('40645: rn:R05907','KEGG','311952',true).
concept_accession('40645: rn:R05907','KEGG','366061',true).
concept_accession('40645: rn:R05907','KEGG','RNO:292090',true).
concept_accession('40645: rn:R05907','KEGG','EC:2.4.1.41',true).
concept_accession('40645: rn:R05907','KEGG','170501',true).
concept_accession('40645: rn:R05907','KEGG','292090',true).
concept_accession('40645: rn:R05907','KEGG','RNO:79214',true).
concept_accession('40645: rn:R05907','KEGG','100366230',true).
concept_accession('40645: rn:R05907','KEGG','499968',true).
concept_accession('40645: rn:R05907','KEGG','RNO:683264',true).
concept_accession('40645: rn:R05907','KEGG','RNO:313233',true).
concept_accession('40645: rn:R05907','KEGG','29750',true).
concept_accession('40645: rn:R05907','KEGG','2.4.1.41',true).
concept_accession('40645: rn:R05907','KEGG','RNO:311952',true).
concept_accession('40645: rn:R05907','KEGG','79214',true).
concept_accession('40645: rn:R05907','KEGG','RNO:293181',true).
concept_accession('1653: rn:R03406 rn:R03407','KEGG','EC:1.1.1.51',true).
concept_accession('1653: rn:R03406 rn:R03407','KEGG','RC:RC00127',true).
concept_accession('1653: rn:R03406 rn:R03407','KEGG','RP00675',true).
concept_accession('1653: rn:R03406 rn:R03407','KEGG','RP:RP00675',true).
concept_accession('1653: rn:R03406 rn:R03407','EC','1.1.1.51',false).
concept_accession('1653: rn:R03406 rn:R03407','KEGG','R03406',true).
concept_accession('1653: rn:R03406 rn:R03407','KEGG','R03407',true).
concept_accession('1653: rn:R03406 rn:R03407','KEGG','RC00127',true).
concept_accession('1653: rn:R03406 rn:R03407','KEGG','1.1.1.51',true).
concept_accession('1653: rn:R03406 rn:R03407','KEGG','RN:R03407',true).
concept_accession('1653: rn:R03406 rn:R03407','KEGG','RN:R03406',true).
concept_accession('40646: rn:R05907','KEGG','RNO:500826',true).
concept_accession('40646: rn:R05907','KEGG','RNO:288611',true).
concept_accession('40646: rn:R05907','KEGG','RNO:366061',true).
concept_accession('40646: rn:R05907','KEGG','313878',true).
concept_accession('40646: rn:R05907','KEGG','RNO:499968',true).
concept_accession('40646: rn:R05907','KEGG','683264',true).
concept_accession('40646: rn:R05907','KEGG','361142',true).
concept_accession('40646: rn:R05907','KEGG','288611',true).
concept_accession('40646: rn:R05907','KEGG','311039',true).
concept_accession('40646: rn:R05907','KEGG','RNO:29750',true).
concept_accession('40646: rn:R05907','EC','2.4.1.41',true).
concept_accession('40646: rn:R05907','KEGG','RNO:362760',true).
concept_accession('40646: rn:R05907','KEGG','RNO:100366230',true).
concept_accession('40646: rn:R05907','KEGG','RNO:83627',true).
concept_accession('40646: rn:R05907','KEGG','293181',true).
concept_accession('40646: rn:R05907','KEGG','RNO:170501',true).
concept_accession('40646: rn:R05907','KEGG','RNO:313878',true).
concept_accession('40646: rn:R05907','KEGG','500826',true).
concept_accession('40646: rn:R05907','KEGG','362760',true).
concept_accession('40646: rn:R05907','KEGG','RNO:361142',true).
concept_accession('40646: rn:R05907','KEGG','83627',true).
concept_accession('40646: rn:R05907','KEGG','100361647',true).
concept_accession('40646: rn:R05907','KEGG','RNO:100361647',true).
concept_accession('40646: rn:R05907','KEGG','RNO:311039',true).
concept_accession('40646: rn:R05907','KEGG','313233',true).
concept_accession('40646: rn:R05907','KEGG','311952',true).
concept_accession('40646: rn:R05907','KEGG','366061',true).
concept_accession('40646: rn:R05907','KEGG','RNO:292090',true).
concept_accession('40646: rn:R05907','KEGG','EC:2.4.1.41',true).
concept_accession('40646: rn:R05907','KEGG','170501',true).
concept_accession('40646: rn:R05907','KEGG','292090',true).
concept_accession('40646: rn:R05907','KEGG','RNO:79214',true).
concept_accession('40646: rn:R05907','KEGG','100366230',true).
concept_accession('40646: rn:R05907','KEGG','499968',true).
concept_accession('40646: rn:R05907','KEGG','RNO:683264',true).
concept_accession('40646: rn:R05907','KEGG','RNO:313233',true).
concept_accession('40646: rn:R05907','KEGG','29750',true).
concept_accession('40646: rn:R05907','KEGG','2.4.1.41',true).
concept_accession('40646: rn:R05907','KEGG','RNO:311952',true).
concept_accession('40646: rn:R05907','KEGG','79214',true).
concept_accession('40646: rn:R05907','KEGG','RNO:293181',true).
concept_accession('40647: rn:R00414','KEGG','114711',true).
concept_accession('40647: rn:R00414','KEGG','5.1.3.14',true).
concept_accession('40647: rn:R00414','KEGG','RNO:114711',true).
concept_accession('40647: rn:R00414','EC','5.1.3.14',true).
concept_accession('40647: rn:R00414','KEGG','EC:5.1.3.14',true).
concept_accession('40699: rn:R01350','KEGG','3.1.1.34',true).
concept_accession('40699: rn:R01350','EC','3.1.1.34',true).
concept_accession('40699: rn:R01350','KEGG','24539',true).
concept_accession('40699: rn:R01350','KEGG','EC:3.1.1.34',true).
concept_accession('40699: rn:R01350','KEGG','RNO:24539',true).
concept_accession('40698: rn:R01041','EC','1.1.1.2',true).
concept_accession('40698: rn:R01041','KEGG','78959',true).
concept_accession('40698: rn:R01041','KEGG','EC:1.1.1.2',true).
concept_accession('40698: rn:R01041','KEGG','RNO:78959',true).
concept_accession('40698: rn:R01041','KEGG','1.1.1.2',true).
concept_accession('40697: rn:R01752','KEGG','1.2.1.3',true).
concept_accession('40697: rn:R01752','KEGG','RNO:291450',true).
concept_accession('40697: rn:R01752','KEGG','RNO:64040',true).
concept_accession('40697: rn:R01752','EC','1.2.1.3',true).
concept_accession('40697: rn:R01752','KEGG','65183',true).
concept_accession('40697: rn:R01752','KEGG','24188',true).
concept_accession('40697: rn:R01752','KEGG','RNO:29539',true).
concept_accession('40697: rn:R01752','KEGG','64040',true).
concept_accession('40697: rn:R01752','KEGG','RNO:24188',true).
concept_accession('40697: rn:R01752','KEGG','29539',true).
concept_accession('40697: rn:R01752','KEGG','29651',true).
concept_accession('40697: rn:R01752','KEGG','298079',true).
concept_accession('40697: rn:R01752','KEGG','RNO:298079',true).
concept_accession('40697: rn:R01752','KEGG','RNO:65183',true).
concept_accession('40697: rn:R01752','KEGG','RNO:29651',true).
concept_accession('40697: rn:R01752','KEGG','291450',true).
concept_accession('40697: rn:R01752','KEGG','EC:1.2.1.3',true).
concept_accession('40696: rn:R00959','KEGG','RNO:24645',true).
concept_accession('40696: rn:R00959','KEGG','EC:5.4.2.2',true).
concept_accession('40696: rn:R00959','KEGG','24645',true).
concept_accession('40696: rn:R00959','KEGG','5.4.2.2',true).
concept_accession('40696: rn:R00959','EC','5.4.2.2',true).
concept_accession('40703: rn:R01092','KEGG','RNO:296117',true).
concept_accession('40703: rn:R01092','KEGG','EC:2.7.1.6',true).
concept_accession('40703: rn:R01092','KEGG','296117',true).
concept_accession('40703: rn:R01092','KEGG','2.7.1.6',true).
concept_accession('40703: rn:R01092','KEGG','287835',true).
concept_accession('40703: rn:R01092','EC','2.7.1.6',true).
concept_accession('40703: rn:R01092','KEGG','RNO:287835',true).
concept_accession('40702: rn:R04568','KEGG','50671',true).
concept_accession('40702: rn:R04568','KEGG','4.2.1.-',true).
concept_accession('40702: rn:R04568','KEGG','EC:4.2.1.-',true).
concept_accession('40702: rn:R04568','KEGG','RNO:50671',true).
concept_accession('40702: rn:R04568','EC','4.2.1.-',true).
concept_accession('40701: rn:R01786','KEGG','RNO:100364027',true).
concept_accession('40701: rn:R01786','KEGG','25058',true).
concept_accession('40701: rn:R01786','KEGG','25059',true).
concept_accession('40701: rn:R01786','KEGG','RNO:25058',true).
concept_accession('40701: rn:R01786','KEGG','25060',true).
concept_accession('40701: rn:R01786','KEGG','RNO:25059',true).
concept_accession('40701: rn:R01786','EC','2.7.1.1',true).
concept_accession('40701: rn:R01786','KEGG','100364027',true).
concept_accession('40701: rn:R01786','KEGG','RNO:25060',true).
concept_accession('40701: rn:R01786','KEGG','EC:2.7.1.1',true).
concept_accession('40701: rn:R01786','KEGG','2.7.1.1',true).
concept_accession('40700: rn:R04967','KEGG','50671',true).
concept_accession('40700: rn:R04967','KEGG','1.3.1.-',true).
concept_accession('40700: rn:R04967','KEGG','RNO:50671',true).
concept_accession('40700: rn:R04967','KEGG','EC:1.3.1.-',true).
concept_accession('40700: rn:R04967','EC','1.3.1.-',true).
concept_accession('40691: rn:R01514','KEGG','684314',true).
concept_accession('40691: rn:R01514','KEGG','RNO:684314',true).
concept_accession('40691: rn:R01514','KEGG','EC:2.7.1.31',true).
concept_accession('40691: rn:R01514','KEGG','2.7.1.31',true).
concept_accession('40691: rn:R01514','EC','2.7.1.31',true).
concept_accession('40690: rn:R04543','KEGG','50671',true).
concept_accession('40690: rn:R04543','KEGG','2.3.1.85',true).
concept_accession('40690: rn:R04543','KEGG','EC:2.3.1.85',true).
concept_accession('40690: rn:R04543','KEGG','RNO:50671',true).
concept_accession('40690: rn:R04543','EC','2.3.1.85',true).
concept_accession('40689: rn:R02577','KEGG','24192',true).
concept_accession('40689: rn:R02577','KEGG','RNO:24192',true).
concept_accession('40689: rn:R02577','KEGG','1.1.1.21',true).
concept_accession('40689: rn:R02577','EC','1.1.1.21',true).
concept_accession('40689: rn:R02577','KEGG','EC:1.1.1.21',true).
concept_accession('40688: rn:R04544','KEGG','50671',true).
concept_accession('40688: rn:R04544','KEGG','4.2.1.-',true).
concept_accession('40688: rn:R04544','KEGG','EC:4.2.1.-',true).
concept_accession('40688: rn:R04544','KEGG','RNO:50671',true).
concept_accession('40688: rn:R04544','EC','4.2.1.-',true).
concept_accession('40695: rn:R04968','KEGG','50671',true).
concept_accession('40695: rn:R04968','KEGG','2.3.1.179',true).
concept_accession('40695: rn:R04968','KEGG','EC:2.3.1.179',true).
concept_accession('40695: rn:R04968','EC','2.3.1.179',true).
concept_accession('40695: rn:R04968','KEGG','RNO:50671',true).
concept_accession('40694: rn:R01036 rn:R01041','KEGG','24192',true).
concept_accession('40694: rn:R01036 rn:R01041','KEGG','RNO:24192',true).
concept_accession('40694: rn:R01036 rn:R01041','KEGG','1.1.1.21',true).
concept_accession('40694: rn:R01036 rn:R01041','EC','1.1.1.21',true).
concept_accession('40694: rn:R01036 rn:R01041','KEGG','EC:1.1.1.21',true).
concept_accession('40693: rn:R01818','KEGG','302915',true).
concept_accession('40693: rn:R01818','KEGG','300089',true).
concept_accession('40693: rn:R01818','KEGG','EC:5.4.2.8',true).
concept_accession('40693: rn:R01818','KEGG','RNO:300089',true).
concept_accession('40693: rn:R01818','KEGG','RNO:302915',true).
concept_accession('40693: rn:R01818','KEGG','5.4.2.8',true).
concept_accession('40693: rn:R01818','EC','5.4.2.8',true).
concept_accession('40692: rn:R01819','EC','5.3.1.8',true).
concept_accession('40692: rn:R01819','KEGG','5.3.1.8',true).
concept_accession('40692: rn:R01819','KEGG','RNO:300741',true).
concept_accession('40692: rn:R01819','KEGG','300741',true).
concept_accession('40692: rn:R01819','KEGG','EC:5.3.1.8',true).
concept_accession('40682: rn:R01706','KEGG','EC:3.1.2.14',true).
concept_accession('40682: rn:R01706','KEGG','50671',true).
concept_accession('40682: rn:R01706','KEGG','3.1.2.14',true).
concept_accession('40682: rn:R01706','EC','3.1.2.14',true).
concept_accession('40682: rn:R01706','KEGG','RNO:50671',true).
concept_accession('40683: rn:R02757','KEGG','RNO:502749',true).
concept_accession('40683: rn:R02757','KEGG','2.7.1.94',true).
concept_accession('40683: rn:R02757','KEGG','502749',true).
concept_accession('40683: rn:R02757','EC','2.7.1.94',true).
concept_accession('40683: rn:R02757','KEGG','EC:2.7.1.94',true).
concept_accession('9275: rn:R00934','KEGG','RC00407',true).
concept_accession('9275: rn:R00934','EC','4.1.3.24',false).
concept_accession('9275: rn:R00934','KEGG','RC:RC00311',true).
concept_accession('9275: rn:R00934','KEGG','RC:RC00407',true).
concept_accession('9275: rn:R00934','KEGG','EC:4.1.3.24',true).
concept_accession('9275: rn:R00934','KEGG','RC00311',true).
concept_accession('9275: rn:R00934','KEGG','R00934',true).
concept_accession('9275: rn:R00934','KEGG','4.1.3.24',true).
concept_accession('9275: rn:R00934','KEGG','RN:R00934',true).
concept_accession('9275: rn:R00934','KEGG','RP01183',true).
concept_accession('9275: rn:R00934','KEGG','RP:RP01184',true).
concept_accession('9275: rn:R00934','KEGG','RP:RP01183',true).
concept_accession('9275: rn:R00934','KEGG','RP01184',true).
concept_accession('40680: rn:R00851','KEGG','29653',true).
concept_accession('40680: rn:R00851','KEGG','305166',true).
concept_accession('40680: rn:R00851','KEGG','RNO:29653',true).
concept_accession('40680: rn:R00851','KEGG','EC:2.3.1.15',true).
concept_accession('40680: rn:R00851','KEGG','RNO:305166',true).
concept_accession('40680: rn:R00851','KEGG','RNO:296130',true).
concept_accession('40680: rn:R00851','KEGG','296130',true).
concept_accession('40680: rn:R00851','KEGG','2.3.1.15',true).
concept_accession('40680: rn:R00851','EC','2.3.1.15',true).
concept_accession('40680: rn:R00851','KEGG','290843',true).
concept_accession('40680: rn:R00851','KEGG','RNO:290843',true).
concept_accession('40681: rn:R01351','KEGG','3.1.1.23',true).
concept_accession('40681: rn:R01351','KEGG','29254',true).
concept_accession('40681: rn:R01351','KEGG','RNO:29254',true).
concept_accession('40681: rn:R01351','KEGG','EC:3.1.1.23',true).
concept_accession('40681: rn:R01351','EC','3.1.1.23',true).
concept_accession('40686: rn:R01804','KEGG','EC:2.5.1.56',true).
concept_accession('40686: rn:R01804','EC','2.5.1.56',true).
concept_accession('40686: rn:R01804','KEGG','2.5.1.56',true).
concept_accession('40686: rn:R01804','KEGG','298071',true).
concept_accession('40686: rn:R01804','KEGG','RNO:298071',true).
concept_accession('40687: rn:R04970','KEGG','50671',true).
concept_accession('40687: rn:R04970','KEGG','1.3.1.-',true).
concept_accession('40687: rn:R04970','KEGG','RNO:50671',true).
concept_accession('40687: rn:R04970','KEGG','EC:1.3.1.-',true).
concept_accession('40687: rn:R04970','EC','1.3.1.-',true).
concept_accession('40684: rn:R01706','KEGG','EC:3.1.2.14',true).
concept_accession('40684: rn:R01706','KEGG','3.1.2.14',true).
concept_accession('40684: rn:R01706','EC','3.1.2.14',true).
concept_accession('40684: rn:R01706','KEGG','RNO:64669',true).
concept_accession('40684: rn:R01706','KEGG','64669',true).
concept_accession('40685: rn:R00847','KEGG','2.7.1.30',true).
concept_accession('40685: rn:R00847','KEGG','79223',true).
concept_accession('40685: rn:R00847','KEGG','RNO:79223',true).
concept_accession('40685: rn:R00847','KEGG','289481',true).
concept_accession('40685: rn:R00847','EC','2.7.1.30',true).
concept_accession('40685: rn:R00847','KEGG','EC:2.7.1.30',true).
concept_accession('40685: rn:R00847','KEGG','RNO:289481',true).
concept_accession('40674: rn:R04952','KEGG','2.3.1.179',true).
concept_accession('40674: rn:R04952','KEGG','EC:2.3.1.179',true).
concept_accession('40674: rn:R04952','EC','2.3.1.179',true).
concept_accession('40674: rn:R04952','KEGG','RNO:289934',true).
concept_accession('40674: rn:R04952','KEGG','289934',true).
concept_accession('40675: rn:R02241','KEGG','362702',true).
concept_accession('40675: rn:R02241','KEGG','170919',true).
concept_accession('40675: rn:R02241','KEGG','RNO:311821',true).
concept_accession('40675: rn:R02241','EC','2.3.1.51',true).
concept_accession('40675: rn:R02241','KEGG','311821',true).
concept_accession('40675: rn:R02241','KEGG','313997',true).
concept_accession('40675: rn:R02241','KEGG','2.3.1.51',true).
concept_accession('40675: rn:R02241','KEGG','RNO:313997',true).
concept_accession('40675: rn:R02241','KEGG','RNO:406165',true).
concept_accession('40675: rn:R02241','KEGG','EC:2.3.1.51',true).
concept_accession('40675: rn:R02241','KEGG','RNO:294324',true).
concept_accession('40675: rn:R02241','KEGG','RNO:170919',true).
concept_accession('40675: rn:R02241','KEGG','406165',true).
concept_accession('40675: rn:R02241','KEGG','294324',true).
concept_accession('40675: rn:R02241','KEGG','498741',true).
concept_accession('40675: rn:R02241','KEGG','RNO:498741',true).
concept_accession('40675: rn:R02241','KEGG','RNO:362702',true).
concept_accession('40672: rn:R04957','KEGG','50671',true).
concept_accession('40672: rn:R04957','KEGG','2.3.1.179',true).
concept_accession('40672: rn:R04957','KEGG','EC:2.3.1.179',true).
concept_accession('40672: rn:R04957','EC','2.3.1.179',true).
concept_accession('40672: rn:R04957','KEGG','RNO:50671',true).
concept_accession('40673: rn:R04536','KEGG','1.1.1.100',true).
concept_accession('40673: rn:R04536','KEGG','50671',true).
concept_accession('40673: rn:R04536','KEGG','EC:1.1.1.100',true).
concept_accession('40673: rn:R04536','KEGG','RNO:50671',true).
concept_accession('40673: rn:R04536','EC','1.1.1.100',true).
concept_accession('40678: rn:R02239','EC','3.1.3.4',true).
concept_accession('40678: rn:R02239','KEGG','RNO:246115',true).
concept_accession('40678: rn:R02239','KEGG','192270',true).
concept_accession('40678: rn:R02239','KEGG','3.1.3.4',true).
concept_accession('40678: rn:R02239','KEGG','RNO:64369',true).
concept_accession('40678: rn:R02239','KEGG','246115',true).
concept_accession('40678: rn:R02239','KEGG','64369',true).
concept_accession('40678: rn:R02239','KEGG','RNO:192270',true).
concept_accession('40678: rn:R02239','KEGG','EC:3.1.3.4',true).
concept_accession('1620: rn:R03263','KEGG','RC:RC00893',true).
concept_accession('1620: rn:R03263','KEGG','RP02894',true).
concept_accession('1620: rn:R03263','KEGG','RN:R03263',true).
concept_accession('1620: rn:R03263','KEGG','RC00893',true).
concept_accession('1620: rn:R03263','KEGG','RP:RP02894',true).
concept_accession('1620: rn:R03263','KEGG','R03263',true).
concept_accession('40679: rn:R01011','KEGG','RNO:361730',true).
concept_accession('40679: rn:R01011','EC','2.7.1.29',true).
concept_accession('40679: rn:R01011','KEGG','EC:2.7.1.29',true).
concept_accession('40679: rn:R01011','KEGG','361730',true).
concept_accession('40679: rn:R01011','KEGG','2.7.1.29',true).
concept_accession('40676: rn:R04957','KEGG','2.3.1.179',true).
concept_accession('40676: rn:R04957','KEGG','EC:2.3.1.179',true).
concept_accession('40676: rn:R04957','EC','2.3.1.179',true).
concept_accession('40676: rn:R04957','KEGG','RNO:289934',true).
concept_accession('40676: rn:R04957','KEGG','289934',true).
concept_accession('40677: rn:R02687','KEGG','84028',true).
concept_accession('40677: rn:R02687','KEGG','117554',true).
concept_accession('40677: rn:R02687','KEGG','RNO:25702',true).
concept_accession('40677: rn:R02687','KEGG','RNO:291437',true).
concept_accession('40677: rn:R02687','KEGG','291437',true).
concept_accession('40677: rn:R02687','KEGG','RNO:84028',true).
concept_accession('40677: rn:R02687','EC','3.1.1.3',true).
concept_accession('40677: rn:R02687','KEGG','RNO:24538',true).
concept_accession('40677: rn:R02687','KEGG','25702',true).
concept_accession('40677: rn:R02687','KEGG','24254',true).
concept_accession('40677: rn:R02687','KEGG','3.1.1.3',true).
concept_accession('40677: rn:R02687','KEGG','RNO:117554',true).
concept_accession('40677: rn:R02687','KEGG','24538',true).
concept_accession('40677: rn:R02687','KEGG','EC:3.1.1.3',true).
concept_accession('40677: rn:R02687','KEGG','50682',true).
concept_accession('40677: rn:R02687','KEGG','RNO:50682',true).
concept_accession('40677: rn:R02687','KEGG','RNO:24254',true).
concept_accession('40605: rn:R06263','EC','2.4.1.-',true).
concept_accession('40605: rn:R06263','KEGG','2.4.1.-',true).
concept_accession('40605: rn:R06263','KEGG','RNO:293129',true).
concept_accession('40605: rn:R06263','KEGG','EC:2.4.1.-',true).
concept_accession('40605: rn:R06263','KEGG','293129',true).
concept_accession('40604: rn:R05981','EC','3.2.1.84',true).
concept_accession('40604: rn:R05981','KEGG','EC:3.2.1.84',true).
concept_accession('40604: rn:R05981','KEGG','RNO:293721',true).
concept_accession('40604: rn:R05981','KEGG','293721',true).
concept_accession('40604: rn:R05981','KEGG','3.2.1.84',true).
concept_accession('40607: rn:R02957','KEGG','1.2.1.3',true).
concept_accession('40607: rn:R02957','KEGG','RNO:291450',true).
concept_accession('40607: rn:R02957','KEGG','RNO:64040',true).
concept_accession('40607: rn:R02957','EC','1.2.1.3',true).
concept_accession('40607: rn:R02957','KEGG','65183',true).
concept_accession('40607: rn:R02957','KEGG','24188',true).
concept_accession('40607: rn:R02957','KEGG','RNO:29539',true).
concept_accession('40607: rn:R02957','KEGG','64040',true).
concept_accession('40607: rn:R02957','KEGG','RNO:24188',true).
concept_accession('40607: rn:R02957','KEGG','29539',true).
concept_accession('40607: rn:R02957','KEGG','29651',true).
concept_accession('40607: rn:R02957','KEGG','298079',true).
concept_accession('40607: rn:R02957','KEGG','RNO:298079',true).
concept_accession('40607: rn:R02957','KEGG','RNO:65183',true).
concept_accession('40607: rn:R02957','KEGG','RNO:29651',true).
concept_accession('40607: rn:R02957','KEGG','291450',true).
concept_accession('40607: rn:R02957','KEGG','EC:1.2.1.3',true).
concept_accession('40606: rn:R06264','EC','2.4.1.-',true).
concept_accession('40606: rn:R06264','KEGG','2.4.1.-',true).
concept_accession('40606: rn:R06264','KEGG','245960',true).
concept_accession('40606: rn:R06264','KEGG','RNO:245960',true).
concept_accession('40606: rn:R06264','KEGG','EC:2.4.1.-',true).
concept_accession('40601: rn:R06127','KEGG','361174',true).
concept_accession('40601: rn:R06127','KEGG','EC:2.4.1.131',true).
concept_accession('40601: rn:R06127','EC','2.4.1.131',true).
concept_accession('40601: rn:R06127','KEGG','RNO:361174',true).
concept_accession('40601: rn:R06127','KEGG','2.4.1.131',true).
concept_accession('40600: rn:R09035','KEGG','RNO:296048',true).
concept_accession('40600: rn:R09035','KEGG','EC:2.3.1.-',true).
concept_accession('40600: rn:R09035','EC','2.3.1.-',true).
concept_accession('40600: rn:R09035','KEGG','296048',true).
concept_accession('40600: rn:R09035','KEGG','362434',true).
concept_accession('40600: rn:R09035','KEGG','313997',true).
concept_accession('40600: rn:R09035','KEGG','RNO:362434',true).
concept_accession('40600: rn:R09035','KEGG','RNO:313997',true).
concept_accession('40600: rn:R09035','KEGG','2.3.1.-',true).
concept_accession('40600: rn:R09035','KEGG','498741',true).
concept_accession('40600: rn:R09035','KEGG','RNO:498741',true).
concept_accession('40603: rn:R06238','KEGG','313231',true).
concept_accession('40603: rn:R06238','EC','2.4.1.-',true).
concept_accession('40603: rn:R06238','KEGG','2.4.1.-',true).
concept_accession('40603: rn:R06238','KEGG','EC:2.4.1.-',true).
concept_accession('40603: rn:R06238','KEGG','RNO:313231',true).
concept_accession('40602: rn:R06261','KEGG','EC:2.4.1.261',true).
concept_accession('40602: rn:R06261','EC','2.4.1.261',true).
concept_accession('40602: rn:R06261','KEGG','RNO:367083',true).
concept_accession('40602: rn:R06261','KEGG','2.4.1.261',true).
concept_accession('40602: rn:R06261','KEGG','367083',true).
concept_accession('40597: rn:R05931','KEGG','EC:2.4.1.226',true).
concept_accession('40597: rn:R05931','EC','2.4.1.226',true).
concept_accession('40597: rn:R05931','KEGG','RNO:292999',true).
concept_accession('40597: rn:R05931','KEGG','296733',true).
concept_accession('40597: rn:R05931','KEGG','291577',true).
concept_accession('40597: rn:R05931','KEGG','RNO:291577',true).
concept_accession('40597: rn:R05931','KEGG','RNO:296733',true).
concept_accession('40597: rn:R05931','KEGG','2.4.1.226',true).
concept_accession('40597: rn:R05931','KEGG','292999',true).
concept_accession('40597: rn:R05931','KEGG','RNO:316533',true).
concept_accession('40597: rn:R05931','KEGG','316533',true).
concept_accession('40596: rn:R05929','KEGG','RNO:306375',true).
concept_accession('40596: rn:R05929','KEGG','2.4.1.174',true).
concept_accession('40596: rn:R05929','KEGG','297554',true).
concept_accession('40596: rn:R05929','KEGG','EC:2.4.1.174',true).
concept_accession('40596: rn:R05929','KEGG','RNO:297554',true).
concept_accession('40596: rn:R05929','EC','2.4.1.174',true).
concept_accession('40596: rn:R05929','KEGG','306375',true).
concept_accession('40599: rn:R09036','KEGG','RNO:296048',true).
concept_accession('40599: rn:R09036','KEGG','362702',true).
concept_accession('40599: rn:R09036','KEGG','RNO:307713',true).
concept_accession('40599: rn:R09036','KEGG','296048',true).
concept_accession('40599: rn:R09036','KEGG','361467',true).
concept_accession('40599: rn:R09036','KEGG','RNO:679692',true).
concept_accession('40599: rn:R09036','KEGG','679692',true).
concept_accession('40599: rn:R09036','KEGG','307713',true).
concept_accession('40599: rn:R09036','EC','2.3.1.-',true).
concept_accession('40599: rn:R09036','KEGG','EC:2.3.1.-',true).
concept_accession('40599: rn:R09036','KEGG','RNO:361467',true).
concept_accession('40599: rn:R09036','KEGG','RNO:100359680',true).
concept_accession('40599: rn:R09036','KEGG','2.3.1.-',true).
concept_accession('40599: rn:R09036','KEGG','RNO:362702',true).
concept_accession('40599: rn:R09036','KEGG','100359680',true).
concept_accession('40598: rn:R05932','KEGG','2.4.1.175',true).
concept_accession('40598: rn:R05932','KEGG','RNO:292999',true).
concept_accession('40598: rn:R05932','KEGG','291577',true).
concept_accession('40598: rn:R05932','KEGG','RNO:291577',true).
concept_accession('40598: rn:R05932','KEGG','292999',true).
concept_accession('40598: rn:R05932','KEGG','RNO:316533',true).
concept_accession('40598: rn:R05932','EC','2.4.1.175',true).
concept_accession('40598: rn:R05932','KEGG','EC:2.4.1.175',true).
concept_accession('40598: rn:R05932','KEGG','316533',true).
concept_accession('40593: rn:R09034','KEGG','RNO:294324',true).
concept_accession('40593: rn:R09034','KEGG','362702',true).
concept_accession('40593: rn:R09034','KEGG','EC:2.3.1.-',true).
concept_accession('40593: rn:R09034','EC','2.3.1.-',true).
concept_accession('40593: rn:R09034','KEGG','170919',true).
concept_accession('40593: rn:R09034','KEGG','RNO:170919',true).
concept_accession('40593: rn:R09034','KEGG','RNO:308309',true).
concept_accession('40593: rn:R09034','KEGG','308309',true).
concept_accession('40593: rn:R09034','KEGG','294324',true).
concept_accession('40593: rn:R09034','KEGG','2.3.1.-',true).
concept_accession('40593: rn:R09034','KEGG','RNO:362702',true).
concept_accession('40592: rn:R05926','KEGG','2.4.1.133',true).
concept_accession('40592: rn:R05926','KEGG','EC:2.4.1.133',true).
concept_accession('40592: rn:R05926','KEGG','364675',true).
concept_accession('40592: rn:R05926','KEGG','RNO:364675',true).
concept_accession('40592: rn:R05926','EC','2.4.1.133',true).
concept_accession('40595: rn:R05928','KEGG','EC:2.4.1.135',true).
concept_accession('40595: rn:R05928','KEGG','2.4.1.135',true).
concept_accession('40595: rn:R05928','KEGG','64544',true).
concept_accession('40595: rn:R05928','KEGG','RNO:117108',true).
concept_accession('40595: rn:R05928','KEGG','RNO:293722',true).
concept_accession('40595: rn:R05928','KEGG','293722',true).
concept_accession('40595: rn:R05928','KEGG','RNO:64544',true).
concept_accession('40595: rn:R05928','KEGG','117108',true).
concept_accession('40595: rn:R05928','EC','2.4.1.135',true).
concept_accession('40594: rn:R05925','EC','2.4.2.26',true).
concept_accession('40594: rn:R05925','KEGG','64133',true).
concept_accession('40594: rn:R05925','KEGG','64134',true).
concept_accession('40594: rn:R05925','KEGG','2.4.2.26',true).
concept_accession('40594: rn:R05925','KEGG','RNO:64134',true).
concept_accession('40594: rn:R05925','KEGG','RNO:64133',true).
concept_accession('40594: rn:R05925','KEGG','EC:2.4.2.26',true).
concept_accession('40588: rn:R07809','KEGG','RNO:294673',true).
concept_accession('40588: rn:R07809','KEGG','294673',true).
concept_accession('40588: rn:R07809','KEGG','RNO:300757',true).
concept_accession('40588: rn:R07809','KEGG','EC:3.2.1.52',true).
concept_accession('40588: rn:R07809','EC','3.2.1.52',true).
concept_accession('40588: rn:R07809','KEGG','300757',true).
concept_accession('40588: rn:R07809','KEGG','3.2.1.52',true).
concept_accession('40589: rn:R07808','KEGG','EC:3.1.6.14',true).
concept_accession('40589: rn:R07808','EC','3.1.6.14',true).
concept_accession('40589: rn:R07808','KEGG','299825',true).
concept_accession('40589: rn:R07808','KEGG','RNO:299825',true).
concept_accession('40589: rn:R07808','KEGG','3.1.6.14',true).
concept_accession('40590: rn:R05927','KEGG','2.4.1.134',true).
concept_accession('40590: rn:R05927','KEGG','EC:2.4.1.134',true).
concept_accession('40590: rn:R05927','KEGG','RNO:298690',true).
concept_accession('40590: rn:R05927','EC','2.4.1.134',true).
concept_accession('40590: rn:R05927','KEGG','298690',true).
concept_accession('40591: rn:R09037','KEGG','363521',true).
concept_accession('40591: rn:R09037','KEGG','362702',true).
concept_accession('40591: rn:R09037','KEGG','RNO:363521',true).
concept_accession('40591: rn:R09037','KEGG','EC:2.3.1.-',true).
concept_accession('40591: rn:R09037','EC','2.3.1.-',true).
concept_accession('40591: rn:R09037','KEGG','2.3.1.-',true).
concept_accession('40591: rn:R09037','KEGG','RNO:362702',true).
concept_accession('40584: rn:R07812','KEGG','RNO:363513',true).
concept_accession('40584: rn:R07812','EC','3.1.6.13',true).
concept_accession('40584: rn:R07812','KEGG','EC:3.1.6.13',true).
concept_accession('40584: rn:R07812','KEGG','3.1.6.13',true).
concept_accession('40584: rn:R07812','KEGG','363513',true).
concept_accession('40585: rn:R07818','EC','3.2.1.31',true).
concept_accession('40585: rn:R07818','KEGG','24434',true).
concept_accession('40585: rn:R07818','KEGG','EC:3.2.1.31',true).
concept_accession('40585: rn:R07818','KEGG','3.2.1.31',true).
concept_accession('40585: rn:R07818','KEGG','RNO:24434',true).
concept_accession('40586: rn:R07807','KEGG','3.2.1.23',true).
concept_accession('40586: rn:R07807','EC','3.2.1.23',true).
concept_accession('40586: rn:R07807','KEGG','EC:3.2.1.23',true).
concept_accession('40586: rn:R07807','KEGG','RNO:316033',true).
concept_accession('40586: rn:R07807','KEGG','316033',true).
concept_accession('40587: rn:R07806','EC','3.1.6.4',true).
concept_accession('40587: rn:R07806','KEGG','3.1.6.4',true).
concept_accession('40587: rn:R07806','KEGG','EC:3.1.6.4',true).
concept_accession('40587: rn:R07806','KEGG','RNO:292073',true).
concept_accession('40587: rn:R07806','KEGG','292073',true).
concept_accession('40580: rn:R03184','EC','1.1.3.8',true).
concept_accession('40580: rn:R03184','KEGG','60671',true).
concept_accession('40580: rn:R03184','KEGG','RNO:60671',true).
concept_accession('40580: rn:R03184','KEGG','1.1.3.8',true).
concept_accession('40580: rn:R03184','KEGG','EC:1.1.3.8',true).
concept_accession('40581: rn:R07811','KEGG','RNO:64537',true).
concept_accession('40581: rn:R07811','KEGG','3.2.1.-',true).
concept_accession('40581: rn:R07811','EC','3.2.1.-',true).
concept_accession('40581: rn:R07811','KEGG','RNO:368128',true).
concept_accession('40581: rn:R07811','KEGG','64537',true).
concept_accession('40581: rn:R07811','KEGG','EC:3.2.1.-',true).
concept_accession('40581: rn:R07811','KEGG','368128',true).
concept_accession('40582: rn:R07816','EC','3.2.1.50',true).
concept_accession('40582: rn:R07816','KEGG','RNO:360630',true).
concept_accession('40582: rn:R07816','KEGG','EC:3.2.1.50',true).
concept_accession('40582: rn:R07816','KEGG','360630',true).
concept_accession('40582: rn:R07816','KEGG','3.2.1.50',true).
concept_accession('40583: rn:R07822','KEGG','EC:3.2.1.76',true).
concept_accession('40583: rn:R07822','EC','3.2.1.76',true).
concept_accession('40583: rn:R07822','KEGG','100361089',true).
concept_accession('40583: rn:R07822','KEGG','3.2.1.76',true).
concept_accession('40583: rn:R07822','KEGG','RNO:100361089',true).
concept_accession('40576: rn:R07824','KEGG','RNO:300993',true).
concept_accession('40576: rn:R07824','KEGG','RNO:500052',true).
concept_accession('40576: rn:R07824','KEGG','RNO:500051',true).
concept_accession('40576: rn:R07824','KEGG','3.2.1.35',true).
concept_accession('40576: rn:R07824','KEGG','500052',true).
concept_accession('40576: rn:R07824','KEGG','RNO:367166',true).
concept_accession('40576: rn:R07824','KEGG','500051',true).
concept_accession('40576: rn:R07824','KEGG','RNO:404783',true).
concept_accession('40576: rn:R07824','EC','3.2.1.35',true).
concept_accession('40576: rn:R07824','KEGG','404783',true).
concept_accession('40576: rn:R07824','KEGG','367166',true).
concept_accession('40576: rn:R07824','KEGG','EC:3.2.1.35',true).
concept_accession('40576: rn:R07824','KEGG','117037',true).
concept_accession('40576: rn:R07824','KEGG','64468',true).
concept_accession('40576: rn:R07824','KEGG','RNO:117037',true).
concept_accession('40576: rn:R07824','KEGG','RNO:64468',true).
concept_accession('40576: rn:R07824','KEGG','300993',true).
concept_accession('40577: rn:R07823','KEGG','EC:3.1.6.12',true).
concept_accession('40577: rn:R07823','EC','3.1.6.12',true).
concept_accession('40577: rn:R07823','KEGG','25227',true).
concept_accession('40577: rn:R07823','KEGG','RNO:25227',true).
concept_accession('40577: rn:R07823','KEGG','3.1.6.12',true).
concept_accession('13665: rn:R08249','KEGG','RN:R08249',true).
concept_accession('13665: rn:R08249','KEGG','RC:RC00962',true).
concept_accession('13665: rn:R08249','EC','3.-.-.-',false).
concept_accession('13665: rn:R08249','KEGG','RC00962',true).
concept_accession('13665: rn:R08249','KEGG','RP13128',true).
concept_accession('13665: rn:R08249','KEGG','RP13126',true).
concept_accession('13665: rn:R08249','KEGG','RC:RC00162',true).
concept_accession('13665: rn:R08249','KEGG','R08249',true).
concept_accession('13665: rn:R08249','KEGG','3.-.-.-',true).
concept_accession('13665: rn:R08249','KEGG','EC:3.-.-.-',true).
concept_accession('13665: rn:R08249','KEGG','RP:RP13126',true).
concept_accession('13665: rn:R08249','KEGG','RC00162',true).
concept_accession('13665: rn:R08249','KEGG','RP:RP13128',true).
concept_accession('40578: rn:R07813','KEGG','EC:3.2.1.76',true).
concept_accession('40578: rn:R07813','EC','3.2.1.76',true).
concept_accession('40578: rn:R07813','KEGG','100361089',true).
concept_accession('40578: rn:R07813','KEGG','3.2.1.76',true).
concept_accession('40578: rn:R07813','KEGG','RNO:100361089',true).
concept_accession('40579: rn:R07814','KEGG','RNO:688293',true).
concept_accession('40579: rn:R07814','KEGG','688293',true).
concept_accession('40579: rn:R07814','KEGG','3.10.1.1',true).
concept_accession('40579: rn:R07814','KEGG','EC:3.10.1.1',true).
concept_accession('40579: rn:R07814','EC','3.10.1.1',true).
concept_accession('40639: rn:R05907','KEGG','RNO:500826',true).
concept_accession('40639: rn:R05907','KEGG','RNO:288611',true).
concept_accession('40639: rn:R05907','KEGG','RNO:366061',true).
concept_accession('40639: rn:R05907','KEGG','313878',true).
concept_accession('40639: rn:R05907','KEGG','RNO:499968',true).
concept_accession('40639: rn:R05907','KEGG','683264',true).
concept_accession('40639: rn:R05907','KEGG','361142',true).
concept_accession('40639: rn:R05907','KEGG','288611',true).
concept_accession('40639: rn:R05907','KEGG','311039',true).
concept_accession('40639: rn:R05907','KEGG','RNO:29750',true).
concept_accession('40639: rn:R05907','EC','2.4.1.41',true).
concept_accession('40639: rn:R05907','KEGG','RNO:362760',true).
concept_accession('40639: rn:R05907','KEGG','RNO:100366230',true).
concept_accession('40639: rn:R05907','KEGG','RNO:83627',true).
concept_accession('40639: rn:R05907','KEGG','293181',true).
concept_accession('40639: rn:R05907','KEGG','RNO:170501',true).
concept_accession('40639: rn:R05907','KEGG','RNO:313878',true).
concept_accession('40639: rn:R05907','KEGG','500826',true).
concept_accession('40639: rn:R05907','KEGG','362760',true).
concept_accession('40639: rn:R05907','KEGG','RNO:361142',true).
concept_accession('40639: rn:R05907','KEGG','83627',true).
concept_accession('40639: rn:R05907','KEGG','100361647',true).
concept_accession('40639: rn:R05907','KEGG','RNO:100361647',true).
concept_accession('40639: rn:R05907','KEGG','RNO:311039',true).
concept_accession('40639: rn:R05907','KEGG','313233',true).
concept_accession('40639: rn:R05907','KEGG','311952',true).
concept_accession('40639: rn:R05907','KEGG','366061',true).
concept_accession('40639: rn:R05907','KEGG','RNO:292090',true).
concept_accession('40639: rn:R05907','KEGG','EC:2.4.1.41',true).
concept_accession('40639: rn:R05907','KEGG','170501',true).
concept_accession('40639: rn:R05907','KEGG','292090',true).
concept_accession('40639: rn:R05907','KEGG','RNO:79214',true).
concept_accession('40639: rn:R05907','KEGG','100366230',true).
concept_accession('40639: rn:R05907','KEGG','499968',true).
concept_accession('40639: rn:R05907','KEGG','RNO:683264',true).
concept_accession('40639: rn:R05907','KEGG','RNO:313233',true).
concept_accession('40639: rn:R05907','KEGG','29750',true).
concept_accession('40639: rn:R05907','KEGG','2.4.1.41',true).
concept_accession('40639: rn:R05907','KEGG','RNO:311952',true).
concept_accession('40639: rn:R05907','KEGG','79214',true).
concept_accession('40639: rn:R05907','KEGG','RNO:293181',true).
concept_accession('40638: rn:R05907','KEGG','RNO:500826',true).
concept_accession('40638: rn:R05907','KEGG','RNO:288611',true).
concept_accession('40638: rn:R05907','KEGG','RNO:366061',true).
concept_accession('40638: rn:R05907','KEGG','313878',true).
concept_accession('40638: rn:R05907','KEGG','RNO:499968',true).
concept_accession('40638: rn:R05907','KEGG','683264',true).
concept_accession('40638: rn:R05907','KEGG','361142',true).
concept_accession('40638: rn:R05907','KEGG','288611',true).
concept_accession('40638: rn:R05907','KEGG','311039',true).
concept_accession('40638: rn:R05907','KEGG','RNO:29750',true).
concept_accession('40638: rn:R05907','EC','2.4.1.41',true).
concept_accession('40638: rn:R05907','KEGG','RNO:362760',true).
concept_accession('40638: rn:R05907','KEGG','RNO:100366230',true).
concept_accession('40638: rn:R05907','KEGG','RNO:83627',true).
concept_accession('40638: rn:R05907','KEGG','293181',true).
concept_accession('40638: rn:R05907','KEGG','RNO:170501',true).
concept_accession('40638: rn:R05907','KEGG','RNO:313878',true).
concept_accession('40638: rn:R05907','KEGG','500826',true).
concept_accession('40638: rn:R05907','KEGG','362760',true).
concept_accession('40638: rn:R05907','KEGG','RNO:361142',true).
concept_accession('40638: rn:R05907','KEGG','83627',true).
concept_accession('40638: rn:R05907','KEGG','100361647',true).
concept_accession('40638: rn:R05907','KEGG','RNO:100361647',true).
concept_accession('40638: rn:R05907','KEGG','RNO:311039',true).
concept_accession('40638: rn:R05907','KEGG','313233',true).
concept_accession('40638: rn:R05907','KEGG','311952',true).
concept_accession('40638: rn:R05907','KEGG','366061',true).
concept_accession('40638: rn:R05907','KEGG','RNO:292090',true).
concept_accession('40638: rn:R05907','KEGG','EC:2.4.1.41',true).
concept_accession('40638: rn:R05907','KEGG','170501',true).
concept_accession('40638: rn:R05907','KEGG','292090',true).
concept_accession('40638: rn:R05907','KEGG','RNO:79214',true).
concept_accession('40638: rn:R05907','KEGG','100366230',true).
concept_accession('40638: rn:R05907','KEGG','499968',true).
concept_accession('40638: rn:R05907','KEGG','RNO:683264',true).
concept_accession('40638: rn:R05907','KEGG','RNO:313233',true).
concept_accession('40638: rn:R05907','KEGG','29750',true).
concept_accession('40638: rn:R05907','KEGG','2.4.1.41',true).
concept_accession('40638: rn:R05907','KEGG','RNO:311952',true).
concept_accession('40638: rn:R05907','KEGG','79214',true).
concept_accession('40638: rn:R05907','KEGG','RNO:293181',true).
concept_accession('40637: rn:R05907','KEGG','RNO:500826',true).
concept_accession('40637: rn:R05907','KEGG','RNO:288611',true).
concept_accession('40637: rn:R05907','KEGG','RNO:366061',true).
concept_accession('40637: rn:R05907','KEGG','313878',true).
concept_accession('40637: rn:R05907','KEGG','RNO:499968',true).
concept_accession('40637: rn:R05907','KEGG','683264',true).
concept_accession('40637: rn:R05907','KEGG','361142',true).
concept_accession('40637: rn:R05907','KEGG','288611',true).
concept_accession('40637: rn:R05907','KEGG','311039',true).
concept_accession('40637: rn:R05907','KEGG','RNO:29750',true).
concept_accession('40637: rn:R05907','EC','2.4.1.41',true).
concept_accession('40637: rn:R05907','KEGG','RNO:362760',true).
concept_accession('40637: rn:R05907','KEGG','RNO:100366230',true).
concept_accession('40637: rn:R05907','KEGG','RNO:83627',true).
concept_accession('40637: rn:R05907','KEGG','293181',true).
concept_accession('40637: rn:R05907','KEGG','RNO:170501',true).
concept_accession('40637: rn:R05907','KEGG','RNO:313878',true).
concept_accession('40637: rn:R05907','KEGG','500826',true).
concept_accession('40637: rn:R05907','KEGG','362760',true).
concept_accession('40637: rn:R05907','KEGG','RNO:361142',true).
concept_accession('40637: rn:R05907','KEGG','83627',true).
concept_accession('40637: rn:R05907','KEGG','100361647',true).
concept_accession('40637: rn:R05907','KEGG','RNO:100361647',true).
concept_accession('40637: rn:R05907','KEGG','RNO:311039',true).
concept_accession('40637: rn:R05907','KEGG','313233',true).
concept_accession('40637: rn:R05907','KEGG','311952',true).
concept_accession('40637: rn:R05907','KEGG','366061',true).
concept_accession('40637: rn:R05907','KEGG','RNO:292090',true).
concept_accession('40637: rn:R05907','KEGG','EC:2.4.1.41',true).
concept_accession('40637: rn:R05907','KEGG','170501',true).
concept_accession('40637: rn:R05907','KEGG','292090',true).
concept_accession('40637: rn:R05907','KEGG','RNO:79214',true).
concept_accession('40637: rn:R05907','KEGG','100366230',true).
concept_accession('40637: rn:R05907','KEGG','499968',true).
concept_accession('40637: rn:R05907','KEGG','RNO:683264',true).
concept_accession('40637: rn:R05907','KEGG','RNO:313233',true).
concept_accession('40637: rn:R05907','KEGG','29750',true).
concept_accession('40637: rn:R05907','KEGG','2.4.1.41',true).
concept_accession('40637: rn:R05907','KEGG','RNO:311952',true).
concept_accession('40637: rn:R05907','KEGG','79214',true).
concept_accession('40637: rn:R05907','KEGG','RNO:293181',true).
concept_accession('9327: rn:R01388','KEGG','RP:RP00299',true).
concept_accession('9327: rn:R01388','KEGG','RC00031',true).
concept_accession('9327: rn:R01388','KEGG','1.1.1.29',true).
concept_accession('9327: rn:R01388','EC','1.1.1.29',false).
concept_accession('9327: rn:R01388','KEGG','R01388',true).
concept_accession('9327: rn:R01388','KEGG','EC:1.1.1.29',true).
concept_accession('9327: rn:R01388','KEGG','RC:RC00031',true).
concept_accession('9327: rn:R01388','KEGG','RP00299',true).
concept_accession('9327: rn:R01388','KEGG','RN:R01388',true).
concept_accession('40636: rn:R05907','KEGG','RNO:500826',true).
concept_accession('40636: rn:R05907','KEGG','RNO:288611',true).
concept_accession('40636: rn:R05907','KEGG','RNO:366061',true).
concept_accession('40636: rn:R05907','KEGG','313878',true).
concept_accession('40636: rn:R05907','KEGG','RNO:499968',true).
concept_accession('40636: rn:R05907','KEGG','683264',true).
concept_accession('40636: rn:R05907','KEGG','361142',true).
concept_accession('40636: rn:R05907','KEGG','288611',true).
concept_accession('40636: rn:R05907','KEGG','311039',true).
concept_accession('40636: rn:R05907','KEGG','RNO:29750',true).
concept_accession('40636: rn:R05907','EC','2.4.1.41',true).
concept_accession('40636: rn:R05907','KEGG','RNO:362760',true).
concept_accession('40636: rn:R05907','KEGG','RNO:100366230',true).
concept_accession('40636: rn:R05907','KEGG','RNO:83627',true).
concept_accession('40636: rn:R05907','KEGG','293181',true).
concept_accession('40636: rn:R05907','KEGG','RNO:170501',true).
concept_accession('40636: rn:R05907','KEGG','RNO:313878',true).
concept_accession('40636: rn:R05907','KEGG','500826',true).
concept_accession('40636: rn:R05907','KEGG','362760',true).
concept_accession('40636: rn:R05907','KEGG','RNO:361142',true).
concept_accession('40636: rn:R05907','KEGG','83627',true).
concept_accession('40636: rn:R05907','KEGG','100361647',true).
concept_accession('40636: rn:R05907','KEGG','RNO:100361647',true).
concept_accession('40636: rn:R05907','KEGG','RNO:311039',true).
concept_accession('40636: rn:R05907','KEGG','313233',true).
concept_accession('40636: rn:R05907','KEGG','311952',true).
concept_accession('40636: rn:R05907','KEGG','366061',true).
concept_accession('40636: rn:R05907','KEGG','RNO:292090',true).
concept_accession('40636: rn:R05907','KEGG','EC:2.4.1.41',true).
concept_accession('40636: rn:R05907','KEGG','170501',true).
concept_accession('40636: rn:R05907','KEGG','292090',true).
concept_accession('40636: rn:R05907','KEGG','RNO:79214',true).
concept_accession('40636: rn:R05907','KEGG','100366230',true).
concept_accession('40636: rn:R05907','KEGG','499968',true).
concept_accession('40636: rn:R05907','KEGG','RNO:683264',true).
concept_accession('40636: rn:R05907','KEGG','RNO:313233',true).
concept_accession('40636: rn:R05907','KEGG','29750',true).
concept_accession('40636: rn:R05907','KEGG','2.4.1.41',true).
concept_accession('40636: rn:R05907','KEGG','RNO:311952',true).
concept_accession('40636: rn:R05907','KEGG','79214',true).
concept_accession('40636: rn:R05907','KEGG','RNO:293181',true).
concept_accession('40635: rn:R08159','KEGG','50671',true).
concept_accession('40635: rn:R08159','KEGG','2.3.1.85',true).
concept_accession('40635: rn:R08159','KEGG','EC:2.3.1.85',true).
concept_accession('40635: rn:R08159','KEGG','RNO:50671',true).
concept_accession('40635: rn:R08159','EC','2.3.1.85',true).
concept_accession('40634: rn:R08615','KEGG','396551',true).
concept_accession('40634: rn:R08615','KEGG','154516',true).
concept_accession('40634: rn:R08615','KEGG','396552',true).
concept_accession('40634: rn:R08615','KEGG','RNO:305264',true).
concept_accession('40634: rn:R08615','KEGG','289533',true).
concept_accession('40634: rn:R08615','KEGG','RNO:396527',true).
concept_accession('40634: rn:R08615','KEGG','574523',true).
concept_accession('40634: rn:R08615','KEGG','396527',true).
concept_accession('40634: rn:R08615','EC','3.2.1.-',true).
concept_accession('40634: rn:R08615','KEGG','113992',true).
concept_accession('40634: rn:R08615','KEGG','RNO:574523',true).
concept_accession('40634: rn:R08615','KEGG','RNO:266685',true).
concept_accession('40634: rn:R08615','KEGG','RNO:24861',true).
concept_accession('40634: rn:R08615','KEGG','266685',true).
concept_accession('40634: rn:R08615','KEGG','RNO:24862',true).
concept_accession('40634: rn:R08615','KEGG','29623',true).
concept_accession('40634: rn:R08615','KEGG','RNO:289533',true).
concept_accession('40634: rn:R08615','KEGG','305264',true).
concept_accession('40634: rn:R08615','KEGG','3.2.1.-',true).
concept_accession('40634: rn:R08615','KEGG','RNO:83808',true).
concept_accession('40634: rn:R08615','KEGG','RNO:301595',true).
concept_accession('40634: rn:R08615','KEGG','EC:3.2.1.-',true).
concept_accession('40634: rn:R08615','KEGG','RNO:29623',true).
concept_accession('40634: rn:R08615','KEGG','RNO:154516',true).
concept_accession('40634: rn:R08615','KEGG','RNO:396552',true).
concept_accession('40634: rn:R08615','KEGG','301595',true).
concept_accession('40634: rn:R08615','KEGG','RNO:396551',true).
concept_accession('40634: rn:R08615','KEGG','RNO:286954',true).
concept_accession('40634: rn:R08615','KEGG','RNO:113992',true).
concept_accession('40634: rn:R08615','KEGG','RNO:63867',true).
concept_accession('40634: rn:R08615','KEGG','286954',true).
concept_accession('40634: rn:R08615','KEGG','83808',true).
concept_accession('40634: rn:R08615','KEGG','24861',true).
concept_accession('40634: rn:R08615','KEGG','63867',true).
concept_accession('40634: rn:R08615','KEGG','24862',true).
concept_accession('40633: rn:R07762','KEGG','2.3.1.179',true).
concept_accession('40633: rn:R07762','KEGG','EC:2.3.1.179',true).
concept_accession('40633: rn:R07762','EC','2.3.1.179',true).
concept_accession('40633: rn:R07762','KEGG','RNO:289934',true).
concept_accession('40633: rn:R07762','KEGG','289934',true).
concept_accession('9323: rn:R01196','KEGG','R01196',true).
concept_accession('9323: rn:R01196','KEGG','RN:R01196',true).
concept_accession('9323: rn:R01196','KEGG','1.2.7.1',true).
concept_accession('9323: rn:R01196','EC','1.2.7.1',false).
concept_accession('9323: rn:R01196','KEGG','EC:1.2.7.1',true).
concept_accession('40632: rn:R08163','KEGG','EC:3.1.2.14',true).
concept_accession('40632: rn:R08163','KEGG','3.1.2.14',true).
concept_accession('40632: rn:R08163','EC','3.1.2.14',true).
concept_accession('40632: rn:R08163','KEGG','RNO:64669',true).
concept_accession('40632: rn:R08163','KEGG','64669',true).
concept_accession('40631: rn:R02814','KEGG','EC:3.1.2.14',true).
concept_accession('40631: rn:R02814','KEGG','3.1.2.14',true).
concept_accession('40631: rn:R02814','EC','3.1.2.14',true).
concept_accession('40631: rn:R02814','KEGG','RNO:64669',true).
concept_accession('40631: rn:R02814','KEGG','64669',true).
concept_accession('40630: rn:R04014','KEGG','EC:3.1.2.21',true).
concept_accession('40630: rn:R04014','KEGG','RNO:64669',true).
concept_accession('40630: rn:R04014','EC','3.1.2.21',true).
concept_accession('40630: rn:R04014','KEGG','3.1.2.21',true).
concept_accession('40630: rn:R04014','KEGG','64669',true).
concept_accession('40629: rn:R08159','KEGG','RNO:64669',true).
concept_accession('40629: rn:R08159','KEGG','2.3.1.85',true).
concept_accession('40629: rn:R08159','KEGG','EC:2.3.1.85',true).
concept_accession('40629: rn:R08159','EC','2.3.1.85',true).
concept_accession('40629: rn:R08159','KEGG','64669',true).
concept_accession('40628: rn:R04968','KEGG','2.3.1.179',true).
concept_accession('40628: rn:R04968','KEGG','EC:2.3.1.179',true).
concept_accession('40628: rn:R04968','EC','2.3.1.179',true).
concept_accession('40628: rn:R04968','KEGG','RNO:289934',true).
concept_accession('40628: rn:R04968','KEGG','289934',true).
concept_accession('40627: rn:R04726','KEGG','RNO:289934',true).
concept_accession('40627: rn:R04726','KEGG','2.3.1.85',true).
concept_accession('40627: rn:R04726','KEGG','EC:2.3.1.85',true).
concept_accession('40627: rn:R04726','KEGG','289934',true).
concept_accession('40627: rn:R04726','EC','2.3.1.85',true).
concept_accession('40626: rn:R05915','KEGG','EC:2.4.1.148',true).
concept_accession('40626: rn:R05915','KEGG','RNO:286976',true).
concept_accession('40626: rn:R05915','KEGG','286976',true).
concept_accession('40626: rn:R05915','EC','2.4.1.148',true).
concept_accession('40626: rn:R05915','KEGG','2.4.1.148',true).
concept_accession('40625: rn:R04963','KEGG','2.3.1.86',true).
concept_accession('40625: rn:R04963','EC','2.3.1.86',true).
concept_accession('40625: rn:R04963','KEGG','RNO:289934',true).
concept_accession('40625: rn:R04963','KEGG','EC:2.3.1.86',true).
concept_accession('40625: rn:R04963','KEGG','289934',true).
concept_accession('40624: rn:R05910','EC','2.4.1.102',true).
concept_accession('40624: rn:R05910','KEGG','EC:2.4.1.102',true).
concept_accession('40624: rn:R05910','KEGG','2.4.1.102',true).
concept_accession('40624: rn:R05910','KEGG','64043',true).
concept_accession('40624: rn:R05910','KEGG','RNO:64043',true).
concept_accession('9341: rn:R00519','KEGG','1.2.1.2',true).
concept_accession('9341: rn:R00519','KEGG','R00519',true).
concept_accession('9341: rn:R00519','KEGG','RN:R00519',true).
concept_accession('9341: rn:R00519','EC','1.2.1.2',false).
concept_accession('9341: rn:R00519','KEGG','EC:1.2.1.2',true).
concept_accession('40622: rn:R05914','KEGG','RNO:287920',true).
concept_accession('40622: rn:R05914','KEGG','2.4.99.3',true).
concept_accession('40622: rn:R05914','KEGG','287920',true).
concept_accession('40622: rn:R05914','KEGG','EC:2.4.99.3',true).
concept_accession('40622: rn:R05914','EC','2.4.99.3',true).
concept_accession('9340: rn:R00945','KEGG','RN:R00945',true).
concept_accession('9340: rn:R00945','KEGG','R00945',true).
concept_accession('9340: rn:R00945','KEGG','EC:2.1.2.1',true).
concept_accession('9340: rn:R00945','KEGG','RP00061',true).
concept_accession('9340: rn:R00945','KEGG','2.1.2.1',true).
concept_accession('9340: rn:R00945','KEGG','RC:RC00022',true).
concept_accession('9340: rn:R00945','KEGG','RP:RP00061',true).
concept_accession('9340: rn:R00945','EC','2.1.2.1',false).
concept_accession('9340: rn:R00945','KEGG','RC00022',true).
concept_accession('40623: rn:R04960','KEGG','2.3.1.179',true).
concept_accession('40623: rn:R04960','KEGG','EC:2.3.1.179',true).
concept_accession('40623: rn:R04960','EC','2.3.1.179',true).
concept_accession('40623: rn:R04960','KEGG','RNO:289934',true).
concept_accession('40623: rn:R04960','KEGG','289934',true).
concept_accession('40620: rn:R05911','KEGG','RNO:287920',true).
concept_accession('40620: rn:R05911','KEGG','2.4.99.3',true).
concept_accession('40620: rn:R05911','KEGG','287920',true).
concept_accession('40620: rn:R05911','KEGG','EC:2.4.99.3',true).
concept_accession('40620: rn:R05911','EC','2.4.99.3',true).
concept_accession('40621: rn:R07628','EC','2.4.1.-',true).
concept_accession('40621: rn:R07628','KEGG','2.4.1.-',true).
concept_accession('40621: rn:R07628','KEGG','EC:2.4.1.-',true).
concept_accession('40621: rn:R07628','KEGG','RNO:362275',true).
concept_accession('40621: rn:R07628','KEGG','362275',true).
concept_accession('5934: rn:R02738','KEGG','RP02452',true).
concept_accession('5934: rn:R02738','KEGG','RN:R02738',true).
concept_accession('5934: rn:R02738','KEGG','RC00017',true).
concept_accession('5934: rn:R02738','EC','2.7.1.69',false).
concept_accession('5934: rn:R02738','KEGG','EC:2.7.1.69',true).
concept_accession('5934: rn:R02738','KEGG','RP:RP02452',true).
concept_accession('5934: rn:R02738','KEGG','RC:RC00017',true).
concept_accession('5934: rn:R02738','KEGG','R02738',true).
concept_accession('5934: rn:R02738','KEGG','2.7.1.69',true).
concept_accession('40618: rn:R05909','KEGG','2.4.1.147',true).
concept_accession('40618: rn:R05909','KEGG','RNO:292325',true).
concept_accession('40618: rn:R05909','KEGG','292325',true).
concept_accession('40618: rn:R05909','EC','2.4.1.147',true).
concept_accession('40618: rn:R05909','KEGG','EC:2.4.1.147',true).
concept_accession('9336: rn:R08572','KEGG','2.7.1.-',true).
concept_accession('9336: rn:R08572','EC','2.7.1.-',false).
concept_accession('9336: rn:R08572','KEGG','R08572',true).
concept_accession('9336: rn:R08572','KEGG','RC:RC00428',true).
concept_accession('9336: rn:R08572','KEGG','RN:R08572',true).
concept_accession('9336: rn:R08572','KEGG','RC00428',true).
concept_accession('9336: rn:R08572','KEGG','RP:RP01729',true).
concept_accession('9336: rn:R08572','KEGG','RP01729',true).
concept_accession('9336: rn:R08572','KEGG','EC:2.7.1.-',true).
concept_accession('40619: rn:R05907','KEGG','RNO:500826',true).
concept_accession('40619: rn:R05907','KEGG','RNO:288611',true).
concept_accession('40619: rn:R05907','KEGG','RNO:366061',true).
concept_accession('40619: rn:R05907','KEGG','313878',true).
concept_accession('40619: rn:R05907','KEGG','RNO:499968',true).
concept_accession('40619: rn:R05907','KEGG','683264',true).
concept_accession('40619: rn:R05907','KEGG','361142',true).
concept_accession('40619: rn:R05907','KEGG','288611',true).
concept_accession('40619: rn:R05907','KEGG','311039',true).
concept_accession('40619: rn:R05907','KEGG','RNO:29750',true).
concept_accession('40619: rn:R05907','EC','2.4.1.41',true).
concept_accession('40619: rn:R05907','KEGG','RNO:362760',true).
concept_accession('40619: rn:R05907','KEGG','RNO:100366230',true).
concept_accession('40619: rn:R05907','KEGG','RNO:83627',true).
concept_accession('40619: rn:R05907','KEGG','293181',true).
concept_accession('40619: rn:R05907','KEGG','RNO:170501',true).
concept_accession('40619: rn:R05907','KEGG','RNO:313878',true).
concept_accession('40619: rn:R05907','KEGG','500826',true).
concept_accession('40619: rn:R05907','KEGG','362760',true).
concept_accession('40619: rn:R05907','KEGG','RNO:361142',true).
concept_accession('40619: rn:R05907','KEGG','83627',true).
concept_accession('40619: rn:R05907','KEGG','100361647',true).
concept_accession('40619: rn:R05907','KEGG','RNO:100361647',true).
concept_accession('40619: rn:R05907','KEGG','RNO:311039',true).
concept_accession('40619: rn:R05907','KEGG','313233',true).
concept_accession('40619: rn:R05907','KEGG','311952',true).
concept_accession('40619: rn:R05907','KEGG','366061',true).
concept_accession('40619: rn:R05907','KEGG','RNO:292090',true).
concept_accession('40619: rn:R05907','KEGG','EC:2.4.1.41',true).
concept_accession('40619: rn:R05907','KEGG','170501',true).
concept_accession('40619: rn:R05907','KEGG','292090',true).
concept_accession('40619: rn:R05907','KEGG','RNO:79214',true).
concept_accession('40619: rn:R05907','KEGG','100366230',true).
concept_accession('40619: rn:R05907','KEGG','499968',true).
concept_accession('40619: rn:R05907','KEGG','RNO:683264',true).
concept_accession('40619: rn:R05907','KEGG','RNO:313233',true).
concept_accession('40619: rn:R05907','KEGG','29750',true).
concept_accession('40619: rn:R05907','KEGG','2.4.1.41',true).
concept_accession('40619: rn:R05907','KEGG','RNO:311952',true).
concept_accession('40619: rn:R05907','KEGG','79214',true).
concept_accession('40619: rn:R05907','KEGG','RNO:293181',true).
concept_accession('40616: rn:R05936','KEGG','RNO:313610',true).
concept_accession('40616: rn:R05936','EC','2.4.1.224',true).
concept_accession('40616: rn:R05936','KEGG','313610',true).
concept_accession('40616: rn:R05936','EC','2.4.1.223',true).
concept_accession('40616: rn:R05936','KEGG','56819',true).
concept_accession('40616: rn:R05936','KEGG','RNO:56819',true).
concept_accession('40616: rn:R05936','KEGG','2.4.1.224',true).
concept_accession('40616: rn:R05936','KEGG','2.4.1.223',true).
concept_accession('40616: rn:R05936','KEGG','EC:2.4.1.224',true).
concept_accession('40616: rn:R05936','KEGG','EC:2.4.1.223',true).
concept_accession('40617: rn:R05930','EC','2.4.1.223',true).
concept_accession('40617: rn:R05930','KEGG','RNO:310803',true).
concept_accession('40617: rn:R05930','KEGG','56819',true).
concept_accession('40617: rn:R05930','KEGG','310803',true).
concept_accession('40617: rn:R05930','KEGG','RNO:56819',true).
concept_accession('40617: rn:R05930','KEGG','2.4.1.223',true).
concept_accession('40617: rn:R05930','KEGG','EC:2.4.1.223',true).
concept_accession('40614: rn:R05911','KEGG','RNO:287920',true).
concept_accession('40614: rn:R05911','KEGG','2.4.99.3',true).
concept_accession('40614: rn:R05911','KEGG','287920',true).
concept_accession('40614: rn:R05911','KEGG','EC:2.4.99.3',true).
concept_accession('40614: rn:R05911','EC','2.4.99.3',true).
concept_accession('9332: rn:R00134','KEGG','RN:R00134',true).
concept_accession('9332: rn:R00134','KEGG','1.2.1.43',true).
concept_accession('9332: rn:R00134','KEGG','EC:1.2.1.43',true).
concept_accession('9332: rn:R00134','EC','1.2.1.43',false).
concept_accession('9332: rn:R00134','KEGG','R00134',true).
concept_accession('40615: rn:R07628','EC','2.4.1.-',true).
concept_accession('40615: rn:R07628','KEGG','2.4.1.-',true).
concept_accession('40615: rn:R07628','KEGG','EC:2.4.1.-',true).
concept_accession('40615: rn:R07628','KEGG','RNO:362275',true).
concept_accession('40615: rn:R07628','KEGG','362275',true).
concept_accession('40612: rn:R05909','KEGG','2.4.1.147',true).
concept_accession('40612: rn:R05909','KEGG','RNO:292325',true).
concept_accession('40612: rn:R05909','KEGG','292325',true).
concept_accession('40612: rn:R05909','EC','2.4.1.147',true).
concept_accession('40612: rn:R05909','KEGG','EC:2.4.1.147',true).
concept_accession('40613: rn:R05907','KEGG','RNO:500826',true).
concept_accession('40613: rn:R05907','KEGG','RNO:288611',true).
concept_accession('40613: rn:R05907','KEGG','RNO:366061',true).
concept_accession('40613: rn:R05907','KEGG','313878',true).
concept_accession('40613: rn:R05907','KEGG','RNO:499968',true).
concept_accession('40613: rn:R05907','KEGG','683264',true).
concept_accession('40613: rn:R05907','KEGG','361142',true).
concept_accession('40613: rn:R05907','KEGG','288611',true).
concept_accession('40613: rn:R05907','KEGG','311039',true).
concept_accession('40613: rn:R05907','KEGG','RNO:29750',true).
concept_accession('40613: rn:R05907','EC','2.4.1.41',true).
concept_accession('40613: rn:R05907','KEGG','RNO:362760',true).
concept_accession('40613: rn:R05907','KEGG','RNO:100366230',true).
concept_accession('40613: rn:R05907','KEGG','RNO:83627',true).
concept_accession('40613: rn:R05907','KEGG','293181',true).
concept_accession('40613: rn:R05907','KEGG','RNO:170501',true).
concept_accession('40613: rn:R05907','KEGG','RNO:313878',true).
concept_accession('40613: rn:R05907','KEGG','500826',true).
concept_accession('40613: rn:R05907','KEGG','362760',true).
concept_accession('40613: rn:R05907','KEGG','RNO:361142',true).
concept_accession('40613: rn:R05907','KEGG','83627',true).
concept_accession('40613: rn:R05907','KEGG','100361647',true).
concept_accession('40613: rn:R05907','KEGG','RNO:100361647',true).
concept_accession('40613: rn:R05907','KEGG','RNO:311039',true).
concept_accession('40613: rn:R05907','KEGG','313233',true).
concept_accession('40613: rn:R05907','KEGG','311952',true).
concept_accession('40613: rn:R05907','KEGG','366061',true).
concept_accession('40613: rn:R05907','KEGG','RNO:292090',true).
concept_accession('40613: rn:R05907','KEGG','EC:2.4.1.41',true).
concept_accession('40613: rn:R05907','KEGG','170501',true).
concept_accession('40613: rn:R05907','KEGG','292090',true).
concept_accession('40613: rn:R05907','KEGG','RNO:79214',true).
concept_accession('40613: rn:R05907','KEGG','100366230',true).
concept_accession('40613: rn:R05907','KEGG','499968',true).
concept_accession('40613: rn:R05907','KEGG','RNO:683264',true).
concept_accession('40613: rn:R05907','KEGG','RNO:313233',true).
concept_accession('40613: rn:R05907','KEGG','29750',true).
concept_accession('40613: rn:R05907','KEGG','2.4.1.41',true).
concept_accession('40613: rn:R05907','KEGG','RNO:311952',true).
concept_accession('40613: rn:R05907','KEGG','79214',true).
concept_accession('40613: rn:R05907','KEGG','RNO:293181',true).
concept_accession('40610: rn:R00647','EC','1.1.3.8',true).
concept_accession('40610: rn:R00647','KEGG','60671',true).
concept_accession('40610: rn:R00647','KEGG','RNO:60671',true).
concept_accession('40610: rn:R00647','KEGG','1.1.3.8',true).
concept_accession('40610: rn:R00647','KEGG','EC:1.1.3.8',true).
concept_accession('1552: rn:R08995','KEGG','RC:RC00607',true).
concept_accession('1552: rn:R08995','KEGG','RN:R08995',true).
concept_accession('1552: rn:R08995','KEGG','RP14203',true).
concept_accession('1552: rn:R08995','KEGG','RP:RP14203',true).
concept_accession('1552: rn:R08995','KEGG','RC00607',true).
concept_accession('1552: rn:R08995','KEGG','R08995',true).
concept_accession('40611: rn:R05983','EC','2.4.1.101',true).
concept_accession('40611: rn:R05983','KEGG','EC:2.4.1.101',true).
concept_accession('40611: rn:R05983','KEGG','2.4.1.101',true).
concept_accession('40611: rn:R05983','KEGG','RNO:81519',true).
concept_accession('40611: rn:R05983','KEGG','81519',true).
concept_accession('9331: rn:R00473','KEGG','RC:RC00307',true).
concept_accession('9331: rn:R00473','KEGG','RC:RC00308',true).
concept_accession('9331: rn:R00473','EC','4.1.3.24',false).
concept_accession('9331: rn:R00473','KEGG','EC:4.1.3.24',true).
concept_accession('9331: rn:R00473','KEGG','RC00307',true).
concept_accession('9331: rn:R00473','KEGG','4.1.3.24',true).
concept_accession('9331: rn:R00473','KEGG','RN:R00473',true).
concept_accession('9331: rn:R00473','KEGG','RP00922',true).
concept_accession('9331: rn:R00473','KEGG','RP00923',true).
concept_accession('9331: rn:R00473','KEGG','RC00308',true).
concept_accession('9331: rn:R00473','KEGG','RP:RP00923',true).
concept_accession('9331: rn:R00473','KEGG','RP:RP00922',true).
concept_accession('9331: rn:R00473','KEGG','R00473',true).
concept_accession('40608: rn:R02933','KEGG','25106',true).
concept_accession('40608: rn:R02933','EC','3.1.1.17',true).
concept_accession('40608: rn:R02933','KEGG','RNO:25106',true).
concept_accession('40608: rn:R02933','KEGG','EC:3.1.1.17',true).
concept_accession('40608: rn:R02933','KEGG','3.1.1.17',true).
concept_accession('40609: rn:R05935','KEGG','RNO:311215',true).
concept_accession('40609: rn:R05935','KEGG','311215',true).
concept_accession('40609: rn:R05935','KEGG','RNO:299907',true).
concept_accession('40609: rn:R05935','EC','2.4.1.224',true).
concept_accession('40609: rn:R05935','KEGG','2.4.1.224',true).
concept_accession('40609: rn:R05935','KEGG','EC:2.4.1.224',true).
concept_accession('40609: rn:R05935','KEGG','299907',true).
concept_accession('40528: rn:R00291','KEGG','RNO:114860',true).
concept_accession('40528: rn:R00291','KEGG','114860',true).
concept_accession('40528: rn:R00291','EC','5.1.3.2',true).
concept_accession('40528: rn:R00291','KEGG','5.1.3.2',true).
concept_accession('40528: rn:R00291','KEGG','EC:5.1.3.2',true).
concept_accession('40529: rn:R02240','KEGG','EC:2.7.1.107',true).
concept_accession('40529: rn:R02240','KEGG','25666',true).
concept_accession('40529: rn:R02240','KEGG','368088',true).
concept_accession('40529: rn:R02240','KEGG','497978',true).
concept_accession('40529: rn:R02240','KEGG','2.7.1.107',true).
concept_accession('40529: rn:R02240','KEGG','RNO:54248',true).
concept_accession('40529: rn:R02240','KEGG','54248',true).
concept_accession('40529: rn:R02240','KEGG','RNO:100361138',true).
concept_accession('40529: rn:R02240','EC','2.7.1.107',true).
concept_accession('40529: rn:R02240','KEGG','RNO:361076',true).
concept_accession('40529: rn:R02240','KEGG','361076',true).
concept_accession('40529: rn:R02240','KEGG','RNO:497978',true).
concept_accession('40529: rn:R02240','KEGG','RNO:688705',true).
concept_accession('40529: rn:R02240','KEGG','RNO:81821',true).
concept_accession('40529: rn:R02240','KEGG','RNO:25666',true).
concept_accession('40529: rn:R02240','KEGG','140866',true).
concept_accession('40529: rn:R02240','KEGG','RNO:140866',true).
concept_accession('40529: rn:R02240','KEGG','RNO:368088',true).
concept_accession('40529: rn:R02240','KEGG','688705',true).
concept_accession('40529: rn:R02240','KEGG','81821',true).
concept_accession('40529: rn:R02240','KEGG','100361138',true).
concept_accession('40530: rn:R00955','KEGG','298003',true).
concept_accession('40530: rn:R00955','KEGG','EC:2.7.7.12',true).
concept_accession('40530: rn:R00955','KEGG','RNO:298003',true).
concept_accession('40530: rn:R00955','KEGG','2.7.7.12',true).
concept_accession('40530: rn:R00955','EC','2.7.7.12',true).
concept_accession('40531: rn:R01092','KEGG','RNO:296117',true).
concept_accession('40531: rn:R01092','KEGG','EC:2.7.1.6',true).
concept_accession('40531: rn:R01092','KEGG','296117',true).
concept_accession('40531: rn:R01092','KEGG','2.7.1.6',true).
concept_accession('40531: rn:R01092','KEGG','287835',true).
concept_accession('40531: rn:R01092','EC','2.7.1.6',true).
concept_accession('40531: rn:R01092','KEGG','RNO:287835',true).
concept_accession('40532: rn:R02051','KEGG','RNO:25096',true).
concept_accession('40532: rn:R02051','KEGG','RNO:25097',true).
concept_accession('40532: rn:R02051','KEGG','25097',true).
concept_accession('40532: rn:R02051','KEGG','25096',true).
concept_accession('40532: rn:R02051','KEGG','3.1.4.4',true).
concept_accession('40532: rn:R02051','EC','3.1.4.4',true).
concept_accession('40532: rn:R02051','KEGG','EC:3.1.4.4',true).
concept_accession('40533: rn:R03236 rn:R03237 rn:R03238 rn:R03239','KEGG','2.7.1.11',true).
concept_accession('40533: rn:R03236 rn:R03237 rn:R03238 rn:R03239','KEGG','RNO:25741',true).
concept_accession('40533: rn:R03236 rn:R03237 rn:R03238 rn:R03239','KEGG','RNO:60416',true).
concept_accession('40533: rn:R03236 rn:R03237 rn:R03238 rn:R03239','KEGG','25741',true).
concept_accession('40533: rn:R03236 rn:R03237 rn:R03238 rn:R03239','EC','2.7.1.11',true).
concept_accession('40533: rn:R03236 rn:R03237 rn:R03238 rn:R03239','KEGG','65152',true).
concept_accession('40533: rn:R03236 rn:R03237 rn:R03238 rn:R03239','KEGG','EC:2.7.1.11',true).
concept_accession('40533: rn:R03236 rn:R03237 rn:R03238 rn:R03239','KEGG','RNO:65152',true).
concept_accession('40533: rn:R03236 rn:R03237 rn:R03238 rn:R03239','KEGG','60416',true).
concept_accession('40534: rn:R07814','KEGG','RNO:688293',true).
concept_accession('40534: rn:R07814','KEGG','688293',true).
concept_accession('40534: rn:R07814','KEGG','3.10.1.1',true).
concept_accession('40534: rn:R07814','KEGG','EC:3.10.1.1',true).
concept_accession('40534: rn:R07814','EC','3.10.1.1',true).
concept_accession('40535: rn:R02746','KEGG','RNO:25514',true).
concept_accession('40535: rn:R02746','KEGG','RNO:192259',true).
concept_accession('40535: rn:R02746','KEGG','RNO:246246',true).
concept_accession('40535: rn:R02746','KEGG','360753',true).
concept_accession('40535: rn:R02746','EC','3.1.1.5',true).
concept_accession('40535: rn:R02746','KEGG','361401',true).
concept_accession('40535: rn:R02746','KEGG','246246',true).
concept_accession('40535: rn:R02746','KEGG','192259',true).
concept_accession('40535: rn:R02746','KEGG','25514',true).
concept_accession('40535: rn:R02746','KEGG','3.1.1.5',true).
concept_accession('40535: rn:R02746','KEGG','RNO:361401',true).
concept_accession('40535: rn:R02746','KEGG','EC:3.1.1.5',true).
concept_accession('40535: rn:R02746','KEGG','RNO:360753',true).
concept_accession('40536: rn:R03634','EC','3.2.1.22',true).
concept_accession('40536: rn:R03634','KEGG','3.2.1.22',true).
concept_accession('40536: rn:R03634','KEGG','EC:3.2.1.22',true).
concept_accession('40536: rn:R03634','KEGG','363494',true).
concept_accession('40536: rn:R03634','KEGG','RNO:363494',true).
concept_accession('40537: rn:R02056','EC','2.1.1.17',true).
concept_accession('40537: rn:R02056','KEGG','EC:2.1.1.17',true).
concept_accession('40537: rn:R02056','KEGG','2.1.1.17',true).
concept_accession('40537: rn:R02056','KEGG','RNO:25511',true).
concept_accession('40537: rn:R02056','KEGG','25511',true).
concept_accession('40538: rn:R05549','EC','3.2.1.22',true).
concept_accession('40538: rn:R05549','KEGG','3.2.1.22',true).
concept_accession('40538: rn:R05549','KEGG','EC:3.2.1.22',true).
concept_accession('40538: rn:R05549','KEGG','363494',true).
concept_accession('40538: rn:R05549','KEGG','RNO:363494',true).
concept_accession('40539: rn:R01801','EC','2.7.8.5',true).
concept_accession('40539: rn:R01801','KEGG','2.7.8.5',true).
concept_accession('40539: rn:R01801','KEGG','RNO:303698',true).
concept_accession('40539: rn:R01801','KEGG','EC:2.7.8.5',true).
concept_accession('40539: rn:R01801','KEGG','303698',true).
concept_accession('40540: rn:R02030 rn:R07390','KEGG','366196',true).
concept_accession('40540: rn:R02030 rn:R07390','KEGG','2.7.8.-',true).
concept_accession('40540: rn:R02030 rn:R07390','EC','2.7.8.-',true).
concept_accession('40540: rn:R02030 rn:R07390','KEGG','RNO:366196',true).
concept_accession('40540: rn:R02030 rn:R07390','KEGG','EC:2.7.8.-',true).
concept_accession('40541: rn:R01103','EC','3.2.1.22',true).
concept_accession('40541: rn:R01103','KEGG','3.2.1.22',true).
concept_accession('40541: rn:R01103','KEGG','EC:3.2.1.22',true).
concept_accession('40541: rn:R01103','KEGG','363494',true).
concept_accession('40541: rn:R01103','KEGG','RNO:363494',true).
concept_accession('40542: rn:R00801','KEGG','EC:3.2.1.20',true).
concept_accession('40542: rn:R00801','EC','3.2.1.20',true).
concept_accession('40542: rn:R00801','KEGG','312272',true).
concept_accession('40542: rn:R00801','KEGG','3.2.1.20',true).
concept_accession('40542: rn:R00801','KEGG','367562',true).
concept_accession('40542: rn:R00801','KEGG','RNO:24382',true).
concept_accession('40542: rn:R00801','KEGG','24382',true).
concept_accession('40542: rn:R00801','KEGG','RNO:312272',true).
concept_accession('40542: rn:R00801','KEGG','RNO:367562',true).
concept_accession('40543: rn:R01104','EC','3.2.1.22',true).
concept_accession('40543: rn:R01104','KEGG','3.2.1.22',true).
concept_accession('40543: rn:R01104','KEGG','EC:3.2.1.22',true).
concept_accession('40543: rn:R01104','KEGG','363494',true).
concept_accession('40543: rn:R01104','KEGG','RNO:363494',true).
concept_accession('40513: rn:R01023','KEGG','2.3.1.6',true).
concept_accession('40513: rn:R01023','KEGG','RNO:290567',true).
concept_accession('40513: rn:R01023','KEGG','EC:2.3.1.6',true).
concept_accession('40513: rn:R01023','EC','2.3.1.6',true).
concept_accession('40513: rn:R01023','KEGG','290567',true).
concept_accession('40512: rn:R01194','EC','3.2.1.22',true).
concept_accession('40512: rn:R01194','KEGG','3.2.1.22',true).
concept_accession('40512: rn:R01194','KEGG','EC:3.2.1.22',true).
concept_accession('40512: rn:R01194','KEGG','363494',true).
concept_accession('40512: rn:R01194','KEGG','RNO:363494',true).
concept_accession('40515: rn:R01026','KEGG','RNO:83817',true).
concept_accession('40515: rn:R01026','EC','3.1.1.7',true).
concept_accession('40515: rn:R01026','KEGG','83817',true).
concept_accession('40515: rn:R01026','KEGG','3.1.1.7',true).
concept_accession('40515: rn:R01026','KEGG','EC:3.1.1.7',true).
concept_accession('40514: rn:R02926','EC','3.2.1.22',true).
concept_accession('40514: rn:R02926','KEGG','3.2.1.22',true).
concept_accession('40514: rn:R02926','KEGG','EC:3.2.1.22',true).
concept_accession('40514: rn:R02926','KEGG','363494',true).
concept_accession('40514: rn:R02926','KEGG','RNO:363494',true).
concept_accession('40517: rn:R01021','KEGG','RNO:29194',true).
concept_accession('40517: rn:R01021','KEGG','29194',true).
concept_accession('40517: rn:R01021','KEGG','EC:2.7.1.32',true).
concept_accession('40517: rn:R01021','KEGG','RNO:29367',true).
concept_accession('40517: rn:R01021','KEGG','29367',true).
concept_accession('40517: rn:R01021','KEGG','2.7.1.32',true).
concept_accession('40517: rn:R01021','EC','2.7.1.32',true).
concept_accession('40516: rn:R01786','KEGG','RNO:100364027',true).
concept_accession('40516: rn:R01786','KEGG','25058',true).
concept_accession('40516: rn:R01786','KEGG','25059',true).
concept_accession('40516: rn:R01786','KEGG','RNO:25058',true).
concept_accession('40516: rn:R01786','KEGG','25060',true).
concept_accession('40516: rn:R01786','KEGG','RNO:25059',true).
concept_accession('40516: rn:R01786','EC','2.7.1.1',true).
concept_accession('40516: rn:R01786','KEGG','100364027',true).
concept_accession('40516: rn:R01786','KEGG','RNO:25060',true).
concept_accession('40516: rn:R01786','KEGG','EC:2.7.1.1',true).
concept_accession('40516: rn:R01786','KEGG','2.7.1.1',true).
concept_accession('40519: rn:R01315','KEGG','298579',true).
concept_accession('40519: rn:R01315','KEGG','RNO:192259',true).
concept_accession('40519: rn:R01315','KEGG','296091',true).
concept_accession('40519: rn:R01315','KEGG','RNO:311341',true).
concept_accession('40519: rn:R01315','KEGG','RNO:29359',true).
concept_accession('40519: rn:R01315','KEGG','RNO:289733',true).
concept_accession('40519: rn:R01315','KEGG','29526',true).
concept_accession('40519: rn:R01315','KEGG','29387',true).
concept_accession('40519: rn:R01315','KEGG','362039',true).
concept_accession('40519: rn:R01315','KEGG','EC:3.1.1.4',true).
concept_accession('40519: rn:R01315','KEGG','RNO:29387',true).
concept_accession('40519: rn:R01315','KEGG','691907',true).
concept_accession('40519: rn:R01315','KEGG','RNO:298579',true).
concept_accession('40519: rn:R01315','KEGG','311341',true).
concept_accession('40519: rn:R01315','KEGG','RNO:690388',true).
concept_accession('40519: rn:R01315','KEGG','289733',true).
concept_accession('40519: rn:R01315','KEGG','RNO:362039',true).
concept_accession('40519: rn:R01315','KEGG','RNO:29692',true).
concept_accession('40519: rn:R01315','KEGG','24653',true).
concept_accession('40519: rn:R01315','KEGG','RNO:29526',true).
concept_accession('40519: rn:R01315','EC','3.1.1.4',true).
concept_accession('40519: rn:R01315','KEGG','RNO:24653',true).
concept_accession('40519: rn:R01315','KEGG','192259',true).
concept_accession('40519: rn:R01315','KEGG','3.1.1.4',true).
concept_accession('40519: rn:R01315','KEGG','690388',true).
concept_accession('40519: rn:R01315','KEGG','RNO:691907',true).
concept_accession('40519: rn:R01315','KEGG','RNO:296091',true).
concept_accession('40519: rn:R01315','KEGG','29359',true).
concept_accession('40519: rn:R01315','KEGG','367415',true).
concept_accession('40519: rn:R01315','KEGG','29354',true).
concept_accession('40519: rn:R01315','KEGG','RNO:367415',true).
concept_accession('40519: rn:R01315','KEGG','RNO:360426',true).
concept_accession('40519: rn:R01315','KEGG','29692',true).
concept_accession('40519: rn:R01315','KEGG','360426',true).
concept_accession('40519: rn:R01315','KEGG','RNO:29354',true).
concept_accession('40518: rn:R01786','KEGG','RNO:24385',true).
concept_accession('40518: rn:R01786','EC','2.7.1.1',true).
concept_accession('40518: rn:R01786','KEGG','24385',true).
concept_accession('40518: rn:R01786','KEGG','EC:2.7.1.1',true).
concept_accession('40518: rn:R01786','KEGG','2.7.1.1',true).
concept_accession('40521: rn:R01678','KEGG','3.2.1.108',true).
concept_accession('40521: rn:R01678','KEGG','RNO:116569',true).
concept_accession('40521: rn:R01678','KEGG','116569',true).
concept_accession('40521: rn:R01678','KEGG','EC:3.2.1.108',true).
concept_accession('40521: rn:R01678','EC','3.2.1.108',true).
concept_accession('6090: rn:R08639','KEGG','EC:5.4.2.2',true).
concept_accession('6090: rn:R08639','KEGG','RC00408',true).
concept_accession('6090: rn:R08639','KEGG','RP10946',true).
concept_accession('6090: rn:R08639','KEGG','RN:R08639',true).
concept_accession('6090: rn:R08639','KEGG','R08639',true).
concept_accession('6090: rn:R08639','KEGG','RC:RC00408',true).
concept_accession('6090: rn:R08639','KEGG','5.4.2.2',true).
concept_accession('6090: rn:R08639','EC','5.4.2.2',false).
concept_accession('6090: rn:R08639','KEGG','RP:RP10946',true).
concept_accession('40520: rn:R01678','KEGG','3.2.1.108',true).
concept_accession('40520: rn:R01678','KEGG','RNO:316033',true).
concept_accession('40520: rn:R01678','KEGG','EC:3.2.1.108',true).
concept_accession('40520: rn:R01678','KEGG','316033',true).
concept_accession('40520: rn:R01678','EC','3.2.1.108',true).
concept_accession('40523: rn:R01468','KEGG','RNO:29194',true).
concept_accession('40523: rn:R01468','KEGG','29194',true).
concept_accession('40523: rn:R01468','KEGG','360843',true).
concept_accession('40523: rn:R01468','KEGG','312828',true).
concept_accession('40523: rn:R01468','KEGG','RNO:360843',true).
concept_accession('40523: rn:R01468','KEGG','RNO:29367',true).
concept_accession('40523: rn:R01468','KEGG','29367',true).
concept_accession('40523: rn:R01468','KEGG','RNO:312828',true).
concept_accession('40523: rn:R01468','KEGG','EC:2.7.1.82',true).
concept_accession('40523: rn:R01468','EC','2.7.1.82',true).
concept_accession('40523: rn:R01468','KEGG','2.7.1.82',true).
concept_accession('40522: rn:R00503','KEGG','RNO:313536',true).
concept_accession('40522: rn:R00503','KEGG','2.4.1.22',true).
concept_accession('40522: rn:R00503','KEGG','EC:2.4.1.22',true).
concept_accession('40522: rn:R00503','KEGG','24390',true).
concept_accession('40522: rn:R00503','KEGG','313536',true).
concept_accession('40522: rn:R00503','KEGG','RNO:24390',true).
concept_accession('40522: rn:R00503','KEGG','RNO:24528',true).
concept_accession('40522: rn:R00503','KEGG','24528',true).
concept_accession('40522: rn:R00503','EC','2.4.1.22',true).
concept_accession('40525: rn:R01310','KEGG','RNO:25096',true).
concept_accession('40525: rn:R01310','KEGG','RNO:25097',true).
concept_accession('40525: rn:R01310','KEGG','25097',true).
concept_accession('40525: rn:R01310','KEGG','25096',true).
concept_accession('40525: rn:R01310','KEGG','3.1.4.4',true).
concept_accession('40525: rn:R01310','EC','3.1.4.4',true).
concept_accession('40525: rn:R01310','KEGG','EC:3.1.4.4',true).
concept_accession('40524: rn:R00959','KEGG','RNO:24645',true).
concept_accession('40524: rn:R00959','KEGG','EC:5.4.2.2',true).
concept_accession('40524: rn:R00959','KEGG','24645',true).
concept_accession('40524: rn:R00959','KEGG','5.4.2.2',true).
concept_accession('40524: rn:R00959','EC','5.4.2.2',true).
concept_accession('40527: rn:R02239','EC','3.1.3.4',true).
concept_accession('40527: rn:R02239','KEGG','RNO:246115',true).
concept_accession('40527: rn:R02239','KEGG','192270',true).
concept_accession('40527: rn:R02239','KEGG','3.1.3.4',true).
concept_accession('40527: rn:R02239','KEGG','RNO:64369',true).
concept_accession('40527: rn:R02239','KEGG','246115',true).
concept_accession('40527: rn:R02239','KEGG','64369',true).
concept_accession('40527: rn:R02239','KEGG','RNO:192270',true).
concept_accession('40527: rn:R02239','KEGG','EC:3.1.3.4',true).
concept_accession('40526: rn:R00289','KEGG','289827',true).
concept_accession('40526: rn:R00289','KEGG','EC:2.7.7.9',true).
concept_accession('40526: rn:R00289','KEGG','2.7.7.9',true).
concept_accession('40526: rn:R00289','KEGG','RNO:289827',true).
concept_accession('40526: rn:R00289','EC','2.7.7.9',true).
concept_accession('40562: rn:R00286','KEGG','RNO:83472',true).
concept_accession('40562: rn:R00286','KEGG','83472',true).
concept_accession('40562: rn:R00286','EC','1.1.1.22',true).
concept_accession('40562: rn:R00286','KEGG','1.1.1.22',true).
concept_accession('40562: rn:R00286','KEGG','EC:1.1.1.22',true).
concept_accession('40563: rn:R07824','KEGG','RNO:300993',true).
concept_accession('40563: rn:R07824','KEGG','RNO:500052',true).
concept_accession('40563: rn:R07824','KEGG','RNO:500051',true).
concept_accession('40563: rn:R07824','KEGG','3.2.1.35',true).
concept_accession('40563: rn:R07824','KEGG','500052',true).
concept_accession('40563: rn:R07824','KEGG','RNO:367166',true).
concept_accession('40563: rn:R07824','KEGG','500051',true).
concept_accession('40563: rn:R07824','KEGG','RNO:404783',true).
concept_accession('40563: rn:R07824','EC','3.2.1.35',true).
concept_accession('40563: rn:R07824','KEGG','404783',true).
concept_accession('40563: rn:R07824','KEGG','367166',true).
concept_accession('40563: rn:R07824','KEGG','EC:3.2.1.35',true).
concept_accession('40563: rn:R07824','KEGG','117037',true).
concept_accession('40563: rn:R07824','KEGG','64468',true).
concept_accession('40563: rn:R07824','KEGG','RNO:117037',true).
concept_accession('40563: rn:R07824','KEGG','RNO:64468',true).
concept_accession('40563: rn:R07824','KEGG','300993',true).
concept_accession('40560: rn:R01184','KEGG','1.13.99.1',true).
concept_accession('40560: rn:R01184','EC','1.13.99.1',true).
concept_accession('40560: rn:R01184','KEGG','RNO:252899',true).
concept_accession('40560: rn:R01184','KEGG','252899',true).
concept_accession('40560: rn:R01184','KEGG','EC:1.13.99.1',true).
concept_accession('40561: rn:R07807','KEGG','3.2.1.23',true).
concept_accession('40561: rn:R07807','EC','3.2.1.23',true).
concept_accession('40561: rn:R07807','KEGG','EC:3.2.1.23',true).
concept_accession('40561: rn:R07807','KEGG','RNO:316033',true).
concept_accession('40561: rn:R07807','KEGG','316033',true).
concept_accession('40566: rn:R07822','KEGG','EC:3.2.1.76',true).
concept_accession('40566: rn:R07822','EC','3.2.1.76',true).
concept_accession('40566: rn:R07822','KEGG','100361089',true).
concept_accession('40566: rn:R07822','KEGG','3.2.1.76',true).
concept_accession('40566: rn:R07822','KEGG','RNO:100361089',true).
concept_accession('40567: rn:R07813','KEGG','EC:3.2.1.76',true).
concept_accession('40567: rn:R07813','EC','3.2.1.76',true).
concept_accession('40567: rn:R07813','KEGG','100361089',true).
concept_accession('40567: rn:R07813','KEGG','3.2.1.76',true).
concept_accession('40567: rn:R07813','KEGG','RNO:100361089',true).
concept_accession('40564: rn:R07812','KEGG','RNO:363513',true).
concept_accession('40564: rn:R07812','EC','3.1.6.13',true).
concept_accession('40564: rn:R07812','KEGG','EC:3.1.6.13',true).
concept_accession('40564: rn:R07812','KEGG','3.1.6.13',true).
concept_accession('40564: rn:R07812','KEGG','363513',true).
concept_accession('40565: rn:R07806','EC','3.1.6.4',true).
concept_accession('40565: rn:R07806','KEGG','3.1.6.4',true).
concept_accession('40565: rn:R07806','KEGG','EC:3.1.6.4',true).
concept_accession('40565: rn:R07806','KEGG','RNO:292073',true).
concept_accession('40565: rn:R07806','KEGG','292073',true).
concept_accession('40570: rn:R07810','KEGG','RNO:294673',true).
concept_accession('40570: rn:R07810','KEGG','294673',true).
concept_accession('40570: rn:R07810','KEGG','RNO:300757',true).
concept_accession('40570: rn:R07810','KEGG','EC:3.2.1.52',true).
concept_accession('40570: rn:R07810','EC','3.2.1.52',true).
concept_accession('40570: rn:R07810','KEGG','300757',true).
concept_accession('40570: rn:R07810','KEGG','3.2.1.52',true).
concept_accession('9384: rn:R01440','KEGG','RP00080',true).
concept_accession('9384: rn:R01440','KEGG','RN:R01440',true).
concept_accession('9384: rn:R01440','EC','2.2.1.3',false).
concept_accession('9384: rn:R01440','KEGG','RC:RC00032',true).
concept_accession('9384: rn:R01440','KEGG','EC:2.2.1.3',true).
concept_accession('9384: rn:R01440','KEGG','RP:RP00080',true).
concept_accession('9384: rn:R01440','KEGG','RC00032',true).
concept_accession('9384: rn:R01440','KEGG','2.2.1.3',true).
concept_accession('9384: rn:R01440','KEGG','R01440',true).
concept_accession('40571: rn:R07825','KEGG','RNO:300993',true).
concept_accession('40571: rn:R07825','KEGG','RNO:500052',true).
concept_accession('40571: rn:R07825','KEGG','RNO:500051',true).
concept_accession('40571: rn:R07825','KEGG','3.2.1.35',true).
concept_accession('40571: rn:R07825','KEGG','500052',true).
concept_accession('40571: rn:R07825','KEGG','RNO:367166',true).
concept_accession('40571: rn:R07825','KEGG','500051',true).
concept_accession('40571: rn:R07825','KEGG','RNO:404783',true).
concept_accession('40571: rn:R07825','EC','3.2.1.35',true).
concept_accession('40571: rn:R07825','KEGG','404783',true).
concept_accession('40571: rn:R07825','KEGG','367166',true).
concept_accession('40571: rn:R07825','KEGG','EC:3.2.1.35',true).
concept_accession('40571: rn:R07825','KEGG','117037',true).
concept_accession('40571: rn:R07825','KEGG','64468',true).
concept_accession('40571: rn:R07825','KEGG','RNO:117037',true).
concept_accession('40571: rn:R07825','KEGG','RNO:64468',true).
concept_accession('40571: rn:R07825','KEGG','300993',true).
concept_accession('40568: rn:R07818','EC','3.2.1.31',true).
concept_accession('40568: rn:R07818','KEGG','24434',true).
concept_accession('40568: rn:R07818','KEGG','EC:3.2.1.31',true).
concept_accession('40568: rn:R07818','KEGG','3.2.1.31',true).
concept_accession('40568: rn:R07818','KEGG','RNO:24434',true).
concept_accession('40569: rn:R07819','KEGG','EC:3.1.6.14',true).
concept_accession('40569: rn:R07819','EC','3.1.6.14',true).
concept_accession('40569: rn:R07819','KEGG','299825',true).
concept_accession('40569: rn:R07819','KEGG','RNO:299825',true).
concept_accession('40569: rn:R07819','KEGG','3.1.6.14',true).
concept_accession('40574: rn:R07824','KEGG','RNO:300993',true).
concept_accession('40574: rn:R07824','KEGG','RNO:500052',true).
concept_accession('40574: rn:R07824','KEGG','RNO:500051',true).
concept_accession('40574: rn:R07824','KEGG','3.2.1.35',true).
concept_accession('40574: rn:R07824','KEGG','500052',true).
concept_accession('40574: rn:R07824','KEGG','RNO:367166',true).
concept_accession('40574: rn:R07824','KEGG','500051',true).
concept_accession('40574: rn:R07824','KEGG','RNO:404783',true).
concept_accession('40574: rn:R07824','EC','3.2.1.35',true).
concept_accession('40574: rn:R07824','KEGG','404783',true).
concept_accession('40574: rn:R07824','KEGG','367166',true).
concept_accession('40574: rn:R07824','KEGG','EC:3.2.1.35',true).
concept_accession('40574: rn:R07824','KEGG','117037',true).
concept_accession('40574: rn:R07824','KEGG','64468',true).
concept_accession('40574: rn:R07824','KEGG','RNO:117037',true).
concept_accession('40574: rn:R07824','KEGG','RNO:64468',true).
concept_accession('40574: rn:R07824','KEGG','300993',true).
concept_accession('40575: rn:R07821','KEGG','RNO:363513',true).
concept_accession('40575: rn:R07821','EC','3.1.6.13',true).
concept_accession('40575: rn:R07821','KEGG','EC:3.1.6.13',true).
concept_accession('40575: rn:R07821','KEGG','3.1.6.13',true).
concept_accession('40575: rn:R07821','KEGG','363513',true).
concept_accession('40572: rn:R07816','EC','3.2.1.50',true).
concept_accession('40572: rn:R07816','KEGG','RNO:360630',true).
concept_accession('40572: rn:R07816','KEGG','EC:3.2.1.50',true).
concept_accession('40572: rn:R07816','KEGG','360630',true).
concept_accession('40572: rn:R07816','KEGG','3.2.1.50',true).
concept_accession('40573: rn:R07809','KEGG','RNO:294673',true).
concept_accession('40573: rn:R07809','KEGG','294673',true).
concept_accession('40573: rn:R07809','KEGG','RNO:300757',true).
concept_accession('40573: rn:R07809','KEGG','EC:3.2.1.52',true).
concept_accession('40573: rn:R07809','EC','3.2.1.52',true).
concept_accession('40573: rn:R07809','KEGG','300757',true).
concept_accession('40573: rn:R07809','KEGG','3.2.1.52',true).
concept_accession('40547: rn:R02057','KEGG','RNO:362713',true).
concept_accession('40547: rn:R02057','KEGG','RNO:310773',true).
concept_accession('40547: rn:R02057','KEGG','2.7.8.1',true).
concept_accession('40547: rn:R02057','KEGG','362713',true).
concept_accession('40547: rn:R02057','EC','2.7.8.1',true).
concept_accession('40547: rn:R02057','KEGG','EC:2.7.8.1',true).
concept_accession('40547: rn:R02057','KEGG','310773',true).
concept_accession('40546: rn:R03416','KEGG','EC:3.1.1.5',true).
concept_accession('40546: rn:R03416','KEGG','RNO:25514',true).
concept_accession('40546: rn:R03416','KEGG','RNO:192259',true).
concept_accession('40546: rn:R03416','KEGG','RNO:246246',true).
concept_accession('40546: rn:R03416','KEGG','360753',true).
concept_accession('40546: rn:R03416','EC','3.1.1.5',true).
concept_accession('40546: rn:R03416','KEGG','246246',true).
concept_accession('40546: rn:R03416','KEGG','192259',true).
concept_accession('40546: rn:R03416','KEGG','25514',true).
concept_accession('40546: rn:R03416','KEGG','3.1.1.5',true).
concept_accession('40546: rn:R03416','KEGG','RNO:360753',true).
concept_accession('40545: rn:R01093 rn:R01095','KEGG','24192',true).
concept_accession('40545: rn:R01093 rn:R01095','KEGG','RNO:24192',true).
concept_accession('40545: rn:R01093 rn:R01095','KEGG','1.1.1.21',true).
concept_accession('40545: rn:R01093 rn:R01095','EC','1.1.1.21',true).
concept_accession('40545: rn:R01093 rn:R01095','KEGG','EC:1.1.1.21',true).
concept_accession('40544: rn:R01329','EC','3.2.1.22',true).
concept_accession('40544: rn:R01329','KEGG','3.2.1.22',true).
concept_accession('40544: rn:R01329','KEGG','EC:3.2.1.22',true).
concept_accession('40544: rn:R01329','KEGG','363494',true).
concept_accession('40544: rn:R01329','KEGG','RNO:363494',true).
concept_accession('40551: rn:R01799','KEGG','EC:2.7.7.41',true).
concept_accession('40551: rn:R01799','KEGG','RNO:81925',true).
concept_accession('40551: rn:R01799','KEGG','114101',true).
concept_accession('40551: rn:R01799','EC','2.7.7.41',true).
concept_accession('40551: rn:R01799','KEGG','81925',true).
concept_accession('40551: rn:R01799','KEGG','RNO:114101',true).
concept_accession('40551: rn:R01799','KEGG','2.7.7.41',true).
concept_accession('40550: rn:R04480','KEGG','RNO:296048',true).
concept_accession('40550: rn:R04480','KEGG','EC:2.3.1.23',true).
concept_accession('40550: rn:R04480','KEGG','296048',true).
concept_accession('40550: rn:R04480','KEGG','362434',true).
concept_accession('40550: rn:R04480','KEGG','2.3.1.23',true).
concept_accession('40550: rn:R04480','KEGG','313997',true).
concept_accession('40550: rn:R04480','KEGG','RNO:362434',true).
concept_accession('40550: rn:R04480','EC','2.3.1.23',true).
concept_accession('40550: rn:R04480','KEGG','RNO:313997',true).
concept_accession('40550: rn:R04480','KEGG','498741',true).
concept_accession('40550: rn:R04480','KEGG','RNO:498741',true).
concept_accession('40549: rn:R07811','KEGG','3.2.1.-',true).
concept_accession('40549: rn:R07811','EC','3.2.1.-',true).
concept_accession('40549: rn:R07811','KEGG','RNO:368128',true).
concept_accession('40549: rn:R07811','KEGG','EC:3.2.1.-',true).
concept_accession('40549: rn:R07811','KEGG','368128',true).
concept_accession('40548: rn:R03417','KEGG','EC:3.1.1.5',true).
concept_accession('40548: rn:R03417','KEGG','83510',true).
concept_accession('40548: rn:R03417','KEGG','RNO:192259',true).
concept_accession('40548: rn:R03417','KEGG','RNO:246246',true).
concept_accession('40548: rn:R03417','KEGG','360753',true).
concept_accession('40548: rn:R03417','EC','3.1.1.5',true).
concept_accession('40548: rn:R03417','KEGG','246246',true).
concept_accession('40548: rn:R03417','KEGG','192259',true).
concept_accession('40548: rn:R03417','KEGG','3.1.1.5',true).
concept_accession('40548: rn:R03417','KEGG','RNO:360753',true).
concept_accession('40548: rn:R03417','KEGG','RNO:83510',true).
concept_accession('40555: rn:R07821','KEGG','RNO:363513',true).
concept_accession('40555: rn:R07821','EC','3.1.6.13',true).
concept_accession('40555: rn:R07821','KEGG','EC:3.1.6.13',true).
concept_accession('40555: rn:R07821','KEGG','3.1.6.13',true).
concept_accession('40555: rn:R07821','KEGG','363513',true).
concept_accession('40554: rn:R02055','KEGG','EC:4.1.1.65',true).
concept_accession('40554: rn:R02055','KEGG','RNO:681361',true).
concept_accession('40554: rn:R02055','KEGG','681361',true).
concept_accession('40554: rn:R02055','KEGG','4.1.1.65',true).
concept_accession('40554: rn:R02055','EC','4.1.1.65',true).
concept_accession('40553: rn:R07811','KEGG','RNO:64537',true).
concept_accession('40553: rn:R07811','KEGG','3.2.1.-',true).
concept_accession('40553: rn:R07811','EC','3.2.1.-',true).
concept_accession('40553: rn:R07811','KEGG','64537',true).
concept_accession('40553: rn:R07811','KEGG','EC:3.2.1.-',true).
concept_accession('40552: rn:R02747','KEGG','EC:3.1.1.5',true).
concept_accession('40552: rn:R02747','KEGG','83510',true).
concept_accession('40552: rn:R02747','KEGG','RNO:192259',true).
concept_accession('40552: rn:R02747','KEGG','RNO:246246',true).
concept_accession('40552: rn:R02747','KEGG','360753',true).
concept_accession('40552: rn:R02747','EC','3.1.1.5',true).
concept_accession('40552: rn:R02747','KEGG','246246',true).
concept_accession('40552: rn:R02747','KEGG','192259',true).
concept_accession('40552: rn:R02747','KEGG','3.1.1.5',true).
concept_accession('40552: rn:R02747','KEGG','RNO:360753',true).
concept_accession('40552: rn:R02747','KEGG','RNO:83510',true).
concept_accession('40559: rn:R07823','KEGG','EC:3.1.6.12',true).
concept_accession('40559: rn:R07823','EC','3.1.6.12',true).
concept_accession('40559: rn:R07823','KEGG','25227',true).
concept_accession('40559: rn:R07823','KEGG','RNO:25227',true).
concept_accession('40559: rn:R07823','KEGG','3.1.6.12',true).
concept_accession('40558: rn:R07808','KEGG','EC:3.1.6.14',true).
concept_accession('40558: rn:R07808','EC','3.1.6.14',true).
concept_accession('40558: rn:R07808','KEGG','299825',true).
concept_accession('40558: rn:R07808','KEGG','RNO:299825',true).
concept_accession('40558: rn:R07808','KEGG','3.1.6.14',true).
concept_accession('40557: rn:R06871','KEGG','RNO:287644',true).
concept_accession('40557: rn:R06871','KEGG','287644',true).
concept_accession('40557: rn:R06871','KEGG','EC:3.1.3.75',true).
concept_accession('40557: rn:R06871','EC','3.1.3.75',true).
concept_accession('40557: rn:R06871','KEGG','3.1.3.75',true).
concept_accession('40556: rn:R00855','KEGG','3.6.1.16',true).
concept_accession('40556: rn:R00855','KEGG','EC:3.6.1.16',true).
concept_accession('40556: rn:R00855','EC','3.6.1.16',true).
concept_accession('40556: rn:R00855','KEGG','287406',true).
concept_accession('40556: rn:R00855','KEGG','RNO:287406',true).
concept_accession('40468: rn:R05916','KEGG','EC:2.4.1.198',true).
concept_accession('40468: rn:R05916','EC','2.4.1.198',true).
concept_accession('40468: rn:R05916','KEGG','2.4.1.198',true).
concept_accession('40468: rn:R05916','KEGG','288238',true).
concept_accession('40468: rn:R05916','KEGG','RNO:288238',true).
concept_accession('40469: rn:R05916','KEGG','EC:2.4.1.198',true).
concept_accession('40469: rn:R05916','KEGG','RNO:287159',true).
concept_accession('40469: rn:R05916','KEGG','287159',true).
concept_accession('40469: rn:R05916','EC','2.4.1.198',true).
concept_accession('40469: rn:R05916','KEGG','2.4.1.198',true).
concept_accession('40470: rn:R00264','KEGG','1.2.1.3',true).
concept_accession('40470: rn:R00264','KEGG','65183',true).
concept_accession('40470: rn:R00264','EC','1.2.1.3',true).
concept_accession('40470: rn:R00264','KEGG','24188',true).
concept_accession('40470: rn:R00264','KEGG','RNO:29539',true).
concept_accession('40470: rn:R00264','KEGG','RNO:24188',true).
concept_accession('40470: rn:R00264','KEGG','29539',true).
concept_accession('40470: rn:R00264','KEGG','29651',true).
concept_accession('40470: rn:R00264','KEGG','298079',true).
concept_accession('40470: rn:R00264','KEGG','RNO:298079',true).
concept_accession('40470: rn:R00264','KEGG','RNO:29651',true).
concept_accession('40470: rn:R00264','KEGG','RNO:65183',true).
concept_accession('40470: rn:R00264','KEGG','EC:1.2.1.3',true).
concept_accession('1700: rn:R01841','KEGG','RC:RC00607',true).
concept_accession('1700: rn:R01841','EC','4.1.2.30',false).
concept_accession('1700: rn:R01841','KEGG','RP01796',true).
concept_accession('1700: rn:R01841','KEGG','4.1.2.30',true).
concept_accession('1700: rn:R01841','KEGG','RP:RP01796',true).
concept_accession('1700: rn:R01841','KEGG','RC00607',true).
concept_accession('1700: rn:R01841','KEGG','R01841',true).
concept_accession('1700: rn:R01841','KEGG','RN:R01841',true).
concept_accession('1700: rn:R01841','KEGG','EC:4.1.2.30',true).
concept_accession('40471: rn:R00705','KEGG','RNO:81708',true).
concept_accession('40471: rn:R00705','EC','1.2.1.27',true).
concept_accession('40471: rn:R00705','KEGG','EC:1.2.1.27',true).
concept_accession('40471: rn:R00705','KEGG','1.2.1.27',true).
concept_accession('40471: rn:R00705','KEGG','81708',true).
concept_accession('40464: rn:R01430','EC','1.1.1.179',true).
concept_accession('40464: rn:R01430','KEGG','EC:1.1.1.179',true).
concept_accession('40464: rn:R01430','KEGG','1.1.1.179',true).
concept_accession('40464: rn:R01430','KEGG','RNO:691002',true).
concept_accession('40464: rn:R01430','KEGG','691002',true).
concept_accession('40465: rn:R05795','KEGG','289021',true).
concept_accession('40465: rn:R05795','KEGG','EC:2.7.1.154',true).
concept_accession('40465: rn:R05795','KEGG','2.7.1.154',true).
concept_accession('40465: rn:R05795','KEGG','RNO:361632',true).
concept_accession('40465: rn:R05795','KEGG','361632',true).
concept_accession('40465: rn:R05795','EC','2.7.1.154',true).
concept_accession('40465: rn:R05795','KEGG','RNO:116720',true).
concept_accession('40465: rn:R05795','KEGG','116720',true).
concept_accession('40465: rn:R05795','KEGG','RNO:289021',true).
concept_accession('40466: rn:R05916','KEGG','29640',true).
concept_accession('40466: rn:R05916','KEGG','EC:2.4.1.198',true).
concept_accession('40466: rn:R05916','EC','2.4.1.198',true).
concept_accession('40466: rn:R05916','KEGG','2.4.1.198',true).
concept_accession('40466: rn:R05916','KEGG','RNO:29640',true).
concept_accession('40467: rn:R05916','KEGG','EC:2.4.1.198',true).
concept_accession('40467: rn:R05916','KEGG','100365921',true).
concept_accession('40467: rn:R05916','EC','2.4.1.198',true).
concept_accession('40467: rn:R05916','KEGG','2.4.1.198',true).
concept_accession('40467: rn:R05916','KEGG','RNO:100365921',true).
concept_accession('40476: rn:R05918','KEGG','378774',true).
concept_accession('40476: rn:R05918','EC','2.3.-.-',true).
concept_accession('40476: rn:R05918','KEGG','2.3.-.-',true).
concept_accession('40476: rn:R05918','KEGG','EC:2.3.-.-',true).
concept_accession('40476: rn:R05918','KEGG','RNO:378774',true).
concept_accession('1710: rn:R04309 rn:R04310','KEGG','EC:1.1.1.50',true).
concept_accession('1710: rn:R04309 rn:R04310','KEGG','R04310',true).
concept_accession('1710: rn:R04309 rn:R04310','KEGG','RC:RC00144',true).
concept_accession('1710: rn:R04309 rn:R04310','KEGG','RN:R04310',true).
concept_accession('1710: rn:R04309 rn:R04310','KEGG','RP00748',true).
concept_accession('1710: rn:R04309 rn:R04310','EC','1.1.1.50',false).
concept_accession('1710: rn:R04309 rn:R04310','KEGG','RC00144',true).
concept_accession('1710: rn:R04309 rn:R04310','KEGG','RP:RP00748',true).
concept_accession('1710: rn:R04309 rn:R04310','KEGG','R04309',true).
concept_accession('1710: rn:R04309 rn:R04310','KEGG','RN:R04309',true).
concept_accession('1710: rn:R04309 rn:R04310','KEGG','1.1.1.50',true).
concept_accession('40477: rn:R08107','KEGG','RNO:313341',true).
concept_accession('40477: rn:R08107','KEGG','EC:2.7.-.-',true).
concept_accession('40477: rn:R08107','EC','2.7.-.-',true).
concept_accession('40477: rn:R08107','KEGG','2.7.-.-',true).
concept_accession('40477: rn:R08107','KEGG','313341',true).
concept_accession('40478: rn:R06623','KEGG','3.1.4.50',true).
concept_accession('40478: rn:R06623','KEGG','RNO:291132',true).
concept_accession('40478: rn:R06623','KEGG','291132',true).
concept_accession('40478: rn:R06623','EC','3.1.4.50',true).
concept_accession('40478: rn:R06623','KEGG','EC:3.1.4.50',true).
concept_accession('40479: rn:R05916','KEGG','EC:2.4.1.198',true).
concept_accession('40479: rn:R05916','KEGG','RNO:363464',true).
concept_accession('40479: rn:R05916','KEGG','363464',true).
concept_accession('40479: rn:R05916','EC','2.4.1.198',true).
concept_accession('40479: rn:R05916','KEGG','2.4.1.198',true).
concept_accession('40472: rn:R01015','KEGG','RNO:246267',true).
concept_accession('40472: rn:R01015','KEGG','RNO:500959',true).
concept_accession('40472: rn:R01015','KEGG','500959',true).
concept_accession('40472: rn:R01015','KEGG','EC:5.3.1.1',true).
concept_accession('40472: rn:R01015','KEGG','498731',true).
concept_accession('40472: rn:R01015','EC','5.3.1.1',true).
concept_accession('40472: rn:R01015','KEGG','RNO:498731',true).
concept_accession('40472: rn:R01015','KEGG','24849',true).
concept_accession('40472: rn:R01015','KEGG','246267',true).
concept_accession('40472: rn:R01015','KEGG','RNO:24849',true).
concept_accession('40472: rn:R01015','KEGG','5.3.1.1',true).
concept_accession('40473: rn:R01802','KEGG','2.7.8.11',true).
concept_accession('40473: rn:R01802','KEGG','EC:2.7.8.11',true).
concept_accession('40473: rn:R01802','KEGG','192260',true).
concept_accession('40473: rn:R01802','KEGG','RNO:192260',true).
concept_accession('40473: rn:R01802','EC','2.7.8.11',true).
concept_accession('40474: rn:R05802','KEGG','316457',true).
concept_accession('40474: rn:R05802','KEGG','EC:2.7.1.150',true).
concept_accession('40474: rn:R05802','KEGG','RNO:316457',true).
concept_accession('40474: rn:R05802','EC','2.7.1.150',true).
concept_accession('40474: rn:R05802','KEGG','2.7.1.150',true).
concept_accession('9416: rn:R00230','KEGG','R00230',true).
concept_accession('9416: rn:R00230','KEGG','2.3.1.8',true).
concept_accession('9416: rn:R00230','KEGG','RN:R00230',true).
concept_accession('9416: rn:R00230','EC','2.3.1.8',false).
concept_accession('9416: rn:R00230','KEGG','EC:2.3.1.8',true).
concept_accession('40475: rn:R05921','EC','2.4.1.-',true).
concept_accession('40475: rn:R05921','KEGG','2.4.1.-',true).
concept_accession('40475: rn:R05921','KEGG','RNO:366478',true).
concept_accession('40475: rn:R05921','KEGG','EC:2.4.1.-',true).
concept_accession('40475: rn:R05921','KEGG','366478',true).
concept_accession('40453: rn:R00872','KEGG','RNO:306490',true).
concept_accession('40453: rn:R00872','KEGG','296571',true).
concept_accession('40453: rn:R00872','KEGG','305935',true).
concept_accession('40453: rn:R00872','EC','3.1.3.-',true).
concept_accession('40453: rn:R00872','KEGG','306490',true).
concept_accession('40453: rn:R00872','KEGG','EC:3.1.3.-',true).
concept_accession('40453: rn:R00872','KEGG','3.1.3.-',true).
concept_accession('40453: rn:R00872','KEGG','RNO:296571',true).
concept_accession('40453: rn:R00872','KEGG','RNO:305935',true).
concept_accession('40452: rn:R01951','KEGG','310935',true).
concept_accession('40452: rn:R01951','KEGG','EC:2.7.7.30',true).
concept_accession('40452: rn:R01951','EC','2.7.7.30',true).
concept_accession('40452: rn:R01951','KEGG','2.7.7.30',true).
concept_accession('40452: rn:R01951','KEGG','RNO:310935',true).
concept_accession('40455: rn:R00867','KEGG','RNO:100364027',true).
concept_accession('40455: rn:R00867','KEGG','25058',true).
concept_accession('40455: rn:R00867','KEGG','25059',true).
concept_accession('40455: rn:R00867','KEGG','RNO:25058',true).
concept_accession('40455: rn:R00867','KEGG','25060',true).
concept_accession('40455: rn:R00867','KEGG','RNO:25059',true).
concept_accession('40455: rn:R00867','EC','2.7.1.1',true).
concept_accession('40455: rn:R00867','KEGG','100364027',true).
concept_accession('40455: rn:R00867','KEGG','RNO:25060',true).
concept_accession('40455: rn:R00867','KEGG','EC:2.7.1.1',true).
concept_accession('40455: rn:R00867','KEGG','2.7.1.1',true).
concept_accession('40454: rn:R01326','KEGG','RNO:100364027',true).
concept_accession('40454: rn:R01326','KEGG','25058',true).
concept_accession('40454: rn:R01326','KEGG','25059',true).
concept_accession('40454: rn:R01326','KEGG','RNO:25058',true).
concept_accession('40454: rn:R01326','KEGG','EC:2.7.1.7',true).
concept_accession('40454: rn:R01326','KEGG','25060',true).
concept_accession('40454: rn:R01326','KEGG','RNO:25059',true).
concept_accession('40454: rn:R01326','KEGG','100364027',true).
concept_accession('40454: rn:R01326','KEGG','2.7.1.7',true).
concept_accession('40454: rn:R01326','KEGG','RNO:25060',true).
concept_accession('40454: rn:R01326','EC','2.7.1.7',true).
concept_accession('40449: rn:R02731','KEGG','RNO:24638',true).
concept_accession('40449: rn:R02731','KEGG','117276',true).
concept_accession('40449: rn:R02731','KEGG','54283',true).
concept_accession('40449: rn:R02731','KEGG','RNO:54283',true).
concept_accession('40449: rn:R02731','KEGG','RNO:24640',true).
concept_accession('40449: rn:R02731','KEGG','RNO:117276',true).
concept_accession('40449: rn:R02731','KEGG','EC:3.1.3.46',true).
concept_accession('40449: rn:R02731','KEGG','24640',true).
concept_accession('40449: rn:R02731','EC','3.1.3.46',true).
concept_accession('40449: rn:R02731','KEGG','RNO:502894',true).
concept_accession('40449: rn:R02731','KEGG','24638',true).
concept_accession('40449: rn:R02731','KEGG','502894',true).
concept_accession('40449: rn:R02731','KEGG','3.1.3.46',true).
concept_accession('1715: rn:R02476 rn:R02477','KEGG','EC:1.1.1.50',true).
concept_accession('1715: rn:R02476 rn:R02477','KEGG','RC:RC00144',true).
concept_accession('1715: rn:R02476 rn:R02477','EC','1.1.1.50',false).
concept_accession('1715: rn:R02476 rn:R02477','KEGG','RC00144',true).
concept_accession('1715: rn:R02476 rn:R02477','KEGG','RN:R02477',true).
concept_accession('1715: rn:R02476 rn:R02477','KEGG','R02476',true).
concept_accession('1715: rn:R02476 rn:R02477','KEGG','RP00381',true).
concept_accession('1715: rn:R02476 rn:R02477','KEGG','R02477',true).
concept_accession('1715: rn:R02476 rn:R02477','KEGG','RN:R02476',true).
concept_accession('1715: rn:R02476 rn:R02477','KEGG','1.1.1.50',true).
concept_accession('1715: rn:R02476 rn:R02477','KEGG','RP:RP00381',true).
concept_accession('40448: rn:R04779','KEGG','2.7.1.11',true).
concept_accession('40448: rn:R04779','KEGG','RNO:25741',true).
concept_accession('40448: rn:R04779','KEGG','RNO:60416',true).
concept_accession('40448: rn:R04779','KEGG','25741',true).
concept_accession('40448: rn:R04779','EC','2.7.1.11',true).
concept_accession('40448: rn:R04779','KEGG','65152',true).
concept_accession('40448: rn:R04779','KEGG','EC:2.7.1.11',true).
concept_accession('40448: rn:R04779','KEGG','RNO:65152',true).
concept_accession('40448: rn:R04779','KEGG','60416',true).
concept_accession('1712: rn:R04309','KEGG','RC:RC00144',true).
concept_accession('1712: rn:R04309','KEGG','RP00748',true).
concept_accession('1712: rn:R04309','KEGG','RC00144',true).
concept_accession('1712: rn:R04309','KEGG','RP:RP00748',true).
concept_accession('1712: rn:R04309','KEGG','EC:1.1.1.152',true).
concept_accession('1712: rn:R04309','KEGG','R04309',true).
concept_accession('1712: rn:R04309','EC','1.1.1.152',false).
concept_accession('1712: rn:R04309','KEGG','RN:R04309',true).
concept_accession('1712: rn:R04309','KEGG','1.1.1.152',true).
concept_accession('40451: rn:R01818','KEGG','302915',true).
concept_accession('40451: rn:R01818','KEGG','300089',true).
concept_accession('40451: rn:R01818','KEGG','EC:5.4.2.8',true).
concept_accession('40451: rn:R01818','KEGG','RNO:300089',true).
concept_accession('40451: rn:R01818','KEGG','RNO:302915',true).
concept_accession('40451: rn:R01818','KEGG','5.4.2.8',true).
concept_accession('40451: rn:R01818','EC','5.4.2.8',true).
concept_accession('40450: rn:R01819','EC','5.3.1.8',true).
concept_accession('40450: rn:R01819','KEGG','5.3.1.8',true).
concept_accession('40450: rn:R01819','KEGG','RNO:300741',true).
concept_accession('40450: rn:R01819','KEGG','300741',true).
concept_accession('40450: rn:R01819','KEGG','EC:5.3.1.8',true).
concept_accession('40461: rn:R03435','KEGG','RNO:29337',true).
concept_accession('40461: rn:R03435','KEGG','RNO:25031',true).
concept_accession('40461: rn:R03435','KEGG','85240',true).
concept_accession('40461: rn:R03435','KEGG','29337',true).
concept_accession('40461: rn:R03435','KEGG','25738',true).
concept_accession('40461: rn:R03435','KEGG','287745',true).
concept_accession('40461: rn:R03435','KEGG','140693',true).
concept_accession('40461: rn:R03435','KEGG','114633',true).
concept_accession('40461: rn:R03435','KEGG','RNO:114633',true).
concept_accession('40461: rn:R03435','KEGG','RNO:29322',true).
concept_accession('40461: rn:R03435','KEGG','3.1.4.11',true).
concept_accession('40461: rn:R03435','KEGG','RNO:85240',true).
concept_accession('40461: rn:R03435','KEGG','29322',true).
concept_accession('40461: rn:R03435','KEGG','24655',true).
concept_accession('40461: rn:R03435','KEGG','24654',true).
concept_accession('40461: rn:R03435','KEGG','RNO:25738',true).
concept_accession('40461: rn:R03435','KEGG','25031',true).
concept_accession('40461: rn:R03435','EC','3.1.4.11',true).
concept_accession('40461: rn:R03435','KEGG','RNO:24654',true).
concept_accession('40461: rn:R03435','KEGG','RNO:497197',true).
concept_accession('40461: rn:R03435','KEGG','RNO:24655',true).
concept_accession('40461: rn:R03435','KEGG','EC:3.1.4.11',true).
concept_accession('40461: rn:R03435','KEGG','RNO:140693',true).
concept_accession('40461: rn:R03435','KEGG','497197',true).
concept_accession('40461: rn:R03435','KEGG','RNO:287745',true).
concept_accession('40460: rn:R04545','KEGG','RNO:170911',true).
concept_accession('40460: rn:R04545','KEGG','2.7.1.153',true).
concept_accession('40460: rn:R04545','KEGG','RNO:85243',true).
concept_accession('40460: rn:R04545','KEGG','EC:2.7.1.153',true).
concept_accession('40460: rn:R04545','EC','2.7.1.153',true).
concept_accession('40460: rn:R04545','KEGG','RNO:366508',true).
concept_accession('40460: rn:R04545','KEGG','170911',true).
concept_accession('40460: rn:R04545','KEGG','366508',true).
concept_accession('40460: rn:R04545','KEGG','85243',true).
concept_accession('40463: rn:R07299','KEGG','116699',true).
concept_accession('40463: rn:R07299','KEGG','EC:3.1.3.66',true).
concept_accession('40463: rn:R07299','EC','3.1.3.66',true).
concept_accession('40463: rn:R07299','KEGG','80849',true).
concept_accession('40463: rn:R07299','KEGG','RNO:80849',true).
concept_accession('40463: rn:R07299','KEGG','3.1.3.66',true).
concept_accession('40463: rn:R07299','KEGG','RNO:116699',true).
concept_accession('40462: rn:R00866','KEGG','EC:2.7.1.3',true).
concept_accession('40462: rn:R00866','EC','2.7.1.3',true).
concept_accession('40462: rn:R00866','KEGG','2.7.1.3',true).
concept_accession('40462: rn:R00866','KEGG','RNO:25659',true).
concept_accession('40462: rn:R00866','KEGG','25659',true).
concept_accession('40457: rn:R01787','KEGG','24192',true).
concept_accession('40457: rn:R01787','KEGG','RNO:24192',true).
concept_accession('40457: rn:R01787','KEGG','1.1.1.21',true).
concept_accession('40457: rn:R01787','EC','1.1.1.21',true).
concept_accession('40457: rn:R01787','KEGG','EC:1.1.1.21',true).
concept_accession('40456: rn:R01185','KEGG','RNO:282636',true).
concept_accession('40456: rn:R01185','KEGG','83523',true).
concept_accession('40456: rn:R01185','KEGG','282636',true).
concept_accession('40456: rn:R01185','EC','3.1.3.25',true).
concept_accession('40456: rn:R01185','KEGG','3.1.3.25',true).
concept_accession('40456: rn:R01185','KEGG','EC:3.1.3.25',true).
concept_accession('40456: rn:R01185','KEGG','RNO:83523',true).
concept_accession('40459: rn:R00875','KEGG','EC:1.1.1.14',true).
concept_accession('40459: rn:R00875','EC','1.1.1.14',true).
concept_accession('40459: rn:R00875','KEGG','RNO:24788',true).
concept_accession('40459: rn:R00875','KEGG','1.1.1.14',true).
concept_accession('40459: rn:R00875','KEGG','24788',true).
concept_accession('40458: rn:R05202','KEGG','EC:2.7.1.158',true).
concept_accession('40458: rn:R05202','EC','2.7.1.158',true).
concept_accession('40458: rn:R05202','KEGG','RNO:306808',true).
concept_accession('40458: rn:R05202','KEGG','2.7.1.158',true).
concept_accession('40458: rn:R05202','KEGG','306808',true).
concept_accession('40502: rn:R06870','KEGG','RNO:287644',true).
concept_accession('40502: rn:R06870','KEGG','287644',true).
concept_accession('40502: rn:R06870','KEGG','EC:3.1.3.75',true).
concept_accession('40502: rn:R06870','EC','3.1.3.75',true).
concept_accession('40502: rn:R06870','KEGG','3.1.3.75',true).
concept_accession('40503: rn:R00299','KEGG','RNO:100364027',true).
concept_accession('40503: rn:R00299','KEGG','25058',true).
concept_accession('40503: rn:R00299','KEGG','25059',true).
concept_accession('40503: rn:R00299','KEGG','RNO:25058',true).
concept_accession('40503: rn:R00299','KEGG','25060',true).
concept_accession('40503: rn:R00299','KEGG','RNO:25059',true).
concept_accession('40503: rn:R00299','EC','2.7.1.1',true).
concept_accession('40503: rn:R00299','KEGG','100364027',true).
concept_accession('40503: rn:R00299','KEGG','RNO:25060',true).
concept_accession('40503: rn:R00299','KEGG','EC:2.7.1.1',true).
concept_accession('40503: rn:R00299','KEGG','2.7.1.1',true).
concept_accession('40500: rn:R02053','KEGG','298579',true).
concept_accession('40500: rn:R02053','KEGG','RNO:192259',true).
concept_accession('40500: rn:R02053','KEGG','296091',true).
concept_accession('40500: rn:R02053','KEGG','RNO:311341',true).
concept_accession('40500: rn:R02053','KEGG','RNO:29359',true).
concept_accession('40500: rn:R02053','KEGG','RNO:289733',true).
concept_accession('40500: rn:R02053','KEGG','29526',true).
concept_accession('40500: rn:R02053','KEGG','29387',true).
concept_accession('40500: rn:R02053','KEGG','362039',true).
concept_accession('40500: rn:R02053','KEGG','EC:3.1.1.4',true).
concept_accession('40500: rn:R02053','KEGG','RNO:29387',true).
concept_accession('40500: rn:R02053','KEGG','691907',true).
concept_accession('40500: rn:R02053','KEGG','RNO:298579',true).
concept_accession('40500: rn:R02053','KEGG','311341',true).
concept_accession('40500: rn:R02053','KEGG','RNO:690388',true).
concept_accession('40500: rn:R02053','KEGG','289733',true).
concept_accession('40500: rn:R02053','KEGG','RNO:362039',true).
concept_accession('40500: rn:R02053','KEGG','RNO:29692',true).
concept_accession('40500: rn:R02053','KEGG','24653',true).
concept_accession('40500: rn:R02053','KEGG','RNO:29526',true).
concept_accession('40500: rn:R02053','EC','3.1.1.4',true).
concept_accession('40500: rn:R02053','KEGG','RNO:24653',true).
concept_accession('40500: rn:R02053','KEGG','192259',true).
concept_accession('40500: rn:R02053','KEGG','3.1.1.4',true).
concept_accession('40500: rn:R02053','KEGG','690388',true).
concept_accession('40500: rn:R02053','KEGG','RNO:691907',true).
concept_accession('40500: rn:R02053','KEGG','RNO:296091',true).
concept_accession('40500: rn:R02053','KEGG','29359',true).
concept_accession('40500: rn:R02053','KEGG','367415',true).
concept_accession('40500: rn:R02053','KEGG','29354',true).
concept_accession('40500: rn:R02053','KEGG','RNO:367415',true).
concept_accession('40500: rn:R02053','KEGG','RNO:360426',true).
concept_accession('40500: rn:R02053','KEGG','29692',true).
concept_accession('40500: rn:R02053','KEGG','360426',true).
concept_accession('40500: rn:R02053','KEGG','RNO:29354',true).
concept_accession('40501: rn:R02241','KEGG','362702',true).
concept_accession('40501: rn:R02241','KEGG','170919',true).
concept_accession('40501: rn:R02241','KEGG','RNO:311821',true).
concept_accession('40501: rn:R02241','EC','2.3.1.51',true).
concept_accession('40501: rn:R02241','KEGG','311821',true).
concept_accession('40501: rn:R02241','KEGG','313997',true).
concept_accession('40501: rn:R02241','KEGG','2.3.1.51',true).
concept_accession('40501: rn:R02241','KEGG','RNO:313997',true).
concept_accession('40501: rn:R02241','KEGG','RNO:406165',true).
concept_accession('40501: rn:R02241','KEGG','EC:2.3.1.51',true).
concept_accession('40501: rn:R02241','KEGG','RNO:294324',true).
concept_accession('40501: rn:R02241','KEGG','RNO:170919',true).
concept_accession('40501: rn:R02241','KEGG','406165',true).
concept_accession('40501: rn:R02241','KEGG','294324',true).
concept_accession('40501: rn:R02241','KEGG','498741',true).
concept_accession('40501: rn:R02241','KEGG','RNO:498741',true).
concept_accession('40501: rn:R02241','KEGG','RNO:362702',true).
concept_accession('40498: rn:R02568','KEGG','24191',true).
concept_accession('40498: rn:R02568','KEGG','24190',true).
concept_accession('40498: rn:R02568','KEGG','RNO:24190',true).
concept_accession('40498: rn:R02568','KEGG','RNO:24191',true).
concept_accession('40498: rn:R02568','KEGG','EC:4.1.2.13',true).
concept_accession('40498: rn:R02568','KEGG','4.1.2.13',true).
concept_accession('40498: rn:R02568','KEGG','RNO:299052',true).
concept_accession('40498: rn:R02568','EC','4.1.2.13',true).
concept_accession('40498: rn:R02568','KEGG','24189',true).
concept_accession('40498: rn:R02568','KEGG','RNO:24189',true).
concept_accession('40498: rn:R02568','KEGG','299052',true).
concept_accession('40499: rn:R01802','KEGG','2.7.8.11',true).
concept_accession('40499: rn:R01802','KEGG','EC:2.7.8.11',true).
concept_accession('40499: rn:R01802','KEGG','192260',true).
concept_accession('40499: rn:R01802','KEGG','RNO:192260',true).
concept_accession('40499: rn:R01802','EC','2.7.8.11',true).
concept_accession('40496: rn:R01070','KEGG','24191',true).
concept_accession('40496: rn:R01070','KEGG','24190',true).
concept_accession('40496: rn:R01070','KEGG','RNO:24190',true).
concept_accession('40496: rn:R01070','KEGG','RNO:24191',true).
concept_accession('40496: rn:R01070','KEGG','EC:4.1.2.13',true).
concept_accession('40496: rn:R01070','KEGG','4.1.2.13',true).
concept_accession('40496: rn:R01070','KEGG','RNO:299052',true).
concept_accession('40496: rn:R01070','EC','4.1.2.13',true).
concept_accession('40496: rn:R01070','KEGG','24189',true).
concept_accession('40496: rn:R01070','KEGG','RNO:24189',true).
concept_accession('40496: rn:R01070','KEGG','299052',true).
concept_accession('40497: rn:R01015','KEGG','RNO:246267',true).
concept_accession('40497: rn:R01015','KEGG','RNO:500959',true).
concept_accession('40497: rn:R01015','KEGG','500959',true).
concept_accession('40497: rn:R01015','KEGG','EC:5.3.1.1',true).
concept_accession('40497: rn:R01015','KEGG','498731',true).
concept_accession('40497: rn:R01015','EC','5.3.1.1',true).
concept_accession('40497: rn:R01015','KEGG','RNO:498731',true).
concept_accession('40497: rn:R01015','KEGG','24849',true).
concept_accession('40497: rn:R01015','KEGG','246267',true).
concept_accession('40497: rn:R01015','KEGG','RNO:24849',true).
concept_accession('40497: rn:R01015','KEGG','5.3.1.1',true).
concept_accession('40510: rn:R01101','EC','3.2.1.22',true).
concept_accession('40510: rn:R01101','KEGG','3.2.1.22',true).
concept_accession('40510: rn:R01101','KEGG','EC:3.2.1.22',true).
concept_accession('40510: rn:R01101','KEGG','363494',true).
concept_accession('40510: rn:R01101','KEGG','RNO:363494',true).
concept_accession('40511: rn:R02038','KEGG','EC:2.7.7.14',true).
concept_accession('40511: rn:R02038','KEGG','RNO:89841',true).
concept_accession('40511: rn:R02038','KEGG','89841',true).
concept_accession('40511: rn:R02038','KEGG','2.7.7.14',true).
concept_accession('40511: rn:R02038','EC','2.7.7.14',true).
concept_accession('40508: rn:R00842','KEGG','RNO:60666',true).
concept_accession('40508: rn:R00842','KEGG','1.1.1.8',true).
concept_accession('40508: rn:R00842','KEGG','60666',true).
concept_accession('40508: rn:R00842','KEGG','RNO:363159',true).
concept_accession('40508: rn:R00842','EC','1.1.1.8',true).
concept_accession('40508: rn:R00842','KEGG','EC:1.1.1.8',true).
concept_accession('40508: rn:R00842','KEGG','363159',true).
concept_accession('40509: rn:R02114','KEGG','RNO:24530',true).
concept_accession('40509: rn:R02114','KEGG','24530',true).
concept_accession('40509: rn:R02114','KEGG','2.3.1.43',true).
concept_accession('40509: rn:R02114','EC','2.3.1.43',true).
concept_accession('40509: rn:R02114','KEGG','EC:2.3.1.43',true).
concept_accession('40506: rn:R00848','KEGG','25062',true).
concept_accession('40506: rn:R00848','KEGG','1.1.5.3',true).
concept_accession('40506: rn:R00848','EC','1.1.5.3',true).
concept_accession('40506: rn:R00848','KEGG','RNO:25062',true).
concept_accession('40506: rn:R00848','KEGG','EC:1.1.5.3',true).
concept_accession('40507: rn:R00851','KEGG','29653',true).
concept_accession('40507: rn:R00851','KEGG','305166',true).
concept_accession('40507: rn:R00851','KEGG','RNO:29653',true).
concept_accession('40507: rn:R00851','KEGG','EC:2.3.1.15',true).
concept_accession('40507: rn:R00851','KEGG','RNO:305166',true).
concept_accession('40507: rn:R00851','KEGG','RNO:296130',true).
concept_accession('40507: rn:R00851','KEGG','296130',true).
concept_accession('40507: rn:R00851','KEGG','2.3.1.15',true).
concept_accession('40507: rn:R00851','EC','2.3.1.15',true).
concept_accession('40507: rn:R00851','KEGG','290843',true).
concept_accession('40507: rn:R00851','KEGG','RNO:290843',true).
concept_accession('40504: rn:R01788','KEGG','RNO:25634',true).
concept_accession('40504: rn:R01788','KEGG','25634',true).
concept_accession('40504: rn:R01788','KEGG','EC:3.1.3.9',true).
concept_accession('40504: rn:R01788','KEGG','3.1.3.9',true).
concept_accession('40504: rn:R01788','EC','3.1.3.9',true).
concept_accession('40505: rn:R00299','KEGG','RNO:24385',true).
concept_accession('40505: rn:R00299','EC','2.7.1.1',true).
concept_accession('40505: rn:R00299','KEGG','24385',true).
concept_accession('40505: rn:R00299','KEGG','EC:2.7.1.1',true).
concept_accession('40505: rn:R00299','KEGG','2.7.1.1',true).
concept_accession('40487: rn:R05916','KEGG','RNO:364032',true).
concept_accession('40487: rn:R05916','KEGG','EC:2.4.1.198',true).
concept_accession('40487: rn:R05916','KEGG','364032',true).
concept_accession('40487: rn:R05916','EC','2.4.1.198',true).
concept_accession('40487: rn:R05916','KEGG','2.4.1.198',true).
concept_accession('40486: rn:R05916','KEGG','EC:2.4.1.198',true).
concept_accession('40486: rn:R05916','KEGG','362756',true).
concept_accession('40486: rn:R05916','KEGG','RNO:362756',true).
concept_accession('40486: rn:R05916','EC','2.4.1.198',true).
concept_accession('40486: rn:R05916','KEGG','2.4.1.198',true).
concept_accession('40485: rn:R05919','EC','2.4.1.-',true).
concept_accession('40485: rn:R05919','KEGG','2.4.1.-',true).
concept_accession('40485: rn:R05919','KEGG','RNO:288041',true).
concept_accession('40485: rn:R05919','KEGG','EC:2.4.1.-',true).
concept_accession('40485: rn:R05919','KEGG','288041',true).
concept_accession('40484: rn:R05919','EC','2.4.1.-',true).
concept_accession('40484: rn:R05919','KEGG','2.4.1.-',true).
concept_accession('40484: rn:R05919','KEGG','EC:2.4.1.-',true).
concept_accession('40484: rn:R05919','KEGG','79112',true).
concept_accession('40484: rn:R05919','KEGG','RNO:79112',true).
concept_accession('40483: rn:R08107','KEGG','EC:2.7.-.-',true).
concept_accession('40483: rn:R08107','EC','2.7.-.-',true).
concept_accession('40483: rn:R08107','KEGG','681086',true).
concept_accession('40483: rn:R08107','KEGG','2.7.-.-',true).
concept_accession('40483: rn:R08107','KEGG','RNO:681086',true).
concept_accession('1681: rn:R02208','EC','1.3.1.30',false).
concept_accession('1681: rn:R02208','KEGG','RC:RC00145',true).
concept_accession('1681: rn:R02208','KEGG','R02208',true).
concept_accession('1681: rn:R02208','KEGG','EC:1.3.1.30',true).
concept_accession('1681: rn:R02208','KEGG','RC00145',true).
concept_accession('1681: rn:R02208','KEGG','RN:R02208',true).
concept_accession('1681: rn:R02208','KEGG','1.3.1.30',true).
concept_accession('1681: rn:R02208','KEGG','RP02043',true).
concept_accession('1681: rn:R02208','KEGG','RP:RP02043',true).
concept_accession('40482: rn:R05917','EC','3.5.1.89',true).
concept_accession('40482: rn:R05917','KEGG','3.5.1.89',true).
concept_accession('40482: rn:R05917','KEGG','192263',true).
concept_accession('40482: rn:R05917','KEGG','EC:3.5.1.89',true).
concept_accession('40482: rn:R05917','KEGG','RNO:192263',true).
concept_accession('40481: rn:R05922','EC','2.4.1.-',true).
concept_accession('40481: rn:R05922','KEGG','2.4.1.-',true).
concept_accession('40481: rn:R05922','KEGG','EC:2.4.1.-',true).
concept_accession('40481: rn:R05922','KEGG','315807',true).
concept_accession('40481: rn:R05922','KEGG','RNO:315807',true).
concept_accession('40480: rn:R05920','KEGG','309051',true).
concept_accession('40480: rn:R05920','KEGG','EC:2.7.-.-',true).
concept_accession('40480: rn:R05920','EC','2.7.-.-',true).
concept_accession('40480: rn:R05920','KEGG','2.7.-.-',true).
concept_accession('40480: rn:R05920','KEGG','RNO:309051',true).
concept_accession('40495: rn:R04780','KEGG','114508',true).
concept_accession('40495: rn:R04780','KEGG','3.1.3.11',true).
concept_accession('40495: rn:R04780','KEGG','24362',true).
concept_accession('40495: rn:R04780','KEGG','RNO:24362',true).
concept_accession('40495: rn:R04780','KEGG','EC:3.1.3.11',true).
concept_accession('40495: rn:R04780','EC','3.1.3.11',true).
concept_accession('40495: rn:R04780','KEGG','RNO:114508',true).
concept_accession('40494: rn:R07376','KEGG','RNO:293620',true).
concept_accession('40494: rn:R07376','KEGG','2.7.8.-',true).
concept_accession('40494: rn:R07376','KEGG','293620',true).
concept_accession('40494: rn:R07376','EC','2.7.8.-',true).
concept_accession('40494: rn:R07376','KEGG','EC:2.7.8.-',true).
concept_accession('40493: rn:R07377','KEGG','RNO:314553',true).
concept_accession('40493: rn:R07377','KEGG','314553',true).
concept_accession('40493: rn:R07377','KEGG','2.7.8.-',true).
concept_accession('40493: rn:R07377','EC','2.7.8.-',true).
concept_accession('40493: rn:R07377','KEGG','EC:2.7.8.-',true).
concept_accession('40492: rn:R03161','KEGG','RNO:307848',true).
concept_accession('40492: rn:R03161','EC','2.7.1.52',true).
concept_accession('40492: rn:R03161','KEGG','2.7.1.52',true).
concept_accession('40492: rn:R03161','KEGG','EC:2.7.1.52',true).
concept_accession('40492: rn:R03161','KEGG','307848',true).
concept_accession('40491: rn:R01013','KEGG','84470',true).
concept_accession('40491: rn:R01013','EC','2.3.1.42',true).
concept_accession('40491: rn:R01013','KEGG','2.3.1.42',true).
concept_accession('40491: rn:R01013','KEGG','EC:2.3.1.42',true).
concept_accession('40491: rn:R01013','KEGG','RNO:84470',true).
concept_accession('40490: rn:R01321','KEGG','2.7.8.2',true).
concept_accession('40490: rn:R01321','KEGG','RNO:310773',true).
concept_accession('40490: rn:R01321','EC','2.7.8.2',true).
concept_accession('40490: rn:R01321','KEGG','310773',true).
concept_accession('40490: rn:R01321','KEGG','362866',true).
concept_accession('40490: rn:R01321','KEGG','EC:2.7.8.2',true).
concept_accession('40490: rn:R01321','KEGG','RNO:362866',true).
concept_accession('40489: rn:R01890','KEGG','2.7.7.15',true).
concept_accession('40489: rn:R01890','KEGG','EC:2.7.7.15',true).
concept_accession('40489: rn:R01890','EC','2.7.7.15',true).
concept_accession('40489: rn:R01890','KEGG','140544',true).
concept_accession('40489: rn:R01890','KEGG','RNO:140544',true).
concept_accession('40489: rn:R01890','KEGG','RNO:286936',true).
concept_accession('40489: rn:R01890','KEGG','286936',true).
concept_accession('40488: rn:R01318','KEGG','RNO:296048',true).
concept_accession('40488: rn:R01318','KEGG','RNO:307713',true).
concept_accession('40488: rn:R01318','KEGG','296048',true).
concept_accession('40488: rn:R01318','KEGG','361467',true).
concept_accession('40488: rn:R01318','KEGG','362434',true).
concept_accession('40488: rn:R01318','EC','2.3.1.23',true).
concept_accession('40488: rn:R01318','KEGG','307713',true).
concept_accession('40488: rn:R01318','KEGG','EC:2.3.1.23',true).
concept_accession('40488: rn:R01318','KEGG','RNO:361467',true).
concept_accession('40488: rn:R01318','KEGG','2.3.1.23',true).
concept_accession('40488: rn:R01318','KEGG','RNO:362434',true).
concept_accession('40488: rn:R01318','KEGG','RNO:100359680',true).
concept_accession('40488: rn:R01318','KEGG','100359680',true).
concept_accession('40906: rn:R05987','KEGG','RNO:367252',true).
concept_accession('40906: rn:R05987','KEGG','2.4.1.145',true).
concept_accession('40906: rn:R05987','KEGG','RNO:304646',true).
concept_accession('40906: rn:R05987','EC','2.4.1.145',true).
concept_accession('40906: rn:R05987','KEGG','RNO:303100',true).
concept_accession('40906: rn:R05987','KEGG','303100',true).
concept_accession('40906: rn:R05987','KEGG','367252',true).
concept_accession('40906: rn:R05987','KEGG','304646',true).
concept_accession('40906: rn:R05987','KEGG','EC:2.4.1.145',true).
concept_accession('40907: rn:R03321','KEGG','5.3.1.9',true).
concept_accession('40907: rn:R03321','EC','5.3.1.9',true).
concept_accession('40907: rn:R03321','KEGG','292804',true).
concept_accession('40907: rn:R03321','KEGG','EC:5.3.1.9',true).
concept_accession('40907: rn:R03321','KEGG','RNO:292804',true).
concept_accession('40904: rn:R05982','EC','3.2.1.113',true).
concept_accession('40904: rn:R05982','KEGG','EC:3.2.1.113',true).
concept_accession('40904: rn:R05982','KEGG','RNO:499751',true).
concept_accession('40904: rn:R05982','KEGG','499751',true).
concept_accession('40904: rn:R05982','KEGG','RNO:295319',true).
concept_accession('40904: rn:R05982','KEGG','3.2.1.113',true).
concept_accession('40904: rn:R05982','KEGG','294410',true).
concept_accession('40904: rn:R05982','KEGG','295319',true).
concept_accession('40904: rn:R05982','KEGG','RNO:362625',true).
concept_accession('40904: rn:R05982','KEGG','362625',true).
concept_accession('40904: rn:R05982','KEGG','RNO:294410',true).
concept_accession('1914: rn:R01856','KEGG','3.1.5.1',true).
concept_accession('1914: rn:R01856','KEGG','R01856',true).
concept_accession('1914: rn:R01856','KEGG','EC:3.1.5.1',true).
concept_accession('1914: rn:R01856','KEGG','RP01802',true).
concept_accession('1914: rn:R01856','KEGG','RC00017',true).
concept_accession('1914: rn:R01856','KEGG','RP:RP01802',true).
concept_accession('1914: rn:R01856','EC','3.1.5.1',false).
concept_accession('1914: rn:R01856','KEGG','RC:RC00017',true).
concept_accession('1914: rn:R01856','KEGG','RN:R01856',true).
concept_accession('40905: rn:R02739','KEGG','5.3.1.9',true).
concept_accession('40905: rn:R02739','EC','5.3.1.9',true).
concept_accession('40905: rn:R02739','KEGG','292804',true).
concept_accession('40905: rn:R02739','KEGG','EC:5.3.1.9',true).
concept_accession('40905: rn:R02739','KEGG','RNO:292804',true).
concept_accession('40910: rn:R05984','KEGG','EC:3.2.1.114',true).
concept_accession('40910: rn:R05984','KEGG','308757',true).
concept_accession('40910: rn:R05984','EC','3.2.1.114',true).
concept_accession('40910: rn:R05984','KEGG','RNO:25478',true).
concept_accession('40910: rn:R05984','KEGG','25478',true).
concept_accession('40910: rn:R05984','KEGG','3.2.1.114',true).
concept_accession('40910: rn:R05984','KEGG','RNO:308757',true).
concept_accession('40911: rn:R01786','KEGG','RNO:24385',true).
concept_accession('40911: rn:R01786','EC','2.7.1.1',true).
concept_accession('40911: rn:R01786','KEGG','24385',true).
concept_accession('40911: rn:R01786','KEGG','EC:2.7.1.1',true).
concept_accession('40911: rn:R01786','KEGG','2.7.1.1',true).
concept_accession('1919: rn:R00087','KEGG','RC00002',true).
concept_accession('1919: rn:R00087','KEGG','RP12346',true).
concept_accession('1919: rn:R00087','KEGG','RP:RP12346',true).
concept_accession('1919: rn:R00087','KEGG','RN:R00087',true).
concept_accession('1919: rn:R00087','KEGG','3.6.1.8',true).
concept_accession('1919: rn:R00087','KEGG','R00087',true).
concept_accession('1919: rn:R00087','KEGG','EC:3.6.1.8',true).
concept_accession('1919: rn:R00087','KEGG','RC:RC00002',true).
concept_accession('1919: rn:R00087','EC','3.6.1.8',false).
concept_accession('40908: rn:R05985','KEGG','EC:2.4.1.143',true).
concept_accession('40908: rn:R05985','KEGG','94273',true).
concept_accession('40908: rn:R05985','KEGG','2.4.1.143',true).
concept_accession('40908: rn:R05985','EC','2.4.1.143',true).
concept_accession('40908: rn:R05985','KEGG','RNO:94273',true).
concept_accession('40909: rn:R01600','KEGG','RNO:100364027',true).
concept_accession('40909: rn:R01600','KEGG','25058',true).
concept_accession('40909: rn:R01600','KEGG','25059',true).
concept_accession('40909: rn:R01600','KEGG','RNO:25058',true).
concept_accession('40909: rn:R01600','KEGG','25060',true).
concept_accession('40909: rn:R01600','KEGG','RNO:25059',true).
concept_accession('40909: rn:R01600','KEGG','100364027',true).
concept_accession('40909: rn:R01600','KEGG','EC:2.7.1.2',true).
concept_accession('40909: rn:R01600','EC','2.7.1.2',true).
concept_accession('40909: rn:R01600','KEGG','RNO:25060',true).
concept_accession('40909: rn:R01600','KEGG','2.7.1.2',true).
concept_accession('40898: rn:R05974','KEGG','293667',true).
concept_accession('40898: rn:R05974','EC','2.4.1.-',true).
concept_accession('40898: rn:R05974','KEGG','2.4.1.-',true).
concept_accession('40898: rn:R05974','KEGG','RNO:305571',true).
concept_accession('40898: rn:R05974','KEGG','EC:2.4.1.-',true).
concept_accession('40898: rn:R05974','KEGG','305571',true).
concept_accession('40898: rn:R05974','KEGG','RNO:293667',true).
concept_accession('40899: rn:R06190','EC','2.4.1.37',true).
concept_accession('40899: rn:R06190','KEGG','RNO:65270',true).
concept_accession('40899: rn:R06190','KEGG','100301568',true).
concept_accession('40899: rn:R06190','KEGG','RNO:100301568',true).
concept_accession('40899: rn:R06190','KEGG','2.4.1.37',true).
concept_accession('40899: rn:R06190','KEGG','RNO:296504',true).
concept_accession('40899: rn:R06190','KEGG','296504',true).
concept_accession('40899: rn:R06190','KEGG','65270',true).
concept_accession('40899: rn:R06190','KEGG','EC:2.4.1.37',true).
concept_accession('40896: rn:R06189','KEGG','306860',true).
concept_accession('40896: rn:R06189','EC','2.4.1.150',true).
concept_accession('40896: rn:R06189','KEGG','2.4.1.150',true).
concept_accession('40896: rn:R06189','KEGG','RNO:306860',true).
concept_accession('40896: rn:R06189','KEGG','EC:2.4.1.150',true).
concept_accession('40897: rn:R06076','KEGG','84597',true).
concept_accession('40897: rn:R06076','KEGG','2.4.1.65',true).
concept_accession('40897: rn:R06076','EC','2.4.1.65',true).
concept_accession('40897: rn:R06076','KEGG','RNO:84597',true).
concept_accession('40897: rn:R06076','KEGG','EC:2.4.1.65',true).
concept_accession('40902: rn:R06221','KEGG','84597',true).
concept_accession('40902: rn:R06221','EC','2.4.1.-',true).
concept_accession('40902: rn:R06221','KEGG','2.4.1.-',true).
concept_accession('40902: rn:R06221','KEGG','EC:2.4.1.-',true).
concept_accession('40902: rn:R06221','KEGG','RNO:84597',true).
concept_accession('40903: rn:R01600','KEGG','RNO:24385',true).
concept_accession('40903: rn:R01600','KEGG','EC:2.7.1.2',true).
concept_accession('40903: rn:R01600','KEGG','24385',true).
concept_accession('40903: rn:R01600','EC','2.7.1.2',true).
concept_accession('40903: rn:R01600','KEGG','2.7.1.2',true).
concept_accession('40900: rn:R06038','KEGG','84597',true).
concept_accession('40900: rn:R06038','EC','2.4.1.-',true).
concept_accession('40900: rn:R06038','KEGG','2.4.1.-',true).
concept_accession('40900: rn:R06038','KEGG','EC:2.4.1.-',true).
concept_accession('40900: rn:R06038','KEGG','RNO:84597',true).
concept_accession('40901: rn:R06191','KEGG','2.4.1.40',true).
concept_accession('40901: rn:R06191','KEGG','EC:2.4.1.40',true).
concept_accession('40901: rn:R06191','KEGG','RNO:65270',true).
concept_accession('40901: rn:R06191','KEGG','100301568',true).
concept_accession('40901: rn:R06191','KEGG','RNO:100301568',true).
concept_accession('40901: rn:R06191','KEGG','RNO:296504',true).
concept_accession('40901: rn:R06191','KEGG','296504',true).
concept_accession('40901: rn:R06191','KEGG','65270',true).
concept_accession('40901: rn:R06191','EC','2.4.1.40',true).
concept_accession('40923: rn:R01005','KEGG','295051',true).
concept_accession('40923: rn:R01005','EC','2.4.1.117',true).
concept_accession('40923: rn:R01005','KEGG','2.4.1.117',true).
concept_accession('40923: rn:R01005','KEGG','RNO:295051',true).
concept_accession('40923: rn:R01005','KEGG','EC:2.4.1.117',true).
concept_accession('40922: rn:R01788','KEGG','RNO:25634',true).
concept_accession('40922: rn:R01788','KEGG','25634',true).
concept_accession('40922: rn:R01788','KEGG','EC:3.1.3.9',true).
concept_accession('40922: rn:R01788','KEGG','3.1.3.9',true).
concept_accession('40922: rn:R01788','EC','3.1.3.9',true).
concept_accession('40921: rn:R05970','KEGG','300284',true).
concept_accession('40921: rn:R05970','KEGG','EC:2.4.1.141',true).
concept_accession('40921: rn:R05970','KEGG','RNO:300284',true).
concept_accession('40921: rn:R05970','KEGG','2.4.1.141',true).
concept_accession('40921: rn:R05970','EC','2.4.1.141',true).
concept_accession('40920: rn:R05960','KEGG','RNO:63888',true).
concept_accession('40920: rn:R05960','KEGG','EC:2.4.1.228',true).
concept_accession('40920: rn:R05960','KEGG','63888',true).
concept_accession('40920: rn:R05960','EC','2.4.1.228',true).
concept_accession('40920: rn:R05960','KEGG','2.4.1.228',true).
concept_accession('40927: rn:R05904','KEGG','84597',true).
concept_accession('40927: rn:R05904','KEGG','2.4.1.152',true).
concept_accession('40927: rn:R05904','KEGG','RNO:84597',true).
concept_accession('40927: rn:R05904','KEGG','EC:2.4.1.152',true).
concept_accession('40927: rn:R05904','EC','2.4.1.152',true).
concept_accession('40926: rn:R01018','KEGG','EC:2.7.1.108',true).
concept_accession('40926: rn:R01018','KEGG','2.7.1.108',true).
concept_accession('40926: rn:R01018','KEGG','311847',true).
concept_accession('40926: rn:R01018','EC','2.7.1.108',true).
concept_accession('40926: rn:R01018','KEGG','RNO:311847',true).
concept_accession('40925: rn:R05973','KEGG','313231',true).
concept_accession('40925: rn:R05973','KEGG','EC:2.4.1.132',true).
concept_accession('40925: rn:R05973','EC','2.4.1.132',true).
concept_accession('40925: rn:R05973','KEGG','RNO:313231',true).
concept_accession('40925: rn:R05973','KEGG','2.4.1.132',true).
concept_accession('40924: rn:R05963','KEGG','RNO:294673',true).
concept_accession('40924: rn:R05963','KEGG','294673',true).
concept_accession('40924: rn:R05963','KEGG','RNO:300757',true).
concept_accession('40924: rn:R05963','KEGG','EC:3.2.1.52',true).
concept_accession('40924: rn:R05963','EC','3.2.1.52',true).
concept_accession('40924: rn:R05963','KEGG','300757',true).
concept_accession('40924: rn:R05963','KEGG','3.2.1.52',true).
concept_accession('40915: rn:R05964','KEGG','288161',true).
concept_accession('40915: rn:R05964','EC','2.4.1.-',true).
concept_accession('40915: rn:R05964','KEGG','2.4.1.-',true).
concept_accession('40915: rn:R05964','KEGG','RNO:288161',true).
concept_accession('40915: rn:R05964','KEGG','EC:2.4.1.-',true).
concept_accession('40914: rn:R05976','KEGG','363160',true).
concept_accession('40914: rn:R05976','EC','2.4.1.119',true).
concept_accession('40914: rn:R05976','KEGG','RNO:500972',true).
concept_accession('40914: rn:R05976','KEGG','EC:2.4.1.119',true).
concept_accession('40914: rn:R05976','KEGG','500972',true).
concept_accession('40914: rn:R05976','KEGG','RNO:363160',true).
concept_accession('40914: rn:R05976','KEGG','2.4.1.119',true).
concept_accession('1890: rn:R00125','KEGG','EC:3.6.1.41',true).
concept_accession('1890: rn:R00125','KEGG','RC00002',true).
concept_accession('1890: rn:R00125','KEGG','RN:R00125',true).
concept_accession('1890: rn:R00125','EC','3.6.1.41',false).
concept_accession('1890: rn:R00125','KEGG','RP03640',true).
concept_accession('1890: rn:R00125','KEGG','RP:RP03640',true).
concept_accession('1890: rn:R00125','KEGG','R00125',true).
concept_accession('1890: rn:R00125','KEGG','RC:RC00002',true).
concept_accession('1890: rn:R00125','KEGG','3.6.1.41',true).
concept_accession('40913: rn:R01786','KEGG','RNO:100364027',true).
concept_accession('40913: rn:R01786','KEGG','25058',true).
concept_accession('40913: rn:R01786','KEGG','25059',true).
concept_accession('40913: rn:R01786','KEGG','RNO:25058',true).
concept_accession('40913: rn:R01786','KEGG','25060',true).
concept_accession('40913: rn:R01786','KEGG','RNO:25059',true).
concept_accession('40913: rn:R01786','EC','2.7.1.1',true).
concept_accession('40913: rn:R01786','KEGG','100364027',true).
concept_accession('40913: rn:R01786','KEGG','RNO:25060',true).
concept_accession('40913: rn:R01786','KEGG','EC:2.7.1.1',true).
concept_accession('40913: rn:R01786','KEGG','2.7.1.1',true).
concept_accession('40912: rn:R06128','KEGG','361174',true).
concept_accession('40912: rn:R06128','KEGG','EC:2.4.1.131',true).
concept_accession('40912: rn:R06128','EC','2.4.1.131',true).
concept_accession('40912: rn:R06128','KEGG','RNO:361174',true).
concept_accession('40912: rn:R06128','KEGG','2.4.1.131',true).
concept_accession('40919: rn:R05972','KEGG','360475',true).
concept_accession('40919: rn:R05972','KEGG','RNO:360475',true).
concept_accession('40919: rn:R05972','KEGG','EC:2.4.1.142',true).
concept_accession('40919: rn:R05972','KEGG','2.4.1.142',true).
concept_accession('40919: rn:R05972','EC','2.4.1.142',true).
concept_accession('40918: rn:R05966','EC','3.2.1.49',true).
concept_accession('40918: rn:R05966','KEGG','EC:3.2.1.49',true).
concept_accession('40918: rn:R05966','KEGG','3.2.1.49',true).
concept_accession('40918: rn:R05966','KEGG','315165',true).
concept_accession('40918: rn:R05966','KEGG','RNO:315165',true).
concept_accession('40917: rn:R05979','KEGG','3.2.1.106',true).
concept_accession('40917: rn:R05979','KEGG','RNO:78947',true).
concept_accession('40917: rn:R05979','EC','3.2.1.106',true).
concept_accession('40917: rn:R05979','KEGG','78947',true).
concept_accession('40917: rn:R05979','KEGG','EC:3.2.1.106',true).
concept_accession('40916: rn:R01602','KEGG','5.1.3.3',true).
concept_accession('40916: rn:R01602','KEGG','RNO:313843',true).
concept_accession('40916: rn:R01602','KEGG','EC:5.1.3.3',true).
concept_accession('40916: rn:R01602','KEGG','313843',true).
concept_accession('40916: rn:R01602','EC','5.1.3.3',true).
concept_accession('40936: rn:R03270','KEGG','RNO:117098',true).
concept_accession('40936: rn:R03270','EC','1.2.4.1',true).
concept_accession('40936: rn:R03270','KEGG','RNO:289950',true).
concept_accession('40936: rn:R03270','KEGG','1.2.4.1',true).
concept_accession('40936: rn:R03270','KEGG','117098',true).
concept_accession('40936: rn:R03270','KEGG','289950',true).
concept_accession('40936: rn:R03270','KEGG','29554',true).
concept_accession('40936: rn:R03270','KEGG','RNO:29554',true).
concept_accession('40936: rn:R03270','KEGG','EC:1.2.4.1',true).
concept_accession('40937: rn:R01518','KEGG','24959',true).
concept_accession('40937: rn:R01518','KEGG','RNO:24959',true).
concept_accession('40937: rn:R01518','KEGG','EC:5.4.2.1',true).
concept_accession('40937: rn:R01518','KEGG','296973',true).
concept_accession('40937: rn:R01518','KEGG','RNO:296973',true).
concept_accession('40937: rn:R01518','KEGG','24642',true).
concept_accession('40937: rn:R01518','KEGG','5.4.2.1',true).
concept_accession('40937: rn:R01518','EC','5.4.2.1',true).
concept_accession('40937: rn:R01518','KEGG','RNO:24642',true).
concept_accession('40938: rn:R00658','EC','4.2.1.11',true).
concept_accession('40938: rn:R00658','KEGG','4.2.1.11',true).
concept_accession('40938: rn:R00658','KEGG','RNO:25438',true).
concept_accession('40938: rn:R00658','KEGG','RNO:24333',true).
concept_accession('40938: rn:R00658','KEGG','24334',true).
concept_accession('40938: rn:R00658','KEGG','RNO:24334',true).
concept_accession('40938: rn:R00658','KEGG','EC:4.2.1.11',true).
concept_accession('40938: rn:R00658','KEGG','25438',true).
concept_accession('40938: rn:R00658','KEGG','24333',true).
concept_accession('1880: rn:R02020','EC','1.17.4.2',false).
concept_accession('1880: rn:R02020','KEGG','RC00613',true).
concept_accession('1880: rn:R02020','KEGG','RN:R02020',true).
concept_accession('1880: rn:R02020','KEGG','RP01915',true).
concept_accession('1880: rn:R02020','KEGG','1.17.4.2',true).
concept_accession('1880: rn:R02020','KEGG','RC:RC00613',true).
concept_accession('1880: rn:R02020','KEGG','EC:1.17.4.2',true).
concept_accession('1880: rn:R02020','KEGG','RP:RP01915',true).
concept_accession('1880: rn:R02020','KEGG','R02020',true).
concept_accession('40939: rn:R00200','KEGG','RNO:25630',true).
concept_accession('40939: rn:R00200','KEGG','24651',true).
concept_accession('40939: rn:R00200','KEGG','2.7.1.40',true).
concept_accession('40939: rn:R00200','KEGG','25630',true).
concept_accession('40939: rn:R00200','KEGG','EC:2.7.1.40',true).
concept_accession('40939: rn:R00200','EC','2.7.1.40',true).
concept_accession('40939: rn:R00200','KEGG','100364062',true).
concept_accession('40939: rn:R00200','KEGG','RNO:24651',true).
concept_accession('40939: rn:R00200','KEGG','RNO:100364062',true).
concept_accession('40940: rn:R05967','KEGG','EC:2.4.99.4',true).
concept_accession('40940: rn:R05967','KEGG','64442',true).
concept_accession('40940: rn:R05967','KEGG','2.4.99.4',true).
concept_accession('40940: rn:R05967','EC','2.4.99.4',true).
concept_accession('40940: rn:R05967','KEGG','RNO:64442',true).
concept_accession('40940: rn:R05967','KEGG','362924',true).
concept_accession('40940: rn:R05967','KEGG','RNO:362924',true).
concept_accession('40941: rn:R04779','KEGG','2.7.1.11',true).
concept_accession('40941: rn:R04779','KEGG','RNO:25741',true).
concept_accession('40941: rn:R04779','KEGG','RNO:60416',true).
concept_accession('40941: rn:R04779','KEGG','25741',true).
concept_accession('40941: rn:R04779','EC','2.7.1.11',true).
concept_accession('40941: rn:R04779','KEGG','65152',true).
concept_accession('40941: rn:R04779','KEGG','EC:2.7.1.11',true).
concept_accession('40941: rn:R04779','KEGG','RNO:65152',true).
concept_accession('40941: rn:R04779','KEGG','60416',true).
concept_accession('40942: rn:R01015','KEGG','RNO:246267',true).
concept_accession('40942: rn:R01015','KEGG','RNO:500959',true).
concept_accession('40942: rn:R01015','KEGG','500959',true).
concept_accession('40942: rn:R01015','KEGG','EC:5.3.1.1',true).
concept_accession('40942: rn:R01015','KEGG','498731',true).
concept_accession('40942: rn:R01015','EC','5.3.1.1',true).
concept_accession('40942: rn:R01015','KEGG','RNO:498731',true).
concept_accession('40942: rn:R01015','KEGG','24849',true).
concept_accession('40942: rn:R01015','KEGG','246267',true).
concept_accession('40942: rn:R01015','KEGG','RNO:24849',true).
concept_accession('40942: rn:R01015','KEGG','5.3.1.1',true).
concept_accession('1884: rn:R00429','KEGG','RC:RC00078',true).
concept_accession('1884: rn:R00429','KEGG','RC00078',true).
concept_accession('1884: rn:R00429','EC','2.7.6.5',false).
concept_accession('1884: rn:R00429','KEGG','EC:2.7.6.5',true).
concept_accession('1884: rn:R00429','KEGG','RP:RP00894',true).
concept_accession('1884: rn:R00429','KEGG','RP00894',true).
concept_accession('1884: rn:R00429','KEGG','R00429',true).
concept_accession('1884: rn:R00429','KEGG','RN:R00429',true).
concept_accession('1884: rn:R00429','KEGG','2.7.6.5',true).
concept_accession('40943: rn:R01061','KEGG','RNO:295423',true).
concept_accession('40943: rn:R01061','KEGG','500983',true).
concept_accession('40943: rn:R01061','KEGG','66020',true).
concept_accession('40943: rn:R01061','KEGG','RNO:688783',true).
concept_accession('40943: rn:R01061','EC','1.2.1.12',true).
concept_accession('40943: rn:R01061','KEGG','RNO:500983',true).
concept_accession('40943: rn:R01061','KEGG','RNO:306115',true).
concept_accession('40943: rn:R01061','KEGG','RNO:498019',true).
concept_accession('40943: rn:R01061','KEGG','RNO:24383',true).
concept_accession('40943: rn:R01061','KEGG','303448',true).
concept_accession('40943: rn:R01061','KEGG','RNO:293876',true).
concept_accession('40943: rn:R01061','KEGG','685186',true).
concept_accession('40943: rn:R01061','KEGG','1.2.1.12',true).
concept_accession('40943: rn:R01061','KEGG','RNO:290604',true).
concept_accession('40943: rn:R01061','KEGG','295423',true).
concept_accession('40943: rn:R01061','KEGG','RNO:498881',true).
concept_accession('40943: rn:R01061','KEGG','RNO:303448',true).
concept_accession('40943: rn:R01061','KEGG','24383',true).
concept_accession('40943: rn:R01061','KEGG','RNO:685186',true).
concept_accession('40943: rn:R01061','KEGG','EC:1.2.1.12',true).
concept_accession('40943: rn:R01061','KEGG','498019',true).
concept_accession('40943: rn:R01061','KEGG','290604',true).
concept_accession('40943: rn:R01061','KEGG','RNO:498099',true).
concept_accession('40943: rn:R01061','KEGG','498099',true).
concept_accession('40943: rn:R01061','KEGG','293876',true).
concept_accession('40943: rn:R01061','KEGG','RNO:498123',true).
concept_accession('40943: rn:R01061','KEGG','498123',true).
concept_accession('40943: rn:R01061','KEGG','688783',true).
concept_accession('40943: rn:R01061','KEGG','498881',true).
concept_accession('40943: rn:R01061','KEGG','RNO:66020',true).
concept_accession('40943: rn:R01061','KEGG','306115',true).
concept_accession('40928: rn:R05968','EC','2.4.1.69',true).
concept_accession('40928: rn:R05968','KEGG','RNO:58924',true).
concept_accession('40928: rn:R05968','KEGG','81919',true).
concept_accession('40928: rn:R05968','KEGG','58924',true).
concept_accession('40928: rn:R05968','KEGG','EC:2.4.1.69',true).
concept_accession('40928: rn:R05968','KEGG','308586',true).
concept_accession('40928: rn:R05968','KEGG','RNO:81919',true).
concept_accession('40928: rn:R05968','KEGG','RNO:308586',true).
concept_accession('40928: rn:R05968','KEGG','2.4.1.69',true).
concept_accession('40929: rn:R07618','KEGG','298942',true).
concept_accession('40929: rn:R07618','KEGG','1.8.1.4',true).
concept_accession('40929: rn:R07618','KEGG','EC:1.8.1.4',true).
concept_accession('40929: rn:R07618','KEGG','RNO:298942',true).
concept_accession('40929: rn:R07618','EC','1.8.1.4',true).
concept_accession('40930: rn:R01009','KEGG','RNO:296394',true).
concept_accession('40930: rn:R01009','KEGG','2.4.1.83',true).
concept_accession('40930: rn:R01009','EC','2.4.1.83',true).
concept_accession('40930: rn:R01009','KEGG','296394',true).
concept_accession('40930: rn:R01009','KEGG','EC:2.4.1.83',true).
concept_accession('1872: rn:R00336','EC','3.1.7.2',false).
concept_accession('1872: rn:R00336','KEGG','EC:3.1.7.2',true).
concept_accession('1872: rn:R00336','KEGG','RC:RC00078',true).
concept_accession('1872: rn:R00336','KEGG','RC00078',true).
concept_accession('1872: rn:R00336','KEGG','RP05043',true).
concept_accession('1872: rn:R00336','KEGG','RP:RP05043',true).
concept_accession('1872: rn:R00336','KEGG','3.1.7.2',true).
concept_accession('1872: rn:R00336','KEGG','R00336',true).
concept_accession('1872: rn:R00336','KEGG','RN:R00336',true).
concept_accession('40931: rn:R05961','EC','3.2.1.22',true).
concept_accession('40931: rn:R05961','KEGG','3.2.1.22',true).
concept_accession('40931: rn:R05961','KEGG','EC:3.2.1.22',true).
concept_accession('40931: rn:R05961','KEGG','363494',true).
concept_accession('40931: rn:R05961','KEGG','RNO:363494',true).
concept_accession('40932: rn:R01512','KEGG','EC:2.7.2.3',true).
concept_accession('40932: rn:R01512','KEGG','RNO:499525',true).
concept_accession('40932: rn:R01512','KEGG','RNO:316265',true).
concept_accession('40932: rn:R01512','KEGG','2.7.2.3',true).
concept_accession('40932: rn:R01512','EC','2.7.2.3',true).
concept_accession('40932: rn:R01512','KEGG','24644',true).
concept_accession('40932: rn:R01512','KEGG','499525',true).
concept_accession('40932: rn:R01512','KEGG','RNO:24644',true).
concept_accession('40932: rn:R01512','KEGG','316265',true).
concept_accession('40933: rn:R05969','KEGG','RNO:300668',true).
concept_accession('40933: rn:R05969','EC','2.7.8.15',true).
concept_accession('40933: rn:R05969','KEGG','2.7.8.15',true).
concept_accession('40933: rn:R05969','KEGG','EC:2.7.8.15',true).
concept_accession('40933: rn:R05969','KEGG','300668',true).
concept_accession('40934: rn:R00703','KEGG','EC:1.1.1.27',true).
concept_accession('40934: rn:R00703','KEGG','RNO:369018',true).
concept_accession('40934: rn:R00703','EC','1.1.1.27',true).
concept_accession('40934: rn:R00703','KEGG','369018',true).
concept_accession('40934: rn:R00703','KEGG','RNO:24533',true).
concept_accession('40934: rn:R00703','KEGG','RNO:29634',true).
concept_accession('40934: rn:R00703','KEGG','RNO:24534',true).
concept_accession('40934: rn:R00703','KEGG','24534',true).
concept_accession('40934: rn:R00703','KEGG','24533',true).
concept_accession('40934: rn:R00703','KEGG','29634',true).
concept_accession('40934: rn:R00703','KEGG','RNO:500965',true).
concept_accession('40934: rn:R00703','KEGG','1.1.1.27',true).
concept_accession('40934: rn:R00703','KEGG','500965',true).
concept_accession('40935: rn:R02569','KEGG','EC:2.3.1.12',true).
concept_accession('40935: rn:R02569','KEGG','2.3.1.12',true).
concept_accession('40935: rn:R02569','KEGG','RNO:81654',true).
concept_accession('40935: rn:R02569','KEGG','81654',true).
concept_accession('40935: rn:R02569','EC','2.3.1.12',true).
concept_accession('40953: rn:R05989','KEGG','RNO:313536',true).
concept_accession('40953: rn:R05989','KEGG','494342',true).
concept_accession('40953: rn:R05989','EC','2.4.1.38',true).
concept_accession('40953: rn:R05989','KEGG','RNO:494342',true).
concept_accession('40953: rn:R05989','KEGG','24390',true).
concept_accession('40953: rn:R05989','KEGG','EC:2.4.1.38',true).
concept_accession('40953: rn:R05989','KEGG','313536',true).
concept_accession('40953: rn:R05989','KEGG','RNO:24390',true).
concept_accession('40953: rn:R05989','KEGG','2.4.1.38',true).
concept_accession('1867: rn:R00131','EC','3.5.1.5',false).
concept_accession('1867: rn:R00131','KEGG','R00131',true).
concept_accession('1867: rn:R00131','KEGG','EC:3.5.1.5',true).
concept_accession('1867: rn:R00131','KEGG','RN:R00131',true).
concept_accession('1867: rn:R00131','KEGG','3.5.1.5',true).
concept_accession('40952: rn:R05988','KEGG','RNO:432392',true).
concept_accession('40952: rn:R05988','KEGG','2.4.1.68',true).
concept_accession('40952: rn:R05988','EC','2.4.1.68',true).
concept_accession('40952: rn:R05988','KEGG','432392',true).
concept_accession('40952: rn:R05988','KEGG','EC:2.4.1.68',true).
concept_accession('9512: rn:R09094','KEGG','R09094',true).
concept_accession('9512: rn:R09094','KEGG','RN:R09094',true).
concept_accession('1864: rn:R02425','KEGG','RC:RC00680',true).
concept_accession('1864: rn:R02425','KEGG','RP02201',true).
concept_accession('1864: rn:R02425','EC','3.5.2.5',false).
concept_accession('1864: rn:R02425','KEGG','R02425',true).
concept_accession('1864: rn:R02425','KEGG','EC:3.5.2.5',true).
concept_accession('1864: rn:R02425','KEGG','3.5.2.5',true).
concept_accession('1864: rn:R02425','KEGG','RC00680',true).
concept_accession('1864: rn:R02425','KEGG','RP:RP02201',true).
concept_accession('1864: rn:R02425','KEGG','RN:R02425',true).
concept_accession('40955: rn:R05986','KEGG','2.4.1.144',true).
concept_accession('40955: rn:R05986','KEGG','RNO:29582',true).
concept_accession('40955: rn:R05986','EC','2.4.1.144',true).
concept_accession('40955: rn:R05986','KEGG','29582',true).
concept_accession('40955: rn:R05986','KEGG','EC:2.4.1.144',true).
concept_accession('40954: rn:R05992','KEGG','RNO:299756',true).
concept_accession('40954: rn:R05992','KEGG','EC:2.4.1.201',true).
concept_accession('40954: rn:R05992','KEGG','2.4.1.201',true).
concept_accession('40954: rn:R05992','EC','2.4.1.201',true).
concept_accession('40954: rn:R05992','KEGG','299756',true).
concept_accession('1870: rn:R00469','EC','3.5.3.19',false).
concept_accession('1870: rn:R00469','KEGG','EC:3.5.3.19',true).
concept_accession('1870: rn:R00469','KEGG','R00469',true).
concept_accession('1870: rn:R00469','KEGG','RN:R00469',true).
concept_accession('1870: rn:R00469','KEGG','3.5.3.19',true).
concept_accession('40957: rn:R00235','KEGG','311569',true).
concept_accession('40957: rn:R00235','KEGG','RNO:296259',true).
concept_accession('40957: rn:R00235','KEGG','296259',true).
concept_accession('40957: rn:R00235','KEGG','EC:6.2.1.1',true).
concept_accession('40957: rn:R00235','KEGG','RNO:311569',true).
concept_accession('40957: rn:R00235','EC','6.2.1.1',true).
concept_accession('40957: rn:R00235','KEGG','6.2.1.1',true).
concept_accession('40956: rn:R05990','KEGG','RNO:301155',true).
concept_accession('40956: rn:R05990','KEGG','RNO:25197',true).
concept_accession('40956: rn:R05990','EC','2.4.99.1',true).
concept_accession('40956: rn:R05990','KEGG','2.4.99.1',true).
concept_accession('40956: rn:R05990','KEGG','25197',true).
concept_accession('40956: rn:R05990','KEGG','301155',true).
concept_accession('40956: rn:R05990','KEGG','EC:2.4.99.1',true).
concept_accession('40959: rn:R04770','KEGG','4.4.1.11',true).
concept_accession('40959: rn:R04770','KEGG','24962',true).
concept_accession('40959: rn:R04770','KEGG','EC:4.4.1.11',true).
concept_accession('40959: rn:R04770','EC','4.4.1.11',true).
concept_accession('40959: rn:R04770','KEGG','RNO:24962',true).
concept_accession('1869: rn:R01618','KEGG','RN:R01618',true).
concept_accession('1869: rn:R01618','KEGG','EC:2.7.7.53',true).
concept_accession('1869: rn:R01618','KEGG','R01618',true).
concept_accession('1869: rn:R01618','EC','2.7.7.53',false).
concept_accession('1869: rn:R01618','KEGG','2.7.7.53',true).
concept_accession('40958: rn:R09085','KEGG','2.7.1.147',true).
concept_accession('40958: rn:R09085','KEGG','RNO:315722',true).
concept_accession('40958: rn:R09085','EC','2.7.1.147',true).
concept_accession('40958: rn:R09085','KEGG','EC:2.7.1.147',true).
concept_accession('40958: rn:R09085','KEGG','315722',true).
concept_accession('40945: rn:R02740','KEGG','5.3.1.9',true).
concept_accession('40945: rn:R02740','EC','5.3.1.9',true).
concept_accession('40945: rn:R02740','KEGG','292804',true).
concept_accession('40945: rn:R02740','KEGG','EC:5.3.1.9',true).
concept_accession('40945: rn:R02740','KEGG','RNO:292804',true).
concept_accession('40944: rn:R00959','KEGG','RNO:24645',true).
concept_accession('40944: rn:R00959','KEGG','EC:5.4.2.2',true).
concept_accession('40944: rn:R00959','KEGG','24645',true).
concept_accession('40944: rn:R00959','KEGG','5.4.2.2',true).
concept_accession('40944: rn:R00959','EC','5.4.2.2',true).
concept_accession('40947: rn:R00431 rn:R00726','EC','4.1.1.32',true).
concept_accession('40947: rn:R00431 rn:R00726','KEGG','RNO:361042',true).
concept_accession('40947: rn:R00431 rn:R00726','KEGG','RNO:362282',true).
concept_accession('40947: rn:R00431 rn:R00726','KEGG','361042',true).
concept_accession('40947: rn:R00431 rn:R00726','KEGG','362282',true).
concept_accession('40947: rn:R00431 rn:R00726','KEGG','EC:4.1.1.32',true).
concept_accession('40947: rn:R00431 rn:R00726','KEGG','4.1.1.32',true).
concept_accession('40946: rn:R04780','KEGG','114508',true).
concept_accession('40946: rn:R04780','KEGG','3.1.3.11',true).
concept_accession('40946: rn:R04780','KEGG','24362',true).
concept_accession('40946: rn:R04780','KEGG','RNO:24362',true).
concept_accession('40946: rn:R04780','KEGG','EC:3.1.3.11',true).
concept_accession('40946: rn:R04780','EC','3.1.3.11',true).
concept_accession('40946: rn:R04780','KEGG','RNO:114508',true).
concept_accession('1862: rn:R00776','KEGG','4.3.2.3',true).
concept_accession('1862: rn:R00776','KEGG','RP:RP00410',true).
concept_accession('1862: rn:R00776','KEGG','EC:4.3.2.3',true).
concept_accession('1862: rn:R00776','KEGG','RC00379',true).
concept_accession('1862: rn:R00776','KEGG','RP01099',true).
concept_accession('1862: rn:R00776','KEGG','R00776',true).
concept_accession('1862: rn:R00776','EC','4.3.2.3',false).
concept_accession('1862: rn:R00776','KEGG','RC00153',true).
concept_accession('1862: rn:R00776','KEGG','RP:RP01099',true).
concept_accession('1862: rn:R00776','KEGG','RN:R00776',true).
concept_accession('1862: rn:R00776','KEGG','RC:RC00379',true).
concept_accession('1862: rn:R00776','KEGG','RP00410',true).
concept_accession('1862: rn:R00776','KEGG','RC:RC00153',true).
concept_accession('40949: rn:R01004','KEGG','296624',true).
concept_accession('40949: rn:R01004','EC','3.6.1.43',true).
concept_accession('40949: rn:R01004','KEGG','3.6.1.43',true).
concept_accession('40949: rn:R01004','KEGG','EC:3.6.1.43',true).
concept_accession('40949: rn:R01004','KEGG','RNO:296624',true).
concept_accession('40948: rn:R05991','KEGG','303693',true).
concept_accession('40948: rn:R05991','KEGG','RNO:65271',true).
concept_accession('40948: rn:R05991','EC','2.4.1.155',true).
concept_accession('40948: rn:R05991','KEGG','EC:2.4.1.155',true).
concept_accession('40948: rn:R05991','KEGG','RNO:303693',true).
concept_accession('40948: rn:R05991','KEGG','65271',true).
concept_accession('40948: rn:R05991','KEGG','2.4.1.155',true).
concept_accession('40951: rn:R06153','KEGG','RNO:64445',true).
concept_accession('40951: rn:R06153','KEGG','EC:2.4.99.6',true).
concept_accession('40951: rn:R06153','KEGG','2.4.99.6',true).
concept_accession('40951: rn:R06153','EC','2.4.99.6',true).
concept_accession('40951: rn:R06153','KEGG','64445',true).
concept_accession('40950: rn:R06153','KEGG','EC:2.4.99.6',true).
concept_accession('40950: rn:R06153','KEGG','RNO:363040',true).
concept_accession('40950: rn:R06153','KEGG','2.4.99.6',true).
concept_accession('40950: rn:R06153','KEGG','363040',true).
concept_accession('40950: rn:R06153','EC','2.4.99.6',true).
concept_accession('40846: rn:R02108','KEGG','RNO:24203',true).
concept_accession('40846: rn:R02108','KEGG','24203',true).
concept_accession('40846: rn:R02108','KEGG','3.2.1.1',true).
concept_accession('40846: rn:R02108','KEGG','EC:3.2.1.1',true).
concept_accession('40846: rn:R02108','KEGG','497039',true).
concept_accession('40846: rn:R02108','KEGG','RNO:497039',true).
concept_accession('40846: rn:R02108','EC','3.2.1.1',true).
concept_accession('40847: rn:R06230','KEGG','84597',true).
concept_accession('40847: rn:R06230','KEGG','2.4.1.65',true).
concept_accession('40847: rn:R06230','EC','2.4.1.65',true).
concept_accession('40847: rn:R06230','KEGG','RNO:84597',true).
concept_accession('40847: rn:R06230','KEGG','EC:2.4.1.65',true).
concept_accession('40844: rn:R05196','KEGG','EC:2.4.1.25',true).
concept_accession('40844: rn:R05196','KEGG','362029',true).
concept_accession('40844: rn:R05196','EC','2.4.1.25',true).
concept_accession('40844: rn:R05196','KEGG','RNO:362029',true).
concept_accession('40844: rn:R05196','KEGG','2.4.1.25',true).
concept_accession('40845: rn:R05974','EC','2.4.1.-',true).
concept_accession('40845: rn:R05974','KEGG','2.4.1.-',true).
concept_accession('40845: rn:R05974','KEGG','EC:2.4.1.-',true).
concept_accession('40845: rn:R05974','KEGG','RNO:290638',true).
concept_accession('40845: rn:R05974','KEGG','290638',true).
concept_accession('40842: rn:R06222','KEGG','84597',true).
concept_accession('40842: rn:R06222','KEGG','2.4.1.152',true).
concept_accession('40842: rn:R06222','KEGG','RNO:84597',true).
concept_accession('40842: rn:R06222','KEGG','EC:2.4.1.152',true).
concept_accession('40842: rn:R06222','EC','2.4.1.152',true).
concept_accession('40843: rn:R02111','KEGG','24701',true).
concept_accession('40843: rn:R02111','KEGG','RNO:24701',true).
concept_accession('40843: rn:R02111','EC','2.4.1.1',true).
concept_accession('40843: rn:R02111','KEGG','RNO:25739',true).
concept_accession('40843: rn:R02111','KEGG','25739',true).
concept_accession('40843: rn:R02111','KEGG','RNO:64035',true).
concept_accession('40843: rn:R02111','KEGG','64035',true).
concept_accession('40843: rn:R02111','KEGG','EC:2.4.1.1',true).
concept_accession('40843: rn:R02111','KEGG','2.4.1.1',true).
concept_accession('40840: rn:R06221','EC','2.4.1.-',true).
concept_accession('40840: rn:R06221','KEGG','2.4.1.-',true).
concept_accession('40840: rn:R06221','KEGG','RNO:60670',true).
concept_accession('40840: rn:R06221','KEGG','EC:2.4.1.-',true).
concept_accession('40840: rn:R06221','KEGG','60670',true).
concept_accession('40841: rn:R06224','KEGG','84597',true).
concept_accession('40841: rn:R06224','KEGG','2.4.1.152',true).
concept_accession('40841: rn:R06224','KEGG','RNO:84597',true).
concept_accession('40841: rn:R06224','KEGG','EC:2.4.1.152',true).
concept_accession('40841: rn:R06224','EC','2.4.1.152',true).
concept_accession('40838: rn:R01786','KEGG','RNO:100364027',true).
concept_accession('40838: rn:R01786','KEGG','25058',true).
concept_accession('40838: rn:R01786','KEGG','25059',true).
concept_accession('40838: rn:R01786','KEGG','RNO:25058',true).
concept_accession('40838: rn:R01786','KEGG','25060',true).
concept_accession('40838: rn:R01786','KEGG','RNO:25059',true).
concept_accession('40838: rn:R01786','EC','2.7.1.1',true).
concept_accession('40838: rn:R01786','KEGG','100364027',true).
concept_accession('40838: rn:R01786','KEGG','RNO:25060',true).
concept_accession('40838: rn:R01786','KEGG','EC:2.7.1.1',true).
concept_accession('40838: rn:R01786','KEGG','2.7.1.1',true).
concept_accession('40839: rn:R06227','KEGG','84597',true).
concept_accession('40839: rn:R06227','KEGG','2.4.1.65',true).
concept_accession('40839: rn:R06227','EC','2.4.1.65',true).
concept_accession('40839: rn:R06227','KEGG','RNO:84597',true).
concept_accession('40839: rn:R06227','KEGG','EC:2.4.1.65',true).
concept_accession('40836: rn:R01786','KEGG','RNO:24385',true).
concept_accession('40836: rn:R01786','EC','2.7.1.1',true).
concept_accession('40836: rn:R01786','KEGG','24385',true).
concept_accession('40836: rn:R01786','KEGG','EC:2.7.1.1',true).
concept_accession('40836: rn:R01786','KEGG','2.7.1.1',true).
concept_accession('40837: rn:R05977','KEGG','494342',true).
concept_accession('40837: rn:R05977','EC','2.4.1.-',true).
concept_accession('40837: rn:R05977','KEGG','2.4.1.-',true).
concept_accession('40837: rn:R05977','KEGG','EC:2.4.1.-',true).
concept_accession('40837: rn:R05977','KEGG','RNO:494342',true).
concept_accession('40834: rn:R05975','KEGG','RNO:288752',true).
concept_accession('40834: rn:R05975','EC','2.4.1.-',true).
concept_accession('40834: rn:R05975','KEGG','2.4.1.-',true).
concept_accession('40834: rn:R05975','KEGG','288752',true).
concept_accession('40834: rn:R05975','KEGG','EC:2.4.1.-',true).
concept_accession('40834: rn:R05975','KEGG','RNO:290638',true).
concept_accession('40834: rn:R05975','KEGG','290638',true).
concept_accession('40835: rn:R05977','KEGG','RNO:313536',true).
concept_accession('40835: rn:R05977','EC','2.4.1.-',true).
concept_accession('40835: rn:R05977','KEGG','2.4.1.-',true).
concept_accession('40835: rn:R05977','KEGG','EC:2.4.1.-',true).
concept_accession('40835: rn:R05977','KEGG','313536',true).
concept_accession('40832: rn:R06039','EC','2.4.1.-',true).
concept_accession('40832: rn:R06039','KEGG','2.4.1.-',true).
concept_accession('40832: rn:R06039','KEGG','RNO:60670',true).
concept_accession('40832: rn:R06039','KEGG','EC:2.4.1.-',true).
concept_accession('40832: rn:R06039','KEGG','60670',true).
concept_accession('40833: rn:R01788','KEGG','RNO:25634',true).
concept_accession('40833: rn:R01788','KEGG','25634',true).
concept_accession('40833: rn:R01788','KEGG','EC:3.1.3.9',true).
concept_accession('40833: rn:R01788','KEGG','3.1.3.9',true).
concept_accession('40833: rn:R01788','EC','3.1.3.9',true).
concept_accession('40863: rn:R06024','EC','2.4.1.69',true).
concept_accession('40863: rn:R06024','KEGG','RNO:58924',true).
concept_accession('40863: rn:R06024','KEGG','81919',true).
concept_accession('40863: rn:R06024','KEGG','58924',true).
concept_accession('40863: rn:R06024','KEGG','EC:2.4.1.69',true).
concept_accession('40863: rn:R06024','KEGG','308586',true).
concept_accession('40863: rn:R06024','KEGG','RNO:81919',true).
concept_accession('40863: rn:R06024','KEGG','RNO:308586',true).
concept_accession('40863: rn:R06024','KEGG','2.4.1.69',true).
concept_accession('40862: rn:R06258','KEGG','2.4.1.258',true).
concept_accession('40862: rn:R06258','KEGG','RNO:287983',true).
concept_accession('40862: rn:R06258','KEGG','EC:2.4.1.258',true).
concept_accession('40862: rn:R06258','KEGG','287983',true).
concept_accession('40862: rn:R06258','EC','2.4.1.258',true).
concept_accession('1838: rn:R01244','KEGG','RC00477',true).
concept_accession('1838: rn:R01244','KEGG','RP01384',true).
concept_accession('1838: rn:R01244','KEGG','EC:3.5.4.2',true).
concept_accession('1838: rn:R01244','KEGG','3.5.4.2',true).
concept_accession('1838: rn:R01244','KEGG','RP:RP01384',true).
concept_accession('1838: rn:R01244','KEGG','R01244',true).
concept_accession('1838: rn:R01244','KEGG','RC:RC00477',true).
concept_accession('1838: rn:R01244','EC','3.5.4.2',false).
concept_accession('1838: rn:R01244','KEGG','RN:R01244',true).
concept_accession('40861: rn:R06027','EC','2.4.1.69',true).
concept_accession('40861: rn:R06027','KEGG','RNO:58924',true).
concept_accession('40861: rn:R06027','KEGG','81919',true).
concept_accession('40861: rn:R06027','KEGG','58924',true).
concept_accession('40861: rn:R06027','KEGG','EC:2.4.1.69',true).
concept_accession('40861: rn:R06027','KEGG','308586',true).
concept_accession('40861: rn:R06027','KEGG','RNO:81919',true).
concept_accession('40861: rn:R06027','KEGG','RNO:308586',true).
concept_accession('40861: rn:R06027','KEGG','2.4.1.69',true).
concept_accession('40860: rn:R06167','KEGG','2.4.1.40',true).
concept_accession('40860: rn:R06167','KEGG','EC:2.4.1.40',true).
concept_accession('40860: rn:R06167','KEGG','RNO:65270',true).
concept_accession('40860: rn:R06167','KEGG','100301568',true).
concept_accession('40860: rn:R06167','KEGG','RNO:100301568',true).
concept_accession('40860: rn:R06167','KEGG','RNO:296504',true).
concept_accession('40860: rn:R06167','KEGG','296504',true).
concept_accession('40860: rn:R06167','KEGG','65270',true).
concept_accession('40860: rn:R06167','EC','2.4.1.40',true).
concept_accession('40859: rn:R01009','KEGG','2.4.1.83',true).
concept_accession('40859: rn:R01009','EC','2.4.1.83',true).
concept_accession('40859: rn:R01009','KEGG','RNO:502017',true).
concept_accession('40859: rn:R01009','KEGG','502017',true).
concept_accession('40859: rn:R01009','KEGG','EC:2.4.1.83',true).
concept_accession('40858: rn:R05970','KEGG','EC:2.4.1.141',true).
concept_accession('40858: rn:R05970','KEGG','RNO:362031',true).
concept_accession('40858: rn:R05970','KEGG','362031',true).
concept_accession('40858: rn:R05970','KEGG','2.4.1.141',true).
concept_accession('40858: rn:R05970','EC','2.4.1.141',true).
concept_accession('40857: rn:R06156','EC','2.4.1.69',true).
concept_accession('40857: rn:R06156','KEGG','RNO:58924',true).
concept_accession('40857: rn:R06156','KEGG','81919',true).
concept_accession('40857: rn:R06156','KEGG','58924',true).
concept_accession('40857: rn:R06156','KEGG','EC:2.4.1.69',true).
concept_accession('40857: rn:R06156','KEGG','308586',true).
concept_accession('40857: rn:R06156','KEGG','RNO:81919',true).
concept_accession('40857: rn:R06156','KEGG','RNO:308586',true).
concept_accession('40857: rn:R06156','KEGG','2.4.1.69',true).
concept_accession('40856: rn:R06006','KEGG','288161',true).
concept_accession('40856: rn:R06006','EC','2.4.1.-',true).
concept_accession('40856: rn:R06006','KEGG','2.4.1.-',true).
concept_accession('40856: rn:R06006','KEGG','RNO:288161',true).
concept_accession('40856: rn:R06006','KEGG','EC:2.4.1.-',true).
concept_accession('13428: rn:R08317','KEGG','RC:RC00490',true).
concept_accession('13428: rn:R08317','KEGG','RN:R08317',true).
concept_accession('13428: rn:R08317','KEGG','RC00490',true).
concept_accession('13428: rn:R08317','KEGG','RP:RP13101',true).
concept_accession('13428: rn:R08317','KEGG','RP13101',true).
concept_accession('13428: rn:R08317','KEGG','R08317',true).
concept_accession('40855: rn:R06006','EC','2.4.1.-',true).
concept_accession('40855: rn:R06006','KEGG','2.4.1.-',true).
concept_accession('40855: rn:R06006','KEGG','EC:2.4.1.-',true).
concept_accession('40855: rn:R06006','KEGG','RNO:686081',true).
concept_accession('40855: rn:R06006','KEGG','686081',true).
concept_accession('40854: rn:R06006','KEGG','366064',true).
concept_accession('40854: rn:R06006','EC','2.4.1.-',true).
concept_accession('40854: rn:R06006','KEGG','2.4.1.-',true).
concept_accession('40854: rn:R06006','KEGG','RNO:366064',true).
concept_accession('40854: rn:R06006','KEGG','EC:2.4.1.-',true).
concept_accession('40853: rn:R06168','EC','2.4.1.37',true).
concept_accession('40853: rn:R06168','KEGG','RNO:65270',true).
concept_accession('40853: rn:R06168','KEGG','100301568',true).
concept_accession('40853: rn:R06168','KEGG','RNO:100301568',true).
concept_accession('40853: rn:R06168','KEGG','2.4.1.37',true).
concept_accession('40853: rn:R06168','KEGG','RNO:296504',true).
concept_accession('40853: rn:R06168','KEGG','296504',true).
concept_accession('40853: rn:R06168','KEGG','65270',true).
concept_accession('40853: rn:R06168','KEGG','EC:2.4.1.37',true).
concept_accession('40852: rn:R06169','KEGG','246766',true).
concept_accession('40852: rn:R06169','KEGG','EC:2.4.1.87',true).
concept_accession('40852: rn:R06169','KEGG','2.4.1.87',true).
concept_accession('40852: rn:R06169','KEGG','RNO:246766',true).
concept_accession('40852: rn:R06169','EC','2.4.1.87',true).
concept_accession('40851: rn:R06170','EC','2.4.1.69',true).
concept_accession('40851: rn:R06170','KEGG','RNO:58924',true).
concept_accession('40851: rn:R06170','KEGG','81919',true).
concept_accession('40851: rn:R06170','KEGG','58924',true).
concept_accession('40851: rn:R06170','KEGG','EC:2.4.1.69',true).
concept_accession('40851: rn:R06170','KEGG','308586',true).
concept_accession('40851: rn:R06170','KEGG','RNO:81919',true).
concept_accession('40851: rn:R06170','KEGG','RNO:308586',true).
concept_accession('40851: rn:R06170','KEGG','2.4.1.69',true).
concept_accession('40850: rn:R00028','KEGG','EC:3.2.1.20',true).
concept_accession('40850: rn:R00028','EC','3.2.1.20',true).
concept_accession('40850: rn:R00028','KEGG','312272',true).
concept_accession('40850: rn:R00028','KEGG','3.2.1.20',true).
concept_accession('40850: rn:R00028','KEGG','367562',true).
concept_accession('40850: rn:R00028','KEGG','RNO:24382',true).
concept_accession('40850: rn:R00028','KEGG','24382',true).
concept_accession('40850: rn:R00028','KEGG','RNO:312272',true).
concept_accession('40850: rn:R00028','KEGG','RNO:367562',true).
concept_accession('40849: rn:R08969','EC','2.7.8.27',true).
concept_accession('40849: rn:R08969','KEGG','310849',true).
concept_accession('40849: rn:R08969','KEGG','RNO:353229',true).
concept_accession('40849: rn:R08969','KEGG','RNO:310849',true).
concept_accession('40849: rn:R08969','KEGG','2.7.8.27',true).
concept_accession('40849: rn:R08969','KEGG','353229',true).
concept_accession('40849: rn:R08969','KEGG','EC:2.7.8.27',true).
concept_accession('40848: rn:R01790','KEGG','312272',true).
concept_accession('40848: rn:R01790','KEGG','EC:3.2.1.3',true).
concept_accession('40848: rn:R01790','EC','3.2.1.3',true).
concept_accession('40848: rn:R01790','KEGG','3.2.1.3',true).
concept_accession('40848: rn:R01790','KEGG','RNO:312272',true).
concept_accession('40876: rn:R06187','KEGG','2.4.1.40',true).
concept_accession('40876: rn:R06187','KEGG','EC:2.4.1.40',true).
concept_accession('40876: rn:R06187','KEGG','RNO:65270',true).
concept_accession('40876: rn:R06187','KEGG','100301568',true).
concept_accession('40876: rn:R06187','KEGG','RNO:100301568',true).
concept_accession('40876: rn:R06187','KEGG','RNO:296504',true).
concept_accession('40876: rn:R06187','KEGG','296504',true).
concept_accession('40876: rn:R06187','KEGG','65270',true).
concept_accession('40876: rn:R06187','EC','2.4.1.40',true).
concept_accession('9598: rn:R00024','KEGG','EC:4.1.1.39',true).
concept_accession('9598: rn:R00024','KEGG','RC:RC00172',true).
concept_accession('9598: rn:R00024','KEGG','RN:R00024',true).
concept_accession('9598: rn:R00024','KEGG','RP00477',true).
concept_accession('9598: rn:R00024','KEGG','4.1.1.39',true).
concept_accession('9598: rn:R00024','EC','4.1.1.39',false).
concept_accession('9598: rn:R00024','KEGG','RP:RP00477',true).
concept_accession('9598: rn:R00024','KEGG','R00024',true).
concept_accession('9598: rn:R00024','KEGG','RC00172',true).
concept_accession('40877: rn:R05977','EC','2.4.1.-',true).
concept_accession('40877: rn:R05977','KEGG','2.4.1.-',true).
concept_accession('40877: rn:R05977','KEGG','EC:2.4.1.-',true).
concept_accession('40877: rn:R05977','KEGG','24390',true).
concept_accession('40877: rn:R05977','KEGG','RNO:24390',true).
concept_accession('40878: rn:R06197','KEGG','2.4.1.40',true).
concept_accession('40878: rn:R06197','KEGG','EC:2.4.1.40',true).
concept_accession('40878: rn:R06197','KEGG','RNO:65270',true).
concept_accession('40878: rn:R06197','KEGG','100301568',true).
concept_accession('40878: rn:R06197','KEGG','RNO:100301568',true).
concept_accession('40878: rn:R06197','KEGG','RNO:296504',true).
concept_accession('40878: rn:R06197','KEGG','296504',true).
concept_accession('40878: rn:R06197','KEGG','65270',true).
concept_accession('40878: rn:R06197','EC','2.4.1.40',true).
concept_accession('40879: rn:R06193','KEGG','2.4.1.40',true).
concept_accession('40879: rn:R06193','KEGG','EC:2.4.1.40',true).
concept_accession('40879: rn:R06193','KEGG','RNO:65270',true).
concept_accession('40879: rn:R06193','KEGG','100301568',true).
concept_accession('40879: rn:R06193','KEGG','RNO:100301568',true).
concept_accession('40879: rn:R06193','KEGG','RNO:296504',true).
concept_accession('40879: rn:R06193','KEGG','296504',true).
concept_accession('40879: rn:R06193','KEGG','65270',true).
concept_accession('40879: rn:R06193','EC','2.4.1.40',true).
concept_accession('40872: rn:R05978','KEGG','246766',true).
concept_accession('40872: rn:R05978','KEGG','EC:2.4.1.87',true).
concept_accession('40872: rn:R05978','KEGG','2.4.1.87',true).
concept_accession('40872: rn:R05978','KEGG','RNO:246766',true).
concept_accession('40872: rn:R05978','EC','2.4.1.87',true).
concept_accession('40873: rn:R01009','KEGG','29640',true).
concept_accession('40873: rn:R01009','KEGG','2.4.1.83',true).
concept_accession('40873: rn:R01009','EC','2.4.1.83',true).
concept_accession('40873: rn:R01009','KEGG','RNO:29640',true).
concept_accession('40873: rn:R01009','KEGG','EC:2.4.1.83',true).
concept_accession('40874: rn:R06031','EC','2.4.1.69',true).
concept_accession('40874: rn:R06031','KEGG','RNO:58924',true).
concept_accession('40874: rn:R06031','KEGG','81919',true).
concept_accession('40874: rn:R06031','KEGG','58924',true).
concept_accession('40874: rn:R06031','KEGG','EC:2.4.1.69',true).
concept_accession('40874: rn:R06031','KEGG','308586',true).
concept_accession('40874: rn:R06031','KEGG','RNO:81919',true).
concept_accession('40874: rn:R06031','KEGG','RNO:308586',true).
concept_accession('40874: rn:R06031','KEGG','2.4.1.69',true).
concept_accession('40875: rn:R06035','EC','2.4.1.69',true).
concept_accession('40875: rn:R06035','KEGG','RNO:58924',true).
concept_accession('40875: rn:R06035','KEGG','81919',true).
concept_accession('40875: rn:R06035','KEGG','58924',true).
concept_accession('40875: rn:R06035','KEGG','EC:2.4.1.69',true).
concept_accession('40875: rn:R06035','KEGG','308586',true).
concept_accession('40875: rn:R06035','KEGG','RNO:81919',true).
concept_accession('40875: rn:R06035','KEGG','RNO:308586',true).
concept_accession('40875: rn:R06035','KEGG','2.4.1.69',true).
concept_accession('40868: rn:R06262','EC','2.4.1.-',true).
concept_accession('40868: rn:R06262','KEGG','RNO:362547',true).
concept_accession('40868: rn:R06262','KEGG','2.4.1.-',true).
concept_accession('40868: rn:R06262','KEGG','EC:2.4.1.-',true).
concept_accession('40868: rn:R06262','KEGG','362547',true).
concept_accession('40869: rn:R06033','EC','2.4.1.-',true).
concept_accession('40869: rn:R06033','KEGG','2.4.1.-',true).
concept_accession('40869: rn:R06033','KEGG','EC:2.4.1.-',true).
concept_accession('40869: rn:R06033','KEGG','24390',true).
concept_accession('40869: rn:R06033','KEGG','RNO:24390',true).
concept_accession('40870: rn:R05975','KEGG','293667',true).
concept_accession('40870: rn:R05975','EC','2.4.1.-',true).
concept_accession('40870: rn:R05975','KEGG','2.4.1.-',true).
concept_accession('40870: rn:R05975','KEGG','RNO:305571',true).
concept_accession('40870: rn:R05975','KEGG','EC:2.4.1.-',true).
concept_accession('40870: rn:R05975','KEGG','305571',true).
concept_accession('40870: rn:R05975','KEGG','RNO:293667',true).
concept_accession('40871: rn:R06029','EC','2.4.1.37',true).
concept_accession('40871: rn:R06029','KEGG','RNO:65270',true).
concept_accession('40871: rn:R06029','KEGG','100301568',true).
concept_accession('40871: rn:R06029','KEGG','RNO:100301568',true).
concept_accession('40871: rn:R06029','KEGG','2.4.1.37',true).
concept_accession('40871: rn:R06029','KEGG','RNO:296504',true).
concept_accession('40871: rn:R06029','KEGG','296504',true).
concept_accession('40871: rn:R06029','KEGG','65270',true).
concept_accession('40871: rn:R06029','KEGG','EC:2.4.1.37',true).
concept_accession('1811: rn:R02014','EC','1.17.4.2',false).
concept_accession('1811: rn:R02014','KEGG','RC00613',true).
concept_accession('1811: rn:R02014','KEGG','RP:RP01910',true).
concept_accession('1811: rn:R02014','KEGG','R02014',true).
concept_accession('1811: rn:R02014','KEGG','RN:R02014',true).
concept_accession('1811: rn:R02014','KEGG','1.17.4.2',true).
concept_accession('1811: rn:R02014','KEGG','RC:RC00613',true).
concept_accession('1811: rn:R02014','KEGG','EC:1.17.4.2',true).
concept_accession('1811: rn:R02014','KEGG','RP01910',true).
concept_accession('40864: rn:R06259','KEGG','2.4.1.259',true).
concept_accession('40864: rn:R06259','KEGG','RNO:367083',true).
concept_accession('40864: rn:R06259','KEGG','EC:2.4.1.259',true).
concept_accession('40864: rn:R06259','KEGG','367083',true).
concept_accession('40864: rn:R06259','EC','2.4.1.259',true).
concept_accession('40865: rn:R06095','KEGG','84597',true).
concept_accession('40865: rn:R06095','KEGG','2.4.1.65',true).
concept_accession('40865: rn:R06095','EC','2.4.1.65',true).
concept_accession('40865: rn:R06095','KEGG','RNO:84597',true).
concept_accession('40865: rn:R06095','KEGG','EC:2.4.1.65',true).
concept_accession('9585: rn:R01829','KEGG','R01829',true).
concept_accession('9585: rn:R01829','KEGG','RC:RC00603',true).
concept_accession('9585: rn:R01829','KEGG','RC:RC00604',true).
concept_accession('9585: rn:R01829','KEGG','RP01789',true).
concept_accession('9585: rn:R01829','KEGG','RP01788',true).
concept_accession('9585: rn:R01829','EC','4.1.2.13',false).
concept_accession('9585: rn:R01829','KEGG','RC00603',true).
concept_accession('9585: rn:R01829','KEGG','RC00604',true).
concept_accession('9585: rn:R01829','KEGG','RN:R01829',true).
concept_accession('9585: rn:R01829','KEGG','EC:4.1.2.13',true).
concept_accession('9585: rn:R01829','KEGG','4.1.2.13',true).
concept_accession('9585: rn:R01829','KEGG','RP:RP01789',true).
concept_accession('9585: rn:R01829','KEGG','RP:RP01788',true).
concept_accession('40866: rn:R06260','KEGG','RNO:315212',true).
concept_accession('40866: rn:R06260','EC','2.4.1.260',true).
concept_accession('40866: rn:R06260','KEGG','315212',true).
concept_accession('40866: rn:R06260','KEGG','2.4.1.260',true).
concept_accession('40866: rn:R06260','KEGG','EC:2.4.1.260',true).
concept_accession('9584: rn:R00214','KEGG','RC:RC00105',true).
concept_accession('9584: rn:R00214','KEGG','RP00287',true).
concept_accession('9584: rn:R00214','KEGG','RN:R00214',true).
concept_accession('9584: rn:R00214','EC','1.1.1.39',false).
concept_accession('9584: rn:R00214','KEGG','EC:1.1.1.39',true).
concept_accession('9584: rn:R00214','KEGG','RP:RP00287',true).
concept_accession('9584: rn:R00214','KEGG','R00214',true).
concept_accession('9584: rn:R00214','KEGG','RC00105',true).
concept_accession('9584: rn:R00214','KEGG','1.1.1.39',true).
concept_accession('40867: rn:R05971','KEGG','116740',true).
concept_accession('40867: rn:R05971','EC','2.4.1.206',true).
concept_accession('40867: rn:R05971','KEGG','311882',true).
concept_accession('40867: rn:R05971','KEGG','RNO:116740',true).
concept_accession('40867: rn:R05971','KEGG','RNO:311882',true).
concept_accession('40867: rn:R05971','KEGG','2.4.1.206',true).
concept_accession('40867: rn:R05971','KEGG','EC:2.4.1.206',true).
concept_accession('40893: rn:R00754','KEGG','24172',true).
concept_accession('40893: rn:R00754','KEGG','RNO:29646',true).
concept_accession('40893: rn:R00754','KEGG','RNO:310903',true).
concept_accession('40893: rn:R00754','KEGG','100145871',true).
concept_accession('40893: rn:R00754','KEGG','EC:1.1.1.1',true).
concept_accession('40893: rn:R00754','KEGG','310903',true).
concept_accession('40893: rn:R00754','KEGG','1.1.1.1',true).
concept_accession('40893: rn:R00754','KEGG','RNO:171178',true).
concept_accession('40893: rn:R00754','EC','1.1.1.1',true).
concept_accession('40893: rn:R00754','KEGG','171178',true).
concept_accession('40893: rn:R00754','KEGG','RNO:100145871',true).
concept_accession('40893: rn:R00754','KEGG','RNO:24172',true).
concept_accession('40893: rn:R00754','KEGG','29646',true).
concept_accession('40892: rn:R06025','KEGG','84597',true).
concept_accession('40892: rn:R06025','KEGG','2.4.1.65',true).
concept_accession('40892: rn:R06025','EC','2.4.1.65',true).
concept_accession('40892: rn:R06025','KEGG','RNO:84597',true).
concept_accession('40892: rn:R06025','KEGG','EC:2.4.1.65',true).
concept_accession('40895: rn:R00014','KEGG','RNO:117098',true).
concept_accession('40895: rn:R00014','EC','1.2.4.1',true).
concept_accession('40895: rn:R00014','KEGG','RNO:289950',true).
concept_accession('40895: rn:R00014','KEGG','1.2.4.1',true).
concept_accession('40895: rn:R00014','KEGG','117098',true).
concept_accession('40895: rn:R00014','KEGG','289950',true).
concept_accession('40895: rn:R00014','KEGG','29554',true).
concept_accession('40895: rn:R00014','KEGG','RNO:29554',true).
concept_accession('40895: rn:R00014','KEGG','EC:1.2.4.1',true).
concept_accession('9581: rn:R00341','KEGG','EC:4.1.1.49',true).
concept_accession('9581: rn:R00341','KEGG','4.1.1.49',true).
concept_accession('9581: rn:R00341','KEGG','R00341',true).
concept_accession('9581: rn:R00341','KEGG','RN:R00341',true).
concept_accession('9581: rn:R00341','EC','4.1.1.49',false).
concept_accession('40894: rn:R06032','KEGG','EC:2.4.99.8',true).
concept_accession('40894: rn:R06032','KEGG','25280',true).
concept_accession('40894: rn:R06032','EC','2.4.99.8',true).
concept_accession('40894: rn:R06032','KEGG','RNO:25280',true).
concept_accession('40894: rn:R06032','KEGG','2.4.99.8',true).
concept_accession('40889: rn:R06039','KEGG','84597',true).
concept_accession('40889: rn:R06039','EC','2.4.1.-',true).
concept_accession('40889: rn:R06039','KEGG','2.4.1.-',true).
concept_accession('40889: rn:R06039','KEGG','EC:2.4.1.-',true).
concept_accession('40889: rn:R06039','KEGG','RNO:84597',true).
concept_accession('40888: rn:R06222','KEGG','2.4.1.152',true).
concept_accession('40888: rn:R06222','KEGG','RNO:60670',true).
concept_accession('40888: rn:R06222','KEGG','EC:2.4.1.152',true).
concept_accession('40888: rn:R06222','KEGG','60670',true).
concept_accession('40888: rn:R06222','EC','2.4.1.152',true).
concept_accession('40891: rn:R00746','EC','1.1.1.2',true).
concept_accession('40891: rn:R00746','KEGG','78959',true).
concept_accession('40891: rn:R00746','KEGG','EC:1.1.1.2',true).
concept_accession('40891: rn:R00746','KEGG','RNO:78959',true).
concept_accession('40891: rn:R00746','KEGG','1.1.1.2',true).
concept_accession('40890: rn:R06026','KEGG','EC:2.4.99.10',true).
concept_accession('40890: rn:R06026','KEGG','RNO:304023',true).
concept_accession('40890: rn:R06026','KEGG','304023',true).
concept_accession('40890: rn:R06026','KEGG','2.4.99.10',true).
concept_accession('40890: rn:R06026','EC','2.4.99.10',true).
concept_accession('9574: rn:R00216','KEGG','RC:RC00105',true).
concept_accession('9574: rn:R00216','KEGG','RP00287',true).
concept_accession('9574: rn:R00216','KEGG','RN:R00216',true).
concept_accession('9574: rn:R00216','KEGG','R00216',true).
concept_accession('9574: rn:R00216','KEGG','RP:RP00287',true).
concept_accession('9574: rn:R00216','KEGG','RC00105',true).
concept_accession('9574: rn:R00216','EC','1.1.1.40',false).
concept_accession('9574: rn:R00216','KEGG','EC:1.1.1.40',true).
concept_accession('9574: rn:R00216','KEGG','1.1.1.40',true).
concept_accession('40885: rn:R00711','KEGG','RNO:25375',true).
concept_accession('40885: rn:R00711','KEGG','25375',true).
concept_accession('40885: rn:R00711','KEGG','RNO:266603',true).
concept_accession('40885: rn:R00711','KEGG','266603',true).
concept_accession('40885: rn:R00711','KEGG','RNO:309147',true).
concept_accession('40885: rn:R00711','KEGG','309147',true).
concept_accession('40885: rn:R00711','KEGG','EC:1.2.1.5',true).
concept_accession('40885: rn:R00711','EC','1.2.1.5',true).
concept_accession('40885: rn:R00711','KEGG','1.2.1.5',true).
concept_accession('40884: rn:R06227','KEGG','2.4.1.65',true).
concept_accession('40884: rn:R06227','KEGG','RNO:60670',true).
concept_accession('40884: rn:R06227','EC','2.4.1.65',true).
concept_accession('40884: rn:R06227','KEGG','60670',true).
concept_accession('40884: rn:R06227','KEGG','EC:2.4.1.65',true).
concept_accession('9572: rn:R00345','EC','4.1.1.31',false).
concept_accession('9572: rn:R00345','KEGG','R00345',true).
concept_accession('9572: rn:R00345','KEGG','RN:R00345',true).
concept_accession('9572: rn:R00345','KEGG','EC:4.1.1.31',true).
concept_accession('9572: rn:R00345','KEGG','4.1.1.31',true).
concept_accession('40887: rn:R06037','KEGG','EC:2.4.99.10',true).
concept_accession('40887: rn:R06037','KEGG','RNO:304023',true).
concept_accession('40887: rn:R06037','KEGG','304023',true).
concept_accession('40887: rn:R06037','KEGG','2.4.99.10',true).
concept_accession('40887: rn:R06037','EC','2.4.99.10',true).
concept_accession('1797: rn:R01053','EC','6.3.4.7',false).
concept_accession('1797: rn:R01053','KEGG','EC:6.3.4.7',true).
concept_accession('1797: rn:R01053','KEGG','RC00431',true).
concept_accession('1797: rn:R01053','KEGG','RC:RC00431',true).
concept_accession('1797: rn:R01053','KEGG','RP:RP01259',true).
concept_accession('1797: rn:R01053','KEGG','RN:R01053',true).
concept_accession('1797: rn:R01053','KEGG','6.3.4.7',true).
concept_accession('1797: rn:R01053','KEGG','R01053',true).
concept_accession('1797: rn:R01053','KEGG','RP01259',true).
concept_accession('40886: rn:R06230','KEGG','2.4.1.65',true).
concept_accession('40886: rn:R06230','KEGG','RNO:60670',true).
concept_accession('40886: rn:R06230','EC','2.4.1.65',true).
concept_accession('40886: rn:R06230','KEGG','60670',true).
concept_accession('40886: rn:R06230','KEGG','EC:2.4.1.65',true).
concept_accession('40881: rn:R06041','EC','2.4.1.69',true).
concept_accession('40881: rn:R06041','KEGG','RNO:58924',true).
concept_accession('40881: rn:R06041','KEGG','81919',true).
concept_accession('40881: rn:R06041','KEGG','58924',true).
concept_accession('40881: rn:R06041','KEGG','EC:2.4.1.69',true).
concept_accession('40881: rn:R06041','KEGG','308586',true).
concept_accession('40881: rn:R06041','KEGG','RNO:81919',true).
concept_accession('40881: rn:R06041','KEGG','RNO:308586',true).
concept_accession('40881: rn:R06041','KEGG','2.4.1.69',true).
concept_accession('40880: rn:R01070','KEGG','24191',true).
concept_accession('40880: rn:R01070','KEGG','24190',true).
concept_accession('40880: rn:R01070','KEGG','RNO:24190',true).
concept_accession('40880: rn:R01070','KEGG','RNO:24191',true).
concept_accession('40880: rn:R01070','KEGG','EC:4.1.2.13',true).
concept_accession('40880: rn:R01070','KEGG','4.1.2.13',true).
concept_accession('40880: rn:R01070','KEGG','RNO:299052',true).
concept_accession('40880: rn:R01070','EC','4.1.2.13',true).
concept_accession('40880: rn:R01070','KEGG','24189',true).
concept_accession('40880: rn:R01070','KEGG','RNO:24189',true).
concept_accession('40880: rn:R01070','KEGG','299052',true).
concept_accession('40883: rn:R06224','KEGG','2.4.1.152',true).
concept_accession('40883: rn:R06224','KEGG','RNO:60670',true).
concept_accession('40883: rn:R06224','KEGG','EC:2.4.1.152',true).
concept_accession('40883: rn:R06224','KEGG','60670',true).
concept_accession('40883: rn:R06224','EC','2.4.1.152',true).
concept_accession('40882: rn:R00710','KEGG','1.2.1.3',true).
concept_accession('40882: rn:R00710','KEGG','RNO:291450',true).
concept_accession('40882: rn:R00710','KEGG','RNO:64040',true).
concept_accession('40882: rn:R00710','EC','1.2.1.3',true).
concept_accession('40882: rn:R00710','KEGG','65183',true).
concept_accession('40882: rn:R00710','KEGG','24188',true).
concept_accession('40882: rn:R00710','KEGG','RNO:29539',true).
concept_accession('40882: rn:R00710','KEGG','64040',true).
concept_accession('40882: rn:R00710','KEGG','RNO:24188',true).
concept_accession('40882: rn:R00710','KEGG','29539',true).
concept_accession('40882: rn:R00710','KEGG','29651',true).
concept_accession('40882: rn:R00710','KEGG','298079',true).
concept_accession('40882: rn:R00710','KEGG','RNO:298079',true).
concept_accession('40882: rn:R00710','KEGG','RNO:65183',true).
concept_accession('40882: rn:R00710','KEGG','RNO:29651',true).
concept_accession('40882: rn:R00710','KEGG','291450',true).
concept_accession('40882: rn:R00710','KEGG','EC:1.2.1.3',true).
concept_accession('40771: rn:R03920','KEGG','RNO:100364027',true).
concept_accession('40771: rn:R03920','KEGG','25058',true).
concept_accession('40771: rn:R03920','KEGG','25059',true).
concept_accession('40771: rn:R03920','KEGG','RNO:25058',true).
concept_accession('40771: rn:R03920','KEGG','25060',true).
concept_accession('40771: rn:R03920','KEGG','EC:2.7.1.4',true).
concept_accession('40771: rn:R03920','KEGG','RNO:25059',true).
concept_accession('40771: rn:R03920','KEGG','100364027',true).
concept_accession('40771: rn:R03920','KEGG','2.7.1.4',true).
concept_accession('40771: rn:R03920','KEGG','RNO:25060',true).
concept_accession('40771: rn:R03920','EC','2.7.1.4',true).
concept_accession('40770: rn:R03354','KEGG','65196',true).
concept_accession('40770: rn:R03354','EC','2.4.1.-',true).
concept_accession('40770: rn:R03354','KEGG','2.4.1.-',true).
concept_accession('40770: rn:R03354','KEGG','RNO:65196',true).
concept_accession('40770: rn:R03354','KEGG','EC:2.4.1.-',true).
concept_accession('40769: rn:R00802','EC','3.2.1.48',true).
concept_accession('40769: rn:R00802','KEGG','EC:3.2.1.48',true).
concept_accession('40769: rn:R00802','KEGG','312272',true).
concept_accession('40769: rn:R00802','KEGG','3.2.1.48',true).
concept_accession('40769: rn:R00802','KEGG','367562',true).
concept_accession('40769: rn:R00802','KEGG','RNO:24382',true).
concept_accession('40769: rn:R00802','KEGG','24382',true).
concept_accession('40769: rn:R00802','KEGG','RNO:312272',true).
concept_accession('40769: rn:R00802','KEGG','RNO:367562',true).
concept_accession('40768: rn:R00802','KEGG','RNO:497756',true).
concept_accession('40768: rn:R00802','EC','3.2.1.48',true).
concept_accession('40768: rn:R00802','KEGG','EC:3.2.1.48',true).
concept_accession('40768: rn:R00802','KEGG','497756',true).
concept_accession('40768: rn:R00802','KEGG','3.2.1.48',true).
concept_accession('40775: rn:R01383','KEGG','396551',true).
concept_accession('40775: rn:R01383','KEGG','2.4.1.17',true).
concept_accession('40775: rn:R01383','KEGG','154516',true).
concept_accession('40775: rn:R01383','KEGG','396552',true).
concept_accession('40775: rn:R01383','KEGG','RNO:305264',true).
concept_accession('40775: rn:R01383','KEGG','289533',true).
concept_accession('40775: rn:R01383','KEGG','RNO:396527',true).
concept_accession('40775: rn:R01383','KEGG','574523',true).
concept_accession('40775: rn:R01383','KEGG','396527',true).
concept_accession('40775: rn:R01383','KEGG','EC:2.4.1.17',true).
concept_accession('40775: rn:R01383','KEGG','113992',true).
concept_accession('40775: rn:R01383','KEGG','RNO:574523',true).
concept_accession('40775: rn:R01383','KEGG','RNO:266685',true).
concept_accession('40775: rn:R01383','KEGG','RNO:24861',true).
concept_accession('40775: rn:R01383','KEGG','266685',true).
concept_accession('40775: rn:R01383','KEGG','RNO:24862',true).
concept_accession('40775: rn:R01383','KEGG','29623',true).
concept_accession('40775: rn:R01383','KEGG','RNO:289533',true).
concept_accession('40775: rn:R01383','KEGG','305264',true).
concept_accession('40775: rn:R01383','KEGG','RNO:83808',true).
concept_accession('40775: rn:R01383','KEGG','RNO:301595',true).
concept_accession('40775: rn:R01383','KEGG','RNO:29623',true).
concept_accession('40775: rn:R01383','KEGG','RNO:154516',true).
concept_accession('40775: rn:R01383','KEGG','301595',true).
concept_accession('40775: rn:R01383','KEGG','RNO:396552',true).
concept_accession('40775: rn:R01383','KEGG','RNO:396551',true).
concept_accession('40775: rn:R01383','KEGG','RNO:286954',true).
concept_accession('40775: rn:R01383','KEGG','RNO:113992',true).
concept_accession('40775: rn:R01383','KEGG','RNO:63867',true).
concept_accession('40775: rn:R01383','KEGG','286954',true).
concept_accession('40775: rn:R01383','KEGG','83808',true).
concept_accession('40775: rn:R01383','KEGG','24861',true).
concept_accession('40775: rn:R01383','KEGG','63867',true).
concept_accession('40775: rn:R01383','EC','2.4.1.17',true).
concept_accession('40775: rn:R01383','KEGG','24862',true).
concept_accession('40774: rn:R03617','KEGG','EC:3.2.1.46',true).
concept_accession('40774: rn:R03617','EC','3.2.1.46',true).
concept_accession('40774: rn:R03617','KEGG','RNO:314360',true).
concept_accession('40774: rn:R03617','KEGG','314360',true).
concept_accession('40774: rn:R03617','KEGG','3.2.1.46',true).
concept_accession('40773: rn:R02887','KEGG','EC:3.1.2.21',true).
concept_accession('40773: rn:R02887','EC','3.1.2.21',true).
concept_accession('40773: rn:R02887','KEGG','RNO:289687',true).
concept_accession('40773: rn:R02887','KEGG','3.1.2.21',true).
concept_accession('40773: rn:R02887','KEGG','289687',true).
concept_accession('40772: rn:R00026','KEGG','EC:3.2.1.21',true).
concept_accession('40772: rn:R00026','KEGG','3.2.1.21',true).
concept_accession('40772: rn:R00026','EC','3.2.1.21',true).
concept_accession('40772: rn:R00026','KEGG','RNO:289687',true).
concept_accession('40772: rn:R00026','KEGG','289687',true).
concept_accession('40779: rn:R01926','KEGG','RNO:170897',true).
concept_accession('40779: rn:R01926','KEGG','EC:2.7.1.91',true).
concept_accession('40779: rn:R01926','EC','2.7.1.91',true).
concept_accession('40779: rn:R01926','KEGG','170897',true).
concept_accession('40779: rn:R01926','KEGG','308589',true).
concept_accession('40779: rn:R01926','KEGG','RNO:308589',true).
concept_accession('40779: rn:R01926','KEGG','2.7.1.91',true).
concept_accession('40778: rn:R04856','KEGG','3.1.6.8',true).
concept_accession('40778: rn:R04856','KEGG','EC:3.1.6.8',true).
concept_accession('40778: rn:R04856','KEGG','RNO:315222',true).
concept_accession('40778: rn:R04856','EC','3.1.6.8',true).
concept_accession('40778: rn:R04856','KEGG','315222',true).
concept_accession('40777: rn:R00289','KEGG','289827',true).
concept_accession('40777: rn:R00289','KEGG','EC:2.7.7.9',true).
concept_accession('40777: rn:R00289','KEGG','2.7.7.9',true).
concept_accession('40777: rn:R00289','KEGG','RNO:289827',true).
concept_accession('40777: rn:R00289','EC','2.7.7.9',true).
concept_accession('40776: rn:R01478','EC','3.2.1.31',true).
concept_accession('40776: rn:R01478','KEGG','24434',true).
concept_accession('40776: rn:R01478','KEGG','EC:3.2.1.31',true).
concept_accession('40776: rn:R01478','KEGG','RNO:83504',true).
concept_accession('40776: rn:R01478','KEGG','3.2.1.31',true).
concept_accession('40776: rn:R01478','KEGG','RNO:24434',true).
concept_accession('40776: rn:R01478','KEGG','83504',true).
concept_accession('40783: rn:R01660','KEGG','2.7.1.106',true).
concept_accession('40783: rn:R01660','KEGG','EC:2.7.1.106',true).
concept_accession('40783: rn:R01660','KEGG','RNO:685076',true).
concept_accession('40783: rn:R01660','EC','2.7.1.106',true).
concept_accession('40783: rn:R01660','KEGG','685076',true).
concept_accession('40782: rn:R06516','KEGG','EC:4.1.2.27',true).
concept_accession('40782: rn:R06516','KEGG','RNO:286896',true).
concept_accession('40782: rn:R06516','KEGG','286896',true).
concept_accession('40782: rn:R06516','KEGG','4.1.2.27',true).
concept_accession('40782: rn:R06516','EC','4.1.2.27',true).
concept_accession('40781: rn:R00286','KEGG','RNO:83472',true).
concept_accession('40781: rn:R00286','KEGG','83472',true).
concept_accession('40781: rn:R00286','EC','1.1.1.22',true).
concept_accession('40781: rn:R00286','KEGG','1.1.1.22',true).
concept_accession('40781: rn:R00286','KEGG','EC:1.1.1.22',true).
concept_accession('40780: rn:R02976','KEGG','RNO:170897',true).
concept_accession('40780: rn:R02976','KEGG','EC:2.7.1.91',true).
concept_accession('40780: rn:R02976','EC','2.7.1.91',true).
concept_accession('40780: rn:R02976','KEGG','170897',true).
concept_accession('40780: rn:R02976','KEGG','308589',true).
concept_accession('40780: rn:R02976','KEGG','RNO:308589',true).
concept_accession('40780: rn:R02976','KEGG','2.7.1.91',true).
concept_accession('40786: rn:R01498','KEGG','RNO:684536',true).
concept_accession('40786: rn:R01498','KEGG','3.2.1.45',true).
concept_accession('40786: rn:R01498','EC','3.2.1.45',true).
concept_accession('40786: rn:R01498','KEGG','EC:3.2.1.45',true).
concept_accession('40786: rn:R01498','KEGG','684536',true).
concept_accession('40787: rn:R01497','EC','2.4.1.80',true).
concept_accession('40787: rn:R01497','KEGG','83626',true).
concept_accession('40787: rn:R01497','KEGG','EC:2.4.1.80',true).
concept_accession('40787: rn:R01497','KEGG','RNO:83626',true).
concept_accession('40787: rn:R01497','KEGG','2.4.1.80',true).
concept_accession('9603: rn:R00345','EC','4.1.1.31',false).
concept_accession('9603: rn:R00345','KEGG','R00345',true).
concept_accession('9603: rn:R00345','KEGG','RN:R00345',true).
concept_accession('9603: rn:R00345','KEGG','EC:4.1.1.31',true).
concept_accession('9603: rn:R00345','KEGG','4.1.1.31',true).
concept_accession('40784: rn:R02464','KEGG','EC:4.1.2.27',true).
concept_accession('40784: rn:R02464','KEGG','RNO:286896',true).
concept_accession('40784: rn:R02464','KEGG','286896',true).
concept_accession('40784: rn:R02464','KEGG','4.1.2.27',true).
concept_accession('40784: rn:R02464','EC','4.1.2.27',true).
concept_accession('40785: rn:R03355','KEGG','3.2.1.23',true).
concept_accession('40785: rn:R03355','EC','3.2.1.23',true).
concept_accession('40785: rn:R03355','KEGG','EC:3.2.1.23',true).
concept_accession('40785: rn:R03355','KEGG','RNO:316033',true).
concept_accession('40785: rn:R03355','KEGG','316033',true).
concept_accession('9605: rn:R00216','KEGG','RC:RC00105',true).
concept_accession('9605: rn:R00216','KEGG','RP00287',true).
concept_accession('9605: rn:R00216','KEGG','RN:R00216',true).
concept_accession('9605: rn:R00216','KEGG','R00216',true).
concept_accession('9605: rn:R00216','KEGG','RP:RP00287',true).
concept_accession('9605: rn:R00216','KEGG','RC00105',true).
concept_accession('9605: rn:R00216','EC','1.1.1.40',false).
concept_accession('9605: rn:R00216','KEGG','EC:1.1.1.40',true).
concept_accession('9605: rn:R00216','KEGG','1.1.1.40',true).
concept_accession('40790: rn:R04019','EC','3.2.1.22',true).
concept_accession('40790: rn:R04019','KEGG','3.2.1.22',true).
concept_accession('40790: rn:R04019','KEGG','EC:3.2.1.22',true).
concept_accession('40790: rn:R04019','KEGG','363494',true).
concept_accession('40790: rn:R04019','KEGG','RNO:363494',true).
concept_accession('40791: rn:R04017','KEGG','2.8.2.11',true).
concept_accession('40791: rn:R04017','EC','2.8.2.11',true).
concept_accession('40791: rn:R04017','KEGG','RNO:683713',true).
concept_accession('40791: rn:R04017','KEGG','EC:2.8.2.11',true).
concept_accession('40791: rn:R04017','KEGG','683713',true).
concept_accession('40788: rn:R01494','KEGG','313339',true).
concept_accession('40788: rn:R01494','KEGG','301118',true).
concept_accession('40788: rn:R01494','KEGG','RNO:114104',true).
concept_accession('40788: rn:R01494','KEGG','84431',true).
concept_accession('40788: rn:R01494','EC','3.5.1.23',true).
concept_accession('40788: rn:R01494','KEGG','114104',true).
concept_accession('40788: rn:R01494','KEGG','RNO:313339',true).
concept_accession('40788: rn:R01494','KEGG','RNO:84431',true).
concept_accession('40788: rn:R01494','KEGG','EC:3.5.1.23',true).
concept_accession('40788: rn:R01494','KEGG','RNO:301118',true).
concept_accession('40788: rn:R01494','KEGG','3.5.1.23',true).
concept_accession('40789: rn:R00287','KEGG','RNO:85496',true).
concept_accession('40789: rn:R00287','KEGG','RNO:54410',true).
concept_accession('40789: rn:R00287','KEGG','3.6.1.9',true).
concept_accession('40789: rn:R00287','KEGG','54410',true).
concept_accession('40789: rn:R00287','KEGG','85496',true).
concept_accession('40789: rn:R00287','KEGG','EC:3.6.1.9',true).
concept_accession('40789: rn:R00287','EC','3.6.1.9',true).
concept_accession('40794: rn:R05105','KEGG','2.8.2.11',true).
concept_accession('40794: rn:R05105','EC','2.8.2.11',true).
concept_accession('40794: rn:R05105','KEGG','RNO:683713',true).
concept_accession('40794: rn:R05105','KEGG','EC:2.8.2.11',true).
concept_accession('40794: rn:R05105','KEGG','683713',true).
concept_accession('5849: rn:R01200','KEGG','RC00166',true).
concept_accession('5849: rn:R01200','KEGG','RN:R01200',true).
concept_accession('5849: rn:R01200','KEGG','R01200',true).
concept_accession('5849: rn:R01200','EC','3.5.1.33',false).
concept_accession('5849: rn:R01200','KEGG','RP:RP00546',true).
concept_accession('5849: rn:R01200','KEGG','3.5.1.33',true).
concept_accession('5849: rn:R01200','KEGG','EC:3.5.1.33',true).
concept_accession('5849: rn:R01200','KEGG','RP00546',true).
concept_accession('5849: rn:R01200','KEGG','RC:RC00166',true).
concept_accession('40795: rn:R02978','KEGG','360833',true).
concept_accession('40795: rn:R02978','KEGG','1.1.1.102',true).
concept_accession('40795: rn:R02978','KEGG','EC:1.1.1.102',true).
concept_accession('40795: rn:R02978','KEGG','RNO:360833',true).
concept_accession('40795: rn:R02978','EC','1.1.1.102',true).
concept_accession('5848: rn:R01204','KEGG','RC00166',true).
concept_accession('5848: rn:R01204','KEGG','R01204',true).
concept_accession('5848: rn:R01204','KEGG','2.3.1.3',true).
concept_accession('5848: rn:R01204','KEGG','RP:RP00546',true).
concept_accession('5848: rn:R01204','EC','2.3.1.3',false).
concept_accession('5848: rn:R01204','KEGG','EC:2.3.1.3',true).
concept_accession('5848: rn:R01204','KEGG','RN:R01204',true).
concept_accession('5848: rn:R01204','KEGG','RP00546',true).
concept_accession('5848: rn:R01204','KEGG','RC:RC00166',true).
concept_accession('40792: rn:R04018','KEGG','RNO:117185',true).
concept_accession('40792: rn:R04018','KEGG','RNO:29204',true).
concept_accession('40792: rn:R04018','KEGG','117185',true).
concept_accession('40792: rn:R04018','KEGG','29204',true).
concept_accession('40792: rn:R04018','KEGG','316642',true).
concept_accession('40792: rn:R04018','KEGG','24591',true).
concept_accession('40792: rn:R04018','KEGG','RNO:316642',true).
concept_accession('40792: rn:R04018','KEGG','EC:3.2.1.18',true).
concept_accession('40792: rn:R04018','KEGG','3.2.1.18',true).
concept_accession('40792: rn:R04018','EC','3.2.1.18',true).
concept_accession('40792: rn:R04018','KEGG','RNO:24591',true).
concept_accession('40793: rn:R01500','KEGG','50555',true).
concept_accession('40793: rn:R01500','KEGG','RNO:50555',true).
concept_accession('40793: rn:R01500','EC','2.4.1.47',true).
concept_accession('40793: rn:R01500','KEGG','2.4.1.47',true).
concept_accession('40793: rn:R01500','KEGG','EC:2.4.1.47',true).
concept_accession('40798: rn:R08359','KEGG','84596',true).
concept_accession('40798: rn:R08359','KEGG','2.5.1.16',true).
concept_accession('40798: rn:R08359','KEGG','RNO:84596',true).
concept_accession('40798: rn:R08359','EC','2.5.1.16',true).
concept_accession('40798: rn:R08359','KEGG','EC:2.5.1.16',true).
concept_accession('40799: rn:R02869','EC','2.5.1.22',true).
concept_accession('40799: rn:R02869','KEGG','EC:2.5.1.22',true).
concept_accession('40799: rn:R02869','KEGG','683008',true).
concept_accession('40799: rn:R02869','KEGG','RNO:683008',true).
concept_accession('40799: rn:R02869','KEGG','2.5.1.22',true).
concept_accession('40796: rn:R01281','KEGG','361213',true).
concept_accession('40796: rn:R01281','KEGG','366697',true).
concept_accession('40796: rn:R01281','KEGG','EC:2.3.1.50',true).
concept_accession('40796: rn:R01281','EC','2.3.1.50',true).
concept_accession('40796: rn:R01281','KEGG','RNO:361213',true).
concept_accession('40796: rn:R01281','KEGG','RNO:366697',true).
concept_accession('40796: rn:R01281','KEGG','2.3.1.50',true).
concept_accession('40796: rn:R01281','KEGG','296188',true).
concept_accession('40796: rn:R01281','KEGG','RNO:296188',true).
concept_accession('40797: rn:R08363','EC','1.17.4.1',true).
concept_accession('40797: rn:R08363','KEGG','362720',true).
concept_accession('40797: rn:R08363','KEGG','RNO:100359539',true).
concept_accession('40797: rn:R08363','KEGG','RNO:685579',true).
concept_accession('40797: rn:R08363','KEGG','1.17.4.1',true).
concept_accession('40797: rn:R08363','KEGG','100359539',true).
concept_accession('40797: rn:R08363','KEGG','EC:1.17.4.1',true).
concept_accession('40797: rn:R08363','KEGG','685579',true).
concept_accession('40797: rn:R08363','KEGG','299976',true).
concept_accession('40797: rn:R08363','KEGG','RNO:299976',true).
concept_accession('40797: rn:R08363','KEGG','RNO:362720',true).
concept_accession('13442: rn:R08309','KEGG','RP:RP13228',true).
concept_accession('13442: rn:R08309','KEGG','RC:RC02271',true).
concept_accession('13442: rn:R08309','KEGG','R08309',true).
concept_accession('13442: rn:R08309','KEGG','RN:R08309',true).
concept_accession('13442: rn:R08309','KEGG','RC02271',true).
concept_accession('13442: rn:R08309','KEGG','RP13228',true).
concept_accession('40801: rn:R06520','EC','3.1.3.4',true).
concept_accession('40801: rn:R06520','KEGG','RNO:246115',true).
concept_accession('40801: rn:R06520','KEGG','192270',true).
concept_accession('40801: rn:R06520','KEGG','3.1.3.4',true).
concept_accession('40801: rn:R06520','KEGG','RNO:64369',true).
concept_accession('40801: rn:R06520','KEGG','246115',true).
concept_accession('40801: rn:R06520','KEGG','64369',true).
concept_accession('40801: rn:R06520','KEGG','RNO:192270',true).
concept_accession('40801: rn:R06520','KEGG','EC:3.1.3.4',true).
concept_accession('40800: rn:R01920','KEGG','84596',true).
concept_accession('40800: rn:R01920','KEGG','2.5.1.16',true).
concept_accession('40800: rn:R01920','KEGG','RNO:84596',true).
concept_accession('40800: rn:R01920','EC','2.5.1.16',true).
concept_accession('40800: rn:R01920','KEGG','EC:2.5.1.16',true).
concept_accession('13440: rn:R08305','KEGG','RP13136',true).
concept_accession('13440: rn:R08305','KEGG','RC00041',true).
concept_accession('13440: rn:R08305','KEGG','RN:R08305',true).
concept_accession('13440: rn:R08305','KEGG','RP:RP13136',true).
concept_accession('13440: rn:R08305','KEGG','RC:RC00041',true).
concept_accession('13440: rn:R08305','KEGG','R08305',true).
concept_accession('40803: rn:R01495','KEGG','300129',true).
concept_accession('40803: rn:R01495','EC','2.7.1.138',true).
concept_accession('40803: rn:R01495','KEGG','RNO:300129',true).
concept_accession('40803: rn:R01495','KEGG','EC:2.7.1.138',true).
concept_accession('40803: rn:R01495','KEGG','2.7.1.138',true).
concept_accession('40802: rn:R06521','EC','3.1.3.4',true).
concept_accession('40802: rn:R06521','KEGG','RNO:246115',true).
concept_accession('40802: rn:R06521','KEGG','192270',true).
concept_accession('40802: rn:R06521','KEGG','3.1.3.4',true).
concept_accession('40802: rn:R06521','KEGG','RNO:64369',true).
concept_accession('40802: rn:R06521','KEGG','246115',true).
concept_accession('40802: rn:R06521','KEGG','64369',true).
concept_accession('40802: rn:R06521','KEGG','RNO:192270',true).
concept_accession('40802: rn:R06521','KEGG','EC:3.1.3.4',true).
concept_accession('40805: rn:R06522','EC','3.1.3.4',true).
concept_accession('40805: rn:R06522','KEGG','RNO:246115',true).
concept_accession('40805: rn:R06522','KEGG','192270',true).
concept_accession('40805: rn:R06522','KEGG','3.1.3.4',true).
concept_accession('40805: rn:R06522','KEGG','RNO:64369',true).
concept_accession('40805: rn:R06522','KEGG','246115',true).
concept_accession('40805: rn:R06522','KEGG','64369',true).
concept_accession('40805: rn:R06522','KEGG','RNO:192270',true).
concept_accession('40805: rn:R06522','KEGG','EC:3.1.3.4',true).
concept_accession('40804: rn:R04951','KEGG','EC:3.4.11.2',true).
concept_accession('40804: rn:R04951','KEGG','RNO:289668',true).
concept_accession('40804: rn:R04951','EC','3.4.11.2',true).
concept_accession('40804: rn:R04951','KEGG','289668',true).
concept_accession('40804: rn:R04951','KEGG','3.4.11.2',true).
concept_accession('13444: rn:R08311','KEGG','RP13233',true).
concept_accession('13444: rn:R08311','KEGG','RN:R08311',true).
concept_accession('13444: rn:R08311','KEGG','R08311',true).
concept_accession('13444: rn:R08311','KEGG','RP:RP13233',true).
concept_accession('13444: rn:R08311','KEGG','RC:RC02272',true).
concept_accession('13444: rn:R08311','KEGG','RC02272',true).
concept_accession('40807: rn:R00899','KEGG','EC:3.4.11.2',true).
concept_accession('40807: rn:R00899','KEGG','RNO:289668',true).
concept_accession('40807: rn:R00899','EC','3.4.11.2',true).
concept_accession('40807: rn:R00899','KEGG','289668',true).
concept_accession('40807: rn:R00899','KEGG','3.4.11.2',true).
concept_accession('40806: rn:R02541','KEGG','94338',true).
concept_accession('40806: rn:R02541','KEGG','303729',true).
concept_accession('40806: rn:R02541','KEGG','308909',true).
concept_accession('40806: rn:R02541','KEGG','315091',true).
concept_accession('40806: rn:R02541','KEGG','RNO:303729',true).
concept_accession('40806: rn:R02541','KEGG','RNO:94338',true).
concept_accession('40806: rn:R02541','EC','3.1.4.12',true).
concept_accession('40806: rn:R02541','KEGG','EC:3.1.4.12',true).
concept_accession('40806: rn:R02541','KEGG','RNO:83537',true).
concept_accession('40806: rn:R02541','KEGG','RNO:315091',true).
concept_accession('40806: rn:R02541','KEGG','RNO:303790',true).
concept_accession('40806: rn:R02541','KEGG','3.1.4.12',true).
concept_accession('40806: rn:R02541','KEGG','RNO:308909',true).
concept_accession('40806: rn:R02541','KEGG','83537',true).
concept_accession('40806: rn:R02541','KEGG','303790',true).
concept_accession('40809: rn:R06518','KEGG','RNO:114104',true).
concept_accession('40809: rn:R06518','KEGG','84431',true).
concept_accession('40809: rn:R06518','EC','3.5.1.23',true).
concept_accession('40809: rn:R06518','KEGG','114104',true).
concept_accession('40809: rn:R06518','KEGG','RNO:84431',true).
concept_accession('40809: rn:R06518','KEGG','EC:3.5.1.23',true).
concept_accession('40809: rn:R06518','KEGG','3.5.1.23',true).
concept_accession('9659: rn:R01196','KEGG','R01196',true).
concept_accession('9659: rn:R01196','KEGG','RN:R01196',true).
concept_accession('9659: rn:R01196','KEGG','1.2.7.1',true).
concept_accession('9659: rn:R01196','EC','1.2.7.1',false).
concept_accession('9659: rn:R01196','KEGG','EC:1.2.7.1',true).
concept_accession('40808: rn:R06519','KEGG','289322',true).
concept_accession('40808: rn:R06519','KEGG','RNO:58970',true).
concept_accession('40808: rn:R06519','KEGG','EC:1.14.-.-',true).
concept_accession('40808: rn:R06519','KEGG','RNO:289322',true).
concept_accession('40808: rn:R06519','KEGG','1.14.-.-',true).
concept_accession('40808: rn:R06519','KEGG','RNO:314438',true).
concept_accession('40808: rn:R06519','KEGG','58970',true).
concept_accession('40808: rn:R06519','KEGG','314438',true).
concept_accession('40808: rn:R06519','EC','1.14.-.-',true).
concept_accession('40811: rn:R06521','EC','3.1.3.4',true).
concept_accession('40811: rn:R06521','KEGG','3.1.3.4',true).
concept_accession('40811: rn:R06521','KEGG','81536',true).
concept_accession('40811: rn:R06521','KEGG','RNO:81536',true).
concept_accession('40811: rn:R06521','KEGG','EC:3.1.3.4',true).
concept_accession('40810: rn:R06528','KEGG','RNO:114104',true).
concept_accession('40810: rn:R06528','KEGG','84431',true).
concept_accession('40810: rn:R06528','EC','3.5.1.23',true).
concept_accession('40810: rn:R06528','KEGG','114104',true).
concept_accession('40810: rn:R06528','KEGG','RNO:84431',true).
concept_accession('40810: rn:R06528','KEGG','EC:3.5.1.23',true).
concept_accession('40810: rn:R06528','KEGG','3.5.1.23',true).
concept_accession('13454: rn:R08278','KEGG','RP13144',true).
concept_accession('13454: rn:R08278','KEGG','RP:RP13144',true).
concept_accession('13454: rn:R08278','KEGG','RN:R08278',true).
concept_accession('13454: rn:R08278','KEGG','R08278',true).
concept_accession('13454: rn:R08278','KEGG','RC02240',true).
concept_accession('13454: rn:R08278','KEGG','RC:RC02240',true).
concept_accession('40813: rn:R06520','EC','3.1.3.4',true).
concept_accession('40813: rn:R06520','KEGG','RNO:301543',true).
concept_accession('40813: rn:R06520','KEGG','3.1.3.4',true).
concept_accession('40813: rn:R06520','KEGG','81536',true).
concept_accession('40813: rn:R06520','KEGG','301543',true).
concept_accession('40813: rn:R06520','KEGG','RNO:81536',true).
concept_accession('40813: rn:R06520','KEGG','EC:3.1.3.4',true).
concept_accession('40812: rn:R08364','EC','1.17.4.1',true).
concept_accession('40812: rn:R08364','KEGG','362720',true).
concept_accession('40812: rn:R08364','KEGG','RNO:100359539',true).
concept_accession('40812: rn:R08364','KEGG','RNO:685579',true).
concept_accession('40812: rn:R08364','KEGG','1.17.4.1',true).
concept_accession('40812: rn:R08364','KEGG','100359539',true).
concept_accession('40812: rn:R08364','KEGG','EC:1.17.4.1',true).
concept_accession('40812: rn:R08364','KEGG','685579',true).
concept_accession('40812: rn:R08364','KEGG','299976',true).
concept_accession('40812: rn:R08364','KEGG','RNO:299976',true).
concept_accession('40812: rn:R08364','KEGG','RNO:362720',true).
concept_accession('40815: rn:R01718','KEGG','RNO:497756',true).
concept_accession('40815: rn:R01718','KEGG','3.2.1.10',true).
concept_accession('40815: rn:R01718','EC','3.2.1.10',true).
concept_accession('40815: rn:R01718','KEGG','497756',true).
concept_accession('40815: rn:R01718','KEGG','EC:3.2.1.10',true).
concept_accession('9661: rn:R00345','EC','4.1.1.31',false).
concept_accession('9661: rn:R00345','KEGG','R00345',true).
concept_accession('9661: rn:R00345','KEGG','RN:R00345',true).
concept_accession('9661: rn:R00345','KEGG','EC:4.1.1.31',true).
concept_accession('9661: rn:R00345','KEGG','4.1.1.31',true).
concept_accession('40814: rn:R06522','EC','3.1.3.4',true).
concept_accession('40814: rn:R06522','KEGG','3.1.3.4',true).
concept_accession('40814: rn:R06522','KEGG','81536',true).
concept_accession('40814: rn:R06522','KEGG','RNO:81536',true).
concept_accession('40814: rn:R06522','KEGG','EC:3.1.3.4',true).
concept_accession('5869: rn:R02087','KEGG','RP01965',true).
concept_accession('5869: rn:R02087','KEGG','EC:5.1.3.9',true).
concept_accession('5869: rn:R02087','KEGG','RC00290',true).
concept_accession('5869: rn:R02087','KEGG','RP:RP01965',true).
concept_accession('5869: rn:R02087','KEGG','RN:R02087',true).
concept_accession('5869: rn:R02087','KEGG','R02087',true).
concept_accession('5869: rn:R02087','EC','5.1.3.9',false).
concept_accession('5869: rn:R02087','KEGG','5.1.3.9',true).
concept_accession('5869: rn:R02087','KEGG','RC:RC00290',true).
concept_accession('40816: rn:R01791','KEGG','3.2.1.10',true).
concept_accession('40816: rn:R01791','EC','3.2.1.10',true).
concept_accession('40816: rn:R01791','KEGG','312272',true).
concept_accession('40816: rn:R01791','KEGG','RNO:312272',true).
concept_accession('40816: rn:R01791','KEGG','EC:3.2.1.10',true).
concept_accession('40817: rn:R01791','KEGG','RNO:497756',true).
concept_accession('40817: rn:R01791','KEGG','3.2.1.10',true).
concept_accession('40817: rn:R01791','EC','3.2.1.10',true).
concept_accession('40817: rn:R01791','KEGG','497756',true).
concept_accession('40817: rn:R01791','KEGG','EC:3.2.1.10',true).
concept_accession('40818: rn:R06075','KEGG','296564',true).
concept_accession('40818: rn:R06075','EC','2.4.1.-',true).
concept_accession('40818: rn:R06075','KEGG','2.4.1.-',true).
concept_accession('40818: rn:R06075','KEGG','RNO:60670',true).
concept_accession('40818: rn:R06075','KEGG','EC:2.4.1.-',true).
concept_accession('40818: rn:R06075','KEGG','RNO:296564',true).
concept_accession('40818: rn:R06075','KEGG','60670',true).
concept_accession('40819: rn:R02109','KEGG','EC:3.2.1.33',true).
concept_accession('40819: rn:R02109','EC','3.2.1.33',true).
concept_accession('40819: rn:R02109','KEGG','362029',true).
concept_accession('40819: rn:R02109','KEGG','3.2.1.33',true).
concept_accession('40819: rn:R02109','KEGG','RNO:362029',true).
concept_accession('40820: rn:R06095','KEGG','2.4.1.65',true).
concept_accession('40820: rn:R06095','KEGG','RNO:60670',true).
concept_accession('40820: rn:R06095','EC','2.4.1.65',true).
concept_accession('40820: rn:R06095','KEGG','60670',true).
concept_accession('40820: rn:R06095','KEGG','EC:2.4.1.65',true).
concept_accession('40821: rn:R02740','KEGG','5.3.1.9',true).
concept_accession('40821: rn:R02740','EC','5.3.1.9',true).
concept_accession('40821: rn:R02740','KEGG','292804',true).
concept_accession('40821: rn:R02740','KEGG','EC:5.3.1.9',true).
concept_accession('40821: rn:R02740','KEGG','RNO:292804',true).
concept_accession('40822: rn:R06076','KEGG','2.4.1.65',true).
concept_accession('40822: rn:R06076','KEGG','RNO:60670',true).
concept_accession('40822: rn:R06076','EC','2.4.1.65',true).
concept_accession('40822: rn:R06076','KEGG','60670',true).
concept_accession('40822: rn:R06076','KEGG','EC:2.4.1.65',true).
concept_accession('40823: rn:R06038','EC','2.4.1.-',true).
concept_accession('40823: rn:R06038','KEGG','2.4.1.-',true).
concept_accession('40823: rn:R06038','KEGG','RNO:60670',true).
concept_accession('40823: rn:R06038','KEGG','EC:2.4.1.-',true).
concept_accession('40823: rn:R06038','KEGG','60670',true).
concept_accession('40824: rn:R02110','KEGG','2.4.1.18',true).
concept_accession('40824: rn:R02110','EC','2.4.1.18',true).
concept_accession('40824: rn:R02110','KEGG','288333',true).
concept_accession('40824: rn:R02110','KEGG','EC:2.4.1.18',true).
concept_accession('40824: rn:R02110','KEGG','RNO:288333',true).
concept_accession('40825: rn:R00010','KEGG','60576',true).
concept_accession('40825: rn:R00010','KEGG','EC:3.2.1.28',true).
concept_accession('40825: rn:R00010','KEGG','3.2.1.28',true).
concept_accession('40825: rn:R00010','EC','3.2.1.28',true).
concept_accession('40825: rn:R00010','KEGG','RNO:60576',true).
concept_accession('40826: rn:R06025','KEGG','2.4.1.65',true).
concept_accession('40826: rn:R06025','KEGG','RNO:60670',true).
concept_accession('40826: rn:R06025','EC','2.4.1.65',true).
concept_accession('40826: rn:R06025','KEGG','60670',true).
concept_accession('40826: rn:R06025','KEGG','EC:2.4.1.65',true).
concept_accession('40827: rn:R05977','EC','2.4.1.-',true).
concept_accession('40827: rn:R05977','KEGG','2.4.1.-',true).
concept_accession('40827: rn:R05977','KEGG','303923',true).
concept_accession('40827: rn:R05977','KEGG','EC:2.4.1.-',true).
concept_accession('40827: rn:R05977','KEGG','RNO:303923',true).
concept_accession('40828: rn:R00292','KEGG','690987',true).
concept_accession('40828: rn:R00292','KEGG','EC:2.4.1.11',true).
concept_accession('40828: rn:R00292','KEGG','25623',true).
concept_accession('40828: rn:R00292','KEGG','RNO:25623',true).
concept_accession('40828: rn:R00292','KEGG','2.4.1.11',true).
concept_accession('40828: rn:R00292','EC','2.4.1.11',true).
concept_accession('40828: rn:R00292','KEGG','RNO:690987',true).
concept_accession('40829: rn:R06033','KEGG','494342',true).
concept_accession('40829: rn:R06033','EC','2.4.1.-',true).
concept_accession('40829: rn:R06033','KEGG','2.4.1.-',true).
concept_accession('40829: rn:R06033','KEGG','EC:2.4.1.-',true).
concept_accession('40829: rn:R06033','KEGG','RNO:494342',true).
concept_accession('40830: rn:R06033','EC','2.4.1.-',true).
concept_accession('40830: rn:R06033','KEGG','2.4.1.-',true).
concept_accession('40830: rn:R06033','KEGG','303923',true).
concept_accession('40830: rn:R06033','KEGG','EC:2.4.1.-',true).
concept_accession('40830: rn:R06033','KEGG','RNO:303923',true).
concept_accession('40831: rn:R00959','KEGG','RNO:24645',true).
concept_accession('40831: rn:R00959','KEGG','EC:5.4.2.2',true).
concept_accession('40831: rn:R00959','KEGG','24645',true).
concept_accession('40831: rn:R00959','KEGG','5.4.2.2',true).
concept_accession('40831: rn:R00959','EC','5.4.2.2',true).
concept_accession('40711: rn:R04726','KEGG','50671',true).
concept_accession('40711: rn:R04726','KEGG','2.3.1.85',true).
concept_accession('40711: rn:R04726','KEGG','EC:2.3.1.85',true).
concept_accession('40711: rn:R04726','KEGG','RNO:50671',true).
concept_accession('40711: rn:R04726','EC','2.3.1.85',true).
concept_accession('40710: rn:R02058','KEGG','2.3.1.4',true).
concept_accession('40710: rn:R02058','KEGG','EC:2.3.1.4',true).
concept_accession('40710: rn:R02058','EC','2.3.1.4',true).
concept_accession('40710: rn:R02058','KEGG','RNO:498486',true).
concept_accession('40710: rn:R02058','KEGG','498486',true).
concept_accession('40709: rn:R03161','KEGG','RNO:307848',true).
concept_accession('40709: rn:R03161','EC','2.7.1.52',true).
concept_accession('40709: rn:R03161','KEGG','2.7.1.52',true).
concept_accession('40709: rn:R03161','KEGG','EC:2.7.1.52',true).
concept_accession('40709: rn:R03161','KEGG','307848',true).
concept_accession('40708: rn:R04566','KEGG','50671',true).
concept_accession('40708: rn:R04566','KEGG','2.3.1.86',true).
concept_accession('40708: rn:R04566','EC','2.3.1.86',true).
concept_accession('40708: rn:R04566','KEGG','EC:2.3.1.86',true).
concept_accession('40708: rn:R04566','KEGG','RNO:50671',true).
concept_accession('9680: rn:R09289','KEGG','R09289',true).
concept_accession('9680: rn:R09289','KEGG','RC00087',true).
concept_accession('9680: rn:R09289','KEGG','RC:RC00087',true).
concept_accession('9680: rn:R09289','KEGG','RP:RP01630',true).
concept_accession('9680: rn:R09289','KEGG','RP01630',true).
concept_accession('9680: rn:R09289','EC','1.1.1.298',false).
concept_accession('9680: rn:R09289','KEGG','EC:1.1.1.298',true).
concept_accession('9680: rn:R09289','KEGG','RN:R09289',true).
concept_accession('9680: rn:R09289','KEGG','1.1.1.298',true).
concept_accession('40707: rn:R04470','EC','3.2.1.22',true).
concept_accession('40707: rn:R04470','KEGG','3.2.1.22',true).
concept_accession('40707: rn:R04470','KEGG','EC:3.2.1.22',true).
concept_accession('40707: rn:R04470','KEGG','363494',true).
concept_accession('40707: rn:R04470','KEGG','RNO:363494',true).
concept_accession('40706: rn:R01951','KEGG','310935',true).
concept_accession('40706: rn:R01951','KEGG','EC:2.7.7.30',true).
concept_accession('40706: rn:R01951','EC','2.7.7.30',true).
concept_accession('40706: rn:R01951','KEGG','2.7.7.30',true).
concept_accession('40706: rn:R01951','KEGG','RNO:310935',true).
concept_accession('40705: rn:R00885','KEGG','EC:2.7.7.13',true).
concept_accession('40705: rn:R00885','KEGG','RNO:363145',true).
concept_accession('40705: rn:R00885','KEGG','363145',true).
concept_accession('40705: rn:R00885','KEGG','501167',true).
concept_accession('40705: rn:R00885','KEGG','2.7.7.13',true).
concept_accession('40705: rn:R00885','EC','2.7.7.13',true).
concept_accession('40705: rn:R00885','KEGG','RNO:501167',true).
concept_accession('40704: rn:R02240','KEGG','EC:2.7.1.107',true).
concept_accession('40704: rn:R02240','KEGG','25666',true).
concept_accession('40704: rn:R02240','KEGG','368088',true).
concept_accession('40704: rn:R02240','KEGG','497978',true).
concept_accession('40704: rn:R02240','KEGG','2.7.1.107',true).
concept_accession('40704: rn:R02240','KEGG','RNO:54248',true).
concept_accession('40704: rn:R02240','KEGG','54248',true).
concept_accession('40704: rn:R02240','KEGG','RNO:100361138',true).
concept_accession('40704: rn:R02240','EC','2.7.1.107',true).
concept_accession('40704: rn:R02240','KEGG','RNO:361076',true).
concept_accession('40704: rn:R02240','KEGG','361076',true).
concept_accession('40704: rn:R02240','KEGG','RNO:497978',true).
concept_accession('40704: rn:R02240','KEGG','RNO:688705',true).
concept_accession('40704: rn:R02240','KEGG','RNO:81821',true).
concept_accession('40704: rn:R02240','KEGG','RNO:25666',true).
concept_accession('40704: rn:R02240','KEGG','140866',true).
concept_accession('40704: rn:R02240','KEGG','RNO:140866',true).
concept_accession('40704: rn:R02240','KEGG','RNO:368088',true).
concept_accession('40704: rn:R02240','KEGG','688705',true).
concept_accession('40704: rn:R02240','KEGG','81821',true).
concept_accession('40704: rn:R02240','KEGG','100361138',true).
concept_accession('40719: rn:R01115','KEGG','EC:1.14.18.2',true).
concept_accession('40719: rn:R01115','KEGG','361245',true).
concept_accession('40719: rn:R01115','KEGG','RNO:361245',true).
concept_accession('40719: rn:R01115','KEGG','1.14.18.2',true).
concept_accession('40719: rn:R01115','EC','1.14.18.2',true).
concept_accession('40718: rn:R00100','KEGG','RNO:304805',true).
concept_accession('40718: rn:R00100','KEGG','EC:1.6.2.2',true).
concept_accession('40718: rn:R00100','KEGG','RNO:365345',true).
concept_accession('40718: rn:R00100','KEGG','RNO:25035',true).
concept_accession('40718: rn:R00100','KEGG','25035',true).
concept_accession('40718: rn:R00100','EC','1.6.2.2',true).
concept_accession('40718: rn:R00100','KEGG','304805',true).
concept_accession('40718: rn:R00100','KEGG','365345',true).
concept_accession('40718: rn:R00100','KEGG','1.6.2.2',true).
concept_accession('40717: rn:R01207','KEGG','EC:5.1.3.8',true).
concept_accession('40717: rn:R01207','KEGG','5.1.3.8',true).
concept_accession('40717: rn:R01207','EC','5.1.3.8',true).
concept_accession('40717: rn:R01207','KEGG','RNO:81759',true).
concept_accession('40717: rn:R01207','KEGG','81759',true).
concept_accession('40716: rn:R01811','KEGG','304860',true).
concept_accession('40716: rn:R01811','EC','4.1.3.3',true).
concept_accession('40716: rn:R01811','KEGG','4.1.3.3',true).
concept_accession('40716: rn:R01811','KEGG','EC:4.1.3.3',true).
concept_accession('40716: rn:R01811','KEGG','RNO:304860',true).
concept_accession('9688: rn:R00473','KEGG','RC:RC00307',true).
concept_accession('9688: rn:R00473','KEGG','RC:RC00308',true).
concept_accession('9688: rn:R00473','EC','4.1.3.24',false).
concept_accession('9688: rn:R00473','KEGG','EC:4.1.3.24',true).
concept_accession('9688: rn:R00473','KEGG','RC00307',true).
concept_accession('9688: rn:R00473','KEGG','4.1.3.24',true).
concept_accession('9688: rn:R00473','KEGG','RN:R00473',true).
concept_accession('9688: rn:R00473','KEGG','RP00922',true).
concept_accession('9688: rn:R00473','KEGG','RP00923',true).
concept_accession('9688: rn:R00473','KEGG','RC00308',true).
concept_accession('9688: rn:R00473','KEGG','RP:RP00923',true).
concept_accession('9688: rn:R00473','KEGG','RP:RP00922',true).
concept_accession('9688: rn:R00473','KEGG','R00473',true).
concept_accession('40715: rn:R00022','KEGG','RNO:294673',true).
concept_accession('40715: rn:R00022','KEGG','294673',true).
concept_accession('40715: rn:R00022','KEGG','RNO:300757',true).
concept_accession('40715: rn:R00022','KEGG','EC:3.2.1.52',true).
concept_accession('40715: rn:R00022','EC','3.2.1.52',true).
concept_accession('40715: rn:R00022','KEGG','300757',true).
concept_accession('40715: rn:R00022','KEGG','3.2.1.52',true).
concept_accession('40714: rn:R00888','KEGG','EC:4.2.1.47',true).
concept_accession('40714: rn:R00888','KEGG','RNO:291095',true).
concept_accession('40714: rn:R00888','KEGG','291095',true).
concept_accession('40714: rn:R00888','EC','4.2.1.47',true).
concept_accession('40714: rn:R00888','KEGG','4.2.1.47',true).
concept_accession('40713: rn:R05692','KEGG','RNO:300036',true).
concept_accession('40713: rn:R05692','EC','1.1.1.271',true).
concept_accession('40713: rn:R05692','KEGG','1.1.1.271',true).
concept_accession('40713: rn:R05692','KEGG','EC:1.1.1.271',true).
concept_accession('40713: rn:R05692','KEGG','300036',true).
concept_accession('40712: rn:R04215','KEGG','EC:2.7.7.43',true).
concept_accession('40712: rn:R04215','EC','2.7.7.43',true).
concept_accession('40712: rn:R04215','KEGG','2.7.7.43',true).
concept_accession('40712: rn:R04215','KEGG','312826',true).
concept_accession('40712: rn:R04215','KEGG','RNO:312826',true).
concept_accession('40726: rn:R01961','KEGG','RNO:100364027',true).
concept_accession('40726: rn:R01961','KEGG','25058',true).
concept_accession('40726: rn:R01961','KEGG','EC:2.7.1.8',true).
concept_accession('40726: rn:R01961','KEGG','25059',true).
concept_accession('40726: rn:R01961','KEGG','RNO:25058',true).
concept_accession('40726: rn:R01961','KEGG','25060',true).
concept_accession('40726: rn:R01961','KEGG','RNO:25059',true).
concept_accession('40726: rn:R01961','KEGG','100364027',true).
concept_accession('40726: rn:R01961','KEGG','RNO:25060',true).
concept_accession('40726: rn:R01961','KEGG','2.7.1.8',true).
concept_accession('40726: rn:R01961','EC','2.7.1.8',true).
concept_accession('40727: rn:R04404','KEGG','84018',true).
concept_accession('40727: rn:R04404','KEGG','EC:3.1.3.36',true).
concept_accession('40727: rn:R04404','KEGG','RNO:85238',true).
concept_accession('40727: rn:R04404','EC','3.1.3.36',true).
concept_accession('40727: rn:R04404','KEGG','3.1.3.36',true).
concept_accession('40727: rn:R04404','KEGG','RNO:362590',true).
concept_accession('40727: rn:R04404','KEGG','85238',true).
concept_accession('40727: rn:R04404','KEGG','RNO:114089',true).
concept_accession('40727: rn:R04404','KEGG','362590',true).
concept_accession('40727: rn:R04404','KEGG','RNO:84018',true).
concept_accession('40727: rn:R04404','KEGG','114089',true).
concept_accession('40727: rn:R04404','KEGG','317576',true).
concept_accession('40727: rn:R04404','KEGG','RNO:317576',true).
concept_accession('40724: rn:R05800','KEGG','RNO:171458',true).
concept_accession('40724: rn:R05800','KEGG','EC:2.7.1.151',true).
concept_accession('40724: rn:R05800','KEGG','171458',true).
concept_accession('40724: rn:R05800','KEGG','2.7.1.151',true).
concept_accession('40724: rn:R05800','EC','2.7.1.151',true).
concept_accession('40725: rn:R04954','KEGG','50671',true).
concept_accession('40725: rn:R04954','KEGG','4.2.1.-',true).
concept_accession('40725: rn:R04954','KEGG','EC:4.2.1.-',true).
concept_accession('40725: rn:R04954','KEGG','RNO:50671',true).
concept_accession('40725: rn:R04954','EC','4.2.1.-',true).
concept_accession('40722: rn:R01786','KEGG','RNO:100364027',true).
concept_accession('40722: rn:R01786','KEGG','25058',true).
concept_accession('40722: rn:R01786','KEGG','25059',true).
concept_accession('40722: rn:R01786','KEGG','RNO:25058',true).
concept_accession('40722: rn:R01786','KEGG','25060',true).
concept_accession('40722: rn:R01786','KEGG','RNO:25059',true).
concept_accession('40722: rn:R01786','EC','2.7.1.1',true).
concept_accession('40722: rn:R01786','KEGG','100364027',true).
concept_accession('40722: rn:R01786','KEGG','RNO:25060',true).
concept_accession('40722: rn:R01786','KEGG','EC:2.7.1.1',true).
concept_accession('40722: rn:R01786','KEGG','2.7.1.1',true).
concept_accession('40723: rn:R05801','KEGG','RNO:171458',true).
concept_accession('40723: rn:R05801','KEGG','EC:2.7.1.151',true).
concept_accession('40723: rn:R05801','KEGG','171458',true).
concept_accession('40723: rn:R05801','KEGG','2.7.1.151',true).
concept_accession('40723: rn:R05801','EC','2.7.1.151',true).
concept_accession('40720: rn:R01803','KEGG','EC:1.14.18.2',true).
concept_accession('40720: rn:R01803','KEGG','361245',true).
concept_accession('40720: rn:R01803','KEGG','RNO:361245',true).
concept_accession('40720: rn:R01803','KEGG','1.14.18.2',true).
concept_accession('40720: rn:R01803','EC','1.14.18.2',true).
concept_accession('9666: rn:R09280','EC','1.2.1.76',false).
concept_accession('9666: rn:R09280','KEGG','RC00184',true).
concept_accession('9666: rn:R09280','KEGG','EC:1.2.1.76',true).
concept_accession('9666: rn:R09280','KEGG','RC:RC00184',true).
concept_accession('9666: rn:R09280','KEGG','RP14558',true).
concept_accession('9666: rn:R09280','KEGG','RN:R09280',true).
concept_accession('9666: rn:R09280','KEGG','RP:RP14558',true).
concept_accession('9666: rn:R09280','KEGG','R09280',true).
concept_accession('9666: rn:R09280','KEGG','1.2.1.76',true).
concept_accession('40721: rn:R00959','KEGG','RNO:24645',true).
concept_accession('40721: rn:R00959','KEGG','EC:5.4.2.2',true).
concept_accession('40721: rn:R00959','KEGG','24645',true).
concept_accession('40721: rn:R00959','KEGG','5.4.2.2',true).
concept_accession('40721: rn:R00959','EC','5.4.2.2',true).
concept_accession('40734: rn:R04430','KEGG','50671',true).
concept_accession('40734: rn:R04430','KEGG','1.3.1.-',true).
concept_accession('40734: rn:R04430','KEGG','RNO:50671',true).
concept_accession('40734: rn:R04430','KEGG','EC:1.3.1.-',true).
concept_accession('40734: rn:R04430','EC','1.3.1.-',true).
concept_accession('40735: rn:R04428','KEGG','50671',true).
concept_accession('40735: rn:R04428','KEGG','4.2.1.-',true).
concept_accession('40735: rn:R04428','KEGG','EC:4.2.1.-',true).
concept_accession('40735: rn:R04428','KEGG','RNO:50671',true).
concept_accession('40735: rn:R04428','EC','4.2.1.-',true).
concept_accession('9679: rn:R00740','KEGG','R00740',true).
concept_accession('9679: rn:R00740','KEGG','EC:1.2.1.18',true).
concept_accession('9679: rn:R00740','KEGG','RC00184',true).
concept_accession('9679: rn:R00740','KEGG','RN:R00740',true).
concept_accession('9679: rn:R00740','KEGG','RP01076',true).
concept_accession('9679: rn:R00740','EC','1.2.1.18',false).
concept_accession('9679: rn:R00740','KEGG','RC:RC00184',true).
concept_accession('9679: rn:R00740','KEGG','1.2.1.18',true).
concept_accession('9679: rn:R00740','KEGG','RP:RP01076',true).
concept_accession('40732: rn:R04956','KEGG','50671',true).
concept_accession('40732: rn:R04956','KEGG','1.3.1.-',true).
concept_accession('40732: rn:R04956','KEGG','RNO:50671',true).
concept_accession('40732: rn:R04956','KEGG','EC:1.3.1.-',true).
concept_accession('40732: rn:R04956','EC','1.3.1.-',true).
concept_accession('40733: rn:R03429','KEGG','EC:2.7.1.159',true).
concept_accession('40733: rn:R03429','EC','2.7.1.159',true).
concept_accession('40733: rn:R03429','KEGG','500709',true).
concept_accession('40733: rn:R03429','KEGG','2.7.1.159',true).
concept_accession('40733: rn:R03429','KEGG','RNO:500709',true).
concept_accession('9673: rn:R00267','KEGG','RN:R00267',true).
concept_accession('9673: rn:R00267','KEGG','RC:RC00114',true).
concept_accession('9673: rn:R00267','KEGG','R00267',true).
concept_accession('9673: rn:R00267','KEGG','RC00114',true).
concept_accession('9673: rn:R00267','KEGG','RP00305',true).
concept_accession('9673: rn:R00267','KEGG','RP:RP00305',true).
concept_accession('9673: rn:R00267','KEGG','EC:1.1.1.42',true).
concept_accession('9673: rn:R00267','KEGG','1.1.1.42',true).
concept_accession('9673: rn:R00267','EC','1.1.1.42',false).
concept_accession('40730: rn:R01786','KEGG','RNO:24385',true).
concept_accession('40730: rn:R01786','EC','2.7.1.1',true).
concept_accession('40730: rn:R01786','KEGG','24385',true).
concept_accession('40730: rn:R01786','KEGG','EC:2.7.1.1',true).
concept_accession('40730: rn:R01786','KEGG','2.7.1.1',true).
concept_accession('9672: rn:R01197','KEGG','R01197',true).
concept_accession('9672: rn:R01197','KEGG','1.2.7.3',true).
concept_accession('9672: rn:R01197','KEGG','RN:R01197',true).
concept_accession('9672: rn:R01197','EC','1.2.7.3',false).
concept_accession('9672: rn:R01197','KEGG','EC:1.2.7.3',true).
concept_accession('40731: rn:R05803','KEGG','RNO:140607',true).
concept_accession('40731: rn:R05803','EC','2.7.1.149',true).
concept_accession('40731: rn:R05803','KEGG','RNO:89812',true).
concept_accession('40731: rn:R05803','KEGG','140607',true).
concept_accession('40731: rn:R05803','KEGG','RNO:116723',true).
concept_accession('40731: rn:R05803','KEGG','89812',true).
concept_accession('40731: rn:R05803','KEGG','2.7.1.149',true).
concept_accession('40731: rn:R05803','KEGG','EC:2.7.1.149',true).
concept_accession('40731: rn:R05803','KEGG','116723',true).
concept_accession('40728: rn:R04953','KEGG','50671',true).
concept_accession('40728: rn:R04953','KEGG','2.3.1.85',true).
concept_accession('40728: rn:R04953','KEGG','EC:2.3.1.85',true).
concept_accession('40728: rn:R04953','KEGG','RNO:50671',true).
concept_accession('40728: rn:R04953','EC','2.3.1.85',true).
concept_accession('40729: rn:R01786','KEGG','RNO:24385',true).
concept_accession('40729: rn:R01786','EC','2.7.1.1',true).
concept_accession('40729: rn:R01786','KEGG','24385',true).
concept_accession('40729: rn:R01786','KEGG','EC:2.7.1.1',true).
concept_accession('40729: rn:R01786','KEGG','2.7.1.1',true).
concept_accession('40741: rn:R04513','KEGG','50557',true).
concept_accession('40741: rn:R04513','KEGG','EC:3.1.3.67',true).
concept_accession('40741: rn:R04513','EC','3.1.3.67',true).
concept_accession('40741: rn:R04513','KEGG','RNO:50557',true).
concept_accession('40741: rn:R04513','KEGG','3.1.3.67',true).
concept_accession('40740: rn:R03434','KEGG','29688',true).
concept_accession('40740: rn:R03434','KEGG','EC:3.1.3.62',true).
concept_accession('40740: rn:R03434','EC','3.1.3.62',true).
concept_accession('40740: rn:R03434','KEGG','RNO:29688',true).
concept_accession('40740: rn:R03434','KEGG','3.1.3.62',true).
concept_accession('40743: rn:R03920','KEGG','RNO:100364027',true).
concept_accession('40743: rn:R03920','KEGG','25058',true).
concept_accession('40743: rn:R03920','KEGG','25059',true).
concept_accession('40743: rn:R03920','KEGG','RNO:25058',true).
concept_accession('40743: rn:R03920','KEGG','25060',true).
concept_accession('40743: rn:R03920','KEGG','EC:2.7.1.4',true).
concept_accession('40743: rn:R03920','KEGG','RNO:25059',true).
concept_accession('40743: rn:R03920','KEGG','100364027',true).
concept_accession('40743: rn:R03920','KEGG','2.7.1.4',true).
concept_accession('40743: rn:R03920','KEGG','RNO:25060',true).
concept_accession('40743: rn:R03920','EC','2.7.1.4',true).
concept_accession('40742: rn:R04355','KEGG','50671',true).
concept_accession('40742: rn:R04355','KEGG','2.3.1.180',true).
concept_accession('40742: rn:R04355','EC','2.3.1.180',true).
concept_accession('40742: rn:R04355','KEGG','RNO:50671',true).
concept_accession('40742: rn:R04355','KEGG','EC:2.3.1.180',true).
concept_accession('40737: rn:R03433','KEGG','RNO:54260',true).
concept_accession('40737: rn:R03433','KEGG','81677',true).
concept_accession('40737: rn:R03433','KEGG','RNO:81677',true).
concept_accession('40737: rn:R03433','KEGG','2.7.1.127',true).
concept_accession('40737: rn:R03433','EC','2.7.1.127',true).
concept_accession('40737: rn:R03433','KEGG','54260',true).
concept_accession('40737: rn:R03433','KEGG','EC:2.7.1.127',true).
concept_accession('9715: rn:R09317','KEGG','RN:R09317',true).
concept_accession('9715: rn:R09317','KEGG','1.2.7.4',true).
concept_accession('9715: rn:R09317','KEGG','2.3.1.169',true).
concept_accession('9715: rn:R09317','KEGG','1.2.99.2',true).
concept_accession('9715: rn:R09317','EC','2.3.1.169',false).
concept_accession('9715: rn:R09317','KEGG','EC:2.3.1.169',true).
concept_accession('9715: rn:R09317','KEGG','R09317',true).
concept_accession('9715: rn:R09317','KEGG','EC:1.2.99.2',true).
concept_accession('9715: rn:R09317','EC','1.2.7.4',false).
concept_accession('9715: rn:R09317','KEGG','EC:1.2.7.4',true).
concept_accession('9715: rn:R09317','EC','1.2.99.2',false).
concept_accession('40736: rn:R03428','KEGG','EC:2.7.1.159',true).
concept_accession('40736: rn:R03428','EC','2.7.1.159',true).
concept_accession('40736: rn:R03428','KEGG','500709',true).
concept_accession('40736: rn:R03428','KEGG','2.7.1.159',true).
concept_accession('40736: rn:R03428','KEGG','RNO:500709',true).
concept_accession('40739: rn:R03430','KEGG','EC:3.1.3.56',true).
concept_accession('40739: rn:R03430','EC','3.1.3.56',true).
concept_accession('40739: rn:R03430','KEGG','171088',true).
concept_accession('40739: rn:R03430','KEGG','RNO:171088',true).
concept_accession('40739: rn:R03430','KEGG','287533',true).
concept_accession('40739: rn:R03430','KEGG','RNO:287533',true).
concept_accession('40739: rn:R03430','KEGG','65038',true).
concept_accession('40739: rn:R03430','KEGG','365382',true).
concept_accession('40739: rn:R03430','KEGG','RNO:365382',true).
concept_accession('40739: rn:R03430','KEGG','3.1.3.56',true).
concept_accession('40739: rn:R03430','KEGG','RNO:65038',true).
concept_accession('1937: rn:R00126','KEGG','RN:R00126',true).
concept_accession('1937: rn:R00126','KEGG','EC:2.7.7.53',true).
concept_accession('1937: rn:R00126','EC','2.7.7.53',false).
concept_accession('1937: rn:R00126','KEGG','R00126',true).
concept_accession('1937: rn:R00126','KEGG','2.7.7.53',true).
concept_accession('40738: rn:R04952','KEGG','50671',true).
concept_accession('40738: rn:R04952','KEGG','2.3.1.179',true).
concept_accession('40738: rn:R04952','KEGG','EC:2.3.1.179',true).
concept_accession('40738: rn:R04952','EC','2.3.1.179',true).
concept_accession('40738: rn:R04952','KEGG','RNO:50671',true).
concept_accession('40749: rn:R03427','KEGG','EC:3.1.3.57',true).
concept_accession('40749: rn:R03427','EC','3.1.3.57',true).
concept_accession('40749: rn:R03427','KEGG','RNO:316376',true).
concept_accession('40749: rn:R03427','KEGG','316376',true).
concept_accession('40749: rn:R03427','KEGG','3.1.3.57',true).
concept_accession('40748: rn:R03394','KEGG','EC:3.1.3.56',true).
concept_accession('40748: rn:R03394','EC','3.1.3.56',true).
concept_accession('40748: rn:R03394','KEGG','171088',true).
concept_accession('40748: rn:R03394','KEGG','RNO:171088',true).
concept_accession('40748: rn:R03394','KEGG','287533',true).
concept_accession('40748: rn:R03394','KEGG','RNO:287533',true).
concept_accession('40748: rn:R03394','KEGG','65038',true).
concept_accession('40748: rn:R03394','KEGG','365382',true).
concept_accession('40748: rn:R03394','KEGG','RNO:365382',true).
concept_accession('40748: rn:R03394','KEGG','3.1.3.56',true).
concept_accession('40748: rn:R03394','KEGG','RNO:65038',true).
concept_accession('40751: rn:R02740','KEGG','5.3.1.9',true).
concept_accession('40751: rn:R02740','EC','5.3.1.9',true).
concept_accession('40751: rn:R02740','KEGG','292804',true).
concept_accession('40751: rn:R02740','KEGG','EC:5.3.1.9',true).
concept_accession('40751: rn:R02740','KEGG','RNO:292804',true).
concept_accession('40750: rn:R04533','KEGG','1.1.1.100',true).
concept_accession('40750: rn:R04533','KEGG','50671',true).
concept_accession('40750: rn:R04533','KEGG','EC:1.1.1.100',true).
concept_accession('40750: rn:R04533','KEGG','RNO:50671',true).
concept_accession('40750: rn:R04533','EC','1.1.1.100',true).
concept_accession('40745: rn:R03393','KEGG','EC:3.1.3.57',true).
concept_accession('40745: rn:R03393','EC','3.1.3.57',true).
concept_accession('40745: rn:R03393','KEGG','RNO:316376',true).
concept_accession('40745: rn:R03393','KEGG','316376',true).
concept_accession('40745: rn:R03393','KEGG','3.1.3.57',true).
concept_accession('1947: rn:R00322','KEGG','EC:3.6.1.20',true).
concept_accession('1947: rn:R00322','KEGG','3.6.1.20',true).
concept_accession('1947: rn:R00322','EC','3.6.1.20',false).
concept_accession('1947: rn:R00322','KEGG','RP:RP04359',true).
concept_accession('1947: rn:R00322','KEGG','RC:RC00070',true).
concept_accession('1947: rn:R00322','KEGG','RN:R00322',true).
concept_accession('1947: rn:R00322','KEGG','R00322',true).
concept_accession('1947: rn:R00322','KEGG','RP04359',true).
concept_accession('1947: rn:R00322','KEGG','RC00070',true).
concept_accession('40744: rn:R01626','KEGG','2.3.1.86',true).
concept_accession('40744: rn:R01626','EC','2.3.1.86',true).
concept_accession('40744: rn:R01626','KEGG','RNO:315173',true).
concept_accession('40744: rn:R01626','KEGG','315173',true).
concept_accession('40744: rn:R01626','KEGG','EC:2.3.1.86',true).
concept_accession('40747: rn:R01626','KEGG','50671',true).
concept_accession('40747: rn:R01626','KEGG','2.3.1.86',true).
concept_accession('40747: rn:R01626','EC','2.3.1.86',true).
concept_accession('40747: rn:R01626','KEGG','EC:2.3.1.86',true).
concept_accession('40747: rn:R01626','KEGG','RNO:50671',true).
concept_accession('40746: rn:R04372','KEGG','116699',true).
concept_accession('40746: rn:R04372','KEGG','EC:3.1.3.66',true).
concept_accession('40746: rn:R04372','EC','3.1.3.66',true).
concept_accession('40746: rn:R04372','KEGG','80849',true).
concept_accession('40746: rn:R04372','KEGG','RNO:80849',true).
concept_accession('40746: rn:R04372','KEGG','3.1.3.66',true).
concept_accession('40746: rn:R04372','KEGG','RNO:116699',true).
concept_accession('9703: rn:R00230','KEGG','R00230',true).
concept_accession('9703: rn:R00230','KEGG','2.3.1.8',true).
concept_accession('9703: rn:R00230','KEGG','RN:R00230',true).
concept_accession('9703: rn:R00230','EC','2.3.1.8',false).
concept_accession('9703: rn:R00230','KEGG','EC:2.3.1.8',true).
concept_accession('40756: rn:R03362','KEGG','2.7.1.137',true).
concept_accession('40756: rn:R03362','KEGG','RNO:65052',true).
concept_accession('40756: rn:R03362','KEGG','65052',true).
concept_accession('40756: rn:R03362','EC','2.7.1.137',true).
concept_accession('40756: rn:R03362','KEGG','EC:2.7.1.137',true).
concept_accession('40757: rn:R03361','KEGG','305419',true).
concept_accession('40757: rn:R03361','KEGG','114554',true).
concept_accession('40757: rn:R03361','KEGG','RNO:64161',true).
concept_accession('40757: rn:R03361','KEGG','RNO:81747',true).
concept_accession('40757: rn:R03361','KEGG','64161',true).
concept_accession('40757: rn:R03361','EC','2.7.1.67',true).
concept_accession('40757: rn:R03361','KEGG','RNO:114554',true).
concept_accession('40757: rn:R03361','KEGG','EC:2.7.1.67',true).
concept_accession('40757: rn:R03361','KEGG','RNO:305419',true).
concept_accession('40757: rn:R03361','KEGG','81747',true).
concept_accession('40757: rn:R03361','KEGG','2.7.1.67',true).
concept_accession('40758: rn:R01187','KEGG','RNO:282636',true).
concept_accession('40758: rn:R01187','KEGG','83523',true).
concept_accession('40758: rn:R01187','KEGG','282636',true).
concept_accession('40758: rn:R01187','EC','3.1.3.25',true).
concept_accession('40758: rn:R01187','KEGG','3.1.3.25',true).
concept_accession('40758: rn:R01187','KEGG','EC:3.1.3.25',true).
concept_accession('40758: rn:R01187','KEGG','RNO:83523',true).
concept_accession('40759: rn:R01206','KEGG','289032',true).
concept_accession('40759: rn:R01206','EC','3.2.1.14',true).
concept_accession('40759: rn:R01206','KEGG','RNO:89824',true).
concept_accession('40759: rn:R01206','KEGG','89824',true).
concept_accession('40759: rn:R01206','KEGG','RNO:113901',true).
concept_accession('40759: rn:R01206','KEGG','113901',true).
concept_accession('40759: rn:R01206','KEGG','EC:3.2.1.14',true).
concept_accession('40759: rn:R01206','KEGG','RNO:289032',true).
concept_accession('40759: rn:R01206','KEGG','3.2.1.14',true).
concept_accession('9699: rn:R00943','KEGG','RP00300',true).
concept_accession('9699: rn:R00943','KEGG','6.3.4.3',true).
concept_accession('9699: rn:R00943','KEGG','RC00026',true).
concept_accession('9699: rn:R00943','KEGG','EC:6.3.4.3',true).
concept_accession('9699: rn:R00943','EC','6.3.4.3',false).
concept_accession('9699: rn:R00943','KEGG','RN:R00943',true).
concept_accession('9699: rn:R00943','KEGG','RC:RC00026',true).
concept_accession('9699: rn:R00943','KEGG','R00943',true).
concept_accession('9699: rn:R00943','KEGG','RP00072',true).
concept_accession('9699: rn:R00943','KEGG','RP:RP00300',true).
concept_accession('9699: rn:R00943','KEGG','RC:RC00111',true).
concept_accession('9699: rn:R00943','KEGG','RP:RP00072',true).
concept_accession('9699: rn:R00943','KEGG','RC00111',true).
concept_accession('1923: rn:R01885','KEGG','EC:3.6.1.21',true).
concept_accession('1923: rn:R01885','EC','3.6.1.21',false).
concept_accession('1923: rn:R01885','KEGG','3.6.1.21',true).
concept_accession('1923: rn:R01885','KEGG','R01885',true).
concept_accession('1923: rn:R01885','KEGG','RN:R01885',true).
concept_accession('40752: rn:R03479','KEGG','2.7.1.134',true).
concept_accession('40752: rn:R03479','KEGG','500709',true).
concept_accession('40752: rn:R03479','EC','2.7.1.134',true).
concept_accession('40752: rn:R03479','KEGG','EC:2.7.1.134',true).
concept_accession('40752: rn:R03479','KEGG','RNO:500709',true).
concept_accession('9698: rn:R00134','KEGG','RN:R00134',true).
concept_accession('9698: rn:R00134','KEGG','1.2.1.43',true).
concept_accession('9698: rn:R00134','KEGG','EC:1.2.1.43',true).
concept_accession('9698: rn:R00134','EC','1.2.1.43',false).
concept_accession('9698: rn:R00134','KEGG','R00134',true).
concept_accession('40753: rn:R01326','KEGG','RNO:100364027',true).
concept_accession('40753: rn:R01326','KEGG','25058',true).
concept_accession('40753: rn:R01326','KEGG','25059',true).
concept_accession('40753: rn:R01326','KEGG','RNO:25058',true).
concept_accession('40753: rn:R01326','KEGG','EC:2.7.1.7',true).
concept_accession('40753: rn:R01326','KEGG','25060',true).
concept_accession('40753: rn:R01326','KEGG','RNO:25059',true).
concept_accession('40753: rn:R01326','KEGG','100364027',true).
concept_accession('40753: rn:R01326','KEGG','2.7.1.7',true).
concept_accession('40753: rn:R01326','KEGG','RNO:25060',true).
concept_accession('40753: rn:R01326','EC','2.7.1.7',true).
concept_accession('40754: rn:R03469','KEGG','RNO:309419',true).
concept_accession('40754: rn:R03469','KEGG','RNO:365865',true).
concept_accession('40754: rn:R03469','KEGG','314641',true).
concept_accession('40754: rn:R03469','KEGG','365865',true).
concept_accession('40754: rn:R03469','KEGG','RNO:314641',true).
concept_accession('40754: rn:R03469','KEGG','RNO:687758',true).
concept_accession('40754: rn:R03469','KEGG','EC:2.7.1.68',true).
concept_accession('40754: rn:R03469','EC','2.7.1.68',true).
concept_accession('40754: rn:R03469','KEGG','309419',true).
concept_accession('40754: rn:R03469','KEGG','687758',true).
concept_accession('40754: rn:R03469','KEGG','2.7.1.68',true).
concept_accession('40755: rn:R04386','KEGG','116719',true).
concept_accession('40755: rn:R04386','KEGG','RNO:116719',true).
concept_accession('40755: rn:R04386','KEGG','6.4.1.2',true).
concept_accession('40755: rn:R04386','EC','6.4.1.2',true).
concept_accession('40755: rn:R04386','KEGG','RNO:60581',true).
concept_accession('40755: rn:R04386','KEGG','60581',true).
concept_accession('40755: rn:R04386','KEGG','EC:6.4.1.2',true).
concept_accession('40764: rn:R01186','KEGG','RNO:282636',true).
concept_accession('40764: rn:R01186','KEGG','83523',true).
concept_accession('40764: rn:R01186','KEGG','282636',true).
concept_accession('40764: rn:R01186','EC','3.1.3.25',true).
concept_accession('40764: rn:R01186','KEGG','3.1.3.25',true).
concept_accession('40764: rn:R01186','KEGG','EC:3.1.3.25',true).
concept_accession('40764: rn:R01186','KEGG','RNO:83523',true).
concept_accession('40765: rn:R04385','KEGG','116719',true).
concept_accession('40765: rn:R04385','KEGG','RNO:116719',true).
concept_accession('40765: rn:R04385','KEGG','6.3.4.14',true).
concept_accession('40765: rn:R04385','KEGG','RNO:60581',true).
concept_accession('40765: rn:R04385','KEGG','60581',true).
concept_accession('40765: rn:R04385','EC','6.3.4.14',true).
concept_accession('40765: rn:R04385','KEGG','EC:6.3.4.14',true).
concept_accession('40766: rn:R01384','KEGG','4.1.1.35',true).
concept_accession('40766: rn:R01384','KEGG','246232',true).
concept_accession('40766: rn:R01384','KEGG','RNO:246232',true).
concept_accession('40766: rn:R01384','EC','4.1.1.35',true).
concept_accession('40766: rn:R01384','KEGG','EC:4.1.1.35',true).
concept_accession('40767: rn:R03527','KEGG','EC:3.2.1.21',true).
concept_accession('40767: rn:R03527','KEGG','3.2.1.21',true).
concept_accession('40767: rn:R03527','EC','3.2.1.21',true).
concept_accession('40767: rn:R03527','KEGG','RNO:289687',true).
concept_accession('40767: rn:R03527','KEGG','289687',true).
concept_accession('40760: rn:R01184','KEGG','1.13.99.1',true).
concept_accession('40760: rn:R01184','EC','1.13.99.1',true).
concept_accession('40760: rn:R01184','KEGG','RNO:252899',true).
concept_accession('40760: rn:R01184','KEGG','252899',true).
concept_accession('40760: rn:R01184','KEGG','EC:1.13.99.1',true).
concept_accession('40761: rn:R00289','KEGG','289827',true).
concept_accession('40761: rn:R00289','KEGG','EC:2.7.7.9',true).
concept_accession('40761: rn:R00289','KEGG','2.7.7.9',true).
concept_accession('40761: rn:R00289','KEGG','RNO:289827',true).
concept_accession('40761: rn:R00289','EC','2.7.7.9',true).
concept_accession('9705: rn:R00237','EC','4.1.3.25',false).
concept_accession('9705: rn:R00237','KEGG','RP:RP04393',true).
concept_accession('9705: rn:R00237','KEGG','RC:RC00502',true).
concept_accession('9705: rn:R00237','KEGG','RN:R00237',true).
concept_accession('9705: rn:R00237','KEGG','RC:RC01205',true).
concept_accession('9705: rn:R00237','KEGG','R00237',true).
concept_accession('9705: rn:R00237','KEGG','RP04393',true).
concept_accession('9705: rn:R00237','KEGG','RC00502',true).
concept_accession('9705: rn:R00237','KEGG','EC:4.1.3.25',true).
concept_accession('9705: rn:R00237','KEGG','RC01205',true).
concept_accession('9705: rn:R00237','KEGG','4.1.3.25',true).
concept_accession('9705: rn:R00237','KEGG','RP04364',true).
concept_accession('9705: rn:R00237','KEGG','RP:RP04364',true).
concept_accession('40762: rn:R07324','KEGG','RNO:290651',true).
concept_accession('40762: rn:R07324','EC','5.5.1.4',true).
concept_accession('40762: rn:R07324','KEGG','290651',true).
concept_accession('40762: rn:R07324','KEGG','EC:5.5.1.4',true).
concept_accession('40762: rn:R07324','KEGG','5.5.1.4',true).
concept_accession('40763: rn:R01624','KEGG','50671',true).
concept_accession('40763: rn:R01624','KEGG','2.3.1.180',true).
concept_accession('40763: rn:R01624','EC','2.3.1.180',true).
concept_accession('40763: rn:R01624','KEGG','RNO:50671',true).
concept_accession('40763: rn:R01624','KEGG','EC:2.3.1.180',true).
concept_accession('2201: rn:R02022','EC','1.17.4.2',false).
concept_accession('2201: rn:R02022','KEGG','RC00613',true).
concept_accession('2201: rn:R02022','KEGG','RN:R02022',true).
concept_accession('2201: rn:R02022','KEGG','1.17.4.2',true).
concept_accession('2201: rn:R02022','KEGG','RC:RC00613',true).
concept_accession('2201: rn:R02022','KEGG','RP01916',true).
concept_accession('2201: rn:R02022','KEGG','EC:1.17.4.2',true).
concept_accession('2201: rn:R02022','KEGG','RP:RP01916',true).
concept_accession('2201: rn:R02022','KEGG','R02022',true).
concept_accession('2205: rn:R02325','KEGG','RP02125',true).
concept_accession('2205: rn:R02325','KEGG','R02325',true).
concept_accession('2205: rn:R02325','KEGG','EC:3.5.4.13',true).
concept_accession('2205: rn:R02325','KEGG','RC00074',true).
concept_accession('2205: rn:R02325','KEGG','RP:RP02125',true).
concept_accession('2205: rn:R02325','KEGG','RN:R02325',true).
concept_accession('2205: rn:R02325','KEGG','3.5.4.13',true).
concept_accession('2205: rn:R02325','KEGG','RC:RC00074',true).
concept_accession('2205: rn:R02325','EC','3.5.4.13',false).
concept_accession('6539: rn:R05146','KEGG','RP03636',true).
concept_accession('6539: rn:R05146','KEGG','RN:R05146',true).
concept_accession('6539: rn:R05146','KEGG','RC00037',true).
concept_accession('6539: rn:R05146','KEGG','R05146',true).
concept_accession('6539: rn:R05146','KEGG','RC00039',true).
concept_accession('6539: rn:R05146','KEGG','RC:RC00037',true).
concept_accession('6539: rn:R05146','KEGG','RC:RC00039',true).
concept_accession('6539: rn:R05146','KEGG','EC:2.3.1.-',true).
concept_accession('6539: rn:R05146','EC','2.3.1.-',false).
concept_accession('6539: rn:R05146','KEGG','RP11624',true).
concept_accession('6539: rn:R05146','KEGG','RP:RP03636',true).
concept_accession('6539: rn:R05146','KEGG','2.3.1.-',true).
concept_accession('6539: rn:R05146','KEGG','RP:RP11624',true).
concept_accession('6540: rn:R05075','KEGG','RP04579',true).
concept_accession('6540: rn:R05075','KEGG','RC00037',true).
concept_accession('6540: rn:R05075','KEGG','RC00039',true).
concept_accession('6540: rn:R05075','KEGG','RN:R05075',true).
concept_accession('6540: rn:R05075','KEGG','RC:RC00037',true).
concept_accession('6540: rn:R05075','KEGG','RC:RC00039',true).
concept_accession('6540: rn:R05075','KEGG','R05075',true).
concept_accession('6540: rn:R05075','KEGG','EC:2.3.1.-',true).
concept_accession('6540: rn:R05075','EC','2.3.1.-',false).
concept_accession('6540: rn:R05075','KEGG','RP11625',true).
concept_accession('6540: rn:R05075','KEGG','RP:RP04579',true).
concept_accession('6540: rn:R05075','KEGG','2.3.1.-',true).
concept_accession('6540: rn:R05075','KEGG','RP:RP11625',true).
concept_accession('2209: rn:R01668','KEGG','RC00002',true).
concept_accession('2209: rn:R01668','KEGG','RP01678',true).
concept_accession('2209: rn:R01668','KEGG','R01668',true).
concept_accession('2209: rn:R01668','KEGG','RN:R01668',true).
concept_accession('2209: rn:R01668','KEGG','3.6.1.12',true).
concept_accession('2209: rn:R01668','KEGG','RP:RP01678',true).
concept_accession('2209: rn:R01668','EC','3.6.1.12',false).
concept_accession('2209: rn:R01668','KEGG','EC:3.6.1.12',true).
concept_accession('2209: rn:R01668','KEGG','RC:RC00002',true).
concept_accession('6639: rn:R01048','KEGG','R01048',true).
concept_accession('6639: rn:R01048','EC','4.2.1.30',false).
concept_accession('6639: rn:R01048','KEGG','RC00430',true).
concept_accession('6639: rn:R01048','KEGG','RC:RC00430',true).
concept_accession('6639: rn:R01048','KEGG','RP01254',true).
concept_accession('6639: rn:R01048','KEGG','4.2.1.30',true).
concept_accession('6639: rn:R01048','KEGG','RP:RP01254',true).
concept_accession('6639: rn:R01048','KEGG','RN:R01048',true).
concept_accession('6639: rn:R01048','KEGG','EC:4.2.1.30',true).
concept_accession('6633: rn:R01034','KEGG','R01034',true).
concept_accession('6633: rn:R01034','KEGG','1.1.1.6',true).
concept_accession('6633: rn:R01034','EC','1.1.1.6',false).
concept_accession('6633: rn:R01034','KEGG','RC00029',true).
concept_accession('6633: rn:R01034','KEGG','RN:R01034',true).
concept_accession('6633: rn:R01034','KEGG','RP00157',true).
concept_accession('6633: rn:R01034','KEGG','RC:RC00029',true).
concept_accession('6633: rn:R01034','KEGG','RP:RP00157',true).
concept_accession('6633: rn:R01034','KEGG','EC:1.1.1.6',true).
concept_accession('6634: rn:R01039','KEGG','R01039',true).
concept_accession('6634: rn:R01039','KEGG','RC00029',true).
concept_accession('6634: rn:R01039','EC','1.1.1.156',false).
concept_accession('6634: rn:R01039','KEGG','1.1.1.156',true).
concept_accession('6634: rn:R01039','KEGG','RN:R01039',true).
concept_accession('6634: rn:R01039','KEGG','EC:1.1.1.156',true).
concept_accession('6634: rn:R01039','KEGG','RP00157',true).
concept_accession('6634: rn:R01039','KEGG','RC:RC00029',true).
concept_accession('6634: rn:R01039','KEGG','RP:RP00157',true).
concept_accession('2255: rn:R00515','KEGG','RC00002',true).
concept_accession('2255: rn:R00515','KEGG','RN:R00515',true).
concept_accession('2255: rn:R00515','KEGG','3.6.1.8',true).
concept_accession('2255: rn:R00515','KEGG','RP00950',true).
concept_accession('2255: rn:R00515','KEGG','EC:3.6.1.8',true).
concept_accession('2255: rn:R00515','KEGG','RC:RC00002',true).
concept_accession('2255: rn:R00515','KEGG','RP:RP00950',true).
concept_accession('2255: rn:R00515','EC','3.6.1.8',false).
concept_accession('2255: rn:R00515','KEGG','R00515',true).
concept_accession('6651: rn:R04471','KEGG','3.1.1.26',true).
concept_accession('6651: rn:R04471','KEGG','RC00495',true).
concept_accession('6651: rn:R04471','KEGG','EC:3.1.1.26',true).
concept_accession('6651: rn:R04471','KEGG','RP04110',true).
concept_accession('6651: rn:R04471','KEGG','RP:RP04110',true).
concept_accession('6651: rn:R04471','KEGG','RN:R04471',true).
concept_accession('6651: rn:R04471','KEGG','RC:RC00495',true).
concept_accession('6651: rn:R04471','KEGG','R04471',true).
concept_accession('6651: rn:R04471','EC','3.1.1.26',false).
concept_accession('2250: rn:R00287','KEGG','RC00002',true).
concept_accession('2250: rn:R00287','KEGG','3.6.1.9',true).
concept_accession('2250: rn:R00287','KEGG','R00287',true).
concept_accession('2250: rn:R00287','KEGG','RP00315',true).
concept_accession('2250: rn:R00287','KEGG','RP:RP00315',true).
concept_accession('2250: rn:R00287','KEGG','RN:R00287',true).
concept_accession('2250: rn:R00287','KEGG','EC:3.6.1.9',true).
concept_accession('2250: rn:R00287','KEGG','RC:RC00002',true).
concept_accession('2250: rn:R00287','EC','3.6.1.9',false).
concept_accession('6620: rn:R02691','EC','2.4.1.46',false).
concept_accession('6620: rn:R02691','KEGG','RC:RC00059',true).
concept_accession('6620: rn:R02691','KEGG','R02691',true).
concept_accession('6620: rn:R02691','KEGG','RP02415',true).
concept_accession('6620: rn:R02691','KEGG','2.4.1.46',true).
concept_accession('6620: rn:R02691','KEGG','RN:R02691',true).
concept_accession('6620: rn:R02691','KEGG','EC:2.4.1.46',true).
concept_accession('6620: rn:R02691','KEGG','RP:RP02415',true).
concept_accession('6620: rn:R02691','KEGG','RC00059',true).
concept_accession('6442: rn:R07817','KEGG','3.1.6.18',true).
concept_accession('6442: rn:R07817','KEGG','R07817',true).
concept_accession('6442: rn:R07817','KEGG','RN:R07817',true).
concept_accession('6442: rn:R07817','KEGG','EC:3.1.6.18',true).
concept_accession('6442: rn:R07817','EC','3.1.6.18',false).
concept_accession('2050: rn:R00150','KEGG','RN:R00150',true).
concept_accession('2050: rn:R00150','KEGG','EC:2.7.2.2',true).
concept_accession('2050: rn:R00150','EC','2.7.2.2',false).
concept_accession('2050: rn:R00150','KEGG','2.7.2.2',true).
concept_accession('2050: rn:R00150','KEGG','R00150',true).
concept_accession('2100: rn:R07969 rn:R07970','EC','1.13.12.-',false).
concept_accession('2100: rn:R07969 rn:R07970','KEGG','RC:RC00334',true).
concept_accession('2100: rn:R07969 rn:R07970','KEGG','R07970',true).
concept_accession('2100: rn:R07969 rn:R07970','KEGG','1.13.12.-',true).
concept_accession('2100: rn:R07969 rn:R07970','KEGG','RP:RP11122',true).
concept_accession('2100: rn:R07969 rn:R07970','KEGG','EC:1.13.12.-',true).
concept_accession('2100: rn:R07969 rn:R07970','KEGG','RC00334',true).
concept_accession('2100: rn:R07969 rn:R07970','KEGG','RN:R07969',true).
concept_accession('2100: rn:R07969 rn:R07970','KEGG','RN:R07970',true).
concept_accession('2100: rn:R07969 rn:R07970','KEGG','R07969',true).
concept_accession('2100: rn:R07969 rn:R07970','KEGG','RP11122',true).
concept_accession('2111: rn:R07919','KEGG','RC:RC00334',true).
concept_accession('2111: rn:R07919','KEGG','2.1.1.160',true).
concept_accession('2111: rn:R07919','KEGG','RP:RP11717',true).
concept_accession('2111: rn:R07919','KEGG','EC:2.1.1.160',true).
concept_accession('2111: rn:R07919','KEGG','RN:R07919',true).
concept_accession('2111: rn:R07919','EC','2.1.1.160',false).
concept_accession('2111: rn:R07919','KEGG','R07919',true).
concept_accession('2111: rn:R07919','KEGG','RC00334',true).
concept_accession('2111: rn:R07919','KEGG','RP11717',true).
concept_accession('2110: rn:R07955 rn:R07956','EC','1.13.12.-',false).
concept_accession('2110: rn:R07955 rn:R07956','KEGG','RC:RC00334',true).
concept_accession('2110: rn:R07955 rn:R07956','KEGG','1.13.12.-',true).
concept_accession('2110: rn:R07955 rn:R07956','KEGG','RP:RP11716',true).
concept_accession('2110: rn:R07955 rn:R07956','KEGG','R07955',true).
concept_accession('2110: rn:R07955 rn:R07956','KEGG','R07956',true).
concept_accession('2110: rn:R07955 rn:R07956','KEGG','RP11716',true).
concept_accession('2110: rn:R07955 rn:R07956','KEGG','RN:R07955',true).
concept_accession('2110: rn:R07955 rn:R07956','KEGG','EC:1.13.12.-',true).
concept_accession('2110: rn:R07955 rn:R07956','KEGG','RC00334',true).
concept_accession('2110: rn:R07955 rn:R07956','KEGG','RN:R07956',true).
concept_accession('2109: rn:R07980','KEGG','R07980',true).
concept_accession('2109: rn:R07980','KEGG','EC:1.17.5.-',true).
concept_accession('2109: rn:R07980','KEGG','RP:RP11721',true).
concept_accession('2109: rn:R07980','KEGG','RC:RC02017',true).
concept_accession('2109: rn:R07980','KEGG','RP11721',true).
concept_accession('2109: rn:R07980','KEGG','RC02017',true).
concept_accession('2109: rn:R07980','EC','1.17.5.-',false).
concept_accession('2109: rn:R07980','KEGG','1.17.5.-',true).
concept_accession('2109: rn:R07980','KEGG','RN:R07980',true).
concept_accession('2108: rn:R07961 rn:R07962','EC','1.13.12.-',false).
concept_accession('2108: rn:R07961 rn:R07962','KEGG','RC:RC00334',true).
concept_accession('2108: rn:R07961 rn:R07962','KEGG','RN:R07961',true).
concept_accession('2108: rn:R07961 rn:R07962','KEGG','RN:R07962',true).
concept_accession('2108: rn:R07961 rn:R07962','KEGG','1.13.12.-',true).
concept_accession('2108: rn:R07961 rn:R07962','KEGG','R07961',true).
concept_accession('2108: rn:R07961 rn:R07962','KEGG','RP:RP11717',true).
concept_accession('2108: rn:R07961 rn:R07962','KEGG','R07962',true).
concept_accession('2108: rn:R07961 rn:R07962','KEGG','EC:1.13.12.-',true).
concept_accession('2108: rn:R07961 rn:R07962','KEGG','RC00334',true).
concept_accession('2108: rn:R07961 rn:R07962','KEGG','RP11717',true).
concept_accession('6419: rn:R07815','KEGG','2.3.1.78',true).
concept_accession('6419: rn:R07815','KEGG','R07815',true).
concept_accession('6419: rn:R07815','KEGG','RN:R07815',true).
concept_accession('6419: rn:R07815','KEGG','EC:2.3.1.78',true).
concept_accession('6419: rn:R07815','EC','2.3.1.78',false).
concept_accession('6423: rn:R07817','KEGG','3.1.6.18',true).
concept_accession('6423: rn:R07817','KEGG','R07817',true).
concept_accession('6423: rn:R07817','KEGG','RN:R07817',true).
concept_accession('6423: rn:R07817','KEGG','EC:3.1.6.18',true).
concept_accession('6423: rn:R07817','EC','3.1.6.18',false).
concept_accession('2142: rn:R07982','KEGG','RP:RP10831',true).
concept_accession('2142: rn:R07982','KEGG','RC:RC02109',true).
concept_accession('2142: rn:R07982','KEGG','RP10831',true).
concept_accession('2142: rn:R07982','KEGG','R07982',true).
concept_accession('2142: rn:R07982','KEGG','RC:RC02108',true).
concept_accession('2142: rn:R07982','KEGG','RC02109',true).
concept_accession('2142: rn:R07982','KEGG','RN:R07982',true).
concept_accession('2142: rn:R07982','KEGG','RC02108',true).
concept_accession('2142: rn:R07982','KEGG','RC01791',true).
concept_accession('2142: rn:R07982','KEGG','RP:RP12178',true).
concept_accession('2142: rn:R07982','KEGG','RP:RP12179',true).
concept_accession('2142: rn:R07982','KEGG','RC:RC01791',true).
concept_accession('2142: rn:R07982','KEGG','RP12178',true).
concept_accession('2142: rn:R07982','KEGG','RP12179',true).
concept_accession('2139: rn:R07922','KEGG','RC:RC00334',true).
concept_accession('2139: rn:R07922','KEGG','RP11917',true).
concept_accession('2139: rn:R07922','KEGG','RN:R07922',true).
concept_accession('2139: rn:R07922','KEGG','R07922',true).
concept_accession('2139: rn:R07922','KEGG','RC00334',true).
concept_accession('2139: rn:R07922','KEGG','RP:RP11917',true).
concept_accession('2119: rn:R07965 rn:R07966','EC','1.13.12.-',false).
concept_accession('2119: rn:R07965 rn:R07966','KEGG','RC:RC01827',true).
concept_accession('2119: rn:R07965 rn:R07966','KEGG','1.13.12.-',true).
concept_accession('2119: rn:R07965 rn:R07966','KEGG','RC01827',true).
concept_accession('2119: rn:R07965 rn:R07966','KEGG','RN:R07965',true).
concept_accession('2119: rn:R07965 rn:R07966','KEGG','RP11120',true).
concept_accession('2119: rn:R07965 rn:R07966','KEGG','RN:R07966',true).
concept_accession('2119: rn:R07965 rn:R07966','KEGG','RP:RP11120',true).
concept_accession('2119: rn:R07965 rn:R07966','KEGG','R07965',true).
concept_accession('2119: rn:R07965 rn:R07966','KEGG','R07966',true).
concept_accession('2119: rn:R07965 rn:R07966','KEGG','EC:1.13.12.-',true).
concept_accession('2112: rn:R07920','KEGG','RC:RC00334',true).
concept_accession('2112: rn:R07920','KEGG','R07920',true).
concept_accession('2112: rn:R07920','KEGG','2.1.1.160',true).
concept_accession('2112: rn:R07920','KEGG','EC:2.1.1.160',true).
concept_accession('2112: rn:R07920','KEGG','RP:RP11716',true).
concept_accession('2112: rn:R07920','EC','2.1.1.160',false).
concept_accession('2112: rn:R07920','KEGG','RP11716',true).
concept_accession('2112: rn:R07920','KEGG','RC00334',true).
concept_accession('2112: rn:R07920','KEGG','RN:R07920',true).
concept_accession('2115: rn:R07919','KEGG','RC:RC00334',true).
concept_accession('2115: rn:R07919','KEGG','2.1.1.160',true).
concept_accession('2115: rn:R07919','KEGG','RP:RP11717',true).
concept_accession('2115: rn:R07919','KEGG','EC:2.1.1.160',true).
concept_accession('2115: rn:R07919','KEGG','RN:R07919',true).
concept_accession('2115: rn:R07919','EC','2.1.1.160',false).
concept_accession('2115: rn:R07919','KEGG','R07919',true).
concept_accession('2115: rn:R07919','KEGG','RC00334',true).
concept_accession('2115: rn:R07919','KEGG','RP11717',true).
concept_accession('2120: rn:R07957 rn:R07958','EC','1.13.12.-',false).
concept_accession('2120: rn:R07957 rn:R07958','KEGG','RC:RC00334',true).
concept_accession('2120: rn:R07957 rn:R07958','KEGG','RP11917',true).
concept_accession('2120: rn:R07957 rn:R07958','KEGG','1.13.12.-',true).
concept_accession('2120: rn:R07957 rn:R07958','KEGG','RN:R07957',true).
concept_accession('2120: rn:R07957 rn:R07958','KEGG','RN:R07958',true).
concept_accession('2120: rn:R07957 rn:R07958','KEGG','EC:1.13.12.-',true).
concept_accession('2120: rn:R07957 rn:R07958','KEGG','RC00334',true).
concept_accession('2120: rn:R07957 rn:R07958','KEGG','R07957',true).
concept_accession('2120: rn:R07957 rn:R07958','KEGG','RP:RP11917',true).
concept_accession('2120: rn:R07957 rn:R07958','KEGG','R07958',true).
concept_accession('2148: rn:R07307','KEGG','RP11109',true).
concept_accession('2148: rn:R07307','KEGG','3.5.4.30',true).
concept_accession('2148: rn:R07307','KEGG','RC01825',true).
concept_accession('2148: rn:R07307','KEGG','RP:RP11109',true).
concept_accession('2148: rn:R07307','KEGG','RC:RC01825',true).
concept_accession('2148: rn:R07307','EC','3.5.4.30',false).
concept_accession('2148: rn:R07307','KEGG','R07307',true).
concept_accession('2148: rn:R07307','KEGG','RN:R07307',true).
concept_accession('2148: rn:R07307','KEGG','EC:3.5.4.30',true).
concept_accession('41568: rn:R01710','KEGG','64533',true).
concept_accession('41568: rn:R01710','KEGG','RNO:64533',true).
concept_accession('41568: rn:R01710','KEGG','EC:1.4.3.5',true).
concept_accession('41568: rn:R01710','EC','1.4.3.5',true).
concept_accession('41568: rn:R01710','KEGG','1.4.3.5',true).
concept_accession('41569: rn:R00277','KEGG','64533',true).
concept_accession('41569: rn:R00277','KEGG','RNO:64533',true).
concept_accession('41569: rn:R00277','KEGG','EC:1.4.3.5',true).
concept_accession('41569: rn:R00277','EC','1.4.3.5',true).
concept_accession('41569: rn:R00277','KEGG','1.4.3.5',true).
concept_accession('41570: rn:R02494','KEGG','RNO:295663',true).
concept_accession('41570: rn:R02494','KEGG','RNO:727679',true).
concept_accession('41570: rn:R02494','EC','3.1.3.74',true).
concept_accession('41570: rn:R02494','KEGG','EC:3.1.3.74',true).
concept_accession('41570: rn:R02494','KEGG','727679',true).
concept_accession('41570: rn:R02494','KEGG','3.1.3.74',true).
concept_accession('41570: rn:R02494','KEGG','295663',true).
concept_accession('41571: rn:R02493','KEGG','EC:2.7.1.35',true).
concept_accession('41571: rn:R02493','EC','2.7.1.35',true).
concept_accession('41571: rn:R02493','KEGG','RNO:361819',true).
concept_accession('41571: rn:R02493','KEGG','RNO:83578',true).
concept_accession('41571: rn:R02493','KEGG','361819',true).
concept_accession('41571: rn:R02493','KEGG','2.7.1.35',true).
concept_accession('41571: rn:R02493','KEGG','83578',true).
concept_accession('41546: rn:R00135','KEGG','RNO:289668',true).
concept_accession('41546: rn:R00135','KEGG','289668',true).
concept_accession('41546: rn:R00135','KEGG','EC:3.4.11.5',true).
concept_accession('41546: rn:R00135','KEGG','3.4.11.5',true).
concept_accession('41546: rn:R00135','EC','3.4.11.5',true).
concept_accession('41547: rn:R00669','KEGG','3.5.1.14',true).
concept_accession('41547: rn:R00669','EC','3.5.1.14',true).
concept_accession('41547: rn:R00669','KEGG','RNO:300981',true).
concept_accession('41547: rn:R00669','KEGG','300981',true).
concept_accession('41547: rn:R00669','KEGG','EC:3.5.1.14',true).
concept_accession('41544: rn:R08408','KEGG','RNO:316421',true).
concept_accession('41544: rn:R08408','KEGG','RNO:54349',true).
concept_accession('41544: rn:R08408','EC','1.2.3.1',true).
concept_accession('41544: rn:R08408','KEGG','EC:1.2.3.1',true).
concept_accession('41544: rn:R08408','KEGG','54349',true).
concept_accession('41544: rn:R08408','KEGG','316421',true).
concept_accession('41544: rn:R08408','KEGG','1.2.3.1',true).
concept_accession('41545: rn:R04085','KEGG','RNO:316421',true).
concept_accession('41545: rn:R04085','KEGG','RNO:54349',true).
concept_accession('41545: rn:R04085','EC','1.2.3.1',true).
concept_accession('41545: rn:R04085','KEGG','EC:1.2.3.1',true).
concept_accession('41545: rn:R04085','KEGG','54349',true).
concept_accession('41545: rn:R04085','KEGG','316421',true).
concept_accession('41545: rn:R04085','KEGG','1.2.3.1',true).
concept_accession('41550: rn:R01086','KEGG','59085',true).
concept_accession('41550: rn:R01086','KEGG','EC:4.3.2.1',true).
concept_accession('41550: rn:R01086','KEGG','4.3.2.1',true).
concept_accession('41550: rn:R01086','KEGG','RNO:59085',true).
concept_accession('41550: rn:R01086','EC','4.3.2.1',true).
concept_accession('41551: rn:R00278','KEGG','64533',true).
concept_accession('41551: rn:R00278','KEGG','RNO:64533',true).
concept_accession('41551: rn:R00278','KEGG','EC:1.4.3.5',true).
concept_accession('41551: rn:R00278','EC','1.4.3.5',true).
concept_accession('41551: rn:R00278','KEGG','1.4.3.5',true).
concept_accession('41548: rn:R01711','KEGG','64533',true).
concept_accession('41548: rn:R01711','KEGG','RNO:64533',true).
concept_accession('41548: rn:R01711','KEGG','EC:1.4.3.5',true).
concept_accession('41548: rn:R01711','EC','1.4.3.5',true).
concept_accession('41548: rn:R01711','KEGG','1.4.3.5',true).
concept_accession('41549: rn:R00551','KEGG','29221',true).
concept_accession('41549: rn:R00551','KEGG','3.5.3.1',true).
concept_accession('41549: rn:R00551','KEGG','RNO:29215',true).
concept_accession('41549: rn:R00551','KEGG','29215',true).
concept_accession('41549: rn:R00551','KEGG','RNO:29221',true).
concept_accession('41549: rn:R00551','EC','3.5.3.1',true).
concept_accession('41549: rn:R00551','KEGG','EC:3.5.3.1',true).
concept_accession('41538: rn:R01269','EC','2.1.1.1',true).
concept_accession('41538: rn:R01269','KEGG','2.1.1.1',true).
concept_accession('41538: rn:R01269','KEGG','300691',true).
concept_accession('41538: rn:R01269','KEGG','EC:2.1.1.1',true).
concept_accession('41538: rn:R01269','KEGG','RNO:300691',true).
concept_accession('41539: rn:R01253','KEGG','RNO:680409',true).
concept_accession('41539: rn:R01253','KEGG','EC:1.5.99.8',true).
concept_accession('41539: rn:R01253','KEGG','680409',true).
concept_accession('41539: rn:R01253','EC','1.5.99.8',true).
concept_accession('41539: rn:R01253','KEGG','1.5.99.8',true).
concept_accession('41536: rn:R00102','KEGG','EC:3.2.2.5',true).
concept_accession('41536: rn:R00102','EC','3.2.2.5',true).
concept_accession('41536: rn:R00102','KEGG','RNO:81506',true).
concept_accession('41536: rn:R00102','KEGG','25668',true).
concept_accession('41536: rn:R00102','KEGG','3.2.2.5',true).
concept_accession('41536: rn:R00102','KEGG','RNO:25668',true).
concept_accession('41536: rn:R00102','KEGG','81506',true).
concept_accession('41537: rn:R01248 rn:R01251','KEGG','RNO:300035',true).
concept_accession('41537: rn:R01248 rn:R01251','KEGG','364064',true).
concept_accession('41537: rn:R01248 rn:R01251','KEGG','EC:1.5.1.2',true).
concept_accession('41537: rn:R01248 rn:R01251','KEGG','287877',true).
concept_accession('41537: rn:R01248 rn:R01251','EC','1.5.1.2',true).
concept_accession('41537: rn:R01248 rn:R01251','KEGG','RNO:287877',true).
concept_accession('41537: rn:R01248 rn:R01251','KEGG','RNO:364064',true).
concept_accession('41537: rn:R01248 rn:R01251','KEGG','1.5.1.2',true).
concept_accession('41537: rn:R01248 rn:R01251','KEGG','300035',true).
concept_accession('41542: rn:R00112','EC','1.6.1.1',true).
concept_accession('41542: rn:R00112','KEGG','RNO:310378',true).
concept_accession('41542: rn:R00112','KEGG','1.6.1.1',true).
concept_accession('41542: rn:R00112','KEGG','EC:1.6.1.1',true).
concept_accession('41542: rn:R00112','KEGG','310378',true).
concept_accession('41543: rn:R01252','EC','1.14.11.2',true).
concept_accession('41543: rn:R01252','KEGG','360526',true).
concept_accession('41543: rn:R01252','KEGG','RNO:64475',true).
concept_accession('41543: rn:R01252','KEGG','1.14.11.2',true).
concept_accession('41543: rn:R01252','KEGG','RNO:361612',true).
concept_accession('41543: rn:R01252','KEGG','EC:1.14.11.2',true).
concept_accession('41543: rn:R01252','KEGG','RNO:360526',true).
concept_accession('41543: rn:R01252','KEGG','361612',true).
concept_accession('41543: rn:R01252','KEGG','64475',true).
concept_accession('41540: rn:R00104','KEGG','2.7.1.23',true).
concept_accession('41540: rn:R00104','KEGG','100125370',true).
concept_accession('41540: rn:R00104','KEGG','RNO:100125370',true).
concept_accession('41540: rn:R00104','KEGG','EC:2.7.1.23',true).
concept_accession('41540: rn:R00104','EC','2.7.1.23',true).
concept_accession('41541: rn:R00667','KEGG','EC:2.6.1.13',true).
concept_accession('41541: rn:R00667','KEGG','2.6.1.13',true).
concept_accession('41541: rn:R00667','KEGG','64313',true).
concept_accession('41541: rn:R00667','EC','2.6.1.13',true).
concept_accession('41541: rn:R00667','KEGG','RNO:64313',true).
concept_accession('41563: rn:R03004','KEGG','RNO:85496',true).
concept_accession('41563: rn:R03004','KEGG','RNO:54410',true).
concept_accession('41563: rn:R03004','KEGG','3.6.1.9',true).
concept_accession('41563: rn:R03004','KEGG','54410',true).
concept_accession('41563: rn:R03004','KEGG','85496',true).
concept_accession('41563: rn:R03004','KEGG','EC:3.6.1.9',true).
concept_accession('41563: rn:R03004','EC','3.6.1.9',true).
concept_accession('41562: rn:R00253','KEGG','RNO:24957',true).
concept_accession('41562: rn:R00253','KEGG','EC:6.3.1.2',true).
concept_accession('41562: rn:R00253','KEGG','24957',true).
concept_accession('41562: rn:R00253','EC','6.3.1.2',true).
concept_accession('41562: rn:R00253','KEGG','6.3.1.2',true).
concept_accession('41561: rn:R01911','KEGG','RNO:295663',true).
concept_accession('41561: rn:R01911','KEGG','RNO:727679',true).
concept_accession('41561: rn:R01911','EC','3.1.3.74',true).
concept_accession('41561: rn:R01911','KEGG','EC:3.1.3.74',true).
concept_accession('41561: rn:R01911','KEGG','727679',true).
concept_accession('41561: rn:R01911','KEGG','3.1.3.74',true).
concept_accession('41561: rn:R01911','KEGG','295663',true).
concept_accession('41560: rn:R01909','KEGG','EC:2.7.1.35',true).
concept_accession('41560: rn:R01909','EC','2.7.1.35',true).
concept_accession('41560: rn:R01909','KEGG','RNO:361819',true).
concept_accession('41560: rn:R01909','KEGG','RNO:83578',true).
concept_accession('41560: rn:R01909','KEGG','361819',true).
concept_accession('41560: rn:R01909','KEGG','2.7.1.35',true).
concept_accession('41560: rn:R01909','KEGG','83578',true).
concept_accession('41567: rn:R00119','KEGG','EC:3.2.2.6',true).
concept_accession('41567: rn:R00119','EC','3.2.2.6',true).
concept_accession('41567: rn:R00119','KEGG','RNO:81506',true).
concept_accession('41567: rn:R00119','KEGG','25668',true).
concept_accession('41567: rn:R00119','KEGG','3.2.2.6',true).
concept_accession('41567: rn:R00119','KEGG','RNO:25668',true).
concept_accession('41567: rn:R00119','KEGG','81506',true).
concept_accession('41566: rn:R03004','KEGG','3.6.1.9',true).
concept_accession('41566: rn:R03004','KEGG','367323',true).
concept_accession('41566: rn:R03004','KEGG','RNO:367323',true).
concept_accession('41566: rn:R03004','KEGG','EC:3.6.1.9',true).
concept_accession('41566: rn:R03004','EC','3.6.1.9',true).
concept_accession('41565: rn:R03348','KEGG','293504',true).
concept_accession('41565: rn:R03348','KEGG','2.4.2.19',true).
concept_accession('41565: rn:R03348','KEGG','RNO:293504',true).
concept_accession('41565: rn:R03348','KEGG','EC:2.4.2.19',true).
concept_accession('41565: rn:R03348','EC','2.4.2.19',true).
concept_accession('41564: rn:R03346','KEGG','RNO:313574',true).
concept_accession('41564: rn:R03346','KEGG','100363253',true).
concept_accession('41564: rn:R03346','KEGG','RNO:688261',true).
concept_accession('41564: rn:R03346','KEGG','RNO:287368',true).
concept_accession('41564: rn:R03346','KEGG','688261',true).
concept_accession('41564: rn:R03346','EC','3.1.3.5',true).
concept_accession('41564: rn:R03346','KEGG','313574',true).
concept_accession('41564: rn:R03346','KEGG','RNO:58813',true).
concept_accession('41564: rn:R03346','KEGG','287368',true).
concept_accession('41564: rn:R03346','KEGG','RNO:312373',true).
concept_accession('41564: rn:R03346','KEGG','3.1.3.5',true).
concept_accession('41564: rn:R03346','KEGG','RNO:100363253',true).
concept_accession('41564: rn:R03346','KEGG','RNO:298881',true).
concept_accession('41564: rn:R03346','KEGG','EC:3.1.3.5',true).
concept_accession('41564: rn:R03346','KEGG','298881',true).
concept_accession('41564: rn:R03346','KEGG','58813',true).
concept_accession('41564: rn:R03346','KEGG','312373',true).
concept_accession('41555: rn:R00149','KEGG','6.3.4.16',true).
concept_accession('41555: rn:R00149','KEGG','EC:6.3.4.16',true).
concept_accession('41555: rn:R00149','EC','6.3.4.16',true).
concept_accession('41555: rn:R00149','KEGG','RNO:497840',true).
concept_accession('41555: rn:R00149','KEGG','497840',true).
concept_accession('41554: rn:R05085','KEGG','293820',true).
concept_accession('41554: rn:R05085','KEGG','EC:2.6.1.52',true).
concept_accession('41554: rn:R05085','EC','2.6.1.52',true).
concept_accession('41554: rn:R05085','KEGG','2.6.1.52',true).
concept_accession('41554: rn:R05085','KEGG','RNO:293820',true).
concept_accession('41553: rn:R01398','KEGG','2.1.3.3',true).
concept_accession('41553: rn:R01398','EC','2.1.3.3',true).
concept_accession('41553: rn:R01398','KEGG','25611',true).
concept_accession('41553: rn:R01398','KEGG','RNO:25611',true).
concept_accession('41553: rn:R01398','KEGG','EC:2.1.3.3',true).
concept_accession('41552: rn:R00259','KEGG','RNO:303563',true).
concept_accession('41552: rn:R00259','KEGG','303563',true).
concept_accession('41552: rn:R00259','KEGG','2.3.1.1',true).
concept_accession('41552: rn:R00259','KEGG','EC:2.3.1.1',true).
concept_accession('41552: rn:R00259','EC','2.3.1.1',true).
concept_accession('41559: rn:R00173','KEGG','RNO:295663',true).
concept_accession('41559: rn:R00173','KEGG','RNO:727679',true).
concept_accession('41559: rn:R00173','EC','3.1.3.74',true).
concept_accession('41559: rn:R00173','KEGG','EC:3.1.3.74',true).
concept_accession('41559: rn:R00173','KEGG','727679',true).
concept_accession('41559: rn:R00173','KEGG','3.1.3.74',true).
concept_accession('41559: rn:R00173','KEGG','295663',true).
concept_accession('41558: rn:R00256','KEGG','RNO:192268',true).
concept_accession('41558: rn:R00256','KEGG','24398',true).
concept_accession('41558: rn:R00256','KEGG','RNO:24398',true).
concept_accession('41558: rn:R00256','KEGG','EC:3.5.1.2',true).
concept_accession('41558: rn:R00256','KEGG','3.5.1.2',true).
concept_accession('41558: rn:R00256','KEGG','192268',true).
concept_accession('41558: rn:R00256','EC','3.5.1.2',true).
concept_accession('41557: rn:R00174','KEGG','EC:2.7.1.35',true).
concept_accession('41557: rn:R00174','EC','2.7.1.35',true).
concept_accession('41557: rn:R00174','KEGG','RNO:361819',true).
concept_accession('41557: rn:R00174','KEGG','RNO:83578',true).
concept_accession('41557: rn:R00174','KEGG','361819',true).
concept_accession('41557: rn:R00174','KEGG','2.7.1.35',true).
concept_accession('41557: rn:R00174','KEGG','83578',true).
concept_accession('41556: rn:R01954','KEGG','6.3.4.5',true).
concept_accession('41556: rn:R01954','KEGG','25698',true).
concept_accession('41556: rn:R01954','KEGG','RNO:25698',true).
concept_accession('41556: rn:R01954','KEGG','EC:6.3.4.5',true).
concept_accession('41556: rn:R01954','EC','6.3.4.5',true).
concept_accession('41516: rn:R00137','KEGG','2.7.7.1',true).
concept_accession('41516: rn:R00137','KEGG','RNO:298653',true).
concept_accession('41516: rn:R00137','EC','2.7.7.1',true).
concept_accession('41516: rn:R00137','KEGG','289095',true).
concept_accession('41516: rn:R00137','KEGG','EC:2.7.7.1',true).
concept_accession('41516: rn:R00137','KEGG','RNO:289095',true).
concept_accession('41516: rn:R00137','KEGG','298653',true).
concept_accession('41517: rn:R00111','KEGG','RNO:24599',true).
concept_accession('41517: rn:R00111','KEGG','24600',true).
concept_accession('41517: rn:R00111','EC','1.14.13.39',true).
concept_accession('41517: rn:R00111','KEGG','RNO:24598',true).
concept_accession('41517: rn:R00111','KEGG','RNO:24600',true).
concept_accession('41517: rn:R00111','KEGG','1.14.13.39',true).
concept_accession('41517: rn:R00111','KEGG','24598',true).
concept_accession('41517: rn:R00111','KEGG','24599',true).
concept_accession('41517: rn:R00111','KEGG','EC:1.14.13.39',true).
concept_accession('41518: rn:R02323','KEGG','RNO:313574',true).
concept_accession('41518: rn:R02323','KEGG','100363253',true).
concept_accession('41518: rn:R02323','KEGG','RNO:688261',true).
concept_accession('41518: rn:R02323','KEGG','RNO:287368',true).
concept_accession('41518: rn:R02323','KEGG','688261',true).
concept_accession('41518: rn:R02323','EC','3.1.3.5',true).
concept_accession('41518: rn:R02323','KEGG','313574',true).
concept_accession('41518: rn:R02323','KEGG','RNO:58813',true).
concept_accession('41518: rn:R02323','KEGG','287368',true).
concept_accession('41518: rn:R02323','KEGG','RNO:312373',true).
concept_accession('41518: rn:R02323','KEGG','3.1.3.5',true).
concept_accession('41518: rn:R02323','KEGG','RNO:100363253',true).
concept_accession('41518: rn:R02323','KEGG','RNO:298881',true).
concept_accession('41518: rn:R02323','KEGG','EC:3.1.3.5',true).
concept_accession('41518: rn:R02323','KEGG','298881',true).
concept_accession('41518: rn:R02323','KEGG','58813',true).
concept_accession('41518: rn:R02323','KEGG','312373',true).
concept_accession('41519: rn:R01271','EC','2.4.2.12',true).
concept_accession('41519: rn:R01271','KEGG','RNO:297508',true).
concept_accession('41519: rn:R01271','KEGG','297508',true).
concept_accession('41519: rn:R01271','KEGG','2.4.2.12',true).
concept_accession('41519: rn:R01271','KEGG','EC:2.4.2.12',true).
concept_accession('41512: rn:R00103','KEGG','EC:3.6.1.22',true).
concept_accession('41512: rn:R00103','KEGG','367323',true).
concept_accession('41512: rn:R00103','KEGG','3.6.1.22',true).
concept_accession('41512: rn:R00103','EC','3.6.1.22',true).
concept_accession('41512: rn:R00103','KEGG','RNO:367323',true).
concept_accession('41513: rn:R01883','EC','2.1.1.2',true).
concept_accession('41513: rn:R01883','KEGG','2.1.1.2',true).
concept_accession('41513: rn:R01883','KEGG','25257',true).
concept_accession('41513: rn:R01883','KEGG','RNO:25257',true).
concept_accession('41513: rn:R01883','KEGG','EC:2.1.1.2',true).
concept_accession('41514: rn:R00137','KEGG','2.7.7.1',true).
concept_accession('41514: rn:R00137','KEGG','RNO:298653',true).
concept_accession('41514: rn:R00137','EC','2.7.7.1',true).
concept_accession('41514: rn:R00137','KEGG','289095',true).
concept_accession('41514: rn:R00137','KEGG','EC:2.7.7.1',true).
concept_accession('41514: rn:R00137','KEGG','RNO:289095',true).
concept_accession('41514: rn:R00137','KEGG','298653',true).
concept_accession('41515: rn:R00565','KEGG','81660',true).
concept_accession('41515: rn:R00565','EC','2.1.4.1',true).
concept_accession('41515: rn:R00565','KEGG','RNO:81660',true).
concept_accession('41515: rn:R00565','KEGG','EC:2.1.4.1',true).
concept_accession('41515: rn:R00565','KEGG','2.1.4.1',true).
concept_accession('41508: rn:R01989','KEGG','81660',true).
concept_accession('41508: rn:R01989','EC','2.1.4.1',true).
concept_accession('41508: rn:R01989','KEGG','RNO:81660',true).
concept_accession('41508: rn:R01989','KEGG','EC:2.1.4.1',true).
concept_accession('41508: rn:R01989','KEGG','2.1.4.1',true).
concept_accession('2503: rn:R01388','KEGG','RP:RP00299',true).
concept_accession('2503: rn:R01388','KEGG','RC00031',true).
concept_accession('2503: rn:R01388','KEGG','1.1.1.29',true).
concept_accession('2503: rn:R01388','EC','1.1.1.29',false).
concept_accession('2503: rn:R01388','KEGG','R01388',true).
concept_accession('2503: rn:R01388','KEGG','EC:1.1.1.29',true).
concept_accession('2503: rn:R01388','KEGG','RC:RC00031',true).
concept_accession('2503: rn:R01388','KEGG','RP00299',true).
concept_accession('2503: rn:R01388','KEGG','RN:R01388',true).
concept_accession('41509: rn:R00566','KEGG','366473',true).
concept_accession('41509: rn:R00566','KEGG','RNO:366473',true).
concept_accession('41509: rn:R00566','KEGG','EC:4.1.1.19',true).
concept_accession('41509: rn:R00566','KEGG','4.1.1.19',true).
concept_accession('41509: rn:R00566','EC','4.1.1.19',true).
concept_accession('41510: rn:R01157','KEGG','EC:3.5.3.11',true).
concept_accession('41510: rn:R01157','KEGG','3.5.3.11',true).
concept_accession('41510: rn:R01157','KEGG','RNO:298607',true).
concept_accession('41510: rn:R01157','KEGG','298607',true).
concept_accession('41510: rn:R01157','EC','3.5.3.11',true).
concept_accession('41511: rn:R00103','KEGG','RNO:85496',true).
concept_accession('41511: rn:R00103','KEGG','EC:3.6.1.22',true).
concept_accession('41511: rn:R00103','KEGG','RNO:54410',true).
concept_accession('41511: rn:R00103','KEGG','3.6.1.22',true).
concept_accession('41511: rn:R00103','KEGG','54410',true).
concept_accession('41511: rn:R00103','EC','3.6.1.22',true).
concept_accession('41511: rn:R00103','KEGG','85496',true).
concept_accession('41504: rn:R00239','KEGG','361755',true).
concept_accession('41504: rn:R00239','KEGG','EC:2.7.2.11',true).
concept_accession('41504: rn:R00239','EC','2.7.2.11',true).
concept_accession('41504: rn:R00239','KEGG','RNO:361755',true).
concept_accession('41504: rn:R00239','KEGG','2.7.2.11',true).
concept_accession('41505: rn:R00245','KEGG','1.5.1.12',true).
concept_accession('41505: rn:R00245','KEGG','641316',true).
concept_accession('41505: rn:R00245','KEGG','RNO:641316',true).
concept_accession('41505: rn:R00245','KEGG','EC:1.5.1.12',true).
concept_accession('41505: rn:R00245','EC','1.5.1.12',true).
concept_accession('41506: rn:R03313','KEGG','361755',true).
concept_accession('41506: rn:R03313','KEGG','EC:1.2.1.41',true).
concept_accession('41506: rn:R03313','KEGG','RNO:361755',true).
concept_accession('41506: rn:R03313','KEGG','1.2.1.41',true).
concept_accession('41506: rn:R03313','EC','1.2.1.41',true).
concept_accession('41507: rn:R00670','KEGG','RNO:24609',true).
concept_accession('41507: rn:R00670','KEGG','EC:4.1.1.17',true).
concept_accession('41507: rn:R00670','KEGG','24609',true).
concept_accession('41507: rn:R00670','KEGG','4.1.1.17',true).
concept_accession('41507: rn:R00670','EC','4.1.1.17',true).
concept_accession('41533: rn:R05051','KEGG','RNO:680409',true).
concept_accession('41533: rn:R05051','KEGG','EC:1.5.99.8',true).
concept_accession('41533: rn:R05051','KEGG','680409',true).
concept_accession('41533: rn:R05051','EC','1.5.99.8',true).
concept_accession('41533: rn:R05051','KEGG','1.5.99.8',true).
concept_accession('41532: rn:R05051','KEGG','641316',true).
concept_accession('41532: rn:R05051','KEGG','EC:1.5.99.8',true).
concept_accession('41532: rn:R05051','EC','1.5.99.8',true).
concept_accession('41532: rn:R05051','KEGG','RNO:641316',true).
concept_accession('41532: rn:R05051','KEGG','1.5.99.8',true).
concept_accession('41535: rn:R04444 rn:R04445','KEGG','1.5.1.12',true).
concept_accession('41535: rn:R04444 rn:R04445','KEGG','641316',true).
concept_accession('41535: rn:R04444 rn:R04445','KEGG','RNO:641316',true).
concept_accession('41535: rn:R04444 rn:R04445','KEGG','EC:1.5.1.12',true).
concept_accession('41535: rn:R04444 rn:R04445','EC','1.5.1.12',true).
concept_accession('41534: rn:R03291 rn:R03293','KEGG','RNO:300035',true).
concept_accession('41534: rn:R03291 rn:R03293','KEGG','364064',true).
concept_accession('41534: rn:R03291 rn:R03293','KEGG','EC:1.5.1.2',true).
concept_accession('41534: rn:R03291 rn:R03293','KEGG','287877',true).
concept_accession('41534: rn:R03291 rn:R03293','EC','1.5.1.2',true).
concept_accession('41534: rn:R03291 rn:R03293','KEGG','RNO:287877',true).
concept_accession('41534: rn:R03291 rn:R03293','KEGG','RNO:364064',true).
concept_accession('41534: rn:R03291 rn:R03293','KEGG','1.5.1.2',true).
concept_accession('41534: rn:R03291 rn:R03293','KEGG','300035',true).
concept_accession('41529: rn:R01724','KEGG','RNO:315085',true).
concept_accession('41529: rn:R01724','EC','2.4.2.11',true).
concept_accession('41529: rn:R01724','KEGG','2.4.2.11',true).
concept_accession('41529: rn:R01724','KEGG','315085',true).
concept_accession('41529: rn:R01724','KEGG','EC:2.4.2.11',true).
concept_accession('41528: rn:R00257','KEGG','353255',true).
concept_accession('41528: rn:R00257','KEGG','RNO:353255',true).
concept_accession('41528: rn:R00257','KEGG','EC:6.3.5.1',true).
concept_accession('41528: rn:R00257','EC','6.3.5.1',true).
concept_accession('41528: rn:R00257','KEGG','6.3.5.1',true).
concept_accession('41531: rn:R02894','KEGG','RNO:114027',true).
concept_accession('41531: rn:R02894','KEGG','114027',true).
concept_accession('41531: rn:R02894','KEGG','EC:1.4.3.3',true).
concept_accession('41531: rn:R02894','EC','1.4.3.3',true).
concept_accession('41531: rn:R02894','KEGG','1.4.3.3',true).
concept_accession('41530: rn:R03295','KEGG','RNO:361538',true).
concept_accession('41530: rn:R03295','KEGG','1.5.-.-',true).
concept_accession('41530: rn:R03295','KEGG','361538',true).
concept_accession('41530: rn:R03295','EC','1.5.-.-',true).
concept_accession('41530: rn:R03295','KEGG','EC:1.5.-.-',true).
concept_accession('41525: rn:R03005','KEGG','2.7.7.18',true).
concept_accession('41525: rn:R03005','KEGG','EC:2.7.7.18',true).
concept_accession('41525: rn:R03005','KEGG','RNO:298653',true).
concept_accession('41525: rn:R03005','KEGG','289095',true).
concept_accession('41525: rn:R03005','EC','2.7.7.18',true).
concept_accession('41525: rn:R03005','KEGG','RNO:289095',true).
concept_accession('41525: rn:R03005','KEGG','298653',true).
concept_accession('41524: rn:R03005','KEGG','2.7.7.18',true).
concept_accession('41524: rn:R03005','KEGG','EC:2.7.7.18',true).
concept_accession('41524: rn:R03005','KEGG','RNO:298653',true).
concept_accession('41524: rn:R03005','KEGG','289095',true).
concept_accession('41524: rn:R03005','EC','2.7.7.18',true).
concept_accession('41524: rn:R03005','KEGG','RNO:289095',true).
concept_accession('41524: rn:R03005','KEGG','298653',true).
concept_accession('41527: rn:R00558','KEGG','RNO:24599',true).
concept_accession('41527: rn:R00558','KEGG','24600',true).
concept_accession('41527: rn:R00558','EC','1.14.13.39',true).
concept_accession('41527: rn:R00558','KEGG','RNO:24598',true).
concept_accession('41527: rn:R00558','KEGG','RNO:24600',true).
concept_accession('41527: rn:R00558','KEGG','1.14.13.39',true).
concept_accession('41527: rn:R00558','KEGG','24598',true).
concept_accession('41527: rn:R00558','KEGG','24599',true).
concept_accession('41527: rn:R00558','KEGG','EC:1.14.13.39',true).
concept_accession('2516: rn:R00996','KEGG','EC:4.3.1.19',true).
concept_accession('2516: rn:R00996','KEGG','RN:R00996',true).
concept_accession('2516: rn:R00996','KEGG','4.3.1.19',true).
concept_accession('2516: rn:R00996','KEGG','R00996',true).
concept_accession('2516: rn:R00996','KEGG','RP01226',true).
concept_accession('2516: rn:R00996','EC','4.3.1.19',false).
concept_accession('2516: rn:R00996','KEGG','RC00418',true).
concept_accession('2516: rn:R00996','KEGG','RP:RP01226',true).
concept_accession('2516: rn:R00996','KEGG','RC:RC00418',true).
concept_accession('41526: rn:R05052','KEGG','25721',true).
concept_accession('41526: rn:R05052','KEGG','RNO:25721',true).
concept_accession('41526: rn:R05052','KEGG','24401',true).
concept_accession('41526: rn:R05052','EC','2.6.1.1',true).
concept_accession('41526: rn:R05052','KEGG','RNO:24401',true).
concept_accession('41526: rn:R05052','KEGG','EC:2.6.1.1',true).
concept_accession('41526: rn:R05052','KEGG','2.6.1.1',true).
concept_accession('41521: rn:R01881','KEGG','2.7.3.2',true).
concept_accession('41521: rn:R01881','EC','2.7.3.2',true).
concept_accession('41521: rn:R01881','KEGG','688698',true).
concept_accession('41521: rn:R01881','KEGG','RNO:29593',true).
concept_accession('41521: rn:R01881','KEGG','RNO:688698',true).
concept_accession('41521: rn:R01881','KEGG','EC:2.7.3.2',true).
concept_accession('41521: rn:R01881','KEGG','RNO:24264',true).
concept_accession('41521: rn:R01881','KEGG','RNO:24265',true).
concept_accession('41521: rn:R01881','KEGG','24265',true).
concept_accession('41521: rn:R01881','KEGG','24264',true).
concept_accession('41521: rn:R01881','KEGG','29593',true).
concept_accession('41520: rn:R02294','KEGG','290029',true).
concept_accession('41520: rn:R02294','KEGG','2.4.2.1',true).
concept_accession('41520: rn:R02294','KEGG','EC:2.4.2.1',true).
concept_accession('41520: rn:R02294','EC','2.4.2.1',true).
concept_accession('41520: rn:R02294','KEGG','RNO:290029',true).
concept_accession('41523: rn:R03347','KEGG','2.7.1.-',true).
concept_accession('41523: rn:R03347','EC','2.7.1.-',true).
concept_accession('41523: rn:R03347','KEGG','RNO:499330',true).
concept_accession('41523: rn:R03347','KEGG','499330',true).
concept_accession('41523: rn:R03347','KEGG','EC:2.7.1.-',true).
concept_accession('41522: rn:R02295','KEGG','290029',true).
concept_accession('41522: rn:R02295','KEGG','2.4.2.1',true).
concept_accession('41522: rn:R02295','KEGG','EC:2.4.2.1',true).
concept_accession('41522: rn:R02295','EC','2.4.2.1',true).
concept_accession('41522: rn:R02295','KEGG','RNO:290029',true).
concept_accession('41486: rn:R02313','KEGG','1.5.1.9',true).
concept_accession('41486: rn:R02313','KEGG','RNO:296925',true).
concept_accession('41486: rn:R02313','KEGG','EC:1.5.1.9',true).
concept_accession('41486: rn:R02313','KEGG','296925',true).
concept_accession('41486: rn:R02313','EC','1.5.1.9',true).
concept_accession('41487: rn:R01940','EC','1.2.4.2',true).
concept_accession('41487: rn:R01940','KEGG','1.2.4.2',true).
concept_accession('41487: rn:R01940','KEGG','RNO:290566',true).
concept_accession('41487: rn:R01940','KEGG','360975',true).
concept_accession('41487: rn:R01940','KEGG','EC:1.2.4.2',true).
concept_accession('41487: rn:R01940','KEGG','290566',true).
concept_accession('41487: rn:R01940','KEGG','RNO:360975',true).
concept_accession('2540: rn:R01388 rn:R01392','KEGG','1.1.1.81',true).
concept_accession('2540: rn:R01388 rn:R01392','KEGG','RP:RP00299',true).
concept_accession('2540: rn:R01388 rn:R01392','KEGG','RC00031',true).
concept_accession('2540: rn:R01388 rn:R01392','KEGG','R01392',true).
concept_accession('2540: rn:R01388 rn:R01392','KEGG','R01388',true).
concept_accession('2540: rn:R01388 rn:R01392','KEGG','RC:RC00031',true).
concept_accession('2540: rn:R01388 rn:R01392','KEGG','EC:1.1.1.81',true).
concept_accession('2540: rn:R01388 rn:R01392','KEGG','RN:R01392',true).
concept_accession('2540: rn:R01388 rn:R01392','KEGG','RP00299',true).
concept_accession('2540: rn:R01388 rn:R01392','EC','1.1.1.81',false).
concept_accession('2540: rn:R01388 rn:R01392','KEGG','RN:R01388',true).
concept_accession('41484: rn:R03875','KEGG','311968',true).
concept_accession('41484: rn:R03875','KEGG','RNO:317568',true).
concept_accession('41484: rn:R03875','KEGG','302553',true).
concept_accession('41484: rn:R03875','KEGG','RNO:100362634',true).
concept_accession('41484: rn:R03875','KEGG','361543',true).
concept_accession('41484: rn:R03875','KEGG','2.1.1.60',true).
concept_accession('41484: rn:R03875','KEGG','689954',true).
concept_accession('41484: rn:R03875','KEGG','310638',true).
concept_accession('41484: rn:R03875','KEGG','RNO:290831',true).
concept_accession('41484: rn:R03875','KEGG','498178',true).
concept_accession('41484: rn:R03875','KEGG','364785',true).
concept_accession('41484: rn:R03875','KEGG','RNO:498178',true).
concept_accession('41484: rn:R03875','KEGG','RNO:689883',true).
concept_accession('41484: rn:R03875','KEGG','RNO:362078',true).
concept_accession('41484: rn:R03875','KEGG','361688',true).
concept_accession('41484: rn:R03875','KEGG','RNO:306764',true).
concept_accession('41484: rn:R03875','KEGG','362078',true).
concept_accession('41484: rn:R03875','KEGG','RNO:362831',true).
concept_accession('41484: rn:R03875','KEGG','100364718',true).
concept_accession('41484: rn:R03875','KEGG','288346',true).
concept_accession('41484: rn:R03875','KEGG','689883',true).
concept_accession('41484: rn:R03875','KEGG','316013',true).
concept_accession('41484: rn:R03875','KEGG','100361710',true).
concept_accession('41484: rn:R03875','KEGG','306764',true).
concept_accession('41484: rn:R03875','KEGG','RNO:100364718',true).
concept_accession('41484: rn:R03875','KEGG','100362634',true).
concept_accession('41484: rn:R03875','KEGG','RNO:100361710',true).
concept_accession('41484: rn:R03875','KEGG','RNO:362996',true).
concept_accession('41484: rn:R03875','KEGG','361798',true).
concept_accession('41484: rn:R03875','KEGG','500281',true).
concept_accession('41484: rn:R03875','KEGG','EC:2.1.1.60',true).
concept_accession('41484: rn:R03875','KEGG','RNO:316013',true).
concept_accession('41484: rn:R03875','KEGG','RNO:680537',true).
concept_accession('41484: rn:R03875','KEGG','290831',true).
concept_accession('41484: rn:R03875','KEGG','RNO:311968',true).
concept_accession('41484: rn:R03875','KEGG','RNO:288346',true).
concept_accession('41484: rn:R03875','KEGG','362996',true).
concept_accession('41484: rn:R03875','KEGG','RNO:500281',true).
concept_accession('41484: rn:R03875','KEGG','689820',true).
concept_accession('41484: rn:R03875','KEGG','RNO:361688',true).
concept_accession('41484: rn:R03875','KEGG','RNO:361543',true).
concept_accession('41484: rn:R03875','KEGG','RNO:310638',true).
concept_accession('41484: rn:R03875','KEGG','RNO:302553',true).
concept_accession('41484: rn:R03875','KEGG','680537',true).
concept_accession('41484: rn:R03875','EC','2.1.1.60',true).
concept_accession('41484: rn:R03875','KEGG','317568',true).
concept_accession('41484: rn:R03875','KEGG','RNO:361798',true).
concept_accession('41484: rn:R03875','KEGG','362831',true).
concept_accession('41484: rn:R03875','KEGG','RNO:689820',true).
concept_accession('41484: rn:R03875','KEGG','RNO:364785',true).
concept_accession('41484: rn:R03875','KEGG','RNO:308345',true).
concept_accession('41484: rn:R03875','KEGG','308345',true).
concept_accession('41484: rn:R03875','KEGG','RNO:689954',true).
concept_accession('41485: rn:R03102 rn:R03103','KEGG','1.2.1.31',true).
concept_accession('41485: rn:R03102 rn:R03103','KEGG','RNO:291450',true).
concept_accession('41485: rn:R03102 rn:R03103','EC','1.2.1.31',true).
concept_accession('41485: rn:R03102 rn:R03103','KEGG','291450',true).
concept_accession('41485: rn:R03102 rn:R03103','KEGG','EC:1.2.1.31',true).
concept_accession('6366: rn:R08905','KEGG','6.2.1.-',true).
concept_accession('6366: rn:R08905','KEGG','RC00014',true).
concept_accession('6366: rn:R08905','KEGG','RP14243',true).
concept_accession('6366: rn:R08905','KEGG','RP14244',true).
concept_accession('6366: rn:R08905','KEGG','RC00039',true).
concept_accession('6366: rn:R08905','KEGG','R08905',true).
concept_accession('6366: rn:R08905','KEGG','RP:RP14244',true).
concept_accession('6366: rn:R08905','KEGG','RC:RC00014',true).
concept_accession('6366: rn:R08905','KEGG','RP:RP14243',true).
concept_accession('6366: rn:R08905','KEGG','RC:RC00039',true).
concept_accession('6366: rn:R08905','EC','6.2.1.-',false).
concept_accession('6366: rn:R08905','KEGG','RN:R08905',true).
concept_accession('6366: rn:R08905','KEGG','EC:6.2.1.-',true).
concept_accession('41482: rn:R03380','KEGG','2.4.1.50',true).
concept_accession('41482: rn:R03380','KEGG','RNO:288583',true).
concept_accession('41482: rn:R03380','KEGG','RNO:289081',true).
concept_accession('41482: rn:R03380','KEGG','EC:2.4.1.50',true).
concept_accession('41482: rn:R03380','KEGG','288583',true).
concept_accession('41482: rn:R03380','KEGG','289081',true).
concept_accession('41482: rn:R03380','EC','2.4.1.50',true).
concept_accession('41482: rn:R03380','KEGG','290637',true).
concept_accession('41482: rn:R03380','KEGG','RNO:290637',true).
concept_accession('2537: rn:R00221','KEGG','RP04299',true).
concept_accession('2537: rn:R00221','KEGG','RN:R00221',true).
concept_accession('2537: rn:R00221','KEGG','4.3.1.18',true).
concept_accession('2537: rn:R00221','EC','4.3.1.18',false).
concept_accession('2537: rn:R00221','KEGG','RC:RC01189',true).
concept_accession('2537: rn:R00221','KEGG','R00221',true).
concept_accession('2537: rn:R00221','KEGG','EC:4.3.1.18',true).
concept_accession('2537: rn:R00221','KEGG','RC01189',true).
concept_accession('2537: rn:R00221','KEGG','RP:RP04299',true).
concept_accession('41483: rn:R00619','KEGG','680668',true).
concept_accession('41483: rn:R00619','KEGG','RNO:680668',true).
concept_accession('41483: rn:R00619','KEGG','EC:2.7.6.2',true).
concept_accession('41483: rn:R00619','EC','2.7.6.2',true).
concept_accession('41483: rn:R00619','KEGG','2.7.6.2',true).
concept_accession('41480: rn:R04313','KEGG','317409',true).
concept_accession('41480: rn:R04313','KEGG','3.4.-.-',true).
concept_accession('41480: rn:R04313','KEGG','RNO:317409',true).
concept_accession('41480: rn:R04313','EC','3.4.-.-',true).
concept_accession('41480: rn:R04313','KEGG','EC:3.4.-.-',true).
concept_accession('41481: rn:R03451','KEGG','RNO:170898',true).
concept_accession('41481: rn:R03451','KEGG','170898',true).
concept_accession('41481: rn:R03451','EC','1.14.11.8',true).
concept_accession('41481: rn:R03451','KEGG','1.14.11.8',true).
concept_accession('41481: rn:R03451','KEGG','EC:1.14.11.8',true).
concept_accession('41478: rn:R03026','KEGG','RNO:170670',true).
concept_accession('41478: rn:R03026','KEGG','171142',true).
concept_accession('41478: rn:R03026','KEGG','RNO:171142',true).
concept_accession('41478: rn:R03026','EC','4.2.1.17',true).
concept_accession('41478: rn:R03026','KEGG','170670',true).
concept_accession('41478: rn:R03026','KEGG','RNO:140547',true).
concept_accession('41478: rn:R03026','KEGG','140547',true).
concept_accession('41478: rn:R03026','KEGG','4.2.1.17',true).
concept_accession('41478: rn:R03026','KEGG','EC:4.2.1.17',true).
concept_accession('41479: rn:R04867','KEGG','311968',true).
concept_accession('41479: rn:R04867','KEGG','RNO:317568',true).
concept_accession('41479: rn:R04867','KEGG','302553',true).
concept_accession('41479: rn:R04867','KEGG','RNO:100362634',true).
concept_accession('41479: rn:R04867','KEGG','361543',true).
concept_accession('41479: rn:R04867','KEGG','2.1.1.60',true).
concept_accession('41479: rn:R04867','KEGG','689954',true).
concept_accession('41479: rn:R04867','KEGG','310638',true).
concept_accession('41479: rn:R04867','KEGG','RNO:290831',true).
concept_accession('41479: rn:R04867','KEGG','498178',true).
concept_accession('41479: rn:R04867','KEGG','364785',true).
concept_accession('41479: rn:R04867','KEGG','RNO:498178',true).
concept_accession('41479: rn:R04867','KEGG','RNO:689883',true).
concept_accession('41479: rn:R04867','KEGG','RNO:362078',true).
concept_accession('41479: rn:R04867','KEGG','361688',true).
concept_accession('41479: rn:R04867','KEGG','RNO:306764',true).
concept_accession('41479: rn:R04867','KEGG','362078',true).
concept_accession('41479: rn:R04867','KEGG','RNO:362831',true).
concept_accession('41479: rn:R04867','KEGG','100364718',true).
concept_accession('41479: rn:R04867','KEGG','288346',true).
concept_accession('41479: rn:R04867','KEGG','689883',true).
concept_accession('41479: rn:R04867','KEGG','316013',true).
concept_accession('41479: rn:R04867','KEGG','100361710',true).
concept_accession('41479: rn:R04867','KEGG','306764',true).
concept_accession('41479: rn:R04867','KEGG','RNO:100364718',true).
concept_accession('41479: rn:R04867','KEGG','100362634',true).
concept_accession('41479: rn:R04867','KEGG','RNO:100361710',true).
concept_accession('41479: rn:R04867','KEGG','RNO:362996',true).
concept_accession('41479: rn:R04867','KEGG','361798',true).
concept_accession('41479: rn:R04867','KEGG','500281',true).
concept_accession('41479: rn:R04867','KEGG','EC:2.1.1.60',true).
concept_accession('41479: rn:R04867','KEGG','RNO:316013',true).
concept_accession('41479: rn:R04867','KEGG','RNO:680537',true).
concept_accession('41479: rn:R04867','KEGG','290831',true).
concept_accession('41479: rn:R04867','KEGG','RNO:311968',true).
concept_accession('41479: rn:R04867','KEGG','RNO:288346',true).
concept_accession('41479: rn:R04867','KEGG','362996',true).
concept_accession('41479: rn:R04867','KEGG','RNO:500281',true).
concept_accession('41479: rn:R04867','KEGG','689820',true).
concept_accession('41479: rn:R04867','KEGG','RNO:361688',true).
concept_accession('41479: rn:R04867','KEGG','RNO:361543',true).
concept_accession('41479: rn:R04867','KEGG','RNO:310638',true).
concept_accession('41479: rn:R04867','KEGG','RNO:302553',true).
concept_accession('41479: rn:R04867','KEGG','680537',true).
concept_accession('41479: rn:R04867','EC','2.1.1.60',true).
concept_accession('41479: rn:R04867','KEGG','317568',true).
concept_accession('41479: rn:R04867','KEGG','RNO:361798',true).
concept_accession('41479: rn:R04867','KEGG','362831',true).
concept_accession('41479: rn:R04867','KEGG','RNO:689820',true).
concept_accession('41479: rn:R04867','KEGG','RNO:364785',true).
concept_accession('41479: rn:R04867','KEGG','RNO:308345',true).
concept_accession('41479: rn:R04867','KEGG','308345',true).
concept_accession('41479: rn:R04867','KEGG','RNO:689954',true).
concept_accession('41476: rn:R03376','KEGG','RNO:116552',true).
concept_accession('41476: rn:R03376','KEGG','RNO:288583',true).
concept_accession('41476: rn:R03376','EC','1.14.11.4',true).
concept_accession('41476: rn:R03376','KEGG','288583',true).
concept_accession('41476: rn:R03376','KEGG','300901',true).
concept_accession('41476: rn:R03376','KEGG','1.14.11.4',true).
concept_accession('41476: rn:R03376','KEGG','116552',true).
concept_accession('41476: rn:R03376','KEGG','RNO:300901',true).
concept_accession('41476: rn:R03376','KEGG','EC:1.14.11.4',true).
concept_accession('41477: rn:R04866','KEGG','EC:2.1.1.43',true).
concept_accession('41477: rn:R04866','KEGG','311968',true).
concept_accession('41477: rn:R04866','KEGG','RNO:317568',true).
concept_accession('41477: rn:R04866','KEGG','302553',true).
concept_accession('41477: rn:R04866','KEGG','RNO:100362634',true).
concept_accession('41477: rn:R04866','KEGG','361543',true).
concept_accession('41477: rn:R04866','KEGG','689954',true).
concept_accession('41477: rn:R04866','KEGG','310638',true).
concept_accession('41477: rn:R04866','KEGG','RNO:290831',true).
concept_accession('41477: rn:R04866','KEGG','498178',true).
concept_accession('41477: rn:R04866','KEGG','364785',true).
concept_accession('41477: rn:R04866','KEGG','RNO:498178',true).
concept_accession('41477: rn:R04866','KEGG','RNO:689883',true).
concept_accession('41477: rn:R04866','KEGG','RNO:362078',true).
concept_accession('41477: rn:R04866','KEGG','361688',true).
concept_accession('41477: rn:R04866','KEGG','RNO:306764',true).
concept_accession('41477: rn:R04866','KEGG','362078',true).
concept_accession('41477: rn:R04866','KEGG','RNO:362831',true).
concept_accession('41477: rn:R04866','KEGG','100364718',true).
concept_accession('41477: rn:R04866','KEGG','288346',true).
concept_accession('41477: rn:R04866','KEGG','689883',true).
concept_accession('41477: rn:R04866','KEGG','316013',true).
concept_accession('41477: rn:R04866','KEGG','100361710',true).
concept_accession('41477: rn:R04866','KEGG','306764',true).
concept_accession('41477: rn:R04866','KEGG','RNO:100364718',true).
concept_accession('41477: rn:R04866','KEGG','100362634',true).
concept_accession('41477: rn:R04866','EC','2.1.1.43',true).
concept_accession('41477: rn:R04866','KEGG','RNO:100361710',true).
concept_accession('41477: rn:R04866','KEGG','RNO:362996',true).
concept_accession('41477: rn:R04866','KEGG','361798',true).
concept_accession('41477: rn:R04866','KEGG','500281',true).
concept_accession('41477: rn:R04866','KEGG','RNO:316013',true).
concept_accession('41477: rn:R04866','KEGG','RNO:680537',true).
concept_accession('41477: rn:R04866','KEGG','290831',true).
concept_accession('41477: rn:R04866','KEGG','RNO:311968',true).
concept_accession('41477: rn:R04866','KEGG','RNO:288346',true).
concept_accession('41477: rn:R04866','KEGG','362996',true).
concept_accession('41477: rn:R04866','KEGG','RNO:500281',true).
concept_accession('41477: rn:R04866','KEGG','689820',true).
concept_accession('41477: rn:R04866','KEGG','RNO:361688',true).
concept_accession('41477: rn:R04866','KEGG','RNO:361543',true).
concept_accession('41477: rn:R04866','KEGG','RNO:310638',true).
concept_accession('41477: rn:R04866','KEGG','RNO:302553',true).
concept_accession('41477: rn:R04866','KEGG','680537',true).
concept_accession('41477: rn:R04866','KEGG','317568',true).
concept_accession('41477: rn:R04866','KEGG','RNO:361798',true).
concept_accession('41477: rn:R04866','KEGG','362831',true).
concept_accession('41477: rn:R04866','KEGG','RNO:689820',true).
concept_accession('41477: rn:R04866','KEGG','RNO:364785',true).
concept_accession('41477: rn:R04866','KEGG','2.1.1.43',true).
concept_accession('41477: rn:R04866','KEGG','RNO:308345',true).
concept_accession('41477: rn:R04866','KEGG','308345',true).
concept_accession('41477: rn:R04866','KEGG','RNO:689954',true).
concept_accession('41474: rn:R00616','KEGG','680668',true).
concept_accession('41474: rn:R00616','KEGG','RNO:680668',true).
concept_accession('41474: rn:R00616','KEGG','2.7.4.15',true).
concept_accession('41474: rn:R00616','EC','2.7.4.15',true).
concept_accession('41474: rn:R00616','KEGG','EC:2.7.4.15',true).
concept_accession('41475: rn:R02571','EC','2.3.1.61',true).
concept_accession('41475: rn:R02571','KEGG','RNO:299201',true).
concept_accession('41475: rn:R02571','KEGG','299201',true).
concept_accession('41475: rn:R02571','KEGG','EC:2.3.1.61',true).
concept_accession('41475: rn:R02571','KEGG','2.3.1.61',true).
concept_accession('41472: rn:R00618','KEGG','305889',true).
concept_accession('41472: rn:R00618','KEGG','EC:3.6.1.28',true).
concept_accession('41472: rn:R00618','EC','3.6.1.28',true).
concept_accession('41472: rn:R00618','KEGG','RNO:305889',true).
concept_accession('41472: rn:R00618','KEGG','3.6.1.28',true).
concept_accession('41473: rn:R02204','KEGG','EC:1.5.3.7',true).
concept_accession('41473: rn:R02204','KEGG','1.5.3.7',true).
concept_accession('41473: rn:R02204','KEGG','303272',true).
concept_accession('41473: rn:R02204','EC','1.5.3.7',true).
concept_accession('41473: rn:R02204','KEGG','RNO:303272',true).
concept_accession('41503: rn:R01920','KEGG','84596',true).
concept_accession('41503: rn:R01920','KEGG','2.5.1.16',true).
concept_accession('41503: rn:R01920','KEGG','RNO:84596',true).
concept_accession('41503: rn:R01920','EC','2.5.1.16',true).
concept_accession('41503: rn:R01920','KEGG','EC:2.5.1.16',true).
concept_accession('41502: rn:R00178','EC','4.1.1.50',true).
concept_accession('41502: rn:R00178','KEGG','EC:4.1.1.50',true).
concept_accession('41502: rn:R00178','KEGG','81640',true).
concept_accession('41502: rn:R00178','KEGG','4.1.1.50',true).
concept_accession('41502: rn:R00178','KEGG','RNO:81640',true).
concept_accession('41501: rn:R01986 rn:R02549','KEGG','1.2.1.3',true).
concept_accession('41501: rn:R01986 rn:R02549','KEGG','RNO:291450',true).
concept_accession('41501: rn:R01986 rn:R02549','KEGG','RNO:64040',true).
concept_accession('41501: rn:R01986 rn:R02549','EC','1.2.1.3',true).
concept_accession('41501: rn:R01986 rn:R02549','KEGG','65183',true).
concept_accession('41501: rn:R01986 rn:R02549','KEGG','24188',true).
concept_accession('41501: rn:R01986 rn:R02549','KEGG','RNO:29539',true).
concept_accession('41501: rn:R01986 rn:R02549','KEGG','64040',true).
concept_accession('41501: rn:R01986 rn:R02549','KEGG','RNO:24188',true).
concept_accession('41501: rn:R01986 rn:R02549','KEGG','29539',true).
concept_accession('41501: rn:R01986 rn:R02549','KEGG','29651',true).
concept_accession('41501: rn:R01986 rn:R02549','KEGG','298079',true).
concept_accession('41501: rn:R01986 rn:R02549','KEGG','RNO:298079',true).
concept_accession('41501: rn:R01986 rn:R02549','KEGG','RNO:65183',true).
concept_accession('41501: rn:R01986 rn:R02549','KEGG','RNO:29651',true).
concept_accession('41501: rn:R01986 rn:R02549','KEGG','291450',true).
concept_accession('41501: rn:R01986 rn:R02549','KEGG','EC:1.2.1.3',true).
concept_accession('41500: rn:R01151','KEGG','RNO:65029',true).
concept_accession('41500: rn:R01151','KEGG','1.4.3.22',true).
concept_accession('41500: rn:R01151','KEGG','EC:1.4.3.22',true).
concept_accession('41500: rn:R01151','KEGG','65029',true).
concept_accession('41500: rn:R01151','EC','1.4.3.22',true).
concept_accession('41499: rn:R00716','KEGG','RNO:296925',true).
concept_accession('41499: rn:R00716','EC','1.5.1.8',true).
concept_accession('41499: rn:R00716','KEGG','296925',true).
concept_accession('41499: rn:R00716','KEGG','1.5.1.8',true).
concept_accession('41499: rn:R00716','KEGG','EC:1.5.1.8',true).
concept_accession('41498: rn:R00937 rn:R00940','KEGG','EC:1.5.1.3',true).
concept_accession('41498: rn:R00937 rn:R00940','EC','1.5.1.3',true).
concept_accession('41498: rn:R00937 rn:R00940','KEGG','24312',true).
concept_accession('41498: rn:R00937 rn:R00940','KEGG','RNO:24312',true).
concept_accession('41498: rn:R00937 rn:R00940','KEGG','1.5.1.3',true).
concept_accession('41497: rn:R03283','EC','1.2.1.47',true).
concept_accession('41497: rn:R03283','KEGG','EC:1.2.1.47',true).
concept_accession('41497: rn:R03283','KEGG','RNO:64040',true).
concept_accession('41497: rn:R03283','KEGG','1.2.1.47',true).
concept_accession('41497: rn:R03283','KEGG','64040',true).
concept_accession('41496: rn:R02397','KEGG','1.14.11.1',true).
concept_accession('41496: rn:R02397','KEGG','EC:1.14.11.1',true).
concept_accession('41496: rn:R02397','KEGG','64564',true).
concept_accession('41496: rn:R02397','KEGG','RNO:64564',true).
concept_accession('41496: rn:R02397','EC','1.14.11.1',true).
concept_accession('41495: rn:R00946','KEGG','81522',true).
concept_accession('41495: rn:R00946','KEGG','2.1.1.13',true).
concept_accession('41495: rn:R00946','KEGG','RNO:81522',true).
concept_accession('41495: rn:R00946','KEGG','EC:2.1.1.13',true).
concept_accession('41495: rn:R00946','EC','2.1.1.13',true).
concept_accession('41494: rn:R02101','EC','2.1.1.45',true).
concept_accession('41494: rn:R02101','KEGG','RNO:29261',true).
concept_accession('41494: rn:R02101','KEGG','2.1.1.45',true).
concept_accession('41494: rn:R02101','KEGG','EC:2.1.1.45',true).
concept_accession('41494: rn:R02101','KEGG','29261',true).
concept_accession('41493: rn:R04560','KEGG','EC:2.1.2.3',true).
concept_accession('41493: rn:R04560','KEGG','2.1.2.3',true).
concept_accession('41493: rn:R04560','KEGG','81643',true).
concept_accession('41493: rn:R04560','EC','2.1.2.3',true).
concept_accession('41493: rn:R04560','KEGG','RNO:81643',true).
concept_accession('41492: rn:R04125','KEGG','EC:2.1.2.10',true).
concept_accession('41492: rn:R04125','EC','2.1.2.10',true).
concept_accession('41492: rn:R04125','KEGG','2.1.2.10',true).
concept_accession('41492: rn:R04125','KEGG','RNO:306586',true).
concept_accession('41492: rn:R04125','KEGG','306586',true).
concept_accession('41491: rn:R00945','KEGG','299857',true).
concept_accession('41491: rn:R00945','KEGG','287379',true).
concept_accession('41491: rn:R00945','KEGG','EC:2.1.2.1',true).
concept_accession('41491: rn:R00945','KEGG','RNO:287379',true).
concept_accession('41491: rn:R00945','KEGG','RNO:299857',true).
concept_accession('41491: rn:R00945','KEGG','2.1.2.1',true).
concept_accession('41491: rn:R00945','EC','2.1.2.1',true).
concept_accession('41490: rn:R01975','KEGG','171142',true).
concept_accession('41490: rn:R01975','KEGG','RNO:171142',true).
concept_accession('41490: rn:R01975','EC','1.1.1.35',true).
concept_accession('41490: rn:R01975','KEGG','RNO:113965',true).
concept_accession('41490: rn:R01975','KEGG','EC:1.1.1.35',true).
concept_accession('41490: rn:R01975','KEGG','1.1.1.35',true).
concept_accession('41490: rn:R01975','KEGG','113965',true).
concept_accession('41489: rn:R07460','KEGG','RNO:84594',true).
concept_accession('41489: rn:R07460','EC','2.8.1.7',true).
concept_accession('41489: rn:R07460','KEGG','2.8.1.7',true).
concept_accession('41489: rn:R07460','KEGG','EC:2.8.1.7',true).
concept_accession('41489: rn:R07460','KEGG','84594',true).
concept_accession('41488: rn:R01939','KEGG','EC:2.6.1.39',true).
concept_accession('41488: rn:R01939','KEGG','RNO:29416',true).
concept_accession('41488: rn:R01939','EC','2.6.1.39',true).
concept_accession('41488: rn:R01939','KEGG','29416',true).
concept_accession('41488: rn:R01939','KEGG','2.6.1.39',true).
concept_accession('2345: rn:R01346','KEGG','2.6.1.14',true).
concept_accession('2345: rn:R01346','KEGG','EC:2.6.1.14',true).
concept_accession('2345: rn:R01346','KEGG','RN:R01346',true).
concept_accession('2345: rn:R01346','KEGG','RC00006',true).
concept_accession('2345: rn:R01346','KEGG','RP:RP00683',true).
concept_accession('2345: rn:R01346','EC','2.6.1.14',false).
concept_accession('2345: rn:R01346','KEGG','R01346',true).
concept_accession('2345: rn:R01346','KEGG','RC:RC00006',true).
concept_accession('2345: rn:R01346','KEGG','RP00683',true).
concept_accession('2346: rn:R00397','KEGG','4.1.1.12',true).
concept_accession('2346: rn:R00397','KEGG','RN:R00397',true).
concept_accession('2346: rn:R00397','EC','4.1.1.12',false).
concept_accession('2346: rn:R00397','KEGG','RC00282',true).
concept_accession('2346: rn:R00397','KEGG','RP:RP00875',true).
concept_accession('2346: rn:R00397','KEGG','RP00875',true).
concept_accession('2346: rn:R00397','KEGG','RC:RC00282',true).
concept_accession('2346: rn:R00397','KEGG','R00397',true).
concept_accession('2346: rn:R00397','KEGG','EC:4.1.1.12',true).
concept_accession('2349: rn:R00491','KEGG','RN:R00491',true).
concept_accession('2349: rn:R00491','KEGG','RP00938',true).
concept_accession('2349: rn:R00491','EC','5.1.1.13',false).
concept_accession('2349: rn:R00491','KEGG','R00491',true).
concept_accession('2349: rn:R00491','KEGG','EC:5.1.1.13',true).
concept_accession('2349: rn:R00491','KEGG','RP:RP00938',true).
concept_accession('2349: rn:R00491','KEGG','5.1.1.13',true).
concept_accession('2349: rn:R00491','KEGG','RC00302',true).
concept_accession('2349: rn:R00491','KEGG','RC:RC00302',true).
concept_accession('2361: rn:R00490','KEGG','RC:RC00316',true).
concept_accession('2361: rn:R00490','KEGG','R00490',true).
concept_accession('2361: rn:R00490','KEGG','RN:R00490',true).
concept_accession('2361: rn:R00490','EC','4.3.1.1',false).
concept_accession('2361: rn:R00490','KEGG','RC00316',true).
concept_accession('2361: rn:R00490','KEGG','RP00937',true).
concept_accession('2361: rn:R00490','KEGG','4.3.1.1',true).
concept_accession('2361: rn:R00490','KEGG','RP:RP00937',true).
concept_accession('2361: rn:R00490','KEGG','EC:4.3.1.1',true).
concept_accession('2388: rn:R00093','KEGG','RC00010',true).
concept_accession('2388: rn:R00093','KEGG','RC00006',true).
concept_accession('2388: rn:R00093','KEGG','RP00024',true).
concept_accession('2388: rn:R00093','KEGG','RN:R00093',true).
concept_accession('2388: rn:R00093','KEGG','RP00014',true).
concept_accession('2388: rn:R00093','KEGG','RC:RC00006',true).
concept_accession('2388: rn:R00093','KEGG','R00093',true).
concept_accession('2388: rn:R00093','KEGG','RC:RC00010',true).
concept_accession('2388: rn:R00093','EC','1.4.1.14',false).
concept_accession('2388: rn:R00093','KEGG','EC:1.4.1.14',true).
concept_accession('2388: rn:R00093','KEGG','RP:RP00014',true).
concept_accession('2388: rn:R00093','KEGG','RP:RP00024',true).
concept_accession('2388: rn:R00093','KEGG','1.4.1.14',true).
concept_accession('2404: rn:R00576','KEGG','EC:2.6.1.15',true).
concept_accession('2404: rn:R00576','KEGG','2.6.1.15',true).
concept_accession('2404: rn:R00576','KEGG','RP:RP00133',true).
concept_accession('2404: rn:R00576','KEGG','RC00006',true).
concept_accession('2404: rn:R00576','EC','2.6.1.15',false).
concept_accession('2404: rn:R00576','KEGG','RC:RC00006',true).
concept_accession('2404: rn:R00576','KEGG','RN:R00576',true).
concept_accession('2404: rn:R00576','KEGG','RP00133',true).
concept_accession('2404: rn:R00576','KEGG','R00576',true).
concept_accession('41309: rn:R00238','KEGG','2.3.1.9',true).
concept_accession('41309: rn:R00238','KEGG','EC:2.3.1.9',true).
concept_accession('41309: rn:R00238','EC','2.3.1.9',true).
concept_accession('41309: rn:R00238','KEGG','RNO:308100',true).
concept_accession('41309: rn:R00238','KEGG','RNO:25014',true).
concept_accession('41309: rn:R00238','KEGG','25014',true).
concept_accession('41309: rn:R00238','KEGG','308100',true).
concept_accession('41308: rn:R00710 rn:R00711','KEGG','1.2.1.3',true).
concept_accession('41308: rn:R00710 rn:R00711','KEGG','RNO:291450',true).
concept_accession('41308: rn:R00710 rn:R00711','KEGG','RNO:64040',true).
concept_accession('41308: rn:R00710 rn:R00711','EC','1.2.1.3',true).
concept_accession('41308: rn:R00710 rn:R00711','KEGG','65183',true).
concept_accession('41308: rn:R00710 rn:R00711','KEGG','24188',true).
concept_accession('41308: rn:R00710 rn:R00711','KEGG','RNO:29539',true).
concept_accession('41308: rn:R00710 rn:R00711','KEGG','64040',true).
concept_accession('41308: rn:R00710 rn:R00711','KEGG','RNO:24188',true).
concept_accession('41308: rn:R00710 rn:R00711','KEGG','29539',true).
concept_accession('41308: rn:R00710 rn:R00711','KEGG','29651',true).
concept_accession('41308: rn:R00710 rn:R00711','KEGG','298079',true).
concept_accession('41308: rn:R00710 rn:R00711','KEGG','RNO:298079',true).
concept_accession('41308: rn:R00710 rn:R00711','KEGG','RNO:65183',true).
concept_accession('41308: rn:R00710 rn:R00711','KEGG','RNO:29651',true).
concept_accession('41308: rn:R00710 rn:R00711','KEGG','291450',true).
concept_accession('41308: rn:R00710 rn:R00711','KEGG','EC:1.2.1.3',true).
concept_accession('41311: rn:R00014','KEGG','RNO:117098',true).
concept_accession('41311: rn:R00014','EC','1.2.4.1',true).
concept_accession('41311: rn:R00014','KEGG','RNO:289950',true).
concept_accession('41311: rn:R00014','KEGG','1.2.4.1',true).
concept_accession('41311: rn:R00014','KEGG','117098',true).
concept_accession('41311: rn:R00014','KEGG','289950',true).
concept_accession('41311: rn:R00014','KEGG','29554',true).
concept_accession('41311: rn:R00014','KEGG','RNO:29554',true).
concept_accession('41311: rn:R00014','KEGG','EC:1.2.4.1',true).
concept_accession('41310: rn:R01795','KEGG','24616',true).
concept_accession('41310: rn:R01795','KEGG','EC:1.14.16.1',true).
concept_accession('41310: rn:R01795','KEGG','1.14.16.1',true).
concept_accession('41310: rn:R01795','KEGG','RNO:24616',true).
concept_accession('41310: rn:R01795','EC','1.14.16.1',true).
concept_accession('41305: rn:R02678','KEGG','1.2.1.3',true).
concept_accession('41305: rn:R02678','KEGG','RNO:291450',true).
concept_accession('41305: rn:R02678','KEGG','RNO:64040',true).
concept_accession('41305: rn:R02678','EC','1.2.1.3',true).
concept_accession('41305: rn:R02678','KEGG','65183',true).
concept_accession('41305: rn:R02678','KEGG','24188',true).
concept_accession('41305: rn:R02678','KEGG','RNO:29539',true).
concept_accession('41305: rn:R02678','KEGG','64040',true).
concept_accession('41305: rn:R02678','KEGG','RNO:24188',true).
concept_accession('41305: rn:R02678','KEGG','29539',true).
concept_accession('41305: rn:R02678','KEGG','29651',true).
concept_accession('41305: rn:R02678','KEGG','298079',true).
concept_accession('41305: rn:R02678','KEGG','RNO:298079',true).
concept_accession('41305: rn:R02678','KEGG','RNO:65183',true).
concept_accession('41305: rn:R02678','KEGG','RNO:29651',true).
concept_accession('41305: rn:R02678','KEGG','291450',true).
concept_accession('41305: rn:R02678','KEGG','EC:1.2.1.3',true).
concept_accession('41304: rn:R02908','KEGG','29253',true).
concept_accession('41304: rn:R02908','KEGG','RNO:29253',true).
concept_accession('41304: rn:R02908','KEGG','25750',true).
concept_accession('41304: rn:R02908','KEGG','RNO:25750',true).
concept_accession('41304: rn:R02908','KEGG','EC:1.4.3.4',true).
concept_accession('41304: rn:R02908','EC','1.4.3.4',true).
concept_accession('41304: rn:R02908','KEGG','1.4.3.4',true).
concept_accession('41307: rn:R00316','KEGG','311569',true).
concept_accession('41307: rn:R00316','KEGG','RNO:296259',true).
concept_accession('41307: rn:R00316','KEGG','296259',true).
concept_accession('41307: rn:R00316','KEGG','EC:6.2.1.1',true).
concept_accession('41307: rn:R00316','KEGG','RNO:311569',true).
concept_accession('41307: rn:R00316','EC','6.2.1.1',true).
concept_accession('41307: rn:R00316','KEGG','6.2.1.1',true).
concept_accession('41306: rn:R00742','KEGG','116719',true).
concept_accession('41306: rn:R00742','KEGG','RNO:116719',true).
concept_accession('41306: rn:R00742','KEGG','6.4.1.2',true).
concept_accession('41306: rn:R00742','EC','6.4.1.2',true).
concept_accession('41306: rn:R00742','KEGG','RNO:60581',true).
concept_accession('41306: rn:R00742','KEGG','60581',true).
concept_accession('41306: rn:R00742','KEGG','EC:6.4.1.2',true).
concept_accession('41301: rn:R02173','KEGG','29253',true).
concept_accession('41301: rn:R02173','KEGG','1.4.3.22',true).
concept_accession('41301: rn:R02173','KEGG','RNO:29253',true).
concept_accession('41301: rn:R02173','KEGG','EC:1.4.3.22',true).
concept_accession('41301: rn:R02173','KEGG','25750',true).
concept_accession('41301: rn:R02173','KEGG','RNO:25750',true).
concept_accession('41301: rn:R02173','EC','1.4.3.22',true).
concept_accession('41300: rn:R04904','KEGG','RNO:316421',true).
concept_accession('41300: rn:R04904','KEGG','RNO:54349',true).
concept_accession('41300: rn:R04904','EC','1.2.3.1',true).
concept_accession('41300: rn:R04904','KEGG','EC:1.2.3.1',true).
concept_accession('41300: rn:R04904','KEGG','54349',true).
concept_accession('41300: rn:R04904','KEGG','316421',true).
concept_accession('41300: rn:R04904','KEGG','1.2.3.1',true).
concept_accession('41303: rn:R04903','KEGG','1.2.1.3',true).
concept_accession('41303: rn:R04903','KEGG','RNO:291450',true).
concept_accession('41303: rn:R04903','KEGG','RNO:64040',true).
concept_accession('41303: rn:R04903','EC','1.2.1.3',true).
concept_accession('41303: rn:R04903','KEGG','65183',true).
concept_accession('41303: rn:R04903','KEGG','24188',true).
concept_accession('41303: rn:R04903','KEGG','RNO:29539',true).
concept_accession('41303: rn:R04903','KEGG','64040',true).
concept_accession('41303: rn:R04903','KEGG','RNO:24188',true).
concept_accession('41303: rn:R04903','KEGG','29539',true).
concept_accession('41303: rn:R04903','KEGG','29651',true).
concept_accession('41303: rn:R04903','KEGG','298079',true).
concept_accession('41303: rn:R04903','KEGG','RNO:298079',true).
concept_accession('41303: rn:R04903','KEGG','RNO:65183',true).
concept_accession('41303: rn:R04903','KEGG','RNO:29651',true).
concept_accession('41303: rn:R04903','KEGG','291450',true).
concept_accession('41303: rn:R04903','KEGG','EC:1.2.1.3',true).
concept_accession('41302: rn:R04911','KEGG','EC:3.5.1.9',true).
concept_accession('41302: rn:R04911','EC','3.5.1.9',true).
concept_accession('41302: rn:R04911','KEGG','3.5.1.9',true).
concept_accession('41302: rn:R04911','KEGG','RNO:688283',true).
concept_accession('41302: rn:R04911','KEGG','688283',true).
concept_accession('41297: rn:R02174','KEGG','2.1.1.49',true).
concept_accession('41297: rn:R02174','EC','2.1.1.49',true).
concept_accession('41297: rn:R02174','KEGG','EC:2.1.1.49',true).
concept_accession('41297: rn:R02174','KEGG','RNO:368066',true).
concept_accession('41297: rn:R02174','KEGG','368066',true).
concept_accession('41296: rn:R01514','KEGG','684314',true).
concept_accession('41296: rn:R01514','KEGG','RNO:684314',true).
concept_accession('41296: rn:R01514','KEGG','EC:2.7.1.31',true).
concept_accession('41296: rn:R01514','KEGG','2.7.1.31',true).
concept_accession('41296: rn:R01514','EC','2.7.1.31',true).
concept_accession('41299: rn:R02173','KEGG','RNO:65029',true).
concept_accession('41299: rn:R02173','KEGG','1.4.3.22',true).
concept_accession('41299: rn:R02173','KEGG','EC:1.4.3.22',true).
concept_accession('41299: rn:R02173','KEGG','65029',true).
concept_accession('41299: rn:R02173','EC','1.4.3.22',true).
concept_accession('41298: rn:R02910','KEGG','2.1.1.49',true).
concept_accession('41298: rn:R02910','EC','2.1.1.49',true).
concept_accession('41298: rn:R02910','KEGG','EC:2.1.1.49',true).
concept_accession('41298: rn:R02910','KEGG','RNO:368066',true).
concept_accession('41298: rn:R02910','KEGG','368066',true).
concept_accession('41292: rn:R04905','EC','2.1.1.4',true).
concept_accession('41292: rn:R04905','KEGG','2.1.1.4',true).
concept_accession('41292: rn:R04905','KEGG','EC:2.1.1.4',true).
concept_accession('41292: rn:R04905','KEGG','RNO:246281',true).
concept_accession('41292: rn:R04905','KEGG','246281',true).
concept_accession('41293: rn:R03130','EC','2.1.1.4',true).
concept_accession('41293: rn:R03130','KEGG','2.1.1.4',true).
concept_accession('41293: rn:R03130','KEGG','EC:2.1.1.4',true).
concept_accession('41293: rn:R03130','KEGG','RNO:246281',true).
concept_accession('41293: rn:R03130','KEGG','246281',true).
concept_accession('41294: rn:R02911','EC','2.3.1.87',true).
concept_accession('41294: rn:R02911','KEGG','2.3.1.87',true).
concept_accession('41294: rn:R02911','KEGG','EC:2.3.1.87',true).
concept_accession('41294: rn:R02911','KEGG','RNO:25120',true).
concept_accession('41294: rn:R02911','KEGG','25120',true).
concept_accession('41295: rn:R01334','KEGG','EC:3.1.3.18',true).
concept_accession('41295: rn:R01334','EC','3.1.3.18',true).
concept_accession('41295: rn:R01334','KEGG','RNO:287115',true).
concept_accession('41295: rn:R01334','KEGG','3.1.3.18',true).
concept_accession('41295: rn:R01334','KEGG','287115',true).
concept_accession('41288: rn:R02702','KEGG','681319',true).
concept_accession('41288: rn:R02702','EC','1.13.11.52',true).
concept_accession('41288: rn:R02702','KEGG','RNO:681319',true).
concept_accession('41288: rn:R02702','KEGG','1.13.11.52',true).
concept_accession('41288: rn:R02702','KEGG','RNO:66029',true).
concept_accession('41288: rn:R02702','KEGG','684861',true).
concept_accession('41288: rn:R02702','KEGG','RNO:684861',true).
concept_accession('41288: rn:R02702','KEGG','66029',true).
concept_accession('41288: rn:R02702','KEGG','EC:1.13.11.52',true).
concept_accession('41289: rn:R04908','KEGG','29253',true).
concept_accession('41289: rn:R04908','KEGG','RNO:29253',true).
concept_accession('41289: rn:R04908','KEGG','25750',true).
concept_accession('41289: rn:R04908','KEGG','RNO:25750',true).
concept_accession('41289: rn:R04908','KEGG','EC:1.4.3.4',true).
concept_accession('41289: rn:R04908','EC','1.4.3.4',true).
concept_accession('41289: rn:R04908','KEGG','1.4.3.4',true).
concept_accession('41290: rn:R04909','KEGG','EC:4.1.1.28',true).
concept_accession('41290: rn:R04909','KEGG','4.1.1.28',true).
concept_accession('41290: rn:R04909','EC','4.1.1.28',true).
concept_accession('41290: rn:R04909','KEGG','RNO:24311',true).
concept_accession('41290: rn:R04909','KEGG','24311',true).
concept_accession('41291: rn:R02909','KEGG','681319',true).
concept_accession('41291: rn:R02909','EC','1.13.11.52',true).
concept_accession('41291: rn:R02909','KEGG','RNO:681319',true).
concept_accession('41291: rn:R02909','KEGG','1.13.11.52',true).
concept_accession('41291: rn:R02909','KEGG','RNO:66029',true).
concept_accession('41291: rn:R02909','KEGG','684861',true).
concept_accession('41291: rn:R02909','KEGG','RNO:684861',true).
concept_accession('41291: rn:R02909','KEGG','66029',true).
concept_accession('41291: rn:R02909','KEGG','EC:1.13.11.52',true).
concept_accession('41284: rn:R00342','KEGG','81829',true).
concept_accession('41284: rn:R00342','KEGG','EC:1.1.1.37',true).
concept_accession('41284: rn:R00342','EC','1.1.1.37',true).
concept_accession('41284: rn:R00342','KEGG','RNO:81829',true).
concept_accession('41284: rn:R00342','KEGG','1.1.1.37',true).
concept_accession('41284: rn:R00342','KEGG','RNO:24551',true).
concept_accession('41284: rn:R00342','KEGG','24551',true).
concept_accession('41285: rn:R01959','KEGG','EC:3.5.1.9',true).
concept_accession('41285: rn:R01959','EC','3.5.1.9',true).
concept_accession('41285: rn:R01959','KEGG','3.5.1.9',true).
concept_accession('41285: rn:R01959','KEGG','RNO:688283',true).
concept_accession('41285: rn:R01959','KEGG','688283',true).
concept_accession('41286: rn:R00238','KEGG','2.3.1.9',true).
concept_accession('41286: rn:R00238','KEGG','EC:2.3.1.9',true).
concept_accession('41286: rn:R00238','EC','2.3.1.9',true).
concept_accession('41286: rn:R00238','KEGG','RNO:308100',true).
concept_accession('41286: rn:R00238','KEGG','RNO:25014',true).
concept_accession('41286: rn:R00238','KEGG','25014',true).
concept_accession('41286: rn:R00238','KEGG','308100',true).
concept_accession('41287: rn:R02701','KEGG','EC:4.1.1.28',true).
concept_accession('41287: rn:R02701','KEGG','4.1.1.28',true).
concept_accession('41287: rn:R02701','EC','4.1.1.28',true).
concept_accession('41287: rn:R02701','KEGG','RNO:24311',true).
concept_accession('41287: rn:R02701','KEGG','24311',true).
concept_accession('41280: rn:R04323','KEGG','171385',true).
concept_accession('41280: rn:R04323','KEGG','EC:4.1.1.45',true).
concept_accession('41280: rn:R04323','EC','4.1.1.45',true).
concept_accession('41280: rn:R04323','KEGG','4.1.1.45',true).
concept_accession('41280: rn:R04323','KEGG','RNO:171385',true).
concept_accession('41281: rn:R01933','EC','1.2.4.2',true).
concept_accession('41281: rn:R01933','KEGG','1.2.4.2',true).
concept_accession('41281: rn:R01933','KEGG','RNO:290566',true).
concept_accession('41281: rn:R01933','KEGG','360975',true).
concept_accession('41281: rn:R01933','KEGG','EC:1.2.4.2',true).
concept_accession('41281: rn:R01933','KEGG','290566',true).
concept_accession('41281: rn:R01933','KEGG','RNO:360975',true).
concept_accession('41282: rn:R03026','KEGG','RNO:170670',true).
concept_accession('41282: rn:R03026','KEGG','171142',true).
concept_accession('41282: rn:R03026','KEGG','RNO:171142',true).
concept_accession('41282: rn:R03026','EC','4.2.1.17',true).
concept_accession('41282: rn:R03026','KEGG','170670',true).
concept_accession('41282: rn:R03026','KEGG','RNO:140547',true).
concept_accession('41282: rn:R03026','KEGG','140547',true).
concept_accession('41282: rn:R03026','KEGG','4.2.1.17',true).
concept_accession('41282: rn:R03026','KEGG','EC:4.2.1.17',true).
concept_accession('41283: rn:R02488','KEGG','RNO:364975',true).
concept_accession('41283: rn:R02488','KEGG','1.3.99.7',true).
concept_accession('41283: rn:R02488','EC','1.3.99.7',true).
concept_accession('41283: rn:R02488','KEGG','EC:1.3.99.7',true).
concept_accession('41283: rn:R02488','KEGG','364975',true).
concept_accession('41343: rn:R01167','KEGG','EC:4.1.1.28',true).
concept_accession('41343: rn:R01167','KEGG','4.1.1.28',true).
concept_accession('41343: rn:R01167','EC','4.1.1.28',true).
concept_accession('41343: rn:R01167','KEGG','RNO:24311',true).
concept_accession('41343: rn:R01167','KEGG','24311',true).
concept_accession('41342: rn:R02914','KEGG','EC:4.2.1.49',true).
concept_accession('41342: rn:R02914','KEGG','4.2.1.49',true).
concept_accession('41342: rn:R02914','EC','4.2.1.49',true).
concept_accession('41342: rn:R02914','KEGG','685999',true).
concept_accession('41342: rn:R02914','KEGG','RNO:685999',true).
concept_accession('41341: rn:R01074','KEGG','RNO:288240',true).
concept_accession('41341: rn:R01074','KEGG','288240',true).
concept_accession('41341: rn:R01074','KEGG','EC:6.3.4.11',true).
concept_accession('41341: rn:R01074','KEGG','6.3.4.11',true).
concept_accession('41341: rn:R01074','EC','6.3.4.11',true).
concept_accession('41340: rn:R01168','EC','4.3.1.3',true).
concept_accession('41340: rn:R01168','KEGG','29301',true).
concept_accession('41340: rn:R01168','KEGG','4.3.1.3',true).
concept_accession('41340: rn:R01168','KEGG','RNO:29301',true).
concept_accession('41340: rn:R01168','KEGG','EC:4.3.1.3',true).
concept_accession('41339: rn:R02287','KEGG','EC:2.1.2.5',true).
concept_accession('41339: rn:R02287','KEGG','89833',true).
concept_accession('41339: rn:R02287','KEGG','2.1.2.5',true).
concept_accession('41339: rn:R02287','EC','2.1.2.5',true).
concept_accession('41339: rn:R02287','KEGG','RNO:89833',true).
concept_accession('2712: rn:R00892','KEGG','RC00011',true).
concept_accession('2712: rn:R00892','KEGG','RP:RP00125',true).
concept_accession('2712: rn:R00892','KEGG','EC:1.8.1.6',true).
concept_accession('2712: rn:R00892','KEGG','RN:R00892',true).
concept_accession('2712: rn:R00892','EC','1.8.1.6',false).
concept_accession('2712: rn:R00892','KEGG','1.8.1.6',true).
concept_accession('2712: rn:R00892','KEGG','RC:RC00011',true).
concept_accession('2712: rn:R00892','KEGG','R00892',true).
concept_accession('2712: rn:R00892','KEGG','RP00125',true).
concept_accession('41338: rn:R07768','KEGG','RNO:305348',true).
concept_accession('41338: rn:R07768','EC','2.8.1.8',true).
concept_accession('41338: rn:R07768','KEGG','305348',true).
concept_accession('41338: rn:R07768','KEGG','2.8.1.8',true).
concept_accession('41338: rn:R07768','KEGG','EC:2.8.1.8',true).
concept_accession('2713: rn:R01113','KEGG','RC00011',true).
concept_accession('2713: rn:R01113','KEGG','RP:RP00125',true).
concept_accession('2713: rn:R01113','KEGG','R01113',true).
concept_accession('2713: rn:R01113','EC','1.8.4.4',false).
concept_accession('2713: rn:R01113','KEGG','EC:1.8.4.4',true).
concept_accession('2713: rn:R01113','KEGG','1.8.4.4',true).
concept_accession('2713: rn:R01113','KEGG','RN:R01113',true).
concept_accession('2713: rn:R01113','KEGG','RC:RC00011',true).
concept_accession('2713: rn:R01113','KEGG','RP00125',true).
concept_accession('41337: rn:R02288','EC','3.5.2.7',true).
concept_accession('41337: rn:R02288','KEGG','RNO:299735',true).
concept_accession('41337: rn:R02288','KEGG','3.5.2.7',true).
concept_accession('41337: rn:R02288','KEGG','299735',true).
concept_accession('41337: rn:R02288','KEGG','EC:3.5.2.7',true).
concept_accession('41336: rn:R07769','KEGG','365314',true).
concept_accession('41336: rn:R07769','EC','2.3.1.181',true).
concept_accession('41336: rn:R07769','KEGG','2.3.1.181',true).
concept_accession('41336: rn:R07769','KEGG','EC:2.3.1.181',true).
concept_accession('41336: rn:R07769','KEGG','RNO:365314',true).
concept_accession('41335: rn:R04869','KEGG','317409',true).
concept_accession('41335: rn:R04869','KEGG','3.4.-.-',true).
concept_accession('41335: rn:R04869','KEGG','RNO:317409',true).
concept_accession('41335: rn:R04869','EC','3.4.-.-',true).
concept_accession('41335: rn:R04869','KEGG','EC:3.4.-.-',true).
concept_accession('41334: rn:R05145','KEGG','EC:6.3.4.9',true).
concept_accession('41334: rn:R05145','EC','6.3.4.9',true).
concept_accession('41334: rn:R05145','KEGG','6.3.4.9',true).
concept_accession('41334: rn:R05145','KEGG','RNO:288240',true).
concept_accession('41334: rn:R05145','KEGG','288240',true).
concept_accession('2709: rn:R07634','KEGG','4.4.1.25',true).
concept_accession('2709: rn:R07634','KEGG','EC:4.4.1.25',true).
concept_accession('2709: rn:R07634','EC','4.4.1.25',false).
concept_accession('2709: rn:R07634','KEGG','R07634',true).
concept_accession('2709: rn:R07634','KEGG','RN:R07634',true).
concept_accession('2709: rn:R07634','KEGG','RC:RC01784',true).
concept_accession('2709: rn:R07634','KEGG','RP:RP10722',true).
concept_accession('2709: rn:R07634','KEGG','RP10722',true).
concept_accession('2709: rn:R07634','KEGG','RC01784',true).
concept_accession('41333: rn:R01077','EC','3.5.1.12',true).
concept_accession('41333: rn:R01077','KEGG','RNO:306262',true).
concept_accession('41333: rn:R01077','KEGG','306262',true).
concept_accession('41333: rn:R01077','KEGG','3.5.1.12',true).
concept_accession('41333: rn:R01077','KEGG','EC:3.5.1.12',true).
concept_accession('2710: rn:R02409','EC','1.8.4.3',false).
concept_accession('2710: rn:R02409','KEGG','EC:1.8.4.3',true).
concept_accession('2710: rn:R02409','KEGG','RN:R02409',true).
concept_accession('2710: rn:R02409','KEGG','1.8.4.3',true).
concept_accession('2710: rn:R02409','KEGG','R02409',true).
concept_accession('41332: rn:R05145','KEGG','EC:6.3.4.9',true).
concept_accession('41332: rn:R05145','EC','6.3.4.9',true).
concept_accession('41332: rn:R05145','KEGG','6.3.4.9',true).
concept_accession('41332: rn:R05145','KEGG','RNO:288240',true).
concept_accession('41332: rn:R05145','KEGG','288240',true).
concept_accession('41331: rn:R05145','KEGG','EC:6.3.4.9',true).
concept_accession('41331: rn:R05145','EC','6.3.4.9',true).
concept_accession('41331: rn:R05145','KEGG','6.3.4.9',true).
concept_accession('41331: rn:R05145','KEGG','RNO:288240',true).
concept_accession('41331: rn:R05145','KEGG','288240',true).
concept_accession('41330: rn:R01074','KEGG','RNO:288240',true).
concept_accession('41330: rn:R01074','KEGG','288240',true).
concept_accession('41330: rn:R01074','KEGG','EC:6.3.4.11',true).
concept_accession('41330: rn:R01074','KEGG','6.3.4.11',true).
concept_accession('41330: rn:R01074','EC','6.3.4.11',true).
concept_accession('41329: rn:R01074','KEGG','RNO:288240',true).
concept_accession('41329: rn:R01074','KEGG','288240',true).
concept_accession('41329: rn:R01074','KEGG','EC:6.3.4.11',true).
concept_accession('41329: rn:R01074','KEGG','6.3.4.11',true).
concept_accession('41329: rn:R01074','EC','6.3.4.11',true).
concept_accession('41328: rn:R07771','KEGG','EC:2.7.7.63',true).
concept_accession('41328: rn:R07771','EC','2.7.7.63',true).
concept_accession('41328: rn:R07771','KEGG','RNO:316342',true).
concept_accession('41328: rn:R07771','KEGG','316342',true).
concept_accession('41328: rn:R07771','KEGG','2.7.7.63',true).
concept_accession('41326: rn:R07767','KEGG','RNO:305348',true).
concept_accession('41326: rn:R07767','EC','2.8.1.8',true).
concept_accession('41326: rn:R07767','KEGG','305348',true).
concept_accession('41326: rn:R07767','KEGG','2.8.1.8',true).
concept_accession('41326: rn:R07767','KEGG','EC:2.8.1.8',true).
concept_accession('41327: rn:R07766','KEGG','365314',true).
concept_accession('41327: rn:R07766','EC','2.3.1.181',true).
concept_accession('41327: rn:R07766','KEGG','2.3.1.181',true).
concept_accession('41327: rn:R07766','KEGG','EC:2.3.1.181',true).
concept_accession('41327: rn:R07766','KEGG','RNO:365314',true).
concept_accession('2700: rn:R07274','KEGG','2.5.1.65',true).
concept_accession('2700: rn:R07274','KEGG','R07274',true).
concept_accession('2700: rn:R07274','EC','2.5.1.65',false).
concept_accession('2700: rn:R07274','KEGG','RN:R07274',true).
concept_accession('2700: rn:R07274','KEGG','EC:2.5.1.65',true).
concept_accession('41324: rn:R00526','KEGG','EC:3.5.1.8',true).
concept_accession('41324: rn:R00526','KEGG','3.5.1.8',true).
concept_accession('41324: rn:R00526','KEGG','293653',true).
concept_accession('41324: rn:R00526','EC','3.5.1.8',true).
concept_accession('41324: rn:R00526','KEGG','RNO:293653',true).
concept_accession('41324: rn:R00526','KEGG','79251',true).
concept_accession('41324: rn:R00526','KEGG','RNO:79251',true).
concept_accession('41325: rn:R01166','KEGG','3.4.13.3',true).
concept_accession('41325: rn:R01166','KEGG','EC:3.4.13.3',true).
concept_accession('41325: rn:R01166','KEGG','RNO:307212',true).
concept_accession('41325: rn:R01166','KEGG','307212',true).
concept_accession('41325: rn:R01166','EC','3.4.13.3',true).
concept_accession('41322: rn:R01394','KEGG','500536',true).
concept_accession('41322: rn:R01394','KEGG','EC:5.3.1.22',true).
concept_accession('41322: rn:R01394','EC','5.3.1.22',true).
concept_accession('41322: rn:R01394','KEGG','RNO:500536',true).
concept_accession('41322: rn:R01394','KEGG','5.3.1.22',true).
concept_accession('2697: rn:R08699','KEGG','RC01020',true).
concept_accession('2697: rn:R08699','KEGG','RP13461',true).
concept_accession('2697: rn:R08699','KEGG','RP:RP13461',true).
concept_accession('2697: rn:R08699','KEGG','RC:RC01020',true).
concept_accession('2697: rn:R08699','KEGG','RN:R08699',true).
concept_accession('2697: rn:R08699','KEGG','R08699',true).
concept_accession('41323: rn:R01159','KEGG','RNO:290564',true).
concept_accession('41323: rn:R01159','KEGG','300989',true).
concept_accession('41323: rn:R01159','KEGG','2.1.1.-',true).
concept_accession('41323: rn:R01159','KEGG','EC:2.1.1.-',true).
concept_accession('41323: rn:R01159','EC','2.1.1.-',true).
concept_accession('41323: rn:R01159','KEGG','290564',true).
concept_accession('41323: rn:R01159','KEGG','RNO:300989',true).
concept_accession('41320: rn:R02670','EC','1.11.1.6',true).
concept_accession('41320: rn:R02670','KEGG','EC:1.11.1.6',true).
concept_accession('41320: rn:R02670','KEGG','24248',true).
concept_accession('41320: rn:R02670','KEGG','RNO:24248',true).
concept_accession('41320: rn:R02670','KEGG','1.11.1.6',true).
concept_accession('41321: rn:R01900','KEGG','EC:4.2.1.3',true).
concept_accession('41321: rn:R01900','EC','4.2.1.3',true).
concept_accession('41321: rn:R01900','KEGG','79250',true).
concept_accession('41321: rn:R01900','KEGG','RNO:79250',true).
concept_accession('41321: rn:R01900','KEGG','4.2.1.3',true).
concept_accession('41321: rn:R01900','KEGG','RNO:50655',true).
concept_accession('41321: rn:R01900','KEGG','50655',true).
concept_accession('41318: rn:R03629','KEGG','25426',true).
concept_accession('41318: rn:R03629','EC','1.14.14.1',true).
concept_accession('41318: rn:R03629','KEGG','1.14.14.1',true).
concept_accession('41318: rn:R03629','KEGG','24297',true).
concept_accession('41318: rn:R03629','KEGG','24296',true).
concept_accession('41318: rn:R03629','KEGG','RNO:24296',true).
concept_accession('41318: rn:R03629','KEGG','RNO:24297',true).
concept_accession('41318: rn:R03629','KEGG','RNO:25426',true).
concept_accession('41318: rn:R03629','KEGG','EC:1.14.14.1',true).
concept_accession('41319: rn:R03628','KEGG','681319',true).
concept_accession('41319: rn:R03628','EC','1.13.11.52',true).
concept_accession('41319: rn:R03628','KEGG','RNO:681319',true).
concept_accession('41319: rn:R03628','KEGG','1.13.11.52',true).
concept_accession('41319: rn:R03628','KEGG','RNO:66029',true).
concept_accession('41319: rn:R03628','KEGG','684861',true).
concept_accession('41319: rn:R03628','KEGG','RNO:684861',true).
concept_accession('41319: rn:R03628','KEGG','66029',true).
concept_accession('41319: rn:R03628','KEGG','EC:1.13.11.52',true).
concept_accession('41316: rn:R01975','KEGG','171142',true).
concept_accession('41316: rn:R01975','KEGG','RNO:171142',true).
concept_accession('41316: rn:R01975','EC','1.1.1.35',true).
concept_accession('41316: rn:R01975','KEGG','RNO:113965',true).
concept_accession('41316: rn:R01975','KEGG','EC:1.1.1.35',true).
concept_accession('41316: rn:R01975','KEGG','1.1.1.35',true).
concept_accession('41316: rn:R01975','KEGG','113965',true).
concept_accession('41317: rn:R00677','KEGG','EC:1.4.3.2',true).
concept_accession('41317: rn:R00677','EC','1.4.3.2',true).
concept_accession('41317: rn:R00677','KEGG','298483',true).
concept_accession('41317: rn:R00677','KEGG','RNO:100360621',true).
concept_accession('41317: rn:R00677','KEGG','1.4.3.2',true).
concept_accession('41317: rn:R00677','KEGG','RNO:298483',true).
concept_accession('41317: rn:R00677','KEGG','100360621',true).
concept_accession('2694: rn:R00901','KEGG','4.4.1.10',true).
concept_accession('2694: rn:R00901','KEGG','RN:R00901',true).
concept_accession('2694: rn:R00901','KEGG','R00901',true).
concept_accession('2694: rn:R00901','EC','4.4.1.10',false).
concept_accession('2694: rn:R00901','KEGG','EC:4.4.1.10',true).
concept_accession('41314: rn:R00317','KEGG','3.6.1.7',true).
concept_accession('41314: rn:R00317','KEGG','299203',true).
concept_accession('41314: rn:R00317','KEGG','RNO:364224',true).
concept_accession('41314: rn:R00317','KEGG','RNO:299203',true).
concept_accession('41314: rn:R00317','EC','3.6.1.7',true).
concept_accession('41314: rn:R00317','KEGG','364224',true).
concept_accession('41314: rn:R00317','KEGG','EC:3.6.1.7',true).
concept_accession('2689: rn:R04860','KEGG','RC00011',true).
concept_accession('2689: rn:R04860','KEGG','R04860',true).
concept_accession('2689: rn:R04860','KEGG','RP:RP13498',true).
concept_accession('2689: rn:R04860','EC','1.8.4.3',false).
concept_accession('2689: rn:R04860','KEGG','EC:1.8.4.3',true).
concept_accession('2689: rn:R04860','KEGG','1.8.4.3',true).
concept_accession('2689: rn:R04860','KEGG','RN:R04860',true).
concept_accession('2689: rn:R04860','KEGG','RC:RC00011',true).
concept_accession('2689: rn:R04860','KEGG','RP13498',true).
concept_accession('41315: rn:R00678','KEGG','681319',true).
concept_accession('41315: rn:R00678','KEGG','EC:1.13.11.11',true).
concept_accession('41315: rn:R00678','KEGG','1.13.11.11',true).
concept_accession('41315: rn:R00678','EC','1.13.11.11',true).
concept_accession('41315: rn:R00678','KEGG','RNO:681319',true).
concept_accession('41315: rn:R00678','KEGG','RNO:66029',true).
concept_accession('41315: rn:R00678','KEGG','684861',true).
concept_accession('41315: rn:R00678','KEGG','RNO:684861',true).
concept_accession('41315: rn:R00678','KEGG','66029',true).
concept_accession('41312: rn:R02569','KEGG','EC:2.3.1.12',true).
concept_accession('41312: rn:R02569','KEGG','2.3.1.12',true).
concept_accession('41312: rn:R02569','KEGG','RNO:81654',true).
concept_accession('41312: rn:R02569','KEGG','81654',true).
concept_accession('41312: rn:R02569','EC','2.3.1.12',true).
concept_accession('41313: rn:R07618','KEGG','298942',true).
concept_accession('41313: rn:R07618','KEGG','1.8.1.4',true).
concept_accession('41313: rn:R07618','KEGG','EC:1.8.1.4',true).
concept_accession('41313: rn:R07618','KEGG','RNO:298942',true).
concept_accession('41313: rn:R07618','EC','1.8.1.4',true).
concept_accession('2690: rn:R00900','KEGG','RC00011',true).
concept_accession('2690: rn:R00900','KEGG','RP:RP13499',true).
concept_accession('2690: rn:R00900','KEGG','RP:RP13498',true).
concept_accession('2690: rn:R00900','KEGG','EC:1.8.1.10',true).
concept_accession('2690: rn:R00900','EC','1.8.1.10',false).
concept_accession('2690: rn:R00900','KEGG','R00900',true).
concept_accession('2690: rn:R00900','KEGG','RN:R00900',true).
concept_accession('2690: rn:R00900','KEGG','1.8.1.10',true).
concept_accession('2690: rn:R00900','KEGG','RC:RC00011',true).
concept_accession('2690: rn:R00900','KEGG','RP13499',true).
concept_accession('2690: rn:R00900','KEGG','RP13498',true).
concept_accession('41241: rn:R05947','KEGG','RNO:364901',true).
concept_accession('41241: rn:R05947','KEGG','EC:2.4.99.8',true).
concept_accession('41241: rn:R05947','KEGG','364901',true).
concept_accession('41241: rn:R05947','EC','2.4.99.8',true).
concept_accession('41241: rn:R05947','KEGG','2.4.99.8',true).
concept_accession('41240: rn:R08965','KEGG','298182',true).
concept_accession('41240: rn:R08965','KEGG','1.14.18.-',true).
concept_accession('41240: rn:R08965','EC','1.14.18.-',true).
concept_accession('41240: rn:R08965','KEGG','EC:1.14.18.-',true).
concept_accession('41240: rn:R08965','KEGG','RNO:298182',true).
concept_accession('41243: rn:R05951','KEGG','RNO:407765',true).
concept_accession('41243: rn:R05951','EC','2.4.99.-',true).
concept_accession('41243: rn:R05951','KEGG','EC:2.4.99.-',true).
concept_accession('41243: rn:R05951','KEGG','407765',true).
concept_accession('41243: rn:R05951','KEGG','2.4.99.-',true).
concept_accession('41242: rn:R05950','EC','2.4.99.-',true).
concept_accession('41242: rn:R05950','KEGG','RNO:364901',true).
concept_accession('41242: rn:R05950','KEGG','364901',true).
concept_accession('41242: rn:R05950','KEGG','EC:2.4.99.-',true).
concept_accession('41242: rn:R05950','KEGG','2.4.99.-',true).
concept_accession('41245: rn:R05952','KEGG','64828',true).
concept_accession('41245: rn:R05952','EC','2.4.1.92',true).
concept_accession('41245: rn:R05952','KEGG','RNO:64828',true).
concept_accession('41245: rn:R05952','KEGG','EC:2.4.1.92',true).
concept_accession('41245: rn:R05952','KEGG','2.4.1.92',true).
concept_accession('41244: rn:R05953','KEGG','EC:2.4.1.62',true).
concept_accession('41244: rn:R05953','KEGG','2.4.1.62',true).
concept_accession('41244: rn:R05953','EC','2.4.1.62',true).
concept_accession('41244: rn:R05953','KEGG','RNO:171079',true).
concept_accession('41244: rn:R05953','KEGG','171079',true).
concept_accession('41247: rn:R05945','KEGG','RNO:407765',true).
concept_accession('41247: rn:R05945','EC','2.4.99.-',true).
concept_accession('41247: rn:R05945','KEGG','EC:2.4.99.-',true).
concept_accession('41247: rn:R05945','KEGG','407765',true).
concept_accession('41247: rn:R05945','KEGG','2.4.99.-',true).
concept_accession('41246: rn:R05958','EC','2.4.99.-',true).
concept_accession('41246: rn:R05958','KEGG','RNO:364901',true).
concept_accession('41246: rn:R05958','KEGG','364901',true).
concept_accession('41246: rn:R05958','KEGG','EC:2.4.99.-',true).
concept_accession('41246: rn:R05958','KEGG','2.4.99.-',true).
concept_accession('41233: rn:R05962','KEGG','EC:2.4.1.79',true).
concept_accession('41233: rn:R05962','KEGG','2.4.1.79',true).
concept_accession('41233: rn:R05962','KEGG','RNO:310508',true).
concept_accession('41233: rn:R05962','EC','2.4.1.79',true).
concept_accession('41233: rn:R05962','KEGG','310508',true).
concept_accession('41232: rn:R05967','KEGG','EC:2.4.99.4',true).
concept_accession('41232: rn:R05967','KEGG','64442',true).
concept_accession('41232: rn:R05967','KEGG','2.4.99.4',true).
concept_accession('41232: rn:R05967','EC','2.4.99.4',true).
concept_accession('41232: rn:R05967','KEGG','RNO:64442',true).
concept_accession('41232: rn:R05967','KEGG','362924',true).
concept_accession('41232: rn:R05967','KEGG','RNO:362924',true).
concept_accession('41235: rn:R06010','KEGG','3.2.1.23',true).
concept_accession('41235: rn:R06010','EC','3.2.1.23',true).
concept_accession('41235: rn:R06010','KEGG','EC:3.2.1.23',true).
concept_accession('41235: rn:R06010','KEGG','RNO:316033',true).
concept_accession('41235: rn:R06010','KEGG','316033',true).
concept_accession('41234: rn:R05904','KEGG','84597',true).
concept_accession('41234: rn:R05904','KEGG','2.4.1.152',true).
concept_accession('41234: rn:R05904','KEGG','RNO:84597',true).
concept_accession('41234: rn:R05904','KEGG','EC:2.4.1.152',true).
concept_accession('41234: rn:R05904','EC','2.4.1.152',true).
concept_accession('41237: rn:R05947','KEGG','EC:2.4.99.8',true).
concept_accession('41237: rn:R05947','KEGG','25280',true).
concept_accession('41237: rn:R05947','EC','2.4.99.8',true).
concept_accession('41237: rn:R05947','KEGG','RNO:25280',true).
concept_accession('41237: rn:R05947','KEGG','2.4.99.8',true).
concept_accession('41236: rn:R05949','KEGG','EC:2.4.99.4',true).
concept_accession('41236: rn:R05949','KEGG','64442',true).
concept_accession('41236: rn:R05949','KEGG','2.4.99.4',true).
concept_accession('41236: rn:R05949','EC','2.4.99.4',true).
concept_accession('41236: rn:R05949','KEGG','RNO:64442',true).
concept_accession('41236: rn:R05949','KEGG','362924',true).
concept_accession('41236: rn:R05949','KEGG','RNO:362924',true).
concept_accession('41239: rn:R02078','KEGG','RNO:308800',true).
concept_accession('41239: rn:R02078','KEGG','308800',true).
concept_accession('41239: rn:R02078','KEGG','EC:1.14.18.1',true).
concept_accession('41239: rn:R02078','EC','1.14.18.1',true).
concept_accession('41239: rn:R02078','KEGG','1.14.18.1',true).
concept_accession('41238: rn:R06004','KEGG','RNO:294673',true).
concept_accession('41238: rn:R06004','KEGG','294673',true).
concept_accession('41238: rn:R06004','KEGG','RNO:300757',true).
concept_accession('41238: rn:R06004','KEGG','EC:3.2.1.52',true).
concept_accession('41238: rn:R06004','EC','3.2.1.52',true).
concept_accession('41238: rn:R06004','KEGG','300757',true).
concept_accession('41238: rn:R06004','KEGG','3.2.1.52',true).
concept_accession('41224: rn:R00216','KEGG','RNO:361602',true).
concept_accession('41224: rn:R00216','KEGG','361602',true).
concept_accession('41224: rn:R00216','KEGG','RNO:24552',true).
concept_accession('41224: rn:R00216','EC','1.1.1.40',true).
concept_accession('41224: rn:R00216','KEGG','24552',true).
concept_accession('41224: rn:R00216','KEGG','EC:1.1.1.40',true).
concept_accession('41224: rn:R00216','KEGG','1.1.1.40',true).
concept_accession('41225: rn:R00227','KEGG','170570',true).
concept_accession('41225: rn:R00227','KEGG','3.1.2.1',true).
concept_accession('41225: rn:R00227','EC','3.1.2.1',true).
concept_accession('41225: rn:R00227','KEGG','EC:3.1.2.1',true).
concept_accession('41225: rn:R00227','KEGG','RNO:170570',true).
concept_accession('41226: rn:R00236','KEGG','311569',true).
concept_accession('41226: rn:R00236','KEGG','RNO:296259',true).
concept_accession('41226: rn:R00236','KEGG','296259',true).
concept_accession('41226: rn:R00236','KEGG','EC:6.2.1.1',true).
concept_accession('41226: rn:R00236','KEGG','RNO:311569',true).
concept_accession('41226: rn:R00236','EC','6.2.1.1',true).
concept_accession('41226: rn:R00236','KEGG','6.2.1.1',true).
concept_accession('41227: rn:R00703','KEGG','EC:1.1.1.27',true).
concept_accession('41227: rn:R00703','KEGG','RNO:369018',true).
concept_accession('41227: rn:R00703','EC','1.1.1.27',true).
concept_accession('41227: rn:R00703','KEGG','369018',true).
concept_accession('41227: rn:R00703','KEGG','RNO:24533',true).
concept_accession('41227: rn:R00703','KEGG','RNO:29634',true).
concept_accession('41227: rn:R00703','KEGG','RNO:24534',true).
concept_accession('41227: rn:R00703','KEGG','24534',true).
concept_accession('41227: rn:R00703','KEGG','24533',true).
concept_accession('41227: rn:R00703','KEGG','29634',true).
concept_accession('41227: rn:R00703','KEGG','RNO:500965',true).
concept_accession('41227: rn:R00703','KEGG','1.1.1.27',true).
concept_accession('41227: rn:R00703','KEGG','500965',true).
concept_accession('41228: rn:R05962','KEGG','EC:2.4.1.79',true).
concept_accession('41228: rn:R05962','KEGG','2.4.1.79',true).
concept_accession('41228: rn:R05962','KEGG','RNO:310508',true).
concept_accession('41228: rn:R05962','EC','2.4.1.79',true).
concept_accession('41228: rn:R05962','KEGG','310508',true).
concept_accession('41229: rn:R05968','EC','2.4.1.69',true).
concept_accession('41229: rn:R05968','KEGG','RNO:58924',true).
concept_accession('41229: rn:R05968','KEGG','81919',true).
concept_accession('41229: rn:R05968','KEGG','58924',true).
concept_accession('41229: rn:R05968','KEGG','EC:2.4.1.69',true).
concept_accession('41229: rn:R05968','KEGG','308586',true).
concept_accession('41229: rn:R05968','KEGG','RNO:81919',true).
concept_accession('41229: rn:R05968','KEGG','RNO:308586',true).
concept_accession('41229: rn:R05968','KEGG','2.4.1.69',true).
concept_accession('41230: rn:R05964','KEGG','288161',true).
concept_accession('41230: rn:R05964','EC','2.4.1.-',true).
concept_accession('41230: rn:R05964','KEGG','2.4.1.-',true).
concept_accession('41230: rn:R05964','KEGG','RNO:288161',true).
concept_accession('41230: rn:R05964','KEGG','EC:2.4.1.-',true).
concept_accession('41231: rn:R05960','KEGG','RNO:63888',true).
concept_accession('41231: rn:R05960','KEGG','EC:2.4.1.228',true).
concept_accession('41231: rn:R05960','KEGG','63888',true).
concept_accession('41231: rn:R05960','EC','2.4.1.228',true).
concept_accession('41231: rn:R05960','KEGG','2.4.1.228',true).
concept_accession('10371: rn:R03684','KEGG','R03684',true).
concept_accession('10371: rn:R03684','KEGG','RN:R03684',true).
concept_accession('41216: rn:R02577','KEGG','24192',true).
concept_accession('41216: rn:R02577','KEGG','RNO:24192',true).
concept_accession('41216: rn:R02577','KEGG','1.1.1.21',true).
concept_accession('41216: rn:R02577','EC','1.1.1.21',true).
concept_accession('41216: rn:R02577','KEGG','EC:1.1.1.21',true).
concept_accession('41217: rn:R02531','KEGG','24192',true).
concept_accession('41217: rn:R02531','KEGG','RNO:24192',true).
concept_accession('41217: rn:R02531','KEGG','1.1.1.21',true).
concept_accession('41217: rn:R02531','EC','1.1.1.21',true).
concept_accession('41217: rn:R02531','KEGG','EC:1.1.1.21',true).
concept_accession('41218: rn:R00200 rn:R02320','KEGG','RNO:25630',true).
concept_accession('41218: rn:R00200 rn:R02320','KEGG','24651',true).
concept_accession('41218: rn:R00200 rn:R02320','KEGG','2.7.1.40',true).
concept_accession('41218: rn:R00200 rn:R02320','KEGG','25630',true).
concept_accession('41218: rn:R00200 rn:R02320','KEGG','EC:2.7.1.40',true).
concept_accession('41218: rn:R00200 rn:R02320','EC','2.7.1.40',true).
concept_accession('41218: rn:R00200 rn:R02320','KEGG','100364062',true).
concept_accession('41218: rn:R00200 rn:R02320','KEGG','RNO:24651',true).
concept_accession('41218: rn:R00200 rn:R02320','KEGG','RNO:100364062',true).
concept_accession('41219: rn:R00344','KEGG','RNO:25104',true).
concept_accession('41219: rn:R00344','KEGG','25104',true).
concept_accession('41219: rn:R00344','KEGG','6.4.1.1',true).
concept_accession('41219: rn:R00344','EC','6.4.1.1',true).
concept_accession('41219: rn:R00344','KEGG','EC:6.4.1.1',true).
concept_accession('41220: rn:R00214','KEGG','307270',true).
concept_accession('41220: rn:R00214','EC','1.1.1.39',true).
concept_accession('41220: rn:R00214','KEGG','EC:1.1.1.39',true).
concept_accession('41220: rn:R00214','KEGG','RNO:307270',true).
concept_accession('41220: rn:R00214','KEGG','1.1.1.39',true).
concept_accession('41221: rn:R00197','KEGG','RNO:307858',true).
concept_accession('41221: rn:R00197','KEGG','1.1.2.4',true).
concept_accession('41221: rn:R00197','KEGG','EC:1.1.2.4',true).
concept_accession('41221: rn:R00197','EC','1.1.2.4',true).
concept_accession('41221: rn:R00197','KEGG','307858',true).
concept_accession('41222: rn:R01736','EC','3.1.2.6',true).
concept_accession('41222: rn:R01736','KEGG','EC:3.1.2.6',true).
concept_accession('41222: rn:R01736','KEGG','RNO:24439',true).
concept_accession('41222: rn:R01736','KEGG','24439',true).
concept_accession('41222: rn:R01736','KEGG','3.1.2.6',true).
concept_accession('41223: rn:R00342','KEGG','81829',true).
concept_accession('41223: rn:R00342','KEGG','EC:1.1.1.37',true).
concept_accession('41223: rn:R00342','EC','1.1.1.37',true).
concept_accession('41223: rn:R00342','KEGG','RNO:81829',true).
concept_accession('41223: rn:R00342','KEGG','1.1.1.37',true).
concept_accession('41223: rn:R00342','KEGG','RNO:24551',true).
concept_accession('41223: rn:R00342','KEGG','24551',true).
concept_accession('41275: rn:R00987','EC','3.7.1.3',true).
concept_accession('41275: rn:R00987','KEGG','EC:3.7.1.3',true).
concept_accession('41275: rn:R00987','KEGG','RNO:116682',true).
concept_accession('41275: rn:R00987','KEGG','3.7.1.3',true).
concept_accession('41275: rn:R00987','KEGG','116682',true).
concept_accession('41274: rn:R00475','KEGG','EC:1.1.3.15',true).
concept_accession('41274: rn:R00475','KEGG','84029',true).
concept_accession('41274: rn:R00475','EC','1.1.3.15',true).
concept_accession('41274: rn:R00475','KEGG','RNO:311446',true).
concept_accession('41274: rn:R00475','KEGG','1.1.3.15',true).
concept_accession('41274: rn:R00475','KEGG','311446',true).
concept_accession('41274: rn:R00475','KEGG','RNO:84029',true).
concept_accession('41273: rn:R00988','KEGG','EC:3.5.1.9',true).
concept_accession('41273: rn:R00988','EC','3.5.1.9',true).
concept_accession('41273: rn:R00988','KEGG','3.5.1.9',true).
concept_accession('41273: rn:R00988','KEGG','RNO:688283',true).
concept_accession('41273: rn:R00988','KEGG','688283',true).
concept_accession('41272: rn:R02668','EC','3.7.1.3',true).
concept_accession('41272: rn:R02668','KEGG','EC:3.7.1.3',true).
concept_accession('41272: rn:R02668','KEGG','RNO:116682',true).
concept_accession('41272: rn:R02668','KEGG','3.7.1.3',true).
concept_accession('41272: rn:R02668','KEGG','116682',true).
concept_accession('41279: rn:R02665','KEGG','RNO:56823',true).
concept_accession('41279: rn:R02665','KEGG','56823',true).
concept_accession('41279: rn:R02665','EC','1.13.11.6',true).
concept_accession('41279: rn:R02665','KEGG','1.13.11.6',true).
concept_accession('41279: rn:R02665','KEGG','EC:1.13.11.6',true).
concept_accession('41278: rn:R01959','KEGG','EC:3.5.1.9',true).
concept_accession('41278: rn:R01959','EC','3.5.1.9',true).
concept_accession('41278: rn:R01959','KEGG','3.5.1.9',true).
concept_accession('41278: rn:R01959','KEGG','RNO:688283',true).
concept_accession('41278: rn:R01959','KEGG','688283',true).
concept_accession('41277: rn:R03936','EC','3.7.1.3',true).
concept_accession('41277: rn:R03936','KEGG','EC:3.7.1.3',true).
concept_accession('41277: rn:R03936','KEGG','RNO:116682',true).
concept_accession('41277: rn:R03936','KEGG','3.7.1.3',true).
concept_accession('41277: rn:R03936','KEGG','116682',true).
concept_accession('41276: rn:R01960','EC','1.14.13.9',true).
concept_accession('41276: rn:R01960','KEGG','59113',true).
concept_accession('41276: rn:R01960','KEGG','1.14.13.9',true).
concept_accession('41276: rn:R01960','KEGG','RNO:59113',true).
concept_accession('41276: rn:R01960','KEGG','EC:1.14.13.9',true).
concept_accession('41267: rn:R04171','EC','2.6.1.7',true).
concept_accession('41267: rn:R04171','KEGG','RNO:311844',true).
concept_accession('41267: rn:R04171','KEGG','RNO:29416',true).
concept_accession('41267: rn:R04171','KEGG','EC:2.6.1.7',true).
concept_accession('41267: rn:R04171','KEGG','RNO:541589',true).
concept_accession('41267: rn:R04171','KEGG','541589',true).
concept_accession('41267: rn:R04171','KEGG','2.6.1.7',true).
concept_accession('41267: rn:R04171','KEGG','29416',true).
concept_accession('41267: rn:R04171','KEGG','311844',true).
concept_accession('41266: rn:R01956','EC','2.6.1.7',true).
concept_accession('41266: rn:R01956','KEGG','RNO:311844',true).
concept_accession('41266: rn:R01956','KEGG','RNO:29416',true).
concept_accession('41266: rn:R01956','KEGG','EC:2.6.1.7',true).
concept_accession('41266: rn:R01956','KEGG','RNO:541589',true).
concept_accession('41266: rn:R01956','KEGG','541589',true).
concept_accession('41266: rn:R01956','KEGG','2.6.1.7',true).
concept_accession('41266: rn:R01956','KEGG','29416',true).
concept_accession('41266: rn:R01956','KEGG','311844',true).
concept_accession('41265: rn:R04907','KEGG','29253',true).
concept_accession('41265: rn:R04907','KEGG','RNO:29253',true).
concept_accession('41265: rn:R04907','KEGG','25750',true).
concept_accession('41265: rn:R04907','KEGG','RNO:25750',true).
concept_accession('41265: rn:R04907','KEGG','EC:1.4.3.4',true).
concept_accession('41265: rn:R04907','EC','1.4.3.4',true).
concept_accession('41265: rn:R04907','KEGG','1.4.3.4',true).
concept_accession('41264: rn:R00351','KEGG','2.3.3.1',true).
concept_accession('41264: rn:R00351','KEGG','EC:2.3.3.1',true).
concept_accession('41264: rn:R00351','EC','2.3.3.1',true).
concept_accession('41264: rn:R00351','KEGG','RNO:170587',true).
concept_accession('41264: rn:R00351','KEGG','170587',true).
concept_accession('41271: rn:R01325','KEGG','EC:4.2.1.3',true).
concept_accession('41271: rn:R01325','EC','4.2.1.3',true).
concept_accession('41271: rn:R01325','KEGG','79250',true).
concept_accession('41271: rn:R01325','KEGG','RNO:79250',true).
concept_accession('41271: rn:R01325','KEGG','4.2.1.3',true).
concept_accession('41271: rn:R01325','KEGG','RNO:50655',true).
concept_accession('41271: rn:R01325','KEGG','50655',true).
concept_accession('41270: rn:R00678','KEGG','EC:1.13.11.11',true).
concept_accession('41270: rn:R00678','KEGG','RNO:64206',true).
concept_accession('41270: rn:R00678','KEGG','1.13.11.11',true).
concept_accession('41270: rn:R00678','EC','1.13.11.11',true).
concept_accession('41270: rn:R00678','KEGG','64206',true).
concept_accession('41269: rn:R01814','KEGG','EC:1.14.16.4',true).
concept_accession('41269: rn:R01814','KEGG','317675',true).
concept_accession('41269: rn:R01814','KEGG','1.14.16.4',true).
concept_accession('41269: rn:R01814','KEGG','RNO:317675',true).
concept_accession('41269: rn:R01814','KEGG','24848',true).
concept_accession('41269: rn:R01814','EC','1.14.16.4',true).
concept_accession('41269: rn:R01814','KEGG','RNO:24848',true).
concept_accession('41268: rn:R03664','KEGG','314442',true).
concept_accession('41268: rn:R03664','EC','6.1.1.2',true).
concept_accession('41268: rn:R03664','KEGG','RNO:690654',true).
concept_accession('41268: rn:R03664','KEGG','EC:6.1.1.2',true).
concept_accession('41268: rn:R03664','KEGG','6.1.1.2',true).
concept_accession('41268: rn:R03664','KEGG','690654',true).
concept_accession('41268: rn:R03664','KEGG','RNO:314442',true).
concept_accession('41258: rn:R05938','KEGG','64828',true).
concept_accession('41258: rn:R05938','EC','2.4.1.92',true).
concept_accession('41258: rn:R05938','KEGG','RNO:64828',true).
concept_accession('41258: rn:R05938','KEGG','EC:2.4.1.92',true).
concept_accession('41258: rn:R05938','KEGG','2.4.1.92',true).
concept_accession('2761: rn:R04861','KEGG','RP04476',true).
concept_accession('2761: rn:R04861','KEGG','R04861',true).
concept_accession('2761: rn:R04861','KEGG','RP:RP04476',true).
concept_accession('2761: rn:R04861','KEGG','RC01225',true).
concept_accession('2761: rn:R04861','KEGG','RC:RC01225',true).
concept_accession('2761: rn:R04861','KEGG','RN:R04861',true).
concept_accession('41259: rn:R05959','KEGG','RNO:407765',true).
concept_accession('41259: rn:R05959','EC','2.4.99.-',true).
concept_accession('41259: rn:R05959','KEGG','EC:2.4.99.-',true).
concept_accession('41259: rn:R05959','KEGG','407765',true).
concept_accession('41259: rn:R05959','KEGG','2.4.99.-',true).
concept_accession('41256: rn:R05941','KEGG','EC:2.4.1.62',true).
concept_accession('41256: rn:R05941','KEGG','2.4.1.62',true).
concept_accession('41256: rn:R05941','EC','2.4.1.62',true).
concept_accession('41256: rn:R05941','KEGG','RNO:171079',true).
concept_accession('41256: rn:R05941','KEGG','171079',true).
concept_accession('41257: rn:R05956','KEGG','EC:2.4.1.62',true).
concept_accession('41257: rn:R05956','KEGG','2.4.1.62',true).
concept_accession('41257: rn:R05956','EC','2.4.1.62',true).
concept_accession('41257: rn:R05956','KEGG','RNO:171079',true).
concept_accession('41257: rn:R05956','KEGG','171079',true).
concept_accession('41262: rn:R05957','KEGG','EC:2.4.99.4',true).
concept_accession('41262: rn:R05957','KEGG','64442',true).
concept_accession('41262: rn:R05957','KEGG','2.4.99.4',true).
concept_accession('41262: rn:R05957','EC','2.4.99.4',true).
concept_accession('41262: rn:R05957','KEGG','RNO:64442',true).
concept_accession('41262: rn:R05957','KEGG','362924',true).
concept_accession('41262: rn:R05957','KEGG','RNO:362924',true).
concept_accession('41263: rn:R00685','KEGG','EC:4.1.1.28',true).
concept_accession('41263: rn:R00685','KEGG','4.1.1.28',true).
concept_accession('41263: rn:R00685','EC','4.1.1.28',true).
concept_accession('41263: rn:R00685','KEGG','RNO:24311',true).
concept_accession('41263: rn:R00685','KEGG','24311',true).
concept_accession('41260: rn:R01364','KEGG','RNO:29383',true).
concept_accession('41260: rn:R01364','EC','3.7.1.2',true).
concept_accession('41260: rn:R01364','KEGG','29383',true).
concept_accession('41260: rn:R01364','KEGG','EC:3.7.1.2',true).
concept_accession('41260: rn:R01364','KEGG','3.7.1.2',true).
concept_accession('41261: rn:R05946','KEGG','64828',true).
concept_accession('41261: rn:R05946','EC','2.4.1.92',true).
concept_accession('41261: rn:R05946','KEGG','RNO:64828',true).
concept_accession('41261: rn:R05946','KEGG','EC:2.4.1.92',true).
concept_accession('41261: rn:R05946','KEGG','2.4.1.92',true).
concept_accession('41250: rn:R05940','KEGG','EC:2.4.99.8',true).
concept_accession('41250: rn:R05940','KEGG','25280',true).
concept_accession('41250: rn:R05940','EC','2.4.99.8',true).
concept_accession('41250: rn:R05940','KEGG','RNO:25280',true).
concept_accession('41250: rn:R05940','KEGG','2.4.99.8',true).
concept_accession('41251: rn:R05959','EC','2.4.99.-',true).
concept_accession('41251: rn:R05959','KEGG','29758',true).
concept_accession('41251: rn:R05959','KEGG','EC:2.4.99.-',true).
concept_accession('41251: rn:R05959','KEGG','RNO:29758',true).
concept_accession('41251: rn:R05959','KEGG','2.4.99.-',true).
concept_accession('41248: rn:R05943','EC','2.4.99.-',true).
concept_accession('41248: rn:R05943','KEGG','RNO:364901',true).
concept_accession('41248: rn:R05943','KEGG','364901',true).
concept_accession('41248: rn:R05943','KEGG','EC:2.4.99.-',true).
concept_accession('41248: rn:R05943','KEGG','2.4.99.-',true).
concept_accession('41249: rn:R05959','EC','2.4.99.-',true).
concept_accession('41249: rn:R05959','KEGG','RNO:407764',true).
concept_accession('41249: rn:R05959','KEGG','EC:2.4.99.-',true).
concept_accession('41249: rn:R05959','KEGG','2.4.99.-',true).
concept_accession('41249: rn:R05959','KEGG','407764',true).
concept_accession('41254: rn:R05948','KEGG','EC:2.4.1.62',true).
concept_accession('41254: rn:R05948','KEGG','2.4.1.62',true).
concept_accession('41254: rn:R05948','EC','2.4.1.62',true).
concept_accession('41254: rn:R05948','KEGG','RNO:171079',true).
concept_accession('41254: rn:R05948','KEGG','171079',true).
concept_accession('41255: rn:R05939','KEGG','64828',true).
concept_accession('41255: rn:R05939','EC','2.4.1.92',true).
concept_accession('41255: rn:R05939','KEGG','RNO:64828',true).
concept_accession('41255: rn:R05939','KEGG','EC:2.4.1.92',true).
concept_accession('41255: rn:R05939','KEGG','2.4.1.92',true).
concept_accession('41252: rn:R05937','KEGG','EC:2.4.99.9',true).
concept_accession('41252: rn:R05937','KEGG','RNO:83505',true).
concept_accession('41252: rn:R05937','KEGG','83505',true).
concept_accession('41252: rn:R05937','EC','2.4.99.9',true).
concept_accession('41252: rn:R05937','KEGG','2.4.99.9',true).
concept_accession('2759: rn:R00863','KEGG','RC00399',true).
concept_accession('2759: rn:R00863','KEGG','RC:RC00400',true).
concept_accession('2759: rn:R00863','KEGG','RN:R00863',true).
concept_accession('2759: rn:R00863','KEGG','R00863',true).
concept_accession('2759: rn:R00863','KEGG','4.1.1.12',true).
concept_accession('2759: rn:R00863','KEGG','RP01146',true).
concept_accession('2759: rn:R00863','KEGG','RP01147',true).
concept_accession('2759: rn:R00863','KEGG','RC:RC00399',true).
concept_accession('2759: rn:R00863','EC','4.1.1.12',false).
concept_accession('2759: rn:R00863','KEGG','RC00400',true).
concept_accession('2759: rn:R00863','KEGG','RP:RP01146',true).
concept_accession('2759: rn:R00863','KEGG','RP:RP01147',true).
concept_accession('2759: rn:R00863','KEGG','EC:4.1.1.12',true).
concept_accession('41253: rn:R05942','KEGG','EC:2.4.99.4',true).
concept_accession('41253: rn:R05942','KEGG','64442',true).
concept_accession('41253: rn:R05942','KEGG','2.4.99.4',true).
concept_accession('41253: rn:R05942','EC','2.4.99.4',true).
concept_accession('41253: rn:R05942','KEGG','RNO:64442',true).
concept_accession('41253: rn:R05942','KEGG','362924',true).
concept_accession('41253: rn:R05942','KEGG','RNO:362924',true).
concept_accession('41428: rn:R00032','KEGG','114106',true).
concept_accession('41428: rn:R00032','KEGG','RNO:114106',true).
concept_accession('41428: rn:R00032','KEGG','1.14.99.36',true).
concept_accession('41428: rn:R00032','EC','1.14.99.36',true).
concept_accession('41428: rn:R00032','KEGG','EC:1.14.99.36',true).
concept_accession('41429: rn:R04893','KEGG','29253',true).
concept_accession('41429: rn:R04893','KEGG','RNO:29253',true).
concept_accession('41429: rn:R04893','KEGG','25750',true).
concept_accession('41429: rn:R04893','KEGG','RNO:25750',true).
concept_accession('41429: rn:R04893','KEGG','EC:1.4.3.4',true).
concept_accession('41429: rn:R04893','EC','1.4.3.4',true).
concept_accession('41429: rn:R04893','KEGG','1.4.3.4',true).
concept_accession('41430: rn:R02123','KEGG','RNO:116676',true).
concept_accession('41430: rn:R02123','KEGG','EC:1.2.1.36',true).
concept_accession('41430: rn:R02123','KEGG','116676',true).
concept_accession('41430: rn:R02123','KEGG','1.2.1.36',true).
concept_accession('41430: rn:R02123','EC','1.2.1.36',true).
concept_accession('2613: rn:R04861','KEGG','RP04476',true).
concept_accession('2613: rn:R04861','KEGG','R04861',true).
concept_accession('2613: rn:R04861','KEGG','RP:RP04476',true).
concept_accession('2613: rn:R04861','KEGG','RC01225',true).
concept_accession('2613: rn:R04861','KEGG','RC:RC01225',true).
concept_accession('2613: rn:R04861','KEGG','RN:R04861',true).
concept_accession('41431: rn:R02519','KEGG','360719',true).
concept_accession('41431: rn:R02519','EC','1.13.11.5',true).
concept_accession('41431: rn:R02519','KEGG','1.13.11.5',true).
concept_accession('41431: rn:R02519','KEGG','RNO:360719',true).
concept_accession('41431: rn:R02519','KEGG','EC:1.13.11.5',true).
concept_accession('41424: rn:R02920','EC','2.1.1.6',true).
concept_accession('41424: rn:R02920','KEGG','RNO:24267',true).
concept_accession('41424: rn:R02920','KEGG','2.1.1.6',true).
concept_accession('41424: rn:R02920','KEGG','EC:2.1.1.6',true).
concept_accession('41424: rn:R02920','KEGG','24267',true).
concept_accession('41425: rn:R08387','KEGG','RNO:64047',true).
concept_accession('41425: rn:R08387','KEGG','EC:2.3.1.135',true).
concept_accession('41425: rn:R08387','KEGG','2.3.1.135',true).
concept_accession('41425: rn:R08387','KEGG','64047',true).
concept_accession('41425: rn:R08387','EC','2.3.1.135',true).
concept_accession('41426: rn:R04891 rn:R04892','KEGG','RNO:25375',true).
concept_accession('41426: rn:R04891 rn:R04892','KEGG','25375',true).
concept_accession('41426: rn:R04891 rn:R04892','KEGG','RNO:266603',true).
concept_accession('41426: rn:R04891 rn:R04892','KEGG','266603',true).
concept_accession('41426: rn:R04891 rn:R04892','KEGG','RNO:309147',true).
concept_accession('41426: rn:R04891 rn:R04892','KEGG','309147',true).
concept_accession('41426: rn:R04891 rn:R04892','KEGG','EC:1.2.1.5',true).
concept_accession('41426: rn:R04891 rn:R04892','EC','1.2.1.5',true).
concept_accession('41426: rn:R04891 rn:R04892','KEGG','1.2.1.5',true).
concept_accession('41427: rn:R02532','KEGG','29253',true).
concept_accession('41427: rn:R02532','KEGG','RNO:29253',true).
concept_accession('41427: rn:R02532','KEGG','25750',true).
concept_accession('41427: rn:R02532','KEGG','RNO:25750',true).
concept_accession('41427: rn:R02532','KEGG','EC:1.4.3.4',true).
concept_accession('41427: rn:R02532','EC','1.4.3.4',true).
concept_accession('41427: rn:R02532','KEGG','1.4.3.4',true).
concept_accession('41436: rn:R03973','KEGG','54314',true).
concept_accession('41436: rn:R03973','KEGG','RNO:54314',true).
concept_accession('41436: rn:R03973','KEGG','1.11.1.8',true).
concept_accession('41436: rn:R03973','KEGG','EC:1.11.1.8',true).
concept_accession('41436: rn:R03973','EC','1.11.1.8',true).
concept_accession('41437: rn:R09395','KEGG','294753',true).
concept_accession('41437: rn:R09395','KEGG','RNO:294753',true).
concept_accession('41438: rn:R03953','KEGG','54314',true).
concept_accession('41438: rn:R03953','KEGG','RNO:54314',true).
concept_accession('41438: rn:R03953','KEGG','1.11.1.8',true).
concept_accession('41438: rn:R03953','KEGG','EC:1.11.1.8',true).
concept_accession('41438: rn:R03953','EC','1.11.1.8',true).
concept_accession('41439: rn:R04620','KEGG','RNO:100359675',true).
concept_accession('41439: rn:R04620','KEGG','64621',true).
concept_accession('41439: rn:R04620','EC','3.1.3.1',true).
concept_accession('41439: rn:R04620','KEGG','24197',true).
concept_accession('41439: rn:R04620','KEGG','3.1.3.1',true).
concept_accession('41439: rn:R04620','KEGG','100359675',true).
concept_accession('41439: rn:R04620','KEGG','RNO:25586',true).
concept_accession('41439: rn:R04620','KEGG','25586',true).
concept_accession('41439: rn:R04620','KEGG','RNO:64621',true).
concept_accession('41439: rn:R04620','KEGG','EC:3.1.3.1',true).
concept_accession('41439: rn:R04620','KEGG','RNO:24197',true).
concept_accession('41432: rn:R03181','KEGG','RNO:681913',true).
concept_accession('41432: rn:R03181','KEGG','681913',true).
concept_accession('41432: rn:R03181','KEGG','5.2.1.2',true).
concept_accession('41432: rn:R03181','KEGG','EC:5.2.1.2',true).
concept_accession('41432: rn:R03181','EC','5.2.1.2',true).
concept_accession('41433: rn:R02124','KEGG','24172',true).
concept_accession('41433: rn:R02124','KEGG','RNO:29646',true).
concept_accession('41433: rn:R02124','KEGG','RNO:310903',true).
concept_accession('41433: rn:R02124','KEGG','100145871',true).
concept_accession('41433: rn:R02124','KEGG','EC:1.1.1.1',true).
concept_accession('41433: rn:R02124','KEGG','310903',true).
concept_accession('41433: rn:R02124','KEGG','1.1.1.1',true).
concept_accession('41433: rn:R02124','KEGG','RNO:171178',true).
concept_accession('41433: rn:R02124','EC','1.1.1.1',true).
concept_accession('41433: rn:R02124','KEGG','171178',true).
concept_accession('41433: rn:R02124','KEGG','RNO:100145871',true).
concept_accession('41433: rn:R02124','KEGG','RNO:24172',true).
concept_accession('41433: rn:R02124','KEGG','29646',true).
concept_accession('2618: rn:R00179','KEGG','RC01124',true).
concept_accession('2618: rn:R00179','KEGG','R00179',true).
concept_accession('2618: rn:R00179','KEGG','4.4.1.14',true).
concept_accession('2618: rn:R00179','KEGG','RP03942',true).
concept_accession('2618: rn:R00179','KEGG','RP:RP03942',true).
concept_accession('2618: rn:R00179','KEGG','RN:R00179',true).
concept_accession('2618: rn:R00179','KEGG','RC00021',true).
concept_accession('2618: rn:R00179','KEGG','RP:RP00058',true).
concept_accession('2618: rn:R00179','KEGG','RC:RC01124',true).
concept_accession('2618: rn:R00179','KEGG','RC:RC00021',true).
concept_accession('2618: rn:R00179','KEGG','EC:4.4.1.14',true).
concept_accession('2618: rn:R00179','EC','4.4.1.14',false).
concept_accession('2618: rn:R00179','KEGG','RP00058',true).
concept_accession('41434: rn:R09394','KEGG','RNO:301221',true).
concept_accession('41434: rn:R09394','KEGG','301221',true).
concept_accession('41435: rn:R03539','KEGG','54314',true).
concept_accession('41435: rn:R03539','KEGG','RNO:54314',true).
concept_accession('41435: rn:R03539','KEGG','1.11.1.8',true).
concept_accession('41435: rn:R03539','KEGG','EC:1.11.1.8',true).
concept_accession('41435: rn:R03539','EC','1.11.1.8',true).
concept_accession('41413: rn:R02535','KEGG','1.14.17.1',true).
concept_accession('41413: rn:R02535','KEGG','25699',true).
concept_accession('41413: rn:R02535','KEGG','EC:1.14.17.1',true).
concept_accession('41413: rn:R02535','KEGG','RNO:25699',true).
concept_accession('41413: rn:R02535','EC','1.14.17.1',true).
concept_accession('41412: rn:R02919','KEGG','29253',true).
concept_accession('41412: rn:R02919','KEGG','RNO:29253',true).
concept_accession('41412: rn:R02919','KEGG','25750',true).
concept_accession('41412: rn:R02919','KEGG','RNO:25750',true).
concept_accession('41412: rn:R02919','KEGG','EC:1.4.3.4',true).
concept_accession('41412: rn:R02919','EC','1.4.3.4',true).
concept_accession('41412: rn:R02919','KEGG','1.4.3.4',true).
concept_accession('2599: rn:R01800','KEGG','R01800',true).
concept_accession('2599: rn:R01800','KEGG','EC:2.7.8.8',true).
concept_accession('2599: rn:R01800','EC','2.7.8.8',false).
concept_accession('2599: rn:R01800','KEGG','RN:R01800',true).
concept_accession('2599: rn:R01800','KEGG','RP01763',true).
concept_accession('2599: rn:R01800','KEGG','RC00017',true).
concept_accession('2599: rn:R01800','KEGG','2.7.8.8',true).
concept_accession('2599: rn:R01800','KEGG','RC:RC00017',true).
concept_accession('2599: rn:R01800','KEGG','RP:RP01763',true).
concept_accession('41415: rn:R04894','KEGG','29253',true).
concept_accession('41415: rn:R04894','KEGG','RNO:29253',true).
concept_accession('41415: rn:R04894','KEGG','25750',true).
concept_accession('41415: rn:R04894','KEGG','RNO:25750',true).
concept_accession('41415: rn:R04894','KEGG','EC:1.4.3.4',true).
concept_accession('41415: rn:R04894','EC','1.4.3.4',true).
concept_accession('41415: rn:R04894','KEGG','1.4.3.4',true).
concept_accession('41414: rn:R07163','KEGG','EC:1.3.99.23',true).
concept_accession('41414: rn:R07163','KEGG','RNO:246298',true).
concept_accession('41414: rn:R07163','KEGG','1.3.99.23',true).
concept_accession('41414: rn:R07163','EC','1.3.99.23',true).
concept_accession('41414: rn:R07163','KEGG','246298',true).
concept_accession('2597: rn:R01566','KEGG','RC:RC00549',true).
concept_accession('2597: rn:R01566','KEGG','RC00549',true).
concept_accession('2597: rn:R01566','KEGG','RP01599',true).
concept_accession('2597: rn:R01566','KEGG','RP:RP01599',true).
concept_accession('2597: rn:R01566','KEGG','R01566',true).
concept_accession('2597: rn:R01566','KEGG','RN:R01566',true).
concept_accession('2597: rn:R01566','KEGG','3.5.3.3',true).
concept_accession('2597: rn:R01566','EC','3.5.3.3',false).
concept_accession('2597: rn:R01566','KEGG','EC:3.5.3.3',true).
concept_accession('41409: rn:R08382 rn:R08383','KEGG','RNO:314264',true).
concept_accession('41409: rn:R08382 rn:R08383','KEGG','362757',true).
concept_accession('41409: rn:R08382 rn:R08383','KEGG','366791',true).
concept_accession('41409: rn:R08382 rn:R08383','KEGG','RNO:366791',true).
concept_accession('41409: rn:R08382 rn:R08383','KEGG','EC:1.1.1.-',true).
concept_accession('41409: rn:R08382 rn:R08383','KEGG','RNO:362757',true).
concept_accession('41409: rn:R08382 rn:R08383','KEGG','1.1.1.-',true).
concept_accession('41409: rn:R08382 rn:R08383','KEGG','314264',true).
concept_accession('41409: rn:R08382 rn:R08383','EC','1.1.1.-',true).
concept_accession('41408: rn:R00736','EC','4.1.1.25',true).
concept_accession('41408: rn:R00736','KEGG','RNO:24311',true).
concept_accession('41408: rn:R00736','KEGG','24311',true).
concept_accession('41408: rn:R00736','KEGG','4.1.1.25',true).
concept_accession('41408: rn:R00736','KEGG','EC:4.1.1.25',true).
concept_accession('41411: rn:R08381','KEGG','2.3.1.76',true).
concept_accession('41411: rn:R08381','KEGG','84497',true).
concept_accession('41411: rn:R08381','KEGG','RNO:84497',true).
concept_accession('41411: rn:R08381','KEGG','EC:2.3.1.76',true).
concept_accession('41411: rn:R08381','EC','2.3.1.76',true).
concept_accession('41411: rn:R08381','KEGG','RNO:302425',true).
concept_accession('41411: rn:R08381','KEGG','302425',true).
concept_accession('41410: rn:R08389','KEGG','RNO:64047',true).
concept_accession('41410: rn:R08389','KEGG','EC:2.3.1.135',true).
concept_accession('41410: rn:R08389','KEGG','2.3.1.135',true).
concept_accession('41410: rn:R08389','KEGG','64047',true).
concept_accession('41410: rn:R08389','EC','2.3.1.135',true).
concept_accession('41421: rn:R04887','EC','2.1.1.6',true).
concept_accession('41421: rn:R04887','KEGG','RNO:24267',true).
concept_accession('41421: rn:R04887','KEGG','2.1.1.6',true).
concept_accession('41421: rn:R04887','KEGG','EC:2.1.1.6',true).
concept_accession('41421: rn:R04887','KEGG','24267',true).
concept_accession('41420: rn:R04881','EC','2.1.1.6',true).
concept_accession('41420: rn:R04881','KEGG','RNO:24267',true).
concept_accession('41420: rn:R04881','KEGG','2.1.1.6',true).
concept_accession('41420: rn:R04881','KEGG','EC:2.1.1.6',true).
concept_accession('41420: rn:R04881','KEGG','24267',true).
concept_accession('41423: rn:R02534','EC','2.1.1.6',true).
concept_accession('41423: rn:R02534','KEGG','RNO:24267',true).
concept_accession('41423: rn:R02534','KEGG','2.1.1.6',true).
concept_accession('41423: rn:R02534','KEGG','EC:2.1.1.6',true).
concept_accession('41423: rn:R02534','KEGG','24267',true).
concept_accession('10317: rn:R02369','KEGG','RN:R02369',true).
concept_accession('10317: rn:R02369','KEGG','5.2.1.7',true).
concept_accession('10317: rn:R02369','EC','5.2.1.7',false).
concept_accession('10317: rn:R02369','KEGG','RC:RC00650',true).
concept_accession('10317: rn:R02369','KEGG','EC:5.2.1.7',true).
concept_accession('10317: rn:R02369','KEGG','RP02159',true).
concept_accession('10317: rn:R02369','KEGG','R02369',true).
concept_accession('10317: rn:R02369','KEGG','RC00650',true).
concept_accession('10317: rn:R02369','KEGG','RP:RP02159',true).
concept_accession('41422: rn:R04882 rn:R04883','KEGG','RNO:25375',true).
concept_accession('41422: rn:R04882 rn:R04883','KEGG','25375',true).
concept_accession('41422: rn:R04882 rn:R04883','KEGG','RNO:266603',true).
concept_accession('41422: rn:R04882 rn:R04883','KEGG','266603',true).
concept_accession('41422: rn:R04882 rn:R04883','KEGG','RNO:309147',true).
concept_accession('41422: rn:R04882 rn:R04883','KEGG','309147',true).
concept_accession('41422: rn:R04882 rn:R04883','KEGG','EC:1.2.1.5',true).
concept_accession('41422: rn:R04882 rn:R04883','EC','1.2.1.5',true).
concept_accession('41422: rn:R04882 rn:R04883','KEGG','1.2.1.5',true).
concept_accession('41417: rn:R02533','KEGG','24661',true).
concept_accession('41417: rn:R02533','KEGG','2.1.1.28',true).
concept_accession('41417: rn:R02533','KEGG','RNO:24661',true).
concept_accession('41417: rn:R02533','KEGG','EC:2.1.1.28',true).
concept_accession('41417: rn:R02533','EC','2.1.1.28',true).
concept_accession('2602: rn:R02722','KEGG','R02722',true).
concept_accession('2602: rn:R02722','KEGG','RC00210',true).
concept_accession('2602: rn:R02722','KEGG','EC:4.2.1.20',true).
concept_accession('2602: rn:R02722','KEGG','4.2.1.20',true).
concept_accession('2602: rn:R02722','KEGG','RP00587',true).
concept_accession('2602: rn:R02722','KEGG','RC:RC00210',true).
concept_accession('2602: rn:R02722','KEGG','RP:RP00587',true).
concept_accession('2602: rn:R02722','EC','4.2.1.20',false).
concept_accession('2602: rn:R02722','KEGG','RN:R02722',true).
concept_accession('41416: rn:R08388','KEGG','89826',true).
concept_accession('41416: rn:R08388','KEGG','RNO:89826',true).
concept_accession('41419: rn:R03048 rn:R08380','KEGG','362757',true).
concept_accession('41419: rn:R03048 rn:R08380','KEGG','366791',true).
concept_accession('41419: rn:R03048 rn:R08380','KEGG','RNO:366791',true).
concept_accession('41419: rn:R03048 rn:R08380','KEGG','EC:1.1.1.-',true).
concept_accession('41419: rn:R03048 rn:R08380','KEGG','RNO:362757',true).
concept_accession('41419: rn:R03048 rn:R08380','KEGG','1.1.1.-',true).
concept_accession('41419: rn:R03048 rn:R08380','EC','1.1.1.-',true).
concept_accession('41418: rn:R04880','KEGG','24172',true).
concept_accession('41418: rn:R04880','KEGG','RNO:29646',true).
concept_accession('41418: rn:R04880','KEGG','RNO:310903',true).
concept_accession('41418: rn:R04880','KEGG','100145871',true).
concept_accession('41418: rn:R04880','KEGG','EC:1.1.1.1',true).
concept_accession('41418: rn:R04880','KEGG','310903',true).
concept_accession('41418: rn:R04880','KEGG','1.1.1.1',true).
concept_accession('41418: rn:R04880','KEGG','RNO:171178',true).
concept_accession('41418: rn:R04880','EC','1.1.1.1',true).
concept_accession('41418: rn:R04880','KEGG','171178',true).
concept_accession('41418: rn:R04880','KEGG','RNO:100145871',true).
concept_accession('41418: rn:R04880','KEGG','RNO:24172',true).
concept_accession('41418: rn:R04880','KEGG','29646',true).
concept_accession('10357: rn:R02126','KEGG','RN:R02126',true).
concept_accession('10357: rn:R02126','KEGG','5.2.1.3',true).
concept_accession('10357: rn:R02126','KEGG','RC:RC00650',true).
concept_accession('10357: rn:R02126','KEGG','RP:RP01984',true).
concept_accession('10357: rn:R02126','KEGG','EC:5.2.1.3',true).
concept_accession('10357: rn:R02126','KEGG','RC00650',true).
concept_accession('10357: rn:R02126','EC','5.2.1.3',false).
concept_accession('10357: rn:R02126','KEGG','R02126',true).
concept_accession('10357: rn:R02126','KEGG','RP01984',true).
concept_accession('41462: rn:R01709','KEGG','RNO:316421',true).
concept_accession('41462: rn:R01709','KEGG','RNO:54349',true).
concept_accession('41462: rn:R01709','EC','1.2.3.1',true).
concept_accession('41462: rn:R01709','KEGG','EC:1.2.3.1',true).
concept_accession('41462: rn:R01709','KEGG','54349',true).
concept_accession('41462: rn:R01709','KEGG','316421',true).
concept_accession('41462: rn:R01709','KEGG','1.2.3.1',true).
concept_accession('41463: rn:R00160','KEGG','RNO:85496',true).
concept_accession('41463: rn:R00160','KEGG','RNO:54410',true).
concept_accession('41463: rn:R00160','KEGG','3.6.1.9',true).
concept_accession('41463: rn:R00160','KEGG','54410',true).
concept_accession('41463: rn:R00160','KEGG','85496',true).
concept_accession('41463: rn:R00160','KEGG','EC:3.6.1.9',true).
concept_accession('41463: rn:R00160','EC','3.6.1.9',true).
concept_accession('41460: rn:R04285','KEGG','29270',true).
concept_accession('41460: rn:R04285','KEGG','EC:1.1.1.220',true).
concept_accession('41460: rn:R04285','KEGG','RNO:29270',true).
concept_accession('41460: rn:R04285','EC','1.1.1.220',true).
concept_accession('41460: rn:R04285','KEGG','1.1.1.220',true).
concept_accession('41461: rn:R03673','KEGG','5.3.3.12',true).
concept_accession('41461: rn:R03673','EC','5.3.3.12',true).
concept_accession('41461: rn:R03673','KEGG','RNO:290484',true).
concept_accession('41461: rn:R03673','KEGG','EC:5.3.3.12',true).
concept_accession('41461: rn:R03673','KEGG','290484',true).
concept_accession('41458: rn:R02235 rn:R02236','KEGG','EC:1.5.1.3',true).
concept_accession('41458: rn:R02235 rn:R02236','EC','1.5.1.3',true).
concept_accession('41458: rn:R02235 rn:R02236','KEGG','24312',true).
concept_accession('41458: rn:R02235 rn:R02236','KEGG','RNO:24312',true).
concept_accession('41458: rn:R02235 rn:R02236','KEGG','1.5.1.3',true).
concept_accession('41459: rn:R00942','EC','6.3.2.17',true).
concept_accession('41459: rn:R00942','KEGG','6.3.2.17',true).
concept_accession('41459: rn:R00942','KEGG','RNO:687266',true).
concept_accession('41459: rn:R00942','KEGG','687266',true).
concept_accession('41459: rn:R00942','KEGG','EC:6.3.2.17',true).
concept_accession('41456: rn:R01793 rn:R01794','KEGG','RNO:64192',true).
concept_accession('41456: rn:R01793 rn:R01794','KEGG','64192',true).
concept_accession('41456: rn:R01793 rn:R01794','KEGG','1.5.1.34',true).
concept_accession('41456: rn:R01793 rn:R01794','KEGG','EC:1.5.1.34',true).
concept_accession('41456: rn:R01793 rn:R01794','EC','1.5.1.34',true).
concept_accession('41457: rn:R00936 rn:R00939','KEGG','EC:1.5.1.3',true).
concept_accession('41457: rn:R00936 rn:R00939','EC','1.5.1.3',true).
concept_accession('41457: rn:R00936 rn:R00939','KEGG','24312',true).
concept_accession('41457: rn:R00936 rn:R00939','KEGG','RNO:24312',true).
concept_accession('41457: rn:R00936 rn:R00939','KEGG','1.5.1.3',true).
concept_accession('41470: rn:R00615','KEGG','3.6.1.15',true).
concept_accession('41470: rn:R00615','KEGG','EC:3.6.1.15',true).
concept_accession('41470: rn:R00615','KEGG','361443',true).
concept_accession('41470: rn:R00615','EC','3.6.1.15',true).
concept_accession('41470: rn:R00615','KEGG','RNO:361443',true).
concept_accession('41471: rn:R03283','KEGG','RNO:291450',true).
concept_accession('41471: rn:R03283','KEGG','RNO:64040',true).
concept_accession('41471: rn:R03283','KEGG','1.2.1.47',true).
concept_accession('41471: rn:R03283','KEGG','65183',true).
concept_accession('41471: rn:R03283','KEGG','24188',true).
concept_accession('41471: rn:R03283','KEGG','RNO:29539',true).
concept_accession('41471: rn:R03283','KEGG','64040',true).
concept_accession('41471: rn:R03283','KEGG','RNO:24188',true).
concept_accession('41471: rn:R03283','EC','1.2.1.47',true).
concept_accession('41471: rn:R03283','KEGG','29539',true).
concept_accession('41471: rn:R03283','KEGG','29651',true).
concept_accession('41471: rn:R03283','KEGG','298079',true).
concept_accession('41471: rn:R03283','KEGG','RNO:298079',true).
concept_accession('41471: rn:R03283','KEGG','EC:1.2.1.47',true).
concept_accession('41471: rn:R03283','KEGG','RNO:65183',true).
concept_accession('41471: rn:R03283','KEGG','RNO:29651',true).
concept_accession('41471: rn:R03283','KEGG','291450',true).
concept_accession('41468: rn:R00238','KEGG','2.3.1.9',true).
concept_accession('41468: rn:R00238','KEGG','EC:2.3.1.9',true).
concept_accession('41468: rn:R00238','EC','2.3.1.9',true).
concept_accession('41468: rn:R00238','KEGG','RNO:308100',true).
concept_accession('41468: rn:R00238','KEGG','RNO:25014',true).
concept_accession('41468: rn:R00238','KEGG','25014',true).
concept_accession('41468: rn:R00238','KEGG','308100',true).
concept_accession('41469: rn:R02488','KEGG','RNO:364975',true).
concept_accession('41469: rn:R02488','KEGG','1.3.99.7',true).
concept_accession('41469: rn:R02488','EC','1.3.99.7',true).
concept_accession('41469: rn:R02488','KEGG','EC:1.3.99.7',true).
concept_accession('41469: rn:R02488','KEGG','364975',true).
concept_accession('41466: rn:R00161','EC','2.7.7.2',true).
concept_accession('41466: rn:R00161','KEGG','2.7.7.2',true).
concept_accession('41466: rn:R00161','KEGG','751787',true).
concept_accession('41466: rn:R00161','KEGG','EC:2.7.7.2',true).
concept_accession('41466: rn:R00161','KEGG','RNO:751787',true).
concept_accession('41467: rn:R00549','KEGG','EC:2.7.1.26',true).
concept_accession('41467: rn:R00549','KEGG','499328',true).
concept_accession('41467: rn:R00549','EC','2.7.1.26',true).
concept_accession('41467: rn:R00549','KEGG','2.7.1.26',true).
concept_accession('41467: rn:R00549','KEGG','RNO:499328',true).
concept_accession('41464: rn:R02363','KEGG','RNO:308800',true).
concept_accession('41464: rn:R02363','KEGG','308800',true).
concept_accession('41464: rn:R02363','KEGG','EC:1.14.18.1',true).
concept_accession('41464: rn:R02363','EC','1.14.18.1',true).
concept_accession('41464: rn:R02363','KEGG','1.14.18.1',true).
concept_accession('41465: rn:R00548','KEGG','RNO:25732',true).
concept_accession('41465: rn:R00548','KEGG','56780',true).
concept_accession('41465: rn:R00548','KEGG','100361084',true).
concept_accession('41465: rn:R00548','KEGG','308569',true).
concept_accession('41465: rn:R00548','KEGG','EC:3.1.3.2',true).
concept_accession('41465: rn:R00548','KEGG','295305',true).
concept_accession('41465: rn:R00548','KEGG','25732',true).
concept_accession('41465: rn:R00548','KEGG','RNO:295305',true).
concept_accession('41465: rn:R00548','KEGG','RNO:308569',true).
concept_accession('41465: rn:R00548','EC','3.1.3.2',true).
concept_accession('41465: rn:R00548','KEGG','100365942',true).
concept_accession('41465: rn:R00548','KEGG','RNO:56780',true).
concept_accession('41465: rn:R00548','KEGG','3.1.3.2',true).
concept_accession('41465: rn:R00548','KEGG','RNO:24162',true).
concept_accession('41465: rn:R00548','KEGG','RNO:100365942',true).
concept_accession('41465: rn:R00548','KEGG','RNO:24161',true).
concept_accession('41465: rn:R00548','KEGG','RNO:100361084',true).
concept_accession('41465: rn:R00548','KEGG','24161',true).
concept_accession('41465: rn:R00548','KEGG','24162',true).
concept_accession('41447: rn:R05046','EC','3.5.4.16',true).
concept_accession('41447: rn:R05046','KEGG','RNO:29244',true).
concept_accession('41447: rn:R05046','KEGG','29244',true).
concept_accession('41447: rn:R05046','KEGG','EC:3.5.4.16',true).
concept_accession('41447: rn:R05046','KEGG','3.5.4.16',true).
concept_accession('41446: rn:R04888 rn:R04889','KEGG','RNO:25375',true).
concept_accession('41446: rn:R04888 rn:R04889','KEGG','25375',true).
concept_accession('41446: rn:R04888 rn:R04889','KEGG','RNO:266603',true).
concept_accession('41446: rn:R04888 rn:R04889','KEGG','266603',true).
concept_accession('41446: rn:R04888 rn:R04889','KEGG','RNO:309147',true).
concept_accession('41446: rn:R04888 rn:R04889','KEGG','309147',true).
concept_accession('41446: rn:R04888 rn:R04889','KEGG','EC:1.2.1.5',true).
concept_accession('41446: rn:R04888 rn:R04889','EC','1.2.1.5',true).
concept_accession('41446: rn:R04888 rn:R04889','KEGG','1.2.1.5',true).
concept_accession('41445: rn:R00428','EC','3.5.4.16',true).
concept_accession('41445: rn:R00428','KEGG','RNO:29244',true).
concept_accession('41445: rn:R00428','KEGG','29244',true).
concept_accession('41445: rn:R00428','KEGG','EC:3.5.4.16',true).
concept_accession('41445: rn:R00428','KEGG','3.5.4.16',true).
concept_accession('41444: rn:R04301','EC','2.1.1.6',true).
concept_accession('41444: rn:R04301','KEGG','RNO:24267',true).
concept_accession('41444: rn:R04301','KEGG','2.1.1.6',true).
concept_accession('41444: rn:R04301','KEGG','EC:2.1.1.6',true).
concept_accession('41444: rn:R04301','KEGG','24267',true).
concept_accession('41443: rn:R04286','KEGG','EC:4.2.3.12',true).
concept_accession('41443: rn:R04286','EC','4.2.3.12',true).
concept_accession('41443: rn:R04286','KEGG','29498',true).
concept_accession('41443: rn:R04286','KEGG','RNO:29498',true).
concept_accession('41443: rn:R04286','KEGG','4.2.3.12',true).
concept_accession('41442: rn:R04890','KEGG','29253',true).
concept_accession('41442: rn:R04890','KEGG','RNO:29253',true).
concept_accession('41442: rn:R04890','KEGG','25750',true).
concept_accession('41442: rn:R04890','KEGG','RNO:25750',true).
concept_accession('41442: rn:R04890','KEGG','EC:1.4.3.4',true).
concept_accession('41442: rn:R04890','EC','1.4.3.4',true).
concept_accession('41442: rn:R04890','KEGG','1.4.3.4',true).
concept_accession('41441: rn:R04242','KEGG','25455',true).
concept_accession('41441: rn:R04242','KEGG','3.4.19.9',true).
concept_accession('41441: rn:R04242','KEGG','RNO:25455',true).
concept_accession('41441: rn:R04242','KEGG','EC:3.4.19.9',true).
concept_accession('41441: rn:R04242','EC','3.4.19.9',true).
concept_accession('41440: rn:R02080','KEGG','EC:4.1.1.28',true).
concept_accession('41440: rn:R02080','KEGG','4.1.1.28',true).
concept_accession('41440: rn:R02080','EC','4.1.1.28',true).
concept_accession('41440: rn:R02080','KEGG','RNO:24311',true).
concept_accession('41440: rn:R02080','KEGG','24311',true).
concept_accession('41455: rn:R01813','KEGG','29270',true).
concept_accession('41455: rn:R01813','KEGG','EC:1.1.1.153',true).
concept_accession('41455: rn:R01813','KEGG','RNO:29270',true).
concept_accession('41455: rn:R01813','EC','1.1.1.153',true).
concept_accession('41455: rn:R01813','KEGG','1.1.1.153',true).
concept_accession('41454: rn:R05048','EC','3.5.4.16',true).
concept_accession('41454: rn:R05048','KEGG','RNO:29244',true).
concept_accession('41454: rn:R05048','KEGG','29244',true).
concept_accession('41454: rn:R05048','KEGG','EC:3.5.4.16',true).
concept_accession('41454: rn:R05048','KEGG','3.5.4.16',true).
concept_accession('41453: rn:R04639','EC','3.5.4.16',true).
concept_accession('41453: rn:R04639','KEGG','RNO:29244',true).
concept_accession('41453: rn:R04639','KEGG','29244',true).
concept_accession('41453: rn:R04639','KEGG','EC:3.5.4.16',true).
concept_accession('41453: rn:R04639','KEGG','3.5.4.16',true).
concept_accession('41452: rn:R03300 rn:R03302','KEGG','RNO:25375',true).
concept_accession('41452: rn:R03300 rn:R03302','KEGG','25375',true).
concept_accession('41452: rn:R03300 rn:R03302','KEGG','RNO:266603',true).
concept_accession('41452: rn:R03300 rn:R03302','KEGG','266603',true).
concept_accession('41452: rn:R03300 rn:R03302','KEGG','RNO:309147',true).
concept_accession('41452: rn:R03300 rn:R03302','KEGG','309147',true).
concept_accession('41452: rn:R03300 rn:R03302','KEGG','EC:1.2.1.5',true).
concept_accession('41452: rn:R03300 rn:R03302','EC','1.2.1.5',true).
concept_accession('41452: rn:R03300 rn:R03302','KEGG','1.2.1.5',true).
concept_accession('41451: rn:R00937 rn:R00940','KEGG','EC:1.5.1.3',true).
concept_accession('41451: rn:R00937 rn:R00940','EC','1.5.1.3',true).
concept_accession('41451: rn:R00937 rn:R00940','KEGG','24312',true).
concept_accession('41451: rn:R00937 rn:R00940','KEGG','RNO:24312',true).
concept_accession('41451: rn:R00937 rn:R00940','KEGG','1.5.1.3',true).
concept_accession('41450: rn:R03304','EC','2.1.1.6',true).
concept_accession('41450: rn:R03304','KEGG','RNO:24267',true).
concept_accession('41450: rn:R03304','KEGG','2.1.1.6',true).
concept_accession('41450: rn:R03304','KEGG','EC:2.1.1.6',true).
concept_accession('41450: rn:R03304','KEGG','24267',true).
concept_accession('41449: rn:R02237','EC','6.3.2.17',true).
concept_accession('41449: rn:R02237','KEGG','6.3.2.17',true).
concept_accession('41449: rn:R02237','KEGG','RNO:687266',true).
concept_accession('41449: rn:R02237','KEGG','687266',true).
concept_accession('41449: rn:R02237','KEGG','EC:6.3.2.17',true).
concept_accession('41448: rn:R04300','KEGG','29253',true).
concept_accession('41448: rn:R04300','KEGG','RNO:29253',true).
concept_accession('41448: rn:R04300','KEGG','25750',true).
concept_accession('41448: rn:R04300','KEGG','RNO:25750',true).
concept_accession('41448: rn:R04300','KEGG','EC:1.4.3.4',true).
concept_accession('41448: rn:R04300','EC','1.4.3.4',true).
concept_accession('41448: rn:R04300','KEGG','1.4.3.4',true).
concept_accession('41360: rn:R03269','KEGG','363069',true).
concept_accession('41360: rn:R03269','KEGG','4.1.1.36',true).
concept_accession('41360: rn:R03269','EC','4.1.1.36',true).
concept_accession('41360: rn:R03269','KEGG','EC:4.1.1.36',true).
concept_accession('41360: rn:R03269','KEGG','RNO:363069',true).
concept_accession('41361: rn:R00130','EC','2.7.1.24',true).
concept_accession('41361: rn:R00130','KEGG','EC:2.7.1.24',true).
concept_accession('41361: rn:R00130','KEGG','2.7.1.24',true).
concept_accession('41361: rn:R00130','KEGG','287711',true).
concept_accession('41361: rn:R00130','KEGG','RNO:287711',true).
concept_accession('41362: rn:R02269','KEGG','65135',true).
concept_accession('41362: rn:R02269','KEGG','RNO:65135',true).
concept_accession('41362: rn:R02269','EC','3.5.2.2',true).
concept_accession('41362: rn:R02269','KEGG','3.5.2.2',true).
concept_accession('41362: rn:R02269','KEGG','EC:3.5.2.2',true).
concept_accession('41363: rn:R00978','KEGG','RNO:81656',true).
concept_accession('41363: rn:R00978','KEGG','81656',true).
concept_accession('41363: rn:R00978','KEGG','1.3.1.2',true).
concept_accession('41363: rn:R00978','KEGG','EC:1.3.1.2',true).
concept_accession('41363: rn:R00978','EC','1.3.1.2',true).
concept_accession('41364: rn:R02869','KEGG','84596',true).
concept_accession('41364: rn:R02869','EC','2.5.1.22',true).
concept_accession('41364: rn:R02869','KEGG','EC:2.5.1.22',true).
concept_accession('41364: rn:R02869','KEGG','RNO:84596',true).
concept_accession('41364: rn:R02869','KEGG','2.5.1.22',true).
concept_accession('41365: rn:R04391','KEGG','171053',true).
concept_accession('41365: rn:R04391','KEGG','RNO:294088',true).
concept_accession('41365: rn:R04391','KEGG','RNO:171053',true).
concept_accession('41365: rn:R04391','KEGG','294088',true).
concept_accession('41365: rn:R04391','KEGG','360511',true).
concept_accession('41365: rn:R04391','KEGG','RNO:296167',true).
concept_accession('41365: rn:R04391','KEGG','296167',true).
concept_accession('41365: rn:R04391','KEGG','2.7.1.33',true).
concept_accession('41365: rn:R04391','EC','2.7.1.33',true).
concept_accession('41365: rn:R04391','KEGG','RNO:360511',true).
concept_accession('41365: rn:R04391','KEGG','EC:2.7.1.33',true).
concept_accession('41366: rn:R04230 rn:R04231','KEGG','EC:6.3.2.5',true).
concept_accession('41366: rn:R04230 rn:R04231','EC','6.3.2.5',true).
concept_accession('41366: rn:R04230 rn:R04231','KEGG','298490',true).
concept_accession('41366: rn:R04230 rn:R04231','KEGG','6.3.2.5',true).
concept_accession('41366: rn:R04230 rn:R04231','KEGG','RNO:298490',true).
concept_accession('41367: rn:R03018','KEGG','171053',true).
concept_accession('41367: rn:R03018','KEGG','RNO:294088',true).
concept_accession('41367: rn:R03018','KEGG','RNO:171053',true).
concept_accession('41367: rn:R03018','KEGG','294088',true).
concept_accession('41367: rn:R03018','KEGG','360511',true).
concept_accession('41367: rn:R03018','KEGG','RNO:296167',true).
concept_accession('41367: rn:R03018','KEGG','296167',true).
concept_accession('41367: rn:R03018','KEGG','2.7.1.33',true).
concept_accession('41367: rn:R03018','EC','2.7.1.33',true).
concept_accession('41367: rn:R03018','KEGG','RNO:360511',true).
concept_accession('41367: rn:R03018','KEGG','EC:2.7.1.33',true).
concept_accession('41368: rn:R00905','EC','3.5.1.6',true).
concept_accession('41368: rn:R00905','KEGG','116593',true).
concept_accession('41368: rn:R00905','KEGG','EC:3.5.1.6',true).
concept_accession('41368: rn:R00905','KEGG','RNO:116593',true).
concept_accession('41368: rn:R00905','KEGG','3.5.1.6',true).
concept_accession('41369: rn:R01154','KEGG','2.3.1.57',true).
concept_accession('41369: rn:R01154','KEGG','RNO:360547',true).
concept_accession('41369: rn:R01154','KEGG','360547',true).
concept_accession('41369: rn:R01154','KEGG','302642',true).
concept_accession('41369: rn:R01154','KEGG','RNO:302642',true).
concept_accession('41369: rn:R01154','KEGG','EC:2.3.1.57',true).
concept_accession('41369: rn:R01154','EC','2.3.1.57',true).
concept_accession('41370: rn:R02869','EC','2.5.1.22',true).
concept_accession('41370: rn:R02869','KEGG','EC:2.5.1.22',true).
concept_accession('41370: rn:R02869','KEGG','683008',true).
concept_accession('41370: rn:R02869','KEGG','RNO:683008',true).
concept_accession('41370: rn:R02869','KEGG','2.5.1.22',true).
concept_accession('41371: rn:R05050','KEGG','1.2.1.3',true).
concept_accession('41371: rn:R05050','KEGG','RNO:291450',true).
concept_accession('41371: rn:R05050','KEGG','RNO:64040',true).
concept_accession('41371: rn:R05050','EC','1.2.1.3',true).
concept_accession('41371: rn:R05050','KEGG','65183',true).
concept_accession('41371: rn:R05050','KEGG','24188',true).
concept_accession('41371: rn:R05050','KEGG','RNO:29539',true).
concept_accession('41371: rn:R05050','KEGG','64040',true).
concept_accession('41371: rn:R05050','KEGG','RNO:24188',true).
concept_accession('41371: rn:R05050','KEGG','29539',true).
concept_accession('41371: rn:R05050','KEGG','29651',true).
concept_accession('41371: rn:R05050','KEGG','298079',true).
concept_accession('41371: rn:R05050','KEGG','RNO:298079',true).
concept_accession('41371: rn:R05050','KEGG','RNO:65183',true).
concept_accession('41371: rn:R05050','KEGG','RNO:29651',true).
concept_accession('41371: rn:R05050','KEGG','291450',true).
concept_accession('41371: rn:R05050','KEGG','EC:1.2.1.3',true).
concept_accession('41372: rn:R04025','KEGG','29253',true).
concept_accession('41372: rn:R04025','KEGG','RNO:29253',true).
concept_accession('41372: rn:R04025','KEGG','25750',true).
concept_accession('41372: rn:R04025','KEGG','RNO:25750',true).
concept_accession('41372: rn:R04025','KEGG','EC:1.4.3.4',true).
concept_accession('41372: rn:R04025','EC','1.4.3.4',true).
concept_accession('41372: rn:R04025','KEGG','1.4.3.4',true).
concept_accession('41373: rn:R00243 rn:R00248','KEGG','RNO:24399',true).
concept_accession('41373: rn:R00243 rn:R00248','KEGG','24399',true).
concept_accession('41373: rn:R00243 rn:R00248','KEGG','1.4.1.3',true).
concept_accession('41373: rn:R00243 rn:R00248','EC','1.4.1.3',true).
concept_accession('41373: rn:R00243 rn:R00248','KEGG','EC:1.4.1.3',true).
concept_accession('41374: rn:R00557','KEGG','RNO:24599',true).
concept_accession('41374: rn:R00557','KEGG','24600',true).
concept_accession('41374: rn:R00557','EC','1.14.13.39',true).
concept_accession('41374: rn:R00557','KEGG','RNO:24598',true).
concept_accession('41374: rn:R00557','KEGG','RNO:24600',true).
concept_accession('41374: rn:R00557','KEGG','1.14.13.39',true).
concept_accession('41374: rn:R00557','KEGG','24598',true).
concept_accession('41374: rn:R00557','KEGG','24599',true).
concept_accession('41374: rn:R00557','KEGG','EC:1.14.13.39',true).
concept_accession('41375: rn:R04300','KEGG','RNO:29473',true).
concept_accession('41375: rn:R04300','KEGG','29473',true).
concept_accession('41375: rn:R04300','KEGG','EC:1.4.3.4',true).
concept_accession('41375: rn:R04300','EC','1.4.3.4',true).
concept_accession('41375: rn:R04300','KEGG','1.4.3.4',true).
concept_accession('41345: rn:R04065','KEGG','1.2.1.3',true).
concept_accession('41345: rn:R04065','KEGG','RNO:291450',true).
concept_accession('41345: rn:R04065','KEGG','RNO:64040',true).
concept_accession('41345: rn:R04065','EC','1.2.1.3',true).
concept_accession('41345: rn:R04065','KEGG','65183',true).
concept_accession('41345: rn:R04065','KEGG','24188',true).
concept_accession('41345: rn:R04065','KEGG','RNO:29539',true).
concept_accession('41345: rn:R04065','KEGG','64040',true).
concept_accession('41345: rn:R04065','KEGG','RNO:24188',true).
concept_accession('41345: rn:R04065','KEGG','29539',true).
concept_accession('41345: rn:R04065','KEGG','29651',true).
concept_accession('41345: rn:R04065','KEGG','298079',true).
concept_accession('41345: rn:R04065','KEGG','RNO:298079',true).
concept_accession('41345: rn:R04065','KEGG','RNO:65183',true).
concept_accession('41345: rn:R04065','KEGG','RNO:29651',true).
concept_accession('41345: rn:R04065','KEGG','291450',true).
concept_accession('41345: rn:R04065','KEGG','EC:1.2.1.3',true).
concept_accession('41344: rn:R01167','KEGG','RNO:24443',true).
concept_accession('41344: rn:R01167','KEGG','EC:4.1.1.28',true).
concept_accession('41344: rn:R01167','KEGG','24443',true).
concept_accession('41344: rn:R01167','KEGG','4.1.1.28',true).
concept_accession('41344: rn:R01167','EC','4.1.1.28',true).
concept_accession('41347: rn:R04996','KEGG','RNO:25375',true).
concept_accession('41347: rn:R04996','KEGG','25375',true).
concept_accession('41347: rn:R04996','KEGG','RNO:266603',true).
concept_accession('41347: rn:R04996','KEGG','266603',true).
concept_accession('41347: rn:R04996','KEGG','RNO:309147',true).
concept_accession('41347: rn:R04996','KEGG','309147',true).
concept_accession('41347: rn:R04996','KEGG','EC:1.2.1.5',true).
concept_accession('41347: rn:R04996','EC','1.2.1.5',true).
concept_accession('41347: rn:R04996','KEGG','1.2.1.5',true).
concept_accession('41346: rn:R04674','KEGG','29253',true).
concept_accession('41346: rn:R04674','KEGG','RNO:29253',true).
concept_accession('41346: rn:R04674','KEGG','25750',true).
concept_accession('41346: rn:R04674','KEGG','RNO:25750',true).
concept_accession('41346: rn:R04674','KEGG','EC:1.4.3.4',true).
concept_accession('41346: rn:R04674','EC','1.4.3.4',true).
concept_accession('41346: rn:R04674','KEGG','1.4.3.4',true).
concept_accession('41349: rn:R02155','KEGG','RNO:81676',true).
concept_accession('41349: rn:R02155','KEGG','81676',true).
concept_accession('41349: rn:R02155','KEGG','EC:2.1.1.8',true).
concept_accession('41349: rn:R02155','EC','2.1.1.8',true).
concept_accession('41349: rn:R02155','KEGG','2.1.1.8',true).
concept_accession('41348: rn:R02150','KEGG','RNO:65029',true).
concept_accession('41348: rn:R02150','KEGG','1.4.3.22',true).
concept_accession('41348: rn:R02150','KEGG','EC:1.4.3.22',true).
concept_accession('41348: rn:R02150','KEGG','65029',true).
concept_accession('41348: rn:R02150','EC','1.4.3.22',true).
concept_accession('41351: rn:R05145','KEGG','EC:6.3.4.9',true).
concept_accession('41351: rn:R05145','EC','6.3.4.9',true).
concept_accession('41351: rn:R05145','KEGG','6.3.4.9',true).
concept_accession('41351: rn:R05145','KEGG','RNO:288240',true).
concept_accession('41351: rn:R05145','KEGG','288240',true).
concept_accession('41350: rn:R01074','KEGG','RNO:288240',true).
concept_accession('41350: rn:R01074','KEGG','288240',true).
concept_accession('41350: rn:R01074','KEGG','EC:6.3.4.11',true).
concept_accession('41350: rn:R01074','KEGG','6.3.4.11',true).
concept_accession('41350: rn:R01074','EC','6.3.4.11',true).
concept_accession('41353: rn:R02973','KEGG','EC:3.5.1.92',true).
concept_accession('41353: rn:R02973','KEGG','29142',true).
concept_accession('41353: rn:R02973','KEGG','3.5.1.92',true).
concept_accession('41353: rn:R02973','EC','3.5.1.92',true).
concept_accession('41353: rn:R02973','KEGG','RNO:29142',true).
concept_accession('41352: rn:R01214','KEGG','64203',true).
concept_accession('41352: rn:R01214','KEGG','RNO:64203',true).
concept_accession('41352: rn:R01214','KEGG','EC:2.6.1.42',true).
concept_accession('41352: rn:R01214','KEGG','RNO:29592',true).
concept_accession('41352: rn:R01214','KEGG','29592',true).
concept_accession('41352: rn:R01214','KEGG','2.6.1.42',true).
concept_accession('41352: rn:R01214','EC','2.6.1.42',true).
concept_accession('41355: rn:R03035','EC','2.7.7.3',true).
concept_accession('41355: rn:R03035','KEGG','2.7.7.3',true).
concept_accession('41355: rn:R03035','KEGG','287711',true).
concept_accession('41355: rn:R03035','KEGG','EC:2.7.7.3',true).
concept_accession('41355: rn:R03035','KEGG','RNO:287711',true).
concept_accession('41354: rn:R00707 rn:R00708','KEGG','1.5.1.12',true).
concept_accession('41354: rn:R00707 rn:R00708','KEGG','641316',true).
concept_accession('41354: rn:R00707 rn:R00708','KEGG','RNO:641316',true).
concept_accession('41354: rn:R00707 rn:R00708','KEGG','EC:1.5.1.12',true).
concept_accession('41354: rn:R00707 rn:R00708','EC','1.5.1.12',true).
concept_accession('41357: rn:R01625','KEGG','300328',true).
concept_accession('41357: rn:R01625','KEGG','2.7.8.-',true).
concept_accession('41357: rn:R01625','EC','2.7.8.-',true).
concept_accession('41357: rn:R01625','KEGG','EC:2.7.8.-',true).
concept_accession('41357: rn:R01625','KEGG','RNO:300328',true).
concept_accession('41356: rn:R04221','KEGG','RNO:114027',true).
concept_accession('41356: rn:R04221','KEGG','114027',true).
concept_accession('41356: rn:R04221','KEGG','EC:1.4.3.3',true).
concept_accession('41356: rn:R04221','EC','1.4.3.3',true).
concept_accession('41356: rn:R04221','KEGG','1.4.3.3',true).
concept_accession('41359: rn:R02971','KEGG','171053',true).
concept_accession('41359: rn:R02971','KEGG','RNO:294088',true).
concept_accession('41359: rn:R02971','KEGG','RNO:171053',true).
concept_accession('41359: rn:R02971','KEGG','294088',true).
concept_accession('41359: rn:R02971','KEGG','360511',true).
concept_accession('41359: rn:R02971','KEGG','RNO:296167',true).
concept_accession('41359: rn:R02971','KEGG','296167',true).
concept_accession('41359: rn:R02971','KEGG','2.7.1.34',true).
concept_accession('41359: rn:R02971','EC','2.7.1.34',true).
concept_accession('41359: rn:R02971','KEGG','EC:2.7.1.34',true).
concept_accession('41359: rn:R02971','KEGG','RNO:360511',true).
concept_accession('41358: rn:R03036','KEGG','RNO:85496',true).
concept_accession('41358: rn:R03036','KEGG','RNO:54410',true).
concept_accession('41358: rn:R03036','KEGG','3.6.1.9',true).
concept_accession('41358: rn:R03036','KEGG','54410',true).
concept_accession('41358: rn:R03036','KEGG','85496',true).
concept_accession('41358: rn:R03036','KEGG','EC:3.6.1.9',true).
concept_accession('41358: rn:R03036','EC','3.6.1.9',true).
concept_accession('41394: rn:R00734','KEGG','EC:2.6.1.5',true).
concept_accession('41394: rn:R00734','KEGG','RNO:24813',true).
concept_accession('41394: rn:R00734','EC','2.6.1.5',true).
concept_accession('41394: rn:R00734','KEGG','2.6.1.5',true).
concept_accession('41394: rn:R00734','KEGG','24813',true).
concept_accession('41395: rn:R08390','KEGG','RNO:24306',true).
concept_accession('41395: rn:R08390','EC','1.14.14.1',true).
concept_accession('41395: rn:R08390','KEGG','24306',true).
concept_accession('41395: rn:R08390','KEGG','50549',true).
concept_accession('41395: rn:R08390','KEGG','RNO:50549',true).
concept_accession('41395: rn:R08390','KEGG','EC:1.14.14.1',true).
concept_accession('41395: rn:R08390','KEGG','1.14.14.1',true).
concept_accession('41395: rn:R08390','KEGG','RNO:266674',true).
concept_accession('41395: rn:R08390','KEGG','266674',true).
concept_accession('41395: rn:R08390','KEGG','RNO:170544',true).
concept_accession('41395: rn:R08390','KEGG','170544',true).
concept_accession('41395: rn:R08390','KEGG','RNO:298423',true).
concept_accession('41395: rn:R08390','KEGG','298423',true).
concept_accession('41392: rn:R00729','KEGG','EC:1.4.3.2',true).
concept_accession('41392: rn:R00729','EC','1.4.3.2',true).
concept_accession('41392: rn:R00729','KEGG','298483',true).
concept_accession('41392: rn:R00729','KEGG','RNO:100360621',true).
concept_accession('41392: rn:R00729','KEGG','1.4.3.2',true).
concept_accession('41392: rn:R00729','KEGG','RNO:298483',true).
concept_accession('41392: rn:R00729','KEGG','100360621',true).
concept_accession('41393: rn:R08390','EC','1.14.14.1',true).
concept_accession('41393: rn:R08390','KEGG','1.14.14.1',true).
concept_accession('41393: rn:R08390','KEGG','24296',true).
concept_accession('41393: rn:R08390','KEGG','RNO:24296',true).
concept_accession('41393: rn:R08390','KEGG','EC:1.14.14.1',true).
concept_accession('41398: rn:R02521','KEGG','1.13.11.27',true).
concept_accession('41398: rn:R02521','KEGG','RNO:29531',true).
concept_accession('41398: rn:R02521','EC','1.13.11.27',true).
concept_accession('41398: rn:R02521','KEGG','29531',true).
concept_accession('41398: rn:R02521','KEGG','EC:1.13.11.27',true).
concept_accession('41399: rn:R02124 rn:R08379','KEGG','RNO:314264',true).
concept_accession('41399: rn:R02124 rn:R08379','KEGG','362757',true).
concept_accession('41399: rn:R02124 rn:R08379','KEGG','353252',true).
concept_accession('41399: rn:R02124 rn:R08379','KEGG','360420',true).
concept_accession('41399: rn:R02124 rn:R08379','EC','1.1.-.-',true).
concept_accession('41399: rn:R02124 rn:R08379','KEGG','RNO:362757',true).
concept_accession('41399: rn:R02124 rn:R08379','KEGG','1.1.-.-',true).
concept_accession('41399: rn:R02124 rn:R08379','KEGG','314264',true).
concept_accession('41399: rn:R02124 rn:R08379','KEGG','RNO:690953',true).
concept_accession('41399: rn:R02124 rn:R08379','KEGG','RNO:360420',true).
concept_accession('41399: rn:R02124 rn:R08379','KEGG','RNO:353252',true).
concept_accession('41399: rn:R02124 rn:R08379','KEGG','690953',true).
concept_accession('41399: rn:R02124 rn:R08379','KEGG','EC:1.1.-.-',true).
concept_accession('41396: rn:R00734','KEGG','EC:2.6.1.5',true).
concept_accession('41396: rn:R00734','KEGG','25721',true).
concept_accession('41396: rn:R00734','KEGG','RNO:25721',true).
concept_accession('41396: rn:R00734','EC','2.6.1.5',true).
concept_accession('41396: rn:R00734','KEGG','24401',true).
concept_accession('41396: rn:R00734','KEGG','2.6.1.5',true).
concept_accession('41396: rn:R00734','KEGG','RNO:24401',true).
concept_accession('41397: rn:R03342','KEGG','RNO:81683',true).
concept_accession('41397: rn:R03342','KEGG','81683',true).
concept_accession('41397: rn:R03342','KEGG','EC:5.3.2.1',true).
concept_accession('41397: rn:R03342','KEGG','5.3.2.1',true).
concept_accession('41397: rn:R03342','EC','5.3.2.1',true).
concept_accession('41402: rn:R02382','KEGG','29253',true).
concept_accession('41402: rn:R02382','KEGG','1.4.3.21',true).
concept_accession('41402: rn:R02382','KEGG','RNO:29253',true).
concept_accession('41402: rn:R02382','EC','1.4.3.21',true).
concept_accession('41402: rn:R02382','KEGG','25750',true).
concept_accession('41402: rn:R02382','KEGG','RNO:25750',true).
concept_accession('41402: rn:R02382','KEGG','EC:1.4.3.21',true).
concept_accession('41403: rn:R08392','EC','1.14.14.1',true).
concept_accession('41403: rn:R08392','KEGG','RNO:154985',true).
concept_accession('41403: rn:R08392','KEGG','1.14.14.1',true).
concept_accession('41403: rn:R08392','KEGG','312495',true).
concept_accession('41403: rn:R08392','KEGG','154985',true).
concept_accession('41403: rn:R08392','KEGG','308190',true).
concept_accession('41403: rn:R08392','KEGG','RNO:312495',true).
concept_accession('41403: rn:R08392','KEGG','RNO:308190',true).
concept_accession('41403: rn:R08392','KEGG','EC:1.14.14.1',true).
concept_accession('41400: rn:R02695 rn:R02697','KEGG','RNO:25375',true).
concept_accession('41400: rn:R02695 rn:R02697','KEGG','25375',true).
concept_accession('41400: rn:R02695 rn:R02697','KEGG','RNO:266603',true).
concept_accession('41400: rn:R02695 rn:R02697','KEGG','266603',true).
concept_accession('41400: rn:R02695 rn:R02697','KEGG','RNO:309147',true).
concept_accession('41400: rn:R02695 rn:R02697','KEGG','309147',true).
concept_accession('41400: rn:R02695 rn:R02697','KEGG','EC:1.2.1.5',true).
concept_accession('41400: rn:R02695 rn:R02697','EC','1.2.1.5',true).
concept_accession('41400: rn:R02695 rn:R02697','KEGG','1.2.1.5',true).
concept_accession('41401: rn:R02124 rn:R08379','KEGG','RNO:313689',true).
concept_accession('41401: rn:R02124 rn:R08379','EC','1.1.-.-',true).
concept_accession('41401: rn:R02124 rn:R08379','KEGG','RNO:170635',true).
concept_accession('41401: rn:R02124 rn:R08379','KEGG','170635',true).
concept_accession('41401: rn:R02124 rn:R08379','KEGG','RNO:266686',true).
concept_accession('41401: rn:R02124 rn:R08379','KEGG','313689',true).
concept_accession('41401: rn:R02124 rn:R08379','KEGG','1.1.-.-',true).
concept_accession('41401: rn:R02124 rn:R08379','KEGG','EC:1.1.-.-',true).
concept_accession('41401: rn:R02124 rn:R08379','KEGG','266686',true).
concept_accession('41406: rn:R08392','EC','1.14.14.1',true).
concept_accession('41406: rn:R08392','KEGG','1.14.14.1',true).
concept_accession('41406: rn:R08392','KEGG','24297',true).
concept_accession('41406: rn:R08392','KEGG','24296',true).
concept_accession('41406: rn:R08392','KEGG','RNO:24296',true).
concept_accession('41406: rn:R08392','KEGG','RNO:24297',true).
concept_accession('41406: rn:R08392','KEGG','EC:1.14.14.1',true).
concept_accession('7021: rn:R03415','KEGG','RN:R03415',true).
concept_accession('7021: rn:R03415','EC','3.3.2.5',false).
concept_accession('7021: rn:R03415','KEGG','RP03027',true).
concept_accession('7021: rn:R03415','KEGG','EC:3.3.2.5',true).
concept_accession('7021: rn:R03415','KEGG','3.3.2.5',true).
concept_accession('7021: rn:R03415','KEGG','RC:RC00199',true).
concept_accession('7021: rn:R03415','KEGG','R03415',true).
concept_accession('7021: rn:R03415','KEGG','RC00199',true).
concept_accession('7021: rn:R03415','KEGG','RP:RP03027',true).
concept_accession('41407: rn:R08392','EC','1.14.14.1',true).
concept_accession('41407: rn:R08392','KEGG','1.14.14.1',true).
concept_accession('41407: rn:R08392','KEGG','25642',true).
concept_accession('41407: rn:R08392','KEGG','RNO:25642',true).
concept_accession('41407: rn:R08392','KEGG','RNO:171352',true).
concept_accession('41407: rn:R08392','KEGG','171352',true).
concept_accession('41407: rn:R08392','KEGG','266682',true).
concept_accession('41407: rn:R08392','KEGG','252931',true).
concept_accession('41407: rn:R08392','KEGG','RNO:266682',true).
concept_accession('41407: rn:R08392','KEGG','RNO:252931',true).
concept_accession('41407: rn:R08392','KEGG','EC:1.14.14.1',true).
concept_accession('7020: rn:R04571','KEGG','R04571',true).
concept_accession('7020: rn:R04571','EC','1.14.99.19',false).
concept_accession('7020: rn:R04571','KEGG','EC:1.14.99.19',true).
concept_accession('7020: rn:R04571','KEGG','1.14.99.19',true).
concept_accession('7020: rn:R04571','KEGG','RN:R04571',true).
concept_accession('41404: rn:R02382','KEGG','1.4.3.21',true).
concept_accession('41404: rn:R02382','KEGG','RNO:29473',true).
concept_accession('41404: rn:R02382','KEGG','29473',true).
concept_accession('41404: rn:R02382','EC','1.4.3.21',true).
concept_accession('41404: rn:R02382','KEGG','EC:1.4.3.21',true).
concept_accession('41405: rn:R02657','KEGG','RNO:316421',true).
concept_accession('41405: rn:R02657','KEGG','RNO:54349',true).
concept_accession('41405: rn:R02657','EC','1.2.3.1',true).
concept_accession('41405: rn:R02657','KEGG','EC:1.2.3.1',true).
concept_accession('41405: rn:R02657','KEGG','54349',true).
concept_accession('41405: rn:R02657','KEGG','316421',true).
concept_accession('41405: rn:R02657','KEGG','1.2.3.1',true).
concept_accession('41379: rn:R02902','KEGG','396551',true).
concept_accession('41379: rn:R02902','KEGG','2.4.1.17',true).
concept_accession('41379: rn:R02902','KEGG','154516',true).
concept_accession('41379: rn:R02902','KEGG','396552',true).
concept_accession('41379: rn:R02902','KEGG','RNO:305264',true).
concept_accession('41379: rn:R02902','KEGG','289533',true).
concept_accession('41379: rn:R02902','KEGG','RNO:396527',true).
concept_accession('41379: rn:R02902','KEGG','574523',true).
concept_accession('41379: rn:R02902','KEGG','396527',true).
concept_accession('41379: rn:R02902','KEGG','EC:2.4.1.17',true).
concept_accession('41379: rn:R02902','KEGG','113992',true).
concept_accession('41379: rn:R02902','KEGG','RNO:574523',true).
concept_accession('41379: rn:R02902','KEGG','RNO:266685',true).
concept_accession('41379: rn:R02902','KEGG','RNO:24861',true).
concept_accession('41379: rn:R02902','KEGG','266685',true).
concept_accession('41379: rn:R02902','KEGG','RNO:24862',true).
concept_accession('41379: rn:R02902','KEGG','29623',true).
concept_accession('41379: rn:R02902','KEGG','RNO:289533',true).
concept_accession('41379: rn:R02902','KEGG','305264',true).
concept_accession('41379: rn:R02902','KEGG','RNO:83808',true).
concept_accession('41379: rn:R02902','KEGG','RNO:301595',true).
concept_accession('41379: rn:R02902','KEGG','RNO:29623',true).
concept_accession('41379: rn:R02902','KEGG','RNO:154516',true).
concept_accession('41379: rn:R02902','KEGG','301595',true).
concept_accession('41379: rn:R02902','KEGG','RNO:396552',true).
concept_accession('41379: rn:R02902','KEGG','RNO:396551',true).
concept_accession('41379: rn:R02902','KEGG','RNO:286954',true).
concept_accession('41379: rn:R02902','KEGG','RNO:113992',true).
concept_accession('41379: rn:R02902','KEGG','RNO:63867',true).
concept_accession('41379: rn:R02902','KEGG','286954',true).
concept_accession('41379: rn:R02902','KEGG','83808',true).
concept_accession('41379: rn:R02902','KEGG','24861',true).
concept_accession('41379: rn:R02902','KEGG','63867',true).
concept_accession('41379: rn:R02902','EC','2.4.1.17',true).
concept_accession('41379: rn:R02902','KEGG','24862',true).
concept_accession('41378: rn:R08383','EC','1.1.-.-',true).
concept_accession('41378: rn:R08383','KEGG','RNO:266686',true).
concept_accession('41378: rn:R08383','KEGG','1.1.-.-',true).
concept_accession('41378: rn:R08383','KEGG','EC:1.1.-.-',true).
concept_accession('41378: rn:R08383','KEGG','266686',true).
concept_accession('41377: rn:R08392','KEGG','361523',true).
concept_accession('41377: rn:R08392','EC','1.14.14.1',true).
concept_accession('41377: rn:R08392','KEGG','246070',true).
concept_accession('41377: rn:R08392','KEGG','100364896',true).
concept_accession('41377: rn:R08392','KEGG','RNO:361523',true).
concept_accession('41377: rn:R08392','KEGG','171521',true).
concept_accession('41377: rn:R08392','KEGG','RNO:293989',true).
concept_accession('41377: rn:R08392','KEGG','293989',true).
concept_accession('41377: rn:R08392','KEGG','RNO:83790',true).
concept_accession('41377: rn:R08392','KEGG','EC:1.14.14.1',true).
concept_accession('41377: rn:R08392','KEGG','RNO:29277',true).
concept_accession('41377: rn:R08392','KEGG','687842',true).
concept_accession('41377: rn:R08392','KEGG','24894',true).
concept_accession('41377: rn:R08392','KEGG','24299',true).
concept_accession('41377: rn:R08392','KEGG','24895',true).
concept_accession('41377: rn:R08392','KEGG','292728',true).
concept_accession('41377: rn:R08392','KEGG','24300',true).
concept_accession('41377: rn:R08392','KEGG','171518',true).
concept_accession('41377: rn:R08392','KEGG','RNO:100364896',true).
concept_accession('41377: rn:R08392','KEGG','RNO:29298',true).
concept_accession('41377: rn:R08392','KEGG','29295',true).
concept_accession('41377: rn:R08392','KEGG','29277',true).
concept_accession('41377: rn:R08392','KEGG','29298',true).
concept_accession('41377: rn:R08392','KEGG','RNO:292728',true).
concept_accession('41377: rn:R08392','KEGG','RNO:286953',true).
concept_accession('41377: rn:R08392','KEGG','RNO:24300',true).
concept_accession('41377: rn:R08392','KEGG','RNO:29295',true).
concept_accession('41377: rn:R08392','KEGG','RNO:246070',true).
concept_accession('41377: rn:R08392','KEGG','RNO:687842',true).
concept_accession('41377: rn:R08392','KEGG','1.14.14.1',true).
concept_accession('41377: rn:R08392','KEGG','286953',true).
concept_accession('41377: rn:R08392','KEGG','RNO:171518',true).
concept_accession('41377: rn:R08392','KEGG','RNO:171521',true).
concept_accession('41377: rn:R08392','KEGG','25011',true).
concept_accession('41377: rn:R08392','KEGG','RNO:25011',true).
concept_accession('41377: rn:R08392','KEGG','RNO:24299',true).
concept_accession('41377: rn:R08392','KEGG','83790',true).
concept_accession('41377: rn:R08392','KEGG','RNO:24894',true).
concept_accession('41377: rn:R08392','KEGG','RNO:24895',true).
concept_accession('41376: rn:R03943','KEGG','RNO:290564',true).
concept_accession('41376: rn:R03943','KEGG','300989',true).
concept_accession('41376: rn:R03943','KEGG','2.1.1.-',true).
concept_accession('41376: rn:R03943','KEGG','EC:2.1.1.-',true).
concept_accession('41376: rn:R03943','EC','2.1.1.-',true).
concept_accession('41376: rn:R03943','KEGG','290564',true).
concept_accession('41376: rn:R03943','KEGG','RNO:300989',true).
concept_accession('41383: rn:R04884','KEGG','RNO:308800',true).
concept_accession('41383: rn:R04884','KEGG','308800',true).
concept_accession('41383: rn:R04884','KEGG','EC:1.14.18.1',true).
concept_accession('41383: rn:R04884','EC','1.14.18.1',true).
concept_accession('41383: rn:R04884','KEGG','1.14.18.1',true).
concept_accession('41382: rn:R08391','EC','1.14.14.1',true).
concept_accession('41382: rn:R08391','KEGG','1.14.14.1',true).
concept_accession('41382: rn:R08391','KEGG','25642',true).
concept_accession('41382: rn:R08391','KEGG','RNO:25642',true).
concept_accession('41382: rn:R08391','KEGG','RNO:171352',true).
concept_accession('41382: rn:R08391','KEGG','171352',true).
concept_accession('41382: rn:R08391','KEGG','266682',true).
concept_accession('41382: rn:R08391','KEGG','252931',true).
concept_accession('41382: rn:R08391','KEGG','RNO:266682',true).
concept_accession('41382: rn:R08391','KEGG','RNO:252931',true).
concept_accession('41382: rn:R08391','KEGG','EC:1.14.14.1',true).
concept_accession('7029: rn:R07382','KEGG','R07382',true).
concept_accession('7029: rn:R07382','EC','2.3.1.-',false).
concept_accession('7029: rn:R07382','KEGG','EC:2.3.1.-',true).
concept_accession('7029: rn:R07382','KEGG','RP:RP11971',true).
concept_accession('7029: rn:R07382','KEGG','RN:R07382',true).
concept_accession('7029: rn:R07382','KEGG','RC00037',true).
concept_accession('7029: rn:R07382','KEGG','RP11971',true).
concept_accession('7029: rn:R07382','KEGG','2.3.1.-',true).
concept_accession('7029: rn:R07382','KEGG','RC:RC00037',true).
concept_accession('41381: rn:R02368','EC','3.1.1.-',true).
concept_accession('41381: rn:R02368','KEGG','3.1.1.-',true).
concept_accession('41381: rn:R02368','KEGG','EC:3.1.1.-',true).
concept_accession('41381: rn:R02368','KEGG','RNO:363471',true).
concept_accession('41381: rn:R02368','KEGG','363471',true).
concept_accession('7030: rn:R07383','KEGG','R07383',true).
concept_accession('7030: rn:R07383','KEGG','RP:RP11455',true).
concept_accession('7030: rn:R07383','EC','3.1.3.-',false).
concept_accession('7030: rn:R07383','KEGG','RC00017',true).
concept_accession('7030: rn:R07383','KEGG','RN:R07383',true).
concept_accession('7030: rn:R07383','KEGG','EC:3.1.3.-',true).
concept_accession('7030: rn:R07383','KEGG','3.1.3.-',true).
concept_accession('7030: rn:R07383','KEGG','RC:RC00017',true).
concept_accession('7030: rn:R07383','KEGG','RP11455',true).
concept_accession('41380: rn:R08385','KEGG','RNO:116676',true).
concept_accession('41380: rn:R08385','KEGG','EC:1.2.1.36',true).
concept_accession('41380: rn:R08385','KEGG','116676',true).
concept_accession('41380: rn:R08385','KEGG','1.2.1.36',true).
concept_accession('41380: rn:R08385','EC','1.2.1.36',true).
concept_accession('41387: rn:R03208','KEGG','54314',true).
concept_accession('41387: rn:R03208','KEGG','RNO:54314',true).
concept_accession('41387: rn:R03208','KEGG','1.11.1.8',true).
concept_accession('41387: rn:R03208','KEGG','EC:1.11.1.8',true).
concept_accession('41387: rn:R03208','EC','1.11.1.8',true).
concept_accession('10281: rn:R00131','EC','3.5.1.5',false).
concept_accession('10281: rn:R00131','KEGG','R00131',true).
concept_accession('10281: rn:R00131','KEGG','EC:3.5.1.5',true).
concept_accession('10281: rn:R00131','KEGG','RN:R00131',true).
concept_accession('10281: rn:R00131','KEGG','3.5.1.5',true).
concept_accession('41386: rn:R08390','EC','1.14.14.1',true).
concept_accession('41386: rn:R08390','KEGG','RNO:154985',true).
concept_accession('41386: rn:R08390','KEGG','1.14.14.1',true).
concept_accession('41386: rn:R08390','KEGG','312495',true).
concept_accession('41386: rn:R08390','KEGG','154985',true).
concept_accession('41386: rn:R08390','KEGG','308190',true).
concept_accession('41386: rn:R08390','KEGG','RNO:312495',true).
concept_accession('41386: rn:R08390','KEGG','RNO:308190',true).
concept_accession('41386: rn:R08390','KEGG','EC:1.14.14.1',true).
concept_accession('41385: rn:R02078','KEGG','RNO:308800',true).
concept_accession('41385: rn:R02078','KEGG','308800',true).
concept_accession('41385: rn:R02078','KEGG','EC:1.14.18.1',true).
concept_accession('41385: rn:R02078','EC','1.14.18.1',true).
concept_accession('41385: rn:R02078','KEGG','1.14.18.1',true).
concept_accession('41384: rn:R08390','EC','1.14.14.1',true).
concept_accession('41384: rn:R08390','KEGG','1.14.14.1',true).
concept_accession('41384: rn:R08390','KEGG','25642',true).
concept_accession('41384: rn:R08390','KEGG','RNO:25642',true).
concept_accession('41384: rn:R08390','KEGG','RNO:171352',true).
concept_accession('41384: rn:R08390','KEGG','171352',true).
concept_accession('41384: rn:R08390','KEGG','266682',true).
concept_accession('41384: rn:R08390','KEGG','252931',true).
concept_accession('41384: rn:R08390','KEGG','RNO:266682',true).
concept_accession('41384: rn:R08390','KEGG','RNO:252931',true).
concept_accession('41384: rn:R08390','KEGG','EC:1.14.14.1',true).
concept_accession('41391: rn:R00731','KEGG','RNO:308800',true).
concept_accession('41391: rn:R00731','KEGG','308800',true).
concept_accession('41391: rn:R00731','KEGG','EC:1.14.18.1',true).
concept_accession('41391: rn:R00731','EC','1.14.18.1',true).
concept_accession('41391: rn:R00731','KEGG','1.14.18.1',true).
concept_accession('41390: rn:R08390','KEGG','361523',true).
concept_accession('41390: rn:R08390','EC','1.14.14.1',true).
concept_accession('41390: rn:R08390','KEGG','246070',true).
concept_accession('41390: rn:R08390','KEGG','100364896',true).
concept_accession('41390: rn:R08390','KEGG','RNO:361523',true).
concept_accession('41390: rn:R08390','KEGG','171521',true).
concept_accession('41390: rn:R08390','KEGG','RNO:293989',true).
concept_accession('41390: rn:R08390','KEGG','293989',true).
concept_accession('41390: rn:R08390','KEGG','RNO:83790',true).
concept_accession('41390: rn:R08390','KEGG','EC:1.14.14.1',true).
concept_accession('41390: rn:R08390','KEGG','RNO:29277',true).
concept_accession('41390: rn:R08390','KEGG','687842',true).
concept_accession('41390: rn:R08390','KEGG','24894',true).
concept_accession('41390: rn:R08390','KEGG','24299',true).
concept_accession('41390: rn:R08390','KEGG','24895',true).
concept_accession('41390: rn:R08390','KEGG','292728',true).
concept_accession('41390: rn:R08390','KEGG','24300',true).
concept_accession('41390: rn:R08390','KEGG','171518',true).
concept_accession('41390: rn:R08390','KEGG','RNO:100364896',true).
concept_accession('41390: rn:R08390','KEGG','RNO:29298',true).
concept_accession('41390: rn:R08390','KEGG','29295',true).
concept_accession('41390: rn:R08390','KEGG','29277',true).
concept_accession('41390: rn:R08390','KEGG','29298',true).
concept_accession('41390: rn:R08390','KEGG','RNO:292728',true).
concept_accession('41390: rn:R08390','KEGG','RNO:286953',true).
concept_accession('41390: rn:R08390','KEGG','RNO:24300',true).
concept_accession('41390: rn:R08390','KEGG','RNO:29295',true).
concept_accession('41390: rn:R08390','KEGG','RNO:246070',true).
concept_accession('41390: rn:R08390','KEGG','RNO:687842',true).
concept_accession('41390: rn:R08390','KEGG','1.14.14.1',true).
concept_accession('41390: rn:R08390','KEGG','286953',true).
concept_accession('41390: rn:R08390','KEGG','RNO:171518',true).
concept_accession('41390: rn:R08390','KEGG','RNO:171521',true).
concept_accession('41390: rn:R08390','KEGG','25011',true).
concept_accession('41390: rn:R08390','KEGG','RNO:25011',true).
concept_accession('41390: rn:R08390','KEGG','RNO:24299',true).
concept_accession('41390: rn:R08390','KEGG','83790',true).
concept_accession('41390: rn:R08390','KEGG','RNO:24894',true).
concept_accession('41390: rn:R08390','KEGG','RNO:24895',true).
concept_accession('41389: rn:R01815','KEGG','RNO:25085',true).
concept_accession('41389: rn:R01815','KEGG','EC:1.14.16.2',true).
concept_accession('41389: rn:R01815','KEGG','25085',true).
concept_accession('41389: rn:R01815','KEGG','1.14.16.2',true).
concept_accession('41389: rn:R01815','EC','1.14.16.2',true).
concept_accession('41388: rn:R08391','EC','1.14.14.1',true).
concept_accession('41388: rn:R08391','KEGG','361523',true).
concept_accession('41388: rn:R08391','KEGG','RNO:361523',true).
concept_accession('41388: rn:R08391','KEGG','29295',true).
concept_accession('41388: rn:R08391','KEGG','RNO:292728',true).
concept_accession('41388: rn:R08391','KEGG','RNO:24300',true).
concept_accession('41388: rn:R08391','KEGG','RNO:286953',true).
concept_accession('41388: rn:R08391','KEGG','EC:1.14.14.1',true).
concept_accession('41388: rn:R08391','KEGG','RNO:29295',true).
concept_accession('41388: rn:R08391','KEGG','24894',true).
concept_accession('41388: rn:R08391','KEGG','1.14.14.1',true).
concept_accession('41388: rn:R08391','KEGG','24299',true).
concept_accession('41388: rn:R08391','KEGG','286953',true).
concept_accession('41388: rn:R08391','KEGG','292728',true).
concept_accession('41388: rn:R08391','KEGG','24895',true).
concept_accession('41388: rn:R08391','KEGG','RNO:24299',true).
concept_accession('41388: rn:R08391','KEGG','24300',true).
concept_accession('41388: rn:R08391','KEGG','RNO:24894',true).
concept_accession('41388: rn:R08391','KEGG','RNO:24895',true).
concept_accession('41038: rn:R02581','KEGG','29224',true).
concept_accession('41038: rn:R02581','KEGG','EC:1.1.1.189',true).
concept_accession('41038: rn:R02581','KEGG','RNO:29224',true).
concept_accession('41038: rn:R02581','KEGG','1.1.1.189',true).
concept_accession('41038: rn:R02581','KEGG','RNO:304078',true).
concept_accession('41038: rn:R02581','EC','1.1.1.189',true).
concept_accession('41038: rn:R02581','KEGG','304078',true).
concept_accession('41039: rn:R02266','KEGG','RNO:25526',true).
concept_accession('41039: rn:R02266','KEGG','RNO:58962',true).
concept_accession('41039: rn:R02266','KEGG','25526',true).
concept_accession('41039: rn:R02266','EC','5.3.99.2',true).
concept_accession('41039: rn:R02266','KEGG','EC:5.3.99.2',true).
concept_accession('41039: rn:R02266','KEGG','58962',true).
concept_accession('41039: rn:R02266','KEGG','5.3.99.2',true).
concept_accession('41036: rn:R00431 rn:R00726','EC','4.1.1.32',true).
concept_accession('41036: rn:R00431 rn:R00726','KEGG','RNO:361042',true).
concept_accession('41036: rn:R00431 rn:R00726','KEGG','RNO:362282',true).
concept_accession('41036: rn:R00431 rn:R00726','KEGG','361042',true).
concept_accession('41036: rn:R00431 rn:R00726','KEGG','362282',true).
concept_accession('41036: rn:R00431 rn:R00726','KEGG','EC:4.1.1.32',true).
concept_accession('41036: rn:R00431 rn:R00726','KEGG','4.1.1.32',true).
concept_accession('41037: rn:R00945','KEGG','299857',true).
concept_accession('41037: rn:R00945','KEGG','287379',true).
concept_accession('41037: rn:R00945','KEGG','EC:2.1.2.1',true).
concept_accession('41037: rn:R00945','KEGG','RNO:287379',true).
concept_accession('41037: rn:R00945','KEGG','RNO:299857',true).
concept_accession('41037: rn:R00945','KEGG','2.1.2.1',true).
concept_accession('41037: rn:R00945','EC','2.1.2.1',true).
concept_accession('41034: rn:R01641','KEGG','RNO:64524',true).
concept_accession('41034: rn:R01641','KEGG','2.2.1.1',true).
concept_accession('41034: rn:R01641','KEGG','689374',true).
concept_accession('41034: rn:R01641','EC','2.2.1.1',true).
concept_accession('41034: rn:R01641','KEGG','290685',true).
concept_accession('41034: rn:R01641','KEGG','RNO:290685',true).
concept_accession('41034: rn:R01641','KEGG','64524',true).
concept_accession('41034: rn:R01641','KEGG','RNO:689374',true).
concept_accession('41034: rn:R01641','KEGG','EC:2.2.1.1',true).
concept_accession('41035: rn:R01051','KEGG','2.7.1.15',true).
concept_accession('41035: rn:R01051','EC','2.7.1.15',true).
concept_accession('41035: rn:R01051','KEGG','EC:2.7.1.15',true).
concept_accession('41035: rn:R01051','KEGG','RNO:362706',true).
concept_accession('41035: rn:R01051','KEGG','362706',true).
concept_accession('41032: rn:R02750','KEGG','2.7.1.15',true).
concept_accession('41032: rn:R02750','EC','2.7.1.15',true).
concept_accession('41032: rn:R02750','KEGG','EC:2.7.1.15',true).
concept_accession('41032: rn:R02750','KEGG','RNO:362706',true).
concept_accession('41032: rn:R02750','KEGG','362706',true).
concept_accession('41033: rn:R01049','KEGG','29562',true).
concept_accession('41033: rn:R01049','KEGG','314140',true).
concept_accession('41033: rn:R01049','KEGG','24689',true).
concept_accession('41033: rn:R01049','KEGG','RNO:298954',true).
concept_accession('41033: rn:R01049','KEGG','298954',true).
concept_accession('41033: rn:R01049','KEGG','EC:2.7.6.1',true).
concept_accession('41033: rn:R01049','EC','2.7.6.1',true).
concept_accession('41033: rn:R01049','KEGG','RNO:24689',true).
concept_accession('41033: rn:R01049','KEGG','RNO:314140',true).
concept_accession('41033: rn:R01049','KEGG','2.7.6.1',true).
concept_accession('41033: rn:R01049','KEGG','RNO:29562',true).
concept_accession('10693: rn:R08375','KEGG','RP:RP12991',true).
concept_accession('10693: rn:R08375','KEGG','RN:R08375',true).
concept_accession('10693: rn:R08375','KEGG','RC00212',true).
concept_accession('10693: rn:R08375','KEGG','RC:RC00212',true).
concept_accession('10693: rn:R08375','KEGG','R08375',true).
concept_accession('10693: rn:R08375','KEGG','RP12991',true).
concept_accession('41030: rn:R00014','KEGG','RNO:117098',true).
concept_accession('41030: rn:R00014','EC','1.2.4.1',true).
concept_accession('41030: rn:R00014','KEGG','RNO:289950',true).
concept_accession('41030: rn:R00014','KEGG','1.2.4.1',true).
concept_accession('41030: rn:R00014','KEGG','117098',true).
concept_accession('41030: rn:R00014','KEGG','289950',true).
concept_accession('41030: rn:R00014','KEGG','29554',true).
concept_accession('41030: rn:R00014','KEGG','RNO:29554',true).
concept_accession('41030: rn:R00014','KEGG','EC:1.2.4.1',true).
concept_accession('41031: rn:R01317','KEGG','298579',true).
concept_accession('41031: rn:R01317','KEGG','RNO:192259',true).
concept_accession('41031: rn:R01317','KEGG','296091',true).
concept_accession('41031: rn:R01317','KEGG','RNO:311341',true).
concept_accession('41031: rn:R01317','KEGG','RNO:29359',true).
concept_accession('41031: rn:R01317','KEGG','RNO:289733',true).
concept_accession('41031: rn:R01317','KEGG','29526',true).
concept_accession('41031: rn:R01317','KEGG','29387',true).
concept_accession('41031: rn:R01317','KEGG','362039',true).
concept_accession('41031: rn:R01317','KEGG','EC:3.1.1.4',true).
concept_accession('41031: rn:R01317','KEGG','RNO:29387',true).
concept_accession('41031: rn:R01317','KEGG','691907',true).
concept_accession('41031: rn:R01317','KEGG','RNO:298579',true).
concept_accession('41031: rn:R01317','KEGG','311341',true).
concept_accession('41031: rn:R01317','KEGG','RNO:690388',true).
concept_accession('41031: rn:R01317','KEGG','289733',true).
concept_accession('41031: rn:R01317','KEGG','RNO:362039',true).
concept_accession('41031: rn:R01317','KEGG','RNO:29692',true).
concept_accession('41031: rn:R01317','KEGG','24653',true).
concept_accession('41031: rn:R01317','KEGG','RNO:29526',true).
concept_accession('41031: rn:R01317','EC','3.1.1.4',true).
concept_accession('41031: rn:R01317','KEGG','RNO:24653',true).
concept_accession('41031: rn:R01317','KEGG','192259',true).
concept_accession('41031: rn:R01317','KEGG','3.1.1.4',true).
concept_accession('41031: rn:R01317','KEGG','690388',true).
concept_accession('41031: rn:R01317','KEGG','RNO:691907',true).
concept_accession('41031: rn:R01317','KEGG','RNO:296091',true).
concept_accession('41031: rn:R01317','KEGG','29359',true).
concept_accession('41031: rn:R01317','KEGG','367415',true).
concept_accession('41031: rn:R01317','KEGG','29354',true).
concept_accession('41031: rn:R01317','KEGG','RNO:367415',true).
concept_accession('41031: rn:R01317','KEGG','RNO:360426',true).
concept_accession('41031: rn:R01317','KEGG','29692',true).
concept_accession('41031: rn:R01317','KEGG','360426',true).
concept_accession('41031: rn:R01317','KEGG','RNO:29354',true).
concept_accession('41028: rn:R01595','EC','1.13.11.34',true).
concept_accession('41028: rn:R01595','KEGG','1.13.11.34',true).
concept_accession('41028: rn:R01595','KEGG','EC:1.13.11.34',true).
concept_accession('41028: rn:R01595','KEGG','25290',true).
concept_accession('41028: rn:R01595','KEGG','RNO:25290',true).
concept_accession('41029: rn:R00073','KEGG','29527',true).
concept_accession('41029: rn:R00073','KEGG','RNO:24693',true).
concept_accession('41029: rn:R00073','KEGG','24693',true).
concept_accession('41029: rn:R00073','KEGG','RNO:29527',true).
concept_accession('41029: rn:R00073','KEGG','1.14.99.1',true).
concept_accession('41029: rn:R00073','KEGG','EC:1.14.99.1',true).
concept_accession('41029: rn:R00073','EC','1.14.99.1',true).
concept_accession('41026: rn:R07034','KEGG','64317',true).
concept_accession('41026: rn:R07034','KEGG','298376',true).
concept_accession('41026: rn:R07034','KEGG','24404',true).
concept_accession('41026: rn:R07034','KEGG','RNO:29326',true).
concept_accession('41026: rn:R07034','KEGG','294744',true).
concept_accession('41026: rn:R07034','KEGG','1.11.1.9',true).
concept_accession('41026: rn:R07034','KEGG','RNO:113919',true).
concept_accession('41026: rn:R07034','KEGG','RNO:294744',true).
concept_accession('41026: rn:R07034','KEGG','EC:1.11.1.9',true).
concept_accession('41026: rn:R07034','KEGG','29326',true).
concept_accession('41026: rn:R07034','KEGG','113919',true).
concept_accession('41026: rn:R07034','KEGG','RNO:24404',true).
concept_accession('41026: rn:R07034','KEGG','259233',true).
concept_accession('41026: rn:R07034','KEGG','RNO:64317',true).
concept_accession('41026: rn:R07034','KEGG','RNO:298376',true).
concept_accession('41026: rn:R07034','KEGG','RNO:259233',true).
concept_accession('41026: rn:R07034','EC','1.11.1.9',true).
concept_accession('41027: rn:R03058','EC','1.13.11.34',true).
concept_accession('41027: rn:R03058','KEGG','1.13.11.34',true).
concept_accession('41027: rn:R03058','KEGG','EC:1.13.11.34',true).
concept_accession('41027: rn:R03058','KEGG','25290',true).
concept_accession('41027: rn:R03058','KEGG','RNO:25290',true).
concept_accession('41024: rn:R01596','EC','1.13.11.31',true).
concept_accession('41024: rn:R01596','KEGG','RNO:287454',true).
concept_accession('41024: rn:R01596','KEGG','287454',true).
concept_accession('41024: rn:R01596','KEGG','EC:1.13.11.31',true).
concept_accession('41024: rn:R01596','KEGG','1.13.11.31',true).
concept_accession('41025: rn:R01593','KEGG','RNO:266604',true).
concept_accession('41025: rn:R01593','KEGG','81639',true).
concept_accession('41025: rn:R01593','KEGG','EC:1.13.11.33',true).
concept_accession('41025: rn:R01593','KEGG','1.13.11.33',true).
concept_accession('41025: rn:R01593','KEGG','RNO:81639',true).
concept_accession('41025: rn:R01593','EC','1.13.11.33',true).
concept_accession('41025: rn:R01593','KEGG','266604',true).
concept_accession('41025: rn:R01593','KEGG','RNO:303252',true).
concept_accession('41025: rn:R01593','KEGG','303252',true).
concept_accession('41055: rn:R04780','KEGG','114508',true).
concept_accession('41055: rn:R04780','KEGG','3.1.3.11',true).
concept_accession('41055: rn:R04780','KEGG','24362',true).
concept_accession('41055: rn:R04780','KEGG','RNO:24362',true).
concept_accession('41055: rn:R04780','KEGG','EC:3.1.3.11',true).
concept_accession('41055: rn:R04780','EC','3.1.3.11',true).
concept_accession('41055: rn:R04780','KEGG','RNO:114508',true).
concept_accession('41054: rn:R04779','KEGG','2.7.1.11',true).
concept_accession('41054: rn:R04779','KEGG','RNO:25741',true).
concept_accession('41054: rn:R04779','KEGG','RNO:60416',true).
concept_accession('41054: rn:R04779','KEGG','25741',true).
concept_accession('41054: rn:R04779','EC','2.7.1.11',true).
concept_accession('41054: rn:R04779','KEGG','65152',true).
concept_accession('41054: rn:R04779','KEGG','EC:2.7.1.11',true).
concept_accession('41054: rn:R04779','KEGG','RNO:65152',true).
concept_accession('41054: rn:R04779','KEGG','60416',true).
concept_accession('41053: rn:R03970','KEGG','RNO:156275',true).
concept_accession('41053: rn:R03970','KEGG','156275',true).
concept_accession('41053: rn:R03970','KEGG','408206',true).
concept_accession('41053: rn:R03970','KEGG','RNO:29566',true).
concept_accession('41053: rn:R03970','KEGG','RNO:408206',true).
concept_accession('41053: rn:R03970','EC','2.3.2.2',true).
concept_accession('41053: rn:R03970','KEGG','2.3.2.2',true).
concept_accession('41053: rn:R03970','KEGG','RNO:116568',true).
concept_accession('41053: rn:R03970','KEGG','116568',true).
concept_accession('41053: rn:R03970','KEGG','29566',true).
concept_accession('41053: rn:R03970','KEGG','EC:2.3.2.2',true).
concept_accession('41052: rn:R02740','KEGG','5.3.1.9',true).
concept_accession('41052: rn:R02740','EC','5.3.1.9',true).
concept_accession('41052: rn:R02740','KEGG','292804',true).
concept_accession('41052: rn:R02740','KEGG','EC:5.3.1.9',true).
concept_accession('41052: rn:R02740','KEGG','RNO:292804',true).
concept_accession('41051: rn:R01529','EC','5.1.3.1',true).
concept_accession('41051: rn:R01529','KEGG','5.1.3.1',true).
concept_accession('41051: rn:R01529','KEGG','EC:5.1.3.1',true).
concept_accession('41051: rn:R01529','KEGG','RNO:501157',true).
concept_accession('41051: rn:R01529','KEGG','501157',true).
concept_accession('41050: rn:R01056','KEGG','362383',true).
concept_accession('41050: rn:R01056','EC','5.3.1.6',true).
concept_accession('41050: rn:R01056','KEGG','EC:5.3.1.6',true).
concept_accession('41050: rn:R01056','KEGG','5.3.1.6',true).
concept_accession('41050: rn:R01056','KEGG','RNO:362383',true).
concept_accession('41049: rn:R01070','KEGG','24191',true).
concept_accession('41049: rn:R01070','KEGG','24190',true).
concept_accession('41049: rn:R01070','KEGG','RNO:24190',true).
concept_accession('41049: rn:R01070','KEGG','RNO:24191',true).
concept_accession('41049: rn:R01070','KEGG','EC:4.1.2.13',true).
concept_accession('41049: rn:R01070','KEGG','4.1.2.13',true).
concept_accession('41049: rn:R01070','KEGG','RNO:299052',true).
concept_accession('41049: rn:R01070','EC','4.1.2.13',true).
concept_accession('41049: rn:R01070','KEGG','24189',true).
concept_accession('41049: rn:R01070','KEGG','RNO:24189',true).
concept_accession('41049: rn:R01070','KEGG','299052',true).
concept_accession('41048: rn:R01830','KEGG','RNO:64524',true).
concept_accession('41048: rn:R01830','KEGG','2.2.1.1',true).
concept_accession('41048: rn:R01830','KEGG','689374',true).
concept_accession('41048: rn:R01830','EC','2.2.1.1',true).
concept_accession('41048: rn:R01830','KEGG','290685',true).
concept_accession('41048: rn:R01830','KEGG','RNO:290685',true).
concept_accession('41048: rn:R01830','KEGG','64524',true).
concept_accession('41048: rn:R01830','KEGG','RNO:689374',true).
concept_accession('41048: rn:R01830','KEGG','EC:2.2.1.1',true).
concept_accession('41047: rn:R03971','KEGG','RNO:156275',true).
concept_accession('41047: rn:R03971','KEGG','156275',true).
concept_accession('41047: rn:R03971','KEGG','408206',true).
concept_accession('41047: rn:R03971','KEGG','RNO:29566',true).
concept_accession('41047: rn:R03971','KEGG','RNO:408206',true).
concept_accession('41047: rn:R03971','EC','2.3.2.2',true).
concept_accession('41047: rn:R03971','KEGG','2.3.2.2',true).
concept_accession('41047: rn:R03971','KEGG','RNO:116568',true).
concept_accession('41047: rn:R03971','KEGG','116568',true).
concept_accession('41047: rn:R03971','KEGG','29566',true).
concept_accession('41047: rn:R03971','KEGG','EC:2.3.2.2',true).
concept_accession('41046: rn:R07050','EC','1.14.14.1',true).
concept_accession('41046: rn:R07050','KEGG','24306',true).
concept_accession('41046: rn:R07050','KEGG','65210',true).
concept_accession('41046: rn:R07050','KEGG','246070',true).
concept_accession('41046: rn:R07050','KEGG','RNO:83790',true).
concept_accession('41046: rn:R07050','KEGG','292728',true).
concept_accession('41046: rn:R07050','KEGG','313375',true).
concept_accession('41046: rn:R07050','KEGG','24300',true).
concept_accession('41046: rn:R07050','KEGG','170544',true).
concept_accession('41046: rn:R07050','KEGG','RNO:100364896',true).
concept_accession('41046: rn:R07050','KEGG','171518',true).
concept_accession('41046: rn:R07050','KEGG','29295',true).
concept_accession('41046: rn:R07050','KEGG','RNO:29298',true).
concept_accession('41046: rn:R07050','KEGG','29298',true).
concept_accession('41046: rn:R07050','KEGG','RNO:292728',true).
concept_accession('41046: rn:R07050','KEGG','RNO:286953',true).
concept_accession('41046: rn:R07050','KEGG','RNO:29295',true).
concept_accession('41046: rn:R07050','KEGG','RNO:687842',true).
concept_accession('41046: rn:R07050','KEGG','RNO:65210',true).
concept_accession('41046: rn:R07050','KEGG','RNO:502969',true).
concept_accession('41046: rn:R07050','KEGG','RNO:171518',true).
concept_accession('41046: rn:R07050','KEGG','83790',true).
concept_accession('41046: rn:R07050','KEGG','502969',true).
concept_accession('41046: rn:R07050','KEGG','361523',true).
concept_accession('41046: rn:R07050','KEGG','100364896',true).
concept_accession('41046: rn:R07050','KEGG','RNO:361523',true).
concept_accession('41046: rn:R07050','KEGG','50549',true).
concept_accession('41046: rn:R07050','KEGG','171521',true).
concept_accession('41046: rn:R07050','KEGG','RNO:293989',true).
concept_accession('41046: rn:R07050','KEGG','293989',true).
concept_accession('41046: rn:R07050','KEGG','EC:1.14.14.1',true).
concept_accession('41046: rn:R07050','KEGG','RNO:29277',true).
concept_accession('41046: rn:R07050','KEGG','687842',true).
concept_accession('41046: rn:R07050','KEGG','RNO:170544',true).
concept_accession('41046: rn:R07050','KEGG','RNO:24306',true).
concept_accession('41046: rn:R07050','KEGG','RNO:313375',true).
concept_accession('41046: rn:R07050','KEGG','29277',true).
concept_accession('41046: rn:R07050','KEGG','RNO:50549',true).
concept_accession('41046: rn:R07050','KEGG','RNO:24300',true).
concept_accession('41046: rn:R07050','KEGG','RNO:246070',true).
concept_accession('41046: rn:R07050','KEGG','1.14.14.1',true).
concept_accession('41046: rn:R07050','KEGG','286953',true).
concept_accession('41046: rn:R07050','KEGG','RNO:171521',true).
concept_accession('41046: rn:R07050','KEGG','RNO:266674',true).
concept_accession('41046: rn:R07050','KEGG','25011',true).
concept_accession('41046: rn:R07050','KEGG','RNO:25011',true).
concept_accession('41046: rn:R07050','KEGG','266674',true).
concept_accession('41046: rn:R07050','KEGG','RNO:298423',true).
concept_accession('41046: rn:R07050','KEGG','298423',true).
concept_accession('41045: rn:R07051','KEGG','361523',true).
concept_accession('41045: rn:R07051','EC','1.14.14.1',true).
concept_accession('41045: rn:R07051','KEGG','65210',true).
concept_accession('41045: rn:R07051','KEGG','246070',true).
concept_accession('41045: rn:R07051','KEGG','100364896',true).
concept_accession('41045: rn:R07051','KEGG','RNO:361523',true).
concept_accession('41045: rn:R07051','KEGG','171521',true).
concept_accession('41045: rn:R07051','KEGG','RNO:293989',true).
concept_accession('41045: rn:R07051','KEGG','293989',true).
concept_accession('41045: rn:R07051','KEGG','RNO:83790',true).
concept_accession('41045: rn:R07051','KEGG','EC:1.14.14.1',true).
concept_accession('41045: rn:R07051','KEGG','RNO:29277',true).
concept_accession('41045: rn:R07051','KEGG','687842',true).
concept_accession('41045: rn:R07051','KEGG','292728',true).
concept_accession('41045: rn:R07051','KEGG','313375',true).
concept_accession('41045: rn:R07051','KEGG','24300',true).
concept_accession('41045: rn:R07051','KEGG','171518',true).
concept_accession('41045: rn:R07051','KEGG','RNO:100364896',true).
concept_accession('41045: rn:R07051','KEGG','RNO:313375',true).
concept_accession('41045: rn:R07051','KEGG','29277',true).
concept_accession('41045: rn:R07051','KEGG','29295',true).
concept_accession('41045: rn:R07051','KEGG','RNO:29298',true).
concept_accession('41045: rn:R07051','KEGG','RNO:292728',true).
concept_accession('41045: rn:R07051','KEGG','29298',true).
concept_accession('41045: rn:R07051','KEGG','RNO:24300',true).
concept_accession('41045: rn:R07051','KEGG','RNO:286953',true).
concept_accession('41045: rn:R07051','KEGG','RNO:29295',true).
concept_accession('41045: rn:R07051','KEGG','RNO:246070',true).
concept_accession('41045: rn:R07051','KEGG','RNO:687842',true).
concept_accession('41045: rn:R07051','KEGG','RNO:65210',true).
concept_accession('41045: rn:R07051','KEGG','1.14.14.1',true).
concept_accession('41045: rn:R07051','KEGG','RNO:502969',true).
concept_accession('41045: rn:R07051','KEGG','286953',true).
concept_accession('41045: rn:R07051','KEGG','RNO:171518',true).
concept_accession('41045: rn:R07051','KEGG','RNO:171521',true).
concept_accession('41045: rn:R07051','KEGG','25011',true).
concept_accession('41045: rn:R07051','KEGG','RNO:25011',true).
concept_accession('41045: rn:R07051','KEGG','83790',true).
concept_accession('41045: rn:R07051','KEGG','502969',true).
concept_accession('41044: rn:R07052','KEGG','361523',true).
concept_accession('41044: rn:R07052','EC','1.14.14.1',true).
concept_accession('41044: rn:R07052','KEGG','65210',true).
concept_accession('41044: rn:R07052','KEGG','246070',true).
concept_accession('41044: rn:R07052','KEGG','100364896',true).
concept_accession('41044: rn:R07052','KEGG','RNO:361523',true).
concept_accession('41044: rn:R07052','KEGG','171521',true).
concept_accession('41044: rn:R07052','KEGG','RNO:293989',true).
concept_accession('41044: rn:R07052','KEGG','293989',true).
concept_accession('41044: rn:R07052','KEGG','RNO:83790',true).
concept_accession('41044: rn:R07052','KEGG','EC:1.14.14.1',true).
concept_accession('41044: rn:R07052','KEGG','RNO:29277',true).
concept_accession('41044: rn:R07052','KEGG','687842',true).
concept_accession('41044: rn:R07052','KEGG','292728',true).
concept_accession('41044: rn:R07052','KEGG','313375',true).
concept_accession('41044: rn:R07052','KEGG','24300',true).
concept_accession('41044: rn:R07052','KEGG','171518',true).
concept_accession('41044: rn:R07052','KEGG','RNO:100364896',true).
concept_accession('41044: rn:R07052','KEGG','RNO:313375',true).
concept_accession('41044: rn:R07052','KEGG','29277',true).
concept_accession('41044: rn:R07052','KEGG','29295',true).
concept_accession('41044: rn:R07052','KEGG','RNO:29298',true).
concept_accession('41044: rn:R07052','KEGG','RNO:292728',true).
concept_accession('41044: rn:R07052','KEGG','29298',true).
concept_accession('41044: rn:R07052','KEGG','RNO:24300',true).
concept_accession('41044: rn:R07052','KEGG','RNO:286953',true).
concept_accession('41044: rn:R07052','KEGG','RNO:29295',true).
concept_accession('41044: rn:R07052','KEGG','RNO:246070',true).
concept_accession('41044: rn:R07052','KEGG','RNO:687842',true).
concept_accession('41044: rn:R07052','KEGG','RNO:65210',true).
concept_accession('41044: rn:R07052','KEGG','1.14.14.1',true).
concept_accession('41044: rn:R07052','KEGG','RNO:502969',true).
concept_accession('41044: rn:R07052','KEGG','286953',true).
concept_accession('41044: rn:R07052','KEGG','RNO:171518',true).
concept_accession('41044: rn:R07052','KEGG','RNO:171521',true).
concept_accession('41044: rn:R07052','KEGG','25011',true).
concept_accession('41044: rn:R07052','KEGG','RNO:25011',true).
concept_accession('41044: rn:R07052','KEGG','83790',true).
concept_accession('41044: rn:R07052','KEGG','502969',true).
concept_accession('41043: rn:R01528','KEGG','1.1.1.44',true).
concept_accession('41043: rn:R01528','KEGG','RNO:100360180',true).
concept_accession('41043: rn:R01528','KEGG','100360180',true).
concept_accession('41043: rn:R01528','EC','1.1.1.44',true).
concept_accession('41043: rn:R01528','KEGG','EC:1.1.1.44',true).
concept_accession('41042: rn:R02736','KEGG','RNO:24377',true).
concept_accession('41042: rn:R02736','KEGG','EC:1.1.1.49',true).
concept_accession('41042: rn:R02736','KEGG','1.1.1.49',true).
concept_accession('41042: rn:R02736','KEGG','24377',true).
concept_accession('41042: rn:R02736','EC','1.1.1.49',true).
concept_accession('41041: rn:R02035','EC','3.1.1.31',true).
concept_accession('41041: rn:R02035','KEGG','EC:3.1.1.31',true).
concept_accession('41041: rn:R02035','KEGG','290636',true).
concept_accession('41041: rn:R02035','KEGG','RNO:290636',true).
concept_accession('41041: rn:R02035','KEGG','3.1.1.31',true).
concept_accession('41040: rn:R02739','KEGG','5.3.1.9',true).
concept_accession('41040: rn:R02739','EC','5.3.1.9',true).
concept_accession('41040: rn:R02739','KEGG','292804',true).
concept_accession('41040: rn:R02739','KEGG','EC:5.3.1.9',true).
concept_accession('41040: rn:R02739','KEGG','RNO:292804',true).
concept_accession('41068: rn:R07045','EC','1.14.14.1',true).
concept_accession('41068: rn:R07045','KEGG','RNO:65210',true).
concept_accession('41068: rn:R07045','KEGG','65210',true).
concept_accession('41068: rn:R07045','KEGG','1.14.14.1',true).
concept_accession('41068: rn:R07045','KEGG','RNO:313375',true).
concept_accession('41068: rn:R07045','KEGG','RNO:502969',true).
concept_accession('41068: rn:R07045','KEGG','313375',true).
concept_accession('41068: rn:R07045','KEGG','502969',true).
concept_accession('41068: rn:R07045','KEGG','EC:1.14.14.1',true).
concept_accession('41069: rn:R01519','KEGG','25106',true).
concept_accession('41069: rn:R01519','EC','3.1.1.17',true).
concept_accession('41069: rn:R01519','KEGG','RNO:25106',true).
concept_accession('41069: rn:R01519','KEGG','EC:3.1.1.17',true).
concept_accession('41069: rn:R01519','KEGG','3.1.1.17',true).
concept_accession('6846: rn:R05381','KEGG','RC:RC01347',true).
concept_accession('6846: rn:R05381','KEGG','R05381',true).
concept_accession('6846: rn:R05381','KEGG','RP04989',true).
concept_accession('6846: rn:R05381','KEGG','RP04988',true).
concept_accession('6846: rn:R05381','KEGG','RC00053',true).
concept_accession('6846: rn:R05381','KEGG','EC:4.3.3.-',true).
concept_accession('6846: rn:R05381','KEGG','4.3.3.-',true).
concept_accession('6846: rn:R05381','KEGG','RN:R05381',true).
concept_accession('6846: rn:R05381','KEGG','RP:RP04989',true).
concept_accession('6846: rn:R05381','KEGG','RP:RP04988',true).
concept_accession('6846: rn:R05381','KEGG','RC:RC00053',true).
concept_accession('6846: rn:R05381','KEGG','RC01347',true).
concept_accession('6846: rn:R05381','EC','4.3.3.-',false).
concept_accession('41070: rn:R04929','KEGG','2.7.7.4',true).
concept_accession('41070: rn:R04929','KEGG','EC:2.7.7.4',true).
concept_accession('41070: rn:R04929','KEGG','RNO:295443',true).
concept_accession('41070: rn:R04929','KEGG','295443',true).
concept_accession('41070: rn:R04929','EC','2.7.7.4',true).
concept_accession('41070: rn:R04929','KEGG','RNO:294103',true).
concept_accession('41070: rn:R04929','KEGG','294103',true).
concept_accession('2957: rn:R04673','EC','2.2.1.6',false).
concept_accession('2957: rn:R04673','KEGG','RP04312',true).
concept_accession('2957: rn:R04673','KEGG','RN:R04673',true).
concept_accession('2957: rn:R04673','KEGG','RC:RC01192',true).
concept_accession('2957: rn:R04673','KEGG','RC01192',true).
concept_accession('2957: rn:R04673','KEGG','EC:2.2.1.6',true).
concept_accession('2957: rn:R04673','KEGG','R04673',true).
concept_accession('2957: rn:R04673','KEGG','RP:RP04312',true).
concept_accession('2957: rn:R04673','KEGG','2.2.1.6',true).
concept_accession('41071: rn:R07054','EC','1.14.14.1',true).
concept_accession('41071: rn:R07054','KEGG','RNO:100364896',true).
concept_accession('41071: rn:R07054','KEGG','171518',true).
concept_accession('41071: rn:R07054','KEGG','246070',true).
concept_accession('41071: rn:R07054','KEGG','100364896',true).
concept_accession('41071: rn:R07054','KEGG','29277',true).
concept_accession('41071: rn:R07054','KEGG','RNO:29298',true).
concept_accession('41071: rn:R07054','KEGG','171521',true).
concept_accession('41071: rn:R07054','KEGG','RNO:293989',true).
concept_accession('41071: rn:R07054','KEGG','29298',true).
concept_accession('41071: rn:R07054','KEGG','RNO:246070',true).
concept_accession('41071: rn:R07054','KEGG','EC:1.14.14.1',true).
concept_accession('41071: rn:R07054','KEGG','RNO:83790',true).
concept_accession('41071: rn:R07054','KEGG','293989',true).
concept_accession('41071: rn:R07054','KEGG','RNO:29277',true).
concept_accession('41071: rn:R07054','KEGG','RNO:687842',true).
concept_accession('41071: rn:R07054','KEGG','687842',true).
concept_accession('41071: rn:R07054','KEGG','1.14.14.1',true).
concept_accession('41071: rn:R07054','KEGG','RNO:171521',true).
concept_accession('41071: rn:R07054','KEGG','RNO:171518',true).
concept_accession('41071: rn:R07054','KEGG','25011',true).
concept_accession('41071: rn:R07054','KEGG','RNO:25011',true).
concept_accession('41071: rn:R07054','KEGG','83790',true).
concept_accession('41064: rn:R07044','EC','1.14.14.1',true).
concept_accession('41064: rn:R07044','KEGG','RNO:65210',true).
concept_accession('41064: rn:R07044','KEGG','65210',true).
concept_accession('41064: rn:R07044','KEGG','1.14.14.1',true).
concept_accession('41064: rn:R07044','KEGG','RNO:313375',true).
concept_accession('41064: rn:R07044','KEGG','RNO:502969',true).
concept_accession('41064: rn:R07044','KEGG','313375',true).
concept_accession('41064: rn:R07044','KEGG','502969',true).
concept_accession('41064: rn:R07044','KEGG','EC:1.14.14.1',true).
concept_accession('41065: rn:R07048','KEGG','361523',true).
concept_accession('41065: rn:R07048','EC','1.14.14.1',true).
concept_accession('41065: rn:R07048','KEGG','65210',true).
concept_accession('41065: rn:R07048','KEGG','246070',true).
concept_accession('41065: rn:R07048','KEGG','100364896',true).
concept_accession('41065: rn:R07048','KEGG','RNO:361523',true).
concept_accession('41065: rn:R07048','KEGG','171521',true).
concept_accession('41065: rn:R07048','KEGG','RNO:293989',true).
concept_accession('41065: rn:R07048','KEGG','293989',true).
concept_accession('41065: rn:R07048','KEGG','RNO:83790',true).
concept_accession('41065: rn:R07048','KEGG','EC:1.14.14.1',true).
concept_accession('41065: rn:R07048','KEGG','RNO:29277',true).
concept_accession('41065: rn:R07048','KEGG','687842',true).
concept_accession('41065: rn:R07048','KEGG','292728',true).
concept_accession('41065: rn:R07048','KEGG','313375',true).
concept_accession('41065: rn:R07048','KEGG','24300',true).
concept_accession('41065: rn:R07048','KEGG','171518',true).
concept_accession('41065: rn:R07048','KEGG','RNO:100364896',true).
concept_accession('41065: rn:R07048','KEGG','RNO:313375',true).
concept_accession('41065: rn:R07048','KEGG','29277',true).
concept_accession('41065: rn:R07048','KEGG','29295',true).
concept_accession('41065: rn:R07048','KEGG','RNO:29298',true).
concept_accession('41065: rn:R07048','KEGG','RNO:292728',true).
concept_accession('41065: rn:R07048','KEGG','29298',true).
concept_accession('41065: rn:R07048','KEGG','RNO:24300',true).
concept_accession('41065: rn:R07048','KEGG','RNO:286953',true).
concept_accession('41065: rn:R07048','KEGG','RNO:29295',true).
concept_accession('41065: rn:R07048','KEGG','RNO:246070',true).
concept_accession('41065: rn:R07048','KEGG','RNO:687842',true).
concept_accession('41065: rn:R07048','KEGG','RNO:65210',true).
concept_accession('41065: rn:R07048','KEGG','1.14.14.1',true).
concept_accession('41065: rn:R07048','KEGG','RNO:502969',true).
concept_accession('41065: rn:R07048','KEGG','286953',true).
concept_accession('41065: rn:R07048','KEGG','RNO:171518',true).
concept_accession('41065: rn:R07048','KEGG','RNO:171521',true).
concept_accession('41065: rn:R07048','KEGG','25011',true).
concept_accession('41065: rn:R07048','KEGG','RNO:25011',true).
concept_accession('41065: rn:R07048','KEGG','83790',true).
concept_accession('41065: rn:R07048','KEGG','502969',true).
concept_accession('41066: rn:R07042','EC','1.14.14.1',true).
concept_accession('41066: rn:R07042','KEGG','65210',true).
concept_accession('41066: rn:R07042','KEGG','246070',true).
concept_accession('41066: rn:R07042','KEGG','100364896',true).
concept_accession('41066: rn:R07042','KEGG','171521',true).
concept_accession('41066: rn:R07042','KEGG','RNO:293989',true).
concept_accession('41066: rn:R07042','KEGG','RNO:83790',true).
concept_accession('41066: rn:R07042','KEGG','293989',true).
concept_accession('41066: rn:R07042','KEGG','EC:1.14.14.1',true).
concept_accession('41066: rn:R07042','KEGG','687842',true).
concept_accession('41066: rn:R07042','KEGG','RNO:29277',true).
concept_accession('41066: rn:R07042','KEGG','313375',true).
concept_accession('41066: rn:R07042','KEGG','171518',true).
concept_accession('41066: rn:R07042','KEGG','RNO:100364896',true).
concept_accession('41066: rn:R07042','KEGG','RNO:313375',true).
concept_accession('41066: rn:R07042','KEGG','RNO:29298',true).
concept_accession('41066: rn:R07042','KEGG','29277',true).
concept_accession('41066: rn:R07042','KEGG','29298',true).
concept_accession('41066: rn:R07042','KEGG','RNO:246070',true).
concept_accession('41066: rn:R07042','KEGG','RNO:687842',true).
concept_accession('41066: rn:R07042','KEGG','RNO:65210',true).
concept_accession('41066: rn:R07042','KEGG','1.14.14.1',true).
concept_accession('41066: rn:R07042','KEGG','RNO:502969',true).
concept_accession('41066: rn:R07042','KEGG','RNO:171521',true).
concept_accession('41066: rn:R07042','KEGG','RNO:171518',true).
concept_accession('41066: rn:R07042','KEGG','25011',true).
concept_accession('41066: rn:R07042','KEGG','RNO:25011',true).
concept_accession('41066: rn:R07042','KEGG','83790',true).
concept_accession('41066: rn:R07042','KEGG','502969',true).
concept_accession('41067: rn:R09366','KEGG','EC:4.4.1.16',true).
concept_accession('41067: rn:R09366','EC','4.4.1.16',true).
concept_accession('41067: rn:R09366','KEGG','RNO:363285',true).
concept_accession('41067: rn:R09366','KEGG','363285',true).
concept_accession('41067: rn:R09366','KEGG','4.4.1.16',true).
concept_accession('41060: rn:R07046','EC','1.14.14.1',true).
concept_accession('41060: rn:R07046','KEGG','RNO:25086',true).
concept_accession('41060: rn:R07046','KEGG','1.14.14.1',true).
concept_accession('41060: rn:R07046','KEGG','25086',true).
concept_accession('41060: rn:R07046','KEGG','EC:1.14.14.1',true).
concept_accession('41061: rn:R07041','KEGG','RNO:290623',true).
concept_accession('41061: rn:R07041','KEGG','290623',true).
concept_accession('41061: rn:R07041','KEGG','RNO:500801',true).
concept_accession('41061: rn:R07041','EC','1.14.13.30',true).
concept_accession('41061: rn:R07041','KEGG','1.14.13.30',true).
concept_accession('41061: rn:R07041','KEGG','56266',true).
concept_accession('41061: rn:R07041','KEGG','RNO:286905',true).
concept_accession('41061: rn:R07041','KEGG','RNO:286904',true).
concept_accession('41061: rn:R07041','KEGG','503122',true).
concept_accession('41061: rn:R07041','KEGG','EC:1.14.13.30',true).
concept_accession('41061: rn:R07041','KEGG','286905',true).
concept_accession('41061: rn:R07041','KEGG','RNO:503122',true).
concept_accession('41061: rn:R07041','KEGG','RNO:56266',true).
concept_accession('41061: rn:R07041','KEGG','286904',true).
concept_accession('41061: rn:R07041','KEGG','500801',true).
concept_accession('41061: rn:R07041','KEGG','RNO:266689',true).
concept_accession('41061: rn:R07041','KEGG','266689',true).
concept_accession('41062: rn:R07041','KEGG','RNO:24306',true).
concept_accession('41062: rn:R07041','KEGG','24306',true).
concept_accession('41062: rn:R07041','KEGG','50549',true).
concept_accession('41062: rn:R07041','EC','1.14.13.30',true).
concept_accession('41062: rn:R07041','KEGG','RNO:50549',true).
concept_accession('41062: rn:R07041','KEGG','1.14.13.30',true).
concept_accession('41062: rn:R07041','KEGG','EC:1.14.13.30',true).
concept_accession('41062: rn:R07041','KEGG','RNO:266674',true).
concept_accession('41062: rn:R07041','KEGG','266674',true).
concept_accession('41062: rn:R07041','KEGG','RNO:170544',true).
concept_accession('41062: rn:R07041','KEGG','170544',true).
concept_accession('41062: rn:R07041','KEGG','RNO:298423',true).
concept_accession('41062: rn:R07041','KEGG','298423',true).
concept_accession('41063: rn:R01057','KEGG','RNO:24645',true).
concept_accession('41063: rn:R01057','KEGG','EC:5.4.2.7',true).
concept_accession('41063: rn:R01057','KEGG','5.4.2.7',true).
concept_accession('41063: rn:R01057','EC','5.4.2.7',true).
concept_accession('41063: rn:R01057','KEGG','24645',true).
concept_accession('41056: rn:R01827','KEGG','2.2.1.2',true).
concept_accession('41056: rn:R01827','EC','2.2.1.2',true).
concept_accession('41056: rn:R01827','KEGG','83688',true).
concept_accession('41056: rn:R01827','KEGG','RNO:83688',true).
concept_accession('41056: rn:R01827','KEGG','EC:2.2.1.2',true).
concept_accession('41057: rn:R07041','KEGG','RNO:310848',true).
concept_accession('41057: rn:R07041','KEGG','310848',true).
concept_accession('41057: rn:R07041','KEGG','EC:1.14.13.30',true).
concept_accession('41057: rn:R07041','EC','1.14.13.30',true).
concept_accession('41057: rn:R07041','KEGG','1.14.13.30',true).
concept_accession('41058: rn:R07046','KEGG','RNO:310848',true).
concept_accession('41058: rn:R07046','EC','1.14.14.1',true).
concept_accession('41058: rn:R07046','KEGG','310848',true).
concept_accession('41058: rn:R07046','KEGG','1.14.14.1',true).
concept_accession('41058: rn:R07046','KEGG','EC:1.14.14.1',true).
concept_accession('41059: rn:R07035','KEGG','64317',true).
concept_accession('41059: rn:R07035','KEGG','298376',true).
concept_accession('41059: rn:R07035','KEGG','24404',true).
concept_accession('41059: rn:R07035','KEGG','RNO:29326',true).
concept_accession('41059: rn:R07035','KEGG','294744',true).
concept_accession('41059: rn:R07035','KEGG','1.11.1.9',true).
concept_accession('41059: rn:R07035','KEGG','RNO:113919',true).
concept_accession('41059: rn:R07035','KEGG','RNO:294744',true).
concept_accession('41059: rn:R07035','KEGG','EC:1.11.1.9',true).
concept_accession('41059: rn:R07035','KEGG','29326',true).
concept_accession('41059: rn:R07035','KEGG','113919',true).
concept_accession('41059: rn:R07035','KEGG','RNO:24404',true).
concept_accession('41059: rn:R07035','KEGG','259233',true).
concept_accession('41059: rn:R07035','KEGG','RNO:64317',true).
concept_accession('41059: rn:R07035','KEGG','RNO:298376',true).
concept_accession('41059: rn:R07035','KEGG','RNO:259233',true).
concept_accession('41059: rn:R07035','EC','1.11.1.9',true).
concept_accession('41085: rn:R00256','KEGG','RNO:192268',true).
concept_accession('41085: rn:R00256','KEGG','24398',true).
concept_accession('41085: rn:R00256','KEGG','RNO:24398',true).
concept_accession('41085: rn:R00256','KEGG','EC:3.5.1.2',true).
concept_accession('41085: rn:R00256','KEGG','3.5.1.2',true).
concept_accession('41085: rn:R00256','KEGG','192268',true).
concept_accession('41085: rn:R00256','EC','3.5.1.2',true).
concept_accession('41084: rn:R01478','EC','3.2.1.31',true).
concept_accession('41084: rn:R01478','KEGG','24434',true).
concept_accession('41084: rn:R01478','KEGG','EC:3.2.1.31',true).
concept_accession('41084: rn:R01478','KEGG','RNO:83504',true).
concept_accession('41084: rn:R01478','KEGG','3.2.1.31',true).
concept_accession('41084: rn:R01478','KEGG','RNO:24434',true).
concept_accession('41084: rn:R01478','KEGG','83504',true).
concept_accession('41087: rn:R07046','EC','1.14.14.1',true).
concept_accession('41087: rn:R07046','KEGG','RNO:65210',true).
concept_accession('41087: rn:R07046','KEGG','65210',true).
concept_accession('41087: rn:R07046','KEGG','1.14.14.1',true).
concept_accession('41087: rn:R07046','KEGG','RNO:313375',true).
concept_accession('41087: rn:R07046','KEGG','RNO:502969',true).
concept_accession('41087: rn:R07046','KEGG','313375',true).
concept_accession('41087: rn:R07046','KEGG','502969',true).
concept_accession('41087: rn:R07046','KEGG','EC:1.14.14.1',true).
concept_accession('41086: rn:R01579','KEGG','RNO:192268',true).
concept_accession('41086: rn:R01579','KEGG','EC:3.5.1.35',true).
concept_accession('41086: rn:R01579','KEGG','24398',true).
concept_accession('41086: rn:R01579','KEGG','RNO:24398',true).
concept_accession('41086: rn:R01579','EC','3.5.1.35',true).
concept_accession('41086: rn:R01579','KEGG','192268',true).
concept_accession('41086: rn:R01579','KEGG','3.5.1.35',true).
concept_accession('41081: rn:R02923','KEGG','RNO:114027',true).
concept_accession('41081: rn:R02923','KEGG','114027',true).
concept_accession('41081: rn:R02923','KEGG','EC:1.4.3.3',true).
concept_accession('41081: rn:R02923','EC','1.4.3.3',true).
concept_accession('41081: rn:R02923','KEGG','1.4.3.3',true).
concept_accession('41080: rn:R03626','KEGG','81639',true).
concept_accession('41080: rn:R03626','KEGG','EC:1.13.11.33',true).
concept_accession('41080: rn:R03626','KEGG','1.13.11.33',true).
concept_accession('41080: rn:R03626','KEGG','RNO:81639',true).
concept_accession('41080: rn:R03626','EC','1.13.11.33',true).
concept_accession('41080: rn:R03626','KEGG','RNO:303252',true).
concept_accession('41080: rn:R03626','KEGG','303252',true).
concept_accession('41083: rn:R00243 rn:R00248','KEGG','RNO:24399',true).
concept_accession('41083: rn:R00243 rn:R00248','KEGG','24399',true).
concept_accession('41083: rn:R00243 rn:R00248','KEGG','1.4.1.3',true).
concept_accession('41083: rn:R00243 rn:R00248','EC','1.4.1.3',true).
concept_accession('41083: rn:R00243 rn:R00248','KEGG','EC:1.4.1.3',true).
concept_accession('41082: rn:R02457','KEGG','RNO:114027',true).
concept_accession('41082: rn:R02457','KEGG','114027',true).
concept_accession('41082: rn:R02457','KEGG','EC:1.4.3.3',true).
concept_accession('41082: rn:R02457','EC','1.4.3.3',true).
concept_accession('41082: rn:R02457','KEGG','1.4.3.3',true).
concept_accession('41077: rn:R02736 rn:R02035','KEGG','RNO:298655',true).
concept_accession('41077: rn:R02736 rn:R02035','KEGG','298655',true).
concept_accession('41076: rn:R07053','KEGG','RNO:266604',true).
concept_accession('41076: rn:R07053','KEGG','1.13.11.-',true).
concept_accession('41076: rn:R07053','KEGG','EC:1.13.11.-',true).
concept_accession('41076: rn:R07053','KEGG','266604',true).
concept_accession('41076: rn:R07053','EC','1.13.11.-',true).
concept_accession('41079: rn:R07064','KEGG','298579',true).
concept_accession('41079: rn:R07064','KEGG','RNO:192259',true).
concept_accession('41079: rn:R07064','KEGG','296091',true).
concept_accession('41079: rn:R07064','KEGG','RNO:311341',true).
concept_accession('41079: rn:R07064','KEGG','RNO:29359',true).
concept_accession('41079: rn:R07064','KEGG','RNO:289733',true).
concept_accession('41079: rn:R07064','KEGG','29526',true).
concept_accession('41079: rn:R07064','KEGG','29387',true).
concept_accession('41079: rn:R07064','KEGG','362039',true).
concept_accession('41079: rn:R07064','KEGG','EC:3.1.1.4',true).
concept_accession('41079: rn:R07064','KEGG','RNO:29387',true).
concept_accession('41079: rn:R07064','KEGG','691907',true).
concept_accession('41079: rn:R07064','KEGG','RNO:298579',true).
concept_accession('41079: rn:R07064','KEGG','311341',true).
concept_accession('41079: rn:R07064','KEGG','RNO:690388',true).
concept_accession('41079: rn:R07064','KEGG','289733',true).
concept_accession('41079: rn:R07064','KEGG','RNO:362039',true).
concept_accession('41079: rn:R07064','KEGG','RNO:29692',true).
concept_accession('41079: rn:R07064','KEGG','24653',true).
concept_accession('41079: rn:R07064','KEGG','RNO:29526',true).
concept_accession('41079: rn:R07064','EC','3.1.1.4',true).
concept_accession('41079: rn:R07064','KEGG','RNO:24653',true).
concept_accession('41079: rn:R07064','KEGG','192259',true).
concept_accession('41079: rn:R07064','KEGG','3.1.1.4',true).
concept_accession('41079: rn:R07064','KEGG','690388',true).
concept_accession('41079: rn:R07064','KEGG','RNO:691907',true).
concept_accession('41079: rn:R07064','KEGG','RNO:296091',true).
concept_accession('41079: rn:R07064','KEGG','29359',true).
concept_accession('41079: rn:R07064','KEGG','367415',true).
concept_accession('41079: rn:R07064','KEGG','29354',true).
concept_accession('41079: rn:R07064','KEGG','RNO:367415',true).
concept_accession('41079: rn:R07064','KEGG','RNO:360426',true).
concept_accession('41079: rn:R07064','KEGG','29692',true).
concept_accession('41079: rn:R07064','KEGG','360426',true).
concept_accession('41079: rn:R07064','KEGG','RNO:29354',true).
concept_accession('41078: rn:R07056','EC','1.14.14.1',true).
concept_accession('41078: rn:R07056','KEGG','65210',true).
concept_accession('41078: rn:R07056','KEGG','25086',true).
concept_accession('41078: rn:R07056','KEGG','246070',true).
concept_accession('41078: rn:R07056','KEGG','100364896',true).
concept_accession('41078: rn:R07056','KEGG','RNO:171352',true).
concept_accession('41078: rn:R07056','KEGG','252931',true).
concept_accession('41078: rn:R07056','KEGG','171521',true).
concept_accession('41078: rn:R07056','KEGG','RNO:293989',true).
concept_accession('41078: rn:R07056','KEGG','293989',true).
concept_accession('41078: rn:R07056','KEGG','RNO:83790',true).
concept_accession('41078: rn:R07056','KEGG','EC:1.14.14.1',true).
concept_accession('41078: rn:R07056','KEGG','687842',true).
concept_accession('41078: rn:R07056','KEGG','RNO:29277',true).
concept_accession('41078: rn:R07056','KEGG','RNO:25642',true).
concept_accession('41078: rn:R07056','KEGG','24297',true).
concept_accession('41078: rn:R07056','KEGG','171352',true).
concept_accession('41078: rn:R07056','KEGG','313375',true).
concept_accession('41078: rn:R07056','KEGG','266682',true).
concept_accession('41078: rn:R07056','KEGG','171518',true).
concept_accession('41078: rn:R07056','KEGG','RNO:100364896',true).
concept_accession('41078: rn:R07056','KEGG','RNO:313375',true).
concept_accession('41078: rn:R07056','KEGG','29277',true).
concept_accession('41078: rn:R07056','KEGG','RNO:29298',true).
concept_accession('41078: rn:R07056','KEGG','RNO:266682',true).
concept_accession('41078: rn:R07056','KEGG','29298',true).
concept_accession('41078: rn:R07056','KEGG','RNO:246070',true).
concept_accession('41078: rn:R07056','KEGG','RNO:687842',true).
concept_accession('41078: rn:R07056','KEGG','RNO:25086',true).
concept_accession('41078: rn:R07056','KEGG','RNO:65210',true).
concept_accession('41078: rn:R07056','KEGG','1.14.14.1',true).
concept_accession('41078: rn:R07056','KEGG','25642',true).
concept_accession('41078: rn:R07056','KEGG','RNO:502969',true).
concept_accession('41078: rn:R07056','KEGG','RNO:171518',true).
concept_accession('41078: rn:R07056','KEGG','RNO:171521',true).
concept_accession('41078: rn:R07056','KEGG','25011',true).
concept_accession('41078: rn:R07056','KEGG','RNO:25011',true).
concept_accession('41078: rn:R07056','KEGG','RNO:24297',true).
concept_accession('41078: rn:R07056','KEGG','83790',true).
concept_accession('41078: rn:R07056','KEGG','502969',true).
concept_accession('41078: rn:R07056','KEGG','RNO:252931',true).
concept_accession('41073: rn:R07043','EC','1.14.14.1',true).
concept_accession('41073: rn:R07043','KEGG','65210',true).
concept_accession('41073: rn:R07043','KEGG','246070',true).
concept_accession('41073: rn:R07043','KEGG','100364896',true).
concept_accession('41073: rn:R07043','KEGG','171521',true).
concept_accession('41073: rn:R07043','KEGG','RNO:293989',true).
concept_accession('41073: rn:R07043','KEGG','RNO:83790',true).
concept_accession('41073: rn:R07043','KEGG','293989',true).
concept_accession('41073: rn:R07043','KEGG','EC:1.14.14.1',true).
concept_accession('41073: rn:R07043','KEGG','687842',true).
concept_accession('41073: rn:R07043','KEGG','RNO:29277',true).
concept_accession('41073: rn:R07043','KEGG','313375',true).
concept_accession('41073: rn:R07043','KEGG','171518',true).
concept_accession('41073: rn:R07043','KEGG','RNO:100364896',true).
concept_accession('41073: rn:R07043','KEGG','RNO:313375',true).
concept_accession('41073: rn:R07043','KEGG','RNO:29298',true).
concept_accession('41073: rn:R07043','KEGG','29277',true).
concept_accession('41073: rn:R07043','KEGG','29298',true).
concept_accession('41073: rn:R07043','KEGG','RNO:246070',true).
concept_accession('41073: rn:R07043','KEGG','RNO:687842',true).
concept_accession('41073: rn:R07043','KEGG','RNO:65210',true).
concept_accession('41073: rn:R07043','KEGG','1.14.14.1',true).
concept_accession('41073: rn:R07043','KEGG','RNO:502969',true).
concept_accession('41073: rn:R07043','KEGG','RNO:171521',true).
concept_accession('41073: rn:R07043','KEGG','RNO:171518',true).
concept_accession('41073: rn:R07043','KEGG','25011',true).
concept_accession('41073: rn:R07043','KEGG','RNO:25011',true).
concept_accession('41073: rn:R07043','KEGG','83790',true).
concept_accession('41073: rn:R07043','KEGG','502969',true).
concept_accession('41072: rn:R09372','KEGG','297437',true).
concept_accession('41072: rn:R09372','KEGG','EC:1.8.1.9',true).
concept_accession('41072: rn:R09372','KEGG','RNO:50551',true).
concept_accession('41072: rn:R09372','KEGG','RNO:58819',true).
concept_accession('41072: rn:R09372','KEGG','50551',true).
concept_accession('41072: rn:R09372','KEGG','RNO:297437',true).
concept_accession('41072: rn:R09372','KEGG','58819',true).
concept_accession('41072: rn:R09372','EC','1.8.1.9',true).
concept_accession('41072: rn:R09372','KEGG','1.8.1.9',true).
concept_accession('41075: rn:R07038','KEGG','287425',true).
concept_accession('41075: rn:R07038','KEGG','1.13.11.-',true).
concept_accession('41075: rn:R07038','KEGG','EC:1.13.11.-',true).
concept_accession('41075: rn:R07038','EC','1.13.11.-',true).
concept_accession('41075: rn:R07038','KEGG','RNO:287425',true).
concept_accession('41074: rn:R09365','KEGG','81522',true).
concept_accession('41074: rn:R09365','KEGG','2.1.1.14',true).
concept_accession('41074: rn:R09365','KEGG','2.1.1.13',true).
concept_accession('41074: rn:R09365','KEGG','RNO:81522',true).
concept_accession('41074: rn:R09365','KEGG','EC:2.1.1.13',true).
concept_accession('41074: rn:R09365','EC','2.1.1.13',true).
concept_accession('41074: rn:R09365','KEGG','EC:2.1.1.14',true).
concept_accession('41074: rn:R09365','EC','2.1.1.14',true).
concept_accession('40970: rn:R00268','KEGG','361596',true).
concept_accession('40970: rn:R00268','KEGG','RNO:361596',true).
concept_accession('40970: rn:R00268','KEGG','24479',true).
concept_accession('40970: rn:R00268','KEGG','EC:1.1.1.42',true).
concept_accession('40970: rn:R00268','KEGG','1.1.1.42',true).
concept_accession('40970: rn:R00268','KEGG','RNO:24479',true).
concept_accession('40970: rn:R00268','EC','1.1.1.42',true).
concept_accession('40971: rn:R00352','KEGG','RNO:24159',true).
concept_accession('40971: rn:R00352','KEGG','2.3.3.8',true).
concept_accession('40971: rn:R00352','KEGG','24159',true).
concept_accession('40971: rn:R00352','KEGG','EC:2.3.3.8',true).
concept_accession('40971: rn:R00352','EC','2.3.3.8',true).
concept_accession('40968: rn:R09373','KEGG','RNO:311844',true).
concept_accession('40968: rn:R09373','KEGG','2.6.1.-',true).
concept_accession('40968: rn:R09373','KEGG','RNO:541589',true).
concept_accession('40968: rn:R09373','KEGG','541589',true).
concept_accession('40968: rn:R09373','KEGG','EC:2.6.1.-',true).
concept_accession('40968: rn:R09373','KEGG','311844',true).
concept_accession('40968: rn:R09373','EC','2.6.1.-',true).
concept_accession('40969: rn:R00709','KEGG','RNO:94173',true).
concept_accession('40969: rn:R00709','KEGG','RNO:114096',true).
concept_accession('40969: rn:R00709','KEGG','94173',true).
concept_accession('40969: rn:R00709','KEGG','25179',true).
concept_accession('40969: rn:R00709','KEGG','RNO:25179',true).
concept_accession('40969: rn:R00709','KEGG','1.1.1.41',true).
concept_accession('40969: rn:R00709','KEGG','114096',true).
concept_accession('40969: rn:R00709','KEGG','EC:1.1.1.41',true).
concept_accession('40969: rn:R00709','EC','1.1.1.41',true).
concept_accession('40974: rn:R03316','EC','1.2.4.2',true).
concept_accession('40974: rn:R03316','KEGG','1.2.4.2',true).
concept_accession('40974: rn:R03316','KEGG','RNO:290566',true).
concept_accession('40974: rn:R03316','KEGG','360975',true).
concept_accession('40974: rn:R03316','KEGG','EC:1.2.4.2',true).
concept_accession('40974: rn:R03316','KEGG','290566',true).
concept_accession('40974: rn:R03316','KEGG','RNO:360975',true).
concept_accession('6877: rn:R02054','KEGG','RP00455',true).
concept_accession('6877: rn:R02054','KEGG','EC:3.1.1.32',true).
concept_accession('6877: rn:R02054','KEGG','RC00041',true).
concept_accession('6877: rn:R02054','EC','3.1.1.32',false).
concept_accession('6877: rn:R02054','KEGG','RP:RP00455',true).
concept_accession('6877: rn:R02054','KEGG','RN:R02054',true).
concept_accession('6877: rn:R02054','KEGG','RC:RC00041',true).
concept_accession('6877: rn:R02054','KEGG','R02054',true).
concept_accession('6877: rn:R02054','KEGG','3.1.1.32',true).
concept_accession('40975: rn:R00432 rn:R00727','EC','6.2.1.4',true).
concept_accession('40975: rn:R00432 rn:R00727','KEGG','RNO:361071',true).
concept_accession('40975: rn:R00432 rn:R00727','KEGG','361071',true).
concept_accession('40975: rn:R00432 rn:R00727','KEGG','EC:6.2.1.4',true).
concept_accession('40975: rn:R00432 rn:R00727','KEGG','6.2.1.4',true).
concept_accession('40975: rn:R00432 rn:R00727','KEGG','114597',true).
concept_accession('40975: rn:R00432 rn:R00727','KEGG','RNO:114597',true).
concept_accession('40975: rn:R00432 rn:R00727','KEGG','362404',true).
concept_accession('40975: rn:R00432 rn:R00727','KEGG','RNO:362404',true).
concept_accession('40972: rn:R01899','KEGG','361596',true).
concept_accession('40972: rn:R01899','KEGG','RNO:361596',true).
concept_accession('40972: rn:R01899','KEGG','24479',true).
concept_accession('40972: rn:R01899','KEGG','EC:1.1.1.42',true).
concept_accession('40972: rn:R01899','KEGG','1.1.1.42',true).
concept_accession('40972: rn:R01899','KEGG','RNO:24479',true).
concept_accession('40972: rn:R01899','EC','1.1.1.42',true).
concept_accession('40973: rn:R02570','EC','2.3.1.61',true).
concept_accession('40973: rn:R02570','KEGG','RNO:299201',true).
concept_accession('40973: rn:R02570','KEGG','299201',true).
concept_accession('40973: rn:R02570','KEGG','EC:2.3.1.61',true).
concept_accession('40973: rn:R02570','KEGG','2.3.1.61',true).
concept_accession('40962: rn:R03599','KEGG','EC:4.4.1.16',true).
concept_accession('40962: rn:R03599','EC','4.4.1.16',true).
concept_accession('40962: rn:R03599','KEGG','RNO:363285',true).
concept_accession('40962: rn:R03599','KEGG','363285',true).
concept_accession('40962: rn:R03599','KEGG','4.4.1.16',true).
concept_accession('40963: rn:R08224','KEGG','RNO:679383',true).
concept_accession('40963: rn:R08224','KEGG','EC:2.9.1.2',true).
concept_accession('40963: rn:R08224','EC','2.9.1.2',true).
concept_accession('40963: rn:R08224','KEGG','679383',true).
concept_accession('40963: rn:R08224','KEGG','2.9.1.2',true).
concept_accession('40960: rn:R01516','KEGG','296973',true).
concept_accession('40960: rn:R01516','KEGG','3.1.3.13',true).
concept_accession('40960: rn:R01516','KEGG','RNO:296973',true).
concept_accession('40960: rn:R01516','EC','3.1.3.13',true).
concept_accession('40960: rn:R01516','KEGG','EC:3.1.3.13',true).
concept_accession('40961: rn:R01662','KEGG','EC:5.4.2.4',true).
concept_accession('40961: rn:R01662','KEGG','296973',true).
concept_accession('40961: rn:R01662','KEGG','RNO:296973',true).
concept_accession('40961: rn:R01662','KEGG','5.4.2.4',true).
concept_accession('40961: rn:R01662','EC','5.4.2.4',true).
concept_accession('40966: rn:R07111','KEGG','65030',true).
concept_accession('40966: rn:R07111','EC','3.3.2.10',true).
concept_accession('40966: rn:R07111','KEGG','EC:3.3.2.10',true).
concept_accession('40966: rn:R07111','KEGG','RNO:65030',true).
concept_accession('40966: rn:R07111','KEGG','3.3.2.10',true).
concept_accession('6869: rn:R01470','KEGG','EC:3.1.4.2',true).
concept_accession('6869: rn:R01470','KEGG','R01470',true).
concept_accession('6869: rn:R01470','KEGG','RC:RC00425',true).
concept_accession('6869: rn:R01470','KEGG','RC00017',true).
concept_accession('6869: rn:R01470','EC','3.1.4.2',false).
concept_accession('6869: rn:R01470','KEGG','RP01534',true).
concept_accession('6869: rn:R01470','KEGG','RP01533',true).
concept_accession('6869: rn:R01470','KEGG','RP:RP01534',true).
concept_accession('6869: rn:R01470','KEGG','RC00425',true).
concept_accession('6869: rn:R01470','KEGG','RN:R01470',true).
concept_accession('6869: rn:R01470','KEGG','RP:RP01533',true).
concept_accession('6869: rn:R01470','KEGG','RC:RC00017',true).
concept_accession('6869: rn:R01470','KEGG','3.1.4.2',true).
concept_accession('40967: rn:R07110','KEGG','65030',true).
concept_accession('40967: rn:R07110','EC','3.3.2.10',true).
concept_accession('40967: rn:R07110','KEGG','EC:3.3.2.10',true).
concept_accession('40967: rn:R07110','KEGG','RNO:65030',true).
concept_accession('40967: rn:R07110','KEGG','3.3.2.10',true).
concept_accession('40964: rn:R07109','KEGG','65030',true).
concept_accession('40964: rn:R07109','EC','3.3.2.10',true).
concept_accession('40964: rn:R07109','KEGG','EC:3.3.2.10',true).
concept_accession('40964: rn:R07109','KEGG','RNO:65030',true).
concept_accession('40964: rn:R07109','KEGG','3.3.2.10',true).
concept_accession('40965: rn:R07108','KEGG','65030',true).
concept_accession('40965: rn:R07108','EC','3.3.2.10',true).
concept_accession('40965: rn:R07108','KEGG','EC:3.3.2.10',true).
concept_accession('40965: rn:R07108','KEGG','RNO:65030',true).
concept_accession('40965: rn:R07108','KEGG','3.3.2.10',true).
concept_accession('6870: rn:R01800','KEGG','R01800',true).
concept_accession('6870: rn:R01800','KEGG','EC:2.7.8.8',true).
concept_accession('6870: rn:R01800','EC','2.7.8.8',false).
concept_accession('6870: rn:R01800','KEGG','RN:R01800',true).
concept_accession('6870: rn:R01800','KEGG','2.7.8.8',true).
concept_accession('40987: rn:R00342','KEGG','81829',true).
concept_accession('40987: rn:R00342','KEGG','EC:1.1.1.37',true).
concept_accession('40987: rn:R00342','EC','1.1.1.37',true).
concept_accession('40987: rn:R00342','KEGG','RNO:81829',true).
concept_accession('40987: rn:R00342','KEGG','1.1.1.37',true).
concept_accession('40987: rn:R00342','KEGG','RNO:24551',true).
concept_accession('40987: rn:R00342','KEGG','24551',true).
concept_accession('40986: rn:R00351','KEGG','2.3.3.1',true).
concept_accession('40986: rn:R00351','KEGG','EC:2.3.3.1',true).
concept_accession('40986: rn:R00351','EC','2.3.3.1',true).
concept_accession('40986: rn:R00351','KEGG','RNO:170587',true).
concept_accession('40986: rn:R00351','KEGG','170587',true).
concept_accession('10650: rn:R05636','KEGG','R05636',true).
concept_accession('10650: rn:R05636','KEGG','RN:R05636',true).
concept_accession('10650: rn:R05636','KEGG','EC:2.2.1.7',true).
concept_accession('10650: rn:R05636','KEGG','RC:RC00032',true).
concept_accession('10650: rn:R05636','KEGG','RP:RP05243',true).
concept_accession('10650: rn:R05636','EC','2.2.1.7',false).
concept_accession('10650: rn:R05636','KEGG','2.2.1.7',true).
concept_accession('10650: rn:R05636','KEGG','RC00032',true).
concept_accession('10650: rn:R05636','KEGG','RP05243',true).
concept_accession('40985: rn:R00344','KEGG','RNO:25104',true).
concept_accession('40985: rn:R00344','KEGG','25104',true).
concept_accession('40985: rn:R00344','KEGG','6.4.1.1',true).
concept_accession('40985: rn:R00344','EC','6.4.1.1',true).
concept_accession('40985: rn:R00344','KEGG','EC:6.4.1.1',true).
concept_accession('40984: rn:R03595','EC','2.7.9.3',true).
concept_accession('40984: rn:R03595','KEGG','308993',true).
concept_accession('40984: rn:R03595','KEGG','EC:2.7.9.3',true).
concept_accession('40984: rn:R03595','KEGG','2.7.9.3',true).
concept_accession('40984: rn:R03595','KEGG','RNO:308993',true).
concept_accession('40984: rn:R03595','KEGG','RNO:291314',true).
concept_accession('40984: rn:R03595','KEGG','291314',true).
concept_accession('40991: rn:R01082','KEGG','EC:4.2.1.2',true).
concept_accession('40991: rn:R01082','KEGG','RNO:24368',true).
concept_accession('40991: rn:R01082','EC','4.2.1.2',true).
concept_accession('40991: rn:R01082','KEGG','24368',true).
concept_accession('40991: rn:R01082','KEGG','4.2.1.2',true).
concept_accession('40990: rn:R02164','KEGG','RNO:363061',true).
concept_accession('40990: rn:R02164','EC','1.3.5.1',true).
concept_accession('40990: rn:R02164','KEGG','RNO:157074',true).
concept_accession('40990: rn:R02164','KEGG','157074',true).
concept_accession('40990: rn:R02164','KEGG','RNO:289217',true).
concept_accession('40990: rn:R02164','KEGG','363061',true).
concept_accession('40990: rn:R02164','KEGG','EC:1.3.5.1',true).
concept_accession('40990: rn:R02164','KEGG','RNO:298596',true).
concept_accession('40990: rn:R02164','KEGG','1.3.5.1',true).
concept_accession('40990: rn:R02164','KEGG','289217',true).
concept_accession('40990: rn:R02164','KEGG','298596',true).
concept_accession('6861: rn:R01316','KEGG','RP00541',true).
concept_accession('6861: rn:R01316','KEGG','RP:RP00541',true).
concept_accession('6861: rn:R01316','KEGG','RN:R01316',true).
concept_accession('6861: rn:R01316','KEGG','EC:3.1.1.32',true).
concept_accession('6861: rn:R01316','KEGG','RC00041',true).
concept_accession('6861: rn:R01316','EC','3.1.1.32',false).
concept_accession('6861: rn:R01316','KEGG','RC:RC00041',true).
concept_accession('6861: rn:R01316','KEGG','R01316',true).
concept_accession('6861: rn:R01316','KEGG','3.1.1.32',true).
concept_accession('40989: rn:R01325','KEGG','EC:4.2.1.3',true).
concept_accession('40989: rn:R01325','EC','4.2.1.3',true).
concept_accession('40989: rn:R01325','KEGG','79250',true).
concept_accession('40989: rn:R01325','KEGG','RNO:79250',true).
concept_accession('40989: rn:R01325','KEGG','4.2.1.3',true).
concept_accession('40989: rn:R01325','KEGG','RNO:50655',true).
concept_accession('40989: rn:R01325','KEGG','50655',true).
concept_accession('40988: rn:R01900','KEGG','EC:4.2.1.3',true).
concept_accession('40988: rn:R01900','EC','4.2.1.3',true).
concept_accession('40988: rn:R01900','KEGG','79250',true).
concept_accession('40988: rn:R01900','KEGG','RNO:79250',true).
concept_accession('40988: rn:R01900','KEGG','4.2.1.3',true).
concept_accession('40988: rn:R01900','KEGG','RNO:50655',true).
concept_accession('40988: rn:R01900','KEGG','50655',true).
concept_accession('6863: rn:R02027','KEGG','RP:RP00393',true).
concept_accession('6863: rn:R02027','KEGG','R02027',true).
concept_accession('6863: rn:R02027','KEGG','EC:3.1.4.3',true).
concept_accession('6863: rn:R02027','EC','3.1.4.3',false).
concept_accession('6863: rn:R02027','KEGG','RC00017',true).
concept_accession('6863: rn:R02027','KEGG','RC:RC00017',true).
concept_accession('6863: rn:R02027','KEGG','RP00393',true).
concept_accession('6863: rn:R02027','KEGG','3.1.4.3',true).
concept_accession('6863: rn:R02027','KEGG','RN:R02027',true).
concept_accession('40979: rn:R09086','KEGG','2.7.1.147',true).
concept_accession('40979: rn:R09086','KEGG','RNO:315722',true).
concept_accession('40979: rn:R09086','EC','2.7.1.147',true).
concept_accession('40979: rn:R09086','KEGG','EC:2.7.1.147',true).
concept_accession('40979: rn:R09086','KEGG','315722',true).
concept_accession('40978: rn:R07618','KEGG','298942',true).
concept_accession('40978: rn:R07618','KEGG','1.8.1.4',true).
concept_accession('40978: rn:R07618','KEGG','EC:1.8.1.4',true).
concept_accession('40978: rn:R07618','KEGG','RNO:298942',true).
concept_accession('40978: rn:R07618','EC','1.8.1.4',true).
concept_accession('6849: rn:R05794','KEGG','RN:R05794',true).
concept_accession('6849: rn:R05794','EC','2.7.8.24',false).
concept_accession('6849: rn:R05794','KEGG','2.7.8.24',true).
concept_accession('6849: rn:R05794','KEGG','R05794',true).
concept_accession('6849: rn:R05794','KEGG','EC:2.7.8.24',true).
concept_accession('40977: rn:R00621','EC','1.2.4.2',true).
concept_accession('40977: rn:R00621','KEGG','1.2.4.2',true).
concept_accession('40977: rn:R00621','KEGG','RNO:290566',true).
concept_accession('40977: rn:R00621','KEGG','360975',true).
concept_accession('40977: rn:R00621','KEGG','EC:1.2.4.2',true).
concept_accession('40977: rn:R00621','KEGG','290566',true).
concept_accession('40977: rn:R00621','KEGG','RNO:360975',true).
concept_accession('40976: rn:R00405','KEGG','RNO:361071',true).
concept_accession('40976: rn:R00405','KEGG','361071',true).
concept_accession('40976: rn:R00405','EC','6.2.1.5',true).
concept_accession('40976: rn:R00405','KEGG','EC:6.2.1.5',true).
concept_accession('40976: rn:R00405','KEGG','114597',true).
concept_accession('40976: rn:R00405','KEGG','6.2.1.5',true).
concept_accession('40976: rn:R00405','KEGG','RNO:114597',true).
concept_accession('40976: rn:R00405','KEGG','362404',true).
concept_accession('40976: rn:R00405','KEGG','RNO:362404',true).
concept_accession('6851: rn:R01319','EC','2.3.1.62',false).
concept_accession('6851: rn:R01319','KEGG','RP00541',true).
concept_accession('6851: rn:R01319','KEGG','RP:RP00541',true).
concept_accession('6851: rn:R01319','KEGG','R01319',true).
concept_accession('6851: rn:R01319','KEGG','RC00041',true).
concept_accession('6851: rn:R01319','KEGG','EC:2.3.1.62',true).
concept_accession('6851: rn:R01319','KEGG','2.3.1.62',true).
concept_accession('6851: rn:R01319','KEGG','RC:RC00041',true).
concept_accession('6851: rn:R01319','KEGG','RN:R01319',true).
concept_accession('40983: rn:R03596','KEGG','297437',true).
concept_accession('40983: rn:R03596','KEGG','EC:1.8.1.9',true).
concept_accession('40983: rn:R03596','KEGG','RNO:50551',true).
concept_accession('40983: rn:R03596','KEGG','RNO:58819',true).
concept_accession('40983: rn:R03596','KEGG','50551',true).
concept_accession('40983: rn:R03596','KEGG','RNO:297437',true).
concept_accession('40983: rn:R03596','KEGG','58819',true).
concept_accession('40983: rn:R03596','EC','1.8.1.9',true).
concept_accession('40983: rn:R03596','KEGG','1.8.1.9',true).
concept_accession('40982: rn:R04162','EC','3.1.3.4',true).
concept_accession('40982: rn:R04162','KEGG','RNO:246115',true).
concept_accession('40982: rn:R04162','KEGG','192270',true).
concept_accession('40982: rn:R04162','KEGG','3.1.3.4',true).
concept_accession('40982: rn:R04162','KEGG','RNO:64369',true).
concept_accession('40982: rn:R04162','KEGG','246115',true).
concept_accession('40982: rn:R04162','KEGG','64369',true).
concept_accession('40982: rn:R04162','KEGG','RNO:192270',true).
concept_accession('40982: rn:R04162','KEGG','EC:3.1.3.4',true).
concept_accession('40981: rn:R04311','KEGG','EC:2.5.1.26',true).
concept_accession('40981: rn:R04311','KEGG','2.5.1.26',true).
concept_accession('40981: rn:R04311','KEGG','84114',true).
concept_accession('40981: rn:R04311','EC','2.5.1.26',true).
concept_accession('40981: rn:R04311','KEGG','RNO:84114',true).
concept_accession('40980: rn:R04773','KEGG','RNO:299851',true).
concept_accession('40980: rn:R04773','KEGG','299851',true).
concept_accession('40980: rn:R04773','KEGG','6.1.1.10',true).
concept_accession('40980: rn:R04773','EC','6.1.1.10',true).
concept_accession('40980: rn:R04773','KEGG','EC:6.1.1.10',true).
concept_accession('40980: rn:R04773','KEGG','RNO:316403',true).
concept_accession('40980: rn:R04773','KEGG','316403',true).
concept_accession('41000: rn:R02466','KEGG','24379',true).
concept_accession('41000: rn:R02466','KEGG','RNO:24379',true).
concept_accession('41000: rn:R02466','KEGG','EC:4.1.1.29',true).
concept_accession('41000: rn:R02466','KEGG','RNO:24380',true).
concept_accession('41000: rn:R02466','KEGG','4.1.1.29',true).
concept_accession('41000: rn:R02466','EC','4.1.1.29',true).
concept_accession('41000: rn:R02466','KEGG','24380',true).
concept_accession('6907: rn:R01030','KEGG','RN:R01030',true).
concept_accession('6907: rn:R01030','EC','3.1.4.46',false).
concept_accession('6907: rn:R01030','KEGG','RC:RC00425',true).
concept_accession('6907: rn:R01030','KEGG','RC00017',true).
concept_accession('6907: rn:R01030','KEGG','RC00425',true).
concept_accession('6907: rn:R01030','KEGG','RC:RC00017',true).
concept_accession('6907: rn:R01030','KEGG','R01030',true).
concept_accession('6907: rn:R01030','KEGG','RP01244',true).
concept_accession('6907: rn:R01030','KEGG','RP01245',true).
concept_accession('6907: rn:R01030','KEGG','EC:3.1.4.46',true).
concept_accession('6907: rn:R01030','KEGG','RP:RP01244',true).
concept_accession('6907: rn:R01030','KEGG','RP:RP01245',true).
concept_accession('6907: rn:R01030','KEGG','3.1.4.46',true).
concept_accession('41001: rn:R07387','KEGG','298579',true).
concept_accession('41001: rn:R07387','KEGG','RNO:192259',true).
concept_accession('41001: rn:R07387','KEGG','296091',true).
concept_accession('41001: rn:R07387','KEGG','RNO:311341',true).
concept_accession('41001: rn:R07387','KEGG','RNO:29359',true).
concept_accession('41001: rn:R07387','KEGG','RNO:289733',true).
concept_accession('41001: rn:R07387','KEGG','29526',true).
concept_accession('41001: rn:R07387','KEGG','29387',true).
concept_accession('41001: rn:R07387','KEGG','362039',true).
concept_accession('41001: rn:R07387','KEGG','EC:3.1.1.4',true).
concept_accession('41001: rn:R07387','KEGG','RNO:29387',true).
concept_accession('41001: rn:R07387','KEGG','691907',true).
concept_accession('41001: rn:R07387','KEGG','RNO:298579',true).
concept_accession('41001: rn:R07387','KEGG','311341',true).
concept_accession('41001: rn:R07387','KEGG','RNO:690388',true).
concept_accession('41001: rn:R07387','KEGG','289733',true).
concept_accession('41001: rn:R07387','KEGG','RNO:362039',true).
concept_accession('41001: rn:R07387','KEGG','RNO:29692',true).
concept_accession('41001: rn:R07387','KEGG','24653',true).
concept_accession('41001: rn:R07387','KEGG','RNO:29526',true).
concept_accession('41001: rn:R07387','EC','3.1.1.4',true).
concept_accession('41001: rn:R07387','KEGG','RNO:24653',true).
concept_accession('41001: rn:R07387','KEGG','192259',true).
concept_accession('41001: rn:R07387','KEGG','3.1.1.4',true).
concept_accession('41001: rn:R07387','KEGG','690388',true).
concept_accession('41001: rn:R07387','KEGG','RNO:691907',true).
concept_accession('41001: rn:R07387','KEGG','RNO:296091',true).
concept_accession('41001: rn:R07387','KEGG','29359',true).
concept_accession('41001: rn:R07387','KEGG','367415',true).
concept_accession('41001: rn:R07387','KEGG','29354',true).
concept_accession('41001: rn:R07387','KEGG','RNO:367415',true).
concept_accession('41001: rn:R07387','KEGG','RNO:360426',true).
concept_accession('41001: rn:R07387','KEGG','29692',true).
concept_accession('41001: rn:R07387','KEGG','360426',true).
concept_accession('41001: rn:R07387','KEGG','RNO:29354',true).
concept_accession('6906: rn:R04864','KEGG','RP00455',true).
concept_accession('6906: rn:R04864','KEGG','RN:R04864',true).
concept_accession('6906: rn:R04864','KEGG','EC:2.3.1.40',true).
concept_accession('6906: rn:R04864','KEGG','RC00041',true).
concept_accession('6906: rn:R04864','EC','2.3.1.40',false).
concept_accession('6906: rn:R04864','KEGG','RP:RP00455',true).
concept_accession('6906: rn:R04864','KEGG','RC:RC00041',true).
concept_accession('6906: rn:R04864','KEGG','R04864',true).
concept_accession('6906: rn:R04864','KEGG','2.3.1.40',true).
concept_accession('41002: rn:R02466','KEGG','EC:4.1.1.29',true).
concept_accession('41002: rn:R02466','KEGG','60356',true).
concept_accession('41002: rn:R02466','KEGG','4.1.1.29',true).
concept_accession('41002: rn:R02466','EC','4.1.1.29',true).
concept_accession('41002: rn:R02466','KEGG','RNO:60356',true).
concept_accession('6905: rn:R01470','KEGG','EC:3.1.4.2',true).
concept_accession('6905: rn:R01470','KEGG','R01470',true).
concept_accession('6905: rn:R01470','KEGG','RC:RC00425',true).
concept_accession('6905: rn:R01470','KEGG','RC00017',true).
concept_accession('6905: rn:R01470','EC','3.1.4.2',false).
concept_accession('6905: rn:R01470','KEGG','RP01534',true).
concept_accession('6905: rn:R01470','KEGG','RP01533',true).
concept_accession('6905: rn:R01470','KEGG','RP:RP01534',true).
concept_accession('6905: rn:R01470','KEGG','RC00425',true).
concept_accession('6905: rn:R01470','KEGG','RN:R01470',true).
concept_accession('6905: rn:R01470','KEGG','RP:RP01533',true).
concept_accession('6905: rn:R01470','KEGG','RC:RC00017',true).
concept_accession('6905: rn:R01470','KEGG','3.1.4.2',true).
concept_accession('41003: rn:R07379','KEGG','298579',true).
concept_accession('41003: rn:R07379','KEGG','RNO:192259',true).
concept_accession('41003: rn:R07379','KEGG','296091',true).
concept_accession('41003: rn:R07379','KEGG','RNO:311341',true).
concept_accession('41003: rn:R07379','KEGG','RNO:29359',true).
concept_accession('41003: rn:R07379','KEGG','RNO:289733',true).
concept_accession('41003: rn:R07379','KEGG','29526',true).
concept_accession('41003: rn:R07379','KEGG','29387',true).
concept_accession('41003: rn:R07379','KEGG','362039',true).
concept_accession('41003: rn:R07379','KEGG','EC:3.1.1.4',true).
concept_accession('41003: rn:R07379','KEGG','RNO:29387',true).
concept_accession('41003: rn:R07379','KEGG','691907',true).
concept_accession('41003: rn:R07379','KEGG','RNO:298579',true).
concept_accession('41003: rn:R07379','KEGG','311341',true).
concept_accession('41003: rn:R07379','KEGG','RNO:690388',true).
concept_accession('41003: rn:R07379','KEGG','289733',true).
concept_accession('41003: rn:R07379','KEGG','RNO:362039',true).
concept_accession('41003: rn:R07379','KEGG','RNO:29692',true).
concept_accession('41003: rn:R07379','KEGG','24653',true).
concept_accession('41003: rn:R07379','KEGG','RNO:29526',true).
concept_accession('41003: rn:R07379','EC','3.1.1.4',true).
concept_accession('41003: rn:R07379','KEGG','RNO:24653',true).
concept_accession('41003: rn:R07379','KEGG','192259',true).
concept_accession('41003: rn:R07379','KEGG','3.1.1.4',true).
concept_accession('41003: rn:R07379','KEGG','690388',true).
concept_accession('41003: rn:R07379','KEGG','RNO:691907',true).
concept_accession('41003: rn:R07379','KEGG','RNO:296091',true).
concept_accession('41003: rn:R07379','KEGG','29359',true).
concept_accession('41003: rn:R07379','KEGG','367415',true).
concept_accession('41003: rn:R07379','KEGG','29354',true).
concept_accession('41003: rn:R07379','KEGG','RNO:367415',true).
concept_accession('41003: rn:R07379','KEGG','RNO:360426',true).
concept_accession('41003: rn:R07379','KEGG','29692',true).
concept_accession('41003: rn:R07379','KEGG','360426',true).
concept_accession('41003: rn:R07379','KEGG','RNO:29354',true).
concept_accession('41004: rn:R02467','KEGG','309732',true).
concept_accession('41004: rn:R02467','KEGG','EC:1.13.11.19',true).
concept_accession('41004: rn:R02467','EC','1.13.11.19',true).
concept_accession('41004: rn:R02467','KEGG','RNO:309732',true).
concept_accession('41004: rn:R02467','KEGG','1.13.11.19',true).
concept_accession('41005: rn:R03437','KEGG','307713',true).
concept_accession('41005: rn:R03437','KEGG','RNO:296048',true).
concept_accession('41005: rn:R03437','KEGG','RNO:307713',true).
concept_accession('41005: rn:R03437','KEGG','RNO:361467',true).
concept_accession('41005: rn:R03437','KEGG','296048',true).
concept_accession('41005: rn:R03437','KEGG','361467',true).
concept_accession('41005: rn:R03437','KEGG','RNO:100359680',true).
concept_accession('41005: rn:R03437','KEGG','EC:2.3.1.67',true).
concept_accession('41005: rn:R03437','KEGG','2.3.1.67',true).
concept_accession('41005: rn:R03437','EC','2.3.1.67',true).
concept_accession('41005: rn:R03437','KEGG','100359680',true).
concept_accession('41006: rn:R00893','KEGG','EC:1.13.11.20',true).
concept_accession('41006: rn:R00893','KEGG','81718',true).
concept_accession('41006: rn:R00893','EC','1.13.11.20',true).
concept_accession('41006: rn:R00893','KEGG','RNO:81718',true).
concept_accession('41006: rn:R00893','KEGG','1.13.11.20',true).
concept_accession('41007: rn:R06364','KEGG','RNO:362713',true).
concept_accession('41007: rn:R06364','KEGG','RNO:310773',true).
concept_accession('41007: rn:R06364','KEGG','2.7.8.1',true).
concept_accession('41007: rn:R06364','KEGG','362713',true).
concept_accession('41007: rn:R06364','EC','2.7.8.1',true).
concept_accession('41007: rn:R06364','KEGG','EC:2.7.8.1',true).
concept_accession('41007: rn:R06364','KEGG','310773',true).
concept_accession('40992: rn:R07380','KEGG','3.1.4.-',true).
concept_accession('40992: rn:R07380','EC','3.1.4.-',true).
concept_accession('40992: rn:R07380','KEGG','EC:3.1.4.-',true).
concept_accession('40992: rn:R07380','KEGG','RNO:306460',true).
concept_accession('40992: rn:R07380','KEGG','306460',true).
concept_accession('40993: rn:R07388','KEGG','RNO:84050',true).
concept_accession('40993: rn:R07388','KEGG','3.1.4.39',true).
concept_accession('40993: rn:R07388','KEGG','84050',true).
concept_accession('40993: rn:R07388','KEGG','EC:3.1.4.39',true).
concept_accession('40993: rn:R07388','EC','3.1.4.39',true).
concept_accession('40994: rn:R07384','KEGG','RNO:362713',true).
concept_accession('40994: rn:R07384','KEGG','RNO:310773',true).
concept_accession('40994: rn:R07384','KEGG','2.7.8.1',true).
concept_accession('40994: rn:R07384','KEGG','362713',true).
concept_accession('40994: rn:R07384','EC','2.7.8.1',true).
concept_accession('40994: rn:R07384','KEGG','EC:2.7.8.1',true).
concept_accession('40994: rn:R07384','KEGG','310773',true).
concept_accession('40995: rn:R04413','KEGG','EC:2.3.1.121',true).
concept_accession('40995: rn:R04413','KEGG','RNO:296048',true).
concept_accession('40995: rn:R04413','KEGG','296048',true).
concept_accession('40995: rn:R04413','KEGG','2.3.1.121',true).
concept_accession('40995: rn:R04413','EC','2.3.1.121',true).
concept_accession('6896: rn:R02756','KEGG','RP:RP02475',true).
concept_accession('6896: rn:R02756','KEGG','1.1.1.101',true).
concept_accession('6896: rn:R02756','KEGG','R02756',true).
concept_accession('6896: rn:R02756','KEGG','RC00029',true).
concept_accession('6896: rn:R02756','KEGG','EC:1.1.1.101',true).
concept_accession('6896: rn:R02756','KEGG','RP02475',true).
concept_accession('6896: rn:R02756','KEGG','RC:RC00029',true).
concept_accession('6896: rn:R02756','KEGG','RN:R02756',true).
concept_accession('6896: rn:R02756','EC','1.1.1.101',false).
concept_accession('40996: rn:R03720','KEGG','RNO:29725',true).
concept_accession('40996: rn:R03720','KEGG','EC:2.3.1.65',true).
concept_accession('40996: rn:R03720','KEGG','29725',true).
concept_accession('40996: rn:R03720','KEGG','2.3.1.65',true).
concept_accession('40996: rn:R03720','EC','2.3.1.65',true).
concept_accession('40997: rn:R07385','KEGG','RNO:25096',true).
concept_accession('40997: rn:R07385','KEGG','RNO:25097',true).
concept_accession('40997: rn:R07385','KEGG','25097',true).
concept_accession('40997: rn:R07385','KEGG','25096',true).
concept_accession('40997: rn:R07385','KEGG','3.1.4.4',true).
concept_accession('40997: rn:R07385','EC','3.1.4.4',true).
concept_accession('40997: rn:R07385','KEGG','EC:3.1.4.4',true).
concept_accession('40998: rn:R01687','KEGG','RNO:156275',true).
concept_accession('40998: rn:R01687','KEGG','156275',true).
concept_accession('40998: rn:R01687','KEGG','408206',true).
concept_accession('40998: rn:R01687','KEGG','RNO:29566',true).
concept_accession('40998: rn:R01687','KEGG','RNO:408206',true).
concept_accession('40998: rn:R01687','EC','2.3.2.2',true).
concept_accession('40998: rn:R01687','KEGG','2.3.2.2',true).
concept_accession('40998: rn:R01687','KEGG','RNO:116568',true).
concept_accession('40998: rn:R01687','KEGG','116568',true).
concept_accession('40998: rn:R01687','KEGG','29566',true).
concept_accession('40998: rn:R01687','KEGG','EC:2.3.2.2',true).
concept_accession('40999: rn:R03438','KEGG','307713',true).
concept_accession('40999: rn:R03438','EC','2.3.1.63',true).
concept_accession('40999: rn:R03438','KEGG','RNO:307713',true).
concept_accession('40999: rn:R03438','KEGG','RNO:361467',true).
concept_accession('40999: rn:R03438','KEGG','361467',true).
concept_accession('40999: rn:R03438','KEGG','EC:2.3.1.63',true).
concept_accession('40999: rn:R03438','KEGG','2.3.1.63',true).
concept_accession('40999: rn:R03438','KEGG','RNO:100359680',true).
concept_accession('40999: rn:R03438','KEGG','100359680',true).
concept_accession('41017: rn:R07618','KEGG','298942',true).
concept_accession('41017: rn:R07618','KEGG','1.8.1.4',true).
concept_accession('41017: rn:R07618','KEGG','EC:1.8.1.4',true).
concept_accession('41017: rn:R07618','KEGG','RNO:298942',true).
concept_accession('41017: rn:R07618','EC','1.8.1.4',true).
concept_accession('41016: rn:R03057','EC','3.3.2.6',true).
concept_accession('41016: rn:R03057','KEGG','299732',true).
concept_accession('41016: rn:R03057','KEGG','3.3.2.6',true).
concept_accession('41016: rn:R03057','KEGG','EC:3.3.2.6',true).
concept_accession('41016: rn:R03057','KEGG','RNO:299732',true).
concept_accession('3035: rn:R00271','KEGG','2.3.3.14',true).
concept_accession('3035: rn:R00271','KEGG','RC:RC00067',true).
concept_accession('3035: rn:R00271','KEGG','RP04508',true).
concept_accession('3035: rn:R00271','EC','2.3.3.14',false).
concept_accession('3035: rn:R00271','KEGG','RC00067',true).
concept_accession('3035: rn:R00271','KEGG','R00271',true).
concept_accession('3035: rn:R00271','KEGG','RN:R00271',true).
concept_accession('3035: rn:R00271','KEGG','RP:RP04508',true).
concept_accession('3035: rn:R00271','KEGG','EC:2.3.3.14',true).
concept_accession('41019: rn:R02265','KEGG','59103',true).
concept_accession('41019: rn:R02265','KEGG','311865',true).
concept_accession('41019: rn:R02265','EC','5.3.99.3',true).
concept_accession('41019: rn:R02265','KEGG','RNO:311865',true).
concept_accession('41019: rn:R02265','KEGG','EC:5.3.99.3',true).
concept_accession('41019: rn:R02265','KEGG','RNO:59103',true).
concept_accession('41019: rn:R02265','KEGG','5.3.99.3',true).
concept_accession('41018: rn:R03866','KEGG','RNO:290623',true).
concept_accession('41018: rn:R03866','KEGG','290623',true).
concept_accession('41018: rn:R03866','KEGG','RNO:500801',true).
concept_accession('41018: rn:R03866','EC','1.14.13.30',true).
concept_accession('41018: rn:R03866','KEGG','1.14.13.30',true).
concept_accession('41018: rn:R03866','KEGG','56266',true).
concept_accession('41018: rn:R03866','KEGG','RNO:286905',true).
concept_accession('41018: rn:R03866','KEGG','RNO:286904',true).
concept_accession('41018: rn:R03866','KEGG','503122',true).
concept_accession('41018: rn:R03866','KEGG','EC:1.14.13.30',true).
concept_accession('41018: rn:R03866','KEGG','286905',true).
concept_accession('41018: rn:R03866','KEGG','RNO:503122',true).
concept_accession('41018: rn:R03866','KEGG','RNO:56266',true).
concept_accession('41018: rn:R03866','KEGG','286904',true).
concept_accession('41018: rn:R03866','KEGG','500801',true).
concept_accession('41018: rn:R03866','KEGG','RNO:266689',true).
concept_accession('41018: rn:R03866','KEGG','266689',true).
concept_accession('41021: rn:R02268','KEGG','EC:5.3.99.5',true).
concept_accession('41021: rn:R02268','KEGG','5.3.99.5',true).
concept_accession('41021: rn:R02268','EC','5.3.99.5',true).
concept_accession('41021: rn:R02268','KEGG','24886',true).
concept_accession('41021: rn:R02268','KEGG','RNO:24886',true).
concept_accession('41020: rn:R02569','KEGG','EC:2.3.1.12',true).
concept_accession('41020: rn:R02569','KEGG','2.3.1.12',true).
concept_accession('41020: rn:R02569','KEGG','RNO:81654',true).
concept_accession('41020: rn:R02569','KEGG','81654',true).
concept_accession('41020: rn:R02569','EC','2.3.1.12',true).
concept_accession('41023: rn:R02267','KEGG','EC:5.3.99.4',true).
concept_accession('41023: rn:R02267','KEGG','RNO:25527',true).
concept_accession('41023: rn:R02267','KEGG','25527',true).
concept_accession('41023: rn:R02267','KEGG','5.3.99.4',true).
concept_accession('41023: rn:R02267','EC','5.3.99.4',true).
concept_accession('41022: rn:R01590','KEGG','29527',true).
concept_accession('41022: rn:R01590','KEGG','RNO:24693',true).
concept_accession('41022: rn:R01590','KEGG','24693',true).
concept_accession('41022: rn:R01590','KEGG','RNO:29527',true).
concept_accession('41022: rn:R01590','KEGG','1.14.99.1',true).
concept_accession('41022: rn:R01590','KEGG','EC:1.14.99.1',true).
concept_accession('41022: rn:R01590','EC','1.14.99.1',true).
concept_accession('41009: rn:R04321','KEGG','2.7.8.2',true).
concept_accession('41009: rn:R04321','KEGG','RNO:310773',true).
concept_accession('41009: rn:R04321','EC','2.7.8.2',true).
concept_accession('41009: rn:R04321','KEGG','310773',true).
concept_accession('41009: rn:R04321','KEGG','362866',true).
concept_accession('41009: rn:R04321','KEGG','EC:2.7.8.2',true).
concept_accession('41009: rn:R04321','KEGG','RNO:362866',true).
concept_accession('41008: rn:R01682','KEGG','24379',true).
concept_accession('41008: rn:R01682','KEGG','RNO:24379',true).
concept_accession('41008: rn:R01682','KEGG','EC:4.1.1.29',true).
concept_accession('41008: rn:R01682','KEGG','RNO:24380',true).
concept_accession('41008: rn:R01682','KEGG','4.1.1.29',true).
concept_accession('41008: rn:R01682','EC','4.1.1.29',true).
concept_accession('41008: rn:R01682','KEGG','24380',true).
concept_accession('3027: rn:R00457','EC','2.6.1.36',false).
concept_accession('3027: rn:R00457','KEGG','2.6.1.36',true).
concept_accession('3027: rn:R00457','KEGG','RP:RP00405',true).
concept_accession('3027: rn:R00457','KEGG','R00457',true).
concept_accession('3027: rn:R00457','KEGG','RN:R00457',true).
concept_accession('3027: rn:R00457','KEGG','EC:2.6.1.36',true).
concept_accession('3027: rn:R00457','KEGG','RC00062',true).
concept_accession('3027: rn:R00457','KEGG','RP00405',true).
concept_accession('3027: rn:R00457','KEGG','RC:RC00062',true).
concept_accession('41011: rn:R04452','EC','3.1.1.47',true).
concept_accession('41011: rn:R04452','KEGG','RNO:83572',true).
concept_accession('41011: rn:R04452','KEGG','301265',true).
concept_accession('41011: rn:R04452','KEGG','EC:3.1.1.47',true).
concept_accession('41011: rn:R04452','KEGG','83572',true).
concept_accession('41011: rn:R04452','KEGG','114113',true).
concept_accession('41011: rn:R04452','KEGG','RNO:313611',true).
concept_accession('41011: rn:R04452','KEGG','313611',true).
concept_accession('41011: rn:R04452','KEGG','RNO:301265',true).
concept_accession('41011: rn:R04452','KEGG','64189',true).
concept_accession('41011: rn:R04452','KEGG','3.1.1.47',true).
concept_accession('41011: rn:R04452','KEGG','RNO:64189',true).
concept_accession('41011: rn:R04452','KEGG','RNO:114113',true).
concept_accession('41010: rn:R01682','KEGG','EC:4.1.1.29',true).
concept_accession('41010: rn:R01682','KEGG','60356',true).
concept_accession('41010: rn:R01682','KEGG','4.1.1.29',true).
concept_accession('41010: rn:R01682','EC','4.1.1.29',true).
concept_accession('41010: rn:R01682','KEGG','RNO:60356',true).
concept_accession('41013: rn:R03059','KEGG','RNO:114097',true).
concept_accession('41013: rn:R03059','KEGG','4.4.1.20',true).
concept_accession('41013: rn:R03059','KEGG','114097',true).
concept_accession('41013: rn:R03059','KEGG','EC:4.4.1.20',true).
concept_accession('41013: rn:R03059','EC','4.4.1.20',true).
concept_accession('6886: rn:R02029','KEGG','RP:RP01923',true).
concept_accession('6886: rn:R02029','KEGG','RC00017',true).
concept_accession('6886: rn:R02029','KEGG','R02029',true).
concept_accession('6886: rn:R02029','KEGG','RC:RC00017',true).
concept_accession('6886: rn:R02029','KEGG','EC:3.1.3.27',true).
concept_accession('6886: rn:R02029','KEGG','3.1.3.27',true).
concept_accession('6886: rn:R02029','KEGG','RN:R02029',true).
concept_accession('6886: rn:R02029','KEGG','RP01923',true).
concept_accession('6886: rn:R02029','EC','3.1.3.27',false).
concept_accession('41012: rn:R07389','KEGG','2.7.8.2',true).
concept_accession('41012: rn:R07389','KEGG','RNO:310773',true).
concept_accession('41012: rn:R07389','EC','2.7.8.2',true).
concept_accession('41012: rn:R07389','KEGG','310773',true).
concept_accession('41012: rn:R07389','KEGG','362866',true).
concept_accession('41012: rn:R07389','KEGG','EC:2.7.8.2',true).
concept_accession('41012: rn:R07389','KEGG','RNO:362866',true).
concept_accession('6887: rn:R01030','KEGG','RN:R01030',true).
concept_accession('6887: rn:R01030','EC','3.1.4.46',false).
concept_accession('6887: rn:R01030','KEGG','RC:RC00425',true).
concept_accession('6887: rn:R01030','KEGG','RC00017',true).
concept_accession('6887: rn:R01030','KEGG','RC00425',true).
concept_accession('6887: rn:R01030','KEGG','RC:RC00017',true).
concept_accession('6887: rn:R01030','KEGG','R01030',true).
concept_accession('6887: rn:R01030','KEGG','RP01244',true).
concept_accession('6887: rn:R01030','KEGG','RP01245',true).
concept_accession('6887: rn:R01030','KEGG','EC:3.1.4.46',true).
concept_accession('6887: rn:R01030','KEGG','RP:RP01244',true).
concept_accession('6887: rn:R01030','KEGG','RP:RP01245',true).
concept_accession('6887: rn:R01030','KEGG','3.1.4.46',true).
concept_accession('41015: rn:R03867','KEGG','RNO:156275',true).
concept_accession('41015: rn:R03867','KEGG','156275',true).
concept_accession('41015: rn:R03867','KEGG','408206',true).
concept_accession('41015: rn:R03867','KEGG','RNO:29566',true).
concept_accession('41015: rn:R03867','KEGG','RNO:408206',true).
concept_accession('41015: rn:R03867','EC','2.3.2.2',true).
concept_accession('41015: rn:R03867','KEGG','2.3.2.2',true).
concept_accession('41015: rn:R03867','KEGG','RNO:116568',true).
concept_accession('41015: rn:R03867','KEGG','116568',true).
concept_accession('41015: rn:R03867','KEGG','29566',true).
concept_accession('41015: rn:R03867','KEGG','EC:2.3.2.2',true).
concept_accession('41014: rn:R03270','KEGG','RNO:117098',true).
concept_accession('41014: rn:R03270','EC','1.2.4.1',true).
concept_accession('41014: rn:R03270','KEGG','RNO:289950',true).
concept_accession('41014: rn:R03270','KEGG','1.2.4.1',true).
concept_accession('41014: rn:R03270','KEGG','117098',true).
concept_accession('41014: rn:R03270','KEGG','289950',true).
concept_accession('41014: rn:R03270','KEGG','29554',true).
concept_accession('41014: rn:R03270','KEGG','RNO:29554',true).
concept_accession('41014: rn:R03270','KEGG','EC:1.2.4.1',true).
concept_accession('6885: rn:R00749','KEGG','EC:4.3.1.7',true).
concept_accession('6885: rn:R00749','KEGG','RP:RP01082',true).
concept_accession('6885: rn:R00749','KEGG','RC00370',true).
concept_accession('6885: rn:R00749','EC','4.3.1.7',false).
concept_accession('6885: rn:R00749','KEGG','RP01082',true).
concept_accession('6885: rn:R00749','KEGG','RN:R00749',true).
concept_accession('6885: rn:R00749','KEGG','R00749',true).
concept_accession('6885: rn:R00749','KEGG','4.3.1.7',true).
concept_accession('6885: rn:R00749','KEGG','RC:RC00370',true).
concept_accession('41159: rn:R02301','KEGG','6.3.3.2',true).
concept_accession('41159: rn:R02301','EC','6.3.3.2',true).
concept_accession('41159: rn:R02301','KEGG','300886',true).
concept_accession('41159: rn:R02301','KEGG','EC:6.3.3.2',true).
concept_accession('41159: rn:R02301','KEGG','RNO:300886',true).
concept_accession('41158: rn:R00904','KEGG','RNO:25375',true).
concept_accession('41158: rn:R00904','KEGG','25375',true).
concept_accession('41158: rn:R00904','KEGG','RNO:266603',true).
concept_accession('41158: rn:R00904','KEGG','266603',true).
concept_accession('41158: rn:R00904','KEGG','RNO:309147',true).
concept_accession('41158: rn:R00904','KEGG','309147',true).
concept_accession('41158: rn:R00904','KEGG','EC:1.2.1.5',true).
concept_accession('41158: rn:R00904','EC','1.2.1.5',true).
concept_accession('41158: rn:R00904','KEGG','1.2.1.5',true).
concept_accession('41157: rn:R04325','KEGG','EC:2.1.2.2',true).
concept_accession('41157: rn:R04325','KEGG','288259',true).
concept_accession('41157: rn:R04325','KEGG','RNO:288259',true).
concept_accession('41157: rn:R04325','KEGG','2.1.2.2',true).
concept_accession('41157: rn:R04325','EC','2.1.2.2',true).
concept_accession('41156: rn:R00943','KEGG','6.3.4.3',true).
concept_accession('41156: rn:R00943','KEGG','RNO:64300',true).
concept_accession('41156: rn:R00943','KEGG','RNO:361472',true).
concept_accession('41156: rn:R00943','KEGG','64300',true).
concept_accession('41156: rn:R00943','KEGG','EC:6.3.4.3',true).
concept_accession('41156: rn:R00943','EC','6.3.4.3',true).
concept_accession('41156: rn:R00943','KEGG','361472',true).
concept_accession('41155: rn:R00941','KEGG','299699',true).
concept_accession('41155: rn:R00941','KEGG','RNO:299699',true).
concept_accession('41155: rn:R00941','KEGG','RNO:64392',true).
concept_accession('41155: rn:R00941','EC','1.5.1.6',true).
concept_accession('41155: rn:R00941','KEGG','1.5.1.6',true).
concept_accession('41155: rn:R00941','KEGG','64392',true).
concept_accession('41155: rn:R00941','KEGG','EC:1.5.1.6',true).
concept_accession('41154: rn:R00978','KEGG','RNO:81656',true).
concept_accession('41154: rn:R00978','KEGG','81656',true).
concept_accession('41154: rn:R00978','KEGG','1.3.1.2',true).
concept_accession('41154: rn:R00978','KEGG','EC:1.3.1.2',true).
concept_accession('41154: rn:R00978','EC','1.3.1.2',true).
concept_accession('41153: rn:R02269','KEGG','65135',true).
concept_accession('41153: rn:R02269','KEGG','RNO:65135',true).
concept_accession('41153: rn:R02269','EC','3.5.2.2',true).
concept_accession('41153: rn:R02269','KEGG','3.5.2.2',true).
concept_accession('41153: rn:R02269','KEGG','EC:3.5.2.2',true).
concept_accession('41152: rn:R00905','EC','3.5.1.6',true).
concept_accession('41152: rn:R00905','KEGG','116593',true).
concept_accession('41152: rn:R00905','KEGG','EC:3.5.1.6',true).
concept_accession('41152: rn:R00905','KEGG','RNO:116593',true).
concept_accession('41152: rn:R00905','KEGG','3.5.1.6',true).
concept_accession('41167: rn:R03189','KEGG','EC:2.1.2.5',true).
concept_accession('41167: rn:R03189','KEGG','89833',true).
concept_accession('41167: rn:R03189','KEGG','2.1.2.5',true).
concept_accession('41167: rn:R03189','EC','2.1.2.5',true).
concept_accession('41167: rn:R03189','KEGG','RNO:89833',true).
concept_accession('41166: rn:R01218','KEGG','RNO:313410',true).
concept_accession('41166: rn:R01218','KEGG','313410',true).
concept_accession('41166: rn:R01218','KEGG','RNO:305248',true).
concept_accession('41166: rn:R01218','EC','1.5.1.15',true).
concept_accession('41166: rn:R01218','KEGG','EC:1.5.1.15',true).
concept_accession('41166: rn:R01218','KEGG','305248',true).
concept_accession('41166: rn:R01218','KEGG','680308',true).
concept_accession('41166: rn:R01218','KEGG','1.5.1.15',true).
concept_accession('41166: rn:R01218','KEGG','RNO:680308',true).
concept_accession('41165: rn:R00936 rn:R00939','KEGG','EC:1.5.1.3',true).
concept_accession('41165: rn:R00936 rn:R00939','EC','1.5.1.3',true).
concept_accession('41165: rn:R00936 rn:R00939','KEGG','24312',true).
concept_accession('41165: rn:R00936 rn:R00939','KEGG','RNO:24312',true).
concept_accession('41165: rn:R00936 rn:R00939','KEGG','1.5.1.3',true).
concept_accession('41164: rn:R01220','KEGG','RNO:64300',true).
concept_accession('41164: rn:R01220','KEGG','1.5.1.5',true).
concept_accession('41164: rn:R01220','EC','1.5.1.5',true).
concept_accession('41164: rn:R01220','KEGG','64300',true).
concept_accession('41164: rn:R01220','KEGG','EC:1.5.1.5',true).
concept_accession('41163: rn:R01655','KEGG','RNO:313410',true).
concept_accession('41163: rn:R01655','KEGG','313410',true).
concept_accession('41163: rn:R01655','KEGG','RNO:305248',true).
concept_accession('41163: rn:R01655','EC','3.5.4.9',true).
concept_accession('41163: rn:R01655','KEGG','3.5.4.9',true).
concept_accession('41163: rn:R01655','KEGG','RNO:64300',true).
concept_accession('41163: rn:R01655','KEGG','EC:3.5.4.9',true).
concept_accession('41163: rn:R01655','KEGG','305248',true).
concept_accession('41163: rn:R01655','KEGG','680308',true).
concept_accession('41163: rn:R01655','KEGG','64300',true).
concept_accession('41163: rn:R01655','KEGG','RNO:680308',true).
concept_accession('41162: rn:R01224 rn:R07168','KEGG','362657',true).
concept_accession('41162: rn:R01224 rn:R07168','KEGG','EC:1.5.1.20',true).
concept_accession('41162: rn:R01224 rn:R07168','EC','1.5.1.20',true).
concept_accession('41162: rn:R01224 rn:R07168','KEGG','1.5.1.20',true).
concept_accession('41162: rn:R01224 rn:R07168','KEGG','RNO:362657',true).
concept_accession('41161: rn:R03940','KEGG','2.1.2.9',true).
concept_accession('41161: rn:R03940','KEGG','RNO:315763',true).
concept_accession('41161: rn:R03940','EC','2.1.2.9',true).
concept_accession('41161: rn:R03940','KEGG','315763',true).
concept_accession('41161: rn:R03940','KEGG','EC:2.1.2.9',true).
concept_accession('41160: rn:R02300','KEGG','EC:2.1.2.10',true).
concept_accession('41160: rn:R02300','EC','2.1.2.10',true).
concept_accession('41160: rn:R02300','KEGG','2.1.2.10',true).
concept_accession('41160: rn:R02300','KEGG','RNO:306586',true).
concept_accession('41160: rn:R02300','KEGG','306586',true).
concept_accession('41174: rn:R01975','KEGG','171142',true).
concept_accession('41174: rn:R01975','KEGG','RNO:171142',true).
concept_accession('41174: rn:R01975','EC','1.1.1.35',true).
concept_accession('41174: rn:R01975','KEGG','RNO:113965',true).
concept_accession('41174: rn:R01975','KEGG','EC:1.1.1.35',true).
concept_accession('41174: rn:R01975','KEGG','1.1.1.35',true).
concept_accession('41174: rn:R01975','KEGG','113965',true).
concept_accession('41175: rn:R00694','EC','2.6.1.9',true).
concept_accession('41175: rn:R00694','KEGG','25721',true).
concept_accession('41175: rn:R00694','KEGG','RNO:25721',true).
concept_accession('41175: rn:R00694','KEGG','EC:2.6.1.9',true).
concept_accession('41175: rn:R00694','KEGG','24401',true).
concept_accession('41175: rn:R00694','KEGG','2.6.1.9',true).
concept_accession('41175: rn:R00694','KEGG','RNO:24401',true).
concept_accession('41172: rn:R01648','EC','2.6.1.19',true).
concept_accession('41172: rn:R01648','KEGG','EC:2.6.1.19',true).
concept_accession('41172: rn:R01648','KEGG','2.6.1.19',true).
concept_accession('41172: rn:R01648','KEGG','RNO:81632',true).
concept_accession('41172: rn:R01648','KEGG','81632',true).
concept_accession('10582: rn:R03166','KEGG','R03166',true).
concept_accession('10582: rn:R03166','KEGG','RN:R03166',true).
concept_accession('10582: rn:R03166','KEGG','RP02809',true).
concept_accession('10582: rn:R03166','KEGG','RP:RP02809',true).
concept_accession('10582: rn:R03166','KEGG','RC00864',true).
concept_accession('10582: rn:R03166','KEGG','RC:RC00864',true).
concept_accession('41173: rn:R00261','KEGG','24379',true).
concept_accession('41173: rn:R00261','KEGG','RNO:24379',true).
concept_accession('41173: rn:R00261','EC','4.1.1.15',true).
concept_accession('41173: rn:R00261','KEGG','RNO:24380',true).
concept_accession('41173: rn:R00261','KEGG','EC:4.1.1.15',true).
concept_accession('41173: rn:R00261','KEGG','24380',true).
concept_accession('41173: rn:R00261','KEGG','4.1.1.15',true).
concept_accession('41170: rn:R02302','KEGG','EC:4.3.1.4',true).
concept_accession('41170: rn:R02302','KEGG','89833',true).
concept_accession('41170: rn:R02302','KEGG','RNO:89833',true).
concept_accession('41170: rn:R02302','KEGG','4.3.1.4',true).
concept_accession('41170: rn:R02302','EC','4.3.1.4',true).
concept_accession('41171: rn:R04326','KEGG','EC:2.1.2.2',true).
concept_accession('41171: rn:R04326','KEGG','288259',true).
concept_accession('41171: rn:R04326','KEGG','RNO:288259',true).
concept_accession('41171: rn:R04326','KEGG','2.1.2.2',true).
concept_accession('41171: rn:R04326','EC','2.1.2.2',true).
concept_accession('41168: rn:R02235 rn:R02236','KEGG','EC:1.5.1.3',true).
concept_accession('41168: rn:R02235 rn:R02236','EC','1.5.1.3',true).
concept_accession('41168: rn:R02235 rn:R02236','KEGG','24312',true).
concept_accession('41168: rn:R02235 rn:R02236','KEGG','RNO:24312',true).
concept_accession('41168: rn:R02235 rn:R02236','KEGG','1.5.1.3',true).
concept_accession('41169: rn:R02287','KEGG','EC:2.1.2.5',true).
concept_accession('41169: rn:R02287','KEGG','89833',true).
concept_accession('41169: rn:R02287','KEGG','2.1.2.5',true).
concept_accession('41169: rn:R02287','EC','2.1.2.5',true).
concept_accession('41169: rn:R02287','KEGG','RNO:89833',true).
concept_accession('41182: rn:R01357','KEGG','65984',true).
concept_accession('41182: rn:R01357','KEGG','RNO:65984',true).
concept_accession('41182: rn:R01357','EC','6.2.1.16',true).
concept_accession('41182: rn:R01357','KEGG','EC:6.2.1.16',true).
concept_accession('41182: rn:R01357','KEGG','6.2.1.16',true).
concept_accession('41183: rn:R00410','KEGG','RNO:100361036',true).
concept_accession('41183: rn:R00410','KEGG','EC:2.8.3.5',true).
concept_accession('41183: rn:R00410','KEGG','100361036',true).
concept_accession('41183: rn:R00410','EC','2.8.3.5',true).
concept_accession('41183: rn:R00410','KEGG','RNO:690163',true).
concept_accession('41183: rn:R00410','KEGG','100365119',true).
concept_accession('41183: rn:R00410','KEGG','100359544',true).
concept_accession('41183: rn:R00410','KEGG','2.8.3.5',true).
concept_accession('41183: rn:R00410','KEGG','RNO:366463',true).
concept_accession('41183: rn:R00410','KEGG','RNO:100365119',true).
concept_accession('41183: rn:R00410','KEGG','RNO:100359544',true).
concept_accession('41183: rn:R00410','KEGG','690163',true).
concept_accession('41183: rn:R00410','KEGG','366463',true).
concept_accession('41180: rn:R01978','KEGG','EC:2.3.3.10',true).
concept_accession('41180: rn:R01978','KEGG','RNO:29637',true).
concept_accession('41180: rn:R01978','KEGG','RNO:24450',true).
concept_accession('41180: rn:R01978','KEGG','2.3.3.10',true).
concept_accession('41180: rn:R01978','KEGG','24450',true).
concept_accession('41180: rn:R01978','EC','2.3.3.10',true).
concept_accession('41180: rn:R01978','KEGG','29637',true).
concept_accession('41181: rn:R01360','KEGG','EC:4.1.3.4',true).
concept_accession('41181: rn:R01360','KEGG','79238',true).
concept_accession('41181: rn:R01360','EC','4.1.3.4',true).
concept_accession('41181: rn:R01360','KEGG','RNO:79238',true).
concept_accession('41181: rn:R01360','KEGG','4.1.3.4',true).
concept_accession('41178: rn:R03026','KEGG','RNO:170670',true).
concept_accession('41178: rn:R03026','KEGG','171142',true).
concept_accession('41178: rn:R03026','KEGG','RNO:171142',true).
concept_accession('41178: rn:R03026','EC','4.2.1.17',true).
concept_accession('41178: rn:R03026','KEGG','170670',true).
concept_accession('41178: rn:R03026','KEGG','RNO:140547',true).
concept_accession('41178: rn:R03026','KEGG','140547',true).
concept_accession('41178: rn:R03026','KEGG','4.2.1.17',true).
concept_accession('41178: rn:R03026','KEGG','EC:4.2.1.17',true).
concept_accession('41179: rn:R01361','KEGG','1.1.1.30',true).
concept_accession('41179: rn:R01361','KEGG','RNO:117099',true).
concept_accession('41179: rn:R01361','KEGG','RNO:295458',true).
concept_accession('41179: rn:R01361','KEGG','117099',true).
concept_accession('41179: rn:R01361','KEGG','295458',true).
concept_accession('41179: rn:R01361','EC','1.1.1.30',true).
concept_accession('41179: rn:R01361','KEGG','EC:1.1.1.30',true).
concept_accession('41176: rn:R00238','KEGG','2.3.1.9',true).
concept_accession('41176: rn:R00238','KEGG','EC:2.3.1.9',true).
concept_accession('41176: rn:R00238','EC','2.3.1.9',true).
concept_accession('41176: rn:R00238','KEGG','RNO:308100',true).
concept_accession('41176: rn:R00238','KEGG','RNO:25014',true).
concept_accession('41176: rn:R00238','KEGG','25014',true).
concept_accession('41176: rn:R00238','KEGG','308100',true).
concept_accession('41177: rn:R00734','KEGG','EC:2.6.1.5',true).
concept_accession('41177: rn:R00734','KEGG','25721',true).
concept_accession('41177: rn:R00734','KEGG','RNO:25721',true).
concept_accession('41177: rn:R00734','EC','2.6.1.5',true).
concept_accession('41177: rn:R00734','KEGG','24401',true).
concept_accession('41177: rn:R00734','KEGG','2.6.1.5',true).
concept_accession('41177: rn:R00734','KEGG','RNO:24401',true).
concept_accession('41189: rn:R00489','KEGG','24379',true).
concept_accession('41189: rn:R00489','KEGG','4.1.1.11',true).
concept_accession('41189: rn:R00489','KEGG','RNO:24379',true).
concept_accession('41189: rn:R00489','EC','4.1.1.11',true).
concept_accession('41189: rn:R00489','KEGG','RNO:24380',true).
concept_accession('41189: rn:R00489','KEGG','24380',true).
concept_accession('41189: rn:R00489','KEGG','EC:4.1.1.11',true).
concept_accession('6710: rn:R03478','KEGG','R03478',true).
concept_accession('6710: rn:R03478','KEGG','RC:RC00078',true).
concept_accession('6710: rn:R03478','KEGG','RC00078',true).
concept_accession('6710: rn:R03478','KEGG','EC:2.7.1.140',true).
concept_accession('6710: rn:R03478','KEGG','RP:RP03092',true).
concept_accession('6710: rn:R03478','KEGG','2.7.1.140',true).
concept_accession('6710: rn:R03478','KEGG','RP03092',true).
concept_accession('6710: rn:R03478','EC','2.7.1.140',false).
concept_accession('6710: rn:R03478','KEGG','RN:R03478',true).
concept_accession('41188: rn:R02869','EC','2.5.1.22',true).
concept_accession('41188: rn:R02869','KEGG','EC:2.5.1.22',true).
concept_accession('41188: rn:R02869','KEGG','683008',true).
concept_accession('41188: rn:R02869','KEGG','RNO:683008',true).
concept_accession('41188: rn:R02869','KEGG','2.5.1.22',true).
concept_accession('41191: rn:R03139','KEGG','1.4.3.21',true).
concept_accession('41191: rn:R03139','KEGG','RNO:29473',true).
concept_accession('41191: rn:R03139','KEGG','29473',true).
concept_accession('41191: rn:R03139','EC','1.4.3.21',true).
concept_accession('41191: rn:R03139','KEGG','EC:1.4.3.21',true).
concept_accession('41190: rn:R00904','EC','1.2.1.5',true).
concept_accession('41190: rn:R00904','KEGG','RNO:291450',true).
concept_accession('41190: rn:R00904','KEGG','RNO:64040',true).
concept_accession('41190: rn:R00904','KEGG','1.2.1.5',true).
concept_accession('41190: rn:R00904','KEGG','65183',true).
concept_accession('41190: rn:R00904','KEGG','24188',true).
concept_accession('41190: rn:R00904','KEGG','RNO:29539',true).
concept_accession('41190: rn:R00904','KEGG','64040',true).
concept_accession('41190: rn:R00904','KEGG','RNO:24188',true).
concept_accession('41190: rn:R00904','KEGG','29539',true).
concept_accession('41190: rn:R00904','KEGG','29651',true).
concept_accession('41190: rn:R00904','KEGG','298079',true).
concept_accession('41190: rn:R00904','KEGG','RNO:298079',true).
concept_accession('41190: rn:R00904','KEGG','RNO:65183',true).
concept_accession('41190: rn:R00904','KEGG','RNO:29651',true).
concept_accession('41190: rn:R00904','KEGG','EC:1.2.1.5',true).
concept_accession('41190: rn:R00904','KEGG','291450',true).
concept_accession('41185: rn:R00014','KEGG','RNO:117098',true).
concept_accession('41185: rn:R00014','EC','1.2.4.1',true).
concept_accession('41185: rn:R00014','KEGG','RNO:289950',true).
concept_accession('41185: rn:R00014','KEGG','1.2.4.1',true).
concept_accession('41185: rn:R00014','KEGG','117098',true).
concept_accession('41185: rn:R00014','KEGG','289950',true).
concept_accession('41185: rn:R00014','KEGG','29554',true).
concept_accession('41185: rn:R00014','KEGG','RNO:29554',true).
concept_accession('41185: rn:R00014','KEGG','EC:1.2.4.1',true).
concept_accession('41184: rn:R03534','KEGG','RNO:314196',true).
concept_accession('41184: rn:R03534','KEGG','EC:1.1.99.2',true).
concept_accession('41184: rn:R03534','KEGG','1.1.99.2',true).
concept_accession('41184: rn:R03534','EC','1.1.99.2',true).
concept_accession('41184: rn:R03534','KEGG','314196',true).
concept_accession('41187: rn:R02869','KEGG','84596',true).
concept_accession('41187: rn:R02869','EC','2.5.1.22',true).
concept_accession('41187: rn:R02869','KEGG','EC:2.5.1.22',true).
concept_accession('41187: rn:R02869','KEGG','RNO:84596',true).
concept_accession('41187: rn:R02869','KEGG','2.5.1.22',true).
concept_accession('41186: rn:R00924','KEGG','RNO:24158',true).
concept_accession('41186: rn:R00924','KEGG','24158',true).
concept_accession('41186: rn:R00924','KEGG','EC:1.3.99.3',true).
concept_accession('41186: rn:R00924','KEGG','1.3.99.3',true).
concept_accession('41186: rn:R00924','EC','1.3.99.3',true).
concept_accession('41197: rn:R00908','EC','2.6.1.19',true).
concept_accession('41197: rn:R00908','KEGG','EC:2.6.1.19',true).
concept_accession('41197: rn:R00908','KEGG','2.6.1.19',true).
concept_accession('41197: rn:R00908','KEGG','RNO:81632',true).
concept_accession('41197: rn:R00908','KEGG','81632',true).
concept_accession('41196: rn:R00713','KEGG','1.2.1.24',true).
concept_accession('41196: rn:R00713','KEGG','RNO:291133',true).
concept_accession('41196: rn:R00713','KEGG','EC:1.2.1.24',true).
concept_accession('41196: rn:R00713','EC','1.2.1.24',true).
concept_accession('41196: rn:R00713','KEGG','291133',true).
concept_accession('41199: rn:R05959','EC','2.4.99.-',true).
concept_accession('41199: rn:R05959','KEGG','EC:2.4.99.-',true).
concept_accession('41199: rn:R05959','KEGG','2.4.99.-',true).
concept_accession('41199: rn:R05959','KEGG','RNO:365984',true).
concept_accession('41199: rn:R05959','KEGG','365984',true).
concept_accession('41198: rn:R01176','KEGG','24763',true).
concept_accession('41198: rn:R01176','KEGG','246263',true).
concept_accession('41198: rn:R01176','KEGG','RNO:24763',true).
concept_accession('41198: rn:R01176','KEGG','RNO:353317',true).
concept_accession('41198: rn:R01176','KEGG','EC:6.2.1.2',true).
concept_accession('41198: rn:R01176','KEGG','353317',true).
concept_accession('41198: rn:R01176','KEGG','RNO:246263',true).
concept_accession('41198: rn:R01176','KEGG','RNO:361637',true).
concept_accession('41198: rn:R01176','KEGG','361637',true).
concept_accession('41198: rn:R01176','EC','6.2.1.2',true).
concept_accession('41198: rn:R01176','KEGG','6.2.1.2',true).
concept_accession('41193: rn:R00233','KEGG','85239',true).
concept_accession('41193: rn:R00233','KEGG','4.1.1.9',true).
concept_accession('41193: rn:R00233','KEGG','EC:4.1.1.9',true).
concept_accession('41193: rn:R00233','KEGG','RNO:85239',true).
concept_accession('41193: rn:R00233','EC','4.1.1.9',true).
concept_accession('41192: rn:R01171','KEGG','64304',true).
concept_accession('41192: rn:R01171','EC','1.3.1.44',true).
concept_accession('41192: rn:R01171','KEGG','1.3.1.44',true).
concept_accession('41192: rn:R01171','KEGG','EC:1.3.1.44',true).
concept_accession('41192: rn:R01171','KEGG','RNO:64304',true).
concept_accession('41195: rn:R03045','KEGG','RNO:170670',true).
concept_accession('41195: rn:R03045','KEGG','171142',true).
concept_accession('41195: rn:R03045','KEGG','RNO:171142',true).
concept_accession('41195: rn:R03045','EC','4.2.1.17',true).
concept_accession('41195: rn:R03045','KEGG','170670',true).
concept_accession('41195: rn:R03045','KEGG','RNO:140547',true).
concept_accession('41195: rn:R03045','KEGG','140547',true).
concept_accession('41195: rn:R03045','KEGG','4.2.1.17',true).
concept_accession('41195: rn:R03045','KEGG','EC:4.2.1.17',true).
concept_accession('41194: rn:R03158','KEGG','RNO:301384',true).
concept_accession('41194: rn:R03158','KEGG','3.1.2.4',true).
concept_accession('41194: rn:R03158','KEGG','EC:3.1.2.4',true).
concept_accession('41194: rn:R03158','EC','3.1.2.4',true).
concept_accession('41194: rn:R03158','KEGG','301384',true).
concept_accession('41204: rn:R00689','KEGG','EC:1.4.3.2',true).
concept_accession('41204: rn:R00689','EC','1.4.3.2',true).
concept_accession('41204: rn:R00689','KEGG','298483',true).
concept_accession('41204: rn:R00689','KEGG','RNO:100360621',true).
concept_accession('41204: rn:R00689','KEGG','1.4.3.2',true).
concept_accession('41204: rn:R00689','KEGG','RNO:298483',true).
concept_accession('41204: rn:R00689','KEGG','100360621',true).
concept_accession('2839: rn:R08567','KEGG','RN:R08567',true).
concept_accession('2839: rn:R08567','KEGG','R08567',true).
concept_accession('2839: rn:R08567','KEGG','1.2.7.7',true).
concept_accession('2839: rn:R08567','EC','1.2.7.7',false).
concept_accession('2839: rn:R08567','KEGG','EC:1.2.7.7',true).
concept_accession('41205: rn:R05937','KEGG','EC:2.4.99.9',true).
concept_accession('41205: rn:R05937','KEGG','RNO:83505',true).
concept_accession('41205: rn:R05937','KEGG','83505',true).
concept_accession('41205: rn:R05937','EC','2.4.99.9',true).
concept_accession('41205: rn:R05937','KEGG','2.4.99.9',true).
concept_accession('2838: rn:R07160','KEGG','RN:R07160',true).
concept_accession('2838: rn:R07160','KEGG','R07160',true).
concept_accession('2838: rn:R07160','KEGG','1.2.7.7',true).
concept_accession('2838: rn:R07160','EC','1.2.7.7',false).
concept_accession('2838: rn:R07160','KEGG','EC:1.2.7.7',true).
concept_accession('41206: rn:R03270','KEGG','RNO:117098',true).
concept_accession('41206: rn:R03270','EC','1.2.4.1',true).
concept_accession('41206: rn:R03270','KEGG','RNO:289950',true).
concept_accession('41206: rn:R03270','KEGG','1.2.4.1',true).
concept_accession('41206: rn:R03270','KEGG','117098',true).
concept_accession('41206: rn:R03270','KEGG','289950',true).
concept_accession('41206: rn:R03270','KEGG','29554',true).
concept_accession('41206: rn:R03270','KEGG','RNO:29554',true).
concept_accession('41206: rn:R03270','KEGG','EC:1.2.4.1',true).
concept_accession('2837: rn:R08566','KEGG','R08566',true).
concept_accession('2837: rn:R08566','KEGG','RN:R08566',true).
concept_accession('2837: rn:R08566','KEGG','1.2.7.7',true).
concept_accession('2837: rn:R08566','EC','1.2.7.7',false).
concept_accession('2837: rn:R08566','KEGG','EC:1.2.7.7',true).
concept_accession('41207: rn:R05947','KEGG','RNO:364901',true).
concept_accession('41207: rn:R05947','KEGG','EC:2.4.99.8',true).
concept_accession('41207: rn:R05947','KEGG','364901',true).
concept_accession('41207: rn:R05947','KEGG','25280',true).
concept_accession('41207: rn:R05947','EC','2.4.99.8',true).
concept_accession('41207: rn:R05947','KEGG','RNO:25280',true).
concept_accession('41207: rn:R05947','KEGG','2.4.99.8',true).
concept_accession('41200: rn:R01378','KEGG','RNO:81683',true).
concept_accession('41200: rn:R01378','KEGG','81683',true).
concept_accession('41200: rn:R01378','KEGG','EC:5.3.2.1',true).
concept_accession('41200: rn:R01378','KEGG','5.3.2.1',true).
concept_accession('41200: rn:R01378','EC','5.3.2.1',true).
concept_accession('41201: rn:R00694','EC','2.6.1.9',true).
concept_accession('41201: rn:R00694','KEGG','RNO:24813',true).
concept_accession('41201: rn:R00694','KEGG','EC:2.6.1.9',true).
concept_accession('41201: rn:R00694','KEGG','2.6.1.9',true).
concept_accession('41201: rn:R00694','KEGG','24813',true).
concept_accession('41202: rn:R00694','EC','2.6.1.9',true).
concept_accession('41202: rn:R00694','KEGG','25721',true).
concept_accession('41202: rn:R00694','KEGG','RNO:25721',true).
concept_accession('41202: rn:R00694','KEGG','EC:2.6.1.9',true).
concept_accession('41202: rn:R00694','KEGG','24401',true).
concept_accession('41202: rn:R00694','KEGG','2.6.1.9',true).
concept_accession('41202: rn:R00694','KEGG','RNO:24401',true).
concept_accession('41203: rn:R00698','EC','1.11.1.7',true).
concept_accession('41203: rn:R00698','KEGG','EC:1.11.1.7',true).
concept_accession('41203: rn:R00698','KEGG','94167',true).
concept_accession('41203: rn:R00698','KEGG','1.11.1.7',true).
concept_accession('41203: rn:R00698','KEGG','RNO:94167',true).
concept_accession('41212: rn:R02613','KEGG','29253',true).
concept_accession('41212: rn:R02613','KEGG','1.4.3.21',true).
concept_accession('41212: rn:R02613','KEGG','RNO:29253',true).
concept_accession('41212: rn:R02613','EC','1.4.3.21',true).
concept_accession('41212: rn:R02613','KEGG','25750',true).
concept_accession('41212: rn:R02613','KEGG','RNO:25750',true).
concept_accession('41212: rn:R02613','KEGG','EC:1.4.3.21',true).
concept_accession('41213: rn:R02613','KEGG','1.4.3.21',true).
concept_accession('41213: rn:R02613','KEGG','RNO:29473',true).
concept_accession('41213: rn:R02613','KEGG','29473',true).
concept_accession('41213: rn:R02613','EC','1.4.3.21',true).
concept_accession('41213: rn:R02613','KEGG','EC:1.4.3.21',true).
concept_accession('41214: rn:R00699','KEGG','EC:4.1.1.53',true).
concept_accession('41214: rn:R00699','KEGG','4.1.1.53',true).
concept_accession('41214: rn:R00699','KEGG','RNO:24311',true).
concept_accession('41214: rn:R00699','KEGG','24311',true).
concept_accession('41214: rn:R00699','EC','4.1.1.53',true).
concept_accession('41215: rn:R02530','KEGG','EC:4.4.1.5',true).
concept_accession('41215: rn:R02530','EC','4.4.1.5',true).
concept_accession('41215: rn:R02530','KEGG','294320',true).
concept_accession('41215: rn:R02530','KEGG','4.4.1.5',true).
concept_accession('41215: rn:R02530','KEGG','RNO:294320',true).
concept_accession('41208: rn:R05940','KEGG','EC:2.4.99.8',true).
concept_accession('41208: rn:R05940','KEGG','25280',true).
concept_accession('41208: rn:R05940','EC','2.4.99.8',true).
concept_accession('41208: rn:R05940','KEGG','RNO:25280',true).
concept_accession('41208: rn:R05940','KEGG','2.4.99.8',true).
concept_accession('41209: rn:R02536 rn:R02537','KEGG','RNO:25375',true).
concept_accession('41209: rn:R02536 rn:R02537','KEGG','25375',true).
concept_accession('41209: rn:R02536 rn:R02537','KEGG','RNO:266603',true).
concept_accession('41209: rn:R02536 rn:R02537','KEGG','266603',true).
concept_accession('41209: rn:R02536 rn:R02537','KEGG','RNO:309147',true).
concept_accession('41209: rn:R02536 rn:R02537','KEGG','309147',true).
concept_accession('41209: rn:R02536 rn:R02537','KEGG','EC:1.2.1.5',true).
concept_accession('41209: rn:R02536 rn:R02537','EC','1.2.1.5',true).
concept_accession('41209: rn:R02536 rn:R02537','KEGG','1.2.1.5',true).
concept_accession('41210: rn:R00431 rn:R00726','EC','4.1.1.32',true).
concept_accession('41210: rn:R00431 rn:R00726','KEGG','RNO:361042',true).
concept_accession('41210: rn:R00431 rn:R00726','KEGG','RNO:362282',true).
concept_accession('41210: rn:R00431 rn:R00726','KEGG','361042',true).
concept_accession('41210: rn:R00431 rn:R00726','KEGG','362282',true).
concept_accession('41210: rn:R00431 rn:R00726','KEGG','EC:4.1.1.32',true).
concept_accession('41210: rn:R00431 rn:R00726','KEGG','4.1.1.32',true).
concept_accession('41211: rn:R01372','KEGG','1.13.11.27',true).
concept_accession('41211: rn:R01372','KEGG','RNO:29531',true).
concept_accession('41211: rn:R01372','EC','1.13.11.27',true).
concept_accession('41211: rn:R01372','KEGG','29531',true).
concept_accession('41211: rn:R01372','KEGG','EC:1.13.11.27',true).
concept_accession('41091: rn:R07888','KEGG','1.3.3.6',true).
concept_accession('41091: rn:R07888','KEGG','EC:1.3.3.6',true).
concept_accession('41091: rn:R07888','EC','1.3.3.6',true).
concept_accession('41091: rn:R07888','KEGG','RNO:50681',true).
concept_accession('41091: rn:R07888','KEGG','50681',true).
concept_accession('41091: rn:R07888','KEGG','83522',true).
concept_accession('41091: rn:R07888','KEGG','RNO:83522',true).
concept_accession('41090: rn:R01529','EC','5.1.3.1',true).
concept_accession('41090: rn:R01529','KEGG','5.1.3.1',true).
concept_accession('41090: rn:R01529','KEGG','EC:5.1.3.1',true).
concept_accession('41090: rn:R01529','KEGG','RNO:501157',true).
concept_accession('41090: rn:R01529','KEGG','501157',true).
concept_accession('41089: rn:R01639','KEGG','EC:2.7.1.17',true).
concept_accession('41089: rn:R01639','KEGG','316067',true).
concept_accession('41089: rn:R01639','EC','2.7.1.17',true).
concept_accession('41089: rn:R01639','KEGG','2.7.1.17',true).
concept_accession('41089: rn:R01639','KEGG','RNO:316067',true).
concept_accession('41088: rn:R07055','EC','1.14.14.1',true).
concept_accession('41088: rn:R07055','KEGG','65210',true).
concept_accession('41088: rn:R07055','KEGG','25086',true).
concept_accession('41088: rn:R07055','KEGG','246070',true).
concept_accession('41088: rn:R07055','KEGG','100364896',true).
concept_accession('41088: rn:R07055','KEGG','RNO:171352',true).
concept_accession('41088: rn:R07055','KEGG','252931',true).
concept_accession('41088: rn:R07055','KEGG','171521',true).
concept_accession('41088: rn:R07055','KEGG','RNO:293989',true).
concept_accession('41088: rn:R07055','KEGG','293989',true).
concept_accession('41088: rn:R07055','KEGG','RNO:83790',true).
concept_accession('41088: rn:R07055','KEGG','EC:1.14.14.1',true).
concept_accession('41088: rn:R07055','KEGG','687842',true).
concept_accession('41088: rn:R07055','KEGG','RNO:29277',true).
concept_accession('41088: rn:R07055','KEGG','RNO:25642',true).
concept_accession('41088: rn:R07055','KEGG','24297',true).
concept_accession('41088: rn:R07055','KEGG','171352',true).
concept_accession('41088: rn:R07055','KEGG','313375',true).
concept_accession('41088: rn:R07055','KEGG','266682',true).
concept_accession('41088: rn:R07055','KEGG','171518',true).
concept_accession('41088: rn:R07055','KEGG','RNO:100364896',true).
concept_accession('41088: rn:R07055','KEGG','RNO:313375',true).
concept_accession('41088: rn:R07055','KEGG','29277',true).
concept_accession('41088: rn:R07055','KEGG','RNO:29298',true).
concept_accession('41088: rn:R07055','KEGG','RNO:266682',true).
concept_accession('41088: rn:R07055','KEGG','29298',true).
concept_accession('41088: rn:R07055','KEGG','RNO:246070',true).
concept_accession('41088: rn:R07055','KEGG','RNO:687842',true).
concept_accession('41088: rn:R07055','KEGG','RNO:25086',true).
concept_accession('41088: rn:R07055','KEGG','RNO:65210',true).
concept_accession('41088: rn:R07055','KEGG','1.14.14.1',true).
concept_accession('41088: rn:R07055','KEGG','25642',true).
concept_accession('41088: rn:R07055','KEGG','RNO:502969',true).
concept_accession('41088: rn:R07055','KEGG','RNO:171518',true).
concept_accession('41088: rn:R07055','KEGG','RNO:171521',true).
concept_accession('41088: rn:R07055','KEGG','25011',true).
concept_accession('41088: rn:R07055','KEGG','RNO:25011',true).
concept_accession('41088: rn:R07055','KEGG','RNO:24297',true).
concept_accession('41088: rn:R07055','KEGG','83790',true).
concept_accession('41088: rn:R07055','KEGG','502969',true).
concept_accession('41088: rn:R07055','KEGG','RNO:252931',true).
concept_accession('41095: rn:R07861','KEGG','1.14.19.-',true).
concept_accession('41095: rn:R07861','KEGG','83512',true).
concept_accession('41095: rn:R07861','EC','1.14.19.-',true).
concept_accession('41095: rn:R07861','KEGG','RNO:83512',true).
concept_accession('41095: rn:R07861','KEGG','EC:1.14.19.-',true).
concept_accession('41094: rn:R01431','KEGG','24192',true).
concept_accession('41094: rn:R01431','KEGG','RNO:24192',true).
concept_accession('41094: rn:R01431','KEGG','1.1.1.21',true).
concept_accession('41094: rn:R01431','EC','1.1.1.21',true).
concept_accession('41094: rn:R01431','KEGG','EC:1.1.1.21',true).
concept_accession('41093: rn:R01758 rn:R01759','KEGG','24192',true).
concept_accession('41093: rn:R01758 rn:R01759','KEGG','RNO:24192',true).
concept_accession('41093: rn:R01758 rn:R01759','KEGG','1.1.1.21',true).
concept_accession('41093: rn:R01758 rn:R01759','EC','1.1.1.21',true).
concept_accession('41093: rn:R01758 rn:R01759','KEGG','EC:1.1.1.21',true).
concept_accession('41092: rn:R01904','KEGG','RNO:171408',true).
concept_accession('41092: rn:R01904','KEGG','1.1.1.10',true).
concept_accession('41092: rn:R01904','KEGG','171408',true).
concept_accession('41092: rn:R01904','KEGG','EC:1.1.1.10',true).
concept_accession('41092: rn:R01904','EC','1.1.1.10',true).
concept_accession('41099: rn:R07859','KEGG','298579',true).
concept_accession('41099: rn:R07859','KEGG','RNO:192259',true).
concept_accession('41099: rn:R07859','KEGG','296091',true).
concept_accession('41099: rn:R07859','KEGG','RNO:311341',true).
concept_accession('41099: rn:R07859','KEGG','RNO:29359',true).
concept_accession('41099: rn:R07859','KEGG','RNO:289733',true).
concept_accession('41099: rn:R07859','KEGG','29526',true).
concept_accession('41099: rn:R07859','KEGG','29387',true).
concept_accession('41099: rn:R07859','KEGG','362039',true).
concept_accession('41099: rn:R07859','KEGG','EC:3.1.1.4',true).
concept_accession('41099: rn:R07859','KEGG','RNO:29387',true).
concept_accession('41099: rn:R07859','KEGG','691907',true).
concept_accession('41099: rn:R07859','KEGG','RNO:298579',true).
concept_accession('41099: rn:R07859','KEGG','311341',true).
concept_accession('41099: rn:R07859','KEGG','RNO:690388',true).
concept_accession('41099: rn:R07859','KEGG','289733',true).
concept_accession('41099: rn:R07859','KEGG','RNO:362039',true).
concept_accession('41099: rn:R07859','KEGG','RNO:29692',true).
concept_accession('41099: rn:R07859','KEGG','24653',true).
concept_accession('41099: rn:R07859','KEGG','RNO:29526',true).
concept_accession('41099: rn:R07859','EC','3.1.1.4',true).
concept_accession('41099: rn:R07859','KEGG','RNO:24653',true).
concept_accession('41099: rn:R07859','KEGG','192259',true).
concept_accession('41099: rn:R07859','KEGG','3.1.1.4',true).
concept_accession('41099: rn:R07859','KEGG','690388',true).
concept_accession('41099: rn:R07859','KEGG','RNO:691907',true).
concept_accession('41099: rn:R07859','KEGG','RNO:296091',true).
concept_accession('41099: rn:R07859','KEGG','29359',true).
concept_accession('41099: rn:R07859','KEGG','367415',true).
concept_accession('41099: rn:R07859','KEGG','29354',true).
concept_accession('41099: rn:R07859','KEGG','RNO:367415',true).
concept_accession('41099: rn:R07859','KEGG','RNO:360426',true).
concept_accession('41099: rn:R07859','KEGG','29692',true).
concept_accession('41099: rn:R07859','KEGG','360426',true).
concept_accession('41099: rn:R07859','KEGG','RNO:29354',true).
concept_accession('41098: rn:R01383','KEGG','396551',true).
concept_accession('41098: rn:R01383','KEGG','2.4.1.17',true).
concept_accession('41098: rn:R01383','KEGG','154516',true).
concept_accession('41098: rn:R01383','KEGG','396552',true).
concept_accession('41098: rn:R01383','KEGG','RNO:305264',true).
concept_accession('41098: rn:R01383','KEGG','289533',true).
concept_accession('41098: rn:R01383','KEGG','RNO:396527',true).
concept_accession('41098: rn:R01383','KEGG','574523',true).
concept_accession('41098: rn:R01383','KEGG','396527',true).
concept_accession('41098: rn:R01383','KEGG','EC:2.4.1.17',true).
concept_accession('41098: rn:R01383','KEGG','113992',true).
concept_accession('41098: rn:R01383','KEGG','RNO:574523',true).
concept_accession('41098: rn:R01383','KEGG','RNO:266685',true).
concept_accession('41098: rn:R01383','KEGG','RNO:24861',true).
concept_accession('41098: rn:R01383','KEGG','266685',true).
concept_accession('41098: rn:R01383','KEGG','RNO:24862',true).
concept_accession('41098: rn:R01383','KEGG','29623',true).
concept_accession('41098: rn:R01383','KEGG','RNO:289533',true).
concept_accession('41098: rn:R01383','KEGG','305264',true).
concept_accession('41098: rn:R01383','KEGG','RNO:83808',true).
concept_accession('41098: rn:R01383','KEGG','RNO:301595',true).
concept_accession('41098: rn:R01383','KEGG','RNO:29623',true).
concept_accession('41098: rn:R01383','KEGG','RNO:154516',true).
concept_accession('41098: rn:R01383','KEGG','301595',true).
concept_accession('41098: rn:R01383','KEGG','RNO:396552',true).
concept_accession('41098: rn:R01383','KEGG','RNO:396551',true).
concept_accession('41098: rn:R01383','KEGG','RNO:286954',true).
concept_accession('41098: rn:R01383','KEGG','RNO:113992',true).
concept_accession('41098: rn:R01383','KEGG','RNO:63867',true).
concept_accession('41098: rn:R01383','KEGG','286954',true).
concept_accession('41098: rn:R01383','KEGG','83808',true).
concept_accession('41098: rn:R01383','KEGG','24861',true).
concept_accession('41098: rn:R01383','KEGG','63867',true).
concept_accession('41098: rn:R01383','EC','2.4.1.17',true).
concept_accession('41098: rn:R01383','KEGG','24862',true).
concept_accession('41097: rn:R02640','KEGG','1.1.1.45',true).
concept_accession('41097: rn:R02640','KEGG','EC:1.1.1.45',true).
concept_accession('41097: rn:R02640','KEGG','RNO:290277',true).
concept_accession('41097: rn:R02640','EC','1.1.1.45',true).
concept_accession('41097: rn:R02640','KEGG','290277',true).
concept_accession('41096: rn:R00289','KEGG','289827',true).
concept_accession('41096: rn:R00289','KEGG','EC:2.7.7.9',true).
concept_accession('41096: rn:R00289','KEGG','2.7.7.9',true).
concept_accession('41096: rn:R00289','KEGG','RNO:289827',true).
concept_accession('41096: rn:R00289','EC','2.7.7.9',true).
concept_accession('41103: rn:R00115','KEGG','116686',true).
concept_accession('41103: rn:R00115','KEGG','EC:1.8.1.7',true).
concept_accession('41103: rn:R00115','EC','1.8.1.7',true).
concept_accession('41103: rn:R00115','KEGG','1.8.1.7',true).
concept_accession('41103: rn:R00115','KEGG','RNO:116686',true).
concept_accession('41102: rn:R01528','KEGG','1.1.1.44',true).
concept_accession('41102: rn:R01528','KEGG','RNO:100360180',true).
concept_accession('41102: rn:R01528','KEGG','100360180',true).
concept_accession('41102: rn:R01528','EC','1.1.1.44',true).
concept_accession('41102: rn:R01528','KEGG','EC:1.1.1.44',true).
concept_accession('2925: rn:R07399','EC','2.3.1.182',false).
concept_accession('2925: rn:R07399','KEGG','RC01205',true).
concept_accession('2925: rn:R07399','KEGG','RP:RP10723',true).
concept_accession('2925: rn:R07399','KEGG','RC:RC01205',true).
concept_accession('2925: rn:R07399','KEGG','EC:2.3.1.182',true).
concept_accession('2925: rn:R07399','KEGG','RP10723',true).
concept_accession('2925: rn:R07399','KEGG','2.3.1.182',true).
concept_accession('2925: rn:R07399','KEGG','R07399',true).
concept_accession('2925: rn:R07399','KEGG','RN:R07399',true).
concept_accession('41101: rn:R00670','KEGG','RNO:24609',true).
concept_accession('41101: rn:R00670','KEGG','EC:4.1.1.17',true).
concept_accession('41101: rn:R00670','KEGG','24609',true).
concept_accession('41101: rn:R00670','KEGG','4.1.1.17',true).
concept_accession('41101: rn:R00670','EC','4.1.1.17',true).
concept_accession('41100: rn:R00286','KEGG','RNO:83472',true).
concept_accession('41100: rn:R00286','KEGG','83472',true).
concept_accession('41100: rn:R00286','EC','1.1.1.22',true).
concept_accession('41100: rn:R00286','KEGG','1.1.1.22',true).
concept_accession('41100: rn:R00286','KEGG','EC:1.1.1.22',true).
concept_accession('41106: rn:R03522','KEGG','289197',true).
concept_accession('41106: rn:R03522','KEGG','494500',true).
concept_accession('41106: rn:R03522','KEGG','RNO:681913',true).
concept_accession('41106: rn:R03522','KEGG','363205',true).
concept_accession('41106: rn:R03522','KEGG','EC:2.5.1.18',true).
concept_accession('41106: rn:R03522','KEGG','RNO:494500',true).
concept_accession('41106: rn:R03522','KEGG','29487',true).
concept_accession('41106: rn:R03522','EC','2.5.1.18',true).
concept_accession('41106: rn:R03522','KEGG','309465',true).
concept_accession('41106: rn:R03522','KEGG','RNO:57298',true).
concept_accession('41106: rn:R03522','KEGG','RNO:171341',true).
concept_accession('41106: rn:R03522','KEGG','RNO:24423',true).
concept_accession('41106: rn:R03522','KEGG','681913',true).
concept_accession('41106: rn:R03522','KEGG','300850',true).
concept_accession('41106: rn:R03522','KEGG','RNO:24424',true).
concept_accession('41106: rn:R03522','KEGG','RNO:24421',true).
concept_accession('41106: rn:R03522','KEGG','RNO:24422',true).
concept_accession('41106: rn:R03522','KEGG','RNO:81869',true).
concept_accession('41106: rn:R03522','KEGG','295037',true).
concept_accession('41106: rn:R03522','KEGG','RNO:24426',true).
concept_accession('41106: rn:R03522','KEGG','494499',true).
concept_accession('41106: rn:R03522','KEGG','RNO:289197',true).
concept_accession('41106: rn:R03522','KEGG','25260',true).
concept_accession('41106: rn:R03522','KEGG','114846',true).
concept_accession('41106: rn:R03522','KEGG','81869',true).
concept_accession('41106: rn:R03522','KEGG','501110',true).
concept_accession('41106: rn:R03522','KEGG','64352',true).
concept_accession('41106: rn:R03522','KEGG','24426',true).
concept_accession('41106: rn:R03522','KEGG','RNO:300850',true).
concept_accession('41106: rn:R03522','KEGG','24421',true).
concept_accession('41106: rn:R03522','KEGG','RNO:499688',true).
concept_accession('41106: rn:R03522','KEGG','2.5.1.18',true).
concept_accession('41106: rn:R03522','KEGG','24423',true).
concept_accession('41106: rn:R03522','KEGG','RNO:499689',true).
concept_accession('41106: rn:R03522','KEGG','24422',true).
concept_accession('41106: rn:R03522','KEGG','24424',true).
concept_accession('41106: rn:R03522','KEGG','499689',true).
concept_accession('41106: rn:R03522','KEGG','RNO:29487',true).
concept_accession('41106: rn:R03522','KEGG','499688',true).
concept_accession('41106: rn:R03522','KEGG','RNO:494499',true).
concept_accession('41106: rn:R03522','KEGG','RNO:114846',true).
concept_accession('41106: rn:R03522','KEGG','RNO:501110',true).
concept_accession('41106: rn:R03522','KEGG','57298',true).
concept_accession('41106: rn:R03522','KEGG','RNO:309465',true).
concept_accession('41106: rn:R03522','KEGG','RNO:297029',true).
concept_accession('41106: rn:R03522','KEGG','171341',true).
concept_accession('41106: rn:R03522','KEGG','RNO:25260',true).
concept_accession('41106: rn:R03522','KEGG','RNO:295037',true).
concept_accession('41106: rn:R03522','KEGG','RNO:363205',true).
concept_accession('41106: rn:R03522','KEGG','RNO:64352',true).
concept_accession('41106: rn:R03522','KEGG','297029',true).
concept_accession('41107: rn:R07896','KEGG','1.3.3.6',true).
concept_accession('41107: rn:R07896','KEGG','EC:1.3.3.6',true).
concept_accession('41107: rn:R07896','EC','1.3.3.6',true).
concept_accession('41107: rn:R07896','KEGG','RNO:50681',true).
concept_accession('41107: rn:R07896','KEGG','50681',true).
concept_accession('41107: rn:R07896','KEGG','83522',true).
concept_accession('41107: rn:R07896','KEGG','RNO:83522',true).
concept_accession('2928: rn:R00996','KEGG','EC:4.3.1.19',true).
concept_accession('2928: rn:R00996','KEGG','RN:R00996',true).
concept_accession('2928: rn:R00996','KEGG','4.3.1.19',true).
concept_accession('2928: rn:R00996','KEGG','R00996',true).
concept_accession('2928: rn:R00996','KEGG','RP01226',true).
concept_accession('2928: rn:R00996','EC','4.3.1.19',false).
concept_accession('2928: rn:R00996','KEGG','RC00418',true).
concept_accession('2928: rn:R00996','KEGG','RP:RP01226',true).
concept_accession('2928: rn:R00996','KEGG','RC:RC00418',true).
concept_accession('41104: rn:R06518','KEGG','499210',true).
concept_accession('41104: rn:R06518','EC','3.5.1.23',true).
concept_accession('41104: rn:R06518','KEGG','RNO:499210',true).
concept_accession('41104: rn:R06518','KEGG','EC:3.5.1.23',true).
concept_accession('41104: rn:R06518','KEGG','3.5.1.23',true).
concept_accession('41105: rn:R07892','KEGG','1.3.3.6',true).
concept_accession('41105: rn:R07892','KEGG','EC:1.3.3.6',true).
concept_accession('41105: rn:R07892','EC','1.3.3.6',true).
concept_accession('41105: rn:R07892','KEGG','RNO:50681',true).
concept_accession('41105: rn:R07892','KEGG','50681',true).
concept_accession('41105: rn:R07892','KEGG','83522',true).
concept_accession('41105: rn:R07892','KEGG','RNO:83522',true).
concept_accession('41110: rn:R03167','KEGG','RNO:29328',true).
concept_accession('41110: rn:R03167','EC','1.11.1.12',true).
concept_accession('41110: rn:R03167','KEGG','EC:1.11.1.12',true).
concept_accession('41110: rn:R03167','KEGG','29328',true).
concept_accession('41110: rn:R03167','KEGG','1.11.1.12',true).
concept_accession('41111: rn:R04951','KEGG','EC:3.4.11.2',true).
concept_accession('41111: rn:R04951','EC','3.4.11.2',true).
concept_accession('41111: rn:R04951','KEGG','3.4.11.2',true).
concept_accession('41111: rn:R04951','KEGG','81641',true).
concept_accession('41111: rn:R04951','KEGG','RNO:81641',true).
concept_accession('6724: rn:R03332','KEGG','RP02951',true).
concept_accession('6724: rn:R03332','KEGG','R03332',true).
concept_accession('6724: rn:R03332','KEGG','4.6.1.13',true).
concept_accession('6724: rn:R03332','KEGG','RP:RP02951',true).
concept_accession('6724: rn:R03332','KEGG','RC:RC00425',true).
concept_accession('6724: rn:R03332','KEGG','RC00425',true).
concept_accession('6724: rn:R03332','EC','4.6.1.13',false).
concept_accession('6724: rn:R03332','KEGG','EC:4.6.1.13',true).
concept_accession('6724: rn:R03332','KEGG','RN:R03332',true).
concept_accession('41108: rn:R03749','EC','2.3.2.4',true).
concept_accession('41108: rn:R03749','KEGG','362368',true).
concept_accession('41108: rn:R03749','KEGG','RNO:362368',true).
concept_accession('41108: rn:R03749','KEGG','2.3.2.4',true).
concept_accession('41108: rn:R03749','KEGG','EC:2.3.2.4',true).
concept_accession('41109: rn:R00274','KEGG','64317',true).
concept_accession('41109: rn:R00274','KEGG','298376',true).
concept_accession('41109: rn:R00274','KEGG','24404',true).
concept_accession('41109: rn:R00274','KEGG','RNO:29326',true).
concept_accession('41109: rn:R00274','KEGG','294744',true).
concept_accession('41109: rn:R00274','KEGG','1.11.1.9',true).
concept_accession('41109: rn:R00274','KEGG','RNO:113919',true).
concept_accession('41109: rn:R00274','KEGG','RNO:294744',true).
concept_accession('41109: rn:R00274','KEGG','EC:1.11.1.9',true).
concept_accession('41109: rn:R00274','KEGG','29326',true).
concept_accession('41109: rn:R00274','KEGG','113919',true).
concept_accession('41109: rn:R00274','KEGG','RNO:24404',true).
concept_accession('41109: rn:R00274','KEGG','259233',true).
concept_accession('41109: rn:R00274','KEGG','RNO:64317',true).
concept_accession('41109: rn:R00274','KEGG','RNO:298376',true).
concept_accession('41109: rn:R00274','KEGG','RNO:259233',true).
concept_accession('41109: rn:R00274','EC','1.11.1.9',true).
concept_accession('41114: rn:R03915 rn:R02824','KEGG','EC:1.8.4.2',true).
concept_accession('41114: rn:R03915 rn:R02824','EC','1.8.4.2',true).
concept_accession('41114: rn:R03915 rn:R02824','KEGG','RNO:298370',true).
concept_accession('41114: rn:R03915 rn:R02824','KEGG','298370',true).
concept_accession('41114: rn:R03915 rn:R02824','KEGG','1.8.4.2',true).
concept_accession('41115: rn:R00894','KEGG','6.3.2.2',true).
concept_accession('41115: rn:R00894','KEGG','29739',true).
concept_accession('41115: rn:R00894','KEGG','EC:6.3.2.2',true).
concept_accession('41115: rn:R00894','EC','6.3.2.2',true).
concept_accession('41115: rn:R00894','KEGG','RNO:29739',true).
concept_accession('41115: rn:R00894','KEGG','RNO:25283',true).
concept_accession('41115: rn:R00894','KEGG','25283',true).
concept_accession('41112: rn:R03916','KEGG','RNO:156275',true).
concept_accession('41112: rn:R03916','KEGG','156275',true).
concept_accession('41112: rn:R03916','KEGG','408206',true).
concept_accession('41112: rn:R03916','KEGG','RNO:29566',true).
concept_accession('41112: rn:R03916','KEGG','RNO:408206',true).
concept_accession('41112: rn:R03916','EC','2.3.2.2',true).
concept_accession('41112: rn:R03916','KEGG','2.3.2.2',true).
concept_accession('41112: rn:R03916','KEGG','RNO:116568',true).
concept_accession('41112: rn:R03916','KEGG','116568',true).
concept_accession('41112: rn:R03916','KEGG','29566',true).
concept_accession('41112: rn:R03916','KEGG','EC:2.3.2.2',true).
concept_accession('41113: rn:R02736','KEGG','RNO:24377',true).
concept_accession('41113: rn:R02736','KEGG','EC:1.1.1.49',true).
concept_accession('41113: rn:R02736','KEGG','1.1.1.49',true).
concept_accession('41113: rn:R02736','KEGG','24377',true).
concept_accession('41113: rn:R02736','EC','1.1.1.49',true).
concept_accession('41118: rn:R00497','KEGG','6.3.2.3',true).
concept_accession('41118: rn:R00497','EC','6.3.2.3',true).
concept_accession('41118: rn:R00497','KEGG','EC:6.3.2.3',true).
concept_accession('41118: rn:R00497','KEGG','25458',true).
concept_accession('41118: rn:R00497','KEGG','RNO:25458',true).
concept_accession('41119: rn:R02743','EC','2.3.2.4',true).
concept_accession('41119: rn:R02743','KEGG','362368',true).
concept_accession('41119: rn:R02743','KEGG','RNO:362368',true).
concept_accession('41119: rn:R02743','KEGG','2.3.2.4',true).
concept_accession('41119: rn:R02743','KEGG','EC:2.3.2.4',true).
concept_accession('6732: rn:R03332','KEGG','RP02951',true).
concept_accession('6732: rn:R03332','KEGG','R03332',true).
concept_accession('6732: rn:R03332','KEGG','4.6.1.13',true).
concept_accession('6732: rn:R03332','KEGG','RP:RP02951',true).
concept_accession('6732: rn:R03332','KEGG','RC:RC00425',true).
concept_accession('6732: rn:R03332','KEGG','RC00425',true).
concept_accession('6732: rn:R03332','EC','4.6.1.13',false).
concept_accession('6732: rn:R03332','KEGG','EC:4.6.1.13',true).
concept_accession('6732: rn:R03332','KEGG','RN:R03332',true).
concept_accession('41116: rn:R00494','KEGG','RNO:156275',true).
concept_accession('41116: rn:R00494','KEGG','156275',true).
concept_accession('41116: rn:R00494','KEGG','408206',true).
concept_accession('41116: rn:R00494','KEGG','RNO:29566',true).
concept_accession('41116: rn:R00494','KEGG','RNO:408206',true).
concept_accession('41116: rn:R00494','EC','2.3.2.2',true).
concept_accession('41116: rn:R00494','KEGG','2.3.2.2',true).
concept_accession('41116: rn:R00494','KEGG','RNO:116568',true).
concept_accession('41116: rn:R00494','KEGG','116568',true).
concept_accession('41116: rn:R00494','KEGG','29566',true).
concept_accession('41116: rn:R00494','KEGG','EC:2.3.2.2',true).
concept_accession('41117: rn:R00267','KEGG','361596',true).
concept_accession('41117: rn:R00267','KEGG','RNO:361596',true).
concept_accession('41117: rn:R00267','KEGG','24479',true).
concept_accession('41117: rn:R00267','KEGG','EC:1.1.1.42',true).
concept_accession('41117: rn:R00267','KEGG','1.1.1.42',true).
concept_accession('41117: rn:R00267','KEGG','RNO:24479',true).
concept_accession('41117: rn:R00267','EC','1.1.1.42',true).
concept_accession('41121: rn:R00899','KEGG','EC:3.4.11.2',true).
concept_accession('41121: rn:R00899','EC','3.4.11.2',true).
concept_accession('41121: rn:R00899','KEGG','3.4.11.2',true).
concept_accession('41121: rn:R00899','KEGG','81641',true).
concept_accession('41121: rn:R00899','KEGG','RNO:81641',true).
concept_accession('41120: rn:R01262','KEGG','RNO:156275',true).
concept_accession('41120: rn:R01262','KEGG','156275',true).
concept_accession('41120: rn:R01262','KEGG','408206',true).
concept_accession('41120: rn:R01262','KEGG','RNO:29566',true).
concept_accession('41120: rn:R01262','KEGG','RNO:408206',true).
concept_accession('41120: rn:R01262','EC','2.3.2.2',true).
concept_accession('41120: rn:R01262','KEGG','2.3.2.2',true).
concept_accession('41120: rn:R01262','KEGG','RNO:116568',true).
concept_accession('41120: rn:R01262','KEGG','116568',true).
concept_accession('41120: rn:R01262','KEGG','29566',true).
concept_accession('41120: rn:R01262','KEGG','EC:2.3.2.2',true).
concept_accession('41123: rn:R01000','KEGG','EC:1.1.1.27',true).
concept_accession('41123: rn:R01000','KEGG','RNO:369018',true).
concept_accession('41123: rn:R01000','EC','1.1.1.27',true).
concept_accession('41123: rn:R01000','KEGG','369018',true).
concept_accession('41123: rn:R01000','KEGG','RNO:24533',true).
concept_accession('41123: rn:R01000','KEGG','RNO:29634',true).
concept_accession('41123: rn:R01000','KEGG','RNO:24534',true).
concept_accession('41123: rn:R01000','KEGG','24534',true).
concept_accession('41123: rn:R01000','KEGG','24533',true).
concept_accession('41123: rn:R01000','KEGG','29634',true).
concept_accession('41123: rn:R01000','KEGG','RNO:500965',true).
concept_accession('41123: rn:R01000','KEGG','1.1.1.27',true).
concept_accession('41123: rn:R01000','KEGG','500965',true).
concept_accession('41122: rn:R00251','EC','3.5.2.9',true).
concept_accession('41122: rn:R00251','KEGG','3.5.2.9',true).
concept_accession('41122: rn:R00251','KEGG','EC:3.5.2.9',true).
concept_accession('41122: rn:R00251','KEGG','116684',true).
concept_accession('41122: rn:R00251','KEGG','RNO:116684',true).
concept_accession('41125: rn:R00742','KEGG','116719',true).
concept_accession('41125: rn:R00742','KEGG','RNO:116719',true).
concept_accession('41125: rn:R00742','KEGG','6.4.1.2',true).
concept_accession('41125: rn:R00742','EC','6.4.1.2',true).
concept_accession('41125: rn:R00742','KEGG','RNO:60581',true).
concept_accession('41125: rn:R00742','KEGG','60581',true).
concept_accession('41125: rn:R00742','KEGG','EC:6.4.1.2',true).
concept_accession('41124: rn:R00233','KEGG','85239',true).
concept_accession('41124: rn:R00233','KEGG','4.1.1.9',true).
concept_accession('41124: rn:R00233','KEGG','EC:4.1.1.9',true).
concept_accession('41124: rn:R00233','KEGG','RNO:85239',true).
concept_accession('41124: rn:R00233','EC','4.1.1.9',true).
concept_accession('41127: rn:R04432','KEGG','RNO:24158',true).
concept_accession('41127: rn:R04432','KEGG','24158',true).
concept_accession('41127: rn:R04432','KEGG','EC:1.3.99.3',true).
concept_accession('41127: rn:R04432','KEGG','1.3.99.3',true).
concept_accession('41127: rn:R04432','EC','1.3.99.3',true).
concept_accession('41126: rn:R00238','KEGG','2.3.1.9',true).
concept_accession('41126: rn:R00238','KEGG','EC:2.3.1.9',true).
concept_accession('41126: rn:R00238','EC','2.3.1.9',true).
concept_accession('41126: rn:R00238','KEGG','RNO:308100',true).
concept_accession('41126: rn:R00238','KEGG','RNO:25014',true).
concept_accession('41126: rn:R00238','KEGG','25014',true).
concept_accession('41126: rn:R00238','KEGG','308100',true).
concept_accession('41129: rn:R00432','EC','6.2.1.4',true).
concept_accession('41129: rn:R00432','KEGG','RNO:361071',true).
concept_accession('41129: rn:R00432','KEGG','361071',true).
concept_accession('41129: rn:R00432','KEGG','EC:6.2.1.4',true).
concept_accession('41129: rn:R00432','KEGG','6.2.1.4',true).
concept_accession('41129: rn:R00432','KEGG','114597',true).
concept_accession('41129: rn:R00432','KEGG','RNO:114597',true).
concept_accession('41129: rn:R00432','KEGG','362404',true).
concept_accession('41129: rn:R00432','KEGG','RNO:362404',true).
concept_accession('6778: rn:R05378','KEGG','RC:RC00603',true).
concept_accession('6778: rn:R05378','KEGG','4.1.2.29',true).
concept_accession('6778: rn:R05378','EC','4.1.2.29',false).
concept_accession('6778: rn:R05378','KEGG','RC00603',true).
concept_accession('6778: rn:R05378','KEGG','EC:4.1.2.29',true).
concept_accession('6778: rn:R05378','KEGG','RP:RP04985',true).
concept_accession('6778: rn:R05378','KEGG','RP:RP04984',true).
concept_accession('6778: rn:R05378','KEGG','RC:RC00721',true).
concept_accession('6778: rn:R05378','KEGG','RN:R05378',true).
concept_accession('6778: rn:R05378','KEGG','R05378',true).
concept_accession('6778: rn:R05378','KEGG','RP04985',true).
concept_accession('6778: rn:R05378','KEGG','RC00721',true).
concept_accession('6778: rn:R05378','KEGG','RP04984',true).
concept_accession('41128: rn:R00405','KEGG','RNO:361071',true).
concept_accession('41128: rn:R00405','KEGG','361071',true).
concept_accession('41128: rn:R00405','EC','6.2.1.5',true).
concept_accession('41128: rn:R00405','KEGG','EC:6.2.1.5',true).
concept_accession('41128: rn:R00405','KEGG','114597',true).
concept_accession('41128: rn:R00405','KEGG','6.2.1.5',true).
concept_accession('41128: rn:R00405','KEGG','RNO:114597',true).
concept_accession('41128: rn:R00405','KEGG','362404',true).
concept_accession('41128: rn:R00405','KEGG','RNO:362404',true).
concept_accession('41131: rn:R02940','KEGG','1.2.1.3',true).
concept_accession('41131: rn:R02940','KEGG','RNO:291450',true).
concept_accession('41131: rn:R02940','KEGG','RNO:64040',true).
concept_accession('41131: rn:R02940','EC','1.2.1.3',true).
concept_accession('41131: rn:R02940','KEGG','65183',true).
concept_accession('41131: rn:R02940','KEGG','24188',true).
concept_accession('41131: rn:R02940','KEGG','RNO:29539',true).
concept_accession('41131: rn:R02940','KEGG','64040',true).
concept_accession('41131: rn:R02940','KEGG','RNO:24188',true).
concept_accession('41131: rn:R02940','KEGG','29539',true).
concept_accession('41131: rn:R02940','KEGG','29651',true).
concept_accession('41131: rn:R02940','KEGG','298079',true).
concept_accession('41131: rn:R02940','KEGG','RNO:298079',true).
concept_accession('41131: rn:R02940','KEGG','RNO:65183',true).
concept_accession('41131: rn:R02940','KEGG','RNO:29651',true).
concept_accession('41131: rn:R02940','KEGG','291450',true).
concept_accession('41131: rn:R02940','KEGG','EC:1.2.1.3',true).
concept_accession('41130: rn:R00833','KEGG','RNO:100361295',true).
concept_accession('41130: rn:R00833','KEGG','100361295',true).
concept_accession('41130: rn:R00833','KEGG','EC:5.4.99.2',true).
concept_accession('41130: rn:R00833','KEGG','RNO:688517',true).
concept_accession('41130: rn:R00833','EC','5.4.99.2',true).
concept_accession('41130: rn:R00833','KEGG','688517',true).
concept_accession('41130: rn:R00833','KEGG','5.4.99.2',true).
concept_accession('41133: rn:R03157 rn:R03158','KEGG','RNO:301384',true).
concept_accession('41133: rn:R03157 rn:R03158','KEGG','3.1.2.4',true).
concept_accession('41133: rn:R03157 rn:R03158','KEGG','EC:3.1.2.4',true).
concept_accession('41133: rn:R03157 rn:R03158','EC','3.1.2.4',true).
concept_accession('41133: rn:R03157 rn:R03158','KEGG','301384',true).
concept_accession('41132: rn:R00908','EC','2.6.1.19',true).
concept_accession('41132: rn:R00908','KEGG','EC:2.6.1.19',true).
concept_accession('41132: rn:R00908','KEGG','2.6.1.19',true).
concept_accession('41132: rn:R00908','KEGG','RNO:81632',true).
concept_accession('41132: rn:R00908','KEGG','81632',true).
concept_accession('41135: rn:R00694','EC','2.6.1.9',true).
concept_accession('41135: rn:R00694','KEGG','RNO:24813',true).
concept_accession('41135: rn:R00694','KEGG','EC:2.6.1.9',true).
concept_accession('41135: rn:R00694','KEGG','2.6.1.9',true).
concept_accession('41135: rn:R00694','KEGG','24813',true).
concept_accession('41134: rn:R00689','KEGG','EC:1.4.3.2',true).
concept_accession('41134: rn:R00689','EC','1.4.3.2',true).
concept_accession('41134: rn:R00689','KEGG','298483',true).
concept_accession('41134: rn:R00689','KEGG','RNO:100360621',true).
concept_accession('41134: rn:R00689','KEGG','1.4.3.2',true).
concept_accession('41134: rn:R00689','KEGG','RNO:298483',true).
concept_accession('41134: rn:R00689','KEGG','100360621',true).
concept_accession('41136: rn:R01795','KEGG','24616',true).
concept_accession('41136: rn:R01795','KEGG','EC:1.14.16.1',true).
concept_accession('41136: rn:R01795','KEGG','1.14.16.1',true).
concept_accession('41136: rn:R01795','KEGG','RNO:24616',true).
concept_accession('41136: rn:R01795','EC','1.14.16.1',true).
concept_accession('41137: rn:R00729','KEGG','EC:1.4.3.2',true).
concept_accession('41137: rn:R00729','EC','1.4.3.2',true).
concept_accession('41137: rn:R00729','KEGG','298483',true).
concept_accession('41137: rn:R00729','KEGG','RNO:100360621',true).
concept_accession('41137: rn:R00729','KEGG','1.4.3.2',true).
concept_accession('41137: rn:R00729','KEGG','RNO:298483',true).
concept_accession('41137: rn:R00729','KEGG','100360621',true).
concept_accession('41138: rn:R03045','KEGG','RNO:170670',true).
concept_accession('41138: rn:R03045','KEGG','171142',true).
concept_accession('41138: rn:R03045','KEGG','RNO:171142',true).
concept_accession('41138: rn:R03045','EC','4.2.1.17',true).
concept_accession('41138: rn:R03045','KEGG','170670',true).
concept_accession('41138: rn:R03045','KEGG','RNO:140547',true).
concept_accession('41138: rn:R03045','KEGG','140547',true).
concept_accession('41138: rn:R03045','KEGG','4.2.1.17',true).
concept_accession('41138: rn:R03045','KEGG','EC:4.2.1.17',true).
concept_accession('41139: rn:R00734','KEGG','EC:2.6.1.5',true).
concept_accession('41139: rn:R00734','KEGG','RNO:24813',true).
concept_accession('41139: rn:R00734','EC','2.6.1.5',true).
concept_accession('41139: rn:R00734','KEGG','2.6.1.5',true).
concept_accession('41139: rn:R00734','KEGG','24813',true).
concept_accession('41140: rn:R00238','KEGG','2.3.1.9',true).
concept_accession('41140: rn:R00238','KEGG','EC:2.3.1.9',true).
concept_accession('41140: rn:R00238','EC','2.3.1.9',true).
concept_accession('41140: rn:R00238','KEGG','RNO:308100',true).
concept_accession('41140: rn:R00238','KEGG','RNO:25014',true).
concept_accession('41140: rn:R00238','KEGG','25014',true).
concept_accession('41140: rn:R00238','KEGG','308100',true).
concept_accession('41141: rn:R00935','KEGG','RNO:81708',true).
concept_accession('41141: rn:R00935','EC','1.2.1.27',true).
concept_accession('41141: rn:R00935','KEGG','EC:1.2.1.27',true).
concept_accession('41141: rn:R00935','KEGG','1.2.1.27',true).
concept_accession('41141: rn:R00935','KEGG','81708',true).
concept_accession('41142: rn:R01859','KEGG','6.4.1.3',true).
concept_accession('41142: rn:R01859','KEGG','24624',true).
concept_accession('41142: rn:R01859','KEGG','687008',true).
concept_accession('41142: rn:R01859','EC','6.4.1.3',true).
concept_accession('41142: rn:R01859','KEGG','RNO:24624',true).
concept_accession('41142: rn:R01859','KEGG','EC:6.4.1.3',true).
concept_accession('41142: rn:R01859','KEGG','RNO:687008',true).
concept_accession('41143: rn:R02765','KEGG','RNO:293829',true).
concept_accession('41143: rn:R02765','KEGG','5.1.99.1',true).
concept_accession('41143: rn:R02765','KEGG','EC:5.1.99.1',true).
concept_accession('41143: rn:R02765','EC','5.1.99.1',true).
concept_accession('41143: rn:R02765','KEGG','293829',true).
concept_accession('41144: rn:R00926','KEGG','RNO:314800',true).
concept_accession('41144: rn:R00926','KEGG','EC:6.2.1.1',true).
concept_accession('41144: rn:R00926','KEGG','314800',true).
concept_accession('41144: rn:R00926','EC','6.2.1.1',true).
concept_accession('41144: rn:R00926','KEGG','6.2.1.1',true).
concept_accession('41145: rn:R01354','KEGG','RNO:314800',true).
concept_accession('41145: rn:R01354','KEGG','314800',true).
concept_accession('41145: rn:R01354','EC','6.2.1.17',true).
concept_accession('41145: rn:R01354','KEGG','6.2.1.17',true).
concept_accession('41145: rn:R01354','KEGG','EC:6.2.1.17',true).
concept_accession('41146: rn:R01354','KEGG','311569',true).
concept_accession('41146: rn:R01354','KEGG','RNO:296259',true).
concept_accession('41146: rn:R01354','KEGG','296259',true).
concept_accession('41146: rn:R01354','EC','6.2.1.17',true).
concept_accession('41146: rn:R01354','KEGG','RNO:311569',true).
concept_accession('41146: rn:R01354','KEGG','6.2.1.17',true).
concept_accession('41146: rn:R01354','KEGG','EC:6.2.1.17',true).
concept_accession('41147: rn:R00926','KEGG','311569',true).
concept_accession('41147: rn:R00926','KEGG','RNO:296259',true).
concept_accession('41147: rn:R00926','KEGG','296259',true).
concept_accession('41147: rn:R00926','KEGG','EC:6.2.1.1',true).
concept_accession('41147: rn:R00926','KEGG','RNO:311569',true).
concept_accession('41147: rn:R00926','EC','6.2.1.1',true).
concept_accession('41147: rn:R00926','KEGG','6.2.1.1',true).
concept_accession('41148: rn:R02765','KEGG','RNO:293829',true).
concept_accession('41148: rn:R02765','KEGG','5.1.99.1',true).
concept_accession('41148: rn:R02765','KEGG','EC:5.1.99.1',true).
concept_accession('41148: rn:R02765','EC','5.1.99.1',true).
concept_accession('41148: rn:R02765','KEGG','293829',true).
concept_accession('6767: rn:R04504','KEGG','R04504',true).
concept_accession('6767: rn:R04504','KEGG','RC01938',true).
concept_accession('6767: rn:R04504','KEGG','RC:RC01938',true).
concept_accession('6767: rn:R04504','KEGG','RP11500',true).
concept_accession('6767: rn:R04504','KEGG','RP:RP11500',true).
concept_accession('6767: rn:R04504','KEGG','RN:R04504',true).
concept_accession('41149: rn:R01859','KEGG','6.4.1.3',true).
concept_accession('41149: rn:R01859','KEGG','24624',true).
concept_accession('41149: rn:R01859','KEGG','687008',true).
concept_accession('41149: rn:R01859','EC','6.4.1.3',true).
concept_accession('41149: rn:R01859','KEGG','RNO:24624',true).
concept_accession('41149: rn:R01859','KEGG','EC:6.4.1.3',true).
concept_accession('41149: rn:R01859','KEGG','RNO:687008',true).
concept_accession('41150: rn:R00833','KEGG','RNO:100361295',true).
concept_accession('41150: rn:R00833','KEGG','100361295',true).
concept_accession('41150: rn:R00833','KEGG','EC:5.4.99.2',true).
concept_accession('41150: rn:R00833','KEGG','RNO:688517',true).
concept_accession('41150: rn:R00833','EC','5.4.99.2',true).
concept_accession('41150: rn:R00833','KEGG','688517',true).
concept_accession('41150: rn:R00833','KEGG','5.4.99.2',true).
concept_accession('41151: rn:R03288','KEGG','EC:3.4.13.5',true).
concept_accession('41151: rn:R03288','KEGG','3.4.13.5',true).
concept_accession('41151: rn:R03288','KEGG','RNO:307212',true).
concept_accession('41151: rn:R03288','KEGG','307212',true).
concept_accession('41151: rn:R03288','EC','3.4.13.5',true).
concept_accession('3286: rn:R04443','KEGG','RN:R04443',true).
concept_accession('3286: rn:R04443','KEGG','RP:RP04081',true).
concept_accession('3286: rn:R04443','KEGG','RC01156',true).
concept_accession('3286: rn:R04443','KEGG','RC:RC01156',true).
concept_accession('3286: rn:R04443','KEGG','RP04081',true).
concept_accession('3286: rn:R04443','KEGG','R04443',true).
concept_accession('7673: rn:R00203','KEGG','RN:R00203',true).
concept_accession('7673: rn:R00203','KEGG','RC:RC00104',true).
concept_accession('7673: rn:R00203','KEGG','1.2.1.23',true).
concept_accession('7673: rn:R00203','KEGG','R00203',true).
concept_accession('7673: rn:R00203','KEGG','RP00283',true).
concept_accession('7673: rn:R00203','KEGG','RC00104',true).
concept_accession('7673: rn:R00203','KEGG','RP:RP00283',true).
concept_accession('7673: rn:R00203','KEGG','EC:1.2.1.23',true).
concept_accession('7673: rn:R00203','EC','1.2.1.23',false).
concept_accession('7672: rn:R01016','KEGG','4.2.3.3',true).
concept_accession('7672: rn:R01016','EC','4.2.3.3',false).
concept_accession('7672: rn:R01016','KEGG','RC:RC00424',true).
concept_accession('7672: rn:R01016','KEGG','RN:R01016',true).
concept_accession('7672: rn:R01016','KEGG','EC:4.2.3.3',true).
concept_accession('7672: rn:R01016','KEGG','RC00424',true).
concept_accession('7672: rn:R01016','KEGG','RP01239',true).
concept_accession('7672: rn:R01016','KEGG','R01016',true).
concept_accession('7672: rn:R01016','KEGG','RP:RP01239',true).
concept_accession('7674: rn:R00203','KEGG','RN:R00203',true).
concept_accession('7674: rn:R00203','KEGG','RC:RC00104',true).
concept_accession('7674: rn:R00203','KEGG','1.2.1.23',true).
concept_accession('7674: rn:R00203','KEGG','R00203',true).
concept_accession('7674: rn:R00203','KEGG','RP00283',true).
concept_accession('7674: rn:R00203','KEGG','RC00104',true).
concept_accession('7674: rn:R00203','KEGG','RP:RP00283',true).
concept_accession('7674: rn:R00203','KEGG','EC:1.2.1.23',true).
concept_accession('7674: rn:R00203','EC','1.2.1.23',false).
concept_accession('3228: rn:R04870','KEGG','R04870',true).
concept_accession('3228: rn:R04870','EC','6.3.2.26',false).
concept_accession('3228: rn:R04870','KEGG','RC01228',true).
concept_accession('3228: rn:R04870','KEGG','RN:R04870',true).
concept_accession('3228: rn:R04870','KEGG','RC:RC00090',true).
concept_accession('3228: rn:R04870','KEGG','RP04485',true).
concept_accession('3228: rn:R04870','KEGG','RP:RP04486',true).
concept_accession('3228: rn:R04870','KEGG','RP04484',true).
concept_accession('3228: rn:R04870','KEGG','RP:RP04484',true).
concept_accession('3228: rn:R04870','KEGG','RP:RP04485',true).
concept_accession('3228: rn:R04870','KEGG','RP04486',true).
concept_accession('3228: rn:R04870','KEGG','RC01227',true).
concept_accession('3228: rn:R04870','KEGG','6.3.2.26',true).
concept_accession('3228: rn:R04870','KEGG','RC:RC01228',true).
concept_accession('3228: rn:R04870','KEGG','RC00090',true).
concept_accession('3228: rn:R04870','KEGG','RC:RC01227',true).
concept_accession('3228: rn:R04870','KEGG','EC:6.3.2.26',true).
concept_accession('3236: rn:R03249','KEGG','RP02877',true).
concept_accession('3236: rn:R03249','KEGG','RP:RP02877',true).
concept_accession('3236: rn:R03249','KEGG','R03249',true).
concept_accession('3236: rn:R03249','KEGG','RC:RC00890',true).
concept_accession('3236: rn:R03249','KEGG','RC00890',true).
concept_accession('3236: rn:R03249','KEGG','RN:R03249',true).
concept_accession('3246: rn:R03314','KEGG','R03314',true).
concept_accession('3246: rn:R03314','KEGG','RC00694',true).
concept_accession('3246: rn:R03314','KEGG','RP02935',true).
concept_accession('3246: rn:R03314','KEGG','RC:RC00694',true).
concept_accession('3246: rn:R03314','KEGG','RP:RP02935',true).
concept_accession('3246: rn:R03314','KEGG','RN:R03314',true).
concept_accession('11808: rn:R01930','KEGG','RC:RC00625',true).
concept_accession('11808: rn:R01930','KEGG','RC00625',true).
concept_accession('11808: rn:R01930','KEGG','EC:3.12.1.1',true).
concept_accession('11808: rn:R01930','EC','3.12.1.1',false).
concept_accession('11808: rn:R01930','KEGG','RP01853',true).
concept_accession('11808: rn:R01930','KEGG','3.12.1.1',true).
concept_accession('11808: rn:R01930','KEGG','RP:RP01853',true).
concept_accession('11808: rn:R01930','KEGG','RN:R01930',true).
concept_accession('11808: rn:R01930','KEGG','R01930',true).
concept_accession('11809: rn:R00897','KEGG','RC00020',true).
concept_accession('11809: rn:R00897','KEGG','EC:2.5.1.47',true).
concept_accession('11809: rn:R00897','EC','2.5.1.47',false).
concept_accession('11809: rn:R00897','KEGG','RC:RC00020',true).
concept_accession('11809: rn:R00897','KEGG','RP00050',true).
concept_accession('11809: rn:R00897','KEGG','2.5.1.47',true).
concept_accession('11809: rn:R00897','KEGG','RN:R00897',true).
concept_accession('11809: rn:R00897','KEGG','RP:RP00050',true).
concept_accession('11809: rn:R00897','KEGG','R00897',true).
concept_accession('3137: rn:R03284','KEGG','RP02914',true).
concept_accession('3137: rn:R03284','KEGG','RP02913',true).
concept_accession('3137: rn:R03284','KEGG','EC:4.1.2.-',true).
concept_accession('3137: rn:R03284','EC','4.1.2.-',false).
concept_accession('3137: rn:R03284','KEGG','RC:RC00312',true).
concept_accession('3137: rn:R03284','KEGG','RN:R03284',true).
concept_accession('3137: rn:R03284','KEGG','RC00312',true).
concept_accession('3137: rn:R03284','KEGG','RC:RC00721',true).
concept_accession('3137: rn:R03284','KEGG','RP:RP02914',true).
concept_accession('3137: rn:R03284','KEGG','RP:RP02913',true).
concept_accession('3137: rn:R03284','KEGG','4.1.2.-',true).
concept_accession('3137: rn:R03284','KEGG','RC00721',true).
concept_accession('3137: rn:R03284','KEGG','R03284',true).
concept_accession('11800: rn:R08553','EC','1.8.99.2',false).
concept_accession('11800: rn:R08553','KEGG','RN:R08553',true).
concept_accession('11800: rn:R08553','KEGG','R08553',true).
concept_accession('11800: rn:R08553','KEGG','1.8.99.2',true).
concept_accession('11800: rn:R08553','KEGG','EC:1.8.99.2',true).
concept_accession('11797: rn:R02021','KEGG','RN:R02021',true).
concept_accession('11797: rn:R02021','EC','1.8.4.8',false).
concept_accession('11797: rn:R02021','KEGG','EC:1.8.4.8',true).
concept_accession('11797: rn:R02021','KEGG','1.8.4.8',true).
concept_accession('11797: rn:R02021','KEGG','R02021',true).
concept_accession('11784: rn:R00897','KEGG','RC00020',true).
concept_accession('11784: rn:R00897','KEGG','EC:2.5.1.47',true).
concept_accession('11784: rn:R00897','EC','2.5.1.47',false).
concept_accession('11784: rn:R00897','KEGG','RC:RC00020',true).
concept_accession('11784: rn:R00897','KEGG','RP00050',true).
concept_accession('11784: rn:R00897','KEGG','2.5.1.47',true).
concept_accession('11784: rn:R00897','KEGG','RN:R00897',true).
concept_accession('11784: rn:R00897','KEGG','RP:RP00050',true).
concept_accession('11784: rn:R00897','KEGG','R00897',true).
concept_accession('11778: rn:R01339','KEGG','RN:R01339',true).
concept_accession('11778: rn:R01339','KEGG','R01339',true).
concept_accession('11779: rn:R00485','KEGG','RP:RP00116',true).
concept_accession('11779: rn:R00485','KEGG','RC00010',true).
concept_accession('11779: rn:R00485','KEGG','RC:RC00010',true).
concept_accession('11779: rn:R00485','KEGG','RN:R00485',true).
concept_accession('11779: rn:R00485','KEGG','R00485',true).
concept_accession('11779: rn:R00485','KEGG','3.5.1.1',true).
concept_accession('11779: rn:R00485','KEGG','EC:3.5.1.1',true).
concept_accession('11779: rn:R00485','EC','3.5.1.1',false).
concept_accession('11779: rn:R00485','KEGG','RP00116',true).
concept_accession('7457: rn:R06198','EC','2.4.1.-',false).
concept_accession('7457: rn:R06198','KEGG','2.4.1.-',true).
concept_accession('7457: rn:R06198','KEGG','EC:2.4.1.-',true).
concept_accession('7457: rn:R06198','KEGG','R06198',true).
concept_accession('7457: rn:R06198','KEGG','RN:R06198',true).
concept_accession('7456: rn:R06192','EC','2.4.1.-',false).
concept_accession('7456: rn:R06192','KEGG','2.4.1.-',true).
concept_accession('7456: rn:R06192','KEGG','R06192',true).
concept_accession('7456: rn:R06192','KEGG','RN:R06192',true).
concept_accession('7456: rn:R06192','KEGG','EC:2.4.1.-',true).
concept_accession('7461: rn:R06097','EC','2.4.1.-',false).
concept_accession('7461: rn:R06097','KEGG','2.4.1.-',true).
concept_accession('7461: rn:R06097','KEGG','RN:R06097',true).
concept_accession('7461: rn:R06097','KEGG','EC:2.4.1.-',true).
concept_accession('7461: rn:R06097','KEGG','R06097',true).
concept_accession('3122: rn:R00462','KEGG','RC:RC00299',true).
concept_accession('3122: rn:R00462','KEGG','RN:R00462',true).
concept_accession('3122: rn:R00462','KEGG','RP00913',true).
concept_accession('3122: rn:R00462','KEGG','EC:4.1.1.18',true).
concept_accession('3122: rn:R00462','KEGG','4.1.1.18',true).
concept_accession('3122: rn:R00462','KEGG','RC00299',true).
concept_accession('3122: rn:R00462','KEGG','RP:RP00913',true).
concept_accession('3122: rn:R00462','EC','4.1.1.18',false).
concept_accession('3122: rn:R00462','KEGG','R00462',true).
concept_accession('3532: rn:R03286','KEGG','EC:6.3.2.11',true).
concept_accession('3532: rn:R03286','KEGG','6.3.2.11',true).
concept_accession('3532: rn:R03286','KEGG','RP00245',true).
concept_accession('3532: rn:R03286','KEGG','RC00064',true).
concept_accession('3532: rn:R03286','KEGG','R03286',true).
concept_accession('3532: rn:R03286','KEGG','RP:RP00245',true).
concept_accession('3532: rn:R03286','EC','6.3.2.11',false).
concept_accession('3532: rn:R03286','KEGG','RC:RC00064',true).
concept_accession('3532: rn:R03286','KEGG','RN:R03286',true).
concept_accession('3471: rn:R05465','KEGG','RC00215',true).
concept_accession('3471: rn:R05465','KEGG','EC:2.5.1.66',true).
concept_accession('3471: rn:R05465','KEGG','2.5.1.66',true).
concept_accession('3471: rn:R05465','KEGG','RN:R05465',true).
concept_accession('3471: rn:R05465','EC','2.5.1.66',false).
concept_accession('3471: rn:R05465','KEGG','RP:RP10848',true).
concept_accession('3471: rn:R05465','KEGG','R05465',true).
concept_accession('3471: rn:R05465','KEGG','RC:RC00215',true).
concept_accession('3471: rn:R05465','KEGG','RP10848',true).
concept_accession('3501: rn:R03288','KEGG','EC:3.4.13.5',true).
concept_accession('3501: rn:R03288','KEGG','R03288',true).
concept_accession('3501: rn:R03288','KEGG','RP00245',true).
concept_accession('3501: rn:R03288','KEGG','3.4.13.5',true).
concept_accession('3501: rn:R03288','KEGG','RC00064',true).
concept_accession('3501: rn:R03288','KEGG','RN:R03288',true).
concept_accession('3501: rn:R03288','KEGG','RP:RP00245',true).
concept_accession('3501: rn:R03288','EC','3.4.13.5',false).
concept_accession('3501: rn:R03288','KEGG','RC:RC00064',true).
concept_accession('3502: rn:R02144','EC','2.1.1.22',false).
concept_accession('3502: rn:R02144','KEGG','EC:2.1.1.22',true).
concept_accession('3502: rn:R02144','KEGG','2.1.1.22',true).
concept_accession('3502: rn:R02144','KEGG','RP:RP01997',true).
concept_accession('3502: rn:R02144','KEGG','R02144',true).
concept_accession('3502: rn:R02144','KEGG','RC:RC00333',true).
concept_accession('3502: rn:R02144','KEGG','RC00333',true).
concept_accession('3502: rn:R02144','KEGG','RN:R02144',true).
concept_accession('3502: rn:R02144','KEGG','RP01997',true).
concept_accession('7303: rn:R06526','KEGG','EC:1.14.-.-',true).
concept_accession('7303: rn:R06526','KEGG','RC00773',true).
concept_accession('7303: rn:R06526','KEGG','RN:R06526',true).
concept_accession('7303: rn:R06526','KEGG','1.14.-.-',true).
concept_accession('7303: rn:R06526','KEGG','RP:RP05669',true).
concept_accession('7303: rn:R06526','KEGG','R06526',true).
concept_accession('7303: rn:R06526','EC','1.14.-.-',false).
concept_accession('7303: rn:R06526','KEGG','RC:RC00773',true).
concept_accession('7303: rn:R06526','KEGG','RP05669',true).
concept_accession('7304: rn:R06525','KEGG','RP05668',true).
concept_accession('7304: rn:R06525','KEGG','EC:1.14.-.-',true).
concept_accession('7304: rn:R06525','KEGG','RC00773',true).
concept_accession('7304: rn:R06525','KEGG','1.14.-.-',true).
concept_accession('7304: rn:R06525','KEGG','RN:R06525',true).
concept_accession('7304: rn:R06525','KEGG','R06525',true).
concept_accession('7304: rn:R06525','EC','1.14.-.-',false).
concept_accession('7304: rn:R06525','KEGG','RC:RC00773',true).
concept_accession('7304: rn:R06525','KEGG','RP:RP05668',true).
concept_accession('7309: rn:R02542','KEGG','RC:RC00425',true).
concept_accession('7309: rn:R02542','KEGG','R02542',true).
concept_accession('7309: rn:R02542','EC','3.1.4.41',false).
concept_accession('7309: rn:R02542','KEGG','3.1.4.41',true).
concept_accession('7309: rn:R02542','KEGG','RC00425',true).
concept_accession('7309: rn:R02542','KEGG','RP02290',true).
concept_accession('7309: rn:R02542','KEGG','EC:3.1.4.41',true).
concept_accession('7309: rn:R02542','KEGG','RP:RP02290',true).
concept_accession('7309: rn:R02542','KEGG','RN:R02542',true).
concept_accession('3406: rn:R00671','EC','4.3.1.12',false).
concept_accession('3406: rn:R00671','KEGG','RC:RC00354',true).
concept_accession('3406: rn:R00671','KEGG','R00671',true).
concept_accession('3406: rn:R00671','KEGG','RN:R00671',true).
concept_accession('3406: rn:R00671','KEGG','EC:4.3.1.12',true).
concept_accession('3406: rn:R00671','KEGG','RP01044',true).
concept_accession('3406: rn:R00671','KEGG','4.3.1.12',true).
concept_accession('3406: rn:R00671','KEGG','RP:RP01044',true).
concept_accession('3406: rn:R00671','KEGG','RC00354',true).
concept_accession('3401: rn:R00131','EC','3.5.1.5',false).
concept_accession('3401: rn:R00131','KEGG','R00131',true).
concept_accession('3401: rn:R00131','KEGG','EC:3.5.1.5',true).
concept_accession('3401: rn:R00131','KEGG','RN:R00131',true).
concept_accession('3401: rn:R00131','KEGG','3.5.1.5',true).
concept_accession('3398: rn:R01987','EC','3.5.1.63',false).
concept_accession('3398: rn:R01987','KEGG','3.5.1.63',true).
concept_accession('3398: rn:R01987','KEGG','RC:RC00096',true).
concept_accession('3398: rn:R01987','KEGG','R01987',true).
concept_accession('3398: rn:R01987','KEGG','RP:RP01893',true).
concept_accession('3398: rn:R01987','KEGG','RN:R01987',true).
concept_accession('3398: rn:R01987','KEGG','EC:3.5.1.63',true).
concept_accession('3398: rn:R01987','KEGG','RP01893',true).
concept_accession('3398: rn:R01987','KEGG','RC00096',true).
concept_accession('3423: rn:R01915','KEGG','RC00225',true).
concept_accession('3423: rn:R01915','KEGG','R01915',true).
concept_accession('3423: rn:R01915','KEGG','EC:1.5.99.6',true).
concept_accession('3423: rn:R01915','KEGG','RN:R01915',true).
concept_accession('3423: rn:R01915','EC','1.5.99.6',false).
concept_accession('3423: rn:R01915','KEGG','RC:RC00225',true).
concept_accession('3423: rn:R01915','KEGG','RP00643',true).
concept_accession('3423: rn:R01915','KEGG','RP:RP00643',true).
concept_accession('3423: rn:R01915','KEGG','1.5.99.6',true).
concept_accession('3432: rn:R02280','EC','3.5.4.22',false).
concept_accession('3432: rn:R02280','KEGG','RN:R02280',true).
concept_accession('3432: rn:R02280','KEGG','RC:RC00679',true).
concept_accession('3432: rn:R02280','KEGG','EC:3.5.4.22',true).
concept_accession('3432: rn:R02280','KEGG','R02280',true).
concept_accession('3432: rn:R02280','KEGG','3.5.4.22',true).
concept_accession('3432: rn:R02280','KEGG','RP:RP02098',true).
concept_accession('3432: rn:R02280','KEGG','RC00679',true).
concept_accession('3432: rn:R02280','KEGG','RP02098',true).
concept_accession('3428: rn:R03296','KEGG','EC:5.1.1.8',true).
concept_accession('3428: rn:R03296','KEGG','RC00479',true).
concept_accession('3428: rn:R03296','KEGG','RN:R03296',true).
concept_accession('3428: rn:R03296','KEGG','R03296',true).
concept_accession('3428: rn:R03296','KEGG','RP02920',true).
concept_accession('3428: rn:R03296','KEGG','5.1.1.8',true).
concept_accession('3428: rn:R03296','KEGG','RP:RP02920',true).
concept_accession('3428: rn:R03296','EC','5.1.1.8',false).
concept_accession('3428: rn:R03296','KEGG','RC:RC00479',true).
concept_accession('3453: rn:R07245','KEGG','EC:2.1.3.9',true).
concept_accession('3453: rn:R07245','KEGG','RC:RC00096',true).
concept_accession('3453: rn:R07245','EC','2.1.3.9',false).
concept_accession('3453: rn:R07245','KEGG','2.1.3.9',true).
concept_accession('3453: rn:R07245','KEGG','RP:RP11135',true).
concept_accession('3453: rn:R07245','KEGG','RC00096',true).
concept_accession('3453: rn:R07245','KEGG','RN:R07245',true).
concept_accession('3453: rn:R07245','KEGG','RP11135',true).
concept_accession('3453: rn:R07245','KEGG','R07245',true).
concept_accession('3343: rn:R00471','KEGG','RC:RC00307',true).
concept_accession('3343: rn:R00471','KEGG','RC:RC00308',true).
concept_accession('3343: rn:R00471','KEGG','4.1.1.3',true).
concept_accession('3343: rn:R00471','KEGG','RP:RP00919',true).
concept_accession('3343: rn:R00471','KEGG','EC:4.1.1.3',true).
concept_accession('3343: rn:R00471','KEGG','RC00307',true).
concept_accession('3343: rn:R00471','KEGG','RN:R00471',true).
concept_accession('3343: rn:R00471','KEGG','R00471',true).
concept_accession('3343: rn:R00471','KEGG','RP00920',true).
concept_accession('3343: rn:R00471','EC','4.1.1.3',false).
concept_accession('3343: rn:R00471','KEGG','RP:RP00920',true).
concept_accession('3343: rn:R00471','KEGG','RC00308',true).
concept_accession('3343: rn:R00471','KEGG','RP00919',true).
concept_accession('3330: rn:R01246 rn:R01249','KEGG','RN:R01246',true).
concept_accession('3330: rn:R01246 rn:R01249','KEGG','EC:1.5.1.1',true).
concept_accession('3330: rn:R01246 rn:R01249','KEGG','RP00597',true).
concept_accession('3330: rn:R01246 rn:R01249','KEGG','RN:R01249',true).
concept_accession('3330: rn:R01246 rn:R01249','EC','1.5.1.1',false).
concept_accession('3330: rn:R01246 rn:R01249','KEGG','RC:RC00135',true).
concept_accession('3330: rn:R01246 rn:R01249','KEGG','RP:RP00597',true).
concept_accession('3330: rn:R01246 rn:R01249','KEGG','R01246',true).
concept_accession('3330: rn:R01246 rn:R01249','KEGG','1.5.1.1',true).
concept_accession('3330: rn:R01246 rn:R01249','KEGG','RC00135',true).
concept_accession('3330: rn:R01246 rn:R01249','KEGG','R01249',true).
concept_accession('3329: rn:R01255','KEGG','5.1.1.4',true).
concept_accession('3329: rn:R01255','KEGG','RC00479',true).
concept_accession('3329: rn:R01255','EC','5.1.1.4',false).
concept_accession('3329: rn:R01255','KEGG','RP01387',true).
concept_accession('3329: rn:R01255','KEGG','RP:RP01387',true).
concept_accession('3329: rn:R01255','KEGG','RN:R01255',true).
concept_accession('3329: rn:R01255','KEGG','EC:5.1.1.4',true).
concept_accession('3329: rn:R01255','KEGG','R01255',true).
concept_accession('3329: rn:R01255','KEGG','RC:RC00479',true).
concept_accession('3353: rn:R01566','KEGG','RC00548',true).
concept_accession('3353: rn:R01566','KEGG','RC00549',true).
concept_accession('3353: rn:R01566','KEGG','RN:R01566',true).
concept_accession('3353: rn:R01566','KEGG','3.5.3.3',true).
concept_accession('3353: rn:R01566','KEGG','RP01598',true).
concept_accession('3353: rn:R01566','KEGG','EC:3.5.3.3',true).
concept_accession('3353: rn:R01566','KEGG','RC:RC00549',true).
concept_accession('3353: rn:R01566','KEGG','RP:RP01598',true).
concept_accession('3353: rn:R01566','KEGG','RP01599',true).
concept_accession('3353: rn:R01566','KEGG','RC:RC00548',true).
concept_accession('3353: rn:R01566','KEGG','R01566',true).
concept_accession('3353: rn:R01566','KEGG','RP:RP01599',true).
concept_accession('3353: rn:R01566','EC','3.5.3.3',false).
concept_accession('3359: rn:R08197','KEGG','RC00006',true).
concept_accession('3359: rn:R08197','KEGG','RP12924',true).
concept_accession('3359: rn:R08197','KEGG','RN:R08197',true).
concept_accession('3359: rn:R08197','EC','2.6.1.84',false).
concept_accession('3359: rn:R08197','KEGG','EC:2.6.1.84',true).
concept_accession('3359: rn:R08197','KEGG','R08197',true).
concept_accession('3359: rn:R08197','KEGG','2.6.1.84',true).
concept_accession('3359: rn:R08197','KEGG','RC:RC00006',true).
concept_accession('3359: rn:R08197','KEGG','RP:RP12924',true).
concept_accession('3345: rn:R00471','KEGG','RC:RC00307',true).
concept_accession('3345: rn:R00471','KEGG','RC:RC00308',true).
concept_accession('3345: rn:R00471','KEGG','4.1.1.3',true).
concept_accession('3345: rn:R00471','KEGG','RP:RP00919',true).
concept_accession('3345: rn:R00471','KEGG','EC:4.1.1.3',true).
concept_accession('3345: rn:R00471','KEGG','RC00307',true).
concept_accession('3345: rn:R00471','KEGG','RN:R00471',true).
concept_accession('3345: rn:R00471','KEGG','R00471',true).
concept_accession('3345: rn:R00471','KEGG','RP00920',true).
concept_accession('3345: rn:R00471','EC','4.1.1.3',false).
concept_accession('3345: rn:R00471','KEGG','RP:RP00920',true).
concept_accession('3345: rn:R00471','KEGG','RC00308',true).
concept_accession('3345: rn:R00471','KEGG','RP00919',true).
concept_accession('3344: rn:R00471','KEGG','RC:RC00307',true).
concept_accession('3344: rn:R00471','KEGG','RC:RC00308',true).
concept_accession('3344: rn:R00471','KEGG','4.1.1.3',true).
concept_accession('3344: rn:R00471','KEGG','RP:RP00919',true).
concept_accession('3344: rn:R00471','KEGG','EC:4.1.1.3',true).
concept_accession('3344: rn:R00471','KEGG','RC00307',true).
concept_accession('3344: rn:R00471','KEGG','RN:R00471',true).
concept_accession('3344: rn:R00471','KEGG','R00471',true).
concept_accession('3344: rn:R00471','KEGG','RP00920',true).
concept_accession('3344: rn:R00471','EC','4.1.1.3',false).
concept_accession('3344: rn:R00471','KEGG','RP:RP00920',true).
concept_accession('3344: rn:R00471','KEGG','RC00308',true).
concept_accession('3344: rn:R00471','KEGG','RP00919',true).
concept_accession('7206: rn:R07063','KEGG','RP:RP10140',true).
concept_accession('7206: rn:R07063','KEGG','RC00917',true).
concept_accession('7206: rn:R07063','KEGG','RN:R07063',true).
concept_accession('7206: rn:R07063','KEGG','R07063',true).
concept_accession('7206: rn:R07063','KEGG','EC:1.14.19.3',true).
concept_accession('7206: rn:R07063','KEGG','1.14.19.3',true).
concept_accession('7206: rn:R07063','KEGG','RC:RC00917',true).
concept_accession('7206: rn:R07063','EC','1.14.19.3',false).
concept_accession('7206: rn:R07063','KEGG','RP10140',true).
concept_accession('3379: rn:R07414','KEGG','RP:RP10975',true).
concept_accession('3379: rn:R07414','KEGG','EC:6.3.1.11',true).
concept_accession('3379: rn:R07414','KEGG','RC:RC00096',true).
concept_accession('3379: rn:R07414','KEGG','RP10975',true).
concept_accession('3379: rn:R07414','EC','6.3.1.11',false).
concept_accession('3379: rn:R07414','KEGG','6.3.1.11',true).
concept_accession('3379: rn:R07414','KEGG','RP10760',true).
concept_accession('3379: rn:R07414','KEGG','RC:RC00090',true).
concept_accession('3379: rn:R07414','KEGG','R07414',true).
concept_accession('3379: rn:R07414','KEGG','RP:RP10760',true).
concept_accession('3379: rn:R07414','KEGG','RN:R07414',true).
concept_accession('3379: rn:R07414','KEGG','RC00090',true).
concept_accession('3379: rn:R07414','KEGG','RC00096',true).
concept_accession('7173: rn:R02264','KEGG','RC:RC00671',true).
concept_accession('7173: rn:R02264','KEGG','RC00671',true).
concept_accession('7173: rn:R02264','KEGG','RN:R02264',true).
concept_accession('7173: rn:R02264','KEGG','RP02083',true).
concept_accession('7173: rn:R02264','KEGG','RP:RP02083',true).
concept_accession('7173: rn:R02264','KEGG','R02264',true).
concept_accession('3839: rn:R09090','KEGG','RN:R09090',true).
concept_accession('3839: rn:R09090','KEGG','R09090',true).
concept_accession('3785: rn:R03341','KEGG','4.1.1.80',true).
concept_accession('3785: rn:R03341','KEGG','R03341',true).
concept_accession('3785: rn:R03341','KEGG','EC:4.1.1.80',true).
concept_accession('3785: rn:R03341','KEGG','RP:RP02956',true).
concept_accession('3785: rn:R03341','KEGG','RC:RC00506',true).
concept_accession('3785: rn:R03341','KEGG','RN:R03341',true).
concept_accession('3785: rn:R03341','KEGG','RP02956',true).
concept_accession('3785: rn:R03341','EC','4.1.1.80',false).
concept_accession('3785: rn:R03341','KEGG','RC00506',true).
concept_accession('3699: rn:R02520','EC','1.13.12.-',false).
concept_accession('3699: rn:R02520','KEGG','1.13.12.-',true).
concept_accession('3699: rn:R02520','KEGG','RP00564',true).
concept_accession('3699: rn:R02520','KEGG','RC:RC00198',true).
concept_accession('3699: rn:R02520','KEGG','EC:1.13.12.-',true).
concept_accession('3699: rn:R02520','KEGG','RN:R02520',true).
concept_accession('3699: rn:R02520','KEGG','R02520',true).
concept_accession('3699: rn:R02520','KEGG','RC00198',true).
concept_accession('3699: rn:R02520','KEGG','RP:RP00564',true).
concept_accession('3694: rn:R00042','KEGG','RC:RC00866',true).
concept_accession('3694: rn:R00042','EC','1.2.3.13',false).
concept_accession('3694: rn:R00042','KEGG','1.2.3.13',true).
concept_accession('3694: rn:R00042','KEGG','RC00866',true).
concept_accession('3694: rn:R00042','KEGG','RP03014',true).
concept_accession('3694: rn:R00042','KEGG','RP:RP03014',true).
concept_accession('3694: rn:R00042','KEGG','R00042',true).
concept_accession('3694: rn:R00042','KEGG','EC:1.2.3.13',true).
concept_accession('3694: rn:R00042','KEGG','RN:R00042',true).
concept_accession('3652: rn:R02384','KEGG','2.1.1.27',true).
concept_accession('3652: rn:R02384','KEGG','RP02172',true).
concept_accession('3652: rn:R02384','KEGG','R02384',true).
concept_accession('3652: rn:R02384','KEGG','RP:RP02172',true).
concept_accession('3652: rn:R02384','KEGG','RC:RC00060',true).
concept_accession('3652: rn:R02384','EC','2.1.1.27',false).
concept_accession('3652: rn:R02384','KEGG','RN:R02384',true).
concept_accession('3652: rn:R02384','KEGG','RC00060',true).
concept_accession('3652: rn:R02384','KEGG','EC:2.1.1.27',true).
concept_accession('7951: rn:R00228','KEGG','RP:RP04321',true).
concept_accession('7951: rn:R00228','KEGG','RP04321',true).
concept_accession('7951: rn:R00228','KEGG','R00228',true).
concept_accession('7951: rn:R00228','KEGG','RN:R00228',true).
concept_accession('7951: rn:R00228','KEGG','EC:1.2.1.10',true).
concept_accession('7951: rn:R00228','KEGG','RC:RC01195',true).
concept_accession('7951: rn:R00228','KEGG','RC01195',true).
concept_accession('7951: rn:R00228','EC','1.2.1.10',false).
concept_accession('7951: rn:R00228','KEGG','1.2.1.10',true).
concept_accession('3646: rn:R02514 rn:R02516','KEGG','1.14.13.18',true).
concept_accession('3646: rn:R02514 rn:R02516','KEGG','RC:RC00193',true).
concept_accession('3646: rn:R02514 rn:R02516','KEGG','RC00193',true).
concept_accession('3646: rn:R02514 rn:R02516','EC','1.14.13.18',false).
concept_accession('3646: rn:R02514 rn:R02516','KEGG','RP:RP00544',true).
concept_accession('3646: rn:R02514 rn:R02516','KEGG','R02516',true).
concept_accession('3646: rn:R02514 rn:R02516','KEGG','R02514',true).
concept_accession('3646: rn:R02514 rn:R02516','KEGG','EC:1.14.13.18',true).
concept_accession('3646: rn:R02514 rn:R02516','KEGG','RP00544',true).
concept_accession('3646: rn:R02514 rn:R02516','KEGG','RN:R02516',true).
concept_accession('3646: rn:R02514 rn:R02516','KEGG','RN:R02514',true).
concept_accession('3642: rn:R02698','KEGG','RP02416',true).
concept_accession('3642: rn:R02698','KEGG','EC:1.14.13.3',true).
concept_accession('3642: rn:R02698','KEGG','RN:R02698',true).
concept_accession('3642: rn:R02698','KEGG','RC:RC00046',true).
concept_accession('3642: rn:R02698','KEGG','RC00046',true).
concept_accession('3642: rn:R02698','EC','1.14.13.3',false).
concept_accession('3642: rn:R02698','KEGG','RP:RP02416',true).
concept_accession('3642: rn:R02698','KEGG','1.14.13.3',true).
concept_accession('3642: rn:R02698','KEGG','R02698',true).
concept_accession('3638: rn:R02518','KEGG','R02518',true).
concept_accession('3638: rn:R02518','EC','4.1.1.-',false).
concept_accession('3638: rn:R02518','KEGG','4.1.1.-',true).
concept_accession('3638: rn:R02518','KEGG','RN:R02518',true).
concept_accession('3638: rn:R02518','KEGG','EC:4.1.1.-',true).
concept_accession('3635: rn:R02489','KEGG','R02489',true).
concept_accession('3635: rn:R02489','EC','4.1.1.62',false).
concept_accession('3635: rn:R02489','KEGG','RP02253',true).
concept_accession('3635: rn:R02489','KEGG','RN:R02489',true).
concept_accession('3635: rn:R02489','KEGG','RC:RC00390',true).
concept_accession('3635: rn:R02489','KEGG','RP:RP02253',true).
concept_accession('3635: rn:R02489','KEGG','EC:4.1.1.62',true).
concept_accession('3635: rn:R02489','KEGG','RC00390',true).
concept_accession('3635: rn:R02489','KEGG','4.1.1.62',true).
concept_accession('7936: rn:R00750','KEGG','RC:RC00307',true).
concept_accession('7936: rn:R00750','EC','4.1.3.39',false).
concept_accession('7936: rn:R00750','KEGG','RC00371',true).
concept_accession('7936: rn:R00750','KEGG','4.1.3.39',true).
concept_accession('7936: rn:R00750','KEGG','EC:4.1.3.39',true).
concept_accession('7936: rn:R00750','KEGG','RC:RC00371',true).
concept_accession('7936: rn:R00750','KEGG','RP:RP01084',true).
concept_accession('7936: rn:R00750','KEGG','RC00307',true).
concept_accession('7936: rn:R00750','KEGG','RP:RP01083',true).
concept_accession('7936: rn:R00750','KEGG','R00750',true).
concept_accession('7936: rn:R00750','KEGG','RN:R00750',true).
concept_accession('7936: rn:R00750','KEGG','RP01084',true).
concept_accession('7936: rn:R00750','KEGG','RP01083',true).
concept_accession('3596: rn:R03672','KEGG','RC:RC00180',true).
concept_accession('3596: rn:R03672','KEGG','RP:RP03299',true).
concept_accession('3596: rn:R03672','KEGG','R03672',true).
concept_accession('3596: rn:R03672','KEGG','RC00180',true).
concept_accession('3596: rn:R03672','KEGG','RP03299',true).
concept_accession('3596: rn:R03672','KEGG','RN:R03672',true).
concept_accession('3598: rn:R03674','KEGG','RC:RC00972',true).
concept_accession('3598: rn:R03674','KEGG','RN:R03674',true).
concept_accession('3598: rn:R03674','KEGG','RC00972',true).
concept_accession('3598: rn:R03674','KEGG','R03674',true).
concept_accession('3598: rn:R03674','KEGG','RP03301',true).
concept_accession('3598: rn:R03674','KEGG','RP:RP03301',true).
concept_accession('11691: rn:R00490','KEGG','R00490',true).
concept_accession('11691: rn:R00490','KEGG','RN:R00490',true).
concept_accession('11691: rn:R00490','EC','4.3.1.1',false).
concept_accession('11691: rn:R00490','KEGG','4.3.1.1',true).
concept_accession('11691: rn:R00490','KEGG','EC:4.3.1.1',true).
concept_accession('11694: rn:R00482','KEGG','RP:RP00116',true).
concept_accession('11694: rn:R00482','KEGG','RC00010',true).
concept_accession('11694: rn:R00482','KEGG','EC:6.3.1.4',true).
concept_accession('11694: rn:R00482','KEGG','RC:RC00010',true).
concept_accession('11694: rn:R00482','KEGG','R00482',true).
concept_accession('11694: rn:R00482','KEGG','RN:R00482',true).
concept_accession('11694: rn:R00482','EC','6.3.1.4',false).
concept_accession('11694: rn:R00482','KEGG','6.3.1.4',true).
concept_accession('11694: rn:R00482','KEGG','RP00116',true).
concept_accession('11693: rn:R00483','KEGG','RP:RP00116',true).
concept_accession('11693: rn:R00483','KEGG','RC00010',true).
concept_accession('11693: rn:R00483','KEGG','RC:RC00010',true).
concept_accession('11693: rn:R00483','EC','6.3.1.1',false).
concept_accession('11693: rn:R00483','KEGG','R00483',true).
concept_accession('11693: rn:R00483','KEGG','RN:R00483',true).
concept_accession('11693: rn:R00483','KEGG','6.3.1.1',true).
concept_accession('11693: rn:R00483','KEGG','EC:6.3.1.1',true).
concept_accession('11693: rn:R00483','KEGG','RP00116',true).
concept_accession('11692: rn:R00490','KEGG','R00490',true).
concept_accession('11692: rn:R00490','KEGG','RN:R00490',true).
concept_accession('11692: rn:R00490','EC','4.3.1.1',false).
concept_accession('11692: rn:R00490','KEGG','4.3.1.1',true).
concept_accession('11692: rn:R00490','KEGG','EC:4.3.1.1',true).
concept_accession('11734: rn:R00493','KEGG','R00493',true).
concept_accession('11734: rn:R00493','KEGG','RN:R00493',true).
concept_accession('7859: rn:R00228','KEGG','RP:RP04321',true).
concept_accession('7859: rn:R00228','KEGG','RP04321',true).
concept_accession('7859: rn:R00228','KEGG','R00228',true).
concept_accession('7859: rn:R00228','KEGG','RN:R00228',true).
concept_accession('7859: rn:R00228','KEGG','EC:1.2.1.10',true).
concept_accession('7859: rn:R00228','KEGG','RC:RC01195',true).
concept_accession('7859: rn:R00228','KEGG','RC01195',true).
concept_accession('7859: rn:R00228','EC','1.2.1.10',false).
concept_accession('7859: rn:R00228','KEGG','1.2.1.10',true).
concept_accession('11774: rn:R00524','KEGG','RP:RP00955',true).
concept_accession('11774: rn:R00524','KEGG','R00524',true).
concept_accession('11774: rn:R00524','KEGG','RN:R00524',true).
concept_accession('11774: rn:R00524','KEGG','EC:3.5.1.49',true).
concept_accession('11774: rn:R00524','KEGG','3.5.1.49',true).
concept_accession('11774: rn:R00524','KEGG','RC02432',true).
concept_accession('11774: rn:R00524','EC','3.5.1.49',false).
concept_accession('11774: rn:R00524','KEGG','RC:RC02432',true).
concept_accession('11774: rn:R00524','KEGG','RP00955',true).
concept_accession('11522: rn:R07260','KEGG','RP11953',true).
concept_accession('11522: rn:R07260','KEGG','RC:RC00059',true).
concept_accession('11522: rn:R07260','KEGG','EC:2.4.1.215',true).
concept_accession('11522: rn:R07260','KEGG','RP00012',true).
concept_accession('11522: rn:R07260','KEGG','RC00005',true).
concept_accession('11522: rn:R07260','KEGG','RC:RC00005',true).
concept_accession('11522: rn:R07260','KEGG','RC00059',true).
concept_accession('11522: rn:R07260','EC','2.4.1.215',false).
concept_accession('11522: rn:R07260','KEGG','RN:R07260',true).
concept_accession('11522: rn:R07260','KEGG','2.4.1.215',true).
concept_accession('11522: rn:R07260','KEGG','R07260',true).
concept_accession('11522: rn:R07260','KEGG','RP:RP00012',true).
concept_accession('11522: rn:R07260','KEGG','RP:RP11953',true).
concept_accession('3943: rn:R06790','KEGG','RC:RC00490',true).
concept_accession('3943: rn:R06790','KEGG','RN:R06790',true).
concept_accession('3943: rn:R06790','KEGG','R06790',true).
concept_accession('3943: rn:R06790','KEGG','RP09197',true).
concept_accession('3943: rn:R06790','KEGG','RP:RP09197',true).
concept_accession('3943: rn:R06790','KEGG','RC00490',true).
concept_accession('3961: rn:R05487','KEGG','RP05085',true).
concept_accession('3961: rn:R05487','KEGG','RC:RC00046',true).
concept_accession('3961: rn:R05487','EC','1.14.13.-',false).
concept_accession('3961: rn:R05487','KEGG','RP:RP05085',true).
concept_accession('3961: rn:R05487','KEGG','R05487',true).
concept_accession('3961: rn:R05487','KEGG','1.14.13.-',true).
concept_accession('3961: rn:R05487','KEGG','RC00046',true).
concept_accession('3961: rn:R05487','KEGG','RN:R05487',true).
concept_accession('3961: rn:R05487','KEGG','EC:1.14.13.-',true).
concept_accession('7745: rn:R00230','KEGG','R00230',true).
concept_accession('7745: rn:R00230','KEGG','2.3.1.8',true).
concept_accession('7745: rn:R00230','KEGG','RN:R00230',true).
concept_accession('7745: rn:R00230','EC','2.3.1.8',false).
concept_accession('7745: rn:R00230','KEGG','EC:2.3.1.8',true).
concept_accession('3953: rn:R01377','KEGG','RP01466',true).
concept_accession('3953: rn:R01377','KEGG','R01377',true).
concept_accession('3953: rn:R01377','EC','4.1.1.-',false).
concept_accession('3953: rn:R01377','KEGG','RC:RC00506',true).
concept_accession('3953: rn:R01377','KEGG','RP:RP01466',true).
concept_accession('3953: rn:R01377','KEGG','4.1.1.-',true).
concept_accession('3953: rn:R01377','KEGG','RN:R01377',true).
concept_accession('3953: rn:R01377','KEGG','EC:4.1.1.-',true).
concept_accession('3953: rn:R01377','KEGG','RC00506',true).
concept_accession('7744: rn:R00753','KEGG','RC:RC00374',true).
concept_accession('7744: rn:R00753','KEGG','RP01088',true).
concept_accession('7744: rn:R00753','KEGG','4.1.2.36',true).
concept_accession('7744: rn:R00753','KEGG','EC:4.1.2.36',true).
concept_accession('7744: rn:R00753','KEGG','RP:RP01088',true).
concept_accession('7744: rn:R00753','KEGG','RN:R00753',true).
concept_accession('7744: rn:R00753','KEGG','R00753',true).
concept_accession('7744: rn:R00753','KEGG','RC00374',true).
concept_accession('7744: rn:R00753','EC','4.1.2.36',false).
concept_accession('7780: rn:R00750','KEGG','RC:RC00307',true).
concept_accession('7780: rn:R00750','EC','4.1.3.39',false).
concept_accession('7780: rn:R00750','KEGG','RC00371',true).
concept_accession('7780: rn:R00750','KEGG','4.1.3.39',true).
concept_accession('7780: rn:R00750','KEGG','EC:4.1.3.39',true).
concept_accession('7780: rn:R00750','KEGG','RC:RC00371',true).
concept_accession('7780: rn:R00750','KEGG','RP:RP01084',true).
concept_accession('7780: rn:R00750','KEGG','RC00307',true).
concept_accession('7780: rn:R00750','KEGG','RP:RP01083',true).
concept_accession('7780: rn:R00750','KEGG','R00750',true).
concept_accession('7780: rn:R00750','KEGG','RN:R00750',true).
concept_accession('7780: rn:R00750','KEGG','RP01084',true).
concept_accession('7780: rn:R00750','KEGG','RP01083',true).
concept_accession('11596: rn:R08052','KEGG','RP:RP10594',true).
concept_accession('11596: rn:R08052','KEGG','R08052',true).
concept_accession('11596: rn:R08052','KEGG','RN:R08052',true).
concept_accession('11596: rn:R08052','KEGG','RC:RC00121',true).
concept_accession('11596: rn:R08052','KEGG','RC00121',true).
concept_accession('11596: rn:R08052','KEGG','RP10594',true).
concept_accession('11597: rn:R08051','KEGG','RP10497',true).
concept_accession('11597: rn:R08051','KEGG','R08051',true).
concept_accession('11597: rn:R08051','KEGG','RC:RC00121',true).
concept_accession('11597: rn:R08051','KEGG','RN:R08051',true).
concept_accession('11597: rn:R08051','KEGG','RC00121',true).
concept_accession('11597: rn:R08051','KEGG','RP:RP10497',true).
concept_accession('7705: rn:R03145','KEGG','RP:RP02797',true).
concept_accession('7705: rn:R03145','KEGG','R03145',true).
concept_accession('7705: rn:R03145','KEGG','RN:R03145',true).
concept_accession('7705: rn:R03145','KEGG','RC00860',true).
concept_accession('7705: rn:R03145','KEGG','RC:RC00860',true).
concept_accession('7705: rn:R03145','EC','1.2.5.1',false).
concept_accession('7705: rn:R03145','KEGG','EC:1.2.5.1',true).
concept_accession('7705: rn:R03145','KEGG','1.2.5.1',true).
concept_accession('7705: rn:R03145','KEGG','RP02797',true).
concept_accession('7706: rn:R00207','KEGG','EC:1.2.3.3',true).
concept_accession('7706: rn:R00207','EC','1.2.3.3',false).
concept_accession('7706: rn:R00207','KEGG','RN:R00207',true).
concept_accession('7706: rn:R00207','KEGG','1.2.3.3',true).
concept_accession('7706: rn:R00207','KEGG','R00207',true).
concept_accession('11595: rn:R04038','KEGG','EC:2.5.1.27',true).
concept_accession('11595: rn:R04038','KEGG','2.5.1.27',true).
concept_accession('11595: rn:R04038','KEGG','RP03664',true).
concept_accession('11595: rn:R04038','KEGG','RP:RP03664',true).
concept_accession('11595: rn:R04038','EC','2.5.1.27',false).
concept_accession('11595: rn:R04038','KEGG','RC:RC00121',true).
concept_accession('11595: rn:R04038','KEGG','R04038',true).
concept_accession('11595: rn:R04038','KEGG','RC00121',true).
concept_accession('11595: rn:R04038','KEGG','RN:R04038',true).
concept_accession('7707: rn:R00230','KEGG','R00230',true).
concept_accession('7707: rn:R00230','KEGG','2.3.1.8',true).
concept_accession('7707: rn:R00230','KEGG','RN:R00230',true).
concept_accession('7707: rn:R00230','EC','2.3.1.8',false).
concept_accession('7707: rn:R00230','KEGG','EC:2.3.1.8',true).
concept_accession('7701: rn:R00472','KEGG','R00472',true).
concept_accession('7701: rn:R00472','KEGG','RN:R00472',true).
concept_accession('7701: rn:R00472','KEGG','2.3.3.9',true).
concept_accession('7701: rn:R00472','EC','2.3.3.9',false).
concept_accession('7701: rn:R00472','KEGG','EC:2.3.3.9',true).
concept_accession('11591: rn:R08076','KEGG','RC:RC00059',true).
concept_accession('11591: rn:R08076','EC','2.4.1.-',false).
concept_accession('11591: rn:R08076','KEGG','RP00012',true).
concept_accession('11591: rn:R08076','KEGG','RC00005',true).
concept_accession('11591: rn:R08076','KEGG','RC:RC00005',true).
concept_accession('11591: rn:R08076','KEGG','R08076',true).
concept_accession('11591: rn:R08076','KEGG','RC00059',true).
concept_accession('11591: rn:R08076','KEGG','2.4.1.-',true).
concept_accession('11591: rn:R08076','KEGG','RP11359',true).
concept_accession('11591: rn:R08076','KEGG','EC:2.4.1.-',true).
concept_accession('11591: rn:R08076','KEGG','RP:RP00012',true).
concept_accession('11591: rn:R08076','KEGG','RP:RP11359',true).
concept_accession('11591: rn:R08076','KEGG','RN:R08076',true).
concept_accession('3875: rn:R02540','KEGG','RC00010',true).
concept_accession('3875: rn:R02540','EC','3.5.1.4',false).
concept_accession('3875: rn:R02540','KEGG','RC:RC00010',true).
concept_accession('3875: rn:R02540','KEGG','RP02287',true).
concept_accession('3875: rn:R02540','KEGG','R02540',true).
concept_accession('3875: rn:R02540','KEGG','EC:3.5.1.4',true).
concept_accession('3875: rn:R02540','KEGG','RP:RP02287',true).
concept_accession('3875: rn:R02540','KEGG','3.5.1.4',true).
concept_accession('3875: rn:R02540','KEGG','RN:R02540',true).
concept_accession('7692: rn:R00212','KEGG','RN:R00212',true).
concept_accession('7692: rn:R00212','KEGG','RP04232',true).
concept_accession('7692: rn:R00212','KEGG','RP:RP04232',true).
concept_accession('7692: rn:R00212','KEGG','R00212',true).
concept_accession('7692: rn:R00212','KEGG','RC01181',true).
concept_accession('7692: rn:R00212','EC','2.3.1.54',false).
concept_accession('7692: rn:R00212','KEGG','2.3.1.54',true).
concept_accession('7692: rn:R00212','KEGG','EC:2.3.1.54',true).
concept_accession('7692: rn:R00212','KEGG','RC:RC01181',true).
concept_accession('7695: rn:R01196','KEGG','R01196',true).
concept_accession('7695: rn:R01196','KEGG','RN:R01196',true).
concept_accession('7695: rn:R01196','KEGG','1.2.7.1',true).
concept_accession('7695: rn:R01196','EC','1.2.7.1',false).
concept_accession('7695: rn:R01196','KEGG','EC:1.2.7.1',true).
concept_accession('7694: rn:R00211','KEGG','1.2.3.6',true).
concept_accession('7694: rn:R00211','KEGG','R00211',true).
concept_accession('7694: rn:R00211','KEGG','RN:R00211',true).
concept_accession('7694: rn:R00211','EC','1.2.3.6',false).
concept_accession('7694: rn:R00211','KEGG','EC:1.2.3.6',true).
concept_accession('7687: rn:R01450','KEGG','EC:5.1.2.1',true).
concept_accession('7687: rn:R01450','KEGG','5.1.2.1',true).
concept_accession('7687: rn:R01450','KEGG','RN:R01450',true).
concept_accession('7687: rn:R01450','KEGG','R01450',true).
concept_accession('7687: rn:R01450','KEGG','RP:RP01518',true).
concept_accession('7687: rn:R01450','KEGG','RP01518',true).
concept_accession('7687: rn:R01450','KEGG','RC00519',true).
concept_accession('7687: rn:R01450','EC','5.1.2.1',false).
concept_accession('7687: rn:R01450','KEGG','RC:RC00519',true).
concept_accession('11600: rn:R03726','KEGG','RP03351',true).
concept_accession('11600: rn:R03726','EC','2.5.1.24',false).
concept_accession('11600: rn:R03726','KEGG','R03726',true).
concept_accession('11600: rn:R03726','KEGG','RP:RP03351',true).
concept_accession('11600: rn:R03726','KEGG','EC:2.5.1.24',true).
concept_accession('11600: rn:R03726','KEGG','RC:RC00986',true).
concept_accession('11600: rn:R03726','KEGG','RC00986',true).
concept_accession('11600: rn:R03726','KEGG','2.5.1.24',true).
concept_accession('11600: rn:R03726','KEGG','RC00021',true).
concept_accession('11600: rn:R03726','KEGG','RP:RP00058',true).
concept_accession('11600: rn:R03726','KEGG','RC:RC00021',true).
concept_accession('11600: rn:R03726','KEGG','RN:R03726',true).
concept_accession('11600: rn:R03726','KEGG','RP00058',true).
concept_accession('11603: rn:R02118','KEGG','RC:RC00059',true).
concept_accession('11603: rn:R02118','KEGG','RP:RP01980',true).
concept_accession('11603: rn:R02118','KEGG','RP00012',true).
concept_accession('11603: rn:R02118','KEGG','RC00005',true).
concept_accession('11603: rn:R02118','KEGG','R02118',true).
concept_accession('11603: rn:R02118','KEGG','RN:R02118',true).
concept_accession('11603: rn:R02118','KEGG','RC:RC00005',true).
concept_accession('11603: rn:R02118','KEGG','RC00059',true).
concept_accession('11603: rn:R02118','KEGG','EC:2.4.1.203',true).
concept_accession('11603: rn:R02118','EC','2.4.1.203',false).
concept_accession('11603: rn:R02118','KEGG','RP01980',true).
concept_accession('11603: rn:R02118','KEGG','RP:RP00012',true).
concept_accession('11603: rn:R02118','KEGG','2.4.1.203',true).
concept_accession('11602: rn:R02119','KEGG','RP:RP01981',true).
concept_accession('11602: rn:R02119','KEGG','RC:RC00059',true).
concept_accession('11602: rn:R02119','KEGG','RC00005',true).
concept_accession('11602: rn:R02119','KEGG','R02119',true).
concept_accession('11602: rn:R02119','KEGG','RN:R02119',true).
concept_accession('11602: rn:R02119','KEGG','RC:RC00005',true).
concept_accession('11602: rn:R02119','KEGG','EC:2.4.2.40',true).
concept_accession('11602: rn:R02119','KEGG','RC00059',true).
concept_accession('11602: rn:R02119','KEGG','2.4.2.40',true).
concept_accession('11602: rn:R02119','KEGG','RP01981',true).
concept_accession('11602: rn:R02119','EC','2.4.2.40',false).
concept_accession('11602: rn:R02119','KEGG','RP:RP00087',true).
concept_accession('11602: rn:R02119','KEGG','RP00087',true).
concept_accession('7743: rn:R00319','KEGG','R00319',true).
concept_accession('7743: rn:R00319','KEGG','EC:1.13.12.4',true).
concept_accession('7743: rn:R00319','KEGG','RN:R00319',true).
concept_accession('7743: rn:R00319','KEGG','RP04861',true).
concept_accession('7743: rn:R00319','KEGG','RP:RP04861',true).
concept_accession('7743: rn:R00319','KEGG','RC:RC01312',true).
concept_accession('7743: rn:R00319','KEGG','RC01312',true).
concept_accession('7743: rn:R00319','EC','1.13.12.4',false).
concept_accession('7743: rn:R00319','KEGG','1.13.12.4',true).
concept_accession('7737: rn:R00205','KEGG','RC:RC00104',true).
concept_accession('7737: rn:R00205','KEGG','RP00283',true).
concept_accession('7737: rn:R00205','KEGG','RN:R00205',true).
concept_accession('7737: rn:R00205','KEGG','R00205',true).
concept_accession('7737: rn:R00205','KEGG','EC:1.2.1.49',true).
concept_accession('7737: rn:R00205','KEGG','RC00104',true).
concept_accession('7737: rn:R00205','KEGG','1.2.1.49',true).
concept_accession('7737: rn:R00205','KEGG','RP:RP00283',true).
concept_accession('7737: rn:R00205','EC','1.2.1.49',false).
concept_accession('3842: rn:R00750','KEGG','RC:RC00307',true).
concept_accession('3842: rn:R00750','EC','4.1.3.39',false).
concept_accession('3842: rn:R00750','KEGG','RC00371',true).
concept_accession('3842: rn:R00750','KEGG','4.1.3.39',true).
concept_accession('3842: rn:R00750','KEGG','EC:4.1.3.39',true).
concept_accession('3842: rn:R00750','KEGG','RC:RC00371',true).
concept_accession('3842: rn:R00750','KEGG','RP:RP01084',true).
concept_accession('3842: rn:R00750','KEGG','RC00307',true).
concept_accession('3842: rn:R00750','KEGG','RP:RP01083',true).
concept_accession('3842: rn:R00750','KEGG','R00750',true).
concept_accession('3842: rn:R00750','KEGG','RN:R00750',true).
concept_accession('3842: rn:R00750','KEGG','RP01084',true).
concept_accession('3842: rn:R00750','KEGG','RP01083',true).
concept_accession('3862: rn:R01377','KEGG','RP01466',true).
concept_accession('3862: rn:R01377','KEGG','R01377',true).
concept_accession('3862: rn:R01377','EC','4.1.1.-',false).
concept_accession('3862: rn:R01377','KEGG','RC:RC00506',true).
concept_accession('3862: rn:R01377','KEGG','RP:RP01466',true).
concept_accession('3862: rn:R01377','KEGG','4.1.1.-',true).
concept_accession('3862: rn:R01377','KEGG','RN:R01377',true).
concept_accession('3862: rn:R01377','KEGG','EC:4.1.1.-',true).
concept_accession('3862: rn:R01377','KEGG','RC00506',true).
concept_accession('7717: rn:R00228','KEGG','RP:RP04321',true).
concept_accession('7717: rn:R00228','KEGG','RP04321',true).
concept_accession('7717: rn:R00228','KEGG','R00228',true).
concept_accession('7717: rn:R00228','KEGG','RN:R00228',true).
concept_accession('7717: rn:R00228','KEGG','EC:1.2.1.10',true).
concept_accession('7717: rn:R00228','KEGG','RC:RC01195',true).
concept_accession('7717: rn:R00228','KEGG','RC01195',true).
concept_accession('7717: rn:R00228','EC','1.2.1.10',false).
concept_accession('7717: rn:R00228','KEGG','1.2.1.10',true).
concept_accession('36906: gl:G00111','KEGG','G00111',true).
concept_accession('36906: gl:G00111','KEGG','GL:G00111',true).
concept_accession('36905: cpd:C00957','KEGG','CPD:C00957',true).
concept_accession('36905: cpd:C00957','KEGG','C00957',true).
concept_accession('36911: gl:G00124','KEGG','G00124',true).
concept_accession('36911: gl:G00124','KEGG','GL:G00124',true).
concept_accession('36909: cpd:C00458','KEGG','CPD:C00458',true).
concept_accession('36909: cpd:C00458','KEGG','C00458',true).
concept_accession('36908: gl:G00112','KEGG','GL:G00112',true).
concept_accession('36908: gl:G00112','KEGG','G00112',true).
concept_accession('36897: cpd:C00063','KEGG','C00063',true).
concept_accession('36897: cpd:C00063','KEGG','CPD:C00063',true).
concept_accession('36896: cpd:C00208','KEGG','C00208',true).
concept_accession('36896: cpd:C00208','KEGG','CPD:C00208',true).
concept_accession('36903: cpd:C00295','KEGG','C00295',true).
concept_accession('36903: cpd:C00295','KEGG','CPD:C00295',true).
concept_accession('39100: gl:G00027','KEGG','G00027',true).
concept_accession('39100: gl:G00027','KEGG','GL:G00027',true).
concept_accession('39075: gl:G00010','KEGG','GL:G00010',true).
concept_accession('39075: gl:G00010','KEGG','G00010',true).
concept_accession('36923: gl:G00109','KEGG','G00109',true).
concept_accession('36923: gl:G00109','KEGG','GL:G00109',true).
concept_accession('36920: gl:G00108','KEGG','G00108',true).
concept_accession('36920: gl:G00108','KEGG','GL:G00108',true).
concept_accession('36925: gl:G00110','KEGG','GL:G00110',true).
concept_accession('36925: gl:G00110','KEGG','G00110',true).
concept_accession('36914: gl:G00123','KEGG','GL:G00123',true).
concept_accession('36914: gl:G00123','KEGG','G00123',true).
concept_accession('36915: cpd:C00721','KEGG','CPD:C00721',true).
concept_accession('36915: cpd:C00721','KEGG','C00721',true).
concept_accession('36913: cpd:C00705','KEGG','CPD:C00705',true).
concept_accession('36913: cpd:C00705','KEGG','C00705',true).
concept_accession('36918: cpd:C01083','KEGG','C01083',true).
concept_accession('36918: cpd:C01083','KEGG','CPD:C01083',true).
concept_accession('36919: cpd:C05670','KEGG','CPD:C05670',true).
concept_accession('36919: cpd:C05670','KEGG','C05670',true).
concept_accession('36916: cpd:C00239','KEGG','CPD:C00239',true).
concept_accession('36916: cpd:C00239','KEGG','C00239',true).
concept_accession('36917: gl:G00113','KEGG','G00113',true).
concept_accession('36917: gl:G00113','KEGG','GL:G00113',true).
concept_accession('36873: cpd:C00664','KEGG','C00664',true).
concept_accession('36873: cpd:C00664','KEGG','CPD:C00664',true).
concept_accession('36872: cpd:C16550','KEGG','C16550',true).
concept_accession('36872: cpd:C16550','KEGG','CPD:C16550',true).
concept_accession('36875: cpd:C05476','KEGG','CPD:C05476',true).
concept_accession('36875: cpd:C05476','KEGG','C05476',true).
concept_accession('36874: cpd:C03479','KEGG','CPD:C03479',true).
concept_accession('36874: cpd:C03479','KEGG','C03479',true).
concept_accession('36877: cpd:C01780','KEGG','CPD:C01780',true).
concept_accession('36877: cpd:C01780','KEGG','C01780',true).
concept_accession('36878: cpd:C00632','KEGG','C00632',true).
concept_accession('36878: cpd:C00632','KEGG','CPD:C00632',true).
concept_accession('36865: cpd:C02538','KEGG','CPD:C02538',true).
concept_accession('36865: cpd:C02538','KEGG','C02538',true).
concept_accession('36864: cpd:C05488','KEGG','C05488',true).
concept_accession('36864: cpd:C05488','KEGG','CPD:C05488',true).
concept_accession('36867: cpd:C07643','KEGG','C07643',true).
concept_accession('36867: cpd:C07643','KEGG','CPD:C07643',true).
concept_accession('36869: cpd:C11554','KEGG','CPD:C11554',true).
concept_accession('36869: cpd:C11554','KEGG','C11554',true).
concept_accession('36868: cpd:C02140','KEGG','C02140',true).
concept_accession('36868: cpd:C02140','KEGG','CPD:C02140',true).
concept_accession('36871: gl:G12396','KEGG','GL:G12396',true).
concept_accession('36871: gl:G12396','KEGG','G12396',true).
concept_accession('36870: cpd:C07644','KEGG','C07644',true).
concept_accession('36870: cpd:C07644','KEGG','CPD:C07644',true).
concept_accession('36889: gl:G00117','KEGG','GL:G00117',true).
concept_accession('36889: gl:G00117','KEGG','G00117',true).
concept_accession('36890: cpd:C01231','KEGG','CPD:C01231',true).
concept_accession('36890: cpd:C01231','KEGG','C01231',true).
concept_accession('36891: gl:G00116','KEGG','GL:G00116',true).
concept_accession('36891: gl:G00116','KEGG','G00116',true).
concept_accession('36893: gl:G00114','KEGG','G00114',true).
concept_accession('36893: gl:G00114','KEGG','GL:G00114',true).
concept_accession('36894: cpd:C05823','KEGG','C05823',true).
concept_accession('36894: cpd:C05823','KEGG','CPD:C05823',true).
concept_accession('36880: cpd:C01176','KEGG','C01176',true).
concept_accession('36880: cpd:C01176','KEGG','CPD:C01176',true).
concept_accession('36881: cpd:C03205','KEGG','CPD:C03205',true).
concept_accession('36881: cpd:C03205','KEGG','C03205',true).
concept_accession('36883: cpd:C00166','KEGG','C00166',true).
concept_accession('36883: cpd:C00166','KEGG','CPD:C00166',true).
concept_accession('36884: cpd:C03681','KEGG','C03681',true).
concept_accession('36884: cpd:C03681','KEGG','CPD:C03681',true).
concept_accession('36886: cpd:C00410','KEGG','C00410',true).
concept_accession('36886: cpd:C00410','KEGG','CPD:C00410',true).
concept_accession('36975: gl:G00125','KEGG','G00125',true).
concept_accession('36975: gl:G00125','KEGG','GL:G00125',true).
concept_accession('36974: cpd:C05335','KEGG','CPD:C05335',true).
concept_accession('36974: cpd:C05335','KEGG','C05335',true).
concept_accession('36973: cpd:C14874','KEGG','C14874',true).
concept_accession('36973: cpd:C14874','KEGG','CPD:C14874',true).
concept_accession('36972: cpd:C05688','KEGG','C05688',true).
concept_accession('36972: cpd:C05688','KEGG','CPD:C05688',true).
concept_accession('36970: cpd:C01159','KEGG','C01159',true).
concept_accession('36970: cpd:C01159','KEGG','CPD:C01159',true).
concept_accession('36967: cpd:C05689','KEGG','C05689',true).
concept_accession('36967: cpd:C05689','KEGG','CPD:C05689',true).
concept_accession('36965: cpd:C05100','KEGG','CPD:C05100',true).
concept_accession('36965: cpd:C05100','KEGG','C05100',true).
concept_accession('36964: cpd:C00469','KEGG','CPD:C00469',true).
concept_accession('36964: cpd:C00469','KEGG','C00469',true).
concept_accession('36962: cpd:C05145','KEGG','C05145',true).
concept_accession('36962: cpd:C05145','KEGG','CPD:C05145',true).
concept_accession('36990: cpd:C00672','KEGG','C00672',true).
concept_accession('36990: cpd:C00672','KEGG','CPD:C00672',true).
concept_accession('36988: cpd:C06899','KEGG','C06899',true).
concept_accession('36988: cpd:C06899','KEGG','CPD:C06899',true).
concept_accession('36989: cpd:C05703','KEGG','CPD:C05703',true).
concept_accession('36989: cpd:C05703','KEGG','C05703',true).
concept_accession('36986: cpd:C14869','KEGG','C14869',true).
concept_accession('36986: cpd:C14869','KEGG','CPD:C14869',true).
concept_accession('36987: cpd:C00364','KEGG','CPD:C00364',true).
concept_accession('36987: cpd:C00364','KEGG','C00364',true).
concept_accession('36984: cpd:C00214','KEGG','C00214',true).
concept_accession('36984: cpd:C00214','KEGG','CPD:C00214',true).
concept_accession('36982: cpd:C00459','KEGG','CPD:C00459',true).
concept_accession('36982: cpd:C00459','KEGG','C00459',true).
concept_accession('36983: cpd:C11088','KEGG','CPD:C11088',true).
concept_accession('36983: cpd:C11088','KEGG','C11088',true).
concept_accession('36980: cpd:C02218','KEGG','CPD:C02218',true).
concept_accession('36980: cpd:C02218','KEGG','C02218',true).
concept_accession('36981: cpd:C14870','KEGG','C14870',true).
concept_accession('36981: cpd:C14870','KEGG','CPD:C14870',true).
concept_accession('36978: cpd:C05336','KEGG','CPD:C05336',true).
concept_accession('36978: cpd:C05336','KEGG','C05336',true).
concept_accession('36979: cpd:C00363','KEGG','C00363',true).
concept_accession('36979: cpd:C00363','KEGG','CPD:C00363',true).
concept_accession('36976: cpd:C05698','KEGG','C05698',true).
concept_accession('36976: cpd:C05698','KEGG','CPD:C05698',true).
concept_accession('36977: cpd:C14871','KEGG','C14871',true).
concept_accession('36977: cpd:C14871','KEGG','CPD:C14871',true).
concept_accession('36941: cpd:C05379','KEGG','C05379',true).
concept_accession('36941: cpd:C05379','KEGG','CPD:C05379',true).
concept_accession('36940: cpd:C05527','KEGG','C05527',true).
concept_accession('36940: cpd:C05527','KEGG','CPD:C05527',true).
concept_accession('36942: cpd:C00365','KEGG','CPD:C00365',true).
concept_accession('36942: cpd:C00365','KEGG','C00365',true).
concept_accession('36936: cpd:C00881','KEGG','C00881',true).
concept_accession('36936: cpd:C00881','KEGG','CPD:C00881',true).
concept_accession('39122: gl:G00026','KEGG','GL:G00026',true).
concept_accession('39122: gl:G00026','KEGG','G00026',true).
concept_accession('36938: cpd:C01346','KEGG','C01346',true).
concept_accession('36938: cpd:C01346','KEGG','CPD:C01346',true).
concept_accession('36933: cpd:C00526','KEGG','C00526',true).
concept_accession('36933: cpd:C00526','KEGG','CPD:C00526',true).
concept_accession('36932: cpd:C18904','KEGG','C18904',true).
concept_accession('36932: cpd:C18904','KEGG','CPD:C18904',true).
concept_accession('39135: gl:G10611','KEGG','GL:G10611',true).
concept_accession('39135: gl:G10611','KEGG','G10611',true).
concept_accession('36935: cpd:C02763','KEGG','C02763',true).
concept_accession('36935: cpd:C02763','KEGG','CPD:C02763',true).
concept_accession('36934: cpd:C14859','KEGG','CPD:C14859',true).
concept_accession('36934: cpd:C14859','KEGG','C14859',true).
concept_accession('36929: cpd:C00460','KEGG','C00460',true).
concept_accession('36929: cpd:C00460','KEGG','CPD:C00460',true).
concept_accession('39128: gl:G00031','KEGG','G00031',true).
concept_accession('39128: gl:G00031','KEGG','GL:G00031',true).
concept_accession('39130: gl:G00032','KEGG','G00032',true).
concept_accession('39130: gl:G00032','KEGG','GL:G00032',true).
concept_accession('36930: cpd:C18902','KEGG','CPD:C18902',true).
concept_accession('36930: cpd:C18902','KEGG','C18902',true).
concept_accession('36956: cpd:C05172','KEGG','CPD:C05172',true).
concept_accession('36956: cpd:C05172','KEGG','C05172',true).
concept_accession('36958: cpd:C05684','KEGG','CPD:C05684',true).
concept_accession('36958: cpd:C05684','KEGG','C05684',true).
concept_accession('36959: cpd:C00906','KEGG','CPD:C00906',true).
concept_accession('36959: cpd:C00906','KEGG','C00906',true).
concept_accession('39104: gl:G00028','KEGG','G00028',true).
concept_accession('39104: gl:G00028','KEGG','GL:G00028',true).
concept_accession('36952: cpd:C00475','KEGG','CPD:C00475',true).
concept_accession('36952: cpd:C00475','KEGG','C00475',true).
concept_accession('39106: gl:G00029','KEGG','G00029',true).
concept_accession('39106: gl:G00029','KEGG','GL:G00029',true).
concept_accession('36954: gl:G00115','KEGG','GL:G00115',true).
concept_accession('36954: gl:G00115','KEGG','G00115',true).
concept_accession('36955: cpd:C00178','KEGG','C00178',true).
concept_accession('36955: cpd:C00178','KEGG','CPD:C00178',true).
concept_accession('36948: cpd:C00055','KEGG','C00055',true).
concept_accession('36948: cpd:C00055','KEGG','CPD:C00055',true).
concept_accession('36949: cpd:C00112','KEGG','CPD:C00112',true).
concept_accession('36949: cpd:C00112','KEGG','C00112',true).
concept_accession('36950: cpd:C01962','KEGG','C01962',true).
concept_accession('36950: cpd:C01962','KEGG','CPD:C01962',true).
concept_accession('39119: gl:G00025','KEGG','G00025',true).
concept_accession('39119: gl:G00025','KEGG','GL:G00025',true).
concept_accession('36951: cpd:C16254','KEGG','CPD:C16254',true).
concept_accession('36951: cpd:C16254','KEGG','C16254',true).
concept_accession('39112: gl:G00035','KEGG','GL:G00035',true).
concept_accession('39112: gl:G00035','KEGG','G00035',true).
concept_accession('36945: cpd:C00491','KEGG','C00491',true).
concept_accession('36945: cpd:C00491','KEGG','CPD:C00491',true).
concept_accession('36946: cpd:C05686','KEGG','C05686',true).
concept_accession('36946: cpd:C05686','KEGG','CPD:C05686',true).
concept_accession('39115: gl:G00023','KEGG','GL:G00023',true).
concept_accession('39115: gl:G00023','KEGG','G00023',true).
concept_accession('37026: cpd:C03406','KEGG','C03406',true).
concept_accession('37026: cpd:C03406','KEGG','CPD:C03406',true).
concept_accession('37027: cpd:C05993','KEGG','CPD:C05993',true).
concept_accession('37027: cpd:C05993','KEGG','C05993',true).
concept_accession('37024: cpd:C14856','KEGG','CPD:C14856',true).
concept_accession('37024: cpd:C14856','KEGG','C14856',true).
concept_accession('37025: cpd:C01097','KEGG','C01097',true).
concept_accession('37025: cpd:C01097','KEGG','CPD:C01097',true).
concept_accession('37031: cpd:C06205','KEGG','CPD:C06205',true).
concept_accession('37031: cpd:C06205','KEGG','C06205',true).
concept_accession('37028: cpd:C03785','KEGG','CPD:C03785',true).
concept_accession('37028: cpd:C03785','KEGG','C03785',true).
concept_accession('37029: cpd:C14853','KEGG','C14853',true).
concept_accession('37029: cpd:C14853','KEGG','CPD:C14853',true).
concept_accession('37035: cpd:C11821','KEGG','C11821',true).
concept_accession('37035: cpd:C11821','KEGG','CPD:C11821',true).
concept_accession('37038: cpd:C05402','KEGG','CPD:C05402',true).
concept_accession('37038: cpd:C05402','KEGG','C05402',true).
concept_accession('37039: cpd:C14556','KEGG','C14556',true).
concept_accession('37039: cpd:C14556','KEGG','CPD:C14556',true).
concept_accession('37037: cpd:C14784','KEGG','C14784',true).
concept_accession('37037: cpd:C14784','KEGG','CPD:C14784',true).
concept_accession('37042: cpd:C12248','KEGG','CPD:C12248',true).
concept_accession('37042: cpd:C12248','KEGG','C12248',true).
concept_accession('37045: cpd:C14850','KEGG','CPD:C14850',true).
concept_accession('37045: cpd:C14850','KEGG','C14850',true).
concept_accession('37054: gl:G00126','KEGG','GL:G00126',true).
concept_accession('37054: gl:G00126','KEGG','G00126',true).
concept_accession('36993: cpd:C01061','KEGG','C01061',true).
concept_accession('36993: cpd:C01061','KEGG','CPD:C01061',true).
concept_accession('36994: cpd:C01036','KEGG','CPD:C01036',true).
concept_accession('36994: cpd:C01036','KEGG','C01036',true).
concept_accession('36995: cpd:C00299','KEGG','C00299',true).
concept_accession('36995: cpd:C00299','KEGG','CPD:C00299',true).
concept_accession('36997: cpd:C14868','KEGG','C14868',true).
concept_accession('36997: cpd:C14868','KEGG','CPD:C14868',true).
concept_accession('36999: cpd:C14863','KEGG','C14863',true).
concept_accession('36999: cpd:C14863','KEGG','CPD:C14863',true).
concept_accession('37000: cpd:C00544','KEGG','CPD:C00544',true).
concept_accession('37000: cpd:C00544','KEGG','C00544',true).
concept_accession('37002: cpd:C14861','KEGG','C14861',true).
concept_accession('37002: cpd:C14861','KEGG','CPD:C14861',true).
concept_accession('37004: cpd:C14865','KEGG','C14865',true).
concept_accession('37004: cpd:C14865','KEGG','CPD:C14865',true).
concept_accession('37005: cpd:C14864','KEGG','C14864',true).
concept_accession('37005: cpd:C14864','KEGG','CPD:C14864',true).
concept_accession('37006: cpd:C00804','KEGG','CPD:C00804',true).
concept_accession('37006: cpd:C00804','KEGG','C00804',true).
concept_accession('37007: cpd:C14858','KEGG','CPD:C14858',true).
concept_accession('37007: cpd:C14858','KEGG','C14858',true).
concept_accession('37009: cpd:C00337','KEGG','C00337',true).
concept_accession('37009: cpd:C00337','KEGG','CPD:C00337',true).
concept_accession('37008: cpd:C14857','KEGG','CPD:C14857',true).
concept_accession('37008: cpd:C14857','KEGG','C14857',true).
concept_accession('37010: cpd:C01528','KEGG','CPD:C01528',true).
concept_accession('37010: cpd:C01528','KEGG','C01528',true).
concept_accession('37013: cpd:C01103','KEGG','C01103',true).
concept_accession('37013: cpd:C01103','KEGG','CPD:C01103',true).
concept_accession('37012: cpd:C05697','KEGG','C05697',true).
concept_accession('37012: cpd:C05697','KEGG','CPD:C05697',true).
concept_accession('37015: cpd:C14851','KEGG','C14851',true).
concept_accession('37015: cpd:C14851','KEGG','CPD:C14851',true).
concept_accession('37017: cpd:C14855','KEGG','C14855',true).
concept_accession('37017: cpd:C14855','KEGG','CPD:C14855',true).
concept_accession('37016: cpd:C00243','KEGG','C00243',true).
concept_accession('37016: cpd:C00243','KEGG','CPD:C00243',true).
concept_accession('37019: cpd:C14852','KEGG','C14852',true).
concept_accession('37019: cpd:C14852','KEGG','CPD:C14852',true).
concept_accession('37023: cpd:C01697','KEGG','C01697',true).
concept_accession('37023: cpd:C01697','KEGG','CPD:C01697',true).
concept_accession('37022: cpd:C14854','KEGG','C14854',true).
concept_accession('37022: cpd:C14854','KEGG','CPD:C14854',true).
concept_accession('37093: cpd:C05273','KEGG','CPD:C05273',true).
concept_accession('37093: cpd:C05273','KEGG','C05273',true).
concept_accession('37090: cpd:C17938','KEGG','C17938',true).
concept_accession('37090: cpd:C17938','KEGG','CPD:C17938',true).
concept_accession('37091: gl:G00103','KEGG','G00103',true).
concept_accession('37091: gl:G00103','KEGG','GL:G00103',true).
concept_accession('37089: cpd:C14847','KEGG','C14847',true).
concept_accession('37089: cpd:C14847','KEGG','CPD:C14847',true).
concept_accession('37102: cpd:C15978','KEGG','C15978',true).
concept_accession('37102: cpd:C15978','KEGG','CPD:C15978',true).
concept_accession('37100: cpd:C05381','KEGG','C05381',true).
concept_accession('37100: cpd:C05381','KEGG','CPD:C05381',true).
concept_accession('37101: gl:G00098','KEGG','GL:G00098',true).
concept_accession('37101: gl:G00098','KEGG','G00098',true).
concept_accession('37098: cpd:C02593','KEGG','CPD:C02593',true).
concept_accession('37098: cpd:C02593','KEGG','C02593',true).
concept_accession('37111: gl:G00099','KEGG','G00099',true).
concept_accession('37111: gl:G00099','KEGG','GL:G00099',true).
concept_accession('37110: cpd:C14801','KEGG','CPD:C14801',true).
concept_accession('37110: cpd:C14801','KEGG','C14801',true).
concept_accession('37109: cpd:C05272','KEGG','C05272',true).
concept_accession('37109: cpd:C05272','KEGG','CPD:C05272',true).
concept_accession('37106: gl:G00097','KEGG','GL:G00097',true).
concept_accession('37106: gl:G00097','KEGG','G00097',true).
concept_accession('37104: gl:G00104','KEGG','GL:G00104',true).
concept_accession('37104: gl:G00104','KEGG','G00104',true).
concept_accession('37119: cpd:C01042','KEGG','C01042',true).
concept_accession('37119: cpd:C01042','KEGG','CPD:C01042',true).
concept_accession('37117: cpd:C05260','KEGG','C05260',true).
concept_accession('37117: cpd:C05260','KEGG','CPD:C05260',true).
concept_accession('37115: cpd:C05261','KEGG','C05261',true).
concept_accession('37115: cpd:C05261','KEGG','CPD:C05261',true).
concept_accession('37114: cpd:C14848','KEGG','C14848',true).
concept_accession('37114: cpd:C14848','KEGG','CPD:C14848',true).
concept_accession('37112: cpd:C00402','KEGG','C00402',true).
concept_accession('37112: cpd:C00402','KEGG','CPD:C00402',true).
concept_accession('37063: cpd:C15974','KEGG','CPD:C15974',true).
concept_accession('37063: cpd:C15974','KEGG','C15974',true).
concept_accession('37058: gl:G00119','KEGG','GL:G00119',true).
concept_accession('37058: gl:G00119','KEGG','G00119',true).
concept_accession('37059: gl:G00118','KEGG','GL:G00118',true).
concept_accession('37059: gl:G00118','KEGG','G00118',true).
concept_accession('37065: gl:G00120','KEGG','G00120',true).
concept_accession('37065: gl:G00120','KEGG','GL:G00120',true).
concept_accession('38995: cpd:C05443','KEGG','C05443',true).
concept_accession('38995: cpd:C05443','KEGG','CPD:C05443',true).
concept_accession('37079: cpd:C15976','KEGG','C15976',true).
concept_accession('37079: cpd:C15976','KEGG','CPD:C15976',true).
concept_accession('37075: gl:G00127','KEGG','GL:G00127',true).
concept_accession('37075: gl:G00127','KEGG','G00127',true).
concept_accession('37084: gl:G00128','KEGG','GL:G00128',true).
concept_accession('37084: gl:G00128','KEGG','G00128',true).
concept_accession('37087: cpd:C14845','KEGG','C14845',true).
concept_accession('37087: cpd:C14845','KEGG','CPD:C14845',true).
concept_accession('37081: gl:G00129','KEGG','G00129',true).
concept_accession('37081: gl:G00129','KEGG','GL:G00129',true).
concept_accession('37177: cpd:C05581','KEGG','CPD:C05581',true).
concept_accession('37177: cpd:C05581','KEGG','C05581',true).
concept_accession('37179: cpd:C05966','KEGG','CPD:C05966',true).
concept_accession('37179: cpd:C05966','KEGG','C05966',true).
concept_accession('37180: cpd:C00294','KEGG','C00294',true).
concept_accession('37180: cpd:C00294','KEGG','CPD:C00294',true).
concept_accession('37181: cpd:C04043','KEGG','CPD:C04043',true).
concept_accession('37181: cpd:C04043','KEGG','C04043',true).
concept_accession('37183: cpd:C00130','KEGG','C00130',true).
concept_accession('37183: cpd:C00130','KEGG','CPD:C00130',true).
concept_accession('37168: cpd:C05583','KEGG','CPD:C05583',true).
concept_accession('37168: cpd:C05583','KEGG','C05583',true).
concept_accession('37169: cpd:C05582','KEGG','CPD:C05582',true).
concept_accession('37169: cpd:C05582','KEGG','C05582',true).
concept_accession('37172: cpd:C05956','KEGG','CPD:C05956',true).
concept_accession('37172: cpd:C05956','KEGG','C05956',true).
concept_accession('37173: cpd:C01161','KEGG','C01161',true).
concept_accession('37173: cpd:C01161','KEGG','CPD:C01161',true).
concept_accession('37175: cpd:C00262','KEGG','CPD:C00262',true).
concept_accession('37175: cpd:C00262','KEGG','C00262',true).
concept_accession('37160: cpd:C05580','KEGG','C05580',true).
concept_accession('37160: cpd:C05580','KEGG','CPD:C05580',true).
concept_accession('37163: cpd:C05584','KEGG','CPD:C05584',true).
concept_accession('37163: cpd:C05584','KEGG','C05584',true).
concept_accession('37162: cpd:C00639','KEGG','CPD:C00639',true).
concept_accession('37162: cpd:C00639','KEGG','C00639',true).
concept_accession('37165: cpd:C00427','KEGG','CPD:C00427',true).
concept_accession('37165: cpd:C00427','KEGG','C00427',true).
concept_accession('37166: cpd:C00212','KEGG','C00212',true).
concept_accession('37166: cpd:C00212','KEGG','CPD:C00212',true).
concept_accession('37153: cpd:C00206','KEGG','C00206',true).
concept_accession('37153: cpd:C00206','KEGG','CPD:C00206',true).
concept_accession('37152: cpd:C02166','KEGG','C02166',true).
concept_accession('37152: cpd:C02166','KEGG','CPD:C02166',true).
concept_accession('37154: cpd:C00547','KEGG','C00547',true).
concept_accession('37154: cpd:C00547','KEGG','CPD:C00547',true).
concept_accession('37156: cpd:C05284','KEGG','CPD:C05284',true).
concept_accession('37156: cpd:C05284','KEGG','C05284',true).
concept_accession('37158: cpd:C05577','KEGG','CPD:C05577',true).
concept_accession('37158: cpd:C05577','KEGG','C05577',true).
concept_accession('37146: cpd:C00584','KEGG','C00584',true).
concept_accession('37146: cpd:C00584','KEGG','CPD:C00584',true).
concept_accession('37147: cpd:C00788','KEGG','C00788',true).
concept_accession('37147: cpd:C00788','KEGG','CPD:C00788',true).
concept_accession('37144: cpd:C01312','KEGG','C01312',true).
concept_accession('37144: cpd:C01312','KEGG','CPD:C01312',true).
concept_accession('37145: cpd:C05588','KEGG','C05588',true).
concept_accession('37145: cpd:C05588','KEGG','CPD:C05588',true).
concept_accession('37150: cpd:C05356','KEGG','CPD:C05356',true).
concept_accession('37150: cpd:C05356','KEGG','C05356',true).
concept_accession('37151: cpd:C05589','KEGG','C05589',true).
concept_accession('37151: cpd:C05589','KEGG','CPD:C05589',true).
concept_accession('37149: cpd:C00131','KEGG','C00131',true).
concept_accession('37149: cpd:C00131','KEGG','CPD:C00131',true).
concept_accession('37138: cpd:C00322','KEGG','C00322',true).
concept_accession('37138: cpd:C00322','KEGG','CPD:C00322',true).
concept_accession('37136: cpd:C01613','KEGG','C01613',true).
concept_accession('37136: cpd:C01613','KEGG','CPD:C01613',true).
concept_accession('37142: cpd:C14791','KEGG','CPD:C14791',true).
concept_accession('37142: cpd:C14791','KEGG','C14791',true).
concept_accession('37143: cpd:C06198','KEGG','CPD:C06198',true).
concept_accession('37143: cpd:C06198','KEGG','C06198',true).
concept_accession('37130: cpd:C00864','KEGG','CPD:C00864',true).
concept_accession('37130: cpd:C00864','KEGG','C00864',true).
concept_accession('37128: gl:G00093','KEGG','G00093',true).
concept_accession('37128: gl:G00093','KEGG','GL:G00093',true).
concept_accession('37134: cpd:C05404','KEGG','CPD:C05404',true).
concept_accession('37134: cpd:C05404','KEGG','C05404',true).
concept_accession('37133: gl:G00094','KEGG','G00094',true).
concept_accession('37133: gl:G00094','KEGG','GL:G00094',true).
concept_accession('37123: cpd:C11713','KEGG','C11713',true).
concept_accession('37123: cpd:C11713','KEGG','CPD:C11713',true).
concept_accession('37122: cpd:C02362','KEGG','CPD:C02362',true).
concept_accession('37122: cpd:C02362','KEGG','C02362',true).
concept_accession('37121: cpd:C05258','KEGG','CPD:C05258',true).
concept_accession('37121: cpd:C05258','KEGG','C05258',true).
concept_accession('37120: cpd:C14453','KEGG','CPD:C14453',true).
concept_accession('37120: cpd:C14453','KEGG','C14453',true).
concept_accession('37126: gl:G00095','KEGG','GL:G00095',true).
concept_accession('37126: gl:G00095','KEGG','G00095',true).
concept_accession('37125: cpd:C01789','KEGG','C01789',true).
concept_accession('37125: cpd:C01789','KEGG','CPD:C01789',true).
concept_accession('37124: cpd:C05259','KEGG','CPD:C05259',true).
concept_accession('37124: cpd:C05259','KEGG','C05259',true).
concept_accession('37244: cpd:C00257','KEGG','C00257',true).
concept_accession('37244: cpd:C00257','KEGG','CPD:C00257',true).
concept_accession('37245: cpd:C04805','KEGG','CPD:C04805',true).
concept_accession('37245: cpd:C04805','KEGG','C04805',true).
concept_accession('37246: cpd:C00330','KEGG','CPD:C00330',true).
concept_accession('37246: cpd:C00330','KEGG','C00330',true).
concept_accession('37247: cpd:C00286','KEGG','C00286',true).
concept_accession('37247: cpd:C00286','KEGG','CPD:C00286',true).
concept_accession('37241: cpd:C00362','KEGG','C00362',true).
concept_accession('37241: cpd:C00362','KEGG','CPD:C00362',true).
concept_accession('37243: gl:G00037','KEGG','GL:G00037',true).
concept_accession('37243: gl:G00037','KEGG','G00037',true).
concept_accession('37232: cpd:C02442','KEGG','C02442',true).
concept_accession('37232: cpd:C02442','KEGG','CPD:C02442',true).
concept_accession('37235: cpd:C00242','KEGG','C00242',true).
concept_accession('37235: cpd:C00242','KEGG','CPD:C00242',true).
concept_accession('37229: cpd:C05594','KEGG','CPD:C05594',true).
concept_accession('37229: cpd:C05594','KEGG','C05594',true).
concept_accession('37228: gl:G10599','KEGG','G10599',true).
concept_accession('37228: gl:G10599','KEGG','GL:G10599',true).
concept_accession('37230: gl:G10598','KEGG','G10598',true).
concept_accession('37230: gl:G10598','KEGG','GL:G10598',true).
concept_accession('37227: cpd:C05576','KEGG','CPD:C05576',true).
concept_accession('37227: cpd:C05576','KEGG','C05576',true).
concept_accession('37221: cpd:C06199','KEGG','CPD:C06199',true).
concept_accession('37221: cpd:C06199','KEGG','C06199',true).
concept_accession('37220: cpd:C00140','KEGG','C00140',true).
concept_accession('37220: cpd:C00140','KEGG','CPD:C00140',true).
concept_accession('37217: cpd:C01040','KEGG','CPD:C01040',true).
concept_accession('37217: cpd:C01040','KEGG','C01040',true).
concept_accession('37216: cpd:C00461','KEGG','C00461',true).
concept_accession('37216: cpd:C00461','KEGG','CPD:C00461',true).
concept_accession('37219: cpd:C00818','KEGG','C00818',true).
concept_accession('37219: cpd:C00818','KEGG','CPD:C00818',true).
concept_accession('37214: cpd:C01260','KEGG','C01260',true).
concept_accession('37214: cpd:C01260','KEGG','CPD:C01260',true).
concept_accession('37208: cpd:C02350','KEGG','CPD:C02350',true).
concept_accession('37208: cpd:C02350','KEGG','C02350',true).
concept_accession('37209: cpd:C01674','KEGG','C01674',true).
concept_accession('37209: cpd:C01674','KEGG','CPD:C01674',true).
concept_accession('37207: cpd:C00499','KEGG','C00499',true).
concept_accession('37207: cpd:C00499','KEGG','CPD:C00499',true).
concept_accession('37205: cpd:C02670','KEGG','CPD:C02670',true).
concept_accession('37205: cpd:C02670','KEGG','C02670',true).
concept_accession('37202: cpd:C00329','KEGG','CPD:C00329',true).
concept_accession('37202: cpd:C00329','KEGG','C00329',true).
concept_accession('37203: cpd:C00366','KEGG','CPD:C00366',true).
concept_accession('37203: cpd:C00366','KEGG','C00366',true).
concept_accession('37201: cpd:C00696','KEGG','CPD:C00696',true).
concept_accession('37201: cpd:C00696','KEGG','C00696',true).
concept_accession('37199: cpd:C02515','KEGG','CPD:C02515',true).
concept_accession('37199: cpd:C02515','KEGG','C02515',true).
concept_accession('37198: cpd:C04853','KEGG','C04853',true).
concept_accession('37198: cpd:C04853','KEGG','CPD:C04853',true).
concept_accession('37196: cpd:C01060','KEGG','C01060',true).
concept_accession('37196: cpd:C01060','KEGG','CPD:C01060',true).
concept_accession('37195: gl:G00157','KEGG','G00157',true).
concept_accession('37195: gl:G00157','KEGG','GL:G00157',true).
concept_accession('37193: cpd:C02465','KEGG','CPD:C02465',true).
concept_accession('37193: cpd:C02465','KEGG','C02465',true).
concept_accession('37191: cpd:C00603','KEGG','C00603',true).
concept_accession('37191: cpd:C00603','KEGG','CPD:C00603',true).
concept_accession('37190: cpd:C05951','KEGG','C05951',true).
concept_accession('37190: cpd:C05951','KEGG','CPD:C05951',true).
concept_accession('37188: cpd:C01829','KEGG','C01829',true).
concept_accession('37188: cpd:C01829','KEGG','CPD:C01829',true).
concept_accession('37186: cpd:C00620','KEGG','CPD:C00620',true).
concept_accession('37186: cpd:C00620','KEGG','C00620',true).
concept_accession('37185: cpd:C05965','KEGG','CPD:C05965',true).
concept_accession('37185: cpd:C05965','KEGG','C05965',true).
concept_accession('37297: cpd:C00673','KEGG','C00673',true).
concept_accession('37297: cpd:C00673','KEGG','CPD:C00673',true).
concept_accession('37296: cpd:C04751','KEGG','C04751',true).
concept_accession('37296: cpd:C04751','KEGG','CPD:C04751',true).
concept_accession('37299: cpd:C05578','KEGG','CPD:C05578',true).
concept_accession('37299: cpd:C05578','KEGG','C05578',true).
concept_accession('37300: cpd:C04640','KEGG','C04640',true).
concept_accession('37300: cpd:C04640','KEGG','CPD:C04640',true).
concept_accession('37303: gl:G00042','KEGG','G00042',true).
concept_accession('37303: gl:G00042','KEGG','GL:G00042',true).
concept_accession('37302: cpd:C01801','KEGG','CPD:C01801',true).
concept_accession('37302: cpd:C01801','KEGG','C01801',true).
concept_accession('37305: cpd:C05579','KEGG','CPD:C05579',true).
concept_accession('37305: cpd:C05579','KEGG','C05579',true).
concept_accession('37304: cpd:C16356','KEGG','C16356',true).
concept_accession('37304: cpd:C16356','KEGG','CPD:C16356',true).
concept_accession('37307: cpd:C04376','KEGG','C04376',true).
concept_accession('37307: cpd:C04376','KEGG','CPD:C04376',true).
concept_accession('37308: cpd:C00355','KEGG','CPD:C00355',true).
concept_accession('37308: cpd:C00355','KEGG','C00355',true).
concept_accession('37310: cpd:C04823','KEGG','CPD:C04823',true).
concept_accession('37310: cpd:C04823','KEGG','C04823',true).
concept_accession('37281: cpd:C00104','KEGG','C00104',true).
concept_accession('37281: cpd:C00104','KEGG','CPD:C00104',true).
concept_accession('37282: cpd:C00642','KEGG','C00642',true).
concept_accession('37282: cpd:C00642','KEGG','CPD:C00642',true).
concept_accession('37285: cpd:C00081','KEGG','CPD:C00081',true).
concept_accession('37285: cpd:C00081','KEGG','C00081',true).
concept_accession('37289: cpd:C01345','KEGG','C01345',true).
concept_accession('37289: cpd:C01345','KEGG','CPD:C01345',true).
concept_accession('37290: cpd:C16358','KEGG','CPD:C16358',true).
concept_accession('37290: cpd:C16358','KEGG','C16358',true).
concept_accession('37294: cpd:C01693','KEGG','C01693',true).
concept_accession('37294: cpd:C01693','KEGG','CPD:C01693',true).
concept_accession('37267: cpd:C00144','KEGG','CPD:C00144',true).
concept_accession('37267: cpd:C00144','KEGG','C00144',true).
concept_accession('37265: cpd:C00999','KEGG','C00999',true).
concept_accession('37265: cpd:C00999','KEGG','CPD:C00999',true).
concept_accession('37271: gl:G00039','KEGG','G00039',true).
concept_accession('37271: gl:G00039','KEGG','GL:G00039',true).
concept_accession('37269: cpd:C01228','KEGG','C01228',true).
concept_accession('37269: cpd:C01228','KEGG','CPD:C01228',true).
concept_accession('37268: cpd:C03691','KEGG','C03691',true).
concept_accession('37268: cpd:C03691','KEGG','CPD:C03691',true).
concept_accession('37275: cpd:C00996','KEGG','C00996',true).
concept_accession('37275: cpd:C00996','KEGG','CPD:C00996',true).
concept_accession('37273: gl:G00044','KEGG','GL:G00044',true).
concept_accession('37273: gl:G00044','KEGG','G00044',true).
concept_accession('37277: cpd:C00387','KEGG','CPD:C00387',true).
concept_accession('37277: cpd:C00387','KEGG','C00387',true).
concept_accession('37250: gl:G10526','KEGG','G10526',true).
concept_accession('37250: gl:G10526','KEGG','GL:G10526',true).
concept_accession('37248: cpd:C00198','KEGG','CPD:C00198',true).
concept_accession('37248: cpd:C00198','KEGG','C00198',true).
concept_accession('37254: cpd:C00345','KEGG','C00345',true).
concept_accession('37254: cpd:C00345','KEGG','CPD:C00345',true).
concept_accession('37252: gl:G10595','KEGG','GL:G10595',true).
concept_accession('37252: gl:G10595','KEGG','G10595',true).
concept_accession('37253: gl:G00038','KEGG','G00038',true).
concept_accession('37253: gl:G00038','KEGG','GL:G00038',true).
concept_accession('37258: gl:G10597','KEGG','GL:G10597',true).
concept_accession('37258: gl:G10597','KEGG','G10597',true).
concept_accession('37256: cpd:C00361','KEGG','C00361',true).
concept_accession('37256: cpd:C00361','KEGG','CPD:C00361',true).
concept_accession('37257: cpd:C05585','KEGG','CPD:C05585',true).
concept_accession('37257: cpd:C05585','KEGG','C05585',true).
concept_accession('37262: cpd:C00035','KEGG','CPD:C00035',true).
concept_accession('37262: cpd:C00035','KEGG','C00035',true).
concept_accession('37260: cpd:C03410','KEGG','C03410',true).
concept_accession('37260: cpd:C03410','KEGG','CPD:C03410',true).
concept_accession('37261: cpd:C04494','KEGG','C04494',true).
concept_accession('37261: cpd:C04494','KEGG','CPD:C04494',true).
concept_accession('37365: cpd:C16219','KEGG','C16219',true).
concept_accession('37365: cpd:C16219','KEGG','CPD:C16219',true).
concept_accession('37367: cpd:C04088','KEGG','CPD:C04088',true).
concept_accession('37367: cpd:C04088','KEGG','C04088',true).
concept_accession('37366: gl:G00002','KEGG','G00002',true).
concept_accession('37366: gl:G00002','KEGG','GL:G00002',true).
concept_accession('37360: cpd:C04742','KEGG','CPD:C04742',true).
concept_accession('37360: cpd:C04742','KEGG','C04742',true).
concept_accession('37373: cpd:C05983','KEGG','C05983',true).
concept_accession('37373: cpd:C05983','KEGG','CPD:C05983',true).
concept_accession('37369: gl:G00001','KEGG','GL:G00001',true).
concept_accession('37369: gl:G00001','KEGG','G00001',true).
concept_accession('37368: cpd:C14781','KEGG','CPD:C14781',true).
concept_accession('37368: cpd:C14781','KEGG','C14781',true).
concept_accession('37371: cpd:C14813','KEGG','CPD:C14813',true).
concept_accession('37371: cpd:C14813','KEGG','C14813',true).
concept_accession('37348: cpd:C00270','KEGG','CPD:C00270',true).
concept_accession('37348: cpd:C00270','KEGG','C00270',true).
concept_accession('37350: cpd:C00909','KEGG','CPD:C00909',true).
concept_accession('37350: cpd:C00909','KEGG','C00909',true).
concept_accession('37344: cpd:C06241','KEGG','CPD:C06241',true).
concept_accession('37344: cpd:C06241','KEGG','C06241',true).
concept_accession('37346: cpd:C02198','KEGG','CPD:C02198',true).
concept_accession('37346: cpd:C02198','KEGG','C02198',true).
concept_accession('37347: cpd:C01261','KEGG','C01261',true).
concept_accession('37347: cpd:C01261','KEGG','CPD:C01261',true).
concept_accession('37358: cpd:C01203','KEGG','CPD:C01203',true).
concept_accession('37358: cpd:C01203','KEGG','C01203',true).
concept_accession('37352: cpd:C00822','KEGG','CPD:C00822',true).
concept_accession('37352: cpd:C00822','KEGG','C00822',true).
concept_accession('37353: cpd:C00128','KEGG','C00128',true).
concept_accession('37353: cpd:C00128','KEGG','CPD:C00128',true).
concept_accession('37354: cpd:C02165','KEGG','C02165',true).
concept_accession('37354: cpd:C02165','KEGG','CPD:C02165',true).
concept_accession('37355: cpd:C00121','KEGG','C00121',true).
concept_accession('37355: cpd:C00121','KEGG','CPD:C00121',true).
concept_accession('37335: cpd:C16360','KEGG','CPD:C16360',true).
concept_accession('37335: cpd:C16360','KEGG','C16360',true).
concept_accession('37334: cpd:C00645','KEGG','C00645',true).
concept_accession('37334: cpd:C00645','KEGG','CPD:C00645',true).
concept_accession('37332: cpd:C03021','KEGG','CPD:C03021',true).
concept_accession('37332: cpd:C03021','KEGG','C03021',true).
concept_accession('37331: cpd:C00483','KEGG','C00483',true).
concept_accession('37331: cpd:C00483','KEGG','CPD:C00483',true).
concept_accession('37330: cpd:C04501','KEGG','CPD:C04501',true).
concept_accession('37330: cpd:C04501','KEGG','C04501',true).
concept_accession('37329: cpd:C16365','KEGG','C16365',true).
concept_accession('37329: cpd:C16365','KEGG','CPD:C16365',true).
concept_accession('37328: gl:G00047','KEGG','G00047',true).
concept_accession('37328: gl:G00047','KEGG','GL:G00047',true).
concept_accession('37343: cpd:C00381','KEGG','C00381',true).
concept_accession('37343: cpd:C00381','KEGG','CPD:C00381',true).
concept_accession('37341: cpd:C00942','KEGG','CPD:C00942',true).
concept_accession('37341: cpd:C00942','KEGG','C00942',true).
concept_accession('37340: cpd:C04257','KEGG','C04257',true).
concept_accession('37340: cpd:C04257','KEGG','CPD:C04257',true).
concept_accession('37339: cpd:C00110','KEGG','CPD:C00110',true).
concept_accession('37339: cpd:C00110','KEGG','C00110',true).
concept_accession('37337: cpd:C05350','KEGG','CPD:C05350',true).
concept_accession('37337: cpd:C05350','KEGG','C05350',true).
concept_accession('37336: cpd:C03862','KEGG','CPD:C03862',true).
concept_accession('37336: cpd:C03862','KEGG','C03862',true).
concept_accession('37318: cpd:C04677','KEGG','CPD:C04677',true).
concept_accession('37318: cpd:C04677','KEGG','C04677',true).
concept_accession('37316: cpd:C03758','KEGG','CPD:C03758',true).
concept_accession('37316: cpd:C03758','KEGG','C03758',true).
concept_accession('37314: cpd:C01236','KEGG','C01236',true).
concept_accession('37314: cpd:C01236','KEGG','CPD:C01236',true).
concept_accession('37312: cpd:C07480','KEGG','C07480',true).
concept_accession('37312: cpd:C07480','KEGG','CPD:C07480',true).
concept_accession('37313: cpd:C03838','KEGG','C03838',true).
concept_accession('37313: cpd:C03838','KEGG','CPD:C03838',true).
concept_accession('37326: cpd:C01246','KEGG','CPD:C01246',true).
concept_accession('37326: cpd:C01246','KEGG','C01246',true).
concept_accession('37327: cpd:C01344','KEGG','C01344',true).
concept_accession('37327: cpd:C01344','KEGG','CPD:C01344',true).
concept_accession('37324: cpd:C16353','KEGG','C16353',true).
concept_accession('37324: cpd:C16353','KEGG','CPD:C16353',true).
concept_accession('37325: cpd:C03765','KEGG','CPD:C03765',true).
concept_accession('37325: cpd:C03765','KEGG','C03765',true).
concept_accession('37322: cpd:C00357','KEGG','C00357',true).
concept_accession('37322: cpd:C00357','KEGG','CPD:C00357',true).
concept_accession('37321: cpd:C05587','KEGG','CPD:C05587',true).
concept_accession('37321: cpd:C05587','KEGG','C05587',true).
concept_accession('37388: gl:G00017','KEGG','G00017',true).
concept_accession('37388: gl:G00017','KEGG','GL:G00017',true).
concept_accession('37391: gl:G00016','KEGG','G00016',true).
concept_accession('37391: gl:G00016','KEGG','GL:G00016',true).
concept_accession('37390: gl:G00007','KEGG','G00007',true).
concept_accession('37390: gl:G00007','KEGG','GL:G00007',true).
concept_accession('37385: cpd:C05984','KEGG','C05984',true).
concept_accession('37385: cpd:C05984','KEGG','CPD:C05984',true).
concept_accession('37384: cpd:C06049','KEGG','CPD:C06049',true).
concept_accession('37384: cpd:C06049','KEGG','C06049',true).
concept_accession('37387: gl:G00008','KEGG','G00008',true).
concept_accession('37387: gl:G00008','KEGG','GL:G00008',true).
concept_accession('37381: gl:G00006','KEGG','G00006',true).
concept_accession('37381: gl:G00006','KEGG','GL:G00006',true).
concept_accession('37383: gl:G00005','KEGG','G00005',true).
concept_accession('37383: gl:G00005','KEGG','GL:G00005',true).
concept_accession('37377: gl:G00003','KEGG','G00003',true).
concept_accession('37377: gl:G00003','KEGG','GL:G00003',true).
concept_accession('37376: gl:G00004','KEGG','G00004',true).
concept_accession('37376: gl:G00004','KEGG','GL:G00004',true).
concept_accession('37379: cpd:C05985','KEGG','C05985',true).
concept_accession('37379: cpd:C05985','KEGG','CPD:C05985',true).
concept_accession('37404: gl:G00019','KEGG','GL:G00019',true).
concept_accession('37404: gl:G00019','KEGG','G00019',true).
concept_accession('37407: gl:G00020','KEGG','GL:G00020',true).
concept_accession('37407: gl:G00020','KEGG','G00020',true).
concept_accession('37402: gl:G00018','KEGG','G00018',true).
concept_accession('37402: gl:G00018','KEGG','GL:G00018',true).
concept_accession('37403: cpd:C00988','KEGG','CPD:C00988',true).
concept_accession('37403: cpd:C00988','KEGG','C00988',true).
concept_accession('37396: cpd:C00886','KEGG','C00886',true).
concept_accession('37396: cpd:C00886','KEGG','CPD:C00886',true).
concept_accession('37397: cpd:C01931','KEGG','C01931',true).
concept_accession('37397: cpd:C01931','KEGG','CPD:C01931',true).
concept_accession('37392: cpd:C00021','KEGG','CPD:C00021',true).
concept_accession('37392: cpd:C00021','KEGG','C00021',true).
concept_accession('37393: gl:G00171','KEGG','G00171',true).
concept_accession('37393: gl:G00171','KEGG','GL:G00171',true).
concept_accession('37395: gl:G00009','KEGG','G00009',true).
concept_accession('37395: gl:G00009','KEGG','GL:G00009',true).
concept_accession('37422: cpd:C14812','KEGG','CPD:C14812',true).
concept_accession('37422: cpd:C14812','KEGG','C14812',true).
concept_accession('37421: gl:G00072','KEGG','GL:G00072',true).
concept_accession('37421: gl:G00072','KEGG','G00072',true).
concept_accession('37420: cpd:C02412','KEGG','CPD:C02412',true).
concept_accession('37420: cpd:C02412','KEGG','C02412',true).
concept_accession('37419: gl:G00073','KEGG','GL:G00073',true).
concept_accession('37419: gl:G00073','KEGG','G00073',true).
concept_accession('37417: cpd:C06424','KEGG','C06424',true).
concept_accession('37417: cpd:C06424','KEGG','CPD:C06424',true).
concept_accession('37415: cpd:C02679','KEGG','CPD:C02679',true).
concept_accession('37415: cpd:C02679','KEGG','C02679',true).
concept_accession('37414: cpd:C02839','KEGG','CPD:C02839',true).
concept_accession('37414: cpd:C02839','KEGG','C02839',true).
concept_accession('37412: cpd:C02992','KEGG','CPD:C02992',true).
concept_accession('37412: cpd:C02992','KEGG','C02992',true).
concept_accession('37411: gl:G00022','KEGG','G00022',true).
concept_accession('37411: gl:G00022','KEGG','GL:G00022',true).
concept_accession('37410: cpd:C03512','KEGG','C03512',true).
concept_accession('37410: cpd:C03512','KEGG','CPD:C03512',true).
concept_accession('37408: gl:G00021','KEGG','GL:G00021',true).
concept_accession('37408: gl:G00021','KEGG','G00021',true).
concept_accession('37438: cpd:C02984','KEGG','C02984',true).
concept_accession('37438: cpd:C02984','KEGG','CPD:C02984',true).
concept_accession('37439: gl:G00074','KEGG','G00074',true).
concept_accession('37439: gl:G00074','KEGG','GL:G00074',true).
concept_accession('37436: gl:G00075','KEGG','G00075',true).
concept_accession('37436: gl:G00075','KEGG','GL:G00075',true).
concept_accession('37434: cpd:C02553','KEGG','CPD:C02553',true).
concept_accession('37434: cpd:C02553','KEGG','C02553',true).
concept_accession('37432: cpd:C00760','KEGG','CPD:C00760',true).
concept_accession('37432: cpd:C00760','KEGG','C00760',true).
concept_accession('37433: gl:G00083','KEGG','GL:G00083',true).
concept_accession('37433: gl:G00083','KEGG','G00083',true).
concept_accession('37429: gl:G00082','KEGG','GL:G00082',true).
concept_accession('37429: gl:G00082','KEGG','G00082',true).
concept_accession('37426: cpd:C02702','KEGG','C02702',true).
concept_accession('37426: cpd:C02702','KEGG','CPD:C02702',true).
concept_accession('37427: gl:G10596','KEGG','GL:G10596',true).
concept_accession('37427: gl:G10596','KEGG','G10596',true).
concept_accession('37424: gl:G00071','KEGG','GL:G00071',true).
concept_accession('37424: gl:G00071','KEGG','G00071',true).
concept_accession('37448: cpd:C02987','KEGG','C02987',true).
concept_accession('37448: cpd:C02987','KEGG','CPD:C02987',true).
concept_accession('37451: gl:G00055','KEGG','G00055',true).
concept_accession('37451: gl:G00055','KEGG','GL:G00055',true).
concept_accession('37450: gl:G00056','KEGG','G00056',true).
concept_accession('37450: gl:G00056','KEGG','GL:G00056',true).
concept_accession('37452: cpd:C14748','KEGG','C14748',true).
concept_accession('37452: cpd:C14748','KEGG','CPD:C14748',true).
concept_accession('37455: gl:G00081','KEGG','GL:G00081',true).
concept_accession('37455: gl:G00081','KEGG','G00081',true).
concept_accession('37454: cpd:C03294','KEGG','C03294',true).
concept_accession('37454: cpd:C03294','KEGG','CPD:C03294',true).
concept_accession('37440: gl:G00068','KEGG','G00068',true).
concept_accession('37440: gl:G00068','KEGG','GL:G00068',true).
concept_accession('37443: cpd:C00252','KEGG','CPD:C00252',true).
concept_accession('37443: cpd:C00252','KEGG','C00252',true).
concept_accession('37445: gl:G00076','KEGG','G00076',true).
concept_accession('37445: gl:G00076','KEGG','GL:G00076',true).
concept_accession('37465: gl:G00059','KEGG','G00059',true).
concept_accession('37465: gl:G00059','KEGG','GL:G00059',true).
concept_accession('37466: cpd:C14773','KEGG','CPD:C14773',true).
concept_accession('37466: cpd:C14773','KEGG','C14773',true).
concept_accession('37468: gl:G00054','KEGG','G00054',true).
concept_accession('37468: gl:G00054','KEGG','GL:G00054',true).
concept_accession('37469: cpd:C14772','KEGG','CPD:C14772',true).
concept_accession('37469: cpd:C14772','KEGG','C14772',true).
concept_accession('37458: cpd:C03289','KEGG','C03289',true).
concept_accession('37458: cpd:C03289','KEGG','CPD:C03289',true).
concept_accession('37459: cpd:C02430','KEGG','CPD:C02430',true).
concept_accession('37459: cpd:C02430','KEGG','C02430',true).
concept_accession('37461: gl:G00077','KEGG','G00077',true).
concept_accession('37461: gl:G00077','KEGG','GL:G00077',true).
concept_accession('37462: cpd:C14823','KEGG','C14823',true).
concept_accession('37462: cpd:C14823','KEGG','CPD:C14823',true).
concept_accession('37463: cpd:C03402','KEGG','C03402',true).
concept_accession('37463: cpd:C03402','KEGG','CPD:C03402',true).
concept_accession('37483: cpd:C02988','KEGG','C02988',true).
concept_accession('37483: cpd:C02988','KEGG','CPD:C02988',true).
concept_accession('37482: cpd:C14749','KEGG','C14749',true).
concept_accession('37482: cpd:C14749','KEGG','CPD:C14749',true).
concept_accession('37481: gl:G00052','KEGG','G00052',true).
concept_accession('37481: gl:G00052','KEGG','GL:G00052',true).
concept_accession('37480: cpd:C00185','KEGG','CPD:C00185',true).
concept_accession('37480: cpd:C00185','KEGG','C00185',true).
concept_accession('37486: gl:G00050','KEGG','G00050',true).
concept_accession('37486: gl:G00050','KEGG','GL:G00050',true).
concept_accession('37485: gl:G00036','KEGG','GL:G00036',true).
concept_accession('37485: gl:G00036','KEGG','G00036',true).
concept_accession('37473: cpd:C14775','KEGG','C14775',true).
concept_accession('37473: cpd:C14775','KEGG','CPD:C14775',true).
concept_accession('37479: gl:G00051','KEGG','G00051',true).
concept_accession('37479: gl:G00051','KEGG','GL:G00051',true).
concept_accession('37478: cpd:C03511','KEGG','C03511',true).
concept_accession('37478: cpd:C03511','KEGG','CPD:C03511',true).
concept_accession('37477: cpd:C14774','KEGG','C14774',true).
concept_accession('37477: cpd:C14774','KEGG','CPD:C14774',true).
concept_accession('37476: gl:G00058','KEGG','G00058',true).
concept_accession('37476: gl:G00058','KEGG','GL:G00058',true).
concept_accession('37498: cpd:C00559','KEGG','C00559',true).
concept_accession('37498: cpd:C00559','KEGG','CPD:C00559',true).
concept_accession('37499: cpd:C02163','KEGG','C02163',true).
concept_accession('37499: cpd:C02163','KEGG','CPD:C02163',true).
concept_accession('37497: cpd:C14814','KEGG','CPD:C14814',true).
concept_accession('37497: cpd:C14814','KEGG','C14814',true).
concept_accession('37503: cpd:C04734','KEGG','CPD:C04734',true).
concept_accession('37503: cpd:C04734','KEGG','C04734',true).
concept_accession('37500: cpd:C14782','KEGG','C14782',true).
concept_accession('37500: cpd:C14782','KEGG','CPD:C14782',true).
concept_accession('37501: cpd:C00360','KEGG','C00360',true).
concept_accession('37501: cpd:C00360','KEGG','CPD:C00360',true).
concept_accession('37490: cpd:C00369','KEGG','CPD:C00369',true).
concept_accession('37490: cpd:C00369','KEGG','C00369',true).
concept_accession('37489: cpd:C02282','KEGG','CPD:C02282',true).
concept_accession('37489: cpd:C02282','KEGG','C02282',true).
concept_accession('37494: cpd:C05512','KEGG','C05512',true).
concept_accession('37494: cpd:C05512','KEGG','CPD:C05512',true).
concept_accession('37495: cpd:C00718','KEGG','CPD:C00718',true).
concept_accession('37495: cpd:C00718','KEGG','C00718',true).
concept_accession('37492: cpd:C14778','KEGG','C14778',true).
concept_accession('37492: cpd:C14778','KEGG','CPD:C14778',true).
concept_accession('37508: cpd:C14768','KEGG','C14768',true).
concept_accession('37508: cpd:C14768','KEGG','CPD:C14768',true).
concept_accession('37511: cpd:C04392','KEGG','C04392',true).
concept_accession('37511: cpd:C04392','KEGG','CPD:C04392',true).
concept_accession('37504: cpd:C14769','KEGG','C14769',true).
concept_accession('37504: cpd:C14769','KEGG','CPD:C14769',true).
concept_accession('37505: cpd:C03125','KEGG','CPD:C03125',true).
concept_accession('37505: cpd:C03125','KEGG','C03125',true).
concept_accession('37512: cpd:C14771','KEGG','CPD:C14771',true).
concept_accession('37512: cpd:C14771','KEGG','C14771',true).
concept_accession('37514: cpd:C01798','KEGG','C01798',true).
concept_accession('37514: cpd:C01798','KEGG','CPD:C01798',true).
concept_accession('37515: cpd:C14770','KEGG','CPD:C14770',true).
concept_accession('37515: cpd:C14770','KEGG','C14770',true).
concept_accession('37525: cpd:C00831','KEGG','CPD:C00831',true).
concept_accession('37525: cpd:C00831','KEGG','C00831',true).
concept_accession('37524: cpd:C02530','KEGG','CPD:C02530',true).
concept_accession('37524: cpd:C02530','KEGG','C02530',true).
concept_accession('37522: cpd:C04079','KEGG','CPD:C04079',true).
concept_accession('37522: cpd:C04079','KEGG','C04079',true).
concept_accession('37533: gl:G00162','KEGG','GL:G00162',true).
concept_accession('37533: gl:G00162','KEGG','G00162',true).
concept_accession('37532: cpd:C01134','KEGG','C01134',true).
concept_accession('37532: cpd:C01134','KEGG','CPD:C01134',true).
concept_accession('37534: gl:G00164','KEGG','GL:G00164',true).
concept_accession('37534: gl:G00164','KEGG','G00164',true).
concept_accession('37531: gl:G00163','KEGG','GL:G00163',true).
concept_accession('37531: gl:G00163','KEGG','G00163',true).
concept_accession('37530: cpd:C00882','KEGG','C00882',true).
concept_accession('37530: cpd:C00882','KEGG','CPD:C00882',true).
concept_accession('37541: cpd:C05437','KEGG','C05437',true).
concept_accession('37541: cpd:C05437','KEGG','CPD:C05437',true).
concept_accession('37539: cpd:C04352','KEGG','C04352',true).
concept_accession('37539: cpd:C04352','KEGG','CPD:C04352',true).
concept_accession('37550: cpd:C01189','KEGG','C01189',true).
concept_accession('37550: cpd:C01189','KEGG','CPD:C01189',true).
concept_accession('37548: cpd:C01164','KEGG','CPD:C01164',true).
concept_accession('37548: cpd:C01164','KEGG','C01164',true).
concept_accession('37544: cpd:C05103','KEGG','C05103',true).
concept_accession('37544: cpd:C05103','KEGG','CPD:C05103',true).
concept_accession('37553: cpd:C15816','KEGG','C15816',true).
concept_accession('37553: cpd:C15816','KEGG','CPD:C15816',true).
concept_accession('37567: cpd:C05439','KEGG','C05439',true).
concept_accession('37567: cpd:C05439','KEGG','CPD:C05439',true).
concept_accession('37575: cpd:C11522','KEGG','CPD:C11522',true).
concept_accession('37575: cpd:C11522','KEGG','C11522',true).
concept_accession('37578: cpd:C03845','KEGG','C03845',true).
concept_accession('37578: cpd:C03845','KEGG','CPD:C03845',true).
concept_accession('37584: cpd:C03492','KEGG','CPD:C03492',true).
concept_accession('37584: cpd:C03492','KEGG','C03492',true).
concept_accession('37590: cpd:C07481','KEGG','C07481',true).
concept_accession('37590: cpd:C07481','KEGG','CPD:C07481',true).
concept_accession('37610: cpd:C06213','KEGG','CPD:C06213',true).
concept_accession('37610: cpd:C06213','KEGG','C06213',true).
concept_accession('37611: cpd:C16359','KEGG','C16359',true).
concept_accession('37611: cpd:C16359','KEGG','CPD:C16359',true).
concept_accession('37608: cpd:C14819','KEGG','C14819',true).
concept_accession('37608: cpd:C14819','KEGG','CPD:C14819',true).
concept_accession('37609: cpd:C06212','KEGG','C06212',true).
concept_accession('37609: cpd:C06212','KEGG','CPD:C06212',true).
concept_accession('37615: cpd:C16355','KEGG','C16355',true).
concept_accession('37615: cpd:C16355','KEGG','CPD:C16355',true).
concept_accession('37613: cpd:C05653','KEGG','CPD:C05653',true).
concept_accession('37613: cpd:C05653','KEGG','C05653',true).
concept_accession('37619: cpd:C15519','KEGG','CPD:C15519',true).
concept_accession('37619: cpd:C15519','KEGG','C15519',true).
concept_accession('37617: cpd:C15610','KEGG','C15610',true).
concept_accession('37617: cpd:C15610','KEGG','CPD:C15610',true).
concept_accession('37623: cpd:C16361','KEGG','CPD:C16361',true).
concept_accession('37623: cpd:C16361','KEGG','C16361',true).
concept_accession('37622: cpd:C03594','KEGG','C03594',true).
concept_accession('37622: cpd:C03594','KEGG','CPD:C03594',true).
concept_accession('37627: cpd:C13550','KEGG','CPD:C13550',true).
concept_accession('37627: cpd:C13550','KEGG','C13550',true).
concept_accession('37626: cpd:C16362','KEGG','C16362',true).
concept_accession('37626: cpd:C16362','KEGG','CPD:C16362',true).
concept_accession('37625: cpd:C17333','KEGG','CPD:C17333',true).
concept_accession('37625: cpd:C17333','KEGG','C17333',true).
concept_accession('37624: cpd:C17336','KEGG','C17336',true).
concept_accession('37624: cpd:C17336','KEGG','CPD:C17336',true).
concept_accession('37629: cpd:C05455','KEGG','C05455',true).
concept_accession('37629: cpd:C05455','KEGG','CPD:C05455',true).
concept_accession('37628: cpd:C13747','KEGG','C13747',true).
concept_accession('37628: cpd:C13747','KEGG','CPD:C13747',true).
concept_accession('37662: cpd:C05444','KEGG','CPD:C05444',true).
concept_accession('37662: cpd:C05444','KEGG','C05444',true).
concept_accession('37663: cpd:C05130','KEGG','CPD:C05130',true).
concept_accession('37663: cpd:C05130','KEGG','C05130',true).
concept_accession('37660: cpd:C04895','KEGG','C04895',true).
concept_accession('37660: cpd:C04895','KEGG','CPD:C04895',true).
concept_accession('37661: cpd:C04244','KEGG','C04244',true).
concept_accession('37661: cpd:C04244','KEGG','CPD:C04244',true).
concept_accession('37658: cpd:C02835','KEGG','C02835',true).
concept_accession('37658: cpd:C02835','KEGG','CPD:C02835',true).
concept_accession('37659: cpd:C05452','KEGG','CPD:C05452',true).
concept_accession('37659: cpd:C05452','KEGG','C05452',true).
concept_accession('37656: cpd:C05467','KEGG','C05467',true).
concept_accession('37656: cpd:C05467','KEGG','CPD:C05467',true).
concept_accession('37657: cpd:C03684','KEGG','C03684',true).
concept_accession('37657: cpd:C03684','KEGG','CPD:C03684',true).
concept_accession('37654: cpd:C05460','KEGG','C05460',true).
concept_accession('37654: cpd:C05460','KEGG','CPD:C05460',true).
concept_accession('37653: gl:G00154','KEGG','G00154',true).
concept_accession('37653: gl:G00154','KEGG','GL:G00154',true).
concept_accession('37651: cpd:C17343','KEGG','C17343',true).
concept_accession('37651: cpd:C17343','KEGG','CPD:C17343',true).
concept_accession('37648: gl:G13041','KEGG','G13041',true).
concept_accession('37648: gl:G13041','KEGG','GL:G13041',true).
concept_accession('37647: cpd:C05552','KEGG','C05552',true).
concept_accession('37647: cpd:C05552','KEGG','CPD:C05552',true).
concept_accession('37642: cpd:C05921','KEGG','C05921',true).
concept_accession('37642: cpd:C05921','KEGG','CPD:C05921',true).
concept_accession('37638: cpd:C00925','KEGG','CPD:C00925',true).
concept_accession('37638: cpd:C00925','KEGG','C00925',true).
concept_accession('37636: cpd:C11556','KEGG','C11556',true).
concept_accession('37636: cpd:C11556','KEGG','CPD:C11556',true).
concept_accession('37632: cpd:C00120','KEGG','C00120',true).
concept_accession('37632: cpd:C00120','KEGG','CPD:C00120',true).
concept_accession('37693: cpd:C17337','KEGG','C17337',true).
concept_accession('37693: cpd:C17337','KEGG','CPD:C17337',true).
concept_accession('37694: cpd:C05544','KEGG','C05544',true).
concept_accession('37694: cpd:C05544','KEGG','CPD:C05544',true).
concept_accession('37695: cpd:C17335','KEGG','C17335',true).
concept_accession('37695: cpd:C17335','KEGG','CPD:C17335',true).
concept_accession('37688: gl:G00156','KEGG','G00156',true).
concept_accession('37688: gl:G00156','KEGG','GL:G00156',true).
concept_accession('37689: cpd:C01044','KEGG','C01044',true).
concept_accession('37689: cpd:C01044','KEGG','CPD:C01044',true).
concept_accession('37690: cpd:C05466','KEGG','C05466',true).
concept_accession('37690: cpd:C05466','KEGG','CPD:C05466',true).
concept_accession('37691: gl:G00155','KEGG','G00155',true).
concept_accession('37691: gl:G00155','KEGG','GL:G00155',true).
concept_accession('37686: cpd:C02528','KEGG','CPD:C02528',true).
concept_accession('37686: cpd:C02528','KEGG','C02528',true).
concept_accession('37680: cpd:C05465','KEGG','CPD:C05465',true).
concept_accession('37680: cpd:C05465','KEGG','C05465',true).
concept_accession('37681: gl:G00159','KEGG','G00159',true).
concept_accession('37681: gl:G00159','KEGG','GL:G00159',true).
concept_accession('37683: gl:G00158','KEGG','G00158',true).
concept_accession('37683: gl:G00158','KEGG','GL:G00158',true).
concept_accession('37676: cpd:C16236','KEGG','CPD:C16236',true).
concept_accession('37676: cpd:C16236','KEGG','C16236',true).
concept_accession('37678: gl:G00160','KEGG','GL:G00160',true).
concept_accession('37678: gl:G00160','KEGG','G00160',true).
concept_accession('37673: cpd:C16237','KEGG','CPD:C16237',true).
concept_accession('37673: cpd:C16237','KEGG','C16237',true).
concept_accession('37672: cpd:C17346','KEGG','C17346',true).
concept_accession('37672: cpd:C17346','KEGG','CPD:C17346',true).
concept_accession('37674: cpd:C05447','KEGG','C05447',true).
concept_accession('37674: cpd:C05447','KEGG','CPD:C05447',true).
concept_accession('37669: cpd:C00272','KEGG','C00272',true).
concept_accession('37669: cpd:C00272','KEGG','CPD:C00272',true).
concept_accession('37668: cpd:C04554','KEGG','CPD:C04554',true).
concept_accession('37668: cpd:C04554','KEGG','C04554',true).
concept_accession('37671: cpd:C17345','KEGG','C17345',true).
concept_accession('37671: cpd:C17345','KEGG','CPD:C17345',true).
concept_accession('37670: cpd:C01152','KEGG','C01152',true).
concept_accession('37670: cpd:C01152','KEGG','CPD:C01152',true).
concept_accession('37665: cpd:C00388','KEGG','C00388',true).
concept_accession('37665: cpd:C00388','KEGG','CPD:C00388',true).
concept_accession('37664: cpd:C05445','KEGG','C05445',true).
concept_accession('37664: cpd:C05445','KEGG','CPD:C05445',true).
concept_accession('37666: cpd:C00268','KEGG','C00268',true).
concept_accession('37666: cpd:C00268','KEGG','CPD:C00268',true).
concept_accession('37722: cpd:C06341','KEGG','C06341',true).
concept_accession('37722: cpd:C06341','KEGG','CPD:C06341',true).
concept_accession('37723: cpd:C02188','KEGG','CPD:C02188',true).
concept_accession('37723: cpd:C02188','KEGG','C02188',true).
concept_accession('37720: cpd:C16239','KEGG','C16239',true).
concept_accession('37720: cpd:C16239','KEGG','CPD:C16239',true).
concept_accession('37726: cpd:C00700','KEGG','CPD:C00700',true).
concept_accession('37726: cpd:C00700','KEGG','C00700',true).
concept_accession('37727: cpd:C01301','KEGG','C01301',true).
concept_accession('37727: cpd:C01301','KEGG','CPD:C01301',true).
concept_accession('37724: cpd:C00655','KEGG','C00655',true).
concept_accession('37724: cpd:C00655','KEGG','CPD:C00655',true).
concept_accession('37725: cpd:C04722','KEGG','C04722',true).
concept_accession('37725: cpd:C04722','KEGG','CPD:C04722',true).
concept_accession('37714: cpd:C05337','KEGG','C05337',true).
concept_accession('37714: cpd:C05337','KEGG','CPD:C05337',true).
concept_accession('37715: cpd:C05127','KEGG','C05127',true).
concept_accession('37715: cpd:C05127','KEGG','CPD:C05127',true).
concept_accession('37712: cpd:C05449','KEGG','C05449',true).
concept_accession('37712: cpd:C05449','KEGG','CPD:C05449',true).
concept_accession('37713: cpd:C00575','KEGG','C00575',true).
concept_accession('37713: cpd:C00575','KEGG','CPD:C00575',true).
concept_accession('37719: cpd:C05446','KEGG','C05446',true).
concept_accession('37719: cpd:C05446','KEGG','CPD:C05446',true).
concept_accession('37716: cpd:C01794','KEGG','CPD:C01794',true).
concept_accession('37716: cpd:C01794','KEGG','C01794',true).
concept_accession('37717: cpd:C00301','KEGG','CPD:C00301',true).
concept_accession('37717: cpd:C00301','KEGG','C00301',true).
concept_accession('37707: cpd:C05454','KEGG','C05454',true).
concept_accession('37707: cpd:C05454','KEGG','CPD:C05454',true).
concept_accession('37706: cpd:C17339','KEGG','C17339',true).
concept_accession('37706: cpd:C17339','KEGG','CPD:C17339',true).
concept_accession('37705: cpd:C04051','KEGG','C04051',true).
concept_accession('37705: cpd:C04051','KEGG','CPD:C04051',true).
concept_accession('37704: cpd:C04487','KEGG','C04487',true).
concept_accession('37704: cpd:C04487','KEGG','CPD:C04487',true).
concept_accession('37711: cpd:C15613','KEGG','CPD:C15613',true).
concept_accession('37711: cpd:C15613','KEGG','C15613',true).
concept_accession('37710: cpd:C05453','KEGG','C05453',true).
concept_accession('37710: cpd:C05453','KEGG','CPD:C05453',true).
concept_accession('37709: cpd:C16238','KEGG','C16238',true).
concept_accession('37709: cpd:C16238','KEGG','CPD:C16238',true).
concept_accession('37708: cpd:C03680','KEGG','C03680',true).
concept_accession('37708: cpd:C03680','KEGG','CPD:C03680',true).
concept_accession('37699: cpd:C17331','KEGG','C17331',true).
concept_accession('37699: cpd:C17331','KEGG','CPD:C17331',true).
concept_accession('37698: cpd:C05545','KEGG','CPD:C05545',true).
concept_accession('37698: cpd:C05545','KEGG','C05545',true).
concept_accession('37697: cpd:C06196','KEGG','CPD:C06196',true).
concept_accession('37697: cpd:C06196','KEGG','C06196',true).
concept_accession('37696: cpd:C17332','KEGG','CPD:C17332',true).
concept_accession('37696: cpd:C17332','KEGG','C17332',true).
concept_accession('37703: cpd:C05451','KEGG','CPD:C05451',true).
concept_accession('37703: cpd:C05451','KEGG','C05451',true).
concept_accession('37702: cpd:C06197','KEGG','CPD:C06197',true).
concept_accession('37702: cpd:C06197','KEGG','C06197',true).
concept_accession('37701: cpd:C01211','KEGG','C01211',true).
concept_accession('37701: cpd:C01211','KEGG','CPD:C01211',true).
concept_accession('37700: cpd:C00785','KEGG','CPD:C00785',true).
concept_accession('37700: cpd:C00785','KEGG','C00785',true).
concept_accession('37752: cpd:C01204','KEGG','C01204',true).
concept_accession('37752: cpd:C01204','KEGG','CPD:C01204',true).
concept_accession('37754: cpd:C05999','KEGG','C05999',true).
concept_accession('37754: cpd:C05999','KEGG','CPD:C05999',true).
concept_accession('37757: cpd:C01272','KEGG','C01272',true).
concept_accession('37757: cpd:C01272','KEGG','CPD:C01272',true).
concept_accession('37759: cpd:C11555','KEGG','CPD:C11555',true).
concept_accession('37759: cpd:C11555','KEGG','C11555',true).
concept_accession('37746: cpd:C00583','KEGG','C00583',true).
concept_accession('37746: cpd:C00583','KEGG','CPD:C00583',true).
concept_accession('37747: cpd:C01243','KEGG','CPD:C01243',true).
concept_accession('37747: cpd:C01243','KEGG','C01243',true).
concept_accession('37749: cpd:C01245','KEGG','CPD:C01245',true).
concept_accession('37749: cpd:C01245','KEGG','C01245',true).
concept_accession('37750: cpd:C04409','KEGG','CPD:C04409',true).
concept_accession('37750: cpd:C04409','KEGG','C04409',true).
concept_accession('37737: cpd:C06148','KEGG','CPD:C06148',true).
concept_accession('37737: cpd:C06148','KEGG','C06148',true).
concept_accession('37736: cpd:C03692','KEGG','C03692',true).
concept_accession('37736: cpd:C03692','KEGG','CPD:C03692',true).
concept_accession('37738: cpd:C05645','KEGG','CPD:C05645',true).
concept_accession('37738: cpd:C05645','KEGG','C05645',true).
concept_accession('37740: cpd:C05637','KEGG','CPD:C05637',true).
concept_accession('37740: cpd:C05637','KEGG','C05637',true).
concept_accession('37742: cpd:C05922','KEGG','C05922',true).
concept_accession('37742: cpd:C05922','KEGG','CPD:C05922',true).
concept_accession('37728: cpd:C00012','KEGG','CPD:C00012',true).
concept_accession('37728: cpd:C00012','KEGG','C00012',true).
concept_accession('37731: cpd:C05636','KEGG','CPD:C05636',true).
concept_accession('37731: cpd:C05636','KEGG','C05636',true).
concept_accession('37732: cpd:C01885','KEGG','CPD:C01885',true).
concept_accession('37732: cpd:C01885','KEGG','C01885',true).
concept_accession('37734: cpd:C03227','KEGG','CPD:C03227',true).
concept_accession('37734: cpd:C03227','KEGG','C03227',true).
concept_accession('37782: cpd:C00695','KEGG','CPD:C00695',true).
concept_accession('37782: cpd:C00695','KEGG','C00695',true).
concept_accession('37780: cpd:C01252','KEGG','C01252',true).
concept_accession('37780: cpd:C01252','KEGG','CPD:C01252',true).
concept_accession('37778: cpd:C00328','KEGG','CPD:C00328',true).
concept_accession('37778: cpd:C00328','KEGG','C00328',true).
concept_accession('37776: cpd:C05448','KEGG','C05448',true).
concept_accession('37776: cpd:C05448','KEGG','CPD:C05448',true).
concept_accession('37789: gl:G13040','KEGG','G13040',true).
concept_accession('37789: gl:G13040','KEGG','GL:G13040',true).
concept_accession('37787: cpd:C09332','KEGG','CPD:C09332',true).
concept_accession('37787: cpd:C09332','KEGG','C09332',true).
concept_accession('37785: cpd:C01921','KEGG','C01921',true).
concept_accession('37785: cpd:C01921','KEGG','CPD:C01921',true).
concept_accession('37784: cpd:C03541','KEGG','C03541',true).
concept_accession('37784: cpd:C03541','KEGG','CPD:C03541',true).
concept_accession('37766: cpd:C15520','KEGG','C15520',true).
concept_accession('37766: cpd:C15520','KEGG','CPD:C15520',true).
concept_accession('37764: cpd:C00643','KEGG','C00643',true).
concept_accession('37764: cpd:C00643','KEGG','CPD:C00643',true).
concept_accession('37765: cpd:C00921','KEGG','C00921',true).
concept_accession('37765: cpd:C00921','KEGG','CPD:C00921',true).
concept_accession('37761: cpd:C11557','KEGG','C11557',true).
concept_accession('37761: cpd:C11557','KEGG','CPD:C11557',true).
concept_accession('37774: cpd:C05923','KEGG','C05923',true).
concept_accession('37774: cpd:C05923','KEGG','CPD:C05923',true).
concept_accession('37773: cpd:C02700','KEGG','CPD:C02700',true).
concept_accession('37773: cpd:C02700','KEGG','C02700',true).
concept_accession('37770: cpd:C04874','KEGG','C04874',true).
concept_accession('37770: cpd:C04874','KEGG','CPD:C04874',true).
concept_accession('37771: cpd:C15518','KEGG','CPD:C15518',true).
concept_accession('37771: cpd:C15518','KEGG','C15518',true).
concept_accession('37769: cpd:C05450','KEGG','CPD:C05450',true).
concept_accession('37769: cpd:C05450','KEGG','C05450',true).
concept_accession('37813: gl:G13043','KEGG','GL:G13043',true).
concept_accession('37813: gl:G13043','KEGG','G13043',true).
concept_accession('37812: gl:G13031','KEGG','GL:G13031',true).
concept_accession('37812: gl:G13031','KEGG','G13031',true).
concept_accession('37815: gl:G00872','KEGG','GL:G00872',true).
concept_accession('37815: gl:G00872','KEGG','G00872',true).
concept_accession('37808: gl:G06780','KEGG','G06780',true).
concept_accession('37808: gl:G06780','KEGG','GL:G06780',true).
concept_accession('37810: gl:G02632','KEGG','G02632',true).
concept_accession('37810: gl:G02632','KEGG','GL:G02632',true).
concept_accession('37821: gl:G12336','KEGG','GL:G12336',true).
concept_accession('37821: gl:G12336','KEGG','G12336',true).
concept_accession('37818: gl:G13042','KEGG','GL:G13042',true).
concept_accession('37818: gl:G13042','KEGG','G13042',true).
concept_accession('37797: gl:G13038','KEGG','G13038',true).
concept_accession('37797: gl:G13038','KEGG','GL:G13038',true).
concept_accession('37799: gl:G13039','KEGG','G13039',true).
concept_accession('37799: gl:G13039','KEGG','GL:G13039',true).
concept_accession('37793: gl:G09660','KEGG','G09660',true).
concept_accession('37793: gl:G09660','KEGG','GL:G09660',true).
concept_accession('37806: cpd:C01277','KEGG','C01277',true).
concept_accession('37806: cpd:C01277','KEGG','CPD:C01277',true).
concept_accession('37801: cpd:C05981','KEGG','CPD:C05981',true).
concept_accession('37801: cpd:C05981','KEGG','C05981',true).
concept_accession('37803: gl:G13032','KEGG','GL:G13032',true).
concept_accession('37803: gl:G13032','KEGG','G13032',true).
concept_accession('37843: cpd:C01284','KEGG','CPD:C01284',true).
concept_accession('37843: cpd:C01284','KEGG','C01284',true).
concept_accession('37842: cpd:C00637','KEGG','CPD:C00637',true).
concept_accession('37842: cpd:C00637','KEGG','C00637',true).
concept_accession('37840: cpd:C04063','KEGG','CPD:C04063',true).
concept_accession('37840: cpd:C04063','KEGG','C04063',true).
concept_accession('37847: cpd:C00954','KEGG','C00954',true).
concept_accession('37847: cpd:C00954','KEGG','CPD:C00954',true).
concept_accession('37850: cpd:C05643','KEGG','CPD:C05643',true).
concept_accession('37850: cpd:C05643','KEGG','C05643',true).
concept_accession('37848: cpd:C01220','KEGG','CPD:C01220',true).
concept_accession('37848: cpd:C01220','KEGG','C01220',true).
concept_accession('37853: cpd:C01598','KEGG','C01598',true).
concept_accession('37853: cpd:C01598','KEGG','CPD:C01598',true).
concept_accession('37852: cpd:C04520','KEGG','CPD:C04520',true).
concept_accession('37852: cpd:C04520','KEGG','C04520',true).
concept_accession('37826: cpd:C00398','KEGG','CPD:C00398',true).
concept_accession('37826: cpd:C00398','KEGG','C00398',true).
concept_accession('37824: gl:G13036','KEGG','G13036',true).
concept_accession('37824: gl:G13036','KEGG','GL:G13036',true).
concept_accession('37831: cpd:C05660','KEGG','CPD:C05660',true).
concept_accession('37831: cpd:C05660','KEGG','C05660',true).
concept_accession('37828: gl:G13037','KEGG','G13037',true).
concept_accession('37828: gl:G13037','KEGG','GL:G13037',true).
concept_accession('37834: gl:G13035','KEGG','GL:G13035',true).
concept_accession('37834: gl:G13035','KEGG','G13035',true).
concept_accession('37832: gl:G13034','KEGG','GL:G13034',true).
concept_accession('37832: gl:G13034','KEGG','G13034',true).
concept_accession('37873: cpd:C04637','KEGG','C04637',true).
concept_accession('37873: cpd:C04637','KEGG','CPD:C04637',true).
concept_accession('37872: cpd:C05647','KEGG','CPD:C05647',true).
concept_accession('37872: cpd:C05647','KEGG','C05647',true).
concept_accession('37875: cpd:C05640','KEGG','C05640',true).
concept_accession('37875: cpd:C05640','KEGG','CPD:C05640',true).
concept_accession('37877: cpd:C05634','KEGG','CPD:C05634',true).
concept_accession('37877: cpd:C05634','KEGG','C05634',true).
concept_accession('37876: cpd:C03546','KEGG','CPD:C03546',true).
concept_accession('37876: cpd:C03546','KEGG','C03546',true).
concept_accession('37878: cpd:C00780','KEGG','C00780',true).
concept_accession('37878: cpd:C00780','KEGG','CPD:C00780',true).
concept_accession('37856: cpd:C00331','KEGG','C00331',true).
concept_accession('37856: cpd:C00331','KEGG','CPD:C00331',true).
concept_accession('37859: cpd:C04477','KEGG','C04477',true).
concept_accession('37859: cpd:C04477','KEGG','CPD:C04477',true).
concept_accession('37861: cpd:C05642','KEGG','CPD:C05642',true).
concept_accession('37861: cpd:C05642','KEGG','C05642',true).
concept_accession('37864: cpd:C05635','KEGG','CPD:C05635',true).
concept_accession('37864: cpd:C05635','KEGG','C05635',true).
concept_accession('37865: cpd:C01177','KEGG','C01177',true).
concept_accession('37865: cpd:C01177','KEGG','CPD:C01177',true).
concept_accession('37867: gl:G08421','KEGG','G08421',true).
concept_accession('37867: gl:G08421','KEGG','GL:G08421',true).
concept_accession('37868: cpd:C00978','KEGG','C00978',true).
concept_accession('37868: cpd:C00978','KEGG','CPD:C00978',true).
concept_accession('37869: cpd:C04549','KEGG','C04549',true).
concept_accession('37869: cpd:C04549','KEGG','CPD:C04549',true).
concept_accession('37871: gl:G13033','KEGG','GL:G13033',true).
concept_accession('37871: gl:G13033','KEGG','G13033',true).
concept_accession('36303: cpd:C18125','KEGG','CPD:C18125',true).
concept_accession('36303: cpd:C18125','KEGG','C18125',true).
concept_accession('36300: cpd:C01013','KEGG','CPD:C01013',true).
concept_accession('36300: cpd:C01013','KEGG','C01013',true).
concept_accession('37987: cpd:C16680','KEGG','CPD:C16680',true).
concept_accession('37987: cpd:C16680','KEGG','C16680',true).
concept_accession('36299: cpd:C16619','KEGG','C16619',true).
concept_accession('36299: cpd:C16619','KEGG','CPD:C16619',true).
concept_accession('36298: cpd:C00020','KEGG','CPD:C00020',true).
concept_accession('36298: cpd:C00020','KEGG','C00020',true).
concept_accession('36297: cpd:C15606','KEGG','C15606',true).
concept_accession('36297: cpd:C15606','KEGG','CPD:C15606',true).
concept_accession('36296: cpd:C00631','KEGG','CPD:C00631',true).
concept_accession('36296: cpd:C00631','KEGG','C00631',true).
concept_accession('37999: cpd:C05946','KEGG','C05946',true).
concept_accession('37999: cpd:C05946','KEGG','CPD:C05946',true).
concept_accession('36295: dr:D08603 cpd:C07648','KEGG','CPD:C07648',true).
concept_accession('36295: dr:D08603 cpd:C07648','KEGG','DR:D08603',true).
concept_accession('36295: dr:D08603 cpd:C07648','KEGG','C07648',true).
concept_accession('36295: dr:D08603 cpd:C07648','KEGG','D08603',true).
concept_accession('36294: cpd:C11131','KEGG','CPD:C11131',true).
concept_accession('36294: cpd:C11131','KEGG','C11131',true).
concept_accession('36292: cpd:C08276','KEGG','C08276',true).
concept_accession('36292: cpd:C08276','KEGG','CPD:C08276',true).
concept_accession('36291: cpd:C02512','KEGG','C02512',true).
concept_accession('36291: cpd:C02512','KEGG','CPD:C02512',true).
concept_accession('36290: cpd:C16615','KEGG','C16615',true).
concept_accession('36290: cpd:C16615','KEGG','CPD:C16615',true).
concept_accession('37992: cpd:C05774','KEGG','C05774',true).
concept_accession('37992: cpd:C05774','KEGG','CPD:C05774',true).
concept_accession('36288: cpd:C16620','KEGG','CPD:C16620',true).
concept_accession('36288: cpd:C16620','KEGG','C16620',true).
concept_accession('36318: cpd:C03267','KEGG','C03267',true).
concept_accession('36318: cpd:C03267','KEGG','CPD:C03267',true).
concept_accession('36319: cpd:C05301','KEGG','C05301',true).
concept_accession('36319: cpd:C05301','KEGG','CPD:C05301',true).
concept_accession('36316: cpd:C06250','KEGG','CPD:C06250',true).
concept_accession('36316: cpd:C06250','KEGG','C06250',true).
concept_accession('38002: cpd:C01157','KEGG','C01157',true).
concept_accession('38002: cpd:C01157','KEGG','CPD:C01157',true).
concept_accession('38003: cpd:C01165','KEGG','CPD:C01165',true).
concept_accession('38003: cpd:C01165','KEGG','C01165',true).
concept_accession('36315: cpd:C05302','KEGG','C05302',true).
concept_accession('36315: cpd:C05302','KEGG','CPD:C05302',true).
concept_accession('38000: cpd:C05947','KEGG','C05947',true).
concept_accession('38000: cpd:C05947','KEGG','CPD:C05947',true).
concept_accession('38001: cpd:C04281','KEGG','CPD:C04281',true).
concept_accession('38001: cpd:C04281','KEGG','C04281',true).
concept_accession('36313: cpd:C04419','KEGG','C04419',true).
concept_accession('36313: cpd:C04419','KEGG','CPD:C04419',true).
concept_accession('36308: cpd:C07585','KEGG','C07585',true).
concept_accession('36308: cpd:C07585','KEGG','CPD:C07585',true).
concept_accession('36307: cpd:C05504','KEGG','C05504',true).
concept_accession('36307: cpd:C05504','KEGG','CPD:C05504',true).
concept_accession('36305: cpd:C00275','KEGG','CPD:C00275',true).
concept_accession('36305: cpd:C00275','KEGG','C00275',true).
concept_accession('37957: cpd:C00899','KEGG','CPD:C00899',true).
concept_accession('37957: cpd:C00899','KEGG','C00899',true).
concept_accession('36332: cpd:C16604','KEGG','CPD:C16604',true).
concept_accession('36332: cpd:C16604','KEGG','C16604',true).
concept_accession('36335: cpd:C04233','KEGG','CPD:C04233',true).
concept_accession('36335: cpd:C04233','KEGG','C04233',true).
concept_accession('36334: cpd:C05535','KEGG','C05535',true).
concept_accession('36334: cpd:C05535','KEGG','CPD:C05535',true).
concept_accession('36329: cpd:C01094','KEGG','C01094',true).
concept_accession('36329: cpd:C01094','KEGG','CPD:C01094',true).
concept_accession('37952: cpd:C02075 cpd:C02588','KEGG','C02075',true).
concept_accession('37952: cpd:C02075 cpd:C02588','KEGG','CPD:C02588',true).
concept_accession('37952: cpd:C02075 cpd:C02588','KEGG','C02588',true).
concept_accession('37952: cpd:C02075 cpd:C02588','KEGG','CPD:C02075',true).
concept_accession('36328: cpd:C00320','KEGG','C00320',true).
concept_accession('36328: cpd:C00320','KEGG','CPD:C00320',true).
concept_accession('36331: cpd:C05299','KEGG','CPD:C05299',true).
concept_accession('36331: cpd:C05299','KEGG','C05299',true).
concept_accession('37965: cpd:C16682','KEGG','C16682',true).
concept_accession('37965: cpd:C16682','KEGG','CPD:C16682',true).
concept_accession('36325: cpd:C16613','KEGG','C16613',true).
concept_accession('36325: cpd:C16613','KEGG','CPD:C16613',true).
concept_accession('36324: cpd:C16617','KEGG','CPD:C16617',true).
concept_accession('36324: cpd:C16617','KEGG','C16617',true).
concept_accession('36327: cpd:C11132','KEGG','CPD:C11132',true).
concept_accession('36327: cpd:C11132','KEGG','C11132',true).
concept_accession('36326: cpd:C18126','KEGG','CPD:C18126',true).
concept_accession('36326: cpd:C18126','KEGG','C18126',true).
concept_accession('37961: cpd:C02110','KEGG','C02110',true).
concept_accession('37961: cpd:C02110','KEGG','CPD:C02110',true).
concept_accession('36320: cpd:C07447','KEGG','C07447',true).
concept_accession('36320: cpd:C07447','KEGG','CPD:C07447',true).
concept_accession('36323: cpd:C00094','KEGG','CPD:C00094',true).
concept_accession('36323: cpd:C00094','KEGG','C00094',true).
concept_accession('37962: cpd:C16681','KEGG','CPD:C16681',true).
concept_accession('37962: cpd:C16681','KEGG','C16681',true).
concept_accession('36322: cpd:C05298','KEGG','CPD:C05298',true).
concept_accession('36322: cpd:C05298','KEGG','C05298',true).
concept_accession('36348: cpd:C00449','KEGG','C00449',true).
concept_accession('36348: cpd:C00449','KEGG','CPD:C00449',true).
concept_accession('36349: cpd:C11133','KEGG','C11133',true).
concept_accession('36349: cpd:C11133','KEGG','CPD:C11133',true).
concept_accession('37974: cpd:C16679','KEGG','C16679',true).
concept_accession('37974: cpd:C16679','KEGG','CPD:C16679',true).
concept_accession('36350: dr:D00358 cpd:C07073','KEGG','CPD:C07073',true).
concept_accession('36350: dr:D00358 cpd:C07073','KEGG','DR:D00358',true).
concept_accession('36350: dr:D00358 cpd:C07073','KEGG','C07073',true).
concept_accession('36350: dr:D00358 cpd:C07073','KEGG','D00358',true).
concept_accession('36351: cpd:C03819','KEGG','CPD:C03819',true).
concept_accession('36351: cpd:C03819','KEGG','C03819',true).
concept_accession('36344: cpd:C01516;dr:D08233 cpd:C01516','KEGG','CPD:C01516',true).
concept_accession('36344: cpd:C01516;dr:D08233 cpd:C01516','KEGG','C01516',true).
concept_accession('36344: cpd:C01516;dr:D08233 cpd:C01516','KEGG','DR:D08233',true).
concept_accession('36344: cpd:C01516;dr:D08233 cpd:C01516','KEGG','D08233',true).
concept_accession('36345: cpd:C00956','KEGG','CPD:C00956',true).
concept_accession('36345: cpd:C00956','KEGG','C00956',true).
concept_accession('37970: cpd:C15493','KEGG','C15493',true).
concept_accession('37970: cpd:C15493','KEGG','CPD:C15493',true).
concept_accession('36346: cpd:C18129','KEGG','CPD:C18129',true).
concept_accession('36346: cpd:C18129','KEGG','C18129',true).
concept_accession('36340: cpd:C04076','KEGG','CPD:C04076',true).
concept_accession('36340: cpd:C04076','KEGG','C04076',true).
concept_accession('36343: cpd:C05141','KEGG','C05141',true).
concept_accession('36343: cpd:C05141','KEGG','CPD:C05141',true).
concept_accession('36337: cpd:C05300','KEGG','C05300',true).
concept_accession('36337: cpd:C05300','KEGG','CPD:C05300',true).
concept_accession('36338: cpd:C16560','KEGG','CPD:C16560',true).
concept_accession('36338: cpd:C16560','KEGG','C16560',true).
concept_accession('36339: cpd:C00040','KEGG','C00040',true).
concept_accession('36339: cpd:C00040','KEGG','CPD:C00040',true).
concept_accession('36235: cpd:C03715','KEGG','C03715',true).
concept_accession('36235: cpd:C03715','KEGG','CPD:C03715',true).
concept_accession('36234: cpd:C00800','KEGG','CPD:C00800',true).
concept_accession('36234: cpd:C00800','KEGG','C00800',true).
concept_accession('37921: cpd:C15492','KEGG','CPD:C15492',true).
concept_accession('37921: cpd:C15492','KEGG','C15492',true).
concept_accession('36233: cpd:C00217','KEGG','CPD:C00217',true).
concept_accession('36233: cpd:C00217','KEGG','C00217',true).
concept_accession('36232: cpd:C06126','KEGG','CPD:C06126',true).
concept_accession('36232: cpd:C06126','KEGG','C06126',true).
concept_accession('36239: cpd:C00181','KEGG','C00181',true).
concept_accession('36239: cpd:C00181','KEGG','CPD:C00181',true).
concept_accession('36238: cpd:C00124','KEGG','CPD:C00124',true).
concept_accession('36238: cpd:C00124','KEGG','C00124',true).
concept_accession('37925: cpd:C03455','KEGG','CPD:C03455',true).
concept_accession('37925: cpd:C03455','KEGG','C03455',true).
concept_accession('36237: cpd:C06128','KEGG','CPD:C06128',true).
concept_accession('36237: cpd:C06128','KEGG','C06128',true).
concept_accession('37930: cpd:C03440','KEGG','C03440',true).
concept_accession('37930: cpd:C03440','KEGG','CPD:C03440',true).
concept_accession('37929: cpd:C05639','KEGG','CPD:C05639',true).
concept_accession('37929: cpd:C05639','KEGG','C05639',true).
concept_accession('36224: dr:D07704 cpd:C07572','KEGG','C07572',true).
concept_accession('36224: dr:D07704 cpd:C07572','KEGG','D07704',true).
concept_accession('36224: dr:D07704 cpd:C07572','KEGG','DR:D07704',true).
concept_accession('36224: dr:D07704 cpd:C07572','KEGG','CPD:C07572',true).
concept_accession('37935: cpd:C04282','KEGG','CPD:C04282',true).
concept_accession('37935: cpd:C04282','KEGG','C04282',true).
concept_accession('36231: cpd:C05212','KEGG','C05212',true).
concept_accession('36231: cpd:C05212','KEGG','CPD:C05212',true).
concept_accession('37934: cpd:C05638','KEGG','C05638',true).
concept_accession('37934: cpd:C05638','KEGG','CPD:C05638',true).
concept_accession('36229: cpd:C06127','KEGG','C06127',true).
concept_accession('36229: cpd:C06127','KEGG','CPD:C06127',true).
concept_accession('37932: cpd:C11061','KEGG','CPD:C11061',true).
concept_accession('37932: cpd:C11061','KEGG','C11061',true).
concept_accession('36228: cpd:C00191','KEGG','C00191',true).
concept_accession('36228: cpd:C00191','KEGG','CPD:C00191',true).
concept_accession('37938: cpd:C05651','KEGG','C05651',true).
concept_accession('37938: cpd:C05651','KEGG','CPD:C05651',true).
concept_accession('36250: cpd:C05859','KEGG','CPD:C05859',true).
concept_accession('36250: cpd:C05859','KEGG','C05859',true).
concept_accession('36251: cpd:C15645','KEGG','CPD:C15645',true).
concept_accession('36251: cpd:C15645','KEGG','C15645',true).
concept_accession('37936: cpd:C16677','KEGG','C16677',true).
concept_accession('37936: cpd:C16677','KEGG','CPD:C16677',true).
concept_accession('36254: cpd:C15646','KEGG','CPD:C15646',true).
concept_accession('36254: cpd:C15646','KEGG','C15646',true).
concept_accession('36255: cpd:C02686','KEGG','C02686',true).
concept_accession('36255: cpd:C02686','KEGG','CPD:C02686',true).
concept_accession('37941: cpd:C00376','KEGG','C00376',true).
concept_accession('37941: cpd:C00376','KEGG','CPD:C00376',true).
concept_accession('36242: cpd:C00199','KEGG','C00199',true).
concept_accession('36242: cpd:C00199','KEGG','CPD:C00199',true).
concept_accession('36243: cpd:C02934','KEGG','C02934',true).
concept_accession('36243: cpd:C02934','KEGG','CPD:C02934',true).
concept_accession('36240: cpd:C06125','KEGG','C06125',true).
concept_accession('36240: cpd:C06125','KEGG','CPD:C06125',true).
concept_accession('37950: cpd:C06037','KEGG','CPD:C06037',true).
concept_accession('37950: cpd:C06037','KEGG','C06037',true).
concept_accession('36246: cpd:C00231','KEGG','C00231',true).
concept_accession('36246: cpd:C00231','KEGG','CPD:C00231',true).
concept_accession('37948: cpd:C00777','KEGG','C00777',true).
concept_accession('37948: cpd:C00777','KEGG','CPD:C00777',true).
concept_accession('36244: cpd:C16586','KEGG','C16586',true).
concept_accession('36244: cpd:C16586','KEGG','CPD:C16586',true).
concept_accession('36265: cpd:C04756','KEGG','CPD:C04756',true).
concept_accession('36265: cpd:C04756','KEGG','C04756',true).
concept_accession('36264: cpd:C04317','KEGG','C04317',true).
concept_accession('36264: cpd:C04317','KEGG','CPD:C04317',true).
concept_accession('36267: dr:D04931 cpd:C02380','KEGG','CPD:C02380',true).
concept_accession('36267: dr:D04931 cpd:C02380','KEGG','C02380',true).
concept_accession('36267: dr:D04931 cpd:C02380','KEGG','D04931',true).
concept_accession('36267: dr:D04931 cpd:C02380','KEGG','DR:D04931',true).
concept_accession('36266: cpd:C00008','KEGG','C00008',true).
concept_accession('36266: cpd:C00008','KEGG','CPD:C00008',true).
concept_accession('36269: cpd:C02336','KEGG','CPD:C02336',true).
concept_accession('36269: cpd:C02336','KEGG','C02336',true).
concept_accession('36268: cpd:C15650','KEGG','CPD:C15650',true).
concept_accession('36268: cpd:C15650','KEGG','C15650',true).
concept_accession('37895: cpd:C00473','KEGG','C00473',true).
concept_accession('37895: cpd:C00473','KEGG','CPD:C00473',true).
concept_accession('36270: cpd:C02170','KEGG','C02170',true).
concept_accession('36270: cpd:C02170','KEGG','CPD:C02170',true).
concept_accession('36257: cpd:C00195','KEGG','CPD:C00195',true).
concept_accession('36257: cpd:C00195','KEGG','C00195',true).
concept_accession('36258: cpd:C00160','KEGG','CPD:C00160',true).
concept_accession('36258: cpd:C00160','KEGG','C00160',true).
concept_accession('36261: cpd:C00319','KEGG','CPD:C00319',true).
concept_accession('36261: cpd:C00319','KEGG','C00319',true).
concept_accession('36260: cpd:C16553','KEGG','CPD:C16553',true).
concept_accession('36260: cpd:C16553','KEGG','C16553',true).
concept_accession('36263: cpd:C00310','KEGG','CPD:C00310',true).
concept_accession('36263: cpd:C00310','KEGG','C00310',true).
concept_accession('36262: cpd:C01233','KEGG','CPD:C01233',true).
concept_accession('36262: cpd:C01233','KEGG','C01233',true).
concept_accession('36280: cpd:C04188','KEGG','C04188',true).
concept_accession('36280: cpd:C04188','KEGG','CPD:C04188',true).
concept_accession('36282: cpd:C06114','KEGG','C06114',true).
concept_accession('36282: cpd:C06114','KEGG','CPD:C06114',true).
concept_accession('36283: cpd:C00346','KEGG','C00346',true).
concept_accession('36283: cpd:C00346','KEGG','CPD:C00346',true).
concept_accession('36284: cpd:C01213','KEGG','C01213',true).
concept_accession('36284: cpd:C01213','KEGG','CPD:C01213',true).
concept_accession('37910: cpd:C00422','KEGG','CPD:C00422',true).
concept_accession('37910: cpd:C00422','KEGG','C00422',true).
concept_accession('36286: cpd:C15647','KEGG','CPD:C15647',true).
concept_accession('36286: cpd:C15647','KEGG','C15647',true).
concept_accession('36287: cpd:C05503','KEGG','C05503',true).
concept_accession('36287: cpd:C05503','KEGG','CPD:C05503',true).
concept_accession('36272: cpd:C01190','KEGG','CPD:C01190',true).
concept_accession('36272: cpd:C01190','KEGG','C01190',true).
concept_accession('36273: cpd:C16618','KEGG','CPD:C16618',true).
concept_accession('36273: cpd:C16618','KEGG','C16618',true).
concept_accession('36274: cpd:C04582','KEGG','C04582',true).
concept_accession('36274: cpd:C04582','KEGG','CPD:C04582',true).
concept_accession('36276: cpd:C06002','KEGG','CPD:C06002',true).
concept_accession('36276: cpd:C06002','KEGG','C06002',true).
concept_accession('36278: cpd:C03090','KEGG','C03090',true).
concept_accession('36278: cpd:C03090','KEGG','CPD:C03090',true).
concept_accession('37919: cpd:C05648','KEGG','CPD:C05648',true).
concept_accession('37919: cpd:C05648','KEGG','C05648',true).
concept_accession('36279: cpd:C01120','KEGG','C01120',true).
concept_accession('36279: cpd:C01120','KEGG','CPD:C01120',true).
concept_accession('38127: cpd:C01079','KEGG','CPD:C01079',true).
concept_accession('38127: cpd:C01079','KEGG','C01079',true).
concept_accession('36167: cpd:C00418','KEGG','C00418',true).
concept_accession('36167: cpd:C00418','KEGG','CPD:C00418',true).
concept_accession('36164: cpd:C00222','KEGG','C00222',true).
concept_accession('36164: cpd:C00222','KEGG','CPD:C00222',true).
concept_accession('36165: cpd:C01107','KEGG','CPD:C01107',true).
concept_accession('36165: cpd:C01107','KEGG','C01107',true).
concept_accession('36162: cpd:C00315','KEGG','CPD:C00315',true).
concept_accession('36162: cpd:C00315','KEGG','C00315',true).
concept_accession('38123: cpd:C02191','KEGG','CPD:C02191',true).
concept_accession('38123: cpd:C02191','KEGG','C02191',true).
concept_accession('36163: cpd:C02630','KEGG','CPD:C02630',true).
concept_accession('36163: cpd:C02630','KEGG','C02630',true).
concept_accession('36161: cpd:C01143','KEGG','CPD:C01143',true).
concept_accession('36161: cpd:C01143','KEGG','C01143',true).
concept_accession('36174: cpd:C00103','KEGG','C00103',true).
concept_accession('36174: cpd:C00103','KEGG','CPD:C00103',true).
concept_accession('36175: cpd:C00668','KEGG','C00668',true).
concept_accession('36175: cpd:C00668','KEGG','CPD:C00668',true).
concept_accession('38116: cpd:C00486','KEGG','C00486',true).
concept_accession('38116: cpd:C00486','KEGG','CPD:C00486',true).
concept_accession('36172: cpd:C00072','KEGG','C00072',true).
concept_accession('36172: cpd:C00072','KEGG','CPD:C00072',true).
concept_accession('36173: cpd:C00532','KEGG','CPD:C00532',true).
concept_accession('36173: cpd:C00532','KEGG','C00532',true).
concept_accession('36170: cpd:C00092','KEGG','CPD:C00092',true).
concept_accession('36170: cpd:C00092','KEGG','C00092',true).
concept_accession('36171: cpd:C03012','KEGG','CPD:C03012',true).
concept_accession('36171: cpd:C03012','KEGG','C03012',true).
concept_accession('38112: cpd:C03287','KEGG','C03287',true).
concept_accession('38112: cpd:C03287','KEGG','CPD:C03287',true).
concept_accession('36169: cpd:C00227','KEGG','CPD:C00227',true).
concept_accession('36169: cpd:C00227','KEGG','C00227',true).
concept_accession('38143: cpd:C02946','KEGG','C02946',true).
concept_accession('38143: cpd:C02946','KEGG','CPD:C02946',true).
concept_accession('36183: cpd:C00267','KEGG','C00267',true).
concept_accession('36183: cpd:C00267','KEGG','CPD:C00267',true).
concept_accession('36182: cpd:C05401','KEGG','CPD:C05401',true).
concept_accession('36182: cpd:C05401','KEGG','C05401',true).
concept_accession('38141: cpd:C05936','KEGG','CPD:C05936',true).
concept_accession('38141: cpd:C05936','KEGG','C05936',true).
concept_accession('36181: cpd:C16643','KEGG','CPD:C16643',true).
concept_accession('36181: cpd:C16643','KEGG','C16643',true).
concept_accession('36180: cpd:C04006','KEGG','C04006',true).
concept_accession('36180: cpd:C04006','KEGG','CPD:C04006',true).
concept_accession('36179: cpd:C00129','KEGG','C00129',true).
concept_accession('36179: cpd:C00129','KEGG','CPD:C00129',true).
concept_accession('36178: cpd:C05668','KEGG','C05668',true).
concept_accession('36178: cpd:C05668','KEGG','CPD:C05668',true).
concept_accession('38137: cpd:C00500','KEGG','C00500',true).
concept_accession('38137: cpd:C00500','KEGG','CPD:C00500',true).
concept_accession('36177: cpd:C00235','KEGG','CPD:C00235',true).
concept_accession('36177: cpd:C00235','KEGG','C00235',true).
concept_accession('38136: cpd:C03263','KEGG','CPD:C03263',true).
concept_accession('38136: cpd:C03263','KEGG','C03263',true).
concept_accession('36176: cpd:C00618','KEGG','C00618',true).
concept_accession('36176: cpd:C00618','KEGG','CPD:C00618',true).
concept_accession('38135: cpd:C00179','KEGG','C00179',true).
concept_accession('38135: cpd:C00179','KEGG','CPD:C00179',true).
concept_accession('36191: cpd:C03454','KEGG','C03454',true).
concept_accession('36191: cpd:C03454','KEGG','CPD:C03454',true).
concept_accession('38134: cpd:C02990','KEGG','C02990',true).
concept_accession('38134: cpd:C02990','KEGG','CPD:C02990',true).
concept_accession('36190: cpd:C15973','KEGG','C15973',true).
concept_accession('36190: cpd:C15973','KEGG','CPD:C15973',true).
concept_accession('36189: cpd:C00670','KEGG','CPD:C00670',true).
concept_accession('36189: cpd:C00670','KEGG','C00670',true).
concept_accession('36188: cpd:C00221','KEGG','CPD:C00221',true).
concept_accession('36188: cpd:C00221','KEGG','C00221',true).
concept_accession('38131: cpd:C05280','KEGG','C05280',true).
concept_accession('38131: cpd:C05280','KEGG','CPD:C05280',true).
concept_accession('36187: cpd:C15972','KEGG','CPD:C15972',true).
concept_accession('36187: cpd:C15972','KEGG','C15972',true).
concept_accession('38130: cpd:C14818','KEGG','C14818',true).
concept_accession('38130: cpd:C14818','KEGG','CPD:C14818',true).
concept_accession('36186: cpd:C00116','KEGG','C00116',true).
concept_accession('36186: cpd:C00116','KEGG','CPD:C00116',true).
concept_accession('36185: cpd:C00259','KEGG','C00259',true).
concept_accession('36185: cpd:C00259','KEGG','CPD:C00259',true).
concept_accession('38128: cpd:C01035','KEGG','CPD:C01035',true).
concept_accession('38128: cpd:C01035','KEGG','C01035',true).
concept_accession('36184: cpd:C00044','KEGG','C00044',true).
concept_accession('36184: cpd:C00044','KEGG','CPD:C00044',true).
concept_accession('38092: cpd:C05766','KEGG','C05766',true).
concept_accession('38092: cpd:C05766','KEGG','CPD:C05766',true).
concept_accession('36196: cpd:C05977','KEGG','C05977',true).
concept_accession('36196: cpd:C05977','KEGG','CPD:C05977',true).
concept_accession('38093: cpd:C00437','KEGG','C00437',true).
concept_accession('38093: cpd:C00437','KEGG','CPD:C00437',true).
concept_accession('36197: cpd:C01172','KEGG','C01172',true).
concept_accession('36197: cpd:C01172','KEGG','CPD:C01172',true).
concept_accession('36198: cpd:C04598','KEGG','C04598',true).
concept_accession('36198: cpd:C04598','KEGG','CPD:C04598',true).
concept_accession('36199: cpd:C16255','KEGG','CPD:C16255',true).
concept_accession('36199: cpd:C16255','KEGG','C16255',true).
concept_accession('36193: cpd:C00047','KEGG','CPD:C00047',true).
concept_accession('36193: cpd:C00047','KEGG','C00047',true).
concept_accession('38090: cpd:C01051','KEGG','CPD:C01051',true).
concept_accession('38090: cpd:C01051','KEGG','C01051',true).
concept_accession('36194: cpd:C00155','KEGG','C00155',true).
concept_accession('36194: cpd:C00155','KEGG','CPD:C00155',true).
concept_accession('36195: cpd:C04475','KEGG','CPD:C04475',true).
concept_accession('36195: cpd:C04475','KEGG','C04475',true).
concept_accession('38084: cpd:C00624','KEGG','CPD:C00624',true).
concept_accession('38084: cpd:C00624','KEGG','C00624',true).
concept_accession('36204: cpd:C03372','KEGG','C03372',true).
concept_accession('36204: cpd:C03372','KEGG','CPD:C03372',true).
concept_accession('38085: cpd:C01024','KEGG','C01024',true).
concept_accession('38085: cpd:C01024','KEGG','CPD:C01024',true).
concept_accession('36205: cpd:C00472','KEGG','C00472',true).
concept_accession('36205: cpd:C00472','KEGG','CPD:C00472',true).
concept_accession('36206: cpd:C16607','KEGG','CPD:C16607',true).
concept_accession('36206: cpd:C16607','KEGG','C16607',true).
concept_accession('36207: cpd:C03820','KEGG','C03820',true).
concept_accession('36207: cpd:C03820','KEGG','CPD:C03820',true).
concept_accession('36200: cpd:C00379','KEGG','C00379',true).
concept_accession('36200: cpd:C00379','KEGG','CPD:C00379',true).
concept_accession('36201: cpd:C00530','KEGG','CPD:C00530',true).
concept_accession('36201: cpd:C00530','KEGG','C00530',true).
concept_accession('36203: cpd:C00550','KEGG','C00550',true).
concept_accession('36203: cpd:C00550','KEGG','CPD:C00550',true).
concept_accession('36213: cpd:C02266','KEGG','CPD:C02266',true).
concept_accession('36213: cpd:C02266','KEGG','C02266',true).
concept_accession('36212: cpd:C00159','KEGG','C00159',true).
concept_accession('36212: cpd:C00159','KEGG','CPD:C00159',true).
concept_accession('36215: cpd:C04635','KEGG','C04635',true).
concept_accession('36215: cpd:C04635','KEGG','CPD:C04635',true).
concept_accession('36214: cpd:C00091','KEGG','C00091',true).
concept_accession('36214: cpd:C00091','KEGG','CPD:C00091',true).
concept_accession('36209: cpd:C02960','KEGG','CPD:C02960',true).
concept_accession('36209: cpd:C02960','KEGG','C02960',true).
concept_accession('36208: cpd:C00819','KEGG','C00819',true).
concept_accession('36208: cpd:C00819','KEGG','CPD:C00819',true).
concept_accession('38100: cpd:C05768','KEGG','C05768',true).
concept_accession('38100: cpd:C05768','KEGG','CPD:C05768',true).
concept_accession('36220: cpd:C00312','KEGG','CPD:C00312',true).
concept_accession('36220: cpd:C00312','KEGG','C00312',true).
concept_accession('36222: cpd:C03201','KEGG','C03201',true).
concept_accession('36222: cpd:C03201','KEGG','CPD:C03201',true).
concept_accession('36216: cpd:C16608','KEGG','C16608',true).
concept_accession('36216: cpd:C16608','KEGG','CPD:C16608',true).
concept_accession('36218: cpd:C00143','KEGG','C00143',true).
concept_accession('36218: cpd:C00143','KEGG','CPD:C00143',true).
concept_accession('36099: cpd:C03771','KEGG','C03771',true).
concept_accession('36099: cpd:C03771','KEGG','CPD:C03771',true).
concept_accession('36096: cpd:C00334','KEGG','C00334',true).
concept_accession('36096: cpd:C00334','KEGG','CPD:C00334',true).
concept_accession('36097: cpd:C01762','KEGG','CPD:C01762',true).
concept_accession('36097: cpd:C01762','KEGG','C01762',true).
concept_accession('36103: cpd:C06426','KEGG','C06426',true).
concept_accession('36103: cpd:C06426','KEGG','CPD:C06426',true).
concept_accession('36100: cpd:C03508','KEGG','CPD:C03508',true).
concept_accession('36100: cpd:C03508','KEGG','C03508',true).
concept_accession('38061: cpd:C00763','KEGG','CPD:C00763',true).
concept_accession('38061: cpd:C00763','KEGG','C00763',true).
concept_accession('36107: cpd:C16651','KEGG','C16651',true).
concept_accession('36107: cpd:C16651','KEGG','CPD:C16651',true).
concept_accession('36105: cpd:C00515','KEGG','CPD:C00515',true).
concept_accession('36105: cpd:C00515','KEGG','C00515',true).
concept_accession('36110: cpd:C00792','KEGG','CPD:C00792',true).
concept_accession('36110: cpd:C00792','KEGG','C00792',true).
concept_accession('36111: cpd:C00683','KEGG','C00683',true).
concept_accession('36111: cpd:C00683','KEGG','CPD:C00683',true).
concept_accession('36108: cpd:C03373','KEGG','C03373',true).
concept_accession('36108: cpd:C03373','KEGG','CPD:C03373',true).
concept_accession('36114: cpd:C00164','KEGG','C00164',true).
concept_accession('36114: cpd:C00164','KEGG','CPD:C00164',true).
concept_accession('38072: cpd:C05791','KEGG','C05791',true).
concept_accession('38072: cpd:C05791','KEGG','CPD:C05791',true).
concept_accession('36112: gl:G00057','KEGG','G00057',true).
concept_accession('36112: gl:G00057','KEGG','GL:G00057',true).
concept_accession('36116: cpd:C00062','KEGG','C00062',true).
concept_accession('36116: cpd:C00062','KEGG','CPD:C00062',true).
concept_accession('36123: cpd:C00433','KEGG','CPD:C00433',true).
concept_accession('36123: cpd:C00433','KEGG','C00433',true).
concept_accession('36122: cpd:C00417','KEGG','C00417',true).
concept_accession('36122: cpd:C00417','KEGG','CPD:C00417',true).
concept_accession('38065: cpd:C03564','KEGG','C03564',true).
concept_accession('38065: cpd:C03564','KEGG','CPD:C03564',true).
concept_accession('36120: cpd:C00119','KEGG','C00119',true).
concept_accession('36120: cpd:C00119','KEGG','CPD:C00119',true).
concept_accession('38071: cpd:C02305','KEGG','CPD:C02305',true).
concept_accession('38071: cpd:C02305','KEGG','C02305',true).
concept_accession('36127: cpd:C00341','KEGG','CPD:C00341',true).
concept_accession('36127: cpd:C00341','KEGG','C00341',true).
concept_accession('38069: cpd:C05933','KEGG','C05933',true).
concept_accession('38069: cpd:C05933','KEGG','CPD:C05933',true).
concept_accession('36125: cpd:C03232','KEGG','CPD:C03232',true).
concept_accession('36125: cpd:C03232','KEGG','C03232',true).
concept_accession('38068: cpd:C06508','KEGG','CPD:C06508',true).
concept_accession('38068: cpd:C06508','KEGG','C06508',true).
concept_accession('36128: cpd:C00123','KEGG','CPD:C00123',true).
concept_accession('36128: cpd:C00123','KEGG','C00123',true).
concept_accession('38025: cpd:C05787','KEGG','CPD:C05787',true).
concept_accession('38025: cpd:C05787','KEGG','C05787',true).
concept_accession('36129: cpd:C00074','KEGG','CPD:C00074',true).
concept_accession('36129: cpd:C00074','KEGG','C00074',true).
concept_accession('36132: cpd:C00311','KEGG','CPD:C00311',true).
concept_accession('36132: cpd:C00311','KEGG','C00311',true).
concept_accession('38030: cpd:C00032','KEGG','CPD:C00032',true).
concept_accession('38030: cpd:C00032','KEGG','C00032',true).
concept_accession('36134: cpd:C05167','KEGG','C05167',true).
concept_accession('36134: cpd:C05167','KEGG','CPD:C05167',true).
concept_accession('36135: cpd:C00233','KEGG','CPD:C00233',true).
concept_accession('36135: cpd:C00233','KEGG','C00233',true).
concept_accession('36136: cpd:C16584','KEGG','C16584',true).
concept_accession('36136: cpd:C16584','KEGG','CPD:C16584',true).
concept_accession('36137: cpd:C00042','KEGG','C00042',true).
concept_accession('36137: cpd:C00042','KEGG','CPD:C00042',true).
concept_accession('38018: cpd:C00327','KEGG','C00327',true).
concept_accession('38018: cpd:C00327','KEGG','CPD:C00327',true).
concept_accession('36139: cpd:C00137','KEGG','C00137',true).
concept_accession('36139: cpd:C00137','KEGG','CPD:C00137',true).
concept_accession('36140: cpd:C00163','KEGG','C00163',true).
concept_accession('36140: cpd:C00163','KEGG','CPD:C00163',true).
concept_accession('36141: cpd:C16587','KEGG','CPD:C16587',true).
concept_accession('36141: cpd:C16587','KEGG','C16587',true).
concept_accession('38022: cpd:C15672','KEGG','CPD:C15672',true).
concept_accession('38022: cpd:C15672','KEGG','C15672',true).
concept_accession('36142: cpd:C00167','KEGG','C00167',true).
concept_accession('36142: cpd:C00167','KEGG','CPD:C00167',true).
concept_accession('36145: cpd:C02291','KEGG','C02291',true).
concept_accession('36145: cpd:C02291','KEGG','CPD:C02291',true).
concept_accession('36144: cpd:C00100','KEGG','CPD:C00100',true).
concept_accession('36144: cpd:C00100','KEGG','C00100',true).
concept_accession('36147: cpd:C03033','KEGG','CPD:C03033',true).
concept_accession('36147: cpd:C03033','KEGG','C03033',true).
concept_accession('36146: cpd:C16582','KEGG','C16582',true).
concept_accession('36146: cpd:C16582','KEGG','CPD:C16582',true).
concept_accession('36148: cpd:C17432','KEGG','CPD:C17432',true).
concept_accession('36148: cpd:C17432','KEGG','C17432',true).
concept_accession('36151: cpd:C00186','KEGG','CPD:C00186',true).
concept_accession('36151: cpd:C00186','KEGG','C00186',true).
concept_accession('36150: cpd:C00213','KEGG','C00213',true).
concept_accession('36150: cpd:C00213','KEGG','CPD:C00213',true).
concept_accession('36153: dr:D08195 cpd:C07163','KEGG','CPD:C07163',true).
concept_accession('36153: dr:D08195 cpd:C07163','KEGG','D08195',true).
concept_accession('36153: dr:D08195 cpd:C07163','KEGG','C07163',true).
concept_accession('36153: dr:D08195 cpd:C07163','KEGG','DR:D08195',true).
concept_accession('38032: cpd:C00931','KEGG','C00931',true).
concept_accession('38032: cpd:C00931','KEGG','CPD:C00931',true).
concept_accession('36152: cpd:C00108','KEGG','CPD:C00108',true).
concept_accession('36152: cpd:C00108','KEGG','C00108',true).
concept_accession('36155: cpd:C00894','KEGG','C00894',true).
concept_accession('36155: cpd:C00894','KEGG','CPD:C00894',true).
concept_accession('36154: cpd:C00039','KEGG','C00039',true).
concept_accession('36154: cpd:C00039','KEGG','CPD:C00039',true).
concept_accession('36157: cpd:C00188','KEGG','C00188',true).
concept_accession('36157: cpd:C00188','KEGG','CPD:C00188',true).
concept_accession('36159: cpd:C02047','KEGG','C02047',true).
concept_accession('36159: cpd:C02047','KEGG','CPD:C02047',true).
concept_accession('36158: cpd:C16659','KEGG','C16659',true).
concept_accession('36158: cpd:C16659','KEGG','CPD:C16659',true).
concept_accession('36060: cpd:C00448','KEGG','C00448',true).
concept_accession('36060: cpd:C00448','KEGG','CPD:C00448',true).
concept_accession('38261: cpd:C05109','KEGG','C05109',true).
concept_accession('38261: cpd:C05109','KEGG','CPD:C05109',true).
concept_accession('36061: cpd:C16602','KEGG','C16602',true).
concept_accession('36061: cpd:C16602','KEGG','CPD:C16602',true).
concept_accession('38262: cpd:C03793','KEGG','CPD:C03793',true).
concept_accession('38262: cpd:C03793','KEGG','C03793',true).
concept_accession('36062: cpd:C02972','KEGG','CPD:C02972',true).
concept_accession('36062: cpd:C02972','KEGG','C02972',true).
concept_accession('36063: cpd:C00029','KEGG','C00029',true).
concept_accession('36063: cpd:C00029','KEGG','CPD:C00029',true).
concept_accession('38256: cpd:C11455','KEGG','C11455',true).
concept_accession('38256: cpd:C11455','KEGG','CPD:C11455',true).
concept_accession('36056: cpd:C00258','KEGG','C00258',true).
concept_accession('36056: cpd:C00258','KEGG','CPD:C00258',true).
concept_accession('36058: gl:G00086','KEGG','GL:G00086',true).
concept_accession('36058: gl:G00086','KEGG','G00086',true).
concept_accession('38269: cpd:C05108','KEGG','C05108',true).
concept_accession('38269: cpd:C05108','KEGG','CPD:C05108',true).
concept_accession('36053: dr:D00252 cpd:C06868','KEGG','D00252',true).
concept_accession('36053: dr:D00252 cpd:C06868','KEGG','CPD:C06868',true).
concept_accession('36053: dr:D00252 cpd:C06868','KEGG','C06868',true).
concept_accession('36053: dr:D00252 cpd:C06868','KEGG','DR:D00252',true).
concept_accession('38264: cpd:C15808','KEGG','C15808',true).
concept_accession('38264: cpd:C15808','KEGG','CPD:C15808',true).
concept_accession('36048: cpd:C00577','KEGG','C00577',true).
concept_accession('36048: cpd:C00577','KEGG','CPD:C00577',true).
concept_accession('38266: cpd:C05546','KEGG','CPD:C05546',true).
concept_accession('38266: cpd:C05546','KEGG','C05546',true).
concept_accession('38245: cpd:C01149','KEGG','C01149',true).
concept_accession('38245: cpd:C01149','KEGG','CPD:C01149',true).
concept_accession('36044: cpd:C00407','KEGG','C00407',true).
concept_accession('36044: cpd:C00407','KEGG','CPD:C00407',true).
concept_accession('36047: cpd:C00041','KEGG','C00041',true).
concept_accession('36047: cpd:C00041','KEGG','CPD:C00041',true).
concept_accession('36041: gl:G00088','KEGG','GL:G00088',true).
concept_accession('36041: gl:G00088','KEGG','G00088',true).
concept_accession('36040: cpd:C00099','KEGG','CPD:C00099',true).
concept_accession('36040: cpd:C00099','KEGG','C00099',true).
concept_accession('36043: cpd:C01005','KEGG','C01005',true).
concept_accession('36043: cpd:C01005','KEGG','CPD:C01005',true).
concept_accession('36042: cpd:C00353','KEGG','C00353',true).
concept_accession('36042: cpd:C00353','KEGG','CPD:C00353',true).
concept_accession('36037: cpd:C07496','KEGG','CPD:C07496',true).
concept_accession('36037: cpd:C07496','KEGG','C07496',true).
concept_accession('36036: cpd:C02642','KEGG','CPD:C02642',true).
concept_accession('36036: cpd:C02642','KEGG','C02642',true).
concept_accession('38254: cpd:C15915','KEGG','CPD:C15915',true).
concept_accession('38254: cpd:C15915','KEGG','C15915',true).
concept_accession('36038: cpd:C00084','KEGG','CPD:C00084',true).
concept_accession('36038: cpd:C00084','KEGG','C00084',true).
concept_accession('38249: cpd:C01943','KEGG','CPD:C01943',true).
concept_accession('38249: cpd:C01943','KEGG','C01943',true).
concept_accession('36033: cpd:C00671','KEGG','CPD:C00671',true).
concept_accession('36033: cpd:C00671','KEGG','C00671',true).
concept_accession('36032: cpd:C00051','KEGG','CPD:C00051',true).
concept_accession('36032: cpd:C00051','KEGG','C00051',true).
concept_accession('36035: cpd:C00533','KEGG','CPD:C00533',true).
concept_accession('36035: cpd:C00533','KEGG','C00533',true).
concept_accession('38250: cpd:C06157','KEGG','CPD:C06157',true).
concept_accession('38250: cpd:C06157','KEGG','C06157',true).
concept_accession('36094: cpd:C00077','KEGG','C00077',true).
concept_accession('36094: cpd:C00077','KEGG','CPD:C00077',true).
concept_accession('38231: cpd:C11508','KEGG','C11508',true).
concept_accession('38231: cpd:C11508','KEGG','CPD:C11508',true).
concept_accession('36095: cpd:C00111','KEGG','C00111',true).
concept_accession('36095: cpd:C00111','KEGG','CPD:C00111',true).
concept_accession('36092: cpd:C01595','KEGG','C01595',true).
concept_accession('36092: cpd:C01595','KEGG','CPD:C01595',true).
concept_accession('36091: cpd:C00086','KEGG','C00086',true).
concept_accession('36091: cpd:C00086','KEGG','CPD:C00086',true).
concept_accession('36088: cpd:C00046','KEGG','CPD:C00046',true).
concept_accession('36088: cpd:C00046','KEGG','C00046',true).
concept_accession('36089: cpd:C00059','KEGG','CPD:C00059',true).
concept_accession('36089: cpd:C00059','KEGG','C00059',true).
concept_accession('36087: cpd:C05345','KEGG','C05345',true).
concept_accession('36087: cpd:C05345','KEGG','CPD:C05345',true).
concept_accession('36084: cpd:C00628','KEGG','C00628',true).
concept_accession('36084: cpd:C00628','KEGG','CPD:C00628',true).
concept_accession('36085: cpd:C00122','KEGG','CPD:C00122',true).
concept_accession('36085: cpd:C00122','KEGG','C00122',true).
concept_accession('38235: cpd:C01802','KEGG','C01802',true).
concept_accession('38235: cpd:C01802','KEGG','CPD:C01802',true).
concept_accession('38233: cpd:C15776','KEGG','CPD:C15776',true).
concept_accession('38233: cpd:C15776','KEGG','C15776',true).
concept_accession('38215: cpd:C15781','KEGG','C15781',true).
concept_accession('38215: cpd:C15781','KEGG','CPD:C15781',true).
concept_accession('36079: cpd:C00058','KEGG','C00058',true).
concept_accession('36079: cpd:C00058','KEGG','CPD:C00058',true).
concept_accession('38214: cpd:C05107','KEGG','C05107',true).
concept_accession('38214: cpd:C05107','KEGG','CPD:C05107',true).
concept_accession('36078: cpd:C01144','KEGG','CPD:C01144',true).
concept_accession('36078: cpd:C01144','KEGG','C01144',true).
concept_accession('36077: cpd:C00232','KEGG','C00232',true).
concept_accession('36077: cpd:C00232','KEGG','CPD:C00232',true).
concept_accession('38212: cpd:C01561','KEGG','CPD:C01561',true).
concept_accession('38212: cpd:C01561','KEGG','C01561',true).
concept_accession('36076: cpd:C00101','KEGG','C00101',true).
concept_accession('36076: cpd:C00101','KEGG','CPD:C00101',true).
concept_accession('36075: cpd:C03127','KEGG','CPD:C03127',true).
concept_accession('36075: cpd:C03127','KEGG','C03127',true).
concept_accession('38210: cpd:C01673','KEGG','CPD:C01673',true).
concept_accession('38210: cpd:C01673','KEGG','C01673',true).
concept_accession('36074: cpd:C00877','KEGG','CPD:C00877',true).
concept_accession('36074: cpd:C00877','KEGG','C00877',true).
concept_accession('36073: gl:G00085','KEGG','GL:G00085',true).
concept_accession('36073: gl:G00085','KEGG','G00085',true).
concept_accession('36072: cpd:C16610','KEGG','C16610',true).
concept_accession('36072: cpd:C16610','KEGG','CPD:C16610',true).
concept_accession('38223: cpd:C08821','KEGG','C08821',true).
concept_accession('38223: cpd:C08821','KEGG','CPD:C08821',true).
concept_accession('36071: cpd:C15777','KEGG','CPD:C15777',true).
concept_accession('36071: cpd:C15777','KEGG','C15777',true).
concept_accession('38222: cpd:C15782','KEGG','C15782',true).
concept_accession('38222: cpd:C15782','KEGG','CPD:C15782',true).
concept_accession('36069: cpd:C01110','KEGG','C01110',true).
concept_accession('36069: cpd:C01110','KEGG','CPD:C01110',true).
concept_accession('38220: cpd:C01753','KEGG','CPD:C01753',true).
concept_accession('38220: cpd:C01753','KEGG','C01753',true).
concept_accession('36067: cpd:C02051','KEGG','CPD:C02051',true).
concept_accession('36067: cpd:C02051','KEGG','C02051',true).
concept_accession('38218: cpd:C15780','KEGG','C15780',true).
concept_accession('38218: cpd:C15780','KEGG','CPD:C15780',true).
concept_accession('36066: gl:G00067','KEGG','GL:G00067',true).
concept_accession('36066: gl:G00067','KEGG','G00067',true).
concept_accession('36065: cpd:C16609','KEGG','C16609',true).
concept_accession('36065: cpd:C16609','KEGG','CPD:C16609',true).
concept_accession('38216: cpd:C15783','KEGG','CPD:C15783',true).
concept_accession('38216: cpd:C15783','KEGG','C15783',true).
concept_accession('35992: cpd:C00083','KEGG','CPD:C00083',true).
concept_accession('35992: cpd:C00083','KEGG','C00083',true).
concept_accession('35993: gl:G00063','KEGG','G00063',true).
concept_accession('35993: gl:G00063','KEGG','GL:G00063',true).
concept_accession('35995: cpd:C00002','KEGG','C00002',true).
concept_accession('35995: cpd:C00002','KEGG','CPD:C00002',true).
concept_accession('35996: cpd:C03035','KEGG','C03035',true).
concept_accession('35996: cpd:C03035','KEGG','CPD:C03035',true).
concept_accession('35997: cpd:C01026','KEGG','C01026',true).
concept_accession('35997: cpd:C01026','KEGG','CPD:C01026',true).
concept_accession('35998: cpd:C00048','KEGG','CPD:C00048',true).
concept_accession('35998: cpd:C00048','KEGG','C00048',true).
concept_accession('35984: cpd:C00037','KEGG','CPD:C00037',true).
concept_accession('35984: cpd:C00037','KEGG','C00037',true).
concept_accession('35985: dr:D04716 cpd:C08012','KEGG','CPD:C08012',true).
concept_accession('35985: dr:D04716 cpd:C08012','KEGG','D04716',true).
concept_accession('35985: dr:D04716 cpd:C08012','KEGG','C08012',true).
concept_accession('35985: dr:D04716 cpd:C08012','KEGG','DR:D04716',true).
concept_accession('35986: gl:G00062','KEGG','GL:G00062',true).
concept_accession('35986: gl:G00062','KEGG','G00062',true).
concept_accession('35988: cpd:C00190','KEGG','C00190',true).
concept_accession('35988: cpd:C00190','KEGG','CPD:C00190',true).
concept_accession('35990: cpd:C00300','KEGG','C00300',true).
concept_accession('35990: cpd:C00300','KEGG','CPD:C00300',true).
concept_accession('35991: cpd:C00082','KEGG','CPD:C00082',true).
concept_accession('35991: cpd:C00082','KEGG','C00082',true).
concept_accession('35977: cpd:C00096','KEGG','CPD:C00096',true).
concept_accession('35977: cpd:C00096','KEGG','C00096',true).
concept_accession('38176: cpd:C03547','KEGG','CPD:C03547',true).
concept_accession('38176: cpd:C03547','KEGG','C03547',true).
concept_accession('35976: gl:G00064','KEGG','G00064',true).
concept_accession('35976: gl:G00064','KEGG','GL:G00064',true).
concept_accession('35979: cpd:C00073','KEGG','CPD:C00073',true).
concept_accession('35979: cpd:C00073','KEGG','C00073',true).
concept_accession('35981: cpd:C00031','KEGG','CPD:C00031',true).
concept_accession('35981: cpd:C00031','KEGG','C00031',true).
concept_accession('35980: cpd:C00197','KEGG','CPD:C00197',true).
concept_accession('35980: cpd:C00197','KEGG','C00197',true).
concept_accession('35983: cpd:C02249','KEGG','CPD:C02249',true).
concept_accession('35983: cpd:C02249','KEGG','C02249',true).
concept_accession('35982: cpd:C00149','KEGG','CPD:C00149',true).
concept_accession('35982: cpd:C00149','KEGG','C00149',true).
concept_accession('35969: cpd:C00061','KEGG','C00061',true).
concept_accession('35969: cpd:C00061','KEGG','CPD:C00061',true).
concept_accession('35968: cpd:C02554','KEGG','CPD:C02554',true).
concept_accession('35968: cpd:C02554','KEGG','C02554',true).
concept_accession('35971: cpd:C00719','KEGG','C00719',true).
concept_accession('35971: cpd:C00719','KEGG','CPD:C00719',true).
concept_accession('35970: cpd:C00169','KEGG','C00169',true).
concept_accession('35970: cpd:C00169','KEGG','CPD:C00169',true).
concept_accession('35973: cpd:C16660','KEGG','C16660',true).
concept_accession('35973: cpd:C16660','KEGG','CPD:C16660',true).
concept_accession('35972: cpd:C03595','KEGG','C03595',true).
concept_accession('35972: cpd:C03595','KEGG','CPD:C03595',true).
concept_accession('35975: cpd:C01180','KEGG','CPD:C01180',true).
concept_accession('35975: cpd:C01180','KEGG','C01180',true).
concept_accession('35974: cpd:C00068','KEGG','C00068',true).
concept_accession('35974: cpd:C00068','KEGG','CPD:C00068',true).
concept_accession('36026: cpd:C00429','KEGG','CPD:C00429',true).
concept_accession('36026: cpd:C00429','KEGG','C00429',true).
concept_accession('38163: cpd:C00226','KEGG','CPD:C00226',true).
concept_accession('38163: cpd:C00226','KEGG','C00226',true).
concept_accession('36024: cpd:C00109','KEGG','C00109',true).
concept_accession('36024: cpd:C00109','KEGG','CPD:C00109',true).
concept_accession('36025: cpd:C00118','KEGG','C00118',true).
concept_accession('36025: cpd:C00118','KEGG','CPD:C00118',true).
concept_accession('36030: gl:G00089','KEGG','G00089',true).
concept_accession('36030: gl:G00089','KEGG','GL:G00089',true).
concept_accession('36031: cpd:C00011','KEGG','CPD:C00011',true).
concept_accession('36031: cpd:C00011','KEGG','C00011',true).
concept_accession('36028: cpd:C00168','KEGG','C00168',true).
concept_accession('36028: cpd:C00168','KEGG','CPD:C00168',true).
concept_accession('36018: cpd:C16162','KEGG','C16162',true).
concept_accession('36018: cpd:C16162','KEGG','CPD:C16162',true).
concept_accession('38168: cpd:C00524','KEGG','CPD:C00524',true).
concept_accession('38168: cpd:C00524','KEGG','C00524',true).
concept_accession('36016: cpd:C01179','KEGG','CPD:C01179',true).
concept_accession('36016: cpd:C01179','KEGG','C01179',true).
concept_accession('36017: cpd:C05125','KEGG','CPD:C05125',true).
concept_accession('36017: cpd:C05125','KEGG','C05125',true).
concept_accession('36023: cpd:C16601','KEGG','C16601',true).
concept_accession('36023: cpd:C16601','KEGG','CPD:C16601',true).
concept_accession('38147: cpd:C02714','KEGG','C02714',true).
concept_accession('38147: cpd:C02714','KEGG','CPD:C02714',true).
concept_accession('36010: cpd:C16169','KEGG','CPD:C16169',true).
concept_accession('36010: cpd:C16169','KEGG','C16169',true).
concept_accession('38144: cpd:C05279','KEGG','CPD:C05279',true).
concept_accession('38144: cpd:C05279','KEGG','C05279',true).
concept_accession('36008: cpd:C00581','KEGG','C00581',true).
concept_accession('36008: cpd:C00581','KEGG','CPD:C00581',true).
concept_accession('36015: gl:G00090','KEGG','G00090',true).
concept_accession('36015: gl:G00090','KEGG','GL:G00090',true).
concept_accession('36014: cpd:C00527','KEGG','C00527',true).
concept_accession('36014: cpd:C00527','KEGG','CPD:C00527',true).
concept_accession('38149: cpd:C05938','KEGG','CPD:C05938',true).
concept_accession('38149: cpd:C05938','KEGG','C05938',true).
concept_accession('36013: gl:G00060','KEGG','G00060',true).
concept_accession('36013: gl:G00060','KEGG','GL:G00060',true).
concept_accession('36003: cpd:C16165','KEGG','C16165',true).
concept_accession('36003: cpd:C16165','KEGG','CPD:C16165',true).
concept_accession('36002: cpd:C05519','KEGG','C05519',true).
concept_accession('36002: cpd:C05519','KEGG','CPD:C05519',true).
concept_accession('38153: cpd:C06505','KEGG','CPD:C06505',true).
concept_accession('38153: cpd:C06505','KEGG','C06505',true).
concept_accession('36000: gl:G00066','KEGG','G00066',true).
concept_accession('36000: gl:G00066','KEGG','GL:G00066',true).
concept_accession('38159: cpd:C01708','KEGG','C01708',true).
concept_accession('38159: cpd:C01708','KEGG','CPD:C01708',true).
concept_accession('38158: cpd:C06506','KEGG','CPD:C06506',true).
concept_accession('38158: cpd:C06506','KEGG','C06506',true).
concept_accession('38157: cpd:C00071','KEGG','CPD:C00071',true).
concept_accession('38157: cpd:C00071','KEGG','C00071',true).
concept_accession('36005: cpd:C00078','KEGG','C00078',true).
concept_accession('36005: cpd:C00078','KEGG','CPD:C00078',true).
concept_accession('38393: cpd:C04185','KEGG','C04185',true).
concept_accession('38393: cpd:C04185','KEGG','CPD:C04185',true).
concept_accession('38390: cpd:C18239','KEGG','CPD:C18239',true).
concept_accession('38390: cpd:C18239','KEGG','C18239',true).
concept_accession('38368: cpd:C05827','KEGG','CPD:C05827',true).
concept_accession('38368: cpd:C05827','KEGG','C05827',true).
concept_accession('38370: cpd:C05828','KEGG','CPD:C05828',true).
concept_accession('38370: cpd:C05828','KEGG','C05828',true).
concept_accession('35959: cpd:C00049','KEGG','CPD:C00049',true).
concept_accession('35959: cpd:C00049','KEGG','C00049',true).
concept_accession('35958: cpd:C00141','KEGG','C00141',true).
concept_accession('35958: cpd:C00141','KEGG','CPD:C00141',true).
concept_accession('35957: cpd:C00036','KEGG','CPD:C00036',true).
concept_accession('35957: cpd:C00036','KEGG','C00036',true).
concept_accession('35956: cpd:C00576','KEGG','C00576',true).
concept_accession('35956: cpd:C00576','KEGG','CPD:C00576',true).
concept_accession('35955: cpd:C00026','KEGG','C00026',true).
concept_accession('35955: cpd:C00026','KEGG','CPD:C00026',true).
concept_accession('35954: cpd:C00154','KEGG','C00154',true).
concept_accession('35954: cpd:C00154','KEGG','CPD:C00154',true).
concept_accession('35953: cpd:C00064','KEGG','C00064',true).
concept_accession('35953: cpd:C00064','KEGG','CPD:C00064',true).
concept_accession('35952: cpd:C00022','KEGG','CPD:C00022',true).
concept_accession('35952: cpd:C00022','KEGG','C00022',true).
concept_accession('35967: cpd:C00065','KEGG','C00065',true).
concept_accession('35967: cpd:C00065','KEGG','CPD:C00065',true).
concept_accession('35966: cpd:C00019','KEGG','C00019',true).
concept_accession('35966: cpd:C00019','KEGG','CPD:C00019',true).
concept_accession('35964: cpd:C00332','KEGG','C00332',true).
concept_accession('35964: cpd:C00332','KEGG','CPD:C00332',true).
concept_accession('35963: cpd:C16662','KEGG','C16662',true).
concept_accession('35963: cpd:C16662','KEGG','CPD:C16662',true).
concept_accession('35962: cpd:C00097','KEGG','CPD:C00097',true).
concept_accession('35962: cpd:C00097','KEGG','C00097',true).
concept_accession('38353: cpd:C05924','KEGG','C05924',true).
concept_accession('38353: cpd:C05924','KEGG','CPD:C05924',true).
concept_accession('35961: gl:G00069','KEGG','G00069',true).
concept_accession('35961: gl:G00069','KEGG','GL:G00069',true).
concept_accession('35960: cpd:C00025','KEGG','CPD:C00025',true).
concept_accession('35960: cpd:C00025','KEGG','C00025',true).
concept_accession('35942: cpd:C00356','KEGG','CPD:C00356',true).
concept_accession('35942: cpd:C00356','KEGG','C00356',true).
concept_accession('35943: cpd:C00079','KEGG','CPD:C00079',true).
concept_accession('35943: cpd:C00079','KEGG','C00079',true).
concept_accession('35940: cpd:C00158','KEGG','CPD:C00158',true).
concept_accession('35940: cpd:C00158','KEGG','C00158',true).
concept_accession('35941: cpd:C00014','KEGG','C00014',true).
concept_accession('35941: cpd:C00014','KEGG','CPD:C00014',true).
concept_accession('35950: cpd:C16661','KEGG','C16661',true).
concept_accession('35950: cpd:C16661','KEGG','CPD:C16661',true).
concept_accession('35951: cpd:C00136','KEGG','C00136',true).
concept_accession('35951: cpd:C00136','KEGG','CPD:C00136',true).
concept_accession('35948: gl:G00084','KEGG','GL:G00084',true).
concept_accession('35948: gl:G00084','KEGG','G00084',true).
concept_accession('35949: cpd:C00033','KEGG','CPD:C00033',true).
concept_accession('35949: cpd:C00033','KEGG','C00033',true).
concept_accession('35946: cpd:C00152','KEGG','C00152',true).
concept_accession('35946: cpd:C00152','KEGG','CPD:C00152',true).
concept_accession('35947: cpd:C00114','KEGG','CPD:C00114',true).
concept_accession('35947: cpd:C00114','KEGG','C00114',true).
concept_accession('35944: cpd:C00024','KEGG','CPD:C00024',true).
concept_accession('35944: cpd:C00024','KEGG','C00024',true).
concept_accession('35945: cpd:C00183','KEGG','C00183',true).
concept_accession('35945: cpd:C00183','KEGG','CPD:C00183',true).
concept_accession('38282: cpd:C01259','KEGG','CPD:C01259',true).
concept_accession('38282: cpd:C01259','KEGG','C01259',true).
concept_accession('38283: cpd:C00751','KEGG','CPD:C00751',true).
concept_accession('38283: cpd:C00751','KEGG','C00751',true).
concept_accession('38280: cpd:C01054','KEGG','CPD:C01054',true).
concept_accession('38280: cpd:C01054','KEGG','C01054',true).
concept_accession('38285: cpd:C03428','KEGG','C03428',true).
concept_accession('38285: cpd:C03428','KEGG','CPD:C03428',true).
concept_accession('38279: cpd:C01181','KEGG','C01181',true).
concept_accession('38279: cpd:C01181','KEGG','CPD:C01181',true).
concept_accession('38276: cpd:C00487','KEGG','C00487',true).
concept_accession('38276: cpd:C00487','KEGG','CPD:C00487',true).
concept_accession('38277: cpd:C01724','KEGG','CPD:C01724',true).
concept_accession('38277: cpd:C01724','KEGG','C01724',true).
concept_accession('36843: gl:G00148','KEGG','GL:G00148',true).
concept_accession('36843: gl:G00148','KEGG','G00148',true).
concept_accession('36844: cpd:C16551','KEGG','C16551',true).
concept_accession('36844: cpd:C16551','KEGG','CPD:C16551',true).
concept_accession('36847: cpd:C11583','KEGG','C11583',true).
concept_accession('36847: cpd:C11583','KEGG','CPD:C11583',true).
concept_accession('36846: gl:G00149','KEGG','GL:G00149',true).
concept_accession('36846: gl:G00149','KEGG','G00149',true).
concept_accession('38472: cpd:C15811','KEGG','C15811',true).
concept_accession('38472: cpd:C15811','KEGG','CPD:C15811',true).
concept_accession('36832: dr:D07760 cpd:C07888','KEGG','D07760',true).
concept_accession('36832: dr:D07760 cpd:C07888','KEGG','DR:D07760',true).
concept_accession('36832: dr:D07760 cpd:C07888','KEGG','CPD:C07888',true).
concept_accession('36832: dr:D07760 cpd:C07888','KEGG','C07888',true).
concept_accession('36835: cpd:C16577','KEGG','CPD:C16577',true).
concept_accession('36835: cpd:C16577','KEGG','C16577',true).
concept_accession('38474: cpd:C15812','KEGG','CPD:C15812',true).
concept_accession('38474: cpd:C15812','KEGG','C15812',true).
concept_accession('36837: cpd:C05332','KEGG','C05332',true).
concept_accession('36837: cpd:C05332','KEGG','CPD:C05332',true).
concept_accession('36836: cpd:C00601','KEGG','C00601',true).
concept_accession('36836: cpd:C00601','KEGG','CPD:C00601',true).
concept_accession('36839: cpd:C02505','KEGG','C02505',true).
concept_accession('36839: cpd:C02505','KEGG','CPD:C02505',true).
concept_accession('36858: cpd:C05487','KEGG','CPD:C05487',true).
concept_accession('36858: cpd:C05487','KEGG','C05487',true).
concept_accession('36860: cpd:C05852','KEGG','C05852',true).
concept_accession('36860: cpd:C05852','KEGG','CPD:C05852',true).
concept_accession('36861: cpd:C00386','KEGG','CPD:C00386',true).
concept_accession('36861: cpd:C00386','KEGG','C00386',true).
concept_accession('36862: cpd:C00951','KEGG','C00951',true).
concept_accession('36862: cpd:C00951','KEGG','CPD:C00951',true).
concept_accession('38488: cpd:C04042','KEGG','CPD:C04042',true).
concept_accession('38488: cpd:C04042','KEGG','C04042',true).
concept_accession('36848: cpd:C00535','KEGG','C00535',true).
concept_accession('36848: cpd:C00535','KEGG','CPD:C00535',true).
concept_accession('36849: cpd:C07646','KEGG','CPD:C07646',true).
concept_accession('36849: cpd:C07646','KEGG','C07646',true).
concept_accession('36850: cpd:C00555','KEGG','CPD:C00555',true).
concept_accession('36850: cpd:C00555','KEGG','C00555',true).
concept_accession('36851: cpd:C00280','KEGG','C00280',true).
concept_accession('36851: cpd:C00280','KEGG','CPD:C00280',true).
concept_accession('36852: cpd:C00415','KEGG','C00415',true).
concept_accession('36852: cpd:C00415','KEGG','CPD:C00415',true).
concept_accession('36853: cpd:C00504','KEGG','CPD:C00504',true).
concept_accession('36853: cpd:C00504','KEGG','C00504',true).
concept_accession('38494: cpd:C02373','KEGG','CPD:C02373',true).
concept_accession('38494: cpd:C02373','KEGG','C02373',true).
concept_accession('36855: cpd:C05500','KEGG','C05500',true).
concept_accession('36855: cpd:C05500','KEGG','CPD:C05500',true).
concept_accession('38499: cpd:C18044','KEGG','C18044',true).
concept_accession('38499: cpd:C18044','KEGG','CPD:C18044',true).
concept_accession('36811: cpd:C15980','KEGG','CPD:C15980',true).
concept_accession('36811: cpd:C15980','KEGG','C15980',true).
concept_accession('36809: gl:G13044','KEGG','GL:G13044',true).
concept_accession('36809: gl:G13044','KEGG','G13044',true).
concept_accession('38496: cpd:C18038','KEGG','C18038',true).
concept_accession('38496: cpd:C18038','KEGG','CPD:C18038',true).
concept_accession('36808: dr:D00399 cpd:C07185','KEGG','DR:D00399',true).
concept_accession('36808: dr:D00399 cpd:C07185','KEGG','CPD:C07185',true).
concept_accession('36808: dr:D00399 cpd:C07185','KEGG','D00399',true).
concept_accession('36808: dr:D00399 cpd:C07185','KEGG','C07185',true).
concept_accession('38503: cpd:C05502','KEGG','C05502',true).
concept_accession('38503: cpd:C05502','KEGG','CPD:C05502',true).
concept_accession('36814: gl:G00147','KEGG','GL:G00147',true).
concept_accession('36814: gl:G00147','KEGG','G00147',true).
concept_accession('38501: cpd:C05501','KEGG','C05501',true).
concept_accession('38501: cpd:C05501','KEGG','CPD:C05501',true).
concept_accession('36813: cpd:C15979','KEGG','C15979',true).
concept_accession('36813: cpd:C15979','KEGG','CPD:C15979',true).
concept_accession('36812: cpd:C04717','KEGG','CPD:C04717',true).
concept_accession('36812: cpd:C04717','KEGG','C04717',true).
concept_accession('36803: cpd:C00669','KEGG','CPD:C00669',true).
concept_accession('36803: cpd:C00669','KEGG','C00669',true).
concept_accession('38511: cpd:C03772','KEGG','CPD:C03772',true).
concept_accession('38511: cpd:C03772','KEGG','C03772',true).
concept_accession('36806: gl:G10610','KEGG','GL:G10610',true).
concept_accession('36806: gl:G10610','KEGG','G10610',true).
concept_accession('36805: cpd:C07645','KEGG','C07645',true).
concept_accession('36805: cpd:C07645','KEGG','CPD:C07645',true).
concept_accession('38508: cpd:C00674','KEGG','C00674',true).
concept_accession('38508: cpd:C00674','KEGG','CPD:C00674',true).
concept_accession('36804: cpd:C01879','KEGG','CPD:C01879',true).
concept_accession('36804: cpd:C01879','KEGG','C01879',true).
concept_accession('38515: cpd:C04295','KEGG','CPD:C04295',true).
concept_accession('38515: cpd:C04295','KEGG','C04295',true).
concept_accession('36827: cpd:C00445','KEGG','CPD:C00445',true).
concept_accession('36827: cpd:C00445','KEGG','C00445',true).
concept_accession('36824: cpd:C15977','KEGG','CPD:C15977',true).
concept_accession('36824: cpd:C15977','KEGG','C15977',true).
concept_accession('38513: cpd:C05285','KEGG','CPD:C05285',true).
concept_accession('38513: cpd:C05285','KEGG','C05285',true).
concept_accession('38518: cpd:C05139','KEGG','C05139',true).
concept_accession('38518: cpd:C05139','KEGG','CPD:C05139',true).
concept_accession('36830: gl:G00145','KEGG','GL:G00145',true).
concept_accession('36830: gl:G00145','KEGG','G00145',true).
concept_accession('36831: cpd:C07086','KEGG','CPD:C07086',true).
concept_accession('36831: cpd:C07086','KEGG','C07086',true).
concept_accession('38516: cpd:C05140','KEGG','C05140',true).
concept_accession('38516: cpd:C05140','KEGG','CPD:C05140',true).
concept_accession('36828: gl:G00143','KEGG','G00143',true).
concept_accession('36828: gl:G00143','KEGG','GL:G00143',true).
concept_accession('36829: cpd:C16576','KEGG','CPD:C16576',true).
concept_accession('36829: cpd:C16576','KEGG','C16576',true).
concept_accession('36818: gl:G00146','KEGG','G00146',true).
concept_accession('36818: gl:G00146','KEGG','GL:G00146',true).
concept_accession('38521: cpd:C01227','KEGG','C01227',true).
concept_accession('38521: cpd:C01227','KEGG','CPD:C01227',true).
concept_accession('38526: cpd:C05490','KEGG','C05490',true).
concept_accession('38526: cpd:C05490','KEGG','CPD:C05490',true).
concept_accession('36822: gl:G00144','KEGG','GL:G00144',true).
concept_accession('36822: gl:G00144','KEGG','G00144',true).
concept_accession('36823: cpd:C02189','KEGG','CPD:C02189',true).
concept_accession('36823: cpd:C02189','KEGG','C02189',true).
concept_accession('38524: cpd:C05478','KEGG','CPD:C05478',true).
concept_accession('38524: cpd:C05478','KEGG','C05478',true).
concept_accession('36820: cpd:C16578','KEGG','CPD:C16578',true).
concept_accession('36820: cpd:C16578','KEGG','C16578',true).
concept_accession('36780: gl:G10617','KEGG','G10617',true).
concept_accession('36780: gl:G10617','KEGG','GL:G10617',true).
concept_accession('36783: cpd:C16548','KEGG','C16548',true).
concept_accession('36783: cpd:C16548','KEGG','CPD:C16548',true).
concept_accession('36782: cpd:C14825','KEGG','C14825',true).
concept_accession('36782: cpd:C14825','KEGG','CPD:C14825',true).
concept_accession('36776: cpd:C00343','KEGG','C00343',true).
concept_accession('36776: cpd:C00343','KEGG','CPD:C00343',true).
concept_accession('36779: cpd:C00342','KEGG','CPD:C00342',true).
concept_accession('36779: cpd:C00342','KEGG','C00342',true).
concept_accession('36773: cpd:C00075','KEGG','C00075',true).
concept_accession('36773: cpd:C00075','KEGG','CPD:C00075',true).
concept_accession('36772: cpd:C00010','KEGG','CPD:C00010',true).
concept_accession('36772: cpd:C00010','KEGG','C00010',true).
concept_accession('36775: dr:D08559 cpd:C07108','KEGG','C07108',true).
concept_accession('36775: dr:D08559 cpd:C07108','KEGG','CPD:C07108',true).
concept_accession('36775: dr:D08559 cpd:C07108','KEGG','DR:D08559',true).
concept_accession('36775: dr:D08559 cpd:C07108','KEGG','D08559',true).
concept_accession('36774: cpd:C02320','KEGG','CPD:C02320',true).
concept_accession('36774: cpd:C02320','KEGG','C02320',true).
concept_accession('36771: cpd:C05011','KEGG','CPD:C05011',true).
concept_accession('36771: cpd:C05011','KEGG','C05011',true).
concept_accession('36770: cpd:C01322','KEGG','CPD:C01322',true).
concept_accession('36770: cpd:C01322','KEGG','C01322',true).
concept_accession('36796: cpd:C03740','KEGG','CPD:C03740',true).
concept_accession('36796: cpd:C03740','KEGG','C03740',true).
concept_accession('36798: cpd:C16561','KEGG','CPD:C16561',true).
concept_accession('36798: cpd:C16561','KEGG','C16561',true).
concept_accession('36793: cpd:C01419','KEGG','C01419',true).
concept_accession('36793: cpd:C01419','KEGG','CPD:C01419',true).
concept_accession('36788: cpd:C16547','KEGG','C16547',true).
concept_accession('36788: cpd:C16547','KEGG','CPD:C16547',true).
concept_accession('36789: cpd:C06482','KEGG','C06482',true).
concept_accession('36789: cpd:C06482','KEGG','CPD:C06482',true).
concept_accession('36790: cpd:C16545','KEGG','C16545',true).
concept_accession('36790: cpd:C16545','KEGG','CPD:C16545',true).
concept_accession('36784: cpd:C01262','KEGG','C01262',true).
concept_accession('36784: cpd:C01262','KEGG','CPD:C01262',true).
concept_accession('36786: cpd:C00127','KEGG','C00127',true).
concept_accession('36786: cpd:C00127','KEGG','CPD:C00127',true).
concept_accession('36787: cpd:C00438','KEGG','CPD:C00438',true).
concept_accession('36787: cpd:C00438','KEGG','C00438',true).
concept_accession('36751: cpd:C00621','KEGG','C00621',true).
concept_accession('36751: cpd:C00621','KEGG','CPD:C00621',true).
concept_accession('36749: cpd:C00492','KEGG','C00492',true).
concept_accession('36749: cpd:C00492','KEGG','CPD:C00492',true).
concept_accession('36748: cpd:C05499','KEGG','CPD:C05499',true).
concept_accession('36748: cpd:C05499','KEGG','C05499',true).
concept_accession('38435: cpd:C00439','KEGG','CPD:C00439',true).
concept_accession('38435: cpd:C00439','KEGG','C00439',true).
concept_accession('36747: cpd:C05269','KEGG','C05269',true).
concept_accession('36747: cpd:C05269','KEGG','CPD:C05269',true).
concept_accession('36745: cpd:C05270','KEGG','C05270',true).
concept_accession('36745: cpd:C05270','KEGG','CPD:C05270',true).
concept_accession('36744: cpd:C01953','KEGG','C01953',true).
concept_accession('36744: cpd:C01953','KEGG','CPD:C01953',true).
concept_accession('36743: gl:G00015','KEGG','G00015',true).
concept_accession('36743: gl:G00015','KEGG','GL:G00015',true).
concept_accession('36742: cpd:C05665','KEGG','C05665',true).
concept_accession('36742: cpd:C05665','KEGG','CPD:C05665',true).
concept_accession('36740: cpd:C00468','KEGG','CPD:C00468',true).
concept_accession('36740: cpd:C00468','KEGG','C00468',true).
concept_accession('36738: cpd:C05271','KEGG','C05271',true).
concept_accession('36738: cpd:C05271','KEGG','CPD:C05271',true).
concept_accession('36737: cpd:C16546','KEGG','C16546',true).
concept_accession('36737: cpd:C16546','KEGG','CPD:C16546',true).
concept_accession('36736: cpd:C00236','KEGG','C00236',true).
concept_accession('36736: cpd:C00236','KEGG','CPD:C00236',true).
concept_accession('36763: cpd:C18045','KEGG','C18045',true).
concept_accession('36763: cpd:C18045','KEGG','CPD:C18045',true).
concept_accession('38449: cpd:C01081','KEGG','C01081',true).
concept_accession('38449: cpd:C01081','KEGG','CPD:C01081',true).
concept_accession('36759: cpd:C04518','KEGG','CPD:C04518',true).
concept_accession('36759: cpd:C04518','KEGG','C04518',true).
concept_accession('36756: cpd:C03824','KEGG','CPD:C03824',true).
concept_accession('36756: cpd:C03824','KEGG','C03824',true).
concept_accession('36754: cpd:C05268','KEGG','C05268',true).
concept_accession('36754: cpd:C05268','KEGG','CPD:C05268',true).
concept_accession('36755: cpd:C04555','KEGG','C04555',true).
concept_accession('36755: cpd:C04555','KEGG','CPD:C04555',true).
concept_accession('36705: cpd:C03221','KEGG','CPD:C03221',true).
concept_accession('36705: cpd:C03221','KEGG','C03221',true).
concept_accession('36706: cpd:C05264','KEGG','CPD:C05264',true).
concept_accession('36706: cpd:C05264','KEGG','C05264',true).
concept_accession('36708: cpd:C00001','KEGG','C00001',true).
concept_accession('36708: cpd:C00001','KEGG','CPD:C00001',true).
concept_accession('36709: cpd:C01832','KEGG','C01832',true).
concept_accession('36709: cpd:C01832','KEGG','CPD:C01832',true).
concept_accession('36712: cpd:C05528','KEGG','CPD:C05528',true).
concept_accession('36712: cpd:C05528','KEGG','C05528',true).
concept_accession('36713: cpd:C05265','KEGG','CPD:C05265',true).
concept_accession('36713: cpd:C05265','KEGG','C05265',true).
concept_accession('38595: cpd:C05138','KEGG','CPD:C05138',true).
concept_accession('38595: cpd:C05138','KEGG','C05138',true).
concept_accession('36715: cpd:C05263','KEGG','CPD:C05263',true).
concept_accession('36715: cpd:C05263','KEGG','C05263',true).
concept_accession('36716: cpd:C05274','KEGG','CPD:C05274',true).
concept_accession('36716: cpd:C05274','KEGG','C05274',true).
concept_accession('36717: cpd:C00151','KEGG','C00151',true).
concept_accession('36717: cpd:C00151','KEGG','CPD:C00151',true).
concept_accession('36721: cpd:C05275','KEGG','CPD:C05275',true).
concept_accession('36721: cpd:C05275','KEGG','C05275',true).
concept_accession('36720: cpd:C05262','KEGG','CPD:C05262',true).
concept_accession('36720: cpd:C05262','KEGG','C05262',true).
concept_accession('36723: cpd:C05399','KEGG','C05399',true).
concept_accession('36723: cpd:C05399','KEGG','CPD:C05399',true).
concept_accession('36724: cpd:C05276','KEGG','CPD:C05276',true).
concept_accession('36724: cpd:C05276','KEGG','C05276',true).
concept_accession('36727: cpd:C01235','KEGG','C01235',true).
concept_accession('36727: cpd:C01235','KEGG','CPD:C01235',true).
concept_accession('36729: cpd:C00279','KEGG','CPD:C00279',true).
concept_accession('36729: cpd:C00279','KEGG','C00279',true).
concept_accession('36728: cpd:C01944','KEGG','CPD:C01944',true).
concept_accession('36728: cpd:C01944','KEGG','C01944',true).
concept_accession('36730: cpd:C14826','KEGG','C14826',true).
concept_accession('36730: cpd:C14826','KEGG','CPD:C14826',true).
concept_accession('36733: cpd:C05266','KEGG','CPD:C05266',true).
concept_accession('36733: cpd:C05266','KEGG','C05266',true).
concept_accession('36732: cpd:C05267','KEGG','C05267',true).
concept_accession('36732: cpd:C05267','KEGG','CPD:C05267',true).
concept_accession('36734: cpd:C05400','KEGG','CPD:C05400',true).
concept_accession('36734: cpd:C05400','KEGG','C05400',true).
concept_accession('36674: cpd:C05751','KEGG','C05751',true).
concept_accession('36674: cpd:C05751','KEGG','CPD:C05751',true).
concept_accession('36675: cpd:C03939','KEGG','C03939',true).
concept_accession('36675: cpd:C03939','KEGG','CPD:C03939',true).
concept_accession('36672: cpd:C05752','KEGG','CPD:C05752',true).
concept_accession('36672: cpd:C05752','KEGG','C05752',true).
concept_accession('36679: cpd:C00106','KEGG','C00106',true).
concept_accession('36679: cpd:C00106','KEGG','CPD:C00106',true).
concept_accession('36676: cpd:C16663','KEGG','CPD:C16663',true).
concept_accession('36676: cpd:C16663','KEGG','C16663',true).
concept_accession('36677: cpd:C05744','KEGG','C05744',true).
concept_accession('36677: cpd:C05744','KEGG','CPD:C05744',true).
concept_accession('36682: cpd:C00162','KEGG','CPD:C00162',true).
concept_accession('36682: cpd:C00162','KEGG','C00162',true).
concept_accession('36683: cpd:C00665','KEGG','C00665',true).
concept_accession('36683: cpd:C00665','KEGG','CPD:C00665',true).
concept_accession('36680: cpd:C11376','KEGG','C11376',true).
concept_accession('36680: cpd:C11376','KEGG','CPD:C11376',true).
concept_accession('36681: cpd:C11173','KEGG','CPD:C11173',true).
concept_accession('36681: cpd:C11173','KEGG','C11173',true).
concept_accession('36686: cpd:C00352','KEGG','CPD:C00352',true).
concept_accession('36686: cpd:C00352','KEGG','C00352',true).
concept_accession('36687: cpd:C01209','KEGG','CPD:C01209',true).
concept_accession('36687: cpd:C01209','KEGG','C01209',true).
concept_accession('36691: cpd:C05745','KEGG','C05745',true).
concept_accession('36691: cpd:C05745','KEGG','CPD:C05745',true).
concept_accession('36690: cpd:C16664','KEGG','CPD:C16664',true).
concept_accession('36690: cpd:C16664','KEGG','C16664',true).
concept_accession('36688: cpd:C16543','KEGG','CPD:C16543',true).
concept_accession('36688: cpd:C16543','KEGG','C16543',true).
concept_accession('36695: cpd:C16336','KEGG','C16336',true).
concept_accession('36695: cpd:C16336','KEGG','CPD:C16336',true).
concept_accession('36694: cpd:C06754','KEGG','CPD:C06754',true).
concept_accession('36694: cpd:C06754','KEGG','C06754',true).
concept_accession('36698: cpd:C04618','KEGG','CPD:C04618',true).
concept_accession('36698: cpd:C04618','KEGG','C04618',true).
concept_accession('36703: cpd:C00253','KEGG','CPD:C00253',true).
concept_accession('36703: cpd:C00253','KEGG','C00253',true).
concept_accession('36702: cpd:C04246','KEGG','C04246',true).
concept_accession('36702: cpd:C04246','KEGG','CPD:C04246',true).
concept_accession('36644: cpd:C07490','KEGG','C07490',true).
concept_accession('36644: cpd:C07490','KEGG','CPD:C07490',true).
concept_accession('38541: cpd:C01124','KEGG','CPD:C01124',true).
concept_accession('38541: cpd:C01124','KEGG','C01124',true).
concept_accession('36645: cpd:C05758','KEGG','C05758',true).
concept_accession('36645: cpd:C05758','KEGG','CPD:C05758',true).
concept_accession('38543: cpd:C05473','KEGG','C05473',true).
concept_accession('38543: cpd:C05473','KEGG','CPD:C05473',true).
concept_accession('36647: dr:D00343 cpd:C07047','KEGG','D00343',true).
concept_accession('36647: dr:D00343 cpd:C07047','KEGG','DR:D00343',true).
concept_accession('36647: dr:D00343 cpd:C07047','KEGG','C07047',true).
concept_accession('36647: dr:D00343 cpd:C07047','KEGG','CPD:C07047',true).
concept_accession('36640: cpd:C05757','KEGG','C05757',true).
concept_accession('36640: cpd:C05757','KEGG','CPD:C05757',true).
concept_accession('36643: gl:G00011','KEGG','G00011',true).
concept_accession('36643: gl:G00011','KEGG','GL:G00011',true).
concept_accession('36652: cpd:C16612','KEGG','C16612',true).
concept_accession('36652: cpd:C16612','KEGG','CPD:C16612',true).
concept_accession('38533: cpd:C18043','KEGG','CPD:C18043',true).
concept_accession('38533: cpd:C18043','KEGG','C18043',true).
concept_accession('36654: cpd:C00105','KEGG','C00105',true).
concept_accession('36654: cpd:C00105','KEGG','CPD:C00105',true).
concept_accession('36648: dr:D01309 cpd:C12739','KEGG','C12739',true).
concept_accession('36648: dr:D01309 cpd:C12739','KEGG','DR:D01309',true).
concept_accession('36648: dr:D01309 cpd:C12739','KEGG','CPD:C12739',true).
concept_accession('36648: dr:D01309 cpd:C12739','KEGG','D01309',true).
concept_accession('36649: cpd:C05223','KEGG','C05223',true).
concept_accession('36649: cpd:C05223','KEGG','CPD:C05223',true).
concept_accession('36661: cpd:C16565','KEGG','CPD:C16565',true).
concept_accession('36661: cpd:C16565','KEGG','C16565',true).
concept_accession('38556: cpd:C05469','KEGG','CPD:C05469',true).
concept_accession('38556: cpd:C05469','KEGG','C05469',true).
concept_accession('36660: cpd:C05749','KEGG','C05749',true).
concept_accession('36660: cpd:C05749','KEGG','CPD:C05749',true).
concept_accession('38559: cpd:C05471','KEGG','C05471',true).
concept_accession('38559: cpd:C05471','KEGG','CPD:C05471',true).
concept_accession('36657: cpd:C05748','KEGG','C05748',true).
concept_accession('36657: cpd:C05748','KEGG','CPD:C05748',true).
concept_accession('36656: cpd:C00940','KEGG','C00940',true).
concept_accession('36656: cpd:C00940','KEGG','CPD:C00940',true).
concept_accession('36669: cpd:C05750','KEGG','CPD:C05750',true).
concept_accession('36669: cpd:C05750','KEGG','C05750',true).
concept_accession('38548: cpd:C00762','KEGG','CPD:C00762',true).
concept_accession('38548: cpd:C00762','KEGG','C00762',true).
concept_accession('36668: cpd:C04620','KEGG','C04620',true).
concept_accession('36668: cpd:C04620','KEGG','CPD:C04620',true).
concept_accession('38551: cpd:C00735','KEGG','C00735',true).
concept_accession('38551: cpd:C00735','KEGG','CPD:C00735',true).
concept_accession('38550: cpd:C15670','KEGG','CPD:C15670',true).
concept_accession('38550: cpd:C15670','KEGG','C15670',true).
concept_accession('38544: cpd:C05489','KEGG','C05489',true).
concept_accession('38544: cpd:C05489','KEGG','CPD:C05489',true).
concept_accession('36664: cpd:C05746','KEGG','C05746',true).
concept_accession('36664: cpd:C05746','KEGG','CPD:C05746',true).
concept_accession('36667: cpd:C05747','KEGG','C05747',true).
concept_accession('36667: cpd:C05747','KEGG','CPD:C05747',true).
concept_accession('38546: cpd:C05485','KEGG','C05485',true).
concept_accession('38546: cpd:C05485','KEGG','CPD:C05485',true).
concept_accession('36614: cpd:C05764','KEGG','CPD:C05764',true).
concept_accession('36614: cpd:C05764','KEGG','C05764',true).
concept_accession('38572: cpd:C05479','KEGG','CPD:C05479',true).
concept_accession('38572: cpd:C05479','KEGG','C05479',true).
concept_accession('36612: cpd:C16596','KEGG','CPD:C16596',true).
concept_accession('36612: cpd:C16596','KEGG','C16596',true).
concept_accession('36613: cpd:C00006','KEGG','C00006',true).
concept_accession('36613: cpd:C00006','KEGG','CPD:C00006',true).
concept_accession('38570: cpd:C18041','KEGG','CPD:C18041',true).
concept_accession('38570: cpd:C18041','KEGG','C18041',true).
concept_accession('36610: cpd:C05763','KEGG','CPD:C05763',true).
concept_accession('36610: cpd:C05763','KEGG','C05763',true).
concept_accession('38568: cpd:C05497','KEGG','CPD:C05497',true).
concept_accession('38568: cpd:C05497','KEGG','C05497',true).
concept_accession('36608: cpd:C00117','KEGG','C00117',true).
concept_accession('36608: cpd:C00117','KEGG','CPD:C00117',true).
concept_accession('36609: gl:G00013','KEGG','G00013',true).
concept_accession('36609: gl:G00013','KEGG','GL:G00013',true).
concept_accession('38566: cpd:C05498','KEGG','CPD:C05498',true).
concept_accession('38566: cpd:C05498','KEGG','C05498',true).
concept_accession('36623: cpd:C11150','KEGG','CPD:C11150',true).
concept_accession('36623: cpd:C11150','KEGG','C11150',true).
concept_accession('38564: cpd:C18075','KEGG','C18075',true).
concept_accession('38564: cpd:C18075','KEGG','CPD:C18075',true).
concept_accession('36620: cpd:C16300','KEGG','CPD:C16300',true).
concept_accession('36620: cpd:C16300','KEGG','C16300',true).
concept_accession('36621: cpd:C05755','KEGG','C05755',true).
concept_accession('36621: cpd:C05755','KEGG','CPD:C05755',true).
concept_accession('36616: cpd:C16591','KEGG','CPD:C16591',true).
concept_accession('36616: cpd:C16591','KEGG','C16591',true).
concept_accession('36631: cpd:C05753','KEGG','C05753',true).
concept_accession('36631: cpd:C05753','KEGG','CPD:C05753',true).
concept_accession('36630: cpd:C16327','KEGG','C16327',true).
concept_accession('36630: cpd:C16327','KEGG','CPD:C16327',true).
concept_accession('36629: cpd:C04619','KEGG','CPD:C04619',true).
concept_accession('36629: cpd:C04619','KEGG','C04619',true).
concept_accession('36628: cpd:C16544','KEGG','CPD:C16544',true).
concept_accession('36628: cpd:C16544','KEGG','C16544',true).
concept_accession('36627: cpd:C05726','KEGG','C05726',true).
concept_accession('36627: cpd:C05726','KEGG','CPD:C05726',true).
concept_accession('36625: cpd:C05754','KEGG','C05754',true).
concept_accession('36625: cpd:C05754','KEGG','CPD:C05754',true).
concept_accession('36624: cpd:C16328','KEGG','C16328',true).
concept_accession('36624: cpd:C16328','KEGG','CPD:C16328',true).
concept_accession('36638: cpd:C00750','KEGG','CPD:C00750',true).
concept_accession('36638: cpd:C00750','KEGG','C00750',true).
concept_accession('36637: cpd:C16635','KEGG','CPD:C16635',true).
concept_accession('36637: cpd:C16635','KEGG','C16635',true).
concept_accession('36636: cpd:C05756','KEGG','C05756',true).
concept_accession('36636: cpd:C05756','KEGG','CPD:C05756',true).
concept_accession('36632: cpd:C05729','KEGG','C05729',true).
concept_accession('36632: cpd:C05729','KEGG','CPD:C05729',true).
concept_accession('36602: gl:G00012','KEGG','G00012',true).
concept_accession('36602: gl:G00012','KEGG','GL:G00012',true).
concept_accession('36603: cpd:C04633','KEGG','C04633',true).
concept_accession('36603: cpd:C04633','KEGG','CPD:C04633',true).
concept_accession('36601: dr:D08086 cpd:C16641','KEGG','D08086',true).
concept_accession('36601: dr:D08086 cpd:C16641','KEGG','DR:D08086',true).
concept_accession('36601: dr:D08086 cpd:C16641','KEGG','CPD:C16641',true).
concept_accession('36601: dr:D08086 cpd:C16641','KEGG','C16641',true).
concept_accession('36606: cpd:C06481','KEGG','C06481',true).
concept_accession('36606: cpd:C06481','KEGG','CPD:C06481',true).
concept_accession('36594: gl:G00014','KEGG','G00014',true).
concept_accession('36594: gl:G00014','KEGG','GL:G00014',true).
concept_accession('36595: cpd:C05759','KEGG','C05759',true).
concept_accession('36595: cpd:C05759','KEGG','CPD:C05759',true).
concept_accession('36596: cpd:C16335','KEGG','CPD:C16335',true).
concept_accession('36596: cpd:C16335','KEGG','C16335',true).
concept_accession('36597: cpd:C16549','KEGG','C16549',true).
concept_accession('36597: cpd:C16549','KEGG','CPD:C16549',true).
concept_accession('36587: cpd:C05760','KEGG','CPD:C05760',true).
concept_accession('36587: cpd:C05760','KEGG','C05760',true).
concept_accession('36586: cpd:C16332','KEGG','C16332',true).
concept_accession('36586: cpd:C16332','KEGG','CPD:C16332',true).
concept_accession('36584: cpd:C16595','KEGG','C16595',true).
concept_accession('36584: cpd:C16595','KEGG','CPD:C16595',true).
concept_accession('38727: cpd:C00847','KEGG','C00847',true).
concept_accession('38727: cpd:C00847','KEGG','CPD:C00847',true).
concept_accession('36590: cpd:C04688','KEGG','CPD:C04688',true).
concept_accession('36590: cpd:C04688','KEGG','C04688',true).
concept_accession('36588: cpd:C02090','KEGG','CPD:C02090',true).
concept_accession('36588: cpd:C02090','KEGG','C02090',true).
concept_accession('36579: cpd:C00005','KEGG','C00005',true).
concept_accession('36579: cpd:C00005','KEGG','CPD:C00005',true).
concept_accession('36578: cpd:C16331','KEGG','CPD:C16331',true).
concept_accession('36578: cpd:C16331','KEGG','C16331',true).
concept_accession('36577: cpd:C16638','KEGG','C16638',true).
concept_accession('36577: cpd:C16638','KEGG','CPD:C16638',true).
concept_accession('36583: cpd:C03170','KEGG','C03170',true).
concept_accession('36583: cpd:C03170','KEGG','CPD:C03170',true).
concept_accession('36582: cpd:C00794','KEGG','CPD:C00794',true).
concept_accession('36582: cpd:C00794','KEGG','C00794',true).
concept_accession('36580: cpd:C05761','KEGG','CPD:C05761',true).
concept_accession('36580: cpd:C05761','KEGG','C05761',true).
concept_accession('36568: cpd:C03460','KEGG','C03460',true).
concept_accession('36568: cpd:C03460','KEGG','CPD:C03460',true).
concept_accession('36570: cpd:C06000','KEGG','CPD:C06000',true).
concept_accession('36570: cpd:C06000','KEGG','C06000',true).
concept_accession('36572: cpd:C06001','KEGG','CPD:C06001',true).
concept_accession('36572: cpd:C06001','KEGG','C06001',true).
concept_accession('36573: cpd:C14840','KEGG','C14840',true).
concept_accession('36573: cpd:C14840','KEGG','CPD:C14840',true).
concept_accession('36575: dr:D00536 cpd:C07501','KEGG','CPD:C07501',true).
concept_accession('36575: dr:D00536 cpd:C07501','KEGG','C07501',true).
concept_accession('36575: dr:D00536 cpd:C07501','KEGG','D00536',true).
concept_accession('36575: dr:D00536 cpd:C07501','KEGG','DR:D00536',true).
concept_accession('36560: cpd:C03345','KEGG','C03345',true).
concept_accession('36560: cpd:C03345','KEGG','CPD:C03345',true).
concept_accession('38777: cpd:C00255','KEGG','C00255',true).
concept_accession('38777: cpd:C00255','KEGG','CPD:C00255',true).
concept_accession('36562: cpd:C04405','KEGG','C04405',true).
concept_accession('36562: cpd:C04405','KEGG','CPD:C04405',true).
concept_accession('38779: cpd:C00007','KEGG','C00007',true).
concept_accession('38779: cpd:C00007','KEGG','CPD:C00007',true).
concept_accession('36565: cpd:C00630','KEGG','CPD:C00630',true).
concept_accession('36565: cpd:C00630','KEGG','C00630',true).
concept_accession('36555: cpd:C00134','KEGG','C00134',true).
concept_accession('36555: cpd:C00134','KEGG','CPD:C00134',true).
concept_accession('36554: cpd:C03344','KEGG','CPD:C03344',true).
concept_accession('36554: cpd:C03344','KEGG','C03344',true).
concept_accession('36559: cpd:C05762','KEGG','CPD:C05762',true).
concept_accession('36559: cpd:C05762','KEGG','C05762',true).
concept_accession('36558: cpd:C00043','KEGG','C00043',true).
concept_accession('36558: cpd:C00043','KEGG','CPD:C00043',true).
concept_accession('36547: cpd:C05378','KEGG','C05378',true).
concept_accession('36547: cpd:C05378','KEGG','CPD:C05378',true).
concept_accession('36546: cpd:C00184','KEGG','C00184',true).
concept_accession('36546: cpd:C00184','KEGG','CPD:C00184',true).
concept_accession('36548: cpd:C14786','KEGG','C14786',true).
concept_accession('36548: cpd:C14786','KEGG','CPD:C14786',true).
concept_accession('36550: cpd:C14839','KEGG','C14839',true).
concept_accession('36550: cpd:C14839','KEGG','CPD:C14839',true).
concept_accession('36542: cpd:C03284','KEGG','C03284',true).
concept_accession('36542: cpd:C03284','KEGG','CPD:C03284',true).
concept_accession('36541: cpd:C14800','KEGG','CPD:C14800',true).
concept_accession('36541: cpd:C14800','KEGG','C14800',true).
concept_accession('36538: cpd:C00234','KEGG','CPD:C00234',true).
concept_accession('36538: cpd:C00234','KEGG','C00234',true).
concept_accession('36536: cpd:C00054','KEGG','C00054',true).
concept_accession('36536: cpd:C00054','KEGG','CPD:C00054',true).
concept_accession('38673: cpd:C00534','KEGG','CPD:C00534',true).
concept_accession('38673: cpd:C00534','KEGG','C00534',true).
concept_accession('36534: cpd:C00506','KEGG','CPD:C00506',true).
concept_accession('36534: cpd:C00506','KEGG','C00506',true).
concept_accession('36532: cpd:C05998','KEGG','C05998',true).
concept_accession('36532: cpd:C05998','KEGG','CPD:C05998',true).
concept_accession('36530: cpd:C01678','KEGG','CPD:C01678',true).
concept_accession('36530: cpd:C01678','KEGG','C01678',true).
concept_accession('38683: cpd:C00314','KEGG','CPD:C00314',true).
concept_accession('38683: cpd:C00314','KEGG','C00314',true).
concept_accession('36531: cpd:C00224','KEGG','C00224',true).
concept_accession('36531: cpd:C00224','KEGG','CPD:C00224',true).
concept_accession('36528: cpd:C03231','KEGG','C03231',true).
concept_accession('36528: cpd:C03231','KEGG','CPD:C03231',true).
concept_accession('36527: cpd:C00606','KEGG','C00606',true).
concept_accession('36527: cpd:C00606','KEGG','CPD:C00606',true).
concept_accession('36526: cpd:C02939','KEGG','C02939',true).
concept_accession('36526: cpd:C02939','KEGG','CPD:C02939',true).
concept_accession('36525: cpd:C03912','KEGG','C03912',true).
concept_accession('36525: cpd:C03912','KEGG','CPD:C03912',true).
concept_accession('36524: cpd:C00053','KEGG','C00053',true).
concept_accession('36524: cpd:C00053','KEGG','CPD:C00053',true).
concept_accession('36523: cpd:C00519','KEGG','CPD:C00519',true).
concept_accession('36523: cpd:C00519','KEGG','C00519',true).
concept_accession('36522: cpd:C03069','KEGG','CPD:C03069',true).
concept_accession('36522: cpd:C03069','KEGG','C03069',true).
concept_accession('38671: cpd:C00250','KEGG','C00250',true).
concept_accession('38671: cpd:C00250','KEGG','CPD:C00250',true).
concept_accession('36519: cpd:C00245','KEGG','C00245',true).
concept_accession('36519: cpd:C00245','KEGG','CPD:C00245',true).
concept_accession('38669: cpd:C00018','KEGG','C00018',true).
concept_accession('38669: cpd:C00018','KEGG','CPD:C00018',true).
concept_accession('36517: cpd:C00095','KEGG','CPD:C00095',true).
concept_accession('36517: cpd:C00095','KEGG','C00095',true).
concept_accession('36516: cpd:C15975','KEGG','CPD:C15975',true).
concept_accession('36516: cpd:C15975','KEGG','C15975',true).
concept_accession('38667: cpd:C00647','KEGG','CPD:C00647',true).
concept_accession('38667: cpd:C00647','KEGG','C00647',true).
concept_accession('36512: cpd:C05844','KEGG','C05844',true).
concept_accession('36512: cpd:C05844','KEGG','CPD:C05844',true).
concept_accession('36509: cpd:C05122','KEGG','CPD:C05122',true).
concept_accession('36509: cpd:C05122','KEGG','C05122',true).
concept_accession('36510: cpd:C00089','KEGG','C00089',true).
concept_accession('36510: cpd:C00089','KEGG','CPD:C00089',true).
concept_accession('36511: cpd:C01146','KEGG','C01146',true).
concept_accession('36511: cpd:C01146','KEGG','CPD:C01146',true).
concept_accession('36505: cpd:C00440','KEGG','C00440',true).
concept_accession('36505: cpd:C00440','KEGG','CPD:C00440',true).
concept_accession('36506: cpd:C06790','KEGG','CPD:C06790',true).
concept_accession('36506: cpd:C06790','KEGG','C06790',true).
concept_accession('36500: gl:G00092','KEGG','G00092',true).
concept_accession('36500: gl:G00092','KEGG','GL:G00092',true).
concept_accession('36501: cpd:C16633','KEGG','C16633',true).
concept_accession('36501: cpd:C16633','KEGG','CPD:C16633',true).
concept_accession('36503: dr:D04197 cpd:C11736','KEGG','C11736',true).
concept_accession('36503: dr:D04197 cpd:C11736','KEGG','CPD:C11736',true).
concept_accession('36503: dr:D04197 cpd:C11736','KEGG','DR:D04197',true).
concept_accession('36503: dr:D04197 cpd:C11736','KEGG','D04197',true).
concept_accession('36496: cpd:C02094','KEGG','C02094',true).
concept_accession('36496: cpd:C02094','KEGG','CPD:C02094',true).
concept_accession('38693: cpd:C06054','KEGG','CPD:C06054',true).
concept_accession('38693: cpd:C06054','KEGG','C06054',true).
concept_accession('36492: cpd:C00135','KEGG','C00135',true).
concept_accession('36492: cpd:C00135','KEGG','CPD:C00135',true).
concept_accession('36495: cpd:C01222','KEGG','C01222',true).
concept_accession('36495: cpd:C01222','KEGG','CPD:C01222',true).
concept_accession('36494: cpd:C04242','KEGG','CPD:C04242',true).
concept_accession('36494: cpd:C04242','KEGG','C04242',true).
concept_accession('38689: cpd:C06055','KEGG','C06055',true).
concept_accession('38689: cpd:C06055','KEGG','CPD:C06055',true).
concept_accession('36489: cpd:C05711','KEGG','CPD:C05711',true).
concept_accession('36489: cpd:C05711','KEGG','C05711',true).
concept_accession('36488: cpd:C02041','KEGG','CPD:C02041',true).
concept_accession('36488: cpd:C02041','KEGG','C02041',true).
concept_accession('38691: cpd:C03451','KEGG','C03451',true).
concept_accession('38691: cpd:C03451','KEGG','CPD:C03451',true).
concept_accession('38690: cpd:C00627','KEGG','C00627',true).
concept_accession('38690: cpd:C00627','KEGG','CPD:C00627',true).
concept_accession('36490: cpd:C01996','KEGG','C01996',true).
concept_accession('36490: cpd:C01996','KEGG','CPD:C01996',true).
concept_accession('36485: cpd:C00412','KEGG','C00412',true).
concept_accession('36485: cpd:C00412','KEGG','CPD:C00412',true).
concept_accession('36484: cpd:C00307','KEGG','C00307',true).
concept_accession('36484: cpd:C00307','KEGG','CPD:C00307',true).
concept_accession('36487: cpd:C04230','KEGG','CPD:C04230',true).
concept_accession('36487: cpd:C04230','KEGG','C04230',true).
concept_accession('36486: cpd:C00246','KEGG','C00246',true).
concept_accession('36486: cpd:C00246','KEGG','CPD:C00246',true).
concept_accession('36481: cpd:C00588','KEGG','C00588',true).
concept_accession('36481: cpd:C00588','KEGG','CPD:C00588',true).
concept_accession('38699: cpd:C00256','KEGG','C00256',true).
concept_accession('38699: cpd:C00256','KEGG','CPD:C00256',true).
concept_accession('36466: cpd:C16630','KEGG','CPD:C16630',true).
concept_accession('36466: cpd:C16630','KEGG','C16630',true).
concept_accession('36465: cpd:C00641','KEGG','C00641',true).
concept_accession('36465: cpd:C00641','KEGG','CPD:C00641',true).
concept_accession('38872: cpd:C03150','KEGG','CPD:C03150',true).
concept_accession('38872: cpd:C03150','KEGG','C03150',true).
concept_accession('36471: cpd:C00344','KEGG','C00344',true).
concept_accession('36471: cpd:C00344','KEGG','CPD:C00344',true).
concept_accession('36470: cpd:C16631','KEGG','CPD:C16631',true).
concept_accession('36470: cpd:C16631','KEGG','C16631',true).
concept_accession('36468: cpd:C03892','KEGG','C03892',true).
concept_accession('36468: cpd:C03892','KEGG','CPD:C03892',true).
concept_accession('38867: cpd:C00857','KEGG','C00857',true).
concept_accession('38867: cpd:C00857','KEGG','CPD:C00857',true).
concept_accession('36475: dr:D01244 cpd:C12673','KEGG','C12673',true).
concept_accession('36475: dr:D01244 cpd:C12673','KEGG','D01244',true).
concept_accession('36475: dr:D01244 cpd:C12673','KEGG','CPD:C12673',true).
concept_accession('36475: dr:D01244 cpd:C12673','KEGG','DR:D01244',true).
concept_accession('36474: cpd:C01019','KEGG','C01019',true).
concept_accession('36474: cpd:C01019','KEGG','CPD:C01019',true).
concept_accession('36473: dr:D00584 cpd:C07649','KEGG','CPD:C07649',true).
concept_accession('36473: dr:D00584 cpd:C07649','KEGG','D00584',true).
concept_accession('36473: dr:D00584 cpd:C07649','KEGG','DR:D00584',true).
concept_accession('36473: dr:D00584 cpd:C07649','KEGG','C07649',true).
concept_accession('38864: cpd:C00003','KEGG','C00003',true).
concept_accession('38864: cpd:C00003','KEGG','CPD:C00003',true).
concept_accession('36472: cpd:C00510','KEGG','C00510',true).
concept_accession('36472: cpd:C00510','KEGG','CPD:C00510',true).
concept_accession('36479: cpd:C16622','KEGG','C16622',true).
concept_accession('36479: cpd:C16622','KEGG','CPD:C16622',true).
concept_accession('38870: cpd:C02918','KEGG','CPD:C02918',true).
concept_accession('38870: cpd:C02918','KEGG','C02918',true).
concept_accession('36478: cpd:C00570','KEGG','C00570',true).
concept_accession('36478: cpd:C00570','KEGG','CPD:C00570',true).
concept_accession('36477: cpd:C01353','KEGG','C01353',true).
concept_accession('36477: cpd:C01353','KEGG','CPD:C01353',true).
concept_accession('36476: cpd:C03794','KEGG','CPD:C03794',true).
concept_accession('36476: cpd:C03794','KEGG','C03794',true).
concept_accession('38858: cpd:C01185','KEGG','C01185',true).
concept_accession('38858: cpd:C01185','KEGG','CPD:C01185',true).
concept_accession('36450: cpd:C01089','KEGG','CPD:C01089',true).
concept_accession('36450: cpd:C01089','KEGG','C01089',true).
concept_accession('36449: cpd:C06428','KEGG','CPD:C06428',true).
concept_accession('36449: cpd:C06428','KEGG','C06428',true).
concept_accession('36454: cpd:C00385','KEGG','C00385',true).
concept_accession('36454: cpd:C00385','KEGG','CPD:C00385',true).
concept_accession('36455: cpd:C05382','KEGG','C05382',true).
concept_accession('36455: cpd:C05382','KEGG','CPD:C05382',true).
concept_accession('36453: cpd:C00430','KEGG','C00430',true).
concept_accession('36453: cpd:C00430','KEGG','CPD:C00430',true).
concept_accession('38848: cpd:C03722','KEGG','C03722',true).
concept_accession('38848: cpd:C03722','KEGG','CPD:C03722',true).
concept_accession('36456: cpd:C00157','KEGG','CPD:C00157',true).
concept_accession('36456: cpd:C00157','KEGG','C00157',true).
concept_accession('36457: cpd:C00740','KEGG','C00740',true).
concept_accession('36457: cpd:C00740','KEGG','CPD:C00740',true).
concept_accession('38855: cpd:C00455','KEGG','C00455',true).
concept_accession('38855: cpd:C00455','KEGG','CPD:C00455',true).
concept_accession('36463: cpd:C16634','KEGG','C16634',true).
concept_accession('36463: cpd:C16634','KEGG','CPD:C16634',true).
concept_accession('36460: cpd:C16632','KEGG','CPD:C16632',true).
concept_accession('36460: cpd:C16632','KEGG','C16632',true).
concept_accession('38904: cpd:C05842','KEGG','C05842',true).
concept_accession('38904: cpd:C05842','KEGG','CPD:C05842',true).
concept_accession('38907: cpd:C05843','KEGG','C05843',true).
concept_accession('38907: cpd:C05843','KEGG','CPD:C05843',true).
concept_accession('36435: cpd:C00416','KEGG','CPD:C00416',true).
concept_accession('36435: cpd:C00416','KEGG','C00416',true).
concept_accession('36434: cpd:C12144','KEGG','C12144',true).
concept_accession('36434: cpd:C12144','KEGG','CPD:C12144',true).
concept_accession('36437: cpd:C01888','KEGG','C01888',true).
concept_accession('36437: cpd:C01888','KEGG','CPD:C01888',true).
concept_accession('36439: cpd:C00546','KEGG','C00546',true).
concept_accession('36439: cpd:C00546','KEGG','CPD:C00546',true).
concept_accession('38910: cpd:C05841','KEGG','CPD:C05841',true).
concept_accession('38910: cpd:C05841','KEGG','C05841',true).
concept_accession('36438: cpd:C01194','KEGG','C01194',true).
concept_accession('36438: cpd:C01194','KEGG','CPD:C01194',true).
concept_accession('36441: cpd:C00052','KEGG','C00052',true).
concept_accession('36441: cpd:C00052','KEGG','CPD:C00052',true).
concept_accession('36440: cpd:C00513','KEGG','C00513',true).
concept_accession('36440: cpd:C00513','KEGG','CPD:C00513',true).
concept_accession('36443: cpd:C00269','KEGG','C00269',true).
concept_accession('36443: cpd:C00269','KEGG','CPD:C00269',true).
concept_accession('38898: cpd:C00153','KEGG','C00153',true).
concept_accession('38898: cpd:C00153','KEGG','CPD:C00153',true).
concept_accession('36445: cpd:C06427','KEGG','C06427',true).
concept_accession('36445: cpd:C06427','KEGG','CPD:C06427',true).
concept_accession('36444: cpd:C00446','KEGG','C00446',true).
concept_accession('36444: cpd:C00446','KEGG','CPD:C00446',true).
concept_accession('36447: cpd:C00189','KEGG','C00189',true).
concept_accession('36447: cpd:C00189','KEGG','CPD:C00189',true).
concept_accession('36446: cpd:C02050','KEGG','CPD:C02050',true).
concept_accession('36446: cpd:C02050','KEGG','C02050',true).
concept_accession('36417: cpd:C01672','KEGG','C01672',true).
concept_accession('36417: cpd:C01672','KEGG','CPD:C01672',true).
concept_accession('36418: cpd:C00147','KEGG','C00147',true).
concept_accession('36418: cpd:C00147','KEGG','CPD:C00147',true).
concept_accession('36419: cpd:C00093','KEGG','CPD:C00093',true).
concept_accession('36419: cpd:C00093','KEGG','C00093',true).
concept_accession('36420: cpd:C00408','KEGG','C00408',true).
concept_accession('36420: cpd:C00408','KEGG','CPD:C00408',true).
concept_accession('36421: cpd:C01242','KEGG','CPD:C01242',true).
concept_accession('36421: cpd:C01242','KEGG','C01242',true).
concept_accession('38894: cpd:C03688','KEGG','CPD:C03688',true).
concept_accession('38894: cpd:C03688','KEGG','C03688',true).
concept_accession('36422: cpd:C12126','KEGG','C12126',true).
concept_accession('36422: cpd:C12126','KEGG','CPD:C12126',true).
concept_accession('36424: cpd:C00229','KEGG','CPD:C00229',true).
concept_accession('36424: cpd:C00229','KEGG','C00229',true).
concept_accession('36425: cpd:C06425','KEGG','CPD:C06425',true).
concept_accession('36425: cpd:C06425','KEGG','C06425',true).
concept_accession('36428: cpd:C00836','KEGG','C00836',true).
concept_accession('36428: cpd:C00836','KEGG','CPD:C00836',true).
concept_accession('36429: cpd:C00636','KEGG','C00636',true).
concept_accession('36429: cpd:C00636','KEGG','CPD:C00636',true).
concept_accession('36431: cpd:C00681','KEGG','C00681',true).
concept_accession('36431: cpd:C00681','KEGG','CPD:C00681',true).
concept_accession('36407: cpd:C00450','KEGG','C00450',true).
concept_accession('36407: cpd:C00450','KEGG','CPD:C00450',true).
concept_accession('36406: cpd:C02985','KEGG','C02985',true).
concept_accession('36406: cpd:C02985','KEGG','CPD:C02985',true).
concept_accession('36405: cpd:C05973','KEGG','CPD:C05973',true).
concept_accession('36405: cpd:C05973','KEGG','C05973',true).
concept_accession('38812: cpd:C00378','KEGG','C00378',true).
concept_accession('38812: cpd:C00378','KEGG','CPD:C00378',true).
concept_accession('36403: cpd:C04646','KEGG','C04646',true).
concept_accession('36403: cpd:C04646','KEGG','CPD:C04646',true).
concept_accession('38810: cpd:C03028','KEGG','C03028',true).
concept_accession('38810: cpd:C03028','KEGG','CPD:C03028',true).
concept_accession('36402: cpd:C11135','KEGG','C11135',true).
concept_accession('36402: cpd:C11135','KEGG','CPD:C11135',true).
concept_accession('36401: cpd:C05980','KEGG','CPD:C05980',true).
concept_accession('36401: cpd:C05980','KEGG','C05980',true).
concept_accession('36415: cpd:C00015','KEGG','C00015',true).
concept_accession('36415: cpd:C00015','KEGG','CPD:C00015',true).
concept_accession('36414: cpd:C12145','KEGG','CPD:C12145',true).
concept_accession('36414: cpd:C12145','KEGG','C12145',true).
concept_accession('36413: cpd:C06429','KEGG','C06429',true).
concept_accession('36413: cpd:C06429','KEGG','CPD:C06429',true).
concept_accession('36411: cpd:C00325','KEGG','C00325',true).
concept_accession('36411: cpd:C00325','KEGG','CPD:C00325',true).
concept_accession('36410: cpd:C04438','KEGG','CPD:C04438',true).
concept_accession('36410: cpd:C04438','KEGG','C04438',true).
concept_accession('36408: cpd:C01290','KEGG','CPD:C01290',true).
concept_accession('36408: cpd:C01290','KEGG','C01290',true).
concept_accession('36391: cpd:C00170','KEGG','C00170',true).
concept_accession('36391: cpd:C00170','KEGG','CPD:C00170',true).
concept_accession('36388: cpd:C06174;dr:D00195 cpd:C06174','KEGG','CPD:C06174',true).
concept_accession('36388: cpd:C06174;dr:D00195 cpd:C06174','KEGG','DR:D00195',true).
concept_accession('36388: cpd:C06174;dr:D00195 cpd:C06174','KEGG','C06174',true).
concept_accession('36388: cpd:C06174;dr:D00195 cpd:C06174','KEGG','D00195',true).
concept_accession('36386: cpd:C01137','KEGG','C01137',true).
concept_accession('36386: cpd:C01137','KEGG','CPD:C01137',true).
concept_accession('36387: cpd:C04373','KEGG','CPD:C04373',true).
concept_accession('36387: cpd:C04373','KEGG','C04373',true).
concept_accession('36385: cpd:C00986','KEGG','C00986',true).
concept_accession('36385: cpd:C00986','KEGG','CPD:C00986',true).
concept_accession('36398: cpd:C00523','KEGG','CPD:C00523',true).
concept_accession('36398: cpd:C00523','KEGG','C00523',true).
concept_accession('36399: dr:D00346 cpd:C07054','KEGG','C07054',true).
concept_accession('36399: dr:D00346 cpd:C07054','KEGG','D00346',true).
concept_accession('36399: dr:D00346 cpd:C07054','KEGG','DR:D00346',true).
concept_accession('36399: dr:D00346 cpd:C07054','KEGG','CPD:C07054',true).
concept_accession('36397: cpd:C03242','KEGG','CPD:C03242',true).
concept_accession('36397: cpd:C03242','KEGG','C03242',true).
concept_accession('38787: cpd:C00016','KEGG','CPD:C00016',true).
concept_accession('38787: cpd:C00016','KEGG','C00016',true).
concept_accession('36392: cpd:C11136','KEGG','CPD:C11136',true).
concept_accession('36392: cpd:C11136','KEGG','C11136',true).
concept_accession('36393: cpd:C06124','KEGG','C06124',true).
concept_accession('36393: cpd:C06124','KEGG','CPD:C06124',true).
concept_accession('36372: cpd:C02737','KEGG','C02737',true).
concept_accession('36372: cpd:C02737','KEGG','CPD:C02737',true).
concept_accession('36375: cpd:C00249','KEGG','C00249',true).
concept_accession('36375: cpd:C00249','KEGG','CPD:C00249',true).
concept_accession('36368: dr:D01223 cpd:C12650','KEGG','C12650',true).
concept_accession('36368: dr:D01223 cpd:C12650','KEGG','D01223',true).
concept_accession('36368: dr:D01223 cpd:C12650','KEGG','CPD:C12650',true).
concept_accession('36368: dr:D01223 cpd:C12650','KEGG','DR:D01223',true).
concept_accession('36370: cpd:C00712','KEGG','C00712',true).
concept_accession('36370: cpd:C00712','KEGG','CPD:C00712',true).
concept_accession('36380: cpd:C00219','KEGG','C00219',true).
concept_accession('36380: cpd:C00219','KEGG','CPD:C00219',true).
concept_accession('36382: cpd:C16614','KEGG','C16614',true).
concept_accession('36382: cpd:C16614','KEGG','CPD:C16614',true).
concept_accession('36376: cpd:C01241','KEGG','CPD:C01241',true).
concept_accession('36376: cpd:C01241','KEGG','C01241',true).
concept_accession('36379: cpd:C05294','KEGG','CPD:C05294',true).
concept_accession('36379: cpd:C05294','KEGG','C05294',true).
concept_accession('36359: cpd:C05293','KEGG','CPD:C05293',true).
concept_accession('36359: cpd:C05293','KEGG','C05293',true).
concept_accession('36352: cpd:C05560','KEGG','C05560',true).
concept_accession('36352: cpd:C05560','KEGG','CPD:C05560',true).
concept_accession('36353: cpd:C03917','KEGG','C03917',true).
concept_accession('36353: cpd:C03917','KEGG','CPD:C03917',true).
concept_accession('36354: cpd:C00148','KEGG','C00148',true).
concept_accession('36354: cpd:C00148','KEGG','CPD:C00148',true).
concept_accession('36364: cpd:C01530','KEGG','C01530',true).
concept_accession('36364: cpd:C01530','KEGG','CPD:C01530',true).
concept_accession('36365: cpd:C00350','KEGG','CPD:C00350',true).
concept_accession('36365: cpd:C00350','KEGG','C00350',true).
concept_accession('36367: cpd:C05290','KEGG','C05290',true).
concept_accession('36367: cpd:C05290','KEGG','CPD:C05290',true).
concept_accession('36361: cpd:C11134','KEGG','C11134',true).
concept_accession('36361: cpd:C11134','KEGG','CPD:C11134',true).
concept_accession('36362: cpd:C00187','KEGG','CPD:C00187',true).
concept_accession('36362: cpd:C00187','KEGG','C00187',true).
produces('40583: rn:R07822','37821: gl:G12336','IMPD').
produces('40601: rn:R06127','37250: gl:G10526','IMPD').
produces('40634: rn:R08615','36228: cpd:C00191','IMPD').
produces('11774: rn:R00524','36079: cpd:C00058','IMPD').
produces('40632: rn:R08163','36364: cpd:C01530','IMPD').
produces('40586: rn:R07807','37808: gl:G06780','IMPD').
produces('40590: rn:R05927','37688: gl:G00156','IMPD').
produces('11779: rn:R00485','35941: cpd:C00014','IMPD').
produces('40585: rn:R07818','37793: gl:G09660','IMPD').
produces('40631: rn:R02814','36370: cpd:C00712','IMPD').
produces('11779: rn:R00485','35959: cpd:C00049','IMPD').
produces('40623: rn:R04960','36631: cpd:C05753','IMPD').
produces('40584: rn:R07812','37834: gl:G13035','IMPD').
produces('40579: rn:R07814','37828: gl:G13037','IMPD').
produces('40578: rn:R07813','37824: gl:G13036','IMPD').
produces('40581: rn:R07811','37832: gl:G13034','IMPD').
produces('40582: rn:R07816','37799: gl:G13039','IMPD').
produces('11778: rn:R01339','36134: cpd:C05167','IMPD').
produces('11784: rn:R00897','35949: cpd:C00033','IMPD').
produces('6090: rn:R08639','36170: cpd:C00092','IMPD').
produces('40575: rn:R07821','37818: gl:G13042','IMPD').
produces('40595: rn:R05928','37195: gl:G00157','IMPD').
produces('40573: rn:R07809','37867: gl:G08421','IMPD').
produces('11784: rn:R00897','35962: cpd:C00097','IMPD').
produces('40574: rn:R07824','37815: gl:G00872','IMPD').
produces('40577: rn:R07823','37813: gl:G13043','IMPD').
produces('40576: rn:R07824','37815: gl:G00872','IMPD').
produces('40572: rn:R07816','37799: gl:G13039','IMPD').
produces('40571: rn:R07825','37815: gl:G00872','IMPD').
produces('40611: rn:R05983','36609: gl:G00013','IMPD').
produces('40570: rn:R07810','37867: gl:G08421','IMPD').
produces('40609: rn:R05935','37531: gl:G00163','IMPD').
produces('10582: rn:R03166','38092: cpd:C05766','IMPD').
produces('40589: rn:R07808','37871: gl:G13033','IMPD').
produces('4840: rn:R01608','36164: cpd:C00222','IMPD').
produces('40596: rn:R05929','37683: gl:G00158','IMPD').
produces('40597: rn:R05931','37681: gl:G00159','IMPD').
produces('40606: rn:R06264','37387: gl:G00008','IMPD').
produces('293: rn:R01481','36228: cpd:C00191','IMPD').
produces('40598: rn:R05932','37678: gl:G00160','IMPD').
produces('40587: rn:R07806','37803: gl:G13032','IMPD').
produces('11774: rn:R00524','35941: cpd:C00014','IMPD').
produces('40625: rn:R04963','36636: cpd:C05756','IMPD').
produces('40605: rn:R06263','37228: gl:G10599','IMPD').
produces('40627: rn:R04726','36595: cpd:C05759','IMPD').
produces('40607: rn:R02957','37219: cpd:C00818','IMPD').
produces('40592: rn:R05926','37691: gl:G00155','IMPD').
produces('40628: rn:R04968','36559: cpd:C05762','IMPD').
produces('40594: rn:R05925','37653: gl:G00154','IMPD').
produces('40603: rn:R06238','37383: gl:G00005','IMPD').
produces('40602: rn:R06261','37390: gl:G00007','IMPD').
produces('40588: rn:R07809','37867: gl:G08421','IMPD').
produces('41567: rn:R00119','38898: cpd:C00153','IMPD').
produces('40549: rn:R07811','37832: gl:G13034','IMPD').
produces('40593: rn:R09034','36438: cpd:C01194','IMPD').
produces('9750: rn:R00740','36164: cpd:C00222','IMPD').
produces('40591: rn:R09037','36401: cpd:C05980','IMPD').
produces('41563: rn:R03004','38858: cpd:C01185','IMPD').
produces('41569: rn:R00277','38669: cpd:C00018','IMPD').
produces('41568: rn:R01710','38671: cpd:C00250','IMPD').
produces('9749: rn:R01196','36031: cpd:C00011','IMPD').
produces('1552: rn:R08995','37156: cpd:C05284','IMPD').
produces('41566: rn:R03004','38858: cpd:C01185','IMPD').
produces('41564: rn:R03346','38910: cpd:C05841','IMPD').
produces('9749: rn:R01196','35944: cpd:C00024','IMPD').
produces('41565: rn:R03348','38858: cpd:C01185','IMPD').
produces('41571: rn:R02493','38667: cpd:C00647','IMPD').
produces('41570: rn:R02494','38673: cpd:C00534','IMPD').
produces('40580: rn:R03184','37458: cpd:C03289','IMPD').
produces('40569: rn:R07819','37810: gl:G02632','IMPD').
produces('40604: rn:R05981','36643: gl:G00011','IMPD').
produces('40566: rn:R07822','37821: gl:G12336','IMPD').
produces('40568: rn:R07818','37793: gl:G09660','IMPD').
produces('40567: rn:R07813','37824: gl:G13036','IMPD').
produces('7030: rn:R07383','36191: cpd:C03454','IMPD').
produces('40565: rn:R07806','37803: gl:G13032','IMPD').
produces('40564: rn:R07812','37834: gl:G13035','IMPD').
produces('7029: rn:R07382','36286: cpd:C15647','IMPD').
produces('40563: rn:R07824','37815: gl:G00872','IMPD').
produces('40558: rn:R07808','37871: gl:G13033','IMPD').
produces('40561: rn:R07807','37808: gl:G06780','IMPD').
produces('40559: rn:R07823','37813: gl:G13043','IMPD').
produces('40599: rn:R09036','36471: cpd:C00344','IMPD').
produces('3785: rn:R03341','37325: cpd:C03765','IMPD').
produces('40555: rn:R07821','37818: gl:G13042','IMPD').
produces('40610: rn:R00647','36172: cpd:C00072','IMPD').
produces('40608: rn:R02933','36234: cpd:C00800','IMPD').
produces('40553: rn:R07811','37832: gl:G13034','IMPD').
produces('40600: rn:R09035','36372: cpd:C02737','IMPD').
produces('11734: rn:R00493','36134: cpd:C05167','IMPD').
produces('2597: rn:R01566','36150: cpd:C00213','IMPD').
produces('2602: rn:R02722','36005: cpd:C00078','IMPD').
produces('40705: rn:R00885','35977: cpd:C00096','IMPD').
produces('40681: rn:R01351','36682: cpd:C00162','IMPD').
produces('2613: rn:R04861','35952: cpd:C00022','IMPD').
produces('2599: rn:R01800','36372: cpd:C02737','IMPD').
produces('40688: rn:R04544','36610: cpd:C05763','IMPD').
produces('40693: rn:R01818','36429: cpd:C00636','IMPD').
produces('40687: rn:R04970','36614: cpd:C05764','IMPD').
produces('40701: rn:R01786','36175: cpd:C00668','IMPD').
produces('40690: rn:R04543','36603: cpd:C04633','IMPD').
produces('40694: rn:R01036 rn:R01041','36048: cpd:C00577','IMPD').
produces('40674: rn:R04952','36664: cpd:C05746','IMPD').
produces('40684: rn:R01706','36375: cpd:C00249','IMPD').
produces('40682: rn:R01706','36375: cpd:C00249','IMPD').
produces('40673: rn:R04536','36668: cpd:C04620','IMPD').
produces('40692: rn:R01819','36087: cpd:C05345','IMPD').
produces('40652: rn:R01201','37322: cpd:C00357','IMPD').
produces('40654: rn:R01805','37348: cpd:C00270','IMPD').
produces('9699: rn:R00943','36538: cpd:C00234','IMPD').
produces('40676: rn:R04957','36669: cpd:C05750','IMPD').
produces('40653: rn:R01117','37353: cpd:C00128','IMPD').
produces('40683: rn:R02757','36431: cpd:C00681','IMPD').
produces('40698: rn:R01041','36048: cpd:C00577','IMPD').
produces('40657: rn:R02705','37340: cpd:C04257','IMPD').
produces('2613: rn:R04861','36323: cpd:C00094','IMPD').
produces('40685: rn:R00847','36419: cpd:C00093','IMPD').
produces('40656: rn:R04435','37340: cpd:C04257','IMPD').
produces('40677: rn:R02687','36682: cpd:C00162','IMPD').
produces('8732: rn:R00519','36031: cpd:C00011','IMPD').
produces('40697: rn:R01752','36056: cpd:C00258','IMPD').
produces('40696: rn:R00959','36175: cpd:C00668','IMPD').
produces('8733: rn:R03146','36031: cpd:C00011','IMPD').
produces('9715: rn:R09317','35944: cpd:C00024','IMPD').
produces('4865: rn:R01164','36861: cpd:C00386','IMPD').
produces('40619: rn:R05907','39115: gl:G00023','IMPD').
produces('40706: rn:R01951','36411: cpd:C00325','IMPD').
produces('40620: rn:R05911','39112: gl:G00035','IMPD').
produces('40702: rn:R04568','36587: cpd:C05760','IMPD').
produces('40699: rn:R01350','36682: cpd:C00162','IMPD').
produces('40709: rn:R03161','36406: cpd:C02985','IMPD').
produces('40621: rn:R07628','39130: gl:G00032','IMPD').
produces('40622: rn:R05914','39100: gl:G00027','IMPD').
produces('4907: rn:R09076','36162: cpd:C00315','IMPD').
produces('8740: rn:R01392','36028: cpd:C00168','IMPD').
produces('40624: rn:R05910','39128: gl:G00031','IMPD').
produces('11694: rn:R00482','35946: cpd:C00152','IMPD').
produces('2618: rn:R00179','36391: cpd:C00170','IMPD').
produces('8739: rn:R01388 rn:R01392','36028: cpd:C00168','IMPD').
produces('10693: rn:R08375','36751: cpd:C00621','IMPD').
produces('40708: rn:R04566','36590: cpd:C04688','IMPD').
produces('12614: rn:R02383','37316: cpd:C03758','IMPD').
produces('40721: rn:R00959','36175: cpd:C00668','IMPD').
produces('8741: rn:R01388','36028: cpd:C00168','IMPD').
produces('40626: rn:R05915','39106: gl:G00029','IMPD').
produces('8744: rn:R00472','35998: cpd:C00048','IMPD').
produces('40612: rn:R05909','39104: gl:G00028','IMPD').
produces('40695: rn:R04968','36559: cpd:C05762','IMPD').
produces('40613: rn:R05907','39115: gl:G00023','IMPD').
produces('40699: rn:R01350','36465: cpd:C00641','IMPD').
produces('40614: rn:R05911','39112: gl:G00035','IMPD').
produces('40615: rn:R07628','39130: gl:G00032','IMPD').
produces('40703: rn:R01092','36444: cpd:C00446','IMPD').
produces('40618: rn:R05909','39104: gl:G00028','IMPD').
produces('40704: rn:R02240','36435: cpd:C00416','IMPD').
produces('40700: rn:R04967','36580: cpd:C05761','IMPD').
produces('3694: rn:R00042','37282: cpd:C00642','IMPD').
produces('40651: rn:R04725','36649: cpd:C05223','IMPD').
produces('9680: rn:R09289','36300: cpd:C01013','IMPD').
produces('9688: rn:R00473','35998: cpd:C00048','IMPD').
produces('40633: rn:R07762','37365: cpd:C16219','IMPD').
produces('4867: rn:R01166','36040: cpd:C00099','IMPD').
produces('40655: rn:R04964','36640: cpd:C05757','IMPD').
produces('40630: rn:R04014','37415: cpd:C02679','IMPD').
produces('40661: rn:R00955','36441: cpd:C00052','IMPD').
produces('4857: rn:R01914','36385: cpd:C00986','IMPD').
produces('40629: rn:R08159','37417: cpd:C06424','IMPD').
produces('40660: rn:R00291','36441: cpd:C00052','IMPD').
produces('9688: rn:R00473','35944: cpd:C00024','IMPD').
produces('11692: rn:R00490','35941: cpd:C00014','IMPD').
produces('40665: rn:R01384','35988: cpd:C00190','IMPD').
produces('9679: rn:R00740','36164: cpd:C00222','IMPD').
produces('40659: rn:R00286','36142: cpd:C00167','IMPD').
produces('11693: rn:R00483','35946: cpd:C00152','IMPD').
produces('11691: rn:R00490','35941: cpd:C00014','IMPD').
produces('3699: rn:R02520','37257: cpd:C05585','IMPD').
produces('40648: rn:R04965','36645: cpd:C05758','IMPD').
produces('5955: rn:R02335','37216: cpd:C00461','IMPD').
produces('40617: rn:R05930','37533: gl:G00162','IMPD').
produces('9673: rn:R00267','36132: cpd:C00311','IMPD').
produces('40661: rn:R00955','36174: cpd:C00103','IMPD').
produces('40649: rn:R00416','36558: cpd:C00043','IMPD').
produces('40616: rn:R05936','37534: gl:G00164','IMPD').
produces('40667: rn:R04959','36672: cpd:C05752','IMPD').
produces('40668: rn:R04960','36631: cpd:C05753','IMPD').
produces('9703: rn:R00230','36169: cpd:C00227','IMPD').
produces('40675: rn:R02241','36435: cpd:C00416','IMPD').
produces('390: rn:R00878','36517: cpd:C00095','IMPD').
produces('4867: rn:R01166','36492: cpd:C00135','IMPD').
produces('40666: rn:R04534','36629: cpd:C04619','IMPD').
produces('40681: rn:R01351','36186: cpd:C00116','IMPD').
produces('40678: rn:R02239','36465: cpd:C00641','IMPD').
produces('40650: rn:R08193','37330: cpd:C04501','IMPD').
produces('392: rn:R00877','36517: cpd:C00095','IMPD').
produces('4857: rn:R01914','36850: cpd:C00555','IMPD').
produces('8710: rn:R00479','35998: cpd:C00048','IMPD').
produces('40672: rn:R04957','36669: cpd:C05750','IMPD').
produces('40680: rn:R00851','36431: cpd:C00681','IMPD').
produces('8709: rn:R00470','35998: cpd:C00048','IMPD').
produces('9705: rn:R00237','35944: cpd:C00024','IMPD').
produces('40669: rn:R04537','36674: cpd:C05751','IMPD').
produces('9705: rn:R00237','35952: cpd:C00022','IMPD').
produces('40647: rn:R00414','37334: cpd:C00645','IMPD').
produces('8708: rn:R00477','35998: cpd:C00048','IMPD').
produces('40691: rn:R01514','35980: cpd:C00197','IMPD').
produces('8709: rn:R00470','35952: cpd:C00022','IMPD').
produces('40670: rn:R02250','36682: cpd:C00162','IMPD').
produces('8708: rn:R00477','35957: cpd:C00036','IMPD').
produces('4849: rn:R02473','37130: cpd:C00864','IMPD').
produces('399: rn:R02730','36318: cpd:C03267','IMPD').
produces('9698: rn:R00134','36079: cpd:C00058','IMPD').
produces('8710: rn:R00479','36137: cpd:C00042','IMPD').
produces('40635: rn:R08159','37417: cpd:C06424','IMPD').
produces('40658: rn:R04962','36621: cpd:C05755','IMPD').
produces('40664: rn:R04535','36625: cpd:C05754','IMPD').
produces('40670: rn:R02250','36465: cpd:C00641','IMPD').
produces('40663: rn:R02059','36686: cpd:C00352','IMPD').
produces('40679: rn:R01011','36095: cpd:C00111','IMPD').
produces('40662: rn:R04963','36636: cpd:C05756','IMPD').
produces('13665: rn:R08249','36320: cpd:C07447','IMPD').
produces('4845: rn:R01611','37006: cpd:C00804','IMPD').
produces('41550: rn:R01086','36116: cpd:C00062','IMPD').
produces('41537: rn:R01248 rn:R01251','36525: cpd:C03912','IMPD').
produces('41480: rn:R04313','38262: cpd:C03793','IMPD').
produces('40497: rn:R01015','36095: cpd:C00111','IMPD').
produces('41465: rn:R00548','38777: cpd:C00255','IMPD').
produces('41481: rn:R03451','38282: cpd:C01259','IMPD').
produces('2404: rn:R00576','36656: cpd:C00940','IMPD').
produces('41555: rn:R00149','35970: cpd:C00169','IMPD').
produces('40498: rn:R02568','36095: cpd:C00111','IMPD').
produces('41539: rn:R01253','36525: cpd:C03912','IMPD').
produces('41466: rn:R00161','38787: cpd:C00016','IMPD').
produces('40477: rn:R08107','36809: gl:G13044','IMPD').
produces('40488: rn:R01318','36456: cpd:C00157','IMPD').
produces('40476: rn:R05918','36830: gl:G00145','IMPD').
produces('40475: rn:R05921','36843: gl:G00148','IMPD').
produces('41558: rn:R00256','35941: cpd:C00014','IMPD').
produces('40496: rn:R01070','36025: cpd:C00118','IMPD').
produces('41546: rn:R00135','36354: cpd:C00148','IMPD').
produces('40491: rn:R01013','36204: cpd:C03372','IMPD').
produces('40495: rn:R04780','36087: cpd:C05345','IMPD').
produces('41540: rn:R00104','36613: cpd:C00006','IMPD').
produces('41487: rn:R01940','38250: cpd:C06157','IMPD').
produces('40498: rn:R02568','36048: cpd:C00577','IMPD').
produces('41562: rn:R00253','35953: cpd:C00064','IMPD').
produces('40503: rn:R00299','36170: cpd:C00092','IMPD').
produces('40482: rn:R05917','36822: gl:G00144','IMPD').
produces('40481: rn:R05922','36846: gl:G00149','IMPD').
produces('40483: rn:R08107','36809: gl:G13044','IMPD').
produces('40506: rn:R00848','36095: cpd:C00111','IMPD').
produces('41542: rn:R00112','36613: cpd:C00006','IMPD').
produces('40510: rn:R01101','35981: cpd:C00031','IMPD').
produces('40504: rn:R01788','36183: cpd:C00267','IMPD').
produces('40484: rn:R05919','36818: gl:G00146','IMPD').
produces('40505: rn:R00299','36170: cpd:C00092','IMPD').
produces('40508: rn:R00842','36095: cpd:C00111','IMPD').
produces('41474: rn:R00616','38810: cpd:C03028','IMPD').
produces('40485: rn:R05919','36818: gl:G00146','IMPD').
produces('40489: rn:R01890','36484: cpd:C00307','IMPD').
produces('9659: rn:R01196','35952: cpd:C00022','IMPD').
produces('40490: rn:R01321','36456: cpd:C00157','IMPD').
produces('40492: rn:R03161','36406: cpd:C02985','IMPD').
produces('40493: rn:R07377','36372: cpd:C02737','IMPD').
produces('40479: rn:R05916','36828: gl:G00143','IMPD').
produces('40478: rn:R06623','36871: gl:G12396','IMPD').
produces('40494: rn:R07376','36372: cpd:C02737','IMPD').
produces('40480: rn:R05920','36814: gl:G00147','IMPD').
produces('9661: rn:R00345','35957: cpd:C00036','IMPD').
produces('41489: rn:R07460','38474: cpd:C15812','IMPD').
produces('41496: rn:R02397','38276: cpd:C00487','IMPD').
produces('40460: rn:R04545','37801: cpd:C05981','IMPD').
produces('41506: rn:R03313','38003: cpd:C01165','IMPD').
produces('40510: rn:R01101','36238: cpd:C00124','IMPD').
produces('41497: rn:R03283','38279: cpd:C01181','IMPD').
produces('40461: rn:R03435','37749: cpd:C01245','IMPD').
produces('40512: rn:R01194','36238: cpd:C00124','IMPD').
produces('41504: rn:R00239','38112: cpd:C03287','IMPD').
produces('3961: rn:R05487','36860: cpd:C05852','IMPD').
produces('4958: rn:R02434','36534: cpd:C00506','IMPD').
produces('40487: rn:R05916','36828: gl:G00143','IMPD').
produces('40499: rn:R01802','36438: cpd:C01194','IMPD').
produces('40515: rn:R01026','35947: cpd:C00114','IMPD').
produces('40500: rn:R02053','36410: cpd:C04438','IMPD').
produces('40486: rn:R05916','36828: gl:G00143','IMPD').
produces('40502: rn:R06870','36447: cpd:C00189','IMPD').
produces('40512: rn:R01194','36139: cpd:C00137','IMPD').
produces('40501: rn:R02241','36435: cpd:C00416','IMPD').
produces('9666: rn:R09280','36077: cpd:C00232','IMPD').
produces('41508: rn:R01989','38128: cpd:C01035','IMPD').
produces('40458: rn:R05202','37752: cpd:C01204','IMPD').
produces('428: rn:R01059','36025: cpd:C00118','IMPD').
produces('40520: rn:R01678','36183: cpd:C00267','IMPD').
produces('425: rn:R02071','36547: cpd:C05378','IMPD').
produces('40474: rn:R05802','37636: cpd:C11556','IMPD').
produces('40511: rn:R02038','36478: cpd:C00570','IMPD').
produces('41509: rn:R00566','38135: cpd:C00179','IMPD').
produces('9672: rn:R01197','35955: cpd:C00026','IMPD').
produces('40526: rn:R00289','36063: cpd:C00029','IMPD').
produces('40513: rn:R01023','36490: cpd:C01996','IMPD').
produces('40521: rn:R01678','36238: cpd:C00124','IMPD').
produces('40521: rn:R01678','36183: cpd:C00267','IMPD').
produces('3953: rn:R01377','36836: cpd:C00601','IMPD').
produces('40520: rn:R01678','36238: cpd:C00124','IMPD').
produces('40507: rn:R00851','36431: cpd:C00681','IMPD').
produces('40516: rn:R01786','36175: cpd:C00668','IMPD').
produces('40514: rn:R02926','36238: cpd:C00124','IMPD').
produces('40509: rn:R02114','36487: cpd:C04230','IMPD').
produces('3943: rn:R06790','37282: cpd:C00642','IMPD').
produces('40463: rn:R07299','37869: cpd:C04549','IMPD').
produces('40518: rn:R01786','36175: cpd:C00668','IMPD').
produces('40453: rn:R00872','36517: cpd:C00095','IMPD').
produces('40433: rn:R04737','37121: cpd:C05258','IMPD').
produces('40471: rn:R00705','35944: cpd:C00024','IMPD').
produces('40464: rn:R01430','36213: cpd:C02266','IMPD').
produces('40434: rn:R03991','37124: cpd:C05259','IMPD').
produces('40435: rn:R03989','37098: cpd:C02593','IMPD').
produces('4926: rn:R05652','36047: cpd:C00041','IMPD').
produces('40444: rn:R04744','36721: cpd:C05275','IMPD').
produces('41494: rn:R02101','36852: cpd:C00415','IMPD').
produces('40470: rn:R00264','35955: cpd:C00026','IMPD').
produces('4921: rn:R00230','36169: cpd:C00227','IMPD').
produces('40448: rn:R04779','36547: cpd:C05378','IMPD').
produces('40452: rn:R01951','36411: cpd:C00325','IMPD').
produces('40429: rn:R04739','37117: cpd:C05260','IMPD').
produces('4911: rn:R05320','36323: cpd:C00094','IMPD').
produces('40442: rn:R04742','36715: cpd:C05263','IMPD').
produces('41510: rn:R01157','36555: cpd:C00134','IMPD').
produces('41500: rn:R01151','36850: cpd:C00555','IMPD').
produces('40430: rn:R03858','37115: cpd:C05261','IMPD').
produces('40443: rn:R04753','36716: cpd:C05274','IMPD').
produces('40454: rn:R01326','36305: cpd:C00275','IMPD').
produces('41507: rn:R00670','36555: cpd:C00134','IMPD').
produces('41488: rn:R01939','37138: cpd:C00322','IMPD').
produces('40440: rn:R03776','36728: cpd:C01944','IMPD').
produces('40457: rn:R01787','36183: cpd:C00267','IMPD').
produces('40451: rn:R01818','36429: cpd:C00636','IMPD').
produces('40395: rn:R00623','38157: cpd:C00071','IMPD').
produces('40441: rn:R04741','36720: cpd:C05262','IMPD').
produces('41476: rn:R03376','37701: cpd:C01211','IMPD').
produces('41477: rn:R04866','37698: cpd:C05545','IMPD').
produces('4923: rn:R05651','36323: cpd:C00094','IMPD').
produces('40459: rn:R00875','36517: cpd:C00095','IMPD').
produces('40461: rn:R03435','36465: cpd:C00641','IMPD').
produces('5934: rn:R02738','36175: cpd:C00668','IMPD').
produces('6907: rn:R01030','36419: cpd:C00093','IMPD').
produces('4923: rn:R05651','36169: cpd:C00227','IMPD').
produces('6905: rn:R01470','36447: cpd:C00189','IMPD').
produces('4908: rn:R09077','36742: cpd:C05665','IMPD').
produces('40436: rn:R04740','37093: cpd:C05273','IMPD').
produces('40462: rn:R00866','36329: cpd:C01094','IMPD').
produces('4907: rn:R09076','36742: cpd:C05665','IMPD').
produces('40403: rn:R04756','38144: cpd:C05279','IMPD').
produces('40472: rn:R01015','36025: cpd:C00118','IMPD').
produces('40473: rn:R01802','36438: cpd:C01194','IMPD').
produces('5869: rn:R02087','37322: cpd:C00357','IMPD').
produces('41484: rn:R03875','37694: cpd:C05544','IMPD').
produces('41461: rn:R03673','38393: cpd:C04185','IMPD').
produces('41482: rn:R03380','37704: cpd:C04487','IMPD').
produces('6905: rn:R01470','36419: cpd:C00093','IMPD').
produces('6906: rn:R04864','36365: cpd:C00350','IMPD').
produces('41471: rn:R03283','38279: cpd:C01181','IMPD').
produces('40469: rn:R05916','36828: gl:G00143','IMPD').
produces('40468: rn:R05916','36828: gl:G00143','IMPD').
produces('40465: rn:R05795','36869: cpd:C11554','IMPD').
produces('40467: rn:R05916','36828: gl:G00143','IMPD').
produces('4935: rn:R00901','36534: cpd:C00506','IMPD').
produces('41522: rn:R02295','36703: cpd:C00253','IMPD').
produces('6896: rn:R02756','36431: cpd:C00681','IMPD').
produces('4936: rn:R01681','36519: cpd:C00245','IMPD').
produces('40466: rn:R05916','36828: gl:G00143','IMPD').
produces('41549: rn:R00551','36091: cpd:C00086','IMPD').
produces('41549: rn:R00551','36094: cpd:C00077','IMPD').
produces('41479: rn:R04867','38266: cpd:C05546','IMPD').
produces('41550: rn:R01086','36085: cpd:C00122','IMPD').
produces('41529: rn:R01724','36703: cpd:C00253','IMPD').
produces('41462: rn:R01709','38727: cpd:C00847','IMPD').
produces('41547: rn:R00669','36094: cpd:C00077','IMPD').
produces('41470: rn:R00615','38449: cpd:C01081','IMPD').
produces('6907: rn:R01030','35947: cpd:C00114','IMPD').
produces('9581: rn:R00341','36031: cpd:C00011','IMPD').
produces('9584: rn:R00214','35952: cpd:C00022','IMPD').
produces('7020: rn:R04571','36265: cpd:C04756','IMPD').
produces('9584: rn:R00214','36031: cpd:C00011','IMPD').
produces('1286: rn:R03724','38235: cpd:C01802','IMPD').
produces('9581: rn:R00341','36129: cpd:C00074','IMPD').
produces('7021: rn:R03415','36215: cpd:C04635','IMPD').
produces('40551: rn:R01799','36443: cpd:C00269','IMPD').
produces('40554: rn:R02055','36365: cpd:C00350','IMPD').
produces('40562: rn:R00286','36142: cpd:C00167','IMPD').
produces('40533: rn:R03236 rn:R03237 rn:R03238 rn:R03239','37028: cpd:C03785','IMPD').
produces('41552: rn:R00259','38084: cpd:C00624','IMPD').
produces('1285: rn:R04667','38214: cpd:C05107','IMPD').
produces('41528: rn:R00257','38864: cpd:C00003','IMPD').
produces('40560: rn:R01184','36228: cpd:C00191','IMPD').
produces('1339: rn:R02797','36519: cpd:C00245','IMPD').
produces('40556: rn:R00855','36419: cpd:C00093','IMPD').
produces('40538: rn:R05549','37038: cpd:C05402','IMPD').
produces('520: rn:R01069','36025: cpd:C00118','IMPD').
produces('41548: rn:R01711','38671: cpd:C00250','IMPD').
produces('3875: rn:R02540','36831: cpd:C07086','IMPD').
produces('41536: rn:R00102','38898: cpd:C00153','IMPD').
produces('40545: rn:R01093 rn:R01095','37023: cpd:C01697','IMPD').
produces('41538: rn:R01269','38870: cpd:C02918','IMPD').
produces('520: rn:R01069','36095: cpd:C00111','IMPD').
produces('41554: rn:R05085','38693: cpd:C06054','IMPD').
produces('2503: rn:R01388','36028: cpd:C00168','IMPD').
produces('41557: rn:R00174','38669: cpd:C00018','IMPD').
produces('9603: rn:R00345','35957: cpd:C00036','IMPD').
produces('41551: rn:R00278','38669: cpd:C00018','IMPD').
produces('1319: rn:R04818 rn:R04819','37659: cpd:C05452','IMPD').
produces('41545: rn:R04085','38907: cpd:C05843','IMPD').
produces('1315: rn:R04824 rn:R04825','37707: cpd:C05454','IMPD').
produces('41544: rn:R08408','38904: cpd:C05842','IMPD').
produces('9598: rn:R00024','35980: cpd:C00197','IMPD').
produces('1354: rn:R03977','36519: cpd:C00245','IMPD').
produces('9605: rn:R00216','35952: cpd:C00022','IMPD').
produces('41559: rn:R00173','38671: cpd:C00250','IMPD').
produces('1327: rn:R03975','37686: cpd:C02528','IMPD').
produces('5848: rn:R01204','37220: cpd:C00140','IMPD').
produces('41561: rn:R01911','38683: cpd:C00314','IMPD').
produces('41560: rn:R01909','38690: cpd:C00627','IMPD').
produces('5849: rn:R01200','37202: cpd:C00329','IMPD').
produces('9605: rn:R00216','36031: cpd:C00011','IMPD').
produces('40534: rn:R07814','37828: gl:G13037','IMPD').
produces('40517: rn:R01021','36481: cpd:C00588','IMPD').
produces('40523: rn:R01468','36283: cpd:C00346','IMPD').
produces('41527: rn:R00558','38069: cpd:C05933','IMPD').
produces('40514: rn:R02926','36582: cpd:C00794','IMPD').
produces('41526: rn:R05052','37999: cpd:C05946','IMPD').
produces('40524: rn:R00959','36175: cpd:C00668','IMPD').
produces('40530: rn:R00955','36174: cpd:C00103','IMPD').
produces('41556: rn:R01954','37026: cpd:C03406','IMPD').
produces('11808: rn:R01930','36328: cpd:C00320','IMPD').
produces('11800: rn:R08553','36531: cpd:C00224','IMPD').
produces('1292: rn:R03311','38995: cpd:C05443','IMPD').
produces('40519: rn:R01315','36487: cpd:C04230','IMPD').
produces('41521: rn:R01881','38071: cpd:C02305','IMPD').
produces('40535: rn:R02746','36189: cpd:C00670','IMPD').
produces('41534: rn:R03291 rn:R03293','38002: cpd:C01157','IMPD').
produces('40525: rn:R01310','36435: cpd:C00416','IMPD').
produces('41535: rn:R04444 rn:R04445','38000: cpd:C05947','IMPD').
produces('40530: rn:R00955','36441: cpd:C00052','IMPD').
produces('41532: rn:R05051','38000: cpd:C05947','IMPD').
produces('1338: rn:R05835','37782: cpd:C00695','IMPD').
produces('40536: rn:R03634','36238: cpd:C00124','IMPD').
produces('11808: rn:R01930','36089: cpd:C00059','IMPD').
produces('40531: rn:R01092','36444: cpd:C00446','IMPD').
produces('41533: rn:R05051','38000: cpd:C05947','IMPD').
produces('41531: rn:R02894','38065: cpd:C03564','IMPD').
produces('40527: rn:R02239','36465: cpd:C00641','IMPD').
produces('40528: rn:R00291','36441: cpd:C00052','IMPD').
produces('2516: rn:R00996','36024: cpd:C00109','IMPD').
produces('40542: rn:R00801','35981: cpd:C00031','IMPD').
produces('41530: rn:R03295','38001: cpd:C04281','IMPD').
produces('40529: rn:R02240','36435: cpd:C00416','IMPD').
produces('11797: rn:R02021','36323: cpd:C00094','IMPD').
produces('1339: rn:R02797','37782: cpd:C00695','IMPD').
produces('11809: rn:R00897','35962: cpd:C00097','IMPD').
produces('40543: rn:R01104','36186: cpd:C00116','IMPD').
produces('41518: rn:R02323','38872: cpd:C03150','IMPD').
produces('40537: rn:R02056','36376: cpd:C01241','IMPD').
produces('11809: rn:R00897','35949: cpd:C00033','IMPD').
produces('2537: rn:R00221','35952: cpd:C00022','IMPD').
produces('1354: rn:R03977','37686: cpd:C02528','IMPD').
produces('41516: rn:R00137','38864: cpd:C00003','IMPD').
produces('40538: rn:R05549','36238: cpd:C00124','IMPD').
produces('41543: rn:R01252','38002: cpd:C01157','IMPD').
produces('40532: rn:R02051','36435: cpd:C00416','IMPD').
produces('41541: rn:R00667','38003: cpd:C01165','IMPD').
produces('40540: rn:R02030 rn:R07390','36401: cpd:C05980','IMPD').
produces('41514: rn:R00137','38864: cpd:C00003','IMPD').
produces('3862: rn:R01377','36836: cpd:C00601','IMPD').
produces('40544: rn:R01329','36238: cpd:C00124','IMPD').
produces('40543: rn:R01104','36238: cpd:C00124','IMPD').
produces('40544: rn:R01329','36212: cpd:C00159','IMPD').
produces('41512: rn:R00103','38855: cpd:C00455','IMPD').
produces('2540: rn:R01388 rn:R01392','36028: cpd:C00168','IMPD').
produces('41511: rn:R00103','38855: cpd:C00455','IMPD').
produces('40541: rn:R01103','36510: cpd:C00089','IMPD').
produces('41553: rn:R01398','38018: cpd:C00327','IMPD').
produces('40548: rn:R03417','36262: cpd:C01233','IMPD').
produces('41525: rn:R03005','38867: cpd:C00857','IMPD').
produces('40557: rn:R06871','35947: cpd:C00114','IMPD').
produces('41524: rn:R03005','38867: cpd:C00857','IMPD').
produces('40522: rn:R00503','37016: cpd:C00243','IMPD').
produces('40546: rn:R03416','36262: cpd:C01233','IMPD').
produces('41523: rn:R03347','38858: cpd:C01185','IMPD').
produces('40539: rn:R01801','36468: cpd:C03892','IMPD').
produces('9574: rn:R00216','36031: cpd:C00011','IMPD').
produces('9574: rn:R00216','35952: cpd:C00022','IMPD').
produces('40550: rn:R04480','36365: cpd:C00350','IMPD').
produces('41520: rn:R02294','38898: cpd:C00153','IMPD').
produces('40536: rn:R03634','36749: cpd:C00492','IMPD').
produces('41519: rn:R01271','38898: cpd:C00153','IMPD').
produces('40542: rn:R00801','36517: cpd:C00095','IMPD').
produces('40547: rn:R02057','36365: cpd:C00350','IMPD').
produces('9572: rn:R00345','35957: cpd:C00036','IMPD').
produces('40552: rn:R02747','36189: cpd:C00670','IMPD').
produces('40904: rn:R05982','36602: gl:G00012','IMPD').
produces('40876: rn:R06187','37468: gl:G00054','IMPD').
produces('550: rn:R02411','36749: cpd:C00492','IMPD').
produces('40878: rn:R06197','37465: gl:G00059','IMPD').
produces('40877: rn:R05977','37486: gl:G00050','IMPD').
produces('40879: rn:R06193','37421: gl:G00072','IMPD').
produces('40874: rn:R06031','37476: gl:G00058','IMPD').
produces('40916: rn:R01602','36188: cpd:C00221','IMPD').
produces('39891: rn:R01954','37026: cpd:C03406','IMPD').
produces('40872: rn:R05978','37479: gl:G00051','IMPD').
produces('40875: rn:R06035','37424: gl:G00071','IMPD').
produces('39897: rn:R01397','36787: cpd:C00438','IMPD').
produces('10317: rn:R02369','37957: cpd:C00899','IMPD').
produces('1811: rn:R02014','37149: cpd:C00131','IMPD').
produces('40913: rn:R01786','36175: cpd:C00668','IMPD').
produces('39858: rn:R00036','38032: cpd:C00931','IMPD').
produces('40871: rn:R06029','37481: gl:G00052','IMPD').
produces('40909: rn:R01600','36197: cpd:C01172','IMPD').
produces('39861: rn:R03165','38090: cpd:C01051','IMPD').
produces('39927: rn:R00443','36088: cpd:C00046','IMPD').
produces('40911: rn:R01786','36175: cpd:C00668','IMPD').
produces('12849: rn:R00462','36417: cpd:C01672','IMPD').
produces('39864: rn:R00310','38030: cpd:C00032','IMPD').
produces('40873: rn:R01009','37336: cpd:C03862','IMPD').
produces('39859: rn:R00084','38085: cpd:C01024','IMPD').
produces('40867: rn:R05971','37485: gl:G00036','IMPD').
produces('39860: rn:R04972','38100: cpd:C05768','IMPD').
produces('39929: rn:R01870','36120: cpd:C00119','IMPD').
produces('40865: rn:R06095','37450: gl:G00056','IMPD').
produces('528: rn:R02410','37038: cpd:C05402','IMPD').
produces('40905: rn:R02739','36197: cpd:C01172','IMPD').
produces('524: rn:R03635','37134: cpd:C05404','IMPD').
produces('40903: rn:R01600','36197: cpd:C01172','IMPD').
produces('39862: rn:R03197','38136: cpd:C03263','IMPD').
produces('39866: rn:R07411','38022: cpd:C15672','IMPD').
produces('40907: rn:R03321','36087: cpd:C05345','IMPD').
produces('40863: rn:R06024','37451: gl:G00055','IMPD').
produces('40864: rn:R06259','37427: gl:G10596','IMPD').
produces('39863: rn:R03222','38123: cpd:C02191','IMPD').
produces('40861: rn:R06027','37481: gl:G00052','IMPD').
produces('6767: rn:R04504','37801: cpd:C05981','IMPD').
produces('40868: rn:R06262','37230: gl:G10598','IMPD').
produces('39856: rn:R05578','37448: cpd:C02987','IMPD').
produces('40866: rn:R06260','37258: gl:G10597','IMPD').
produces('4516: rn:R04172','37731: cpd:C05636','IMPD').
produces('39903: rn:R00359','35957: cpd:C00036','IMPD').
produces('39886: rn:R00768','36686: cpd:C00352','IMPD').
produces('40860: rn:R06167','37303: gl:G00042','IMPD').
produces('40858: rn:R05970','37366: gl:G00002','IMPD').
produces('40859: rn:R01009','37336: cpd:C03862','IMPD').
produces('40902: rn:R06221','36015: gl:G00090','IMPD').
produces('40862: rn:R06258','37252: gl:G10595','IMPD').
produces('39892: rn:R01135','36476: cpd:C03794','IMPD').
produces('40900: rn:R06038','36030: gl:G00089','IMPD').
produces('4503: rn:R01974','37842: cpd:C00637','IMPD').
produces('40857: rn:R06156','37273: gl:G00044','IMPD').
produces('9512: rn:R09094','36031: cpd:C00011','IMPD').
produces('40856: rn:R06006','37243: gl:G00037','IMPD').
produces('39865: rn:R00078','37608: cpd:C14819','IMPD').
produces('40895: rn:R00014','36017: cpd:C05125','IMPD').
produces('40855: rn:R06006','37243: gl:G00037','IMPD').
produces('40853: rn:R06168','37271: gl:G00039','IMPD').
produces('556: rn:R01192','36727: cpd:C01235','IMPD').
produces('39914: rn:R00905','36040: cpd:C00099','IMPD').
produces('39850: rn:R02389','38025: cpd:C05787','IMPD').
produces('40893: rn:R00754','36038: cpd:C00084','IMPD').
produces('40854: rn:R06006','37243: gl:G00037','IMPD').
produces('40847: rn:R06230','37445: gl:G00076','IMPD').
produces('40894: rn:R06032','35976: gl:G00064','IMPD').
produces('40892: rn:R06025','36013: gl:G00060','IMPD').
produces('40852: rn:R06169','37253: gl:G00038','IMPD').
produces('39911: rn:R00442','36088: cpd:C00046','IMPD').
produces('39847: rn:R04979','38072: cpd:C05791','IMPD').
produces('39913: rn:R02269','36036: cpd:C02642','IMPD').
produces('40887: rn:R06037','36041: gl:G00088','IMPD').
produces('39872: rn:R08180','36413: cpd:C06429','IMPD').
produces('39871: rn:R08179','36449: cpd:C06428','IMPD').
produces('39887: rn:R00707 rn:R00708','35960: cpd:C00025','IMPD').
produces('40890: rn:R06026','35986: gl:G00062','IMPD').
produces('1838: rn:R01244','37175: cpd:C00262','IMPD').
produces('39888: rn:R00269','35955: cpd:C00026','IMPD').
produces('39874: rn:R08182','36397: cpd:C03242','IMPD').
produces('40888: rn:R06222','36073: gl:G00085','IMPD').
produces('39875: rn:R08183','36380: cpd:C00219','IMPD').
produces('40843: rn:R02111','37495: cpd:C00718','IMPD').
produces('39890: rn:R00243 rn:R00248','35941: cpd:C00014','IMPD').
produces('40845: rn:R05974','37440: gl:G00068','IMPD').
produces('40851: rn:R06170','37271: gl:G00039','IMPD').
produces('39890: rn:R00243 rn:R00248','35955: cpd:C00026','IMPD').
produces('40891: rn:R00746','36038: cpd:C00084','IMPD').
produces('39877: rn:R08176','36370: cpd:C00712','IMPD').
produces('40883: rn:R06224','36058: gl:G00086','IMPD').
produces('40837: rn:R05977','37486: gl:G00050','IMPD').
produces('3532: rn:R03286','36784: cpd:C01262','IMPD').
produces('39821: rn:R03220','38127: cpd:C01079','IMPD').
produces('40839: rn:R06227','37429: gl:G00082','IMPD').
produces('3501: rn:R03288','37670: cpd:C01152','IMPD').
produces('39878: rn:R08175','36425: cpd:C06425','IMPD').
produces('40889: rn:R06039','35948: gl:G00084','IMPD').
produces('2838: rn:R07160','36565: cpd:C00630','IMPD').
produces('40880: rn:R01070','36025: cpd:C00118','IMPD').
produces('1870: rn:R00469','35941: cpd:C00014','IMPD').
produces('1867: rn:R00131','36031: cpd:C00011','IMPD').
produces('39889: rn:R00713','36137: cpd:C00042','IMPD').
produces('39879: rn:R08178','36445: cpd:C06427','IMPD').
produces('39895: rn:R00369','35952: cpd:C00022','IMPD').
produces('40882: rn:R00710','35949: cpd:C00033','IMPD').
produces('39896: rn:R00258','35952: cpd:C00022','IMPD').
produces('39893: rn:R01083','36085: cpd:C00122','IMPD').
produces('40835: rn:R05977','37486: gl:G00050','IMPD').
produces('6724: rn:R03332','37865: cpd:C01177','IMPD').
produces('39898: rn:R00488','35959: cpd:C00049','IMPD').
produces('39894: rn:R01086','36085: cpd:C00122','IMPD').
produces('6778: rn:R05378','36164: cpd:C00222','IMPD').
produces('1862: rn:R00776','36091: cpd:C00086','IMPD').
produces('1867: rn:R00131','35941: cpd:C00014','IMPD').
produces('40880: rn:R01070','36095: cpd:C00111','IMPD').
produces('40885: rn:R00711','35949: cpd:C00033','IMPD').
produces('40828: rn:R00292','37495: cpd:C00718','IMPD').
produces('39899: rn:R00348','35957: cpd:C00036','IMPD').
produces('6778: rn:R05378','36095: cpd:C00111','IMPD').
produces('1870: rn:R00469','36031: cpd:C00011','IMPD').
produces('39900: rn:R00578','35946: cpd:C00152','IMPD').
produces('39901: rn:R00357','35957: cpd:C00036','IMPD').
produces('2839: rn:R08567','36811: cpd:C15980','IMPD').
produces('39902: rn:R00355','35957: cpd:C00036','IMPD').
produces('40844: rn:R05196','36896: cpd:C00208','IMPD').
produces('39788: rn:R07412','38550: cpd:C15670','IMPD').
produces('40824: rn:R02110','37490: cpd:C00369','IMPD').
produces('39800: rn:R03683','38137: cpd:C00500','IMPD').
produces('39857: rn:R00830','36453: cpd:C00430','IMPD').
produces('40827: rn:R05977','37486: gl:G00050','IMPD').
produces('40846: rn:R02108','36915: cpd:C00721','IMPD').
produces('6732: rn:R03332','37865: cpd:C01177','IMPD').
produces('40822: rn:R06076','37455: gl:G00081','IMPD').
produces('39873: rn:R08181','36103: cpd:C06426','IMPD').
produces('40869: rn:R06033','36066: gl:G00067','IMPD').
produces('40870: rn:R05975','36000: gl:G00066','IMPD').
produces('1862: rn:R00776','35998: cpd:C00048','IMPD').
produces('2837: rn:R08566','36526: cpd:C02939','IMPD').
produces('8368: rn:R09152','36079: cpd:C00058','IMPD').
produces('40819: rn:R02109','37495: cpd:C00718','IMPD').
produces('40820: rn:R06095','37450: gl:G00056','IMPD').
produces('39882: rn:R00256','35941: cpd:C00014','IMPD').
produces('39876: rn:R08177','36092: cpd:C01595','IMPD').
produces('39870: rn:R01274','36375: cpd:C00249','IMPD').
produces('39883: rn:R00253','35953: cpd:C00064','IMPD').
produces('39869: rn:R08174','36364: cpd:C01530','IMPD').
produces('39882: rn:R00256','35960: cpd:C00025','IMPD').
produces('39885: rn:R00575','35970: cpd:C00169','IMPD').
produces('39881: rn:R01648','36077: cpd:C00232','IMPD').
produces('39880: rn:R00261','36096: cpd:C00334','IMPD').
produces('39884: rn:R00149','35970: cpd:C00169','IMPD').
produces('8367: rn:R09151','35998: cpd:C00048','IMPD').
produces('40979: rn:R09086','36197: cpd:C01172','IMPD').
produces('40987: rn:R00342','35957: cpd:C00036','IMPD').
produces('12906: rn:R00446','36340: cpd:C04076','IMPD').
produces('39855: rn:R00367','36150: cpd:C00213','IMPD').
produces('40986: rn:R00351','35940: cpd:C00158','IMPD').
produces('40978: rn:R07618','36187: cpd:C15972','IMPD').
produces('39849: rn:R04125','36218: cpd:C00143','IMPD').
produces('40985: rn:R00344','35957: cpd:C00036','IMPD').
produces('6861: rn:R01316','36335: cpd:C04233','IMPD').
produces('40959: rn:R04770','36989: cpd:C05703','IMPD').
produces('39854: rn:R03425','36031: cpd:C00011','IMPD').
produces('39783: rn:R05220','38158: cpd:C06506','IMPD').
produces('39800: rn:R03683','37608: cpd:C14819','IMPD').
produces('40982: rn:R04162','36222: cpd:C03201','IMPD').
produces('40981: rn:R04311','36235: cpd:C03715','IMPD').
produces('40963: rn:R08224','36789: cpd:C06482','IMPD').
produces('40933: rn:R05969','37369: gl:G00001','IMPD').
produces('10371: rn:R03684','38159: cpd:C01708','IMPD').
produces('39853: rn:R00830','36453: cpd:C00430','IMPD').
produces('39854: rn:R03425','36421: cpd:C01242','IMPD').
produces('6863: rn:R02027','36465: cpd:C00641','IMPD').
produces('40940: rn:R05967','37101: gl:G00098','IMPD').
produces('39851: rn:R02529','36439: cpd:C00546','IMPD').
produces('39852: rn:R02529','36439: cpd:C00546','IMPD').
produces('6869: rn:R01470','36419: cpd:C00093','IMPD').
produces('6869: rn:R01470','36447: cpd:C00189','IMPD').
produces('12917: rn:R02317','36407: cpd:C00450','IMPD').
produces('40975: rn:R00432 rn:R00727','36214: cpd:C00091','IMPD').
produces('40976: rn:R00405','36214: cpd:C00091','IMPD').
produces('6870: rn:R01800','36372: cpd:C02737','IMPD').
produces('6887: rn:R01030','35947: cpd:C00114','IMPD').
produces('3502: rn:R02144','36784: cpd:C01262','IMPD').
produces('6885: rn:R00749','36038: cpd:C00084','IMPD').
produces('39843: rn:R00611','35984: cpd:C00037','IMPD').
produces('39844: rn:R00582','35967: cpd:C00065','IMPD').
produces('40926: rn:R01018','37339: cpd:C00110','IMPD').
produces('40925: rn:R05973','37376: gl:G00004','IMPD').
produces('39839: rn:R00371','36100: cpd:C03508','IMPD').
produces('39842: rn:R00610','35984: cpd:C00037','IMPD').
produces('40971: rn:R00352','35940: cpd:C00158','IMPD').
produces('40970: rn:R00268','35955: cpd:C00026','IMPD').
produces('39838: rn:R01465','36100: cpd:C03508','IMPD').
produces('39810: rn:R02408','36950: cpd:C01962','IMPD').
produces('39826: rn:R00589','36457: cpd:C00740','IMPD').
produces('40969: rn:R00709','35955: cpd:C00026','IMPD').
produces('40943: rn:R01061','36736: cpd:C00236','IMPD').
produces('39835: rn:R01513','36125: cpd:C03232','IMPD').
produces('39807: rn:R00590','36980: cpd:C02218','IMPD').
produces('6877: rn:R02054','36405: cpd:C05973','IMPD').
produces('39840: rn:R00220','35952: cpd:C00022','IMPD').
produces('40974: rn:R03316','35974: cpd:C00068','IMPD').
produces('40930: rn:R01009','37336: cpd:C03862','IMPD').
produces('39837: rn:R00366','35998: cpd:C00048','IMPD').
produces('39836: rn:R01883','35990: cpd:C00300','IMPD').
produces('39849: rn:R04125','36062: cpd:C02972','IMPD').
produces('40917: rn:R05979','37393: gl:G00171','IMPD').
produces('39848: rn:R03815','36067: cpd:C02051','IMPD').
produces('39784: rn:R07268','38068: cpd:C06508','IMPD').
produces('39820: rn:R03104','36894: cpd:C05823','IMPD').
produces('40924: rn:R05963','37128: gl:G00093','IMPD').
produces('40941: rn:R04779','36547: cpd:C05378','IMPD').
produces('39803: rn:R04858','37392: cpd:C00021','IMPD').
produces('40914: rn:R05976','37395: gl:G00009','IMPD').
produces('40960: rn:R01516','35980: cpd:C00197','IMPD').
produces('39849: rn:R04125','35941: cpd:C00014','IMPD').
produces('40923: rn:R01005','37326: cpd:C01246','IMPD').
produces('39818: rn:R00896','36905: cpd:C00957','IMPD').
produces('39817: rn:R02619','36940: cpd:C05527','IMPD').
produces('40921: rn:R05970','37366: gl:G00002','IMPD').
produces('6887: rn:R01030','36419: cpd:C00093','IMPD').
produces('39841: rn:R04173','36125: cpd:C03232','IMPD').
produces('40928: rn:R05968','37111: gl:G00099','IMPD').
produces('40958: rn:R09085','36175: cpd:C00668','IMPD').
produces('40962: rn:R03599','36047: cpd:C00041','IMPD').
produces('39846: rn:R00751','35984: cpd:C00037','IMPD').
produces('39845: rn:R00945','35967: cpd:C00065','IMPD').
produces('6886: rn:R02029','36471: cpd:C00344','IMPD').
produces('40927: rn:R05904','37104: gl:G00104','IMPD').
produces('40919: rn:R05972','37377: gl:G00003','IMPD').
produces('40915: rn:R05964','37106: gl:G00097','IMPD').
produces('3428: rn:R03296','37930: cpd:C03440','IMPD').
produces('40906: rn:R05987','37407: gl:G00020','IMPD').
produces('40947: rn:R00431 rn:R00726','36129: cpd:C00074','IMPD').
produces('39825: rn:R02565 rn:R02566','35971: cpd:C00719','IMPD').
produces('39828: rn:R01001','35962: cpd:C00097','IMPD').
produces('40957: rn:R00235','35944: cpd:C00024','IMPD').
produces('40918: rn:R05966','37133: gl:G00094','IMPD').
produces('2928: rn:R00996','36024: cpd:C00109','IMPD').
produces('40932: rn:R01512','36736: cpd:C00236','IMPD').
produces('39816: rn:R02245','36165: cpd:C01107','IMPD').
produces('40920: rn:R05960','37128: gl:G00093','IMPD').
produces('40912: rn:R06128','37381: gl:G00006','IMPD').
produces('39824: rn:R01025','35956: cpd:C00576','IMPD').
produces('39823: rn:R01514','35980: cpd:C00197','IMPD').
produces('40938: rn:R00658','36129: cpd:C00074','IMPD').
produces('1797: rn:R01053','36278: cpd:C03090','IMPD').
produces('39832: rn:R02821','35997: cpd:C01026','IMPD').
produces('40936: rn:R03270','36199: cpd:C16255','IMPD').
produces('39827: rn:R01565','36150: cpd:C00213','IMPD').
produces('40896: rn:R06189','37461: gl:G00077','IMPD').
produces('39833: rn:R00588','35984: cpd:C00037','IMPD').
produces('654: rn:R01481','36228: cpd:C00191','IMPD').
produces('6846: rn:R05381','36038: cpd:C00084','IMPD').
produces('39829: rn:R01290','36145: cpd:C02291','IMPD').
produces('662: rn:R02754','35952: cpd:C00022','IMPD').
produces('40897: rn:R06076','37455: gl:G00081','IMPD').
produces('40898: rn:R05974','37440: gl:G00068','IMPD').
produces('40899: rn:R06190','37433: gl:G00083','IMPD').
produces('40942: rn:R01015','36095: cpd:C00111','IMPD').
produces('39834: rn:R00585','36028: cpd:C00168','IMPD').
produces('39811: rn:R00893','36527: cpd:C00606','IMPD').
produces('40931: rn:R05961','36500: gl:G00092','IMPD').
produces('40901: rn:R06191','37436: gl:G00075','IMPD').
produces('40945: rn:R02740','36087: cpd:C05345','IMPD').
produces('39819: rn:R03105','36328: cpd:C00320','IMPD').
produces('40946: rn:R04780','36087: cpd:C05345','IMPD').
produces('39830: rn:R00565','36008: cpd:C00581','IMPD').
produces('40944: rn:R00959','36175: cpd:C00668','IMPD').
produces('39831: rn:R06171','36002: cpd:C05519','IMPD').
produces('39822: rn:R01072','36278: cpd:C03090','IMPD').
produces('39808: rn:R02433','36712: cpd:C05528','IMPD').
produces('40936: rn:R03270','35974: cpd:C00068','IMPD').
produces('40929: rn:R07618','36187: cpd:C15972','IMPD').
produces('39795: rn:R01920','36391: cpd:C00170','IMPD').
produces('40939: rn:R00200','35952: cpd:C00022','IMPD').
produces('39804: rn:R00192','36194: cpd:C00155','IMPD').
produces('40937: rn:R01518','35980: cpd:C00197','IMPD').
produces('39796: rn:R00178','36386: cpd:C01137','IMPD').
produces('39769: rn:R07599','37079: cpd:C15976','IMPD').
produces('39799: rn:R01290','36145: cpd:C02291','IMPD').
produces('6846: rn:R05381','36447: cpd:C00189','IMPD').
produces('40914: rn:R05976','36751: cpd:C00621','IMPD').
produces('653: rn:R03183','37205: cpd:C02670','IMPD').
produces('39794: rn:R01402','36280: cpd:C04188','IMPD').
produces('40935: rn:R02569','36199: cpd:C16255','IMPD').
produces('39805: rn:R00648','35979: cpd:C00073','IMPD').
produces('682: rn:R01483','36228: cpd:C00191','IMPD').
produces('10357: rn:R02126','37961: cpd:C02110','IMPD').
produces('6849: rn:R05794','36456: cpd:C00157','IMPD').
produces('662: rn:R02754','36511: cpd:C01146','IMPD').
produces('39809: rn:R01123','36177: cpd:C00235','IMPD').
produces('39806: rn:R07395','36297: cpd:C15606','IMPD').
produces('40910: rn:R05984','36594: gl:G00014','IMPD').
produces('40881: rn:R06041','37439: gl:G00074','IMPD').
produces('39819: rn:R03105','35952: cpd:C00022','IMPD').
produces('40922: rn:R01788','36183: cpd:C00267','IMPD').
produces('39812: rn:R02082','36167: cpd:C00418','IMPD').
produces('40884: rn:R06227','37429: gl:G00082','IMPD').
produces('39813: rn:R01978','35942: cpd:C00356','IMPD').
produces('9416: rn:R00230','35944: cpd:C00024','IMPD').
produces('40886: rn:R06230','37445: gl:G00076','IMPD').
produces('6851: rn:R01319','36456: cpd:C00157','IMPD').
produces('39814: rn:R00238','35964: cpd:C00332','IMPD').
produces('40908: rn:R05985','36743: gl:G00015','IMPD').
produces('40934: rn:R00703','35952: cpd:C00022','IMPD').
produces('39815: rn:R00782','35952: cpd:C00022','IMPD').
produces('39780: rn:R03172','36560: cpd:C03345','IMPD').
produces('40763: rn:R01624','36675: cpd:C03939','IMPD').
produces('39797: rn:R01001','36024: cpd:C00109','IMPD').
produces('39798: rn:R00946','35979: cpd:C00073','IMPD').
produces('40776: rn:R01478','36228: cpd:C00191','IMPD').
produces('40770: rn:R03354','36408: cpd:C01290','IMPD').
produces('39779: rn:R02350','36536: cpd:C00054','IMPD').
produces('39770: rn:R03174','36811: cpd:C15980','IMPD').
produces('39797: rn:R01001','35962: cpd:C00097','IMPD').
produces('40723: rn:R05801','37843: cpd:C01284','IMPD').
produces('39778: rn:R00629','36536: cpd:C00054','IMPD').
produces('40774: rn:R03617','36257: cpd:C00195','IMPD').
produces('39777: rn:R02180','36536: cpd:C00054','IMPD').
produces('39793: rn:R04420','36274: cpd:C04582','IMPD').
produces('40724: rn:R05800','37759: cpd:C11555','IMPD').
produces('39802: rn:R02821','35979: cpd:C00073','IMPD').
produces('2700: rn:R07274','35962: cpd:C00097','IMPD').
produces('40775: rn:R01383','36147: cpd:C03033','IMPD').
produces('39792: rn:R07392','36268: cpd:C15650','IMPD').
produces('40777: rn:R00289','36063: cpd:C00029','IMPD').
produces('39791: rn:R07363','36292: cpd:C08276','IMPD').
produces('40773: rn:R02887','36188: cpd:C00221','IMPD').
produces('39801: rn:R00177','35966: cpd:C00019','IMPD').
produces('39782: rn:R00508','36531: cpd:C00224','IMPD').
produces('39781: rn:R02661','36568: cpd:C03460','IMPD').
produces('40772: rn:R00026','36188: cpd:C00221','IMPD').
produces('40769: rn:R00802','36269: cpd:C02336','IMPD').
produces('40768: rn:R00802','36269: cpd:C02336','IMPD').
produces('9384: rn:R01440','36546: cpd:C00184','IMPD').
produces('39790: rn:R07364','35975: cpd:C01180','IMPD').
produces('40784: rn:R02464','36283: cpd:C00346','IMPD').
produces('6620: rn:R02691','37736: cpd:C03692','IMPD').
produces('40733: rn:R03429','37859: cpd:C04477','IMPD').
produces('40736: rn:R03428','37757: cpd:C01272','IMPD').
produces('40731: rn:R05803','37873: cpd:C04637','IMPD').
produces('40782: rn:R06516','36283: cpd:C00346','IMPD').
produces('1681: rn:R02208','36884: cpd:C03681','IMPD').
produces('39789: rn:R07396','35979: cpd:C00073','IMPD').
produces('40779: rn:R01926','36393: cpd:C06124','IMPD').
produces('39787: rn:R00372','35998: cpd:C00048','IMPD').
produces('39768: rn:R04204','36562: cpd:C04405','IMPD').
produces('39785: rn:R00588','36028: cpd:C00168','IMPD').
produces('39771: rn:R00132','36477: cpd:C01353','IMPD').
produces('40780: rn:R02976','36279: cpd:C01120','IMPD').
produces('39775: rn:R01242','36536: cpd:C00054','IMPD').
produces('39776: rn:R00509','36524: cpd:C00053','IMPD').
produces('40778: rn:R04856','36255: cpd:C02686','IMPD').
produces('40727: rn:R04404','37806: cpd:C01277','IMPD').
produces('40781: rn:R00286','36142: cpd:C00167','IMPD').
produces('40760: rn:R01184','36228: cpd:C00191','IMPD').
produces('40762: rn:R07324','36180: cpd:C04006','IMPD').
produces('40755: rn:R04386','36316: cpd:C06250','IMPD').
produces('2689: rn:R04860','36032: cpd:C00051','IMPD').
produces('40744: rn:R01626','36687: cpd:C01209','IMPD').
produces('40766: rn:R01384','35988: cpd:C00190','IMPD').
produces('40753: rn:R01326','36305: cpd:C00275','IMPD').
produces('40707: rn:R04470','37736: cpd:C03692','IMPD').
produces('40761: rn:R00289','36063: cpd:C00029','IMPD').
produces('40758: rn:R01187','36139: cpd:C00137','IMPD').
produces('40742: rn:R04355','36677: cpd:C05744','IMPD').
produces('39767: rn:R02661','36568: cpd:C03460','IMPD').
produces('39786: rn:R00891','35962: cpd:C00097','IMPD').
produces('39748: rn:R07601','37063: cpd:C15974','IMPD').
produces('40720: rn:R01803','37275: cpd:C00996','IMPD').
produces('9384: rn:R01440','36025: cpd:C00118','IMPD').
produces('40720: rn:R01803','37260: cpd:C03410','IMPD').
produces('12699: rn:R03341','37325: cpd:C03765','IMPD').
produces('40769: rn:R00802','36183: cpd:C00267','IMPD').
produces('40765: rn:R04385','36313: cpd:C04419','IMPD').
produces('39753: rn:R02661','36568: cpd:C03460','IMPD').
produces('39773: rn:R00253','35953: cpd:C00064','IMPD').
produces('39772: rn:R01221','35984: cpd:C00037','IMPD').
produces('39754: rn:R03172','36560: cpd:C03345','IMPD').
produces('39774: rn:R01001','35941: cpd:C00014','IMPD').
produces('39755: rn:R04203','36554: cpd:C03344','IMPD').
produces('39766: rn:R00833','36214: cpd:C00091','IMPD').
produces('40767: rn:R03527','36183: cpd:C00267','IMPD').
produces('6639: rn:R01048','37754: cpd:C05999','IMPD').
produces('39762: rn:R03869','36270: cpd:C02170','IMPD').
produces('40768: rn:R00802','36183: cpd:C00267','IMPD').
produces('39752: rn:R04224','36570: cpd:C06000','IMPD').
produces('40771: rn:R03920','36087: cpd:C05345','IMPD').
produces('39757: rn:R05064','36572: cpd:C06001','IMPD').
produces('39770: rn:R03174','36190: cpd:C15973','IMPD').
produces('40750: rn:R04533','36677: cpd:C05744','IMPD').
produces('40764: rn:R01186','36139: cpd:C00137','IMPD').
produces('40747: rn:R01626','36687: cpd:C01209','IMPD').
produces('39765: rn:R02765','36284: cpd:C01213','IMPD').
produces('40728: rn:R04953','36667: cpd:C05747','IMPD').
produces('39745: rn:R04095','36522: cpd:C03069','IMPD').
produces('40726: rn:R01961','36686: cpd:C00352','IMPD').
produces('40746: rn:R04372','36180: cpd:C04006','IMPD').
produces('39756: rn:R04188','36276: cpd:C06002','IMPD').
produces('39763: rn:R02197','36033: cpd:C00671','IMPD').
produces('39746: rn:R03172','36560: cpd:C03345','IMPD').
produces('6633: rn:R01034','36546: cpd:C00184','IMPD').
produces('39760: rn:R01859','36111: cpd:C00683','IMPD').
produces('1653: rn:R03406 rn:R03407','38515: cpd:C04295','IMPD').
produces('3652: rn:R02384','37232: cpd:C02442','IMPD').
produces('11591: rn:R08076','36415: cpd:C00015','IMPD').
produces('6634: rn:R01039','36546: cpd:C00184','IMPD').
produces('39758: rn:R05066','36276: cpd:C06002','IMPD').
produces('40645: rn:R05907','39115: gl:G00023','IMPD').
produces('40689: rn:R02577','37746: cpd:C00583','IMPD').
produces('40644: rn:R05907','39115: gl:G00023','IMPD').
produces('39749: rn:R04097','36526: cpd:C02939','IMPD').
produces('39761: rn:R00935','36144: cpd:C00100','IMPD').
produces('40643: rn:R05910','39128: gl:G00031','IMPD').
produces('39764: rn:R02199','36033: cpd:C00671','IMPD').
produces('39747: rn:R02662','36565: cpd:C00630','IMPD').
produces('39751: rn:R04203','36554: cpd:C03344','IMPD').
produces('39742: rn:R07600','36824: cpd:C15977','IMPD').
produces('40646: rn:R05907','39115: gl:G00023','IMPD').
produces('39759: rn:R03871','36270: cpd:C02170','IMPD').
produces('40725: rn:R04954','36657: cpd:C05748','IMPD').
produces('40743: rn:R03920','36087: cpd:C05345','IMPD').
produces('40735: rn:R04428','36702: cpd:C04246','IMPD').
produces('39750: rn:R01090','36135: cpd:C00233','IMPD').
produces('39738: rn:R07602','36516: cpd:C15975','IMPD').
produces('40734: rn:R04430','36691: cpd:C05745','IMPD').
produces('39747: rn:R02662','36190: cpd:C15973','IMPD').
produces('40738: rn:R04952','36664: cpd:C05746','IMPD').
produces('40717: rn:R01207','37334: cpd:C00645','IMPD').
produces('40719: rn:R01115','37275: cpd:C00996','IMPD').
produces('40719: rn:R01115','37268: cpd:C03691','IMPD').
produces('39749: rn:R04097','36190: cpd:C15973','IMPD').
produces('40718: rn:R00100','37265: cpd:C00999','IMPD').
produces('40716: rn:R01811','37334: cpd:C00645','IMPD').
produces('40732: rn:R04956','36660: cpd:C05749','IMPD').
produces('40751: rn:R02740','36087: cpd:C05345','IMPD').
produces('40712: rn:R04215','37268: cpd:C03691','IMPD').
produces('40710: rn:R02058','37322: cpd:C00357','IMPD').
produces('39725: rn:R07603','37102: cpd:C15978','IMPD').
produces('40715: rn:R00022','37220: cpd:C00140','IMPD').
produces('40755: rn:R04386','35992: cpd:C00083','IMPD').
produces('39739: rn:R07618','36187: cpd:C15972','IMPD').
produces('39699: rn:R03663','37412: cpd:C02992','IMPD').
produces('40677: rn:R02687','37732: cpd:C01885','IMPD').
produces('40671: rn:R02251','37910: cpd:C00422','IMPD').
produces('39701: rn:R03664','37410: cpd:C03512','IMPD').
produces('39710: rn:R01939','37138: cpd:C00322','IMPD').
produces('40729: rn:R01786','36175: cpd:C00668','IMPD').
produces('40722: rn:R01786','36175: cpd:C00668','IMPD').
produces('39743: rn:R07618','36187: cpd:C15972','IMPD').
produces('39702: rn:R03940','37454: cpd:C03294','IMPD').
produces('39703: rn:R02918','37414: cpd:C02839','IMPD').
produces('40713: rn:R05692','36495: cpd:C01222','IMPD').
produces('39704: rn:R03661','37426: cpd:C02702','IMPD').
produces('3642: rn:R02698','37173: cpd:C01161','IMPD').
produces('1710: rn:R04309 rn:R04310','36387: cpd:C04373','IMPD').
produces('40714: rn:R00888','36495: cpd:C01222','IMPD').
produces('4653: rn:R01073','36152: cpd:C00108','IMPD').
produces('40711: rn:R04726','36595: cpd:C05759','IMPD').
produces('40686: rn:R01804','37348: cpd:C00270','IMPD').
produces('39734: rn:R02085','36528: cpd:C03231','IMPD').
produces('3638: rn:R02518','37257: cpd:C05585','IMPD').
produces('3646: rn:R02514 rn:R02516','37000: cpd:C00544','IMPD').
produces('4653: rn:R01073','36120: cpd:C00119','IMPD').
produces('39705: rn:R05578','37448: cpd:C02987','IMPD').
produces('1715: rn:R02476 rn:R02477','36398: cpd:C00523','IMPD').
produces('40640: rn:R05914','39100: gl:G00027','IMPD').
produces('1700: rn:R01841','36851: cpd:C00280','IMPD').
produces('2697: rn:R08699','36534: cpd:C00506','IMPD').
produces('39733: rn:R01360','36114: cpd:C00164','IMPD').
produces('39738: rn:R07602','35974: cpd:C00068','IMPD').
produces('39691: rn:R05577','37438: cpd:C02984','IMPD').
produces('12727: rn:R02383','37316: cpd:C03758','IMPD').
produces('39689: rn:R03650','37505: cpd:C03125','IMPD').
produces('39729: rn:R05066','36276: cpd:C06002','IMPD').
produces('39692: rn:R03654','37420: cpd:C02412','IMPD').
produces('40641: rn:R05907','39115: gl:G00023','IMPD').
produces('39740: rn:R00243 rn:R00248','35941: cpd:C00014','IMPD').
produces('39690: rn:R03652','37489: cpd:C02282','IMPD').
produces('11600: rn:R03726','36391: cpd:C00170','IMPD').
produces('40642: rn:R05915','39106: gl:G00029','IMPD').
produces('39741: rn:R00256','35941: cpd:C00014','IMPD').
produces('1712: rn:R04309','36387: cpd:C04373','IMPD').
produces('2694: rn:R00901','36534: cpd:C00506','IMPD').
produces('2713: rn:R01113','35962: cpd:C00097','IMPD').
produces('39695: rn:R03038','37396: cpd:C00886','IMPD').
produces('39693: rn:R03659','37459: cpd:C02430','IMPD').
produces('39694: rn:R03662','37434: cpd:C02553','IMPD').
produces('40730: rn:R01786','36175: cpd:C00668','IMPD').
produces('39742: rn:R07600','35974: cpd:C00068','IMPD').
produces('39724: rn:R04095','36522: cpd:C03069','IMPD').
produces('6651: rn:R04471','36182: cpd:C05401','IMPD').
produces('40636: rn:R05907','39115: gl:G00023','IMPD').
produces('39716: rn:R07604','36813: cpd:C15979','IMPD').
produces('39744: rn:R01168','35941: cpd:C00014','IMPD').
produces('40637: rn:R05907','39115: gl:G00023','IMPD').
produces('39726: rn:R04138','36528: cpd:C03231','IMPD').
produces('39698: rn:R03658','37397: cpd:C01931','IMPD').
produces('1649: rn:R03403','38521: cpd:C01227','IMPD').
produces('39727: rn:R04137','36522: cpd:C03069','IMPD').
produces('40638: rn:R05907','39115: gl:G00023','IMPD').
produces('2709: rn:R07634','35952: cpd:C00022','IMPD').
produces('11602: rn:R02119','36415: cpd:C00015','IMPD').
produces('11603: rn:R02118','36415: cpd:C00015','IMPD').
produces('40639: rn:R05907','39115: gl:G00023','IMPD').
produces('39687: rn:R03646','37499: cpd:C02163','IMPD').
produces('39688: rn:R03660','37478: cpd:C03511','IMPD').
produces('39737: rn:R00578','35960: cpd:C00025','IMPD').
produces('39736: rn:R00410','35964: cpd:C00332','IMPD').
produces('39735: rn:R01978','35942: cpd:C00356','IMPD').
produces('39686: rn:R03648','37463: cpd:C03402','IMPD').
produces('39708: rn:R08224','36789: cpd:C06482','IMPD').
produces('9332: rn:R00134','36079: cpd:C00058','IMPD').
produces('40842: rn:R06222','36073: gl:G00085','IMPD').
produces('40841: rn:R06224','36058: gl:G00086','IMPD').
produces('39728: rn:R00927','36144: cpd:C00100','IMPD').
produces('39685: rn:R03655','37483: cpd:C02988','IMPD').
produces('40838: rn:R01786','36175: cpd:C00668','IMPD').
produces('39733: rn:R01360','35944: cpd:C00024','IMPD').
produces('39732: rn:R00149','35970: cpd:C00169','IMPD').
produces('39723: rn:R05556','36250: cpd:C05859','IMPD').
produces('2761: rn:R04861','36323: cpd:C00094','IMPD').
produces('39731: rn:R00238','35964: cpd:C00332','IMPD').
produces('9331: rn:R00473','35998: cpd:C00048','IMPD').
produces('40843: rn:R02111','36174: cpd:C00103','IMPD').
produces('39730: rn:R01214','35958: cpd:C00141','IMPD').
produces('39709: rn:R08218','36606: cpd:C06481','IMPD').
produces('39722: rn:R09249','36148: cpd:C17432','IMPD').
produces('40848: rn:R01790','36183: cpd:C00267','IMPD').
produces('39714: rn:R02869','36391: cpd:C00170','IMPD').
produces('9336: rn:R08572','36296: cpd:C00631','IMPD').
produces('39728: rn:R00927','35944: cpd:C00024','IMPD').
produces('2761: rn:R04861','35952: cpd:C00022','IMPD').
produces('9340: rn:R00945','36076: cpd:C00101','IMPD').
produces('1620: rn:R03263','36877: cpd:C01780','IMPD').
produces('39720: rn:R03245','36161: cpd:C01143','IMPD').
produces('2759: rn:R00863','36047: cpd:C00041','IMPD').
produces('39719: rn:R01121','36179: cpd:C00129','IMPD').
produces('39712: rn:R03098','36352: cpd:C05560','IMPD').
produces('39717: rn:R07618','36187: cpd:C15972','IMPD').
produces('39721: rn:R02003','36060: cpd:C00448','IMPD').
produces('9341: rn:R00519','36031: cpd:C00011','IMPD').
produces('39718: rn:R01658','36127: cpd:C00341','IMPD').
produces('39711: rn:R04390','36340: cpd:C04076','IMPD').
produces('9340: rn:R00945','35967: cpd:C00065','IMPD').
produces('40850: rn:R00028','36183: cpd:C00267','IMPD').
produces('40849: rn:R08969','36203: cpd:C00550','IMPD').
produces('39707: rn:R04863','36334: cpd:C05535','IMPD').
produces('9323: rn:R01196','35952: cpd:C00022','IMPD').
produces('39713: rn:R00716','36193: cpd:C00047','IMPD').
produces('40832: rn:R06039','35948: gl:G00084','IMPD').
produces('40826: rn:R06025','36013: gl:G00060','IMPD').
produces('40813: rn:R06520','36428: cpd:C00836','IMPD').
produces('39715: rn:R02061','36042: cpd:C00353','IMPD').
produces('8337: rn:R06973','36038: cpd:C00084','IMPD').
produces('3635: rn:R02489','36201: cpd:C00530','IMPD').
produces('40834: rn:R05975','36000: gl:G00066','IMPD').
produces('39716: rn:R07604','35974: cpd:C00068','IMPD').
produces('40812: rn:R08364','36583: cpd:C03170','IMPD').
produces('40829: rn:R06033','36066: gl:G00067','IMPD').
produces('6710: rn:R03478','37843: cpd:C01284','IMPD').
produces('40830: rn:R06033','36066: gl:G00067','IMPD').
produces('3596: rn:R03672','37294: cpd:C01693','IMPD').
produces('40831: rn:R00959','36175: cpd:C00668','IMPD').
produces('9331: rn:R00473','35944: cpd:C00024','IMPD').
produces('9327: rn:R01388','36056: cpd:C00258','IMPD').
produces('3598: rn:R03674','37299: cpd:C05578','IMPD').
produces('3596: rn:R03672','37308: cpd:C00355','IMPD').
produces('2712: rn:R00892','36945: cpd:C00491','IMPD').
produces('40836: rn:R01786','36175: cpd:C00668','IMPD').
produces('39706: rn:R00014','36017: cpd:C05125','IMPD').
produces('40833: rn:R01788','36183: cpd:C00267','IMPD').
produces('40840: rn:R06221','36015: gl:G00090','IMPD').
produces('39702: rn:R03940','36076: cpd:C00101','IMPD').
produces('40783: rn:R01660','36890: cpd:C01231','IMPD').
produces('40752: rn:R03479','37843: cpd:C01284','IMPD').
produces('40803: rn:R01495','36209: cpd:C02960','IMPD').
produces('40802: rn:R06521','36261: cpd:C00319','IMPD').
produces('40805: rn:R06522','36257: cpd:C00195','IMPD').
produces('39700: rn:R03656','36075: cpd:C03127','IMPD').
produces('39697: rn:R03657','36159: cpd:C02047','IMPD').
produces('39683: rn:R02661','36568: cpd:C03460','IMPD').
produces('40757: rn:R03361','37806: cpd:C01277','IMPD').
produces('11522: rn:R07260','36415: cpd:C00015','IMPD').
produces('39696: rn:R03665','35968: cpd:C02554','IMPD').
produces('755: rn:R03370','37358: cpd:C01203','IMPD').
produces('40806: rn:R02541','36257: cpd:C00195','IMPD').
produces('40754: rn:R03469','37873: cpd:C04637','IMPD').
produces('40801: rn:R06520','36428: cpd:C00836','IMPD').
produces('40818: rn:R06075','35993: gl:G00063','IMPD').
produces('39680: rn:R00529','36531: cpd:C00224','IMPD').
produces('40808: rn:R06519','36257: cpd:C00195','IMPD').
produces('40756: rn:R03362','37869: cpd:C04549','IMPD').
produces('40799: rn:R02869','36638: cpd:C00750','IMPD').
produces('40797: rn:R08363','36690: cpd:C16664','IMPD').
produces('40798: rn:R08359','36661: cpd:C16565','IMPD').
produces('40811: rn:R06521','36261: cpd:C00319','IMPD').
produces('40816: rn:R01791','36183: cpd:C00267','IMPD').
produces('40815: rn:R01718','36183: cpd:C00267','IMPD').
produces('40821: rn:R02740','36087: cpd:C05345','IMPD').
produces('40810: rn:R06528','36434: cpd:C12144','IMPD').
produces('40823: rn:R06038','36030: gl:G00089','IMPD').
produces('40809: rn:R06518','36428: cpd:C00836','IMPD').
produces('40817: rn:R01791','36183: cpd:C00267','IMPD').
produces('40814: rn:R06522','36257: cpd:C00195','IMPD').
produces('40819: rn:R02109','36183: cpd:C00267','IMPD').
produces('40825: rn:R00010','35981: cpd:C00031','IMPD').
produces('40804: rn:R04951','36627: cpd:C05726','IMPD').
produces('40737: rn:R03433','37757: cpd:C01272','IMPD').
produces('40785: rn:R03355','36272: cpd:C01190','IMPD').
produces('40789: rn:R00287','36174: cpd:C00103','IMPD').
produces('40786: rn:R01498','36257: cpd:C00195','IMPD').
produces('39679: rn:R03657','36159: cpd:C02047','IMPD').
produces('40739: rn:R03430','37747: cpd:C01243','IMPD').
produces('40787: rn:R01497','36272: cpd:C01190','IMPD').
produces('40788: rn:R01494','36261: cpd:C00319','IMPD').
produces('40740: rn:R03434','37749: cpd:C01245','IMPD').
produces('39684: rn:R03656','36075: cpd:C03127','IMPD').
produces('39677: rn:R02199','36044: cpd:C00407','IMPD').
produces('39676: rn:R00533','36089: cpd:C00059','IMPD').
produces('40790: rn:R04019','36255: cpd:C02686','IMPD').
produces('40759: rn:R01206','37220: cpd:C00140','IMPD').
produces('40791: rn:R04017','36240: cpd:C06125','IMPD').
produces('39681: rn:R03665','35968: cpd:C02554','IMPD').
produces('39682: rn:R01214','35945: cpd:C00183','IMPD').
produces('40792: rn:R04018','36255: cpd:C02686','IMPD').
produces('40793: rn:R01500','36255: cpd:C02686','IMPD').
produces('40741: rn:R04513','37873: cpd:C04637','IMPD').
produces('39678: rn:R01090','36135: cpd:C00233','IMPD').
produces('40794: rn:R05105','36229: cpd:C06127','IMPD').
produces('40804: rn:R04951','35984: cpd:C00037','IMPD').
produces('40796: rn:R01281','36243: cpd:C02934','IMPD').
produces('40745: rn:R03393','37876: cpd:C03546','IMPD').
produces('40800: rn:R01920','36162: cpd:C00315','IMPD').
produces('40807: rn:R00899','35984: cpd:C00037','IMPD').
produces('40807: rn:R00899','35962: cpd:C00097','IMPD').
produces('40748: rn:R03394','37848: cpd:C01220','IMPD').
produces('40749: rn:R03427','37840: cpd:C04063','IMPD').
produces('40795: rn:R02978','36428: cpd:C00836','IMPD').
produces('8295: rn:R09158','36031: cpd:C00011','IMPD').
produces('41110: rn:R03167','36786: cpd:C00127','IMPD').
produces('41128: rn:R00405','36214: cpd:C00091','IMPD').
produces('41136: rn:R01795','35991: cpd:C00082','IMPD').
produces('41117: rn:R00267','36579: cpd:C00005','IMPD').
produces('41108: rn:R03749','36804: cpd:C01879','IMPD').
produces('41087: rn:R07046','37482: cpd:C14749','IMPD').
produces('41109: rn:R00274','36786: cpd:C00127','IMPD').
produces('41135: rn:R00694','35943: cpd:C00079','IMPD').
produces('40105: rn:R07087','37022: cpd:C14854','IMPD').
produces('41127: rn:R04432','36155: cpd:C00894','IMPD').
produces('41112: rn:R03916','36632: cpd:C05729','IMPD').
produces('40122: rn:R01135','36476: cpd:C03794','IMPD').
produces('41114: rn:R03915 rn:R02824','36786: cpd:C00127','IMPD').
produces('41139: rn:R00734','36016: cpd:C01179','IMPD').
produces('41133: rn:R03157 rn:R03158','36178: cpd:C05668','IMPD').
produces('41140: rn:R00238','35964: cpd:C00332','IMPD').
produces('13211: rn:R08219','36789: cpd:C06482','IMPD').
produces('41132: rn:R00908','36164: cpd:C00222','IMPD').
produces('41137: rn:R00729','36016: cpd:C01179','IMPD').
produces('40101: rn:R07085','37029: cpd:C14853','IMPD').
produces('40093: rn:R01227','37277: cpd:C00387','IMPD').
produces('40123: rn:R00122','36298: cpd:C00020','IMPD').
produces('41129: rn:R00432','36214: cpd:C00091','IMPD').
produces('40124: rn:R00127','36266: cpd:C00008','IMPD').
produces('40095: rn:R01863','37175: cpd:C00262','IMPD').
produces('40133: rn:R00184','35995: cpd:C00002','IMPD').
produces('40098: rn:R07075','37087: cpd:C14845','IMPD').
produces('41130: rn:R00833','36214: cpd:C00091','IMPD').
produces('9221: rn:R00325','35949: cpd:C00033','IMPD').
produces('9221: rn:R00325','35952: cpd:C00022','IMPD').
produces('41126: rn:R00238','35964: cpd:C00332','IMPD').
produces('41125: rn:R00742','35992: cpd:C00083','IMPD').
produces('41123: rn:R01000','36024: cpd:C00109','IMPD').
produces('41105: rn:R07892','36586: cpd:C16332','IMPD').
produces('41113: rn:R02736','36579: cpd:C00005','IMPD').
produces('41106: rn:R03522','36774: cpd:C02320','IMPD').
produces('41108: rn:R03749','36717: cpd:C00151','IMPD').
produces('41111: rn:R04951','36627: cpd:C05726','IMPD').
produces('41107: rn:R07896','36695: cpd:C16336','IMPD').
produces('5318: rn:R08358','36172: cpd:C00072','IMPD').
produces('2100: rn:R07969 rn:R07970','36454: cpd:C00385','IMPD').
produces('41146: rn:R01354','36140: cpd:C00163','IMPD').
produces('5338: rn:R01918','36162: cpd:C00315','IMPD').
produces('5323: rn:R08361','36583: cpd:C03170','IMPD').
produces('41143: rn:R02765','36284: cpd:C01213','IMPD').
produces('40119: rn:R00181','37183: cpd:C00130','IMPD').
produces('2142: rn:R07982','35998: cpd:C00048','IMPD').
produces('41151: rn:R03288','36040: cpd:C00099','IMPD').
produces('13208: rn:R08223','36577: cpd:C16638','IMPD').
produces('40152: rn:R00376','36154: cpd:C00039','IMPD').
produces('40145: rn:R00187','36266: cpd:C00008','IMPD').
produces('40111: rn:R04559','37318: cpd:C04677','IMPD').
produces('5323: rn:R08361','36676: cpd:C16663','IMPD').
produces('9991: rn:R02322','38858: cpd:C01185','IMPD').
produces('41145: rn:R01354','36140: cpd:C00163','IMPD').
produces('40096: rn:R02142','37724: cpd:C00655','IMPD').
produces('40114: rn:R02748','37175: cpd:C00262','IMPD').
produces('40110: rn:R04591','37310: cpd:C04823','IMPD').
produces('41149: rn:R01859','36111: cpd:C00683','IMPD').
produces('40130: rn:R01054','36608: cpd:C00117','IMPD').
produces('41152: rn:R00905','36040: cpd:C00099','IMPD').
produces('41153: rn:R02269','36036: cpd:C02642','IMPD').
produces('40132: rn:R07093','37005: cpd:C14864','IMPD').
produces('40116: rn:R02556','37494: cpd:C05512','IMPD').
produces('2119: rn:R07965 rn:R07966','36454: cpd:C00385','IMPD').
produces('41138: rn:R03045','36178: cpd:C05668','IMPD').
produces('41115: rn:R00894','36803: cpd:C00669','IMPD').
produces('5318: rn:R08358','36583: cpd:C03170','IMPD').
produces('40125: rn:R01137','37149: cpd:C00131','IMPD').
produces('40115: rn:R02088','37498: cpd:C00559','IMPD').
produces('40126: rn:R02017','37153: cpd:C00206','IMPD').
produces('41116: rn:R00494','36793: cpd:C01419','IMPD').
produces('5338: rn:R01918','36032: cpd:C00051','IMPD').
produces('40106: rn:R00089','37713: cpd:C00575','IMPD').
produces('40112: rn:R04560','37503: cpd:C04734','IMPD').
produces('40155: rn:R00441','36088: cpd:C00046','IMPD').
produces('41119: rn:R02743','36804: cpd:C01879','IMPD').
produces('3122: rn:R00462','36417: cpd:C01672','IMPD').
produces('40120: rn:R00183','37166: cpd:C00212','IMPD').
produces('41142: rn:R01859','36111: cpd:C00683','IMPD').
produces('41120: rn:R01262','36793: cpd:C01419','IMPD').
produces('41120: rn:R01262','36796: cpd:C03740','IMPD').
produces('41141: rn:R00935','36144: cpd:C00100','IMPD').
produces('40165: rn:R00330','36184: cpd:C00044','IMPD').
produces('41165: rn:R00936 rn:R00939','36076: cpd:C00101','IMPD').
produces('40129: rn:R07002','37142: cpd:C14791','IMPD').
produces('41167: rn:R03189','36076: cpd:C00101','IMPD').
produces('41174: rn:R01975','35964: cpd:C00332','IMPD').
produces('40128: rn:R01855','37241: cpd:C00362','IMPD').
produces('41169: rn:R02287','36076: cpd:C00101','IMPD').
produces('5358: rn:R08358','36172: cpd:C00072','IMPD').
produces('40159: rn:R07104','36623: cpd:C11150','IMPD').
produces('40142: rn:R01547','37153: cpd:C00206','IMPD').
produces('41148: rn:R02765','36284: cpd:C01213','IMPD').
produces('40138: rn:R01229','37267: cpd:C00144','IMPD').
produces('41155: rn:R00941','36076: cpd:C00101','IMPD').
produces('40140: rn:R00961','37183: cpd:C00130','IMPD').
produces('40135: rn:R00434','37341: cpd:C00942','IMPD').
produces('41150: rn:R00833','36214: cpd:C00091','IMPD').
produces('40149: rn:R07083','37017: cpd:C14855','IMPD').
produces('41158: rn:R00904','36040: cpd:C00099','IMPD').
produces('41157: rn:R04325','36076: cpd:C00101','IMPD').
produces('40147: rn:R07084','37024: cpd:C14856','IMPD').
produces('41134: rn:R00689','36883: cpd:C00166','IMPD').
produces('40131: rn:R01232','37347: cpd:C01261','IMPD').
produces('40134: rn:R01967','37241: cpd:C00362','IMPD').
produces('40137: rn:R01858','37247: cpd:C00286','IMPD').
produces('40136: rn:R00430','37262: cpd:C00035','IMPD').
produces('41161: rn:R03940','36076: cpd:C00101','IMPD').
produces('41131: rn:R02940','37006: cpd:C00804','IMPD').
produces('5359: rn:R08361','36583: cpd:C03170','IMPD').
produces('41183: rn:R00410','35964: cpd:C00332','IMPD').
produces('40156: rn:R07112','36981: cpd:C14870','IMPD').
produces('41179: rn:R01361','36114: cpd:C00164','IMPD').
produces('5358: rn:R08358','36583: cpd:C03170','IMPD').
produces('40148: rn:R01968','37246: cpd:C00330','IMPD').
produces('40157: rn:R07113','36973: cpd:C14874','IMPD').
produces('40185: rn:R01049','36120: cpd:C00119','IMPD').
produces('40141: rn:R02557','37498: cpd:C00559','IMPD').
produces('41181: rn:R01360','36114: cpd:C00164','IMPD').
produces('40150: rn:R01857','37247: cpd:C00286','IMPD').
produces('41159: rn:R02301','36827: cpd:C00445','IMPD').
produces('41185: rn:R00014','36017: cpd:C05125','IMPD').
produces('40180: rn:R00507','36089: cpd:C00059','IMPD').
produces('40127: rn:R02805','37726: cpd:C00700','IMPD').
produces('5359: rn:R08361','36676: cpd:C16663','IMPD').
produces('40151: rn:R07091','37002: cpd:C14861','IMPD').
produces('40181: rn:R04208','36108: cpd:C03373','IMPD').
produces('40143: rn:R03530','37289: cpd:C01345','IMPD').
produces('41144: rn:R00926','37373: cpd:C05983','IMPD').
produces('40164: rn:R07105','36644: cpd:C07490','IMPD').
produces('41160: rn:R02300','36874: cpd:C03479','IMPD').
produces('40171: rn:R01768','36454: cpd:C00385','IMPD').
produces('41184: rn:R03534','36163: cpd:C02630','IMPD').
produces('40153: rn:R07082','37019: cpd:C14852','IMPD').
produces('40146: rn:R02147','37235: cpd:C00242','IMPD').
produces('5350: rn:R03821','36613: cpd:C00006','IMPD').
produces('40161: rn:R06601','37042: cpd:C12248','IMPD').
produces('41175: rn:R00694','35943: cpd:C00079','IMPD').
produces('40178: rn:R00509','36524: cpd:C00053','IMPD').
produces('41171: rn:R04326','36076: cpd:C00101','IMPD').
produces('41156: rn:R00943','36538: cpd:C00234','IMPD').
produces('41176: rn:R00238','35964: cpd:C00332','IMPD').
produces('5350: rn:R03821','36588: cpd:C02090','IMPD').
produces('41172: rn:R01648','36077: cpd:C00232','IMPD').
produces('40154: rn:R00434','37341: cpd:C00942','IMPD').
produces('40180: rn:R00507','36536: cpd:C00054','IMPD').
produces('41154: rn:R00978','36679: cpd:C00106','IMPD').
produces('41173: rn:R00261','36096: cpd:C00334','IMPD').
produces('40166: rn:R07092','37004: cpd:C14865','IMPD').
produces('41180: rn:R01978','35942: cpd:C00356','IMPD').
produces('41177: rn:R00734','36016: cpd:C01179','IMPD').
produces('41181: rn:R01360','35944: cpd:C00024','IMPD').
produces('40160: rn:R07106','36986: cpd:C14869','IMPD').
produces('41162: rn:R01224 rn:R07168','36505: cpd:C00440','IMPD').
produces('40184: rn:R01072','36278: cpd:C03090','IMPD').
produces('41182: rn:R01357','35964: cpd:C00332','IMPD').
produces('40139: rn:R04378','37705: cpd:C04051','IMPD').
produces('40162: rn:R07100','36997: cpd:C14868','IMPD').
produces('40177: rn:R00529','36531: cpd:C00224','IMPD').
produces('41163: rn:R01655','36538: cpd:C00234','IMPD').
produces('41178: rn:R03026','36078: cpd:C01144','IMPD').
produces('40065: rn:R08339','36158: cpd:C16659','IMPD').
produces('41206: rn:R03270','35974: cpd:C00068','IMPD').
produces('40044: rn:R08266','36790: cpd:C16545','IMPD').
produces('41197: rn:R00908','36164: cpd:C00222','IMPD').
produces('40060: rn:R08343','36216: cpd:C16608','IMPD').
produces('4266: rn:R00829','35944: cpd:C00024','IMPD').
produces('41196: rn:R00713','36137: cpd:C00042','IMPD').
produces('41202: rn:R00694','35943: cpd:C00079','IMPD').
produces('41195: rn:R03045','36155: cpd:C00894','IMPD').
produces('41194: rn:R03158','36178: cpd:C05668','IMPD').
produces('41201: rn:R00694','35943: cpd:C00079','IMPD').
produces('41170: rn:R02302','36873: cpd:C00664','IMPD').
produces('4261: rn:R00829','36214: cpd:C00091','IMPD').
produces('40059: rn:R01057','36608: cpd:C00117','IMPD').
produces('41198: rn:R01176','35951: cpd:C00136','IMPD').
produces('2050: rn:R00150','35941: cpd:C00014','IMPD').
produces('40070: rn:R08262','36181: cpd:C16643','IMPD').
produces('40049: rn:R08282 rn:R08283','36849: cpd:C07646','IMPD').
produces('41168: rn:R02235 rn:R02236','36852: cpd:C00415','IMPD').
produces('41192: rn:R01171','36074: cpd:C00877','IMPD').
produces('40056: rn:R01054','36608: cpd:C00117','IMPD').
produces('41166: rn:R01218','36827: cpd:C00445','IMPD').
produces('2050: rn:R00150','36031: cpd:C00011','IMPD').
produces('4266: rn:R00829','36214: cpd:C00091','IMPD').
produces('41188: rn:R02869','36162: cpd:C00315','IMPD').
produces('5378: rn:R03921','36175: cpd:C00668','IMPD').
produces('41187: rn:R02869','36162: cpd:C00315','IMPD').
produces('41186: rn:R00924','36144: cpd:C00100','IMPD').
produces('41164: rn:R01220','36827: cpd:C00445','IMPD').
produces('41193: rn:R00233','35944: cpd:C00024','IMPD').
produces('41190: rn:R00904','36040: cpd:C00099','IMPD').
produces('41147: rn:R00926','37373: cpd:C05983','IMPD').
produces('40068: rn:R03697','36344: cpd:C01516;dr:D08233 cpd:C01516','IMPD').
produces('5378: rn:R03921','36269: cpd:C02336','IMPD').
produces('41189: rn:R00489','36040: cpd:C00099','IMPD').
produces('40050: rn:R07069','37089: cpd:C14847','IMPD').
produces('41224: rn:R00216','35952: cpd:C00022','IMPD').
produces('41223: rn:R00342','35957: cpd:C00036','IMPD').
produces('41221: rn:R00197','35952: cpd:C00022','IMPD').
produces('40046: rn:R01138','37153: cpd:C00206','IMPD').
produces('40051: rn:R07094','36999: cpd:C14863','IMPD').
produces('10102: rn:R02972','37525: cpd:C00831','IMPD').
produces('41218: rn:R00200 rn:R02320','35952: cpd:C00022','IMPD').
produces('5392: rn:R00806','36510: cpd:C00089','IMPD').
produces('41220: rn:R00214','35952: cpd:C00022','IMPD').
produces('40088: rn:R02422','36091: cpd:C00086','IMPD').
produces('41219: rn:R00344','35957: cpd:C00036','IMPD').
produces('40052: rn:R07027','37110: cpd:C14801','IMPD').
produces('41191: rn:R03139','36742: cpd:C05665','IMPD').
produces('10099: rn:R01623','37532: cpd:C01134','IMPD').
produces('40074: rn:R01769','36454: cpd:C00385','IMPD').
produces('40075: rn:R01561','36418: cpd:C00147','IMPD').
produces('41206: rn:R03270','36199: cpd:C16255','IMPD').
produces('10110: rn:R02473','37130: cpd:C00864','IMPD').
produces('41210: rn:R00431 rn:R00726','36129: cpd:C00074','IMPD').
produces('40054: rn:R01127','37183: cpd:C00130','IMPD').
produces('40089: rn:R02719','36097: cpd:C01762','IMPD').
produces('5400: rn:R00960','36183: cpd:C00267','IMPD').
produces('40071: rn:R08281','36844: cpd:C16551','IMPD').
produces('4290: rn:R00750','35952: cpd:C00022','IMPD').
produces('40069: rn:R08261','36835: cpd:C16577','IMPD').
produces('40057: rn:R06604','37208: cpd:C02350','IMPD').
produces('40097: rn:R00124','35995: cpd:C00002','IMPD').
produces('4290: rn:R00750','36038: cpd:C00084','IMPD').
produces('41209: rn:R02536 rn:R02537','36831: cpd:C07086','IMPD').
produces('7672: rn:R01016','36439: cpd:C00546','IMPD').
produces('40094: rn:R07020','36171: cpd:C03012','IMPD').
produces('40062: rn:R07943','37290: cpd:C16358','IMPD').
produces('41212: rn:R02613','36836: cpd:C00601','IMPD').
produces('41211: rn:R01372','36860: cpd:C05852','IMPD').
produces('5400: rn:R00960','36890: cpd:C01231','IMPD').
produces('41208: rn:R05940','36917: gl:G00113','IMPD').
produces('40087: rn:R01676','36454: cpd:C00385','IMPD').
produces('41204: rn:R00689','36883: cpd:C00166','IMPD').
produces('5428: rn:R01555','35981: cpd:C00031','IMPD').
produces('41205: rn:R05937','36920: gl:G00108','IMPD').
produces('40099: rn:R00086','36266: cpd:C00008','IMPD').
produces('40102: rn:R00375','36154: cpd:C00039','IMPD').
produces('40104: rn:R00435','36088: cpd:C00046','IMPD').
produces('3137: rn:R03284','35984: cpd:C00037','IMPD').
produces('41199: rn:R05959','37075: gl:G00127','IMPD').
produces('40063: rn:R07978','37335: cpd:C16360','IMPD').
produces('40067: rn:R07945','37304: cpd:C16356','IMPD').
produces('7695: rn:R01196','35944: cpd:C00024','IMPD').
produces('40066: rn:R07940','37329: cpd:C16365','IMPD').
produces('40100: rn:R00086','36266: cpd:C00008','IMPD').
produces('41200: rn:R01378','36935: cpd:C02763','IMPD').
produces('41203: rn:R00698','36839: cpd:C02505','IMPD').
produces('7694: rn:R00211','35944: cpd:C00024','IMPD').
produces('41215: rn:R02530','36439: cpd:C00546','IMPD').
produces('40072: rn:R01132','37175: cpd:C00262','IMPD').
produces('40061: rn:R07942','37611: cpd:C16359','IMPD').
produces('41226: rn:R00236','35944: cpd:C00024','IMPD').
produces('40073: rn:R00328','37267: cpd:C00144','IMPD').
produces('4310: rn:R00228','35944: cpd:C00024','IMPD').
produces('40109: rn:R04209','36108: cpd:C03373','IMPD').
produces('41225: rn:R00227','35949: cpd:C00033','IMPD').
produces('7692: rn:R00212','35952: cpd:C00022','IMPD').
produces('10099: rn:R01623','38894: cpd:C03688','IMPD').
produces('41227: rn:R00703','35952: cpd:C00022','IMPD').
produces('5449: rn:R00306','35981: cpd:C00031','IMPD').
produces('40107: rn:R00191','36298: cpd:C00020','IMPD').
produces('40108: rn:R00437','36266: cpd:C00008','IMPD').
produces('40064: rn:R07981','37626: cpd:C16362','IMPD').
produces('40077: rn:R00328','37267: cpd:C00144','IMPD').
produces('40119: rn:R00181','35941: cpd:C00014','IMPD').
produces('40078: rn:R01230 rn:R01231','37267: cpd:C00144','IMPD').
produces('40085: rn:R02106','37035: cpd:C11821','IMPD').
produces('40080: rn:R00961','37183: cpd:C00130','IMPD').
produces('40081: rn:R01134','37183: cpd:C00130','IMPD').
produces('40083: rn:R01560','37180: cpd:C00294','IMPD').
produces('40079: rn:R00722','37285: cpd:C00081','IMPD').
produces('5444: rn:R00952','35981: cpd:C00031','IMPD').
produces('40084: rn:R01126','37180: cpd:C00294','IMPD').
produces('6540: rn:R05075','36424: cpd:C00229','IMPD').
produces('6539: rn:R05146','36424: cpd:C00229','IMPD').
produces('40103: rn:R07107','36623: cpd:C11150','IMPD').
produces('9209: rn:R00932','36163: cpd:C02630','IMPD').
produces('5393: rn:R03526','37514: cpd:C01798','IMPD').
produces('5395: rn:R02889','37432: cpd:C00760','IMPD').
produces('40082: rn:R00719','37285: cpd:C00081','IMPD').
produces('40092: rn:R07016','37037: cpd:C14784','IMPD').
produces('40086: rn:R01969','37235: cpd:C00242','IMPD').
produces('40117: rn:R00185','36298: cpd:C00020','IMPD').
produces('40088: rn:R02422','37191: cpd:C00603','IMPD').
produces('40113: rn:R02297','36454: cpd:C00385','IMPD').
produces('41213: rn:R02613','36836: cpd:C00601','IMPD').
produces('7674: rn:R00203','35952: cpd:C00022','IMPD').
produces('41207: rn:R05947','37059: gl:G00118','IMPD').
produces('41214: rn:R00699','36837: cpd:C05332','IMPD').
produces('40121: rn:R01083','36298: cpd:C00020','IMPD').
produces('7673: rn:R00203','35952: cpd:C00022','IMPD').
produces('40090: rn:R01229','37267: cpd:C00144','IMPD').
produces('5386: rn:R02886','37480: cpd:C00185','IMPD').
produces('40118: rn:R00190','36418: cpd:C00147','IMPD').
produces('40076: rn:R01130','37724: cpd:C00655','IMPD').
produces('40091: rn:R00332','37262: cpd:C00035','IMPD').
produces('5386: rn:R02886','37432: cpd:C00760','IMPD').
produces('40000: rn:R08222','36473: dr:D00584 cpd:C07649','IMPD').
produces('40951: rn:R06153','37328: gl:G00047','IMPD').
produces('40991: rn:R01082','36085: cpd:C00122','IMPD').
produces('39985: rn:R01569','36984: cpd:C00214','IMPD').
produces('5444: rn:R00952','36174: cpd:C00103','IMPD').
produces('40962: rn:R03599','37010: cpd:C01528','IMPD').
produces('39994: rn:R02484','36679: cpd:C00106','IMPD').
produces('40988: rn:R01900','36132: cpd:C00311','IMPD').
produces('40949: rn:R01004','37339: cpd:C00110','IMPD').
produces('40961: rn:R01662','36970: cpd:C01159','IMPD').
produces('39961: rn:R07979','37615: cpd:C16355','IMPD').
produces('40004: rn:R08240','36273: cpd:C16618','IMPD').
produces('39983: rn:R02092','36987: cpd:C00364','IMPD').
produces('40948: rn:R05991','37408: gl:G00021','IMPD').
produces('40989: rn:R01325','36122: cpd:C00417','IMPD').
produces('40990: rn:R02164','36085: cpd:C00122','IMPD').
produces('40950: rn:R06153','37328: gl:G00047','IMPD').
produces('40953: rn:R05989','37388: gl:G00017','IMPD').
produces('7457: rn:R06198','36112: gl:G00057','IMPD').
produces('40968: rn:R09373','36932: cpd:C18904','IMPD').
produces('40954: rn:R05992','37411: gl:G00022','IMPD').
produces('39981: rn:R02094','36979: cpd:C00363','IMPD').
produces('7461: rn:R06097','35961: gl:G00069','IMPD').
produces('39977: rn:R02093','36982: cpd:C00459','IMPD').
produces('39998: rn:R08236','36382: cpd:C16614','IMPD').
produces('39979: rn:R02095','36979: cpd:C00363','IMPD').
produces('40952: rn:R05988','37391: gl:G00016','IMPD').
produces('40005: rn:R00377','36154: cpd:C00039','IMPD').
produces('40972: rn:R01899','36941: cpd:C05379','IMPD').
produces('9066: rn:R05450','37000: cpd:C00544','IMPD').
produces('40973: rn:R02570','36951: cpd:C16254','IMPD').
produces('39956: rn:R07939','37628: cpd:C13747','IMPD').
produces('40995: rn:R04413','36265: cpd:C04756','IMPD').
produces('5429: rn:R02112','36896: cpd:C00208','IMPD').
produces('40992: rn:R07380','36251: cpd:C15645','IMPD').
produces('40994: rn:R07384','36191: cpd:C03454','IMPD').
produces('40955: rn:R05986','37404: gl:G00019','IMPD').
produces('5455: rn:R00803','36174: cpd:C00103','IMPD').
produces('40993: rn:R07388','36254: cpd:C15646','IMPD').
produces('40956: rn:R05990','37402: gl:G00018','IMPD').
produces('40997: rn:R07385','36286: cpd:C15647','IMPD').
produces('39971: rn:R01570','36990: cpd:C00672','IMPD').
produces('40999: rn:R03438','36231: cpd:C05212','IMPD').
produces('39973: rn:R04666','36962: cpd:C05145','IMPD').
produces('39995: rn:R08246','36288: cpd:C16620','IMPD').
produces('39970: rn:R01415','36955: cpd:C00178','IMPD').
produces('39972: rn:R01868','36903: cpd:C00295','IMPD').
produces('40974: rn:R03316','36951: cpd:C16254','IMPD').
produces('9063: rn:R05487','36860: cpd:C05852','IMPD').
produces('39971: rn:R01570','36955: cpd:C00178','IMPD').
produces('39993: rn:R08239','36290: cpd:C16615','IMPD').
produces('40980: rn:R04773','36978: cpd:C05336','IMPD').
produces('40964: rn:R07109','37477: cpd:C14774','IMPD').
produces('41005: rn:R03437','36198: cpd:C04598','IMPD').
produces('40003: rn:R01665','36913: cpd:C00705','IMPD').
produces('40016: rn:R08229','36501: cpd:C16633','IMPD').
produces('41003: rn:R07379','36215: cpd:C04635','IMPD').
produces('40015: rn:R08230','36503: dr:D04197 cpd:C11736','IMPD').
produces('41001: rn:R07387','36264: cpd:C04317','IMPD').
produces('40010: rn:R08221','36648: dr:D01309 cpd:C12739','IMPD').
produces('39999: rn:R02101','36987: cpd:C00364','IMPD').
produces('40001: rn:R02326','36909: cpd:C00458','IMPD').
produces('40014: rn:R08226','36466: cpd:C16630','IMPD').
produces('41009: rn:R04321','36198: cpd:C04598','IMPD').
produces('40008: rn:R08220','36637: cpd:C16635','IMPD').
produces('40983: rn:R03596','37010: cpd:C01528','IMPD').
produces('40984: rn:R03595','36956: cpd:C05172','IMPD').
produces('40006: rn:R08259','36680: cpd:C11376','IMPD').
produces('40013: rn:R08227','36470: cpd:C16631','IMPD').
produces('40967: rn:R07110','37466: cpd:C14773','IMPD').
produces('40998: rn:R01687','36512: cpd:C05844','IMPD').
produces('41007: rn:R06364','36195: cpd:C04475','IMPD').
produces('41014: rn:R03270','35974: cpd:C00068','IMPD').
produces('5455: rn:R00803','36517: cpd:C00095','IMPD').
produces('40966: rn:R07111','37469: cpd:C14772','IMPD').
produces('9: rn:R00755','36038: cpd:C00084','IMPD').
produces('40977: rn:R00621','37100: cpd:C05381','IMPD').
produces('40965: rn:R07108','37473: cpd:C14775','IMPD').
produces('40996: rn:R03720','36509: cpd:C05122','IMPD').
produces('41011: rn:R04452','36264: cpd:C04317','IMPD').
produces('41012: rn:R07389','36231: cpd:C05212','IMPD').
produces('41002: rn:R02466','36523: cpd:C00519','IMPD').
produces('39992: rn:R02485','36933: cpd:C00526','IMPD').
produces('39997: rn:R02016','36779: cpd:C00342','IMPD').
produces('39991: rn:R02099','36942: cpd:C00365','IMPD').
produces('41000: rn:R02466','36523: cpd:C00519','IMPD').
produces('39990: rn:R02098','36938: cpd:C01346','IMPD').
produces('41017: rn:R07618','36187: cpd:C15972','IMPD').
produces('41006: rn:R00893','36527: cpd:C00606','IMPD').
produces('39989: rn:R02331','36929: cpd:C00460','IMPD').
produces('39987: rn:R01567','36987: cpd:C00364','IMPD').
produces('41014: rn:R03270','36199: cpd:C16255','IMPD').
produces('40002: rn:R08225','36473: dr:D00584 cpd:C07649','IMPD').
produces('41004: rn:R02467','36523: cpd:C00519','IMPD').
produces('39996: rn:R02484','36679: cpd:C00106','IMPD').
produces('9123: rn:R00212','35944: cpd:C00024','IMPD').
produces('41008: rn:R01682','36519: cpd:C00245','IMPD').
produces('1914: rn:R01856','37246: cpd:C00330','IMPD').
produces('9122: rn:R01196','35944: cpd:C00024','IMPD').
produces('41020: rn:R02569','36199: cpd:C16255','IMPD').
produces('40022: rn:R02024','36776: cpd:C00343','IMPD').
produces('41010: rn:R01682','36519: cpd:C00245','IMPD').
produces('40024: rn:R02016','36779: cpd:C00342','IMPD').
produces('40012: rn:R01663','36942: cpd:C00365','IMPD').
produces('40017: rn:R02016','36779: cpd:C00342','IMPD').
produces('41030: rn:R00014','36017: cpd:C05125','IMPD').
produces('4473: rn:R01816','36878: cpd:C00632','IMPD').
produces('40020: rn:R02016','36779: cpd:C00342','IMPD').
produces('40027: rn:R08294','36338: cpd:C16560','IMPD').
produces('40023: rn:R08228','36460: cpd:C16632','IMPD').
produces('40009: rn:R01666','36916: cpd:C00239','IMPD').
produces('5445: rn:R02886','37480: cpd:C00185','IMPD').
produces('5445: rn:R02886','37432: cpd:C00760','IMPD').
produces('5462: rn:R01557','36918: cpd:C01083','IMPD').
produces('1923: rn:R01885','37186: cpd:C00620','IMPD').
produces('41037: rn:R00945','35967: cpd:C00065','IMPD').
produces('40030: rn:R08294','36338: cpd:C16560','IMPD').
produces('40033: rn:R08285','36260: cpd:C16553','IMPD').
produces('40011: rn:R02100','36942: cpd:C00365','IMPD').
produces('40019: rn:R08232','36463: cpd:C16634','IMPD').
produces('40018: rn:R08233','36494: cpd:C04242','IMPD').
produces('41033: rn:R01049','36120: cpd:C00119','IMPD').
produces('40026: rn:R08285','36260: cpd:C16553','IMPD').
produces('6442: rn:R07817','37789: gl:G13040','IMPD').
produces('1947: rn:R00322','36298: cpd:C00020','IMPD').
produces('40021: rn:R08231','36463: cpd:C16634','IMPD').
produces('41036: rn:R00431 rn:R00726','36129: cpd:C00074','IMPD').
produces('40007: rn:R01664','36936: cpd:C00881','IMPD').
produces('40036: rn:R08275','36867: cpd:C07643','IMPD').
produces('40039: rn:R08267','36771: cpd:C05011','IMPD').
produces('40035: rn:R08275','36867: cpd:C07643','IMPD').
produces('41034: rn:R01641','36246: cpd:C00231','IMPD').
produces('40043: rn:R08271','36628: cpd:C16544','IMPD').
produces('6423: rn:R07817','37789: gl:G13040','IMPD').
produces('40038: rn:R08275','36867: cpd:C07643','IMPD').
produces('6419: rn:R07815','37797: gl:G13038','IMPD').
produces('40037: rn:R08276','36872: cpd:C16550','IMPD').
produces('40040: rn:R08269','36788: cpd:C16547','IMPD').
produces('40041: rn:R08268','36737: cpd:C16546','IMPD').
produces('41040: rn:R02739','36197: cpd:C01172','IMPD').
produces('40037: rn:R08276','36694: cpd:C06754','IMPD').
produces('40058: rn:R08312','36037: cpd:C07496','IMPD').
produces('41031: rn:R01317','36456: cpd:C00157','IMPD').
produces('40053: rn:R07015','36171: cpd:C03012','IMPD').
produces('40034: rn:R08280','36847: cpd:C11583','IMPD').
produces('40042: rn:R08274','36597: cpd:C16549','IMPD').
produces('40047: rn:R00200','36266: cpd:C00008','IMPD').
produces('41043: rn:R01528','36242: cpd:C00199','IMPD').
produces('40029: rn:R08293','36798: cpd:C16561','IMPD').
produces('41049: rn:R01070','36025: cpd:C00118','IMPD').
produces('41013: rn:R03059','37152: cpd:C02166','IMPD').
produces('40032: rn:R08272','36783: cpd:C16548','IMPD').
produces('40048: rn:R00185','36298: cpd:C00020','IMPD').
produces('1937: rn:R00126','37214: cpd:C01260','IMPD').
produces('40031: rn:R08270','36788: cpd:C16547','IMPD').
produces('41052: rn:R02740','36087: cpd:C05345','IMPD').
produces('40022: rn:R02024','36913: cpd:C00705','IMPD').
produces('41035: rn:R01051','36608: cpd:C00117','IMPD').
produces('41034: rn:R01641','36608: cpd:C00117','IMPD').
produces('4451: rn:R01974','37842: cpd:C00637','IMPD').
produces('41015: rn:R03867','37190: cpd:C05951','IMPD').
produces('40055: rn:R08341','35950: cpd:C16661','IMPD').
produces('40025: rn:R08277','36870: cpd:C07644','IMPD').
produces('41018: rn:R03866','37198: cpd:C04853','IMPD').
produces('40045: rn:R00086','36266: cpd:C00008','IMPD').
produces('40028: rn:R08293','36798: cpd:C16561','IMPD').
produces('41048: rn:R01830','36246: cpd:C00231','IMPD').
produces('41019: rn:R02265','37146: cpd:C00584','IMPD').
produces('41047: rn:R03971','36282: cpd:C06114','IMPD').
produces('39940: rn:R08304','36146: cpd:C16582','IMPD').
produces('39943: rn:R08349','36072: cpd:C16610','IMPD').
produces('41021: rn:R02268','37346: cpd:C02198','IMPD').
produces('41028: rn:R01595','37150: cpd:C05356','IMPD').
produces('39912: rn:R00440','36949: cpd:C00112','IMPD').
produces('41024: rn:R01596','37185: cpd:C05965','IMPD').
produces('41025: rn:R01593','37179: cpd:C05966','IMPD').
produces('41023: rn:R02267','37144: cpd:C01312','IMPD').
produces('41022: rn:R01590','37172: cpd:C05956','IMPD').
produces('39950: rn:R08340','35973: cpd:C16660','IMPD').
produces('41016: rn:R03057','37354: cpd:C02165','IMPD').
produces('39951: rn:R08342','35963: cpd:C16662','IMPD').
produces('1880: rn:R02020','37247: cpd:C00286','IMPD').
produces('39925: rn:R00157','36773: cpd:C00075','IMPD').
produces('41055: rn:R04780','36087: cpd:C05345','IMPD').
produces('41050: rn:R01056','36242: cpd:C00199','IMPD').
produces('39946: rn:R08345','36065: cpd:C16609','IMPD').
produces('39916: rn:R00963','36995: cpd:C00299','IMPD').
produces('41056: rn:R01827','36087: cpd:C05345','IMPD').
produces('41051: rn:R01529','36246: cpd:C00231','IMPD').
produces('39867: rn:R02480','38168: cpd:C00524','IMPD').
produces('39924: rn:R00158','36415: cpd:C00015','IMPD').
produces('39915: rn:R00978','36679: cpd:C00106','IMPD').
produces('39906: rn:R00511','36952: cpd:C00475','IMPD').
produces('39939: rn:R00575','35970: cpd:C00169','IMPD').
produces('41032: rn:R02750','37297: cpd:C00673','IMPD').
produces('39907: rn:R00514','36948: cpd:C00055','IMPD').
produces('41027: rn:R03058','37350: cpd:C00909','IMPD').
produces('39904: rn:R01878','36995: cpd:C00299','IMPD').
produces('41048: rn:R01830','36729: cpd:C00279','IMPD').
produces('41054: rn:R04779','36547: cpd:C05378','IMPD').
produces('39868: rn:R02391 rn:R02393','38116: cpd:C00486','IMPD').
produces('39922: rn:R00159','36415: cpd:C00015','IMPD').
produces('39905: rn:R00513 rn:R00516 rn:R00517 rn:R00962 rn:R01548 rn:R02091 rn:R02096 rn:R02371 rn:R02372','36948: cpd:C00055','IMPD').
produces('1884: rn:R00429','37261: cpd:C04494','IMPD').
produces('41053: rn:R03970','36489: cpd:C05711','IMPD').
produces('39937: rn:R08303','36136: cpd:C16584','IMPD').
produces('39928: rn:R00438','36415: cpd:C00015','IMPD').
produces('1919: rn:R00087','36298: cpd:C00020','IMPD').
produces('39920: rn:R00155','36654: cpd:C00105','IMPD').
produces('39919: rn:R00966','36679: cpd:C00106','IMPD').
produces('39936: rn:R08304','36146: cpd:C16582','IMPD').
produces('39938: rn:R08303','36136: cpd:C16584','IMPD').
produces('3027: rn:R00457','36340: cpd:C04076','IMPD').
produces('39921: rn:R00155','36654: cpd:C00105','IMPD').
produces('41029: rn:R00073','37165: cpd:C00427','IMPD').
produces('39918: rn:R00964 rn:R00967 rn:R00968 rn:R00970 rn:R01549 rn:R01880 rn:R02097 rn:R02327 rn:R02332','36654: cpd:C00105','IMPD').
produces('39910: rn:R00570','36897: cpd:C00063','IMPD').
produces('41026: rn:R07034','37245: cpd:C04805','IMPD').
produces('39917: rn:R01876','36679: cpd:C00106','IMPD').
produces('39934: rn:R08306','36141: cpd:C16587','IMPD').
produces('39908: rn:R00512','36949: cpd:C00112','IMPD').
produces('39909: rn:R00569','36949: cpd:C00112','IMPD').
produces('41041: rn:R02035','37254: cpd:C00345','IMPD').
produces('41083: rn:R00243 rn:R00248','35955: cpd:C00026','IMPD').
produces('41079: rn:R07064','36092: cpd:C01595','IMPD').
produces('39942: rn:R08348','36652: cpd:C16612','IMPD').
produces('41056: rn:R01827','36729: cpd:C00279','IMPD').
produces('39933: rn:R08264','36829: cpd:C16576','IMPD').
produces('39958: rn:R08313','36061: cpd:C16602','IMPD').
produces('41039: rn:R02266','37201: cpd:C00696','IMPD').
produces('39945: rn:R08347','36652: cpd:C16612','IMPD').
produces('39941: rn:R02018','36776: cpd:C00343','IMPD').
produces('41038: rn:R02581','37162: cpd:C00639','IMPD').
produces('39944: rn:R08346','36652: cpd:C16612','IMPD').
produces('39948: rn:R08344','36206: cpd:C16607','IMPD').
produces('39935: rn:R08310','36612: cpd:C16596','IMPD').
produces('7456: rn:R06192','37419: gl:G00073','IMPD').
produces('39947: rn:R08343','36216: cpd:C16608','IMPD').
produces('39953: rn:R08312','36037: cpd:C07496','IMPD').
produces('39923: rn:R00571 rn:R00573','36897: cpd:C00063','IMPD').
produces('39932: rn:R08307','36616: cpd:C16591','IMPD').
produces('39926: rn:R00156','36773: cpd:C00075','IMPD').
produces('10281: rn:R00131','36031: cpd:C00011','IMPD').
produces('39929: rn:R01870','36903: cpd:C00295','IMPD').
produces('41042: rn:R02736','37314: cpd:C01236','IMPD').
produces('41082: rn:R02457','36069: cpd:C01110','IMPD').
produces('41081: rn:R02923','36099: cpd:C03771','IMPD').
produces('41085: rn:R00256','35960: cpd:C00025','IMPD').
produces('39931: rn:R01397','36787: cpd:C00438','IMPD').
produces('39954: rn:R08313','36061: cpd:C16602','IMPD').
produces('39949: rn:R08343','36216: cpd:C16608','IMPD').
produces('39952: rn:R08327','36107: cpd:C16651','IMPD').
produces('41063: rn:R01057','36608: cpd:C00117','IMPD').
produces('39930: rn:R01993','36787: cpd:C00438','IMPD').
produces('41046: rn:R07050','37515: cpd:C14770','IMPD').
produces('41089: rn:R01639','36246: cpd:C00231','IMPD').
produces('41096: rn:R00289','36063: cpd:C00029','IMPD').
produces('41090: rn:R01529','36246: cpd:C00231','IMPD').
produces('39975: rn:R00378','36154: cpd:C00039','IMPD').
produces('41084: rn:R01478','36228: cpd:C00191','IMPD').
produces('41044: rn:R07052','37508: cpd:C14768','IMPD').
produces('41086: rn:R01579','36233: cpd:C00217','IMPD').
produces('41045: rn:R07051','37504: cpd:C14769','IMPD').
produces('39974: rn:R08245','36299: cpd:C16619','IMPD').
produces('41057: rn:R07041','37452: cpd:C14748','IMPD').
produces('39957: rn:R08318','36332: cpd:C16604','IMPD').
produces('41059: rn:R07035','37360: cpd:C04742','IMPD').
produces('39959: rn:R08285','36260: cpd:C16553','IMPD').
produces('41100: rn:R00286','36142: cpd:C00167','IMPD').
produces('41072: rn:R09372','36989: cpd:C05703','IMPD').
produces('41103: rn:R00115','36032: cpd:C00051','IMPD').
produces('41058: rn:R07046','37482: cpd:C14749','IMPD').
produces('41074: rn:R09365','36974: cpd:C05335','IMPD').
produces('39941: rn:R02018','36938: cpd:C01346','IMPD').
produces('41080: rn:R03626','36812: cpd:C04717','IMPD').
produces('41067: rn:R09366','36989: cpd:C05703','IMPD').
produces('41093: rn:R01758 rn:R01759','36185: cpd:C00259','IMPD').
produces('41092: rn:R01904','36220: cpd:C00312','IMPD').
produces('41070: rn:R04929','36946: cpd:C05686','IMPD').
produces('41078: rn:R07056','36730: cpd:C14826','IMPD').
produces('41094: rn:R01431','36239: cpd:C00181','IMPD').
produces('41098: rn:R01383','36147: cpd:C03033','IMPD').
produces('41097: rn:R02640','36176: cpd:C00618','IMPD').
produces('39963: rn:R02100','36942: cpd:C00365','IMPD').
produces('41064: rn:R07044','37500: cpd:C14782','IMPD').
produces('41091: rn:R07888','36624: cpd:C16328','IMPD').
produces('39980: rn:R08237','36403: cpd:C04646','IMPD').
produces('41116: rn:R00494','35960: cpd:C00025','IMPD').
produces('41095: rn:R07861','36620: cpd:C16300','IMPD').
produces('1890: rn:R00125','36266: cpd:C00008','IMPD').
produces('41088: rn:R07055','36782: cpd:C14825','IMPD').
produces('41099: rn:R07859','36445: cpd:C06427','IMPD').
produces('41065: rn:R07048','37512: cpd:C14771','IMPD').
produces('41062: rn:R07041','37452: cpd:C14748','IMPD').
produces('41061: rn:R07041','37452: cpd:C14748','IMPD').
produces('39955: rn:R07977','37304: cpd:C16356','IMPD').
produces('41060: rn:R07046','37482: cpd:C14749','IMPD').
produces('41066: rn:R07042','37368: cpd:C14781','IMPD').
produces('39984: rn:R08250','36479: cpd:C16622','IMPD').
produces('41111: rn:R04951','35984: cpd:C00037','IMPD').
produces('41112: rn:R03916','35960: cpd:C00025','IMPD').
produces('39969: rn:R03055','36965: cpd:C05100','IMPD').
produces('41069: rn:R01519','37244: cpd:C00257','IMPD').
produces('39988: rn:R08235','36325: cpd:C16613','IMPD').
produces('1864: rn:R02425','37207: cpd:C00499','IMPD').
produces('39986: rn:R08243','36403: cpd:C04646','IMPD').
produces('9048: rn:R02540','36831: cpd:C07086','IMPD').
produces('39976: rn:R08244','36299: cpd:C16619','IMPD').
produces('41075: rn:R07038','37422: cpd:C14812','IMPD').
produces('1869: rn:R01618','37214: cpd:C01260','IMPD').
produces('41102: rn:R01528','36579: cpd:C00005','IMPD').
produces('41122: rn:R00251','35960: cpd:C00025','IMPD').
produces('41121: rn:R00899','35984: cpd:C00037','IMPD').
produces('41121: rn:R00899','35962: cpd:C00097','IMPD').
produces('39962: rn:R08255','36681: cpd:C11173','IMPD').
produces('39966: rn:R08258','36681: cpd:C11173','IMPD').
produces('41076: rn:R07053','37462: cpd:C14823','IMPD').
produces('39978: rn:R08238','36290: cpd:C16615','IMPD').
produces('41103: rn:R00115','36613: cpd:C00006','IMPD').
produces('41124: rn:R00233','35944: cpd:C00024','IMPD').
produces('39960: rn:R08263','36820: cpd:C16578','IMPD').
produces('39964: rn:R08260','36681: cpd:C11173','IMPD').
produces('1872: rn:R00336','37262: cpd:C00035','IMPD').
produces('41073: rn:R07043','37371: cpd:C14813','IMPD').
produces('39965: rn:R00969','36773: cpd:C00075','IMPD').
produces('39968: rn:R00662','36654: cpd:C00105','IMPD').
produces('41068: rn:R07045','37497: cpd:C14814','IMPD').
produces('39967: rn:R00965','36654: cpd:C00105','IMPD').
produces('41101: rn:R00670','36555: cpd:C00134','IMPD').
produces('41118: rn:R00497','36032: cpd:C00051','IMPD').
produces('39982: rn:R08248','36308: cpd:C07585','IMPD').
produces('41071: rn:R07054','37492: cpd:C14778','IMPD').
produces('41077: rn:R02736 rn:R02035','37254: cpd:C00345','IMPD').
produces('41104: rn:R06518','36422: cpd:C12126','IMPD').
produces('41119: rn:R02743','35962: cpd:C00097','IMPD').
produces('40346: rn:R07491','38218: cpd:C15780','IMPD').
produces('40347: rn:R07492','38215: cpd:C15781','IMPD').
produces('41375: rn:R04300','37181: cpd:C04043','IMPD').
produces('41365: rn:R04391','37539: cpd:C04352','IMPD').
produces('41376: rn:R03943','37221: cpd:C06199','IMPD').
produces('41337: rn:R02288','38435: cpd:C00439','IMPD').
produces('40385: rn:R03990','37093: cpd:C05273','IMPD').
produces('41366: rn:R04230 rn:R04231','37539: cpd:C04352','IMPD').
produces('8944: rn:R01611','37006: cpd:C00804','IMPD').
produces('41339: rn:R02287','38435: cpd:C00439','IMPD').
produces('40342: rn:R01457','38235: cpd:C01802','IMPD').
produces('41367: rn:R03018','37584: cpd:C03492','IMPD').
produces('40392: rn:R03857','36705: cpd:C03221','IMPD').
produces('41356: rn:R04221','37935: cpd:C04282','IMPD').
produces('40391: rn:R03858','36772: cpd:C00010','IMPD').
produces('40393: rn:R04741','36715: cpd:C05263','IMPD').
produces('41349: rn:R02155','37715: cpd:C05127','IMPD').
produces('41355: rn:R03035','37530: cpd:C00882','IMPD').
produces('3329: rn:R01255','38061: cpd:C00763','IMPD').
produces('40391: rn:R03858','37115: cpd:C05261','IMPD').
produces('13454: rn:R08278','36805: cpd:C07645','IMPD').
produces('41358: rn:R03036','37530: cpd:C00882','IMPD').
produces('40404: rn:R01177','36747: cpd:C05269','IMPD').
produces('41405: rn:R02657','36084: cpd:C00628','IMPD').
produces('40405: rn:R01177','36747: cpd:C05269','IMPD').
produces('40404: rn:R01177','36772: cpd:C00010','IMPD').
produces('41360: rn:R03269','37532: cpd:C01134','IMPD').
produces('40351: rn:R07486','38216: cpd:C15783','IMPD').
produces('40398: rn:R04751','36738: cpd:C05271','IMPD').
produces('41359: rn:R02971','37532: cpd:C01134','IMPD').
produces('40386: rn:R04739','37115: cpd:C05261','IMPD').
produces('7859: rn:R00228','35944: cpd:C00024','IMPD').
produces('40389: rn:R03990','37093: cpd:C05273','IMPD').
produces('40388: rn:R04739','37115: cpd:C05261','IMPD').
produces('40390: rn:R04740','37093: cpd:C05273','IMPD').
produces('40427: rn:R01278','35954: cpd:C00154','IMPD').
produces('3330: rn:R01246 rn:R01249','38065: cpd:C03564','IMPD').
produces('40379: rn:R04754','36721: cpd:C05275','IMPD').
produces('40400: rn:R01175','36074: cpd:C00877','IMPD').
produces('155: rn:R01196','35952: cpd:C00022','IMPD').
produces('41342: rn:R02914','37708: cpd:C03680','IMPD').
produces('40329: rn:R05639','38269: cpd:C05108','IMPD').
produces('7304: rn:R06525','36434: cpd:C12144','IMPD').
produces('41344: rn:R01167','37665: cpd:C00388','IMPD').
produces('40378: rn:R04744','36721: cpd:C05275','IMPD').
produces('41396: rn:R00734','36016: cpd:C01179','IMPD').
produces('41343: rn:R01167','37665: cpd:C00388','IMPD').
produces('40402: rn:R01175','36074: cpd:C00877','IMPD').
produces('8965: rn:R00740','35992: cpd:C00083','IMPD').
produces('40380: rn:R03778','36772: cpd:C00010','IMPD').
produces('7309: rn:R02542','36209: cpd:C02960','IMPD').
produces('40331: rn:R02874','38280: cpd:C01054','IMPD').
produces('40401: rn:R03026','36074: cpd:C00877','IMPD').
produces('41345: rn:R04065','37658: cpd:C02835','IMPD').
produces('40330: rn:R03199','38277: cpd:C01724','IMPD').
produces('40367: rn:R04737','37124: cpd:C05259','IMPD').
produces('7303: rn:R06526','36414: cpd:C12145','IMPD').
produces('40380: rn:R03778','36713: cpd:C05265','IMPD').
produces('40381: rn:R04743','36713: cpd:C05265','IMPD').
produces('40368: rn:R01279','37109: cpd:C05272','IMPD').
produces('40353: rn:R04804','37567: cpd:C05439','IMPD').
produces('40325: rn:R03689','38261: cpd:C05109','IMPD').
produces('40399: rn:R01975','35964: cpd:C00332','IMPD').
produces('40375: rn:R04742','36715: cpd:C05263','IMPD').
produces('41348: rn:R02150','37663: cpd:C05130','IMPD').
produces('40377: rn:R04743','36713: cpd:C05265','IMPD').
produces('40375: rn:R04742','36772: cpd:C00010','IMPD').
produces('40365: rn:R01279','37109: cpd:C05272','IMPD').
produces('40376: rn:R04754','36721: cpd:C05275','IMPD').
produces('41350: rn:R01074','37642: cpd:C05921','IMPD').
produces('40397: rn:R01175','36074: cpd:C00877','IMPD').
produces('2388: rn:R00093','35960: cpd:C00025','IMPD').
produces('41353: rn:R02973','37130: cpd:C00864','IMPD').
produces('2349: rn:R00491','37112: cpd:C00402','IMPD').
produces('40338: rn:R07487','38223: cpd:C08821','IMPD').
produces('40337: rn:R07499','38254: cpd:C15915','IMPD').
produces('165: rn:R05605','35952: cpd:C00022','IMPD').
produces('41335: rn:R04869','37647: cpd:C05552','IMPD').
produces('2345: rn:R01346','37122: cpd:C02362','IMPD').
produces('41370: rn:R02869','36638: cpd:C00750','IMPD').
produces('41336: rn:R07769','37673: cpd:C16237','IMPD').
produces('40333: rn:R00702','38285: cpd:C03428','IMPD').
produces('41338: rn:R07768','37720: cpd:C16239','IMPD').
produces('40371: rn:R04738','37109: cpd:C05272','IMPD').
produces('40335: rn:R05731','38231: cpd:C11508','IMPD').
produces('40370: rn:R04737','37124: cpd:C05259','IMPD').
produces('40383: rn:R03777','36724: cpd:C05276','IMPD').
produces('40332: rn:R02872','38283: cpd:C00751','IMPD').
produces('40382: rn:R04745','36732: cpd:C05267','IMPD').
produces('40334: rn:R07488','38220: cpd:C01753','IMPD').
produces('41392: rn:R00729','36016: cpd:C01179','IMPD').
produces('40369: rn:R03991','37124: cpd:C05259','IMPD').
produces('41394: rn:R00734','36016: cpd:C01179','IMPD').
produces('40336: rn:R07483','38233: cpd:C15776','IMPD').
produces('41340: rn:R01168','37700: cpd:C00785','IMPD').
produces('41341: rn:R01074','37642: cpd:C05921','IMPD').
produces('41384: rn:R08390','37974: cpd:C16679','IMPD').
produces('40450: rn:R01819','36087: cpd:C05345','IMPD').
produces('9007: rn:R01438','36276: cpd:C06002','IMPD').
produces('40431: rn:R03856','36709: cpd:C01832','IMPD').
produces('40384: rn:R01347 rn:R01348','38176: cpd:C03547','IMPD').
produces('41412: rn:R02919','37158: cpd:C05577','IMPD').
produces('41386: rn:R08390','37974: cpd:C16679','IMPD').
produces('41382: rn:R08391','37987: cpd:C16680','IMPD').
produces('41404: rn:R02382','37325: cpd:C03765','IMPD').
produces('40449: rn:R02731','36087: cpd:C05345','IMPD').
produces('41388: rn:R08391','37987: cpd:C16680','IMPD').
produces('41415: rn:R04894','37168: cpd:C05583','IMPD').
produces('40428: rn:R04355','36677: cpd:C05744','IMPD').
produces('3286: rn:R04443','38149: cpd:C05938','IMPD').
produces('3353: rn:R01566','36091: cpd:C00086','IMPD').
produces('41390: rn:R08390','37974: cpd:C16679','IMPD').
produces('41451: rn:R00937 rn:R00940','36076: cpd:C00101','IMPD').
produces('40423: rn:R06985','36745: cpd:C05270','IMPD').
produces('41413: rn:R02535','37154: cpd:C00547','IMPD').
produces('41408: rn:R00736','37331: cpd:C00483','IMPD').
produces('3353: rn:R01566','36150: cpd:C00213','IMPD').
produces('40424: rn:R01177','36747: cpd:C05269','IMPD').
produces('41397: rn:R03342','37337: cpd:C05350','IMPD').
produces('41371: rn:R05050','38143: cpd:C02946','IMPD').
produces('40426: rn:R04738','37109: cpd:C05272','IMPD').
produces('41377: rn:R08392','37936: cpd:C16677','IMPD').
produces('40445: rn:R00888','36495: cpd:C01222','IMPD').
produces('5072: rn:R07229','36958: cpd:C05684','IMPD').
produces('41372: rn:R04025','38141: cpd:C05936','IMPD').
produces('41378: rn:R08383','37962: cpd:C16681','IMPD').
produces('41400: rn:R02695 rn:R02697','37282: cpd:C00642','IMPD').
produces('41379: rn:R02902','37932: cpd:C11061','IMPD').
produces('40439: rn:R03778','36713: cpd:C05265','IMPD').
produces('40446: rn:R05692','36411: cpd:C00325','IMPD').
produces('41369: rn:R01154','38147: cpd:C02714','IMPD').
produces('13440: rn:R08305','36244: cpd:C16586','IMPD').
produces('41374: rn:R00557','38018: cpd:C00327','IMPD').
produces('40456: rn:R01185','36139: cpd:C00137','IMPD').
produces('40438: rn:R04743','36706: cpd:C05264','IMPD').
produces('3359: rn:R08197','36099: cpd:C03771','IMPD').
produces('40437: rn:R04743','36706: cpd:C05264','IMPD').
produces('41380: rn:R08385','37970: cpd:C15493','IMPD').
produces('99: rn:R01197','36214: cpd:C00091','IMPD').
produces('40455: rn:R00867','36087: cpd:C05345','IMPD').
produces('41402: rn:R02382','37325: cpd:C03765','IMPD').
produces('41381: rn:R02368','37895: cpd:C00473','IMPD').
produces('40432: rn:R04170','36705: cpd:C03221','IMPD').
produces('2361: rn:R00490','36085: cpd:C00122','IMPD').
produces('41441: rn:R04242','36076: cpd:C00101','IMPD').
produces('40387: rn:R00631','38157: cpd:C00071','IMPD').
produces('40425: rn:R01274','36375: cpd:C00249','IMPD').
produces('40414: rn:R04746','36724: cpd:C05276','IMPD').
produces('41389: rn:R01815','37308: cpd:C00355','IMPD').
produces('40413: rn:R04745','36732: cpd:C05267','IMPD').
produces('40412: rn:R04747','36772: cpd:C00010','IMPD').
produces('41398: rn:R02521','37000: cpd:C00544','IMPD').
produces('40412: rn:R04747','36732: cpd:C05267','IMPD').
produces('40410: rn:R04748','36747: cpd:C05269','IMPD').
produces('5079: rn:R08223','36577: cpd:C16638','IMPD').
produces('40411: rn:R04751','36738: cpd:C05271','IMPD').
produces('40409: rn:R04751','36738: cpd:C05271','IMPD').
produces('3343: rn:R00471','35952: cpd:C00022','IMPD').
produces('40408: rn:R04751','36738: cpd:C05271','IMPD').
produces('40396: rn:R01279','37109: cpd:C05272','IMPD').
produces('40406: rn:R04748','36747: cpd:C05269','IMPD').
produces('40361: rn:R01923','38134: cpd:C02990','IMPD').
produces('40405: rn:R01177','36772: cpd:C00010','IMPD').
produces('41391: rn:R00731','37308: cpd:C00355','IMPD').
produces('3344: rn:R00471','35952: cpd:C00022','IMPD').
produces('40407: rn:R04749','36738: cpd:C05271','IMPD').
produces('3345: rn:R00471','35952: cpd:C00022','IMPD').
produces('40447: rn:R00885','35977: cpd:C00096','IMPD').
produces('40421: rn:R04748','36754: cpd:C05268','IMPD').
produces('3343: rn:R00471','35998: cpd:C00048','IMPD').
produces('40422: rn:R04749','36738: cpd:C05271','IMPD').
produces('41347: rn:R04996','38370: cpd:C05828','IMPD').
produces('40420: rn:R04748','36754: cpd:C05268','IMPD').
produces('3344: rn:R00471','35998: cpd:C00048','IMPD').
produces('41346: rn:R04674','38368: cpd:C05827','IMPD').
produces('13444: rn:R08311','36616: cpd:C16591','IMPD').
produces('3345: rn:R00471','35998: cpd:C00048','IMPD').
produces('40419: rn:R04746','36724: cpd:C05276','IMPD').
produces('41385: rn:R02078','37352: cpd:C00822','IMPD').
produces('40418: rn:R04745','36733: cpd:C05266','IMPD').
produces('40417: rn:R04745','36733: cpd:C05266','IMPD').
produces('40416: rn:R04747','36732: cpd:C05267','IMPD').
produces('13442: rn:R08309','36584: cpd:C16595','IMPD').
produces('2346: rn:R00397','36047: cpd:C00041','IMPD').
produces('40415: rn:R03777','36724: cpd:C05276','IMPD').
produces('41387: rn:R03208','37188: cpd:C01829','IMPD').
produces('41383: rn:R04884','37305: cpd:C05579','IMPD').
produces('40265: rn:R02218','38566: cpd:C05498','IMPD').
produces('41446: rn:R04888 rn:R04889','37169: cpd:C05582','IMPD').
produces('40350: rn:R01360','35944: cpd:C00024','IMPD').
produces('40291: rn:R07208','37771: cpd:C15518','IMPD').
produces('40295: rn:R01463','37622: cpd:C03594','IMPD').
produces('41457: rn:R00936 rn:R00939','36852: cpd:C00415','IMPD').
produces('40266: rn:R02219','38572: cpd:C05479','IMPD').
produces('40269: rn:R02207 rn:R02209','38488: cpd:C04042','IMPD').
produces('40297: rn:R07218','37619: cpd:C15519','IMPD').
produces('40267: rn:R08958','38570: cpd:C18041','IMPD').
produces('41458: rn:R02235 rn:R02236','36853: cpd:C00504','IMPD').
produces('41444: rn:R04301','37321: cpd:C05587','IMPD').
produces('8907: rn:R06987','36144: cpd:C00100','IMPD').
produces('41464: rn:R02363','36708: cpd:C00001','IMPD').
produces('40293: rn:R02794','37782: cpd:C00695','IMPD').
produces('41473: rn:R02204','36407: cpd:C00450','IMPD').
produces('41448: rn:R04300','37181: cpd:C04043','IMPD').
produces('9799: rn:R02135','38812: cpd:C00378','IMPD').
produces('40298: rn:R08743','37686: cpd:C02528','IMPD').
produces('41416: rn:R08388','37957: cpd:C00899','IMPD').
produces('40294: rn:R03718','37785: cpd:C01921','IMPD').
produces('40272: rn:R04840','38524: cpd:C05478','IMPD').
produces('41478: rn:R03026','36078: cpd:C01144','IMPD').
produces('40296: rn:R04813','37769: cpd:C05450','IMPD').
produces('41442: rn:R04890','37177: cpd:C05581','IMPD').
produces('40271: rn:R03848','38526: cpd:C05490','IMPD').
produces('40355: rn:R00238','35964: cpd:C00332','IMPD').
produces('40299: rn:R08744','37690: cpd:C05466','IMPD').
produces('40350: rn:R01360','36114: cpd:C00164','IMPD').
produces('40300: rn:R03719','37716: cpd:C01794','IMPD').
produces('41440: rn:R02080','37316: cpd:C03758','IMPD').
produces('40303: rn:R08505','37617: cpd:C15610','IMPD').
produces('40356: rn:R00410','35964: cpd:C00332','IMPD').
produces('3423: rn:R01915','36850: cpd:C00555','IMPD').
produces('41419: rn:R03048 rn:R08380','37957: cpd:C00899','IMPD').
produces('41483: rn:R00619','35974: cpd:C00068','IMPD').
produces('41436: rn:R03973','37196: cpd:C01060','IMPD').
produces('41475: rn:R02571','36014: cpd:C00527','IMPD').
produces('40301: rn:R04811','37714: cpd:C05337','IMPD').
produces('41414: rn:R07163','37921: cpd:C15492','IMPD').
produces('41449: rn:R02237','36852: cpd:C00415','IMPD').
produces('41438: rn:R03953','37193: cpd:C02465','IMPD').
produces('40305: rn:R04263','37629: cpd:C05455','IMPD').
produces('40302: rn:R08761','37725: cpd:C04722','IMPD').
produces('40354: rn:R01361','36114: cpd:C00164','IMPD').
produces('41464: rn:R02363','36205: cpd:C00472','IMPD').
produces('40304: rn:R08759','37727: cpd:C01301','IMPD').
produces('41472: rn:R00618','35974: cpd:C00068','IMPD').
produces('9798: rn:R02134','38449: cpd:C01081','IMPD').
produces('40308: rn:R08724','37624: cpd:C17336','IMPD').
produces('40306: rn:R08723','37696: cpd:C17332','IMPD').
produces('41469: rn:R02488','36074: cpd:C00877','IMPD').
produces('40307: rn:R08728','37693: cpd:C17337','IMPD').
produces('41409: rn:R08382 rn:R08383','37962: cpd:C16681','IMPD').
produces('41410: rn:R08389','37925: cpd:C03455','IMPD').
produces('41411: rn:R08381','37925: cpd:C03455','IMPD').
produces('41435: rn:R03539','37199: cpd:C02515','IMPD').
produces('40352: rn:R01451 rn:R01456','36362: cpd:C00187','IMPD').
produces('40311: rn:R07207','37627: cpd:C13550','IMPD').
produces('84: rn:R01058','35980: cpd:C00197','IMPD').
produces('5101: rn:R09371','36989: cpd:C05703','IMPD').
produces('85: rn:R01196','35952: cpd:C00022','IMPD').
produces('40277: rn:R04810','37712: cpd:C05449','IMPD').
produces('41429: rn:R04893','37168: cpd:C05583','IMPD').
produces('41407: rn:R08392','37936: cpd:C16677','IMPD').
produces('40279: rn:R08727','37695: cpd:C17335','IMPD').
produces('41406: rn:R08392','37936: cpd:C16677','IMPD').
produces('83: rn:R07159','35980: cpd:C00197','IMPD').
produces('40278: rn:R08721','37699: cpd:C17331','IMPD').
produces('40253: rn:R03783','38595: cpd:C05138','IMPD').
produces('41432: rn:R03181','36993: cpd:C01061','IMPD').
produces('3432: rn:R02280','36123: cpd:C00433','IMPD').
produces('41426: rn:R04891 rn:R04892','37163: cpd:C05584','IMPD').
produces('41401: rn:R02124 rn:R08379','37941: cpd:C00376','IMPD').
produces('40282: rn:R08740','37674: cpd:C05447','IMPD').
produces('41431: rn:R02519','36994: cpd:C01036','IMPD').
produces('40280: rn:R04823','37710: cpd:C05453','IMPD').
produces('40281: rn:R08739','37672: cpd:C17346','IMPD').
produces('41468: rn:R00238','35944: cpd:C00024','IMPD').
produces('40285: rn:R08738','37671: cpd:C17345','IMPD').
produces('41467: rn:R00549','35969: cpd:C00061','IMPD').
produces('41403: rn:R08392','37936: cpd:C16677','IMPD').
produces('40256: rn:R03713','38543: cpd:C05473','IMPD').
produces('86: rn:R07159','35980: cpd:C00197','IMPD').
produces('5097: rn:R04931','36967: cpd:C05689','IMPD').
produces('41427: rn:R02532','37158: cpd:C05577','IMPD').
produces('40255: rn:R03262','38541: cpd:C01124','IMPD').
produces('40259: rn:R03408','38518: cpd:C05139','IMPD').
produces('40283: rn:R04809','37776: cpd:C05448','IMPD').
produces('41422: rn:R04882 rn:R04883','37160: cpd:C05580','IMPD').
produces('40287: rn:R08758','37664: cpd:C05445','IMPD').
produces('41420: rn:R04881','37229: cpd:C05594','IMPD').
produces('40284: rn:R08733','37711: cpd:C15613','IMPD').
produces('40258: rn:R03404','38521: cpd:C01227','IMPD').
produces('40286: rn:R04806','37662: cpd:C05444','IMPD').
produces('41421: rn:R04887','37163: cpd:C05584','IMPD').
produces('41395: rn:R08390','37974: cpd:C16679','IMPD').
produces('40261: rn:R04678','38516: cpd:C05140','IMPD').
produces('41399: rn:R02124 rn:R08379','37941: cpd:C00376','IMPD').
produces('5125: rn:R01267','35946: cpd:C00152','IMPD').
produces('41463: rn:R00160','35969: cpd:C00061','IMPD').
produces('13428: rn:R08317','36023: cpd:C16601','IMPD').
produces('40260: rn:R04678','38516: cpd:C05140','IMPD').
produces('41423: rn:R02534','37151: cpd:C05589','IMPD').
produces('40288: rn:R08760','37668: cpd:C04554','IMPD').
produces('41424: rn:R02920','37145: cpd:C05588','IMPD').
produces('41418: rn:R04880','37158: cpd:C05577','IMPD').
produces('40290: rn:R04826','37706: cpd:C17339','IMPD').
produces('41417: rn:R02533','37147: cpd:C00788','IMPD').
produces('5120: rn:R00486','35959: cpd:C00049','IMPD').
produces('40349: rn:R01978','35942: cpd:C00356','IMPD').
produces('40348: rn:R00238','35964: cpd:C00332','IMPD').
produces('5094: rn:R08219','36789: cpd:C06482','IMPD').
produces('40292: rn:R08745','37680: cpd:C05465','IMPD').
produces('41393: rn:R08390','37974: cpd:C16679','IMPD').
produces('41517: rn:R00111','36035: cpd:C00533','IMPD').
produces('8940: rn:R01608','36164: cpd:C00222','IMPD').
produces('27: rn:R02738','36175: cpd:C00668','IMPD').
produces('7951: rn:R00228','35944: cpd:C00024','IMPD').
produces('40345: rn:R07493','37125: cpd:C01789','IMPD').
produces('41459: rn:R00942','37787: cpd:C09332','IMPD').
produces('40358: rn:R03857','36705: cpd:C03221','IMPD').
produces('41502: rn:R00178','36386: cpd:C01137','IMPD').
produces('40364: rn:R03777','36724: cpd:C05276','IMPD').
produces('40363: rn:R04751','36738: cpd:C05271','IMPD').
produces('41515: rn:R00565','36008: cpd:C00581','IMPD').
produces('3406: rn:R00671','36354: cpd:C00148','IMPD').
produces('41460: rn:R04285','37661: cpd:C04244','IMPD').
produces('41437: rn:R09395','38353: cpd:C05924','IMPD').
produces('41513: rn:R01883','35990: cpd:C00300','IMPD').
produces('40341: rn:R07507','37548: cpd:C01164','IMPD').
produces('41456: rn:R01793 rn:R01794','37669: cpd:C00272','IMPD').
produces('41454: rn:R05048','37737: cpd:C06148','IMPD').
produces('8936: rn:R01199','36024: cpd:C00109','IMPD').
produces('41499: rn:R00716','36348: cpd:C00449','IMPD').
produces('41434: rn:R09394','38390: cpd:C18239','IMPD').
produces('8935: rn:R01199','36024: cpd:C00109','IMPD').
produces('40321: rn:R03611','38212: cpd:C01561','IMPD').
produces('40339: rn:R03353','37550: cpd:C01189','IMPD').
produces('41503: rn:R01920','36162: cpd:C00315','IMPD').
produces('41455: rn:R01813','37669: cpd:C00272','IMPD').
produces('40340: rn:R03310 rn:R07215','37548: cpd:C01164','IMPD').
produces('40372: rn:R03857','36705: cpd:C03221','IMPD').
produces('39: rn:R00947','36183: cpd:C00267','IMPD').
produces('41453: rn:R04639','37660: cpd:C04895','IMPD').
produces('40360: rn:R01279','37109: cpd:C05272','IMPD').
produces('40373: rn:R04741','36715: cpd:C05263','IMPD').
produces('40323: rn:R07509','38264: cpd:C15808','IMPD').
produces('40394: rn:R02487','36074: cpd:C00877','IMPD').
produces('40374: rn:R04170','36705: cpd:C03221','IMPD').
produces('40324: rn:R05640','38256: cpd:C11455','IMPD').
produces('41505: rn:R00245','35960: cpd:C00025','IMPD').
produces('41501: rn:R01986 rn:R02549','36096: cpd:C00334','IMPD').
produces('40322: rn:R03610','38210: cpd:C01673','IMPD').
produces('41447: rn:R05046','37774: cpd:C05923','IMPD').
produces('40369: rn:R03991','36772: cpd:C00010','IMPD').
produces('40343: rn:R07498','37578: cpd:C03845','IMPD').
produces('40: rn:R00960','36183: cpd:C00267','IMPD').
produces('40359: rn:R03990','37093: cpd:C05273','IMPD').
produces('40344: rn:R05703','37567: cpd:C05439','IMPD').
produces('40313: rn:R08725','37693: cpd:C17337','IMPD').
produces('8923: rn:R00920','36144: cpd:C00100','IMPD').
produces('40312: rn:R04817','37703: cpd:C05451','IMPD').
produces('40314: rn:R08726','37625: cpd:C17333','IMPD').
produces('41445: rn:R00428','37742: cpd:C05922','IMPD').
produces('40310: rn:R07372','37722: cpd:C06341','IMPD').
produces('41498: rn:R00937 rn:R00940','36076: cpd:C00101','IMPD').
produces('40309: rn:R07372','37722: cpd:C06341','IMPD').
produces('40362: rn:R01175','36074: cpd:C00877','IMPD').
produces('40366: rn:R01280','35954: cpd:C00154','IMPD').
produces('40315: rn:R07209','37766: cpd:C15520','IMPD').
produces('41492: rn:R04125','36218: cpd:C00143','IMPD').
produces('3398: rn:R01987','36096: cpd:C00334','IMPD').
produces('3401: rn:R00131','36031: cpd:C00011','IMPD').
produces('40317: rn:R08734','37651: cpd:C17343','IMPD').
produces('41495: rn:R00946','36076: cpd:C00101','IMPD').
produces('41486: rn:R02313','36340: cpd:C04076','IMPD').
produces('40320: rn:R01461','37524: cpd:C02530','IMPD').
produces('41443: rn:R04286','37657: cpd:C03684','IMPD').
produces('40316: rn:R08735','37654: cpd:C05460','IMPD').
produces('41485: rn:R03102 rn:R03103','36345: cpd:C00956','IMPD').
produces('41439: rn:R04620','37770: cpd:C04874','IMPD').
produces('41493: rn:R04560','36076: cpd:C00101','IMPD').
produces('41433: rn:R02124','37941: cpd:C00376','IMPD').
produces('40326: rn:R07494','37553: cpd:C15816','IMPD').
produces('41491: rn:R00945','36076: cpd:C00101','IMPD').
produces('40318: rn:R04807','37719: cpd:C05446','IMPD').
produces('41430: rn:R02123','37948: cpd:C00777','IMPD').
produces('8915: rn:R02764','36111: cpd:C00683','IMPD').
produces('41428: rn:R00032','37941: cpd:C00376','IMPD').
produces('40357: rn:R04754','36721: cpd:C05275','IMPD').
produces('7936: rn:R00750','36038: cpd:C00084','IMPD').
produces('8920: rn:R00928','36144: cpd:C00100','IMPD').
produces('40328: rn:R07484','37575: cpd:C11522','IMPD').
produces('9921: rn:R01580','36233: cpd:C00217','IMPD').
produces('41452: rn:R03300 rn:R03302','37173: cpd:C01161','IMPD').
produces('41425: rn:R08387','37952: cpd:C02075 cpd:C02588','IMPD').
produces('7936: rn:R00750','35952: cpd:C00022','IMPD').
produces('41490: rn:R01975','35964: cpd:C00332','IMPD').
produces('40327: rn:R07495','37544: cpd:C05103','IMPD').
produces('2255: rn:R00515','36948: cpd:C00055','IMPD').
produces('41450: rn:R03304','37169: cpd:C05582','IMPD').
produces('8914: rn:R03381','36284: cpd:C01213','IMPD').
produces('3246: rn:R03314','36525: cpd:C03912','IMPD').
produces('41274: rn:R00475','35998: cpd:C00048','IMPD').
produces('41217: rn:R02531','37754: cpd:C05999','IMPD').
produces('41216: rn:R02577','37746: cpd:C00583','IMPD').
produces('41241: rn:R05947','37059: gl:G00118','IMPD').
produces('41240: rn:R08965','37090: cpd:C17938','IMPD').
produces('40268: rn:R03851','36868: cpd:C02140','IMPD').
produces('41273: rn:R00988','36152: cpd:C00108','IMPD').
produces('41243: rn:R05951','37081: gl:G00129','IMPD').
produces('5209: rn:R00279','35955: cpd:C00026','IMPD').
produces('40209: rn:R04758','38513: cpd:C05285','IMPD').
produces('41248: rn:R05943','36908: gl:G00112','IMPD').
produces('40263: rn:R02499','36848: cpd:C00535','IMPD').
produces('41246: rn:R05958','37054: gl:G00126','IMPD').
produces('41275: rn:R00987','36152: cpd:C00108','IMPD').
produces('41250: rn:R05940','36917: gl:G00113','IMPD').
produces('41245: rn:R05952','37058: gl:G00119','IMPD').
produces('41244: rn:R05953','37065: gl:G00120','IMPD').
produces('40264: rn:R03849','36868: cpd:C02140','IMPD').
produces('41252: rn:R05937','36920: gl:G00108','IMPD').
produces('41281: rn:R01933','36014: cpd:C00527','IMPD').
produces('7706: rn:R00207','36169: cpd:C00227','IMPD').
produces('41253: rn:R05942','36906: gl:G00111','IMPD').
produces('41247: rn:R05945','37084: gl:G00128','IMPD').
produces('40206: rn:R01834','38508: cpd:C00674','IMPD').
produces('41278: rn:R01959','36079: cpd:C00058','IMPD').
produces('7707: rn:R00230','36169: cpd:C00227','IMPD').
produces('41249: rn:R05959','37075: gl:G00127','IMPD').
produces('40262: rn:R02499','36848: cpd:C00535','IMPD').
produces('41282: rn:R03026','36078: cpd:C01144','IMPD').
produces('40208: rn:R01835','38511: cpd:C03772','IMPD').
produces('41286: rn:R00238','35944: cpd:C00024','IMPD').
produces('41284: rn:R00342','35957: cpd:C00036','IMPD').
produces('41239: rn:R02078','37352: cpd:C00822','IMPD').
produces('7717: rn:R00228','35944: cpd:C00024','IMPD').
produces('9955: rn:R01355','35952: cpd:C00022','IMPD').
produces('40254: rn:R08949','36877: cpd:C01780','IMPD').
produces('41251: rn:R05959','37075: gl:G00127','IMPD').
produces('41256: rn:R05941','36925: gl:G00110','IMPD').
produces('41257: rn:R05956','36911: gl:G00124','IMPD').
produces('40257: rn:R03405','36755: cpd:C04555','IMPD').
produces('41255: rn:R05939','36923: gl:G00109','IMPD').
produces('41254: rn:R05948','36954: gl:G00115','IMPD').
produces('5210: rn:R00579','36208: cpd:C00819','IMPD').
produces('41283: rn:R02488','36074: cpd:C00877','IMPD').
produces('41258: rn:R05938','36914: gl:G00123','IMPD').
produces('2250: rn:R00287','36654: cpd:C00105','IMPD').
produces('9955: rn:R01355','36140: cpd:C00163','IMPD').
produces('40250: rn:R04675','36858: cpd:C05487','IMPD').
produces('40195: rn:R08945 rn:R08980','38564: cpd:C18075','IMPD').
produces('9873: rn:R07456','38669: cpd:C00018','IMPD').
produces('5189: rn:R00279','35955: cpd:C00026','IMPD').
produces('287: rn:R01905','36220: cpd:C00312','IMPD').
produces('9872: rn:R07456','38669: cpd:C00018','IMPD').
produces('40196: rn:R03329','38568: cpd:C05497','IMPD').
produces('40251: rn:R01837','36851: cpd:C00280','IMPD').
produces('7705: rn:R03145','35949: cpd:C00033','IMPD').
produces('40197: rn:R02838','38568: cpd:C05497','IMPD').
produces('40252: rn:R01837','36851: cpd:C00280','IMPD').
produces('40273: rn:R00734','36016: cpd:C01179','IMPD').
produces('40191: rn:R02893','38556: cpd:C05469','IMPD').
produces('5163: rn:R06614','36919: cpd:C05670','IMPD').
produces('40246: rn:R02216','36886: cpd:C00410','IMPD').
produces('283: rn:R01903','36220: cpd:C00312','IMPD').
produces('40192: rn:R02843','38551: cpd:C00735','IMPD').
produces('40193: rn:R02841','38559: cpd:C05471','IMPD').
produces('41260: rn:R01364','36085: cpd:C00122','IMPD').
produces('41264: rn:R00351','35957: cpd:C00036','IMPD').
produces('280: rn:R01432','36263: cpd:C00310','IMPD').
produces('41260: rn:R01364','36114: cpd:C00164','IMPD').
produces('279: rn:R01896','36263: cpd:C00310','IMPD').
produces('40245: rn:R04853','36748: cpd:C05499','IMPD').
produces('40241: rn:R04849','36864: cpd:C05488','IMPD').
produces('41236: rn:R05949','36891: gl:G00116','IMPD').
produces('41235: rn:R06010','36923: gl:G00109','IMPD').
produces('41229: rn:R05968','37111: gl:G00099','IMPD').
produces('41228: rn:R05962','37133: gl:G00094','IMPD').
produces('3236: rn:R03249','36069: cpd:C01110','IMPD').
produces('40188: rn:R04852','38566: cpd:C05498','IMPD').
produces('40242: rn:R04163','36881: cpd:C03205','IMPD').
produces('41230: rn:R05964','37106: gl:G00097','IMPD').
produces('8829: rn:R00934','36144: cpd:C00100','IMPD').
produces('40243: rn:R04163','36881: cpd:C03205','IMPD').
produces('41231: rn:R05960','37128: gl:G00093','IMPD').
produces('40190: rn:R02836 rn:R02834','38548: cpd:C00762','IMPD').
produces('41238: rn:R06004','36920: gl:G00108','IMPD').
produces('41232: rn:R05967','37101: gl:G00098','IMPD').
produces('7701: rn:R00472','35982: cpd:C00149','IMPD').
produces('40237: rn:R02216','36886: cpd:C00410','IMPD').
produces('41271: rn:R01325','35940: cpd:C00158','IMPD').
produces('41233: rn:R05962','37133: gl:G00094','IMPD').
produces('41234: rn:R05904','37104: gl:G00104','IMPD').
produces('41242: rn:R05950','36889: gl:G00117','IMPD').
produces('5191: rn:R00260','36233: cpd:C00217','IMPD').
produces('41237: rn:R05947','37059: gl:G00118','IMPD').
produces('8829: rn:R00934','35998: cpd:C00048','IMPD').
produces('41222: rn:R01736','38699: cpd:C00256','IMPD').
produces('40319: rn:R01462','36362: cpd:C00187','IMPD').
produces('202: rn:R01522','37248: cpd:C00198','IMPD').
produces('41309: rn:R00238','35964: cpd:C00332','IMPD').
produces('40276: rn:R04812','37656: cpd:C05467','IMPD').
produces('7206: rn:R07063','36103: cpd:C06426','IMPD').
produces('40249: rn:R08943','38496: cpd:C18038','IMPD').
produces('40248: rn:R08942','38499: cpd:C18044','IMPD').
produces('7173: rn:R02264','37162: cpd:C00639','IMPD').
produces('2205: rn:R02325','36929: cpd:C00460','IMPD').
produces('41308: rn:R00710 rn:R00711','35949: cpd:C00033','IMPD').
produces('41306: rn:R00742','35992: cpd:C00083','IMPD').
produces('4261: rn:R00829','35944: cpd:C00024','IMPD').
produces('40247: rn:R08978','38499: cpd:C18044','IMPD').
produces('40244: rn:R03784','38546: cpd:C05485','IMPD').
produces('41314: rn:R00317','35949: cpd:C00033','IMPD').
produces('41311: rn:R00014','36017: cpd:C05125','IMPD').
produces('2201: rn:R02022','36909: cpd:C00458','IMPD').
produces('41310: rn:R01795','35991: cpd:C00082','IMPD').
produces('40240: rn:R02840','38551: cpd:C00735','IMPD').
produces('194: rn:R01522','37248: cpd:C00198','IMPD').
produces('40239: rn:R02840','38551: cpd:C00735','IMPD').
produces('195: rn:R01520 rn:R01521','37248: cpd:C00198','IMPD').
produces('41316: rn:R01975','35964: cpd:C00332','IMPD').
produces('40238: rn:R04850','38544: cpd:C05489','IMPD').
produces('41268: rn:R03664','37410: cpd:C03512','IMPD').
produces('41265: rn:R04907','37740: cpd:C05637','IMPD').
produces('41313: rn:R07618','36187: cpd:C15972','IMPD').
produces('2209: rn:R01668','36916: cpd:C00239','IMPD').
produces('7744: rn:R00753','36151: cpd:C00186','IMPD').
produces('192: rn:R06620','37248: cpd:C00198','IMPD').
produces('7745: rn:R00230','36169: cpd:C00227','IMPD').
produces('41312: rn:R02569','36199: cpd:C16255','IMPD').
produces('193: rn:R00305','37248: cpd:C00198','IMPD').
produces('40230: rn:R04676','38595: cpd:C05138','IMPD').
produces('40229: rn:R08977','38533: cpd:C18043','IMPD').
produces('40230: rn:R04676','38494: cpd:C02373','IMPD').
produces('5218: rn:R00672','36094: cpd:C00077','IMPD').
produces('5217: rn:R00672','36094: cpd:C00077','IMPD').
produces('41261: rn:R05946','36893: gl:G00114','IMPD').
produces('40231: rn:R03933','38494: cpd:C02373','IMPD').
produces('41296: rn:R01514','35980: cpd:C00197','IMPD').
produces('40228: rn:R08941','38533: cpd:C18043','IMPD').
produces('5219: rn:R00672','36094: cpd:C00077','IMPD').
produces('41259: rn:R05959','37075: gl:G00127','IMPD').
produces('40226: rn:R02723','38503: cpd:C05502','IMPD').
produces('5222: rn:R02458','36105: cpd:C00515','IMPD').
produces('41262: rn:R05957','36975: gl:G00125','IMPD').
produces('7743: rn:R00319','35949: cpd:C00033','IMPD').
produces('40227: rn:R04855','38503: cpd:C05502','IMPD').
produces('40275: rn:R02521','37000: cpd:C00544','IMPD').
produces('1197: rn:R07496','37541: cpd:C05437','IMPD').
produces('5224: rn:R00567','36110: cpd:C00792','IMPD').
produces('40289: rn:R03720','36509: cpd:C05122','IMPD').
produces('41272: rn:R02668','36878: cpd:C00632','IMPD').
produces('2201: rn:R02022','36776: cpd:C00343','IMPD').
produces('7737: rn:R00205','35952: cpd:C00022','IMPD').
produces('41295: rn:R01334','36258: cpd:C00160','IMPD').
produces('9921: rn:R01580','38669: cpd:C00018','IMPD').
produces('41280: rn:R04323','36756: cpd:C03824','IMPD').
produces('40274: rn:R02352 rn:R02353','36740: cpd:C00468','IMPD').
produces('40270: rn:R02213','36881: cpd:C03205','IMPD').
produces('3137: rn:R03284','38245: cpd:C01149','IMPD').
produces('40186: rn:R02107','37203: cpd:C00366','IMPD').
produces('1327: rn:R03975','35984: cpd:C00037','IMPD').
produces('40183: rn:R04144','37313: cpd:C03838','IMPD').
produces('41334: rn:R05145','36316: cpd:C06250','IMPD').
produces('40215: rn:R03088 rn:R03090','36319: cpd:C05301','IMPD').
produces('41285: rn:R01959','37778: cpd:C00328','IMPD').
produces('40214: rn:R04764','36315: cpd:C05302','IMPD').
produces('40182: rn:R04325','37307: cpd:C04376','IMPD').
produces('8770: rn:R01388','36028: cpd:C00168','IMPD').
produces('208: rn:R08570','35952: cpd:C00022','IMPD').
produces('40198: rn:R02211','36880: cpd:C01176','IMPD').
produces('41307: rn:R00316','37027: cpd:C05993','IMPD').
produces('41322: rn:R01394','36511: cpd:C01146','IMPD').
produces('40187: rn:R02019','37256: cpd:C00361','IMPD').
produces('41333: rn:R01077','36193: cpd:C00047','IMPD').
produces('40218: rn:R02354 rn:R02355','36322: cpd:C05298','IMPD').
produces('9923: rn:R01147','38669: cpd:C00018','IMPD').
produces('40217: rn:R02358','36349: cpd:C11133','IMPD').
produces('212: rn:R05605','36025: cpd:C00118','IMPD').
produces('41332: rn:R05145','36316: cpd:C06250','IMPD').
produces('208: rn:R08570','36048: cpd:C00577','IMPD').
produces('168: rn:R02749','37297: cpd:C00673','IMPD').
produces('40219: rn:R04762','36331: cpd:C05299','IMPD').
produces('40174: rn:R02720','37724: cpd:C00655','IMPD').
produces('212: rn:R05605','35952: cpd:C00022','IMPD').
produces('41331: rn:R05145','36316: cpd:C06250','IMPD').
produces('40220: rn:R04353','36327: cpd:C11132','IMPD').
produces('41325: rn:R01166','36492: cpd:C00135','IMPD').
produces('41290: rn:R04909','37934: cpd:C05638','IMPD').
produces('40189: rn:R01836','36851: cpd:C00280','IMPD').
produces('40204: rn:R01840','36367: cpd:C05290','IMPD').
produces('41289: rn:R04908','37929: cpd:C05639','IMPD').
produces('41291: rn:R02909','37872: cpd:C05647','IMPD').
produces('41352: rn:R01214','35958: cpd:C00141','IMPD').
produces('41292: rn:R04905','37831: cpd:C05660','IMPD').
produces('41294: rn:R02911','37868: cpd:C00978','IMPD').
produces('40205: rn:R02478','36402: cpd:C11135','IMPD').
produces('41293: rn:R03130','37853: cpd:C01598','IMPD').
produces('41354: rn:R00707 rn:R00708','35960: cpd:C00025','IMPD').
produces('40212: rn:R03091','36287: cpd:C05503','IMPD').
produces('7780: rn:R00750','35952: cpd:C00022','IMPD').
produces('9993: rn:R01268','36703: cpd:C00253','IMPD').
produces('41287: rn:R02701','37878: cpd:C00780','IMPD').
produces('40179: rn:R01234','37267: cpd:C00144','IMPD').
produces('40207: rn:R04352','36392: cpd:C11136','IMPD').
produces('41298: rn:R02910','37609: cpd:C06212','IMPD').
produces('41288: rn:R02702','37919: cpd:C05648','IMPD').
produces('40213: rn:R04354','36294: cpd:C11131','IMPD').
produces('40194: rn:R03326','36864: cpd:C05488','IMPD').
produces('7780: rn:R00750','36038: cpd:C00084','IMPD').
produces('41297: rn:R02174','37610: cpd:C06213','IMPD').
produces('41269: rn:R01814','37764: cpd:C00643','IMPD').
produces('40176: rn:R07116','36977: cpd:C14871','IMPD').
produces('40167: rn:R00335','37262: cpd:C00035','IMPD').
produces('41270: rn:R00678','37773: cpd:C02700','IMPD').
produces('7687: rn:R01450','38699: cpd:C00256','IMPD').
produces('40200: rn:R04683','36307: cpd:C05504','IMPD').
produces('40199: rn:R04681 rn:R04682','36337: cpd:C05300','IMPD').
produces('40169: rn:R00439','37262: cpd:C00035','IMPD').
produces('41277: rn:R03936','37613: cpd:C05653','IMPD').
produces('40172: rn:R02103','37203: cpd:C00366','IMPD').
produces('41263: rn:R00685','37826: cpd:C00398','IMPD').
produces('41324: rn:R00526','35959: cpd:C00049','IMPD').
produces('40170: rn:R04463','37300: cpd:C04640','IMPD').
produces('189: rn:R01737','37254: cpd:C00345','IMPD').
produces('41267: rn:R04171','37738: cpd:C05645','IMPD').
produces('40201: rn:R03089','36343: cpd:C05141','IMPD').
produces('41266: rn:R01956','37780: cpd:C01252','IMPD').
produces('8743: rn:R00013','36511: cpd:C01146','IMPD').
produces('40175: rn:R00720','37183: cpd:C00130','IMPD').
produces('1338: rn:R05835','35984: cpd:C00037','IMPD').
produces('40203: rn:R02356','36337: cpd:C05300','IMPD').
produces('40173: rn:R00426','37267: cpd:C00144','IMPD').
produces('8742: rn:R01745 rn:R01747','36511: cpd:C01146','IMPD').
produces('41321: rn:R01900','36132: cpd:C00311','IMPD').
produces('40202: rn:R02501','36379: cpd:C05294','IMPD').
produces('40144: rn:R03531','37697: cpd:C06196','IMPD').
produces('40158: rn:R03409','37269: cpd:C01228','IMPD').
produces('41279: rn:R02665','37750: cpd:C04409','IMPD').
produces('40163: rn:R02090','37256: cpd:C00361','IMPD').
produces('41276: rn:R01960','37734: cpd:C03227','IMPD').
produces('210: rn:R08572','36296: cpd:C00631','IMPD').
produces('40168: rn:R07070','37114: cpd:C14848','IMPD').
produces('2139: rn:R07922','37628: cpd:C13747','IMPD').
produces('8767: rn:R03140','35980: cpd:C00197','IMPD').
produces('40232: rn:R01454','36855: cpd:C05500','IMPD').
produces('2120: rn:R07957 rn:R07958','37324: cpd:C16353','IMPD').
produces('41319: rn:R03628','37861: cpd:C05642','IMPD').
produces('41318: rn:R03629','37850: cpd:C05643','IMPD').
produces('2112: rn:R07920','37590: cpd:C07481','IMPD').
produces('41323: rn:R01159','37670: cpd:C01152','IMPD').
produces('41317: rn:R00677','37856: cpd:C00331','IMPD').
produces('40236: rn:R03327','36880: cpd:C01176','IMPD').
produces('40235: rn:R03327','36880: cpd:C01176','IMPD').
produces('41357: rn:R01625','36536: cpd:C00054','IMPD').
produces('40234: rn:R04849','36864: cpd:C05488','IMPD').
produces('40233: rn:R04854','36855: cpd:C05500','IMPD').
produces('41315: rn:R00678','37773: cpd:C02700','IMPD').
produces('8767: rn:R03140','37403: cpd:C00988','IMPD').
produces('41361: rn:R00130','36772: cpd:C00010','IMPD').
produces('41333: rn:R01077','37632: cpd:C00120','IMPD').
produces('165: rn:R05605','36025: cpd:C00118','IMPD').
produces('40225: rn:R03325','36759: cpd:C04518','IMPD').
produces('41363: rn:R00978','36679: cpd:C00106','IMPD').
produces('41364: rn:R02869','36638: cpd:C00750','IMPD').
produces('40224: rn:R08961','36763: cpd:C18045','IMPD').
produces('41330: rn:R01074','37642: cpd:C05921','IMPD').
produces('40231: rn:R03933','36744: cpd:C01953','IMPD').
produces('41329: rn:R01074','37642: cpd:C05921','IMPD').
produces('41328: rn:R07771','37673: cpd:C16237','IMPD').
produces('41327: rn:R07766','37676: cpd:C16236','IMPD').
produces('169: rn:R01066','36025: cpd:C00118','IMPD').
produces('2148: rn:R07307','36942: cpd:C00365','IMPD').
produces('41320: rn:R02670','37875: cpd:C05640','IMPD').
produces('41326: rn:R07767','37673: cpd:C16237','IMPD').
produces('41351: rn:R05145','36316: cpd:C06250','IMPD').
produces('5289: rn:R01918','36032: cpd:C00051','IMPD').
produces('41300: rn:R04904','37864: cpd:C05635','IMPD').
produces('41301: rn:R02173','37842: cpd:C00637','IMPD').
produces('2108: rn:R07961 rn:R07962','37324: cpd:C16353','IMPD').
produces('40210: rn:R02725','37156: cpd:C05284','IMPD').
produces('41299: rn:R02173','37842: cpd:C00637','IMPD').
produces('2111: rn:R07919','37312: cpd:C07480','IMPD').
produces('2110: rn:R07955 rn:R07956','37312: cpd:C07480','IMPD').
produces('40223: rn:R02502','36361: cpd:C11134','IMPD').
produces('41368: rn:R00905','36040: cpd:C00099','IMPD').
produces('41373: rn:R00243 rn:R00248','35941: cpd:C00014','IMPD').
produces('13236: rn:R07073','37120: cpd:C14453','IMPD').
produces('41357: rn:R01625','36424: cpd:C00229','IMPD').
produces('2115: rn:R07919','37312: cpd:C07480','IMPD').
produces('40221: rn:R02497','36353: cpd:C03917','IMPD').
produces('40222: rn:R02498','36359: cpd:C05293','IMPD').
produces('40211: rn:R01838','36851: cpd:C00280','IMPD').
produces('40216: rn:R02350','36740: cpd:C00468','IMPD').
produces('9975: rn:R04292','38848: cpd:C03722','IMPD').
produces('2109: rn:R07980','37623: cpd:C16361','IMPD').
produces('41362: rn:R02269','36036: cpd:C02642','IMPD').
produces('41303: rn:R04903','37864: cpd:C05635','IMPD').
produces('41304: rn:R02908','37877: cpd:C05634','IMPD').
produces('41305: rn:R02678','37847: cpd:C00954','IMPD').
produces('5289: rn:R01918','36162: cpd:C00315','IMPD').
produces('41302: rn:R04911','37938: cpd:C05651','IMPD').
member_of('6634: rn:R01039','6611: rn00561','IMPD').
member_of('41435: rn:R03539','31129: rno00350','IMPD').
member_of('40392: rn:R03857','28772: rno00071','IMPD').
member_of('40391: rn:R03858','28772: rno00071','IMPD').
member_of('40394: rn:R02487','28772: rno00071','IMPD').
member_of('40393: rn:R04741','28772: rno00071','IMPD').
member_of('6633: rn:R01034','6611: rn00561','IMPD').
member_of('41436: rn:R03973','31129: rno00350','IMPD').
member_of('41431: rn:R02519','31129: rno00350','IMPD').
member_of('40396: rn:R01279','28772: rno00071','IMPD').
member_of('1285: rn:R04667','1195: rn00100','IMPD').
member_of('40395: rn:R00623','28772: rno00071','IMPD').
member_of('7020: rn:R04571','6975: rn00565','IMPD').
member_of('41429: rn:R04893','31129: rno00350','IMPD').
member_of('40398: rn:R04751','28772: rno00071','IMPD').
member_of('41432: rn:R03181','31129: rno00350','IMPD').
member_of('40397: rn:R01175','28772: rno00071','IMPD').
member_of('40383: rn:R03777','28772: rno00071','IMPD').
member_of('41330: rn:R01074','34623: rno00780','IMPD').
member_of('40382: rn:R04745','28772: rno00071','IMPD').
member_of('41328: rn:R07771','34653: rno00785','IMPD').
member_of('41329: rn:R01074','34623: rno00780','IMPD').
member_of('41442: rn:R04890','31129: rno00350','IMPD').
member_of('41332: rn:R05145','34623: rno00780','IMPD').
member_of('7021: rn:R03415','6975: rn00565','IMPD').
member_of('40386: rn:R04739','28772: rno00071','IMPD').
member_of('40384: rn:R01347 rn:R01348','28772: rno00071','IMPD').
member_of('41331: rn:R05145','34623: rno00780','IMPD').
member_of('41444: rn:R04301','31129: rno00350','IMPD').
member_of('40385: rn:R03990','28772: rno00071','IMPD').
member_of('40388: rn:R04739','28772: rno00071','IMPD').
member_of('8923: rn:R00920','8903: rn00640','IMPD').
member_of('40387: rn:R00631','28772: rno00071','IMPD').
member_of('41438: rn:R03953','31129: rno00350','IMPD').
member_of('6639: rn:R01048','6611: rn00561','IMPD').
member_of('41327: rn:R07766','34653: rno00785','IMPD').
member_of('8920: rn:R00928','8903: rn00640','IMPD').
member_of('40390: rn:R04740','28772: rno00071','IMPD').
member_of('41326: rn:R07767','34653: rno00785','IMPD').
member_of('40176: rn:R07116','35350: rno00980','IMPD').
member_of('40389: rn:R03990','28772: rno00071','IMPD').
member_of('41440: rn:R02080','31129: rno00350','IMPD').
member_of('8944: rn:R01611','8903: rn00640','IMPD').
member_of('41336: rn:R07769','34653: rno00785','IMPD').
member_of('41450: rn:R03304','31129: rno00350','IMPD').
member_of('40407: rn:R04749','28772: rno00071','IMPD').
member_of('41338: rn:R07768','34653: rno00785','IMPD').
member_of('40408: rn:R04751','28772: rno00071','IMPD').
member_of('40409: rn:R04751','28772: rno00071','IMPD').
member_of('41452: rn:R03300 rn:R03302','31129: rno00350','IMPD').
member_of('41341: rn:R01074','34623: rno00780','IMPD').
member_of('40410: rn:R04748','28772: rno00071','IMPD').
member_of('41446: rn:R04888 rn:R04889','31129: rno00350','IMPD').
member_of('2250: rn:R00287','2143: rn00240','IMPD').
member_of('41333: rn:R01077','34623: rno00780','IMPD').
member_of('40411: rn:R04751','28772: rno00071','IMPD').
member_of('41334: rn:R05145','34623: rno00780','IMPD').
member_of('40412: rn:R04747','28772: rno00071','IMPD').
member_of('41448: rn:R04300','31129: rno00350','IMPD').
member_of('41335: rn:R04869','34623: rno00780','IMPD').
member_of('40413: rn:R04745','28772: rno00071','IMPD').
member_of('40416: rn:R04747','28714: rno00062','IMPD').
member_of('40414: rn:R04746','28772: rno00071','IMPD').
member_of('40399: rn:R01975','28772: rno00071','IMPD').
member_of('41471: rn:R03283','30742: rno00310','IMPD').
member_of('8936: rn:R01199','8903: rn00640','IMPD').
member_of('40400: rn:R01175','28772: rno00071','IMPD').
member_of('8935: rn:R01199','8903: rn00640','IMPD').
member_of('40401: rn:R03026','28772: rno00071','IMPD').
member_of('41473: rn:R02204','30742: rno00310','IMPD').
member_of('13236: rn:R07073','13221: rn00980','IMPD').
member_of('41461: rn:R03673','31129: rno00350','IMPD').
member_of('40402: rn:R01175','28772: rno00071','IMPD').
member_of('1286: rn:R03724','1195: rn00100','IMPD').
member_of('40403: rn:R04756','28772: rno00071','IMPD').
member_of('8940: rn:R01608','8903: rn00640','IMPD').
member_of('40404: rn:R01177','28772: rno00071','IMPD').
member_of('41468: rn:R00238','30742: rno00310','IMPD').
member_of('40405: rn:R01177','28772: rno00071','IMPD').
member_of('1292: rn:R03311','1195: rn00100','IMPD').
member_of('41469: rn:R02488','30742: rno00310','IMPD').
member_of('40406: rn:R04748','28772: rno00071','IMPD').
member_of('6620: rn:R02691','6611: rn00561','IMPD').
member_of('2255: rn:R00515','2143: rn00240','IMPD').
member_of('41404: rn:R02382','31129: rno00350','IMPD').
member_of('40149: rn:R07083','35350: rno00980','IMPD').
member_of('40361: rn:R01923','28772: rno00071','IMPD').
member_of('40356: rn:R00410','28906: rno00072','IMPD').
member_of('40360: rn:R01279','28772: rno00071','IMPD').
member_of('41314: rn:R00317','33877: rno00620','IMPD').
member_of('40355: rn:R00238','28906: rno00072','IMPD').
member_of('40147: rn:R07084','35350: rno00980','IMPD').
member_of('40359: rn:R03990','28772: rno00071','IMPD').
member_of('41402: rn:R02382','31129: rno00350','IMPD').
member_of('41313: rn:R07618','33877: rno00620','IMPD').
member_of('40354: rn:R01361','28906: rno00072','IMPD').
member_of('40358: rn:R03857','28772: rno00071','IMPD').
member_of('40353: rn:R04804','28924: rno00100','IMPD').
member_of('41312: rn:R02569','33877: rno00620','IMPD').
member_of('40365: rn:R01279','28772: rno00071','IMPD').
member_of('41311: rn:R00014','33877: rno00620','IMPD').
member_of('40153: rn:R07082','35350: rno00980','IMPD').
member_of('41400: rn:R02695 rn:R02697','31129: rno00350','IMPD').
member_of('40364: rn:R03777','28772: rno00071','IMPD').
member_of('41309: rn:R00238','33877: rno00620','IMPD').
member_of('40363: rn:R04751','28772: rno00071','IMPD').
member_of('41398: rn:R02521','31129: rno00350','IMPD').
member_of('40151: rn:R07091','35350: rno00980','IMPD').
member_of('41397: rn:R03342','31129: rno00350','IMPD').
member_of('41308: rn:R00710 rn:R00711','33877: rno00620','IMPD').
member_of('40362: rn:R01175','28772: rno00071','IMPD').
member_of('9975: rn:R04292','9950: rn00760','IMPD').
member_of('41396: rn:R00734','31129: rno00350','IMPD').
member_of('1315: rn:R04824 rn:R04825','1307: rn00120','IMPD').
member_of('41412: rn:R02919','31129: rno00350','IMPD').
member_of('40347: rn:R07492','28924: rno00100','IMPD').
member_of('40346: rn:R07491','28924: rno00100','IMPD').
member_of('40344: rn:R05703','28924: rno00100','IMPD').
member_of('40345: rn:R07493','28924: rno00100','IMPD').
member_of('41408: rn:R00736','31129: rno00350','IMPD').
member_of('40352: rn:R01451 rn:R01456','28924: rno00100','IMPD').
member_of('40357: rn:R04754','28772: rno00071','IMPD').
member_of('40351: rn:R07486','28924: rno00100','IMPD').
member_of('40350: rn:R01360','28906: rno00072','IMPD').
member_of('40349: rn:R01978','28906: rno00072','IMPD').
member_of('41405: rn:R02657','31129: rno00350','IMPD').
member_of('40164: rn:R07105','35350: rno00980','IMPD').
member_of('40376: rn:R04754','28772: rno00071','IMPD').
member_of('9993: rn:R01268','9950: rn00760','IMPD').
member_of('41420: rn:R04881','31129: rno00350','IMPD').
member_of('40377: rn:R04743','28772: rno00071','IMPD').
member_of('40162: rn:R07100','35350: rno00980','IMPD').
member_of('1327: rn:R03975','1307: rn00120','IMPD').
member_of('40374: rn:R04170','28772: rno00071','IMPD').
member_of('41417: rn:R02533','31129: rno00350','IMPD').
member_of('41418: rn:R04880','31129: rno00350','IMPD').
member_of('40375: rn:R04742','28772: rno00071','IMPD').
member_of('40380: rn:R03778','28772: rno00071','IMPD').
member_of('41415: rn:R04894','31129: rno00350','IMPD').
member_of('40168: rn:R07070','35350: rno00980','IMPD').
member_of('40381: rn:R04743','28772: rno00071','IMPD').
member_of('41413: rn:R02535','31129: rno00350','IMPD').
member_of('8915: rn:R02764','8903: rn00640','IMPD').
member_of('40378: rn:R04744','28772: rno00071','IMPD').
member_of('41321: rn:R01900','33976: rno00630','IMPD').
member_of('40166: rn:R07092','35350: rno00980','IMPD').
member_of('8914: rn:R03381','8903: rn00640','IMPD').
member_of('9991: rn:R02322','9950: rn00760','IMPD').
member_of('40379: rn:R04754','28772: rno00071','IMPD').
member_of('41322: rn:R01394','33976: rno00630','IMPD').
member_of('41427: rn:R02532','31129: rno00350','IMPD').
member_of('40156: rn:R07112','35350: rno00980','IMPD').
member_of('40368: rn:R01279','28772: rno00071','IMPD').
member_of('40369: rn:R03991','28772: rno00071','IMPD').
member_of('40157: rn:R07113','35350: rno00980','IMPD').
member_of('1319: rn:R04818 rn:R04819','1307: rn00120','IMPD').
member_of('40366: rn:R01280','28772: rno00071','IMPD').
member_of('41426: rn:R04891 rn:R04892','31129: rno00350','IMPD').
member_of('40367: rn:R04737','28772: rno00071','IMPD').
member_of('41423: rn:R02534','31129: rno00350','IMPD').
member_of('40372: rn:R03857','28772: rno00071','IMPD').
member_of('40160: rn:R07106','35350: rno00980','IMPD').
member_of('41424: rn:R02920','31129: rno00350','IMPD').
member_of('40373: rn:R04741','28772: rno00071','IMPD').
member_of('41421: rn:R04887','31129: rno00350','IMPD').
member_of('40370: rn:R04737','28772: rno00071','IMPD').
member_of('8907: rn:R06987','8903: rn00640','IMPD').
member_of('41422: rn:R04882 rn:R04883','31129: rno00350','IMPD').
member_of('40371: rn:R04738','28772: rno00071','IMPD').
member_of('40159: rn:R07104','35350: rno00980','IMPD').
member_of('41374: rn:R00557','30830: rno00330','IMPD').
member_of('41373: rn:R00243 rn:R00248','30830: rno00330','IMPD').
member_of('399: rn:R02730','383: rn00051','IMPD').
member_of('41274: rn:R00475','33976: rno00630','IMPD').
member_of('41278: rn:R01959','33976: rno00630','IMPD').
member_of('390: rn:R00878','383: rn00051','IMPD').
member_of('41375: rn:R04300','31129: rno00350','IMPD').
member_of('41376: rn:R03943','31129: rno00350','IMPD').
member_of('41284: rn:R00342','33976: rno00630','IMPD').
member_of('9955: rn:R01355','9950: rn00760','IMPD').
member_of('392: rn:R00877','383: rn00051','IMPD').
member_of('40496: rn:R01070','28191: rno00051','IMPD').
member_of('3694: rn:R00042','3595: rn00350','IMPD').
member_of('40497: rn:R01015','28191: rno00051','IMPD').
member_of('40498: rn:R02568','28191: rno00051','IMPD').
member_of('41383: rn:R04884','31129: rno00350','IMPD').
member_of('40492: rn:R03161','28191: rno00051','IMPD').
member_of('41385: rn:R02078','31129: rno00350','IMPD').
member_of('41295: rn:R01334','33976: rno00630','IMPD').
member_of('40495: rn:R04780','28191: rno00051','IMPD').
member_of('41387: rn:R03208','31129: rno00350','IMPD').
member_of('9007: rn:R01438','8903: rn00640','IMPD').
member_of('41296: rn:R01514','33976: rno00630','IMPD').
member_of('41389: rn:R01815','31129: rno00350','IMPD').
member_of('41391: rn:R00731','31129: rno00350','IMPD').
member_of('3699: rn:R02520','3595: rn00350','IMPD').
member_of('41392: rn:R00729','31129: rno00350','IMPD').
member_of('41306: rn:R00742','33877: rno00620','IMPD').
member_of('41394: rn:R00734','31129: rno00350','IMPD').
member_of('41307: rn:R00316','33877: rno00620','IMPD').
member_of('41247: rn:R05945','33807: rno00604','IMPD').
member_of('40433: rn:R04737','28714: rno00062','IMPD').
member_of('40450: rn:R01819','28191: rno00051','IMPD').
member_of('41246: rn:R05958','33807: rno00604','IMPD').
member_of('40432: rn:R04170','28714: rno00062','IMPD').
member_of('3642: rn:R02698','3595: rn00350','IMPD').
member_of('40449: rn:R02731','28191: rno00051','IMPD').
member_of('41245: rn:R05952','33807: rno00604','IMPD').
member_of('40431: rn:R03856','28714: rno00062','IMPD').
member_of('40448: rn:R04779','28191: rno00051','IMPD').
member_of('41244: rn:R05953','33807: rno00604','IMPD').
member_of('40447: rn:R00885','28191: rno00051','IMPD').
member_of('40430: rn:R03858','28714: rno00062','IMPD').
member_of('8965: rn:R00740','8903: rn00640','IMPD').
member_of('41251: rn:R05959','33807: rno00604','IMPD').
member_of('41340: rn:R01168','31047: rno00340','IMPD').
member_of('40429: rn:R04739','28714: rno00062','IMPD').
member_of('40446: rn:R05692','28191: rno00051','IMPD').
member_of('41250: rn:R05940','33807: rno00604','IMPD').
member_of('41339: rn:R02287','31047: rno00340','IMPD').
member_of('3638: rn:R02518','3595: rn00350','IMPD').
member_of('40445: rn:R00888','28191: rno00051','IMPD').
member_of('41249: rn:R05959','33807: rno00604','IMPD').
member_of('40427: rn:R01278','28714: rno00062','IMPD').
member_of('41248: rn:R05943','33807: rno00604','IMPD').
member_of('41337: rn:R02288','31047: rno00340','IMPD').
member_of('40426: rn:R04738','28714: rno00062','IMPD').
member_of('40425: rn:R01274','28714: rno00062','IMPD').
member_of('41344: rn:R01167','31047: rno00340','IMPD').
member_of('41255: rn:R05939','33807: rno00604','IMPD').
member_of('40424: rn:R01177','28714: rno00062','IMPD').
member_of('41343: rn:R01167','31047: rno00340','IMPD').
member_of('41254: rn:R05948','33807: rno00604','IMPD').
member_of('40423: rn:R06985','28714: rno00062','IMPD').
member_of('41253: rn:R05942','33807: rno00604','IMPD').
member_of('41342: rn:R02914','31047: rno00340','IMPD').
member_of('40422: rn:R04749','28714: rno00062','IMPD').
member_of('3652: rn:R02384','3595: rn00350','IMPD').
member_of('41252: rn:R05937','33807: rno00604','IMPD').
member_of('40421: rn:R04748','28714: rno00062','IMPD').
member_of('40428: rn:R04355','28488: rno00061','IMPD').
member_of('41356: rn:R04221','30830: rno00330','IMPD').
member_of('41349: rn:R02155','31047: rno00340','IMPD').
member_of('425: rn:R02071','383: rn00051','IMPD').
member_of('9921: rn:R01580','9869: rn00750','IMPD').
member_of('40420: rn:R04748','28714: rno00062','IMPD').
member_of('41259: rn:R05959','33807: rno00604','IMPD').
member_of('3646: rn:R02514 rn:R02516','3595: rn00350','IMPD').
member_of('41348: rn:R02150','31047: rno00340','IMPD').
member_of('41258: rn:R05938','33807: rno00604','IMPD').
member_of('41354: rn:R00707 rn:R00708','30830: rno00330','IMPD').
member_of('41347: rn:R04996','31047: rno00340','IMPD').
member_of('40419: rn:R04746','28714: rno00062','IMPD').
member_of('40418: rn:R04745','28714: rno00062','IMPD').
member_of('41257: rn:R05956','33807: rno00604','IMPD').
member_of('41346: rn:R04674','31047: rno00340','IMPD').
member_of('9923: rn:R01147','9869: rn00750','IMPD').
member_of('428: rn:R01059','383: rn00051','IMPD').
member_of('40417: rn:R04745','28714: rno00062','IMPD').
member_of('41256: rn:R05941','33807: rno00604','IMPD').
member_of('41345: rn:R04065','31047: rno00340','IMPD').
member_of('40415: rn:R03777','28772: rno00071','IMPD').
member_of('40470: rn:R00264','28072: rno00040','IMPD').
member_of('41261: rn:R05946','33807: rno00604','IMPD').
member_of('41262: rn:R05957','33807: rno00604','IMPD').
member_of('40444: rn:R04744','28714: rno00062','IMPD').
member_of('7030: rn:R07383','6975: rn00565','IMPD').
member_of('2345: rn:R01346','2329: rn00250','IMPD').
member_of('40462: rn:R00866','28191: rno00051','IMPD').
member_of('7029: rn:R07382','6975: rn00565','IMPD').
member_of('41364: rn:R02869','30830: rno00330','IMPD').
member_of('40442: rn:R04742','28714: rno00062','IMPD').
member_of('40459: rn:R00875','28191: rno00051','IMPD').
member_of('40443: rn:R04753','28714: rno00062','IMPD').
member_of('6651: rn:R04471','6611: rn00561','IMPD').
member_of('2346: rn:R00397','2329: rn00250','IMPD').
member_of('40464: rn:R01430','28072: rno00040','IMPD').
member_of('2349: rn:R00491','2329: rn00250','IMPD').
member_of('40457: rn:R01787','28191: rno00051','IMPD').
member_of('40440: rn:R03776','28714: rno00062','IMPD').
member_of('40441: rn:R04741','28714: rno00062','IMPD').
member_of('40438: rn:R04743','28714: rno00062','IMPD').
member_of('40455: rn:R00867','28191: rno00051','IMPD').
member_of('41264: rn:R00351','33976: rno00630','IMPD').
member_of('40439: rn:R03778','28714: rno00062','IMPD').
member_of('40453: rn:R00872','28191: rno00051','IMPD').
member_of('40436: rn:R04740','28714: rno00062','IMPD').
member_of('41371: rn:R05050','30830: rno00330','IMPD').
member_of('41271: rn:R01325','33976: rno00630','IMPD').
member_of('40454: rn:R01326','28191: rno00051','IMPD').
member_of('40437: rn:R04743','28714: rno00062','IMPD').
member_of('41372: rn:R04025','30830: rno00330','IMPD').
member_of('40451: rn:R01818','28191: rno00051','IMPD').
member_of('41369: rn:R01154','30830: rno00330','IMPD').
member_of('40434: rn:R03991','28714: rno00062','IMPD').
member_of('41370: rn:R02869','30830: rno00330','IMPD').
member_of('40435: rn:R03989','28714: rno00062','IMPD').
member_of('40452: rn:R01951','28191: rno00051','IMPD').
member_of('40034: rn:R08280','35469: rno00982','IMPD').
member_of('41221: rn:R00197','33877: rno00620','IMPD').
member_of('40235: rn:R03327','29239: rno00140','IMPD').
member_of('41301: rn:R02173','31414: rno00380','IMPD').
member_of('40236: rn:R03327','29239: rno00140','IMPD').
member_of('40035: rn:R08275','35469: rno00982','IMPD').
member_of('41222: rn:R01736','33877: rno00620','IMPD').
member_of('6896: rn:R02756','6835: rn00564','IMPD').
member_of('41302: rn:R04911','31414: rno00380','IMPD').
member_of('40237: rn:R02216','29239: rno00140','IMPD').
member_of('40036: rn:R08275','35469: rno00982','IMPD').
member_of('41223: rn:R00342','33877: rno00620','IMPD').
member_of('202: rn:R01522','162: rn00030','IMPD').
member_of('41303: rn:R04903','31414: rno00380','IMPD').
member_of('40238: rn:R04850','29239: rno00140','IMPD').
member_of('40037: rn:R08276','35469: rno00982','IMPD').
member_of('41224: rn:R00216','33877: rno00620','IMPD').
member_of('41304: rn:R02908','31414: rno00380','IMPD').
member_of('41228: rn:R05962','33768: rno00603','IMPD').
member_of('40239: rn:R02840','29239: rno00140','IMPD').
member_of('40038: rn:R08275','35469: rno00982','IMPD').
member_of('41217: rn:R02531','33877: rno00620','IMPD').
member_of('41218: rn:R00200 rn:R02320','33877: rno00620','IMPD').
member_of('41297: rn:R02174','31414: rno00380','IMPD').
member_of('40039: rn:R08267','35469: rno00982','IMPD').
member_of('40240: rn:R02840','29239: rno00140','IMPD').
member_of('41219: rn:R00344','33877: rno00620','IMPD').
member_of('40241: rn:R04849','29239: rno00140','IMPD').
member_of('41298: rn:R02910','31414: rno00380','IMPD').
member_of('40040: rn:R08269','35469: rno00982','IMPD').
member_of('6767: rn:R04504','6695: rn00562','IMPD').
member_of('41299: rn:R02173','31414: rno00380','IMPD').
member_of('41220: rn:R00214','33877: rno00620','IMPD').
member_of('40041: rn:R08268','35469: rno00982','IMPD').
member_of('40242: rn:R04163','29239: rno00140','IMPD').
member_of('41300: rn:R04904','31414: rno00380','IMPD').
member_of('40042: rn:R08274','35469: rno00982','IMPD').
member_of('9048: rn:R02540','9044: rn00643','IMPD').
member_of('212: rn:R05605','162: rn00030','IMPD').
member_of('40043: rn:R08271','35469: rno00982','IMPD').
member_of('40244: rn:R03784','29239: rno00140','IMPD').
member_of('41292: rn:R04905','31414: rno00380','IMPD').
member_of('40243: rn:R04163','29239: rno00140','IMPD').
member_of('40245: rn:R04853','29239: rno00140','IMPD').
member_of('40044: rn:R08266','35469: rno00982','IMPD').
member_of('41293: rn:R03130','31414: rno00380','IMPD').
member_of('6887: rn:R01030','6835: rn00564','IMPD').
member_of('41215: rn:R02530','33877: rno00620','IMPD').
member_of('210: rn:R08572','162: rn00030','IMPD').
member_of('40246: rn:R02216','29239: rno00140','IMPD').
member_of('41294: rn:R02911','31414: rno00380','IMPD').
member_of('6886: rn:R02029','6835: rn00564','IMPD').
member_of('41216: rn:R02577','33877: rno00620','IMPD').
member_of('40247: rn:R08978','29239: rno00140','IMPD').
member_of('2361: rn:R00490','2329: rn00250','IMPD').
member_of('6885: rn:R00749','6835: rn00564','IMPD').
member_of('40051: rn:R07094','35350: rno00980','IMPD').
member_of('40248: rn:R08942','29239: rno00140','IMPD').
member_of('208: rn:R08570','162: rn00030','IMPD').
member_of('41288: rn:R02702','31414: rno00380','IMPD').
member_of('40050: rn:R07069','35350: rno00980','IMPD').
member_of('40052: rn:R07027','35350: rno00980','IMPD').
member_of('40249: rn:R08943','29239: rno00140','IMPD').
member_of('41210: rn:R00431 rn:R00726','33877: rno00620','IMPD').
member_of('41289: rn:R04908','31414: rno00380','IMPD').
member_of('40250: rn:R04675','29239: rno00140','IMPD').
member_of('40049: rn:R08282 rn:R08283','35469: rno00982','IMPD').
member_of('40053: rn:R07015','35350: rno00980','IMPD').
member_of('41290: rn:R04909','31414: rno00380','IMPD').
member_of('40251: rn:R01837','29239: rno00140','IMPD').
member_of('41291: rn:R02909','31414: rno00380','IMPD').
member_of('41318: rn:R03629','31414: rno00380','IMPD').
member_of('41241: rn:R05947','33807: rno00604','IMPD').
member_of('40253: rn:R03783','29239: rno00140','IMPD').
member_of('41317: rn:R00677','31414: rno00380','IMPD').
member_of('9063: rn:R05487','9044: rn00643','IMPD').
member_of('40252: rn:R01837','29239: rno00140','IMPD').
member_of('2388: rn:R00093','2329: rn00250','IMPD').
member_of('41320: rn:R02670','31414: rno00380','IMPD').
member_of('40255: rn:R03262','29239: rno00140','IMPD').
member_of('41243: rn:R05951','33807: rno00604','IMPD').
member_of('6877: rn:R02054','6835: rn00564','IMPD').
member_of('41319: rn:R03628','31414: rno00380','IMPD').
member_of('40254: rn:R08949','29239: rno00140','IMPD').
member_of('41242: rn:R05950','33807: rno00604','IMPD').
member_of('3635: rn:R02489','3595: rn00350','IMPD').
member_of('9066: rn:R05450','9044: rn00643','IMPD').
member_of('40257: rn:R03405','29239: rno00140','IMPD').
member_of('41237: rn:R05947','33807: rno00604','IMPD').
member_of('40256: rn:R03713','29239: rno00140','IMPD').
member_of('40055: rn:R08341','35469: rno00982','IMPD').
member_of('41325: rn:R01166','31047: rno00340','IMPD').
member_of('41236: rn:R05949','33807: rno00604','IMPD').
member_of('41316: rn:R01975','31414: rno00380','IMPD').
member_of('40058: rn:R08312','35469: rno00982','IMPD').
member_of('40259: rn:R03408','29239: rno00140','IMPD').
member_of('41315: rn:R00678','31414: rno00380','IMPD').
member_of('41238: rn:R06004','33807: rno00604','IMPD').
member_of('40258: rn:R03404','29239: rno00140','IMPD').
member_of('41234: rn:R05904','33768: rno00603','IMPD').
member_of('195: rn:R01520 rn:R01521','162: rn00030','IMPD').
member_of('40261: rn:R04678','29239: rno00140','IMPD').
member_of('40060: rn:R08343','35469: rno00982','IMPD').
member_of('41233: rn:R05962','33768: rno00603','IMPD').
member_of('40260: rn:R04678','29239: rno00140','IMPD').
member_of('41324: rn:R00526','31047: rno00340','IMPD').
member_of('41235: rn:R06010','33807: rno00604','IMPD').
member_of('6869: rn:R01470','6835: rn00564','IMPD').
member_of('193: rn:R00305','162: rn00030','IMPD').
member_of('40263: rn:R02499','29239: rno00140','IMPD').
member_of('6870: rn:R01800','6835: rn00564','IMPD').
member_of('41323: rn:R01159','31047: rno00340','IMPD').
member_of('194: rn:R01522','162: rn00030','IMPD').
member_of('40262: rn:R02499','29239: rno00140','IMPD').
member_of('41310: rn:R01795','31292: rno00360','IMPD').
member_of('41230: rn:R05964','33768: rno00603','IMPD').
member_of('40265: rn:R02218','29239: rno00140','IMPD').
member_of('41226: rn:R00236','33877: rno00620','IMPD').
member_of('41305: rn:R02678','31414: rno00380','IMPD').
member_of('41229: rn:R05968','33768: rno00603','IMPD').
member_of('41225: rn:R00227','33877: rno00620','IMPD').
member_of('40264: rn:R03849','29239: rno00140','IMPD').
member_of('192: rn:R06620','162: rn00030','IMPD').
member_of('41232: rn:R05967','33768: rno00603','IMPD').
member_of('40267: rn:R08958','29239: rno00140','IMPD').
member_of('189: rn:R01737','162: rn00030','IMPD').
member_of('41231: rn:R05960','33768: rno00603','IMPD').
member_of('40065: rn:R08339','35469: rno00982','IMPD').
member_of('40266: rn:R02219','29239: rno00140','IMPD').
member_of('41227: rn:R00703','33877: rno00620','IMPD').
member_of('41180: rn:R01978','34184: rno00650','IMPD').
member_of('6861: rn:R01316','6835: rn00564','IMPD').
member_of('39998: rn:R08236','35619: rno00983','IMPD').
member_of('40204: rn:R01840','29239: rno00140','IMPD').
member_of('41270: rn:R00678','31414: rno00380','IMPD').
member_of('41181: rn:R01360','34184: rno00650','IMPD').
member_of('40205: rn:R02478','29239: rno00140','IMPD').
member_of('40000: rn:R08222','35619: rno00983','IMPD').
member_of('41178: rn:R03026','34184: rno00650','IMPD').
member_of('40202: rn:R02501','29239: rno00140','IMPD').
member_of('6863: rn:R02027','6835: rn00564','IMPD').
member_of('41268: rn:R03664','31414: rno00380','IMPD').
member_of('2404: rn:R00576','2329: rn00250','IMPD').
member_of('40203: rn:R02356','29239: rno00140','IMPD').
member_of('41179: rn:R01361','34184: rno00650','IMPD').
member_of('41269: rn:R01814','31414: rno00380','IMPD').
member_of('41265: rn:R04907','31414: rno00380','IMPD').
member_of('40208: rn:R01835','29239: rno00140','IMPD').
member_of('10110: rn:R02473','10064: rn00770','IMPD').
member_of('41176: rn:R00238','34184: rno00650','IMPD').
member_of('40209: rn:R04758','29239: rno00140','IMPD').
member_of('41266: rn:R01956','31414: rno00380','IMPD').
member_of('40004: rn:R08240','35619: rno00983','IMPD').
member_of('41267: rn:R04171','31414: rno00380','IMPD').
member_of('40206: rn:R01834','29239: rno00140','IMPD').
member_of('41263: rn:R00685','31414: rno00380','IMPD').
member_of('41171: rn:R04326','34278: rno00670','IMPD').
member_of('41174: rn:R01975','34184: rno00650','IMPD').
member_of('40207: rn:R04352','29239: rno00140','IMPD').
member_of('40002: rn:R08225','35619: rno00983','IMPD').
member_of('40213: rn:R04354','29239: rno00140','IMPD').
member_of('41169: rn:R02287','34278: rno00670','IMPD').
member_of('41172: rn:R01648','34184: rno00650','IMPD').
member_of('40214: rn:R04764','29239: rno00140','IMPD').
member_of('41170: rn:R02302','34278: rno00670','IMPD').
member_of('40008: rn:R08220','35619: rno00983','IMPD').
member_of('41173: rn:R00261','34184: rno00650','IMPD').
member_of('41167: rn:R03189','34278: rno00670','IMPD').
member_of('6732: rn:R03332','6695: rn00562','IMPD').
member_of('40210: rn:R02725','29239: rno00140','IMPD').
member_of('40212: rn:R03091','29239: rno00140','IMPD').
member_of('40006: rn:R08259','35619: rno00983','IMPD').
member_of('41168: rn:R02235 rn:R02236','34278: rno00670','IMPD').
member_of('40211: rn:R01838','29239: rno00140','IMPD').
member_of('10102: rn:R02972','10064: rn00770','IMPD').
member_of('41165: rn:R00936 rn:R00939','34278: rno00670','IMPD').
member_of('40217: rn:R02358','29239: rno00140','IMPD').
member_of('7951: rn:R00228','7868: rn00622','IMPD').
member_of('41166: rn:R01218','34278: rno00670','IMPD').
member_of('40218: rn:R02354 rn:R02355','29239: rno00140','IMPD').
member_of('41163: rn:R01655','34278: rno00670','IMPD').
member_of('40215: rn:R03088 rn:R03090','29239: rno00140','IMPD').
member_of('41164: rn:R01220','34278: rno00670','IMPD').
member_of('40010: rn:R08221','35619: rno00983','IMPD').
member_of('40216: rn:R02350','29239: rno00140','IMPD').
member_of('40016: rn:R08229','35619: rno00983','IMPD').
member_of('3596: rn:R03672','3595: rn00350','IMPD').
member_of('41287: rn:R02701','31414: rno00380','IMPD').
member_of('41198: rn:R01176','34184: rno00650','IMPD').
member_of('40222: rn:R02498','29239: rno00140','IMPD').
member_of('41286: rn:R00238','31414: rno00380','IMPD').
member_of('40221: rn:R02497','29239: rno00140','IMPD').
member_of('40015: rn:R08230','35619: rno00983','IMPD').
member_of('3598: rn:R03674','3595: rn00350','IMPD').
member_of('41285: rn:R01959','31414: rno00380','IMPD').
member_of('41206: rn:R03270','33877: rno00620','IMPD').
member_of('41196: rn:R00713','34184: rno00650','IMPD').
member_of('41208: rn:R05940','33807: rno00604','IMPD').
member_of('6846: rn:R05381','6835: rn00564','IMPD').
member_of('40014: rn:R08226','35619: rno00983','IMPD').
member_of('40220: rn:R04353','29239: rno00140','IMPD').
member_of('6724: rn:R03332','6695: rn00562','IMPD').
member_of('40219: rn:R04762','29239: rno00140','IMPD').
member_of('40013: rn:R08227','35619: rno00983','IMPD').
member_of('41207: rn:R05947','33807: rno00604','IMPD').
member_of('41283: rn:R02488','31414: rno00380','IMPD').
member_of('40226: rn:R02723','29239: rno00140','IMPD').
member_of('40025: rn:R08277','35469: rno00982','IMPD').
member_of('6849: rn:R05794','6835: rn00564','IMPD').
member_of('40019: rn:R08232','35619: rno00983','IMPD').
member_of('41205: rn:R05937','33807: rno00604','IMPD').
member_of('41282: rn:R03026','31414: rno00380','IMPD').
member_of('40225: rn:R03325','29239: rno00140','IMPD').
member_of('40018: rn:R08233','35619: rno00983','IMPD').
member_of('40224: rn:R08961','29239: rno00140','IMPD').
member_of('41281: rn:R01933','31414: rno00380','IMPD').
member_of('41192: rn:R01171','34184: rno00650','IMPD').
member_of('6851: rn:R01319','6835: rn00564','IMPD').
member_of('41280: rn:R04323','31414: rno00380','IMPD').
member_of('40223: rn:R02502','29239: rno00140','IMPD').
member_of('41279: rn:R02665','31414: rno00380','IMPD').
member_of('40230: rn:R04676','29239: rno00140','IMPD').
member_of('40029: rn:R08293','35469: rno00982','IMPD').
member_of('40028: rn:R08293','35469: rno00982','IMPD').
member_of('40229: rn:R08977','29239: rno00140','IMPD').
member_of('40023: rn:R08228','35619: rno00983','IMPD').
member_of('41277: rn:R03936','31414: rno00380','IMPD').
member_of('40228: rn:R08941','29239: rno00140','IMPD').
member_of('40027: rn:R08294','35469: rno00982','IMPD').
member_of('41199: rn:R05959','33807: rno00604','IMPD').
member_of('40227: rn:R04855','29239: rno00140','IMPD').
member_of('41276: rn:R01960','31414: rno00380','IMPD').
member_of('40021: rn:R08231','35619: rno00983','IMPD').
member_of('40026: rn:R08285','35469: rno00982','IMPD').
member_of('41275: rn:R00987','31414: rno00380','IMPD').
member_of('41185: rn:R00014','34184: rno00650','IMPD').
member_of('40033: rn:R08285','35469: rno00982','IMPD').
member_of('40234: rn:R04849','29239: rno00140','IMPD').
member_of('41184: rn:R03534','34184: rno00650','IMPD').
member_of('40032: rn:R08272','35469: rno00982','IMPD').
member_of('40233: rn:R04854','29239: rno00140','IMPD').
member_of('41273: rn:R00988','31414: rno00380','IMPD').
member_of('7936: rn:R00750','7868: rn00622','IMPD').
member_of('6710: rn:R03478','6695: rn00562','IMPD').
member_of('41183: rn:R00410','34184: rno00650','IMPD').
member_of('40031: rn:R08270','35469: rno00982','IMPD').
member_of('40232: rn:R01454','29239: rno00140','IMPD').
member_of('41272: rn:R02668','31414: rno00380','IMPD').
member_of('41182: rn:R01357','34184: rno00650','IMPD').
member_of('40030: rn:R08294','35469: rno00982','IMPD').
member_of('40231: rn:R03933','29239: rno00140','IMPD').
member_of('41240: rn:R08965','31129: rno00350','IMPD').
member_of('41148: rn:R02765','33976: rno00630','IMPD').
member_of('41144: rn:R00926','34092: rno00640','IMPD').
member_of('40312: rn:R04817','29028: rno00120','IMPD').
member_of('41149: rn:R01859','33976: rno00630','IMPD').
member_of('41145: rn:R01354','34092: rno00640','IMPD').
member_of('40313: rn:R08725','29028: rno00120','IMPD').
member_of('1339: rn:R02797','1307: rn00120','IMPD').
member_of('41150: rn:R00833','33976: rno00630','IMPD').
member_of('41146: rn:R01354','34092: rno00640','IMPD').
member_of('1338: rn:R05835','1307: rn00120','IMPD').
member_of('40314: rn:R08726','29028: rno00120','IMPD').
member_of('40319: rn:R01462','28924: rno00100','IMPD').
member_of('4628: rn:R01826','4627: rn00400','IMPD').
member_of('41147: rn:R00926','34092: rno00640','IMPD').
member_of('40315: rn:R07209','29028: rno00120','IMPD').
member_of('40308: rn:R08724','29028: rno00120','IMPD').
member_of('40105: rn:R07087','35350: rno00980','IMPD').
member_of('40309: rn:R07372','29028: rno00120','IMPD').
member_of('40310: rn:R07372','29028: rno00120','IMPD').
member_of('13444: rn:R08311','13427: rn00982','IMPD').
member_of('40311: rn:R07207','29028: rno00120','IMPD').
member_of('9123: rn:R00212','9098: rn00650','IMPD').
member_of('40324: rn:R05640','28924: rno00100','IMPD').
member_of('41140: rn:R00238','33976: rno00630','IMPD').
member_of('9122: rn:R01196','9098: rn00650','IMPD').
member_of('40325: rn:R03689','28924: rno00100','IMPD').
member_of('40326: rn:R07494','28924: rno00100','IMPD').
member_of('41138: rn:R03045','34092: rno00640','IMPD').
member_of('40327: rn:R07495','28924: rno00100','IMPD').
member_of('40316: rn:R08735','29028: rno00120','IMPD').
member_of('40320: rn:R01461','28924: rno00100','IMPD').
member_of('40317: rn:R08734','29028: rno00120','IMPD').
member_of('13454: rn:R08278','13427: rn00982','IMPD').
member_of('40321: rn:R03611','28924: rno00100','IMPD').
member_of('41141: rn:R00935','34092: rno00640','IMPD').
member_of('40318: rn:R04807','29028: rno00120','IMPD').
member_of('41142: rn:R01859','34092: rno00640','IMPD').
member_of('40322: rn:R03610','28924: rno00100','IMPD').
member_of('41143: rn:R02765','34092: rno00640','IMPD').
member_of('40323: rn:R07509','28924: rno00100','IMPD').
member_of('41239: rn:R02078','31129: rno00350','IMPD').
member_of('41156: rn:R00943','34278: rno00670','IMPD').
member_of('40333: rn:R00702','28924: rno00100','IMPD').
member_of('41155: rn:R00941','34278: rno00670','IMPD').
member_of('40332: rn:R02872','28924: rno00100','IMPD').
member_of('40335: rn:R05731','28924: rno00100','IMPD').
member_of('41157: rn:R04325','34278: rno00670','IMPD').
member_of('1354: rn:R03977','1307: rn00120','IMPD').
member_of('40334: rn:R07488','28924: rno00100','IMPD').
member_of('41160: rn:R02300','34278: rno00670','IMPD').
member_of('10099: rn:R01623','10064: rn00770','IMPD').
member_of('40329: rn:R05639','28924: rno00100','IMPD').
member_of('40328: rn:R07484','28924: rno00100','IMPD').
member_of('41159: rn:R02301','34278: rno00670','IMPD').
member_of('41260: rn:R01364','31129: rno00350','IMPD').
member_of('13428: rn:R08317','13427: rn00982','IMPD').
member_of('41162: rn:R01224 rn:R07168','34278: rno00670','IMPD').
member_of('40331: rn:R02874','28924: rno00100','IMPD').
member_of('41161: rn:R03940','34278: rno00670','IMPD').
member_of('40330: rn:R03199','28924: rno00100','IMPD').
member_of('40341: rn:R07507','28924: rno00100','IMPD').
member_of('13442: rn:R08309','13427: rn00982','IMPD').
member_of('40340: rn:R03310 rn:R07215','28924: rno00100','IMPD').
member_of('40348: rn:R00238','28772: rno00071','IMPD').
member_of('13440: rn:R08305','13427: rn00982','IMPD').
member_of('40343: rn:R07498','28924: rno00100','IMPD').
member_of('40342: rn:R01457','28924: rno00100','IMPD').
member_of('4653: rn:R01073','4627: rn00400','IMPD').
member_of('40337: rn:R07499','28924: rno00100','IMPD').
member_of('40336: rn:R07483','28924: rno00100','IMPD').
member_of('40129: rn:R07002','35350: rno00980','IMPD').
member_of('40339: rn:R03353','28924: rno00100','IMPD').
member_of('40132: rn:R07093','35350: rno00980','IMPD').
member_of('40338: rn:R07487','28924: rno00100','IMPD').
member_of('40274: rn:R02352 rn:R02353','29239: rno00140','IMPD').
member_of('41203: rn:R00698','31292: rno00360','IMPD').
member_of('40281: rn:R08739','29028: rno00120','IMPD').
member_of('41193: rn:R00233','31657: rno00410','IMPD').
member_of('40282: rn:R08740','29028: rno00120','IMPD').
member_of('41204: rn:R00689','31292: rno00360','IMPD').
member_of('293: rn:R01481','250: rn00040','IMPD').
member_of('41190: rn:R00904','31657: rno00410','IMPD').
member_of('41201: rn:R00694','31292: rno00360','IMPD').
member_of('40071: rn:R08281','35469: rno00982','IMPD').
member_of('41189: rn:R00489','31657: rno00410','IMPD').
member_of('40272: rn:R04840','29239: rno00140','IMPD').
member_of('40279: rn:R08727','29028: rno00120','IMPD').
member_of('41191: rn:R03139','31657: rno00410','IMPD').
member_of('41202: rn:R00694','31292: rno00360','IMPD').
member_of('40280: rn:R04823','29028: rno00120','IMPD').
member_of('40277: rn:R04810','29028: rno00120','IMPD').
member_of('40270: rn:R02213','29239: rno00140','IMPD').
member_of('40069: rn:R08261','35469: rno00982','IMPD').
member_of('41197: rn:R00908','31657: rno00410','IMPD').
member_of('41209: rn:R02536 rn:R02537','31292: rno00360','IMPD').
member_of('40275: rn:R02521','29132: rno00130','IMPD').
member_of('40278: rn:R08721','29028: rno00120','IMPD').
member_of('40070: rn:R08262','35469: rno00982','IMPD').
member_of('40271: rn:R03848','29239: rno00140','IMPD').
member_of('41194: rn:R03158','31657: rno00410','IMPD').
member_of('40268: rn:R03851','29239: rno00140','IMPD').
member_of('41195: rn:R03045','31657: rno00410','IMPD').
member_of('40273: rn:R00734','29132: rno00130','IMPD').
member_of('40276: rn:R04812','29028: rno00120','IMPD').
member_of('40068: rn:R03697','35469: rno00982','IMPD').
member_of('40269: rn:R02207 rn:R02209','29239: rno00140','IMPD').
member_of('40290: rn:R04826','29028: rno00120','IMPD').
member_of('40291: rn:R07208','29028: rno00120','IMPD').
member_of('40287: rn:R08758','29028: rno00120','IMPD').
member_of('40288: rn:R08760','29028: rno00120','IMPD').
member_of('40289: rn:R03720','29028: rno00120','IMPD').
member_of('41187: rn:R02869','31657: rno00410','IMPD').
member_of('40285: rn:R08738','29028: rno00120','IMPD').
member_of('41200: rn:R01378','31292: rno00360','IMPD').
member_of('41188: rn:R02869','31657: rno00410','IMPD').
member_of('40286: rn:R04806','29028: rno00120','IMPD').
member_of('40283: rn:R04809','29028: rno00120','IMPD').
member_of('40284: rn:R08733','29028: rno00120','IMPD').
member_of('41186: rn:R00924','31657: rno00410','IMPD').
member_of('40299: rn:R08744','29028: rno00120','IMPD').
member_of('41131: rn:R02940','34092: rno00640','IMPD').
member_of('40298: rn:R08743','29028: rno00120','IMPD').
member_of('40094: rn:R07020','35350: rno00980','IMPD').
member_of('41130: rn:R00833','34092: rno00640','IMPD').
member_of('40297: rn:R07218','29028: rno00120','IMPD').
member_of('41129: rn:R00432','34092: rno00640','IMPD').
member_of('41128: rn:R00405','34092: rno00640','IMPD').
member_of('279: rn:R01896','250: rn00040','IMPD').
member_of('40092: rn:R07016','35350: rno00980','IMPD').
member_of('40296: rn:R04813','29028: rno00120','IMPD').
member_of('41127: rn:R04432','34092: rno00640','IMPD').
member_of('280: rn:R01432','250: rn00040','IMPD').
member_of('40295: rn:R01463','29028: rno00120','IMPD').
member_of('40294: rn:R03718','29028: rno00120','IMPD').
member_of('41133: rn:R03157 rn:R03158','34092: rno00640','IMPD').
member_of('40293: rn:R02794','29028: rno00120','IMPD').
member_of('283: rn:R01903','250: rn00040','IMPD').
member_of('41132: rn:R00908','34092: rno00640','IMPD').
member_of('40292: rn:R08745','29028: rno00120','IMPD').
member_of('40307: rn:R08728','29028: rno00120','IMPD').
member_of('40103: rn:R07107','35350: rno00980','IMPD').
member_of('6906: rn:R04864','6835: rn00564','IMPD').
member_of('41213: rn:R02613','31292: rno00360','IMPD').
member_of('40306: rn:R08723','29028: rno00120','IMPD').
member_of('6907: rn:R01030','6835: rn00564','IMPD').
member_of('41212: rn:R02613','31292: rno00360','IMPD').
member_of('40305: rn:R04263','29028: rno00120','IMPD').
member_of('287: rn:R01905','250: rn00040','IMPD').
member_of('40101: rn:R07085','35350: rno00980','IMPD').
member_of('41211: rn:R01372','31292: rno00360','IMPD').
member_of('3532: rn:R03286','3491: rn00340','IMPD').
member_of('40304: rn:R08759','29028: rno00120','IMPD').
member_of('41126: rn:R00238','34092: rno00640','IMPD').
member_of('6778: rn:R05378','6695: rn00562','IMPD').
member_of('40303: rn:R08505','29028: rno00120','IMPD').
member_of('41125: rn:R00742','34092: rno00640','IMPD').
member_of('40098: rn:R07075','35350: rno00980','IMPD').
member_of('40302: rn:R08761','29028: rno00120','IMPD').
member_of('41124: rn:R00233','34092: rno00640','IMPD').
member_of('40301: rn:R04811','29028: rno00120','IMPD').
member_of('41123: rn:R01000','34092: rno00640','IMPD').
member_of('41214: rn:R00699','31292: rno00360','IMPD').
member_of('40300: rn:R03719','29028: rno00120','IMPD').
member_of('6905: rn:R01470','6835: rn00564','IMPD').
member_of('40116: rn:R02556','29671: rno00230','IMPD').
member_of('41175: rn:R00694','31565: rno00400','IMPD').
member_of('10281: rn:R00131','10249: rn00791','IMPD').
member_of('40117: rn:R00185','29671: rno00230','IMPD').
member_of('40114: rn:R02748','29671: rno00230','IMPD').
member_of('40115: rn:R02088','29671: rno00230','IMPD').
member_of('39933: rn:R08264','35469: rno00982','IMPD').
member_of('40120: rn:R00183','29671: rno00230','IMPD').
member_of('1552: rn:R08995','1536: rn00140','IMPD').
member_of('39934: rn:R08306','35469: rno00982','IMPD').
member_of('40121: rn:R01083','29671: rno00230','IMPD').
member_of('2503: rn:R01388','2477: rn00260','IMPD').
member_of('41104: rn:R06518','33534: rno00600','IMPD').
member_of('40118: rn:R00190','29671: rno00230','IMPD').
member_of('39932: rn:R08307','35469: rno00982','IMPD').
member_of('40119: rn:R00181','29671: rno00230','IMPD').
member_of('41107: rn:R07896','33469: rno00592','IMPD').
member_of('3501: rn:R03288','3491: rn00340','IMPD').
member_of('40108: rn:R00437','29671: rno00230','IMPD').
member_of('40109: rn:R04209','29671: rno00230','IMPD').
member_of('2516: rn:R00996','2477: rn00260','IMPD').
member_of('5400: rn:R00960','5369: rn00500','IMPD').
member_of('40106: rn:R00089','29671: rno00230','IMPD').
member_of('3502: rn:R02144','3491: rn00340','IMPD').
member_of('40107: rn:R00191','29671: rno00230','IMPD').
member_of('6366: rn:R08905','6322: rn00524','IMPD').
member_of('39681: rn:R03665','30599: rno00290','IMPD').
member_of('40112: rn:R04560','29671: rno00230','IMPD').
member_of('40113: rn:R02297','29671: rno00230','IMPD').
member_of('39682: rn:R01214','30599: rno00290','IMPD').
member_of('39683: rn:R02661','30491: rno00280','IMPD').
member_of('39679: rn:R03657','30599: rno00290','IMPD').
member_of('40110: rn:R04591','29671: rno00230','IMPD').
member_of('41177: rn:R00734','31565: rno00400','IMPD').
member_of('40111: rn:R04559','29671: rno00230','IMPD').
member_of('39678: rn:R01090','30599: rno00290','IMPD').
member_of('39677: rn:R02199','30599: rno00290','IMPD').
member_of('40100: rn:R00086','29671: rno00230','IMPD').
member_of('41154: rn:R00978','31657: rno00410','IMPD').
member_of('40099: rn:R00086','29671: rno00230','IMPD').
member_of('41095: rn:R07861','33469: rno00592','IMPD').
member_of('41153: rn:R02269','31657: rno00410','IMPD').
member_of('41152: rn:R00905','31657: rno00410','IMPD').
member_of('40097: rn:R00124','29671: rno00230','IMPD').
member_of('4451: rn:R01974','4447: rn00380','IMPD').
member_of('41151: rn:R03288','31657: rno00410','IMPD').
member_of('40104: rn:R00435','29671: rno00230','IMPD').
member_of('8367: rn:R09151','8294: rn00625','IMPD').
member_of('41091: rn:R07888','33469: rno00592','IMPD').
member_of('8368: rn:R09152','8294: rn00625','IMPD').
member_of('40102: rn:R00375','29671: rno00230','IMPD').
member_of('5428: rn:R01555','5369: rn00500','IMPD').
member_of('41105: rn:R07892','33469: rno00592','IMPD').
member_of('40091: rn:R00332','29671: rno00230','IMPD').
member_of('40090: rn:R01229','29671: rno00230','IMPD').
member_of('40089: rn:R02719','29671: rno00230','IMPD').
member_of('40096: rn:R02142','29671: rno00230','IMPD').
member_of('40095: rn:R01863','29671: rno00230','IMPD').
member_of('41099: rn:R07859','33469: rno00592','IMPD').
member_of('41158: rn:R00904','31657: rno00410','IMPD').
member_of('40093: rn:R01227','29671: rno00230','IMPD').
member_of('41079: rn:R07064','33430: rno00591','IMPD').
member_of('40081: rn:R01134','29671: rno00230','IMPD').
member_of('41139: rn:R00734','31565: rno00400','IMPD').
member_of('41080: rn:R03626','33430: rno00591','IMPD').
member_of('40082: rn:R00719','29671: rno00230','IMPD').
member_of('2540: rn:R01388 rn:R01392','2477: rn00260','IMPD').
member_of('40083: rn:R01560','29671: rno00230','IMPD').
member_of('2537: rn:R00221','2477: rn00260','IMPD').
member_of('40084: rn:R01126','29671: rno00230','IMPD').
member_of('41135: rn:R00694','31565: rno00400','IMPD').
member_of('40085: rn:R02106','29671: rno00230','IMPD').
member_of('41136: rn:R01795','31565: rno00400','IMPD').
member_of('5378: rn:R03921','5369: rn00500','IMPD').
member_of('40086: rn:R01969','29671: rno00230','IMPD').
member_of('41137: rn:R00729','31565: rno00400','IMPD').
member_of('40087: rn:R01676','29671: rno00230','IMPD').
member_of('41078: rn:R07056','33430: rno00591','IMPD').
member_of('40088: rn:R02422','29671: rno00230','IMPD').
member_of('40064: rn:R07981','29933: rno00232','IMPD').
member_of('3471: rn:R05465','3470: rn00331','IMPD').
member_of('40073: rn:R00328','29671: rno00230','IMPD').
member_of('39879: rn:R08178','35689: rno01040','IMPD').
member_of('40074: rn:R01769','29671: rno00230','IMPD').
member_of('41088: rn:R07055','33430: rno00591','IMPD').
member_of('40066: rn:R07940','29933: rno00232','IMPD').
member_of('40075: rn:R01561','29671: rno00230','IMPD').
member_of('40067: rn:R07945','29933: rno00232','IMPD').
member_of('40076: rn:R01130','29671: rno00230','IMPD').
member_of('40077: rn:R00328','29671: rno00230','IMPD').
member_of('41087: rn:R07046','33310: rno00590','IMPD').
member_of('40078: rn:R01230 rn:R01231','29671: rno00230','IMPD').
member_of('40079: rn:R00722','29671: rno00230','IMPD').
member_of('40080: rn:R00961','29671: rno00230','IMPD').
member_of('41112: rn:R03916','31929: rno00480','IMPD').
member_of('39871: rn:R08179','35689: rno01040','IMPD').
member_of('41111: rn:R04951','31929: rno00480','IMPD').
member_of('3453: rn:R07245','3235: rn00330','IMPD').
member_of('41066: rn:R07042','33310: rno00590','IMPD').
member_of('39870: rn:R01274','35689: rno01040','IMPD').
member_of('41114: rn:R03915 rn:R02824','31929: rno00480','IMPD').
member_of('8337: rn:R06973','8294: rn00625','IMPD').
member_of('39873: rn:R08181','35689: rno01040','IMPD').
member_of('41113: rn:R02736','31929: rno00480','IMPD').
member_of('41068: rn:R07045','33310: rno00590','IMPD').
member_of('39872: rn:R08180','35689: rno01040','IMPD').
member_of('39875: rn:R08183','35689: rno01040','IMPD').
member_of('40061: rn:R07942','29933: rno00232','IMPD').
member_of('41062: rn:R07041','33310: rno00590','IMPD').
member_of('5395: rn:R02889','5369: rn00500','IMPD').
member_of('39874: rn:R08182','35689: rno01040','IMPD').
member_of('41106: rn:R03522','31929: rno00480','IMPD').
member_of('41065: rn:R07048','33310: rno00590','IMPD').
member_of('5392: rn:R00806','5369: rn00500','IMPD').
member_of('40072: rn:R01132','29671: rno00230','IMPD').
member_of('41110: rn:R03167','31929: rno00480','IMPD').
member_of('39878: rn:R08175','35689: rno01040','IMPD').
member_of('39877: rn:R08176','35689: rno01040','IMPD').
member_of('41109: rn:R00274','31929: rno00480','IMPD').
member_of('40063: rn:R07978','29933: rno00232','IMPD').
member_of('41064: rn:R07044','33310: rno00590','IMPD').
member_of('5393: rn:R03526','5369: rn00500','IMPD').
member_of('41108: rn:R03749','31929: rno00480','IMPD').
member_of('39876: rn:R08177','35689: rno01040','IMPD').
member_of('40062: rn:R07943','29933: rno00232','IMPD').
member_of('40057: rn:R06604','29671: rno00230','IMPD').
member_of('41075: rn:R07038','33310: rno00590','IMPD').
member_of('41120: rn:R01262','31929: rno00480','IMPD').
member_of('40056: rn:R01054','29671: rno00230','IMPD').
member_of('41119: rn:R02743','31929: rno00480','IMPD').
member_of('40059: rn:R01057','29671: rno00230','IMPD').
member_of('41134: rn:R00689','31565: rno00400','IMPD').
member_of('41122: rn:R00251','31929: rno00480','IMPD').
member_of('41076: rn:R07053','33310: rno00590','IMPD').
member_of('41121: rn:R00899','31929: rno00480','IMPD').
member_of('41071: rn:R07054','33310: rno00590','IMPD').
member_of('41116: rn:R00494','31929: rno00480','IMPD').
member_of('5386: rn:R02886','5369: rn00500','IMPD').
member_of('41115: rn:R00894','31929: rno00480','IMPD').
member_of('41073: rn:R07043','33310: rno00590','IMPD').
member_of('39869: rn:R08174','35689: rno01040','IMPD').
member_of('41118: rn:R00497','31929: rno00480','IMPD').
member_of('41117: rn:R00267','31929: rno00480','IMPD').
member_of('40200: rn:R04683','29239: rno00140','IMPD').
member_of('40186: rn:R02107','29671: rno00230','IMPD').
member_of('39759: rn:R03871','30491: rno00280','IMPD').
member_of('40187: rn:R02019','29671: rno00230','IMPD').
member_of('40201: rn:R03089','29239: rno00140','IMPD').
member_of('39995: rn:R08246','35619: rno00983','IMPD').
member_of('39760: rn:R01859','30491: rno00280','IMPD').
member_of('5346: rn:R08354','5255: rn00480','IMPD').
member_of('40184: rn:R01072','29671: rno00230','IMPD').
member_of('5350: rn:R03821','5255: rn00480','IMPD').
member_of('40198: rn:R02211','29239: rno00140','IMPD').
member_of('41045: rn:R07051','33310: rno00590','IMPD').
member_of('39757: rn:R05064','30491: rno00280','IMPD').
member_of('40185: rn:R01049','29671: rno00230','IMPD').
member_of('40199: rn:R04681 rn:R04682','29239: rno00140','IMPD').
member_of('6423: rn:R07817','6381: rn00531','IMPD').
member_of('41046: rn:R07050','33310: rno00590','IMPD').
member_of('39993: rn:R08239','35619: rno00983','IMPD').
member_of('39758: rn:R05066','30491: rno00280','IMPD').
member_of('40196: rn:R03329','29239: rno00140','IMPD').
member_of('40182: rn:R04325','29671: rno00230','IMPD').
member_of('5343: rn:R08352','5255: rn00480','IMPD').
member_of('39763: rn:R02197','30491: rno00280','IMPD').
member_of('40183: rn:R04144','29671: rno00230','IMPD').
member_of('40197: rn:R02838','29239: rno00140','IMPD').
member_of('39764: rn:R02199','30491: rno00280','IMPD').
member_of('39988: rn:R08235','35619: rno00983','IMPD').
member_of('40180: rn:R00507','29671: rno00230','IMPD').
member_of('40194: rn:R03326','29239: rno00140','IMPD').
member_of('39761: rn:R00935','30491: rno00280','IMPD').
member_of('40181: rn:R04208','29671: rno00230','IMPD').
member_of('40195: rn:R08945 rn:R08980','29239: rno00140','IMPD').
member_of('39762: rn:R03869','30491: rno00280','IMPD').
member_of('5339: rn:R01917','5255: rn00480','IMPD').
member_of('40178: rn:R00509','29671: rno00230','IMPD').
member_of('40192: rn:R02843','29239: rno00140','IMPD').
member_of('39986: rn:R08243','35619: rno00983','IMPD').
member_of('39751: rn:R04203','30491: rno00280','IMPD').
member_of('39752: rn:R04224','30491: rno00280','IMPD').
member_of('41057: rn:R07041','33310: rno00590','IMPD').
member_of('5338: rn:R01918','5255: rn00480','IMPD').
member_of('40193: rn:R02841','29239: rno00140','IMPD').
member_of('40179: rn:R01234','29671: rno00230','IMPD').
member_of('41101: rn:R00670','31929: rno00480','IMPD').
member_of('40190: rn:R02836 rn:R02834','29239: rno00140','IMPD').
member_of('39984: rn:R08250','35619: rno00983','IMPD').
member_of('39749: rn:R04097','30491: rno00280','IMPD').
member_of('40177: rn:R00529','29671: rno00230','IMPD').
member_of('40191: rn:R02893','29239: rno00140','IMPD').
member_of('39750: rn:R01090','30491: rno00280','IMPD').
member_of('41060: rn:R07046','33310: rno00590','IMPD').
member_of('40174: rn:R02720','29671: rno00230','IMPD').
member_of('40188: rn:R04852','29239: rno00140','IMPD').
member_of('39982: rn:R08248','35619: rno00983','IMPD').
member_of('39755: rn:R04203','30491: rno00280','IMPD').
member_of('41061: rn:R07041','33310: rno00590','IMPD').
member_of('40189: rn:R01836','29239: rno00140','IMPD').
member_of('40175: rn:R00720','29671: rno00230','IMPD').
member_of('39756: rn:R04188','30491: rno00280','IMPD').
member_of('39980: rn:R08237','35619: rno00983','IMPD').
member_of('40172: rn:R02103','29671: rno00230','IMPD').
member_of('41058: rn:R07046','33310: rno00590','IMPD').
member_of('39753: rn:R02661','30491: rno00280','IMPD').
member_of('41102: rn:R01528','31929: rno00480','IMPD').
member_of('40173: rn:R00426','29671: rno00230','IMPD').
member_of('41059: rn:R07035','33310: rno00590','IMPD').
member_of('39754: rn:R03172','30491: rno00280','IMPD').
member_of('41103: rn:R00115','31929: rno00480','IMPD').
member_of('653: rn:R03183','614: rn00053','IMPD').
member_of('40171: rn:R01768','29671: rno00230','IMPD').
member_of('39743: rn:R07618','30491: rno00280','IMPD').
member_of('654: rn:R01481','614: rn00053','IMPD').
member_of('40170: rn:R04463','29671: rno00230','IMPD').
member_of('41031: rn:R01317','33310: rno00590','IMPD').
member_of('39978: rn:R08238','35619: rno00983','IMPD').
member_of('39742: rn:R07600','30491: rno00280','IMPD').
member_of('40169: rn:R00439','29671: rno00230','IMPD').
member_of('3423: rn:R01915','3235: rn00330','IMPD').
member_of('41029: rn:R00073','33310: rno00590','IMPD').
member_of('39976: rn:R08244','35619: rno00983','IMPD').
member_of('39748: rn:R07601','30491: rno00280','IMPD').
member_of('5359: rn:R08361','5255: rn00480','IMPD').
member_of('41081: rn:R02923','31912: rno00472','IMPD').
member_of('657: rn:R03277','614: rn00053','IMPD').
member_of('6442: rn:R07817','6381: rn00531','IMPD').
member_of('40167: rn:R00335','29671: rno00230','IMPD').
member_of('39747: rn:R02662','30491: rno00280','IMPD').
member_of('39974: rn:R08245','35619: rno00983','IMPD').
member_of('39746: rn:R03172','30491: rno00280','IMPD').
member_of('4516: rn:R04172','4447: rn00380','IMPD').
member_of('40165: rn:R00330','29671: rno00230','IMPD').
member_of('39745: rn:R04095','30491: rno00280','IMPD').
member_of('40163: rn:R02090','29671: rno00230','IMPD').
member_of('39735: rn:R01978','30491: rno00280','IMPD').
member_of('41086: rn:R01579','31885: rno00471','IMPD').
member_of('39736: rn:R00410','30491: rno00280','IMPD').
member_of('39734: rn:R02085','30491: rno00280','IMPD').
member_of('41039: rn:R02266','33310: rno00590','IMPD').
member_of('41085: rn:R00256','31885: rno00471','IMPD').
member_of('40161: rn:R06601','29671: rno00230','IMPD').
member_of('39733: rn:R01360','30491: rno00280','IMPD').
member_of('4503: rn:R01974','4447: rn00380','IMPD').
member_of('41038: rn:R02581','33310: rno00590','IMPD').
member_of('3432: rn:R02280','3235: rn00330','IMPD').
member_of('8295: rn:R09158','8294: rn00625','IMPD').
member_of('41083: rn:R00243 rn:R00248','31885: rno00471','IMPD').
member_of('41082: rn:R02457','31912: rno00472','IMPD').
member_of('5358: rn:R08358','5255: rn00480','IMPD').
member_of('39966: rn:R08258','35619: rno00983','IMPD').
member_of('41044: rn:R07052','33310: rno00590','IMPD').
member_of('40158: rn:R03409','29671: rno00230','IMPD').
member_of('39739: rn:R07618','30491: rno00280','IMPD').
member_of('39964: rn:R08260','35619: rno00983','IMPD').
member_of('3428: rn:R03296','3235: rn00330','IMPD').
member_of('39738: rn:R07602','30491: rno00280','IMPD').
member_of('40155: rn:R00441','29671: rno00230','IMPD').
member_of('39724: rn:R04095','30491: rno00280','IMPD').
member_of('2602: rn:R02722','2477: rn00260','IMPD').
member_of('41013: rn:R03059','33310: rno00590','IMPD').
member_of('40152: rn:R00376','29671: rno00230','IMPD').
member_of('39725: rn:R07603','30491: rno00280','IMPD').
member_of('3406: rn:R00671','3235: rn00330','IMPD').
member_of('39726: rn:R04138','30491: rno00280','IMPD').
member_of('39962: rn:R08255','35619: rno00983','IMPD').
member_of('41015: rn:R03867','33310: rno00590','IMPD').
member_of('40154: rn:R00434','29671: rno00230','IMPD').
member_of('2599: rn:R01800','2477: rn00260','IMPD').
member_of('39727: rn:R04137','30491: rno00280','IMPD').
member_of('41016: rn:R03057','33310: rno00590','IMPD').
member_of('39960: rn:R08263','35469: rno00982','IMPD').
member_of('39728: rn:R00927','30491: rno00280','IMPD').
member_of('41067: rn:R09366','31768: rno00450','IMPD').
member_of('40148: rn:R01968','29671: rno00230','IMPD').
member_of('39729: rn:R05066','30491: rno00280','IMPD').
member_of('41018: rn:R03866','33310: rno00590','IMPD').
member_of('41019: rn:R02265','33310: rno00590','IMPD').
member_of('39730: rn:R01214','30491: rno00280','IMPD').
member_of('40150: rn:R01857','29671: rno00230','IMPD').
member_of('3401: rn:R00131','3235: rn00330','IMPD').
member_of('39731: rn:R00238','30491: rno00280','IMPD').
member_of('40143: rn:R03530','29671: rno00230','IMPD').
member_of('39710: rn:R01939','30663: rno00300','IMPD').
member_of('41021: rn:R02268','33310: rno00590','IMPD').
member_of('39716: rn:R07604','30491: rno00280','IMPD').
member_of('41070: rn:R04929','31768: rno00450','IMPD').
member_of('40144: rn:R03531','29671: rno00230','IMPD').
member_of('39957: rn:R08318','35469: rno00982','IMPD').
member_of('39711: rn:R04390','30663: rno00300','IMPD').
member_of('41022: rn:R01590','33310: rno00590','IMPD').
member_of('39717: rn:R07618','30491: rno00280','IMPD').
member_of('662: rn:R02754','614: rn00053','IMPD').
member_of('40145: rn:R00187','29671: rno00230','IMPD').
member_of('39958: rn:R08313','35469: rno00982','IMPD').
member_of('39712: rn:R03098','30663: rno00300','IMPD').
member_of('41023: rn:R02267','33310: rno00590','IMPD').
member_of('41072: rn:R09372','31768: rno00450','IMPD').
member_of('39959: rn:R08285','35469: rno00982','IMPD').
member_of('39713: rn:R00716','30663: rno00300','IMPD').
member_of('40146: rn:R02147','29671: rno00230','IMPD').
member_of('41024: rn:R01596','33310: rno00590','IMPD').
member_of('39952: rn:R08327','35469: rno00982','IMPD').
member_of('40139: rn:R04378','29671: rno00230','IMPD').
member_of('41025: rn:R01593','33310: rno00590','IMPD').
member_of('41074: rn:R09365','31768: rno00450','IMPD').
member_of('41026: rn:R07034','33310: rno00590','IMPD').
member_of('39953: rn:R08312','35469: rno00982','IMPD').
member_of('40140: rn:R00961','29671: rno00230','IMPD').
member_of('41027: rn:R03058','33310: rno00590','IMPD').
member_of('39954: rn:R08313','35469: rno00982','IMPD').
member_of('40141: rn:R02557','29671: rno00230','IMPD').
member_of('9221: rn:R00325','9202: rn00660','IMPD').
member_of('41028: rn:R01595','33310: rno00590','IMPD').
member_of('40142: rn:R01547','29671: rno00230','IMPD').
member_of('39949: rn:R08343','35469: rno00982','IMPD').
member_of('40136: rn:R00430','29671: rno00230','IMPD').
member_of('40997: rn:R07385','33267: rno00565','IMPD').
member_of('40135: rn:R00434','29671: rno00230','IMPD').
member_of('39948: rn:R08344','35469: rno00982','IMPD').
member_of('41047: rn:R03971','31817: rno00460','IMPD').
member_of('7304: rn:R06525','7290: rn00600','IMPD').
member_of('40138: rn:R01229','29671: rno00230','IMPD').
member_of('39951: rn:R08342','35469: rno00982','IMPD').
member_of('40999: rn:R03438','33267: rno00565','IMPD').
member_of('40137: rn:R01858','29671: rno00230','IMPD').
member_of('39950: rn:R08340','35469: rno00982','IMPD').
member_of('39714: rn:R02869','30350: rno00270','IMPD').
member_of('39706: rn:R00014','30599: rno00290','IMPD').
member_of('40131: rn:R01232','29671: rno00230','IMPD').
member_of('39944: rn:R08346','35469: rno00982','IMPD').
member_of('39707: rn:R04863','30663: rno00300','IMPD').
member_of('7303: rn:R06526','7290: rn00600','IMPD').
member_of('41001: rn:R07387','33267: rno00565','IMPD').
member_of('39943: rn:R08349','35469: rno00982','IMPD').
member_of('40130: rn:R01054','29671: rno00230','IMPD').
member_of('40134: rn:R01967','29671: rno00230','IMPD').
member_of('39947: rn:R08343','35469: rno00982','IMPD').
member_of('39945: rn:R08347','35469: rno00982','IMPD').
member_of('41003: rn:R07379','33267: rno00565','IMPD').
member_of('39946: rn:R08345','35469: rno00982','IMPD').
member_of('40133: rn:R00184','29671: rno00230','IMPD').
member_of('39940: rn:R08304','35469: rno00982','IMPD').
member_of('40127: rn:R02805','29671: rno00230','IMPD').
member_of('41053: rn:R03970','31817: rno00460','IMPD').
member_of('40126: rn:R02017','29671: rno00230','IMPD').
member_of('41005: rn:R03437','33267: rno00565','IMPD').
member_of('41009: rn:R04321','33267: rno00565','IMPD').
member_of('39942: rn:R08348','35469: rno00982','IMPD').
member_of('9209: rn:R00932','9202: rn00660','IMPD').
member_of('41007: rn:R06364','33267: rno00565','IMPD').
member_of('40128: rn:R01855','29671: rno00230','IMPD').
member_of('5323: rn:R08361','5255: rn00480','IMPD').
member_of('3398: rn:R01987','3235: rn00330','IMPD').
member_of('41011: rn:R04452','33267: rno00565','IMPD').
member_of('2597: rn:R01566','2477: rn00260','IMPD').
member_of('40123: rn:R00122','29671: rno00230','IMPD').
member_of('39936: rn:R08304','35469: rno00982','IMPD').
member_of('6419: rn:R07815','6381: rn00531','IMPD').
member_of('39700: rn:R03656','30599: rno00290','IMPD').
member_of('40122: rn:R01135','29671: rno00230','IMPD').
member_of('39935: rn:R08310','35469: rno00982','IMPD').
member_of('5318: rn:R08358','5255: rn00480','IMPD').
member_of('682: rn:R01483','614: rn00053','IMPD').
member_of('40125: rn:R01137','29671: rno00230','IMPD').
member_of('39938: rn:R08303','35469: rno00982','IMPD').
member_of('41012: rn:R07389','33267: rno00565','IMPD').
member_of('4473: rn:R01816','4447: rn00380','IMPD').
member_of('39937: rn:R08303','35469: rno00982','IMPD').
member_of('7309: rn:R02542','7290: rn00600','IMPD').
member_of('40124: rn:R00127','29671: rno00230','IMPD').
member_of('39831: rn:R06171','30225: rno00260','IMPD').
member_of('39967: rn:R00965','29971: rno00240','IMPD').
member_of('39830: rn:R00565','30225: rno00260','IMPD').
member_of('40995: rn:R04413','33267: rno00565','IMPD').
member_of('39829: rn:R01290','30225: rno00260','IMPD').
member_of('40994: rn:R07384','33267: rno00565','IMPD').
member_of('39965: rn:R00969','29971: rno00240','IMPD').
member_of('39828: rn:R01001','30225: rno00260','IMPD').
member_of('40993: rn:R07388','33267: rno00565','IMPD').
member_of('3379: rn:R07414','3235: rn00330','IMPD').
member_of('40992: rn:R07380','33267: rno00565','IMPD').
member_of('39971: rn:R01570','29971: rno00240','IMPD').
member_of('39827: rn:R01565','30225: rno00260','IMPD').
member_of('39970: rn:R01415','29971: rno00240','IMPD').
member_of('39826: rn:R00589','30225: rno00260','IMPD').
member_of('39969: rn:R03055','29971: rno00240','IMPD').
member_of('39825: rn:R02565 rn:R02566','30225: rno00260','IMPD').
member_of('41037: rn:R00945','31817: rno00460','IMPD').
member_of('39824: rn:R01025','30225: rno00260','IMPD').
member_of('39820: rn:R03104','30350: rno00270','IMPD').
member_of('39968: rn:R00662','29971: rno00240','IMPD').
member_of('9323: rn:R01196','9317: rn00680','IMPD').
member_of('39839: rn:R00371','30225: rno00260','IMPD').
member_of('39812: rn:R02082','35023: rno00900','IMPD').
member_of('39975: rn:R00378','29971: rno00240','IMPD').
member_of('1681: rn:R02208','1536: rn00140','IMPD').
member_of('39838: rn:R01465','30225: rno00260','IMPD').
member_of('39837: rn:R00366','30225: rno00260','IMPD').
member_of('39973: rn:R04666','29971: rno00240','IMPD').
member_of('9327: rn:R01388','9317: rn00680','IMPD').
member_of('39836: rn:R01883','30225: rno00260','IMPD').
member_of('39676: rn:R00533','35185: rno00920','IMPD').
member_of('39972: rn:R01868','29971: rno00240','IMPD').
member_of('39809: rn:R01123','35023: rno00900','IMPD').
member_of('39979: rn:R02095','29971: rno00240','IMPD').
member_of('39835: rn:R01513','30225: rno00260','IMPD').
member_of('39816: rn:R02245','35023: rno00900','IMPD').
member_of('39834: rn:R00585','30225: rno00260','IMPD').
member_of('40982: rn:R04162','33267: rno00565','IMPD').
member_of('39833: rn:R00588','30225: rno00260','IMPD').
member_of('39814: rn:R00238','35023: rno00900','IMPD').
member_of('39977: rn:R02093','29971: rno00240','IMPD').
member_of('40981: rn:R04311','33267: rno00565','IMPD').
member_of('39821: rn:R03220','34791: rno00860','IMPD').
member_of('9331: rn:R00473','9317: rn00680','IMPD').
member_of('39813: rn:R01978','35023: rno00900','IMPD').
member_of('39832: rn:R02821','30225: rno00260','IMPD').
member_of('39782: rn:R00508','35185: rno00920','IMPD').
member_of('3359: rn:R08197','3235: rn00330','IMPD').
member_of('39810: rn:R02408','30350: rno00270','IMPD').
member_of('39779: rn:R02350','35185: rno00920','IMPD').
member_of('39807: rn:R00590','30350: rno00270','IMPD').
member_of('39808: rn:R02433','30350: rno00270','IMPD').
member_of('39805: rn:R00648','30350: rno00270','IMPD').
member_of('39955: rn:R07977','29933: rno00232','IMPD').
member_of('39806: rn:R07395','30350: rno00270','IMPD').
member_of('39956: rn:R07939','29933: rno00232','IMPD').
member_of('39803: rn:R04858','30350: rno00270','IMPD').
member_of('39804: rn:R00192','30350: rno00270','IMPD').
member_of('39817: rn:R02619','30350: rno00270','IMPD').
member_of('39818: rn:R00896','30350: rno00270','IMPD').
member_of('39819: rn:R03105','30350: rno00270','IMPD').
member_of('39823: rn:R01514','30225: rno00260','IMPD').
member_of('39822: rn:R01072','30134: rno00250','IMPD').
member_of('39815: rn:R00782','30350: rno00270','IMPD').
member_of('40967: rn:R07110','33310: rno00590','IMPD').
member_of('39800: rn:R03683','34791: rno00860','IMPD').
member_of('3353: rn:R01566','3235: rn00330','IMPD').
member_of('2618: rn:R00179','2612: rn00270','IMPD').
member_of('40965: rn:R07108','33310: rno00590','IMPD').
member_of('2613: rn:R04861','2612: rn00270','IMPD').
member_of('39963: rn:R02100','29971: rno00240','IMPD').
member_of('40966: rn:R07111','33310: rno00590','IMPD').
member_of('39811: rn:R00893','30350: rno00270','IMPD').
member_of('39961: rn:R07979','29933: rno00232','IMPD').
member_of('40964: rn:R07109','33310: rno00590','IMPD').
member_of('39792: rn:R07392','30350: rno00270','IMPD').
member_of('40950: rn:R06153','33605: rno00601','IMPD').
member_of('3345: rn:R00471','3235: rn00330','IMPD').
member_of('39791: rn:R07363','30350: rno00270','IMPD').
member_of('41010: rn:R01682','31725: rno00430','IMPD').
member_of('39931: rn:R01397','29971: rno00240','IMPD').
member_of('39794: rn:R01402','30350: rno00270','IMPD').
member_of('3343: rn:R00471','3235: rn00330','IMPD').
member_of('40951: rn:R06153','33605: rno00601','IMPD').
member_of('39793: rn:R04420','30350: rno00270','IMPD').
member_of('3344: rn:R00471','3235: rn00330','IMPD').
member_of('39771: rn:R00132','35100: rno00910','IMPD').
member_of('1712: rn:R04309','1536: rn00140','IMPD').
member_of('41006: rn:R00893','31725: rno00430','IMPD').
member_of('40940: rn:R05967','33768: rno00603','IMPD').
member_of('39790: rn:R07364','30350: rno00270','IMPD').
member_of('39783: rn:R05220','34791: rno00860','IMPD').
member_of('39773: rn:R00253','35100: rno00910','IMPD').
member_of('39789: rn:R07396','30350: rno00270','IMPD').
member_of('1710: rn:R04309 rn:R04310','1536: rn00140','IMPD').
member_of('39772: rn:R01221','35100: rno00910','IMPD').
member_of('41008: rn:R01682','31725: rno00430','IMPD').
member_of('4310: rn:R00228','4169: rn00362','IMPD').
member_of('1715: rn:R02476 rn:R02477','1536: rn00140','IMPD').
member_of('39774: rn:R01001','35100: rno00910','IMPD').
member_of('39784: rn:R07268','34791: rno00860','IMPD').
member_of('41002: rn:R02466','31725: rno00430','IMPD').
member_of('39939: rn:R00575','29971: rno00240','IMPD').
member_of('39799: rn:R01290','30350: rno00270','IMPD').
member_of('39802: rn:R02821','30350: rno00270','IMPD').
member_of('41004: rn:R02467','31725: rno00430','IMPD').
member_of('39941: rn:R02018','29971: rno00240','IMPD').
member_of('39801: rn:R00177','30350: rno00270','IMPD').
member_of('40998: rn:R01687','31725: rno00430','IMPD').
member_of('39796: rn:R00178','30350: rno00270','IMPD').
member_of('39776: rn:R00509','35185: rno00920','IMPD').
member_of('39788: rn:R07412','34791: rno00860','IMPD').
member_of('40931: rn:R05961','33768: rno00603','IMPD').
member_of('39795: rn:R01920','30350: rno00270','IMPD').
member_of('39775: rn:R01242','35185: rno00920','IMPD').
member_of('39798: rn:R00946','30350: rno00270','IMPD').
member_of('41000: rn:R02466','31725: rno00430','IMPD').
member_of('39778: rn:R00629','35185: rno00920','IMPD').
member_of('39797: rn:R01001','30350: rno00270','IMPD').
member_of('39777: rn:R02180','35185: rno00920','IMPD').
member_of('39770: rn:R03174','30491: rno00280','IMPD').
member_of('3330: rn:R01246 rn:R01249','3235: rn00330','IMPD').
member_of('39914: rn:R00905','29971: rno00240','IMPD').
member_of('40927: rn:R05904','33768: rno00603','IMPD').
member_of('10371: rn:R03684','10366: rn00860','IMPD').
member_of('3329: rn:R01255','3235: rn00330','IMPD').
member_of('40928: rn:R05968','33768: rno00603','IMPD').
member_of('39915: rn:R00978','29971: rno00240','IMPD').
member_of('39916: rn:R00963','29971: rno00240','IMPD').
member_of('39917: rn:R01876','29971: rno00240','IMPD').
member_of('40996: rn:R03720','31725: rno00430','IMPD').
member_of('39918: rn:R00964 rn:R00967 rn:R00968 rn:R00970 rn:R01549 rn:R01880 rn:R02097 rn:R02327 rn:R02332','29971: rno00240','IMPD').
member_of('39765: rn:R02765','30491: rno00280','IMPD').
member_of('39919: rn:R00966','29971: rno00240','IMPD').
member_of('40924: rn:R05963','33768: rno00603','IMPD').
member_of('39766: rn:R00833','30491: rno00280','IMPD').
member_of('39920: rn:R00155','29971: rno00240','IMPD').
member_of('39768: rn:R04204','30491: rno00280','IMPD').
member_of('39767: rn:R02661','30491: rno00280','IMPD').
member_of('9275: rn:R00934','9202: rn00660','IMPD').
member_of('39921: rn:R00155','29971: rno00240','IMPD').
member_of('39769: rn:R07599','30491: rno00280','IMPD').
member_of('39922: rn:R00159','29971: rno00240','IMPD').
member_of('40984: rn:R03595','31768: rno00450','IMPD').
member_of('39923: rn:R00571 rn:R00573','29971: rno00240','IMPD').
member_of('39786: rn:R00891','30225: rno00260','IMPD').
member_of('1700: rn:R01841','1536: rn00140','IMPD').
member_of('39924: rn:R00158','29971: rno00240','IMPD').
member_of('39787: rn:R00372','30225: rno00260','IMPD').
member_of('40920: rn:R05960','33768: rno00603','IMPD').
member_of('39925: rn:R00157','29971: rno00240','IMPD').
member_of('39780: rn:R03172','30491: rno00280','IMPD').
member_of('39926: rn:R00156','29971: rno00240','IMPD').
member_of('39781: rn:R02661','30491: rno00280','IMPD').
member_of('4290: rn:R00750','4169: rn00362','IMPD').
member_of('40915: rn:R05964','33768: rno00603','IMPD').
member_of('39927: rn:R00443','29971: rno00240','IMPD').
member_of('39928: rn:R00438','29971: rno00240','IMPD').
member_of('41100: rn:R00286','28072: rno00040','IMPD').
member_of('40980: rn:R04773','31768: rno00450','IMPD').
member_of('39929: rn:R01870','29971: rno00240','IMPD').
member_of('39930: rn:R01993','29971: rno00240','IMPD').
member_of('39785: rn:R00588','30225: rno00260','IMPD').
member_of('40983: rn:R03596','31768: rno00450','IMPD').
member_of('40918: rn:R05966','33768: rno00603','IMPD').
member_of('41094: rn:R01431','28072: rno00040','IMPD').
member_of('40047: rn:R00200','29671: rno00230','IMPD').
member_of('39896: rn:R00258','30134: rno00250','IMPD').
member_of('41093: rn:R01758 rn:R01759','28072: rno00040','IMPD').
member_of('40046: rn:R01138','29671: rno00230','IMPD').
member_of('39895: rn:R00369','30134: rno00250','IMPD').
member_of('41092: rn:R01904','28072: rno00040','IMPD').
member_of('40045: rn:R00086','29671: rno00230','IMPD').
member_of('39894: rn:R01086','30134: rno00250','IMPD').
member_of('39732: rn:R00149','35100: rno00910','IMPD').
member_of('39893: rn:R01083','30134: rno00250','IMPD').
member_of('41090: rn:R01529','28072: rno00040','IMPD').
member_of('39905: rn:R00513 rn:R00516 rn:R00517 rn:R00962 rn:R01548 rn:R02091 rn:R02096 rn:R02371 rn:R02372','29971: rno00240','IMPD').
member_of('41098: rn:R01383','28072: rno00040','IMPD').
member_of('39900: rn:R00578','30134: rno00250','IMPD').
member_of('39740: rn:R00243 rn:R00248','35100: rno00910','IMPD').
member_of('39904: rn:R01878','29971: rno00240','IMPD').
member_of('41097: rn:R02640','28072: rno00040','IMPD').
member_of('39899: rn:R00348','30134: rno00250','IMPD').
member_of('9384: rn:R01440','9317: rn00680','IMPD').
member_of('41096: rn:R00289','28072: rno00040','IMPD').
member_of('2709: rn:R07634','2612: rn00270','IMPD').
member_of('39898: rn:R00488','30134: rno00250','IMPD').
member_of('10357: rn:R02126','10296: rn00830','IMPD').
member_of('2710: rn:R02409','2612: rn00270','IMPD').
member_of('39897: rn:R01397','30134: rno00250','IMPD').
member_of('39737: rn:R00578','35100: rno00910','IMPD').
member_of('39744: rn:R01168','35100: rno00910','IMPD').
member_of('39909: rn:R00569','29971: rno00240','IMPD').
member_of('2694: rn:R00901','2612: rn00270','IMPD').
member_of('40953: rn:R05989','32173: rno00510','IMPD').
member_of('40054: rn:R01127','29671: rno00230','IMPD').
member_of('41084: rn:R01478','28072: rno00040','IMPD').
member_of('39903: rn:R00359','30134: rno00250','IMPD').
member_of('39908: rn:R00512','29971: rno00240','IMPD').
member_of('40952: rn:R05988','32173: rno00510','IMPD').
member_of('39902: rn:R00355','30134: rno00250','IMPD').
member_of('39907: rn:R00514','29971: rno00240','IMPD').
member_of('1620: rn:R03263','1536: rn00140','IMPD').
member_of('39741: rn:R00256','35100: rno00910','IMPD').
member_of('39901: rn:R00357','30134: rno00250','IMPD').
member_of('2697: rn:R08699','2612: rn00270','IMPD').
member_of('39906: rn:R00511','29971: rno00240','IMPD').
member_of('40963: rn:R08224','31768: rno00450','IMPD').
member_of('41089: rn:R01639','28072: rno00040','IMPD').
member_of('39913: rn:R02269','29971: rno00240','IMPD').
member_of('40956: rn:R05990','32173: rno00510','IMPD').
member_of('39912: rn:R00440','29971: rno00240','IMPD').
member_of('40955: rn:R05986','32173: rno00510','IMPD').
member_of('40968: rn:R09373','31768: rno00450','IMPD').
member_of('39911: rn:R00442','29971: rno00240','IMPD').
member_of('2700: rn:R07274','2612: rn00270','IMPD').
member_of('40954: rn:R05992','32173: rno00510','IMPD').
member_of('40048: rn:R00185','29671: rno00230','IMPD').
member_of('39910: rn:R00570','29971: rno00240','IMPD').
member_of('40020: rn:R02016','29971: rno00240','IMPD').
member_of('40898: rn:R05974','33605: rno00601','IMPD').
member_of('39720: rn:R03245','35023: rno00900','IMPD').
member_of('39864: rn:R00310','34791: rno00860','IMPD').
member_of('40897: rn:R06076','33605: rno00601','IMPD').
member_of('40899: rn:R06190','33605: rno00601','IMPD').
member_of('39721: rn:R02003','35023: rno00900','IMPD').
member_of('39865: rn:R00078','34791: rno00860','IMPD').
member_of('41077: rn:R02736 rn:R02035','27988: rno00030','IMPD').
member_of('39718: rn:R01658','35023: rno00900','IMPD').
member_of('2689: rn:R04860','2612: rn00270','IMPD').
member_of('39862: rn:R03197','34791: rno00860','IMPD').
member_of('39719: rn:R01121','35023: rno00900','IMPD').
member_of('39863: rn:R03222','34791: rno00860','IMPD').
member_of('40896: rn:R06189','33605: rno00601','IMPD').
member_of('40948: rn:R05991','32173: rno00510','IMPD').
member_of('40902: rn:R06221','33605: rno00601','IMPD').
member_of('39882: rn:R00256','30134: rno00250','IMPD').
member_of('39860: rn:R04972','34791: rno00860','IMPD').
member_of('2690: rn:R00900','2612: rn00270','IMPD').
member_of('40962: rn:R03599','31768: rno00450','IMPD').
member_of('40949: rn:R01004','32173: rno00510','IMPD').
member_of('39883: rn:R00253','30134: rno00250','IMPD').
member_of('40017: rn:R02016','29971: rno00240','IMPD').
member_of('39861: rn:R03165','34791: rno00860','IMPD').
member_of('520: rn:R01069','514: rn00052','IMPD').
member_of('40959: rn:R04770','31768: rno00450','IMPD').
member_of('39858: rn:R00036','34791: rno00860','IMPD').
member_of('39722: rn:R09249','35023: rno00900','IMPD').
member_of('40900: rn:R06038','33605: rno00601','IMPD').
member_of('39880: rn:R00261','30134: rno00250','IMPD').
member_of('39859: rn:R00084','34791: rno00860','IMPD').
member_of('39723: rn:R05556','35023: rno00900','IMPD').
member_of('40901: rn:R06191','33605: rno00601','IMPD').
member_of('39881: rn:R01648','30134: rno00250','IMPD').
member_of('40889: rn:R06039','33605: rno00601','IMPD').
member_of('39886: rn:R00768','30134: rno00250','IMPD').
member_of('524: rn:R03635','514: rn00052','IMPD').
member_of('40890: rn:R06026','33605: rno00601','IMPD').
member_of('39887: rn:R00707 rn:R00708','30134: rno00250','IMPD').
member_of('40887: rn:R06037','33605: rno00601','IMPD').
member_of('40933: rn:R05969','32173: rno00510','IMPD').
member_of('39884: rn:R00149','30134: rno00250','IMPD').
member_of('40888: rn:R06222','33605: rno00601','IMPD').
member_of('41069: rn:R01519','27988: rno00030','IMPD').
member_of('39885: rn:R00575','30134: rno00250','IMPD').
member_of('39868: rn:R02391 rn:R02393','34791: rno00860','IMPD').
member_of('39891: rn:R01954','30134: rno00250','IMPD').
member_of('39890: rn:R00243 rn:R00248','30134: rno00250','IMPD').
member_of('40024: rn:R02016','29971: rno00240','IMPD').
member_of('7206: rn:R07063','7177: rn00591','IMPD').
member_of('3286: rn:R04443','3235: rn00330','IMPD').
member_of('40894: rn:R06032','33605: rno00601','IMPD').
member_of('39892: rn:R01135','30134: rno00250','IMPD').
member_of('528: rn:R02410','514: rn00052','IMPD').
member_of('39866: rn:R07411','34791: rno00860','IMPD').
member_of('39888: rn:R00269','30134: rno00250','IMPD').
member_of('40022: rn:R02024','29971: rno00240','IMPD').
member_of('40892: rn:R06025','33605: rno00601','IMPD').
member_of('39867: rn:R02480','34791: rno00860','IMPD').
member_of('39889: rn:R00713','30134: rno00250','IMPD').
member_of('39696: rn:R03665','35230: rno00970','IMPD').
member_of('39847: rn:R04979','34791: rno00860','IMPD').
member_of('40926: rn:R01018','32173: rno00510','IMPD').
member_of('40879: rn:R06193','33605: rno00601','IMPD').
member_of('39695: rn:R03038','35230: rno00970','IMPD').
member_of('40001: rn:R02326','29971: rno00240','IMPD').
member_of('40925: rn:R05973','32173: rno00510','IMPD').
member_of('39698: rn:R03658','35230: rno00970','IMPD').
member_of('41063: rn:R01057','27988: rno00030','IMPD').
member_of('40881: rn:R06041','33605: rno00601','IMPD').
member_of('39697: rn:R03657','35230: rno00970','IMPD').
member_of('10317: rn:R02369','10296: rn00830','IMPD').
member_of('40003: rn:R01665','29971: rno00240','IMPD').
member_of('7173: rn:R02264','7032: rn00590','IMPD').
member_of('13211: rn:R08219','13122: rn00970','IMPD').
member_of('40884: rn:R06227','33605: rno00601','IMPD').
member_of('13208: rn:R08223','13122: rn00970','IMPD').
member_of('40930: rn:R01009','32173: rno00510','IMPD').
member_of('39997: rn:R02016','29971: rno00240','IMPD').
member_of('39699: rn:R03663','35230: rno00970','IMPD').
member_of('40883: rn:R06224','33605: rno00601','IMPD').
member_of('39702: rn:R03940','35230: rno00970','IMPD').
member_of('5429: rn:R02112','5369: rn00500','IMPD').
member_of('40886: rn:R06230','33605: rno00601','IMPD').
member_of('39701: rn:R03664','35230: rno00970','IMPD').
member_of('39999: rn:R02101','29971: rno00240','IMPD').
member_of('5444: rn:R00952','5369: rn00500','IMPD').
member_of('39704: rn:R03661','35230: rno00970','IMPD').
member_of('1653: rn:R03406 rn:R03407','1536: rn00140','IMPD').
member_of('40872: rn:R05978','33605: rno00601','IMPD').
member_of('5445: rn:R02886','5369: rn00500','IMPD').
member_of('40009: rn:R01666','29971: rno00240','IMPD').
member_of('39703: rn:R02918','35230: rno00970','IMPD').
member_of('41052: rn:R02740','27988: rno00030','IMPD').
member_of('40917: rn:R05979','32173: rno00510','IMPD').
member_of('40871: rn:R06029','33605: rno00601','IMPD').
member_of('40012: rn:R01663','29971: rno00240','IMPD').
member_of('40874: rn:R06031','33605: rno00601','IMPD').
member_of('41055: rn:R04780','27988: rno00030','IMPD').
member_of('39857: rn:R00830','34791: rno00860','IMPD').
member_of('40011: rn:R02100','29971: rno00240','IMPD').
member_of('39856: rn:R05578','34791: rno00860','IMPD').
member_of('41054: rn:R04779','27988: rno00030','IMPD').
member_of('40919: rn:R05972','32173: rno00510','IMPD').
member_of('39705: rn:R05578','35230: rno00970','IMPD').
member_of('39709: rn:R08218','35230: rno00970','IMPD').
member_of('39715: rn:R02061','35023: rno00900','IMPD').
member_of('1649: rn:R03403','1536: rn00140','IMPD').
member_of('40876: rn:R06187','33605: rno00601','IMPD').
member_of('40005: rn:R00377','29971: rno00240','IMPD').
member_of('39708: rn:R08224','35230: rno00970','IMPD').
member_of('39850: rn:R02389','34791: rno00860','IMPD').
member_of('41056: rn:R01827','27988: rno00030','IMPD').
member_of('40921: rn:R05970','32173: rno00510','IMPD').
member_of('40875: rn:R06035','33605: rno00601','IMPD').
member_of('40878: rn:R06197','33605: rno00601','IMPD').
member_of('40923: rn:R01005','32173: rno00510','IMPD').
member_of('40007: rn:R01664','29971: rno00240','IMPD').
member_of('40877: rn:R05977','33605: rno00601','IMPD').
member_of('39840: rn:R00220','30225: rno00260','IMPD').
member_of('39680: rn:R00529','35185: rno00920','IMPD').
member_of('39985: rn:R01569','29971: rno00240','IMPD').
member_of('39841: rn:R04173','30225: rno00260','IMPD').
member_of('40910: rn:R05984','32173: rno00510','IMPD').
member_of('40863: rn:R06024','33605: rno00601','IMPD').
member_of('39842: rn:R00610','30225: rno00260','IMPD').
member_of('39987: rn:R01567','29971: rno00240','IMPD').
member_of('550: rn:R02411','514: rn00052','IMPD').
member_of('40912: rn:R06128','32173: rno00510','IMPD').
member_of('39843: rn:R00611','30225: rno00260','IMPD').
member_of('40865: rn:R06095','33605: rno00601','IMPD').
member_of('9336: rn:R08572','9317: rn00680','IMPD').
member_of('40867: rn:R05971','33605: rno00601','IMPD').
member_of('5449: rn:R00306','5369: rn00500','IMPD').
member_of('39844: rn:R00582','30225: rno00260','IMPD').
member_of('41048: rn:R01830','27988: rno00030','IMPD').
member_of('556: rn:R01192','514: rn00052','IMPD').
member_of('39845: rn:R00945','30225: rno00260','IMPD').
member_of('41049: rn:R01070','27988: rno00030','IMPD').
member_of('40914: rn:R05976','32173: rno00510','IMPD').
member_of('39684: rn:R03656','35230: rno00970','IMPD').
member_of('39981: rn:R02094','29971: rno00240','IMPD').
member_of('40869: rn:R06033','33605: rno00601','IMPD').
member_of('41050: rn:R01056','27988: rno00030','IMPD').
member_of('39846: rn:R00751','30225: rno00260','IMPD').
member_of('39685: rn:R03655','35230: rno00970','IMPD').
member_of('40870: rn:R05975','33605: rno00601','IMPD').
member_of('41051: rn:R01529','27988: rno00030','IMPD').
member_of('9332: rn:R00134','9317: rn00680','IMPD').
member_of('39983: rn:R02092','29971: rno00240','IMPD').
member_of('39686: rn:R03648','35230: rno00970','IMPD').
member_of('41035: rn:R01051','27988: rno00030','IMPD').
member_of('39687: rn:R03646','35230: rno00970','IMPD').
member_of('5462: rn:R01557','5369: rn00500','IMPD').
member_of('40854: rn:R06006','33605: rno00601','IMPD').
member_of('39848: rn:R03815','30225: rno00260','IMPD').
member_of('39688: rn:R03660','35230: rno00970','IMPD').
member_of('40855: rn:R06006','33605: rno00601','IMPD').
member_of('2713: rn:R01113','2612: rn00270','IMPD').
member_of('39994: rn:R02484','29971: rno00240','IMPD').
member_of('39849: rn:R04125','30225: rno00260','IMPD').
member_of('39689: rn:R03650','35230: rno00970','IMPD').
member_of('2712: rn:R00892','2612: rn00270','IMPD').
member_of('40856: rn:R06006','33605: rno00601','IMPD').
member_of('39690: rn:R03652','35230: rno00970','IMPD').
member_of('40857: rn:R06156','33605: rno00601','IMPD').
member_of('39996: rn:R02484','29971: rno00240','IMPD').
member_of('39851: rn:R02529','30225: rno00260','IMPD').
member_of('6540: rn:R05075','6500: rn00540','IMPD').
member_of('40904: rn:R05982','32173: rno00510','IMPD').
member_of('39691: rn:R05577','35230: rno00970','IMPD').
member_of('39989: rn:R02331','29971: rno00240','IMPD').
member_of('39852: rn:R02529','30225: rno00260','IMPD').
member_of('39854: rn:R03425','30225: rno00260','IMPD').
member_of('6539: rn:R05146','6500: rn00540','IMPD').
member_of('41040: rn:R02739','27988: rno00030','IMPD').
member_of('41041: rn:R02035','27988: rno00030','IMPD').
member_of('40906: rn:R05987','32173: rno00510','IMPD').
member_of('39692: rn:R03654','35230: rno00970','IMPD').
member_of('39990: rn:R02098','29971: rno00240','IMPD').
member_of('39853: rn:R00830','30225: rno00260','IMPD').
member_of('39855: rn:R00367','30225: rno00260','IMPD').
member_of('9341: rn:R00519','9317: rn00680','IMPD').
member_of('40860: rn:R06167','33605: rno00601','IMPD').
member_of('39991: rn:R02099','29971: rno00240','IMPD').
member_of('41042: rn:R02736','27988: rno00030','IMPD').
member_of('39693: rn:R03659','35230: rno00970','IMPD').
member_of('5455: rn:R00803','5369: rn00500','IMPD').
member_of('9340: rn:R00945','9317: rn00680','IMPD').
member_of('40861: rn:R06027','33605: rno00601','IMPD').
member_of('39694: rn:R03662','35230: rno00970','IMPD').
member_of('41043: rn:R01528','27988: rno00030','IMPD').
member_of('40908: rn:R05985','32173: rno00510','IMPD').
member_of('39992: rn:R02485','29971: rno00240','IMPD').
member_of('40757: rn:R03361','32993: rno00562','IMPD').
member_of('40756: rn:R03362','32993: rno00562','IMPD').
member_of('40922: rn:R01788','27827: rno00010','IMPD').
member_of('40754: rn:R03469','32993: rno00562','IMPD').
member_of('40752: rn:R03479','32993: rno00562','IMPD').
member_of('6090: rn:R08639','6057: rn00521','IMPD').
member_of('40783: rn:R01660','32030: rno00500','IMPD').
member_of('40781: rn:R00286','32030: rno00500','IMPD').
member_of('40749: rn:R03427','32993: rno00562','IMPD').
member_of('40916: rn:R01602','27827: rno00010','IMPD').
member_of('40748: rn:R03394','32993: rno00562','IMPD').
member_of('40746: rn:R04372','32993: rno00562','IMPD').
member_of('40777: rn:R00289','32030: rno00500','IMPD').
member_of('40913: rn:R01786','27827: rno00010','IMPD').
member_of('40911: rn:R01786','27827: rno00010','IMPD').
member_of('40745: rn:R03393','32993: rno00562','IMPD').
member_of('40776: rn:R01478','32030: rno00500','IMPD').
member_of('5125: rn:R01267','5104: rn00460','IMPD').
member_of('40775: rn:R01383','32030: rno00500','IMPD').
member_of('40909: rn:R01600','27827: rno00010','IMPD').
member_of('40761: rn:R00289','32397: rno00520','IMPD').
member_of('40773: rn:R02887','32030: rno00500','IMPD').
member_of('40939: rn:R00200','27827: rno00010','IMPD').
member_of('40807: rn:R00899','31929: rno00480','IMPD').
member_of('5120: rn:R00486','5104: rn00460','IMPD').
member_of('40937: rn:R01518','27827: rno00010','IMPD').
member_of('40938: rn:R00658','27827: rno00010','IMPD').
member_of('40935: rn:R02569','27827: rno00010','IMPD').
member_of('40804: rn:R04951','31929: rno00480','IMPD').
member_of('40936: rn:R03270','27827: rno00010','IMPD').
member_of('40934: rn:R00703','27827: rno00010','IMPD').
member_of('40764: rn:R01186','32993: rno00562','IMPD').
member_of('40799: rn:R02869','31929: rno00480','IMPD').
member_of('40932: rn:R01512','27827: rno00010','IMPD').
member_of('40800: rn:R01920','31929: rno00480','IMPD').
member_of('40762: rn:R07324','32993: rno00562','IMPD').
member_of('40929: rn:R07618','27827: rno00010','IMPD').
member_of('40797: rn:R08363','31929: rno00480','IMPD').
member_of('40798: rn:R08359','31929: rno00480','IMPD').
member_of('40760: rn:R01184','32993: rno00562','IMPD').
member_of('9416: rn:R00230','9317: rn00680','IMPD').
member_of('40758: rn:R01187','32993: rno00562','IMPD').
member_of('40789: rn:R00287','32030: rno00500','IMPD').
member_of('40819: rn:R02109','32030: rno00500','IMPD').
member_of('40770: rn:R03354','33534: rno00600','IMPD').
member_of('3228: rn:R04870','3188: rn00311','IMPD').
member_of('40957: rn:R00235','27827: rno00010','IMPD').
member_of('40821: rn:R02740','32030: rno00500','IMPD').
member_of('40815: rn:R01718','32030: rno00500','IMPD').
member_of('40817: rn:R01791','32030: rno00500','IMPD').
member_of('40816: rn:R01791','32030: rno00500','IMPD').
member_of('40947: rn:R00431 rn:R00726','27827: rno00010','IMPD').
member_of('5163: rn:R06614','5104: rn00460','IMPD').
member_of('40946: rn:R04780','27827: rno00010','IMPD').
member_of('40942: rn:R01015','27827: rno00010','IMPD').
member_of('40941: rn:R04779','27827: rno00010','IMPD').
member_of('40812: rn:R08364','31929: rno00480','IMPD').
member_of('40945: rn:R02740','27827: rno00010','IMPD').
member_of('40943: rn:R01061','27827: rno00010','IMPD').
member_of('40944: rn:R00959','27827: rno00010','IMPD').
member_of('40786: rn:R01498','33534: rno00600','IMPD').
member_of('40836: rn:R01786','32030: rno00500','IMPD').
member_of('40787: rn:R01497','33534: rno00600','IMPD').
member_of('40969: rn:R00709','27923: rno00020','IMPD').
member_of('40788: rn:R01494','33534: rno00600','IMPD').
member_of('40838: rn:R01786','32030: rno00500','IMPD').
member_of('40970: rn:R00268','27923: rno00020','IMPD').
member_of('40831: rn:R00959','32030: rno00500','IMPD').
member_of('40782: rn:R06516','33534: rno00600','IMPD').
member_of('40833: rn:R01788','32030: rno00500','IMPD').
member_of('40784: rn:R02464','33534: rno00600','IMPD').
member_of('40785: rn:R03355','33534: rno00600','IMPD').
member_of('3236: rn:R03249','3235: rn00330','IMPD').
member_of('40778: rn:R04856','33534: rno00600','IMPD').
member_of('40779: rn:R01926','33534: rno00600','IMPD').
member_of('40828: rn:R00292','32030: rno00500','IMPD').
member_of('40780: rn:R02976','33534: rno00600','IMPD').
member_of('40774: rn:R03617','33534: rno00600','IMPD').
member_of('40958: rn:R09085','27827: rno00010','IMPD').
member_of('3246: rn:R03314','3235: rn00330','IMPD').
member_of('40824: rn:R02110','32030: rno00500','IMPD').
member_of('40960: rn:R01516','27827: rno00010','IMPD').
member_of('40825: rn:R00010','32030: rno00500','IMPD').
member_of('40961: rn:R01662','27827: rno00010','IMPD').
member_of('40850: rn:R00028','32030: rno00500','IMPD').
member_of('40802: rn:R06521','33534: rno00600','IMPD').
member_of('40801: rn:R06520','33534: rno00600','IMPD').
member_of('40848: rn:R01790','32030: rno00500','IMPD').
member_of('40987: rn:R00342','27923: rno00020','IMPD').
member_of('40806: rn:R02541','33534: rno00600','IMPD').
member_of('5072: rn:R07229','5050: rn00450','IMPD').
member_of('40986: rn:R00351','27923: rno00020','IMPD').
member_of('40805: rn:R06522','33534: rno00600','IMPD').
member_of('40985: rn:R00344','27923: rno00020','IMPD').
member_of('40803: rn:R01495','33534: rno00600','IMPD').
member_of('40974: rn:R03316','27923: rno00020','IMPD').
member_of('40793: rn:R01500','33534: rno00600','IMPD').
member_of('40973: rn:R02570','27923: rno00020','IMPD').
member_of('40792: rn:R04018','33534: rno00600','IMPD').
member_of('40972: rn:R01899','27923: rno00020','IMPD').
member_of('40791: rn:R04017','33534: rno00600','IMPD').
member_of('3137: rn:R03284','3071: rn00310','IMPD').
member_of('40971: rn:R00352','27923: rno00020','IMPD').
member_of('40790: rn:R04019','33534: rno00600','IMPD').
member_of('40846: rn:R02108','32030: rno00500','IMPD').
member_of('40978: rn:R07618','27923: rno00020','IMPD').
member_of('40977: rn:R00621','27923: rno00020','IMPD').
member_of('40796: rn:R01281','33534: rno00600','IMPD').
member_of('40844: rn:R05196','32030: rno00500','IMPD').
member_of('40976: rn:R00405','27923: rno00020','IMPD').
member_of('40795: rn:R02978','33534: rno00600','IMPD').
member_of('40979: rn:R09086','27827: rno00010','IMPD').
member_of('40975: rn:R00432 rn:R00727','27923: rno00020','IMPD').
member_of('40794: rn:R05105','33534: rno00600','IMPD').
member_of('40843: rn:R02111','32030: rno00500','IMPD').
member_of('12917: rn:R02317','12769: rn00960','IMPD').
member_of('40862: rn:R06258','32173: rno00510','IMPD').
member_of('40859: rn:R01009','32173: rno00510','IMPD').
member_of('40866: rn:R06260','32173: rno00510','IMPD').
member_of('40820: rn:R06095','33605: rno00601','IMPD').
member_of('755: rn:R03370','728: rn00061','IMPD').
member_of('40818: rn:R06075','33605: rno00601','IMPD').
member_of('40864: rn:R06259','32173: rno00510','IMPD').
member_of('40990: rn:R02164','27923: rno00020','IMPD').
member_of('40809: rn:R06518','33534: rno00600','IMPD').
member_of('40991: rn:R01082','27923: rno00020','IMPD').
member_of('40810: rn:R06528','33534: rno00600','IMPD').
member_of('40988: rn:R01900','27923: rno00020','IMPD').
member_of('40989: rn:R01325','27923: rno00020','IMPD').
member_of('40808: rn:R06519','33534: rno00600','IMPD').
member_of('40813: rn:R06520','33534: rno00600','IMPD').
member_of('1838: rn:R01244','1774: rn00230','IMPD').
member_of('40814: rn:R06522','33534: rno00600','IMPD').
member_of('40858: rn:R05970','32173: rno00510','IMPD').
member_of('40811: rn:R06521','33534: rno00600','IMPD').
member_of('12906: rn:R00446','12769: rn00960','IMPD').
member_of('40830: rn:R06033','33605: rno00601','IMPD').
member_of('41014: rn:R03270','27923: rno00020','IMPD').
member_of('40829: rn:R06033','33605: rno00601','IMPD').
member_of('4261: rn:R00829','4169: rn00362','IMPD').
member_of('40832: rn:R06039','33605: rno00601','IMPD').
member_of('5101: rn:R09371','5050: rn00450','IMPD').
member_of('40835: rn:R05977','33605: rno00601','IMPD').
member_of('9512: rn:R09094','9317: rn00680','IMPD').
member_of('40834: rn:R05975','33605: rno00601','IMPD').
member_of('41017: rn:R07618','27923: rno00020','IMPD').
member_of('40837: rn:R05977','33605: rno00601','IMPD').
member_of('41020: rn:R02569','27923: rno00020','IMPD').
member_of('40868: rn:R06262','32173: rno00510','IMPD').
member_of('40822: rn:R06076','33605: rno00601','IMPD').
member_of('5094: rn:R08219','5050: rn00450','IMPD').
member_of('40823: rn:R06038','33605: rno00601','IMPD').
member_of('40826: rn:R06025','33605: rno00601','IMPD').
member_of('5097: rn:R04931','5050: rn00450','IMPD').
member_of('40827: rn:R05977','33605: rno00601','IMPD').
member_of('40873: rn:R01009','32173: rno00510','IMPD').
member_of('41030: rn:R00014','27923: rno00020','IMPD').
member_of('40849: rn:R08969','33534: rno00600','IMPD').
member_of('40847: rn:R06230','33605: rno00601','IMPD').
member_of('40851: rn:R06170','33605: rno00601','IMPD').
member_of('41032: rn:R02750','27988: rno00030','IMPD').
member_of('40852: rn:R06169','33605: rno00601','IMPD').
member_of('41033: rn:R01049','27988: rno00030','IMPD').
member_of('1797: rn:R01053','1774: rn00230','IMPD').
member_of('40853: rn:R06168','33605: rno00601','IMPD').
member_of('41036: rn:R00431 rn:R00726','27923: rno00020','IMPD').
member_of('41034: rn:R01641','27988: rno00030','IMPD').
member_of('40839: rn:R06227','33605: rno00601','IMPD').
member_of('5079: rn:R08223','5050: rn00450','IMPD').
member_of('1811: rn:R02014','1774: rn00230','IMPD').
member_of('40840: rn:R06221','33605: rno00601','IMPD').
member_of('40841: rn:R06224','33605: rno00601','IMPD').
member_of('40842: rn:R06222','33605: rno00601','IMPD').
member_of('4266: rn:R00829','4169: rn00362','IMPD').
member_of('40845: rn:R05974','33605: rno00601','IMPD').
member_of('40638: rn:R05907','32319: rno00512','IMPD').
member_of('40639: rn:R05907','32319: rno00512','IMPD').
member_of('1890: rn:R00125','1774: rn00230','IMPD').
member_of('40636: rn:R05907','32319: rno00512','IMPD').
member_of('40637: rn:R05907','32319: rno00512','IMPD').
member_of('40617: rn:R05930','32829: rno00534','IMPD').
member_of('40755: rn:R04386','28488: rno00061','IMPD').
member_of('40616: rn:R05936','32829: rno00534','IMPD').
member_of('40646: rn:R05907','32319: rno00512','IMPD').
member_of('1880: rn:R02020','1774: rn00230','IMPD').
member_of('40644: rn:R05907','32319: rno00512','IMPD').
member_of('40645: rn:R05907','32319: rno00512','IMPD').
member_of('40642: rn:R05915','32319: rno00512','IMPD').
member_of('1884: rn:R00429','1774: rn00230','IMPD').
member_of('11734: rn:R00493','11675: rn00910','IMPD').
member_of('40765: rn:R04385','28488: rno00061','IMPD').
member_of('40643: rn:R05910','32319: rno00512','IMPD').
member_of('40640: rn:R05914','32319: rno00512','IMPD').
member_of('40763: rn:R01624','28488: rno00061','IMPD').
member_of('40641: rn:R05907','32319: rno00512','IMPD').
member_of('40653: rn:R01117','32397: rno00520','IMPD').
member_of('40652: rn:R01201','32397: rno00520','IMPD').
member_of('40649: rn:R00416','32397: rno00520','IMPD').
member_of('40650: rn:R08193','32397: rno00520','IMPD').
member_of('40647: rn:R00414','32397: rno00520','IMPD').
member_of('40661: rn:R00955','32397: rno00520','IMPD').
member_of('40660: rn:R00291','32397: rno00520','IMPD').
member_of('40659: rn:R00286','32397: rno00520','IMPD').
member_of('12849: rn:R00462','12769: rn00960','IMPD').
member_of('40657: rn:R02705','32397: rno00520','IMPD').
member_of('40656: rn:R04435','32397: rno00520','IMPD').
member_of('40654: rn:R01805','32397: rno00520','IMPD').
member_of('5289: rn:R01918','5255: rn00480','IMPD').
member_of('5288: rn:R01917','5255: rn00480','IMPD').
member_of('40663: rn:R02059','32397: rno00520','IMPD').
member_of('5286: rn:R04950','5255: rn00480','IMPD').
member_of('40665: rn:R01384','32397: rno00520','IMPD').
member_of('10650: rn:R05636','10635: rn00900','IMPD').
member_of('40686: rn:R01804','32397: rno00520','IMPD').
member_of('1872: rn:R00336','1774: rn00230','IMPD').
member_of('3122: rn:R00462','3071: rn00310','IMPD').
member_of('9574: rn:R00216','9570: rn00710','IMPD').
member_of('9572: rn:R00345','9570: rn00710','IMPD').
member_of('1864: rn:R02425','1774: rn00230','IMPD').
member_of('40692: rn:R01819','32397: rno00520','IMPD').
member_of('40675: rn:R02241','32918: rno00561','IMPD').
member_of('1862: rn:R00776','1774: rn00230','IMPD').
member_of('9584: rn:R00214','9570: rn00710','IMPD').
member_of('40677: rn:R02687','32918: rno00561','IMPD').
member_of('40693: rn:R01818','32397: rno00520','IMPD').
member_of('9585: rn:R01829','9570: rn00710','IMPD').
member_of('40671: rn:R02251','32918: rno00561','IMPD').
member_of('1869: rn:R01618','1774: rn00230','IMPD').
member_of('40670: rn:R02250','32918: rno00561','IMPD').
member_of('1870: rn:R00469','1774: rn00230','IMPD').
member_of('1867: rn:R00131','1774: rn00230','IMPD').
member_of('9581: rn:R00341','9570: rn00710','IMPD').
member_of('40680: rn:R00851','32918: rno00561','IMPD').
member_of('5189: rn:R00279','5178: rn00471','IMPD').
member_of('40681: rn:R01351','32918: rno00561','IMPD').
member_of('5191: rn:R00260','5178: rn00471','IMPD').
member_of('40678: rn:R02239','32918: rno00561','IMPD').
member_of('40696: rn:R00959','32397: rno00520','IMPD').
member_of('40679: rn:R01011','32918: rno00561','IMPD').
member_of('40701: rn:R01786','32397: rno00520','IMPD').
member_of('11809: rn:R00897','11781: rn00920','IMPD').
member_of('40685: rn:R00847','32918: rno00561','IMPD').
member_of('11808: rn:R01930','11781: rn00920','IMPD').
member_of('40683: rn:R02757','32918: rno00561','IMPD').
member_of('40705: rn:R00885','32397: rno00520','IMPD').
member_of('11797: rn:R02021','11781: rn00920','IMPD').
member_of('40706: rn:R01951','32397: rno00520','IMPD').
member_of('40689: rn:R02577','32918: rno00561','IMPD').
member_of('40703: rn:R01092','32397: rno00520','IMPD').
member_of('9598: rn:R00024','9570: rn00710','IMPD').
member_of('40709: rn:R03161','32397: rno00520','IMPD').
member_of('11800: rn:R08553','11781: rn00920','IMPD').
member_of('40710: rn:R02058','32397: rno00520','IMPD').
member_of('40694: rn:R01036 rn:R01041','32918: rno00561','IMPD').
member_of('40691: rn:R01514','32918: rno00561','IMPD').
member_of('1947: rn:R00322','1774: rn00230','IMPD').
member_of('9603: rn:R00345','9570: rn00710','IMPD').
member_of('40698: rn:R01041','32918: rno00561','IMPD').
member_of('40715: rn:R00022','32397: rno00520','IMPD').
member_of('9605: rn:R00216','9570: rn00710','IMPD').
member_of('10582: rn:R03166','10366: rn00860','IMPD').
member_of('40697: rn:R01752','32918: rno00561','IMPD').
member_of('40714: rn:R00888','32397: rno00520','IMPD').
member_of('40713: rn:R05692','32397: rno00520','IMPD').
member_of('40712: rn:R04215','32397: rno00520','IMPD').
member_of('40719: rn:R01115','32397: rno00520','IMPD').
member_of('40718: rn:R00100','32397: rno00520','IMPD').
member_of('40717: rn:R01207','32397: rno00520','IMPD').
member_of('3027: rn:R00457','2992: rn00300','IMPD').
member_of('40699: rn:R01350','32918: rno00561','IMPD').
member_of('40716: rn:R01811','32397: rno00520','IMPD').
member_of('40722: rn:R01786','32397: rno00520','IMPD').
member_of('40721: rn:R00959','32397: rno00520','IMPD').
member_of('40704: rn:R02240','32918: rno00561','IMPD').
member_of('40720: rn:R01803','32397: rno00520','IMPD').
member_of('40726: rn:R01961','32397: rno00520','IMPD').
member_of('40707: rn:R04470','32918: rno00561','IMPD').
member_of('11778: rn:R01339','11675: rn00910','IMPD').
member_of('40729: rn:R01786','32397: rno00520','IMPD').
member_of('5222: rn:R02458','5211: rn00472','IMPD').
member_of('40730: rn:R01786','32397: rno00520','IMPD').
member_of('1923: rn:R01885','1774: rn00230','IMPD').
member_of('40880: rn:R01070','27827: rno00010','IMPD').
member_of('40882: rn:R00710','27827: rno00010','IMPD').
member_of('5224: rn:R00567','5211: rn00472','IMPD').
member_of('11779: rn:R00485','11675: rn00910','IMPD').
member_of('1919: rn:R00087','1774: rn00230','IMPD').
member_of('40885: rn:R00711','27827: rno00010','IMPD').
member_of('11774: rn:R00524','11675: rn00910','IMPD').
member_of('1914: rn:R01856','1774: rn00230','IMPD').
member_of('3035: rn:R00271','2992: rn00300','IMPD').
member_of('40723: rn:R05801','32993: rno00562','IMPD').
member_of('40724: rn:R05800','32993: rno00562','IMPD').
member_of('40743: rn:R03920','32397: rno00520','IMPD').
member_of('40891: rn:R00746','27827: rno00010','IMPD').
member_of('40893: rn:R00754','27827: rno00010','IMPD').
member_of('7456: rn:R06192','7369: rn00601','IMPD').
member_of('7457: rn:R06198','7369: rn00601','IMPD').
member_of('40895: rn:R00014','27827: rno00010','IMPD').
member_of('40727: rn:R04404','32993: rno00562','IMPD').
member_of('7461: rn:R06097','7369: rn00601','IMPD').
member_of('5209: rn:R00279','5178: rn00471','IMPD').
member_of('1937: rn:R00126','1774: rn00230','IMPD').
member_of('40751: rn:R02740','32397: rno00520','IMPD').
member_of('5210: rn:R00579','5178: rn00471','IMPD').
member_of('40731: rn:R05803','32993: rno00562','IMPD').
member_of('40766: rn:R01384','32030: rno00500','IMPD').
member_of('40733: rn:R03429','32993: rno00562','IMPD').
member_of('40753: rn:R01326','32397: rno00520','IMPD').
member_of('40903: rn:R01600','27827: rno00010','IMPD').
member_of('40768: rn:R00802','32030: rno00500','IMPD').
member_of('40737: rn:R03433','32993: rno00562','IMPD').
member_of('40767: rn:R03527','32030: rno00500','IMPD').
member_of('40736: rn:R03428','32993: rno00562','IMPD').
member_of('40905: rn:R02739','27827: rno00010','IMPD').
member_of('5218: rn:R00672','5211: rn00472','IMPD').
member_of('40739: rn:R03430','32993: rno00562','IMPD').
member_of('5219: rn:R00672','5211: rn00472','IMPD').
member_of('40769: rn:R00802','32030: rno00500','IMPD').
member_of('40907: rn:R03321','27827: rno00010','IMPD').
member_of('40741: rn:R04513','32993: rno00562','IMPD').
member_of('40772: rn:R00026','32030: rno00500','IMPD').
member_of('11784: rn:R00897','11781: rn00920','IMPD').
member_of('5217: rn:R00672','5211: rn00472','IMPD').
member_of('40740: rn:R03434','32993: rno00562','IMPD').
member_of('40759: rn:R01206','32397: rno00520','IMPD').
member_of('40771: rn:R03920','32030: rno00500','IMPD').
member_of('40502: rn:R06870','33136: rno00564','IMPD').
member_of('41571: rn:R02493','34418: rno00750','IMPD').
member_of('4867: rn:R01166','4830: rn00410','IMPD').
member_of('40655: rn:R04964','28488: rno00061','IMPD').
member_of('4865: rn:R01164','4830: rn00410','IMPD').
member_of('40648: rn:R04965','28488: rno00061','IMPD').
member_of('9680: rn:R09289','9648: rn00720','IMPD').
member_of('7737: rn:R00205','7659: rn00620','IMPD').
member_of('99: rn:R01197','97: rn00020','IMPD').
member_of('40499: rn:R01802','33136: rno00564','IMPD').
member_of('9679: rn:R00740','9648: rn00720','IMPD').
member_of('12727: rn:R02383','12565: rn00950','IMPD').
member_of('40500: rn:R02053','33136: rno00564','IMPD').
member_of('40651: rn:R04725','28488: rno00061','IMPD').
member_of('40501: rn:R02241','33136: rno00564','IMPD').
member_of('40494: rn:R07376','33136: rno00564','IMPD').
member_of('9673: rn:R00267','9648: rn00720','IMPD').
member_of('4857: rn:R01914','4830: rn00410','IMPD').
member_of('9672: rn:R01197','9648: rn00720','IMPD').
member_of('86: rn:R07159','1: rn00010','IMPD').
member_of('7745: rn:R00230','7659: rn00620','IMPD').
member_of('40489: rn:R01890','33136: rno00564','IMPD').
member_of('7744: rn:R00753','7659: rn00620','IMPD').
member_of('40490: rn:R01321','33136: rno00564','IMPD').
member_of('7743: rn:R00319','7659: rn00620','IMPD').
member_of('40491: rn:R01013','33136: rno00564','IMPD').
member_of('8829: rn:R00934','8701: rn00630','IMPD').
member_of('2957: rn:R04673','2924: rn00290','IMPD').
member_of('40493: rn:R07377','33136: rno00564','IMPD').
member_of('40503: rn:R00299','32616: rno00524','IMPD').
member_of('9666: rn:R09280','9648: rn00720','IMPD').
member_of('40487: rn:R05916','33083: rno00563','IMPD').
member_of('40635: rn:R08159','28488: rno00061','IMPD').
member_of('40488: rn:R01318','33136: rno00564','IMPD').
member_of('40505: rn:R00299','32616: rno00524','IMPD').
member_of('41557: rn:R00174','34418: rno00750','IMPD').
member_of('40484: rn:R05919','33083: rno00563','IMPD').
member_of('41560: rn:R01909','34418: rno00750','IMPD').
member_of('40632: rn:R08163','28488: rno00061','IMPD').
member_of('41559: rn:R00173','34418: rno00750','IMPD').
member_of('40483: rn:R08107','33083: rno00563','IMPD').
member_of('40634: rn:R08615','28395: rno00053','IMPD').
member_of('40631: rn:R02814','28488: rno00061','IMPD').
member_of('40486: rn:R05916','33083: rno00563','IMPD').
member_of('41561: rn:R01911','34418: rno00750','IMPD').
member_of('40485: rn:R05919','33083: rno00563','IMPD').
member_of('40633: rn:R07762','28488: rno00061','IMPD').
member_of('9661: rn:R00345','9648: rn00720','IMPD').
member_of('40628: rn:R04968','28488: rno00061','IMPD').
member_of('40480: rn:R05920','33083: rno00563','IMPD').
member_of('40627: rn:R04726','28488: rno00061','IMPD').
member_of('9659: rn:R01196','9648: rn00720','IMPD').
member_of('40479: rn:R05916','33083: rno00563','IMPD').
member_of('12699: rn:R03341','12565: rn00950','IMPD').
member_of('40630: rn:R04014','28488: rno00061','IMPD').
member_of('41564: rn:R03346','34478: rno00760','IMPD').
member_of('40482: rn:R05917','33083: rno00563','IMPD').
member_of('41563: rn:R03004','34478: rno00760','IMPD').
member_of('40629: rn:R08159','28488: rno00061','IMPD').
member_of('40481: rn:R05922','33083: rno00563','IMPD').
member_of('41566: rn:R03004','34478: rno00760','IMPD').
member_of('41568: rn:R01710','34418: rno00750','IMPD').
member_of('40476: rn:R05918','33083: rno00563','IMPD').
member_of('41565: rn:R03348','34478: rno00760','IMPD').
member_of('40475: rn:R05921','33083: rno00563','IMPD').
member_of('40623: rn:R04960','28488: rno00061','IMPD').
member_of('41570: rn:R02494','34418: rno00750','IMPD').
member_of('40478: rn:R06623','33083: rno00563','IMPD').
member_of('41569: rn:R00277','34418: rno00750','IMPD').
member_of('41567: rn:R00119','34478: rno00760','IMPD').
member_of('40477: rn:R08107','33083: rno00563','IMPD').
member_of('40625: rn:R04963','28488: rno00061','IMPD').
member_of('9715: rn:R09317','9648: rn00720','IMPD').
member_of('11595: rn:R04038','11521: rn00908','IMPD').
member_of('40537: rn:R02056','33136: rno00564','IMPD').
member_of('40687: rn:R04970','28488: rno00061','IMPD').
member_of('40688: rn:R04544','28488: rno00061','IMPD').
member_of('40553: rn:R07811','32674: rno00531','IMPD').
member_of('11597: rn:R08051','11521: rn00908','IMPD').
member_of('40535: rn:R02746','33136: rno00564','IMPD').
member_of('5848: rn:R01204','5815: rn00520','IMPD').
member_of('11596: rn:R08052','11521: rn00908','IMPD').
member_of('3953: rn:R01377','3838: rn00360','IMPD').
member_of('11591: rn:R08076','11521: rn00908','IMPD').
member_of('40549: rn:R07811','32674: rno00531','IMPD').
member_of('40684: rn:R01706','28488: rno00061','IMPD').
member_of('5849: rn:R01200','5815: rn00520','IMPD').
member_of('40532: rn:R02051','33136: rno00564','IMPD').
member_of('40682: rn:R01706','28488: rno00061','IMPD').
member_of('11603: rn:R02118','11521: rn00908','IMPD').
member_of('40529: rn:R02240','33136: rno00564','IMPD').
member_of('11602: rn:R02119','11521: rn00908','IMPD').
member_of('9705: rn:R00237','9648: rn00720','IMPD').
member_of('3943: rn:R06790','3838: rn00360','IMPD').
member_of('40676: rn:R04957','28488: rno00061','IMPD').
member_of('40527: rn:R02239','33136: rno00564','IMPD').
member_of('40674: rn:R04952','28488: rno00061','IMPD').
member_of('40525: rn:R01310','33136: rno00564','IMPD').
member_of('40672: rn:R04957','28488: rno00061','IMPD').
member_of('9703: rn:R00230','9648: rn00720','IMPD').
member_of('40673: rn:R04536','28488: rno00061','IMPD').
member_of('11600: rn:R03726','11521: rn00908','IMPD').
member_of('40523: rn:R01468','33136: rno00564','IMPD').
member_of('9698: rn:R00134','9648: rn00720','IMPD').
member_of('40534: rn:R07814','32674: rno00531','IMPD').
member_of('9699: rn:R00943','9648: rn00720','IMPD').
member_of('40519: rn:R01315','33136: rno00564','IMPD').
member_of('40669: rn:R04537','28488: rno00061','IMPD').
member_of('40668: rn:R04960','28488: rno00061','IMPD').
member_of('7780: rn:R00750','7778: rn00621','IMPD').
member_of('40517: rn:R01021','33136: rno00564','IMPD').
member_of('40667: rn:R04959','28488: rno00061','IMPD').
member_of('83: rn:R07159','1: rn00010','IMPD').
member_of('40666: rn:R04534','28488: rno00061','IMPD').
member_of('84: rn:R01058','1: rn00010','IMPD').
member_of('40515: rn:R01026','33136: rno00564','IMPD').
member_of('85: rn:R01196','1: rn00010','IMPD').
member_of('4911: rn:R05320','4909: rn00430','IMPD').
member_of('40664: rn:R04535','28488: rno00061','IMPD').
member_of('40513: rn:R01023','33136: rno00564','IMPD').
member_of('5869: rn:R02087','5815: rn00520','IMPD').
member_of('40662: rn:R04963','28488: rno00061','IMPD').
member_of('4907: rn:R09076','4830: rn00410','IMPD').
member_of('40511: rn:R02038','33136: rno00564','IMPD').
member_of('4908: rn:R09077','4830: rn00410','IMPD').
member_of('40509: rn:R02114','33136: rno00564','IMPD').
member_of('40508: rn:R00842','33136: rno00564','IMPD').
member_of('40658: rn:R04962','28488: rno00061','IMPD').
member_of('40507: rn:R00851','33136: rno00564','IMPD').
member_of('9688: rn:R00473','9648: rn00720','IMPD').
member_of('40506: rn:R00848','33136: rno00564','IMPD').
member_of('40579: rn:R07814','32674: rno00531','IMPD').
member_of('40581: rn:R07811','32674: rno00531','IMPD').
member_of('40582: rn:R07816','32674: rno00531','IMPD').
member_of('8770: rn:R01388','8701: rn00630','IMPD').
member_of('11691: rn:R00490','11675: rn00910','IMPD').
member_of('40583: rn:R07822','32674: rno00531','IMPD').
member_of('9750: rn:R00740','9648: rn00720','IMPD').
member_of('40584: rn:R07812','32674: rno00531','IMPD').
member_of('9749: rn:R01196','9648: rn00720','IMPD').
member_of('40601: rn:R06127','32173: rno00510','IMPD').
member_of('40585: rn:R07818','32674: rno00531','IMPD').
member_of('8767: rn:R03140','8701: rn00630','IMPD').
member_of('10693: rn:R08375','10635: rn00900','IMPD').
member_of('40602: rn:R06261','32173: rno00510','IMPD').
member_of('40586: rn:R07807','32674: rno00531','IMPD').
member_of('41516: rn:R00137','34478: rno00760','IMPD').
member_of('40570: rn:R07810','32674: rno00531','IMPD').
member_of('40557: rn:R06871','33136: rno00564','IMPD').
member_of('155: rn:R01196','97: rn00020','IMPD').
member_of('11694: rn:R00482','11675: rn00910','IMPD').
member_of('40571: rn:R07825','32674: rno00531','IMPD').
member_of('40556: rn:R00855','33136: rno00564','IMPD').
member_of('41518: rn:R02323','34478: rno00760','IMPD').
member_of('40572: rn:R07816','32674: rno00531','IMPD').
member_of('11693: rn:R00483','11675: rn00910','IMPD').
member_of('41519: rn:R01271','34478: rno00760','IMPD').
member_of('40708: rn:R04566','28488: rno00061','IMPD').
member_of('40573: rn:R07809','32674: rno00531','IMPD').
member_of('11692: rn:R00490','11675: rn00910','IMPD').
member_of('40575: rn:R07821','32674: rno00531','IMPD').
member_of('41511: rn:R00103','34478: rno00760','IMPD').
member_of('40574: rn:R07824','32674: rno00531','IMPD').
member_of('40576: rn:R07824','32674: rno00531','IMPD').
member_of('40711: rn:R04726','28488: rno00061','IMPD').
member_of('41512: rn:R00103','34478: rno00760','IMPD').
member_of('40577: rn:R07823','32674: rno00531','IMPD').
member_of('40578: rn:R07813','32674: rno00531','IMPD').
member_of('41514: rn:R00137','34478: rno00760','IMPD').
member_of('40548: rn:R03417','33136: rno00564','IMPD').
member_of('41498: rn:R00937 rn:R00940','34278: rno00670','IMPD').
member_of('40563: rn:R07824','32674: rno00531','IMPD').
member_of('40547: rn:R02057','33136: rno00564','IMPD').
member_of('40700: rn:R04967','28488: rno00061','IMPD').
member_of('40565: rn:R07806','32674: rno00531','IMPD').
member_of('40550: rn:R04480','33136: rno00564','IMPD').
member_of('40564: rn:R07812','32674: rno00531','IMPD').
member_of('40552: rn:R02747','33136: rno00564','IMPD').
member_of('40567: rn:R07813','32674: rno00531','IMPD').
member_of('40702: rn:R04568','28488: rno00061','IMPD').
member_of('41494: rn:R02101','34278: rno00670','IMPD').
member_of('40551: rn:R01799','33136: rno00564','IMPD').
member_of('40566: rn:R07822','32674: rno00531','IMPD').
member_of('41493: rn:R04560','34278: rno00670','IMPD').
member_of('40569: rn:R07819','32674: rno00531','IMPD').
member_of('40554: rn:R02055','33136: rno00564','IMPD').
member_of('40568: rn:R07818','32674: rno00531','IMPD').
member_of('41495: rn:R00946','34278: rno00670','IMPD').
member_of('40555: rn:R07821','32674: rno00531','IMPD').
member_of('40690: rn:R04543','28488: rno00061','IMPD').
member_of('40540: rn:R02030 rn:R07390','33136: rno00564','IMPD').
member_of('40539: rn:R01801','33136: rno00564','IMPD').
member_of('168: rn:R02749','162: rn00030','IMPD').
member_of('169: rn:R01066','162: rn00030','IMPD').
member_of('3961: rn:R05487','3838: rn00360','IMPD').
member_of('40559: rn:R07823','32674: rno00531','IMPD').
member_of('40558: rn:R07808','32674: rno00531','IMPD').
member_of('40561: rn:R07807','32674: rno00531','IMPD').
member_of('40546: rn:R03416','33136: rno00564','IMPD').
member_of('165: rn:R05605','162: rn00030','IMPD').
member_of('40695: rn:R04968','28488: rno00061','IMPD').
member_of('41542: rn:R00112','34478: rno00760','IMPD').
member_of('40599: rn:R09036','33136: rno00564','IMPD').
member_of('40609: rn:R05935','32829: rno00534','IMPD').
member_of('40626: rn:R05915','32319: rno00512','IMPD').
member_of('40600: rn:R09035','33136: rno00564','IMPD').
member_of('40750: rn:R04533','28488: rno00061','IMPD').
member_of('41540: rn:R00104','34478: rno00760','IMPD').
member_of('40747: rn:R01626','28488: rno00061','IMPD').
member_of('40624: rn:R05910','32319: rno00512','IMPD').
member_of('41538: rn:R01269','34478: rno00760','IMPD').
member_of('41536: rn:R00102','34478: rno00760','IMPD').
member_of('40591: rn:R09037','33136: rno00564','IMPD').
member_of('2925: rn:R07399','2924: rn00290','IMPD').
member_of('40618: rn:R05909','32319: rno00512','IMPD').
member_of('41554: rn:R05085','34418: rno00750','IMPD').
member_of('40742: rn:R04355','28488: rno00061','IMPD').
member_of('40615: rn:R07628','32319: rno00512','IMPD').
member_of('41551: rn:R00278','34418: rno00750','IMPD').
member_of('40738: rn:R04952','28488: rno00061','IMPD').
member_of('40621: rn:R07628','32319: rno00512','IMPD').
member_of('41548: rn:R01711','34418: rno00750','IMPD').
member_of('12614: rn:R02383','12565: rn00950','IMPD').
member_of('40622: rn:R05914','32319: rno00512','IMPD').
member_of('2928: rn:R00996','2924: rn00290','IMPD').
member_of('40593: rn:R09034','33136: rno00564','IMPD').
member_of('40619: rn:R05907','32319: rno00512','IMPD').
member_of('41544: rn:R08408','34478: rno00760','IMPD').
member_of('40744: rn:R01626','28488: rno00061','IMPD').
member_of('40620: rn:R05911','32319: rno00512','IMPD').
member_of('41545: rn:R04085','34478: rno00760','IMPD').
member_of('40596: rn:R05929','32743: rno00532','IMPD').
member_of('40732: rn:R04956','28488: rno00061','IMPD').
member_of('40595: rn:R05928','32743: rno00532','IMPD').
member_of('4845: rn:R01611','4830: rn00410','IMPD').
member_of('40594: rn:R05925','32743: rno00532','IMPD').
member_of('2050: rn:R00150','1774: rn00230','IMPD').
member_of('41525: rn:R03005','34478: rno00760','IMPD').
member_of('40611: rn:R05983','32173: rno00510','IMPD').
member_of('41524: rn:R03005','34478: rno00760','IMPD').
member_of('5934: rn:R02738','5815: rn00520','IMPD').
member_of('41523: rn:R03347','34478: rno00760','IMPD').
member_of('40614: rn:R05911','32319: rno00512','IMPD').
member_of('41522: rn:R02295','34478: rno00760','IMPD').
member_of('4849: rn:R02473','4830: rn00410','IMPD').
member_of('40613: rn:R05907','32319: rno00512','IMPD').
member_of('40598: rn:R05932','32743: rno00532','IMPD').
member_of('40735: rn:R04428','28488: rno00061','IMPD').
member_of('40612: rn:R05909','32319: rno00512','IMPD').
member_of('40597: rn:R05931','32743: rno00532','IMPD').
member_of('40734: rn:R04430','28488: rno00061','IMPD').
member_of('41520: rn:R02294','34478: rno00760','IMPD').
member_of('40725: rn:R04954','28488: rno00061','IMPD').
member_of('40606: rn:R06264','32173: rno00510','IMPD').
member_of('40589: rn:R07808','32674: rno00531','IMPD').
member_of('40605: rn:R06263','32173: rno00510','IMPD').
member_of('40588: rn:R07809','32674: rno00531','IMPD').
member_of('40604: rn:R05981','32173: rno00510','IMPD').
member_of('40587: rn:R07806','32674: rno00531','IMPD').
member_of('40603: rn:R06238','32173: rno00510','IMPD').
member_of('40592: rn:R05926','32743: rno00532','IMPD').
member_of('4840: rn:R01608','4830: rn00410','IMPD').
member_of('40728: rn:R04953','28488: rno00061','IMPD').
member_of('7859: rn:R00228','7778: rn00621','IMPD').
member_of('41529: rn:R01724','34478: rno00760','IMPD').
member_of('40590: rn:R05927','32743: rno00532','IMPD').
member_of('41528: rn:R00257','34478: rno00760','IMPD').
member_of('40518: rn:R01786','28301: rno00052','IMPD').
member_of('5955: rn:R02335','5815: rn00520','IMPD').
member_of('2837: rn:R08566','2768: rn00280','IMPD').
member_of('41439: rn:R04620','34669: rno00790','IMPD').
member_of('12580: rn:R04305','12565: rn00950','IMPD').
member_of('40520: rn:R01678','28301: rno00052','IMPD').
member_of('41441: rn:R04242','34669: rno00790','IMPD').
member_of('40514: rn:R02926','28301: rno00052','IMPD').
member_of('9799: rn:R02135','9756: rn00730','IMPD').
member_of('41443: rn:R04286','34669: rno00790','IMPD').
member_of('40516: rn:R01786','28301: rno00052','IMPD').
member_of('41445: rn:R00428','34669: rno00790','IMPD').
member_of('9798: rn:R02134','9756: rn00730','IMPD').
member_of('41556: rn:R01954','30830: rno00330','IMPD').
member_of('41430: rn:R02123','34731: rno00830','IMPD').
member_of('41555: rn:R00149','30830: rno00330','IMPD').
member_of('40526: rn:R00289','28301: rno00052','IMPD').
member_of('41558: rn:R00256','30830: rno00330','IMPD').
member_of('13665: rn:R08249','13613: rn00983','IMPD').
member_of('2148: rn:R07307','2143: rn00240','IMPD').
member_of('41434: rn:R09394','34669: rno00790','IMPD').
member_of('40528: rn:R00291','28301: rno00052','IMPD').
member_of('40522: rn:R00503','28301: rno00052','IMPD').
member_of('8707: rn:R01180','8701: rn00630','IMPD').
member_of('41433: rn:R02124','34731: rno00830','IMPD').
member_of('40521: rn:R01678','28301: rno00052','IMPD').
member_of('41562: rn:R00253','30830: rno00330','IMPD').
member_of('8705: rn:R00474','8701: rn00630','IMPD').
member_of('40524: rn:R00959','28301: rno00052','IMPD').
member_of('41437: rn:R09395','34669: rno00790','IMPD').
member_of('1197: rn:R07496','1195: rn00100','IMPD').
member_of('41546: rn:R00135','30830: rno00330','IMPD').
member_of('41547: rn:R00669','30830: rno00330','IMPD').
member_of('8710: rn:R00479','8701: rn00630','IMPD').
member_of('8709: rn:R00470','8701: rn00630','IMPD').
member_of('41549: rn:R00551','30830: rno00330','IMPD').
member_of('2142: rn:R07982','2085: rn00232','IMPD').
member_of('8708: rn:R00477','8701: rn00630','IMPD').
member_of('40504: rn:R01788','28301: rno00052','IMPD').
member_of('41550: rn:R01086','30830: rno00330','IMPD').
member_of('41425: rn:R08387','34731: rno00830','IMPD').
member_of('41552: rn:R00259','30830: rno00330','IMPD').
member_of('41553: rn:R01398','30830: rno00330','IMPD').
member_of('41428: rn:R00032','34731: rno00830','IMPD').
member_of('41539: rn:R01253','30830: rno00330','IMPD').
member_of('40510: rn:R01101','28301: rno00052','IMPD').
member_of('41414: rn:R07163','34731: rno00830','IMPD').
member_of('41416: rn:R08388','34731: rno00830','IMPD').
member_of('41541: rn:R00667','30830: rno00330','IMPD').
member_of('40512: rn:R01194','28301: rno00052','IMPD').
member_of('3785: rn:R03341','3595: rn00350','IMPD').
member_of('2139: rn:R07922','2085: rn00232','IMPD').
member_of('41543: rn:R01252','30830: rno00330','IMPD').
member_of('41419: rn:R03048 rn:R08380','34731: rno00830','IMPD').
member_of('41492: rn:R04125','34278: rno00670','IMPD').
member_of('41491: rn:R00945','34278: rno00670','IMPD').
member_of('41489: rn:R07460','34314: rno00730','IMPD').
member_of('8732: rn:R00519','8701: rn00630','IMPD').
member_of('8733: rn:R03146','8701: rn00630','IMPD').
member_of('2119: rn:R07965 rn:R07966','2085: rn00232','IMPD').
member_of('2120: rn:R07957 rn:R07958','2085: rn00232','IMPD').
member_of('41483: rn:R00619','34314: rno00730','IMPD').
member_of('8739: rn:R01388 rn:R01392','8701: rn00630','IMPD').
member_of('8740: rn:R01392','8701: rn00630','IMPD').
member_of('41467: rn:R00549','34369: rno00740','IMPD').
member_of('2109: rn:R07980','2085: rn00232','IMPD').
member_of('41458: rn:R02235 rn:R02236','34669: rno00790','IMPD').
member_of('40536: rn:R03634','28301: rno00052','IMPD').
member_of('8742: rn:R01745 rn:R01747','8701: rn00630','IMPD').
member_of('41470: rn:R00615','34314: rno00730','IMPD').
member_of('2108: rn:R07961 rn:R07962','2085: rn00232','IMPD').
member_of('8741: rn:R01388','8701: rn00630','IMPD').
member_of('41459: rn:R00942','34669: rno00790','IMPD').
member_of('41465: rn:R00548','34369: rno00740','IMPD').
member_of('41456: rn:R01793 rn:R01794','34669: rno00790','IMPD').
member_of('2111: rn:R07919','2085: rn00232','IMPD').
member_of('8744: rn:R00472','8701: rn00630','IMPD').
member_of('41466: rn:R00161','34369: rno00740','IMPD').
member_of('41457: rn:R00936 rn:R00939','34669: rno00790','IMPD').
member_of('2110: rn:R07955 rn:R07956','2085: rn00232','IMPD').
member_of('8743: rn:R00013','8701: rn00630','IMPD').
member_of('41474: rn:R00616','34314: rno00730','IMPD').
member_of('40533: rn:R03236 rn:R03237 rn:R03238 rn:R03239','28301: rno00052','IMPD').
member_of('2112: rn:R07920','2085: rn00232','IMPD').
member_of('41460: rn:R04285','34669: rno00790','IMPD').
member_of('40530: rn:R00955','28301: rno00052','IMPD').
member_of('2115: rn:R07919','2085: rn00232','IMPD').
member_of('41472: rn:R00618','34314: rno00730','IMPD').
member_of('40531: rn:R01092','28301: rno00052','IMPD').
member_of('40544: rn:R01329','28301: rno00052','IMPD').
member_of('41449: rn:R02237','34669: rno00790','IMPD').
member_of('41451: rn:R00937 rn:R00940','34669: rno00790','IMPD').
member_of('2100: rn:R07969 rn:R07970','2085: rn00232','IMPD').
member_of('40545: rn:R01093 rn:R01095','28301: rno00052','IMPD').
member_of('40542: rn:R00801','28301: rno00052','IMPD').
member_of('41447: rn:R05046','34669: rno00790','IMPD').
member_of('40543: rn:R01104','28301: rno00052','IMPD').
member_of('41462: rn:R01709','34418: rno00750','IMPD').
member_of('41454: rn:R05048','34669: rno00790','IMPD').
member_of('41463: rn:R00160','34369: rno00740','IMPD').
member_of('2839: rn:R08567','2768: rn00280','IMPD').
member_of('41455: rn:R01813','34669: rno00790','IMPD').
member_of('41464: rn:R02363','34369: rno00740','IMPD').
member_of('2838: rn:R07160','2768: rn00280','IMPD').
member_of('40541: rn:R01103','28301: rno00052','IMPD').
member_of('40538: rn:R05549','28301: rno00052','IMPD').
member_of('41453: rn:R04639','34669: rno00790','IMPD').
member_of('41502: rn:R00178','30830: rno00330','IMPD').
member_of('27: rn:R02738','1: rn00010','IMPD').
member_of('41501: rn:R01986 rn:R02549','30830: rno00330','IMPD').
member_of('41504: rn:R00239','30830: rno00330','IMPD').
member_of('41378: rn:R08383','34731: rno00830','IMPD').
member_of('41503: rn:R01920','30830: rno00330','IMPD').
member_of('41377: rn:R08392','34731: rno00830','IMPD').
member_of('4923: rn:R05651','4909: rn00430','IMPD').
member_of('40580: rn:R03184','28395: rno00053','IMPD').
member_of('41500: rn:R01151','30830: rno00330','IMPD').
member_of('4921: rn:R00230','4909: rn00430','IMPD').
member_of('4926: rn:R05652','4909: rn00430','IMPD').
member_of('41497: rn:R03283','30742: rno00310','IMPD').
member_of('41496: rn:R02397','30742: rno00310','IMPD').
member_of('41499: rn:R00716','30742: rno00310','IMPD').
member_of('2761: rn:R04861','2612: rn00270','IMPD').
member_of('7674: rn:R00203','7659: rn00620','IMPD').
member_of('41368: rn:R00905','34563: rno00770','IMPD').
member_of('7672: rn:R01016','7659: rn00620','IMPD').
member_of('9872: rn:R07456','9869: rn00750','IMPD').
member_of('7673: rn:R00203','7659: rn00620','IMPD').
member_of('9873: rn:R07456','9869: rn00750','IMPD').
member_of('4935: rn:R00901','4909: rn00430','IMPD').
member_of('40560: rn:R01184','28395: rno00053','IMPD').
member_of('41487: rn:R01940','30742: rno00310','IMPD').
member_of('7695: rn:R01196','7659: rn00620','IMPD').
member_of('41365: rn:R04391','34563: rno00770','IMPD').
member_of('41488: rn:R01939','30742: rno00310','IMPD').
member_of('7694: rn:R00211','7659: rn00620','IMPD').
member_of('40562: rn:R00286','28395: rno00053','IMPD').
member_of('41366: rn:R04230 rn:R04231','34563: rno00770','IMPD').
member_of('41367: rn:R03018','34563: rno00770','IMPD').
member_of('41490: rn:R01975','30742: rno00310','IMPD').
member_of('2759: rn:R00863','2612: rn00270','IMPD').
member_of('2209: rn:R01668','2143: rn00240','IMPD').
member_of('41360: rn:R03269','34563: rno00770','IMPD').
member_of('40: rn:R00960','1: rn00010','IMPD').
member_of('41484: rn:R03875','30742: rno00310','IMPD').
member_of('41361: rn:R00130','34563: rno00770','IMPD').
member_of('39: rn:R00947','1: rn00010','IMPD').
member_of('41485: rn:R03102 rn:R03103','30742: rno00310','IMPD').
member_of('41362: rn:R02269','34563: rno00770','IMPD').
member_of('4936: rn:R01681','4909: rn00430','IMPD').
member_of('41486: rn:R02313','30742: rno00310','IMPD').
member_of('41363: rn:R00978','34563: rno00770','IMPD').
member_of('41479: rn:R04867','30742: rno00310','IMPD').
member_of('2205: rn:R02325','2143: rn00240','IMPD').
member_of('7687: rn:R01450','7659: rn00620','IMPD').
member_of('41480: rn:R04313','30742: rno00310','IMPD').
member_of('3842: rn:R00750','3838: rn00360','IMPD').
member_of('41357: rn:R01625','34563: rno00770','IMPD').
member_of('41481: rn:R03451','30742: rno00310','IMPD').
member_of('41358: rn:R03036','34563: rno00770','IMPD').
member_of('41482: rn:R03380','30742: rno00310','IMPD').
member_of('2201: rn:R02022','2143: rn00240','IMPD').
member_of('41359: rn:R02971','34563: rno00770','IMPD').
member_of('41475: rn:R02571','30742: rno00310','IMPD').
member_of('3839: rn:R09090','3838: rn00360','IMPD').
member_of('41350: rn:R01074','34623: rno00780','IMPD').
member_of('41352: rn:R01214','34563: rno00770','IMPD').
member_of('7692: rn:R00212','7659: rn00620','IMPD').
member_of('41476: rn:R03376','30742: rno00310','IMPD').
member_of('41353: rn:R02973','34563: rno00770','IMPD').
member_of('41351: rn:R05145','34623: rno00780','IMPD').
member_of('41477: rn:R04866','30742: rno00310','IMPD').
member_of('41478: rn:R03026','30742: rno00310','IMPD').
member_of('41355: rn:R03035','34563: rno00770','IMPD').
member_of('41411: rn:R08381','34731: rno00830','IMPD').
member_of('41537: rn:R01248 rn:R01251','30830: rno00330','IMPD').
member_of('41410: rn:R08389','34731: rno00830','IMPD').
member_of('40463: rn:R07299','32993: rno00562','IMPD').
member_of('41409: rn:R08382 rn:R08383','34731: rno00830','IMPD').
member_of('40610: rn:R00647','28395: rno00053','IMPD').
member_of('41535: rn:R04444 rn:R04445','30830: rno00330','IMPD').
member_of('40461: rn:R03435','32993: rno00562','IMPD').
member_of('41534: rn:R03291 rn:R03293','30830: rno00330','IMPD').
member_of('41407: rn:R08392','34731: rno00830','IMPD').
member_of('41533: rn:R05051','30830: rno00330','IMPD').
member_of('41406: rn:R08392','34731: rno00830','IMPD').
member_of('41532: rn:R05051','30830: rno00330','IMPD').
member_of('41531: rn:R02894','30830: rno00330','IMPD').
member_of('41530: rn:R03295','30830: rno00330','IMPD').
member_of('40465: rn:R05795','32993: rno00562','IMPD').
member_of('40469: rn:R05916','33083: rno00563','IMPD').
member_of('40472: rn:R01015','32993: rno00562','IMPD').
member_of('41403: rn:R08392','34731: rno00830','IMPD').
member_of('7701: rn:R00472','7659: rn00620','IMPD').
member_of('40468: rn:R05916','33083: rno00563','IMPD').
member_of('40471: rn:R00705','32993: rno00562','IMPD').
member_of('4958: rn:R02434','4909: rn00430','IMPD').
member_of('40467: rn:R05916','33083: rno00563','IMPD').
member_of('41401: rn:R02124 rn:R08379','34731: rno00830','IMPD').
member_of('41527: rn:R00558','30830: rno00330','IMPD').
member_of('40466: rn:R05916','33083: rno00563','IMPD').
member_of('41526: rn:R05052','30830: rno00330','IMPD').
member_of('7705: rn:R03145','7659: rn00620','IMPD').
member_of('41399: rn:R02124 rn:R08379','34731: rno00830','IMPD').
member_of('7706: rn:R00207','7659: rn00620','IMPD').
member_of('7707: rn:R00230','7659: rn00620','IMPD').
member_of('40474: rn:R05802','32993: rno00562','IMPD').
member_of('40473: rn:R01802','32993: rno00562','IMPD').
member_of('9: rn:R00755','1: rn00010','IMPD').
member_of('41395: rn:R08390','34731: rno00830','IMPD').
member_of('41521: rn:R01881','30830: rno00330','IMPD').
member_of('41393: rn:R08390','34731: rno00830','IMPD').
member_of('41390: rn:R08390','34731: rno00830','IMPD').
member_of('41517: rn:R00111','30830: rno00330','IMPD').
member_of('41388: rn:R08391','34731: rno00830','IMPD').
member_of('41513: rn:R01883','30830: rno00330','IMPD').
member_of('41515: rn:R00565','30830: rno00330','IMPD').
member_of('3862: rn:R01377','3838: rn00360','IMPD').
member_of('11522: rn:R07260','11521: rn00908','IMPD').
member_of('41386: rn:R08390','34731: rno00830','IMPD').
member_of('7717: rn:R00228','7659: rn00620','IMPD').
member_of('40456: rn:R01185','32993: rno00562','IMPD').
member_of('41509: rn:R00566','30830: rno00330','IMPD').
member_of('41384: rn:R08390','34731: rno00830','IMPD').
member_of('3875: rn:R02540','3838: rn00360','IMPD').
member_of('41510: rn:R01157','30830: rno00330','IMPD').
member_of('40607: rn:R02957','28395: rno00053','IMPD').
member_of('41507: rn:R00670','30830: rno00330','IMPD').
member_of('41381: rn:R02368','34731: rno00830','IMPD').
member_of('41508: rn:R01989','30830: rno00330','IMPD').
member_of('40608: rn:R02933','28395: rno00053','IMPD').
member_of('41382: rn:R08391','34731: rno00830','IMPD').
member_of('40460: rn:R04545','32993: rno00562','IMPD').
member_of('41505: rn:R00245','30830: rno00330','IMPD').
member_of('41379: rn:R02902','34731: rno00830','IMPD').
member_of('41506: rn:R03313','30830: rno00330','IMPD').
member_of('41380: rn:R08385','34731: rno00830','IMPD').
member_of('40458: rn:R05202','32993: rno00562','IMPD').
consumed_by0('36164: cpd:C00222','8337: rn:R06973','IMPD').
consumed_by0('36157: cpd:C00188','39699: rn:R03663','IMPD').
consumed_by0('36094: cpd:C00077','41541: rn:R00667','IMPD').
consumed_by0('37358: cpd:C01203','40631: rn:R02814','IMPD').
consumed_by0('36094: cpd:C00077','41553: rn:R01398','IMPD').
consumed_by0('36096: cpd:C00334','41508: rn:R01989','IMPD').
consumed_by0('36150: cpd:C00213','39843: rn:R00611','IMPD').
consumed_by0('36150: cpd:C00213','39842: rn:R00610','IMPD').
consumed_by0('36110: cpd:C00792','41081: rn:R02923','IMPD').
consumed_by0('36144: cpd:C00100','8935: rn:R01199','IMPD').
consumed_by0('36144: cpd:C00100','8936: rn:R01199','IMPD').
consumed_by0('36063: cpd:C00029','11591: rn:R08076','IMPD').
consumed_by0('36063: cpd:C00029','11603: rn:R02118','IMPD').
consumed_by0('36094: cpd:C00077','41507: rn:R00670','IMPD').
consumed_by0('36129: cpd:C00074','9572: rn:R00345','IMPD').
consumed_by0('37392: cpd:C00021','39804: rn:R00192','IMPD').
consumed_by0('36145: cpd:C02291','39828: rn:R01001','IMPD').
consumed_by0('36063: cpd:C00029','11522: rn:R07260','IMPD').
consumed_by0('37350: cpd:C00909','41016: rn:R03057','IMPD').
consumed_by0('36105: cpd:C00515','41082: rn:R02457','IMPD').
consumed_by0('37350: cpd:C00909','41013: rn:R03059','IMPD').
consumed_by0('36112: gl:G00057','40874: rn:R06031','IMPD').
consumed_by0('36129: cpd:C00074','9661: rn:R00345','IMPD').
consumed_by0('36144: cpd:C00100','9209: rn:R00932','IMPD').
consumed_by0('36141: cpd:C16587','39932: rn:R08307','IMPD').
consumed_by0('37343: cpd:C00381','40926: rn:R01018','IMPD').
consumed_by0('36123: cpd:C00433','40470: rn:R00264','IMPD').
consumed_by0('36145: cpd:C02291','39797: rn:R01001','IMPD').
consumed_by0('37325: cpd:C03765','41400: rn:R02695 rn:R02697','IMPD').
consumed_by0('36203: cpd:C00550','7309: rn:R02542','IMPD').
consumed_by0('36129: cpd:C00074','9603: rn:R00345','IMPD').
consumed_by0('37348: cpd:C00270','40720: rn:R01803','IMPD').
consumed_by0('36144: cpd:C00100','39760: rn:R01859','IMPD').
consumed_by0('37348: cpd:C00270','40716: rn:R01811','IMPD').
consumed_by0('36096: cpd:C00334','41172: rn:R01648','IMPD').
consumed_by0('37331: cpd:C00483','41404: rn:R02382','IMPD').
consumed_by0('37353: cpd:C00128','40719: rn:R01115','IMPD').
consumed_by0('37331: cpd:C00483','41402: rn:R02382','IMPD').
consumed_by0('36144: cpd:C00100','9275: rn:R00934','IMPD').
consumed_by0('37369: gl:G00001','40858: rn:R05970','IMPD').
consumed_by0('36094: cpd:C00077','41101: rn:R00670','IMPD').
consumed_by0('36095: cpd:C00111','9975: rn:R04292','IMPD').
consumed_by0('37366: gl:G00002','40919: rn:R05972','IMPD').
consumed_by0('37376: gl:G00004','40603: rn:R06238','IMPD').
consumed_by0('36092: cpd:C01595','41078: rn:R07056','IMPD').
consumed_by0('36092: cpd:C01595','41080: rn:R03626','IMPD').
consumed_by0('36135: cpd:C00233','39748: rn:R07601','IMPD').
consumed_by0('36092: cpd:C01595','41088: rn:R07055','IMPD').
consumed_by0('36195: cpd:C04475','7020: rn:R04571','IMPD').
consumed_by0('36078: cpd:C01144','41490: rn:R01975','IMPD').
consumed_by0('36120: cpd:C00119','40184: rn:R01072','IMPD').
consumed_by0('36134: cpd:C05167','39744: rn:R01168','IMPD').
consumed_by0('36134: cpd:C05167','39774: rn:R01001','IMPD').
consumed_by0('37383: gl:G00005','40601: rn:R06127','IMPD').
consumed_by0('37368: cpd:C14781','41064: rn:R07044','IMPD').
consumed_by0('36114: cpd:C00164','40356: rn:R00410','IMPD').
consumed_by0('36076: cpd:C00101','41492: rn:R04125','IMPD').
consumed_by0('36076: cpd:C00101','41457: rn:R00936 rn:R00939','IMPD').
consumed_by0('36076: cpd:C00101','41459: rn:R00942','IMPD').
consumed_by0('37369: gl:G00001','40921: rn:R05970','IMPD').
consumed_by0('36016: cpd:C01179','12699: rn:R03341','IMPD').
consumed_by0('36074: cpd:C00877','41478: rn:R03026','IMPD').
consumed_by0('36087: cpd:C05345','41048: rn:R01830','IMPD').
consumed_by0('37355: cpd:C00121','41035: rn:R01051','IMPD').
consumed_by0('36087: cpd:C05345','41054: rn:R04779','IMPD').
consumed_by0('36078: cpd:C01144','41316: rn:R01975','IMPD').
consumed_by0('37367: cpd:C04088','40632: rn:R08163','IMPD').
consumed_by0('37294: cpd:C01693','3598: rn:R03674','IMPD').
consumed_by0('36128: cpd:C00123','39750: rn:R01090','IMPD').
consumed_by0('37354: cpd:C02165','41018: rn:R03866','IMPD').
consumed_by0('36091: cpd:C00086','10281: rn:R00131','IMPD').
consumed_by0('37220: cpd:C00140','5849: rn:R01200','IMPD').
consumed_by0('36128: cpd:C00123','39697: rn:R03657','IMPD').
consumed_by0('36127: cpd:C00341','39721: rn:R02003','IMPD').
consumed_by0('36128: cpd:C00123','39679: rn:R03657','IMPD').
consumed_by0('36128: cpd:C00123','39678: rn:R01090','IMPD').
consumed_by0('36087: cpd:C05345','40941: rn:R04779','IMPD').
consumed_by0('36140: cpd:C00163','8920: rn:R00928','IMPD').
consumed_by0('36140: cpd:C00163','8923: rn:R00920','IMPD').
consumed_by0('36078: cpd:C01144','41174: rn:R01975','IMPD').
consumed_by0('36077: cpd:C00232','41196: rn:R00713','IMPD').
consumed_by0('36074: cpd:C00877','41282: rn:R03026','IMPD').
consumed_by0('36204: cpd:C03372','6896: rn:R02756','IMPD').
consumed_by0('36187: cpd:C15972','39716: rn:R07604','IMPD').
consumed_by0('37352: cpd:C00822','3596: rn:R03672','IMPD').
consumed_by0('36142: cpd:C00167','41098: rn:R01383','IMPD').
consumed_by0('36187: cpd:C15972','39742: rn:R07600','IMPD').
consumed_by0('36187: cpd:C15972','39738: rn:R07602','IMPD').
consumed_by0('36164: cpd:C00222','40471: rn:R00705','IMPD').
consumed_by0('36144: cpd:C00100','41127: rn:R04432','IMPD').
consumed_by0('37379: cpd:C05985','41131: rn:R02940','IMPD').
consumed_by0('36179: cpd:C00129','39809: rn:R01123','IMPD').
consumed_by0('36137: cpd:C00042','41129: rn:R00432','IMPD').
consumed_by0('36137: cpd:C00042','41128: rn:R00405','IMPD').
consumed_by0('37387: gl:G00008','40914: rn:R05976','IMPD').
consumed_by0('37390: gl:G00007','40868: rn:R06262','IMPD').
consumed_by0('37388: gl:G00017','40956: rn:R05990','IMPD').
consumed_by0('36137: cpd:C00042','40990: rn:R02164','IMPD').
consumed_by0('36137: cpd:C00042','40975: rn:R00432 rn:R00727','IMPD').
consumed_by0('36137: cpd:C00042','40976: rn:R00405','IMPD').
consumed_by0('36129: cpd:C00074','41218: rn:R00200 rn:R02320','IMPD').
consumed_by0('36179: cpd:C00129','39721: rn:R02003','IMPD').
consumed_by0('36179: cpd:C00129','39718: rn:R01658','IMPD').
consumed_by0('36179: cpd:C00129','39715: rn:R02061','IMPD').
consumed_by0('36169: cpd:C00227','9416: rn:R00230','IMPD').
consumed_by0('37371: cpd:C14813','41068: rn:R07045','IMPD').
consumed_by0('36147: cpd:C03033','40776: rn:R01478','IMPD').
consumed_by0('36116: cpd:C00062','41509: rn:R00566','IMPD').
consumed_by0('36122: cpd:C00417','41321: rn:R01900','IMPD').
consumed_by0('36164: cpd:C00222','9680: rn:R09289','IMPD').
consumed_by0('36116: cpd:C00062','41515: rn:R00565','IMPD').
consumed_by0('37377: gl:G00003','40925: rn:R05973','IMPD').
consumed_by0('36418: cpd:C00147','1838: rn:R01244','IMPD').
consumed_by0('36116: cpd:C00062','41549: rn:R00551','IMPD').
consumed_by0('37381: gl:G00006','40862: rn:R06258','IMPD').
consumed_by0('36116: cpd:C00062','41527: rn:R00558','IMPD').
consumed_by0('36142: cpd:C00167','40766: rn:R01384','IMPD').
consumed_by0('36142: cpd:C00167','40775: rn:R01383','IMPD').
consumed_by0('36177: cpd:C00235','39718: rn:R01658','IMPD').
consumed_by0('37373: cpd:C05983','41145: rn:R01354','IMPD').
consumed_by0('37373: cpd:C05983','41146: rn:R01354','IMPD').
consumed_by0('36167: cpd:C00418','39816: rn:R02245','IMPD').
consumed_by0('36116: cpd:C00062','41374: rn:R00557','IMPD').
consumed_by0('36132: cpd:C00311','40972: rn:R01899','IMPD').
consumed_by0('36132: cpd:C00311','40969: rn:R00709','IMPD').
consumed_by0('36122: cpd:C00417','41271: rn:R01325','IMPD').
consumed_by0('36139: cpd:C00137','40760: rn:R01184','IMPD').
consumed_by0('36142: cpd:C00167','40665: rn:R01384','IMPD').
consumed_by0('36345: cpd:C00956','3228: rn:R04870','IMPD').
consumed_by0('36142: cpd:C00167','40634: rn:R08615','IMPD').
consumed_by0('36139: cpd:C00137','40560: rn:R01184','IMPD').
consumed_by0('38368: cpd:C05827','41347: rn:R04996','IMPD').
consumed_by0('36164: cpd:C00222','8944: rn:R01611','IMPD').
consumed_by0('36165: cpd:C01107','39720: rn:R03245','IMPD').
consumed_by0('36158: cpd:C16659','39950: rn:R08340','IMPD').
consumed_by0('36129: cpd:C00074','40939: rn:R00200','IMPD').
consumed_by0('36164: cpd:C00222','8965: rn:R00740','IMPD').
consumed_by0('37331: cpd:C00483','3652: rn:R02384','IMPD').
consumed_by0('36291: cpd:C02512','5125: rn:R01267','IMPD').
consumed_by0('36291: cpd:C02512','5120: rn:R00486','IMPD').
consumed_by0('36300: cpd:C01013','4840: rn:R01608','IMPD').
consumed_by0('36114: cpd:C00164','41183: rn:R00410','IMPD').
consumed_by0('36114: cpd:C00164','41182: rn:R01357','IMPD').
consumed_by0('36157: cpd:C00188','39846: rn:R00751','IMPD').
consumed_by0('36161: cpd:C01143','39719: rn:R01121','IMPD').
consumed_by0('36157: cpd:C00188','39838: rn:R01465','IMPD').
consumed_by0('36441: cpd:C00052','556: rn:R01192','IMPD').
consumed_by0('36153: dr:D08195 cpd:C07163','40065: rn:R08339','IMPD').
consumed_by0('37391: gl:G00016','40953: rn:R05989','IMPD').
consumed_by0('36139: cpd:C00137','40473: rn:R01802','IMPD').
consumed_by0('36291: cpd:C02512','5163: rn:R06614','IMPD').
consumed_by0('36122: cpd:C00417','40988: rn:R01900','IMPD').
consumed_by0('37385: cpd:C05984','41123: rn:R01000','IMPD').
consumed_by0('37384: cpd:C06049','41278: rn:R01959','IMPD').
consumed_by0('37395: gl:G00009','40917: rn:R05979','IMPD').
consumed_by0('36111: cpd:C00683','41148: rn:R02765','IMPD').
consumed_by0('36111: cpd:C00683','41143: rn:R02765','IMPD').
consumed_by0('36354: cpd:C00148','3329: rn:R01255','IMPD').
consumed_by0('36354: cpd:C00148','3330: rn:R01246 rn:R01249','IMPD').
consumed_by0('36186: cpd:C00116','40685: rn:R00847','IMPD').
consumed_by0('36173: cpd:C00532','41093: rn:R01758 rn:R01759','IMPD').
consumed_by0('37313: cpd:C03838','40182: rn:R04325','IMPD').
consumed_by0('36174: cpd:C00103','6090: rn:R08639','IMPD').
consumed_by0('36175: cpd:C00668','41052: rn:R02740','IMPD').
consumed_by0('36186: cpd:C00116','40694: rn:R01036 rn:R01041','IMPD').
consumed_by0('36175: cpd:C00668','41040: rn:R02739','IMPD').
consumed_by0('36186: cpd:C00116','40698: rn:R01041','IMPD').
consumed_by0('36162: cpd:C00315','41370: rn:R02869','IMPD').
consumed_by0('36162: cpd:C00315','41364: rn:R02869','IMPD').
consumed_by0('35995: cpd:C00002','11597: rn:R08051','IMPD').
consumed_by0('36183: cpd:C00267','40701: rn:R01786','IMPD').
consumed_by0('36175: cpd:C00668','40945: rn:R02740','IMPD').
consumed_by0('36025: cpd:C00118','10650: rn:R05636','IMPD').
consumed_by0('36183: cpd:C00267','40730: rn:R01786','IMPD').
consumed_by0('36183: cpd:C00267','40729: rn:R01786','IMPD').
consumed_by0('36183: cpd:C00267','40722: rn:R01786','IMPD').
consumed_by0('36183: cpd:C00267','40911: rn:R01786','IMPD').
consumed_by0('37312: cpd:C07480','40063: rn:R07978','IMPD').
consumed_by0('38393: cpd:C04185','41240: rn:R08965','IMPD').
consumed_by0('36218: cpd:C00143','39845: rn:R00945','IMPD').
consumed_by0('36183: cpd:C00267','40916: rn:R01602','IMPD').
consumed_by0('36183: cpd:C00267','40913: rn:R01786','IMPD').
consumed_by0('36183: cpd:C00267','40838: rn:R01786','IMPD').
consumed_by0('37307: cpd:C04376','40170: rn:R04463','IMPD').
consumed_by0('36183: cpd:C00267','40836: rn:R01786','IMPD').
consumed_by0('36183: cpd:C00267','40844: rn:R05196','IMPD').
consumed_by0('36174: cpd:C00103','41096: rn:R00289','IMPD').
consumed_by0('37310: cpd:C04823','40111: rn:R04559','IMPD').
consumed_by0('36169: cpd:C00227','41314: rn:R00317','IMPD').
consumed_by0('36040: cpd:C00099','10110: rn:R02473','IMPD').
consumed_by0('36182: cpd:C05401','40543: rn:R01104','IMPD').
consumed_by0('36174: cpd:C00103','40777: rn:R00289','IMPD').
consumed_by0('36174: cpd:C00103','40783: rn:R01660','IMPD').
consumed_by0('36175: cpd:C00668','40751: rn:R02740','IMPD').
consumed_by0('38551: cpd:C00735','1552: rn:R08995','IMPD').
consumed_by0('36183: cpd:C00267','40516: rn:R01786','IMPD').
consumed_by0('36183: cpd:C00267','40518: rn:R01786','IMPD').
consumed_by0('36174: cpd:C00103','40831: rn:R00959','IMPD').
consumed_by0('36079: cpd:C00058','9341: rn:R00519','IMPD').
consumed_by0('36174: cpd:C00103','40721: rn:R00959','IMPD').
consumed_by0('38390: cpd:C18239','41437: rn:R09395','IMPD').
consumed_by0('36174: cpd:C00103','40761: rn:R00289','IMPD').
consumed_by0('37300: cpd:C04640','40181: rn:R04208','IMPD').
consumed_by0('36175: cpd:C00668','40905: rn:R02739','IMPD').
consumed_by0('36174: cpd:C00103','40944: rn:R00959','IMPD').
consumed_by0('36180: cpd:C04006','40758: rn:R01187','IMPD').
consumed_by0('36175: cpd:C00668','40922: rn:R01788','IMPD').
consumed_by0('36175: cpd:C00668','40821: rn:R02740','IMPD').
consumed_by0('36175: cpd:C00668','40833: rn:R01788','IMPD').
consumed_by0('36155: cpd:C00894','41138: rn:R03045','IMPD').
consumed_by0('37302: cpd:C01801','41032: rn:R02750','IMPD').
consumed_by0('36175: cpd:C00668','40504: rn:R01788','IMPD').
consumed_by0('36174: cpd:C00103','40524: rn:R00959','IMPD').
consumed_by0('36174: cpd:C00103','40526: rn:R00289','IMPD').
consumed_by0('36151: cpd:C00186','41227: rn:R00703','IMPD').
consumed_by0('36184: cpd:C00044','40173: rn:R00426','IMPD').
consumed_by0('36184: cpd:C00044','40167: rn:R00335','IMPD').
consumed_by0('36184: cpd:C00044','40155: rn:R00441','IMPD').
consumed_by0('36184: cpd:C00044','40154: rn:R00434','IMPD').
consumed_by0('36174: cpd:C00103','40696: rn:R00959','IMPD').
consumed_by0('37327: cpd:C01344','40143: rn:R03530','IMPD').
consumed_by0('36170: cpd:C00092','40762: rn:R07324','IMPD').
consumed_by0('36174: cpd:C00103','5400: rn:R00960','IMPD').
consumed_by0('36155: cpd:C00894','41186: rn:R00924','IMPD').
consumed_by0('35988: cpd:C00190','11602: rn:R02119','IMPD').
consumed_by0('36193: cpd:C00047','39698: rn:R03658','IMPD').
consumed_by0('36147: cpd:C03033','41084: rn:R01478','IMPD').
consumed_by0('36190: cpd:C15973','39739: rn:R07618','IMPD').
consumed_by0('36190: cpd:C15973','39743: rn:R07618','IMPD').
consumed_by0('36144: cpd:C00100','41144: rn:R00926','IMPD').
consumed_by0('36190: cpd:C15973','39717: rn:R07618','IMPD').
consumed_by0('36144: cpd:C00100','41142: rn:R01859','IMPD').
consumed_by0('36144: cpd:C00100','41149: rn:R01859','IMPD').
consumed_by0('36079: cpd:C00058','8732: rn:R00519','IMPD').
consumed_by0('36144: cpd:C00100','41147: rn:R00926','IMPD').
consumed_by0('36079: cpd:C00058','8733: rn:R03146','IMPD').
consumed_by0('36151: cpd:C00186','40934: rn:R00703','IMPD').
consumed_by0('36162: cpd:C00315','40799: rn:R02869','IMPD').
consumed_by0('36184: cpd:C00044','40135: rn:R00434','IMPD').
consumed_by0('36184: cpd:C00044','40136: rn:R00430','IMPD').
consumed_by0('36184: cpd:C00044','40131: rn:R01232','IMPD').
consumed_by0('37318: cpd:C04677','40139: rn:R04378','IMPD').
consumed_by0('37324: cpd:C16353','39961: rn:R07979','IMPD').
consumed_by0('36194: cpd:C00155','39802: rn:R02821','IMPD').
consumed_by0('36194: cpd:C00155','39799: rn:R01290','IMPD').
consumed_by0('36194: cpd:C00155','39798: rn:R00946','IMPD').
consumed_by0('36056: cpd:C00258','9336: rn:R08572','IMPD').
consumed_by0('37318: cpd:C04677','40112: rn:R04560','IMPD').
consumed_by0('37340: cpd:C04257','5869: rn:R02087','IMPD').
consumed_by0('37330: cpd:C04501','40649: rn:R00416','IMPD').
consumed_by0('36207: cpd:C03820','41009: rn:R04321','IMPD').
consumed_by0('36095: cpd:C00111','9585: rn:R01829','IMPD').
consumed_by0('36244: cpd:C16586','39934: rn:R08306','IMPD').
consumed_by0('36193: cpd:C00047','41499: rn:R00716','IMPD').
consumed_by0('36208: cpd:C00819','41086: rn:R01579','IMPD').
consumed_by0('37341: cpd:C00942','40179: rn:R01234','IMPD').
consumed_by0('36151: cpd:C00186','7687: rn:R01450','IMPD').
consumed_by0('36186: cpd:C00116','6639: rn:R01048','IMPD').
consumed_by0('36214: cpd:C00091','40973: rn:R02570','IMPD').
consumed_by0('37314: cpd:C01236','41041: rn:R02035','IMPD').
consumed_by0('36186: cpd:C00116','6634: rn:R01039','IMPD').
consumed_by0('36186: cpd:C00116','6633: rn:R01034','IMPD').
consumed_by0('36233: cpd:C00217','5209: rn:R00279','IMPD').
consumed_by0('36151: cpd:C00186','7743: rn:R00319','IMPD').
consumed_by0('36233: cpd:C00217','5189: rn:R00279','IMPD').
consumed_by0('37308: cpd:C00355','41239: rn:R02078','IMPD').
consumed_by0('37294: cpd:C01693','41461: rn:R03673','IMPD').
consumed_by0('36184: cpd:C00044','41434: rn:R09394','IMPD').
consumed_by0('36184: cpd:C00044','41445: rn:R00428','IMPD').
consumed_by0('36197: cpd:C01172','41042: rn:R02736','IMPD').
consumed_by0('36198: cpd:C04598','41011: rn:R04452','IMPD').
consumed_by0('36197: cpd:C01172','41077: rn:R02736 rn:R02035','IMPD').
consumed_by0('36189: cpd:C00670','6887: rn:R01030','IMPD').
consumed_by0('37322: cpd:C00357','40650: rn:R08193','IMPD').
consumed_by0('36189: cpd:C00670','6907: rn:R01030','IMPD').
consumed_by0('36190: cpd:C15973','41313: rn:R07618','IMPD').
consumed_by0('36190: cpd:C15973','41312: rn:R02569','IMPD').
consumed_by0('37322: cpd:C00357','40663: rn:R02059','IMPD').
consumed_by0('37299: cpd:C05578','41383: rn:R04884','IMPD').
consumed_by0('36132: cpd:C00311','8710: rn:R00479','IMPD').
consumed_by0('36209: cpd:C02960','40805: rn:R06522','IMPD').
consumed_by0('36204: cpd:C03372','40981: rn:R04311','IMPD').
consumed_by0('36200: cpd:C00379','41094: rn:R01431','IMPD').
consumed_by0('36200: cpd:C00379','41092: rn:R01904','IMPD').
consumed_by0('36209: cpd:C02960','40814: rn:R06522','IMPD').
consumed_by0('36212: cpd:C00159','40753: rn:R01326','IMPD').
consumed_by0('37339: cpd:C00110','40873: rn:R01009','IMPD').
consumed_by0('37321: cpd:C05587','41442: rn:R04890','IMPD').
consumed_by0('37339: cpd:C00110','40859: rn:R01009','IMPD').
consumed_by0('36190: cpd:C15973','41017: rn:R07618','IMPD').
consumed_by0('36190: cpd:C15973','41020: rn:R02569','IMPD').
consumed_by0('36224: dr:D07704 cpd:C07572','39947: rn:R08343','IMPD').
consumed_by0('36224: dr:D07704 cpd:C07572','39948: rn:R08344','IMPD').
consumed_by0('36224: dr:D07704 cpd:C07572','39949: rn:R08343','IMPD').
consumed_by0('36079: cpd:C00058','9512: rn:R09094','IMPD').
consumed_by0('36224: dr:D07704 cpd:C07572','39944: rn:R08346','IMPD').
consumed_by0('37339: cpd:C00110','40933: rn:R05969','IMPD').
consumed_by0('36076: cpd:C00101','9699: rn:R00943','IMPD').
consumed_by0('37339: cpd:C00110','40923: rn:R01005','IMPD').
consumed_by0('37348: cpd:C00270','40653: rn:R01117','IMPD').
consumed_by0('37339: cpd:C00110','40930: rn:R01009','IMPD').
consumed_by0('36196: cpd:C05977','40982: rn:R04162','IMPD').
consumed_by0('37316: cpd:C03758','41448: rn:R04300','IMPD').
consumed_by0('37316: cpd:C03758','41444: rn:R04301','IMPD').
consumed_by0('36212: cpd:C00159','40454: rn:R01326','IMPD').
consumed_by0('36197: cpd:C01172','40907: rn:R03321','IMPD').
consumed_by0('36187: cpd:C15972','41206: rn:R03270','IMPD').
consumed_by0('37332: cpd:C03021','40914: rn:R05976','IMPD').
consumed_by0('37316: cpd:C03758','41413: rn:R02535','IMPD').
consumed_by0('36224: dr:D07704 cpd:C07572','40060: rn:R08343','IMPD').
consumed_by0('37344: cpd:C06241','40656: rn:R04435','IMPD').
consumed_by0('37344: cpd:C06241','40654: rn:R01805','IMPD').
consumed_by0('36203: cpd:C00550','40806: rn:R02541','IMPD').
consumed_by0('37336: cpd:C03862','40862: rn:R06258','IMPD').
consumed_by0('36183: cpd:C00267','40958: rn:R09085','IMPD').
consumed_by0('38595: cpd:C05138','1649: rn:R03403','IMPD').
consumed_by0('36216: cpd:C16608','39945: rn:R08347','IMPD').
consumed_by0('36216: cpd:C16608','39946: rn:R08345','IMPD').
consumed_by0('37316: cpd:C03758','41375: rn:R04300','IMPD').
consumed_by0('36188: cpd:C00221','40909: rn:R01600','IMPD').
consumed_by0('36188: cpd:C00221','40903: rn:R01600','IMPD').
consumed_by0('36187: cpd:C15972','40936: rn:R03270','IMPD').
consumed_by0('36178: cpd:C05668','41195: rn:R03045','IMPD').
consumed_by0('37308: cpd:C00355','41440: rn:R02080','IMPD').
consumed_by0('36188: cpd:C00221','40979: rn:R09086','IMPD').
consumed_by0('36187: cpd:C15972','40974: rn:R03316','IMPD').
consumed_by0('37326: cpd:C01246','40868: rn:R06262','IMPD').
consumed_by0('36190: cpd:C15973','40978: rn:R07618','IMPD').
consumed_by0('36190: cpd:C15973','40973: rn:R02570','IMPD').
consumed_by0('36190: cpd:C15973','40935: rn:R02569','IMPD').
consumed_by0('36190: cpd:C15973','40929: rn:R07618','IMPD').
consumed_by0('37334: cpd:C00645','40657: rn:R02705','IMPD').
consumed_by0('36187: cpd:C15972','41014: rn:R03270','IMPD').
consumed_by0('37334: cpd:C00645','40686: rn:R01804','IMPD').
consumed_by0('36079: cpd:C00058','9699: rn:R00943','IMPD').
consumed_by0('36141: cpd:C16587','13442: rn:R08309','IMPD').
consumed_by0('37196: cpd:C01060','41387: rn:R03208','IMPD').
consumed_by0('37220: cpd:C00140','40652: rn:R01201','IMPD').
consumed_by0('38233: cpd:C15776','40328: rn:R07484','IMPD').
consumed_by0('36266: cpd:C00008','40123: rn:R00122','IMPD').
consumed_by0('36266: cpd:C00008','40126: rn:R02017','IMPD').
consumed_by0('37216: cpd:C00461','40759: rn:R01206','IMPD').
consumed_by0('36234: cpd:C00800','41097: rn:R02640','IMPD').
consumed_by0('36266: cpd:C00008','40097: rn:R00124','IMPD').
consumed_by0('37235: cpd:C00242','40138: rn:R01229','IMPD').
consumed_by0('36276: cpd:C06002','39762: rn:R03869','IMPD').
consumed_by0('36276: cpd:C06002','39759: rn:R03871','IMPD').
consumed_by0('36276: cpd:C06002','39761: rn:R00935','IMPD').
consumed_by0('36243: cpd:C02934','40795: rn:R02978','IMPD').
consumed_by0('38231: cpd:C11508','40336: rn:R07483','IMPD').
consumed_by0('36274: cpd:C04582','39792: rn:R07392','IMPD').
consumed_by0('37235: cpd:C00242','40087: rn:R01676','IMPD').
consumed_by0('37235: cpd:C00242','40090: rn:R01229','IMPD').
consumed_by0('36267: dr:D04931 cpd:C02380','39998: rn:R08236','IMPD').
consumed_by0('37199: cpd:C02515','41436: rn:R03973','IMPD').
consumed_by0('36267: dr:D04931 cpd:C02380','39988: rn:R08235','IMPD').
consumed_by0('36218: cpd:C00143','41494: rn:R02101','IMPD').
consumed_by0('36267: dr:D04931 cpd:C02380','39980: rn:R08237','IMPD').
consumed_by0('36218: cpd:C00143','41491: rn:R00945','IMPD').
consumed_by0('36240: cpd:C06125','40778: rn:R04856','IMPD').
consumed_by0('37220: cpd:C00140','40717: rn:R01207','IMPD').
consumed_by0('37196: cpd:C01060','41438: rn:R03953','IMPD').
consumed_by0('36231: cpd:C05212','41001: rn:R07387','IMPD').
consumed_by0('37230: gl:G10598','40605: rn:R06263','IMPD').
consumed_by0('37246: cpd:C00330','40086: rn:R01969','IMPD').
consumed_by0('36276: cpd:C06002','8914: rn:R03381','IMPD').
consumed_by0('38223: cpd:C08821','40334: rn:R07488','IMPD').
consumed_by0('36284: cpd:C01213','39766: rn:R00833','IMPD').
consumed_by0('36242: cpd:C00199','41090: rn:R01529','IMPD').
consumed_by0('37228: gl:G10599','40606: rn:R06264','IMPD').
consumed_by0('37241: cpd:C00362','40148: rn:R01968','IMPD').
consumed_by0('36242: cpd:C00199','41051: rn:R01529','IMPD').
consumed_by0('37241: cpd:C00362','40163: rn:R02090','IMPD').
consumed_by0('38222: cpd:C15782','40351: rn:R07486','IMPD').
consumed_by0('37247: cpd:C00286','40128: rn:R01855','IMPD').
consumed_by0('36280: cpd:C04188','39793: rn:R04420','IMPD').
consumed_by0('37247: cpd:C00286','40152: rn:R00376','IMPD').
consumed_by0('37246: cpd:C00330','40134: rn:R01967','IMPD').
consumed_by0('36273: cpd:C16618','39976: rn:R08244','IMPD').
consumed_by0('38218: cpd:C15780','40347: rn:R07492','IMPD').
consumed_by0('38249: cpd:C01943','40335: rn:R05731','IMPD').
consumed_by0('36222: cpd:C03201','41007: rn:R06364','IMPD').
consumed_by0('36222: cpd:C03201','41012: rn:R07389','IMPD').
consumed_by0('36239: cpd:C00181','40464: rn:R01430','IMPD').
consumed_by0('36270: cpd:C02170','8915: rn:R02764','IMPD').
consumed_by0('36335: cpd:C04233','6851: rn:R01319','IMPD').
consumed_by0('37256: cpd:C00361','40150: rn:R01857','IMPD').
consumed_by0('36242: cpd:C00199','9873: rn:R07456','IMPD').
consumed_by0('36242: cpd:C00199','9872: rn:R07456','IMPD').
consumed_by0('37256: cpd:C00361','40137: rn:R01858','IMPD').
consumed_by0('36215: cpd:C04635','40995: rn:R04413','IMPD').
consumed_by0('36215: cpd:C04635','40993: rn:R07388','IMPD').
consumed_by0('36215: cpd:C04635','40992: rn:R07380','IMPD').
consumed_by0('36201: cpd:C00530','41464: rn:R02363','IMPD').
consumed_by0('37262: cpd:C00035','40073: rn:R00328','IMPD').
consumed_by0('37262: cpd:C00035','40077: rn:R00328','IMPD').
consumed_by0('36268: cpd:C15650','39806: rn:R07395','IMPD').
consumed_by0('36246: cpd:C00231','9384: rn:R01440','IMPD').
consumed_by0('37261: cpd:C04494','40158: rn:R03409','IMPD').
consumed_by0('36237: cpd:C06128','40792: rn:R04018','IMPD').
consumed_by0('36238: cpd:C00124','40703: rn:R01092','IMPD').
consumed_by0('36509: cpd:C05122','1339: rn:R02797','IMPD').
consumed_by0('36232: cpd:C06126','40794: rn:R05105','IMPD').
consumed_by0('36232: cpd:C06126','40790: rn:R04019','IMPD').
consumed_by0('37267: cpd:C00144','40091: rn:R00332','IMPD').
consumed_by0('37267: cpd:C00144','40081: rn:R01134','IMPD').
consumed_by0('37243: gl:G00037','40852: rn:R06169','IMPD').
consumed_by0('37267: cpd:C00144','40093: rn:R01227','IMPD').
consumed_by0('36238: cpd:C00124','40531: rn:R01092','IMPD').
consumed_by0('36238: cpd:C00124','40545: rn:R01093 rn:R01095','IMPD').
consumed_by0('36218: cpd:C00143','41164: rn:R01220','IMPD').
consumed_by0('37262: cpd:C00035','40165: rn:R00330','IMPD').
consumed_by0('36218: cpd:C00143','41166: rn:R01218','IMPD').
consumed_by0('36218: cpd:C00143','41162: rn:R01224 rn:R07168','IMPD').
consumed_by0('36177: cpd:C00235','11596: rn:R08052','IMPD').
consumed_by0('36177: cpd:C00235','11595: rn:R04038','IMPD').
consumed_by0('36177: cpd:C00235','11597: rn:R08051','IMPD').
consumed_by0('37262: cpd:C00035','40187: rn:R02019','IMPD').
consumed_by0('36298: cpd:C00020','40124: rn:R00127','IMPD').
consumed_by0('36298: cpd:C00020','40120: rn:R00183','IMPD').
consumed_by0('36298: cpd:C00020','40118: rn:R00190','IMPD').
consumed_by0('36298: cpd:C00020','40119: rn:R00181','IMPD').
consumed_by0('38264: cpd:C15808','40326: rn:R07494','IMPD').
consumed_by0('37243: gl:G00037','40857: rn:R06156','IMPD').
consumed_by0('36279: cpd:C01120','40784: rn:R02464','IMPD').
consumed_by0('36193: cpd:C00047','12849: rn:R00462','IMPD').
consumed_by0('37243: gl:G00037','40950: rn:R06153','IMPD').
consumed_by0('37243: gl:G00037','40951: rn:R06153','IMPD').
consumed_by0('38508: cpd:C00674','1715: rn:R02476 rn:R02477','IMPD').
consumed_by0('37227: cpd:C05576','41420: rn:R04881','IMPD').
consumed_by0('37227: cpd:C05576','41418: rn:R04880','IMPD').
consumed_by0('37232: cpd:C02442','41376: rn:R03943','IMPD').
consumed_by0('38511: cpd:C03772','1710: rn:R04309 rn:R04310','IMPD').
consumed_by0('36265: cpd:C04756','40997: rn:R07385','IMPD').
consumed_by0('38511: cpd:C03772','1712: rn:R04309','IMPD').
consumed_by0('36193: cpd:C00047','12906: rn:R00446','IMPD').
consumed_by0('36265: cpd:C04756','41003: rn:R07379','IMPD').
consumed_by0('36272: cpd:C01190','40786: rn:R01498','IMPD').
consumed_by0('36265: cpd:C04756','40994: rn:R07384','IMPD').
consumed_by0('36272: cpd:C01190','40770: rn:R03354','IMPD').
consumed_by0('36264: cpd:C04317','40999: rn:R03438','IMPD').
consumed_by0('36264: cpd:C04317','41005: rn:R03437','IMPD').
consumed_by0('36283: cpd:C00346','40502: rn:R06870','IMPD').
consumed_by0('37548: cpd:C01164','1292: rn:R03311','IMPD').
consumed_by0('36283: cpd:C00346','40511: rn:R02038','IMPD').
consumed_by0('37258: gl:G10597','40602: rn:R06261','IMPD').
consumed_by0('36299: cpd:C16619','39995: rn:R08246','IMPD').
consumed_by0('36258: cpd:C00160','41274: rn:R00475','IMPD').
consumed_by0('36263: cpd:C00310','41089: rn:R01639','IMPD').
consumed_by0('37252: gl:G10595','40864: rn:R06259','IMPD').
consumed_by0('37253: gl:G00038','40851: rn:R06170','IMPD').
consumed_by0('38256: cpd:C11455','40329: rn:R05639','IMPD').
consumed_by0('37250: gl:G10526','40912: rn:R06128','IMPD').
consumed_by0('36323: cpd:C00094','39676: rn:R00533','IMPD').
consumed_by0('37248: cpd:C00198','41069: rn:R01519','IMPD').
consumed_by0('37277: cpd:C00387','40146: rn:R02147','IMPD').
consumed_by0('38521: cpd:C01227','1653: rn:R03406 rn:R03407','IMPD').
consumed_by0('37260: cpd:C03410','40712: rn:R04215','IMPD').
consumed_by0('37281: cpd:C00104','40079: rn:R00722','IMPD').
consumed_by0('36279: cpd:C01120','40801: rn:R06520','IMPD').
consumed_by0('37281: cpd:C00104','40080: rn:R00961','IMPD').
consumed_by0('37281: cpd:C00104','40082: rn:R00719','IMPD').
consumed_by0('36279: cpd:C01120','40813: rn:R06520','IMPD').
consumed_by0('37281: cpd:C00104','40140: rn:R00961','IMPD').
consumed_by0('37254: cpd:C00345','41043: rn:R01528','IMPD').
consumed_by0('36257: cpd:C00195','40849: rn:R08969','IMPD').
consumed_by0('38280: cpd:C01054','40330: rn:R03199','IMPD').
consumed_by0('36278: cpd:C03090','40183: rn:R04144','IMPD').
consumed_by0('37265: cpd:C00999','40719: rn:R01115','IMPD').
consumed_by0('37265: cpd:C00999','40720: rn:R01803','IMPD').
consumed_by0('36300: cpd:C01013','8940: rn:R01608','IMPD').
consumed_by0('38245: cpd:C01149','41497: rn:R03283','IMPD').
consumed_by0('36261: cpd:C00319','40779: rn:R01926','IMPD').
consumed_by0('38245: cpd:C01149','41471: rn:R03283','IMPD').
consumed_by0('37285: cpd:C00081','40175: rn:R00720','IMPD').
consumed_by0('38283: cpd:C00751','40331: rn:R02874','IMPD').
consumed_by0('36255: cpd:C02686','40791: rn:R04017','IMPD').
consumed_by0('37290: cpd:C16358','40061: rn:R07942','IMPD').
consumed_by0('36531: cpd:C00224','1869: rn:R01618','IMPD').
consumed_by0('36255: cpd:C02686','40774: rn:R03617','IMPD').
consumed_by0('38277: cpd:C01724','40325: rn:R03689','IMPD').
consumed_by0('38277: cpd:C01724','40324: rn:R05640','IMPD').
consumed_by0('36257: cpd:C00195','40793: rn:R01500','IMPD').
consumed_by0('36257: cpd:C00195','40788: rn:R01494','IMPD').
consumed_by0('36257: cpd:C00195','40787: rn:R01497','IMPD').
consumed_by0('37289: cpd:C01345','40144: rn:R03531','IMPD').
consumed_by0('36250: cpd:C05859','10693: rn:R08375','IMPD').
consumed_by0('36257: cpd:C00195','40803: rn:R01495','IMPD').
consumed_by0('37544: cpd:C05103','1197: rn:R07496','IMPD').
consumed_by0('36269: cpd:C02336','40743: rn:R03920','IMPD').
consumed_by0('36269: cpd:C02336','40771: rn:R03920','IMPD').
consumed_by0('36295: dr:D08603 cpd:C07648','39974: rn:R08245','IMPD').
consumed_by0('37275: cpd:C00996','40718: rn:R00100','IMPD').
consumed_by0('37296: cpd:C04751','40110: rn:R04591','IMPD').
consumed_by0('37296: cpd:C04751','40109: rn:R04209','IMPD').
consumed_by0('37273: gl:G00044','40853: rn:R06168','IMPD').
consumed_by0('38269: cpd:C05108','40323: rn:R07509','IMPD').
consumed_by0('37273: gl:G00044','40860: rn:R06167','IMPD').
consumed_by0('38269: cpd:C05108','40337: rn:R07499','IMPD').
consumed_by0('36297: cpd:C15606','39791: rn:R07363','IMPD').
consumed_by0('36297: cpd:C15606','39790: rn:R07364','IMPD').
consumed_by0('37257: cpd:C05585','41405: rn:R02657','IMPD').
consumed_by0('38541: cpd:C01124','1620: rn:R03263','IMPD').
consumed_by0('36365: cpd:C00350','6877: rn:R02054','IMPD').
consumed_by0('36318: cpd:C03267','40453: rn:R00872','IMPD').
consumed_by0('36286: cpd:C15647','7030: rn:R07383','IMPD').
consumed_by0('37146: cpd:C00584','41038: rn:R02581','IMPD').
consumed_by0('37138: cpd:C00322','41281: rn:R01933','IMPD').
consumed_by0('37175: cpd:C00262','40074: rn:R01769','IMPD').
consumed_by0('36300: cpd:C01013','41133: rn:R03157 rn:R03158','IMPD').
consumed_by0('36345: cpd:C00956','39710: rn:R01939','IMPD').
consumed_by0('36345: cpd:C00956','39712: rn:R03098','IMPD').
consumed_by0('37130: cpd:C00864','41367: rn:R03018','IMPD').
consumed_by0('38262: cpd:C03793','41481: rn:R03451','IMPD').
consumed_by0('37133: gl:G00094','41230: rn:R05964','IMPD').
consumed_by0('37186: cpd:C00620','40059: rn:R01057','IMPD').
consumed_by0('36316: cpd:C06250','40765: rn:R04385','IMPD').
consumed_by0('37183: cpd:C00130','40122: rn:R01135','IMPD').
consumed_by0('38250: cpd:C06157','41475: rn:R02571','IMPD').
consumed_by0('37138: cpd:C00322','41487: rn:R01940','IMPD').
consumed_by0('37183: cpd:C00130','40084: rn:R01126','IMPD').
consumed_by0('37183: cpd:C00130','40076: rn:R01130','IMPD').
consumed_by0('37183: cpd:C00130','40072: rn:R01132','IMPD').
consumed_by0('36348: cpd:C00449','39713: rn:R00716','IMPD').
consumed_by0('36300: cpd:C01013','41194: rn:R03158','IMPD').
consumed_by0('38285: cpd:C03428','40332: rn:R02872','IMPD').
consumed_by0('37152: cpd:C02166','41015: rn:R03867','IMPD').
consumed_by0('36331: cpd:C05299','40220: rn:R04353','IMPD').
consumed_by0('36313: cpd:C04419','40755: rn:R04386','IMPD').
consumed_by0('36326: cpd:C18126','40599: rn:R09036','IMPD').
consumed_by0('37150: cpd:C05356','41026: rn:R07034','IMPD').
consumed_by0('36329: cpd:C01094','40498: rn:R02568','IMPD').
consumed_by0('37150: cpd:C05356','41027: rn:R03058','IMPD').
consumed_by0('37180: cpd:C00294','40095: rn:R01863','IMPD').
consumed_by0('36354: cpd:C00148','39704: rn:R03661','IMPD').
consumed_by0('36344: cpd:C01516;dr:D08233 cpd:C01516','39960: rn:R08263','IMPD').
consumed_by0('36352: cpd:C05560','39707: rn:R04863','IMPD').
consumed_by0('37175: cpd:C00262','40171: rn:R01768','IMPD').
consumed_by0('37432: cpd:C00760','5386: rn:R02886','IMPD').
consumed_by0('37147: cpd:C00788','41412: rn:R02919','IMPD').
consumed_by0('36276: cpd:C06002','41141: rn:R00935','IMPD').
consumed_by0('37147: cpd:C00788','41424: rn:R02920','IMPD').
consumed_by0('36320: cpd:C07447','39984: rn:R08250','IMPD').
consumed_by0('36305: cpd:C00275','40450: rn:R01819','IMPD').
consumed_by0('37145: cpd:C05588','41415: rn:R04894','IMPD').
consumed_by0('36305: cpd:C00275','40451: rn:R01818','IMPD').
consumed_by0('36284: cpd:C01213','41130: rn:R00833','IMPD').
consumed_by0('38279: cpd:C01181','41496: rn:R02397','IMPD').
consumed_by0('36323: cpd:C00094','39819: rn:R03105','IMPD').
consumed_by0('36262: cpd:C01233','7021: rn:R03415','IMPD').
consumed_by0('37432: cpd:C00760','5445: rn:R02886','IMPD').
consumed_by0('37567: cpd:C05439','1285: rn:R04667','IMPD').
consumed_by0('36324: cpd:C16617','39986: rn:R08243','IMPD').
consumed_by0('38266: cpd:C05546','41480: rn:R04313','IMPD').
consumed_by0('36053: dr:D00252 cpd:C06868','13428: rn:R08317','IMPD').
consumed_by0('36334: cpd:C05535','39711: rn:R04390','IMPD').
consumed_by0('37158: cpd:C05577','41422: rn:R04882 rn:R04883','IMPD').
consumed_by0('36262: cpd:C01233','6905: rn:R01470','IMPD').
consumed_by0('36284: cpd:C01213','41150: rn:R00833','IMPD').
consumed_by0('36303: cpd:C18125','40600: rn:R09035','IMPD').
consumed_by0('36315: cpd:C05302','40213: rn:R04354','IMPD').
consumed_by0('37165: cpd:C00427','41039: rn:R02266','IMPD').
consumed_by0('36305: cpd:C00275','40692: rn:R01819','IMPD').
consumed_by0('36305: cpd:C00275','40693: rn:R01818','IMPD').
consumed_by0('37154: cpd:C00547','41423: rn:R02534','IMPD').
consumed_by0('36262: cpd:C01233','6869: rn:R01470','IMPD').
consumed_by0('37154: cpd:C00547','41427: rn:R02532','IMPD').
consumed_by0('36322: cpd:C05298','40219: rn:R04762','IMPD').
consumed_by0('37154: cpd:C00547','41417: rn:R02533','IMPD').
consumed_by0('37151: cpd:C05589','41429: rn:R04893','IMPD').
consumed_by0('36319: cpd:C05301','40214: rn:R04764','IMPD').
consumed_by0('36254: cpd:C15646','7029: rn:R07382','IMPD').
consumed_by0('36291: cpd:C02512','41053: rn:R03970','IMPD').
consumed_by0('37165: cpd:C00427','41021: rn:R02268','IMPD').
consumed_by0('37165: cpd:C00427','41019: rn:R02265','IMPD').
consumed_by0('37165: cpd:C00427','41023: rn:R02267','IMPD').
consumed_by0('36296: cpd:C00631','40937: rn:R01518','IMPD').
consumed_by0('36296: cpd:C00631','40938: rn:R00658','IMPD').
consumed_by0('37207: cpd:C00499','40088: rn:R02422','IMPD').
consumed_by0('37480: cpd:C00185','5444: rn:R00952','IMPD').
consumed_by0('37480: cpd:C00185','5449: rn:R00306','IMPD').
consumed_by0('36346: cpd:C18129','40591: rn:R09037','IMPD').
consumed_by0('37203: cpd:C00366','40085: rn:R02106','IMPD').
consumed_by0('37590: cpd:C07481','2109: rn:R07980','IMPD').
consumed_by0('37160: cpd:C05580','41421: rn:R04887','IMPD').
consumed_by0('37590: cpd:C07481','2110: rn:R07955 rn:R07956','IMPD').
consumed_by0('36457: cpd:C00740','2537: rn:R00221','IMPD').
consumed_by0('36368: dr:D01223 cpd:C12650','40008: rn:R08220','IMPD').
consumed_by0('37172: cpd:C05956','41029: rn:R00073','IMPD').
consumed_by0('36362: cpd:C00187','40229: rn:R08977','IMPD').
consumed_by0('36362: cpd:C00187','40228: rn:R08941','IMPD').
consumed_by0('36362: cpd:C00187','40232: rn:R01454','IMPD').
consumed_by0('36351: cpd:C03819','40593: rn:R09034','IMPD').
consumed_by0('36362: cpd:C00187','40226: rn:R02723','IMPD').
consumed_by0('36362: cpd:C00187','40311: rn:R07207','IMPD').
consumed_by0('36362: cpd:C00187','40320: rn:R01461','IMPD').
consumed_by0('36362: cpd:C00187','40297: rn:R07218','IMPD').
consumed_by0('36362: cpd:C00187','40295: rn:R01463','IMPD').
consumed_by0('36362: cpd:C00187','40303: rn:R08505','IMPD').
consumed_by0('37214: cpd:C01260','40133: rn:R00184','IMPD').
consumed_by0('37421: gl:G00072','7456: rn:R06192','IMPD').
consumed_by0('37186: cpd:C00620','41063: rn:R01057','IMPD').
consumed_by0('36362: cpd:C00187','40342: rn:R01457','IMPD').
consumed_by0('37173: cpd:C01161','41450: rn:R03304','IMPD').
consumed_by0('37168: cpd:C05583','41426: rn:R04891 rn:R04892','IMPD').
consumed_by0('37195: gl:G00157','40596: rn:R05929','IMPD').
consumed_by0('37179: cpd:C05966','41073: rn:R07043','IMPD').
consumed_by0('37179: cpd:C05966','41066: rn:R07042','IMPD').
consumed_by0('37490: cpd:C00369','5429: rn:R02112','IMPD').
consumed_by0('37179: cpd:C05966','41059: rn:R07035','IMPD').
consumed_by0('36511: cpd:C01146','657: rn:R03277','IMPD').
consumed_by0('37195: gl:G00157','40617: rn:R05930','IMPD').
consumed_by0('36386: cpd:C01137','39714: rn:R02869','IMPD').
consumed_by0('37202: cpd:C00329','40726: rn:R01961','IMPD').
consumed_by0('36214: cpd:C00091','9666: rn:R09280','IMPD').
consumed_by0('36344: cpd:C01516;dr:D08233 cpd:C01516','40070: rn:R08262','IMPD').
consumed_by0('36214: cpd:C00091','9672: rn:R01197','IMPD').
consumed_by0('36510: cpd:C00089','550: rn:R02411','IMPD').
consumed_by0('37181: cpd:C04043','41452: rn:R03300 rn:R03302','IMPD').
consumed_by0('36343: cpd:C05141','40200: rn:R04683','IMPD').
consumed_by0('36343: cpd:C05141','40199: rn:R04681 rn:R04682','IMPD').
consumed_by0('36350: dr:D00358 cpd:C07073','40027: rn:R08294','IMPD').
consumed_by0('36350: dr:D00358 cpd:C07073','40029: rn:R08293','IMPD').
consumed_by0('36350: dr:D00358 cpd:C07073','40028: rn:R08293','IMPD').
consumed_by0('36350: dr:D00358 cpd:C07073','40030: rn:R08294','IMPD').
consumed_by0('36335: cpd:C04233','40552: rn:R02747','IMPD').
consumed_by0('37177: cpd:C05581','41446: rn:R04888 rn:R04889','IMPD').
consumed_by0('37205: cpd:C02670','40607: rn:R02957','IMPD').
consumed_by0('36339: cpd:C00040','40501: rn:R02241','IMPD').
consumed_by0('36339: cpd:C00040','40507: rn:R00851','IMPD').
consumed_by0('37217: cpd:C01040','40580: rn:R03184','IMPD').
consumed_by0('36218: cpd:C00143','9340: rn:R00945','IMPD').
consumed_by0('37217: cpd:C01040','40608: rn:R02933','IMPD').
consumed_by0('36316: cpd:C06250','41335: rn:R04869','IMPD').
consumed_by0('37209: cpd:C01674','40715: rn:R00022','IMPD').
consumed_by0('36339: cpd:C00040','40680: rn:R00851','IMPD').
consumed_by0('36339: cpd:C00040','40675: rn:R02241','IMPD').
consumed_by0('36339: cpd:C00040','40671: rn:R02251','IMPD').
consumed_by0('36345: cpd:C00956','41488: rn:R01939','IMPD').
consumed_by0('36465: cpd:C00641','6620: rn:R02691','IMPD').
consumed_by0('37651: cpd:C17343','40316: rn:R08735','IMPD').
consumed_by0('36387: cpd:C04373','40207: rn:R04352','IMPD').
consumed_by0('36523: cpd:C00519','4936: rn:R01681','IMPD').
consumed_by0('36340: cpd:C04076','41485: rn:R03102 rn:R03103','IMPD').
consumed_by0('37654: cpd:C05460','40296: rn:R04813','IMPD').
consumed_by0('37440: gl:G00068','7461: rn:R06097','IMPD').
consumed_by0('37648: gl:G13041','40555: rn:R07821','IMPD').
consumed_by0('36388: cpd:C06174;dr:D00195 cpd:C06174','40069: rn:R08261','IMPD').
consumed_by0('36388: cpd:C06174;dr:D00195 cpd:C06174','40068: rn:R03697','IMPD').
consumed_by0('36510: cpd:C00089','5455: rn:R00803','IMPD').
consumed_by0('37648: gl:G13041','40575: rn:R07821','IMPD').
consumed_by0('37656: cpd:C05467','40300: rn:R03719','IMPD').
consumed_by0('36372: cpd:C02737','40554: rn:R02055','IMPD').
consumed_by0('36391: cpd:C00170','39794: rn:R01402','IMPD').
consumed_by0('36527: cpd:C00606','4958: rn:R02434','IMPD').
consumed_by0('36439: cpd:C00546','7674: rn:R00203','IMPD').
consumed_by0('36439: cpd:C00546','7673: rn:R00203','IMPD').
consumed_by0('37613: cpd:C05653','41273: rn:R00988','IMPD').
consumed_by0('36375: cpd:C00249','40366: rn:R01280','IMPD').
consumed_by0('36468: cpd:C03892','6886: rn:R02029','IMPD').
consumed_by0('36565: cpd:C00630','3839: rn:R09090','IMPD').
consumed_by0('36388: cpd:C06174;dr:D00195 cpd:C06174','39933: rn:R08264','IMPD').
consumed_by0('36439: cpd:C00546','7737: rn:R00205','IMPD').
consumed_by0('36365: cpd:C00350','40480: rn:R05920','IMPD').
consumed_by0('36365: cpd:C00350','40483: rn:R08107','IMPD').
consumed_by0('36471: cpd:C00344','6863: rn:R02027','IMPD').
consumed_by0('36365: cpd:C00350','40477: rn:R08107','IMPD').
consumed_by0('37638: cpd:C00925','40553: rn:R07811','IMPD').
consumed_by0('37638: cpd:C00925','40549: rn:R07811','IMPD').
consumed_by0('36386: cpd:C01137','39795: rn:R01920','IMPD').
consumed_by0('36365: cpd:C00350','40537: rn:R02056','IMPD').
consumed_by0('36365: cpd:C00350','40532: rn:R02051','IMPD').
consumed_by0('36382: cpd:C16614','39978: rn:R08238','IMPD').
consumed_by0('36365: cpd:C00350','40500: rn:R02053','IMPD').
consumed_by0('36365: cpd:C00350','40494: rn:R07376','IMPD').
consumed_by0('37638: cpd:C00925','40581: rn:R07811','IMPD').
consumed_by0('36683: cpd:C00665','399: rn:R02730','IMPD').
consumed_by0('36354: cpd:C00148','41543: rn:R01252','IMPD').
consumed_by0('36354: cpd:C00148','41539: rn:R01253','IMPD').
consumed_by0('36354: cpd:C00148','41537: rn:R01248 rn:R01251','IMPD').
consumed_by0('37626: cpd:C16362','2142: rn:R07982','IMPD').
consumed_by0('36398: cpd:C00523','40205: rn:R02478','IMPD').
consumed_by0('37628: cpd:C13747','2120: rn:R07957 rn:R07958','IMPD').
consumed_by0('36323: cpd:C00094','11800: rn:R08553','IMPD').
consumed_by0('37625: cpd:C17333','40279: rn:R08727','IMPD').
consumed_by0('37624: cpd:C17336','40313: rn:R08725','IMPD').
consumed_by0('37627: cpd:C13550','40291: rn:R07208','IMPD').
consumed_by0('36403: cpd:C04646','40004: rn:R08240','IMPD').
consumed_by0('36403: cpd:C04646','39993: rn:R08239','IMPD').
consumed_by0('36348: cpd:C00449','41486: rn:R02313','IMPD').
consumed_by0('37629: cpd:C05455','40290: rn:R04826','IMPD').
consumed_by0('37629: cpd:C05455','40312: rn:R04817','IMPD').
consumed_by0('36399: dr:D00346 cpd:C07054','39982: rn:R08248','IMPD').
consumed_by0('36410: cpd:C04438','40546: rn:R03416','IMPD').
consumed_by0('36410: cpd:C04438','40550: rn:R04480','IMPD').
consumed_by0('36385: cpd:C00986','41191: rn:R03139','IMPD').
consumed_by0('36405: cpd:C05973','40548: rn:R03417','IMPD').
consumed_by0('36418: cpd:C00147','40141: rn:R02557','IMPD').
consumed_by0('36406: cpd:C02985','40452: rn:R01951','IMPD').
consumed_by0('38667: cpd:C00647','9923: rn:R01147','IMPD').
consumed_by0('38667: cpd:C00647','9921: rn:R01580','IMPD').
consumed_by0('36393: cpd:C06124','40811: rn:R06521','IMPD').
consumed_by0('36393: cpd:C06124','40802: rn:R06521','IMPD').
consumed_by0('36393: cpd:C06124','40782: rn:R06516','IMPD').
consumed_by0('37468: gl:G00054','7457: rn:R06198','IMPD').
consumed_by0('37642: cpd:C05921','41351: rn:R05145','IMPD').
consumed_by0('37642: cpd:C05921','41334: rn:R05145','IMPD').
consumed_by0('37642: cpd:C05921','41332: rn:R05145','IMPD').
consumed_by0('37642: cpd:C05921','41331: rn:R05145','IMPD').
consumed_by0('36421: cpd:C01242','39849: rn:R04125','IMPD').
consumed_by0('36380: cpd:C00219','41087: rn:R07046','IMPD').
consumed_by0('36380: cpd:C00219','41062: rn:R07041','IMPD').
consumed_by0('36380: cpd:C00219','41065: rn:R07048','IMPD').
consumed_by0('36380: cpd:C00219','41075: rn:R07038','IMPD').
consumed_by0('36380: cpd:C00219','41076: rn:R07053','IMPD').
consumed_by0('36380: cpd:C00219','41071: rn:R07054','IMPD').
consumed_by0('36380: cpd:C00219','41046: rn:R07050','IMPD').
consumed_by0('36380: cpd:C00219','41058: rn:R07046','IMPD').
consumed_by0('36380: cpd:C00219','41061: rn:R07041','IMPD').
consumed_by0('36380: cpd:C00219','41060: rn:R07046','IMPD').
consumed_by0('37647: cpd:C05552','41333: rn:R01077','IMPD').
consumed_by0('36380: cpd:C00219','41057: rn:R07041','IMPD').
consumed_by0('36380: cpd:C00219','41031: rn:R01317','IMPD').
consumed_by0('36380: cpd:C00219','41044: rn:R07052','IMPD').
consumed_by0('36380: cpd:C00219','41045: rn:R07051','IMPD').
consumed_by0('36380: cpd:C00219','41025: rn:R01593','IMPD').
consumed_by0('36380: cpd:C00219','41024: rn:R01596','IMPD').
consumed_by0('36380: cpd:C00219','41022: rn:R01590','IMPD').
consumed_by0('36380: cpd:C00219','41028: rn:R01595','IMPD').
consumed_by0('36415: cpd:C00015','39941: rn:R02018','IMPD').
consumed_by0('36415: cpd:C00015','39920: rn:R00155','IMPD').
consumed_by0('36415: cpd:C00015','39921: rn:R00155','IMPD').
consumed_by0('36415: cpd:C00015','39925: rn:R00157','IMPD').
consumed_by0('36415: cpd:C00015','39926: rn:R00156','IMPD').
consumed_by0('36417: cpd:C01672','40798: rn:R08359','IMPD').
consumed_by0('36429: cpd:C00636','40447: rn:R00885','IMPD').
consumed_by0('36419: cpd:C00093','40680: rn:R00851','IMPD').
consumed_by0('37632: cpd:C00120','41350: rn:R01074','IMPD').
consumed_by0('37632: cpd:C00120','41341: rn:R01074','IMPD').
consumed_by0('36446: cpd:C02050','39876: rn:R08177','IMPD').
consumed_by0('37690: cpd:C05466','1327: rn:R03975','IMPD').
consumed_by0('37668: cpd:C04554','40285: rn:R08738','IMPD').
consumed_by0('36414: cpd:C12145','40810: rn:R06528','IMPD').
consumed_by0('37674: cpd:C05447','40283: rn:R04809','IMPD').
consumed_by0('37325: cpd:C03765','12580: rn:R04305','IMPD').
consumed_by0('37671: cpd:C17345','40281: rn:R08739','IMPD').
consumed_by0('37672: cpd:C17346','40282: rn:R08740','IMPD').
consumed_by0('36419: cpd:C00093','40506: rn:R00848','IMPD').
consumed_by0('36419: cpd:C00093','40508: rn:R00842','IMPD').
consumed_by0('36419: cpd:C00093','40507: rn:R00851','IMPD').
consumed_by0('36386: cpd:C01137','41503: rn:R01920','IMPD').
consumed_by0('36408: cpd:C01290','40785: rn:R03355','IMPD').
consumed_by0('36411: cpd:C00325','40713: rn:R05692','IMPD').
consumed_by0('37659: cpd:C05452','40286: rn:R04806','IMPD').
consumed_by0('37680: cpd:C05465','1354: rn:R03977','IMPD').
consumed_by0('37664: cpd:C05445','40288: rn:R08760','IMPD').
consumed_by0('37632: cpd:C00120','41329: rn:R01074','IMPD').
consumed_by0('36437: cpd:C01888','39851: rn:R02529','IMPD').
consumed_by0('37632: cpd:C00120','41330: rn:R01074','IMPD').
consumed_by0('36437: cpd:C01888','39852: rn:R02529','IMPD').
consumed_by0('37316: cpd:C03758','12580: rn:R04305','IMPD').
consumed_by0('36406: cpd:C02985','40706: rn:R01951','IMPD').
consumed_by0('37662: cpd:C05444','40287: rn:R08758','IMPD').
consumed_by0('36386: cpd:C01137','41370: rn:R02869','IMPD').
consumed_by0('36386: cpd:C01137','41364: rn:R02869','IMPD').
consumed_by0('37653: gl:G00154','40592: rn:R05926','IMPD').
consumed_by0('36438: cpd:C01194','40486: rn:R05916','IMPD').
consumed_by0('36438: cpd:C01194','40487: rn:R05916','IMPD').
consumed_by0('36438: cpd:C01194','40479: rn:R05916','IMPD').
consumed_by0('36438: cpd:C01194','40467: rn:R05916','IMPD').
consumed_by0('36438: cpd:C01194','40466: rn:R05916','IMPD').
consumed_by0('36428: cpd:C00836','40780: rn:R02976','IMPD').
consumed_by0('36438: cpd:C01194','40469: rn:R05916','IMPD').
consumed_by0('36438: cpd:C01194','40468: rn:R05916','IMPD').
consumed_by0('36435: cpd:C00416','40678: rn:R02239','IMPD').
consumed_by0('37703: cpd:C05451','1319: rn:R04818 rn:R04819','IMPD').
consumed_by0('36443: cpd:C00269','40499: rn:R01802','IMPD').
consumed_by0('36441: cpd:C00052','40522: rn:R00503','IMPD').
consumed_by0('36440: cpd:C00513','40556: rn:R00855','IMPD').
consumed_by0('36454: cpd:C00385','40096: rn:R02142','IMPD').
consumed_by0('36527: cpd:C00606','2759: rn:R00863','IMPD').
consumed_by0('36444: cpd:C00446','40530: rn:R00955','IMPD').
consumed_by0('36443: cpd:C00269','40539: rn:R01801','IMPD').
consumed_by0('36443: cpd:C00269','40540: rn:R02030 rn:R07390','IMPD').
consumed_by0('36454: cpd:C00385','40186: rn:R02107','IMPD').
consumed_by0('36454: cpd:C00385','40172: rn:R02103','IMPD').
consumed_by0('38667: cpd:C00647','41569: rn:R00277','IMPD').
consumed_by0('38667: cpd:C00647','41570: rn:R02494','IMPD').
consumed_by0('37578: cpd:C03845','40339: rn:R03353','IMPD').
consumed_by0('37590: cpd:C07481','39956: rn:R07939','IMPD').
consumed_by0('36422: cpd:C12126','40809: rn:R06518','IMPD').
consumed_by0('36422: cpd:C12126','40808: rn:R06519','IMPD').
consumed_by0('36405: cpd:C05973','6906: rn:R04864','IMPD').
consumed_by0('36424: cpd:C00229','40763: rn:R01624','IMPD').
consumed_by0('38669: cpd:C00018','41559: rn:R00173','IMPD').
consumed_by0('36453: cpd:C00430','39858: rn:R00036','IMPD').
consumed_by0('36431: cpd:C00681','40501: rn:R02241','IMPD').
consumed_by0('38671: cpd:C00250','41462: rn:R01709','IMPD').
consumed_by0('37331: cpd:C00483','12614: rn:R02383','IMPD').
consumed_by0('36534: cpd:C00506','2709: rn:R07634','IMPD').
consumed_by0('38671: cpd:C00250','41557: rn:R00174','IMPD').
consumed_by0('36435: cpd:C00416','40527: rn:R02239','IMPD').
consumed_by0('38673: cpd:C00534','41568: rn:R01710','IMPD').
consumed_by0('38673: cpd:C00534','41571: rn:R02493','IMPD').
consumed_by0('36431: cpd:C00681','40675: rn:R02241','IMPD').
consumed_by0('36435: cpd:C00416','40551: rn:R01799','IMPD').
consumed_by0('37331: cpd:C00483','12727: rn:R02383','IMPD').
consumed_by0('36429: cpd:C00636','40705: rn:R00885','IMPD').
consumed_by0('36470: cpd:C16631','40023: rn:R08228','IMPD').
consumed_by0('36456: cpd:C00157','40509: rn:R02114','IMPD').
consumed_by0('36476: cpd:C03794','39893: rn:R01083','IMPD').
consumed_by0('37539: cpd:C04352','41360: rn:R03269','IMPD').
consumed_by0('36456: cpd:C00157','40493: rn:R07377','IMPD').
consumed_by0('36473: dr:D00584 cpd:C07649','40014: rn:R08226','IMPD').
consumed_by0('36473: dr:D00584 cpd:C07649','40015: rn:R08230','IMPD').
consumed_by0('36473: dr:D00584 cpd:C07649','40016: rn:R08229','IMPD').
consumed_by0('36456: cpd:C00157','40525: rn:R01310','IMPD').
consumed_by0('36456: cpd:C00157','40519: rn:R01315','IMPD').
consumed_by0('36424: cpd:C00229','6366: rn:R08905','IMPD').
consumed_by0('36473: dr:D00584 cpd:C07649','40021: rn:R08231','IMPD').
consumed_by0('36475: dr:D01244 cpd:C12673','40002: rn:R08225','IMPD').
consumed_by0('36450: cpd:C01089','40354: rn:R01361','IMPD').
consumed_by0('37710: cpd:C05453','1315: rn:R04824 rn:R04825','IMPD').
consumed_by0('36438: cpd:C01194','40757: rn:R03361','IMPD').
consumed_by0('36438: cpd:C01194','40756: rn:R03362','IMPD').
consumed_by0('37530: cpd:C00882','41361: rn:R00130','IMPD').
consumed_by0('36428: cpd:C00836','41104: rn:R06518','IMPD').
consumed_by0('36447: cpd:C00189','40523: rn:R01468','IMPD').
consumed_by0('36444: cpd:C00446','40661: rn:R00955','IMPD').
consumed_by0('37532: cpd:C01134','41358: rn:R03036','IMPD').
consumed_by0('37532: cpd:C01134','41355: rn:R03035','IMPD').
consumed_by0('37525: cpd:C00831','41353: rn:R02973','IMPD').
consumed_by0('37525: cpd:C00831','41359: rn:R02971','IMPD').
consumed_by0('36466: cpd:C16630','40013: rn:R08227','IMPD').
consumed_by0('36420: cpd:C00408','41473: rn:R02204','IMPD').
consumed_by0('36472: cpd:C00510','39877: rn:R08176','IMPD').
consumed_by0('36266: cpd:C00008','11596: rn:R08052','IMPD').
consumed_by0('36474: cpd:C01019','40492: rn:R03161','IMPD').
consumed_by0('37717: cpd:C00301','1923: rn:R01885','IMPD').
consumed_by0('36455: cpd:C05382','41056: rn:R01827','IMPD').
consumed_by0('37622: cpd:C03594','40305: rn:R04263','IMPD').
consumed_by0('36471: cpd:C00344','40540: rn:R02030 rn:R07390','IMPD').
consumed_by0('36455: cpd:C05382','41034: rn:R01641','IMPD').
consumed_by0('36465: cpd:C00641','40704: rn:R02240','IMPD').
consumed_by0('36450: cpd:C01089','41179: rn:R01361','IMPD').
consumed_by0('36465: cpd:C00641','40671: rn:R02251','IMPD').
consumed_by0('36465: cpd:C00641','40677: rn:R02687','IMPD').
consumed_by0('37628: cpd:C13747','40066: rn:R07940','IMPD').
consumed_by0('37628: cpd:C13747','40067: rn:R07945','IMPD').
consumed_by0('37628: cpd:C13747','40062: rn:R07943','IMPD').
consumed_by0('37670: cpd:C01152','3532: rn:R03286','IMPD').
consumed_by0('37619: cpd:C15519','40315: rn:R07209','IMPD').
consumed_by0('37584: cpd:C03492','41366: rn:R04230 rn:R04231','IMPD').
consumed_by0('36456: cpd:C00157','41099: rn:R07859','IMPD').
consumed_by0('37617: cpd:C15610','40314: rn:R08726','IMPD').
consumed_by0('37617: cpd:C15610','40310: rn:R07372','IMPD').
consumed_by0('37617: cpd:C15610','40309: rn:R07372','IMPD').
consumed_by0('37628: cpd:C13747','39955: rn:R07977','IMPD').
consumed_by0('36456: cpd:C00157','41079: rn:R07064','IMPD').
consumed_by0('37623: cpd:C16361','40064: rn:R07981','IMPD').
consumed_by0('36492: cpd:C00135','39685: rn:R03655','IMPD').
consumed_by0('36476: cpd:C03794','40121: rn:R01083','IMPD').
consumed_by0('36445: cpd:C06427','41095: rn:R07861','IMPD').
consumed_by0('36485: cpd:C00412','39869: rn:R08174','IMPD').
consumed_by0('36465: cpd:C00641','40490: rn:R01321','IMPD').
consumed_by0('36422: cpd:C12126','7303: rn:R06526','IMPD').
consumed_by0('36439: cpd:C00546','41217: rn:R02531','IMPD').
consumed_by0('36488: cpd:C02041','39878: rn:R08175','IMPD').
consumed_by0('36438: cpd:C01194','6732: rn:R03332','IMPD').
consumed_by0('36438: cpd:C01194','6724: rn:R03332','IMPD').
consumed_by0('36465: cpd:C00641','40529: rn:R02240','IMPD').
consumed_by0('36465: cpd:C00641','40547: rn:R02057','IMPD').
consumed_by0('36490: cpd:C01996','40515: rn:R01026','IMPD').
consumed_by0('36447: cpd:C00189','6885: rn:R00749','IMPD').
consumed_by0('36487: cpd:C04230','40488: rn:R01318','IMPD').
consumed_by0('36608: cpd:C00117','1797: rn:R01053','IMPD').
consumed_by0('36487: cpd:C04230','40535: rn:R02746','IMPD').
consumed_by0('36503: dr:D04197 cpd:C11736','40018: rn:R08233','IMPD').
consumed_by0('36495: cpd:C01222','40446: rn:R05692','IMPD').
consumed_by0('38691: cpd:C03451','41222: rn:R01736','IMPD').
consumed_by0('36443: cpd:C00269','6849: rn:R05794','IMPD').
consumed_by0('36555: cpd:C00134','3379: rn:R07414','IMPD').
consumed_by0('36428: cpd:C00836','7304: rn:R06525','IMPD').
consumed_by0('38691: cpd:C03451','41215: rn:R02530','IMPD').
consumed_by0('36443: cpd:C00269','6870: rn:R01800','IMPD').
consumed_by0('36516: cpd:C15975','39749: rn:R04097','IMPD').
consumed_by0('36481: cpd:C00588','40489: rn:R01890','IMPD').
consumed_by0('36474: cpd:C01019','40709: rn:R03161','IMPD').
consumed_by0('36456: cpd:C00157','6861: rn:R01316','IMPD').
consumed_by0('36519: cpd:C00245','4911: rn:R05320','IMPD').
consumed_by0('36519: cpd:C00245','4926: rn:R05652','IMPD').
consumed_by0('38683: cpd:C00314','41548: rn:R01711','IMPD').
consumed_by0('38683: cpd:C00314','41560: rn:R01909','IMPD').
consumed_by0('36478: cpd:C00570','40547: rn:R02057','IMPD').
consumed_by0('36298: cpd:C00020','11595: rn:R04038','IMPD').
consumed_by0('38699: cpd:C00256','41221: rn:R00197','IMPD').
consumed_by0('38689: cpd:C06055','41554: rn:R05085','IMPD').
consumed_by0('36501: cpd:C16633','40019: rn:R08232','IMPD').
consumed_by0('38690: cpd:C00627','41561: rn:R01911','IMPD').
consumed_by0('38690: cpd:C00627','41551: rn:R00278','IMPD').
consumed_by0('36481: cpd:C00588','40557: rn:R06871','IMPD').
consumed_by0('36484: cpd:C00307','40490: rn:R01321','IMPD').
consumed_by0('36524: cpd:C00053','39777: rn:R02180','IMPD').
consumed_by0('36524: cpd:C00053','39775: rn:R01242','IMPD').
consumed_by0('38515: cpd:C04295','40262: rn:R02499','IMPD').
consumed_by0('38515: cpd:C04295','40263: rn:R02499','IMPD').
consumed_by0('36524: cpd:C00053','39778: rn:R00629','IMPD').
consumed_by0('36524: cpd:C00053','39779: rn:R02350','IMPD').
consumed_by0('36526: cpd:C02939','39745: rn:R04095','IMPD').
consumed_by0('36526: cpd:C02939','39724: rn:R04095','IMPD').
consumed_by0('36524: cpd:C00053','39782: rn:R00508','IMPD').
consumed_by0('37495: cpd:C00718','40824: rn:R02110','IMPD').
consumed_by0('36506: cpd:C06790','40162: rn:R07100','IMPD').
consumed_by0('38472: cpd:C15811','41489: rn:R07460','IMPD').
consumed_by0('36522: cpd:C03069','39726: rn:R04138','IMPD').
consumed_by0('36532: cpd:C05998','39727: rn:R04137','IMPD').
consumed_by0('36638: cpd:C00750','5343: rn:R08352','IMPD').
consumed_by0('36531: cpd:C00224','39776: rn:R00509','IMPD').
consumed_by0('36486: cpd:C00246','41198: rn:R01176','IMPD').
consumed_by0('36525: cpd:C03912','39887: rn:R00707 rn:R00708','IMPD').
consumed_by0('36527: cpd:C00606','39817: rn:R02619','IMPD').
consumed_by0('37524: cpd:C02530','40319: rn:R01462','IMPD').
consumed_by0('37498: cpd:C00559','40116: rn:R02556','IMPD').
consumed_by0('36517: cpd:C00095','40462: rn:R00866','IMPD').
consumed_by0('36517: cpd:C00095','40455: rn:R00867','IMPD').
consumed_by0('37501: cpd:C00360','40142: rn:R01547','IMPD').
consumed_by0('36492: cpd:C00135','41340: rn:R01168','IMPD').
consumed_by0('36492: cpd:C00135','41344: rn:R01167','IMPD').
consumed_by0('36492: cpd:C00135','41343: rn:R01167','IMPD').
consumed_by0('38501: cpd:C05501','40227: rn:R04855','IMPD').
consumed_by0('37480: cpd:C00185','40772: rn:R00026','IMPD').
consumed_by0('36492: cpd:C00135','41323: rn:R01159','IMPD').
consumed_by0('36510: cpd:C00089','40769: rn:R00802','IMPD').
consumed_by0('36510: cpd:C00089','40768: rn:R00802','IMPD').
consumed_by0('38501: cpd:C05501','40231: rn:R03933','IMPD').
consumed_by0('38501: cpd:C05501','40233: rn:R04854','IMPD').
consumed_by0('36542: cpd:C03284','39756: rn:R04188','IMPD').
consumed_by0('37476: gl:G00058','40878: rn:R06197','IMPD').
consumed_by0('37503: cpd:C04734','40054: rn:R01127','IMPD').
consumed_by0('37501: cpd:C00360','40115: rn:R02088','IMPD').
consumed_by0('36538: cpd:C00234','39702: rn:R03940','IMPD').
consumed_by0('36519: cpd:C00245','40292: rn:R08745','IMPD').
consumed_by0('36519: cpd:C00245','40289: rn:R03720','IMPD').
consumed_by0('37479: gl:G00051','40861: rn:R06027','IMPD').
consumed_by0('36500: gl:G00092','40867: rn:R05971','IMPD').
consumed_by0('36534: cpd:C00506','39808: rn:R02433','IMPD').
consumed_by0('36510: cpd:C00089','40542: rn:R00801','IMPD').
consumed_by0('36500: gl:G00092','40920: rn:R05960','IMPD').
consumed_by0('36524: cpd:C00053','40180: rn:R00507','IMPD').
consumed_by0('37485: gl:G00036','40827: rn:R05977','IMPD').
consumed_by0('37485: gl:G00036','40835: rn:R05977','IMPD').
consumed_by0('37485: gl:G00036','40837: rn:R05977','IMPD').
consumed_by0('36500: gl:G00092','41231: rn:R05960','IMPD').
consumed_by0('36500: gl:G00092','41252: rn:R05937','IMPD').
consumed_by0('36500: gl:G00092','41258: rn:R05938','IMPD').
consumed_by0('37485: gl:G00036','40877: rn:R05977','IMPD').
consumed_by0('37486: gl:G00050','40863: rn:R06024','IMPD').
consumed_by0('37486: gl:G00050','40870: rn:R05975','IMPD').
consumed_by0('36496: cpd:C02094','41428: rn:R00032','IMPD').
consumed_by0('37485: gl:G00036','40854: rn:R06006','IMPD').
consumed_by0('37486: gl:G00050','40826: rn:R06025','IMPD').
consumed_by0('37485: gl:G00036','40856: rn:R06006','IMPD').
consumed_by0('37485: gl:G00036','40855: rn:R06006','IMPD').
consumed_by0('37486: gl:G00050','40834: rn:R05975','IMPD').
consumed_by0('36541: cpd:C14800','40052: rn:R07027','IMPD').
consumed_by0('36531: cpd:C00224','40178: rn:R00509','IMPD').
consumed_by0('37486: gl:G00050','40872: rn:R05978','IMPD').
consumed_by0('37511: cpd:C04392','40127: rn:R02805','IMPD').
consumed_by0('37486: gl:G00050','40890: rn:R06026','IMPD').
consumed_by0('37486: gl:G00050','40892: rn:R06025','IMPD').
consumed_by0('37490: cpd:C00369','40848: rn:R01790','IMPD').
consumed_by0('36500: gl:G00092','41205: rn:R05937','IMPD').
consumed_by0('37490: cpd:C00369','40846: rn:R02108','IMPD').
consumed_by0('37490: cpd:C00369','40819: rn:R02109','IMPD').
consumed_by0('37785: cpd:C01921','1338: rn:R05835','IMPD').
consumed_by0('37490: cpd:C00369','40843: rn:R02111','IMPD').
consumed_by0('36661: cpd:C16565','5346: rn:R08354','IMPD').
consumed_by0('38551: cpd:C00735','40193: rn:R02841','IMPD').
consumed_by0('38551: cpd:C00735','40197: rn:R02838','IMPD').
consumed_by0('38551: cpd:C00735','40190: rn:R02836 rn:R02834','IMPD').
consumed_by0('36550: cpd:C14839','40050: rn:R07069','IMPD').
consumed_by0('36519: cpd:C00245','40998: rn:R01687','IMPD').
consumed_by0('36519: cpd:C00245','40996: rn:R03720','IMPD').
consumed_by0('37541: cpd:C05437','40343: rn:R07498','IMPD').
consumed_by0('37533: gl:G00162','40609: rn:R05935','IMPD').
consumed_by0('37541: cpd:C05437','40353: rn:R04804','IMPD').
consumed_by0('38548: cpd:C00762','40191: rn:R02893','IMPD').
consumed_by0('37548: cpd:C01164','40352: rn:R01451 rn:R01456','IMPD').
consumed_by0('38546: cpd:C05485','40242: rn:R04163','IMPD').
consumed_by0('38546: cpd:C05485','40243: rn:R04163','IMPD').
consumed_by0('38544: cpd:C05489','40239: rn:R02840','IMPD').
consumed_by0('38544: cpd:C05489','40240: rn:R02840','IMPD').
consumed_by0('36554: cpd:C03344','39728: rn:R00927','IMPD').
consumed_by0('36527: cpd:C00606','41000: rn:R02466','IMPD').
consumed_by0('36527: cpd:C00606','41002: rn:R02466','IMPD').
consumed_by0('37553: cpd:C15816','40327: rn:R07495','IMPD').
consumed_by0('36568: cpd:C03460','39752: rn:R04224','IMPD').
consumed_by0('36565: cpd:C00630','39753: rn:R02661','IMPD').
consumed_by0('37550: cpd:C01189','40340: rn:R03310 rn:R07215','IMPD').
consumed_by0('36565: cpd:C00630','39767: rn:R02661','IMPD').
consumed_by0('37522: cpd:C04079','10102: rn:R02972','IMPD').
consumed_by0('37550: cpd:C01189','40344: rn:R05703','IMPD').
consumed_by0('36565: cpd:C00630','39781: rn:R02661','IMPD').
consumed_by0('37522: cpd:C04079','41365: rn:R04391','IMPD').
consumed_by0('36779: cpd:C00342','2201: rn:R02022','IMPD').
consumed_by0('36565: cpd:C00630','39683: rn:R02661','IMPD').
consumed_by0('36548: cpd:C14786','40129: rn:R07002','IMPD').
consumed_by0('36560: cpd:C03345','39768: rn:R04204','IMPD').
consumed_by0('36505: cpd:C00440','41495: rn:R00946','IMPD').
consumed_by0('36562: cpd:C04405','39751: rn:R04203','IMPD').
consumed_by0('36562: cpd:C04405','39755: rn:R04203','IMPD').
consumed_by0('37514: cpd:C01798','40767: rn:R03527','IMPD').
consumed_by0('36546: cpd:C00184','40679: rn:R01011','IMPD').
consumed_by0('36577: cpd:C16638','39708: rn:R08224','IMPD').
consumed_by0('36534: cpd:C00506','41008: rn:R01682','IMPD').
consumed_by0('36534: cpd:C00506','41010: rn:R01682','IMPD').
consumed_by0('37504: cpd:C14769','40967: rn:R07110','IMPD').
consumed_by0('36572: cpd:C06001','39758: rn:R05066','IMPD').
consumed_by0('36547: cpd:C05378','40496: rn:R01070','IMPD').
consumed_by0('36547: cpd:C05378','40495: rn:R04780','IMPD').
consumed_by0('36572: cpd:C06001','39729: rn:R05066','IMPD').
consumed_by0('36530: cpd:C01678','41004: rn:R02467','IMPD').
consumed_by0('36570: cpd:C06000','39757: rn:R05064','IMPD').
consumed_by0('37508: cpd:C14768','40966: rn:R07111','IMPD').
consumed_by0('36690: cpd:C16664','5359: rn:R08361','IMPD').
consumed_by0('36538: cpd:C00234','41155: rn:R00941','IMPD').
consumed_by0('37515: cpd:C14770','40964: rn:R07109','IMPD').
consumed_by0('36547: cpd:C05378','40880: rn:R01070','IMPD').
consumed_by0('36538: cpd:C00234','41157: rn:R04325','IMPD').
consumed_by0('36538: cpd:C00234','41161: rn:R03940','IMPD').
consumed_by0('36690: cpd:C16664','5323: rn:R08361','IMPD').
consumed_by0('36575: dr:D00536 cpd:C07501','39940: rn:R08304','IMPD').
consumed_by0('36649: cpd:C05223','6539: rn:R05146','IMPD').
consumed_by0('36575: dr:D00536 cpd:C07501','39938: rn:R08303','IMPD').
consumed_by0('36575: dr:D00536 cpd:C07501','39937: rn:R08303','IMPD').
consumed_by0('36575: dr:D00536 cpd:C07501','39936: rn:R08304','IMPD').
consumed_by0('37512: cpd:C14771','40965: rn:R07108','IMPD').
consumed_by0('38521: cpd:C01227','40257: rn:R03405','IMPD').
consumed_by0('38521: cpd:C01227','40251: rn:R01837','IMPD').
consumed_by0('38521: cpd:C01227','40252: rn:R01837','IMPD').
consumed_by0('37531: gl:G00163','40616: rn:R05936','IMPD').
consumed_by0('38521: cpd:C01227','40259: rn:R03408','IMPD').
consumed_by0('38521: cpd:C01227','40224: rn:R08961','IMPD').
consumed_by0('36525: cpd:C03912','41354: rn:R00707 rn:R00708','IMPD').
consumed_by0('38518: cpd:C05139','40261: rn:R04678','IMPD').
consumed_by0('38518: cpd:C05139','40260: rn:R04678','IMPD').
consumed_by0('36340: cpd:C04076','12917: rn:R02317','IMPD').
consumed_by0('36547: cpd:C05378','40946: rn:R04780','IMPD').
consumed_by0('37432: cpd:C00760','40773: rn:R02887','IMPD').
consumed_by0('36558: cpd:C00043','40647: rn:R00414','IMPD').
consumed_by0('36573: cpd:C14840','40168: rn:R07070','IMPD').
consumed_by0('36588: cpd:C02090','5323: rn:R08361','IMPD').
consumed_by0('36588: cpd:C02090','5318: rn:R08358','IMPD').
consumed_by0('36547: cpd:C05378','41049: rn:R01070','IMPD').
consumed_by0('36555: cpd:C00134','40800: rn:R01920','IMPD').
consumed_by0('37424: gl:G00071','40879: rn:R06193','IMPD').
consumed_by0('36547: cpd:C05378','41055: rn:R04780','IMPD').
consumed_by0('36559: cpd:C05762','40690: rn:R04543','IMPD').
consumed_by0('37424: gl:G00071','40897: rn:R06076','IMPD').
consumed_by0('37424: gl:G00071','40899: rn:R06190','IMPD').
consumed_by0('36584: cpd:C16595','39935: rn:R08310','IMPD').
consumed_by0('37427: gl:G10596','40866: rn:R06260','IMPD').
consumed_by0('36583: cpd:C03170','5350: rn:R03821','IMPD').
consumed_by0('36308: cpd:C07585','13665: rn:R08249','IMPD').
consumed_by0('36558: cpd:C00043','5955: rn:R02335','IMPD').
consumed_by0('36424: cpd:C00229','10099: rn:R01623','IMPD').
consumed_by0('36538: cpd:C00234','41493: rn:R04560','IMPD').
consumed_by0('37439: gl:G00074','40901: rn:R06191','IMPD').
consumed_by0('36579: cpd:C00005','5350: rn:R03821','IMPD').
consumed_by0('36727: cpd:C01235','550: rn:R02411','IMPD').
consumed_by0('37734: cpd:C03227','4516: rn:R04172','IMPD').
consumed_by0('36582: cpd:C00794','40459: rn:R00875','IMPD').
consumed_by0('36582: cpd:C00794','40457: rn:R01787','IMPD').
consumed_by0('36506: cpd:C06790','8367: rn:R09151','IMPD').
consumed_by0('36506: cpd:C06790','8368: rn:R09152','IMPD').
consumed_by0('36606: cpd:C06481','5094: rn:R08219','IMPD').
consumed_by0('36555: cpd:C00134','41369: rn:R01154','IMPD').
consumed_by0('37407: gl:G00020','40948: rn:R05991','IMPD').
consumed_by0('36606: cpd:C06481','5079: rn:R08223','IMPD').
consumed_by0('37408: gl:G00021','40954: rn:R05992','IMPD').
consumed_by0('38566: cpd:C05498','40264: rn:R03849','IMPD').
consumed_by0('36601: dr:D08086 cpd:C16641','39962: rn:R08255','IMPD').
consumed_by0('36580: cpd:C05761','40628: rn:R04968','IMPD').
consumed_by0('36580: cpd:C05761','40629: rn:R08159','IMPD').
consumed_by0('38568: cpd:C05497','40188: rn:R04852','IMPD').
consumed_by0('36580: cpd:C05761','40635: rn:R08159','IMPD').
consumed_by0('36555: cpd:C00134','41503: rn:R01920','IMPD').
consumed_by0('36555: cpd:C00134','41500: rn:R01151','IMPD').
consumed_by0('37459: cpd:C02430','39702: rn:R03940','IMPD').
consumed_by0('36749: cpd:C00492','528: rn:R02410','IMPD').
consumed_by0('36580: cpd:C05761','40695: rn:R04968','IMPD').
consumed_by0('37424: gl:G00071','40822: rn:R06076','IMPD').
consumed_by0('37403: cpd:C00988','41295: rn:R01334','IMPD').
consumed_by0('36588: cpd:C02090','5358: rn:R08358','IMPD').
consumed_by0('36588: cpd:C02090','5359: rn:R08361','IMPD').
consumed_by0('36587: cpd:C05760','40700: rn:R04967','IMPD').
consumed_by0('37419: gl:G00073','40881: rn:R06041','IMPD').
consumed_by0('36577: cpd:C16638','40963: rn:R08224','IMPD').
consumed_by0('36590: cpd:C04688','40702: rn:R04568','IMPD').
consumed_by0('36578: cpd:C16331','41105: rn:R07892','IMPD').
consumed_by0('36608: cpd:C00117','40185: rn:R01049','IMPD').
consumed_by0('36580: cpd:C05761','6540: rn:R05075','IMPD').
consumed_by0('36595: cpd:C05759','40708: rn:R04566','IMPD').
consumed_by0('36588: cpd:C02090','40812: rn:R08364','IMPD').
consumed_by0('36579: cpd:C00005','41103: rn:R00115','IMPD').
consumed_by0('36602: gl:G00012','40611: rn:R05983','IMPD').
consumed_by0('37494: cpd:C05512','40114: rn:R02748','IMPD').
consumed_by0('36603: cpd:C04633','40688: rn:R04544','IMPD').
consumed_by0('36594: gl:G00014','40908: rn:R05985','IMPD').
consumed_by0('38595: cpd:C05138','40235: rn:R03327','IMPD').
consumed_by0('38595: cpd:C05138','40236: rn:R03327','IMPD').
consumed_by0('38595: cpd:C05138','40250: rn:R04675','IMPD').
consumed_by0('38449: cpd:C01081','9799: rn:R02135','IMPD').
consumed_by0('36614: cpd:C05764','40633: rn:R07762','IMPD').
consumed_by0('36596: cpd:C16335','41107: rn:R07896','IMPD').
consumed_by0('36610: cpd:C05763','40687: rn:R04970','IMPD').
consumed_by0('37443: cpd:C00252','40815: rn:R01718','IMPD').
consumed_by0('36609: gl:G00013','40910: rn:R05984','IMPD').
consumed_by0('36637: cpd:C16635','40010: rn:R08221','IMPD').
consumed_by0('37455: gl:G00081','40884: rn:R06227','IMPD').
consumed_by0('36614: cpd:C05764','40684: rn:R01706','IMPD').
consumed_by0('36614: cpd:C05764','40682: rn:R01706','IMPD').
consumed_by0('37455: gl:G00081','40839: rn:R06227','IMPD').
consumed_by0('36627: cpd:C05726','5286: rn:R04950','IMPD').
consumed_by0('36621: cpd:C05755','40662: rn:R04963','IMPD').
consumed_by0('36608: cpd:C00117','41050: rn:R01056','IMPD').
consumed_by0('36638: cpd:C00750','4907: rn:R09076','IMPD').
consumed_by0('36621: cpd:C05755','40625: rn:R04963','IMPD').
consumed_by0('36608: cpd:C00117','41033: rn:R01049','IMPD').
consumed_by0('37451: gl:G00055','40876: rn:R06187','IMPD').
consumed_by0('37451: gl:G00055','40871: rn:R06029','IMPD').
consumed_by0('37451: gl:G00055','40865: rn:R06095','IMPD').
consumed_by0('37458: cpd:C03289','40610: rn:R00647','IMPD').
consumed_by0('37451: gl:G00055','40820: rn:R06095','IMPD').
consumed_by0('36687: cpd:C01209','40428: rn:R04355','IMPD').
consumed_by0('36676: cpd:C16663','40797: rn:R08363','IMPD').
consumed_by0('35945: cpd:C00183','9007: rn:R01438','IMPD').
consumed_by0('35955: cpd:C00026','8705: rn:R00474','IMPD').
consumed_by0('37895: cpd:C00473','41401: rn:R02124 rn:R08379','IMPD').
consumed_by0('36063: cpd:C00029','5392: rn:R00806','IMPD').
consumed_by0('36063: cpd:C00029','5395: rn:R02889','IMPD').
consumed_by0('37895: cpd:C00473','41399: rn:R02124 rn:R08379','IMPD').
consumed_by0('36063: cpd:C00029','5393: rn:R03526','IMPD').
consumed_by0('37895: cpd:C00473','41414: rn:R07163','IMPD').
consumed_by0('37895: cpd:C00473','41433: rn:R02124','IMPD').
consumed_by0('36157: cpd:C00188','2516: rn:R00996','IMPD').
consumed_by0('37895: cpd:C00473','41425: rn:R08387','IMPD').
consumed_by0('36687: cpd:C01209','40625: rn:R04963','IMPD').
consumed_by0('36687: cpd:C01209','40627: rn:R04726','IMPD').
consumed_by0('36687: cpd:C01209','40628: rn:R04968','IMPD').
consumed_by0('36687: cpd:C01209','40623: rn:R04960','IMPD').
consumed_by0('36687: cpd:C01209','40633: rn:R07762','IMPD').
consumed_by0('36687: cpd:C01209','40662: rn:R04963','IMPD').
consumed_by0('36686: cpd:C00352','40710: rn:R02058','IMPD').
consumed_by0('36687: cpd:C01209','40676: rn:R04957','IMPD').
consumed_by0('36687: cpd:C01209','40674: rn:R04952','IMPD').
consumed_by0('36687: cpd:C01209','40672: rn:R04957','IMPD').
consumed_by0('36687: cpd:C01209','40668: rn:R04960','IMPD').
consumed_by0('36990: cpd:C00672','168: rn:R02749','IMPD').
consumed_by0('36682: cpd:C00162','40384: rn:R01347 rn:R01348','IMPD').
consumed_by0('36682: cpd:C00162','40387: rn:R00631','IMPD').
consumed_by0('36672: cpd:C05752','40668: rn:R04960','IMPD').
consumed_by0('36674: cpd:C05751','40667: rn:R04959','IMPD').
consumed_by0('36234: cpd:C00800','293: rn:R01481','IMPD').
consumed_by0('36883: cpd:C00166','3862: rn:R01377','IMPD').
consumed_by0('36683: cpd:C00665','40449: rn:R02731','IMPD').
consumed_by0('37910: cpd:C00422','40670: rn:R02250','IMPD').
consumed_by0('36184: cpd:C00044','1880: rn:R02020','IMPD').
consumed_by0('35944: cpd:C00024','9323: rn:R01196','IMPD').
consumed_by0('36184: cpd:C00044','1884: rn:R00429','IMPD').
consumed_by0('35952: cpd:C00022','9123: rn:R00212','IMPD').
consumed_by0('35952: cpd:C00022','9122: rn:R01196','IMPD').
consumed_by0('37910: cpd:C00422','40699: rn:R01350','IMPD').
consumed_by0('36675: cpd:C03939','40742: rn:R04355','IMPD').
consumed_by0('36239: cpd:C00181','280: rn:R01432','IMPD').
consumed_by0('38894: cpd:C03688','41357: rn:R01625','IMPD').
consumed_by0('36909: cpd:C00458','2205: rn:R02325','IMPD').
consumed_by0('37919: cpd:C05648','41302: rn:R04911','IMPD').
consumed_by0('36909: cpd:C00458','2209: rn:R01668','IMPD').
consumed_by0('36664: cpd:C05746','40728: rn:R04953','IMPD').
consumed_by0('36688: cpd:C16543','39966: rn:R08258','IMPD').
consumed_by0('36668: cpd:C04620','40669: rn:R04537','IMPD').
consumed_by0('36550: cpd:C14839','13236: rn:R07073','IMPD').
consumed_by0('36675: cpd:C03939','40428: rn:R04355','IMPD').
consumed_by0('36672: cpd:C05752','40623: rn:R04960','IMPD').
consumed_by0('36669: cpd:C05750','40673: rn:R04536','IMPD').
consumed_by0('36667: cpd:C05747','40725: rn:R04954','IMPD').
consumed_by0('36909: cpd:C00458','2148: rn:R07307','IMPD').
consumed_by0('38898: cpd:C00153','41538: rn:R01269','IMPD').
consumed_by0('36212: cpd:C00159','392: rn:R00877','IMPD').
consumed_by0('36116: cpd:C00062','3359: rn:R08197','IMPD').
consumed_by0('36638: cpd:C00750','41188: rn:R02869','IMPD').
consumed_by0('36638: cpd:C00750','41187: rn:R02869','IMPD').
consumed_by0('36680: cpd:C11376','39964: rn:R08260','IMPD').
consumed_by0('36135: cpd:C00233','2837: rn:R08566','IMPD').
consumed_by0('36660: cpd:C05749','40676: rn:R04957','IMPD').
consumed_by0('36660: cpd:C05749','40672: rn:R04957','IMPD').
consumed_by0('36681: cpd:C11173','40006: rn:R08259','IMPD').
consumed_by0('36657: cpd:C05748','40732: rn:R04956','IMPD').
consumed_by0('36116: cpd:C00062','3471: rn:R05465','IMPD').
consumed_by0('35951: cpd:C00136','8707: rn:R01180','IMPD').
consumed_by0('36632: cpd:C05729','41111: rn:R04951','IMPD').
consumed_by0('35957: cpd:C00036','9581: rn:R00341','IMPD').
consumed_by0('36839: cpd:C02505','3875: rn:R02540','IMPD').
consumed_by0('35952: cpd:C00022','9749: rn:R01196','IMPD').
consumed_by0('36649: cpd:C05223','40630: rn:R04014','IMPD').
consumed_by0('36649: cpd:C05223','40627: rn:R04726','IMPD').
consumed_by0('35955: cpd:C00026','9673: rn:R00267','IMPD').
consumed_by0('35952: cpd:C00022','9923: rn:R01147','IMPD').
consumed_by0('37868: cpd:C00978','41293: rn:R03130','IMPD').
consumed_by0('36162: cpd:C00315','3423: rn:R01915','IMPD').
consumed_by0('36105: cpd:C00515','5218: rn:R00672','IMPD').
consumed_by0('36105: cpd:C00515','5217: rn:R00672','IMPD').
consumed_by0('36831: cpd:C07086','3961: rn:R05487','IMPD').
consumed_by0('36649: cpd:C05223','40711: rn:R04726','IMPD').
consumed_by0('36643: gl:G00011','40904: rn:R05982','IMPD').
consumed_by0('36861: cpd:C00386','3502: rn:R02144','IMPD').
consumed_by0('37864: cpd:C05635','41292: rn:R04905','IMPD').
consumed_by0('37736: cpd:C03692','6651: rn:R04471','IMPD').
consumed_by0('36105: cpd:C00515','5219: rn:R00672','IMPD').
consumed_by0('35955: cpd:C00026','9921: rn:R01580','IMPD').
consumed_by0('36640: cpd:C05757','40648: rn:R04965','IMPD').
consumed_by0('38848: cpd:C03722','41565: rn:R03348','IMPD').
consumed_by0('36897: cpd:C00063','2255: rn:R00515','IMPD').
consumed_by0('35998: cpd:C00048','8743: rn:R00013','IMPD').
consumed_by0('38855: cpd:C00455','41514: rn:R00137','IMPD').
consumed_by0('36645: cpd:C05758','40651: rn:R04725','IMPD').
consumed_by0('38855: cpd:C00455','41516: rn:R00137','IMPD').
consumed_by0('38855: cpd:C00455','41518: rn:R02323','IMPD').
consumed_by0('37876: cpd:C03546','40764: rn:R01186','IMPD').
consumed_by0('38855: cpd:C00455','41519: rn:R01271','IMPD').
consumed_by0('36129: cpd:C00074','4628: rn:R01826','IMPD').
consumed_by0('36110: cpd:C00792','5222: rn:R02458','IMPD').
consumed_by0('36897: cpd:C00063','2201: rn:R02022','IMPD').
consumed_by0('36613: cpd:C00006','41567: rn:R00119','IMPD').
consumed_by0('36630: cpd:C16327','41091: rn:R07888','IMPD').
consumed_by0('35998: cpd:C00048','8707: rn:R01180','IMPD').
consumed_by0('35998: cpd:C00048','8705: rn:R00474','IMPD').
consumed_by0('38898: cpd:C00153','9993: rn:R01268','IMPD').
consumed_by0('38858: cpd:C01185','41564: rn:R03346','IMPD').
consumed_by0('36157: cpd:C00188','2928: rn:R00996','IMPD').
consumed_by0('36631: cpd:C05753','40666: rn:R04534','IMPD').
consumed_by0('36656: cpd:C00940','39888: rn:R00269','IMPD').
consumed_by0('38858: cpd:C01185','41524: rn:R03005','IMPD').
consumed_by0('38858: cpd:C01185','41525: rn:R03005','IMPD').
consumed_by0('38858: cpd:C01185','41529: rn:R01724','IMPD').
consumed_by0('36654: cpd:C00105','39924: rn:R00158','IMPD').
consumed_by0('36654: cpd:C00105','39916: rn:R00963','IMPD').
consumed_by0('36654: cpd:C00105','39919: rn:R00966','IMPD').
consumed_by0('38864: cpd:C00003','41536: rn:R00102','IMPD').
consumed_by0('38864: cpd:C00003','41542: rn:R00112','IMPD').
consumed_by0('38864: cpd:C00003','41540: rn:R00104','IMPD').
consumed_by0('36234: cpd:C00800','654: rn:R01481','IMPD').
consumed_by0('35944: cpd:C00024','9659: rn:R01196','IMPD').
consumed_by0('36632: cpd:C05729','40804: rn:R04951','IMPD').
consumed_by0('38864: cpd:C00003','41512: rn:R00103','IMPD').
consumed_by0('38864: cpd:C00003','41511: rn:R00103','IMPD').
consumed_by0('36636: cpd:C05756','40655: rn:R04964','IMPD').
consumed_by0('38867: cpd:C00857','41566: rn:R03004','IMPD').
consumed_by0('38867: cpd:C00857','41563: rn:R03004','IMPD').
consumed_by0('36831: cpd:C07086','3943: rn:R06790','IMPD').
consumed_by0('36625: cpd:C05754','40658: rn:R04962','IMPD').
consumed_by0('36647: dr:D00343 cpd:C07047','39959: rn:R08285','IMPD').
consumed_by0('38867: cpd:C00857','41528: rn:R00257','IMPD').
consumed_by0('37878: cpd:C00780','41304: rn:R02908','IMPD').
consumed_by0('37878: cpd:C00780','41298: rn:R02910','IMPD').
consumed_by0('37878: cpd:C00780','41291: rn:R02909','IMPD').
consumed_by0('37878: cpd:C00780','41294: rn:R02911','IMPD').
consumed_by0('35944: cpd:C00024','9703: rn:R00230','IMPD').
consumed_by0('37877: cpd:C05634','41303: rn:R04903','IMPD').
consumed_by0('37877: cpd:C05634','41300: rn:R04904','IMPD').
consumed_by0('36652: cpd:C16612','39943: rn:R08349','IMPD').
consumed_by0('36629: cpd:C04619','40664: rn:R04535','IMPD').
consumed_by0('35982: cpd:C00149','8744: rn:R00472','IMPD').
consumed_by0('38872: cpd:C03150','41520: rn:R02294','IMPD').
consumed_by0('36644: cpd:C07490','40160: rn:R07106','IMPD').
consumed_by0('38870: cpd:C02918','41545: rn:R04085','IMPD').
consumed_by0('38870: cpd:C02918','41544: rn:R08408','IMPD').
consumed_by0('36613: cpd:C00006','41117: rn:R00267','IMPD').
consumed_by0('36613: cpd:C00006','41113: rn:R02736','IMPD').
consumed_by0('36647: dr:D00343 cpd:C07047','40033: rn:R08285','IMPD').
consumed_by0('36613: cpd:C00006','41102: rn:R01528','IMPD').
consumed_by0('36648: dr:D01309 cpd:C12739','40000: rn:R08222','IMPD').
consumed_by0('36647: dr:D00343 cpd:C07047','40026: rn:R08285','IMPD').
consumed_by0('36644: cpd:C07490','40103: rn:R07107','IMPD').
consumed_by0('35992: cpd:C00083','9679: rn:R00740','IMPD').
consumed_by0('36771: cpd:C05011','40040: rn:R08269','IMPD').
consumed_by0('36743: gl:G00015','40906: rn:R05987','IMPD').
consumed_by0('36773: cpd:C00075','39968: rn:R00662','IMPD').
consumed_by0('37852: cpd:C04520','40752: rn:R03479','IMPD').
consumed_by0('36743: gl:G00015','40955: rn:R05986','IMPD').
consumed_by0('36743: gl:G00015','40952: rn:R05988','IMPD').
consumed_by0('36754: cpd:C05268','40422: rn:R04749','IMPD').
consumed_by0('36736: cpd:C00236','40961: rn:R01662','IMPD').
consumed_by0('36754: cpd:C05268','40407: rn:R04749','IMPD').
consumed_by0('36754: cpd:C05268','40406: rn:R04748','IMPD').
consumed_by0('36754: cpd:C05268','40410: rn:R04748','IMPD').
consumed_by0('37865: cpd:C01177','40456: rn:R01185','IMPD').
consumed_by0('36773: cpd:C00075','39923: rn:R00571 rn:R00573','IMPD').
consumed_by0('36773: cpd:C00075','39922: rn:R00159','IMPD').
consumed_by0('36773: cpd:C00075','39927: rn:R00443','IMPD').
consumed_by0('36880: cpd:C01176','1700: rn:R01841','IMPD').
consumed_by0('36024: cpd:C00109','8907: rn:R06987','IMPD').
consumed_by0('36755: cpd:C04555','40258: rn:R03404','IMPD').
consumed_by0('37826: cpd:C00398','41301: rn:R02173','IMPD').
consumed_by0('37826: cpd:C00398','41299: rn:R02173','IMPD').
consumed_by0('37826: cpd:C00398','41297: rn:R02174','IMPD').
consumed_by0('36749: cpd:C00492','40541: rn:R01103','IMPD').
consumed_by0('35992: cpd:C00083','9750: rn:R00740','IMPD').
consumed_by0('36747: cpd:C05269','40420: rn:R04748','IMPD').
consumed_by0('36886: cpd:C00410','1681: rn:R02208','IMPD').
consumed_by0('36747: cpd:C05269','40421: rn:R04748','IMPD').
consumed_by0('37848: cpd:C01220','40745: rn:R03393','IMPD').
consumed_by0('36038: cpd:C00084','7717: rn:R00228','IMPD').
consumed_by0('36748: cpd:C05499','40230: rn:R04676','IMPD').
consumed_by0('37935: cpd:C04282','3432: rn:R02280','IMPD').
consumed_by0('37871: gl:G13033','40588: rn:R07809','IMPD').
consumed_by0('36745: cpd:C05270','40412: rn:R04747','IMPD').
consumed_by0('36745: cpd:C05270','40411: rn:R04751','IMPD').
consumed_by0('36745: cpd:C05270','40416: rn:R04747','IMPD').
consumed_by0('36745: cpd:C05270','40409: rn:R04751','IMPD').
consumed_by0('36745: cpd:C05270','40408: rn:R04751','IMPD').
consumed_by0('36745: cpd:C05270','40398: rn:R04751','IMPD').
consumed_by0('36745: cpd:C05270','40363: rn:R04751','IMPD').
consumed_by0('36038: cpd:C00084','7744: rn:R00753','IMPD').
consumed_by0('36744: cpd:C01953','40248: rn:R08942','IMPD').
consumed_by0('36744: cpd:C01953','40249: rn:R08943','IMPD').
consumed_by0('36744: cpd:C01953','40246: rn:R02216','IMPD').
consumed_by0('37853: cpd:C01598','41319: rn:R03628','IMPD').
consumed_by0('36744: cpd:C01953','40247: rn:R08978','IMPD').
consumed_by0('36744: cpd:C01953','40244: rn:R03784','IMPD').
consumed_by0('36744: cpd:C01953','40253: rn:R03783','IMPD').
consumed_by0('36738: cpd:C05271','40423: rn:R06985','IMPD').
consumed_by0('36744: cpd:C01953','40237: rn:R02216','IMPD').
consumed_by0('37853: cpd:C01598','41318: rn:R03629','IMPD').
consumed_by0('36734: cpd:C05400','40544: rn:R01329','IMPD').
consumed_by0('38995: cpd:C05443','40321: rn:R03611','IMPD').
consumed_by0('36116: cpd:C00062','5224: rn:R00567','IMPD').
consumed_by0('36717: cpd:C00151','41120: rn:R01262','IMPD').
consumed_by0('37873: cpd:C04637','40727: rn:R04404','IMPD').
consumed_by0('35998: cpd:C00048','9209: rn:R00932','IMPD').
consumed_by0('35952: cpd:C00022','10650: rn:R05636','IMPD').
consumed_by0('36733: cpd:C05266','40419: rn:R04746','IMPD').
consumed_by0('36740: cpd:C00468','40203: rn:R02356','IMPD').
consumed_by0('36733: cpd:C05266','40413: rn:R04745','IMPD').
consumed_by0('36733: cpd:C05266','40414: rn:R04746','IMPD').
consumed_by0('36038: cpd:C00084','7951: rn:R00228','IMPD').
consumed_by0('36740: cpd:C00468','40218: rn:R02354 rn:R02355','IMPD').
consumed_by0('36740: cpd:C00468','40217: rn:R02358','IMPD').
consumed_by0('35998: cpd:C00048','9275: rn:R00934','IMPD').
consumed_by0('37842: cpd:C00637','41305: rn:R02678','IMPD').
consumed_by0('36152: cpd:C00108','4473: rn:R01816','IMPD').
consumed_by0('37869: cpd:C04549','40474: rn:R05802','IMPD').
consumed_by0('38855: cpd:C00455','9991: rn:R02322','IMPD').
consumed_by0('35982: cpd:C00149','9584: rn:R00214','IMPD').
consumed_by0('36727: cpd:C01235','40512: rn:R01194','IMPD').
consumed_by0('35982: cpd:C00149','9605: rn:R00216','IMPD').
consumed_by0('36038: cpd:C00084','7859: rn:R00228','IMPD').
consumed_by0('36728: cpd:C01944','40439: rn:R03778','IMPD').
consumed_by0('35982: cpd:C00149','9574: rn:R00216','IMPD').
consumed_by0('36193: cpd:C00047','3027: rn:R00457','IMPD').
consumed_by0('36733: cpd:C05266','40382: rn:R04745','IMPD').
consumed_by0('36732: cpd:C05267','40417: rn:R04745','IMPD').
consumed_by0('36732: cpd:C05267','40418: rn:R04745','IMPD').
consumed_by0('37871: gl:G13033','40573: rn:R07809','IMPD').
consumed_by0('36193: cpd:C00047','3122: rn:R00462','IMPD').
consumed_by0('37873: cpd:C04637','40461: rn:R03435','IMPD').
consumed_by0('37873: cpd:C04637','40460: rn:R04545','IMPD').
consumed_by0('37828: gl:G13037','6419: rn:R07815','IMPD').
consumed_by0('36056: cpd:C00258','8742: rn:R01745 rn:R01747','IMPD').
consumed_by0('36056: cpd:C00258','8741: rn:R01388','IMPD').
consumed_by0('36056: cpd:C00258','8740: rn:R01392','IMPD').
consumed_by0('36056: cpd:C00258','8739: rn:R01388 rn:R01392','IMPD').
consumed_by0('37824: gl:G13036','40579: rn:R07814','IMPD').
consumed_by0('36728: cpd:C01944','40383: rn:R03777','IMPD').
consumed_by0('35959: cpd:C00049','11734: rn:R00493','IMPD').
consumed_by0('36728: cpd:C01944','40380: rn:R03778','IMPD').
consumed_by0('36056: cpd:C00258','8770: rn:R01388','IMPD').
consumed_by0('36728: cpd:C01944','40415: rn:R03777','IMPD').
consumed_by0('35959: cpd:C00049','11692: rn:R00490','IMPD').
consumed_by0('35959: cpd:C00049','11691: rn:R00490','IMPD').
consumed_by0('35959: cpd:C00049','11694: rn:R00482','IMPD').
consumed_by0('35959: cpd:C00049','11693: rn:R00483','IMPD').
consumed_by0('37824: gl:G13036','40534: rn:R07814','IMPD').
consumed_by0('36737: cpd:C16546','40031: rn:R08270','IMPD').
consumed_by0('36737: cpd:C16546','40032: rn:R08272','IMPD').
consumed_by0('36724: cpd:C05276','40440: rn:R03776','IMPD').
consumed_by0('36737: cpd:C16546','40042: rn:R08274','IMPD').
consumed_by0('36723: cpd:C05399','40514: rn:R02926','IMPD').
consumed_by0('36728: cpd:C01944','40364: rn:R03777','IMPD').
consumed_by0('36162: cpd:C00315','5339: rn:R01917','IMPD').
consumed_by0('38910: cpd:C05841','41522: rn:R02295','IMPD').
consumed_by0('38910: cpd:C05841','41523: rn:R03347','IMPD').
consumed_by0('36031: cpd:C00011','9332: rn:R00134','IMPD').
consumed_by0('36784: cpd:C01262','3501: rn:R03288','IMPD').
consumed_by0('36720: cpd:C05262','40432: rn:R04170','IMPD').
consumed_by0('36721: cpd:C05275','40443: rn:R04753','IMPD').
consumed_by0('36162: cpd:C00315','5288: rn:R01917','IMPD').
consumed_by0('36720: cpd:C05262','40374: rn:R04170','IMPD').
consumed_by0('36720: cpd:C05262','40373: rn:R04741','IMPD').
consumed_by0('36720: cpd:C05262','40393: rn:R04741','IMPD').
consumed_by0('36524: cpd:C00053','11797: rn:R02021','IMPD').
consumed_by0('36031: cpd:C00011','9698: rn:R00134','IMPD').
consumed_by0('36031: cpd:C00011','9715: rn:R09317','IMPD').
consumed_by0('36716: cpd:C05274','40442: rn:R04742','IMPD').
consumed_by0('37821: gl:G12336','40559: rn:R07823','IMPD').
consumed_by0('36716: cpd:C05274','40379: rn:R04754','IMPD').
consumed_by0('36095: cpd:C00111','7672: rn:R01016','IMPD').
consumed_by0('36716: cpd:C05274','40376: rn:R04754','IMPD').
consumed_by0('36716: cpd:C05274','40375: rn:R04742','IMPD').
consumed_by0('36329: cpd:C01094','425: rn:R02071','IMPD').
consumed_by0('37821: gl:G12336','40577: rn:R07823','IMPD').
consumed_by0('36031: cpd:C00011','9661: rn:R00345','IMPD').
consumed_by0('36031: cpd:C00011','9659: rn:R01196','IMPD').
consumed_by0('36031: cpd:C00011','9672: rn:R01197','IMPD').
consumed_by0('37821: gl:G12336','40571: rn:R07825','IMPD').
consumed_by0('36031: cpd:C00011','9673: rn:R00267','IMPD').
consumed_by0('36715: cpd:C05263','40441: rn:R04741','IMPD').
consumed_by0('36025: cpd:C00118','9873: rn:R07456','IMPD').
consumed_by0('36025: cpd:C00118','9872: rn:R07456','IMPD').
consumed_by0('36031: cpd:C00011','9572: rn:R00345','IMPD').
consumed_by0('37818: gl:G13042','40566: rn:R07822','IMPD').
consumed_by0('36702: cpd:C04246','40734: rn:R04430','IMPD').
consumed_by0('35960: cpd:C00025','11778: rn:R01339','IMPD').
consumed_by0('35966: cpd:C00019','11600: rn:R03726','IMPD').
consumed_by0('37818: gl:G13042','40583: rn:R07822','IMPD').
consumed_by0('36031: cpd:C00011','9598: rn:R00024','IMPD').
consumed_by0('36031: cpd:C00011','9603: rn:R00345','IMPD').
consumed_by0('36716: cpd:C05274','40357: rn:R04754','IMPD').
consumed_by0('36713: cpd:C05265','40437: rn:R04743','IMPD').
consumed_by0('36713: cpd:C05265','40438: rn:R04743','IMPD').
consumed_by0('38812: cpd:C00378','9798: rn:R02134','IMPD').
consumed_by0('36729: cpd:C00279','4628: rn:R01826','IMPD').
consumed_by0('36162: cpd:C00315','4908: rn:R09077','IMPD').
consumed_by0('36164: cpd:C00222','4845: rn:R01611','IMPD').
consumed_by0('36709: cpd:C01832','40430: rn:R03858','IMPD').
consumed_by0('37843: cpd:C01284','40458: rn:R05202','IMPD').
consumed_by0('36698: cpd:C04618','40750: rn:R04533','IMPD').
consumed_by0('36709: cpd:C01832','40391: rn:R03858','IMPD').
consumed_by0('36709: cpd:C01832','40392: rn:R03857','IMPD').
consumed_by0('36698: cpd:C04618','40735: rn:R04428','IMPD').
consumed_by0('36162: cpd:C00315','4857: rn:R01914','IMPD').
consumed_by0('36709: cpd:C01832','40372: rn:R03857','IMPD').
consumed_by0('36706: cpd:C05264','40444: rn:R04744','IMPD').
consumed_by0('36709: cpd:C01832','40358: rn:R03857','IMPD').
consumed_by0('37840: cpd:C04063','40746: rn:R04372','IMPD').
consumed_by0('35941: cpd:C00014','11694: rn:R00482','IMPD').
consumed_by0('35941: cpd:C00014','11693: rn:R00483','IMPD').
consumed_by0('36705: cpd:C03221','40431: rn:R03856','IMPD').
consumed_by0('36706: cpd:C05264','40381: rn:R04743','IMPD').
consumed_by0('36706: cpd:C05264','40377: rn:R04743','IMPD').
consumed_by0('36706: cpd:C05264','40378: rn:R04744','IMPD').
consumed_by0('37799: gl:G13039','6442: rn:R07817','IMPD').
consumed_by0('37834: gl:G13035','40567: rn:R07813','IMPD').
consumed_by0('37834: gl:G13035','40578: rn:R07813','IMPD').
consumed_by0('37832: gl:G13034','40584: rn:R07812','IMPD').
consumed_by0('36672: cpd:C05752','41338: rn:R07768','IMPD').
consumed_by0('37799: gl:G13039','6423: rn:R07817','IMPD').
consumed_by0('36266: cpd:C00008','1937: rn:R00126','IMPD').
consumed_by0('36672: cpd:C05752','41327: rn:R07766','IMPD').
consumed_by0('36691: cpd:C05745','40738: rn:R04952','IMPD').
consumed_by0('37832: gl:G13034','40564: rn:R07812','IMPD').
consumed_by0('36028: cpd:C00168','9327: rn:R01388','IMPD').
consumed_by0('36079: cpd:C00058','7692: rn:R00212','IMPD').
consumed_by0('36691: cpd:C05745','40674: rn:R04952','IMPD').
consumed_by0('35946: cpd:C00152','11779: rn:R00485','IMPD').
consumed_by0('36687: cpd:C01209','40742: rn:R04355','IMPD').
consumed_by0('37856: cpd:C00331','4503: rn:R01974','IMPD').
consumed_by0('36623: cpd:C11150','8295: rn:R09158','IMPD').
consumed_by0('36687: cpd:C01209','40738: rn:R04952','IMPD').
consumed_by0('36092: cpd:C01595','7206: rn:R07063','IMPD').
consumed_by0('36687: cpd:C01209','40695: rn:R04968','IMPD').
consumed_by0('37856: cpd:C00331','4451: rn:R01974','IMPD').
consumed_by0('36687: cpd:C01209','40711: rn:R04726','IMPD').
consumed_by0('36972: cpd:C05688','5097: rn:R04931','IMPD').
consumed_by0('35952: cpd:C00022','4926: rn:R05652','IMPD').
consumed_by0('37764: cpd:C00643','41288: rn:R02702','IMPD').
consumed_by0('37764: cpd:C00643','41287: rn:R02701','IMPD').
consumed_by0('36814: gl:G00147','40475: rn:R05921','IMPD').
consumed_by0('36017: cpd:C05125','2957: rn:R04673','IMPD').
consumed_by0('36793: cpd:C01419','41121: rn:R00899','IMPD').
consumed_by0('35992: cpd:C00083','3839: rn:R09090','IMPD').
consumed_by0('36796: cpd:C03740','41108: rn:R03749','IMPD').
consumed_by0('35944: cpd:C00024','5286: rn:R04950','IMPD').
consumed_by0('36832: dr:D07760 cpd:C07888','40035: rn:R08275','IMPD').
consumed_by0('36832: dr:D07760 cpd:C07888','40036: rn:R08275','IMPD').
consumed_by0('36832: dr:D07760 cpd:C07888','40037: rn:R08276','IMPD').
consumed_by0('36832: dr:D07760 cpd:C07888','40038: rn:R08275','IMPD').
consumed_by0('37765: cpd:C00921','41449: rn:R02237','IMPD').
consumed_by0('36818: gl:G00146','40480: rn:R05920','IMPD').
consumed_by0('37797: gl:G13038','40572: rn:R07816','IMPD').
consumed_by0('36839: cpd:C02505','9048: rn:R02540','IMPD').
consumed_by0('37773: cpd:C02700','41277: rn:R03936','IMPD').
consumed_by0('35944: cpd:C00024','4921: rn:R00230','IMPD').
consumed_by0('37773: cpd:C02700','41285: rn:R01959','IMPD').
consumed_by0('36822: gl:G00144','40476: rn:R05918','IMPD').
consumed_by0('36822: gl:G00144','40478: rn:R06623','IMPD').
consumed_by0('37789: gl:G13040','40568: rn:R07818','IMPD').
consumed_by0('37789: gl:G13040','40585: rn:R07818','IMPD').
consumed_by0('36804: cpd:C01879','41122: rn:R00251','IMPD').
consumed_by0('37793: gl:G09660','40569: rn:R07819','IMPD').
consumed_by0('36803: cpd:C00669','41118: rn:R00497','IMPD').
consumed_by0('36803: cpd:C00669','41119: rn:R02743','IMPD').
consumed_by0('36956: cpd:C05172','5094: rn:R08219','IMPD').
consumed_by0('36774: cpd:C02320','41112: rn:R03916','IMPD').
consumed_by0('37774: cpd:C05923','41454: rn:R05048','IMPD').
consumed_by0('37806: cpd:C01277','40465: rn:R05795','IMPD').
consumed_by0('37803: gl:G13032','40561: rn:R07807','IMPD').
consumed_by0('37803: gl:G13032','40586: rn:R07807','IMPD').
consumed_by0('36831: cpd:C07086','9063: rn:R05487','IMPD').
consumed_by0('37797: gl:G13038','40582: rn:R07816','IMPD').
consumed_by0('37000: cpd:C00544','3638: rn:R02518','IMPD').
consumed_by0('35990: cpd:C00300','3353: rn:R01566','IMPD').
consumed_by0('36824: cpd:C15977','39747: rn:R02662','IMPD').
consumed_by0('37000: cpd:C00544','3699: rn:R02520','IMPD').
consumed_by0('37778: cpd:C00328','41276: rn:R01960','IMPD').
consumed_by0('37778: cpd:C00328','41275: rn:R00987','IMPD').
consumed_by0('36772: cpd:C00010','41357: rn:R01625','IMPD').
consumed_by0('37778: cpd:C00328','41266: rn:R01956','IMPD').
consumed_by0('37999: cpd:C05946','3343: rn:R00471','IMPD').
consumed_by0('37999: cpd:C05946','3344: rn:R00471','IMPD').
consumed_by0('37999: cpd:C05946','3345: rn:R00471','IMPD').
consumed_by0('38001: cpd:C04281','3286: rn:R04443','IMPD').
consumed_by0('38003: cpd:C01165','3246: rn:R03314','IMPD').
consumed_by0('37812: gl:G13031','40565: rn:R07806','IMPD').
consumed_by0('37784: cpd:C03541','41441: rn:R04242','IMPD').
consumed_by0('37806: cpd:C01277','40754: rn:R03469','IMPD').
consumed_by0('36793: cpd:C01419','40807: rn:R00899','IMPD').
consumed_by0('37812: gl:G13031','40587: rn:R07806','IMPD').
consumed_by0('37813: gl:G13043','40563: rn:R07824','IMPD').
consumed_by0('37813: gl:G13043','40574: rn:R07824','IMPD').
consumed_by0('37813: gl:G13043','40576: rn:R07824','IMPD').
consumed_by0('36806: gl:G10610','40479: rn:R05916','IMPD').
consumed_by0('36806: gl:G10610','40468: rn:R05916','IMPD').
consumed_by0('36784: cpd:C01262','41151: rn:R03288','IMPD').
consumed_by0('36806: gl:G10610','40469: rn:R05916','IMPD').
consumed_by0('36806: gl:G10610','40466: rn:R05916','IMPD').
consumed_by0('36806: gl:G10610','40467: rn:R05916','IMPD').
consumed_by0('37801: cpd:C05981','40741: rn:R04513','IMPD').
consumed_by0('36806: gl:G10610','40487: rn:R05916','IMPD').
consumed_by0('36806: gl:G10610','40486: rn:R05916','IMPD').
consumed_by0('36786: cpd:C00127','41103: rn:R00115','IMPD').
consumed_by0('38002: cpd:C01157','3428: rn:R03296','IMPD').
consumed_by0('37808: gl:G06780','40558: rn:R07808','IMPD').
consumed_by0('37808: gl:G06780','40570: rn:R07810','IMPD').
consumed_by0('37808: gl:G06780','40589: rn:R07808','IMPD').
consumed_by0('36780: gl:G10617','40485: rn:R05919','IMPD').
consumed_by0('36780: gl:G10617','40484: rn:R05919','IMPD').
consumed_by0('36780: gl:G10617','40481: rn:R05922','IMPD').
consumed_by0('36780: gl:G10617','40475: rn:R05921','IMPD').
consumed_by0('37749: cpd:C01245','40748: rn:R03394','IMPD').
consumed_by0('37749: cpd:C01245','40737: rn:R03433','IMPD').
consumed_by0('37749: cpd:C01245','40724: rn:R05800','IMPD').
consumed_by0('37731: cpd:C05636','41265: rn:R04907','IMPD').
consumed_by0('37747: cpd:C01243','40749: rn:R03427','IMPD').
consumed_by0('37723: cpd:C02188','41484: rn:R03875','IMPD').
consumed_by0('37747: cpd:C01243','40736: rn:R03428','IMPD').
consumed_by0('37747: cpd:C01243','40733: rn:R03429','IMPD').
consumed_by0('37723: cpd:C02188','41476: rn:R03376','IMPD').
consumed_by0('37869: cpd:C04549','6767: rn:R04504','IMPD').
consumed_by0('36811: cpd:C15980','39754: rn:R03172','IMPD').
consumed_by0('37759: cpd:C11555','40723: rn:R05801','IMPD').
consumed_by0('36811: cpd:C15980','39780: rn:R03172','IMPD').
consumed_by0('36056: cpd:C00258','2503: rn:R01388','IMPD').
consumed_by0('36025: cpd:C00118','3471: rn:R05465','IMPD').
consumed_by0('36016: cpd:C01179','3694: rn:R00042','IMPD').
consumed_by0('37757: cpd:C01272','40740: rn:R03434','IMPD').
consumed_by0('37757: cpd:C01272','40739: rn:R03430','IMPD').
consumed_by0('36811: cpd:C15980','39746: rn:R03172','IMPD').
consumed_by0('36063: cpd:C00029','2250: rn:R00287','IMPD').
consumed_by0('37771: cpd:C15518','40278: rn:R08721','IMPD').
consumed_by0('36805: cpd:C07645','40071: rn:R08281','IMPD').
consumed_by0('37769: cpd:C05450','40276: rn:R04812','IMPD').
consumed_by0('37728: cpd:C00012','41546: rn:R00135','IMPD').
consumed_by0('36805: cpd:C07645','40034: rn:R08280','IMPD').
consumed_by0('36808: dr:D00399 cpd:C07185','39952: rn:R08327','IMPD').
consumed_by0('36805: cpd:C07645','40049: rn:R08282 rn:R08283','IMPD').
consumed_by0('36813: cpd:C15979','39770: rn:R03174','IMPD').
consumed_by0('36770: cpd:C01322','41106: rn:R03522','IMPD').
consumed_by0('37766: cpd:C15520','40306: rn:R08723','IMPD').
consumed_by0('37754: cpd:C05999','40689: rn:R02577','IMPD').
consumed_by0('36056: cpd:C00258','2540: rn:R01388 rn:R01392','IMPD').
consumed_by0('36016: cpd:C01179','3785: rn:R03341','IMPD').
consumed_by0('37734: cpd:C03227','41267: rn:R04171','IMPD').
consumed_by0('37734: cpd:C03227','41272: rn:R02668','IMPD').
consumed_by0('35960: cpd:C00025','5191: rn:R00260','IMPD').
consumed_by0('37027: cpd:C05993','1947: rn:R00322','IMPD').
consumed_by0('36779: cpd:C00342','39941: rn:R02018','IMPD').
consumed_by0('36776: cpd:C00343','39997: rn:R02016','IMPD').
consumed_by0('37742: cpd:C05922','41447: rn:R05046','IMPD').
consumed_by0('36776: cpd:C00343','40024: rn:R02016','IMPD').
consumed_by0('36776: cpd:C00343','40020: rn:R02016','IMPD').
consumed_by0('36776: cpd:C00343','40017: rn:R02016','IMPD').
consumed_by0('36775: dr:D08559 cpd:C07108','40041: rn:R08268','IMPD').
consumed_by0('36775: dr:D08559 cpd:C07108','40043: rn:R08271','IMPD').
consumed_by0('36775: dr:D08559 cpd:C07108','40044: rn:R08266','IMPD').
consumed_by0('36775: dr:D08559 cpd:C07108','40039: rn:R08267','IMPD').
consumed_by0('37761: cpd:C11557','40731: rn:R05803','IMPD').
consumed_by0('37776: cpd:C05448','40277: rn:R04810','IMPD').
consumed_by0('36751: cpd:C00621','40949: rn:R01004','IMPD').
consumed_by0('36779: cpd:C00342','40022: rn:R02024','IMPD').
consumed_by0('36742: cpd:C05665','41158: rn:R00904','IMPD').
consumed_by0('36742: cpd:C05665','41190: rn:R00904','IMPD').
consumed_by0('36043: cpd:C01005','2700: rn:R07274','IMPD').
consumed_by0('37737: cpd:C06148','41453: rn:R04639','IMPD').
consumed_by0('36032: cpd:C00051','2690: rn:R00900','IMPD').
consumed_by0('36024: cpd:C00109','2957: rn:R04673','IMPD').
consumed_by0('37859: cpd:C04477','6710: rn:R03478','IMPD').
consumed_by0('37754: cpd:C05999','41216: rn:R02577','IMPD').
consumed_by0('36033: cpd:C00671','2839: rn:R08567','IMPD').
consumed_by0('35953: cpd:C00064','5210: rn:R00579','IMPD').
consumed_by0('37750: cpd:C04409','41280: rn:R04323','IMPD').
consumed_by0('35962: cpd:C00097','4935: rn:R00901','IMPD').
consumed_by0('37725: cpd:C04722','40284: rn:R08733','IMPD').
consumed_by0('36980: cpd:C02218','2697: rn:R08699','IMPD').
consumed_by0('36173: cpd:C00532','283: rn:R01903','IMPD').
consumed_by0('37727: cpd:C01301','40302: rn:R08761','IMPD').
consumed_by0('36850: cpd:C00555','41501: rn:R01986 rn:R02549','IMPD').
consumed_by0('36089: cpd:C00059','2689: rn:R04860','IMPD').
consumed_by0('36174: cpd:C00103','40: rn:R00960','IMPD').
consumed_by0('36886: cpd:C00410','40198: rn:R02211','IMPD').
consumed_by0('36884: cpd:C03681','40267: rn:R08958','IMPD').
consumed_by0('36896: cpd:C00208','5462: rn:R01557','IMPD').
consumed_by0('36853: cpd:C00504','41168: rn:R02235 rn:R02236','IMPD').
consumed_by0('36174: cpd:C00103','39: rn:R00947','IMPD').
consumed_by0('36896: cpd:C00208','5428: rn:R01555','IMPD').
consumed_by0('36897: cpd:C00063','39911: rn:R00442','IMPD').
consumed_by0('36897: cpd:C00063','39909: rn:R00569','IMPD').
consumed_by0('36886: cpd:C00410','40269: rn:R02207 rn:R02209','IMPD').
consumed_by0('36886: cpd:C00410','40270: rn:R02213','IMPD').
consumed_by0('36886: cpd:C00410','40265: rn:R02218','IMPD').
consumed_by0('36886: cpd:C00410','40266: rn:R02219','IMPD').
consumed_by0('36089: cpd:C00059','2710: rn:R02409','IMPD').
consumed_by0('36038: cpd:C00084','4310: rn:R00228','IMPD').
consumed_by0('36861: cpd:C00386','41325: rn:R01166','IMPD').
consumed_by0('37694: cpd:C05544','41477: rn:R04866','IMPD').
consumed_by0('35981: cpd:C00031','5934: rn:R02738','IMPD').
consumed_by0('37700: cpd:C00785','41342: rn:R02914','IMPD').
consumed_by0('38810: cpd:C03028','41472: rn:R00618','IMPD').
consumed_by0('36853: cpd:C00504','41451: rn:R00937 rn:R00940','IMPD').
consumed_by0('36852: cpd:C00415','41458: rn:R02235 rn:R02236','IMPD').
consumed_by0('36905: cpd:C00957','39819: rn:R03105','IMPD').
consumed_by0('36905: cpd:C00957','39820: rn:R03104','IMPD').
consumed_by0('37698: cpd:C05545','41479: rn:R04867','IMPD').
consumed_by0('38812: cpd:C00378','41483: rn:R00619','IMPD').
consumed_by0('37701: cpd:C01211','41482: rn:R03380','IMPD').
consumed_by0('36853: cpd:C00504','41498: rn:R00937 rn:R00940','IMPD').
consumed_by0('36038: cpd:C00084','3842: rn:R00750','IMPD').
consumed_by0('38065: cpd:C03564','3236: rn:R03249','IMPD').
consumed_by0('37708: cpd:C03680','41337: rn:R02288','IMPD').
consumed_by0('37709: cpd:C16238','41328: rn:R07771','IMPD').
consumed_by0('35960: cpd:C00025','6366: rn:R08905','IMPD').
consumed_by0('37732: cpd:C01885','40681: rn:R01351','IMPD').
consumed_by0('37732: cpd:C01885','40683: rn:R02757','IMPD').
consumed_by0('36836: cpd:C00601','41209: rn:R02536 rn:R02537','IMPD').
consumed_by0('36837: cpd:C05332','41212: rn:R02613','IMPD').
consumed_by0('36837: cpd:C05332','41213: rn:R02613','IMPD').
consumed_by0('36868: cpd:C02140','40255: rn:R03262','IMPD').
consumed_by0('36868: cpd:C02140','40271: rn:R03848','IMPD').
consumed_by0('36880: cpd:C01176','40225: rn:R03325','IMPD').
consumed_by0('37715: cpd:C05127','41346: rn:R04674','IMPD').
consumed_by0('36852: cpd:C00415','41165: rn:R00936 rn:R00939','IMPD').
consumed_by0('36881: cpd:C03205','40254: rn:R08949','IMPD').
consumed_by0('37028: cpd:C03785','520: rn:R01069','IMPD').
consumed_by0('36881: cpd:C03205','40268: rn:R03851','IMPD').
consumed_by0('36612: cpd:C16596','13444: rn:R08311','IMPD').
consumed_by0('36869: cpd:C11554','40463: rn:R07299','IMPD').
consumed_by0('36091: cpd:C00086','1867: rn:R00131','IMPD').
consumed_by0('37720: cpd:C16239','41336: rn:R07769','IMPD').
consumed_by0('36875: cpd:C05476','40272: rn:R04840','IMPD').
consumed_by0('36877: cpd:C01780','40256: rn:R03713','IMPD').
consumed_by0('36880: cpd:C01176','40196: rn:R03329','IMPD').
consumed_by0('36880: cpd:C01176','40194: rn:R03326','IMPD').
consumed_by0('36858: cpd:C05487','40234: rn:R04849','IMPD').
consumed_by0('36858: cpd:C05487','40241: rn:R04849','IMPD').
consumed_by0('36858: cpd:C05487','40238: rn:R04850','IMPD').
consumed_by0('37683: gl:G00158','40597: rn:R05931','IMPD').
consumed_by0('36827: cpd:C00445','41163: rn:R01655','IMPD').
consumed_by0('36827: cpd:C00445','41160: rn:R02300','IMPD').
consumed_by0('36827: cpd:C00445','41171: rn:R04326','IMPD').
consumed_by0('36827: cpd:C00445','41170: rn:R02302','IMPD').
consumed_by0('36855: cpd:C05500','40245: rn:R04853','IMPD').
consumed_by0('37681: gl:G00159','40598: rn:R05932','IMPD').
consumed_by0('37688: gl:G00156','40595: rn:R05928','IMPD').
consumed_by0('37661: cpd:C04244','41455: rn:R01813','IMPD').
consumed_by0('36846: gl:G00149','40483: rn:R08107','IMPD').
consumed_by0('36846: gl:G00149','40477: rn:R08107','IMPD').
consumed_by0('37660: cpd:C04895','41439: rn:R04620','IMPD').
consumed_by0('37663: cpd:C05130','41345: rn:R04065','IMPD').
consumed_by0('37660: cpd:C04895','41443: rn:R04286','IMPD').
consumed_by0('38787: cpd:C00016','41463: rn:R00160','IMPD').
consumed_by0('37702: cpd:C06197','40145: rn:R00187','IMPD').
consumed_by0('36200: cpd:C00379','279: rn:R01896','IMPD').
consumed_by0('36851: cpd:C00280','40208: rn:R01835','IMPD').
consumed_by0('36851: cpd:C00280','40206: rn:R01834','IMPD').
consumed_by0('37657: cpd:C03684','41460: rn:R04285','IMPD').
consumed_by0('36851: cpd:C00280','40210: rn:R02725','IMPD').
consumed_by0('37695: cpd:C17335','40307: rn:R08728','IMPD').
consumed_by0('36729: cpd:C00279','9585: rn:R01829','IMPD').
consumed_by0('36843: gl:G00148','40481: rn:R05922','IMPD').
consumed_by0('37691: gl:G00155','40590: rn:R05927','IMPD').
consumed_by0('36865: cpd:C02538','40216: rn:R02350','IMPD').
consumed_by0('36032: cpd:C00051','5346: rn:R08354','IMPD').
consumed_by0('36032: cpd:C00051','5339: rn:R01917','IMPD').
consumed_by0('36032: cpd:C00051','5343: rn:R08352','IMPD').
consumed_by0('36862: cpd:C00951','40274: rn:R02352 rn:R02353','IMPD').
consumed_by0('36094: cpd:C00077','3406: rn:R00671','IMPD').
consumed_by0('36864: cpd:C05488','40192: rn:R02843','IMPD').
consumed_by0('37665: cpd:C00388','41348: rn:R02150','IMPD').
consumed_by0('37665: cpd:C00388','41349: rn:R02155','IMPD').
consumed_by0('36945: cpd:C00491','2713: rn:R01113','IMPD').
consumed_by0('36945: cpd:C00491','2710: rn:R02409','IMPD').
consumed_by0('36032: cpd:C00051','5288: rn:R01917','IMPD').
consumed_by0('38779: cpd:C00007','41464: rn:R02363','IMPD').
consumed_by0('36606: cpd:C06481','13208: rn:R08223','IMPD').
consumed_by0('36606: cpd:C06481','13211: rn:R08219','IMPD').
consumed_by0('36862: cpd:C00951','40212: rn:R03091','IMPD').
consumed_by0('36862: cpd:C00951','40215: rn:R03088 rn:R03090','IMPD').
consumed_by0('37706: cpd:C17339','40280: rn:R04823','IMPD').
consumed_by0('36862: cpd:C00951','40201: rn:R03089','IMPD').
consumed_by0('36084: cpd:C00628','3635: rn:R02489','IMPD').
consumed_by0('35952: cpd:C00022','7706: rn:R00207','IMPD').
consumed_by0('36091: cpd:C00086','3401: rn:R00131','IMPD').
consumed_by0('36867: cpd:C07643','40025: rn:R08277','IMPD').
consumed_by0('38777: cpd:C00255','41467: rn:R00549','IMPD').
consumed_by0('35952: cpd:C00022','7694: rn:R00211','IMPD').
consumed_by0('35952: cpd:C00022','7695: rn:R01196','IMPD').
consumed_by0('35952: cpd:C00022','7705: rn:R03145','IMPD').
consumed_by0('37666: cpd:C00268','41456: rn:R01793 rn:R01794','IMPD').
consumed_by0('36940: cpd:C05527','2761: rn:R04861','IMPD').
consumed_by0('37676: cpd:C16236','41326: rn:R07767','IMPD').
consumed_by0('37717: cpd:C00301','40056: rn:R01054','IMPD').
consumed_by0('37713: cpd:C00575','40107: rn:R00191','IMPD').
consumed_by0('36830: gl:G00145','40485: rn:R05919','IMPD').
consumed_by0('36830: gl:G00145','40484: rn:R05919','IMPD').
consumed_by0('36183: cpd:C00267','390: rn:R00878','IMPD').
consumed_by0('37707: cpd:C05454','40318: rn:R04807','IMPD').
consumed_by0('36040: cpd:C00099','4849: rn:R02473','IMPD').
consumed_by0('36708: cpd:C00001','9598: rn:R00024','IMPD').
consumed_by0('36861: cpd:C00386','4867: rn:R01166','IMPD').
consumed_by0('36040: cpd:C00099','4865: rn:R01164','IMPD').
consumed_by0('36823: cpd:C02189','40636: rn:R05907','IMPD').
consumed_by0('36823: cpd:C02189','40639: rn:R05907','IMPD').
consumed_by0('36823: cpd:C02189','40637: rn:R05907','IMPD').
consumed_by0('36828: gl:G00143','40482: rn:R05917','IMPD').
consumed_by0('36823: cpd:C02189','40638: rn:R05907','IMPD').
consumed_by0('37714: cpd:C05337','40298: rn:R08743','IMPD').
consumed_by0('37714: cpd:C05337','40299: rn:R08744','IMPD').
consumed_by0('37714: cpd:C05337','40292: rn:R08745','IMPD').
consumed_by0('36823: cpd:C02189','40644: rn:R05907','IMPD').
consumed_by0('36823: cpd:C02189','40641: rn:R05907','IMPD').
consumed_by0('36823: cpd:C02189','40646: rn:R05907','IMPD').
consumed_by0('35944: cpd:C00024','7745: rn:R00230','IMPD').
consumed_by0('36823: cpd:C02189','40645: rn:R05907','IMPD').
consumed_by0('36940: cpd:C05527','2613: rn:R04861','IMPD').
consumed_by0('36188: cpd:C00221','194: rn:R01522','IMPD').
consumed_by0('36188: cpd:C00221','195: rn:R01520 rn:R01521','IMPD').
consumed_by0('36188: cpd:C00221','202: rn:R01522','IMPD').
consumed_by0('37717: cpd:C00301','40130: rn:R01054','IMPD').
consumed_by0('37711: cpd:C15613','40317: rn:R08734','IMPD').
consumed_by0('37712: cpd:C05449','40301: rn:R04811','IMPD').
consumed_by0('35944: cpd:C00024','7692: rn:R00212','IMPD').
consumed_by0('36823: cpd:C02189','40594: rn:R05925','IMPD').
consumed_by0('35944: cpd:C00024','7701: rn:R00472','IMPD').
consumed_by0('36823: cpd:C02189','40619: rn:R05907','IMPD').
consumed_by0('36823: cpd:C02189','40613: rn:R05907','IMPD').
consumed_by0('35944: cpd:C00024','7707: rn:R00230','IMPD').
consumed_by0('36883: cpd:C00166','3953: rn:R01377','IMPD').
consumed_by0('37724: cpd:C00655','40089: rn:R02719','IMPD').
consumed_by0('37719: cpd:C05446','40304: rn:R08759','IMPD').
consumed_by0('36851: cpd:C00280','40204: rn:R01840','IMPD').
consumed_by0('37716: cpd:C01794','40289: rn:R03720','IMPD').
consumed_by0('37716: cpd:C01794','40293: rn:R02794','IMPD').
consumed_by0('36848: cpd:C00535','40189: rn:R01836','IMPD').
consumed_by0('37716: cpd:C01794','40294: rn:R03718','IMPD').
consumed_by0('36575: dr:D00536 cpd:C07501','13440: rn:R08305','IMPD').
consumed_by0('36848: cpd:C00535','40222: rn:R02498','IMPD').
consumed_by0('36848: cpd:C00535','40223: rn:R02502','IMPD').
consumed_by0('36848: cpd:C00535','40221: rn:R02497','IMPD').
consumed_by0('37724: cpd:C00655','40078: rn:R01230 rn:R01231','IMPD').
consumed_by0('36848: cpd:C00535','40202: rn:R02501','IMPD').
consumed_by0('36848: cpd:C00535','40211: rn:R01838','IMPD').
consumed_by0('37689: cpd:C01044','41324: rn:R00526','IMPD').
consumed_by0('36176: cpd:C00618','287: rn:R01905','IMPD').
consumed_by0('37726: cpd:C00700','40174: rn:R02720','IMPD').
consumed_by0('37722: cpd:C06341','40308: rn:R08724','IMPD').
consumed_by0('35960: cpd:C00025','39890: rn:R00243 rn:R00248','IMPD').
consumed_by0('36911: gl:G00124','41262: rn:R05957','IMPD').
consumed_by0('35944: cpd:C00024','40391: rn:R03858','IMPD').
consumed_by0('35944: cpd:C00024','40405: rn:R01177','IMPD').
consumed_by0('35944: cpd:C00024','40404: rn:R01177','IMPD').
consumed_by0('35967: cpd:C00065','39694: rn:R03662','IMPD').
consumed_by0('35944: cpd:C00024','40412: rn:R04747','IMPD').
consumed_by0('35944: cpd:C00024','40416: rn:R04747','IMPD').
consumed_by0('35944: cpd:C00024','40355: rn:R00238','IMPD').
consumed_by0('35964: cpd:C00332','39735: rn:R01978','IMPD').
consumed_by0('35959: cpd:C00049','39891: rn:R01954','IMPD').
consumed_by0('35959: cpd:C00049','39892: rn:R01135','IMPD').
consumed_by0('35959: cpd:C00049','39897: rn:R01397','IMPD').
consumed_by0('35959: cpd:C00049','39900: rn:R00578','IMPD').
consumed_by0('35959: cpd:C00049','39901: rn:R00357','IMPD').
consumed_by0('35959: cpd:C00049','39902: rn:R00355','IMPD').
consumed_by0('35944: cpd:C00024','40369: rn:R03991','IMPD').
consumed_by0('35962: cpd:C00097','39811: rn:R00893','IMPD').
consumed_by0('35962: cpd:C00097','39815: rn:R00782','IMPD').
consumed_by0('35944: cpd:C00024','40375: rn:R04742','IMPD').
consumed_by0('38216: cpd:C15783','40338: rn:R07487','IMPD').
consumed_by0('35960: cpd:C00025','39880: rn:R00261','IMPD').
consumed_by0('35962: cpd:C00097','39818: rn:R00896','IMPD').
consumed_by0('35960: cpd:C00025','39883: rn:R00253','IMPD').
consumed_by0('35944: cpd:C00024','40380: rn:R03778','IMPD').
consumed_by0('36949: cpd:C00112','40022: rn:R02024','IMPD').
consumed_by0('38215: cpd:C15781','40345: rn:R07493','IMPD').
consumed_by0('35960: cpd:C00025','39856: rn:R05578','IMPD').
consumed_by0('35944: cpd:C00024','40349: rn:R01978','IMPD').
consumed_by0('35944: cpd:C00024','40348: rn:R00238','IMPD').
consumed_by0('36952: cpd:C00475','39905: rn:R00513 rn:R00516 rn:R00517 rn:R00962 rn:R01548 rn:R02091 rn:R02096 rn:R02371 rn:R02372','IMPD').
consumed_by0('36952: cpd:C00475','39904: rn:R01878','IMPD').
consumed_by0('38214: cpd:C05107','40341: rn:R07507','IMPD').
consumed_by0('36917: gl:G00113','41207: rn:R05947','IMPD').
consumed_by0('35942: cpd:C00356','40350: rn:R01360','IMPD').
consumed_by0('35960: cpd:C00025','39740: rn:R00243 rn:R00248','IMPD').
consumed_by0('38212: cpd:C01561','40322: rn:R03610','IMPD').
consumed_by0('35955: cpd:C00026','99: rn:R01197','IMPD').
consumed_by0('35962: cpd:C00097','39689: rn:R03650','IMPD').
consumed_by0('35958: cpd:C00141','39769: rn:R07599','IMPD').
consumed_by0('35960: cpd:C00025','39705: rn:R05578','IMPD').
consumed_by0('35956: cpd:C00576','39825: rn:R02565 rn:R02566','IMPD').
consumed_by0('36914: gl:G00123','41257: rn:R05956','IMPD').
consumed_by0('35953: cpd:C00064','39939: rn:R00575','IMPD').
consumed_by0('36919: cpd:C05670','41047: rn:R03971','IMPD').
consumed_by0('35953: cpd:C00064','39886: rn:R00768','IMPD').
consumed_by0('35953: cpd:C00064','39885: rn:R00575','IMPD').
consumed_by0('35954: cpd:C00154','39870: rn:R01274','IMPD').
consumed_by0('35971: cpd:C00719','39832: rn:R02821','IMPD').
consumed_by0('35954: cpd:C00154','40361: rn:R01923','IMPD').
consumed_by0('35954: cpd:C00154','40360: rn:R01279','IMPD').
consumed_by0('35974: cpd:C00068','39725: rn:R07603','IMPD').
consumed_by0('35951: cpd:C00136','40424: rn:R01177','IMPD').
consumed_by0('35947: cpd:C00114','40517: rn:R01021','IMPD').
consumed_by0('35951: cpd:C00136','40400: rn:R01175','IMPD').
consumed_by0('35951: cpd:C00136','40397: rn:R01175','IMPD').
consumed_by0('35951: cpd:C00136','40404: rn:R01177','IMPD').
consumed_by0('35951: cpd:C00136','40402: rn:R01175','IMPD').
consumed_by0('35951: cpd:C00136','40405: rn:R01177','IMPD').
consumed_by0('36942: cpd:C00365','39999: rn:R02101','IMPD').
consumed_by0('35947: cpd:C00114','40513: rn:R01023','IMPD').
consumed_by0('36915: cpd:C00721','40817: rn:R01791','IMPD').
consumed_by0('36915: cpd:C00721','40816: rn:R01791','IMPD').
consumed_by0('35951: cpd:C00136','40362: rn:R01175','IMPD').
consumed_by0('36942: cpd:C00365','39990: rn:R02098','IMPD').
consumed_by0('35967: cpd:C00065','39840: rn:R00220','IMPD').
consumed_by0('35967: cpd:C00065','39833: rn:R00588','IMPD').
consumed_by0('35967: cpd:C00065','39834: rn:R00585','IMPD').
consumed_by0('35967: cpd:C00065','39826: rn:R00589','IMPD').
consumed_by0('35967: cpd:C00065','39829: rn:R01290','IMPD').
consumed_by0('37191: cpd:C00603','1870: rn:R00469','IMPD').
consumed_by0('37191: cpd:C00603','1862: rn:R00776','IMPD').
consumed_by0('35967: cpd:C00065','39807: rn:R00590','IMPD').
consumed_by0('35967: cpd:C00065','39799: rn:R01290','IMPD').
consumed_by0('35967: cpd:C00065','39785: rn:R00588','IMPD').
consumed_by0('35967: cpd:C00065','39786: rn:R00891','IMPD').
consumed_by0('35966: cpd:C00019','39803: rn:R04858','IMPD').
consumed_by0('37244: cpd:C00257','189: rn:R01737','IMPD').
consumed_by0('35966: cpd:C00019','39796: rn:R00178','IMPD').
consumed_by0('36906: gl:G00111','41248: rn:R05943','IMPD').
consumed_by0('36906: gl:G00111','41247: rn:R05945','IMPD').
consumed_by0('36949: cpd:C00112','39910: rn:R00570','IMPD').
consumed_by0('36949: cpd:C00112','39907: rn:R00514','IMPD').
consumed_by0('35953: cpd:C00064','40184: rn:R01072','IMPD').
consumed_by0('35944: cpd:C00024','40442: rn:R04742','IMPD').
consumed_by0('36948: cpd:C00055','39906: rn:R00511','IMPD').
consumed_by0('35944: cpd:C00024','40439: rn:R03778','IMPD').
consumed_by0('36948: cpd:C00055','39908: rn:R00512','IMPD').
consumed_by0('35944: cpd:C00024','40434: rn:R03991','IMPD').
consumed_by0('35964: cpd:C00332','39813: rn:R01978','IMPD').
consumed_by0('35944: cpd:C00024','40430: rn:R03858','IMPD').
consumed_by0('36918: cpd:C01083','40825: rn:R00010','IMPD').
consumed_by0('35944: cpd:C00024','40424: rn:R01177','IMPD').
consumed_by0('35967: cpd:C00065','39709: rn:R08218','IMPD').
consumed_by0('35979: cpd:C00073','39801: rn:R00177','IMPD').
consumed_by0('38214: cpd:C05107','1286: rn:R03724','IMPD').
consumed_by0('36925: gl:G00110','41253: rn:R05942','IMPD').
consumed_by0('35940: cpd:C00158','40989: rn:R01325','IMPD').
consumed_by0('35975: cpd:C01180','39789: rn:R07396','IMPD').
consumed_by0('35972: cpd:C03595','39874: rn:R08182','IMPD').
consumed_by0('35975: cpd:C01180','39805: rn:R00648','IMPD').
consumed_by0('35944: cpd:C00024','40763: rn:R01624','IMPD').
consumed_by0('35944: cpd:C00024','40755: rn:R04386','IMPD').
consumed_by0('35979: cpd:C00073','39693: rn:R03659','IMPD').
consumed_by0('36941: cpd:C05379','40970: rn:R00268','IMPD').
consumed_by0('35954: cpd:C00154','40476: rn:R05918','IMPD').
consumed_by0('35954: cpd:C00154','40365: rn:R01279','IMPD').
consumed_by0('35954: cpd:C00154','40368: rn:R01279','IMPD').
consumed_by0('35974: cpd:C00068','39748: rn:R07601','IMPD').
consumed_by0('35974: cpd:C00068','39769: rn:R07599','IMPD').
consumed_by0('35952: cpd:C00022','657: rn:R03277','IMPD').
consumed_by0('35954: cpd:C00154','40396: rn:R01279','IMPD').
consumed_by0('35970: cpd:C00169','39931: rn:R01397','IMPD').
consumed_by0('35954: cpd:C00154','40425: rn:R01274','IMPD').
consumed_by0('35952: cpd:C00022','40895: rn:R00014','IMPD').
consumed_by0('35940: cpd:C00158','41264: rn:R00351','IMPD').
consumed_by0('35944: cpd:C00024','41140: rn:R00238','IMPD').
consumed_by0('35944: cpd:C00024','41126: rn:R00238','IMPD').
consumed_by0('36920: gl:G00108','41208: rn:R05940','IMPD').
consumed_by0('35944: cpd:C00024','41125: rn:R00742','IMPD').
consumed_by0('36920: gl:G00108','41255: rn:R05939','IMPD').
consumed_by0('35944: cpd:C00024','41176: rn:R00238','IMPD').
consumed_by0('36920: gl:G00108','41250: rn:R05940','IMPD').
consumed_by0('35943: cpd:C00079','41204: rn:R00689','IMPD').
consumed_by0('35943: cpd:C00079','41203: rn:R00698','IMPD').
consumed_by0('35943: cpd:C00079','41214: rn:R00699','IMPD').
consumed_by0('35944: cpd:C00024','41180: rn:R01978','IMPD').
consumed_by0('35991: cpd:C00082','39703: rn:R02918','IMPD').
consumed_by0('35984: cpd:C00037','39837: rn:R00366','IMPD').
consumed_by0('35984: cpd:C00037','39839: rn:R00371','IMPD').
consumed_by0('35984: cpd:C00037','39845: rn:R00945','IMPD').
consumed_by0('35983: cpd:C02249','39875: rn:R08183','IMPD').
consumed_by0('36917: gl:G00113','41261: rn:R05946','IMPD').
consumed_by0('36917: gl:G00113','41237: rn:R05947','IMPD').
consumed_by0('36917: gl:G00113','41241: rn:R05947','IMPD').
consumed_by0('35984: cpd:C00037','39830: rn:R00565','IMPD').
consumed_by0('35984: cpd:C00037','39831: rn:R06171','IMPD').
consumed_by0('35954: cpd:C00154','40796: rn:R01281','IMPD').
consumed_by0('35949: cpd:C00033','40957: rn:R00235','IMPD').
consumed_by0('35942: cpd:C00356','41181: rn:R01360','IMPD').
consumed_by0('35984: cpd:C00037','39853: rn:R00830','IMPD').
consumed_by0('35984: cpd:C00037','39854: rn:R03425','IMPD').
consumed_by0('35984: cpd:C00037','39855: rn:R00367','IMPD').
consumed_by0('35984: cpd:C00037','39857: rn:R00830','IMPD').
consumed_by0('36959: cpd:C00906','39970: rn:R01415','IMPD').
consumed_by0('36959: cpd:C00906','39969: rn:R03055','IMPD').
consumed_by0('35943: cpd:C00079','41134: rn:R00689','IMPD').
consumed_by0('35943: cpd:C00079','41136: rn:R01795','IMPD').
consumed_by0('35944: cpd:C00024','41020: rn:R02569','IMPD').
consumed_by0('38149: cpd:C05938','41532: rn:R05051','IMPD').
consumed_by0('38149: cpd:C05938','41533: rn:R05051','IMPD').
consumed_by0('35948: gl:G00084','40888: rn:R06222','IMPD').
consumed_by0('36923: gl:G00109','41256: rn:R05941','IMPD').
consumed_by0('36923: gl:G00109','41238: rn:R06004','IMPD').
consumed_by0('36925: gl:G00110','41235: rn:R06010','IMPD').
consumed_by0('37208: cpd:C02350','1864: rn:R02425','IMPD').
consumed_by0('36930: cpd:C18902','41072: rn:R09372','IMPD').
consumed_by0('36965: cpd:C05100','39973: rn:R04666','IMPD').
consumed_by0('35984: cpd:C00037','39787: rn:R00372','IMPD').
consumed_by0('35980: cpd:C00197','39835: rn:R01513','IMPD').
consumed_by0('35984: cpd:C00037','39692: rn:R03654','IMPD').
consumed_by0('35944: cpd:C00024','40935: rn:R02569','IMPD').
consumed_by0('35944: cpd:C00024','40986: rn:R00351','IMPD').
consumed_by0('35981: cpd:C00031','27: rn:R02738','IMPD').
consumed_by0('35944: cpd:C00024','40971: rn:R00352','IMPD').
consumed_by0('38143: cpd:C02946','3398: rn:R01987','IMPD').
consumed_by0('35948: gl:G00084','40842: rn:R06222','IMPD').
consumed_by0('35964: cpd:C00332','40349: rn:R01978','IMPD').
consumed_by0('36916: cpd:C00239','40012: rn:R01663','IMPD').
consumed_by0('36916: cpd:C00239','40007: rn:R01664','IMPD').
consumed_by0('36916: cpd:C00239','40003: rn:R01665','IMPD').
consumed_by0('36878: cpd:C00632','41279: rn:R02665','IMPD').
consumed_by0('35981: cpd:C00031','192: rn:R06620','IMPD').
consumed_by0('35981: cpd:C00031','193: rn:R00305','IMPD').
consumed_by0('36878: cpd:C00632','41320: rn:R02670','IMPD').
consumed_by0('36883: cpd:C00166','41175: rn:R00694','IMPD').
consumed_by0('36883: cpd:C00166','41135: rn:R00694','IMPD').
consumed_by0('36896: cpd:C00208','40850: rn:R00028','IMPD').
consumed_by0('38147: cpd:C02714','41372: rn:R04025','IMPD').
consumed_by0('36883: cpd:C00166','41200: rn:R01378','IMPD').
consumed_by0('36883: cpd:C00166','41201: rn:R00694','IMPD').
consumed_by0('36883: cpd:C00166','41202: rn:R00694','IMPD').
consumed_by0('36883: cpd:C00166','41211: rn:R01372','IMPD').
consumed_by0('36909: cpd:C00458','40005: rn:R00377','IMPD').
consumed_by0('38135: cpd:C00179','41510: rn:R01157','IMPD').
consumed_by0('35941: cpd:C00014','39732: rn:R00149','IMPD').
consumed_by0('36873: cpd:C00664','41169: rn:R02287','IMPD').
consumed_by0('38141: cpd:C05936','41371: rn:R05050','IMPD').
consumed_by0('36913: cpd:C00705','40001: rn:R02326','IMPD').
consumed_by0('36874: cpd:C03479','41159: rn:R02301','IMPD').
consumed_by0('36874: cpd:C03479','41167: rn:R03189','IMPD').
consumed_by0('38093: cpd:C00437','3453: rn:R07245','IMPD').
consumed_by0('35941: cpd:C00014','39884: rn:R00149','IMPD').
consumed_by0('38163: cpd:C00226','40395: rn:R00623','IMPD').
consumed_by0('36933: cpd:C00526','39994: rn:R02484','IMPD').
consumed_by0('36933: cpd:C00526','39991: rn:R02099','IMPD').
consumed_by0('36933: cpd:C00526','39996: rn:R02484','IMPD').
consumed_by0('39135: gl:G10611','40613: rn:R05907','IMPD').
consumed_by0('36893: gl:G00114','41254: rn:R05948','IMPD').
consumed_by0('35944: cpd:C00024','39813: rn:R01978','IMPD').
consumed_by0('35944: cpd:C00024','39814: rn:R00238','IMPD').
consumed_by0('39135: gl:G10611','40619: rn:R05907','IMPD').
consumed_by0('39135: gl:G10611','40641: rn:R05907','IMPD').
consumed_by0('39135: gl:G10611','40644: rn:R05907','IMPD').
consumed_by0('39135: gl:G10611','40646: rn:R05907','IMPD').
consumed_by0('39135: gl:G10611','40645: rn:R05907','IMPD').
consumed_by0('39135: gl:G10611','40636: rn:R05907','IMPD').
consumed_by0('39135: gl:G10611','40638: rn:R05907','IMPD').
consumed_by0('39135: gl:G10611','40637: rn:R05907','IMPD').
consumed_by0('39135: gl:G10611','40639: rn:R05907','IMPD').
consumed_by0('36936: cpd:C00881','39992: rn:R02485','IMPD').
consumed_by0('36936: cpd:C00881','40009: rn:R01666','IMPD').
consumed_by0('35943: cpd:C00079','39688: rn:R03660','IMPD').
consumed_by0('35942: cpd:C00356','39733: rn:R01360','IMPD').
consumed_by0('35942: cpd:C00356','39734: rn:R02085','IMPD').
consumed_by0('35941: cpd:C00014','39772: rn:R01221','IMPD').
consumed_by0('35941: cpd:C00014','39773: rn:R00253','IMPD').
consumed_by0('37895: cpd:C00473','10317: rn:R02369','IMPD').
consumed_by0('36938: cpd:C01346','39989: rn:R02331','IMPD').
consumed_by0('35945: cpd:C00183','39681: rn:R03665','IMPD').
consumed_by0('36934: cpd:C14859','40132: rn:R07093','IMPD').
consumed_by0('35945: cpd:C00183','39696: rn:R03665','IMPD').
consumed_by0('36945: cpd:C00491','39810: rn:R02408','IMPD').
consumed_by0('35944: cpd:C00024','39735: rn:R01978','IMPD').
consumed_by0('35944: cpd:C00024','39731: rn:R00238','IMPD').
consumed_by0('35942: cpd:C00356','39812: rn:R02082','IMPD').
consumed_by0('35946: cpd:C00152','39686: rn:R03648','IMPD').
consumed_by0('35945: cpd:C00183','39730: rn:R01214','IMPD').
consumed_by0('37205: cpd:C02670','682: rn:R01483','IMPD').
consumed_by0('35958: cpd:C00141','39682: rn:R01214','IMPD').
consumed_by0('37217: cpd:C01040','653: rn:R03183','IMPD').
consumed_by0('35953: cpd:C00064','39822: rn:R01072','IMPD').
consumed_by0('35953: cpd:C00064','39882: rn:R00256','IMPD').
consumed_by0('35959: cpd:C00049','39691: rn:R05577','IMPD').
consumed_by0('35950: cpd:C16661','39951: rn:R08342','IMPD').
consumed_by0('36929: cpd:C00460','39963: rn:R02100','IMPD').
consumed_by0('35947: cpd:C00114','39824: rn:R01025','IMPD').
consumed_by0('35952: cpd:C00022','39706: rn:R00014','IMPD').
consumed_by0('36929: cpd:C00460','40011: rn:R02100','IMPD').
consumed_by0('35953: cpd:C00064','39690: rn:R03652','IMPD').
consumed_by0('36017: cpd:C05125','9: rn:R00755','IMPD').
consumed_by0('35953: cpd:C00064','39741: rn:R00256','IMPD').
consumed_by0('36891: gl:G00116','41243: rn:R05951','IMPD').
consumed_by0('36891: gl:G00116','41242: rn:R05950','IMPD').
consumed_by0('35953: cpd:C00064','39737: rn:R00578','IMPD').
consumed_by0('37026: cpd:C03406','39894: rn:R01086','IMPD').
consumed_by0('37019: cpd:C14852','40101: rn:R07085','IMPD').
consumed_by0('37012: cpd:C05697','5072: rn:R07229','IMPD').
consumed_by0('37015: cpd:C14851','40149: rn:R07083','IMPD').
consumed_by0('37010: cpd:C01528','5101: rn:R09371','IMPD').
consumed_by0('35946: cpd:C00152','2345: rn:R01346','IMPD').
consumed_by0('38112: cpd:C03287','41506: rn:R03313','IMPD').
consumed_by0('36975: gl:G00125','41259: rn:R05959','IMPD').
consumed_by0('36975: gl:G00125','41246: rn:R05958','IMPD').
consumed_by0('36975: gl:G00125','41251: rn:R05959','IMPD').
consumed_by0('36975: gl:G00125','41249: rn:R05959','IMPD').
consumed_by0('36975: gl:G00125','41199: rn:R05959','IMPD').
consumed_by0('35955: cpd:C00026','2388: rn:R00093','IMPD').
consumed_by0('37008: cpd:C14857','40166: rn:R07092','IMPD').
consumed_by0('37007: cpd:C14858','40151: rn:R07091','IMPD').
consumed_by0('37013: cpd:C01103','39967: rn:R00965','IMPD').
consumed_by0('36976: cpd:C05698','41074: rn:R09365','IMPD').
consumed_by0('37013: cpd:C01103','39929: rn:R01870','IMPD').
consumed_by0('38153: cpd:C06505','39783: rn:R05220','IMPD').
consumed_by0('35953: cpd:C00064','2388: rn:R00093','IMPD').
consumed_by0('35953: cpd:C00064','2404: rn:R00576','IMPD').
consumed_by0('36025: cpd:C00118','86: rn:R07159','IMPD').
consumed_by0('36025: cpd:C00118','84: rn:R01058','IMPD').
consumed_by0('38159: cpd:C01708','39800: rn:R03683','IMPD').
consumed_by0('36025: cpd:C00118','83: rn:R07159','IMPD').
consumed_by0('37009: cpd:C00337','39972: rn:R01868','IMPD').
consumed_by0('37009: cpd:C00337','39930: rn:R01993','IMPD').
consumed_by0('35944: cpd:C00024','3035: rn:R00271','IMPD').
consumed_by0('35944: cpd:C00024','2925: rn:R07399','IMPD').
consumed_by0('36993: cpd:C01061','41260: rn:R01364','IMPD').
consumed_by0('37031: cpd:C06205','40092: rn:R07016','IMPD').
consumed_by0('38131: cpd:C05280','40403: rn:R04756','IMPD').
consumed_by0('35970: cpd:C00169','2050: rn:R00150','IMPD').
consumed_by0('35959: cpd:C00049','2346: rn:R00397','IMPD').
consumed_by0('35959: cpd:C00049','2349: rn:R00491','IMPD').
consumed_by0('37031: cpd:C06205','40053: rn:R07015','IMPD').
consumed_by0('37016: cpd:C00243','40520: rn:R01678','IMPD').
consumed_by0('37016: cpd:C00243','40521: rn:R01678','IMPD').
consumed_by0('38093: cpd:C00437','41547: rn:R00669','IMPD').
consumed_by0('35959: cpd:C00049','2361: rn:R00490','IMPD').
consumed_by0('35962: cpd:C00097','2690: rn:R00900','IMPD').
consumed_by0('35962: cpd:C00097','2694: rn:R00901','IMPD').
consumed_by0('35945: cpd:C00183','3228: rn:R04870','IMPD').
consumed_by0('35962: cpd:C00097','2712: rn:R00892','IMPD').
consumed_by0('38137: cpd:C00500','39868: rn:R02391 rn:R02393','IMPD').
consumed_by0('35958: cpd:C00141','2838: rn:R07160','IMPD').
consumed_by0('35952: cpd:C00022','2925: rn:R07399','IMPD').
consumed_by0('38136: cpd:C03263','39821: rn:R03220','IMPD').
consumed_by0('37019: cpd:C14852','40147: rn:R07084','IMPD').
consumed_by0('36981: cpd:C14870','40176: rn:R07116','IMPD').
consumed_by0('36956: cpd:C05172','40963: rn:R08224','IMPD').
consumed_by0('38127: cpd:C01079','39863: rn:R03222','IMPD').
consumed_by0('36987: cpd:C00364','39985: rn:R01569','IMPD').
consumed_by0('36987: cpd:C00364','39981: rn:R02094','IMPD').
consumed_by0('36958: cpd:C05684','40983: rn:R03596','IMPD').
consumed_by0('35995: cpd:C00002','1919: rn:R00087','IMPD').
consumed_by0('36983: cpd:C11088','40156: rn:R07112','IMPD').
consumed_by0('36983: cpd:C11088','40157: rn:R07113','IMPD').
consumed_by0('36984: cpd:C00214','39971: rn:R01570','IMPD').
consumed_by0('35967: cpd:C00065','2602: rn:R02722','IMPD').
consumed_by0('38130: cpd:C14818','39864: rn:R00310','IMPD').
consumed_by0('38130: cpd:C14818','39865: rn:R00078','IMPD').
consumed_by0('35966: cpd:C00019','2618: rn:R00179','IMPD').
consumed_by0('35967: cpd:C00065','2599: rn:R01800','IMPD').
consumed_by0('37941: cpd:C00376','10357: rn:R02126','IMPD').
consumed_by0('35995: cpd:C00002','1811: rn:R02014','IMPD').
consumed_by0('36984: cpd:C00214','39987: rn:R01567','IMPD').
consumed_by0('35955: cpd:C00026','3035: rn:R00271','IMPD').
consumed_by0('36979: cpd:C00363','39983: rn:R02092','IMPD').
consumed_by0('36056: cpd:C00258','210: rn:R08572','IMPD').
consumed_by0('36979: cpd:C00363','39977: rn:R02093','IMPD').
consumed_by0('35962: cpd:C00097','3228: rn:R04870','IMPD').
consumed_by0('36982: cpd:C00459','39975: rn:R00378','IMPD').
consumed_by0('36860: cpd:C05852','9066: rn:R05450','IMPD').
consumed_by0('36982: cpd:C00459','39979: rn:R02095','IMPD').
consumed_by0('38123: cpd:C02191','39864: rn:R00310','IMPD').
consumed_by0('37136: cpd:C01613','524: rn:R03635','IMPD').
consumed_by0('38069: cpd:C05933','41517: rn:R00111','IMPD').
consumed_by0('36048: cpd:C00577','428: rn:R01059','IMPD').
consumed_by0('36972: cpd:C05688','40962: rn:R03599','IMPD').
consumed_by0('36974: cpd:C05335','40959: rn:R04770','IMPD').
consumed_by0('35990: cpd:C00300','2597: rn:R01566','IMPD').
consumed_by0('36974: cpd:C05335','40980: rn:R04773','IMPD').
consumed_by0('37004: cpd:C14865','40051: rn:R07094','IMPD').
consumed_by0('36967: cpd:C05689','40968: rn:R09373','IMPD').
consumed_by0('38061: cpd:C00763','41531: rn:R02894','IMPD').
consumed_by0('36970: cpd:C01159','40960: rn:R01516','IMPD').
consumed_by0('35960: cpd:C00025','3379: rn:R07414','IMPD').
consumed_by0('38116: cpd:C00486','39850: rn:R02389','IMPD').
consumed_by0('36967: cpd:C05689','41067: rn:R09366','IMPD').
consumed_by0('36954: gl:G00115','41236: rn:R05949','IMPD').
consumed_by0('35970: cpd:C00169','3453: rn:R07245','IMPD').
consumed_by0('35952: cpd:C00022','3842: rn:R00750','IMPD').
consumed_by0('36964: cpd:C00469','40891: rn:R00746','IMPD').
consumed_by0('36964: cpd:C00469','40893: rn:R00754','IMPD').
consumed_by0('36995: cpd:C00299','39917: rn:R01876','IMPD').
consumed_by0('36995: cpd:C00299','39918: rn:R00964 rn:R00967 rn:R00968 rn:R00970 rn:R01549 rn:R01880 rn:R02097 rn:R02327 rn:R02332','IMPD').
consumed_by0('36988: cpd:C06899','40164: rn:R07105','IMPD').
consumed_by0('36988: cpd:C06899','40159: rn:R07104','IMPD').
consumed_by0('37026: cpd:C03406','41550: rn:R01086','IMPD').
consumed_by0('36056: cpd:C00258','41296: rn:R01514','IMPD').
consumed_by0('38092: cpd:C05766','39860: rn:R04972','IMPD').
consumed_by0('36089: cpd:C00059','40177: rn:R00529','IMPD').
consumed_by0('36066: gl:G00067','40886: rn:R06230','IMPD').
consumed_by0('36066: gl:G00067','40887: rn:R06037','IMPD').
consumed_by0('36066: gl:G00067','40875: rn:R06035','IMPD').
consumed_by0('38090: cpd:C01051','39862: rn:R03197','IMPD').
consumed_by0('38030: cpd:C00032','10371: rn:R03684','IMPD').
consumed_by0('36066: gl:G00067','40896: rn:R06189','IMPD').
consumed_by0('36066: gl:G00067','40898: rn:R05974','IMPD').
consumed_by0('36066: gl:G00067','40900: rn:R06038','IMPD').
consumed_by0('36066: gl:G00067','40823: rn:R06038','IMPD').
consumed_by0('36096: cpd:C00334','39881: rn:R01648','IMPD').
consumed_by0('36066: gl:G00067','40845: rn:R05974','IMPD').
consumed_by0('36066: gl:G00067','40847: rn:R06230','IMPD').
consumed_by0('36088: cpd:C00046','40169: rn:R00439','IMPD').
consumed_by0('38085: cpd:C01024','39861: rn:R03165','IMPD').
consumed_by0('37312: cpd:C07480','2112: rn:R07920','IMPD').
consumed_by0('37312: cpd:C07480','2108: rn:R07961 rn:R07962','IMPD').
consumed_by0('36063: cpd:C00029','40828: rn:R00292','IMPD').
consumed_by0('36088: cpd:C00046','40108: rn:R00437','IMPD').
consumed_by0('36078: cpd:C01144','40401: rn:R03026','IMPD').
consumed_by0('36078: cpd:C01144','40399: rn:R01975','IMPD').
consumed_by0('36063: cpd:C00029','40781: rn:R00286','IMPD').
consumed_by0('36063: cpd:C00029','40789: rn:R00287','IMPD').
consumed_by0('36088: cpd:C00046','39928: rn:R00438','IMPD').
consumed_by0('36063: cpd:C00029','40660: rn:R00291','IMPD').
consumed_by0('36063: cpd:C00029','40659: rn:R00286','IMPD').
consumed_by0('36063: cpd:C00029','40661: rn:R00955','IMPD').
consumed_by0('36088: cpd:C00046','39912: rn:R00440','IMPD').
consumed_by0('36071: cpd:C15777','40346: rn:R07491','IMPD').
consumed_by0('38282: cpd:C01259','3137: rn:R03284','IMPD').
consumed_by0('37102: cpd:C15978','39716: rn:R07604','IMPD').
consumed_by0('36076: cpd:C00101','41156: rn:R00943','IMPD').
consumed_by0('36074: cpd:C00877','41178: rn:R03026','IMPD').
consumed_by0('36095: cpd:C00111','40491: rn:R01013','IMPD').
consumed_by0('38018: cpd:C00327','41556: rn:R01954','IMPD').
consumed_by0('36095: cpd:C00111','40472: rn:R01015','IMPD').
consumed_by0('37282: cpd:C00642','3646: rn:R02514 rn:R02516','IMPD').
consumed_by0('37282: cpd:C00642','3642: rn:R02698','IMPD').
consumed_by0('36114: cpd:C00164','39736: rn:R00410','IMPD').
consumed_by0('37165: cpd:C00427','7173: rn:R02264','IMPD').
consumed_by0('36116: cpd:C00062','39687: rn:R03646','IMPD').
consumed_by0('37059: gl:G00118','41245: rn:R05952','IMPD').
consumed_by0('37058: gl:G00119','41244: rn:R05953','IMPD').
consumed_by0('36111: cpd:C00683','39765: rn:R02765','IMPD').
consumed_by0('37324: cpd:C16353','2119: rn:R07965 rn:R07966','IMPD').
consumed_by0('37324: cpd:C16353','2139: rn:R07922','IMPD').
consumed_by0('36087: cpd:C05345','40448: rn:R04779','IMPD').
consumed_by0('37367: cpd:C04088','755: rn:R03370','IMPD').
consumed_by0('37324: cpd:C16353','2115: rn:R07919','IMPD').
consumed_by0('37324: cpd:C16353','2111: rn:R07919','IMPD').
consumed_by0('36073: gl:G00085','40883: rn:R06224','IMPD').
consumed_by0('37202: cpd:C00329','5848: rn:R01204','IMPD').
consumed_by0('36073: gl:G00085','40841: rn:R06224','IMPD').
consumed_by0('36097: cpd:C01762','40113: rn:R02297','IMPD').
consumed_by0('36063: cpd:C00029','41100: rn:R00286','IMPD').
consumed_by0('36994: cpd:C01036','41432: rn:R03181','IMPD').
consumed_by0('37035: cpd:C11821','40161: rn:R06601','IMPD').
consumed_by0('36014: cpd:C00527','41469: rn:R02488','IMPD').
consumed_by0('38003: cpd:C01165','41505: rn:R00245','IMPD').
consumed_by0('36016: cpd:C01179','41398: rn:R02521','IMPD').
consumed_by0('36016: cpd:C01179','41397: rn:R03342','IMPD').
consumed_by0('38002: cpd:C01157','41530: rn:R03295','IMPD').
consumed_by0('36067: cpd:C02051','39854: rn:R03425','IMPD').
consumed_by0('37025: cpd:C01097','40533: rn:R03236 rn:R03237 rn:R03238 rn:R03239','IMPD').
consumed_by0('36065: cpd:C16609','39942: rn:R08348','IMPD').
consumed_by0('37010: cpd:C01528','40984: rn:R03595','IMPD').
consumed_by0('36026: cpd:C00429','41154: rn:R00978','IMPD').
consumed_by0('36026: cpd:C00429','41153: rn:R02269','IMPD').
consumed_by0('37039: cpd:C14556','40105: rn:R07087','IMPD').
consumed_by0('36030: gl:G00089','40840: rn:R06221','IMPD').
consumed_by0('36062: cpd:C02972','39848: rn:R03815','IMPD').
consumed_by0('36008: cpd:C00581','41513: rn:R01883','IMPD').
consumed_by0('37042: cpd:C12248','40057: rn:R06604','IMPD').
consumed_by0('36025: cpd:C00118','41034: rn:R01641','IMPD').
consumed_by0('37000: cpd:C00544','41431: rn:R02519','IMPD').
consumed_by0('36025: cpd:C00118','41048: rn:R01830','IMPD').
consumed_by0('38000: cpd:C05947','41526: rn:R05052','IMPD').
consumed_by0('36030: gl:G00089','40902: rn:R06221','IMPD').
consumed_by0('36025: cpd:C00118','41056: rn:R01827','IMPD').
consumed_by0('38001: cpd:C04281','41535: rn:R04444 rn:R04445','IMPD').
consumed_by0('38001: cpd:C04281','41534: rn:R03291 rn:R03293','IMPD').
consumed_by0('37012: cpd:C05697','41070: rn:R04929','IMPD').
consumed_by0('37045: cpd:C14850','40153: rn:R07082','IMPD').
consumed_by0('36053: dr:D00252 cpd:C06868','40058: rn:R08312','IMPD').
consumed_by0('36014: cpd:C00527','41283: rn:R02488','IMPD').
consumed_by0('36025: cpd:C00118','40942: rn:R01015','IMPD').
consumed_by0('36025: cpd:C00118','40943: rn:R01061','IMPD').
consumed_by0('36017: cpd:C05125','41206: rn:R03270','IMPD').
consumed_by0('36017: cpd:C05125','41014: rn:R03270','IMPD').
consumed_by0('36056: cpd:C00258','39823: rn:R01514','IMPD').
consumed_by0('36060: cpd:C00448','39715: rn:R02061','IMPD').
consumed_by0('37038: cpd:C05402','40510: rn:R01101','IMPD').
consumed_by0('36060: cpd:C00448','39723: rn:R05556','IMPD').
consumed_by0('36060: cpd:C00448','39722: rn:R09249','IMPD').
consumed_by0('37063: cpd:C15974','39738: rn:R07602','IMPD').
consumed_by0('36053: dr:D00252 cpd:C06868','39953: rn:R08312','IMPD').
consumed_by0('36053: dr:D00252 cpd:C06868','39954: rn:R08313','IMPD').
consumed_by0('36053: dr:D00252 cpd:C06868','39958: rn:R08313','IMPD').
consumed_by0('36040: cpd:C00099','41197: rn:R00908','IMPD').
consumed_by0('36089: cpd:C00059','39680: rn:R00529','IMPD').
consumed_by0('36056: cpd:C00258','40691: rn:R01514','IMPD').
consumed_by0('36063: cpd:C00029','40562: rn:R00286','IMPD').
consumed_by0('36038: cpd:C00084','41308: rn:R00710 rn:R00711','IMPD').
consumed_by0('36036: cpd:C02642','41368: rn:R00905','IMPD').
consumed_by0('36063: cpd:C00029','40530: rn:R00955','IMPD').
consumed_by0('36063: cpd:C00029','40528: rn:R00291','IMPD').
consumed_by0('36036: cpd:C02642','41152: rn:R00905','IMPD').
consumed_by0('36077: cpd:C00232','39889: rn:R00713','IMPD').
consumed_by0('36040: cpd:C00099','41132: rn:R00908','IMPD').
consumed_by0('36048: cpd:C00577','40697: rn:R01752','IMPD').
consumed_by0('36060: cpd:C00448','40333: rn:R00702','IMPD').
consumed_by0('36028: cpd:C00168','41322: rn:R01394','IMPD').
consumed_by0('36026: cpd:C00429','41362: rn:R02269','IMPD').
consumed_by0('36026: cpd:C00429','41363: rn:R00978','IMPD').
consumed_by0('37027: cpd:C05993','41226: rn:R00236','IMPD').
consumed_by0('36076: cpd:C00101','39849: rn:R04125','IMPD').
consumed_by0('36038: cpd:C00084','40882: rn:R00710','IMPD').
consumed_by0('36038: cpd:C00084','40885: rn:R00711','IMPD').
consumed_by0('36032: cpd:C00051','41120: rn:R01262','IMPD').
consumed_by0('36032: cpd:C00051','41116: rn:R00494','IMPD').
consumed_by0('36032: cpd:C00051','41114: rn:R03915 rn:R02824','IMPD').
consumed_by0('37079: cpd:C15976','39742: rn:R07600','IMPD').
consumed_by0('37290: cpd:C16358','2100: rn:R07969 rn:R07970','IMPD').
consumed_by0('36032: cpd:C00051','41110: rn:R03167','IMPD').
consumed_by0('36032: cpd:C00051','41106: rn:R03522','IMPD').
consumed_by0('36032: cpd:C00051','41109: rn:R00274','IMPD').
consumed_by0('37106: gl:G00097','41229: rn:R05968','IMPD').
consumed_by0('36014: cpd:C00527','40394: rn:R02487','IMPD').
consumed_by0('36000: gl:G00066','40829: rn:R06033','IMPD').
consumed_by0('36000: gl:G00066','40830: rn:R06033','IMPD').
consumed_by0('37106: gl:G00097','41232: rn:R05967','IMPD').
consumed_by0('36031: cpd:C00011','39771: rn:R00132','IMPD').
consumed_by0('36033: cpd:C00671','39725: rn:R07603','IMPD').
consumed_by0('36016: cpd:C01179','40275: rn:R02521','IMPD').
consumed_by0('38022: cpd:C15672','39788: rn:R07412','IMPD').
consumed_by0('38025: cpd:C05787','39847: rn:R04979','IMPD').
consumed_by0('39128: gl:G00031','40615: rn:R07628','IMPD').
consumed_by0('35992: cpd:C00083','41193: rn:R00233','IMPD').
consumed_by0('39128: gl:G00031','40621: rn:R07628','IMPD').
consumed_by0('37143: cpd:C06198','39965: rn:R00969','IMPD').
consumed_by0('35991: cpd:C00082','41139: rn:R00734','IMPD').
consumed_by0('35991: cpd:C00082','41137: rn:R00729','IMPD').
consumed_by0('36000: gl:G00066','40869: rn:R06033','IMPD').
consumed_by0('35992: cpd:C00083','41124: rn:R00233','IMPD').
consumed_by0('35991: cpd:C00082','41177: rn:R00734','IMPD').
consumed_by0('37136: cpd:C01613','40536: rn:R03634','IMPD').
consumed_by0('35984: cpd:C00037','41037: rn:R00945','IMPD').
consumed_by0('38030: cpd:C00032','39867: rn:R02480','IMPD').
consumed_by0('38030: cpd:C00032','39866: rn:R07411','IMPD').
consumed_by0('37247: cpd:C00286','1914: rn:R01856','IMPD').
consumed_by0('35969: cpd:C00061','41466: rn:R00161','IMPD').
consumed_by0('35974: cpd:C00068','41311: rn:R00014','IMPD').
consumed_by0('35969: cpd:C00061','41465: rn:R00548','IMPD').
consumed_by0('35992: cpd:C00083','40747: rn:R01626','IMPD').
consumed_by0('35992: cpd:C00083','40744: rn:R01626','IMPD').
consumed_by0('37134: cpd:C05404','40538: rn:R05549','IMPD').
consumed_by0('39122: gl:G00026','40640: rn:R05914','IMPD').
consumed_by0('37149: cpd:C00131','40102: rn:R00375','IMPD').
consumed_by0('39122: gl:G00026','40622: rn:R05914','IMPD').
consumed_by0('35982: cpd:C00149','41224: rn:R00216','IMPD').
consumed_by0('35974: cpd:C00068','41474: rn:R00616','IMPD').
consumed_by0('36023: cpd:C16601','39957: rn:R08318','IMPD').
consumed_by0('36026: cpd:C00429','39915: rn:R00978','IMPD').
consumed_by0('37149: cpd:C00131','40046: rn:R01138','IMPD').
consumed_by0('36026: cpd:C00429','39913: rn:R02269','IMPD').
consumed_by0('35982: cpd:C00149','41284: rn:R00342','IMPD').
consumed_by0('36033: cpd:C00671','39677: rn:R02199','IMPD').
consumed_by0('35984: cpd:C00037','41118: rn:R00497','IMPD').
consumed_by0('35970: cpd:C00169','41553: rn:R01398','IMPD').
consumed_by0('35974: cpd:C00068','41470: rn:R00615','IMPD').
consumed_by0('35982: cpd:C00149','41223: rn:R00342','IMPD').
consumed_by0('35982: cpd:C00149','41220: rn:R00214','IMPD').
consumed_by0('38032: cpd:C00931','39859: rn:R00084','IMPD').
consumed_by0('36047: cpd:C00041','39895: rn:R00369','IMPD').
consumed_by0('37133: gl:G00094','40915: rn:R05964','IMPD').
consumed_by0('36047: cpd:C00041','39896: rn:R00258','IMPD').
consumed_by0('37156: cpd:C05284','40195: rn:R08945 rn:R08980','IMPD').
consumed_by0('37133: gl:G00094','40924: rn:R05963','IMPD').
consumed_by0('37156: cpd:C05284','40209: rn:R04758','IMPD').
consumed_by0('39115: gl:G00023','40624: rn:R05910','IMPD').
consumed_by0('39115: gl:G00023','40614: rn:R05911','IMPD').
consumed_by0('39115: gl:G00023','40620: rn:R05911','IMPD').
consumed_by0('39115: gl:G00023','40618: rn:R05909','IMPD').
consumed_by0('39115: gl:G00023','40643: rn:R05910','IMPD').
consumed_by0('39115: gl:G00023','40612: rn:R05909','IMPD').
consumed_by0('37952: cpd:C02075 cpd:C02588','41416: rn:R08388','IMPD').
consumed_by0('36025: cpd:C00118','40497: rn:R01015','IMPD').
consumed_by0('36005: cpd:C00078','41315: rn:R00678','IMPD').
consumed_by0('36005: cpd:C00078','41317: rn:R00677','IMPD').
consumed_by0('37128: gl:G00093','40931: rn:R05961','IMPD').
consumed_by0('37153: cpd:C00206','40125: rn:R01137','IMPD').
consumed_by0('36017: cpd:C05125','40936: rn:R03270','IMPD').
consumed_by0('37957: cpd:C00899','41411: rn:R08381','IMPD').
consumed_by0('37957: cpd:C00899','41410: rn:R08389','IMPD').
consumed_by0('36005: cpd:C00078','41263: rn:R00685','IMPD').
consumed_by0('36005: cpd:C00078','41268: rn:R03664','IMPD').
consumed_by0('36005: cpd:C00078','41269: rn:R01814','IMPD').
consumed_by0('36005: cpd:C00078','41270: rn:R00678','IMPD').
consumed_by0('37126: gl:G00095','40918: rn:R05966','IMPD').
consumed_by0('35991: cpd:C00082','41392: rn:R00729','IMPD').
consumed_by0('35991: cpd:C00082','41391: rn:R00731','IMPD').
consumed_by0('37965: cpd:C16682','41378: rn:R08383','IMPD').
consumed_by0('35991: cpd:C00082','41389: rn:R01815','IMPD').
consumed_by0('35991: cpd:C00082','41385: rn:R02078','IMPD').
consumed_by0('37166: cpd:C00212','40117: rn:R00185','IMPD').
consumed_by0('36044: cpd:C00407','39700: rn:R03656','IMPD').
consumed_by0('36044: cpd:C00407','39684: rn:R03656','IMPD').
consumed_by0('37166: cpd:C00212','40083: rn:R01560','IMPD').
consumed_by0('37961: cpd:C02110','41419: rn:R03048 rn:R08380','IMPD').
consumed_by0('36036: cpd:C02642','39914: rn:R00905','IMPD').
consumed_by0('37166: cpd:C00212','40075: rn:R01561','IMPD').
consumed_by0('37962: cpd:C16681','41380: rn:R08385','IMPD').
consumed_by0('37128: gl:G00093','41228: rn:R05962','IMPD').
consumed_by0('37166: cpd:C00212','40048: rn:R00185','IMPD').
consumed_by0('37128: gl:G00093','41233: rn:R05962','IMPD').
consumed_by0('39104: gl:G00028','40642: rn:R05915','IMPD').
consumed_by0('39104: gl:G00028','40626: rn:R05915','IMPD').
consumed_by0('35990: cpd:C00300','41521: rn:R01881','IMPD').
consumed_by0('37269: cpd:C01228','1872: rn:R00336','IMPD').
consumed_by0('36043: cpd:C01005','39844: rn:R00582','IMPD').
consumed_by0('36043: cpd:C01005','39841: rn:R04173','IMPD').
consumed_by0('36047: cpd:C00041','39695: rn:R03038','IMPD').
consumed_by0('35991: cpd:C00082','41435: rn:R03539','IMPD').
consumed_by0('37965: cpd:C16682','41409: rn:R08382 rn:R08383','IMPD').
consumed_by0('35991: cpd:C00082','41394: rn:R00734','IMPD').
consumed_by0('35991: cpd:C00082','41396: rn:R00734','IMPD').
consumed_by0('36044: cpd:C00407','39763: rn:R02197','IMPD').
consumed_by0('35991: cpd:C00082','41408: rn:R00736','IMPD').
consumed_by0('36044: cpd:C00407','39764: rn:R02199','IMPD').
consumed_by0('37098: cpd:C02593','40359: rn:R03990','IMPD').
consumed_by0('37098: cpd:C02593','40369: rn:R03991','IMPD').
consumed_by0('35941: cpd:C00014','41555: rn:R00149','IMPD').
consumed_by0('35949: cpd:C00033','41307: rn:R00316','IMPD').
consumed_by0('37098: cpd:C02593','40385: rn:R03990','IMPD').
consumed_by0('35997: cpd:C01026','39827: rn:R01565','IMPD').
consumed_by0('35941: cpd:C00014','41562: rn:R00253','IMPD').
consumed_by0('35977: cpd:C00096','40445: rn:R00888','IMPD').
consumed_by0('35952: cpd:C00022','41219: rn:R00344','IMPD').
consumed_by0('37098: cpd:C02593','40389: rn:R03990','IMPD').
consumed_by0('35996: cpd:C03035','39873: rn:R08181','IMPD').
consumed_by0('35967: cpd:C00065','40796: rn:R01281','IMPD').
consumed_by0('37098: cpd:C02593','40434: rn:R03991','IMPD').
consumed_by0('35955: cpd:C00026','41184: rn:R03534','IMPD').
consumed_by0('35984: cpd:C00037','40294: rn:R03718','IMPD').
consumed_by0('35984: cpd:C00037','40299: rn:R08744','IMPD').
consumed_by0('35952: cpd:C00022','41311: rn:R00014','IMPD').
consumed_by0('35962: cpd:C00097','41006: rn:R00893','IMPD').
consumed_by0('35960: cpd:C00025','41083: rn:R00243 rn:R00248','IMPD').
consumed_by0('37992: cpd:C05774','39784: rn:R07268','IMPD').
consumed_by0('36005: cpd:C00078','39701: rn:R03664','IMPD').
consumed_by0('35960: cpd:C00025','41115: rn:R00894','IMPD').
consumed_by0('35957: cpd:C00036','41210: rn:R00431 rn:R00726','IMPD').
consumed_by0('35995: cpd:C00002','40045: rn:R00086','IMPD').
consumed_by0('35995: cpd:C00002','40047: rn:R00200','IMPD').
consumed_by0('37093: cpd:C05273','40435: rn:R03989','IMPD').
consumed_by0('37941: cpd:C00376','41430: rn:R02123','IMPD').
consumed_by0('35981: cpd:C00031','40505: rn:R00299','IMPD').
consumed_by0('35981: cpd:C00031','40503: rn:R00299','IMPD').
consumed_by0('35959: cpd:C00049','41189: rn:R00489','IMPD').
consumed_by0('35995: cpd:C00002','40100: rn:R00086','IMPD').
consumed_by0('35995: cpd:C00002','40099: rn:R00086','IMPD').
consumed_by0('37112: cpd:C00402','39903: rn:R00359','IMPD').
consumed_by0('35960: cpd:C00025','41173: rn:R00261','IMPD').
consumed_by0('35962: cpd:C00097','41115: rn:R00894','IMPD').
consumed_by0('35995: cpd:C00002','40104: rn:R00435','IMPD').
consumed_by0('35995: cpd:C00002','40106: rn:R00089','IMPD').
consumed_by0('37122: cpd:C02362','39899: rn:R00348','IMPD').
consumed_by0('35944: cpd:C00024','41225: rn:R00227','IMPD').
consumed_by0('35952: cpd:C00022','40985: rn:R00344','IMPD').
consumed_by0('35943: cpd:C00079','41310: rn:R01795','IMPD').
consumed_by0('35952: cpd:C00022','41030: rn:R00014','IMPD').
consumed_by0('37214: cpd:C01260','1890: rn:R00125','IMPD').
consumed_by0('37948: cpd:C00777','41386: rn:R08390','IMPD').
consumed_by0('37948: cpd:C00777','41388: rn:R08391','IMPD').
consumed_by0('37948: cpd:C00777','41382: rn:R08391','IMPD').
consumed_by0('37948: cpd:C00777','41384: rn:R08390','IMPD').
consumed_by0('37948: cpd:C00777','41395: rn:R08390','IMPD').
consumed_by0('35944: cpd:C00024','41309: rn:R00238','IMPD').
consumed_by0('35944: cpd:C00024','41306: rn:R00742','IMPD').
consumed_by0('37948: cpd:C00777','41390: rn:R08390','IMPD').
consumed_by0('35944: cpd:C00024','41312: rn:R02569','IMPD').
consumed_by0('37948: cpd:C00777','41393: rn:R08390','IMPD').
consumed_by0('37091: gl:G00103','40927: rn:R05904','IMPD').
consumed_by0('37948: cpd:C00777','41379: rn:R02902','IMPD').
consumed_by0('37948: cpd:C00777','41377: rn:R08392','IMPD').
consumed_by0('35985: dr:D04716 cpd:C08012','40055: rn:R08341','IMPD').
consumed_by0('37948: cpd:C00777','41407: rn:R08392','IMPD').
consumed_by0('37948: cpd:C00777','41406: rn:R08392','IMPD').
consumed_by0('35955: cpd:C00026','40977: rn:R00621','IMPD').
consumed_by0('37948: cpd:C00777','41403: rn:R08392','IMPD').
consumed_by0('35957: cpd:C00036','40971: rn:R00352','IMPD').
consumed_by0('35953: cpd:C00064','41085: rn:R00256','IMPD').
consumed_by0('35961: gl:G00069','40832: rn:R06039','IMPD').
consumed_by0('35957: cpd:C00036','40947: rn:R00431 rn:R00726','IMPD').
consumed_by0('35951: cpd:C00136','41192: rn:R01171','IMPD').
consumed_by0('35957: cpd:C00036','40986: rn:R00351','IMPD').
consumed_by0('37119: cpd:C01042','39898: rn:R00488','IMPD').
consumed_by0('35945: cpd:C00183','41352: rn:R01214','IMPD').
consumed_by0('35957: cpd:C00036','41036: rn:R00431 rn:R00726','IMPD').
consumed_by0('35952: cpd:C00022','41185: rn:R00014','IMPD').
consumed_by0('37952: cpd:C02075 cpd:C02588','41381: rn:R02368','IMPD').
consumed_by0('35961: gl:G00069','40889: rn:R06039','IMPD').
consumed_by0('35960: cpd:C00025','41504: rn:R00239','IMPD').
consumed_by0('35944: cpd:C00024','155: rn:R01196','IMPD').
consumed_by0('37123: cpd:C11713','40094: rn:R07020','IMPD').
consumed_by0('35974: cpd:C00068','41030: rn:R00014','IMPD').
consumed_by0('37117: cpd:C05260','40390: rn:R04740','IMPD').
consumed_by0('37117: cpd:C05260','40388: rn:R04739','IMPD').
consumed_by0('37117: cpd:C05260','40386: rn:R04739','IMPD').
consumed_by0('36867: cpd:C07643','13454: rn:R08278','IMPD').
consumed_by0('35959: cpd:C00049','41556: rn:R01954','IMPD').
consumed_by0('35960: cpd:C00025','41552: rn:R00259','IMPD').
consumed_by0('35980: cpd:C00197','40932: rn:R01512','IMPD').
consumed_by0('35962: cpd:C00097','41489: rn:R07460','IMPD').
consumed_by0('37115: cpd:C05261','40429: rn:R04739','IMPD').
consumed_by0('37120: cpd:C14453','40098: rn:R07075','IMPD').
consumed_by0('35974: cpd:C00068','41185: rn:R00014','IMPD').
consumed_by0('35986: gl:G00062','40818: rn:R06075','IMPD').
consumed_by0('35964: cpd:C00332','41468: rn:R00238','IMPD').
consumed_by0('37297: cpd:C00673','169: rn:R01066','IMPD').
consumed_by0('37109: cpd:C05272','40427: rn:R01278','IMPD').
consumed_by0('35966: cpd:C00019','41502: rn:R00178','IMPD').
consumed_by0('35944: cpd:C00024','85: rn:R01196','IMPD').
consumed_by0('35986: gl:G00062','40894: rn:R06032','IMPD').
consumed_by0('36018: cpd:C16162','39879: rn:R08178','IMPD').
consumed_by0('35982: cpd:C00149','40991: rn:R01082','IMPD').
consumed_by0('35982: cpd:C00149','40987: rn:R00342','IMPD').
consumed_by0('37106: gl:G00097','40928: rn:R05968','IMPD').
consumed_by0('38085: cpd:C01024','10582: rn:R03166','IMPD').
consumed_by0('35991: cpd:C00082','40273: rn:R00734','IMPD').
consumed_by0('35977: cpd:C00096','40714: rn:R00888','IMPD').
consumed_by0('37930: cpd:C03440','41356: rn:R04221','IMPD').
consumed_by0('36003: cpd:C16165','39871: rn:R08179','IMPD').
consumed_by0('37121: cpd:C05258','40426: rn:R04738','IMPD').
consumed_by0('37950: cpd:C06037','40707: rn:R04470','IMPD').
consumed_by0('37124: cpd:C05259','40433: rn:R04737','IMPD').
consumed_by0('35974: cpd:C00068','40895: rn:R00014','IMPD').
consumed_by0('36008: cpd:C00581','39836: rn:R01883','IMPD').
consumed_by0('35964: cpd:C00332','41180: rn:R01978','IMPD').
consumed_by0('37934: cpd:C05638','41289: rn:R04908','IMPD').
consumed_by0('39075: gl:G00010','40604: rn:R05981','IMPD').
consumed_by0('37106: gl:G00097','40940: rn:R05967','IMPD').
consumed_by0('35977: cpd:C00096','40859: rn:R01009','IMPD').
consumed_by0('35960: cpd:C00025','41373: rn:R00243 rn:R00248','IMPD').
consumed_by0('37100: cpd:C05381','40974: rn:R03316','IMPD').
consumed_by0('37117: cpd:C05260','40436: rn:R04740','IMPD').
consumed_by0('37091: gl:G00103','41234: rn:R05904','IMPD').
consumed_by0('35960: cpd:C00025','41339: rn:R02287','IMPD').
consumed_by0('35953: cpd:C00064','41558: rn:R00256','IMPD').
consumed_by0('35977: cpd:C00096','40930: rn:R01009','IMPD').
consumed_by0('35977: cpd:C00096','40919: rn:R05972','IMPD').
consumed_by0('35962: cpd:C00097','41366: rn:R04230 rn:R04231','IMPD').
consumed_by0('36010: cpd:C16169','39872: rn:R08180','IMPD').
consumed_by0('37938: cpd:C05651','41290: rn:R04909','IMPD').
consumed_by0('37121: cpd:C05258','40371: rn:R04738','IMPD').
consumed_by0('37121: cpd:C05258','40370: rn:R04737','IMPD').
consumed_by0('37121: cpd:C05258','40367: rn:R04737','IMPD').
consumed_by0('35964: cpd:C00332','41286: rn:R00238','IMPD').
consumed_by0('35974: cpd:C00068','40977: rn:R00621','IMPD').
consumed_by0('35977: cpd:C00096','40873: rn:R01009','IMPD').
gives(X,Y,Z) :- produces(X,Y,Z).
taken_by(X,Y,Z) :- consumed_by0(X,Y,Z).
has_attributive_relation_with(X,Y,Z) :- member_of(X,Y,Z).
molecule(A,B,C,D,E) :- metabolite(A,B,C,D,E).
process(A,B,C,D,E) :- reaction(A,B,C,D,E).
processsequence(A,B,C,D,E) :- pathway(A,B,C,D,E).

concept_name0(RID,'rno:non-annotated',false).
